/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/base/common/network","vs/base/common/uri","vs/base/common/event","vs/base/node/pfs","vs/platform/log/common/log","fs","vs/base/common/errors","vs/base/common/buffer","vs/base/common/platform","vs/base/common/strings","vs/base/common/objects","vs/base/common/arrays","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/platform/configuration/common/configurationRegistry","vs/base/common/errorMessage","vs/base/common/stream","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","child_process","vs/platform/extensions/common/extensions","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/base/common/uuid","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/node/zip","vs/base/common/map","vs/base/node/decoder","os","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/userDataPath","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/environment/node/environmentService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/base/common/normalization","vs/base/common/performance","vs/base/common/iterator","util","crypto","vs/base/common/process","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],Y=function(x){for(var t=[],y=0,A=x.length;y<A;y++)t[y]=Q[x[y]];return t};define(Q[54],Y([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function y(A,F){if(!A)throw new Error(F?`Assertion failed (${F})`:"Assertion Failed")}t.ok=y}),define(Q[55],Y([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createMemoizer=t.createDecorator=void 0;function y(h){return(d,b,u)=>{let R=null,w=null;if(typeof u.value=="function"?(R="value",w=u.value):typeof u.get=="function"&&(R="get",w=u.get),!w)throw new Error("not supported");u[R]=h(w,b)}}t.createDecorator=y;let A=0;function F(){const h=`$memoize${A++}`;let d;const b=function(R,w,l){let C=null,v=null;if(typeof l.value=="function"?(C="value",v=l.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(C="get",v=l.get),!v)throw new Error("not supported");const m=`${h}:${w}`;l[C]=function(...p){return d=this,this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!0,enumerable:!1,writable:!0,value:v.apply(this,p)}),this[m]}};return b.clear=()=>{typeof d!="undefined"&&Object.getOwnPropertyNames(d).forEach(u=>{u.indexOf(h)===0&&delete d[u]})},b}t.createMemoizer=F;function E(h,d,b){return F()(h,d,b)}t.memoize=E;function k(h,d,b){return y((u,R)=>{const w=`$debounce$${R}`,l=`$debounce$result$${R}`;return function(...C){this[l]||(this[l]=b?b():void 0),clearTimeout(this[w]),d&&(this[l]=d(this[l],...C),C=[this[l]]),this[w]=setTimeout(()=>{u.apply(this,C),this[l]=b?b():void 0},h)}})}t.debounce=k;function T(h,d,b){return y((u,R)=>{const w=`$throttle$timer$${R}`,l=`$throttle$result$${R}`,C=`$throttle$lastRun$${R}`,v=`$throttle$pending$${R}`;return function(...m){if(this[l]||(this[l]=b?b():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),d&&(this[l]=d(this[l],...m)),!this[v]){const p=this[C]+h;p<=Date.now()?(this[C]=Date.now(),u.apply(this,[this[l]]),this[l]=b?b():void 0):(this[v]=!0,this[w]=setTimeout(()=>{this[v]=!1,this[C]=Date.now(),u.apply(this,[this[l]]),this[l]=b?b():void 0},p-Date.now()))}}})}t.throttle=T}),define(Q[20],Y([0,1,15]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function A(W,L=0){return W[W.length-(1+L)]}t.tail=A;function F(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}t.tail2=F;function E(W,L,S=(g,c)=>g===c){if(W===L)return!0;if(!W||!L||W.length!==L.length)return!1;for(let g=0,c=W.length;g<c;g++)if(!S(W[g],L[g]))return!1;return!0}t.equals=E;function k(W,L,S){let g=0,c=W.length-1;for(;g<=c;){const I=(g+c)/2|0,D=S(W[I],L);if(D<0)g=I+1;else if(D>0)c=I-1;else return I}return-(g+1)}t.binarySearch=k;function T(W,L){let S=0,g=W.length;if(g===0)return 0;for(;S<g;){const c=Math.floor((S+g)/2);L(W[c])?g=c:S=c+1}return S}t.findFirstInSorted=T;function h(W,L,S){if(W=W|0,W>=L.length)throw new TypeError("invalid index");let g=L[Math.floor(L.length*Math.random())],c=[],I=[],D=[];for(let N of L){const z=S(N,g);z<0?c.push(N):z>0?I.push(N):D.push(N)}return W<c.length?h(W,c,S):W<c.length+D.length?D[0]:h(W-(c.length+D.length),I,S)}t.quickSelect=h;function d(W,L){const S=[];let g;for(const c of W.slice(0).sort(L))!g||L(g[0],c)!==0?(g=[c],S.push(g)):g.push(c);return S}t.groupBy=d;function b(W,L,S){const g=[];function c(N,z,$){if(!(z===0&&$.length===0)){const _=g[g.length-1];_&&_.start+_.deleteCount===N?(_.deleteCount+=z,_.toInsert.push(...$)):g.push({start:N,deleteCount:z,toInsert:$})}}let I=0,D=0;for(;;){if(I===W.length){c(I,0,L.slice(D));break}if(D===L.length){c(I,W.length-I,[]);break}const N=W[I],z=L[D],$=S(N,z);$===0?(I+=1,D+=1):$<0?(c(I,1,[]),I+=1):$>0&&(c(I,0,[z]),D+=1)}return g}t.sortedDiff=b;function u(W,L,S){const g=b(W,L,S),c=[],I=[];for(const D of g)c.push(...W.slice(D.start,D.start+D.deleteCount)),I.push(...D.toInsert);return{removed:c,added:I}}t.delta=u;function R(W,L,S){if(S===0)return[];const g=W.slice(0,S).sort(L);return l(W,L,g,S,W.length),g}t.top=R;function w(W,L,S,g,c){return S===0?Promise.resolve([]):new Promise((I,D)=>{(async()=>{const N=W.length,z=W.slice(0,S).sort(L);for(let $=S,_=Math.min(S+g,N);$<N;$=_,_=Math.min(_+g,N)){if($>S&&await new Promise(q=>setTimeout(q)),c&&c.isCancellationRequested)throw(0,y.canceled)();l(W,L,z,$,_)}return z})().then(I,D)})}t.topAsync=w;function l(W,L,S,g,c){for(const I=S.length;g<c;g++){const D=W[g];if(L(D,S[I-1])<0){S.pop();const N=T(S,z=>L(D,z)<0);S.splice(N,0,D)}}}function C(W){return W.filter(L=>!!L)}t.coalesce=C;function v(W){let L=0;for(let S=0;S<W.length;S++)W[S]&&(W[L]=W[S],L+=1);W.length=L}t.coalesceInPlace=v;function m(W,L,S){W.splice(S,0,W.splice(L,1)[0])}t.move=m;function p(W){return!Array.isArray(W)||W.length===0}t.isFalsyOrEmpty=p;function P(W){return Array.isArray(W)&&W.length>0}t.isNonEmptyArray=P;function o(W,L){if(!L)return W.filter((g,c)=>W.indexOf(g)===c);const S=Object.create(null);return W.filter(g=>{const c=L(g);return S[c]?!1:(S[c]=!0,!0)})}t.distinct=o;function i(W){const L=new Set;return W.filter(S=>L.has(S)?!1:(L.add(S),!0))}t.distinctES6=i;function e(W){const L=Object.create(null);return S=>{const g=W(S);return L[g]?!1:(L[g]=!0,!0)}}t.uniqueFilter=e;function n(W,L){for(let S=W.length-1;S>=0;S--){const g=W[S];if(L(g))return S}return-1}t.lastIndex=n;function s(W,L){return W.length>0?W[0]:L}t.firstOrDefault=s;function a(W,L,S=(g,c)=>g===c){let g=0;for(let c=0,I=Math.min(W.length,L.length);c<I&&S(W[c],L[c]);c++)g++;return g}t.commonPrefixLength=a;function r(W){return[].concat(...W)}t.flatten=r;function f(W,L){let S=typeof L=="number"?W:0;typeof L=="number"?S=W:(S=0,L=W);const g=[];if(S<=L)for(let c=S;c<L;c++)g.push(c);else for(let c=S;c>L;c--)g.push(c);return g}t.range=f;function O(W,L,S){return W.reduce((g,c)=>(g[L(c)]=S?S(c):c,g),Object.create(null))}t.index=O;function j(W,L){return W.push(L),()=>M(W,L)}t.insert=j;function M(W,L){const S=W.indexOf(L);if(S>-1)return W.splice(S,1),L}t.remove=M;function U(W,L,S){const g=W.slice(0,L),c=W.slice(L);return g.concat(S,c)}t.arrayInsert=U;function B(W,L){let S;if(typeof L=="number"){let g=L;S=()=>{const c=Math.sin(g++)*179426549;return c-Math.floor(c)}}else S=Math.random;for(let g=W.length-1;g>0;g-=1){const c=Math.floor(S()*(g+1)),I=W[g];W[g]=W[c],W[c]=I}}t.shuffle=B;function K(W,L){const S=W.indexOf(L);S>-1&&(W.splice(S,1),W.unshift(L))}t.pushToStart=K;function ee(W,L){const S=W.indexOf(L);S>-1&&(W.splice(S,1),W.push(L))}t.pushToEnd=ee;function ae(W,L){return Array.isArray(W)?W.map(L):L(W)}t.mapArrayOrNot=ae;function re(W){return Array.isArray(W)?W:[W]}t.asArray=re;function Z(W){return W[Math.floor(Math.random()*W.length)]}t.getRandomElement=Z;function le(W,L){for(const S of W){const g=L(S);if(g!==void 0)return g}}t.mapFind=le}),define(Q[56],Y([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var y;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(y=t.ScanError||(t.ScanError={}));var A;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(A=t.SyntaxKind||(t.SyntaxKind={}));var F;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(F=t.ParseErrorCode||(t.ParseErrorCode={}));var E;(function(e){e.DEFAULT={allowTrailingComma:!0}})(E=t.ParseOptions||(t.ParseOptions={}));function k(e,n=!1){let s=0,a=e.length,r="",f=0,O=16,j=0;function M(Z){let le=0,W=0;for(;le<Z;){const L=e.charCodeAt(s);if(L>=48&&L<=57)W=W*16+L-48;else if(L>=65&&L<=70)W=W*16+L-65+10;else if(L>=97&&L<=102)W=W*16+L-97+10;else break;s++,le++}return le<Z&&(W=-1),W}function U(Z){s=Z,r="",f=0,O=16,j=0}function B(){const Z=s;if(e.charCodeAt(s)===48)s++;else for(s++;s<e.length&&d(e.charCodeAt(s));)s++;if(s<e.length&&e.charCodeAt(s)===46)if(s++,s<e.length&&d(e.charCodeAt(s)))for(s++;s<e.length&&d(e.charCodeAt(s));)s++;else return j=3,e.substring(Z,s);let le=s;if(s<e.length&&(e.charCodeAt(s)===69||e.charCodeAt(s)===101))if(s++,(s<e.length&&e.charCodeAt(s)===43||e.charCodeAt(s)===45)&&s++,s<e.length&&d(e.charCodeAt(s))){for(s++;s<e.length&&d(e.charCodeAt(s));)s++;le=s}else j=3;return e.substring(Z,le)}function K(){let Z="",le=s;for(;;){if(s>=a){Z+=e.substring(le,s),j=2;break}const W=e.charCodeAt(s);if(W===34){Z+=e.substring(le,s),s++;break}if(W===92){if(Z+=e.substring(le,s),s++,s>=a){j=2;break}switch(e.charCodeAt(s++)){case 34:Z+='"';break;case 92:Z+="\\";break;case 47:Z+="/";break;case 98:Z+="\b";break;case 102:Z+="\f";break;case 110:Z+=`
`;break;case 114:Z+="\r";break;case 116:Z+="	";break;case 117:const S=M(4);S>=0?Z+=String.fromCharCode(S):j=4;break;default:j=5}le=s;continue}if(W>=0&&W<=31)if(h(W)){Z+=e.substring(le,s),j=2;break}else j=6;s++}return Z}function ee(){if(r="",j=0,f=s,s>=a)return f=a,O=17;let Z=e.charCodeAt(s);if(T(Z)){do s++,r+=String.fromCharCode(Z),Z=e.charCodeAt(s);while(T(Z));return O=15}if(h(Z))return s++,r+=String.fromCharCode(Z),Z===13&&e.charCodeAt(s)===10&&(s++,r+=`
`),O=14;switch(Z){case 123:return s++,O=1;case 125:return s++,O=2;case 91:return s++,O=3;case 93:return s++,O=4;case 58:return s++,O=6;case 44:return s++,O=5;case 34:return s++,r=K(),O=10;case 47:const le=s-1;if(e.charCodeAt(s+1)===47){for(s+=2;s<a&&!h(e.charCodeAt(s));)s++;return r=e.substring(le,s),O=12}if(e.charCodeAt(s+1)===42){s+=2;const W=a-1;let L=!1;for(;s<W;){if(e.charCodeAt(s)===42&&e.charCodeAt(s+1)===47){s+=2,L=!0;break}s++}return L||(s++,j=1),r=e.substring(le,s),O=13}return r+=String.fromCharCode(Z),s++,O=16;case 45:if(r+=String.fromCharCode(Z),s++,s===a||!d(e.charCodeAt(s)))return O=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=B(),O=11;default:for(;s<a&&ae(Z);)s++,Z=e.charCodeAt(s);if(f!==s){switch(r=e.substring(f,s),r){case"true":return O=8;case"false":return O=9;case"null":return O=7}return O=16}return r+=String.fromCharCode(Z),s++,O=16}}function ae(Z){if(T(Z)||h(Z))return!1;switch(Z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let Z;do Z=ee();while(Z>=12&&Z<=15);return Z}return{setPosition:U,getPosition:()=>s,scan:n?re:ee,getToken:()=>O,getTokenValue:()=>r,getTokenOffset:()=>f,getTokenLength:()=>s-f,getTokenError:()=>j}}t.createScanner=k;function T(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function h(e){return e===10||e===13||e===8232||e===8233}function d(e){return e>=48&&e<=57}var b;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(b||(b={}));function u(e,n){const s=[],a=new Object;let r;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let O=!1;function j(M,U,B,K){f.value=M,f.offset=U,f.length=B,f.type=K,f.colonOffset=void 0,r=f}try{P(e,{onObjectBegin:(M,U)=>{if(n<=M)throw a;r=void 0,O=n>M,s.push("")},onObjectProperty:(M,U,B)=>{if(n<U||(j(M,U,B,"property"),s[s.length-1]=M,n<=U+B))throw a},onObjectEnd:(M,U)=>{if(n<=M)throw a;r=void 0,s.pop()},onArrayBegin:(M,U)=>{if(n<=M)throw a;r=void 0,s.push(0)},onArrayEnd:(M,U)=>{if(n<=M)throw a;r=void 0,s.pop()},onLiteralValue:(M,U,B)=>{if(n<U||(j(M,U,B,i(M)),n<=U+B))throw a},onSeparator:(M,U,B)=>{if(n<=U)throw a;if(M===":"&&r&&r.type==="property")r.colonOffset=U,O=!1,r=void 0;else if(M===","){const K=s[s.length-1];typeof K=="number"?s[s.length-1]=K+1:(O=!0,s[s.length-1]=""),r=void 0}}})}catch(M){if(M!==a)throw M}return{path:s,previousNode:r,isAtPropertyKey:O,matches:M=>{let U=0;for(let B=0;U<M.length&&B<s.length;B++)if(M[U]===s[B]||M[U]==="*")U++;else if(M[U]!=="**")return!1;return U===M.length}}}t.getLocation=u;function R(e,n=[],s=E.DEFAULT){let a=null,r=[];const f=[];function O(M){Array.isArray(r)?r.push(M):a!==null&&(r[a]=M)}return P(e,{onObjectBegin:()=>{const M={};O(M),f.push(r),r=M,a=null},onObjectProperty:M=>{a=M},onObjectEnd:()=>{r=f.pop()},onArrayBegin:()=>{const M=[];O(M),f.push(r),r=M,a=null},onArrayEnd:()=>{r=f.pop()},onLiteralValue:O,onError:(M,U,B)=>{n.push({error:M,offset:U,length:B})}},s),r[0]}t.parse=R;function w(e,n=[],s=E.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(M){a.type==="property"&&(a.length=M-a.offset,a=a.parent)}function f(M){return a.children.push(M),M}P(e,{onObjectBegin:M=>{a=f({type:"object",offset:M,length:-1,parent:a,children:[]})},onObjectProperty:(M,U,B)=>{a=f({type:"property",offset:U,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:M,offset:U,length:B,parent:a})},onObjectEnd:(M,U)=>{a.length=M+U-a.offset,a=a.parent,r(M+U)},onArrayBegin:(M,U)=>{a=f({type:"array",offset:M,length:-1,parent:a,children:[]})},onArrayEnd:(M,U)=>{a.length=M+U-a.offset,a=a.parent,r(M+U)},onLiteralValue:(M,U,B)=>{f({type:i(M),offset:U,length:B,parent:a,value:M}),r(U+B)},onSeparator:(M,U,B)=>{a.type==="property"&&(M===":"?a.colonOffset=U:M===","&&r(U))},onError:(M,U,B)=>{n.push({error:M,offset:U,length:B})}},s);const j=a.children[0];return j&&delete j.parent,j}t.parseTree=w;function l(e,n){if(!!e){let s=e;for(let a of n)if(typeof a=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const f of s.children)if(Array.isArray(f.children)&&f.children[0].value===a){s=f.children[1],r=!0;break}if(!r)return}else{const r=a;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}}t.findNodeAtLocation=l;function C(e){if(!e.parent||!e.parent.children)return[];const n=C(e.parent);if(e.parent.type==="property"){const s=e.parent.children[0].value;n.push(s)}else if(e.parent.type==="array"){const s=e.parent.children.indexOf(e);s!==-1&&n.push(s)}return n}t.getNodePath=C;function v(e){switch(e.type){case"array":return e.children.map(v);case"object":const n=Object.create(null);for(let s of e.children){const a=s.children[1];a&&(n[s.children[0].value]=v(a))}return n;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=v;function m(e,n,s=!1){return n>=e.offset&&n<e.offset+e.length||s&&n===e.offset+e.length}t.contains=m;function p(e,n,s=!1){if(m(e,n,s)){const a=e.children;if(Array.isArray(a))for(let r=0;r<a.length&&a[r].offset<=n;r++){const f=p(a[r],n,s);if(f)return f}return e}}t.findNodeAtOffset=p;function P(e,n,s=E.DEFAULT){const a=k(e,!1);function r(z){return z?()=>z(a.getTokenOffset(),a.getTokenLength()):()=>!0}function f(z){return z?$=>z($,a.getTokenOffset(),a.getTokenLength()):()=>!0}const O=r(n.onObjectBegin),j=f(n.onObjectProperty),M=r(n.onObjectEnd),U=r(n.onArrayBegin),B=r(n.onArrayEnd),K=f(n.onLiteralValue),ee=f(n.onSeparator),ae=r(n.onComment),re=f(n.onError),Z=s&&s.disallowComments,le=s&&s.allowTrailingComma;function W(){for(;;){const z=a.scan();switch(a.getTokenError()){case 4:L(14);break;case 5:L(15);break;case 3:L(13);break;case 1:Z||L(11);break;case 2:L(12);break;case 6:L(16);break}switch(z){case 12:case 13:Z?L(10):ae();break;case 16:L(1);break;case 15:case 14:break;default:return z}}}function L(z,$=[],_=[]){if(re(z),$.length+_.length>0){let q=a.getToken();for(;q!==17;){if($.indexOf(q)!==-1){W();break}else if(_.indexOf(q)!==-1)break;q=W()}}}function S(z){const $=a.getTokenValue();return z?K($):j($),W(),!0}function g(){switch(a.getToken()){case 11:let z=0;try{z=JSON.parse(a.getTokenValue()),typeof z!="number"&&(L(2),z=0)}catch($){L(2)}K(z);break;case 7:K(null);break;case 8:K(!0);break;case 9:K(!1);break;default:return!1}return W(),!0}function c(){return a.getToken()!==10?(L(3,[],[2,5]),!1):(S(!1),a.getToken()===6?(ee(":"),W(),N()||L(4,[],[2,5])):L(5,[],[2,5]),!0)}function I(){O(),W();let z=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(z||L(4,[],[]),ee(","),W(),a.getToken()===2&&le)break}else z&&L(6,[],[]);c()||L(4,[],[2,5]),z=!0}return M(),a.getToken()!==2?L(7,[2],[]):W(),!0}function D(){U(),W();let z=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(z||L(4,[],[]),ee(","),W(),a.getToken()===4&&le)break}else z&&L(6,[],[]);N()||L(4,[],[4,5]),z=!0}return B(),a.getToken()!==4?L(8,[4],[]):W(),!0}function N(){switch(a.getToken()){case 3:return D();case 1:return I();case 10:return S(!0);default:return g()}}return W(),a.getToken()===17?s.allowEmptyContent?!0:(L(4,[],[]),!1):N()?(a.getToken()!==17&&L(9,[],[]),!0):(L(4,[],[]),!1)}t.visit=P;function o(e,n){let s=k(e),a=[],r,f=0,O;do switch(O=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:f!==O&&a.push(e.substring(f,O)),n!==void 0&&a.push(s.getTokenValue().replace(/[^\r\n]/g,n)),f=s.getPosition();break}while(r!==17);return a.join("")}t.stripComments=o;function i(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=i});"use strict";(function(){function x(F){const E=[];typeof F=="number"&&E.push("code/timeOrigin",F);function k(h){E.push(h,Date.now())}function T(){const h=[];for(let d=0;d<E.length;d+=2)h.push({name:E[d],startTime:E[d+1]});return h}return{mark:k,getMarks:T}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(F){performance.mark(F)},getMarks(){let F=performance.timeOrigin;typeof F!="number"&&(F=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const E=[{name:"code/timeOrigin",startTime:Math.round(F)}];for(const k of performance.getEntriesByType("mark"))E.push({name:k.name,startTime:Math.round(F+k.startTime)});return E}};if(typeof process=="object"){const F=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(F)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function y(F){return F.MonacoPerformanceMarks||(F.MonacoPerformanceMarks=t()),F.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=y(A))})(),function(x,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var y=t();for(var A in y)(typeof exports=="object"?exports:x)[A]=y[A]}}(typeof self!="undefined"?self:this,function(){return function(x){var t={};function y(A){if(t[A])return t[A].exports;var F=t[A]={i:A,l:!1,exports:{}};return x[A].call(F.exports,F,F.exports,y),F.l=!0,F.exports}return y.m=x,y.c=t,y.d=function(A,F,E){y.o(A,F)||Object.defineProperty(A,F,{enumerable:!0,get:E})},y.r=function(A){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},y.t=function(A,F){if(1&F&&(A=y(A)),8&F||4&F&&typeof A=="object"&&A&&A.__esModule)return A;var E=Object.create(null);if(y.r(E),Object.defineProperty(E,"default",{enumerable:!0,value:A}),2&F&&typeof A!="string")for(var k in A)y.d(E,k,function(T){return A[T]}.bind(null,k));return E},y.n=function(A){var F=A&&A.__esModule?function(){return A.default}:function(){return A};return y.d(F,"a",F),F},y.o=function(A,F){return Object.prototype.hasOwnProperty.call(A,F)},y.p="",y(y.s=0)}([function(x,t,y){(function(A){var F;t=x.exports=_,F=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var E=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,T=t.re=[],h=t.src=[],d=0,b=d++;h[b]="0|[1-9]\\d*";var u=d++;h[u]="[0-9]+";var R=d++;h[R]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=d++;h[w]="("+h[b]+")\\.("+h[b]+")\\.("+h[b]+")";var l=d++;h[l]="("+h[u]+")\\.("+h[u]+")\\.("+h[u]+")";var C=d++;h[C]="(?:"+h[b]+"|"+h[R]+")";var v=d++;h[v]="(?:"+h[u]+"|"+h[R]+")";var m=d++;h[m]="(?:-("+h[C]+"(?:\\."+h[C]+")*))";var p=d++;h[p]="(?:-?("+h[v]+"(?:\\."+h[v]+")*))";var P=d++;h[P]="[0-9A-Za-z-]+";var o=d++;h[o]="(?:\\+("+h[P]+"(?:\\."+h[P]+")*))";var i=d++,e="v?"+h[w]+h[m]+"?"+h[o]+"?";h[i]="^"+e+"$";var n="[v=\\s]*"+h[l]+h[p]+"?"+h[o]+"?",s=d++;h[s]="^"+n+"$";var a=d++;h[a]="((?:<|>)?=?)";var r=d++;h[r]=h[u]+"|x|X|\\*";var f=d++;h[f]=h[b]+"|x|X|\\*";var O=d++;h[O]="[v=\\s]*("+h[f]+")(?:\\.("+h[f]+")(?:\\.("+h[f]+")(?:"+h[m]+")?"+h[o]+"?)?)?";var j=d++;h[j]="[v=\\s]*("+h[r]+")(?:\\.("+h[r]+")(?:\\.("+h[r]+")(?:"+h[p]+")?"+h[o]+"?)?)?";var M=d++;h[M]="^"+h[a]+"\\s*"+h[O]+"$";var U=d++;h[U]="^"+h[a]+"\\s*"+h[j]+"$";var B=d++;h[B]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var K=d++;h[K]="(?:~>?)";var ee=d++;h[ee]="(\\s*)"+h[K]+"\\s+",T[ee]=new RegExp(h[ee],"g");var ae=d++;h[ae]="^"+h[K]+h[O]+"$";var re=d++;h[re]="^"+h[K]+h[j]+"$";var Z=d++;h[Z]="(?:\\^)";var le=d++;h[le]="(\\s*)"+h[Z]+"\\s+",T[le]=new RegExp(h[le],"g");var W=d++;h[W]="^"+h[Z]+h[O]+"$";var L=d++;h[L]="^"+h[Z]+h[j]+"$";var S=d++;h[S]="^"+h[a]+"\\s*("+n+")$|^$";var g=d++;h[g]="^"+h[a]+"\\s*("+e+")$|^$";var c=d++;h[c]="(\\s*)"+h[a]+"\\s*("+n+"|"+h[O]+")",T[c]=new RegExp(h[c],"g");var I=d++;h[I]="^\\s*("+h[O]+")\\s+-\\s+("+h[O]+")\\s*$";var D=d++;h[D]="^\\s*("+h[j]+")\\s+-\\s+("+h[j]+")\\s*$";var N=d++;h[N]="(<|>)?=?\\s*\\*";for(var z=0;z<35;z++)F(z,h[z]),T[z]||(T[z]=new RegExp(h[z]));function $(V,G){if(V instanceof _)return V;if(typeof V!="string"||V.length>E||!(G?T[s]:T[i]).test(V))return null;try{return new _(V,G)}catch(H){return null}}function _(V,G){if(V instanceof _){if(V.loose===G)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>E)throw new TypeError("version is longer than "+E+" characters");if(!(this instanceof _))return new _(V,G);F("SemVer",V,G),this.loose=G;var H=V.trim().match(G?T[s]:T[i]);if(!H)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ie){if(/^[0-9]+$/.test(ie)){var se=+ie;if(se>=0&&se<k)return se}return ie}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}t.parse=$,t.valid=function(V,G){var H=$(V,G);return H?H.version:null},t.clean=function(V,G){var H=$(V.trim().replace(/^[=v]+/,""),G);return H?H.version:null},t.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(V){return F("SemVer.compare",this.version,this.loose,V),V instanceof _||(V=new _(V,this.loose)),this.compareMain(V)||this.comparePre(V)},_.prototype.compareMain=function(V){return V instanceof _||(V=new _(V,this.loose)),X(this.major,V.major)||X(this.minor,V.minor)||X(this.patch,V.patch)},_.prototype.comparePre=function(V){if(V instanceof _||(V=new _(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var G=0;do{var H=this.prerelease[G],ie=V.prerelease[G];if(F("prerelease compare",G,H,ie),H===void 0&&ie===void 0)return 0;if(ie===void 0)return 1;if(H===void 0)return-1;if(H!==ie)return X(H,ie)}while(++G)},_.prototype.inc=function(V,G){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},t.inc=function(V,G,H,ie){typeof H=="string"&&(ie=H,H=void 0);try{return new _(V,H).inc(G,ie).version}catch(se){return null}},t.diff=function(V,G){if(de(V,G))return null;var H=$(V),ie=$(G);if(H.prerelease.length||ie.prerelease.length){for(var se in H)if((se==="major"||se==="minor"||se==="patch")&&H[se]!==ie[se])return"pre"+se;return"prerelease"}for(var se in H)if((se==="major"||se==="minor"||se==="patch")&&H[se]!==ie[se])return se},t.compareIdentifiers=X;var q=/^[0-9]+$/;function X(V,G){var H=q.test(V),ie=q.test(G);return H&&ie&&(V=+V,G=+G),H&&!ie?-1:ie&&!H?1:V<G?-1:V>G?1:0}function J(V,G,H){return new _(V,H).compare(new _(G,H))}function te(V,G,H){return J(V,G,H)>0}function ne(V,G,H){return J(V,G,H)<0}function de(V,G,H){return J(V,G,H)===0}function me(V,G,H){return J(V,G,H)!==0}function Ie(V,G,H){return J(V,G,H)>=0}function Le(V,G,H){return J(V,G,H)<=0}function Fe(V,G,H,ie){var se;switch(G){case"===":typeof V=="object"&&(V=V.version),typeof H=="object"&&(H=H.version),se=V===H;break;case"!==":typeof V=="object"&&(V=V.version),typeof H=="object"&&(H=H.version),se=V!==H;break;case"":case"=":case"==":se=de(V,H,ie);break;case"!=":se=me(V,H,ie);break;case">":se=te(V,H,ie);break;case">=":se=Ie(V,H,ie);break;case"<":se=ne(V,H,ie);break;case"<=":se=Le(V,H,ie);break;default:throw new TypeError("Invalid operator: "+G)}return se}function Pe(V,G){if(V instanceof Pe){if(V.loose===G)return V;V=V.value}if(!(this instanceof Pe))return new Pe(V,G);F("comparator",V,G),this.loose=G,this.parse(V),this.semver===Ae?this.value="":this.value=this.operator+this.semver.version,F("comp",this)}t.rcompareIdentifiers=function(V,G){return X(G,V)},t.major=function(V,G){return new _(V,G).major},t.minor=function(V,G){return new _(V,G).minor},t.patch=function(V,G){return new _(V,G).patch},t.compare=J,t.compareLoose=function(V,G){return J(V,G,!0)},t.rcompare=function(V,G,H){return J(G,V,H)},t.sort=function(V,G){return V.sort(function(H,ie){return t.compare(H,ie,G)})},t.rsort=function(V,G){return V.sort(function(H,ie){return t.rcompare(H,ie,G)})},t.gt=te,t.lt=ne,t.eq=de,t.neq=me,t.gte=Ie,t.lte=Le,t.cmp=Fe,t.Comparator=Pe;var Ae={};function ve(V,G){if(V instanceof ve)return V.loose===G?V:new ve(V.raw,G);if(V instanceof Pe)return new ve(V.value,G);if(!(this instanceof ve))return new ve(V,G);if(this.loose=G,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function Oe(V){return!V||V.toLowerCase()==="x"||V==="*"}function Be(V,G,H,ie,se,we,he,Re,ye,De,ke,Ee,Se){return((G=Oe(H)?"":Oe(ie)?">="+H+".0.0":Oe(se)?">="+H+"."+ie+".0":">="+G)+" "+(Re=Oe(ye)?"":Oe(De)?"<"+(+ye+1)+".0.0":Oe(ke)?"<"+ye+"."+(+De+1)+".0":Ee?"<="+ye+"."+De+"."+ke+"-"+Ee:"<="+Re)).trim()}function _e(V,G){for(var H=0;H<V.length;H++)if(!V[H].test(G))return!1;if(G.prerelease.length){for(H=0;H<V.length;H++)if(F(V[H].semver),V[H].semver!==Ae&&V[H].semver.prerelease.length>0){var ie=V[H].semver;if(ie.major===G.major&&ie.minor===G.minor&&ie.patch===G.patch)return!0}return!1}return!0}function je(V,G,H){try{G=new ve(G,H)}catch(ie){return!1}return G.test(V)}function ze(V,G,H,ie){var se,we,he,Re,ye;switch(V=new _(V,ie),G=new ve(G,ie),H){case">":se=te,we=Le,he=ne,Re=">",ye=">=";break;case"<":se=ne,we=Ie,he=te,Re="<",ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(V,G,ie))return!1;for(var De=0;De<G.set.length;++De){var ke=G.set[De],Ee=null,Se=null;if(ke.forEach(function(Ce){Ce.semver===Ae&&(Ce=new Pe(">=0.0.0")),Ee=Ee||Ce,Se=Se||Ce,se(Ce.semver,Ee.semver,ie)?Ee=Ce:he(Ce.semver,Se.semver,ie)&&(Se=Ce)}),Ee.operator===Re||Ee.operator===ye||(!Se.operator||Se.operator===Re)&&we(V,Se.semver)||Se.operator===ye&&he(V,Se.semver))return!1}return!0}Pe.prototype.parse=function(V){var G=this.loose?T[S]:T[g],H=V.match(G);if(!H)throw new TypeError("Invalid comparator: "+V);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new _(H[2],this.loose):this.semver=Ae},Pe.prototype.toString=function(){return this.value},Pe.prototype.test=function(V){return F("Comparator.test",V,this.loose),this.semver===Ae||(typeof V=="string"&&(V=new _(V,this.loose)),Fe(V,this.operator,this.semver,this.loose))},Pe.prototype.intersects=function(V,G){if(!(V instanceof Pe))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new ve(V.value,G),je(this.value,H,G);if(V.operator==="")return H=new ve(this.value,G),je(V.semver,H,G);var ie=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),se=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),we=this.semver.version===V.semver.version,he=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Re=Fe(this.semver,"<",V.semver,G)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),ye=Fe(this.semver,">",V.semver,G)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return ie||se||we&&he||Re||ye},t.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(V){var G=this.loose;V=V.trim(),F("range",V,G);var H=G?T[D]:T[I];V=V.replace(H,Be),F("hyphen replace",V),V=V.replace(T[c],"$1$2$3"),F("comparator trim",V,T[c]),V=(V=(V=V.replace(T[ee],"$1~")).replace(T[le],"$1^")).split(/\s+/).join(" ");var ie=G?T[S]:T[g],se=V.split(" ").map(function(we){return function(he,Re){return F("comp",he),he=function(ye,De){return ye.trim().split(/\s+/).map(function(ke){return function(Ee,Se){F("caret",Ee,Se);var Ce=Se?T[L]:T[W];return Ee.replace(Ce,function(Te,oe,ue,ge,pe){var be;return F("caret",Ee,Te,oe,ue,ge,pe),Oe(oe)?be="":Oe(ue)?be=">="+oe+".0.0 <"+(+oe+1)+".0.0":Oe(ge)?be=oe==="0"?">="+oe+"."+ue+".0 <"+oe+"."+(+ue+1)+".0":">="+oe+"."+ue+".0 <"+(+oe+1)+".0.0":pe?(F("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),be=oe==="0"?ue==="0"?">="+oe+"."+ue+"."+ge+pe+" <"+oe+"."+ue+"."+(+ge+1):">="+oe+"."+ue+"."+ge+pe+" <"+oe+"."+(+ue+1)+".0":">="+oe+"."+ue+"."+ge+pe+" <"+(+oe+1)+".0.0"):(F("no pr"),be=oe==="0"?ue==="0"?">="+oe+"."+ue+"."+ge+" <"+oe+"."+ue+"."+(+ge+1):">="+oe+"."+ue+"."+ge+" <"+oe+"."+(+ue+1)+".0":">="+oe+"."+ue+"."+ge+" <"+(+oe+1)+".0.0"),F("caret return",be),be})}(ke,De)}).join(" ")}(he,Re),F("caret",he),he=function(ye,De){return ye.trim().split(/\s+/).map(function(ke){return function(Ee,Se){var Ce=Se?T[re]:T[ae];return Ee.replace(Ce,function(Te,oe,ue,ge,pe){var be;return F("tilde",Ee,Te,oe,ue,ge,pe),Oe(oe)?be="":Oe(ue)?be=">="+oe+".0.0 <"+(+oe+1)+".0.0":Oe(ge)?be=">="+oe+"."+ue+".0 <"+oe+"."+(+ue+1)+".0":pe?(F("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),be=">="+oe+"."+ue+"."+ge+pe+" <"+oe+"."+(+ue+1)+".0"):be=">="+oe+"."+ue+"."+ge+" <"+oe+"."+(+ue+1)+".0",F("tilde return",be),be})}(ke,De)}).join(" ")}(he,Re),F("tildes",he),he=function(ye,De){return F("replaceXRanges",ye,De),ye.split(/\s+/).map(function(ke){return function(Ee,Se){Ee=Ee.trim();var Ce=Se?T[U]:T[M];return Ee.replace(Ce,function(Te,oe,ue,ge,pe,be){F("xRange",Ee,Te,oe,ue,ge,pe,be);var Ue=Oe(ue),Me=Ue||Oe(ge),Ne=Me||Oe(pe);return oe==="="&&Ne&&(oe=""),Ue?Te=oe===">"||oe==="<"?"<0.0.0":"*":oe&&Ne?(Me&&(ge=0),Ne&&(pe=0),oe===">"?(oe=">=",Me?(ue=+ue+1,ge=0,pe=0):Ne&&(ge=+ge+1,pe=0)):oe==="<="&&(oe="<",Me?ue=+ue+1:ge=+ge+1),Te=oe+ue+"."+ge+"."+pe):Me?Te=">="+ue+".0.0 <"+(+ue+1)+".0.0":Ne&&(Te=">="+ue+"."+ge+".0 <"+ue+"."+(+ge+1)+".0"),F("xRange return",Te),Te})}(ke,De)}).join(" ")}(he,Re),F("xrange",he),he=function(ye,De){return F("replaceStars",ye,De),ye.trim().replace(T[N],"")}(he,Re),F("stars",he),he}(we,G)}).join(" ").split(/\s+/);return this.loose&&(se=se.filter(function(we){return!!we.match(ie)})),se=se.map(function(we){return new Pe(we,G)})},ve.prototype.intersects=function(V,G){if(!(V instanceof ve))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ie){return V.set.some(function(se){return se.every(function(we){return ie.intersects(we,G)})})})})},t.toComparators=function(V,G){return new ve(V,G).set.map(function(H){return H.map(function(ie){return ie.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new _(V,this.loose));for(var G=0;G<this.set.length;G++)if(_e(this.set[G],V))return!0;return!1},t.satisfies=je,t.maxSatisfying=function(V,G,H){var ie=null,se=null;try{var we=new ve(G,H)}catch(he){return null}return V.forEach(function(he){we.test(he)&&(ie&&se.compare(he)!==-1||(se=new _(ie=he,H)))}),ie},t.minSatisfying=function(V,G,H){var ie=null,se=null;try{var we=new ve(G,H)}catch(he){return null}return V.forEach(function(he){we.test(he)&&(ie&&se.compare(he)!==1||(se=new _(ie=he,H)))}),ie},t.validRange=function(V,G){try{return new ve(V,G).range||"*"}catch(H){return null}},t.ltr=function(V,G,H){return ze(V,G,"<",H)},t.gtr=function(V,G,H){return ze(V,G,">",H)},t.outside=ze,t.prerelease=function(V,G){var H=$(V,G);return H&&H.prerelease.length?H.prerelease:null},t.intersects=function(V,G,H){return V=new ve(V,H),G=new ve(G,H),V.intersects(G)},t.coerce=function(V){if(V instanceof _)return V;if(typeof V!="string")return null;var G=V.match(T[B]);return G==null?null:$((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,y(1))},function(x,t){var y,A,F=x.exports={};function E(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function T(v){if(y===setTimeout)return setTimeout(v,0);if((y===E||!y)&&setTimeout)return y=setTimeout,setTimeout(v,0);try{return y(v,0)}catch(m){try{return y.call(null,v,0)}catch(p){return y.call(this,v,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:E}catch(v){y=E}try{A=typeof clearTimeout=="function"?clearTimeout:k}catch(v){A=k}})();var h,d=[],b=!1,u=-1;function R(){b&&h&&(b=!1,h.length?d=h.concat(d):u=-1,d.length&&w())}function w(){if(!b){var v=T(R);b=!0;for(var m=d.length;m;){for(h=d,d=[];++u<m;)h&&h[u].run();u=-1,m=d.length}h=null,b=!1,function(p){if(A===clearTimeout)return clearTimeout(p);if((A===k||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(p);try{A(p)}catch(P){try{return A.call(null,p)}catch(o){return A.call(this,p)}}}(v)}}function l(v,m){this.fun=v,this.array=m}function C(){}F.nextTick=function(v){var m=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)m[p-1]=arguments[p];d.push(new l(v,m)),d.length!==1||b||T(w)},l.prototype.run=function(){this.fun.apply(null,this.array)},F.title="browser",F.browser=!0,F.env={},F.argv=[],F.version="",F.versions={},F.on=C,F.addListener=C,F.once=C,F.off=C,F.removeListener=C,F.removeAllListeners=C,F.emit=C,F.prependListener=C,F.prependOnceListener=C,F.listeners=function(v){return[]},F.binding=function(v){throw new Error("process.binding is not supported")},F.cwd=function(){return"/"},F.chdir=function(v){throw new Error("process.chdir is not supported")},F.umask=function(){return 0}}])}),define(Q[31],Y([0,1,15,2]),function(x,t,y,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.transform=t.toReadable=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function F(v){const m=v;return m&&[m.on,m.pause,m.resume,m.destroy].every(p=>typeof p=="function")}t.isReadableStream=F;function E(v){const m=v;return m&&F(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean"}t.isReadableBufferedStream=E;function k(v,m){return new T(v,m)}t.newWriteableStream=k;class T{constructor(m,p){this.reducer=m,this.options=p,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){var p;if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof((p=this.options)===null||p===void 0?void 0:p.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(P=>this.pendingWritePromises.push(P))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(p=>p(m))}emitError(m){this.listeners.error.length===0?(0,y.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(p=>p(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,p){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(p),this.resume();break;case"end":this.listeners.end.push(p),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(p),this.state.flowing&&this.flowErrors();break}}removeListener(m,p){if(!this.state.destroyed){let P;switch(m){case"data":P=this.listeners.data;break;case"end":P=this.listeners.end;break;case"error":P=this.listeners.error;break}if(P){const o=P.indexOf(p);o>=0&&P.splice(o,1)}}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const p=[...this.pendingWritePromises];this.pendingWritePromises.length=0,p.forEach(P=>P())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function h(v,m){const p=[];let P;for(;(P=v.read())!==null;)p.push(P);return m(p)}t.consumeReadable=h;function d(v,m,p){const P=[];let o;for(;(o=v.read())!==null&&P.length<p;)P.push(o);return o===null&&P.length>0?m(P):{read:()=>{if(P.length>0)return P.shift();if(typeof o!="undefined"){const i=o;return o=void 0,i}return v.read()}}}t.peekReadable=d;function b(v,m){return new Promise((p,P)=>{const o=[];u(v,{onData:i=>{m&&o.push(i)},onError:i=>{m?P(i):p(void 0)},onEnd:()=>{p(m?m(o):void 0)}})})}t.consumeStream=b;function u(v,m){v.on("error",p=>m.onError(p)),v.on("end",()=>m.onEnd()),v.on("data",p=>m.onData(p))}t.listenStream=u;function R(v,m){return new Promise((p,P)=>{const o=new A.DisposableStore,i=[],e=a=>{if(i.push(a),i.length>m)return o.dispose(),v.pause(),p({stream:v,buffer:i,ended:!1})},n=a=>P(a),s=()=>p({stream:v,buffer:i,ended:!0});o.add((0,A.toDisposable)(()=>v.removeListener("error",n))),v.on("error",n),o.add((0,A.toDisposable)(()=>v.removeListener("end",s))),v.on("end",s),o.add((0,A.toDisposable)(()=>v.removeListener("data",e))),v.on("data",e)})}t.peekStream=R;function w(v,m){const p=k(m);return p.end(v),p}t.toStream=w;function l(v){let m=!1;return{read:()=>m?null:(m=!0,v)}}t.toReadable=l;function C(v,m,p){const P=k(p);return u(v,{onData:o=>P.write(m.data(o)),onError:o=>P.error(m.error?m.error(o):o),onEnd:()=>P.end()}),P}t.transform=C}),define(Q[16],Y([0,1,18,31]),function(x,t,y,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const F=typeof Buffer!="undefined",E=typeof TextEncoder!="undefined",k=typeof TextDecoder!="undefined";let T,h;class d{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return F?new d(Buffer.allocUnsafe(r)):new d(new Uint8Array(r))}static wrap(r){return F&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new d(r)}static fromString(r,f){return!((f==null?void 0:f.dontUseNodeBuffer)||!1)&&F?new d(Buffer.from(r)):E?(T||(T=new TextEncoder),new d(T.encode(r))):new d(y.encodeUTF8(r))}static concat(r,f){if(typeof f=="undefined"){f=0;for(let M=0,U=r.length;M<U;M++)f+=r[M].byteLength}const O=d.alloc(f);let j=0;for(let M=0,U=r.length;M<U;M++){const B=r[M];O.set(B,j),j+=B.byteLength}return O}toString(){return F?this.buffer.toString():k?(h||(h=new TextDecoder),h.decode(this.buffer)):y.decodeUTF8(this.buffer)}slice(r,f){return new d(this.buffer.subarray(r,f))}set(r,f){r instanceof d?this.buffer.set(r.buffer,f):this.buffer.set(r,f)}readUInt32BE(r){return R(this.buffer,r)}writeUInt32BE(r,f){w(this.buffer,r,f)}readUInt32LE(r){return l(this.buffer,r)}writeUInt32LE(r,f){C(this.buffer,r,f)}readUInt8(r){return v(this.buffer,r)}writeUInt8(r,f){m(this.buffer,r,f)}}t.VSBuffer=d;function b(a,r){return a[r+0]<<0>>>0|a[r+1]<<8>>>0}t.readUInt16LE=b;function u(a,r,f){a[f+0]=r&255,r=r>>>8,a[f+1]=r&255}t.writeUInt16LE=u;function R(a,r){return a[r]*2**24+a[r+1]*2**16+a[r+2]*2**8+a[r+3]}t.readUInt32BE=R;function w(a,r,f){a[f+3]=r,r=r>>>8,a[f+2]=r,r=r>>>8,a[f+1]=r,r=r>>>8,a[f]=r}t.writeUInt32BE=w;function l(a,r){return a[r+0]<<0>>>0|a[r+1]<<8>>>0|a[r+2]<<16>>>0|a[r+3]<<24>>>0}t.readUInt32LE=l;function C(a,r,f){a[f+0]=r&255,r=r>>>8,a[f+1]=r&255,r=r>>>8,a[f+2]=r&255,r=r>>>8,a[f+3]=r&255}t.writeUInt32LE=C;function v(a,r){return a[r]}t.readUInt8=v;function m(a,r,f){a[f]=r}t.writeUInt8=m;function p(a){return A.consumeReadable(a,r=>d.concat(r))}t.readableToBuffer=p;function P(a){return A.toReadable(a)}t.bufferToReadable=P;function o(a){return A.consumeStream(a,r=>d.concat(r))}t.streamToBuffer=o;async function i(a){return a.ended?d.concat(a.buffer):d.concat([...a.buffer,await o(a.stream)])}t.bufferedStreamToBuffer=i;function e(a){return A.toStream(a,r=>d.concat(r))}t.bufferToStream=e;function n(a){return A.transform(a,{data:r=>typeof r=="string"?d.fromString(r):d.wrap(r)},r=>d.concat(r))}t.streamToBufferReadableStream=n;function s(a){return A.newWriteableStream(r=>d.concat(r),a)}t.newWriteableBufferStream=s}),define(Q[19],Y([0,1,8]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function A(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const C=Array.isArray(l)?[]:{};return Object.keys(l).forEach(v=>{l[v]&&typeof l[v]=="object"?C[v]=A(l[v]):C[v]=l[v]}),C}t.deepClone=A;function F(l){if(!l||typeof l!="object")return l;const C=[l];for(;C.length>0;){const v=C.shift();Object.freeze(v);for(const m in v)if(E.call(v,m)){const p=v[m];typeof p=="object"&&!Object.isFrozen(p)&&C.push(p)}}return l}t.deepFreeze=F;const E=Object.prototype.hasOwnProperty;function k(l,C){return T(l,C,new Set)}t.cloneAndChange=k;function T(l,C,v){if((0,y.isUndefinedOrNull)(l))return l;const m=C(l);if(typeof m!="undefined")return m;if((0,y.isArray)(l)){const p=[];for(const P of l)p.push(T(P,C,v));return p}if((0,y.isObject)(l)){if(v.has(l))throw new Error("Cannot clone recursive data-structure");v.add(l);const p={};for(let P in l)E.call(l,P)&&(p[P]=T(l[P],C,v));return v.delete(l),p}return l}function h(l,C,v=!0){return(0,y.isObject)(l)?((0,y.isObject)(C)&&Object.keys(C).forEach(m=>{m in l?v&&((0,y.isObject)(l[m])&&(0,y.isObject)(C[m])?h(l[m],C[m],v):l[m]=C[m]):l[m]=C[m]}),l):C}t.mixin=h;function d(l,C){if(l===C)return!0;if(l==null||C===null||C===void 0||typeof l!=typeof C||typeof l!="object"||Array.isArray(l)!==Array.isArray(C))return!1;let v,m;if(Array.isArray(l)){if(l.length!==C.length)return!1;for(v=0;v<l.length;v++)if(!d(l[v],C[v]))return!1}else{const p=[];for(m in l)p.push(m);p.sort();const P=[];for(m in C)P.push(m);if(P.sort(),!d(p,P))return!1;for(v=0;v<p.length;v++)if(!d(l[p[v]],C[p[v]]))return!1}return!0}t.equals=d;function b(l){const C=new Set;return JSON.stringify(l,(v,m)=>{if((0,y.isObject)(m)||Array.isArray(m)){if(C.has(m))return"[Circular]";C.add(m)}return m})}t.safeStringify=b;function u(l,C,v){const m=C(l);return typeof m=="undefined"?v:m}t.getOrDefault=u;function R(l,C){const v=Object.create(null);return!l||!C||Object.keys(C).forEach(p=>{const P=l[p],o=C[p];d(P,o)||(v[p]=o)}),v}t.distinct=R;function w(l,C){const v=C.toLowerCase(),m=Object.keys(l).find(p=>p.toLowerCase()===v);return m?l[m]:l[C]}t.getCaseInsensitive=w}),define(Q[57],Y([0,1,10]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function A(d){const b=d;return b&&typeof b.type=="string"&&typeof b.severity=="string"}t.isRemoteConsoleLog=A;function F(d){const b=[];let u;try{const R=JSON.parse(d.arguments),w=R[R.length-1];w&&w.__$stack&&(R.pop(),u=w.__$stack),b.push(...R)}catch(R){b.push("Unable to log remote console arguments",d.arguments)}return{args:b,stack:u}}t.parse=F;function E(d){if(typeof d!="string")return E(F(d).stack);const b=d;if(b){const u=k(b),R=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(u||"");if(R&&R.length===4)return{uri:y.URI.file(R[1]),line:Number(R[2]),column:Number(R[3])}}}t.getFirstFrame=E;function k(d){if(!d)return d;const b=d.indexOf(`
`);return b===-1?d:d.substring(0,b)}function T(d,b){const{args:u,stack:R}=F(d),w=typeof u[0]=="string"&&u.length===1;let l=k(R);l&&(l=`(${l.trim()})`);let C=[];if(typeof u[0]=="string"?l&&w?C=[`%c[${b}] %c${u[0]} %c${l}`,h("blue"),h(""),h("grey")]:C=[`%c[${b}] %c${u[0]}`,h("blue"),h(""),...u.slice(1)]:C=[`%c[${b}]%`,h("blue"),...u],l&&!w&&C.push(l),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,C)}t.log=T;function h(d){return`color: ${d}`}}),define(Q[58],Y([0,1,16,18,10]),function(x,t,y,A,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function E(d){return JSON.stringify(d,T)}t.stringify=E;function k(d){let b=JSON.parse(d);return b=h(b),b}t.parse=k;function T(d,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,A.regExpFlags)(b)}:b}function h(d,b=0){if(!d||b>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return F.URI.revive(d);case 2:return new RegExp(d.source,d.flags)}if(d instanceof y.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let u=0;u<d.length;++u)d[u]=h(d[u],b+1);else for(const u in d)Object.hasOwnProperty.call(d,u)&&(d[u]=h(d[u],b+1))}return d}t.revive=h}),define(Q[59],Y([0,1,18,32,3,43,4]),function(x,t,y,A,F,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function T(){return Object.create(null)}t.getEmptyExpression=T;const h="**",d="/",b="[/\\\\]",u="[^/\\\\]",R=/\//g;function w(c){switch(c){case 0:return"";case 1:return`${u}*?`;default:return`(?:${b}|${u}+${b}|${b}${u}+)*?`}}function l(c,I){if(!c)return[];const D=[];let N=!1,z=!1,$="";for(const _ of c){switch(_){case I:if(!N&&!z){D.push($),$="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":z=!0;break;case"]":z=!1;break}$+=_}return $&&D.push($),D}t.splitGlobAware=l;function C(c){if(!c)return"";let I="";const D=l(c,d);if(D.every(N=>N===h))I=".*";else{let N=!1;D.forEach((z,$)=>{if(z===h){N||(I+=w(2),N=!0);return}let _=!1,q="",X=!1,J="";for(const te of z){if(te!=="}"&&_){q+=te;continue}if(X&&(te!=="]"||!J)){let ne;te==="-"?ne=te:(te==="^"||te==="!")&&!J?ne="^":te===d?ne="":ne=y.escapeRegExpCharacters(te),J+=ne;continue}switch(te){case"{":_=!0;continue;case"[":X=!0;continue;case"}":I+=`(?:${l(q,",").map(me=>C(me)).join("|")})`,_=!1,q="";break;case"]":I+="["+J+"]",X=!1,J="";break;case"?":I+=u;continue;case"*":I+=w(1);continue;default:I+=y.escapeRegExpCharacters(te)}}$<D.length-1&&(D[$+1]!==h||$+2<D.length)&&(I+=b),N=!1})}return I}const v=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,P=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,i=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new E.LRUCache(1e4),n=function(){return!1},s=function(){return null};function a(c,I){if(!c)return s;let D;typeof c!="string"?D=c.pattern:D=c,D=D.trim();const N=`${D}_${!!I.trimForExclusions}`;let z=e.get(N);if(z)return r(z,c);let $;if(v.test(D)){const _=D.substr(4);z=function(q,X){return typeof q=="string"&&q.endsWith(_)?D:null}}else($=m.exec(f(D,I)))?z=O($[1],D):(I.trimForExclusions?P:p).test(D)?z=j(D,I):($=o.exec(f(D,I)))?z=M($[1].substr(1),D,!0):($=i.exec(f(D,I)))?z=M($[1],D,!1):z=U(D);return e.set(N,z),r(z,c)}function r(c,I){return typeof I=="string"?c:function(D,N){return A.isEqualOrParent(D,I.base)?c(F.relative(I.base,D),N):null}}function f(c,I){return I.trimForExclusions&&c.endsWith("/**")?c.substr(0,c.length-2):c}function O(c,I){const D=`/${c}`,N=`\\${c}`,z=function(_,q){return typeof _!="string"?null:q?q===c?I:null:_===c||_.endsWith(D)||_.endsWith(N)?I:null},$=[c];return z.basenames=$,z.patterns=[I],z.allBasenames=$,z}function j(c,I){const D=g(c.slice(1,-1).split(",").map(q=>a(q,I)).filter(q=>q!==s),c),N=D.length;if(!N)return s;if(N===1)return D[0];const z=function(q,X){for(let J=0,te=D.length;J<te;J++)if(D[J](q,X))return c;return null},$=D.find(q=>!!q.allBasenames);$&&(z.allBasenames=$.allBasenames);const _=D.reduce((q,X)=>X.allPaths?q.concat(X.allPaths):q,[]);return _.length&&(z.allPaths=_),z}function M(c,I,D){const N=F.sep===F.posix.sep,z=N?c:c.replace(R,F.sep),$=F.sep+z,_=F.posix.sep+c,q=D?function(X,J){return typeof X=="string"&&(X===z||X.endsWith($)||!N&&(X===c||X.endsWith(_)))?I:null}:function(X,J){return typeof X=="string"&&(X===z||!N&&X===c)?I:null};return q.allPaths=[(D?"*/":"./")+c],q}function U(c){try{const I=new RegExp(`^${C(c)}$`);return function(D){return I.lastIndex=0,typeof D=="string"&&I.test(D)?c:null}}catch(I){return s}}function B(c,I,D){return!c||typeof I!="string"?!1:K(c)(I,void 0,D)}t.match=B;function K(c,I={}){if(!c)return n;if(typeof c=="string"||Z(c)){const D=a(c,I);if(D===s)return n;const N=function(z,$){return!!D(z,$)};return D.allBasenames&&(N.allBasenames=D.allBasenames),D.allPaths&&(N.allPaths=D.allPaths),N}return L(c,I)}t.parse=K;function ee(c){if(!!c){let I;return D=>(I||(I=(c()||Promise.resolve([])).then(N=>N?re(N):{})),I.then(N=>!!N[D]))}}t.hasSiblingPromiseFn=ee;function ae(c){if(!!c){let I;return D=>{if(!I){const N=c();I=N?re(N):{}}return!!I[D]}}}t.hasSiblingFn=ae;function re(c){const I={};for(const D of c)I[D]=!0;return I}function Z(c){const I=c;return I&&typeof I.base=="string"&&typeof I.pattern=="string"}t.isRelativePattern=Z;function le(c){return c.allBasenames||[]}t.getBasenameTerms=le;function W(c){return c.allPaths||[]}t.getPathTerms=W;function L(c,I){const D=g(Object.getOwnPropertyNames(c).map(q=>S(q,c[q],I)).filter(q=>q!==s)),N=D.length;if(!N)return s;if(!D.some(q=>!!q.requiresSiblings)){if(N===1)return D[0];const q=function(te,ne){for(let de=0,me=D.length;de<me;de++){const Ie=D[de](te,ne);if(Ie)return Ie}return null},X=D.find(te=>!!te.allBasenames);X&&(q.allBasenames=X.allBasenames);const J=D.reduce((te,ne)=>ne.allPaths?te.concat(ne.allPaths):te,[]);return J.length&&(q.allPaths=J),q}const z=function(q,X,J){let te;for(let ne=0,de=D.length;ne<de;ne++){const me=D[ne];me.requiresSiblings&&J&&(X||(X=F.basename(q)),te||(te=X.substr(0,X.length-F.extname(q).length)));const Ie=me(q,X,te,J);if(Ie)return Ie}return null},$=D.find(q=>!!q.allBasenames);$&&(z.allBasenames=$.allBasenames);const _=D.reduce((q,X)=>X.allPaths?q.concat(X.allPaths):q,[]);return _.length&&(z.allPaths=_),z}function S(c,I,D){if(I===!1)return s;const N=a(c,D);if(N===s)return s;if(typeof I=="boolean")return N;if(I){const z=I.when;if(typeof z=="string"){const $=(_,q,X,J)=>{if(!J||!N(_,q))return null;const te=z.replace("$(basename)",X),ne=J(te);return(0,k.isThenable)(ne)?ne.then(de=>de?c:null):ne?c:null};return $.requiresSiblings=!0,$}}return N}function g(c,I){const D=c.filter(q=>!!q.basenames);if(D.length<2)return c;const N=D.reduce((q,X)=>{const J=X.basenames;return J?q.concat(J):q},[]);let z;if(I){z=[];for(let q=0,X=N.length;q<X;q++)z.push(I)}else z=D.reduce((q,X)=>{const J=X.patterns;return J?q.concat(J):q},[]);const $=function(q,X){if(typeof q!="string")return null;if(!X){let te;for(te=q.length;te>0;te--){const ne=q.charCodeAt(te-1);if(ne===47||ne===92)break}X=q.substr(te)}const J=N.indexOf(X);return J!==-1?z[J]:null};$.basenames=N,$.patterns=z,$.allBasenames=N;const _=c.filter(q=>!q.basenames);return _.push($),_}}),define(Q[60],Y([0,1,10,3,18,9,17,21,32]),function(x,t,y,A,F,E,k,T,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function d(a,r,f){if(typeof a=="string"&&(a=y.URI.file(a)),f){const j=f.getWorkspaceFolder(a);if(j){const M=f.getWorkspace().folders.length>1;let U;if((0,T.isEqual)(j.uri,a)?U="":U=(0,T.relativePath)(j.uri,a),M){const B=j.name?j.name:(0,T.basename)(j.uri);U=U?B+" \u2022 "+U:B}return U}}if(a.scheme!==E.Schemas.file&&a.scheme!==E.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if((0,h.hasDriveLetter)(a.fsPath))return(0,A.normalize)(u(a.fsPath));let O=(0,A.normalize)(a.fsPath);return!k.isWindows&&(r==null?void 0:r.userHome)&&(O=w(O,r.userHome.fsPath)),O}t.getPathLabel=d;function b(a){if(!!a){typeof a=="string"&&(a=y.URI.file(a));const r=(0,T.basename)(a)||(a.scheme===E.Schemas.file?a.fsPath:a.path);return k.isWindows&&(0,h.isRootOrDriveLetter)(r)?u(r):r}}t.getBaseLabel=b;function u(a){return(0,h.hasDriveLetter)(a)?a.charAt(0).toUpperCase()+a.slice(1):a}t.normalizeDriveLetter=u;let R=Object.create(null);function w(a,r){if(k.isWindows||!a||!r)return a;let f=R.original===r?R.normalized:void 0;return f||(f=`${(0,F.rtrim)(r,A.posix.sep)}${A.posix.sep}`,R={original:r,normalized:f}),(k.isLinux?a.startsWith(f):(0,F.startsWithIgnoreCase)(a,f))&&(a=`~/${a.substr(f.length)}`),a}t.tildify=w;function l(a,r){return a.replace(/^~($|\/|\\)/,`${r}$1`)}t.untildify=l;const C="\u2026",v="\\\\",m="~";function p(a,r=A.sep){const f=new Array(a.length);let O=!1;for(let j=0;j<a.length;j++){let M=a[j];if(M===""){f[j]=`.${r}`;continue}if(!M){f[j]=M;continue}O=!0;let U="";M.indexOf(v)===0?(U=M.substr(0,M.indexOf(v)+v.length),M=M.substr(M.indexOf(v)+v.length)):M.indexOf(r)===0?(U=M.substr(0,M.indexOf(r)+r.length),M=M.substr(M.indexOf(r)+r.length)):M.indexOf(m)===0&&(U=M.substr(0,M.indexOf(m)+m.length),M=M.substr(M.indexOf(m)+m.length));const B=M.split(r);for(let K=1;O&&K<=B.length;K++)for(let ee=B.length-K;O&&ee>=0;ee--){O=!1;let ae=B.slice(ee,ee+K).join(r);for(let re=0;!O&&re<a.length;re++)if(re!==j&&a[re]&&a[re].indexOf(ae)>-1){const Z=ee+K===B.length,le=ee>0&&a[re].indexOf(r)>-1?r+ae:ae,W=a[re].endsWith(le);O=!Z||W}if(!O){let re="";(B[0].endsWith(":")||U!=="")&&(ee===1&&(ee=0,K++,ae=B[0]+r+ae),ee>0&&(re=B[0]+r),re=U+re),ee>0&&(re=re+C+r),re=re+ae,ee+K<B.length&&(re=re+r+C),f[j]=re}}O&&(f[j]=M)}return f}t.shorten=p;var P;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(P||(P={}));function o(a,r=Object.create(null)){const f=[];let O=!1,j="";for(const M of a)if(M==="$"||O&&M==="{")j&&f.push({value:j,type:P.TEXT}),j="",O=!0;else if(M==="}"&&O){const U=r[j];if(typeof U=="string")U.length&&f.push({value:U,type:P.VARIABLE});else if(U){const B=f[f.length-1];(!B||B.type!==P.SEPARATOR)&&f.push({value:U.label,type:P.SEPARATOR})}j="",O=!1}else j+=M;return j&&!O&&f.push({value:j,type:P.TEXT}),f.filter((M,U)=>{if(M.type===P.SEPARATOR){const B=f[U-1],K=f[U+1];return[B,K].every(ee=>ee&&(ee.type===P.VARIABLE||ee.type===P.TEXT)&&ee.value.length>0)}return!0}).map(M=>M.value).join("")}t.template=o;function i(a,r){return k.isMacintosh||r?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):a.replace(/&&|&/g,f=>f==="&"?"&&":"&")}t.mnemonicMenuLabel=i;function e(a,r){return k.isMacintosh||r?a.replace(/\(&&\w\)|&&/g,""):k.isWindows?a.replace(/&&|&/g,f=>f==="&"?"&&":"&"):a.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function n(a){return a.replace(/&/g,"&&")}t.unmnemonicLabel=n;function s(a){const r=a.indexOf("/")!==-1?A.posix:A.win32,f=r.basename(a),O=r.dirname(a);return f.length?{name:f,parentPath:O}:{name:O,parentPath:""}}t.splitName=s}),define(Q[44],Y([0,1,119]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class A{constructor(E="utf8"){this.stringDecoder=new y.StringDecoder(E),this.remaining=null}write(E){const k=[],T=this.remaining?this.remaining+this.stringDecoder.write(E):this.stringDecoder.write(E);if(T.length<1)return k;let h=0,d,b=h;for(;b<T.length;)if(d=T.charCodeAt(b),d===13||d===10){if(k.push(T.substring(h,b)),b++,b<T.length){const u=d;d=T.charCodeAt(b),(u===13&&d===10||u===10&&d===13)&&b++}h=b}else b++;return this.remaining=h<T.length?T.substr(h):null,k}end(){return this.remaining}}t.LineDecoder=A}),define(Q[61],Y([0,1,14,18,3,12]),function(x,t,y,A,F,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function k(b){const u=(0,F.dirname)(b);if(b===u)return b;const R=((0,F.basename)(b)||b).toLowerCase();try{const l=(0,E.readdirSync)(u).filter(C=>C.toLowerCase()===R);if(l.length===1){const C=k(u);if(C)return(0,F.join)(C,l[0])}else if(l.length>1){const C=l.indexOf(R);if(C>=0){const v=k(u);if(v)return(0,F.join)(v,l[C])}}}catch(w){}return null}t.realcaseSync=k;async function T(b){try{return await y.promises.realpath(b)}catch(u){const R=d(b);return await y.promises.access(R,y.constants.R_OK),R}}t.realpath=T;function h(b){try{return y.realpathSync(b)}catch(u){const R=d(b);return y.accessSync(R,y.constants.R_OK),R}}t.realpathSync=h;function d(b){return(0,A.rtrim)((0,F.normalize)(b),F.sep)}}),function(){"use strict";function x(t,y,A){function F(){let E=process.env.VSCODE_APPDATA;if(!E)switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=t.join(k,"AppData","Roaming")}break;case"darwin":E=t.join(y.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||t.join(y.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(E,A)}return{getDefaultUserDataPath:F}}if(typeof define=="function")define(Q[62],Y([0,120,45,9,21]),function(t,y,A,F,E){const k=E.dirname(F.FileAccess.asFileUri("",t)),T=t.__$__nodeRequire(E.joinPath(k,"package.json").fsPath);return x(y,A,T.name)});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../package.json"),y=require("path"),A=require("os");module.exports=x(y,A,t.name)}else throw new Error("Unknown context")}(),define(Q[63],Y([0,1,3,14,17,121,2,12]),function(x,t,y,A,F,E,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function h(u,R,w){return b({path:u,isDirectory:!1},R,w)}t.watchFile=h;function d(u,R,w){return b({path:u,isDirectory:!0},R,w)}t.watchFolder=d,t.CHANGE_BUFFER_DELAY=100;function b(u,R,w){const l=(0,y.basename)(u.path),C=new Map;let v=!1,m=[(0,k.toDisposable)(()=>{C.forEach(p=>(0,k.dispose)(p)),C.clear()})];try{const p=(0,A.watch)(u.path);m.push((0,k.toDisposable)(()=>{p.removeAllListeners(),p.close()}));const P=new Set;u.isDirectory&&(0,T.readdir)(u.path).then(o=>o.forEach(i=>P.add(i))),p.on("error",(o,i)=>{v||w(`Failed to watch ${u.path} for changes using fs.watch() (${o}, ${i})`)}),p.on("change",(o,i)=>{if(!v){let e="";if(i&&(e=i.toString(),F.isMacintosh&&(e=(0,E.normalizeNFC)(e))),!(!e||o!=="change"&&o!=="rename")){const n=u.isDirectory?(0,y.join)(u.path,e):u.path;if(u.isDirectory)if(o==="rename"){const s=C.get(n);s&&(0,k.dispose)(s);const a=setTimeout(async()=>{C.delete(n);const r=await(0,T.exists)(n);if(!v){let f;r?P.has(e)?f="changed":(f="added",P.add(e)):(P.delete(e),f="deleted"),R(f,n)}},t.CHANGE_BUFFER_DELAY);C.set(n,(0,k.toDisposable)(()=>clearTimeout(a)))}else{let s;P.has(e)?s="changed":(s="added",P.add(e)),R(s,n)}else if(o==="rename"||e!==l){const s=setTimeout(async()=>{const a=await(0,T.exists)(n);v||(a?(R("changed",n),m=[b(u,R,w)]):R("deleted",n))},t.CHANGE_BUFFER_DELAY);(0,k.dispose)(m),m=[(0,k.toDisposable)(()=>clearTimeout(s))]}else R("changed",n)}}})}catch(p){(0,T.exists)(u.path).then(P=>{P&&!v&&w(`Failed to watch ${u.path} for changes using fs.watch() (${p.toString()})`)})}return(0,k.toDisposable)(()=>{v=!0,m=(0,k.dispose)(m)})}}),define(Q[33],Y([0,1,11,2,4,28,15,16,20,8,58,18]),function(x,t,y,A,F,E,k,T,h,d,b,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var R;(function(S){S[S.Promise=100]="Promise",S[S.PromiseCancel=101]="PromiseCancel",S[S.EventListen=102]="EventListen",S[S.EventDispose=103]="EventDispose"})(R=t.RequestType||(t.RequestType={}));function w(S){switch(S){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(S){S[S.Initialize=200]="Initialize",S[S.PromiseSuccess=201]="PromiseSuccess",S[S.PromiseError=202]="PromiseError",S[S.PromiseErrorObj=203]="PromiseErrorObj",S[S.EventFire=204]="EventFire"})(l=t.ResponseType||(t.ResponseType={}));function C(S){switch(S){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(S){S[S.Uninitialized=0]="Uninitialized",S[S.Idle=1]="Idle"})(v||(v={}));class m{constructor(g){this.buffer=g,this.pos=0}read(g){const c=this.buffer.slice(this.pos,this.pos+g);return this.pos+=c.byteLength,c}}class p{constructor(){this.buffers=[]}get buffer(){return T.VSBuffer.concat(this.buffers)}write(g){this.buffers.push(g)}}var P;(function(S){S[S.Undefined=0]="Undefined",S[S.String=1]="String",S[S.Buffer=2]="Buffer",S[S.VSBuffer=3]="VSBuffer",S[S.Array=4]="Array",S[S.Object=5]="Object"})(P||(P={}));function o(S){const g=T.VSBuffer.alloc(4);return g.writeUInt32BE(S,0),g}function i(S){return S.read(4).readUInt32BE(0)}function e(S){const g=T.VSBuffer.alloc(1);return g.writeUInt8(S,0),g}const n={Undefined:e(P.Undefined),String:e(P.String),Buffer:e(P.Buffer),VSBuffer:e(P.VSBuffer),Array:e(P.Array),Object:e(P.Object)},s=typeof Buffer!="undefined";function a(S,g){if(typeof g=="undefined")S.write(n.Undefined);else if(typeof g=="string"){const c=T.VSBuffer.fromString(g);S.write(n.String),S.write(o(c.byteLength)),S.write(c)}else if(s&&Buffer.isBuffer(g)){const c=T.VSBuffer.wrap(g);S.write(n.Buffer),S.write(o(c.byteLength)),S.write(c)}else if(g instanceof T.VSBuffer)S.write(n.VSBuffer),S.write(o(g.byteLength)),S.write(g);else if(Array.isArray(g)){S.write(n.Array),S.write(o(g.length));for(const c of g)a(S,c)}else{const c=T.VSBuffer.fromString(JSON.stringify(g));S.write(n.Object),S.write(o(c.byteLength)),S.write(c)}}function r(S){switch(S.read(1).readUInt8(0)){case P.Undefined:return;case P.String:return S.read(i(S)).toString();case P.Buffer:return S.read(i(S)).buffer;case P.VSBuffer:return S.read(i(S));case P.Array:{const c=i(S),I=[];for(let D=0;D<c;D++)I.push(r(S));return I}case P.Object:return JSON.parse(S.read(i(S)).toString())}}class f{constructor(g,c,I=null,D=1e3){this.protocol=g,this.ctx=c,this.logger=I,this.timeoutDelay=D,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(N=>this.onRawMessage(N)),this.sendResponse({type:200})}registerChannel(g,c){this.channels.set(g,c),setTimeout(()=>this.flushPendingRequests(g),0)}sendResponse(g){switch(g.type){case 200:{const c=this.send([g.type]);this.logger&&this.logger.logOutgoing(c,0,1,C(g.type));return}case 201:case 202:case 204:case 203:{const c=this.send([g.type,g.id],g.data);this.logger&&this.logger.logOutgoing(c,g.id,1,C(g.type),g.data);return}}}send(g,c=void 0){const I=new p;return a(I,g),a(I,c),this.sendBuffer(I.buffer)}sendBuffer(g){try{return this.protocol.send(g),g.byteLength}catch(c){return 0}}onRawMessage(g){const c=new m(g),I=r(c),D=r(c),N=I[0];switch(N){case 100:return this.logger&&this.logger.logIncoming(g.byteLength,I[1],1,`${w(N)}: ${I[2]}.${I[3]}`,D),this.onPromise({type:N,id:I[1],channelName:I[2],name:I[3],arg:D});case 102:return this.logger&&this.logger.logIncoming(g.byteLength,I[1],1,`${w(N)}: ${I[2]}.${I[3]}`,D),this.onEventListen({type:N,id:I[1],channelName:I[2],name:I[3],arg:D});case 101:return this.logger&&this.logger.logIncoming(g.byteLength,I[1],1,`${w(N)}`),this.disposeActiveRequest({type:N,id:I[1]});case 103:return this.logger&&this.logger.logIncoming(g.byteLength,I[1],1,`${w(N)}`),this.disposeActiveRequest({type:N,id:I[1]})}}onPromise(g){const c=this.channels.get(g.channelName);if(!c){this.collectPendingRequest(g);return}const I=new E.CancellationTokenSource;let D;try{D=c.call(this.ctx,g.name,g.arg,I.token)}catch($){D=Promise.reject($)}const N=g.id;D.then($=>{this.sendResponse({id:N,data:$,type:201}),this.activeRequests.delete(g.id)},$=>{$ instanceof Error?this.sendResponse({id:N,data:{message:$.message,name:$.name,stack:$.stack?$.stack.split?$.stack.split(`
`):$.stack:void 0},type:202}):this.sendResponse({id:N,data:$,type:203}),this.activeRequests.delete(g.id)});const z=(0,A.toDisposable)(()=>I.cancel());this.activeRequests.set(g.id,z)}onEventListen(g){const c=this.channels.get(g.channelName);if(!c){this.collectPendingRequest(g);return}const I=g.id,N=c.listen(this.ctx,g.name,g.arg)(z=>this.sendResponse({id:I,data:z,type:204}));this.activeRequests.set(g.id,N)}disposeActiveRequest(g){const c=this.activeRequests.get(g.id);c&&(c.dispose(),this.activeRequests.delete(g.id))}collectPendingRequest(g){let c=this.pendingRequests.get(g.channelName);c||(c=[],this.pendingRequests.set(g.channelName,c));const I=setTimeout(()=>{console.error(`Unknown channel: ${g.channelName}`),g.type===100&&this.sendResponse({id:g.id,data:{name:"Unknown channel",message:`Channel name '${g.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);c.push({request:g,timeoutTimer:I})}flushPendingRequests(g){const c=this.pendingRequests.get(g);if(c){for(const I of c)switch(clearTimeout(I.timeoutTimer),I.request.type){case 100:this.onPromise(I.request);break;case 102:this.onEventListen(I.request);break}this.pendingRequests.delete(g)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(g=>g.dispose()),this.activeRequests.clear()}}t.ChannelServer=f;var O;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(O=t.RequestInitiator||(t.RequestInitiator={}));class j{constructor(g,c=null){this.protocol=g,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(I=>this.onBuffer(I)),this.logger=c}getChannel(g){const c=this;return{call(I,D,N){return c.isDisposed?Promise.reject(k.canceled()):c.requestPromise(g,I,D,N)},listen(I,D){return c.isDisposed?Promise.reject(k.canceled()):c.requestEvent(g,I,D)}}}requestPromise(g,c,I,D=E.CancellationToken.None){const N=this.lastRequestId++,$={id:N,type:100,channelName:g,name:c,arg:I};if(D.isCancellationRequested)return Promise.reject(k.canceled());let _;return new Promise((X,J)=>{if(D.isCancellationRequested)return J(k.canceled());const te=()=>{const Ie=Le=>{switch(Le.type){case 201:this.handlers.delete(N),X(Le.data);break;case 202:this.handlers.delete(N);const Fe=new Error(Le.data.message);Fe.stack=Le.data.stack,Fe.name=Le.data.name,J(Fe);break;case 203:this.handlers.delete(N),J(Le.data);break}};this.handlers.set(N,Ie),this.sendRequest($)};let ne=null;this.state===v.Idle?te():(ne=(0,F.createCancelablePromise)(Ie=>this.whenInitialized()),ne.then(()=>{ne=null,te()}));const de=()=>{ne?(ne.cancel(),ne=null):this.sendRequest({id:N,type:101}),J(k.canceled())},me=D.onCancellationRequested(de);_=(0,A.combinedDisposable)((0,A.toDisposable)(de),me),this.activeRequests.add(_)}).finally(()=>{this.activeRequests.delete(_)})}requestEvent(g,c,I){const D=this.lastRequestId++,z={id:D,type:102,channelName:g,name:c,arg:I};let $=null;const _=new y.Emitter({onFirstListenerAdd:()=>{$=(0,F.createCancelablePromise)(X=>this.whenInitialized()),$.then(()=>{$=null,this.activeRequests.add(_),this.sendRequest(z)})},onLastListenerRemove:()=>{$?($.cancel(),$=null):(this.activeRequests.delete(_),this.sendRequest({id:D,type:103}))}}),q=X=>_.fire(X.data);return this.handlers.set(D,q),_.event}sendRequest(g){switch(g.type){case 100:case 102:{const c=this.send([g.type,g.id,g.channelName,g.name],g.arg);this.logger&&this.logger.logOutgoing(c,g.id,0,`${w(g.type)}: ${g.channelName}.${g.name}`,g.arg);return}case 101:case 103:{const c=this.send([g.type,g.id]);this.logger&&this.logger.logOutgoing(c,g.id,0,w(g.type));return}}}send(g,c=void 0){const I=new p;return a(I,g),a(I,c),this.sendBuffer(I.buffer)}sendBuffer(g){try{return this.protocol.send(g),g.byteLength}catch(c){return 0}}onBuffer(g){const c=new m(g),I=r(c),D=r(c),N=I[0];switch(N){case 200:return this.logger&&this.logger.logIncoming(g.byteLength,0,0,C(N)),this.onResponse({type:I[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(g.byteLength,I[1],0,C(N),D),this.onResponse({type:I[0],id:I[1],data:D})}}onResponse(g){if(g.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const c=this.handlers.get(g.id);c&&c(g)}whenInitialized(){return this.state===v.Idle?Promise.resolve():y.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(g=>g.dispose()),this.activeRequests.clear()}}t.ChannelClient=j;class M{constructor(g){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,g(({protocol:c,onDidClientDisconnect:I})=>{y.Event.once(c.onMessage)(N=>{const z=new m(N),$=r(z),_=new f(c,$),q=new j(c);this.channels.forEach((J,te)=>_.registerChannel(te,J));const X={channelServer:_,channelClient:q,ctx:$};this._connections.add(X),this._onDidAddConnection.fire(X),I(()=>{_.dispose(),q.dispose(),this._connections.delete(X),this._onDidRemoveConnection.fire(X)})})})}get connections(){const g=[];return this._connections.forEach(c=>g.push(c)),g}getChannel(g,c){const I=this;return{call(D,N,z){let $;if((0,d.isFunction)(c)){let q=(0,h.getRandomElement)(I.connections.filter(c));$=q?Promise.resolve(q):y.Event.toPromise(y.Event.filter(I.onDidAddConnection,c))}else $=c.routeCall(I,D,N);const _=$.then(q=>q.channelClient.getChannel(g));return B(_).call(D,N,z)},listen(D,N){if((0,d.isFunction)(c))return I.getMulticastEvent(g,c,D,N);const z=c.routeEvent(I,D,N).then($=>$.channelClient.getChannel(g));return B(z).listen(D,N)}}}getMulticastEvent(g,c,I,D){const N=this;let z=new A.DisposableStore;const $=new y.Emitter({onFirstListenerAdd:()=>{z=new A.DisposableStore;const _=new y.EventMultiplexer,q=new Map,X=te=>{const de=te.channelClient.getChannel(g).listen(I,D),me=_.add(de);q.set(te,me)},J=te=>{const ne=q.get(te);!ne||(ne.dispose(),q.delete(te))};N.connections.filter(c).forEach(X),y.Event.filter(N.onDidAddConnection,c)(X,void 0,z),N.onDidRemoveConnection(J,void 0,z),_.event($.fire,$,z),z.add(_)},onLastListenerRemove:()=>{z.dispose()}});return $.event}registerChannel(g,c){this.channels.set(g,c),this._connections.forEach(I=>{I.channelServer.registerChannel(g,c)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=M;class U{constructor(g,c,I=null){const D=new p;a(D,c),g.send(D.buffer),this.channelClient=new j(g,I),this.channelServer=new f(g,c,I)}getChannel(g){return this.channelClient.getChannel(g)}registerChannel(g,c){this.channelServer.registerChannel(g,c)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=U;function B(S){return{call(g,c,I){return S.then(D=>D.call(g,c,I))},listen(g,c){const I=new y.Relay;return S.then(D=>I.input=D.listen(g,c)),I.event}}}t.getDelayedChannel=B;function K(S){let g=!1;return{call(c,I,D){return g?S.call(c,I,D):(0,F.timeout)(0).then(()=>g=!0).then(()=>S.call(c,I,D))},listen(c,I){if(g)return S.listen(c,I);const D=new y.Relay;return(0,F.timeout)(0).then(()=>g=!0).then(()=>D.input=S.listen(c,I)),D.event}}}t.getNextTickChannel=K;class ee{constructor(g){this.fn=g}routeCall(g){return this.route(g)}routeEvent(g){return this.route(g)}async route(g){for(const c of g.connections)if(await Promise.resolve(this.fn(c.ctx)))return Promise.resolve(c);return await y.Event.toPromise(g.onDidAddConnection),await this.route(g)}}t.StaticRouter=ee;var ae;(function(S){function g(D,N){const z=D,$=N&&N.disableMarshalling,_=new Map;for(const q in z)I(q)&&_.set(q,y.Event.buffer(z[q],!0));return new class{listen(q,X){const J=_.get(X);if(J)return J;throw new Error(`Event not found: ${X}`)}call(q,X,J){const te=z[X];if(typeof te=="function"){if(!$&&Array.isArray(J))for(let ne=0;ne<J.length;ne++)J[ne]=(0,b.revive)(J[ne]);return te.apply(z,J)}throw new Error(`Method not found: ${X}`)}}}S.fromService=g;function c(D,N){const z=N&&N.disableMarshalling;return new Proxy({},{get($,_){var q;if(typeof _=="string")return((q=N==null?void 0:N.properties)===null||q===void 0?void 0:q.has(_))?N.properties.get(_):I(_)?D.listen(_):async function(...X){let J;N&&!(0,d.isUndefinedOrNull)(N.context)?J=[N.context,...X]:J=X;const te=await D.call(_,J);return z?te:(0,b.revive)(te)};throw new Error(`Property not found: ${String(_)}`)}})}S.toService=c;function I(D){return D[0]==="o"&&D[1]==="n"&&u.isUpperAsciiLetter(D.charCodeAt(2))}})(ae=t.ProxyChannel||(t.ProxyChannel={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Z(S){if(Array.isArray(S))return S;if(S&&typeof S=="object"&&typeof S.toString=="function"){let g=S.toString();if(g!=="[object Object]")return g}return S}function le(S){return Array.isArray(S)?S.map(Z):Z(S)}function W(S,g,c,I,D,N,z){z=le(z);const $=re[D],_=$[I%$.length];let q=[`%c[${S}]%c[${String(g).padStart(7," ")}]%c[len: ${String(c).padStart(5," ")}]%c${String(I).padStart(5," ")} - ${N}`,"color: darkgreen","color: grey","color: grey",`color: ${_}`];/\($/.test(N)?(q=q.concat(z),q.push(")")):q.push(z),console.log.apply(console,q)}t.logWithColors=W;class L{constructor(g,c){this._outgoingPrefix=g,this._incomingPrefix=c,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(g,c,I,D,N){this._totalOutgoing+=g,W(this._outgoingPrefix,this._totalOutgoing,g,c,I,D,N)}logIncoming(g,c,I,D,N){this._totalIncoming+=g,W(this._incomingPrefix,this._totalIncoming,g,c,I,D,N)}}t.IPCLogger=L}),define(Q[64],Y([0,1,2,11,4,8]),function(x,t,y,A,F,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var k;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=t.StorageHint||(t.StorageHint={}));var T;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(T||(T={}));class h extends y.Disposable{constructor(u,R=Object.create(null)){super();this.database=u,this.options=R,this._onDidChangeStorage=this._register(new A.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=T.None,this.cache=new Map,this.flushDelayer=new F.ThrottledDelayer(h.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(u=>this.onDidChangeItemsExternal(u)))}onDidChangeItemsExternal(u){var R,w;(R=u.changed)===null||R===void 0||R.forEach((l,C)=>this.accept(C,l)),(w=u.deleted)===null||w===void 0||w.forEach(l=>this.accept(l,void 0))}accept(u,R){if(this.state!==T.Closed){let w=!1;(0,E.isUndefinedOrNull)(R)?w=this.cache.delete(u):this.cache.get(u)!==R&&(this.cache.set(u,R),w=!0),w&&this._onDidChangeStorage.fire(u)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===T.None&&(this.state=T.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(u,R){const w=this.cache.get(u);return(0,E.isUndefinedOrNull)(w)?R:w}getBoolean(u,R){const w=this.get(u);return(0,E.isUndefinedOrNull)(w)?R:w==="true"}getNumber(u,R){const w=this.get(u);return(0,E.isUndefinedOrNull)(w)?R:parseInt(w,10)}async set(u,R){if(this.state!==T.Closed){if((0,E.isUndefinedOrNull)(R))return this.delete(u);const w=String(R);if(this.cache.get(u)!==w)return this.cache.set(u,w),this.pendingInserts.set(u,w),this.pendingDeletes.delete(u),this._onDidChangeStorage.fire(u),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(u){if(this.state!==T.Closed&&!!this.cache.delete(u))return this.pendingDeletes.has(u)||this.pendingDeletes.add(u),this.pendingInserts.delete(u),this._onDidChangeStorage.fire(u),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=T.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(u){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const u={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(u).finally(()=>{var R;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(R=this.whenFlushedCallbacks.pop())===null||R===void 0||R()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(u=>this.whenFlushedCallbacks.push(u))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}t.Storage=h,h.DEFAULT_FLUSH_DELAY=100;class d{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(u){u.insert&&u.insert.forEach((R,w)=>this.items.set(w,R)),u.delete&&u.delete.forEach(R=>this.items.delete(R))}async close(){}}t.InMemoryStorageDatabase=d}),define(Q[65],Y([5,6]),function(x,t){return x.create("vs/base/common/date",t)}),define(Q[66],Y([0,1,65]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const A=60,F=A*60,E=F*24,k=E*7,T=E*30,h=E*365;function d(u,R){typeof u!="number"&&(u=u.getTime());const w=Math.round((new Date().getTime()-u)/1e3);if(w<-30)return(0,y.localize)(0,null,d(new Date().getTime()+w*1e3,!1));if(w<30)return(0,y.localize)(1,null);let l;return w<A?(l=w,R?l===1?(0,y.localize)(2,null,l):(0,y.localize)(3,null,l):l===1?(0,y.localize)(4,null,l):(0,y.localize)(5,null,l)):w<F?(l=Math.floor(w/A),R?l===1?(0,y.localize)(6,null,l):(0,y.localize)(7,null,l):l===1?(0,y.localize)(8,null,l):(0,y.localize)(9,null,l)):w<E?(l=Math.floor(w/F),R?l===1?(0,y.localize)(10,null,l):(0,y.localize)(11,null,l):l===1?(0,y.localize)(12,null,l):(0,y.localize)(13,null,l)):w<k?(l=Math.floor(w/E),R?l===1?(0,y.localize)(14,null,l):(0,y.localize)(15,null,l):l===1?(0,y.localize)(16,null,l):(0,y.localize)(17,null,l)):w<T?(l=Math.floor(w/k),R?l===1?(0,y.localize)(18,null,l):(0,y.localize)(19,null,l):l===1?(0,y.localize)(20,null,l):(0,y.localize)(21,null,l)):w<h?(l=Math.floor(w/T),R?l===1?(0,y.localize)(22,null,l):(0,y.localize)(23,null,l):l===1?(0,y.localize)(24,null,l):(0,y.localize)(25,null,l)):(l=Math.floor(w/h),R?l===1?(0,y.localize)(26,null,l):(0,y.localize)(27,null,l):l===1?(0,y.localize)(28,null,l):(0,y.localize)(29,null,l))}t.fromNow=d;function b(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=b}),define(Q[67],Y([5,6]),function(x,t){return x.create("vs/base/common/errorMessage",t)}),define(Q[30],Y([0,1,67,8,20]),function(x,t,y,A,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function E(d,b){return b&&(d.stack||d.stacktrace)?y.localize(0,null,T(d),k(d.stack)||k(d.stacktrace)):T(d)}function k(d){return Array.isArray(d)?d.join(`
`):d}function T(d){return typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?y.localize(1,null,d.message):d.message||y.localize(2,null)}function h(d=null,b=!1){if(!d)return y.localize(3,null);if(Array.isArray(d)){const u=F.coalesce(d),R=h(u[0],b);return u.length>1?y.localize(4,null,R,u.length):R}if(A.isString(d))return d;if(d.detail){const u=d.detail;if(u.error)return E(u.error,b);if(u.exception)return E(u.exception,b)}return d.stack?E(d,b):d.message?d.message:y.localize(5,null)}t.toErrorMessage=h}),define(Q[68],Y([5,6]),function(x,t){return x.create("vs/base/node/processes",t)}),define(Q[69],Y([0,1,3,14,12,34,68,8,19,32,17,44,9]),function(x,t,y,A,F,E,k,T,h,d,b,u,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function w(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function l(o,i){if(b.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};i&&(e.cwd=i);const n=E.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],e);return new Promise(s=>{n.once("error",a=>{s({success:!1,error:a})}),n.once("exit",(a,r)=>{s(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?w(e.status):1})}else if(b.isLinux||b.isMacintosh)try{const e=R.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",x).fsPath;return new Promise(n=>{E.execFile(e,[o.pid.toString()],{encoding:"utf8",shell:!0},(s,a,r)=>{n(s?{success:!1,error:s}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function C(o=process.env){return o.comspec||"cmd.exe"}t.getWindowsShell=C;class v{constructor(i,e,n,s){if(e!==void 0&&n!==void 0&&s!==void 0)this.cmd=i,this.args=e,this.shell=n,this.options=s;else{const a=i;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(process.env).forEach(r=>{a[r]=process.env[r]}),Object.keys(this.options.env).forEach(r=>{a[r]=this.options.env[r]}),this.options.env=a}}getSanitizedCommand(){let i=this.cmd.toLowerCase();const e=i.lastIndexOf(y.sep);return e!==-1&&(i=i.substring(e+1)),v.WellKnowCommands[i]?i:"other"}start(i){return b.isWindows&&(this.options&&this.options.cwd&&d.isUNC(this.options.cwd)||!this.options&&d.isUNC(process.cwd()))?Promise.reject(new Error(k.localize(0,null))):this.useExec().then(e=>{let n,s;const a=new Promise((r,f)=>{n=r,s=f});if(e){let r=this.cmd;this.args&&(r=r+" "+this.args.join(" ")),this.childProcess=E.exec(r,this.options,(f,O,j)=>{this.childProcess=null;const M=f;M&&M.killed?s({killed:this.terminateRequested,stdout:O.toString(),stderr:j.toString()}):this.handleExec(n,i,f,O,j)})}else{let r=null;const f=O=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(O,n,i,s);const j={terminated:this.terminateRequested};T.isNumber(O)&&(j.cmdCode=O),n(j)};if(this.shell&&b.isWindows){const O=h.deepClone(this.options);O.windowsVerbatimArguments=!0,O.detached=!1;let j=!1,M=!1;const U=[];let B=this.ensureQuotes(this.cmd);U.push(B.value),j=B.quoted,this.args&&this.args.forEach(ee=>{B=this.ensureQuotes(ee),U.push(B.value),M=M&&B.quoted});const K=["/s","/c"];j?M?K.push('"'+U.join(" ")+'"'):U.length>1?K.push('"'+U[0]+'" '+U.slice(1).join(" ")):K.push('"'+U[0]+'"'):K.push(U.join(" ")),r=E.spawn(C(),K,O)}else this.cmd&&(r=E.spawn(this.cmd,this.args,this.options));r&&(this.childProcess=r,this.childProcessPromise=Promise.resolve(r),this.pidResolve&&(this.pidResolve(T.isNumber(r.pid)?r.pid:-1),this.pidResolve=void 0),r.on("error",O=>{this.childProcess=null,s({terminated:this.terminateRequested,error:O})}),r.pid&&(this.childProcess.on("close",f),this.handleSpawn(r,n,i,s,!0)))}return a})}handleClose(i,e,n,s){}ensureQuotes(i){return v.regexp.test(i)?{value:'"'+i+'"',quoted:!0}:{value:i,quoted:i.length>0&&i[0]==='"'&&i[i.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(i=>i.pid,i=>-1):new Promise(i=>{this.pidResolve=i})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(i=>(this.terminateRequested=!0,l(i,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),i=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(i=>{if(!this.shell||!b.isWindows)return i(!1);const e=E.spawn(C(),["/s","/c"]);e.on("error",n=>i(!0)),e.on("exit",n=>i(!1))})}}t.AbstractProcess=v,v.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},v.regexp=/^[^"].* .*[^"]/;class m extends v{constructor(i,e,n,s){super(i,e,n,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(i,e,n,s,a){[s,a].forEach((r,f)=>{const O=new u.LineDecoder;O.write(r).forEach(U=>{e({line:U,source:f===0?0:1})});const M=O.end();M&&e({line:M,source:f===0?0:1})}),i({terminated:this.terminateRequested,error:n})}handleSpawn(i,e,n,s,a){const r=new u.LineDecoder,f=new u.LineDecoder;i.stdout.on("data",O=>{r.write(O).forEach(M=>n({line:M,source:0}))}),i.stderr.on("data",O=>{f.write(O).forEach(M=>n({line:M,source:1}))}),this.stdoutLineDecoder=r,this.stderrLineDecoder=f}handleClose(i,e,n,s){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&n({line:a,source:0});const r=this.stderrLineDecoder?this.stderrLineDecoder.end():null;r&&n({line:r,source:1})}}t.LineProcess=m;function p(o){let i=[],e=!1;const n=function(s){if(e){i.push(s);return}(!o.send(s,r=>{if(r&&console.error(r),e=!1,i.length>0){const f=i.slice(0);i=[],f.forEach(O=>n(O))}})||b.isWindows)&&(e=!0)};return{send:n}}t.createQueuedSender=p;var P;(function(o){async function i(e,n,s){if(y.isAbsolute(e))return e;if(n===void 0&&(n=process.cwd()),y.dirname(e)!=="."||(s===void 0&&T.isString(process.env.PATH)&&(s=process.env.PATH.split(y.delimiter)),s===void 0||s.length===0))return y.join(n,e);async function r(f){return await F.exists(f)?!(await A.promises.stat(f)).isDirectory():!1}for(let f of s){let O;if(y.isAbsolute(f)?O=y.join(f,e):O=y.join(n,f,e),await r(O))return O;let j=O+".com";if(await r(j)||(j=O+".exe",await r(j)))return j}return y.join(n,e)}o.findExecutable=i})(P=t.win32||(t.win32={}))}),define(Q[46],Y([0,1,34,2,4,19,11,69,33,57,28,15,16,17]),function(x,t,y,A,F,E,k,T,h,d,b,u,R,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class l extends h.ChannelServer{constructor(m){super({send:p=>{try{process.send&&process.send(p.buffer.toString("base64"))}catch(P){}},onMessage:k.Event.fromNodeEventEmitter(process,"message",p=>R.VSBuffer.wrap(Buffer.from(p,"base64")))},m);process.once("disconnect",()=>this.dispose())}}t.Server=l;class C{constructor(m,p){this.modulePath=m,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new k.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const P=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new F.Delayer(P),this.child=null,this._client=null}getChannel(m){const p=this;return{call(P,o,i){return p.requestPromise(m,P,o,i)},listen(P,o){return p.requestEvent(m,P,o)}}}requestPromise(m,p,P,o=b.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(u.canceled());this.disposeDelayer.cancel();const i=this.getCachedChannel(m),e=(0,F.createCancelablePromise)(a=>i.call(p,P,a)),n=o.onCancellationRequested(()=>e.cancel()),s=(0,A.toDisposable)(()=>e.cancel());return this.activeRequests.add(s),e.finally(()=>{n.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(m,p,P){if(!this.disposeDelayer)return k.Event.None;this.disposeDelayer.cancel();let o;const i=new k.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(m).listen(p,P)(i.fire,i),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return i.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env=Object.assign(Object.assign({},(0,E.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(p.env=Object.assign(Object.assign({},p.env),this.options.env)),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),w.isMacintosh&&p.env&&delete p.env.DYLD_LIBRARY_PATH,this.child=(0,y.fork)(this.modulePath,m,p);const P=new k.Emitter;k.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,d.isRemoteConsoleLog)(r)){(0,d.log)(r,`IPC Library: ${this.options.serverName}`);return}P.fire(R.VSBuffer.wrap(Buffer.from(r,"base64")))});const i=this.options.useQueue?(0,T.createQueuedSender)(this.child):this.child,e=r=>this.child&&this.child.connected&&i.send(r.buffer.toString("base64")),n=P.event,s={send:e,onMessage:n};this._client=new h.ChannelClient(s);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,f)=>{process.removeListener("exit",a),this.activeRequests.forEach(O=>(0,A.dispose)(O)),this.activeRequests.clear(),r!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+f),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:f})})}return this._client}getCachedChannel(m){let p=this.channels.get(m);return p||(p=this.client.getChannel(m),this.channels.set(m,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=C}),define(Q[70],Y([5,6]),function(x,t){return x.create("vs/base/node/zip",t)}),define(Q[71],Y([5,6]),function(x,t){return x.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Q[72],Y([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Q[73],Y([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Q[74],Y([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Q[75],Y([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Q[76],Y([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Q[77],Y([5,6]),function(x,t){return x.create("vs/platform/extensions/common/extensionValidator",t)}),define(Q[78],Y([5,6]),function(x,t){return x.create("vs/platform/files/common/fileService",t)}),define(Q[79],Y([5,6]),function(x,t){return x.create("vs/platform/files/common/io",t)}),define(Q[80],Y([5,6]),function(x,t){return x.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Q[81],Y([5,6]),function(x,t){return x.create("vs/platform/request/common/request",t)}),define(Q[82],Y([5,6]),function(x,t){return x.create("vs/platform/telemetry/common/telemetryService",t)}),define(Q[83],Y([0,1,19]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const A=/^%([\w\d.-]+)%$/i;function F(E,k){const T=h=>{if(typeof h=="string"){const d=A.exec(h);if(!!d)return k[d[1]]||h}};return(0,y.cloneAndChange)(E,T)}t.localizeManifest=F}),define(Q[47],Y([0,1,77]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVersionValid=t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function F(u){return u=u.trim(),u==="*"||A.test(u)}t.isValidVersionStr=F;function E(u){if(!F(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let R=u.match(A);return R?{hasCaret:R[1]==="^",hasGreaterEquals:R[1]===">=",majorBase:R[2]==="x"?0:parseInt(R[2],10),majorMustEqual:R[2]!=="x",minorBase:R[4]==="x"?0:parseInt(R[4],10),minorMustEqual:R[4]!=="x",patchBase:R[6]==="x"?0:parseInt(R[6],10),patchMustEqual:R[6]!=="x",preRelease:R[8]||null}:null}t.parseVersion=E;function k(u){if(!u)return null;let R=u.majorBase,w=u.majorMustEqual,l=u.minorBase,C=u.minorMustEqual,v=u.patchBase,m=u.patchMustEqual;return u.hasCaret&&(R===0||(C=!1),m=!1),{majorBase:R,majorMustEqual:w,minorBase:l,minorMustEqual:C,patchBase:v,patchMustEqual:m,isMinimum:u.hasGreaterEquals}}t.normalizeVersion=k;function T(u,R){let w;typeof u=="string"?w=k(E(u)):w=u;let l;if(typeof R=="string"?l=k(E(R)):l=R,!w||!l)return!1;let C=w.majorBase,v=w.minorBase,m=w.patchBase,p=l.majorBase,P=l.minorBase,o=l.patchBase,i=l.majorMustEqual,e=l.minorMustEqual,n=l.patchMustEqual;return l.isMinimum?C>p?!0:C<p?!1:v>P?!0:v<P?!1:m>=o:(C===1&&p===0&&(!i||!e||!n)&&(p=1,P=0,o=0,i=!0,e=!1,n=!1),C<p?!1:C>p?!i:v<P?!1:v>P?!e:m<o?!1:m>o?!n:!0)}t.isValidVersion=T;function h(u,R,w){return R.isBuiltin||typeof R.main=="undefined"?!0:b(u,R.engines.vscode,w)}t.isValidExtensionVersion=h;function d(u,R){return u==="*"||b(R,u)}t.isEngineValid=d;function b(u,R,w=[]){let l=k(E(R));if(!l)return w.push(y.localize(0,null,R)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return w.push(y.localize(1,null,R)),!1}else if(!l.majorMustEqual)return w.push(y.localize(2,null,R)),!1;return T(u,l)?!0:(w.push(y.localize(3,null,u,R)),!1)}t.isVersionValid=b}),define(Q[84],Y([0,1,33,46,2,9]),function(x,t,y,A,F,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class k extends F.Disposable{constructor(h,d,b,u){super();this.folders=h,this.onDidFilesChange=d,this.onLogMessage=b,this.verboseLogging=u,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const h=this._register(new A.Client(E.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(h.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=y.ProxyChannel.toService((0,y.getNextTickChannel)(h.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.setFolders(this.folders)}setVerboseLogging(h){this.verboseLogging=h,!this.isDisposed&&this.service&&this.service.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${h}`})}setFolders(h){this.folders=h,this.service&&this.service.setRoots(h)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=k,k.MAX_RESTARTS=5}),define(Q[85],Y([0,1,33,46,2,9]),function(x,t,y,A,F,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class k extends F.Disposable{constructor(h,d,b,u,R={}){super();this.folders=h,this.onDidFilesChange=d,this.onLogMessage=b,this.verboseLogging=u,this.watcherOptions=R,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const h=this._register(new A.Client(E.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(h.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=y.ProxyChannel.toService((0,y.getNextTickChannel)(h.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.service.setRoots(this.folders)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${h}`})}setVerboseLogging(h){this.verboseLogging=h,this.service&&this.service.setVerboseLogging(h)}setFolders(h){this.folders=h,this.service&&this.service.setRoots(h)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=k,k.MAX_RESTARTS=5}),define(Q[86],Y([0,1,34,44,59,9]),function(x,t,y,A,F,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class k{constructor(h,d,b,u,R){this.watchedFolder=h,this.eventCallback=b,this.logCallback=u,this.verboseLogging=R,this.restartCounter=0,Array.isArray(d)?this.ignored=d.map(w=>F.parse(w)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${h}`),this.startWatcher()}startWatcher(){const h=[this.watchedFolder];this.verboseLogging&&h.push("-verbose"),this.handle=y.spawn(E.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",x).fsPath,h);const d=new A.LineDecoder;this.handle.stdout.on("data",b=>{const u=[];d.write(b).forEach(R=>{const w=R.split("|");if(w.length===2){const l=Number(w[0]),C=w[1];if(l>=0&&l<3){if(this.ignored&&this.ignored.some(v=>v(C))){this.verboseLogging&&this.log(C);return}u.push({type:k.changeTypeMap[l],path:C})}else this.log(w[1])}}),u.length>0&&this.eventCallback(u)}),this.handle.on("error",b=>this.onError(b)),this.handle.stderr.on("data",b=>this.onError(b)),this.handle.on("exit",(b,u)=>this.onExit(b,u))}onError(h){this.error("process error: "+h.toString())}onExit(h,d){this.handle&&(this.error(`terminated unexpectedly (code: ${h}, signal: ${d})`),this.restartCounter<=k.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(h){this.logCallback({type:"error",message:`[File Watcher (C#)] ${h}`})}log(h){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${h}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=k,k.MAX_RESTARTS=5,k.changeTypeMap=[0,1,2]}),define(Q[87],Y([0,1,86,3,18]),function(x,t,y,A,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class E{constructor(T,h,d,b){this.onDidFilesChange=h,this.onLogMessage=d,this.verboseLogging=b,this.service=void 0,this.folder=T[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(A.posix.sep)&&(this.folder.path=(0,F.rtrim)(this.folder.path,A.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new y.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,T=>this.onFileEvents(T),T=>this.onLogMessage(T),this.verboseLogging)}setVerboseLogging(T){this.verboseLogging=T,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(T){this.isDisposed||T.length>0&&this.onDidFilesChange(T)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=E}),define(Q[48],Y([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSyncDescriptor=t.SyncDescriptor=void 0;class y{constructor(E,k=[],T=!1){this.ctor=E,this.staticArguments=k,this.supportsDelayedInstantiation=T}}t.SyncDescriptor=y;const A=(F,...E)=>new y(F,E);t.createSyncDescriptor=A}),define(Q[88],Y([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class y{constructor(E){this.incoming=new Map,this.outgoing=new Map,this.data=E}}t.Node=y;class A{constructor(E){this._hashFn=E,this._nodes=new Map}roots(){const E=[];for(let k of this._nodes.values())k.outgoing.size===0&&E.push(k);return E}insertEdge(E,k){const T=this.lookupOrInsertNode(E),h=this.lookupOrInsertNode(k);T.outgoing.set(this._hashFn(k),h),h.incoming.set(this._hashFn(E),T)}removeNode(E){const k=this._hashFn(E);this._nodes.delete(k);for(let T of this._nodes.values())T.outgoing.delete(k),T.incoming.delete(k)}lookupOrInsertNode(E){const k=this._hashFn(E);let T=this._nodes.get(k);return T||(T=new y(E),this._nodes.set(k,T)),T}lookup(E){return this._nodes.get(this._hashFn(E))}isEmpty(){return this._nodes.size===0}toString(){let E=[];for(let[k,T]of this._nodes)E.push(`${k}, (incoming)[${[...T.incoming.keys()].join(", ")}], (outgoing)[${[...T.outgoing.keys()].join(",")}]`);return E.join(`
`)}}t.Graph=A}),define(Q[89],Y([0,1,7]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,y.createDecorator)("downloadService")}),define(Q[22],Y([0,1,7]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,y.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,y.refineServiceDecorator)(t.IEnvironmentService)}),define(Q[23],Y([0,1,72,7,9]),function(x,t,y,A,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN);function E(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}t.isIExtensionIdentifier=E;var k;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=5]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(k=t.SortBy||(t.SortBy={}));var T;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(T=t.SortOrder||(t.SortOrder={}));var h;(function(u){u.Uninstall="uninstall"})(h=t.StatisticType||(t.StatisticType={}));var d;(function(u){u[u.None=0]="None",u[u.Install=1]="Install",u[u.Update=2]="Update"})(d=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class b extends Error{constructor(R,w){super(R);this.code=w}}t.ExtensionManagementError=b,t.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=F.FileAccess.asBrowserUri("./media/defaultIcon.png",x).toString(!0),t.ExtensionsLabel=(0,y.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,y.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,A.createDecorator)("IExtensionManagementCLIService")}),define(Q[35],Y([0,1,18,7]),function(x,t,y,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin";function F(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}t.isIExtensionIdentifier=F,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(E=t.ExtensionType||(t.ExtensionType={}));class k{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,u){if(typeof b=="undefined"||b===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof b=="string"||typeof u=="string"){let R=typeof b=="string"?b:b.value,w=typeof u=="string"?u:u.value;return y.equalsIgnoreCase(R,w)}return b._lower===u._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}t.ExtensionIdentifier=k;function T(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}t.isLanguagePackExtension=T;function h(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=h,t.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[26],Y([0,1,18,35]),function(x,t,y,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function F(w,l){return w.uuid&&l.uuid?w.uuid===l.uuid:w.id===l.id?!0:(0,y.compareIgnoreCase)(w.id,l.id)===0}t.areSameExtensions=F;class E{constructor(l,C){this.version=C,this.id=l.id,this.uuid=l.uuid}key(){return`${this.id}-${this.version}`}equals(l){return l instanceof E?F(this,l)&&this.version===l.version:!1}}t.ExtensionIdentifierWithVersion=E;function k(w,l){return`${w}.${l}`}t.getExtensionId=k;function T(w){return w.toLocaleLowerCase()}t.adoptToGalleryExtensionId=T;function h(w,l){return T(k(w,l))}t.getGalleryExtensionId=h;function d(w,l){const C=[],v=m=>{for(const p of C)if(p.some(P=>F(l(P),l(m))))return p;return null};for(const m of w){const p=v(m);p?p.push(m):C.push([m])}return C}t.groupByExtension=d;function b(w){return{id:w.identifier.id,name:w.manifest.name,galleryId:null,publisherId:w.publisherId,publisherName:w.manifest.publisher,publisherDisplayName:w.publisherDisplayName,dependencies:w.manifest.extensionDependencies&&w.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=b;function u(w){return Object.assign({id:w.identifier.id,name:w.name,galleryId:w.identifier.uuid,publisherId:w.publisherId,publisherName:w.publisher,publisherDisplayName:w.publisherDisplayName,dependencies:!!(w.properties.dependencies&&w.properties.dependencies.length>0)},w.telemetryData)}t.getGalleryExtensionTelemetryData=u,t.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function R(w){const l=new Set;for(const C of w)C.malicious&&l.add(C.id.id);return l}t.getMaliciousExtensionsSet=R}),define(Q[90],Y([0,1,2,3,35,12]),function(x,t,y,A,F,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class k extends y.Disposable{constructor(h,d){super();this.environmentService=h,this.extensionsManifestCache=(0,A.join)(this.environmentService.userDataPath,F.MANIFEST_CACHE_FOLDER,F.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtension(b=>this.onDidInstallExtension(b))),this._register(d.onDidUninstallExtension(b=>this.onDidUnInstallExtension(b)))}onDidInstallExtension(h){h.error||this.invalidate()}onDidUnInstallExtension(h){h.error||this.invalidate()}invalidate(){E.rimraf(this.extensionsManifestCache,E.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=k}),define(Q[49],Y([0,1,79,16,24,15]),function(x,t,y,A,F,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function k(b,u,R,w,l,C){let v;try{await T(b,u,R,w,l,C)}catch(m){v=m}finally{v&&l.errorTransformer&&(v=l.errorTransformer(v)),typeof v!="undefined"&&R.error(v),R.end()}}t.readFileIntoStream=k;async function T(b,u,R,w,l,C){h(C);const v=await b.open(u,{create:!1});try{h(C);let m=0,p=0,P=l&&typeof l.length=="number"?l.length:void 0,o=A.VSBuffer.alloc(Math.min(l.bufferSize,typeof P=="number"?P:l.bufferSize)),i=l&&typeof l.position=="number"?l.position:0,e=0;do p=await b.read(v,i,o.buffer,e,o.byteLength-e),i+=p,e+=p,m+=p,typeof P=="number"&&(P-=p),e===o.byteLength&&(await R.write(w(o)),o=A.VSBuffer.alloc(Math.min(l.bufferSize,typeof P=="number"?P:l.bufferSize)),e=0);while(p>0&&(typeof P!="number"||P>0)&&h(C)&&d(m,l));if(e>0){let n=e;typeof P=="number"&&(n=Math.min(e,P)),R.write(w(o.slice(0,n)))}}catch(m){throw(0,F.ensureFileSystemProviderError)(m)}finally{await b.close(v)}}function h(b){if(b.isCancellationRequested)throw(0,E.canceled)();return!0}function d(b,u){if(u==null?void 0:u.limits){if(typeof u.limits.memory=="number"&&b>u.limits.memory)throw(0,F.createFileSystemProviderError)((0,y.localize)(0,null),F.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof u.limits.size=="number"&&b>u.limits.size)throw(0,F.createFileSystemProviderError)((0,y.localize)(1,null),F.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[50],Y([0,1,10,24,17]),function(x,t,y,A,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function E(h){return h.map(d=>({type:d.type,resource:y.URI.file(d.path)}))}t.toFileChanges=E;function k(h){const d=new T;for(const b of h)d.processEvent(b);return d.normalize()}t.normalizeFileChanges=k;class T{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(d){const b=this.mapPathToChange.get(d.path);if(b){const u=b.type,R=d.type;u===1&&R===2?(this.mapPathToChange.delete(d.path),this.normalized.splice(this.normalized.indexOf(b),1)):u===2&&R===1?b.type=0:u===1&&R===0||(b.type=R)}else this.normalized.push(d),this.mapPathToChange.set(d.path,d)}normalize(){const d=[],b=[];return this.normalized.filter(u=>u.type!==2?(d.push(u),!1):!0).sort((u,R)=>u.path.length-R.path.length).filter(u=>b.some(R=>(0,A.isParent)(u.path,R,!F.isLinux))?!1:(b.push(u.path),!0)).concat(d)}}}),define(Q[91],Y([0,1,50,2,12,61,63,4,3]),function(x,t,y,A,F,E,k,T,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class d extends A.Disposable{constructor(u,R,w,l){super();this.path=u,this.onDidFilesChange=R,this.onLogMessage=w,this.verboseLogging=l,this.fileChangesDelayer=this._register(new T.ThrottledDelayer(k.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(u){this.verboseLogging=u}async startWatching(){try{const{stat:u,symbolicLink:R}=await F.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let w=this.path;if(R)try{w=await(0,E.realpath)(w)}catch(l){if(this.onError(l),R.dangling)return}u.isDirectory()?this._register((0,k.watchFolder)(w,(l,C)=>{this.onFileChange({type:l==="changed"?0:l==="added"?1:2,path:(0,h.join)(this.path,(0,h.basename)(C))})},l=>this.onError(l))):this._register((0,k.watchFile)(w,l=>{this.onFileChange({type:l==="changed"?0:2,path:this.path})},l=>this.onError(l)))}catch(u){u.code!=="ENOENT"&&this.onError(u)}}onFileChange(u){this.fileChangesBuffer.push(u),this.verboseLogging&&this.onVerbose(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`),this.fileChangesDelayer.trigger(async()=>{const R=this.fileChangesBuffer;this.fileChangesBuffer=[];const w=(0,y.normalizeFileChanges)(R);this.verboseLogging&&w.forEach(l=>{this.onVerbose(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`)}),w.length>0&&this.onDidFilesChange(w)})}onError(u){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${u}`})}onVerbose(u){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${u}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=d}),define(Q[51],Y([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class y{constructor(...F){this._entries=new Map;for(let[E,k]of F)this.set(E,k)}set(F,E){const k=this._entries.get(F);return this._entries.set(F,E),k}has(F){return this._entries.has(F)}get(F){return this._entries.get(F)}}t.ServiceCollection=y}),define(Q[92],Y([0,1,15,88,48,7,51,4]),function(x,t,y,A,F,E,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const h=!1;class d extends Error{constructor(l){super("cyclic dependency between services");this.message=l.toString()}}class b{constructor(l=new k.ServiceCollection,C=!1,v){this._activeInstantiations=new Set,this._services=l,this._strict=C,this._parent=v,this._services.set(E.IInstantiationService,this)}createChild(l){return new b(l,this._strict,this)}invokeFunction(l,...C){let v=R.traceInvocation(l),m=!1;try{return l({get:(P,o)=>{if(m)throw(0,y.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(P,v);if(!i&&o!==E.optional)throw new Error(`[invokeFunction] unknown service '${P}'`);return i}},...C)}finally{m=!0,v.stop()}}createInstance(l,...C){let v,m;return l instanceof F.SyncDescriptor?(v=R.traceCreation(l.ctor),m=this._createInstance(l.ctor,l.staticArguments.concat(C),v)):(v=R.traceCreation(l),m=this._createInstance(l,C,v)),v.stop(),m}_createInstance(l,C=[],v){let m=E._util.getServiceDependencies(l).sort((o,i)=>o.index-i.index),p=[];for(const o of m){let i=this._getOrCreateServiceInstance(o.id,v);if(!i&&this._strict&&!o.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${o.id}.`);p.push(i)}let P=m.length>0?m[0].index:C.length;if(C.length!==P){console.warn(`[createInstance] First service dependency of ${l.name} at position ${P+1} conflicts with ${C.length} static arguments`);let o=P-C.length;o>0?C=C.concat(new Array(o)):C=C.slice(0,P)}return new l(...[...C,...p])}_setServiceInstance(l,C){if(this._services.get(l)instanceof F.SyncDescriptor)this._services.set(l,C);else if(this._parent)this._parent._setServiceInstance(l,C);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let C=this._services.get(l);return!C&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):C}_getOrCreateServiceInstance(l,C){let v=this._getServiceInstanceOrDescriptor(l);return v instanceof F.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,v,C.branch(l,!0)):(C.branch(l,!1),v)}_safeCreateAndCacheServiceInstance(l,C,v){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,C,v)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,C,v){const m=new A.Graph(o=>o.id.toString());let p=0;const P=[{id:l,desc:C,_trace:v}];for(;P.length;){const o=P.pop();if(m.lookupOrInsertNode(o),p++>1e3)throw new d(m);for(let i of E._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(i.id);if(!e&&!i.optional&&console.warn(`[createInstance] ${l} depends on ${i.id} which is NOT registered.`),e instanceof F.SyncDescriptor){const n={id:i.id,desc:e,_trace:o._trace.branch(i.id,!0)};m.insertEdge(o,n),P.push(n)}}}for(;;){const o=m.roots();if(o.length===0){if(!m.isEmpty())throw new d(m);break}for(const{data:i}of o){if(this._getServiceInstanceOrDescriptor(i.id)instanceof F.SyncDescriptor){const n=this._createServiceInstanceWithOwner(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this._setServiceInstance(i.id,n)}m.removeNode(i)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,C,v=[],m,p){if(this._services.get(l)instanceof F.SyncDescriptor)return this._createServiceInstance(C,v,m,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,C,v,m,p);throw new Error(`illegalState - creating UNKNOWN service instance ${C.name}`)}_createServiceInstance(l,C=[],v,m){if(v){const p=new T.IdleValue(()=>this._createInstance(l,C,m));return new Proxy(Object.create(null),{get(P,o){if(o in P)return P[o];let i=p.value,e=i[o];return typeof e!="function"||(e=e.bind(i),P[o]=e),e},set(P,o,i){return p.value[o]=i,!0}})}else return this._createInstance(l,C,m)}}t.InstantiationService=b;var u;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(u||(u={}));class R{constructor(l,C){this.type=l,this.name=C,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return h?new R(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):R._None}static traceCreation(l){return h?new R(0,l.name):R._None}branch(l,C){let v=new R(2,l.toString());return this._dep.push([l,C,v]),v}stop(){let l=Date.now()-this._start;R._totals+=l;let C=!1;function v(p,P){let o=[],i=new Array(p+1).join("	");for(const[e,n,s]of P._dep)if(n&&s){C=!0,o.push(`${i}CREATES -> ${e}`);let a=v(p+1,s);a&&o.push(a)}else o.push(`${i}uses -> ${e}`);return o.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${R._totals.toFixed(2)}ms)`];(l>2||C)&&console.log(m.join(`
`))}}R._None=new class extends R{constructor(){super(-1,null)}stop(){}branch(){return this}},R._totals=0}),define(Q[36],Y([0,1,7]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,y.createDecorator)("localizationsService");function A(F){if(typeof F.languageId!="string"||!Array.isArray(F.translations)||F.translations.length===0)return!1;for(const E of F.translations)if(typeof E.id!="string"||typeof E.path!="string")return!1;return!(F.languageName&&typeof F.languageName!="string"||F.localizedLanguageName&&typeof F.localizedLanguageName!="string")}t.isValidLocalization=A});var ce=this&&this.__decorate||function(x,t,y,A){var F=arguments.length,E=F<3?t:A===null?A=Object.getOwnPropertyDescriptor(t,y):A,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")E=Reflect.decorate(x,t,y,A);else for(var T=x.length-1;T>=0;T--)(k=x[T])&&(E=(F<3?k(E):F>3?k(t,y,E):k(t,y))||E);return F>3&&E&&Object.defineProperty(t,y,E),E},fe=this&&this.__param||function(x,t){return function(y,A){t(y,A,x)}};define(Q[93],Y([0,1,73,15,10,37,23,26,35,60,28,9,36]),function(x,t,y,A,F,E,k,T,h,d,b,u,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const w=P=>(0,y.localize)(0,null,P),l=(0,y.localize)(1,null,"ms-dotnettools.csharp");function C(P,o){return o?`${P.publisher}.${P.name}@${P.version}`:`${P.publisher}.${P.name}`}const v=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function m(P){const o=v.exec(P);return o&&o[1]?[(0,T.adoptToGalleryExtensionId)(o[1]),o[2]]:[(0,T.adoptToGalleryExtensionId)(P),void 0]}t.getIdAndVersion=m;let p=class{constructor(o,i,e){this.extensionManagementService=o,this.extensionGalleryService=i,this.localizationsService=e}get location(){}async listExtensions(o,i,e=console){let n=await this.extensionManagementService.getInstalled(1);const s=h.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(i&&i!==""){if(s.indexOf(i.toLowerCase())<0){e.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}n=n.filter(r=>r.manifest.categories?r.manifest.categories.map(O=>O.toLowerCase()).indexOf(i.toLowerCase())>-1:!1)}else if(i===""){e.log("Possible Categories: "),s.forEach(r=>{e.log(r)});return}this.location&&e.log((0,y.localize)(2,null,this.location)),n=n.sort((r,f)=>r.identifier.id.localeCompare(f.identifier.id));let a;for(let r of n)a!==r.identifier.id&&(a=r.identifier.id,e.log(C(r.manifest,o)))}async installExtensions(o,i,e,n,s=console){const a=[],r=[];o.length&&s.log(this.location?(0,y.localize)(3,null,this.location):(0,y.localize)(4,null));const f=await this.extensionManagementService.getInstalled(1),O=(U,B)=>{const K=f.find(ee=>(0,T.areSameExtensions)(ee.identifier,{id:U}));if(K){if(!B&&!n)return s.log((0,y.localize)(5,null,U,K.manifest.version,U)),!1;if(B&&K.manifest.version===B)return s.log((0,y.localize)(6,null,`${U}@${B}`)),!1}return!0},j=[],M=[];for(const U of o)if(U instanceof F.URI)j.push(U);else{const[B,K]=m(U);O(B,K)&&M.push({id:B,version:K,installOptions:{isBuiltin:!1,isMachineScoped:e}})}for(const U of i){const[B,K]=m(U);O(B,K)&&M.push({id:B,version:K,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(j.length&&await Promise.all(j.map(async U=>{try{const B=await this.installVSIX(U,n,s);B&&r.push(B)}catch(B){s.error(B.message||B.stack||B),a.push(U.toString())}})),M.length){const U=await this.getGalleryExtensions(M);await Promise.all(M.map(async B=>{const K=U.get(B.id.toLowerCase());if(K)try{const ee=await this.installFromGallery(B,K,f,n,s);ee&&r.push(ee)}catch(ee){s.error(ee.message||ee.stack||ee),a.push(B.id)}else s.error(`${w(B.version?`${B.id}@${B.version}`:B.id)}
${l}`),a.push(B.id)}))}if(r.some(U=>(0,h.isLanguagePackExtension)(U))&&await this.updateLocalizationsCache(),a.length)throw new Error((0,y.localize)(7,null,a.join(", ")))}async installVSIX(o,i,e){const n=await this.extensionManagementService.getManifest(o);if(!n)throw new Error("Invalid vsix");if(await this.validateVSIX(n,i,e))try{return await this.extensionManagementService.install(o),e.log((0,y.localize)(8,null,(0,d.getBaseLabel)(o))),n}catch(a){if((0,A.isPromiseCanceledError)(a))return e.log((0,y.localize)(9,null,(0,d.getBaseLabel)(o))),null;throw a}return null}async getGalleryExtensions(o){const i=o.filter(({version:s})=>s===void 0).map(({id:s})=>s),e=o.filter(({version:s})=>s!==void 0),n=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(i,b.CancellationToken.None)).forEach(a=>n.set(a.identifier.id.toLowerCase(),a))})(),Promise.all(e.map(async({id:s,version:a})=>{const r=await this.extensionGalleryService.getCompatibleExtension({id:s},a);r&&n.set(r.identifier.id.toLowerCase(),r)}))]),n}async installFromGallery({id:o,version:i,installOptions:e},n,s,a,r){const f=await this.extensionGalleryService.getManifest(n,b.CancellationToken.None);if(f&&!this.validateExtensionKind(f,r))return null;const O=s.find(j=>(0,T.areSameExtensions)(j.identifier,n.identifier));if(O){if(n.version===O.manifest.version)return r.log((0,y.localize)(10,null,i?`${o}@${i}`:o)),null;r.log((0,y.localize)(11,null,o,n.version))}try{return e.isBuiltin?r.log((0,y.localize)(12,null,o,n.version)):r.log((0,y.localize)(13,null,o,n.version)),await this.extensionManagementService.installFromGallery(n,e),r.log((0,y.localize)(14,null,o,n.version)),f}catch(j){if((0,A.isPromiseCanceledError)(j))return r.log((0,y.localize)(15,null,o)),null;throw j}}validateExtensionKind(o,i){return!0}async validateVSIX(o,i,e){const n={id:(0,T.getGalleryExtensionId)(o.publisher,o.name)},a=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,T.areSameExtensions)(n,r.identifier)&&(0,E.gt)(r.manifest.version,o.version));return a&&!i?(e.log((0,y.localize)(16,null,a.identifier.id,a.manifest.version,o.version)),!1):this.validateExtensionKind(o,e)}async uninstallExtensions(o,i,e=console){const n=async a=>{if(a instanceof F.URI){const r=await this.extensionManagementService.getManifest(a);return C(r)}return a},s=[];for(const a of o){const r=await n(a),O=(await this.extensionManagementService.getInstalled()).filter(j=>(0,T.areSameExtensions)(j.identifier,{id:r}));if(!O.length)throw new Error(`${this.notInstalled(r)}
${l}`);if(O.some(j=>j.type===0)){e.log((0,y.localize)(17,null,r));return}if(!i&&O.some(j=>j.isBuiltin)){e.log((0,y.localize)(18,null,r));return}e.log((0,y.localize)(19,null,r));for(const j of O)await this.extensionManagementService.uninstall(j),s.push(j);this.location?e.log((0,y.localize)(20,null,r,this.location)):e.log((0,y.localize)(21,null,r))}s.some(a=>(0,h.isLanguagePackExtension)(a.manifest))&&await this.updateLocalizationsCache()}async locateExtension(o,i=console){const e=await this.extensionManagementService.getInstalled();o.forEach(n=>{e.forEach(s=>{if(s.identifier.id===n&&s.location.scheme===u.Schemas.file){i.log(s.location.fsPath);return}})})}updateLocalizationsCache(){return this.localizationsService.update()}notInstalled(o){return this.location?(0,y.localize)(22,null,o,this.location):(0,y.localize)(23,null,o)}};p=ce([fe(0,k.IExtensionManagementService),fe(1,k.IExtensionGalleryService),fe(2,R.ILocalizationsService)],p),t.ExtensionManagementCLIService=p}),define(Q[13],Y([0,1,7,2,17,11,30]),function(x,t,y,A,F,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,y.createDecorator)("logService"),t.ILoggerService=(0,y.createDecorator)("loggerService");function T(){return new Date().toISOString()}var h;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(h=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=h.Info;class d extends A.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new E.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=d;class b extends d{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...e){this.checkLogLevel(h.Trace)&&this.log(h.Trace,this.format([i,...e]))}debug(i,...e){this.checkLogLevel(h.Debug)&&this.log(h.Debug,this.format([i,...e]))}info(i,...e){this.checkLogLevel(h.Info)&&this.log(h.Info,this.format([i,...e]))}warn(i,...e){this.checkLogLevel(h.Warning)&&this.log(h.Warning,this.format([i,...e]))}error(i,...e){if(this.checkLogLevel(h.Error))if(i instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=i.stack,this.log(h.Error,this.format(n))}else this.log(h.Error,this.format([i,...e]))}critical(i,...e){this.checkLogLevel(h.Critical)&&this.log(h.Critical,this.format([i,...e]))}flush(){}format(i){let e="";for(let n=0;n<i.length;n++){let s=i[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch(a){}e+=(n>0?" ":"")+s}return e}}t.AbstractMessageLogger=b;class u extends d{constructor(i=t.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!F.isWindows}trace(i,...e){this.getLevel()<=h.Trace&&(this.useColors?console.log(`[90m[main ${T()}][0m`,i,...e):console.log(`[main ${T()}]`,i,...e))}debug(i,...e){this.getLevel()<=h.Debug&&(this.useColors?console.log(`[90m[main ${T()}][0m`,i,...e):console.log(`[main ${T()}]`,i,...e))}info(i,...e){this.getLevel()<=h.Info&&(this.useColors?console.log(`[90m[main ${T()}][0m`,i,...e):console.log(`[main ${T()}]`,i,...e))}warn(i,...e){this.getLevel()<=h.Warning&&(this.useColors?console.warn(`[93m[main ${T()}][0m`,i,...e):console.warn(`[main ${T()}]`,i,...e))}error(i,...e){this.getLevel()<=h.Error&&(this.useColors?console.error(`[91m[main ${T()}][0m`,i,...e):console.error(`[main ${T()}]`,i,...e))}critical(i,...e){this.getLevel()<=h.Critical&&(this.useColors?console.error(`[90m[main ${T()}][0m`,i,...e):console.error(`[main ${T()}]`,i,...e))}dispose(){}flush(){}}t.ConsoleMainLogger=u;class R extends d{constructor(i=t.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...e){this.getLevel()<=h.Trace&&console.log("%cTRACE","color: #888",i,...e)}debug(i,...e){this.getLevel()<=h.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...e)}info(i,...e){this.getLevel()<=h.Info&&console.log("%c INFO","color: #33f",i,...e)}warn(i,...e){this.getLevel()<=h.Warning&&console.log("%c WARN","color: #993",i,...e)}error(i,...e){this.getLevel()<=h.Error&&console.log("%c  ERR","color: #f33",i,...e)}critical(i,...e){this.getLevel()<=h.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...e)}dispose(){}flush(){}}t.ConsoleLogger=R;class w extends d{constructor(i,e=t.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(e)}trace(i,...e){this.getLevel()<=h.Trace&&this.adapter.log(h.Trace,[this.extractMessage(i),...e])}debug(i,...e){this.getLevel()<=h.Debug&&this.adapter.log(h.Debug,[this.extractMessage(i),...e])}info(i,...e){this.getLevel()<=h.Info&&this.adapter.log(h.Info,[this.extractMessage(i),...e])}warn(i,...e){this.getLevel()<=h.Warning&&this.adapter.log(h.Warning,[this.extractMessage(i),...e])}error(i,...e){this.getLevel()<=h.Error&&this.adapter.log(h.Error,[this.extractMessage(i),...e])}critical(i,...e){this.getLevel()<=h.Critical&&this.adapter.log(h.Critical,[this.extractMessage(i),...e])}extractMessage(i){return typeof i=="string"?i:(0,k.toErrorMessage)(i,this.getLevel()<=h.Trace)}dispose(){}flush(){}}t.AdapterLogger=w;class l extends d{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const e of this.logServices)e.setLevel(i);super.setLevel(i)}trace(i,...e){for(const n of this.logServices)n.trace(i,...e)}debug(i,...e){for(const n of this.logServices)n.debug(i,...e)}info(i,...e){for(const n of this.logServices)n.info(i,...e)}warn(i,...e){for(const n of this.logServices)n.warn(i,...e)}error(i,...e){for(const n of this.logServices)n.error(i,...e)}critical(i,...e){for(const n of this.logServices)n.critical(i,...e)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}t.MultiplexLogService=l;class C extends A.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...e){this.logger.trace(i,...e)}debug(i,...e){this.logger.debug(i,...e)}info(i,...e){this.logger.info(i,...e)}warn(i,...e){this.logger.warn(i,...e)}error(i,...e){this.logger.error(i,...e)}critical(i,...e){this.logger.critical(i,...e)}flush(){this.logger.flush()}}t.LogService=C;class v{constructor(){this.onDidChangeLogLevel=new E.Emitter().event}setLevel(i){}getLevel(){return h.Info}trace(i,...e){}debug(i,...e){}info(i,...e){}warn(i,...e){}error(i,...e){}critical(i,...e){}dispose(){}flush(){}}t.NullLogService=v;function m(o){if(o.verbose)return h.Trace;if(typeof o.logLevel=="string"){const i=p(o.logLevel.toLowerCase());if(i!==void 0)return i}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=m;function p(o){switch(o){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Critical;case"off":return h.Off}}t.parseLogLevel=p;function P(o){switch(o){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Critical:return"critical";case h.Off:return"off"}}t.LogLevelToString=P}),define(Q[94],Y([0,1,14,2,24,23,22,10,21,26,13,38,37,17,4]),function(x,t,y,A,F,E,k,T,h,d,b,u,R,w,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let v=class extends A.Disposable{constructor(p,P,o,i){super();this.fileService=P,this.extensionGalleryService=o,this.logService=i,this.extensionsDownloadDir=T.URI.file(p.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(p,P){await this.cleanUpPromise;const o=this.getName(p),i=(0,h.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(i)){const e=(0,h.joinPath)(this.extensionsDownloadDir,`.${o}`);await this.fileService.exists(e)||await this.extensionGalleryService.download(p,e,P),await this.rename(e,i,Date.now()+2*60*1e3)}return i}async delete(p){}async rename(p,P,o){try{await y.promises.rename(p.fsPath,P.fsPath)}catch(i){if(w.isWindows&&i&&i.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${p} to ${P} with 'EPERM' error. Trying again...`),this.rename(p,P,o);throw i}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const p=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(p.children){const P=[],o=[];for(const n of p.children){const s=this.parse(n.name);s&&o.push([s,n])}const i=(0,d.groupByExtension)(o,([n])=>n),e=[];for(const n of i)n.sort((s,a)=>R.rcompare(s[0].version,a[0].version)),P.push(...n.slice(1).map(s=>s[1].resource)),e.push(n[0][1]);e.sort((n,s)=>n.mtime-s.mtime),P.push(...e.slice(0,Math.max(0,e.length-this.cache)).map(n=>n.resource)),await l.Promises.settled(P.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(p){this.logService.error(p)}}getName(p){return this.cache?new d.ExtensionIdentifierWithVersion(p.identifier,p.version).key().toLowerCase():(0,u.generateUuid)()}parse(p){const P=C.exec(p);return P&&P[1]&&P[2]?new d.ExtensionIdentifierWithVersion({id:P[1]},P[2]):null}};v=ce([fe(0,k.INativeEnvironmentService),fe(1,F.IFileService),fe(2,E.IExtensionGalleryService),fe(3,b.ILogService)],v),t.ExtensionsDownloader=v}),define(Q[95],Y([0,1,2,13,34,30,3,4,11,9,12,22]),function(x,t,y,A,F,E,k,T,h,d,b,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let R=class extends y.Disposable{constructor(l,C){super();this.environmentService=l,this.logService=C,this.processesLimiter=new T.Limiter(5)}async postUninstall(l){const C=this.parseScript(l,"uninstall");return C&&(this.logService.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(C.script,"uninstall",C.args,!0,l).then(()=>this.logService.info(l.identifier.id,l.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(l.identifier.id,l.manifest.version,`Failed to run post uninstall script: ${v}`)))),(0,b.rimraf)(this.getExtensionStoragePath(l)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(l,C){const v=`vscode:${C}`;if(l.location.scheme===d.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[v]=="string"){const m=l.manifest.scripts[v].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(l.identifier.id,l.manifest.version,`${v} should be a node script`),null):{script:(0,k.join)(l.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(l,C,v,m,p){return new Promise((P,o)=>{const i=this.start(l,C,v,p);let e;const n=s=>{e&&(clearTimeout(e),e=null),s?o(s):P(void 0)};i.on("error",s=>{n((0,E.toErrorMessage)(s)||"Unknown")}),i.on("exit",(s,a)=>{n(s?`post-${C} process exited with code ${s}`:void 0)}),m&&(e=setTimeout(()=>{e=null,i.kill(),o("timed out")},5e3))})}start(l,C,v,m){const p={silent:!0,execArgv:void 0},P=(0,F.fork)(l,[`--type=extension-post-${C}`,...v],p);P.stdout.setEncoding("utf8"),P.stderr.setEncoding("utf8");const o=h.Event.fromNodeEventEmitter(P.stdout,"data"),i=h.Event.fromNodeEventEmitter(P.stderr,"data");o(s=>this.logService.info(m.identifier.id,m.manifest.version,`post-${C}`,s)),i(s=>this.logService.error(m.identifier.id,m.manifest.version,`post-${C}`,s));const e=h.Event.any(h.Event.map(o,s=>({data:`%c${s}`,format:[""]})),h.Event.map(i,s=>({data:`%c${s}`,format:["color: red"]})));return h.Event.debounce(e,(s,a)=>s?{data:s.data+a.data,format:[...s.format,...a.format]}:{data:a.data,format:a.format},100)(s=>{console.group(m.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),P}getExtensionStoragePath(l){return(0,k.join)(this.environmentService.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};R=ce([fe(0,u.IEnvironmentService),fe(1,A.ILogService)],R),t.ExtensionsLifecycle=R}),define(Q[96],Y([0,1,78,122,2,24,11,21,43,20,13,16,31,4,28,9,49,123]),function(x,t,y,A,F,E,k,T,h,d,b,u,R,w,l,C,v,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let p=class extends F.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new w.ResourceQueue)}registerProvider(o,i){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,A.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:i});const e=new F.DisposableStore;return e.add(i.onDidChangeFile(n=>this._onDidFilesChange.fire(new E.FileChangesEvent(n,!this.isPathCaseSensitive(i))))),e.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:o}))),typeof i.onDidErrorOccur=="function"&&e.add(i.onDidErrorOccur(n=>this._onError.fire(new Error(n)))),(0,F.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:i}),this.provider.delete(o),(0,F.dispose)(e)})}async activateProvider(o){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){i.push(e)}}),!this.provider.has(o)&&await w.Promises.settled(i)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,i){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&i)}listCapabilities(){return m.Iterable.map(this.provider,([o,i])=>({scheme:o,capabilities:i.capabilities}))}async withProvider(o){if(!(0,T.isAbsolutePath)(o))throw new E.FileOperationError((0,y.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const i=this.provider.get(o.scheme);if(!i){const e=new Error;throw e.name="ENOPRO",e.message=(0,y.localize)(1,null,o.toString()),e}return i}async withReadProvider(o){const i=await this.withProvider(o);if((0,E.hasOpenReadWriteCloseCapability)(i)||(0,E.hasReadWriteCapability)(i)||(0,E.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const i=await this.withProvider(o);if((0,E.hasOpenReadWriteCloseCapability)(i)||(0,E.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,i){try{return await this.doResolveFile(o,i)}catch(e){throw(0,E.toFileSystemProviderErrorCode)(e)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,y.localize)(2,null,this.resourceForError(o)),1):(0,E.ensureFileSystemProviderError)(e)}}async doResolveFile(o,i){const e=await this.withProvider(o),n=this.isPathCaseSensitive(e),s=i==null?void 0:i.resolveTo,a=i==null?void 0:i.resolveSingleChildDescendants,r=i==null?void 0:i.resolveMetadata,f=await e.stat(o);let O;return this.toFileStat(e,o,f,void 0,!!r,(j,M)=>(O||(O=h.TernarySearchTree.forUris(()=>!n),O.set(o,!0),(0,d.isNonEmptyArray)(s)&&s.forEach(U=>O.set(U,!0))),Boolean(O.findSuperstr(j.resource)||O.get(j.resource))?!0:j.isDirectory&&a?M===1:!1))}async toFileStat(o,i,e,n,s,a){const{providerExtUri:r}=this.getExtUri(o),f={resource:i,name:r.basename(i),isFile:(e.type&E.FileType.File)!=0,isDirectory:(e.type&E.FileType.Directory)!=0,isSymbolicLink:(e.type&E.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,etag:(0,E.etag)({mtime:e.mtime,size:e.size})};if(f.isDirectory&&a(f,n)){try{const O=await o.readdir(i),j=await w.Promises.settled(O.map(async([M,U])=>{try{const B=r.joinPath(i,M),K=s?await o.stat(B):{type:U};return await this.toFileStat(o,B,K,O.length,s,a)}catch(B){return this.logService.trace(B),null}}));f.children=(0,d.coalesce)(j)}catch(O){this.logService.trace(O),f.children=[]}return f}return f}async resolveAll(o){return w.Promises.settled(o.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const i=await this.withProvider(o);try{return!!await i.stat(o)}catch(e){return!1}}async canCreateFile(o,i){try{await this.doValidateCreateFile(o,i)}catch(e){return e}return!0}async doValidateCreateFile(o,i){if(!(i==null?void 0:i.overwrite)&&await this.exists(o))throw new E.FileOperationError((0,y.localize)(3,null,this.resourceForError(o)),3,i)}async createFile(o,i=u.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const n=await this.writeFile(o,i);return this._onDidRunOperation.fire(new E.FileOperationEvent(o,0,n)),n}async writeFile(o,i,e){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:s}=this.getExtUri(n);try{await this.validateWriteFile(n,o,e)||await this.mkdirp(n,s.dirname(o));let r;if((0,E.hasReadWriteCapability)(n)&&!(i instanceof u.VSBuffer))if((0,R.isReadableStream)(i)){const f=await(0,R.peekStream)(i,3);f.ended?r=u.VSBuffer.concat(f.buffer):r=f}else r=(0,R.peekReadable)(i,f=>u.VSBuffer.concat(f),3);else r=i;!(0,E.hasOpenReadWriteCloseCapability)(n)||(0,E.hasReadWriteCapability)(n)&&r instanceof u.VSBuffer?await this.doWriteUnbuffered(n,o,r):await this.doWriteBuffered(n,o,r instanceof u.VSBuffer?(0,u.bufferToReadable)(r):r)}catch(a){throw new E.FileOperationError((0,y.localize)(4,null,this.resourceForError(o),(0,E.ensureFileSystemProviderError)(a).toString()),(0,E.toFileOperationResult)(a),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,i,e){let n;try{n=await o.stat(i)}catch(s){return}if((n.type&E.FileType.Directory)!=0)throw new E.FileOperationError((0,y.localize)(5,null,this.resourceForError(i)),0,e);if(e&&typeof e.mtime=="number"&&typeof e.etag=="string"&&e.etag!==E.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,E.etag)({mtime:e.mtime,size:n.size}))throw new E.FileOperationError((0,y.localize)(6,null),3,e);return n}async readFile(o,i){const e=await this.withReadProvider(o);return(i==null?void 0:i.atomic)?this.doReadFileAtomic(e,o,i):this.doReadFile(e,o,i)}async doReadFileAtomic(o,i,e){return new Promise((n,s)=>{this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(o,i,e);n(a)}catch(a){s(a)}})})}async doReadFile(o,i,e){const n=await this.doReadFileStream(o,i,Object.assign(Object.assign({},e),{preferUnbuffered:!0}));return Object.assign(Object.assign({},n),{value:await(0,u.streamToBuffer)(n.value)})}async readFileStream(o,i){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,i)}async doReadFileStream(o,i,e){const n=new l.CancellationTokenSource,s=this.validateReadFile(i,e).then(r=>r,r=>{throw n.cancel(),r});let a;try{e&&typeof e.etag=="string"&&e.etag!==E.ETAG_DISABLED&&await s,!((0,E.hasOpenReadWriteCloseCapability)(o)||(0,E.hasFileReadStreamCapability)(o))||(0,E.hasReadWriteCapability)(o)&&(e==null?void 0:e.preferUnbuffered)?a=this.readFileUnbuffered(o,i,e):(0,E.hasFileReadStreamCapability)(o)?a=this.readFileStreamed(o,i,n.token,e):a=this.readFileBuffered(o,i,n.token,e);const r=await s;return Object.assign(Object.assign({},r),{value:a})}catch(r){throw a&&await(0,R.consumeStream)(a),new E.FileOperationError((0,y.localize)(7,null,this.resourceForError(i),(0,E.ensureFileSystemProviderError)(r).toString()),(0,E.toFileOperationResult)(r),e)}}readFileStreamed(o,i,e,n=Object.create(null)){const s=o.readFileStream(i,n,e);return(0,R.transform)(s,{data:a=>a instanceof u.VSBuffer?a:u.VSBuffer.wrap(a),error:a=>new E.FileOperationError((0,y.localize)(8,null,this.resourceForError(i),(0,E.ensureFileSystemProviderError)(a).toString()),(0,E.toFileOperationResult)(a),n)},a=>u.VSBuffer.concat(a))}readFileBuffered(o,i,e,n=Object.create(null)){const s=(0,u.newWriteableBufferStream)();return(0,v.readFileIntoStream)(o,i,s,a=>a,Object.assign(Object.assign({},n),{bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new E.FileOperationError((0,y.localize)(9,null,this.resourceForError(i),(0,E.ensureFileSystemProviderError)(a).toString()),(0,E.toFileOperationResult)(a),n)}),e),s}readFileUnbuffered(o,i,e){const n=(0,R.newWriteableStream)(s=>u.VSBuffer.concat(s));return(async()=>{try{let s=await o.readFile(i);e&&typeof e.position=="number"&&(s=s.slice(e.position)),e&&typeof e.length=="number"&&(s=s.slice(0,e.length)),this.validateReadFileLimits(i,s.byteLength,e),n.end(u.VSBuffer.wrap(s))}catch(s){n.error(s),n.end()}})(),n}async validateReadFile(o,i){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new E.FileOperationError((0,y.localize)(10,null,this.resourceForError(o)),0,i);if(i&&typeof i.etag=="string"&&i.etag!==E.ETAG_DISABLED&&i.etag===e.etag)throw new E.FileOperationError((0,y.localize)(11,null),2,i);return this.validateReadFileLimits(o,e.size,i),e}validateReadFileLimits(o,i,e){if(e==null?void 0:e.limits){let n;if(typeof e.limits.memory=="number"&&i>e.limits.memory&&(n=9),typeof e.limits.size=="number"&&i>e.limits.size&&(n=7),typeof n=="number")throw new E.FileOperationError((0,y.localize)(12,null,this.resourceForError(o)),n)}}async canMove(o,i,e){return this.doCanMoveCopy(o,i,"move",e)}async canCopy(o,i,e){return this.doCanMoveCopy(o,i,"copy",e)}async doCanMoveCopy(o,i,e,n){if(o.toString()!==i.toString())try{const s=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(s,o,a,i,e,n)}catch(s){return s}return!0}async move(o,i,e){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),a=await this.doMoveCopy(n,o,s,i,"move",!!e),r=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(o,a==="move"?2:3,r)),r}async copy(o,i,e){const n=await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),a=await this.doMoveCopy(n,o,s,i,"copy",!!e),r=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(o,a==="copy"?3:2,r)),r}async doMoveCopy(o,i,e,n,s,a){if(i.toString()===n.toString())return s;const{exists:r,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(o,i,e,n,s,a);if(r&&!f&&a&&await this.del(n,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(n)),s==="copy"){if(o===e&&(0,E.hasFileFolderCopyCapability)(o))await o.copy(i,n,{overwrite:a});else{const O=await this.resolve(i);O.isDirectory?await this.doCopyFolder(o,O,e,n):await this.doCopyFile(o,i,e,n)}return s}else return o===e?(await o.rename(i,n,{overwrite:a}),s):(await this.doMoveCopy(o,i,e,n,"copy",a),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(o,i,e,n){if((0,E.hasOpenReadWriteCloseCapability)(o)&&(0,E.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(o,i,e,n);if((0,E.hasOpenReadWriteCloseCapability)(o)&&(0,E.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(o,i,e,n);if((0,E.hasReadWriteCapability)(o)&&(0,E.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(o,i,e,n);if((0,E.hasReadWriteCapability)(o)&&(0,E.hasReadWriteCapability)(e))return this.doPipeUnbuffered(o,i,e,n)}async doCopyFolder(o,i,e,n){await e.mkdir(n),Array.isArray(i.children)&&await w.Promises.settled(i.children.map(async s=>{const a=this.getExtUri(e).providerExtUri.joinPath(n,s.name);return s.isDirectory?this.doCopyFolder(o,await this.resolve(s.resource),e,a):this.doCopyFile(o,s.resource,e,a)}))}async doValidateMoveCopy(o,i,e,n,s,a){let r=!1;if(o===e){const{providerExtUri:O,isPathCaseSensitive:j}=this.getExtUri(o);if(j||(r=O.isEqual(i,n)),r&&s==="copy")throw new Error((0,y.localize)(13,null,this.resourceForError(i),this.resourceForError(n)));if(!r&&O.isEqualOrParent(n,i))throw new Error((0,y.localize)(14,null,this.resourceForError(i),this.resourceForError(n)))}const f=await this.exists(n);if(f&&!r){if(!a)throw new E.FileOperationError((0,y.localize)(15,null,this.resourceForError(i),this.resourceForError(n)),4);if(o===e){const{providerExtUri:O}=this.getExtUri(o);if(O.isEqualOrParent(i,n))throw new Error((0,y.localize)(16,null,this.resourceForError(i),this.resourceForError(n)))}}return{exists:f,isSameResourceWithDifferentPathCase:r}}getExtUri(o){const i=this.isPathCaseSensitive(o);return{providerExtUri:i?T.extUri:T.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(i,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(o,0,e)),e}async mkdirp(o,i){const e=[],{providerExtUri:n}=this.getExtUri(o);for(;!n.isEqual(i,n.dirname(i));)try{if(((await o.stat(i)).type&E.FileType.Directory)==0)throw new Error((0,y.localize)(17,null,this.resourceForError(i)));break}catch(s){if((0,E.toFileSystemProviderErrorCode)(s)!==E.FileSystemProviderErrorCode.FileNotFound)throw s;e.push(n.basename(i)),i=n.dirname(i)}for(let s=e.length-1;s>=0;s--){i=n.joinPath(i,e[s]);try{await o.mkdir(i)}catch(a){if((0,E.toFileSystemProviderErrorCode)(a)!==E.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,i){try{await this.doValidateDelete(o,i)}catch(e){return e}return!0}async doValidateDelete(o,i){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!(i==null?void 0:i.useTrash)&&!(e.capabilities&4096))throw new Error((0,y.localize)(18,null,this.resourceForError(o)));const s=await this.exists(o);if(!s)throw new E.FileOperationError((0,y.localize)(19,null,this.resourceForError(o)),1);if(!!!(i==null?void 0:i.recursive)&&s){const r=await this.resolve(o);if(r.isDirectory&&Array.isArray(r.children)&&r.children.length>0)throw new Error((0,y.localize)(20,null,this.resourceForError(o)))}return e}async del(o,i){const e=await this.doValidateDelete(o,i),n=!!(i==null?void 0:i.useTrash),s=!!(i==null?void 0:i.recursive);await e.delete(o,{recursive:s,useTrash:n}),this._onDidRunOperation.fire(new E.FileOperationEvent(o,1))}watch(o,i={recursive:!1,excludes:[]}){let e=!1,n=()=>{e=!0};return this.doWatch(o,i).then(s=>{e?(0,F.dispose)(s):n=()=>(0,F.dispose)(s)},s=>this.logService.error(s)),(0,F.toDisposable)(()=>n())}async doWatch(o,i){const e=await this.withProvider(o),n=this.toWatchKey(e,o,i),s=this.activeWatchers.get(n)||{count:0,disposable:e.watch(o,i)};return this.activeWatchers.has(n)||this.activeWatchers.set(n,s),s.count+=1,(0,F.toDisposable)(()=>{s.count--,s.count===0&&((0,F.dispose)(s.disposable),this.activeWatchers.delete(n))})}toWatchKey(o,i,e){const{providerExtUri:n}=this.getExtUri(o);return[n.getComparisonKey(i),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>(0,F.dispose)(o.disposable)),this.activeWatchers.clear()}async doWriteBuffered(o,i,e){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(i,{create:!0});try{(0,R.isReadableStream)(e)||(0,R.isReadableBufferedStream)(e)?await this.doWriteStreamBufferedQueued(o,n,e):await this.doWriteReadableBufferedQueued(o,n,e)}catch(s){throw(0,E.ensureFileSystemProviderError)(s)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,i,e){let n=0,s;if((0,R.isReadableBufferedStream)(e)){if(e.buffer.length>0){const a=u.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,i,a,a.byteLength,n,0),n+=a.byteLength}if(e.ended)return;s=e.stream}else s=e;return new Promise(async(a,r)=>{(0,R.listenStream)(s,{onData:async f=>{s.pause();try{await this.doWriteBuffer(o,i,f,f.byteLength,n,0)}catch(O){return r(O)}n+=f.byteLength,setTimeout(()=>s.resume())},onError:f=>r(f),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(o,i,e){let n=0,s;for(;(s=e.read())!==null;)await this.doWriteBuffer(o,i,s,s.byteLength,n,0),n+=s.byteLength}async doWriteBuffer(o,i,e,n,s,a){let r=0;for(;r<n;)r+=await o.write(i,s+r,e.buffer,a+r,n-r)}async doWriteUnbuffered(o,i,e){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,i,e))}async doWriteUnbufferedQueued(o,i,e){let n;e instanceof u.VSBuffer?n=e:(0,R.isReadableStream)(e)?n=await(0,u.streamToBuffer)(e):(0,R.isReadableBufferedStream)(e)?n=await(0,u.bufferedStreamToBuffer)(e):n=(0,u.readableToBuffer)(e),await o.writeFile(i,n.buffer,{create:!0,overwrite:!0})}async doPipeBuffered(o,i,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,i,e,n))}async doPipeBufferedQueued(o,i,e,n){let s,a;try{s=await o.open(i,{create:!1}),a=await e.open(n,{create:!0});const r=u.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,O=0,j=0;do j=await o.read(s,f,r.buffer,O,r.byteLength-O),await this.doWriteBuffer(e,a,r,j,f,O),f+=j,O+=j,O===r.byteLength&&(O=0);while(j>0)}catch(r){throw(0,E.ensureFileSystemProviderError)(r)}finally{await w.Promises.settled([typeof s=="number"?o.close(s):Promise.resolve(),typeof a=="number"?e.close(a):Promise.resolve()])}}async doPipeUnbuffered(o,i,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,i,e,n))}async doPipeUnbufferedQueued(o,i,e,n){return e.writeFile(n,await o.readFile(i),{create:!0,overwrite:!0})}async doPipeUnbufferedToBuffered(o,i,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,i,e,n))}async doPipeUnbufferedToBufferedQueued(o,i,e,n){const s=await e.open(n,{create:!0});try{const a=await o.readFile(i);await this.doWriteBuffer(e,s,u.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,E.ensureFileSystemProviderError)(a)}finally{await e.close(s)}}async doPipeBufferedToUnbuffered(o,i,e,n){const s=await(0,u.streamToBuffer)(this.readFileBuffered(o,i,l.CancellationToken.None));await this.doWriteUnbuffered(e,n,s)}throwIfFileSystemIsReadonly(o,i){if(o.capabilities&2048)throw new E.FileOperationError((0,y.localize)(21,null,this.resourceForError(i)),6);return o}resourceForError(o){return o.scheme===C.Schemas.file?o.fsPath:o.toString(!0)}};p=ce([fe(0,b.ILogService)],p),t.FileService=p}),define(Q[97],Y([0,1,14,124,2,24,11,17,12,3,21,32,4,13,80,50,85,87,84,91,31,49,20,16]),function(x,t,y,A,F,E,k,T,h,d,b,u,R,w,l,C,v,m,p,P,o,i,e,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class s extends F.Disposable{constructor(r,f){var O;super();this.logService=r,this.options=f,this.BUFFER_SIZE=((O=this.options)===null||O===void 0?void 0:O.bufferSize)||64*1024,this.onDidChangeCapabilities=k.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Set,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new k.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new R.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8,T.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:f,symbolicLink:O}=await h.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(f,O),ctime:f.birthtime.getTime(),mtime:f.mtime.getTime(),size:f.size}}catch(f){throw this.toFileSystemProviderError(f)}}async readdir(r){try{const f=await(0,h.readdir)(this.toFilePath(r),{withFileTypes:!0}),O=[];return await Promise.all(f.map(async j=>{try{let M;j.isSymbolicLink()?M=(await this.stat((0,b.joinPath)(r,j.name))).type:M=this.toType(j),O.push([j.name,M])}catch(M){this.logService.trace(M)}})),O}catch(f){throw this.toFileSystemProviderError(f)}}toType(r,f){let O;return(f==null?void 0:f.dangling)?O=E.FileType.Unknown:r.isFile()?O=E.FileType.File:r.isDirectory()?O=E.FileType.Directory:O=E.FileType.Unknown,f&&(O|=E.FileType.SymbolicLink),O}async readFile(r){try{const f=this.toFilePath(r);return await y.promises.readFile(f)}catch(f){throw this.toFileSystemProviderError(f)}}readFileStream(r,f,O){const j=(0,o.newWriteableStream)(M=>n.VSBuffer.concat(M.map(U=>n.VSBuffer.wrap(U))).buffer);return(0,i.readFileIntoStream)(this,r,j,M=>M.buffer,Object.assign(Object.assign({},f),{bufferSize:this.BUFFER_SIZE}),O),j}async writeFile(r,f,O){let j;try{const M=this.toFilePath(r);if(!O.create||!O.overwrite){if(await(0,h.exists)(M)){if(!O.overwrite)throw(0,E.createFileSystemProviderError)((0,l.localize)(0,null),E.FileSystemProviderErrorCode.FileExists)}else if(!O.create)throw(0,E.createFileSystemProviderError)((0,l.localize)(1,null),E.FileSystemProviderErrorCode.FileNotFound)}j=await this.open(r,{create:!0}),await this.write(j,0,f,0,f.byteLength)}catch(M){throw this.toFileSystemProviderError(M)}finally{typeof j=="number"&&await this.close(j)}}async open(r,f){try{const O=this.toFilePath(r);let j;if(f.create){if(T.isWindows)try{await y.promises.truncate(O,0),j="r+"}catch(U){U.code!=="ENOENT"&&this.logService.trace(U)}j||(j="w")}else j="r";const M=await(0,A.promisify)(y.open)(O,j);return this.mapHandleToPos.set(M,0),f.create&&this.writeHandles.add(M),M}catch(O){throw this.toFileSystemProviderError(O)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await(0,A.promisify)(y.fdatasync)(r)}catch(f){this.canFlush=!1,this.logService.error(f)}return await(0,A.promisify)(y.close)(r)}catch(f){throw this.toFileSystemProviderError(f)}}async read(r,f,O,j,M){const U=this.normalizePos(r,f);let B=null;try{const K=await(0,A.promisify)(y.read)(r,O,j,M,U);return typeof K=="number"?B=K:B=K.bytesRead,B}catch(K){throw this.toFileSystemProviderError(K)}finally{this.updatePos(r,U,B)}}normalizePos(r,f){return f===this.mapHandleToPos.get(r)?null:f}updatePos(r,f,O){const j=this.mapHandleToPos.get(r);typeof j=="number"&&(typeof f=="number"||(typeof O=="number"?this.mapHandleToPos.set(r,j+O):this.mapHandleToPos.delete(r)))}async write(r,f,O,j,M){return(0,R.retry)(()=>this.doWrite(r,f,O,j,M),100,3)}async doWrite(r,f,O,j,M){const U=this.normalizePos(r,f);let B=null;try{const K=await(0,A.promisify)(y.write)(r,O,j,M,U);return typeof K=="number"?B=K:B=K.bytesWritten,B}catch(K){throw this.toFileSystemProviderError(K)}finally{this.updatePos(r,U,B)}}async mkdir(r){try{await y.promises.mkdir(this.toFilePath(r))}catch(f){throw this.toFileSystemProviderError(f)}}async delete(r,f){try{const O=this.toFilePath(r);await this.doDelete(O,f)}catch(O){throw this.toFileSystemProviderError(O)}}async doDelete(r,f){f.recursive?await(0,h.rimraf)(r,h.RimRafMode.MOVE):await y.promises.unlink(r)}async rename(r,f,O){const j=this.toFilePath(r),M=this.toFilePath(f);if(j!==M)try{await this.validateTargetDeleted(r,f,"move",O.overwrite),await(0,h.move)(j,M)}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error((0,l.localize)(2,null,(0,d.basename)(j),(0,d.basename)((0,d.dirname)(M)),U.toString()))),this.toFileSystemProviderError(U)}}async copy(r,f,O){const j=this.toFilePath(r),M=this.toFilePath(f);if(j!==M)try{await this.validateTargetDeleted(r,f,"copy",O.overwrite),await(0,h.copy)(j,M,{preserveSymlinks:!0})}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error((0,l.localize)(3,null,(0,d.basename)(j),(0,d.basename)((0,d.dirname)(M)),U.toString()))),this.toFileSystemProviderError(U)}}async validateTargetDeleted(r,f,O,j){const M=this.toFilePath(r),U=this.toFilePath(f);let B=!1;if(!!(this.capabilities&1024)||(B=(0,u.isEqual)(M,U,!0)),B&&O==="copy")throw(0,E.createFileSystemProviderError)((0,l.localize)(4,null),E.FileSystemProviderErrorCode.FileExists);if(!B&&await(0,h.exists)(U)){if(!j)throw(0,E.createFileSystemProviderError)((0,l.localize)(5,null),E.FileSystemProviderErrorCode.FileExists);await this.delete(f,{recursive:!0,useTrash:!1})}}watch(r,f){return f.recursive?this.watchRecursive(r,f.excludes):this.watchNonRecursive(r)}watchRecursive(r,f){const O={path:this.toFilePath(r),excludes:f},j=(0,e.insert)(this.recursiveFoldersToWatch,O);return this.refreshRecursiveWatchers(),(0,F.toDisposable)(()=>{j(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var r,f,O;if(this.recursiveWatcher instanceof p.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,F.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let j,M;((f=(r=this.options)===null||r===void 0?void 0:r.watcher)===null||f===void 0?void 0:f.usePolling)?(j=v.FileWatcher,M=(O=this.options)===null||O===void 0?void 0:O.watcher):this.recursiveFoldersToWatch.length===1?T.isWindows?j=m.FileWatcher:j=v.FileWatcher:j=p.FileWatcher,this.recursiveWatcher=new j(this.recursiveFoldersToWatch,U=>this._onDidChangeFile.fire((0,C.toFileChanges)(U)),U=>{U.type==="error"&&this._onDidWatchErrorOccur.fire(U.message),this.logService[U.type](U.message)},this.logService.getLevel()===w.LogLevel.Trace,M),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)}))}}watchNonRecursive(r){const f=new P.FileWatcher(this.toFilePath(r),j=>this._onDidChangeFile.fire((0,C.toFileChanges)(j)),j=>{j.type==="error"&&this._onDidWatchErrorOccur.fire(j.message),this.logService[j.type](j.message)},this.logService.getLevel()===w.LogLevel.Trace),O=this.logService.onDidChangeLogLevel(()=>{f.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)});return(0,F.combinedDisposable)(f,O)}toFilePath(r){return(0,d.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof E.FileSystemProviderError)return r;let f;switch(r.code){case"ENOENT":f=E.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":f=E.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":f=E.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":f=E.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":f=E.FileSystemProviderErrorCode.NoPermissions;break;default:f=E.FileSystemProviderErrorCode.Unknown}return(0,E.createFileSystemProviderError)(r,f)}dispose(){super.dispose(),(0,F.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,F.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=s}),define(Q[98],Y([0,1,12,14,125,23,2,22,4,26,13,36,20,11,9,3]),function(x,t,y,A,F,E,k,T,h,d,b,u,R,w,l,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let v=class extends k.Disposable{constructor(P,o,i){super();this.extensionManagementService=P,this.logService=i,this._onDidLanguagesChange=this._register(new w.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new m(o,i)),this._register(P.onDidInstallExtension(({local:e})=>this.onDidInstallExtension(e))),this._register(P.onDidUninstallExtension(({identifier:e})=>this.onDidUninstallExtension(e)))}getLanguageIds(){return this.cache.getLanguagePacks().then(P=>{const o=["en",...Object.keys(P)];return(0,R.distinct)(o)})}onDidInstallExtension(P){P&&P.manifest&&P.manifest.contributes&&P.manifest.contributes.localizations&&P.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",P.identifier.id),this.update().then(o=>{o&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(P){this.cache.getLanguagePacks().then(o=>{Object.keys(o).some(i=>o[i]&&o[i].extensions.some(e=>(0,d.areSameExtensions)(e.extensionIdentifier,P)))&&(this.logService.debug("Removing language packs from the extension",P.id),this.update().then(i=>{i&&this._onDidLanguagesChange.fire()}))})}async update(){const[P,o]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),i=await this.cache.update(o);return!(0,R.equals)(Object.keys(P),Object.keys(i))}};v=ce([fe(0,E.IExtensionManagementService),fe(1,T.INativeEnvironmentService),fe(2,b.ILogService)],v),t.LocalizationsService=v;let m=class extends k.Disposable{constructor(P,o){super();this.logService=o,this.languagePacks={},this.languagePacksFilePath=(0,C.join)(P.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new h.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(P){return this.withLanguagePacks(o=>{Object.keys(o).forEach(i=>delete o[i]),this.createLanguagePacksFromExtensions(o,...P)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(P,...o){for(const i of o)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(P,i);Object.keys(P).forEach(i=>this.updateHash(P[i]))}createLanguagePacksFromExtension(P,o){const i=o.identifier,e=o.manifest.contributes&&o.manifest.contributes.localizations?o.manifest.contributes.localizations:[];for(const n of e)if(o.location.scheme===l.Schemas.file&&(0,u.isValidLocalization)(n)){let s=P[n.languageId];s||(s={hash:"",extensions:[],translations:{}},P[n.languageId]=s);let a=s.extensions.filter(r=>(0,d.areSameExtensions)(r.extensionIdentifier,i))[0];a?a.version=o.manifest.version:s.extensions.push({extensionIdentifier:i,version:o.manifest.version});for(const r of n.translations)s.translations[r.id]=(0,C.join)(o.location.fsPath,r.path)}}updateHash(P){if(P){const o=(0,F.createHash)("md5");for(const i of P.extensions)o.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);P.hash=o.digest("hex")}}withLanguagePacks(P=()=>null){return this.languagePacksFileLimiter.queue(()=>{let o=null;return A.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch(e){return{}}}).then(i=>(o=P(i),i)).then(i=>{for(const n of Object.keys(i))i[n]||delete i[n];this.languagePacks=i,this.initializedCache=!0;const e=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",e),(0,y.writeFile)(this.languagePacksFilePath,e)}).then(()=>o,i=>this.logService.error(i))})}};m=ce([fe(0,T.INativeEnvironmentService),fe(1,b.ILogService)],m)}),define(Q[99],Y([0,1,13,24]),function(x,t,y,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function F(h,d,b,u){try{const R=await new Promise((w,l)=>{x(["spdlog"],w,l)});return R.setAsyncMode(8192,500),R.createRotatingLoggerAsync(h,d,b,u)}catch(R){console.error(R)}return null}function E(h,d,b,u){return x.__$__nodeRequire("spdlog").createRotatingLogger(h,d,b,u)}t.createRotatingLogger=E;function k(h,d,b){switch(d){case y.LogLevel.Trace:h.trace(b);break;case y.LogLevel.Debug:h.debug(b);break;case y.LogLevel.Info:h.info(b);break;case y.LogLevel.Warning:h.warn(b);break;case y.LogLevel.Error:h.error(b);break;case y.LogLevel.Critical:h.critical(b);break;default:throw new Error("Invalid log level")}}class T extends y.AbstractMessageLogger{constructor(d,b,u,R){super();this.name=d,this.filepath=b,this.rotating=u,this.buffer=[],this.setLevel(R),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(w=>{this._logger&&this._logger.setLevel(w)}))}_createSpdLogLogger(){const d=this.rotating?6:1,b=30/d*A.ByteSize.MB;return F(this.name,this.filepath,b,d).then(u=>{if(u){this._logger=u,this._logger.setLevel(this.getLevel());for(const{level:R,message:w}of this.buffer)k(this._logger,R,w);this.buffer=[]}})}log(d,b){this._logger?k(this._logger,d,b):this.getLevel()<=d&&this.buffer.push({level:d,message:b})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=T}),define(Q[100],Y([0,1,45,39,62,3,21,55,66,9,10]),function(x,t,y,A,F,E,k,T,h,d,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseUserDataDir=t.parsePathArg=t.parseSearchPort=t.parseExtensionHostPort=t.NativeEnvironmentService=void 0;class u{constructor(p){if(this._args=p,!p.logsPath){const P=(0,h.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");p.logsPath=(0,E.join)(this.userDataPath,"logs",P)}this.logsPath=p.logsPath}get args(){return this._args}get appRoot(){return(0,E.dirname)(d.FileAccess.asFileUri("",x).fsPath)}get userHome(){return b.URI.file((0,y.homedir)())}get userDataPath(){const p=process.env.VSCODE_PORTABLE;return p?(0,E.join)(p,"user-data"):v(this._args,process)}get appSettingsHome(){return b.URI.file((0,E.join)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file((0,y.tmpdir)())}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,k.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get userDataSyncLogResource(){return b.URI.file((0,E.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(b.URI.file((0,E.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return b.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return b.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=process.env.VSCODE_PORTABLE;return p?b.URI.file((0,E.join)(p,"argv.json")):(0,k.joinPath)(this.userHome,A.default.dataFolderName,"argv.json")}get snippetsHome(){return(0,k.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this._args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,E.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,E.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const p=C(this._args["builtin-extensions-dir"],process);return p||(0,E.normalize)((0,E.join)(d.FileAccess.asFileUri("",x).fsPath,"..","extensions"))}get extensionsDownloadPath(){const p=C(this._args["extensions-download-dir"],process);return p||(0,E.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const p=C(this._args["extensions-dir"],process);if(p)return p;const P=process.env.VSCODE_EXTENSIONS;if(P)return P;const o=process.env.VSCODE_PORTABLE;return o?(0,E.join)(o,"extensions"):(0,k.joinPath)(this.userHome,A.default.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this._args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(P=>/^[^:/?#]+?:\/\//.test(P)?b.URI.parse(P):b.URI.file((0,E.normalize)(P)))}get extensionTestsLocationURI(){const p=this._args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?b.URI.parse(p):b.URI.file((0,E.normalize)(p))}get disableExtensions(){if(this._args["disable-extensions"])return!0;const p=this._args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return R(this._args,this.isBuilt)}get debugRenderer(){return!!this._args.debugRenderer}get isBuilt(){return!process.env.VSCODE_DEV}get verbose(){return!!this._args.verbose}get logLevel(){return this._args.log}get serviceMachineIdResource(){return(0,k.joinPath)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this._args["crash-reporter-id"]}get crashReporterDirectory(){return this._args["crash-reporter-directory"]}get driverHandle(){return this._args.driver}get telemetryLogResource(){return b.URI.file((0,E.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this._args["disable-telemetry"]}}ce([T.memoize],u.prototype,"appRoot",null),ce([T.memoize],u.prototype,"userHome",null),ce([T.memoize],u.prototype,"userDataPath",null),ce([T.memoize],u.prototype,"appSettingsHome",null),ce([T.memoize],u.prototype,"tmpDir",null),ce([T.memoize],u.prototype,"userRoamingDataHome",null),ce([T.memoize],u.prototype,"settingsResource",null),ce([T.memoize],u.prototype,"userDataSyncHome",null),ce([T.memoize],u.prototype,"userDataSyncLogResource",null),ce([T.memoize],u.prototype,"sync",null),ce([T.memoize],u.prototype,"machineSettingsResource",null),ce([T.memoize],u.prototype,"globalStorageHome",null),ce([T.memoize],u.prototype,"workspaceStorageHome",null),ce([T.memoize],u.prototype,"keybindingsResource",null),ce([T.memoize],u.prototype,"keyboardLayoutResource",null),ce([T.memoize],u.prototype,"argvResource",null),ce([T.memoize],u.prototype,"snippetsHome",null),ce([T.memoize],u.prototype,"isExtensionDevelopment",null),ce([T.memoize],u.prototype,"untitledWorkspacesHome",null),ce([T.memoize],u.prototype,"installSourcePath",null),ce([T.memoize],u.prototype,"builtinExtensionsPath",null),ce([T.memoize],u.prototype,"extensionsPath",null),ce([T.memoize],u.prototype,"extensionDevelopmentLocationURI",null),ce([T.memoize],u.prototype,"extensionTestsLocationURI",null),ce([T.memoize],u.prototype,"debugExtensionHost",null),ce([T.memoize],u.prototype,"serviceMachineIdResource",null),ce([T.memoize],u.prototype,"telemetryLogResource",null),t.NativeEnvironmentService=u;function R(m,p){return l(m["inspect-extensions"],m["inspect-brk-extensions"],5870,p,m.debugId)}t.parseExtensionHostPort=R;function w(m,p){return l(m["inspect-search"],m["inspect-brk-search"],5876,p)}t.parseSearchPort=w;function l(m,p,P,o,i){const n=Number(p||m)||(o?null:P),s=n?Boolean(!!p):!1;return{port:n,break:s,debugId:i}}function C(m,p){if(!!m){const P=(0,E.resolve)(m);return(0,E.normalize)(m)===P?P:(0,E.resolve)(p.env.VSCODE_CWD||p.cwd(),m)}}t.parsePathArg=C;function v(m,p){return C(m["user-data-dir"],p)||(0,E.resolve)((0,F.getDefaultUserDataPath)())}t.parseUserDataDir=v}),define(Q[40],Y([0,1,7]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,y.createDecorator)("productService")}),define(Q[25],Y([0,1,8,54]),function(x,t,y,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class F{constructor(){this.data=new Map}add(k,T){A.ok(y.isString(k)),A.ok(y.isObject(T)),A.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,T)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}t.Registry=new F}),define(Q[101],Y([0,1,25,11]),function(x,t,y,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function F(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class E{constructor(){this._onDidChangeSchema=new A.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,d){this.schemasById[F(h)]=d,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new E;y.Registry.add(t.Extensions.JSONContribution,k)}),define(Q[29],Y([0,1,71,11,25,8,101]),function(x,t,y,A,F,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=void 0,t.Extensions={Configuration:"base.contributions.configuration"};var T;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const h=F.Registry.as(k.Extensions.JSONContribution);class d{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new A.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new A.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:y.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},h.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(m,p=!0){this.registerConfigurations([m],p)}registerConfigurations(m,p=!0){const P=[];m.forEach(o=>{P.push(...this.validateAndRegisterProperties(o,p)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),h.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(P)}deregisterConfigurations(m){const p=[],P=o=>{if(o.properties)for(const i in o.properties)p.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,o.properties[i]);o.allOf&&o.allOf.forEach(i=>P(i))};for(const o of m){P(o);const i=this.configurationContributors.indexOf(o);i!==-1&&this.configurationContributors.splice(i,1)}h.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}registerDefaultConfigurations(m){const p=[],P=[];for(const o of m)for(const i in o)if(p.push(i),t.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]=Object.assign(Object.assign({},this.defaultValues[i]||{}),o[i]);const e={type:"object",default:this.defaultValues[i],description:y.localize(1,null,i),$ref:t.resourceLanguageSettingsSchemaId};P.push(u(i)),this.configurationProperties[i]=e,this.defaultLanguageConfigurationOverridesNode.properties[i]=e}else{this.defaultValues[i]=o[i];const e=this.configurationProperties[i];e&&(this.updatePropertyDefaultValue(i,e),this.updateSchema(i,e))}this.registerOverrideIdentifiers(P),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}deregisterDefaultConfigurations(m){const p=[];for(const P of m)for(const o in P)if(p.push(o),delete this.defaultValues[o],t.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const i=this.configurationProperties[o];i&&(this.updatePropertyDefaultValue(o,i),this.updateSchema(o,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}notifyConfigurationSchemaUpdated(...m){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(m){for(const p of m)this.overrideIdentifiers.add(p);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(m,p=!0,P=3){P=E.isUndefinedOrNull(m.scope)?P:m.scope;let o=[],i=m.properties;if(i)for(let n in i){if(p&&l(n)){delete i[n];continue}const s=i[n];if(this.updatePropertyDefaultValue(n,s),t.OVERRIDE_PROPERTY_PATTERN.test(n)?s.scope=void 0:s.scope=E.isUndefinedOrNull(s.scope)?P:s.scope,i[n].hasOwnProperty("included")&&!i[n].included){this.excludedConfigurationProperties[n]=i[n],delete i[n];continue}else this.configurationProperties[n]=i[n];!i[n].deprecationMessage&&i[n].markdownDeprecationMessage&&(i[n].deprecationMessage=i[n].markdownDeprecationMessage),o.push(n)}let e=m.allOf;if(e)for(let n of e)o.push(...this.validateAndRegisterProperties(n,p,P));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(m){const p=P=>{let o=P.properties;if(o)for(const e in o)this.updateSchema(e,o[e]);let i=P.allOf;i&&i.forEach(p)};p(m)}updateSchema(m,p){switch(t.allSettings.properties[m]=p,p.scope){case 1:t.applicationSettings.properties[m]=p;break;case 2:t.machineSettings.properties[m]=p;break;case 6:t.machineOverridableSettings.properties[m]=p;break;case 3:t.windowSettings.properties[m]=p;break;case 4:t.resourceSettings.properties[m]=p;break;case 5:t.resourceSettings.properties[m]=p,this.resourceLanguageSettingsSchema.properties[m]=p;break}}removeFromSchema(m,p){switch(delete t.allSettings.properties[m],p.scope){case 1:delete t.applicationSettings.properties[m];break;case 2:delete t.machineSettings.properties[m];break;case 6:delete t.machineOverridableSettings.properties[m];break;case 3:delete t.windowSettings.properties[m];break;case 4:case 5:delete t.resourceSettings.properties[m];break}}updateOverridePropertyPatternKey(){for(const m of this.overrideIdentifiers.values()){const p=`[${m}]`,P={type:"object",description:y.localize(2,null),errorMessage:y.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(p,P),t.allSettings.properties[p]=P,t.applicationSettings.properties[p]=P,t.machineSettings.properties[p]=P,t.machineOverridableSettings.properties[p]=P,t.windowSettings.properties[p]=P,t.resourceSettings.properties[p]=P}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(m,p){let P=this.defaultValues[m];E.isUndefined(P)&&(P=p.default),E.isUndefined(P)&&(P=R(p.type)),p.default=P}}const b="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(b);function u(v){return v.substring(1,v.length-1)}t.overrideIdentifierFromKey=u;function R(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=R;const w=new d;F.Registry.add(t.Extensions.Configuration,w);function l(v){return v.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(v)?y.localize(5,null,v):w.getConfigurationProperties()[v]!==void 0?y.localize(6,null,v):null:y.localize(4,null)}t.validateProperty=l;function C(){const v=[],m=w.getConfigurationProperties();for(const p of Object.keys(m))v.push([p,m[p].scope]);return v.push(["launch",4]),v.push(["task",4]),v}t.getScopes=C}),define(Q[27],Y([0,1,19,8,10,25,7,29]),function(x,t,y,A,F,E,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,k.createDecorator)("configurationService");function h(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof F.URI)}t.isConfigurationOverrides=h;var d;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(d=t.ConfigurationTarget||(t.ConfigurationTarget={}));function b(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=b;function u(n,s){const a=s?n?s.keys.filter(B=>n.keys.indexOf(B)===-1):[...s.keys]:[],r=n?s?n.keys.filter(B=>s.keys.indexOf(B)===-1):[...n.keys]:[],f=[];if(s&&n){for(const B of n.keys)if(s.keys.indexOf(B)!==-1){const K=m(n.contents,B),ee=m(s.contents,B);y.equals(K,ee)||f.push(B)}}const O=[],j=B=>{const K={};for(const ee of B)for(const ae of ee.identifiers)K[i(ae)]=ee;return K},M=s?j(s.overrides):{},U=n?j(n.overrides):{};if(Object.keys(M).length)for(const B of a){const K=M[B];K&&O.push([(0,T.overrideIdentifierFromKey)(B),K.keys])}if(Object.keys(U).length)for(const B of r){const K=U[B];K&&O.push([(0,T.overrideIdentifierFromKey)(B),K.keys])}if(Object.keys(M).length&&Object.keys(U).length)for(const B of f){const K=U[B],ee=M[B];if(K&&ee){const ae=u({contents:K.contents,keys:K.keys,overrides:[]},{contents:ee.contents,keys:ee.keys,overrides:[]});O.push([(0,T.overrideIdentifierFromKey)(B),[...ae.added,...ae.removed,...ae.updated]])}}return{added:a,removed:r,updated:f,overrides:O}}t.compare=u;function R(n,s){const a=[];for(const r of Object.keys(n))if(T.OVERRIDE_PROPERTY_PATTERN.test(r)){const f={};for(const O in n[r])f[O]=n[r][O];a.push({identifiers:[(0,T.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(f),contents:w(f,s)})}return a}t.toOverrides=R;function w(n,s){const a=Object.create(null);for(let r in n)l(a,r,n[r],s);return a}t.toValuesTree=w;function l(n,s,a,r){const f=s.split("."),O=f.pop();let j=n;for(let M=0;M<f.length;M++){let U=f[M],B=j[U];switch(typeof B){case"undefined":B=j[U]=Object.create(null);break;case"object":break;default:r(`Ignoring ${s} as ${f.slice(0,M+1).join(".")} is ${JSON.stringify(B)}`);return}j=B}if(typeof j=="object"&&j!==null)try{j[O]=a}catch(M){r(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(j)}`)}else r(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(j)}`)}t.addToValueTree=l;function C(n,s){const a=s.split(".");v(n,a)}t.removeFromValueTree=C;function v(n,s){const a=s.shift();if(s.length===0){delete n[a];return}if(Object.keys(n).indexOf(a)!==-1){const r=n[a];typeof r=="object"&&!Array.isArray(r)&&(v(r,s),Object.keys(r).length===0&&delete n[a])}}function m(n,s,a){function r(j,M){let U=j;for(const B of M){if(typeof U!="object"||U===null)return;U=U[B]}return U}const f=s.split("."),O=r(n,f);return typeof O=="undefined"?a:O}t.getConfigurationValue=m;function p(n,s,a){Object.keys(s).forEach(r=>{r!=="__proto__"&&(r in n?A.isObject(n[r])&&A.isObject(s[r])?p(n[r],s[r],a):a&&(n[r]=s[r]):n[r]=s[r])})}t.merge=p;function P(){const n=E.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}t.getConfigurationKeys=P;function o(){const n=Object.create(null),s=E.Registry.as(T.Extensions.Configuration).getConfigurationProperties();for(let a in s){let r=s[a].default;l(n,a,r,f=>console.error(`Conflict in default settings: ${f}`))}return n}t.getDefaultValues=o;function i(n){return`[${n}]`}t.keyFromOverrideIdentifier=i;function e(n,s,a){const r=n.inspect(s),f=n.inspect(a);return typeof r.userValue!="undefined"||typeof r.workspaceValue!="undefined"||typeof r.workspaceFolderValue!="undefined"?r.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:r.defaultValue}t.getMigratedSettingValue=e}),define(Q[102],Y([0,1,56,43,20,8,19,10,29,27,25,2,11]),function(x,t,y,A,F,E,k,T,h,d,b,u,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class w{constructor(e={},n=[],s=[]){this._contents=e,this._keys=n,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,d.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,n){const s=this.getContentsForOverrideIdentifer(n);return s?e?(0,d.getConfigurationValue)(s,e):s:void 0}getKeysForOverrideIdentifier(e){for(const n of this.overrides)if(n.identifiers.indexOf(e)!==-1)return n.keys;return[]}override(e){const n=this.getContentsForOverrideIdentifer(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const a of F.distinct([...Object.keys(this.contents),...Object.keys(n)])){let r=this.contents[a],f=n[a];f&&(typeof r=="object"&&typeof f=="object"?(r=k.deepClone(r),this.mergeContents(r,f)):r=f),s[a]=r}return new w(s,this.keys,this.overrides)}merge(...e){const n=k.deepClone(this.contents),s=k.deepClone(this.overrides),a=[...this.keys];for(const r of e){this.mergeContents(n,r.contents);for(const f of r.overrides){const[O]=s.filter(j=>F.equals(j.identifiers,f.identifiers));O?this.mergeContents(O.contents,f.contents):s.push(k.deepClone(f))}for(const f of r.keys)a.indexOf(f)===-1&&a.push(f)}return new w(n,a,s)}freeze(){return this.isFrozen=!0,this}mergeContents(e,n){for(const s of Object.keys(n)){if(s in e&&E.isObject(e[s])&&E.isObject(n[s])){this.mergeContents(e[s],n[s]);continue}e[s]=k.deepClone(n[s])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?k.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const n of this.overrides)if(n.identifiers.indexOf(e)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,n){this.addKey(e),(0,d.addToValueTree)(this.contents,e,n,s=>{throw new Error(s)})}removeValue(e){this.removeKey(e)&&(0,d.removeFromValueTree)(this.contents,e)}addKey(e){let n=this.keys.length;for(let s=0;s<n;s++)e.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,e)}removeKey(e){let n=this.keys.indexOf(e);return n!==-1?(this.keys.splice(n,1),!0):!1}}t.ConfigurationModel=w;class l extends w{constructor(){const e=(0,d.getDefaultValues)(),n=(0,d.getConfigurationKeys)(),s=[];for(const a of Object.keys(e))h.OVERRIDE_PROPERTY_PATTERN.test(a)&&s.push({identifiers:[(0,h.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(e[a]),contents:(0,d.toValuesTree)(e[a],r=>console.error(`Conflict in default settings file: ${r}`))});super(e,n,s)}}t.DefaultConfigurationModel=l;class C{constructor(e,n){this._name=e,this._scopes=n,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get errors(){return this._parseErrors}parseContent(e){if(!E.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n)}}parseRaw(e){this._raw=e;const n=this.doParseRaw(e);this._configurationModel=new w(n.contents,n.keys,n.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(e){let n={},s=null,a=[],r=[],f=[];function O(M){Array.isArray(a)?a.push(M):s&&(a[s]=M)}let j={onObjectBegin:()=>{let M={};O(M),r.push(a),a=M,s=null},onObjectProperty:M=>{s=M},onObjectEnd:()=>{a=r.pop()},onArrayBegin:()=>{let M=[];O(M),r.push(a),a=M,s=null},onArrayEnd:()=>{a=r.pop()},onLiteralValue:O,onError:(M,U,B)=>{f.push({error:M,offset:U,length:B})}};if(e)try{y.visit(e,j),n=a[0]||{}}catch(M){console.error(`Error while parsing settings file ${this._name}: ${M}`),this._parseErrors=[M]}return n}doParseRaw(e){if(this._scopes){const r=b.Registry.as(h.Extensions.Configuration).getConfigurationProperties();e=this.filterByScope(e,r,!0,this._scopes)}const n=(0,d.toValuesTree)(e,r=>console.error(`Conflict in settings file ${this._name}: ${r}`)),s=Object.keys(e),a=(0,d.toOverrides)(e,r=>console.error(`Conflict in settings file ${this._name}: ${r}`));return{contents:n,keys:s,overrides:a}}filterByScope(e,n,s,a){const r={};for(let f in e)if(h.OVERRIDE_PROPERTY_PATTERN.test(f)&&s)r[f]=this.filterByScope(e[f],n,!1,a);else{const O=this.getScope(f,n);(O===void 0||a.indexOf(O)!==-1)&&(r[f]=e[f])}return r}getScope(e,n){const s=n[e];return s?typeof s.scope!="undefined"?s.scope:3:void 0}}t.ConfigurationModelParser=C;class v extends u.Disposable{constructor(e,n,s,a){super();this.userSettingsResource=e,this.scopes=n,this.fileService=a,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new C(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(R.Event.filter(this.fileService.onDidFilesChange,r=>r.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(e.value.toString()||"{}"),this.parser.configurationModel}catch(e){return new w}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}t.UserSettings=v;class m{constructor(e,n,s=new w,a=new w,r=new A.ResourceMap,f=new w,O=new A.ResourceMap,j=!0){this._defaultConfiguration=e,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=a,this._folderConfigurations=r,this._memoryConfiguration=f,this._memoryConfigurationByResource=O,this._freeze=j,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(e,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(e)}updateValue(e,n,s={}){let a;s.resource?(a=this._memoryConfigurationByResource.get(s.resource),a||(a=new w,this._memoryConfigurationByResource.set(s.resource,a))):a=this._memoryConfiguration,n===void 0?a.removeValue(e):a.setValue(e,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,n,s){const a=this.getConsolidateConfigurationModel(n,s),r=this.getFolderConfigurationModelForResource(n.resource,s),f=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,O=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),j=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),M=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),U=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),B=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,K=r?n.overrideIdentifier?r.freeze().override(n.overrideIdentifier).getValue(e):r.freeze().getValue(e):void 0,ee=n.overrideIdentifier?f.override(n.overrideIdentifier).getValue(e):f.getValue(e),ae=a.getValue(e),re=F.distinct(F.flatten(a.overrides.map(Z=>Z.identifiers))).filter(Z=>a.getOverrideValue(e,Z)!==void 0);return{defaultValue:O,userValue:j,userLocalValue:M,userRemoteValue:U,workspaceValue:B,workspaceFolderValue:K,memoryValue:ee,value:ae,default:O!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,user:j!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userLocal:M!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspace:B!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspaceFolder:K!==void 0?{value:r==null?void 0:r.freeze().getValue(e),override:n.overrideIdentifier?r==null?void 0:r.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,memory:ee!==void 0?{value:f.getValue(e),override:n.overrideIdentifier?f.getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:re.length?re:void 0}}keys(e){const n=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,n){this._folderConfigurations.set(e,n),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,n){const s=n.filter(a=>h.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const r=(0,h.overrideIdentifierFromKey)(a),f=this._defaultConfiguration.getKeysForOverrideIdentifier(r),O=e.getKeysForOverrideIdentifier(r),j=[...O.filter(M=>f.indexOf(M)===-1),...f.filter(M=>O.indexOf(M)===-1),...f.filter(M=>!k.equals(this._defaultConfiguration.override(r).getValue(M),e.override(r).getValue(M)))];return[r,j]});return this.updateDefaultConfiguration(e),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:s,removed:a,overrides:r}=(0,d.compare)(this.localUserConfiguration,e),f=[...n,...s,...a];return f.length&&this.updateLocalUserConfiguration(e),{keys:f,overrides:r}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:s,removed:a,overrides:r}=(0,d.compare)(this.remoteUserConfiguration,e);let f=[...n,...s,...a];return f.length&&this.updateRemoteUserConfiguration(e),{keys:f,overrides:r}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:s,removed:a,overrides:r}=(0,d.compare)(this.workspaceConfiguration,e);let f=[...n,...s,...a];return f.length&&this.updateWorkspaceConfiguration(e),{keys:f,overrides:r}}compareAndUpdateFolderConfiguration(e,n){const s=this.folderConfigurations.get(e),{added:a,updated:r,removed:f,overrides:O}=(0,d.compare)(s,n);let j=[...a,...r,...f];return(j.length||!s)&&this.updateFolderConfiguration(e,n),{keys:j,overrides:O}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:s,updated:a,removed:r,overrides:f}=(0,d.compare)(n,void 0);return{keys:[...s,...a,...r],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,n){let s=this.getConsolidatedConfigurationModelForResource(e,n);return e.overrideIdentifier?s.override(e.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:e},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&e){const a=n.getFolder(e);a&&(s=this.getFolderConsolidatedConfiguration(a.uri)||s);const r=this._memoryConfigurationByResource.get(e);r&&(s=s.merge(r))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let n=this._foldersConsolidatedConfigurations.get(e);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(e);a?(n=s.merge(a),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(e,n)):n=s}return n}getFolderConfigurationModelForResource(e,n){if(n&&e){const s=n.getFolder(e);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,n)=>{const{contents:s,overrides:a,keys:r}=this._folderConfigurations.get(n);return e.push([n,{contents:s,overrides:a,keys:r}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>e.add(n)),this.userConfiguration.freeze().keys.forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>e.add(s))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(e).forEach(a=>n.add(a))),[...n.values()]}static parse(e){const n=this.parseConfigurationModel(e.defaults),s=this.parseConfigurationModel(e.user),a=this.parseConfigurationModel(e.workspace),r=e.folders.reduce((f,O)=>(f.set(T.URI.revive(O[0]),this.parseConfigurationModel(O[1])),f),new A.ResourceMap);return new m(n,s,new w,a,r,new w,new A.ResourceMap,!1)}static parseConfigurationModel(e){return new w(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=m;function p(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const e=new Set,n=new Map;for(const a of i)a.keys.forEach(r=>e.add(r)),a.overrides.forEach(([r,f])=>{const O=(0,A.getOrSet)(n,r,new Set);f.forEach(j=>O.add(j))});const s=[];return n.forEach((a,r)=>s.push([r,[...a.values()]])),{keys:[...e.values()],overrides:s}}t.mergeChanges=p;class P{constructor(e,n,s,a){this.change=e,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=a,this._previousConfiguration=void 0;const r=new Set;e.keys.forEach(O=>r.add(O)),e.overrides.forEach(([,O])=>O.forEach(j=>r.add(j))),this.affectedKeys=[...r.values()];const f=new w;this.affectedKeys.forEach(O=>f.setValue(O,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,n){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(n){const a=this.previousConfiguration?this.previousConfiguration.getValue(e,n,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,r=this.currentConfiguraiton.getValue(e,n,this.currentWorkspace);return!k.equals(a,r)}return!0}return!1}doesAffectedKeysTreeContains(e,n){let s=(0,d.toValuesTree)({[n]:!0},()=>{}),a;for(;typeof s=="object"&&(a=Object.keys(s)[0]);){if(e=e[a],!e)return!1;s=s[a]}return!0}}t.ConfigurationChangeEvent=P;class o extends P{constructor(e,n,s,a){super({keys:e.allKeys(),overrides:[]},void 0,e,n);this.source=s,this.sourceConfig=a}}t.AllKeysConfigurationChangeEvent=o}),define(Q[103],Y([0,1,25,29,2,27,102,11,4,21]),function(x,t,y,A,F,E,k,T,h,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class b extends F.Disposable{constructor(R,w){super();this.settingsResource=R,this._onDidChangeConfiguration=this._register(new T.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new k.UserSettings(this.settingsResource,void 0,d.extUriBiasedIgnorePathCase,w)),this.configuration=new k.Configuration(new k.DefaultConfigurationModel,new k.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new h.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(y.Registry.as(A.Extensions.Configuration).onDidUpdateConfiguration(l=>this.onDidDefaultConfigurationChange(l))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const R=await this.userConfiguration.loadConfiguration();this.configuration=new k.Configuration(new k.DefaultConfigurationModel,R)}getConfigurationData(){return this.configuration.toData()}getValue(R,w){const l=typeof R=="string"?R:void 0,C=(0,E.isConfigurationOverrides)(R)?R:(0,E.isConfigurationOverrides)(w)?w:{};return this.configuration.getValue(l,C,void 0)}updateValue(R,w,l,C){return Promise.reject(new Error("not supported"))}inspect(R){return this.configuration.inspect(R,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const R=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(R)}onDidChangeUserConfiguration(R){const w=this.configuration.toData(),l=this.configuration.compareAndUpdateLocalUserConfiguration(R);this.trigger(l,w,1)}onDidDefaultConfigurationChange(R){const w=this.configuration.toData(),l=this.configuration.compareAndUpdateDefaultConfiguration(new k.DefaultConfigurationModel,R);this.trigger(l,w,6)}trigger(R,w,l){const C=new k.ConfigurationChangeEvent(R,{data:w},this.configuration);C.source=l,C.sourceConfig=this.getTargetConfiguration(l),this._onDidChangeConfiguration.fire(C)}getTargetConfiguration(R){switch(R){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=b}),define(Q[52],Y([0,1,81,7,29,25,16]),function(x,t,y,A,F,E,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,A.createDecorator)("requestService");function T(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}t.isSuccess=T;function h(u){return u.res.statusCode===204}async function d(u){if(!T(u))throw new Error("Server returned "+u.res.statusCode);return h(u)?null:(await(0,k.streamToBuffer)(u.stream)).toString()}t.asText=d;async function b(u){if(!T(u))throw new Error("Server returned "+u.res.statusCode);if(h(u))return null;const w=(await(0,k.streamToBuffer)(u.stream)).toString();try{return JSON.parse(w)}catch(l){throw l.message+=`:
`+w,l}}t.asJson=b,E.Registry.as(F.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:(0,y.localize)(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,y.localize)(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,y.localize)(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,y.localize)(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[(0,y.localize)(4,null),(0,y.localize)(5,null),(0,y.localize)(6,null)],default:"override",description:(0,y.localize)(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:(0,y.localize)(8,null)}}})}),define(Q[104],Y([0,1,105,8]),function(x,t,y,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function F(k){return k.protocol==="http:"?process.env.HTTP_PROXY||process.env.http_proxy||null:k.protocol==="https:"&&(process.env.HTTPS_PROXY||process.env.https_proxy||process.env.HTTP_PROXY||process.env.http_proxy)||null}async function E(k,T={}){const h=(0,y.parse)(k),d=T.proxyUrl||F(h);if(!d)return null;const b=(0,y.parse)(d);if(!/^https?:$/.test(b.protocol||""))return null;const u={host:b.hostname||"",port:b.port||(b.protocol==="https"?"443":"80"),auth:b.auth,rejectUnauthorized:(0,A.isBoolean)(T.strictSSL)?T.strictSSL:!0};return h.protocol==="http:"?new(await new Promise((R,w)=>{x(["http-proxy-agent"],R,w)}))(u):new(await new Promise((R,w)=>{x(["https-proxy-agent"],R,w)}))(u)}t.getProxyAgent=E}),define(Q[106],Y([0,1,38,16]),function(x,t,y,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function F(E,k,T){let h=T&&T.get("storage.serviceMachineId",0)||null;if(h)return h;try{const b=(await k.readFile(E.serviceMachineIdResource)).value.toString();h=(0,y.isUUID)(b)?b:null}catch(d){h=null}if(!h){h=(0,y.generateUuid)();try{await k.writeFile(E.serviceMachineIdResource,A.VSBuffer.fromString(h))}catch(d){}}return T&&T.store("storage.serviceMachineId",h,0,1),h}t.getServiceMachineId=F}),define(Q[107],Y([0,1,7]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IStateService=void 0,t.IStateService=(0,y.createDecorator)("stateService")}),define(Q[108],Y([0,1,3,14,22,12,8,13]),function(x,t,y,A,F,E,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StateService=t.FileStorage=void 0;class h{constructor(u,R){this.dbPath=u,this.onError=R,this._database=null,this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(!this._database){const u=await this.loadAsync();this._database||(this._database=u)}}loadSync(){try{return this.lastFlushedSerializedDatabase=A.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(u){return u.code!=="ENOENT"&&this.onError(u),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await A.promises.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(u){return u.code!=="ENOENT"&&this.onError(u),{}}}getItem(u,R){const w=this.database[u];return(0,k.isUndefinedOrNull)(w)?R:w}setItem(u,R){if((0,k.isUndefinedOrNull)(R))return this.removeItem(u);(typeof R=="string"||typeof R=="number"||typeof R=="boolean")&&this.database[u]===R||(this.database[u]=R,this.saveSync())}removeItem(u){(0,k.isUndefined)(this.database[u])||(this.database[u]=void 0,this.saveSync())}saveSync(){const u=JSON.stringify(this.database,null,4);if(u!==this.lastFlushedSerializedDatabase)try{(0,E.writeFileSync)(this.dbPath,u),this.lastFlushedSerializedDatabase=u}catch(R){this.onError(R)}}}t.FileStorage=h;let d=class Ve{constructor(u,R){this.fileStorage=new h(y.join(u.userDataPath,Ve.STATE_FILE),w=>R.error(w))}init(){return this.fileStorage.init()}getItem(u,R){return this.fileStorage.getItem(u,R)}setItem(u,R){this.fileStorage.setItem(u,R)}removeItem(u){this.fileStorage.removeItem(u)}};d.STATE_FILE="storage.json",d=ce([fe(0,F.INativeEnvironmentService),fe(1,T.ILogService)],d),t.StateService=d}),define(Q[109],Y([0,1,7,11,2,8,64,4]),function(x,t,y,A,F,E,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const h="__$__targetStorageMarker";t.IStorageService=(0,y.createDecorator)("storageService");var d;(function(C){C[C.NONE=0]="NONE",C[C.SHUTDOWN=1]="SHUTDOWN"})(d=t.WillSaveStateReason||(t.WillSaveStateReason={}));var b;(function(C){C[C.GLOBAL=0]="GLOBAL",C[C.WORKSPACE=1]="WORKSPACE"})(b=t.StorageScope||(t.StorageScope={}));var u;(function(C){C[C.USER=0]="USER",C[C.MACHINE=1]="MACHINE"})(u=t.StorageTarget||(t.StorageTarget={}));class R extends F.Disposable{constructor(v={flushInterval:R.DEFAULT_FLUSH_INTERVAL}){super();this.options=v,this._onDidChangeValue=this._register(new A.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new A.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new A.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new F.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,F.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,m){m===h?(v===0?this._globalKeyTargets=void 0:v===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:v})):this._onDidChangeValue.fire({scope:v,key:m,target:this.getKeyTargets(v)[m]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,m,p){var P;return(P=this.getStorage(m))===null||P===void 0?void 0:P.get(v,p)}getBoolean(v,m,p){var P;return(P=this.getStorage(m))===null||P===void 0?void 0:P.getBoolean(v,p)}getNumber(v,m,p){var P;return(P=this.getStorage(m))===null||P===void 0?void 0:P.getNumber(v,p)}store(v,m,p,P){if((0,E.isUndefinedOrNull)(m)){this.remove(v,p);return}this.withPausedEmitters(()=>{var o;this.updateKeyTarget(v,p,P),(o=this.getStorage(p))===null||o===void 0||o.set(v,m)})}remove(v,m){this.withPausedEmitters(()=>{var p;this.updateKeyTarget(v,m,void 0),(p=this.getStorage(m))===null||p===void 0||p.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,m){const p=[],P=this.getKeyTargets(v);for(const o of Object.keys(P))P[o]===m&&p.push(o);return p}updateKeyTarget(v,m,p){var P,o;const i=this.getKeyTargets(m);typeof p=="number"?i[v]!==p&&(i[v]=p,(P=this.getStorage(m))===null||P===void 0||P.set(h,JSON.stringify(i))):typeof i[v]=="number"&&(delete i[v],(o=this.getStorage(m))===null||o===void 0||o.set(h,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(v){return v===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(v){const m=this.get(h,v);if(m)try{return JSON.parse(m)}catch(p){}return Object.create(null)}isNew(v){return this.getBoolean(t.IS_NEW_KEY,v)===!0}async flush(){var v,m,p,P;this._onWillSaveState.fire({reason:d.NONE}),await T.Promises.settled([(m=(v=this.getStorage(0))===null||v===void 0?void 0:v.whenFlushed())!==null&&m!==void 0?m:Promise.resolve(),(P=(p=this.getStorage(1))===null||p===void 0?void 0:p.whenFlushed())!==null&&P!==void 0?P:Promise.resolve()])}async logStorage(){var v,m,p,P,o,i;const e=(m=(v=this.getStorage(0))===null||v===void 0?void 0:v.items)!==null&&m!==void 0?m:new Map,n=(P=(p=this.getStorage(1))===null||p===void 0?void 0:p.items)!==null&&P!==void 0?P:new Map;return l(e,n,(o=this.getLogDetails(0))!==null&&o!==void 0?o:"",(i=this.getLogDetails(1))!==null&&i!==void 0?i:"")}}t.AbstractStorageService=R,R.DEFAULT_FLUSH_INTERVAL=60*1e3;class w extends R{constructor(){super();this.globalStorage=new k.Storage(new k.InMemoryStorageDatabase),this.workspaceStorage=new k.Storage(new k.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.globalStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v)))}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(v){}}t.InMemoryStorageService=w;async function l(C,v,m,p){const P=r=>{try{return JSON.parse(r)}catch(f){return r}},o=new Map,i=new Map;C.forEach((r,f)=>{o.set(f,r),i.set(f,P(r))});const e=new Map,n=new Map;v.forEach((r,f)=>{e.set(f,r),n.set(f,P(r))}),console.group(`Storage: Global (path: ${m})`);let s=[];o.forEach((r,f)=>{s.push({key:f,value:r})}),console.table(s),console.groupEnd(),console.log(i),console.group(`Storage: Workspace (path: ${p})`);let a=[];e.forEach((r,f)=>{a.push({key:f,value:r})}),console.table(a),console.groupEnd(),console.log(n)}t.logStorage=l}),define(Q[110],Y([0,1,17,126,38,10]),function(x,t,y,A,F,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveCommonProperties=void 0;async function k(h,d,b,u,R,w,l,C,v){const m=Object.create(null);m["common.machineId"]=w,m.sessionID=(0,F.generateUuid)()+Date.now(),m.commitHash=u,m.version=R,m["common.platformVersion"]=(d||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,y.PlatformToString)(y.platform),m["common.nodePlatform"]=A.platform,m["common.nodeArch"]=b,m["common.product"]=v||"desktop";const p=T(l||[]);p&&(m["common.msftInternal"]=p);let P=0;const o=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),y.isLinuxSnap&&(m["common.snap"]="true");try{const i=await h.readFile(E.URI.file(C));m["common.source"]=i.value.toString().slice(0,30)}catch(i){}return m}t.resolveCommonProperties=k;function T(h){const d=A.env.USERDNSDOMAIN;if(!d)return!1;const b=d.toLowerCase();return h.some(u=>b===u)}}),define(Q[41],Y([0,1,7]),function(x,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ITelemetryService=void 0,t.ITelemetryService=(0,y.createDecorator)("telemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(Q[111],Y([0,1,15,23,26,19,41,52,47,22,28,13,24,10,40,109,106,7,21]),function(x,t,y,A,F,E,k,T,h,d,b,u,R,w,l,C,v,m,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var P;(function(g){g[g.None=0]="None",g[g.IncludeVersions=1]="IncludeVersions",g[g.IncludeFiles=2]="IncludeFiles",g[g.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",g[g.IncludeSharedAccounts=8]="IncludeSharedAccounts",g[g.IncludeVersionProperties=16]="IncludeVersionProperties",g[g.ExcludeNonValidated=32]="ExcludeNonValidated",g[g.IncludeInstallationTargets=64]="IncludeInstallationTargets",g[g.IncludeAssetUri=128]="IncludeAssetUri",g[g.IncludeStatistics=256]="IncludeStatistics",g[g.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",g[g.Unpublished=4096]="Unpublished"})(P||(P={}));function o(...g){return String(g.reduce((c,I)=>c|I,0))}var i;(function(g){g[g.Tag=1]="Tag",g[g.ExtensionId=4]="ExtensionId",g[g.Category=5]="Category",g[g.ExtensionName=7]="ExtensionName",g[g.Target=8]="Target",g[g.Featured=9]="Featured",g[g.SearchText=10]="SearchText",g[g.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const e={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},n={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:P.None,criteria:[],assetTypes:[]};class r{constructor(c=a){this.state=c}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(c,I=this.state.pageSize){return new r(Object.assign(Object.assign({},this.state),{pageNumber:c,pageSize:I}))}withFilter(c,...I){const D=[...this.state.criteria,...I.length?I.map(N=>({filterType:c,value:N})):[{filterType:c}]];return new r(Object.assign(Object.assign({},this.state),{criteria:D}))}withSortBy(c){return new r(Object.assign(Object.assign({},this.state),{sortBy:c}))}withSortOrder(c){return new r(Object.assign(Object.assign({},this.state),{sortOrder:c}))}withFlags(...c){return new r(Object.assign(Object.assign({},this.state),{flags:c.reduce((I,D)=>I|D,0)}))}withAssetTypes(...c){return new r(Object.assign(Object.assign({},this.state),{assetTypes:c}))}get raw(){const{criteria:c,pageNumber:I,pageSize:D,sortBy:N,sortOrder:z,flags:$,assetTypes:_}=this.state;return{filters:[{criteria:c,pageNumber:I,pageSize:D,sortBy:N,sortOrder:z}],assetTypes:_,flags:$}}get searchText(){const c=this.state.criteria.filter(I=>I.filterType===i.SearchText)[0];return c&&c.value?c.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(c=>String(c.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function f(g,c){const I=(g||[]).filter(D=>D.statisticName===c)[0];return I?I.value:0}function O(g){const c="Microsoft.VisualStudio.Code.Translation.";return g.files.filter(D=>D.assetType.indexOf(c)===0).reduce((D,N)=>{const z=B(g,N.assetType);return z&&D.push([N.assetType.substring(c.length),z]),D},[])}function j(g){if(g.properties){const c=g.properties.filter(N=>N.key===e.Repository),I=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),D=c.filter(N=>I.test(N.value))[0];return D?{uri:D.value,fallbackUri:D.value}:null}return B(g,e.Repository)}function M(g){return{uri:`${g.fallbackAssetUri}/${e.VSIX}?redirect=true`,fallbackUri:`${g.fallbackAssetUri}/${e.VSIX}`}}function U(g){const c=B(g,e.Icon);if(c)return c;const I=A.DefaultIconPath;return{uri:I,fallbackUri:I}}function B(g,c){return g.files.filter(D=>D.assetType===c)[0]?{uri:`${g.assetUri}/${c}`,fallbackUri:`${g.fallbackAssetUri}/${c}`}:null}function K(g,c){const I=g.properties?g.properties.filter(N=>N.key===c):[],D=I.length>0&&I[0].value;return D?D.split(",").map(N=>(0,F.adoptToGalleryExtensionId)(N)):[]}function ee(g){const c=g.properties?g.properties.filter(I=>I.key===n.Engine):[];return c.length>0&&c[0].value||""}function ae(g){const c=g.properties?g.properties.filter(D=>D.key===n.LocalizedLanguages):[],I=c.length>0&&c[0].value||"";return I?I.split(","):[]}function re(g){return g.indexOf("preview")!==-1}function Z(g){const c=g.properties?g.properties.find(I=>I.key===n.WebExtension):void 0;return!!c&&c.value==="true"}function le(g){return g.files.some(c=>c.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,p.joinPath)(w.URI.parse(g.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function W(g,c,I,D,N){const z={manifest:B(c,e.Manifest),readme:B(c,e.Details),changelog:B(c,e.Changelog),license:B(c,e.License),repository:j(c),download:M(c),icon:U(c),coreTranslations:O(c)};return{identifier:{id:(0,F.getGalleryExtensionId)(g.publisher.publisherName,g.extensionName),uuid:g.extensionId},name:g.extensionName,version:c.version,date:c.lastUpdated,displayName:g.displayName,publisherId:g.publisher.publisherId,publisher:g.publisher.publisherName,publisherDisplayName:g.publisher.displayName,description:g.shortDescription||"",installCount:f(g.statistics,"install"),rating:f(g.statistics,"averagerating"),ratingCount:f(g.statistics,"ratingcount"),assetUri:w.URI.parse(c.assetUri),webResource:le(c),assetTypes:c.files.map(({assetType:$})=>$),assets:z,properties:{dependencies:K(c,n.Dependency),extensionPack:K(c,n.ExtensionPack),engine:ee(c),localizedLanguages:ae(c),webExtension:Z(c)},telemetryData:{index:(D.pageNumber-1)*D.pageSize+I,searchText:D.searchText,querySource:N},preview:re(g.flags)}}let L=class{constructor(c,I,D,N,z,$,_){this.requestService=c,this.logService=I,this.environmentService=D,this.telemetryService=N,this.fileService=z,this.productService=$;const q=$.extensionsGallery;this.extensionsGalleryUrl=q&&q.serviceUrl,this.extensionsControlUrl=q&&q.controlUrl,this.commonHeadersPromise=S($.version,this.environmentService,this.fileService,_)}api(c=""){return`${this.extensionsGalleryUrl}${c}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(c,I){const D=[];let{total:N,firstPage:z,getPage:$}=await this.query({names:c,pageSize:c.length},I);D.push(...z);for(let _=1;D.length<N&&(z=await $(_,I),z.length);_++)D.push(...z);return D}async getCompatibleExtension(c,I){const D=await this.getCompatibleExtensionByEngine(c,I);return(D==null?void 0:D.properties.webExtension)?D.webResource?D:null:D}async getCompatibleExtensionByEngine(c,I){const D=(0,A.isIExtensionIdentifier)(c)?null:c;if(D&&D.properties.engine&&(0,h.isEngineValid)(D.properties.engine,this.productService.version))return D;const{id:N,uuid:z}=D?D.identifier:c;let $=new r().withFlags(P.IncludeAssetUri,P.IncludeStatistics,P.IncludeFiles,P.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");z?$=$.withFilter(i.ExtensionId,z):$=$.withFilter(i.ExtensionName,N);const{galleryExtensions:_}=await this.queryGallery($,b.CancellationToken.None),[q]=_;if(!q||!q.versions.length)return null;if(I){const J=q.versions.filter(te=>te.version===I)[0];if(J){const te=W(q,J,0,$);if(te.properties.engine&&(0,h.isEngineValid)(te.properties.engine,this.productService.version))return te}return null}const X=await this.getLastValidExtensionVersion(q,q.versions);return X?W(q,X,0,$):null}async query(c,I){const D=b.CancellationToken.isCancellationToken(c)?{}:c,N=b.CancellationToken.isCancellationToken(c)?c:I;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let z=D.text||"";const $=(0,E.getOrDefault)(D,ne=>ne.pageSize,50);let _=new r().withFlags(P.IncludeLatestVersionOnly,P.IncludeAssetUri,P.IncludeStatistics,P.IncludeFiles,P.IncludeVersionProperties).withPage(1,$).withFilter(i.Target,"Microsoft.VisualStudio.Code");z?(z=z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ne,de,me)=>(_=_.withFilter(i.Category,me||de),"")),z=z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ne,de,me)=>(_=_.withFilter(i.Tag,me||de),"")),z=z.replace(/\bfeatured(\s+|\b|$)/g,()=>(_=_.withFilter(i.Featured),"")),z=z.trim(),z&&(z=z.length<200?z:z.substring(0,200),_=_.withFilter(i.SearchText,z)),_=_.withSortBy(0)):D.ids?_=_.withFilter(i.ExtensionId,...D.ids):D.names?_=_.withFilter(i.ExtensionName,...D.names):_=_.withSortBy(4),typeof D.sortBy=="number"&&(_=_.withSortBy(D.sortBy)),typeof D.sortOrder=="number"&&(_=_.withSortOrder(D.sortOrder));const{galleryExtensions:q,total:X}=await this.queryGallery(_,N),J=q.map((ne,de)=>W(ne,ne.versions[0],de,_,D.source)),te=async(ne,de)=>{if(de.isCancellationRequested)throw(0,y.canceled)();const me=_.withPage(ne+1),{galleryExtensions:Ie}=await this.queryGallery(me,de);return Ie.map((Le,Fe)=>W(Le,Le.versions[0],Fe,me,D.source))};return{firstPage:J,total:X,pageSize:_.pageSize,getPage:te}}async queryGallery(c,I){if(!this.isEnabled())throw new Error("No extension gallery service configured.");c=c.withFlags(c.flags,P.ExcludeNonValidated).withFilter(i.ExcludeWithFlags,o(P.Unpublished));const D=await this.commonHeadersPromise,N=JSON.stringify(c.raw),z=Object.assign(Object.assign({},D),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(N.length)}),$=new Date().getTime();let _,q,X=0;try{if(_=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:N,headers:z},I),_.res.statusCode&&_.res.statusCode>=400&&_.res.statusCode<500)return{galleryExtensions:[],total:X};const J=await(0,T.asJson)(_);if(J){const te=J.results[0],ne=te.extensions,de=te.resultMetadata&&te.resultMetadata.filter(me=>me.metadataType==="ResultCount")[0];return X=de&&de.metadataItems.filter(me=>me.name==="TotalCount")[0].count||0,{galleryExtensions:ne,total:X}}return{galleryExtensions:[],total:X}}catch(J){throw q=J,J}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},c.telemetryData),{requestBodySize:String(N.length),duration:new Date().getTime()-$,success:!!_&&(0,T.isSuccess)(_),responseBodySize:_==null?void 0:_.res.headers["Content-Length"],statusCode:_?String(_.res.statusCode):void 0,errorCode:q?(0,y.isPromiseCanceledError)(q)?"canceled":(0,y.getErrorMessage)(q).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(X)}))}}async reportStatistic(c,I,D,N){if(!!this.isEnabled()){const z=await this.commonHeadersPromise,$=Object.assign(Object.assign({},z),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${c}/extensions/${I}/${D}/stats?statType=${N}`),headers:$},b.CancellationToken.None)}catch(_){}}}async download(c,I,D){this.logService.trace("ExtensionGalleryService#download",c.identifier.id);const N=(0,F.getGalleryExtensionTelemetryData)(c),z=new Date().getTime(),$=J=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},N),{duration:J})),_=D===1?"install":D===2?"update":"",q=_?{uri:`${c.assets.download.uri}&${_}=true`,fallbackUri:`${c.assets.download.fallbackUri}?${_}=true`}:c.assets.download,X=await this.getAsset(q);await this.fileService.writeFile(I,X.stream),$(new Date().getTime()-z)}async getReadme(c,I){if(c.assets.readme){const D=await this.getAsset(c.assets.readme,{},I);return await(0,T.asText)(D)||""}return""}async getManifest(c,I){if(c.assets.manifest){const D=await this.getAsset(c.assets.manifest,{},I),N=await(0,T.asText)(D);return N?JSON.parse(N):null}return null}async getCoreTranslation(c,I){const D=c.assets.coreTranslations.filter(N=>N[0]===I.toUpperCase())[0];if(D){const N=await this.getAsset(D[1]),z=await(0,T.asText)(N);return z?JSON.parse(z):null}return null}async getChangelog(c,I){if(c.assets.changelog){const D=await this.getAsset(c.assets.changelog,{},I);return await(0,T.asText)(D)||""}return""}async getAllVersions(c,I){let D=new r().withFlags(P.IncludeVersions,P.IncludeFiles,P.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");c.identifier.uuid?D=D.withFilter(i.ExtensionId,c.identifier.uuid):D=D.withFilter(i.ExtensionName,c.identifier.id);const N=[],{galleryExtensions:z}=await this.queryGallery(D,b.CancellationToken.None);return z.length&&(I?await Promise.all(z[0].versions.map(async $=>{let _;try{_=await this.getEngine($)}catch(q){}_&&(0,h.isEngineValid)(_,this.productService.version)&&N.push({version:$.version,date:$.lastUpdated})})):N.push(...z[0].versions.map($=>({version:$.version,date:$.lastUpdated})))),N}async getAsset(c,I={},D=b.CancellationToken.None){const N=await this.commonHeadersPromise,z={type:"GET"},$=Object.assign(Object.assign({},N),I.headers||{});I=Object.assign(Object.assign(Object.assign({},I),z),{headers:$});const _=c.uri,q=c.fallbackUri,X=Object.assign(Object.assign({},I),{url:_});try{const J=await this.requestService.request(X,D);if(J.res.statusCode===200)return J;const te=await(0,T.asText)(J);throw new Error(`Expected 200, got back ${J.res.statusCode} instead.

${te}`)}catch(J){if((0,y.isPromiseCanceledError)(J))throw J;const te=(0,y.getErrorMessage)(J);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:_,message:te});const ne=Object.assign(Object.assign({},I),{url:q});return this.requestService.request(ne,D)}}async getLastValidExtensionVersion(c,I){const D=this.getLastValidExtensionVersionFromProperties(c,I);return D||this.getLastValidExtensionVersionRecursively(c,I)}getLastValidExtensionVersionFromProperties(c,I){for(const D of I){const N=ee(D);if(!N)return null;if((0,h.isEngineValid)(N,this.productService.version))return D}return null}async getEngine(c){const I=ee(c);if(I)return I;const D=B(c,e.Manifest);if(!D)throw new Error("Manifest was not found");const N={"Accept-Encoding":"gzip"},z=await this.getAsset(D,{headers:N}),$=await(0,T.asJson)(z);if($)return $.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(c,I){if(!I.length)return null;const D=I[0],N=await this.getEngine(D);return(0,h.isEngineValid)(N,this.productService.version)?(D.properties=D.properties||[],D.properties.push({key:n.Engine,value:N}),D):this.getLastValidExtensionVersionRecursively(c,I.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const c=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},b.CancellationToken.None);if(c.res.statusCode!==200)throw new Error("Could not get extensions report.");const I=await(0,T.asJson)(c),D=new Map;if(I)for(const N of I.malicious){const z=D.get(N)||{id:{id:N},malicious:!0,slow:!1};z.malicious=!0,D.set(N,z)}return[...D.values()]}};L=ce([fe(0,T.IRequestService),fe(1,u.ILogService),fe(2,d.IEnvironmentService),fe(3,k.ITelemetryService),fe(4,R.IFileService),fe(5,l.IProductService),fe(6,(0,m.optional)(C.IStorageService))],L),t.ExtensionGalleryService=L;async function S(g,c,I,D){const N={"X-Market-Client-Id":`VSCode ${g}`,"User-Agent":`VSCode ${g}`},z=await(0,v.getServiceMachineId)(c,I,D);return N["X-Market-User-Id"]=z,N}t.resolveMarketplaceHeaders=S}),define(Q[112],Y([0,1,39,82,18,7,27,29,2,19,25]),function(x,t,y,A,F,E,k,T,h,d,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let u=class{constructor(l,C){this._configurationService=C,this._experimentProperties={},this._disposables=new h.DisposableStore,this._cleanupPatterns=[],this._appender=l.appender,this._commonProperties=l.commonProperties||Promise.resolve({}),this._piiPaths=l.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!l.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let v of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,F.escapeRegExpCharacters)(v),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(v=>{const m=/^[a-f0-9]+$/i.test(v["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!m})}))}setExperimentProperty(l,C){this._experimentProperties[l]=C}setEnabled(l){this._enabled=l}_updateUserOptIn(){var l;const C=(l=this._configurationService)===null||l===void 0?void 0:l.getValue(R);this._userOptIn=C?C.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const l=await this._commonProperties;let C=l.sessionID,v=l["common.instanceId"],m=l["common.machineId"],p=l["common.firstSessionDate"],P=l["common.msftInternal"];return{sessionId:C,instanceId:v,machineId:m,firstSessionDate:p,msftInternal:P}}dispose(){this._disposables.dispose()}publicLog(l,C,v){return this.isOptedIn?this._commonProperties.then(m=>{C=(0,d.mixin)(C,m),C=(0,d.mixin)(C,this._experimentProperties),C=(0,d.cloneAndChange)(C,p=>{if(typeof p=="string")return this._cleanupInfo(p,v)}),this._appender.log(l,C)},m=>{console.error(m)}):Promise.resolve(void 0)}publicLog2(l,C,v){return this.publicLog(l,C,v)}publicLogError(l,C){return this.sendErrorTelemetry?this.publicLog(l,C,!0):Promise.resolve(void 0)}publicLogError2(l,C){return this.publicLogError(l,C)}_cleanupInfo(l,C){let v=l;if(C){const m=[];for(let i of this._cleanupPatterns)for(;;){const e=i.exec(l);if(!e)break;m.push([e.index,i.lastIndex])}const p=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,P=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(v="";;){const i=P.exec(l);if(!i)break;!p.test(i[0])&&m.every(([e,n])=>i.index<e||i.index>=n)&&(v+=l.substring(o,i.index)+"<REDACTED: user-file-path>",o=P.lastIndex)}o<l.length&&(v+=l.substr(o))}for(let m of this._cleanupPatterns)v=v.replace(m,"");return v}};u.IDLE_START_EVENT_NAME="UserIdleStart",u.IDLE_STOP_EVENT_NAME="UserIdleStop",u=ce([fe(1,(0,E.optional)(k.IConfigurationService))],u),t.TelemetryService=u;const R="telemetry";b.Registry.as(T.Extensions.Configuration).registerConfiguration({id:R,order:110,type:"object",title:(0,A.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:y.default.privacyStatementUrl?(0,A.localize)(2,null,y.default.privacyStatementUrl):(0,A.localize)(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(Q[53],Y([0,1,27,19,8,4]),function(x,t,y,A,F,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(w,l){return Promise.resolve(void 0)}publicLog2(w,l){return this.publicLog(w,l)}publicLogError(w,l){return Promise.resolve(void 0)}publicLogError2(w,l){return this.publicLogError(w,l)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};function k(...w){return{log:(l,C)=>w.forEach(v=>v.log(l,C)),flush:()=>E.Promises.settled(w.map(l=>l.flush()))}}t.combinedAppender=k,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function T(w,l){return l.onDidChangeConfiguration(C=>{C.source!==6&&w.publicLog2("updateConfiguration",{configurationSource:(0,y.ConfigurationTargetToString)(C.source),configurationKeys:u(C.sourceConfig)})})}t.configurationTelemetry=T;function h(w){const l=Object.create(null),C=Object.create(null),v=Object.create(null);b(w,v);for(let m in v){m=m.length>150?m.substr(m.length-149):m;const p=v[m];typeof p=="number"?C[m]=p:typeof p=="boolean"?C[m]=p?1:0:typeof p=="string"?l[m]=p.substring(0,1023):typeof p!="undefined"&&p!==null&&(l[m]=p)}return{properties:l,measurements:C}}t.validateTelemetryData=h;function d(w){if(!w)return"none";let l="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(v=>{w.indexOf(`${v}+`)===0&&(l=v)}),l}t.cleanRemoteAuthority=d;function b(w,l,C=0,v){if(!!w)for(let m of Object.getOwnPropertyNames(w)){const p=w[m],P=v?v+m:m;Array.isArray(p)?l[P]=(0,A.safeStringify)(p):p instanceof Date?l[P]=p.toISOString():(0,F.isObject)(p)?C<2?b(p,l,C+1,P+"."):l[P]=(0,A.safeStringify)(p):l[P]=p}}function u(w){if(!w)return[];const l=[];return R(l,"",w),l}function R(w,l,C){C&&typeof C=="object"&&!Array.isArray(C)?Object.keys(C).forEach(v=>R(w,l?`${l}.${v}`:v,C[v])):w.push(l)}}),define(Q[113],Y([0,1,15,19,53]),function(x,t,y,A,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function E(T){const h=await new Promise((b,u)=>{x(["applicationinsights"],b,u)});let d;return h.defaultClient?(d=new h.TelemetryClient(T),d.channel.setUseDiskRetryCaching(!0)):(h.setup(T).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),d=h.defaultClient),T.indexOf("AIF-")===0&&(d.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),d}class k{constructor(h,d,b){this._eventPrefix=h,this._defaultData=d,this._defaultData||(this._defaultData=Object.create(null)),typeof b=="function"?this._aiClient=b():this._aiClient=b,this._asyncAIClient=null}_withAIClient(h){if(!!this._aiClient){if(typeof this._aiClient!="string"){h(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=E(this._aiClient)),this._asyncAIClient.then(d=>{h(d)},d=>{(0,y.onUnexpectedError)(d),console.error(d)})}}log(h,d){!this._aiClient||(d=(0,A.mixin)(d,this._defaultData),d=(0,F.validateTelemetryData)(d),this._withAIClient(b=>b.trackEvent({name:this._eventPrefix+"/"+h,properties:d.properties,measurements:d.measurements})))}flush(){return this._aiClient?new Promise(h=>{this._withAIClient(d=>{d.flush({callback:()=>{this._aiClient=void 0,h(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=k}),define(Q[114],Y([0,1,12,14,3]),function(x,t,y,A,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;function E(k,T){const h=Object.create(null),d=(u,R)=>{const w=JSON.parse(u);h[R]=w};if(T){const u=(0,y.readdirSync)(T).filter(w=>{try{return(0,A.statSync)((0,F.join)(T,w)).isDirectory()}catch(l){return!1}}),R=[];u.forEach(w=>{(0,y.readdirSync)((0,F.join)(T,w)).filter(C=>C==="telemetry.json").length===1&&R.push(w)}),R.forEach(w=>{const l=(0,A.readFileSync)((0,F.join)(T,w,"telemetry.json")).toString();d(l,w)})}let b=(0,A.readFileSync)((0,F.join)(k,"telemetry-core.json")).toString();return d(b,"vscode-core"),b=(0,A.readFileSync)((0,F.join)(k,"telemetry-extensions.json")).toString(),d(b,"vscode-extensions"),JSON.stringify(h,null,4)}t.buildTelemetryMessage=E}),define(Q[42],Y([0,1,70,3,14,4,12,127,128,8]),function(x,t,y,A,F,E,k,T,h,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class b extends Error{constructor(e,n){let s=n.message;switch(e){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s);this.type=e,this.cause=n}}t.ExtractError=b;function u(i){const e=i.externalFileAttributes>>16||33188;return[448,56,7].map(n=>e&n).reduce((n,s)=>n+s,e&61440)}function R(i){if(i instanceof b)return i;let e;return/end of central directory record signature not found/.test(i.message)&&(e="CorruptZip"),new b(e,i)}function w(i,e,n,s,a,r){const f=A.dirname(e),O=A.join(s,f);if(!O.startsWith(s))return Promise.reject(new Error(y.localize(0,null,e)));const j=A.join(s,e);let M;return r.onCancellationRequested(()=>{M&&M.destroy()}),Promise.resolve(F.promises.mkdir(O,{recursive:!0})).then(()=>new Promise((U,B)=>{if(!r.isCancellationRequested)try{M=(0,F.createWriteStream)(j,{mode:n}),M.once("close",()=>U()),M.once("error",B),i.once("error",B),i.pipe(M)}catch(K){B(K)}}))}function l(i,e,n,s){let a=(0,E.createCancelablePromise)(()=>Promise.resolve()),r=0;return s.onCancellationRequested(()=>{a.cancel(),i.close()}),new Promise((f,O)=>{const j=new E.Sequencer,M=U=>{U.isCancellationRequested||(r++,i.readEntry())};i.once("error",O),i.once("close",()=>a.then(()=>{s.isCancellationRequested||i.entryCount===r?f():O(new b("Incomplete",new Error(y.localize(1,null,r,i.entryCount))))},O)),i.readEntry(),i.on("entry",U=>{if(!s.isCancellationRequested){if(!n.sourcePathRegex.test(U.fileName)){M(s);return}const B=U.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(B)){const ae=A.join(e,B);a=(0,E.createCancelablePromise)(re=>F.promises.mkdir(ae,{recursive:!0}).then(()=>M(re)).then(void 0,O));return}const K=v(i,U),ee=u(U);a=(0,E.createCancelablePromise)(ae=>j.queue(()=>K.then(re=>w(re,B,ee,e,n,ae).then(()=>M(ae)))).then(null,O))}})})}function C(i,e=!1){return new Promise((n,s)=>{(0,T.open)(i,e?{lazyEntries:!0}:void 0,(a,r)=>{a?s(R(a)):n((0,d.assertIsDefined)(r))})})}function v(i,e){return new Promise((n,s)=>{i.openReadStream(e,(a,r)=>{a?s(R(a)):n((0,d.assertIsDefined)(r))})})}function m(i,e){return new Promise((n,s)=>{const a=new h.ZipFile;e.forEach(f=>{f.contents?a.addBuffer(typeof f.contents=="string"?Buffer.from(f.contents,"utf8"):f.contents,f.path):f.localPath&&a.addFile(f.localPath,f.path)}),a.end();const r=(0,F.createWriteStream)(i);a.outputStream.pipe(r),a.outputStream.once("error",s),r.once("error",s),r.once("finish",()=>n(i))})}t.zip=m;function p(i,e,n={},s){const a=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let r=C(i,!0);return n.overwrite&&(r=r.then(f=>(0,k.rimraf)(e).then(()=>f))),r.then(f=>l(f,e,{sourcePathRegex:a},s))}t.extract=p;function P(i,e){return C(i).then(n=>new Promise((s,a)=>{n.on("entry",r=>{r.fileName===e&&v(n,r).then(f=>s(f),f=>a(f))}),n.once("close",()=>a(new Error(y.localize(2,null,e))))}))}function o(i,e){return P(i,e).then(n=>new Promise((s,a)=>{const r=[];n.once("error",a),n.on("data",f=>r.push(f)),n.on("end",()=>s(Buffer.concat(r)))}))}t.buffer=o}),define(Q[115],Y([0,1,42,75]),function(x,t,y,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function F(E){return(0,y.buffer)(E,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch(T){throw new Error((0,A.localize)(0,null))}})}t.getManifest=F}),define(Q[116],Y([0,1,14,37,2,12,3,13,23,26,4,10,22,83,76,40,42,17,20,9]),function(x,t,y,A,F,E,k,T,h,d,b,u,R,w,l,C,v,m,p,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const o="scanningSystem",i="scanningUser",e="extracting",n="deleting",s="renaming";let a=class extends F.Disposable{constructor(f,O,j,M){super();this.beforeRemovingExtension=f,this.logService=O,this.environmentService=j,this.productService=M,this._devSystemExtensionsPath=null,this.systemExtensionsPath=j.builtinExtensionsPath,this.extensionsPath=j.extensionsPath,this.uninstalledPath=k.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new b.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(f){const O=[];(f===null||f===0)&&O.push(this.scanSystemExtensions().then(null,j=>Promise.reject(new h.ExtensionManagementError(this.joinErrors(j).message,o)))),(f===null||f===1)&&O.push(this.scanUserExtensions(!0).then(null,j=>Promise.reject(new h.ExtensionManagementError(this.joinErrors(j).message,i))));try{const j=await Promise.all(O);return(0,p.flatten)(j)}catch(j){throw this.joinErrors(j)}}async scanUserExtensions(f){this.logService.trace("Started scanning user extensions");let[O,j]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return j=j.filter(M=>!O[new d.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version).key()]),f&&(j=(0,d.groupByExtension)(j,U=>U.identifier).map(U=>U.sort((B,K)=>A.rcompare(B.manifest.version,K.manifest.version))[0])),this.logService.trace("Scanned user extensions:",j.length),j}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(f,O,j){const M=f.key(),U=k.join(this.extensionsPath,`.${M}`),B=k.join(this.extensionsPath,M);try{await E.rimraf(B)}catch(ee){try{await E.rimraf(B)}catch(ae){}throw new h.ExtensionManagementError((0,l.localize)(0,null,B,f.id),n)}await this.extractAtLocation(f,O,U,j);try{await this.rename(f,U,B,Date.now()+2*60*1e3),this.logService.info("Renamed to",B)}catch(ee){this.logService.info("Rename failed. Deleting from extracted location",U);try{E.rimraf(U)}catch(ae){}throw ee}let K=null;try{K=await this.scanExtension(M,this.extensionsPath,1)}catch(ee){}if(K)return K;throw new Error((0,l.localize)(1,null,this.extensionsPath))}async saveMetadataForLocalExtension(f,O){this.setMetadata(f,O),O.isMachineScoped=O.isMachineScoped||void 0,O.isBuiltin=O.isBuiltin||void 0;const j=k.join(f.location.fsPath,"package.json"),M=await y.promises.readFile(j,"utf8"),{manifest:U}=await this.parseManifest(M);return U.__metadata=O,await E.writeFile(j,JSON.stringify(U,null,"	")),f}getUninstalledExtensions(){return this.withUninstalledExtensions(f=>f)}async withUninstalledExtensions(f){return this.uninstalledFileLimiter.queue(async()=>{let O;try{O=await y.promises.readFile(this.uninstalledPath,"utf8")}catch(U){if(U.code!=="ENOENT")throw U}let j={};if(O)try{j=JSON.parse(O)}catch(U){}const M=f(j);return Object.keys(j).length?await E.writeFile(this.uninstalledPath,JSON.stringify(j)):await E.rimraf(this.uninstalledPath),M})}async removeExtension(f,O){this.logService.trace(`Deleting ${O} extension from disk`,f.identifier.id,f.location.fsPath),await E.rimraf(f.location.fsPath),this.logService.info("Deleted from disk",f.identifier.id,f.location.fsPath)}async removeUninstalledExtension(f){await this.removeExtension(f,"uninstalled"),await this.withUninstalledExtensions(O=>delete O[new d.ExtensionIdentifierWithVersion(f.identifier,f.manifest.version).key()])}async extractAtLocation(f,O,j,M){this.logService.trace(`Started extracting the extension from ${O} to ${j}`);try{await E.rimraf(j)}catch(U){throw new h.ExtensionManagementError(this.joinErrors(U).message,n)}try{await(0,v.extract)(O,j,{sourcePath:"extension",overwrite:!0},M),this.logService.info(`Extracted extension to ${j}:`,f.id)}catch(U){try{await E.rimraf(j)}catch(B){}throw new h.ExtensionManagementError(U.message,U instanceof v.ExtractError&&U.type?U.type:e)}}async rename(f,O,j,M){try{await y.promises.rename(O,j)}catch(U){if(m.isWindows&&U&&U.code==="EPERM"&&Date.now()<M)return this.logService.info(`Failed renaming ${O} to ${j} with 'EPERM' error. Trying again...`,f.id),this.rename(f,O,j,M);throw new h.ExtensionManagementError(U.message||(0,l.localize)(2,null,O,j),U.code||s)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const f=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return f;const O=this.scanDevSystemExtensions(),[j,M]=await Promise.all([f,O]);return[...j,...M]}async scanExtensionsInDir(f,O){const j=new b.Limiter(10),M=await E.readdir(f);return(await Promise.all(M.map(B=>j.queue(()=>this.scanExtension(B,f,O))))).filter(B=>B&&B.identifier)}async scanExtension(f,O,j){if(j===1&&f.indexOf(".")===0)return null;const M=k.join(O,f);try{const U=await E.readdir(M),{manifest:B,metadata:K}=await this.readManifest(M),ee=U.filter(L=>/^readme(\.txt|\.md|)$/i.test(L))[0],ae=ee?u.URI.file(k.join(M,ee)):void 0,re=U.filter(L=>/^changelog(\.txt|\.md|)$/i.test(L))[0],Z=re?u.URI.file(k.join(M,re)):void 0,le={id:(0,d.getGalleryExtensionId)(B.publisher,B.name)},W={type:j,identifier:le,manifest:B,location:u.URI.file(M),readmeUrl:ae,changelogUrl:Z,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:j===0};return K&&this.setMetadata(W,K),W}catch(U){return this.logService.trace(U),null}}async scanDefaultSystemExtensions(){const f=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",f.length),f}async scanDevSystemExtensions(){const f=this.getDevSystemExtensionsList();if(f.length){const O=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",O.length),O.filter(j=>f.some(M=>(0,d.areSameExtensions)(j.identifier,{id:M})))}else return[]}setMetadata(f,O){f.publisherDisplayName=O.publisherDisplayName||null,f.publisherId=O.publisherId||null,f.identifier.uuid=O.id,f.isMachineScoped=!!O.isMachineScoped,f.isBuiltin=f.type===0||!!O.isBuiltin}async removeUninstalledExtensions(){const f=await this.getUninstalledExtensions(),O=await this.scanAllUserExtensions(),j=new Set;for(const B of O)f[new d.ExtensionIdentifierWithVersion(B.identifier,B.manifest.version).key()]||j.add(B.identifier.id.toLowerCase());const M=(0,d.groupByExtension)(O,B=>B.identifier);await b.Promises.settled(M.map(async B=>{const K=B.sort((ee,ae)=>A.rcompare(ee.manifest.version,ae.manifest.version))[0];j.has(K.identifier.id.toLowerCase())||await this.beforeRemovingExtension(K)}));const U=O.filter(B=>f[new d.ExtensionIdentifierWithVersion(B.identifier,B.manifest.version).key()]);await b.Promises.settled(U.map(B=>this.removeUninstalledExtension(B)))}async removeOutdatedExtensions(){const f=await this.scanAllUserExtensions(),O=[],j=(0,d.groupByExtension)(f,M=>M.identifier);O.push(...(0,p.flatten)(j.map(M=>M.sort((U,B)=>A.rcompare(U.manifest.version,B.manifest.version)).slice(1)))),await b.Promises.settled(O.map(M=>this.removeExtension(M,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(f=>f.name)}joinErrors(f){const O=Array.isArray(f)?f:[f];return O.length===1?O[0]instanceof Error?O[0]:new Error(O[0]):O.reduce((j,M)=>new Error(`${j.message}${j.message?",":""}${M instanceof Error?M.message:M}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=k.normalize(k.join(P.FileAccess.asFileUri("",x).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(f){const O=[y.promises.readFile(k.join(f,"package.json"),"utf8").then(B=>this.parseManifest(B)),y.promises.readFile(k.join(f,"package.nls.json"),"utf8").then(void 0,B=>B.code!=="ENOENT"?Promise.reject(B):"{}").then(B=>JSON.parse(B))],[{manifest:j,metadata:M},U]=await Promise.all(O);return{manifest:(0,w.localizeManifest)(j,U),metadata:M}}parseManifest(f){return new Promise((O,j)=>{try{const M=JSON.parse(f),U=M.__metadata||null;O({manifest:M,metadata:U})}catch(M){j(new Error((0,l.localize)(3,null)))}})}};a=ce([fe(1,T.ILogService),fe(2,R.INativeEnvironmentService),fe(3,C.IProductService)],a),t.ExtensionsScanner=a}),define(Q[117],Y([0,1,14,74,3,12,2,20,42,23,26,22,4,11,37,10,39,17,13,90,30,41,47,21,38,89,7,9,28,115,94,116,95]),function(x,t,y,A,F,E,k,T,h,d,b,u,R,w,l,C,v,m,p,P,o,i,e,n,s,a,r,f,O,j,M,U,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const K="unsetUninstalled",ee="downloading",ae="validating",re="local",Z="unknown";let le=class extends k.Disposable{constructor(L,S,g,c,I,D){super();this.environmentService=L,this.galleryService=S,this.logService=g,this.downloadService=c,this.telemetryService=I,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new w.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new w.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new w.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new w.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const N=this._register(D.createInstance(B.ExtensionsLifecycle));this.extensionsScanner=this._register(D.createInstance(U.ExtensionsScanner,z=>N.postUninstall(z))),this.manifestCache=this._register(new P.ExtensionsManifestCache(L,this)),this.extensionsDownloader=this._register(D.createInstance(M.ExtensionsDownloader)),this._register((0,k.toDisposable)(()=>{this.installingExtensions.forEach(z=>z.cancel()),this.uninstallingExtensions.forEach(z=>z.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(L){this.logService.trace("ExtensionManagementService#zip",L.identifier.id);const S=await this.collectFiles(L),g=await(0,h.zip)((0,n.joinPath)(this.environmentService.tmpDir,(0,s.generateUuid)()).fsPath,S);return C.URI.file(g)}async unzip(L){return this.logService.trace("ExtensionManagementService#unzip",L.toString()),(await this.install(L)).identifier}async getManifest(L){const S=await this.downloadVsix(L),g=F.resolve(S.fsPath);return(0,j.getManifest)(g)}async collectFiles(L){const S=async c=>{let I=await E.readdir(c);I=I.map(z=>F.join(c,z));const D=await Promise.all(I.map(z=>y.promises.stat(z)));let N=Promise.resolve([]);return D.forEach((z,$)=>{const _=I[$];z.isFile()&&(N=N.then(q=>[...q,_])),z.isDirectory()&&(N=N.then(q=>S(_).then(X=>[...q,...X])))}),N};return(await S(L.location.fsPath)).map(c=>({path:`extension/${F.relative(L.location.fsPath,c)}`,localPath:c}))}async install(L,S={}){return this.logService.trace("ExtensionManagementService#install",L.toString()),(0,R.createCancelablePromise)(async g=>{const c=await this.downloadVsix(L),I=F.resolve(c.fsPath),D=await(0,j.getManifest)(I),N={id:(0,b.getGalleryExtensionId)(D.publisher,D.name)};let z=1;if(D.engines&&D.engines.vscode&&!(0,e.isEngineValid)(D.engines.vscode,v.default.version))throw new Error(A.localize(0,null,N.id,v.default.version));const $=new b.ExtensionIdentifierWithVersion(N,D.version),q=(await this.getInstalled(1)).find(J=>(0,b.areSameExtensions)(N,J.identifier));if(q)if(S.isMachineScoped=S.isMachineScoped||q.isMachineScoped,S.isBuiltin=S.isBuiltin||q.isBuiltin,z=2,$.equals(new b.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version)))try{await this.extensionsScanner.removeExtension(q,"existing")}catch(J){throw new Error(A.localize(1,null,D.displayName||D.name))}else l.gt(q.manifest.version,D.version)&&await this.uninstallExtension(q);else{const J=await this.unsetUninstalledAndGetLocal($);if(J)try{await this.extensionsScanner.removeExtension(J,"existing")}catch(te){throw new Error(A.localize(2,null,D.displayName||D.name))}}this.logService.info("Installing the extension:",N.id),this._onInstallExtension.fire({identifier:N,zipPath:I});let X;try{X=await this.getGalleryMetadata((0,b.getGalleryExtensionId)(D.publisher,D.name))}catch(J){}try{const J=await this.installFromZipPath($,I,Object.assign(Object.assign({},X||{}),S),S,z,g);return this.logService.info("Successfully installed the extension:",N.id),J}catch(J){throw this.logService.error("Failed to install the extension:",N.id,J.message),J}})}async downloadVsix(L){if(L.scheme===f.Schemas.file)return L;if(!this.downloadService)throw new Error("Download service is not available");const S=(0,n.joinPath)(this.environmentService.tmpDir,(0,s.generateUuid)());return await this.downloadService.download(L,S),S}async installFromZipPath(L,S,g,c,I,D){try{const N=await this.installExtension({zipPath:S,identifierWithVersion:L,metadata:g},D);try{await this.installDependenciesAndPackExtensions(N,void 0,c)}catch(z){(0,T.isNonEmptyArray)(N.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",N.identifier.id,z.message),(0,T.isNonEmptyArray)(N.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",N.identifier.id,z.message)}return this._onDidInstallExtension.fire({identifier:L,zipPath:S,local:N,operation:I}),N}catch(N){throw this._onDidInstallExtension.fire({identifier:L,zipPath:S,operation:I,error:N}),N}}async canInstall(L){return!0}async installFromGallery(L,S={}){if(!this.galleryService.isEnabled())throw new Error(A.localize(3,null));try{L=await this.checkAndGetCompatibleVersion(L)}catch(I){const D=I&&I.code?I.code:Z;throw this.logService.error("Failed to install extension:",L.identifier.id,I?I.message:D),this.reportTelemetry(this.getTelemetryEvent(1),(0,b.getGalleryExtensionTelemetryData)(L),void 0,I),I instanceof Error&&(I.name=D),I}const g=new b.ExtensionIdentifierWithVersion(L.identifier,L.version).key();let c=this.installingExtensions.get(g);return c||(c=(0,R.createCancelablePromise)(I=>this.doInstallFromGallery(L,S,I)),this.installingExtensions.set(g,c),c.finally(()=>this.installingExtensions.delete(g))),c}async doInstallFromGallery(L,S,g){const c=new Date().getTime();let I=1;this.logService.info("Installing extension:",L.identifier.id),this._onInstallExtension.fire({identifier:L.identifier,gallery:L});try{const N=(await this.getInstalled(1)).find(_=>(0,b.areSameExtensions)(_.identifier,L.identifier));N&&(I=2);const z=await this.downloadInstallableExtension(L,I);z.metadata.isMachineScoped=S.isMachineScoped||(N==null?void 0:N.isMachineScoped),z.metadata.isBuiltin=S.isBuiltin||(N==null?void 0:N.isBuiltin);const $=await this.installExtension(z,g);try{await this.extensionsDownloader.delete(C.URI.file(z.zipPath))}catch(_){}if(!S.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions($,N,S)}catch(_){try{await this.uninstall($)}catch(q){}throw _}return N&&l.neq(N.manifest.version,L.version)&&await this.setUninstalled(N),this.logService.info("Extensions installed successfully:",L.identifier.id),this._onDidInstallExtension.fire({identifier:L.identifier,gallery:L,local:$,operation:I}),this.reportTelemetry(this.getTelemetryEvent(I),(0,b.getGalleryExtensionTelemetryData)(L),new Date().getTime()-c,void 0),$}catch(D){const N=D&&D.code?D.code:Z;throw this.logService.error("Failed to install extension:",L.identifier.id,D?D.message:N),this._onDidInstallExtension.fire({identifier:L.identifier,gallery:L,operation:I,error:N}),this.reportTelemetry(this.getTelemetryEvent(I),(0,b.getGalleryExtensionTelemetryData)(L),new Date().getTime()-c,D),D instanceof Error&&(D.name=N),D}}async checkAndGetCompatibleVersion(L){if(await this.isMalicious(L))throw new d.ExtensionManagementError(A.localize(4,null),d.INSTALL_ERROR_MALICIOUS);const S=await this.galleryService.getCompatibleExtension(L);if(!S)throw new d.ExtensionManagementError(A.localize(5,null,L.identifier.id,v.default.version),d.INSTALL_ERROR_INCOMPATIBLE);return S}async reinstallFromGallery(L){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",L.identifier.id),!this.galleryService.isEnabled())throw new Error(A.localize(6,null));const S=await this.findGalleryExtension(L);if(!S)throw new Error(A.localize(7,null));await this.setUninstalled(L);try{await this.extensionsScanner.removeUninstalledExtension(L)}catch(g){throw new Error(A.localize(8,null,(0,o.toErrorMessage)(g)))}await this.installFromGallery(S)}getTelemetryEvent(L){return L===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(L){const S=await this.getExtensionsReport();return(0,b.getMaliciousExtensionsSet)(S).has(L.identifier.id)}async downloadInstallableExtension(L,S){const g={id:L.identifier.uuid,publisherId:L.publisherId,publisherDisplayName:L.publisherDisplayName};let c;try{this.logService.trace("Started downloading extension:",L.identifier.id);const I=await this.extensionsDownloader.downloadExtension(L,S);this.logService.info("Downloaded extension:",L.identifier.id,c),c=I.fsPath}catch(I){throw new d.ExtensionManagementError(this.joinErrors(I).message,ee)}try{const I=await(0,j.getManifest)(c);return{zipPath:c,identifierWithVersion:new b.ExtensionIdentifierWithVersion(L.identifier,I.version),metadata:g}}catch(I){throw new d.ExtensionManagementError(this.joinErrors(I).message,ae)}}async installExtension(L,S){try{const g=await this.unsetUninstalledAndGetLocal(L.identifierWithVersion);if(g)return L.metadata?this.extensionsScanner.saveMetadataForLocalExtension(g,L.metadata):g}catch(g){throw m.isMacintosh?new d.ExtensionManagementError(A.localize(9,null),K):new d.ExtensionManagementError(A.localize(10,null),K)}return this.extractAndInstall(L,S)}async unsetUninstalledAndGetLocal(L){return await this.isUninstalled(L)?(this.logService.trace("Removing the extension from uninstalled list:",L.id),await this.unsetUninstalled(L),this.logService.info("Removed the extension from uninstalled list:",L.id),(await this.getInstalled(1)).find(c=>new b.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version).equals(L))||null):null}async extractAndInstall({zipPath:L,identifierWithVersion:S,metadata:g},c){let I=await this.extensionsScanner.extractUserExtension(S,L,c);return this.logService.info("Installation completed.",S.id),g&&(I=await this.extensionsScanner.saveMetadataForLocalExtension(I,g)),I}async installDependenciesAndPackExtensions(L,S,g){if(!!this.galleryService.isEnabled()){const c=L.manifest.extensionDependencies||[];if(L.manifest.extensionPack)for(const I of L.manifest.extensionPack)S&&S.manifest.extensionPack&&S.manifest.extensionPack.some(D=>(0,b.areSameExtensions)({id:D},{id:I}))||c.every(D=>!(0,b.areSameExtensions)({id:D},{id:I}))&&c.push(I);if(c.length){const I=await this.getInstalled(),D=c.filter(N=>I.every(({identifier:z})=>!(0,b.areSameExtensions)(z,{id:N})));if(D.length){const z=(await this.galleryService.query({names:D,pageSize:c.length},O.CancellationToken.None)).firstPage;try{await R.Promises.settled(z.map($=>this.installFromGallery($,g)))}catch($){try{await this.rollback(z)}catch(_){}throw $}}}}}async rollback(L){const g=(await this.getInstalled(1)).filter(c=>L.some(I=>new b.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version).equals(new b.ExtensionIdentifierWithVersion(I.identifier,I.version))));await R.Promises.settled(g.map(c=>this.uninstall(c)))}async uninstall(L,S={}){this.logService.trace("ExtensionManagementService#uninstall",L.identifier.id);const g=await this.getInstalled(1),c=g.find(I=>(0,b.areSameExtensions)(I.identifier,L.identifier));if(!c)throw new Error(A.localize(11,null,L.manifest.displayName||L.manifest.name));try{await this.checkForDependenciesAndUninstall(c,g,S)}catch(I){throw this.joinErrors(I)}}async updateMetadata(L,S){return this.logService.trace("ExtensionManagementService#updateMetadata",L.identifier.id),L=await this.extensionsScanner.saveMetadataForLocalExtension(L,Object.assign(Object.assign({},L.manifest.__metadata||{}),S)),this.manifestCache.invalidate(),L}async updateExtensionScope(L,S){return this.logService.trace("ExtensionManagementService#updateExtensionScope",L.identifier.id),L=await this.extensionsScanner.saveMetadataForLocalExtension(L,Object.assign(Object.assign({},L.manifest.__metadata||{}),{isMachineScoped:S})),this.manifestCache.invalidate(),L}async getGalleryMetadata(L){const S=await this.findGalleryExtensionByName(L);return S?{id:S.identifier.uuid,publisherDisplayName:S.publisherDisplayName,publisherId:S.publisherId}:void 0}async findGalleryExtension(L){if(L.identifier.uuid){const S=await this.findGalleryExtensionById(L.identifier.uuid);return S||this.findGalleryExtensionByName(L.identifier.id)}return this.findGalleryExtensionByName(L.identifier.id)}async findGalleryExtensionById(L){return(await this.galleryService.query({ids:[L],pageSize:1},O.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(L){return(await this.galleryService.query({names:[L],pageSize:1},O.CancellationToken.None)).firstPage[0]}joinErrors(L){const S=Array.isArray(L)?L:[L];return S.length===1?S[0]instanceof Error?S[0]:new Error(S[0]):S.reduce((g,c)=>new Error(`${g.message}${g.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}async checkForDependenciesAndUninstall(L,S,g){try{await this.preUninstallExtension(L);const c=g.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(L,S);await this.uninstallExtensions(L,c,S,g)}catch(c){throw await this.postUninstallExtension(L,new d.ExtensionManagementError(c instanceof Error?c.message:c,re)),c}await this.postUninstallExtension(L)}async uninstallExtensions(L,S,g,c){const I=[L,...S];if(!c.donotCheckDependents)for(const D of I)this.checkForDependents(D,I,g,L);await R.Promises.settled([this.uninstallExtension(L),...S.map(D=>this.doUninstall(D))])}checkForDependents(L,S,g,c){const I=this.getDependents(L,g);if(I.length){const D=I.filter(N=>S.indexOf(N)===-1);if(D.length)throw new Error(this.getDependentsErrorMessage(L,D,c))}}getDependentsErrorMessage(L,S,g){return g===L?S.length===1?A.localize(12,null,g.manifest.displayName||g.manifest.name,S[0].manifest.displayName||S[0].manifest.name):S.length===2?A.localize(13,null,g.manifest.displayName||g.manifest.name,S[0].manifest.displayName||S[0].manifest.name,S[1].manifest.displayName||S[1].manifest.name):A.localize(14,null,g.manifest.displayName||g.manifest.name,S[0].manifest.displayName||S[0].manifest.name,S[1].manifest.displayName||S[1].manifest.name):S.length===1?A.localize(15,null,g.manifest.displayName||g.manifest.name,L.manifest.displayName||L.manifest.name,S[0].manifest.displayName||S[0].manifest.name):S.length===2?A.localize(16,null,g.manifest.displayName||g.manifest.name,L.manifest.displayName||L.manifest.name,S[0].manifest.displayName||S[0].manifest.name,S[1].manifest.displayName||S[1].manifest.name):A.localize(17,null,g.manifest.displayName||g.manifest.name,L.manifest.displayName||L.manifest.name,S[0].manifest.displayName||S[0].manifest.name,S[1].manifest.displayName||S[1].manifest.name)}getAllPackExtensionsToUninstall(L,S,g=[]){if(g.indexOf(L)!==-1)return[];g.push(L);const c=L.manifest.extensionPack?L.manifest.extensionPack:[];if(c.length){const I=S.filter(N=>!N.isBuiltin&&c.some(z=>(0,b.areSameExtensions)({id:z},N.identifier))),D=[];for(const N of I)D.push(...this.getAllPackExtensionsToUninstall(N,S,g));return[...I,...D]}return[]}getDependents(L,S){return S.filter(g=>g.manifest.extensionDependencies&&g.manifest.extensionDependencies.some(c=>(0,b.areSameExtensions)({id:c},L.identifier)))}async doUninstall(L){try{await this.preUninstallExtension(L),await this.uninstallExtension(L)}catch(S){throw await this.postUninstallExtension(L,new d.ExtensionManagementError(S instanceof Error?S.message:S,re)),S}await this.postUninstallExtension(L)}async preUninstallExtension(L){if(!await E.exists(L.location.fsPath))throw new Error(A.localize(18,null));this.logService.info("Uninstalling extension:",L.identifier.id),this._onUninstallExtension.fire(L.identifier)}async uninstallExtension(L){let S=this.uninstallingExtensions.get(L.identifier.id);return S||(S=(0,R.createCancelablePromise)(async()=>{const g=await this.extensionsScanner.scanUserExtensions(!1);await this.setUninstalled(...g.filter(c=>(0,b.areSameExtensions)(c.identifier,L.identifier)))}),this.uninstallingExtensions.set(L.identifier.id,S),S.finally(()=>this.uninstallingExtensions.delete(L.identifier.id))),S}async postUninstallExtension(L,S){if(S)this.logService.error("Failed to uninstall extension:",L.identifier.id,S.message);else if(this.logService.info("Successfully uninstalled extension:",L.identifier.id),L.identifier.uuid)try{await this.galleryService.reportStatistic(L.manifest.publisher,L.manifest.name,L.manifest.version,"uninstall")}catch(c){}this.reportTelemetry("extensionGallery:uninstall",(0,b.getLocalExtensionTelemetryData)(L),void 0,S);const g=S?S instanceof d.ExtensionManagementError?S.code:Z:void 0;this._onDidUninstallExtension.fire({identifier:L.identifier,error:g})}getInstalled(L=null){return this.extensionsScanner.scanExtensions(L)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(L){return(await this.filterUninstalled(L)).length===1}filterUninstalled(...L){return this.extensionsScanner.withUninstalledExtensions(S=>{const g=[];for(const c of L)S[c.key()]&&g.push(c.key());return g})}setUninstalled(...L){const S=L.map(g=>new b.ExtensionIdentifierWithVersion(g.identifier,g.manifest.version));return this.extensionsScanner.withUninstalledExtensions(g=>(S.forEach(c=>g[c.key()]=!0),g))}unsetUninstalled(L){return this.extensionsScanner.withUninstalledExtensions(S=>delete S[L.key()])}getExtensionsReport(){const L=new Date().getTime();return(!this.reportedExtensions||L-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=L),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const L=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${L.length} reported extensions from service`),L}catch(L){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(L,S,g,c){const I=c?c instanceof d.ExtensionManagementError?c.code:Z:void 0;this.telemetryService.publicLogError(L,Object.assign(Object.assign({},S),{success:!c,duration:g,errorcode:I}))}};le=ce([fe(0,u.INativeEnvironmentService),fe(1,d.IExtensionGalleryService),fe(2,p.ILogService),fe(3,(0,r.optional)(a.IDownloadService)),fe(4,i.ITelemetryService),fe(5,r.IInstantiationService)],le),t.ExtensionManagementService=le}),define(Q[118],Y([0,1,129,105,2,8,15,104,27,13,16]),function(x,t,y,A,F,E,k,T,h,d,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let u=class extends F.Disposable{constructor(w,l){super();this.logService=l,this.configure(w.getValue()),this._register(w.onDidChangeConfiguration(()=>this.configure(w.getValue()),this))}configure(w){this.proxyUrl=w.http&&w.http.proxy,this.strictSSL=!!(w.http&&w.http.proxyStrictSSL),this.authorization=w.http&&w.http.proxyAuthorization}async request(w,l){this.logService.trace("RequestService#request",w.url);const{proxyUrl:C,strictSSL:v}=this,m=w.agent?w.agent:await(0,T.getProxyAgent)(w.url||"",{proxyUrl:C,strictSSL:v});return w.agent=m,w.strictSSL=v,this.authorization&&(w.headers=Object.assign(Object.assign({},w.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(w,l)}async getNodeRequest(w){return((0,A.parse)(w.url).protocol==="https:"?await new Promise((v,m)=>{x(["https"],v,m)}):await new Promise((v,m)=>{x(["http"],v,m)})).request}_request(w,l){return new Promise(async(C,v)=>{let m;const p=(0,A.parse)(w.url),P=w.getRawRequest?w.getRawRequest(w):await this.getNodeRequest(w),o={hostname:p.hostname,port:p.port?parseInt(p.port):p.protocol==="https:"?443:80,protocol:p.protocol,path:p.path,method:w.type||"GET",headers:w.headers,agent:w.agent,rejectUnauthorized:(0,E.isBoolean)(w.strictSSL)?w.strictSSL:!0};w.user&&w.password&&(o.auth=w.user+":"+w.password),m=P(o,i=>{const e=(0,E.isNumber)(w.followRedirects)?w.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&e>0&&i.headers.location)this._request(Object.assign(Object.assign({},w),{url:i.headers.location,followRedirects:e-1}),l).then(C,v);else{let n=i;i.headers["content-encoding"]==="gzip"&&(n=i.pipe((0,y.createGunzip)())),C({res:i,stream:(0,b.streamToBufferReadableStream)(n)})}}),m.on("error",v),w.timeout&&m.setTimeout(w.timeout),w.data&&typeof w.data=="string"&&m.write(w.data),m.end(),l.onCancellationRequested(()=>{m.abort(),v((0,k.canceled)())})})}async resolveProxy(w){}};u=ce([fe(0,h.IConfigurationService),fe(1,d.ILogService)],u),t.RequestService=u}),define(Q[130],Y([0,1,45,14,131,3,4,39,51,48,92,22,100,23,117,111,41,53,112,110,52,118,27,103,113,107,108,13,9,99,114,96,24,97,2,40,93,10,98,36,15,30,16]),function(x,t,y,A,F,E,k,T,h,d,b,u,R,w,l,C,v,m,p,P,o,i,e,n,s,a,r,f,O,j,M,U,B,K,ee,ae,re,Z,le,W,L,S,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class c extends ee.Disposable{constructor(N){super();this.argv=N,(0,F.gracefulify)(A),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[N,z]=await this.initServices();return N.invokeFunction(async $=>{const _=$.get(f.ILogService),q=$.get(B.IFileService),X=$.get(u.INativeEnvironmentService),J=$.get(w.IExtensionManagementCLIService);return _.info("CLI main",this.argv),this.registerErrorHandler(_),await this.doRun(X,J,q),(0,k.raceTimeout)((0,m.combinedAppender)(...z).flush(),1e3)})}async initServices(){const N=new h.ServiceCollection,z=new R.NativeEnvironmentService(this.argv);N.set(u.INativeEnvironmentService,z),await Promise.all([z.appSettingsHome.fsPath,z.extensionsPath].map(Ae=>Ae?A.promises.mkdir(Ae,{recursive:!0}):void 0));const $=(0,f.getLogLevel)(z),_=[];_.push(new j.SpdLogLogger("cli",(0,E.join)(z.logsPath,"cli.log"),!0,$)),$===f.LogLevel.Trace&&_.push(new f.ConsoleLogger($));const q=this._register(new f.MultiplexLogService(_));N.set(f.ILogService,q);const X=this._register(new U.FileService(q));N.set(B.IFileService,X);const J=this._register(new K.DiskFileSystemProvider(q));X.registerProvider(O.Schemas.file,J);const te=this._register(new n.ConfigurationService(z.settingsResource,X));N.set(e.IConfigurationService,te),await te.initialize();const ne=new r.StateService(z,q);N.set(a.IStateService,ne),N.set(ae.IProductService,Object.assign({_serviceBrand:void 0},T.default));const{appRoot:de,extensionsPath:me,extensionDevelopmentLocationURI:Ie,isBuilt:Le,installSourcePath:Fe}=z;N.set(o.IRequestService,new d.SyncDescriptor(i.RequestService)),N.set(w.IExtensionManagementService,new d.SyncDescriptor(l.ExtensionManagementService)),N.set(w.IExtensionGalleryService,new d.SyncDescriptor(C.ExtensionGalleryService)),N.set(w.IExtensionManagementCLIService,new d.SyncDescriptor(re.ExtensionManagementCLIService)),N.set(W.ILocalizationsService,new d.SyncDescriptor(le.LocalizationsService));const Pe=[];if(Le&&!Ie&&!z.disableTelemetry&&T.default.enableTelemetry){T.default.aiConfig&&T.default.aiConfig.asimovKey&&Pe.push(new s.AppInsightsAppender("monacoworkbench",null,T.default.aiConfig.asimovKey));const Ae={appender:(0,m.combinedAppender)(...Pe),sendErrorTelemetry:!1,commonProperties:(0,P.resolveCommonProperties)(X,(0,y.release)(),process.arch,T.default.commit,T.default.version,ne.getItem("telemetry.machineId"),T.default.msftInternalDomains,Fe),piiPaths:[de,me]};N.set(v.ITelemetryService,new d.SyncDescriptor(p.TelemetryService,[Ae]))}else N.set(v.ITelemetryService,m.NullTelemetryService);return[new b.InstantiationService(N),Pe]}registerErrorHandler(N){(0,L.setUnexpectedErrorHandler)(z=>{const $=(0,S.toErrorMessage)(z,!0);!$||N.error(`[uncaught exception in CLI]: ${$}`)})}async doRun(N,z,$){if(this.argv["install-source"])return this.setInstallSource(N,$,this.argv["install-source"]);if(this.argv["list-extensions"])return z.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return z.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return z.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return z.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log((0,M.buildTelemetryMessage)(N.appRoot,N.extensionsPath))}asExtensionIdOrVSIX(N){return N.map(z=>/\.vsix$/i.test(z)?Z.URI.file((0,E.isAbsolute)(z)?z:(0,E.join)(process.cwd(),z)):z)}async setInstallSource(N,z,$){await z.writeFile(Z.URI.file(N.installSourcePath),g.VSBuffer.fromString($.slice(0,30)))}}async function I(D){const N=new c(D);try{await N.run()}finally{N.dispose()}}t.main=I})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5d80c30e5b6ce8b2f5336ed55ad043490b0b818f/core/vs/code/node/cliProcessMain.js.map
