/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/base/common/path","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/platform","vs/base/common/network","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/types","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/errors","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/map","vs/base/common/resources","vs/base/common/objects","vs/base/node/pfs","vs/base/common/buffer","vs/workbench/api/common/extHostInitDataService","vs/base/common/uuid","vs/platform/extensions/common/extensions","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/base/common/glob","fs","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostExtensionService","os","vs/editor/common/core/range","vs/workbench/api/common/extHostDebugService","vs/base/common/stopwatch","vs/base/common/codicons","vs/editor/common/core/position","vs/platform/files/common/files","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostCommands","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/linkedList","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/severity","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/node/processes","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/workbench/api/common/shared/webview","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/powershell","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTelemetry","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/base/node/extpath","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/contrib/terminal/common/terminal","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/externalTerminal/node/externalTerminal","vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminal","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminal","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyAgent","https","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","vs/base/common/marked/marked","url","vscode-proxy-agent","tls","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],pe=function(Z){for(var e=[],_=0,D=Z.length;_<D;_++)e[_]=me[Z[_]];return e};define(me[53],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function _(D,R){if(!D)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=_}),define(me[54],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const _=Object.prototype.hasOwnProperty;function D(T){const k=[];for(let w in T)_.call(T,w)&&k.push(T[w]);return k}e.values=D;function R(T,k){for(let w in T)if(_.call(T,w)&&k({key:w,value:T[w]},function(){delete T[w]})===!1)return}e.forEach=R;function I(T,k){const w=Object.create(null);for(const f of T){const l=k(f);let m=w[l];m||(m=w[l]=[]),m.push(f)}return w}e.groupBy=I;function C(T){const k=Object.create(null);return T&&T.forEach((w,f)=>{k[f]=w}),k}e.fromMap=C;function P(T,k){const w=[],f=[];for(let l of T)k.has(l)||w.push(l);for(let l of k)T.has(l)||f.push(l);return{removed:w,added:f}}e.diffSets=P;function y(T,k){const w=[],f=[];for(let[l,m]of T)k.has(l)||w.push(m);for(let[l,m]of k)T.has(l)||f.push(m);return{removed:w,added:f}}e.diffMaps=y;class i{constructor(){this.map=new Map}add(k,w){let f=this.map.get(k);f||(f=new Set,this.map.set(k,f)),f.add(w)}delete(k,w){const f=this.map.get(k);!f||(f.delete(w),f.size===0&&this.map.delete(k))}forEach(k,w){const f=this.map.get(k);!f||f.forEach(w)}}e.SetMap=i}),define(me[55],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function _(y){return(i,T,k)=>{let w=null,f=null;if(typeof k.value=="function"?(w="value",f=k.value):typeof k.get=="function"&&(w="get",f=k.get),!f)throw new Error("not supported");k[w]=y(f,T)}}e.createDecorator=_;let D=0;function R(){const y=`$memoize${D++}`;let i;const T=function(w,f,l){let m=null,S=null;if(typeof l.value=="function"?(m="value",S=l.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(m="get",S=l.get),!S)throw new Error("not supported");const g=`${y}:${f}`;l[m]=function(...b){return i=this,this.hasOwnProperty(g)||Object.defineProperty(this,g,{configurable:!0,enumerable:!1,writable:!0,value:S.apply(this,b)}),this[g]}};return T.clear=()=>{typeof i!="undefined"&&Object.getOwnPropertyNames(i).forEach(k=>{k.indexOf(y)===0&&delete i[k]})},T}e.createMemoizer=R;function I(y,i,T){return R()(y,i,T)}e.memoize=I;function C(y,i,T){return _((k,w)=>{const f=`$debounce$${w}`,l=`$debounce$result$${w}`;return function(...m){this[l]||(this[l]=T?T():void 0),clearTimeout(this[f]),i&&(this[l]=i(this[l],...m),m=[this[l]]),this[f]=setTimeout(()=>{k.apply(this,m),this[l]=T?T():void 0},y)}})}e.debounce=C;function P(y,i,T){return _((k,w)=>{const f=`$throttle$timer$${w}`,l=`$throttle$result$${w}`,m=`$throttle$lastRun$${w}`,S=`$throttle$pending$${w}`;return function(...g){if(this[l]||(this[l]=T?T():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),i&&(this[l]=i(this[l],...g)),!this[S]){const b=this[m]+y;b<=Date.now()?(this[m]=Date.now(),k.apply(this,[this[l]]),this[l]=T?T():void 0):(this[S]=!0,this[f]=setTimeout(()=>{this[S]=!1,this[m]=Date.now(),k.apply(this,[this[l]]),this[l]=T?T():void 0},b-Date.now()))}}})}e.throttle=P}),define(me[18],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class _{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=_,e.errorHandler=new _;function D(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=D;function R(a){y(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=R;function I(a){y(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=I;function C(a){if(a instanceof Error){let{name:t,message:r}=a;const s=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:s}}return a}e.transformErrorForSerialization=C;const P="Canceled";function y(a){return a instanceof Error&&a.name===P&&a.message===P}e.isPromiseCanceledError=y;class i extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=i;function T(){const a=new Error(P);return a.name=a.message,a}e.canceled=T;function k(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=k;function w(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=w;function f(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function l(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=l;function m(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=m;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class g extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=g;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function d(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=d;function u(a,t=Object.create(null)){const r=new Error(a);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=u}),define(me[14],pe([0,1,18]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function D(O,N=0){return O[O.length-(1+N)]}e.tail=D;function R(O){if(O.length===0)throw new Error("Invalid tail call");return[O.slice(0,O.length-1),O[O.length-1]]}e.tail2=R;function I(O,N,U=(L,M)=>L===M){if(O===N)return!0;if(!O||!N||O.length!==N.length)return!1;for(let L=0,M=O.length;L<M;L++)if(!U(O[L],N[L]))return!1;return!0}e.equals=I;function C(O,N,U){let L=0,M=O.length-1;for(;L<=M;){const V=(L+M)/2|0,K=U(O[V],N);if(K<0)L=V+1;else if(K>0)M=V-1;else return V}return-(L+1)}e.binarySearch=C;function P(O,N){let U=0,L=O.length;if(L===0)return 0;for(;U<L;){const M=Math.floor((U+L)/2);N(O[M])?L=M:U=M+1}return U}e.findFirstInSorted=P;function y(O,N,U){if(O=O|0,O>=N.length)throw new TypeError("invalid index");let L=N[Math.floor(N.length*Math.random())],M=[],V=[],K=[];for(let se of N){const ce=U(se,L);ce<0?M.push(se):ce>0?V.push(se):K.push(se)}return O<M.length?y(O,M,U):O<M.length+K.length?K[0]:y(O-(M.length+K.length),V,U)}e.quickSelect=y;function i(O,N){const U=[];let L;for(const M of O.slice(0).sort(N))!L||N(L[0],M)!==0?(L=[M],U.push(L)):L.push(M);return U}e.groupBy=i;function T(O,N,U){const L=[];function M(se,ce,we){if(!(ce===0&&we.length===0)){const Te=L[L.length-1];Te&&Te.start+Te.deleteCount===se?(Te.deleteCount+=ce,Te.toInsert.push(...we)):L.push({start:se,deleteCount:ce,toInsert:we})}}let V=0,K=0;for(;;){if(V===O.length){M(V,0,N.slice(K));break}if(K===N.length){M(V,O.length-V,[]);break}const se=O[V],ce=N[K],we=U(se,ce);we===0?(V+=1,K+=1):we<0?(M(V,1,[]),V+=1):we>0&&(M(V,0,[ce]),K+=1)}return L}e.sortedDiff=T;function k(O,N,U){const L=T(O,N,U),M=[],V=[];for(const K of L)M.push(...O.slice(K.start,K.start+K.deleteCount)),V.push(...K.toInsert);return{removed:M,added:V}}e.delta=k;function w(O,N,U){if(U===0)return[];const L=O.slice(0,U).sort(N);return l(O,N,L,U,O.length),L}e.top=w;function f(O,N,U,L,M){return U===0?Promise.resolve([]):new Promise((V,K)=>{(async()=>{const se=O.length,ce=O.slice(0,U).sort(N);for(let we=U,Te=Math.min(U+L,se);we<se;we=Te,Te=Math.min(Te+L,se)){if(we>U&&await new Promise(Ie=>setTimeout(Ie)),M&&M.isCancellationRequested)throw(0,_.canceled)();l(O,N,ce,we,Te)}return ce})().then(V,K)})}e.topAsync=f;function l(O,N,U,L,M){for(const V=U.length;L<M;L++){const K=O[L];if(N(K,U[V-1])<0){U.pop();const se=P(U,ce=>N(K,ce)<0);U.splice(se,0,K)}}}function m(O){return O.filter(N=>!!N)}e.coalesce=m;function S(O){let N=0;for(let U=0;U<O.length;U++)O[U]&&(O[N]=O[U],N+=1);O.length=N}e.coalesceInPlace=S;function g(O,N,U){O.splice(U,0,O.splice(N,1)[0])}e.move=g;function b(O){return!Array.isArray(O)||O.length===0}e.isFalsyOrEmpty=b;function d(O){return Array.isArray(O)&&O.length>0}e.isNonEmptyArray=d;function u(O,N){if(!N)return O.filter((L,M)=>O.indexOf(L)===M);const U=Object.create(null);return O.filter(L=>{const M=N(L);return U[M]?!1:(U[M]=!0,!0)})}e.distinct=u;function a(O){const N=new Set;return O.filter(U=>N.has(U)?!1:(N.add(U),!0))}e.distinctES6=a;function t(O){const N=Object.create(null);return U=>{const L=O(U);return N[L]?!1:(N[L]=!0,!0)}}e.uniqueFilter=t;function r(O,N){for(let U=O.length-1;U>=0;U--){const L=O[U];if(N(L))return U}return-1}e.lastIndex=r;function s(O,N){return O.length>0?O[0]:N}e.firstOrDefault=s;function o(O,N,U=(L,M)=>L===M){let L=0;for(let M=0,V=Math.min(O.length,N.length);M<V&&U(O[M],N[M]);M++)L++;return L}e.commonPrefixLength=o;function n(O){return[].concat(...O)}e.flatten=n;function c(O,N){let U=typeof N=="number"?O:0;typeof N=="number"?U=O:(U=0,N=O);const L=[];if(U<=N)for(let M=U;M<N;M++)L.push(M);else for(let M=U;M>N;M--)L.push(M);return L}e.range=c;function p(O,N,U){return O.reduce((L,M)=>(L[N(M)]=U?U(M):M,L),Object.create(null))}e.index=p;function E(O,N){return O.push(N),()=>h(O,N)}e.insert=E;function h(O,N){const U=O.indexOf(N);if(U>-1)return O.splice(U,1),N}e.remove=h;function v(O,N,U){const L=O.slice(0,N),M=O.slice(N);return L.concat(U,M)}e.arrayInsert=v;function A(O,N){let U;if(typeof N=="number"){let L=N;U=()=>{const M=Math.sin(L++)*179426549;return M-Math.floor(M)}}else U=Math.random;for(let L=O.length-1;L>0;L-=1){const M=Math.floor(U()*(L+1)),V=O[L];O[L]=O[M],O[M]=V}}e.shuffle=A;function F(O,N){const U=O.indexOf(N);U>-1&&(O.splice(U,1),O.unshift(N))}e.pushToStart=F;function x(O,N){const U=O.indexOf(N);U>-1&&(O.splice(U,1),O.push(N))}e.pushToEnd=x;function j(O,N){return Array.isArray(O)?O.map(N):N(O)}e.mapArrayOrNot=j;function G(O){return Array.isArray(O)?O:[O]}e.asArray=G;function B(O){return O[Math.floor(Math.random()*O.length)]}e.getRandomElement=B;function J(O,N){for(const U of O){const L=N(U);if(L!==void 0)return L}}e.mapFind=J}),define(me[70],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function _(D){const R=this;let I=!1,C;return function(){return I||(I=!0,C=D.apply(R,arguments)),C}}e.once=_}),define(me[71],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class _{constructor(R){this._prefix=R,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=_,e.defaultGenerator=new _("id#")}),define(me[72],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var _;(function(D){function R(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}D.is=R;const I=Object.freeze([]);function C(){return I}D.empty=C;function*P(a){yield a}D.single=P;function y(a){return a||I}D.from=y;function i(a){return!a||a[Symbol.iterator]().next().done===!0}D.isEmpty=i;function T(a){return a[Symbol.iterator]().next().value}D.first=T;function k(a,t){for(const r of a)if(t(r))return!0;return!1}D.some=k;function w(a,t){for(const r of a)if(t(r))return r}D.find=w;function*f(a,t){for(const r of a)t(r)&&(yield r)}D.filter=f;function*l(a,t){for(const r of a)yield t(r)}D.map=l;function*m(...a){for(const t of a)for(const r of t)yield r}D.concat=m;function*S(a){for(const t of a)for(const r of t)yield r}D.concatNested=S;function g(a,t,r){let s=r;for(const o of a)s=t(s,o);return s}D.reduce=g;function*b(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}D.slice=b;function d(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const s=a[Symbol.iterator]();for(let o=0;o<t;o++){const n=s.next();if(n.done)return[r,D.empty()];r.push(n.value)}return[r,{[Symbol.iterator](){return s}}]}D.consume=d;function u(a,t,r=(s,o)=>s===o){const s=a[Symbol.iterator](),o=t[Symbol.iterator]();for(;;){const n=s.next(),c=o.next();if(n.done!==c.done)return!1;if(n.done)return!0;if(!r(n.value,c.value))return!1}}D.equals=u})(_=e.Iterable||(e.Iterable={}))}),define(me[56],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var _;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(_=e.ScanError||(e.ScanError={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var I;(function(t){t.DEFAULT={allowTrailingComma:!0}})(I=e.ParseOptions||(e.ParseOptions={}));function C(t,r=!1){let s=0,o=t.length,n="",c=0,p=16,E=0;function h(B){let J=0,O=0;for(;J<B;){const N=t.charCodeAt(s);if(N>=48&&N<=57)O=O*16+N-48;else if(N>=65&&N<=70)O=O*16+N-65+10;else if(N>=97&&N<=102)O=O*16+N-97+10;else break;s++,J++}return J<B&&(O=-1),O}function v(B){s=B,n="",c=0,p=16,E=0}function A(){const B=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&i(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&i(t.charCodeAt(s)))for(s++;s<t.length&&i(t.charCodeAt(s));)s++;else return E=3,t.substring(B,s);let J=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&i(t.charCodeAt(s))){for(s++;s<t.length&&i(t.charCodeAt(s));)s++;J=s}else E=3;return t.substring(B,J)}function F(){let B="",J=s;for(;;){if(s>=o){B+=t.substring(J,s),E=2;break}const O=t.charCodeAt(s);if(O===34){B+=t.substring(J,s),s++;break}if(O===92){if(B+=t.substring(J,s),s++,s>=o){E=2;break}switch(t.charCodeAt(s++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:const U=h(4);U>=0?B+=String.fromCharCode(U):E=4;break;default:E=5}J=s;continue}if(O>=0&&O<=31)if(y(O)){B+=t.substring(J,s),E=2;break}else E=6;s++}return B}function x(){if(n="",E=0,c=s,s>=o)return c=o,p=17;let B=t.charCodeAt(s);if(P(B)){do s++,n+=String.fromCharCode(B),B=t.charCodeAt(s);while(P(B));return p=15}if(y(B))return s++,n+=String.fromCharCode(B),B===13&&t.charCodeAt(s)===10&&(s++,n+=`
`),p=14;switch(B){case 123:return s++,p=1;case 125:return s++,p=2;case 91:return s++,p=3;case 93:return s++,p=4;case 58:return s++,p=6;case 44:return s++,p=5;case 34:return s++,n=F(),p=10;case 47:const J=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<o&&!y(t.charCodeAt(s));)s++;return n=t.substring(J,s),p=12}if(t.charCodeAt(s+1)===42){s+=2;const O=o-1;let N=!1;for(;s<O;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,N=!0;break}s++}return N||(s++,E=1),n=t.substring(J,s),p=13}return n+=String.fromCharCode(B),s++,p=16;case 45:if(n+=String.fromCharCode(B),s++,s===o||!i(t.charCodeAt(s)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=A(),p=11;default:for(;s<o&&j(B);)s++,B=t.charCodeAt(s);if(c!==s){switch(n=t.substring(c,s),n){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return n+=String.fromCharCode(B),s++,p=16}}function j(B){if(P(B)||y(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let B;do B=x();while(B>=12&&B<=15);return B}return{setPosition:v,getPosition:()=>s,scan:r?G:x,getToken:()=>p,getTokenValue:()=>n,getTokenOffset:()=>c,getTokenLength:()=>s-c,getTokenError:()=>E}}e.createScanner=C;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function i(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function k(t,r){const s=[],o=new Object;let n;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function E(h,v,A,F){c.value=h,c.offset=v,c.length=A,c.type=F,c.colonOffset=void 0,n=c}try{d(t,{onObjectBegin:(h,v)=>{if(r<=h)throw o;n=void 0,p=r>h,s.push("")},onObjectProperty:(h,v,A)=>{if(r<v||(E(h,v,A,"property"),s[s.length-1]=h,r<=v+A))throw o},onObjectEnd:(h,v)=>{if(r<=h)throw o;n=void 0,s.pop()},onArrayBegin:(h,v)=>{if(r<=h)throw o;n=void 0,s.push(0)},onArrayEnd:(h,v)=>{if(r<=h)throw o;n=void 0,s.pop()},onLiteralValue:(h,v,A)=>{if(r<v||(E(h,v,A,a(h)),r<=v+A))throw o},onSeparator:(h,v,A)=>{if(r<=v)throw o;if(h===":"&&n&&n.type==="property")n.colonOffset=v,p=!1,n=void 0;else if(h===","){const F=s[s.length-1];typeof F=="number"?s[s.length-1]=F+1:(p=!0,s[s.length-1]=""),n=void 0}}})}catch(h){if(h!==o)throw h}return{path:s,previousNode:n,isAtPropertyKey:p,matches:h=>{let v=0;for(let A=0;v<h.length&&A<s.length;A++)if(h[v]===s[A]||h[v]==="*")v++;else if(h[v]!=="**")return!1;return v===h.length}}}e.getLocation=k;function w(t,r=[],s=I.DEFAULT){let o=null,n=[];const c=[];function p(h){Array.isArray(n)?n.push(h):o!==null&&(n[o]=h)}return d(t,{onObjectBegin:()=>{const h={};p(h),c.push(n),n=h,o=null},onObjectProperty:h=>{o=h},onObjectEnd:()=>{n=c.pop()},onArrayBegin:()=>{const h=[];p(h),c.push(n),n=h,o=null},onArrayEnd:()=>{n=c.pop()},onLiteralValue:p,onError:(h,v,A)=>{r.push({error:h,offset:v,length:A})}},s),n[0]}e.parse=w;function f(t,r=[],s=I.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(h){o.type==="property"&&(o.length=h-o.offset,o=o.parent)}function c(h){return o.children.push(h),h}d(t,{onObjectBegin:h=>{o=c({type:"object",offset:h,length:-1,parent:o,children:[]})},onObjectProperty:(h,v,A)=>{o=c({type:"property",offset:v,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:h,offset:v,length:A,parent:o})},onObjectEnd:(h,v)=>{o.length=h+v-o.offset,o=o.parent,n(h+v)},onArrayBegin:(h,v)=>{o=c({type:"array",offset:h,length:-1,parent:o,children:[]})},onArrayEnd:(h,v)=>{o.length=h+v-o.offset,o=o.parent,n(h+v)},onLiteralValue:(h,v,A)=>{c({type:a(h),offset:v,length:A,parent:o,value:h}),n(v+A)},onSeparator:(h,v,A)=>{o.type==="property"&&(h===":"?o.colonOffset=v:h===","&&n(v))},onError:(h,v,A)=>{r.push({error:h,offset:v,length:A})}},s);const E=o.children[0];return E&&delete E.parent,E}e.parseTree=f;function l(t,r){if(!!t){let s=t;for(let o of r)if(typeof o=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let n=!1;for(const c of s.children)if(Array.isArray(c.children)&&c.children[0].value===o){s=c.children[1],n=!0;break}if(!n)return}else{const n=o;if(s.type!=="array"||n<0||!Array.isArray(s.children)||n>=s.children.length)return;s=s.children[n]}return s}}e.findNodeAtLocation=l;function m(t){if(!t.parent||!t.parent.children)return[];const r=m(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.getNodePath=m;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const r=Object.create(null);for(let s of t.children){const o=s.children[1];o&&(r[s.children[0].value]=S(o))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function g(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.contains=g;function b(t,r,s=!1){if(g(t,r,s)){const o=t.children;if(Array.isArray(o))for(let n=0;n<o.length&&o[n].offset<=r;n++){const c=b(o[n],r,s);if(c)return c}return t}}e.findNodeAtOffset=b;function d(t,r,s=I.DEFAULT){const o=C(t,!1);function n(ce){return ce?()=>ce(o.getTokenOffset(),o.getTokenLength()):()=>!0}function c(ce){return ce?we=>ce(we,o.getTokenOffset(),o.getTokenLength()):()=>!0}const p=n(r.onObjectBegin),E=c(r.onObjectProperty),h=n(r.onObjectEnd),v=n(r.onArrayBegin),A=n(r.onArrayEnd),F=c(r.onLiteralValue),x=c(r.onSeparator),j=n(r.onComment),G=c(r.onError),B=s&&s.disallowComments,J=s&&s.allowTrailingComma;function O(){for(;;){const ce=o.scan();switch(o.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:B||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(ce){case 12:case 13:B?N(10):j();break;case 16:N(1);break;case 15:case 14:break;default:return ce}}}function N(ce,we=[],Te=[]){if(G(ce),we.length+Te.length>0){let Ie=o.getToken();for(;Ie!==17;){if(we.indexOf(Ie)!==-1){O();break}else if(Te.indexOf(Ie)!==-1)break;Ie=O()}}}function U(ce){const we=o.getTokenValue();return ce?F(we):E(we),O(),!0}function L(){switch(o.getToken()){case 11:let ce=0;try{ce=JSON.parse(o.getTokenValue()),typeof ce!="number"&&(N(2),ce=0)}catch(we){N(2)}F(ce);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return O(),!0}function M(){return o.getToken()!==10?(N(3,[],[2,5]),!1):(U(!1),o.getToken()===6?(x(":"),O(),se()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function V(){p(),O();let ce=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ce||N(4,[],[]),x(","),O(),o.getToken()===2&&J)break}else ce&&N(6,[],[]);M()||N(4,[],[2,5]),ce=!0}return h(),o.getToken()!==2?N(7,[2],[]):O(),!0}function K(){v(),O();let ce=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ce||N(4,[],[]),x(","),O(),o.getToken()===4&&J)break}else ce&&N(6,[],[]);se()||N(4,[],[4,5]),ce=!0}return A(),o.getToken()!==4?N(8,[4],[]):O(),!0}function se(){switch(o.getToken()){case 3:return K();case 1:return V();case 10:return U(!0);default:return L()}}return O(),o.getToken()===17?s.allowEmptyContent?!0:(N(4,[],[]),!1):se()?(o.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=d;function u(t,r){let s=C(t),o=[],n,c=0,p;do switch(p=s.getPosition(),n=s.scan(),n){case 12:case 13:case 17:c!==p&&o.push(t.substring(c,p)),r!==void 0&&o.push(s.getTokenValue().replace(/[^\r\n]/g,r)),c=s.getPosition();break}while(n!==17);return o.join("")}e.stripComments=u;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(me[129],pe([0,1,56]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function D(y,i,T){let k,w,f,l,m;if(i){for(l=i.offset,m=l+i.length,f=l;f>0&&!P(y,f-1);)f--;let c=m;for(;c<y.length&&!P(y,c);)c++;w=y.substring(f,c),k=I(w,T)}else w=y,k=0,f=0,l=0,m=y.length;const S=C(T,y);let g=!1,b=0,d;T.insertSpaces?d=R(" ",T.tabSize||4):d="	";const u=(0,_.createScanner)(w,!1);let a=!1;function t(){return S+R(d,k+b)}function r(){let c=u.scan();for(g=!1;c===15||c===14;)g=g||c===14,c=u.scan();return a=c===16||u.getTokenError()!==0,c}const s=[];function o(c,p,E){!a&&p<m&&E>l&&y.substring(p,E)!==c&&s.push({offset:p,length:E-p,content:c})}let n=r();if(n!==17){const c=u.getTokenOffset()+f,p=R(d,k);o(p,f,c)}for(;n!==17;){let c=u.getTokenOffset()+u.getTokenLength()+f,p=r(),E="";for(;!g&&(p===12||p===13);){const v=u.getTokenOffset()+f;o(" ",c,v),c=u.getTokenOffset()+u.getTokenLength()+f,E=p===12?t():"",p=r()}if(p===2)n!==1&&(b--,E=t());else if(p===4)n!==3&&(b--,E=t());else{switch(n){case 3:case 1:b++,E=t();break;case 5:case 12:E=t();break;case 13:g?E=t():E=" ";break;case 6:E=" ";break;case 10:if(p===6){E="";break}case 7:case 8:case 9:case 11:case 2:case 4:p===12||p===13?E=" ":p!==5&&p!==17&&(a=!0);break;case 16:a=!0;break}g&&(p===12||p===13)&&(E=t())}const h=u.getTokenOffset()+f;o(E,c,h),n=p}return s}e.format=D;function R(y,i){let T="";for(let k=0;k<i;k++)T+=y;return T}function I(y,i){let T=0,k=0;const w=i.tabSize||4;for(;T<y.length;){const f=y.charAt(T);if(f===" ")k++;else if(f==="	")k+=w;else break;T++}return Math.floor(k/w)}function C(y,i){for(let T=0;T<i.length;T++){const k=i.charAt(T);if(k==="\r")return T+1<i.length&&i.charAt(T+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=C;function P(y,i){return`\r
`.indexOf(y.charAt(i))!==-1}e.isEOL=P}),define(me[130],pe([0,1,56,129]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(i,T,k){return I(i,T,void 0,k)}e.removeProperty=R;function I(i,T,k,w,f){const l=T.slice(),m=[],S=(0,_.parseTree)(i,m);let g,b;for(;l.length>0&&(b=l.pop(),g=(0,_.findNodeAtLocation)(S,l),g===void 0&&k!==void 0);)typeof b=="string"?k={[b]:k}:k=[k];if(g)if(g.type==="object"&&typeof b=="string"&&Array.isArray(g.children)){const d=(0,_.findNodeAtLocation)(g,[b]);if(d!==void 0)if(k===void 0){if(!d.parent)throw new Error("Malformed AST");const u=g.children.indexOf(d.parent);let a,t=d.parent.offset+d.parent.length;if(u>0){const r=g.children[u-1];a=r.offset+r.length}else a=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return C(i,{offset:a,length:t-a,content:""},w)}else return C(i,{offset:d.offset,length:d.length,content:JSON.stringify(k)},w);else{if(k===void 0)return[];const u=`${JSON.stringify(b)}: ${JSON.stringify(k)}`,a=f?f(g.children.map(r=>r.children[0].value)):g.children.length;let t;if(a>0){const r=g.children[a-1];t={offset:r.offset+r.length,length:0,content:","+u}}else g.children.length===0?t={offset:g.offset+1,length:0,content:u}:t={offset:g.offset+1,length:0,content:u+","};return C(i,t,w)}}else if(g.type==="array"&&typeof b=="number"&&Array.isArray(g.children))if(k!==void 0){const d=`${JSON.stringify(k)}`;let u;if(g.children.length===0||b===0)u={offset:g.offset+1,length:0,content:g.children.length===0?d:d+","};else{const a=b===-1||b>g.children.length?g.children.length:b,t=g.children[a-1];u={offset:t.offset+t.length,length:0,content:","+d}}return C(i,u,w)}else{const d=b,u=g.children[d];let a;if(g.children.length===1)a={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===d){const t=g.children[d-1],r=t.offset+t.length,s=g.offset+g.length;a={offset:r,length:s-2-r,content:""}}else a={offset:u.offset,length:g.children[d+1].offset-u.offset,content:""};return C(i,a,w)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${g.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return C(i,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(k)},w)}}e.setProperty=I;function C(i,T,k){let w=P(i,T),f=T.offset,l=T.offset+T.content.length;if(T.length===0||T.content.length===0){for(;f>0&&!(0,D.isEOL)(w,f-1);)f--;for(;l<w.length&&!(0,D.isEOL)(w,l);)l++}const m=(0,D.format)(w,{offset:f,length:l-f},k);for(let g=m.length-1;g>=0;g--){const b=m[g];w=P(w,b),f=Math.min(f,b.offset),l=Math.max(l,b.offset+b.length),l+=b.content.length-b.length}const S=i.length-(w.length-l)-f;return[{offset:f,length:S,content:w.substring(f,l)}]}e.withFormatting=C;function P(i,T){return i.substring(0,T.offset)+T.content+i.substring(T.offset+T.length)}e.applyEdit=P;function y(i,T){let k=T.slice(0).sort((f,l)=>{const m=f.offset-l.offset;return m===0?f.length-l.length:m}),w=i.length;for(let f=k.length-1;f>=0;f--){let l=k[f];if(l.offset+l.length<=w)i=P(i,l);else throw new Error("Overlapping edit");w=l.offset}return i}e.applyEdits=y}),define(me[131],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class _{constructor(R){this.executor=R,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(R){this._error=R}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(R){return new _(()=>R(this.getValue()))}}e.Lazy=_}),define(me[6],pe([0,1,70,72]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const R=!1;let I=null;function C(d){I=d}if(e.setDisposableTracker=C,R){const d="__is_disposable_tracked__";I=new class{trackDisposable(u){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[d]||console.log(a)},3e3)}markTracked(u){if(u&&u!==m.None)try{u[d]=!0}catch(a){}}}}function P(d){!I||I.markTracked(d)}function y(d){return I&&I.trackDisposable(d),d}e.trackDisposable=y;class i extends Error{constructor(u){super(`Encountered errors while disposing of store. Errors: [${u.join(", ")}]`);this.errors=u}}e.MultiDisposeError=i;function T(d){return typeof d.dispose=="function"&&d.dispose.length===0}e.isDisposable=T;function k(d){if(D.Iterable.is(d)){let u=[];for(const a of d)if(a){P(a);try{a.dispose()}catch(t){u.push(t)}}if(u.length===1)throw u[0];if(u.length>1)throw new i(u);return Array.isArray(d)?[]:d}else if(d)return P(d),d.dispose(),d}e.dispose=k;function w(...d){return d.forEach(P),f(()=>k(d))}e.combinedDisposable=w;function f(d){const u=y({dispose:()=>{P(u),d()}});return u}e.toDisposable=f;class l{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}clear(){try{k(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return P(u),this._isDisposed?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=l,l.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new l,y(this)}dispose(){P(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){var a;this._isDisposed||u===this._value||((a=this._value)===null||a===void 0||a.dispose(),u&&P(u),this._value=u)}clear(){this.value=void 0}dispose(){var u;this._isDisposed=!0,P(this),(u=this._value)===null||u===void 0||u.dispose(),this._value=void 0}}e.MutableDisposable=S;class g{constructor(){this.references=new Map}acquire(u,...a){let t=this.references.get(u);t||(t={counter:0,object:this.createReferencedObject(u,...a)},this.references.set(u,t));const{object:r}=t,s=(0,_.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(u,t.object),this.references.delete(u))});return t.counter++,{object:r,dispose:s}}}e.ReferenceCollection=g;class b{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=b}),define(me[57],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class _{constructor(I){this.element=I,this.next=_.Undefined,this.prev=_.Undefined}}_.Undefined=new _(void 0);class D{constructor(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===_.Undefined}clear(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}unshift(I){return this._insert(I,!1)}push(I){return this._insert(I,!0)}_insert(I,C){const P=new _(I);if(this._first===_.Undefined)this._first=P,this._last=P;else if(C){const i=this._last;this._last=P,P.prev=i,i.next=P}else{const i=this._first;this._first=P,P.next=i,i.prev=P}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(P))}}shift(){if(this._first!==_.Undefined){const I=this._first.element;return this._remove(this._first),I}}pop(){if(this._last!==_.Undefined){const I=this._last.element;return this._remove(this._last),I}}_remove(I){if(I.prev!==_.Undefined&&I.next!==_.Undefined){const C=I.prev;C.next=I.next,I.next.prev=C}else I.prev===_.Undefined&&I.next===_.Undefined?(this._first=_.Undefined,this._last=_.Undefined):I.next===_.Undefined?(this._last=this._last.prev,this._last.next=_.Undefined):I.prev===_.Undefined&&(this._first=this._first.next,this._first.prev=_.Undefined);this._size-=1}*[Symbol.iterator](){let I=this._first;for(;I!==_.Undefined;)yield I.element,I=I.next}}e.LinkedList=D}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,Z.marked=e())}(this,function(){"use strict";function Z(q,ae){for(var he=0;he<ae.length;he++){var Y=ae[he];Y.enumerable=Y.enumerable||!1,Y.configurable=!0,"value"in Y&&(Y.writable=!0),Object.defineProperty(q,Y.key,Y)}}function e(q,ae,he){return ae&&Z(q.prototype,ae),he&&Z(q,he),q}function _(q,ae){if(!!q){if(typeof q=="string")return D(q,ae);var he=Object.prototype.toString.call(q).slice(8,-1);if(he==="Object"&&q.constructor&&(he=q.constructor.name),he==="Map"||he==="Set")return Array.from(q);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return D(q,ae)}}function D(q,ae){(ae==null||ae>q.length)&&(ae=q.length);for(var he=0,Y=new Array(ae);he<ae;he++)Y[he]=q[he];return Y}function R(q,ae){var he;if(typeof Symbol=="undefined"||q[Symbol.iterator]==null){if(Array.isArray(q)||(he=_(q))||ae&&q&&typeof q.length=="number"){he&&(q=he);var Y=0;return function(){return Y>=q.length?{done:!0}:{done:!1,value:q[Y++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return he=q[Symbol.iterator](),he.next.bind(he)}function I(q){var ae={exports:{}};return q(ae,ae.exports),ae.exports}var C=I(function(q){function ae(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function he(Y){q.exports.defaults=Y}q.exports={defaults:ae(),getDefaults:ae,changeDefaults:he}}),P=/[&<>"']/,y=/[&<>"']/g,i=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,k={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(ae){return k[ae]};function f(q,ae){if(ae){if(P.test(q))return q.replace(y,w)}else if(i.test(q))return q.replace(T,w);return q}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(q){return q.replace(l,function(ae,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var S=/(^|[^\[])\^/g;function g(q,ae){q=q.source||q,ae=ae||"";var he={replace:function(re,ue){return ue=ue.source||ue,ue=ue.replace(S,"$1"),q=q.replace(re,ue),he},getRegex:function(){return new RegExp(q,ae)}};return he}var b=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(q,ae,he){if(q){var Y;try{Y=decodeURIComponent(m(he)).replace(b,"").toLowerCase()}catch(re){return null}if(Y.indexOf("javascript:")===0||Y.indexOf("vbscript:")===0||Y.indexOf("data:")===0)return null}ae&&!d.test(he)&&(he=o(ae,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch(re){return null}return he}var a={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(q,ae){a[" "+q]||(t.test(q)?a[" "+q]=q+"/":a[" "+q]=E(q,"/",!0)),q=a[" "+q];var he=q.indexOf(":")===-1;return ae.substring(0,2)==="//"?he?ae:q.replace(r,"$1")+ae:ae.charAt(0)==="/"?he?ae:q.replace(s,"$1")+ae:q+ae}var n={exec:function(){}};function c(q){for(var ae=1,he,Y;ae<arguments.length;ae++){he=arguments[ae];for(Y in he)Object.prototype.hasOwnProperty.call(he,Y)&&(q[Y]=he[Y])}return q}function p(q,ae){var he=q.replace(/\|/g,function(ue,fe,ye){for(var je=!1,We=fe;--We>=0&&ye[We]==="\\";)je=!je;return je?"|":" |"}),Y=he.split(/ \|/),re=0;if(Y.length>ae)Y.splice(ae);else for(;Y.length<ae;)Y.push("");for(;re<Y.length;re++)Y[re]=Y[re].trim().replace(/\\\|/g,"|");return Y}function E(q,ae,he){var Y=q.length;if(Y===0)return"";for(var re=0;re<Y;){var ue=q.charAt(Y-re-1);if(ue===ae&&!he)re++;else if(ue!==ae&&he)re++;else break}return q.substr(0,Y-re)}function h(q,ae){if(q.indexOf(ae[1])===-1)return-1;for(var he=q.length,Y=0,re=0;re<he;re++)if(q[re]==="\\")re++;else if(q[re]===ae[0])Y++;else if(q[re]===ae[1]&&(Y--,Y<0))return re;return-1}function v(q){q&&q.sanitize&&!q.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(q,ae){if(ae<1)return"";for(var he="";ae>1;)ae&1&&(he+=q),ae>>=1,q+=q;return he+q}var F={escape:f,unescape:m,edit:g,cleanUrl:u,resolveUrl:o,noopTest:n,merge:c,splitCells:p,rtrim:E,findClosingBracket:h,checkSanitizeDeprecation:v,repeatString:A},x=C.defaults,j=F.rtrim,G=F.splitCells,B=F.escape,J=F.findClosingBracket;function O(q,ae,he){var Y=ae.href,re=ae.title?B(ae.title):null,ue=q[1].replace(/\\([\[\]])/g,"$1");return q[0].charAt(0)!=="!"?{type:"link",raw:he,href:Y,title:re,text:ue}:{type:"image",raw:he,href:Y,title:re,text:B(ue)}}function N(q,ae){var he=q.match(/^(\s+)(?:```)/);if(he===null)return ae;var Y=he[1];return ae.split(`
`).map(function(re){var ue=re.match(/^\s+/);if(ue===null)return re;var fe=ue[0];return fe.length>=Y.length?re.slice(Y.length):re}).join(`
`)}var U=function(){function q(he){this.options=he||x}var ae=q.prototype;return ae.space=function(Y){var re=this.rules.block.newline.exec(Y);if(re)return re[0].length>1?{type:"space",raw:re[0]}:{raw:`
`}},ae.code=function(Y){var re=this.rules.block.code.exec(Y);if(re){var ue=re[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:re[0],codeBlockStyle:"indented",text:this.options.pedantic?ue:j(ue,`
`)}}},ae.fences=function(Y){var re=this.rules.block.fences.exec(Y);if(re){var ue=re[0],fe=N(ue,re[3]||"");return{type:"code",raw:ue,lang:re[2]?re[2].trim():re[2],text:fe}}},ae.heading=function(Y){var re=this.rules.block.heading.exec(Y);if(re){var ue=re[2].trim();if(/#$/.test(ue)){var fe=j(ue,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(ue=fe.trim())}return{type:"heading",raw:re[0],depth:re[1].length,text:ue}}},ae.nptable=function(Y){var re=this.rules.block.nptable.exec(Y);if(re){var ue={type:"table",header:G(re[1].replace(/^ *| *\| *$/g,"")),align:re[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:re[3]?re[3].replace(/\n$/,"").split(`
`):[],raw:re[0]};if(ue.header.length===ue.align.length){var fe=ue.align.length,ye;for(ye=0;ye<fe;ye++)/^ *-+: *$/.test(ue.align[ye])?ue.align[ye]="right":/^ *:-+: *$/.test(ue.align[ye])?ue.align[ye]="center":/^ *:-+ *$/.test(ue.align[ye])?ue.align[ye]="left":ue.align[ye]=null;for(fe=ue.cells.length,ye=0;ye<fe;ye++)ue.cells[ye]=G(ue.cells[ye],ue.header.length);return ue}}},ae.hr=function(Y){var re=this.rules.block.hr.exec(Y);if(re)return{type:"hr",raw:re[0]}},ae.blockquote=function(Y){var re=this.rules.block.blockquote.exec(Y);if(re){var ue=re[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:re[0],text:ue}}},ae.list=function(Y){var re=this.rules.block.list.exec(Y);if(re){var ue=re[0],fe=re[2],ye=fe.length>1,je={type:"list",raw:ue,ordered:ye,start:ye?+fe.slice(0,-1):"",loose:!1,items:[]},We=re[0].match(this.rules.block.item),ze=!1,Xe,nt,et,Je,_e,De,de,ee,Ae=We.length;et=this.rules.block.listItemStart.exec(We[0]);for(var Re=0;Re<Ae;Re++){if(Xe=We[Re],ue=Xe,Re!==Ae-1){if(Je=this.rules.block.listItemStart.exec(We[Re+1]),this.options.pedantic?Je[1].length>et[1].length:Je[1].length>et[0].length||Je[1].length>3){We.splice(Re,2,We[Re]+`
`+We[Re+1]),Re--,Ae--;continue}else(!this.options.pedantic||this.options.smartLists?Je[2][Je[2].length-1]!==fe[fe.length-1]:ye===(Je[2].length===1))&&(_e=We.slice(Re+1).join(`
`),je.raw=je.raw.substring(0,je.raw.length-_e.length),Re=Ae-1);et=Je}nt=Xe.length,Xe=Xe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Xe.indexOf(`
 `)&&(nt-=Xe.length,Xe=this.options.pedantic?Xe.replace(/^ {1,4}/gm,""):Xe.replace(new RegExp("^ {1,"+nt+"}","gm"),"")),De=ze||/\n\n(?!\s*$)/.test(Xe),Re!==Ae-1&&(ze=Xe.charAt(Xe.length-1)===`
`,De||(De=ze)),De&&(je.loose=!0),this.options.gfm&&(de=/^\[[ xX]\] /.test(Xe),ee=void 0,de&&(ee=Xe[1]!==" ",Xe=Xe.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:ue,task:de,checked:ee,loose:De,text:Xe})}return je}},ae.html=function(Y){var re=this.rules.block.html.exec(Y);if(re)return{type:this.options.sanitize?"paragraph":"html",raw:re[0],pre:!this.options.sanitizer&&(re[1]==="pre"||re[1]==="script"||re[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(re[0]):B(re[0]):re[0]}},ae.def=function(Y){var re=this.rules.block.def.exec(Y);if(re){re[3]&&(re[3]=re[3].substring(1,re[3].length-1));var ue=re[1].toLowerCase().replace(/\s+/g," ");return{tag:ue,raw:re[0],href:re[2],title:re[3]}}},ae.table=function(Y){var re=this.rules.block.table.exec(Y);if(re){var ue={type:"table",header:G(re[1].replace(/^ *| *\| *$/g,"")),align:re[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:re[3]?re[3].replace(/\n$/,"").split(`
`):[]};if(ue.header.length===ue.align.length){ue.raw=re[0];var fe=ue.align.length,ye;for(ye=0;ye<fe;ye++)/^ *-+: *$/.test(ue.align[ye])?ue.align[ye]="right":/^ *:-+: *$/.test(ue.align[ye])?ue.align[ye]="center":/^ *:-+ *$/.test(ue.align[ye])?ue.align[ye]="left":ue.align[ye]=null;for(fe=ue.cells.length,ye=0;ye<fe;ye++)ue.cells[ye]=G(ue.cells[ye].replace(/^ *\| *| *\| *$/g,""),ue.header.length);return ue}}},ae.lheading=function(Y){var re=this.rules.block.lheading.exec(Y);if(re)return{type:"heading",raw:re[0],depth:re[2].charAt(0)==="="?1:2,text:re[1]}},ae.paragraph=function(Y){var re=this.rules.block.paragraph.exec(Y);if(re)return{type:"paragraph",raw:re[0],text:re[1].charAt(re[1].length-1)===`
`?re[1].slice(0,-1):re[1]}},ae.text=function(Y){var re=this.rules.block.text.exec(Y);if(re)return{type:"text",raw:re[0],text:re[0]}},ae.escape=function(Y){var re=this.rules.inline.escape.exec(Y);if(re)return{type:"escape",raw:re[0],text:B(re[1])}},ae.tag=function(Y,re,ue){var fe=this.rules.inline.tag.exec(Y);if(fe)return!re&&/^<a /i.test(fe[0])?re=!0:re&&/^<\/a>/i.test(fe[0])&&(re=!1),!ue&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?ue=!0:ue&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(ue=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:re,inRawBlock:ue,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):B(fe[0]):fe[0]}},ae.link=function(Y){var re=this.rules.inline.link.exec(Y);if(re){var ue=re[2].trim();if(!this.options.pedantic&&/^</.test(ue)){if(!/>$/.test(ue))return;var fe=j(ue.slice(0,-1),"\\");if((ue.length-fe.length)%2==0)return}else{var ye=J(re[2],"()");if(ye>-1){var je=re[0].indexOf("!")===0?5:4,We=je+re[1].length+ye;re[2]=re[2].substring(0,ye),re[0]=re[0].substring(0,We).trim(),re[3]=""}}var ze=re[2],Xe="";if(this.options.pedantic){var nt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ze);nt&&(ze=nt[1],Xe=nt[3])}else Xe=re[3]?re[3].slice(1,-1):"";return ze=ze.trim(),/^</.test(ze)&&(this.options.pedantic&&!/>$/.test(ue)?ze=ze.slice(1):ze=ze.slice(1,-1)),O(re,{href:ze&&ze.replace(this.rules.inline._escapes,"$1"),title:Xe&&Xe.replace(this.rules.inline._escapes,"$1")},re[0])}},ae.reflink=function(Y,re){var ue;if((ue=this.rules.inline.reflink.exec(Y))||(ue=this.rules.inline.nolink.exec(Y))){var fe=(ue[2]||ue[1]).replace(/\s+/g," ");if(fe=re[fe.toLowerCase()],!fe||!fe.href){var ye=ue[0].charAt(0);return{type:"text",raw:ye,text:ye}}return O(ue,fe,ue[0])}},ae.emStrong=function(Y,re,ue){ue===void 0&&(ue="");var fe=this.rules.inline.emStrong.lDelim.exec(Y);if(!!fe&&!(fe[3]&&ue.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ye=fe[1]||fe[2]||"";if(!ye||ye&&(ue===""||this.rules.inline.punctuation.exec(ue))){var je=fe[0].length-1,We,ze,Xe=je,nt=0,et=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(et.lastIndex=0,re=re.slice(-1*Y.length+je);(fe=et.exec(re))!=null;)if(We=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!We){if(ze=We.length,fe[3]||fe[4]){Xe+=ze;continue}else if((fe[5]||fe[6])&&je%3&&!((je+ze)%3)){nt+=ze;continue}if(Xe-=ze,!(Xe>0)){if(Xe+nt-ze<=0&&!re.slice(et.lastIndex).match(et)&&(ze=Math.min(ze,ze+Xe+nt)),Math.min(je,ze)%2)return{type:"em",raw:Y.slice(0,je+fe.index+ze+1),text:Y.slice(1,je+fe.index+ze)};if(Math.min(je,ze)%2==0)return{type:"strong",raw:Y.slice(0,je+fe.index+ze+1),text:Y.slice(2,je+fe.index+ze-1)}}}}}},ae.codespan=function(Y){var re=this.rules.inline.code.exec(Y);if(re){var ue=re[2].replace(/\n/g," "),fe=/[^ ]/.test(ue),ye=/^ /.test(ue)&&/ $/.test(ue);return fe&&ye&&(ue=ue.substring(1,ue.length-1)),ue=B(ue,!0),{type:"codespan",raw:re[0],text:ue}}},ae.br=function(Y){var re=this.rules.inline.br.exec(Y);if(re)return{type:"br",raw:re[0]}},ae.del=function(Y){var re=this.rules.inline.del.exec(Y);if(re)return{type:"del",raw:re[0],text:re[2]}},ae.autolink=function(Y,re){var ue=this.rules.inline.autolink.exec(Y);if(ue){var fe,ye;return ue[2]==="@"?(fe=B(this.options.mangle?re(ue[1]):ue[1]),ye="mailto:"+fe):(fe=B(ue[1]),ye=fe),{type:"link",raw:ue[0],text:fe,href:ye,tokens:[{type:"text",raw:fe,text:fe}]}}},ae.url=function(Y,re){var ue;if(ue=this.rules.inline.url.exec(Y)){var fe,ye;if(ue[2]==="@")fe=B(this.options.mangle?re(ue[0]):ue[0]),ye="mailto:"+fe;else{var je;do je=ue[0],ue[0]=this.rules.inline._backpedal.exec(ue[0])[0];while(je!==ue[0]);fe=B(ue[0]),ue[1]==="www."?ye="http://"+fe:ye=fe}return{type:"link",raw:ue[0],text:fe,href:ye,tokens:[{type:"text",raw:fe,text:fe}]}}},ae.inlineText=function(Y,re,ue){var fe=this.rules.inline.text.exec(Y);if(fe){var ye;return re?ye=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):B(fe[0]):fe[0]:ye=B(this.options.smartypants?ue(fe[0]):fe[0]),{type:"text",raw:fe[0],text:ye}}},q}(),L=F.noopTest,M=F.edit,V=F.merge,K={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:L,table:L,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};K._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,K._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,K.def=M(K.def).replace("label",K._label).replace("title",K._title).getRegex(),K.bullet=/(?:[*+-]|\d{1,9}[.)])/,K.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,K.item=M(K.item,"gm").replace(/bull/g,K.bullet).getRegex(),K.listItemStart=M(/^( *)(bull)/).replace("bull",K.bullet).getRegex(),K.list=M(K.list).replace(/bull/g,K.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+K.def.source+")").getRegex(),K._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",K._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,K.html=M(K.html,"i").replace("comment",K._comment).replace("tag",K._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),K.paragraph=M(K._paragraph).replace("hr",K.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",K._tag).getRegex(),K.blockquote=M(K.blockquote).replace("paragraph",K.paragraph).getRegex(),K.normal=V({},K),K.gfm=V({},K.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),K.gfm.nptable=M(K.gfm.nptable).replace("hr",K.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",K._tag).getRegex(),K.gfm.table=M(K.gfm.table).replace("hr",K.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",K._tag).getRegex(),K.pedantic=V({},K.normal,{html:M(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",K._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:L,paragraph:M(K.normal._paragraph).replace("hr",K.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",K.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var se={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:L,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:L,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};se._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",se.punctuation=M(se.punctuation).replace(/punctuation/g,se._punctuation).getRegex(),se.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,se.escapedEmSt=/\\\*|\\_/g,se._comment=M(K._comment).replace("(?:-->|$)","-->").getRegex(),se.emStrong.lDelim=M(se.emStrong.lDelim).replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimAst=M(se.emStrong.rDelimAst,"g").replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimUnd=M(se.emStrong.rDelimUnd,"g").replace(/punct/g,se._punctuation).getRegex(),se._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,se._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,se._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,se.autolink=M(se.autolink).replace("scheme",se._scheme).replace("email",se._email).getRegex(),se._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,se.tag=M(se.tag).replace("comment",se._comment).replace("attribute",se._attribute).getRegex(),se._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,se._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,se._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,se.link=M(se.link).replace("label",se._label).replace("href",se._href).replace("title",se._title).getRegex(),se.reflink=M(se.reflink).replace("label",se._label).getRegex(),se.reflinkSearch=M(se.reflinkSearch,"g").replace("reflink",se.reflink).replace("nolink",se.nolink).getRegex(),se.normal=V({},se),se.pedantic=V({},se.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:M(/^!?\[(label)\]\((.*?)\)/).replace("label",se._label).getRegex(),reflink:M(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",se._label).getRegex()}),se.gfm=V({},se.normal,{escape:M(se.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),se.gfm.url=M(se.gfm.url,"i").replace("email",se.gfm._extended_email).getRegex(),se.breaks=V({},se.gfm,{br:M(se.br).replace("{2,}","*").getRegex(),text:M(se.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ce={block:K,inline:se},we=C.defaults,Te=ce.block,Ie=ce.inline,Me=F.repeatString;function H(q){return q.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Q(q){var ae="",he,Y,re=q.length;for(he=0;he<re;he++)Y=q.charCodeAt(he),Math.random()>.5&&(Y="x"+Y.toString(16)),ae+="&#"+Y+";";return ae}var ne=function(){function q(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||we,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var Y={block:Te.normal,inline:Ie.normal};this.options.pedantic?(Y.block=Te.pedantic,Y.inline=Ie.pedantic):this.options.gfm&&(Y.block=Te.gfm,this.options.breaks?Y.inline=Ie.breaks:Y.inline=Ie.gfm),this.tokenizer.rules=Y}q.lex=function(Y,re){var ue=new q(re);return ue.lex(Y)},q.lexInline=function(Y,re){var ue=new q(re);return ue.inlineTokens(Y)};var ae=q.prototype;return ae.lex=function(Y){return Y=Y.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Y,this.tokens,!0),this.inline(this.tokens),this.tokens},ae.blockTokens=function(Y,re,ue){re===void 0&&(re=[]),ue===void 0&&(ue=!0),this.options.pedantic&&(Y=Y.replace(/^ +$/gm,""));for(var fe,ye,je,We;Y;){if(fe=this.tokenizer.space(Y)){Y=Y.substring(fe.raw.length),fe.type&&re.push(fe);continue}if(fe=this.tokenizer.code(Y)){Y=Y.substring(fe.raw.length),We=re[re.length-1],We&&We.type==="paragraph"?(We.raw+=`
`+fe.raw,We.text+=`
`+fe.text):re.push(fe);continue}if(fe=this.tokenizer.fences(Y)){Y=Y.substring(fe.raw.length),re.push(fe);continue}if(fe=this.tokenizer.heading(Y)){Y=Y.substring(fe.raw.length),re.push(fe);continue}if(fe=this.tokenizer.nptable(Y)){Y=Y.substring(fe.raw.length),re.push(fe);continue}if(fe=this.tokenizer.hr(Y)){Y=Y.substring(fe.raw.length),re.push(fe);continue}if(fe=this.tokenizer.blockquote(Y)){Y=Y.substring(fe.raw.length),fe.tokens=this.blockTokens(fe.text,[],ue),re.push(fe);continue}if(fe=this.tokenizer.list(Y)){for(Y=Y.substring(fe.raw.length),je=fe.items.length,ye=0;ye<je;ye++)fe.items[ye].tokens=this.blockTokens(fe.items[ye].text,[],!1);re.push(fe);continue}if(fe=this.tokenizer.html(Y)){Y=Y.substring(fe.raw.length),re.push(fe);continue}if(ue&&(fe=this.tokenizer.def(Y))){Y=Y.substring(fe.raw.length),this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(Y)){Y=Y.substring(fe.raw.length),re.push(fe);continue}if(fe=this.tokenizer.lheading(Y)){Y=Y.substring(fe.raw.length),re.push(fe);continue}if(ue&&(fe=this.tokenizer.paragraph(Y))){Y=Y.substring(fe.raw.length),re.push(fe);continue}if(fe=this.tokenizer.text(Y)){Y=Y.substring(fe.raw.length),We=re[re.length-1],We&&We.type==="text"?(We.raw+=`
`+fe.raw,We.text+=`
`+fe.text):re.push(fe);continue}if(Y){var ze="Infinite loop on byte: "+Y.charCodeAt(0);if(this.options.silent){console.error(ze);break}else throw new Error(ze)}}return re},ae.inline=function(Y){var re,ue,fe,ye,je,We,ze=Y.length;for(re=0;re<ze;re++)switch(We=Y[re],We.type){case"paragraph":case"text":case"heading":{We.tokens=[],this.inlineTokens(We.text,We.tokens);break}case"table":{for(We.tokens={header:[],cells:[]},ye=We.header.length,ue=0;ue<ye;ue++)We.tokens.header[ue]=[],this.inlineTokens(We.header[ue],We.tokens.header[ue]);for(ye=We.cells.length,ue=0;ue<ye;ue++)for(je=We.cells[ue],We.tokens.cells[ue]=[],fe=0;fe<je.length;fe++)We.tokens.cells[ue][fe]=[],this.inlineTokens(je[fe],We.tokens.cells[ue][fe]);break}case"blockquote":{this.inline(We.tokens);break}case"list":{for(ye=We.items.length,ue=0;ue<ye;ue++)this.inline(We.items[ue].tokens);break}}return Y},ae.inlineTokens=function(Y,re,ue,fe){re===void 0&&(re=[]),ue===void 0&&(ue=!1),fe===void 0&&(fe=!1);var ye,je,We=Y,ze,Xe,nt;if(this.tokens.links){var et=Object.keys(this.tokens.links);if(et.length>0)for(;(ze=this.tokenizer.rules.inline.reflinkSearch.exec(We))!=null;)et.includes(ze[0].slice(ze[0].lastIndexOf("[")+1,-1))&&(We=We.slice(0,ze.index)+"["+Me("a",ze[0].length-2)+"]"+We.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ze=this.tokenizer.rules.inline.blockSkip.exec(We))!=null;)We=We.slice(0,ze.index)+"["+Me("a",ze[0].length-2)+"]"+We.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ze=this.tokenizer.rules.inline.escapedEmSt.exec(We))!=null;)We=We.slice(0,ze.index)+"++"+We.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Y;){if(Xe||(nt=""),Xe=!1,ye=this.tokenizer.escape(Y)){Y=Y.substring(ye.raw.length),re.push(ye);continue}if(ye=this.tokenizer.tag(Y,ue,fe)){Y=Y.substring(ye.raw.length),ue=ye.inLink,fe=ye.inRawBlock;var Je=re[re.length-1];Je&&ye.type==="text"&&Je.type==="text"?(Je.raw+=ye.raw,Je.text+=ye.text):re.push(ye);continue}if(ye=this.tokenizer.link(Y)){Y=Y.substring(ye.raw.length),ye.type==="link"&&(ye.tokens=this.inlineTokens(ye.text,[],!0,fe)),re.push(ye);continue}if(ye=this.tokenizer.reflink(Y,this.tokens.links)){Y=Y.substring(ye.raw.length);var _e=re[re.length-1];ye.type==="link"?(ye.tokens=this.inlineTokens(ye.text,[],!0,fe),re.push(ye)):_e&&ye.type==="text"&&_e.type==="text"?(_e.raw+=ye.raw,_e.text+=ye.text):re.push(ye);continue}if(ye=this.tokenizer.emStrong(Y,We,nt)){Y=Y.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],ue,fe),re.push(ye);continue}if(ye=this.tokenizer.codespan(Y)){Y=Y.substring(ye.raw.length),re.push(ye);continue}if(ye=this.tokenizer.br(Y)){Y=Y.substring(ye.raw.length),re.push(ye);continue}if(ye=this.tokenizer.del(Y)){Y=Y.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],ue,fe),re.push(ye);continue}if(ye=this.tokenizer.autolink(Y,Q)){Y=Y.substring(ye.raw.length),re.push(ye);continue}if(!ue&&(ye=this.tokenizer.url(Y,Q))){Y=Y.substring(ye.raw.length),re.push(ye);continue}if(ye=this.tokenizer.inlineText(Y,fe,H)){Y=Y.substring(ye.raw.length),ye.raw.slice(-1)!=="_"&&(nt=ye.raw.slice(-1)),Xe=!0,je=re[re.length-1],je&&je.type==="text"?(je.raw+=ye.raw,je.text+=ye.text):re.push(ye);continue}if(Y){var De="Infinite loop on byte: "+Y.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return re},e(q,null,[{key:"rules",get:function(){return{block:Te,inline:Ie}}}]),q}(),oe=C.defaults,ge=F.cleanUrl,Ce=F.escape,Oe=function(){function q(he){this.options=he||oe}var ae=q.prototype;return ae.code=function(Y,re,ue){var fe=(re||"").match(/\S*/)[0];if(this.options.highlight){var ye=this.options.highlight(Y,fe);ye!=null&&ye!==Y&&(ue=!0,Y=ye)}return Y=Y.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+Ce(fe,!0)+'">'+(ue?Y:Ce(Y,!0))+`</code></pre>
`:"<pre><code>"+(ue?Y:Ce(Y,!0))+`</code></pre>
`},ae.blockquote=function(Y){return`<blockquote>
`+Y+`</blockquote>
`},ae.html=function(Y){return Y},ae.heading=function(Y,re,ue,fe){return this.options.headerIds?"<h"+re+' id="'+this.options.headerPrefix+fe.slug(ue)+'">'+Y+"</h"+re+`>
`:"<h"+re+">"+Y+"</h"+re+`>
`},ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ae.list=function(Y,re,ue){var fe=re?"ol":"ul",ye=re&&ue!==1?' start="'+ue+'"':"";return"<"+fe+ye+`>
`+Y+"</"+fe+`>
`},ae.listitem=function(Y){return"<li>"+Y+`</li>
`},ae.checkbox=function(Y){return"<input "+(Y?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ae.paragraph=function(Y){return"<p>"+Y+`</p>
`},ae.table=function(Y,re){return re&&(re="<tbody>"+re+"</tbody>"),`<table>
<thead>
`+Y+`</thead>
`+re+`</table>
`},ae.tablerow=function(Y){return`<tr>
`+Y+`</tr>
`},ae.tablecell=function(Y,re){var ue=re.header?"th":"td",fe=re.align?"<"+ue+' align="'+re.align+'">':"<"+ue+">";return fe+Y+"</"+ue+`>
`},ae.strong=function(Y){return"<strong>"+Y+"</strong>"},ae.em=function(Y){return"<em>"+Y+"</em>"},ae.codespan=function(Y){return"<code>"+Y+"</code>"},ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},ae.del=function(Y){return"<del>"+Y+"</del>"},ae.link=function(Y,re,ue){if(Y=ge(this.options.sanitize,this.options.baseUrl,Y),Y===null)return ue;var fe='<a href="'+Ce(Y)+'"';return re&&(fe+=' title="'+re+'"'),fe+=">"+ue+"</a>",fe},ae.image=function(Y,re,ue){if(Y=ge(this.options.sanitize,this.options.baseUrl,Y),Y===null)return ue;var fe='<img src="'+Y+'" alt="'+ue+'"';return re&&(fe+=' title="'+re+'"'),fe+=this.options.xhtml?"/>":">",fe},ae.text=function(Y){return Y},q}(),ve=function(){function q(){}var ae=q.prototype;return ae.strong=function(Y){return Y},ae.em=function(Y){return Y},ae.codespan=function(Y){return Y},ae.del=function(Y){return Y},ae.html=function(Y){return Y},ae.text=function(Y){return Y},ae.link=function(Y,re,ue){return""+ue},ae.image=function(Y,re,ue){return""+ue},ae.br=function(){return""},q}(),ke=function(){function q(){this.seen={}}var ae=q.prototype;return ae.serialize=function(Y){return Y.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ae.getNextSafeSlug=function(Y,re){var ue=Y,fe=0;if(this.seen.hasOwnProperty(ue)){fe=this.seen[Y];do fe++,ue=Y+"-"+fe;while(this.seen.hasOwnProperty(ue))}return re||(this.seen[Y]=fe,this.seen[ue]=0),ue},ae.slug=function(Y,re){re===void 0&&(re={});var ue=this.serialize(Y);return this.getNextSafeSlug(ue,re.dryrun)},q}(),Pe=C.defaults,Ue=F.unescape,Se=function(){function q(he){this.options=he||Pe,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ve,this.slugger=new ke}q.parse=function(Y,re){var ue=new q(re);return ue.parse(Y)},q.parseInline=function(Y,re){var ue=new q(re);return ue.parseInline(Y)};var ae=q.prototype;return ae.parse=function(Y,re){re===void 0&&(re=!0);var ue="",fe,ye,je,We,ze,Xe,nt,et,Je,_e,De,de,ee,Ae,Re,Ze,Le,it,st=Y.length;for(fe=0;fe<st;fe++)switch(_e=Y[fe],_e.type){case"space":continue;case"hr":{ue+=this.renderer.hr();continue}case"heading":{ue+=this.renderer.heading(this.parseInline(_e.tokens),_e.depth,Ue(this.parseInline(_e.tokens,this.textRenderer)),this.slugger);continue}case"code":{ue+=this.renderer.code(_e.text,_e.lang,_e.escaped);continue}case"table":{for(et="",nt="",We=_e.header.length,ye=0;ye<We;ye++)nt+=this.renderer.tablecell(this.parseInline(_e.tokens.header[ye]),{header:!0,align:_e.align[ye]});for(et+=this.renderer.tablerow(nt),Je="",We=_e.cells.length,ye=0;ye<We;ye++){for(Xe=_e.tokens.cells[ye],nt="",ze=Xe.length,je=0;je<ze;je++)nt+=this.renderer.tablecell(this.parseInline(Xe[je]),{header:!1,align:_e.align[je]});Je+=this.renderer.tablerow(nt)}ue+=this.renderer.table(et,Je);continue}case"blockquote":{Je=this.parse(_e.tokens),ue+=this.renderer.blockquote(Je);continue}case"list":{for(De=_e.ordered,de=_e.start,ee=_e.loose,We=_e.items.length,Je="",ye=0;ye<We;ye++)Re=_e.items[ye],Ze=Re.checked,Le=Re.task,Ae="",Re.task&&(it=this.renderer.checkbox(Ze),ee?Re.tokens.length>0&&Re.tokens[0].type==="text"?(Re.tokens[0].text=it+" "+Re.tokens[0].text,Re.tokens[0].tokens&&Re.tokens[0].tokens.length>0&&Re.tokens[0].tokens[0].type==="text"&&(Re.tokens[0].tokens[0].text=it+" "+Re.tokens[0].tokens[0].text)):Re.tokens.unshift({type:"text",text:it}):Ae+=it),Ae+=this.parse(Re.tokens,ee),Je+=this.renderer.listitem(Ae,Le,Ze);ue+=this.renderer.list(Je,De,de);continue}case"html":{ue+=this.renderer.html(_e.text);continue}case"paragraph":{ue+=this.renderer.paragraph(this.parseInline(_e.tokens));continue}case"text":{for(Je=_e.tokens?this.parseInline(_e.tokens):_e.text;fe+1<st&&Y[fe+1].type==="text";)_e=Y[++fe],Je+=`
`+(_e.tokens?this.parseInline(_e.tokens):_e.text);ue+=re?this.renderer.paragraph(Je):Je;continue}default:{var Ke='Token with "'+_e.type+'" type was not found.';if(this.options.silent){console.error(Ke);return}else throw new Error(Ke)}}return ue},ae.parseInline=function(Y,re){re=re||this.renderer;var ue="",fe,ye,je=Y.length;for(fe=0;fe<je;fe++)switch(ye=Y[fe],ye.type){case"escape":{ue+=re.text(ye.text);break}case"html":{ue+=re.html(ye.text);break}case"link":{ue+=re.link(ye.href,ye.title,this.parseInline(ye.tokens,re));break}case"image":{ue+=re.image(ye.href,ye.title,ye.text);break}case"strong":{ue+=re.strong(this.parseInline(ye.tokens,re));break}case"em":{ue+=re.em(this.parseInline(ye.tokens,re));break}case"codespan":{ue+=re.codespan(ye.text);break}case"br":{ue+=re.br();break}case"del":{ue+=re.del(this.parseInline(ye.tokens,re));break}case"text":{ue+=re.text(ye.text);break}default:{var We='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(We);return}else throw new Error(We)}}return ue},q}(),qe=F.merge,X=F.checkSanitizeDeprecation,ie=F.escape,Ee=C.getDefaults,Ne=C.changeDefaults,He=C.defaults;function Be(q,ae,he){if(typeof q=="undefined"||q===null)throw new Error("marked(): input parameter is undefined or null");if(typeof q!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(q)+", string expected");if(typeof ae=="function"&&(he=ae,ae=null),ae=qe({},Be.defaults,ae||{}),X(ae),he){var Y=ae.highlight,re;try{re=ne.lex(q,ae)}catch(je){return he(je)}var ue=function(We){var ze;if(!We)try{ze=Se.parse(re,ae)}catch(Xe){We=Xe}return ae.highlight=Y,We?he(We):he(null,ze)};if(!Y||Y.length<3||(delete ae.highlight,!re.length))return ue();var fe=0;Be.walkTokens(re,function(je){je.type==="code"&&(fe++,setTimeout(function(){Y(je.text,je.lang,function(We,ze){if(We)return ue(We);ze!=null&&ze!==je.text&&(je.text=ze,je.escaped=!0),fe--,fe===0&&ue()})},0))}),fe===0&&ue();return}try{var ye=ne.lex(q,ae);return ae.walkTokens&&Be.walkTokens(ye,ae.walkTokens),Se.parse(ye,ae)}catch(je){if(je.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+ie(je.message+"",!0)+"</pre>";throw je}}Be.options=Be.setOptions=function(q){return qe(Be.defaults,q),Ne(Be.defaults),Be},Be.getDefaults=Ee,Be.defaults=He,Be.use=function(q){var ae=qe({},q);if(q.renderer&&function(){var Y=Be.defaults.renderer||new Oe,re=function(ye){var je=Y[ye];Y[ye]=function(){for(var We=arguments.length,ze=new Array(We),Xe=0;Xe<We;Xe++)ze[Xe]=arguments[Xe];var nt=q.renderer[ye].apply(Y,ze);return nt===!1&&(nt=je.apply(Y,ze)),nt}};for(var ue in q.renderer)re(ue);ae.renderer=Y}(),q.tokenizer&&function(){var Y=Be.defaults.tokenizer||new U,re=function(ye){var je=Y[ye];Y[ye]=function(){for(var We=arguments.length,ze=new Array(We),Xe=0;Xe<We;Xe++)ze[Xe]=arguments[Xe];var nt=q.tokenizer[ye].apply(Y,ze);return nt===!1&&(nt=je.apply(Y,ze)),nt}};for(var ue in q.tokenizer)re(ue);ae.tokenizer=Y}(),q.walkTokens){var he=Be.defaults.walkTokens;ae.walkTokens=function(Y){q.walkTokens(Y),he&&he(Y)}}Be.setOptions(ae)},Be.walkTokens=function(q,ae){for(var he=R(q),Y;!(Y=he()).done;){var re=Y.value;switch(ae(re),re.type){case"table":{for(var ue=R(re.tokens.header),fe;!(fe=ue()).done;){var ye=fe.value;Be.walkTokens(ye,ae)}for(var je=R(re.tokens.cells),We;!(We=je()).done;)for(var ze=We.value,Xe=R(ze),nt;!(nt=Xe()).done;){var et=nt.value;Be.walkTokens(et,ae)}break}case"list":{Be.walkTokens(re.items,ae);break}default:re.tokens&&Be.walkTokens(re.tokens,ae)}}},Be.parseInline=function(q,ae){if(typeof q=="undefined"||q===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof q!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(q)+", string expected");ae=qe({},Be.defaults,ae||{}),X(ae);try{var he=ne.lexInline(q,ae);return ae.walkTokens&&Be.walkTokens(he,ae.walkTokens),Se.parseInline(he,ae)}catch(Y){if(Y.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+ie(Y.message+"",!0)+"</pre>";throw Y}},Be.Parser=Se,Be.parser=Se.parse,Be.Renderer=Oe,Be.TextRenderer=ve,Be.Lexer=ne,Be.lexer=ne.lex,Be.Tokenizer=U,Be.Slugger=ke,Be.parse=Be;var Ye=Be;return Ye}),define(me[73],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function _(C,P,y){return Math.min(Math.max(C,P),y)}e.clamp=_;function D(C,P){return(P+C%P)%P}e.rot=D;class R{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=R;class I{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=I});"use strict";(function(){function Z(R){const I=[];typeof R=="number"&&I.push("code/timeOrigin",R);function C(y){I.push(y,Date.now())}function P(){const y=[];for(let i=0;i<I.length;i+=2)y.push({name:I[i],startTime:I[i+1]});return y}return{mark:C,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const C of performance.getEntriesByType("mark"))I.push({name:C.name,startTime:Math.round(R+C.startTime)});return I}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function _(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return _(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=_(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=_(D))})(),define(me[10],pe([0,1]),function(Z,e){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.globals=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=void 0;const D="en";let R=!1,I=!1,C=!1,P=!1,y=!1,i=!1,T=!1,k,w=D,f,l;const m=typeof self=="object"?self:typeof global=="object"?global:{};let S;typeof process!="undefined"?S=process:typeof m.vscode!="undefined"&&(S=m.vscode.process);const g=typeof((_=S==null?void 0:S.versions)===null||_===void 0?void 0:_.electron)=="string"&&S.type==="renderer";if(e.isElectronSandboxed=g&&(S==null?void 0:S.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const n=S==null?void 0:S.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof n=="string")return n==="none"||n==="code"||n==="bypassHeatCheck"||n==="bypassHeatCheckAndEagerCompile"?n:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!g)l=navigator.userAgent,R=l.indexOf("Windows")>=0,I=l.indexOf("Macintosh")>=0,T=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=l.indexOf("Linux")>=0,i=!0,k=navigator.language,w=k;else if(typeof S=="object"){R=S.platform==="win32",I=S.platform==="darwin",C=S.platform==="linux",P=C&&!!S.env.SNAP&&!!S.env.SNAP_REVISION,k=D,w=D;const n=S.env.VSCODE_NLS_CONFIG;if(n)try{const c=JSON.parse(n),p=c.availableLanguages["*"];k=c.locale,w=p||D,f=c._translationsConfigFile}catch(c){}y=!0}else console.error("Unable to resolve platform.");var b;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function d(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=d;let u=0;I?u=1:R?u=3:C&&(u=2),e.isWindows=R,e.isMacintosh=I,e.isLinux=C,e.isLinuxSnap=P,e.isNative=y,e.isWeb=i,e.isIOS=T,e.platform=u,e.userAgent=l,e.language=w;var a;(function(n){function c(){return e.language}n.value=c;function p(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=p;function E(){return e.language==="en"}n.isDefault=E})(a=e.Language||(e.Language={})),e.locale=k,e.translationsConfigFile=f,e.globals=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let p=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeSetImmediateId)for(let v=0,A=p.length;v<A;v++){const F=p[v];if(F.id===h.data.vscodeSetImmediateId){p.splice(v,1),F.callback();return}}});let E=0;return h=>{const v=++E;p.push({id:v,callback:h}),e.globals.postMessage({vscodeSetImmediateId:v},"*")}}if(S&&typeof S.nextTick=="function")return S.nextTick.bind(S);const c=Promise.resolve();return p=>c.then(p)}();var t;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||T?2:R?1:3;let r=!0,s=!1;function o(){if(!s){s=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,r=new Uint16Array(n.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=o}),define(me[37],pe([0,1,10]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let D;typeof process!="undefined"?D=process:typeof _.globals.vscode!="undefined"?D={get platform(){return _.globals.vscode.process.platform},get env(){return _.globals.vscode.process.env},nextTick(R){return(0,_.setImmediate)(R)},cwd(){return _.globals.vscode.process.env.VSCODE_CWD||_.globals.vscode.process.execPath.substr(0,_.globals.vscode.process.execPath.lastIndexOf(_.globals.vscode.process.platform==="win32"?"\\":"/"))}}:D={get platform(){return _.isWindows?"win32":_.isMacintosh?"darwin":"linux"},nextTick(R){return(0,_.setImmediate)(R)},get env(){return Object.create(null)},cwd(){return"/"}},e.cwd=D.cwd,e.env=D.env,e.platform=D.platform,e.nextTick=D.nextTick}),define(me[7],pe([0,1,37]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const D=65,R=97,I=90,C=122,P=46,y=47,i=92,T=58,k=63;class w extends Error{constructor(u,a,t){let r;typeof a=="string"&&a.indexOf("not ")===0?(r="must not be",a=a.replace(/^not /,"")):r="must be";const s=u.indexOf(".")!==-1?"property":"argument";let o=`The "${u}" ${s} ${r} of type ${a}`;o+=`. Received type ${typeof t}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function f(d,u){if(typeof d!="string")throw new w(u,"string",d)}function l(d){return d===y||d===i}function m(d){return d===y}function S(d){return d>=D&&d<=I||d>=R&&d<=C}function g(d,u,a,t){let r="",s=0,o=-1,n=0,c=0;for(let p=0;p<=d.length;++p){if(p<d.length)c=d.charCodeAt(p);else{if(t(c))break;c=y}if(t(c)){if(!(o===p-1||n===1))if(n===2){if(r.length<2||s!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const E=r.lastIndexOf(a);E===-1?(r="",s=0):(r=r.slice(0,E),s=r.length-1-r.lastIndexOf(a)),o=p,n=0;continue}else if(r.length!==0){r="",s=0,o=p,n=0;continue}}u&&(r+=r.length>0?`${a}..`:"..",s=2)}else r.length>0?r+=`${a}${d.slice(o+1,p)}`:r=d.slice(o+1,p),s=p-o-1;o=p,n=0}else c===P&&n!==-1?++n:n=-1}return r}function b(d,u){if(u===null||typeof u!="object")throw new w("pathObject","Object",u);const a=u.dir||u.root,t=u.base||`${u.name||""}${u.ext||""}`;return a?a===u.root?`${a}${t}`:`${a}${d}${t}`:t}e.win32={resolve(...d){let u="",a="",t=!1;for(let r=d.length-1;r>=-1;r--){let s;if(r>=0){if(s=d[r],f(s,"path"),s.length===0)continue}else u.length===0?s=_.cwd():(s=_.env[`=${u}`]||_.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==u.toLowerCase()&&s.charCodeAt(2)===i)&&(s=`${u}\\`));const o=s.length;let n=0,c="",p=!1;const E=s.charCodeAt(0);if(o===1)l(E)&&(n=1,p=!0);else if(l(E))if(p=!0,l(s.charCodeAt(1))){let h=2,v=h;for(;h<o&&!l(s.charCodeAt(h));)h++;if(h<o&&h!==v){const A=s.slice(v,h);for(v=h;h<o&&l(s.charCodeAt(h));)h++;if(h<o&&h!==v){for(v=h;h<o&&!l(s.charCodeAt(h));)h++;(h===o||h!==v)&&(c=`\\\\${A}\\${s.slice(v,h)}`,n=h)}}}else n=1;else S(E)&&s.charCodeAt(1)===T&&(c=s.slice(0,2),n=2,o>2&&l(s.charCodeAt(2))&&(p=!0,n=3));if(c.length>0)if(u.length>0){if(c.toLowerCase()!==u.toLowerCase())continue}else u=c;if(t){if(u.length>0)break}else if(a=`${s.slice(n)}\\${a}`,t=p,p&&u.length>0)break}return a=g(a,!t,"\\",l),t?`${u}\\${a}`:`${u}${a}`||"."},normalize(d){f(d,"path");const u=d.length;if(u===0)return".";let a=0,t,r=!1;const s=d.charCodeAt(0);if(u===1)return m(s)?"\\":d;if(l(s))if(r=!0,l(d.charCodeAt(1))){let n=2,c=n;for(;n<u&&!l(d.charCodeAt(n));)n++;if(n<u&&n!==c){const p=d.slice(c,n);for(c=n;n<u&&l(d.charCodeAt(n));)n++;if(n<u&&n!==c){for(c=n;n<u&&!l(d.charCodeAt(n));)n++;if(n===u)return`\\\\${p}\\${d.slice(c)}\\`;n!==c&&(t=`\\\\${p}\\${d.slice(c,n)}`,a=n)}}}else a=1;else S(s)&&d.charCodeAt(1)===T&&(t=d.slice(0,2),a=2,u>2&&l(d.charCodeAt(2))&&(r=!0,a=3));let o=a<u?g(d.slice(a),!r,"\\",l):"";return o.length===0&&!r&&(o="."),o.length>0&&l(d.charCodeAt(u-1))&&(o+="\\"),t===void 0?r?`\\${o}`:o:r?`${t}\\${o}`:`${t}${o}`},isAbsolute(d){f(d,"path");const u=d.length;if(u===0)return!1;const a=d.charCodeAt(0);return l(a)||u>2&&S(a)&&d.charCodeAt(1)===T&&l(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let u,a;for(let s=0;s<d.length;++s){const o=d[s];f(o,"path"),o.length>0&&(u===void 0?u=a=o:u+=`\\${o}`)}if(u===void 0)return".";let t=!0,r=0;if(typeof a=="string"&&l(a.charCodeAt(0))){++r;const s=a.length;s>1&&l(a.charCodeAt(1))&&(++r,s>2&&(l(a.charCodeAt(2))?++r:t=!1))}if(t){for(;r<u.length&&l(u.charCodeAt(r));)r++;r>=2&&(u=`\\${u.slice(r)}`)}return e.win32.normalize(u)},relative(d,u){if(f(d,"from"),f(u,"to"),d===u)return"";const a=e.win32.resolve(d),t=e.win32.resolve(u);if(a===t||(d=a.toLowerCase(),u=t.toLowerCase(),d===u))return"";let r=0;for(;r<d.length&&d.charCodeAt(r)===i;)r++;let s=d.length;for(;s-1>r&&d.charCodeAt(s-1)===i;)s--;const o=s-r;let n=0;for(;n<u.length&&u.charCodeAt(n)===i;)n++;let c=u.length;for(;c-1>n&&u.charCodeAt(c-1)===i;)c--;const p=c-n,E=o<p?o:p;let h=-1,v=0;for(;v<E;v++){const F=d.charCodeAt(r+v);if(F!==u.charCodeAt(n+v))break;F===i&&(h=v)}if(v!==E){if(h===-1)return t}else{if(p>E){if(u.charCodeAt(n+v)===i)return t.slice(n+v+1);if(v===2)return t.slice(n+v)}o>E&&(d.charCodeAt(r+v)===i?h=v:v===2&&(h=3)),h===-1&&(h=0)}let A="";for(v=r+h+1;v<=s;++v)(v===s||d.charCodeAt(v)===i)&&(A+=A.length===0?"..":"\\..");return n+=h,A.length>0?`${A}${t.slice(n,c)}`:(t.charCodeAt(n)===i&&++n,t.slice(n,c))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const u=e.win32.resolve(d);if(u.length<=2)return d;if(u.charCodeAt(0)===i){if(u.charCodeAt(1)===i){const a=u.charCodeAt(2);if(a!==k&&a!==P)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(S(u.charCodeAt(0))&&u.charCodeAt(1)===T&&u.charCodeAt(2)===i)return`\\\\?\\${u}`;return d},dirname(d){f(d,"path");const u=d.length;if(u===0)return".";let a=-1,t=0;const r=d.charCodeAt(0);if(u===1)return l(r)?d:".";if(l(r)){if(a=t=1,l(d.charCodeAt(1))){let n=2,c=n;for(;n<u&&!l(d.charCodeAt(n));)n++;if(n<u&&n!==c){for(c=n;n<u&&l(d.charCodeAt(n));)n++;if(n<u&&n!==c){for(c=n;n<u&&!l(d.charCodeAt(n));)n++;if(n===u)return d;n!==c&&(a=t=n+1)}}}}else S(r)&&d.charCodeAt(1)===T&&(a=u>2&&l(d.charCodeAt(2))?3:2,t=a);let s=-1,o=!0;for(let n=u-1;n>=t;--n)if(l(d.charCodeAt(n))){if(!o){s=n;break}}else o=!1;if(s===-1){if(a===-1)return".";s=a}return d.slice(0,s)},basename(d,u){u!==void 0&&f(u,"ext"),f(d,"path");let a=0,t=-1,r=!0,s;if(d.length>=2&&S(d.charCodeAt(0))&&d.charCodeAt(1)===T&&(a=2),u!==void 0&&u.length>0&&u.length<=d.length){if(u===d)return"";let o=u.length-1,n=-1;for(s=d.length-1;s>=a;--s){const c=d.charCodeAt(s);if(l(c)){if(!r){a=s+1;break}}else n===-1&&(r=!1,n=s+1),o>=0&&(c===u.charCodeAt(o)?--o==-1&&(t=s):(o=-1,t=n))}return a===t?t=n:t===-1&&(t=d.length),d.slice(a,t)}for(s=d.length-1;s>=a;--s)if(l(d.charCodeAt(s))){if(!r){a=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":d.slice(a,t)},extname(d){f(d,"path");let u=0,a=-1,t=0,r=-1,s=!0,o=0;d.length>=2&&d.charCodeAt(1)===T&&S(d.charCodeAt(0))&&(u=t=2);for(let n=d.length-1;n>=u;--n){const c=d.charCodeAt(n);if(l(c)){if(!s){t=n+1;break}continue}r===-1&&(s=!1,r=n+1),c===P?a===-1?a=n:o!==1&&(o=1):a!==-1&&(o=-1)}return a===-1||r===-1||o===0||o===1&&a===r-1&&a===t+1?"":d.slice(a,r)},format:b.bind(null,"\\"),parse(d){f(d,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return u;const a=d.length;let t=0,r=d.charCodeAt(0);if(a===1)return l(r)?(u.root=u.dir=d,u):(u.base=u.name=d,u);if(l(r)){if(t=1,l(d.charCodeAt(1))){let h=2,v=h;for(;h<a&&!l(d.charCodeAt(h));)h++;if(h<a&&h!==v){for(v=h;h<a&&l(d.charCodeAt(h));)h++;if(h<a&&h!==v){for(v=h;h<a&&!l(d.charCodeAt(h));)h++;h===a?t=h:h!==v&&(t=h+1)}}}}else if(S(r)&&d.charCodeAt(1)===T){if(a<=2)return u.root=u.dir=d,u;if(t=2,l(d.charCodeAt(2))){if(a===3)return u.root=u.dir=d,u;t=3}}t>0&&(u.root=d.slice(0,t));let s=-1,o=t,n=-1,c=!0,p=d.length-1,E=0;for(;p>=t;--p){if(r=d.charCodeAt(p),l(r)){if(!c){o=p+1;break}continue}n===-1&&(c=!1,n=p+1),r===P?s===-1?s=p:E!==1&&(E=1):s!==-1&&(E=-1)}return n!==-1&&(s===-1||E===0||E===1&&s===n-1&&s===o+1?u.base=u.name=d.slice(o,n):(u.name=d.slice(o,s),u.base=d.slice(o,n),u.ext=d.slice(s,n))),o>0&&o!==t?u.dir=d.slice(0,o-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let u="",a=!1;for(let t=d.length-1;t>=-1&&!a;t--){const r=t>=0?d[t]:_.cwd();f(r,"path"),r.length!==0&&(u=`${r}/${u}`,a=r.charCodeAt(0)===y)}return u=g(u,!a,"/",m),a?`/${u}`:u.length>0?u:"."},normalize(d){if(f(d,"path"),d.length===0)return".";const u=d.charCodeAt(0)===y,a=d.charCodeAt(d.length-1)===y;return d=g(d,!u,"/",m),d.length===0?u?"/":a?"./":".":(a&&(d+="/"),u?`/${d}`:d)},isAbsolute(d){return f(d,"path"),d.length>0&&d.charCodeAt(0)===y},join(...d){if(d.length===0)return".";let u;for(let a=0;a<d.length;++a){const t=d[a];f(t,"path"),t.length>0&&(u===void 0?u=t:u+=`/${t}`)}return u===void 0?".":e.posix.normalize(u)},relative(d,u){if(f(d,"from"),f(u,"to"),d===u||(d=e.posix.resolve(d),u=e.posix.resolve(u),d===u))return"";const a=1,t=d.length,r=t-a,s=1,o=u.length-s,n=r<o?r:o;let c=-1,p=0;for(;p<n;p++){const h=d.charCodeAt(a+p);if(h!==u.charCodeAt(s+p))break;h===y&&(c=p)}if(p===n)if(o>n){if(u.charCodeAt(s+p)===y)return u.slice(s+p+1);if(p===0)return u.slice(s+p)}else r>n&&(d.charCodeAt(a+p)===y?c=p:p===0&&(c=0));let E="";for(p=a+c+1;p<=t;++p)(p===t||d.charCodeAt(p)===y)&&(E+=E.length===0?"..":"/..");return`${E}${u.slice(s+c)}`},toNamespacedPath(d){return d},dirname(d){if(f(d,"path"),d.length===0)return".";const u=d.charCodeAt(0)===y;let a=-1,t=!0;for(let r=d.length-1;r>=1;--r)if(d.charCodeAt(r)===y){if(!t){a=r;break}}else t=!1;return a===-1?u?"/":".":u&&a===1?"//":d.slice(0,a)},basename(d,u){u!==void 0&&f(u,"ext"),f(d,"path");let a=0,t=-1,r=!0,s;if(u!==void 0&&u.length>0&&u.length<=d.length){if(u===d)return"";let o=u.length-1,n=-1;for(s=d.length-1;s>=0;--s){const c=d.charCodeAt(s);if(c===y){if(!r){a=s+1;break}}else n===-1&&(r=!1,n=s+1),o>=0&&(c===u.charCodeAt(o)?--o==-1&&(t=s):(o=-1,t=n))}return a===t?t=n:t===-1&&(t=d.length),d.slice(a,t)}for(s=d.length-1;s>=0;--s)if(d.charCodeAt(s)===y){if(!r){a=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":d.slice(a,t)},extname(d){f(d,"path");let u=-1,a=0,t=-1,r=!0,s=0;for(let o=d.length-1;o>=0;--o){const n=d.charCodeAt(o);if(n===y){if(!r){a=o+1;break}continue}t===-1&&(r=!1,t=o+1),n===P?u===-1?u=o:s!==1&&(s=1):u!==-1&&(s=-1)}return u===-1||t===-1||s===0||s===1&&u===t-1&&u===a+1?"":d.slice(u,t)},format:b.bind(null,"/"),parse(d){f(d,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return u;const a=d.charCodeAt(0)===y;let t;a?(u.root="/",t=1):t=0;let r=-1,s=0,o=-1,n=!0,c=d.length-1,p=0;for(;c>=t;--c){const E=d.charCodeAt(c);if(E===y){if(!n){s=c+1;break}continue}o===-1&&(n=!1,o=c+1),E===P?r===-1?r=c:p!==1&&(p=1):r!==-1&&(p=-1)}if(o!==-1){const E=s===0&&a?1:s;r===-1||p===0||p===1&&r===o-1&&r===s+1?u.base=u.name=d.slice(E,o):(u.name=d.slice(E,r),u.base=d.slice(E,o),u.ext=d.slice(r,o))}return s>0?u.dir=d.slice(0,s-1):a&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=_.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=_.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=_.platform==="win32"?e.win32.join:e.posix.join,e.resolve=_.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=_.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=_.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=_.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=_.platform==="win32"?e.win32.extname:e.posix.extname,e.format=_.platform==="win32"?e.win32.format:e.posix.format,e.parse=_.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=_.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=_.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=_.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[132],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var _;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(_=e.Source||(e.Source={}));var D;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(I,...C){const P=C.reduce((T,k)=>(T[k]=!0,T),{}),y=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(T=>!P[T]).forEach(T=>{for(let k=0;k<y.length;k++)if(T.search(y[k])!==-1){delete I[T];break}})}e.sanitizeProcessEnvironment=R}),define(me[46],pe([0,1,10]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const D=_.globals.performance&&typeof _.globals.performance.now=="function";class R{constructor(C){this._highResolution=D&&C,this._startTime=this._now(),this._stopTime=-1}static create(C=!0){return new R(C)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?_.globals.performance.now():Date.now()}}e.StopWatch=R}),define(me[3],pe([0,1,18,70,6,57,46]),function(Z,e,_,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(g){g.None=()=>R.Disposable.None;function b(G){return(B,J=null,O)=>{let N=!1,U;return U=G(L=>{if(!N)return U?U.dispose():N=!0,B.call(J,L)},null,O),N&&U.dispose(),U}}g.once=b;function d(G,B){return o((J,O=null,N)=>G(U=>J.call(O,B(U)),null,N))}g.map=d;function u(G,B){return o((J,O=null,N)=>G(U=>{B(U),J.call(O,U)},null,N))}g.forEach=u;function a(G,B){return o((J,O=null,N)=>G(U=>B(U)&&J.call(O,U),null,N))}g.filter=a;function t(G){return G}g.signal=t;function r(...G){return(B,J=null,O)=>(0,R.combinedDisposable)(...G.map(N=>N(U=>B.call(J,U),null,O)))}g.any=r;function s(G,B,J){let O=J;return d(G,N=>(O=B(O,N),O))}g.reduce=s;function o(G){let B;const J=new w({onFirstListenerAdd(){B=G(J.fire,J)},onLastListenerRemove(){B.dispose()}});return J.event}g.snapshot=o;function n(G,B,J=100,O=!1,N){let U,L,M,V=0;const K=new w({leakWarningThreshold:N,onFirstListenerAdd(){U=G(se=>{V++,L=B(L,se),O&&!M&&(K.fire(L),L=void 0),clearTimeout(M),M=setTimeout(()=>{const ce=L;L=void 0,M=void 0,(!O||V>1)&&K.fire(ce),V=0},J)})},onLastListenerRemove(){U.dispose()}});return K.event}g.debounce=n;function c(G){const B=new Date().getTime();return d(b(G),J=>new Date().getTime()-B)}g.stopwatch=c;function p(G){let B=!0,J;return a(G,O=>{const N=B||O!==J;return B=!1,J=O,N})}g.latch=p;function E(G,B=!1,J=[]){let O=J.slice(),N=G(M=>{O?O.push(M):L.fire(M)});const U=()=>{O&&O.forEach(M=>L.fire(M)),O=null},L=new w({onFirstListenerAdd(){N||(N=G(M=>L.fire(M)))},onFirstListenerDidAdd(){O&&(B?setTimeout(U):U())},onLastListenerRemove(){N&&N.dispose(),N=null}});return L.event}g.buffer=E;class h{constructor(B){this.event=B}map(B){return new h(d(this.event,B))}forEach(B){return new h(u(this.event,B))}filter(B){return new h(a(this.event,B))}reduce(B,J){return new h(s(this.event,B,J))}latch(){return new h(p(this.event))}debounce(B,J=100,O=!1,N){return new h(n(this.event,B,J,O,N))}on(B,J,O){return this.event(B,J,O)}once(B,J,O){return b(this.event)(B,J,O)}}function v(G){return new h(G)}g.chain=v;function A(G,B,J=O=>O){const O=(...M)=>L.fire(J(...M)),N=()=>G.on(B,O),U=()=>G.removeListener(B,O),L=new w({onFirstListenerAdd:N,onLastListenerRemove:U});return L.event}g.fromNodeEventEmitter=A;function F(G,B,J=O=>O){const O=(...M)=>L.fire(J(...M)),N=()=>G.addEventListener(B,O),U=()=>G.removeEventListener(B,O),L=new w({onFirstListenerAdd:N,onLastListenerRemove:U});return L.event}g.fromDOMEventEmitter=F;function x(G){const B=new w;let J=!1;return G.then(void 0,()=>null).then(()=>{J?B.fire(void 0):setTimeout(()=>B.fire(void 0),0)}),J=!0,B.event}g.fromPromise=x;function j(G){return new Promise(B=>b(G)(B))}g.toPromise=j})(P=e.Event||(e.Event={}));class y{constructor(b){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${b}_${y._idPool++}`}start(b){this._stopWatch=new C.StopWatch(!0),this._listenerCount=b}stop(){if(this._stopWatch){const b=this._stopWatch.elapsed();this._elapsedOverall+=b,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${b.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let i=-1;function T(g){const b=i;return i=g,{dispose(){i=b}}}e.setGlobalLeakWarningThreshold=T;class k{constructor(b,d=Math.random().toString(18).slice(2,5)){this.customThreshold=b,this.name=d,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(b){let d=i;if(typeof this.customThreshold=="number"&&(d=this.customThreshold),!(d<=0||b<d)){this._stacks||(this._stacks=new Map);const u=new Error().stack.split(`
`).slice(3).join(`
`),a=this._stacks.get(u)||0;if(this._stacks.set(u,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=d*.5;let t,r=0;for(const[s,o]of this._stacks)(!t||r<o)&&(t=s,r=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${b} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(u)||0;this._stacks.set(u,t-1)}}}}class w{constructor(b){var d;this._disposed=!1,this._options=b,this._leakageMon=i>0?new k(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((d=this._options)===null||d===void 0?void 0:d._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(b,d,u)=>{var a;this._listeners||(this._listeners=new I.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(d?[b,d]:b);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,b,d);const s=(a=this._leakageMon)===null||a===void 0?void 0:a.check(this._listeners.size);let o;return o={dispose:()=>{s&&s(),o.dispose=w._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},u instanceof R.DisposableStore?u.add(o):Array.isArray(u)&&u.push(o),o}),this._event}fire(b){var d,u;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new I.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,b]);for((d=this._perfMon)===null||d===void 0||d.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,t]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,t):a[0].call(a[1],t)}catch(r){(0,_.onUnexpectedError)(r)}}(u=this._perfMon)===null||u===void 0||u.stop()}}dispose(){var b,d,u;(b=this._listeners)===null||b===void 0||b.clear(),(d=this._deliveryQueue)===null||d===void 0||d.clear(),(u=this._leakageMon)===null||u===void 0||u.dispose(),this._disposed=!0}}e.Emitter=w,w._noop=function(){};class f extends w{constructor(b){super(b);this._isPaused=0,this._eventQueue=new I.LinkedList,this._mergeFn=b==null?void 0:b.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const b=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(b))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(b){this._listeners&&(this._isPaused!==0?this._eventQueue.push(b):super.fire(b))}}e.PauseableEmitter=f;class l{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new w({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(b){const d={event:b,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const u=()=>{this.hasListeners&&this.unhook(d);const a=this.events.indexOf(d);this.events.splice(a,1)};return(0,R.toDisposable)((0,D.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(b=>this.hook(b))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(b=>this.unhook(b))}hook(b){b.listener=b.event(d=>this.emitter.fire(d))}unhook(b){b.listener&&b.listener.dispose(),b.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=l;class m{constructor(){this.buffers=[]}wrapEvent(b){return(d,u,a)=>b(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>d.call(u,t)):d.call(u,t)},void 0,a)}bufferEvents(b){const d=[];this.buffers.push(d);const u=b();return this.buffers.pop(),d.forEach(a=>a()),u}}e.EventBufferer=m;class S{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=R.Disposable.None,this.emitter=new w({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(b){this.inputEvent=b,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=b(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=S}),define(me[21],pe([0,1,3]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const D=Object.freeze(function(P,y){const i=setTimeout(P.bind(y),0);return{dispose(){clearTimeout(i)}}});var R;(function(P){function y(i){return i===P.None||i===P.Cancelled||i instanceof I?!0:!i||typeof i!="object"?!1:typeof i.isCancellationRequested=="boolean"&&typeof i.onCancellationRequested=="function"}P.isCancellationToken=y,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(R=e.CancellationToken||(e.CancellationToken={}));class I{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?D:(this._emitter||(this._emitter=new _.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new I),this._token}cancel(){this._token?this._token instanceof I&&this._token.cancel():this._token=R.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof I&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=C}),define(me[47],pe([0,1,3]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class D{constructor(){this._icons=new Map,this._onDidRegister=new _.Emitter}add(T){const k=this._icons.get(T.id);k?T.description?k.description=T.description:console.error(`Duplicate registration of codicon ${T.id}`):(this._icons.set(T.id,T),this._onDidRegister.fire(T))}get(T){return this._icons.get(T)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new D;e.iconRegistry=R;function I(i,T){return new C(i,T)}e.registerCodicon=I;class C{constructor(T,k,w){this.id=T,this.definition=k,this.description=w,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function P(i,T){const k=["codicon","codicon-"+i];return T&&k.push("codicon-modifier-"+T),k}e.getClassNamesArray=P;var y;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const T=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function k(l){if(l instanceof C)return["codicon","codicon-"+l.id];const m=T.exec(l.id);if(!m)return k(C.error);let[,S,g]=m;const b=["codicon","codicon-"+S];return g&&b.push("codicon-modifier-"+g.substr(1)),b}i.asClassNameArray=k;function w(l){return k(l).join(" ")}i.asClassName=w;function f(l){return"."+k(l).join(".")}i.asCSSSelector=f})(y=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personAdd=new i("person-add",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(me[91],pe([0,1,18,6]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(S){const g=S;return g&&[g.on,g.pause,g.resume,g.destroy].every(b=>typeof b=="function")}e.isReadableStream=R;function I(S){const g=S;return g&&R(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean"}e.isReadableBufferedStream=I;function C(S,g){return new P(S,g)}e.newWriteableStream=C;class P{constructor(g,b){this.reducer=g,this.options=b,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(g){var b;if(!this.state.destroyed){if(this.state.flowing)this.emitData(g);else if(this.buffer.data.push(g),typeof((b=this.options)===null||b===void 0?void 0:b.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(d=>this.pendingWritePromises.push(d))}}error(g){this.state.destroyed||(this.state.flowing?this.emitError(g):this.buffer.error.push(g))}end(g){this.state.destroyed||(typeof g!="undefined"&&this.write(g),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(g){this.listeners.data.slice(0).forEach(b=>b(g))}emitError(g){this.listeners.error.length===0?(0,_.onUnexpectedError)(g):this.listeners.error.slice(0).forEach(b=>b(g))}emitEnd(){this.listeners.end.slice(0).forEach(g=>g())}on(g,b){if(!this.state.destroyed)switch(g){case"data":this.listeners.data.push(b),this.resume();break;case"end":this.listeners.end.push(b),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(b),this.state.flowing&&this.flowErrors();break}}removeListener(g,b){if(!this.state.destroyed){let d;switch(g){case"data":d=this.listeners.data;break;case"end":d=this.listeners.end;break;case"error":d=this.listeners.error;break}if(d){const u=d.indexOf(b);u>=0&&d.splice(u,1)}}}flowData(){if(this.buffer.data.length>0){const g=this.reducer(this.buffer.data);this.emitData(g),this.buffer.data.length=0;const b=[...this.pendingWritePromises];this.pendingWritePromises.length=0,b.forEach(d=>d())}}flowErrors(){if(this.listeners.error.length>0){for(const g of this.buffer.error)this.emitError(g);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(S,g){const b=[];let d;for(;(d=S.read())!==null;)b.push(d);return g(b)}e.consumeReadable=y;function i(S,g,b){const d=[];let u;for(;(u=S.read())!==null&&d.length<b;)d.push(u);return u===null&&d.length>0?g(d):{read:()=>{if(d.length>0)return d.shift();if(typeof u!="undefined"){const a=u;return u=void 0,a}return S.read()}}}e.peekReadable=i;function T(S,g){return new Promise((b,d)=>{const u=[];k(S,{onData:a=>{g&&u.push(a)},onError:a=>{g?d(a):b(void 0)},onEnd:()=>{b(g?g(u):void 0)}})})}e.consumeStream=T;function k(S,g){S.on("error",b=>g.onError(b)),S.on("end",()=>g.onEnd()),S.on("data",b=>g.onData(b))}e.listenStream=k;function w(S,g){return new Promise((b,d)=>{const u=new D.DisposableStore,a=[],t=o=>{if(a.push(o),a.length>g)return u.dispose(),S.pause(),b({stream:S,buffer:a,ended:!1})},r=o=>d(o),s=()=>b({stream:S,buffer:a,ended:!0});u.add((0,D.toDisposable)(()=>S.removeListener("error",r))),S.on("error",r),u.add((0,D.toDisposable)(()=>S.removeListener("end",s))),S.on("end",s),u.add((0,D.toDisposable)(()=>S.removeListener("data",t))),S.on("data",t)})}e.peekStream=w;function f(S,g){const b=C(g);return b.end(S),b}e.toStream=f;function l(S){let g=!1;return{read:()=>g?null:(g=!0,S)}}e.toReadable=l;function m(S,g,b){const d=C(b);return k(S,{onData:u=>d.write(g.data(u)),onError:u=>d.error(g.error?g.error(u):u),onEnd:()=>d.end()}),d}e.transform=m}),define(me[9],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function _(q){return!q||typeof q!="string"?!0:q.trim().length===0}e.isFalsyOrWhitespace=_;const D=/{(\d+)}/g;function R(q,...ae){return ae.length===0?q:q.replace(D,function(he,Y){const re=parseInt(Y,10);return isNaN(re)||re<0||re>=ae.length?he:ae[re]})}e.format=R;function I(q){return q.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}e.escape=I;function C(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function P(q,ae){let he=0;const Y=ae.charCodeAt(0);for(let re=q.length-1;re>=0;re--)q.charCodeAt(re)===Y&&he++;return he}e.count=P;function y(q,ae,he="\u2026"){return q.length<=ae?q:`${q.substr(0,ae)}${he}`}e.truncate=y;function i(q,ae=" "){const he=T(q,ae);return k(he,ae)}e.trim=i;function T(q,ae){if(!q||!ae)return q;const he=ae.length;if(he===0||q.length===0)return q;let Y=0;for(;q.indexOf(ae,Y)===Y;)Y=Y+he;return q.substring(Y)}e.ltrim=T;function k(q,ae){if(!q||!ae)return q;const he=ae.length,Y=q.length;if(he===0||Y===0)return q;let re=Y,ue=-1;for(;ue=q.lastIndexOf(ae,re-1),!(ue===-1||ue+he!==re);){if(ue===0)return"";re=ue}return q.substring(0,re)}e.rtrim=k;function w(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=w;function f(q){return q.replace(/\*/g,"")}e.stripWildcards=f;function l(q,ae,he={}){if(!q)throw new Error("Cannot create regex from empty string");ae||(q=C(q)),he.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let Y="";return he.global&&(Y+="g"),he.matchCase||(Y+="i"),he.multiline&&(Y+="m"),he.unicode&&(Y+="u"),new RegExp(q,Y)}e.createRegExp=l;function m(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function S(q){return!!q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=S;function g(q){return(q.global?"g":"")+(q.ignoreCase?"i":"")+(q.multiline?"m":"")+(q.unicode?"u":"")}e.regExpFlags=g;function b(q){return q.split(/\r\n|\r|\n/)}e.splitLines=b;function d(q){for(let ae=0,he=q.length;ae<he;ae++){const Y=q.charCodeAt(ae);if(Y!==32&&Y!==9)return ae}return-1}e.firstNonWhitespaceIndex=d;function u(q,ae=0,he=q.length){for(let Y=ae;Y<he;Y++){const re=q.charCodeAt(Y);if(re!==32&&re!==9)return q.substring(ae,Y)}return q.substring(ae,he)}e.getLeadingWhitespace=u;function a(q,ae=q.length-1){for(let he=ae;he>=0;he--){const Y=q.charCodeAt(he);if(Y!==32&&Y!==9)return he}return-1}e.lastNonWhitespaceIndex=a;function t(q,ae){return q<ae?-1:q>ae?1:0}e.compare=t;function r(q,ae,he=0,Y=q.length,re=0,ue=ae.length){for(;he<Y&&re<ue;he++,re++){let je=q.charCodeAt(he),We=ae.charCodeAt(re);if(je<We)return-1;if(je>We)return 1}const fe=Y-he,ye=ue-re;return fe<ye?-1:fe>ye?1:0}e.compareSubstring=r;function s(q,ae){return o(q,ae,0,q.length,0,ae.length)}e.compareIgnoreCase=s;function o(q,ae,he=0,Y=q.length,re=0,ue=ae.length){for(;he<Y&&re<ue;he++,re++){let je=q.charCodeAt(he),We=ae.charCodeAt(re);if(je!==We){const ze=je-We;if(!(ze===32&&c(We))&&!(ze===-32&&c(je)))return n(je)&&n(We)?ze:r(q.toLowerCase(),ae.toLowerCase(),he,Y,re,ue)}}const fe=Y-he,ye=ue-re;return fe<ye?-1:fe>ye?1:0}e.compareSubstringIgnoreCase=o;function n(q){return q>=97&&q<=122}e.isLowerAsciiLetter=n;function c(q){return q>=65&&q<=90}e.isUpperAsciiLetter=c;function p(q){return n(q)||c(q)}function E(q,ae){return q.length===ae.length&&h(q,ae)}e.equalsIgnoreCase=E;function h(q,ae,he=q.length){for(let Y=0;Y<he;Y++){const re=q.charCodeAt(Y),ue=ae.charCodeAt(Y);if(re!==ue){if(p(re)&&p(ue)){const fe=Math.abs(re-ue);if(fe!==0&&fe!==32)return!1}else if(String.fromCharCode(re).toLowerCase()!==String.fromCharCode(ue).toLowerCase())return!1}}return!0}function v(q,ae){const he=ae.length;return ae.length>q.length?!1:h(q,ae,he)}e.startsWithIgnoreCase=v;function A(q,ae){let he,Y=Math.min(q.length,ae.length);for(he=0;he<Y;he++)if(q.charCodeAt(he)!==ae.charCodeAt(he))return he;return Y}e.commonPrefixLength=A;function F(q,ae){let he,Y=Math.min(q.length,ae.length);const re=q.length-1,ue=ae.length-1;for(he=0;he<Y;he++)if(q.charCodeAt(re-he)!==ae.charCodeAt(ue-he))return he;return Y}e.commonSuffixLength=F;function x(q){return 55296<=q&&q<=56319}e.isHighSurrogate=x;function j(q){return 56320<=q&&q<=57343}e.isLowSurrogate=j;function G(q,ae){return(q-55296<<10)+(ae-56320)+65536}e.computeCodePoint=G;function B(q,ae,he){const Y=q.charCodeAt(he);if(x(Y)&&he+1<ae){const re=q.charCodeAt(he+1);if(j(re))return G(Y,re)}return Y}e.getNextCodePoint=B;function J(q,ae){const he=q.charCodeAt(ae-1);if(j(he)&&ae>1){const Y=q.charCodeAt(ae-2);if(x(Y))return G(Y,he)}return he}function O(q,ae){const he=Be.getInstance(),Y=ae,re=q.length,ue=B(q,re,ae);ae+=ue>=65536?2:1;let fe=he.getGraphemeBreakType(ue);for(;ae<re;){const ye=B(q,re,ae),je=he.getGraphemeBreakType(ye);if(Ne(fe,je))break;ae+=ye>=65536?2:1,fe=je}return ae-Y}e.nextCharLength=O;function N(q,ae){const he=Be.getInstance(),Y=ae,re=J(q,ae);ae-=re>=65536?2:1;let ue=he.getGraphemeBreakType(re);for(;ae>0;){const fe=J(q,ae),ye=he.getGraphemeBreakType(fe);if(Ne(ye,ue))break;ae-=fe>=65536?2:1,ue=ye}return Y-ae}e.prevCharLength=N;function U(q,ae){const he=Be.getInstance(),Y=q.length,re=ae,ue=B(q,Y,ae),fe=he.getGraphemeBreakType(ue);ae+=ue>=65536?2:1;let ye=fe;for(;ae<Y;){const We=B(q,Y,ae),ze=he.getGraphemeBreakType(We);if(Ne(ye,ze))break;ae+=We>=65536?2:1,ye=ze}const je=ae;for(ae=re,ye=fe;ae>0;){const We=J(q,ae),ze=he.getGraphemeBreakType(We);if(Ne(ze,ye))break;ae-=We>=65536?2:1,ye=ze}return[ae,je]}function L(q,ae){return ae>0&&j(q.charCodeAt(ae))?U(q,ae-1):U(q,ae)}e.getCharContainingOffset=L;function M(q){const ae=q.length;let he=0,Y=0;for(;Y<ae;){const fe=B(q,ae,Y);Y+=fe>=65536?2:1,fe<128?he+=1:fe<2048?he+=2:fe<65536?he+=3:he+=4}const re=new Uint8Array(he);Y=0;let ue=0;for(;Y<ae;){const fe=B(q,ae,Y);Y+=fe>=65536?2:1,fe<128?re[ue++]=fe:fe<2048?(re[ue++]=192|(fe&1984)>>>6,re[ue++]=128|(fe&63)>>>0):fe<65536?(re[ue++]=224|(fe&61440)>>>12,re[ue++]=128|(fe&4032)>>>6,re[ue++]=128|(fe&63)>>>0):(re[ue++]=240|(fe&1835008)>>>18,re[ue++]=128|(fe&258048)>>>12,re[ue++]=128|(fe&4032)>>>6,re[ue++]=128|(fe&63)>>>0)}return re}e.encodeUTF8=M;function V(q){const ae=q.byteLength,he=[];let Y=0;for(;Y<ae;){const re=q[Y];let ue;if(re>=240&&Y+3<ae?ue=(q[Y++]&7)<<18>>>0|(q[Y++]&63)<<12>>>0|(q[Y++]&63)<<6>>>0|(q[Y++]&63)<<0>>>0:re>=224&&Y+2<ae?ue=(q[Y++]&15)<<12>>>0|(q[Y++]&63)<<6>>>0|(q[Y++]&63)<<0>>>0:re>=192&&Y+1<ae?ue=(q[Y++]&31)<<6>>>0|(q[Y++]&63)<<0>>>0:ue=q[Y++],ue>=0&&ue<=55295||ue>=57344&&ue<=65535)he.push(String.fromCharCode(ue));else if(ue>=65536&&ue<=1114111){const fe=ue-65536,ye=55296+((fe&1047552)>>>10),je=56320+((fe&1023)>>>0);he.push(String.fromCharCode(ye)),he.push(String.fromCharCode(je))}else he.push(String.fromCharCode(65533))}return he.join("")}e.decodeUTF8=V;const K=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function se(q){return K.test(q)}e.containsRTL=se;const ce=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function we(q){return ce.test(q)}e.containsEmoji=we;const Te=/^[\t\n\r\x20-\x7E]*$/;function Ie(q){return Te.test(q)}e.isBasicASCII=Ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Me(q){return e.UNUSUAL_LINE_TERMINATORS.test(q)}e.containsUnusualLineTerminators=Me;function H(q){for(let ae=0,he=q.length;ae<he;ae++)if(Q(q.charCodeAt(ae)))return!0;return!1}e.containsFullWidthCharacter=H;function Q(q){return q=+q,q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}e.isFullWidthCharacter=Q;function ne(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129003||q>=129280&&q<=129535||q>=129648&&q<=129750}e.isEmojiImprecise=ne;function oe(q,ae){if(q.length<ae)return q;const he=/\b/g;let Y=0;for(;he.test(q)&&!(q.length-he.lastIndex<ae);)Y=he.lastIndex,he.lastIndex+=1;return q.substring(Y).replace(/^\s/,"")}e.lcut=oe;const ge=/\x1B\x5B[12]?K/g,Ce=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function ve(q){return q&&(q=q.replace(ge,""),q=q.replace(Ce,""),q=q.replace(Oe,"")),q}e.removeAnsiEscapeCodes=ve,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(q){return!!(q&&q.length>0&&q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Pe(q){return ke(q)?q.substr(1):q}e.stripUTF8BOM=Pe;function Ue(q,ae){if(!q||!ae||q.length<ae.length)return!1;const he=ae.length,Y=q.toLowerCase();let re=0,ue=-1;for(;re<he;){const fe=Y.indexOf(ae[re],ue+1);if(fe<0)return!1;ue=fe,re++}return!0}e.fuzzyContains=Ue;function Se(q,ae=!1){return q?(ae&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}e.containsUppercaseCharacter=Se;function qe(q){return q.charAt(0).toUpperCase()+q.slice(1)}e.uppercaseFirstLetter=qe;function X(q,ae=1){if(ae===0)return"";let he=-1;do he=q.indexOf(`
`,he+1),ae--;while(ae>0&&he>=0);return he===-1?q:(q[he-1]==="\r"&&he--,q.substr(0,he))}e.getNLines=X;function ie(q){const ae=90-65+1;return q=q%(2*ae),q<ae?String.fromCharCode(97+q):String.fromCharCode(65+q-ae)}e.singleLetterHash=ie;function Ee(q){return Be.getInstance().getGraphemeBreakType(q)}e.getGraphemeBreakType=Ee;function Ne(q,ae){return q===0?ae!==5&&ae!==7:q===2&&ae===3?!1:q===4||q===2||q===3||ae===4||ae===2||ae===3?!0:!(q===8&&(ae===8||ae===9||ae===11||ae===12)||(q===11||q===9)&&(ae===9||ae===10)||(q===12||q===10)&&ae===10||ae===5||ae===13||ae===7||q===1||q===13&&ae===14||q===6&&ae===6)}e.breakBetweenGraphemeBreakType=Ne;var He;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(He=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=Ye()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const he=this._data,Y=he.length/3;let re=1;for(;re<=Y;)if(ae<he[3*re])re=2*re;else if(ae>he[3*re+1])re=2*re+1;else return he[3*re+2];return 0}}Be._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(me[26],pe([0,1,9,91]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer!="undefined",I=typeof TextEncoder!="undefined",C=typeof TextDecoder!="undefined";let P,y;class i{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return R?new i(Buffer.allocUnsafe(n)):new i(new Uint8Array(n))}static wrap(n){return R&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new i(n)}static fromString(n,c){return!((c==null?void 0:c.dontUseNodeBuffer)||!1)&&R?new i(Buffer.from(n)):I?(P||(P=new TextEncoder),new i(P.encode(n))):new i(_.encodeUTF8(n))}static concat(n,c){if(typeof c=="undefined"){c=0;for(let h=0,v=n.length;h<v;h++)c+=n[h].byteLength}const p=i.alloc(c);let E=0;for(let h=0,v=n.length;h<v;h++){const A=n[h];p.set(A,E),E+=A.byteLength}return p}toString(){return R?this.buffer.toString():C?(y||(y=new TextDecoder),y.decode(this.buffer)):_.decodeUTF8(this.buffer)}slice(n,c){return new i(this.buffer.subarray(n,c))}set(n,c){n instanceof i?this.buffer.set(n.buffer,c):this.buffer.set(n,c)}readUInt32BE(n){return w(this.buffer,n)}writeUInt32BE(n,c){f(this.buffer,n,c)}readUInt32LE(n){return l(this.buffer,n)}writeUInt32LE(n,c){m(this.buffer,n,c)}readUInt8(n){return S(this.buffer,n)}writeUInt8(n,c){g(this.buffer,n,c)}}e.VSBuffer=i;function T(o,n){return o[n+0]<<0>>>0|o[n+1]<<8>>>0}e.readUInt16LE=T;function k(o,n,c){o[c+0]=n&255,n=n>>>8,o[c+1]=n&255}e.writeUInt16LE=k;function w(o,n){return o[n]*2**24+o[n+1]*2**16+o[n+2]*2**8+o[n+3]}e.readUInt32BE=w;function f(o,n,c){o[c+3]=n,n=n>>>8,o[c+2]=n,n=n>>>8,o[c+1]=n,n=n>>>8,o[c]=n}e.writeUInt32BE=f;function l(o,n){return o[n+0]<<0>>>0|o[n+1]<<8>>>0|o[n+2]<<16>>>0|o[n+3]<<24>>>0}e.readUInt32LE=l;function m(o,n,c){o[c+0]=n&255,n=n>>>8,o[c+1]=n&255,n=n>>>8,o[c+2]=n&255,n=n>>>8,o[c+3]=n&255}e.writeUInt32LE=m;function S(o,n){return o[n]}e.readUInt8=S;function g(o,n,c){o[c]=n}e.writeUInt8=g;function b(o){return D.consumeReadable(o,n=>i.concat(n))}e.readableToBuffer=b;function d(o){return D.toReadable(o)}e.bufferToReadable=d;function u(o){return D.consumeStream(o,n=>i.concat(n))}e.streamToBuffer=u;async function a(o){return o.ended?i.concat(o.buffer):i.concat([...o.buffer,await u(o.stream)])}e.bufferedStreamToBuffer=a;function t(o){return D.toStream(o,n=>i.concat(n))}e.bufferToStream=t;function r(o){return D.transform(o,{data:n=>typeof n=="string"?i.fromString(n):i.wrap(n)},n=>i.concat(n))}e.streamToBufferReadableStream=r;function s(o){return D.newWriteableStream(n=>i.concat(n),o)}e.newWriteableBufferStream=s}),define(me[74],pe([0,1,9]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function D(g){return R(g,0)}e.hash=D;function R(g,b){switch(typeof g){case"object":return g===null?I(349,b):Array.isArray(g)?y(g,b):i(g,b);case"string":return P(g,b);case"boolean":return C(g,b);case"number":return I(g,b);case"undefined":return I(937,b);default:return I(617,b)}}e.doHash=R;function I(g,b){return(b<<5)-b+g|0}function C(g,b){return I(g?433:863,b)}function P(g,b){b=I(149417,b);for(let d=0,u=g.length;d<u;d++)b=I(g.charCodeAt(d),b);return b}e.stringHash=P;function y(g,b){return b=I(104579,b),g.reduce((d,u)=>R(u,d),b)}function i(g,b){return b=I(181387,b),Object.keys(g).sort().reduce((d,u)=>(d=P(u,d),R(g[u],d)),b)}class T{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=R(b,this._value),this._value}}e.Hasher=T;var k;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function w(g,b,d=32){const u=d-b,a=~((1<<u)-1);return(g<<b|(a&g)>>>u)>>>0}function f(g,b=0,d=g.byteLength,u=0){for(let a=0;a<d;a++)g[b+a]=u}function l(g,b,d="0"){for(;g.length<b;)g=d+g;return g}function m(g,b=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(d=>d.toString(16).padStart(2,"0")).join(""):l((g>>>0).toString(16),b/4)}e.toHexString=m;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const d=b.length;if(d!==0){const u=this._buff;let a=this._buffLen,t=this._leftoverHighSurrogate,r,s;for(t!==0?(r=t,s=-1,t=0):(r=b.charCodeAt(0),s=0);;){let o=r;if(_.isHighSurrogate(r))if(s+1<d){const n=b.charCodeAt(s+1);_.isLowSurrogate(n)?(s++,o=_.computeCodePoint(r,n)):o=65533}else{t=r;break}else _.isLowSurrogate(r)&&(o=65533);if(a=this._push(u,a,o),s++,s<d)r=b.charCodeAt(s);else break}this._buffLen=a,this._leftoverHighSurrogate=t}}_push(b,d,u){return u<128?b[d++]=u:u<2048?(b[d++]=192|(u&1984)>>>6,b[d++]=128|(u&63)>>>0):u<65536?(b[d++]=224|(u&61440)>>>12,b[d++]=128|(u&4032)>>>6,b[d++]=128|(u&63)>>>0):(b[d++]=240|(u&1835008)>>>18,b[d++]=128|(u&258048)>>>12,b[d++]=128|(u&4032)>>>6,b[d++]=128|(u&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=S._bigBlock32,d=this._buffDV;for(let p=0;p<64;p+=4)b.setUint32(p,d.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)b.setUint32(p,w(b.getUint32(p-12,!1)^b.getUint32(p-32,!1)^b.getUint32(p-56,!1)^b.getUint32(p-64,!1),1),!1);let u=this._h0,a=this._h1,t=this._h2,r=this._h3,s=this._h4,o,n,c;for(let p=0;p<80;p++)p<20?(o=a&t|~a&r,n=1518500249):p<40?(o=a^t^r,n=1859775393):p<60?(o=a&t|a&r|t&r,n=2400959708):(o=a^t^r,n=3395469782),c=w(u,5)+o+s+n+b.getUint32(p*4,!1)&4294967295,s=r,r=t,t=w(a,30),a=u,u=c;this._h0=this._h0+u&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[75],pe([0,1,9]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(D||(D={})),function(R){const I="error",C="warning",P="warn",y="info";function i(T){return T?_.equalsIgnoreCase(I,T)?R.Error:_.equalsIgnoreCase(C,T)||_.equalsIgnoreCase(P,T)?R.Warning:_.equalsIgnoreCase(y,T)?R.Info:R.Ignore:R.Ignore}R.fromValue=i}(D||(D={})),e.default=D}),define(me[15],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function _(n){return Array.isArray(n)}e.isArray=_;function D(n){return typeof n=="string"}e.isString=D;function R(n){return Array.isArray(n)&&n.every(c=>D(c))}e.isStringArray=R;function I(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}e.isObject=I;function C(n){return typeof n=="number"&&!isNaN(n)}e.isNumber=C;function P(n){return n===!0||n===!1}e.isBoolean=P;function y(n){return typeof n=="undefined"}e.isUndefined=y;function i(n){return!T(n)}e.isDefined=i;function T(n){return y(n)||n===null}e.isUndefinedOrNull=T;function k(n,c){if(!n)throw new Error(c?`Unexpected type, expected '${c}'`:"Unexpected type")}e.assertType=k;function w(n){if(T(n))throw new Error("Assertion Failed: argument is undefined or null");return n}e.assertIsDefined=w;function f(...n){const c=[];for(let p=0;p<n.length;p++){const E=n[p];if(T(E))throw new Error(`Assertion Failed: argument at index ${p} is undefined or null`);c.push(E)}return c}e.assertAllDefined=f;const l=Object.prototype.hasOwnProperty;function m(n){if(!I(n))return!1;for(let c in n)if(l.call(n,c))return!1;return!0}e.isEmptyObject=m;function S(n){return typeof n=="function"}e.isFunction=S;function g(...n){return n.length>0&&n.every(S)}e.areFunctions=g;function b(n,c){const p=Math.min(n.length,c.length);for(let E=0;E<p;E++)d(n[E],c[E])}e.validateConstraints=b;function d(n,c){if(D(c)){if(typeof n!==c)throw new Error(`argument does not match constraint: typeof ${c}`)}else if(S(c)){try{if(n instanceof c)return}catch(p){}if(!T(n)&&n.constructor===c||c.length===1&&c.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function u(n){let c=[],p=Object.getPrototypeOf(n);for(;Object.prototype!==p;)c=c.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return c}e.getAllPropertyNames=u;function a(n){const c=[];for(const p of u(n))typeof n[p]=="function"&&c.push(p);return c}e.getAllMethodNames=a;function t(n,c){const p=h=>function(){const v=Array.prototype.slice.call(arguments,0);return c(h,v)};let E={};for(const h of n)E[h]=p(h);return E}e.createProxyObject=t;function r(n){return n===null?void 0:n}e.withNullAsUndefined=r;function s(n){return typeof n=="undefined"?null:n}e.withUndefinedAsNull=s;function o(n){return class{constructor(){return new Proxy({},{get(c,p){if(c[p])return c[p];throw new Error(`Not Implemented: ${n}->${String(p)}`)}})}}}e.NotImplementedProxy=o}),define(me[30],pe([0,1,10,9,7,15]),function(Z,e,_,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function C(r){return r===47||r===92}e.isPathSeparator=C;function P(r){return r.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=P;function y(r,s=R.posix.sep){if(!r)return"";const o=r.length,n=r.charCodeAt(0);if(C(n)){if(C(r.charCodeAt(1))&&!C(r.charCodeAt(2))){let p=3;const E=p;for(;p<o&&!C(r.charCodeAt(p));p++);if(E!==p&&!C(r.charCodeAt(p+1))){for(p+=1;p<o;p++)if(C(r.charCodeAt(p)))return r.slice(0,p+1).replace(/[\\/]/g,s)}}return s}else if(S(n)&&r.charCodeAt(1)===58)return C(r.charCodeAt(2))?r.slice(0,2)+s:r.slice(0,2);let c=r.indexOf("://");if(c!==-1){for(c+=3;c<o;c++)if(C(r.charCodeAt(c)))return r.slice(0,c+1)}return""}e.getRoot=y;function i(r){if(!_.isWindows||!r||r.length<5)return!1;let s=r.charCodeAt(0);if(s!==92||(s=r.charCodeAt(1),s!==92))return!1;let o=2;const n=o;for(;o<r.length&&(s=r.charCodeAt(o),s!==92);o++);return!(n===o||(s=r.charCodeAt(o+1),isNaN(s)||s===92))}e.isUNC=i;const T=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,s=_.isWindows){const o=s?T:k;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||s&&w.test(r)||r==="."||r===".."||s&&r[r.length-1]==="."||s&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=f;function l(r,s,o){const n=r===s;return!o||n?n:!r||!s?!1:(0,D.equalsIgnoreCase)(r,s)}e.isEqual=l;function m(r,s,o,n=R.sep){if(r===s)return!0;if(!r||!s||s.length>r.length)return!1;if(o){if(!(0,D.startsWithIgnoreCase)(r,s))return!1;if(s.length===r.length)return!0;let p=s.length;return s.charAt(s.length-1)===n&&p--,r.charAt(p)===n}return s.charAt(s.length-1)!==n&&(s+=n),r.indexOf(s)===0}e.isEqualOrParent=m;function S(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=S;function g(r,s){return _.isWindows&&r.endsWith(":")&&(r+=R.sep),(0,R.isAbsolute)(r)||(r=(0,R.join)(s,r)),r=(0,R.normalize)(r),_.isWindows?(r=(0,D.rtrim)(r,R.sep),r.endsWith(":")&&(r+=R.sep)):(r=(0,D.rtrim)(r,R.sep),r||(r=R.sep)),r}e.sanitizeFilePath=g;function b(r){const s=(0,R.normalize)(r);return _.isWindows?r.length>3?!1:d(s)&&(r.length===2||s.charCodeAt(2)===92):s===R.posix.sep}e.isRootOrDriveLetter=b;function d(r){return _.isWindows?S(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function u(r){return d(r)?r[0]:void 0}e.getDriveLetter=u;function a(r,s,o){return s.length>r.length?-1:r===s?0:(o&&(r=r.toLowerCase(),s=s.toLowerCase()),r.indexOf(s))}e.indexOfPath=a;function t(r){const s=r.split(":");let o,n,c;if(s.forEach(p=>{const E=Number(p);(0,I.isNumber)(E)?n===void 0?n=E:c===void 0&&(c=E):o=o?[o,p].join(":"):p}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:n!==void 0?n:void 0,column:c!==void 0?c:n!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(me[24],pe([0,1,15]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function D(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const m=Array.isArray(l)?[]:{};return Object.keys(l).forEach(S=>{l[S]&&typeof l[S]=="object"?m[S]=D(l[S]):m[S]=l[S]}),m}e.deepClone=D;function R(l){if(!l||typeof l!="object")return l;const m=[l];for(;m.length>0;){const S=m.shift();Object.freeze(S);for(const g in S)if(I.call(S,g)){const b=S[g];typeof b=="object"&&!Object.isFrozen(b)&&m.push(b)}}return l}e.deepFreeze=R;const I=Object.prototype.hasOwnProperty;function C(l,m){return P(l,m,new Set)}e.cloneAndChange=C;function P(l,m,S){if((0,_.isUndefinedOrNull)(l))return l;const g=m(l);if(typeof g!="undefined")return g;if((0,_.isArray)(l)){const b=[];for(const d of l)b.push(P(d,m,S));return b}if((0,_.isObject)(l)){if(S.has(l))throw new Error("Cannot clone recursive data-structure");S.add(l);const b={};for(let d in l)I.call(l,d)&&(b[d]=P(l[d],m,S));return S.delete(l),b}return l}function y(l,m,S=!0){return(0,_.isObject)(l)?((0,_.isObject)(m)&&Object.keys(m).forEach(g=>{g in l?S&&((0,_.isObject)(l[g])&&(0,_.isObject)(m[g])?y(l[g],m[g],S):l[g]=m[g]):l[g]=m[g]}),l):m}e.mixin=y;function i(l,m){if(l===m)return!0;if(l==null||m===null||m===void 0||typeof l!=typeof m||typeof l!="object"||Array.isArray(l)!==Array.isArray(m))return!1;let S,g;if(Array.isArray(l)){if(l.length!==m.length)return!1;for(S=0;S<l.length;S++)if(!i(l[S],m[S]))return!1}else{const b=[];for(g in l)b.push(g);b.sort();const d=[];for(g in m)d.push(g);if(d.sort(),!i(b,d))return!1;for(S=0;S<b.length;S++)if(!i(l[b[S]],m[b[S]]))return!1}return!0}e.equals=i;function T(l){const m=new Set;return JSON.stringify(l,(S,g)=>{if((0,_.isObject)(g)||Array.isArray(g)){if(m.has(g))return"[Circular]";m.add(g)}return g})}e.safeStringify=T;function k(l,m,S){const g=m(l);return typeof g=="undefined"?S:g}e.getOrDefault=k;function w(l,m){const S=Object.create(null);return!l||!m||Object.keys(m).forEach(b=>{const d=l[b],u=m[b];i(d,u)||(S[b]=u)}),S}e.distinct=w;function f(l,m){const S=m.toLowerCase(),g=Object.keys(l).find(b=>b.toLowerCase()===S);return g?l[g]:l[m]}e.getCaseInsensitive=f}),define(me[92],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var _;(function(I){I[I.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",I[I.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",I[I.MAX_UINT_8=255]="MAX_UINT_8",I[I.MAX_UINT_16=65535]="MAX_UINT_16",I[I.MAX_UINT_32=4294967295]="MAX_UINT_32",I[I.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(_=e.Constants||(e.Constants={}));function D(I){return I<0?0:I>255?255:I|0}e.toUint8=D;function R(I){return I<0?0:I>4294967295?4294967295:I|0}e.toUint32=R}),define(me[2],pe([0,1,10,7]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,I=/^\//,C=/^\/\//;function P(s,o){if(!s.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!R.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!I.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(s,o){return!s&&!o?"file":s}function i(s,o){switch(s){case"https":case"http":case"file":o?o[0]!==k&&(o=k+o):o=k;break}return o}const T="",k="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(o,n,c,p,E,h=!1){typeof o=="object"?(this.scheme=o.scheme||T,this.authority=o.authority||T,this.path=o.path||T,this.query=o.query||T,this.fragment=o.fragment||T):(this.scheme=y(o,h),this.authority=n||T,this.path=i(this.scheme,c||T),this.query=p||T,this.fragment=E||T,P(this,h))}static isUri(o){return o instanceof f?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return d(this,!1)}with(o){if(!o)return this;let{scheme:n,authority:c,path:p,query:E,fragment:h}=o;return n===void 0?n=this.scheme:n===null&&(n=T),c===void 0?c=this.authority:c===null&&(c=T),p===void 0?p=this.path:p===null&&(p=T),E===void 0?E=this.query:E===null&&(E=T),h===void 0?h=this.fragment:h===null&&(h=T),n===this.scheme&&c===this.authority&&p===this.path&&E===this.query&&h===this.fragment?this:new m(n,c,p,E,h)}static parse(o,n=!1){const c=w.exec(o);return c?new m(c[2]||T,r(c[4]||T),r(c[5]||T),r(c[7]||T),r(c[9]||T),n):new m(T,T,T,T,T)}static file(o){let n=T;if(_.isWindows&&(o=o.replace(/\\/g,k)),o[0]===k&&o[1]===k){const c=o.indexOf(k,2);c===-1?(n=o.substring(2),o=k):(n=o.substring(2,c),o=o.substring(c)||k)}return new m("file",n,o,T,T)}static from(o){return new m(o.scheme,o.authority,o.path,o.query,o.fragment)}static joinPath(o,...n){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return _.isWindows&&o.scheme==="file"?c=f.file(D.win32.join(d(o,!0),...n)).path:c=D.posix.join(o.path,...n),o.with({path:c})}toString(o=!1){return u(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof f)return o;{const n=new m(o);return n._formatted=o.external,n._fsPath=o._sep===l?o.fsPath:null,n}}else return o}}e.URI=f;const l=_.isWindows?1:void 0;class m extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(o=!1){return o?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=l),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(s,o){let n,c=-1;for(let p=0;p<s.length;p++){const E=s.charCodeAt(p);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||o&&E===47)c!==-1&&(n+=encodeURIComponent(s.substring(c,p)),c=-1),n!==void 0&&(n+=s.charAt(p));else{n===void 0&&(n=s.substr(0,p));const h=S[E];h!==void 0?(c!==-1&&(n+=encodeURIComponent(s.substring(c,p)),c=-1),n+=h):c===-1&&(c=p)}}return c!==-1&&(n+=encodeURIComponent(s.substring(c))),n!==void 0?n:s}function b(s){let o;for(let n=0;n<s.length;n++){const c=s.charCodeAt(n);c===35||c===63?(o===void 0&&(o=s.substr(0,n)),o+=S[c]):o!==void 0&&(o+=s[n])}return o!==void 0?o:s}function d(s,o){let n;return s.authority&&s.path.length>1&&s.scheme==="file"?n=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?o?n=s.path.substr(1):n=s.path[1].toLowerCase()+s.path.substr(2):n=s.path,_.isWindows&&(n=n.replace(/\//g,"\\")),n}e.uriToFsPath=d;function u(s,o){const n=o?b:g;let c="",{scheme:p,authority:E,path:h,query:v,fragment:A}=s;if(p&&(c+=p,c+=":"),(E||p==="file")&&(c+=k,c+=k),E){let F=E.indexOf("@");if(F!==-1){const x=E.substr(0,F);E=E.substr(F+1),F=x.indexOf(":"),F===-1?c+=n(x,!1):(c+=n(x.substr(0,F),!1),c+=":",c+=n(x.substr(F+1),!1)),c+="@"}E=E.toLowerCase(),F=E.indexOf(":"),F===-1?c+=n(E,!1):(c+=n(E.substr(0,F),!1),c+=E.substr(F))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const F=h.charCodeAt(1);F>=65&&F<=90&&(h=`/${String.fromCharCode(F+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const F=h.charCodeAt(0);F>=65&&F<=90&&(h=`${String.fromCharCode(F+32)}:${h.substr(2)}`)}c+=n(h,!0)}return v&&(c+="?",c+=n(v,!1)),A&&(c+="#",c+=o?A:g(A,!1)),c}function a(s){try{return decodeURIComponent(s)}catch(o){return s.length>3?s.substr(0,3)+a(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(s){return s.match(t)?s.replace(t,o=>a(o)):s}}),define(me[22],pe([0,1,2,9]),function(Z,e,_,D){"use strict";var R,I;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(u,a,t){let r=u.get(a);return r===void 0&&(r=t,u.set(a,r)),r}e.getOrSet=C;function P(u){const a=[];return u.forEach((t,r)=>{a.push(`${r} => ${t}`)}),`Map(${u.size}) {${a.join(", ")}}`}e.mapToString=P;function y(u){const a=[];return u.forEach(t=>{a.push(t)}),`Set(${u.size}) {${a.join(", ")}}`}e.setToString=y;class i{constructor(){this._value="",this._pos=0}reset(a){return this._value=a,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(a){const t=a.charCodeAt(0),r=this._value.charCodeAt(this._pos);return t-r}value(){return this._value[this._pos]}}e.StringIterator=i;class T{constructor(a=!0){this._caseSensitive=a}reset(a){return this._value=a,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(a)this._from++;else break;else a=!1;return this}cmp(a){return this._caseSensitive?(0,D.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=T;class k{constructor(a=!0,t=!0){this._splitOnBackslash=a,this._caseSensitive=t}reset(a){return this._value=a.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(a)this._from++;else break;else a=!1}return this}cmp(a){return this._caseSensitive?(0,D.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=k;var w;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(w||(w={}));class f{constructor(a){this._ignorePathCasing=a,this._states=[],this._stateIdx=0}reset(a){return this._value=a,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new k(!1,!this._ignorePathCasing(a)),this._pathIterator.reset(a.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(a){if(this._states[this._stateIdx]===1)return(0,D.compareIgnoreCase)(a,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,D.compareIgnoreCase)(a,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(a);if(this._states[this._stateIdx]===4)return(0,D.compare)(a,this._value.query);if(this._states[this._stateIdx]===5)return(0,D.compare)(a,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class l{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class m{constructor(a){this._iter=a}static forUris(a=()=>!1){return new m(new f(a))}static forPaths(){return new m(new k)}static forStrings(){return new m(new i)}static forConfigKeys(){return new m(new T)}clear(){this._root=void 0}set(a,t){const r=this._iter.reset(a);let s;for(this._root||(this._root=new l,this._root.segment=r.value()),s=this._root;;){const n=r.cmp(s.segment);if(n>0)s.left||(s.left=new l,s.left.segment=r.value()),s=s.left;else if(n<0)s.right||(s.right=new l,s.right.segment=r.value()),s=s.right;else if(r.hasNext())r.next(),s.mid||(s.mid=new l,s.mid.segment=r.value()),s=s.mid;else break}const o=s.value;return s.value=t,s.key=a,o}get(a){var t;return(t=this._getNode(a))===null||t===void 0?void 0:t.value}_getNode(a){const t=this._iter.reset(a);let r=this._root;for(;r;){const s=t.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else break}return r}has(a){const t=this._getNode(a);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(a){return this._delete(a,!1)}deleteSuperstr(a){return this._delete(a,!0)}_delete(a,t){const r=this._iter.reset(a),s=[];let o=this._root;for(;o;){const n=r.cmp(o.segment);if(n>0)s.push([1,o]),o=o.left;else if(n<0)s.push([-1,o]),o=o.right;else if(r.hasNext())r.next(),s.push([0,o]),o=o.mid;else{for(t?(o.left=void 0,o.mid=void 0,o.right=void 0):o.value=void 0;s.length>0&&o.isEmpty();){let[c,p]=s.pop();switch(c){case 1:p.left=void 0;break;case 0:p.mid=void 0;break;case-1:p.right=void 0;break}o=p}break}}}findSubstr(a){const t=this._iter.reset(a);let r=this._root,s;for(;r;){const o=t.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(t.hasNext())t.next(),s=r.value||s,r=r.mid;else break}return r&&r.value||s}findSuperstr(a){const t=this._iter.reset(a);let r=this._root;for(;r;){const s=t.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(a){for(const[t,r]of this)a(r,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(a){a&&(yield*this._entries(a.left),a.value&&(yield[a.key,a.value]),yield*this._entries(a.mid),yield*this._entries(a.right))}}e.TernarySearchTree=m;class S{constructor(a,t){this[R]="ResourceMap",a instanceof S?(this.map=new Map(a.map),this.toKey=t!=null?t:S.defaultToKey):(this.map=new Map,this.toKey=a!=null?a:S.defaultToKey)}set(a,t){return this.map.set(this.toKey(a),t),this}get(a){return this.map.get(this.toKey(a))}has(a){return this.map.has(this.toKey(a))}get size(){return this.map.size}clear(){this.map.clear()}delete(a){return this.map.delete(this.toKey(a))}forEach(a,t){typeof t!="undefined"&&(a=a.bind(t));for(let[r,s]of this.map)a(s,_.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let a of this.map.keys())yield _.URI.parse(a)}*entries(){for(let a of this.map.entries())yield[_.URI.parse(a[0]),a[1]]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let a of this.map)yield[_.URI.parse(a[0]),a[1]]}}e.ResourceMap=S,S.defaultToKey=u=>u.toString();var g;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(g=e.Touch||(e.Touch={}));class b{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var a;return(a=this._head)===null||a===void 0?void 0:a.value}get last(){var a;return(a=this._tail)===null||a===void 0?void 0:a.value}has(a){return this._map.has(a)}get(a,t=0){const r=this._map.get(a);if(!!r)return t!==0&&this.touch(r,t),r.value}set(a,t,r=0){let s=this._map.get(a);if(s)s.value=t,r!==0&&this.touch(s,r);else{switch(s={key:a,value:t,next:void 0,previous:void 0},r){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(a,s),this._size++}return this}delete(a){return!!this.remove(a)}remove(a){const t=this._map.get(a);if(!!t)return this._map.delete(a),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const a=this._head;return this._map.delete(a.key),this.removeItem(a),this._size--,a.value}}forEach(a,t){const r=this._state;let s=this._head;for(;s;){if(t?a.bind(t)(s.value,s.key,this):a(s.value,s.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const a=this,t=this._state;let r=this._head;const s={[Symbol.iterator](){return s},next(){if(a._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const o={value:r.key,done:!1};return r=r.next,o}else return{value:void 0,done:!0}}};return s}values(){const a=this,t=this._state;let r=this._head;const s={[Symbol.iterator](){return s},next(){if(a._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const o={value:r.value,done:!1};return r=r.next,o}else return{value:void 0,done:!0}}};return s}entries(){const a=this,t=this._state;let r=this._head;const s={[Symbol.iterator](){return s},next(){if(a._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const o={value:[r.key,r.value],done:!1};return r=r.next,o}else return{value:void 0,done:!0}}};return s}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(a){if(!(a>=this.size)){if(a===0){this.clear();return}let t=this._head,r=this.size;for(;t&&r>a;)this._map.delete(t.key),t=t.next,r--;this._head=t,this._size=r,t&&(t.previous=void 0),this._state++}}addItemFirst(a){if(!this._head&&!this._tail)this._tail=a;else if(this._head)a.next=this._head,this._head.previous=a;else throw new Error("Invalid list");this._head=a,this._state++}addItemLast(a){if(!this._head&&!this._tail)this._head=a;else if(this._tail)a.previous=this._tail,this._tail.next=a;else throw new Error("Invalid list");this._tail=a,this._state++}removeItem(a){if(a===this._head&&a===this._tail)this._head=void 0,this._tail=void 0;else if(a===this._head){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this._head=a.next}else if(a===this._tail){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this._tail=a.previous}else{const t=a.next,r=a.previous;if(!t||!r)throw new Error("Invalid list");t.previous=r,r.next=t}a.next=void 0,a.previous=void 0,this._state++}touch(a,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(a===this._head)return;const r=a.next,s=a.previous;a===this._tail?(s.next=void 0,this._tail=s):(r.previous=s,s.next=r),a.previous=void 0,a.next=this._head,this._head.previous=a,this._head=a,this._state++}else if(t===2){if(a===this._tail)return;const r=a.next,s=a.previous;a===this._head?(r.previous=void 0,this._head=r):(r.previous=s,s.next=r),a.next=void 0,a.previous=this._tail,this._tail.next=a,this._tail=a,this._state++}}}toJSON(){const a=[];return this.forEach((t,r)=>{a.push([r,t])}),a}fromJSON(a){this.clear();for(const[t,r]of a)this.set(t,r)}}e.LinkedMap=b;class d extends b{constructor(a,t=1){super();this._limit=a,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(a){this._limit=a,this.checkTrim()}get ratio(){return this._ratio}set ratio(a){this._ratio=Math.min(Math.max(0,a),1),this.checkTrim()}get(a,t=2){return super.get(a,t)}peek(a){return super.get(a,0)}set(a,t){return super.set(a,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d}),define(me[93],pe([0,1,22,9]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function R(...ve){return function(ke,Pe){for(let Ue=0,Se=ve.length;Ue<Se;Ue++){const qe=ve[Ue](ke,Pe);if(qe)return qe}return null}}e.or=R,e.matchesStrictPrefix=I.bind(void 0,!1),e.matchesPrefix=I.bind(void 0,!0);function I(ve,ke,Pe){if(!Pe||Pe.length<ke.length)return null;let Ue;return ve?Ue=D.startsWithIgnoreCase(Pe,ke):Ue=Pe.indexOf(ke)===0,Ue?ke.length>0?[{start:0,end:ke.length}]:[]:null}function C(ve,ke){const Pe=ke.toLowerCase().indexOf(ve.toLowerCase());return Pe===-1?null:[{start:Pe,end:Pe+ve.length}]}e.matchesContiguousSubString=C;function P(ve,ke){return y(ve.toLowerCase(),ke.toLowerCase(),0,0)}e.matchesSubString=P;function y(ve,ke,Pe,Ue){if(Pe===ve.length)return[];if(Ue===ke.length)return null;if(ve[Pe]===ke[Ue]){let Se=null;return(Se=y(ve,ke,Pe+1,Ue+1))?g({start:Ue,end:Ue+1},Se):null}return y(ve,ke,Pe,Ue+1)}function i(ve){return 97<=ve&&ve<=122}function T(ve){return 65<=ve&&ve<=90}e.isUpper=T;function k(ve){return 48<=ve&&ve<=57}function w(ve){return ve===32||ve===9||ve===10||ve===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(ve=>f.add(ve.charCodeAt(0)));function l(ve){return w(ve)||f.has(ve)}function m(ve,ke){return ve===ke||l(ve)&&l(ke)}function S(ve){return i(ve)||T(ve)||k(ve)}function g(ve,ke){return ke.length===0?ke=[ve]:ve.end===ke[0].start?ke[0].start=ve.start:ke.unshift(ve),ke}function b(ve,ke){for(let Pe=ke;Pe<ve.length;Pe++){const Ue=ve.charCodeAt(Pe);if(T(Ue)||k(Ue)||Pe>0&&!S(ve.charCodeAt(Pe-1)))return Pe}return ve.length}function d(ve,ke,Pe,Ue){if(Pe===ve.length)return[];if(Ue===ke.length)return null;if(ve[Pe]!==ke[Ue].toLowerCase())return null;{let Se=null,qe=Ue+1;for(Se=d(ve,ke,Pe+1,Ue+1);!Se&&(qe=b(ke,qe))<ke.length;)Se=d(ve,ke,Pe+1,qe),qe++;return Se===null?null:g({start:Ue,end:Ue+1},Se)}}function u(ve){let ke=0,Pe=0,Ue=0,Se=0,qe=0;for(let He=0;He<ve.length;He++)qe=ve.charCodeAt(He),T(qe)&&ke++,i(qe)&&Pe++,S(qe)&&Ue++,k(qe)&&Se++;const X=ke/ve.length,ie=Pe/ve.length,Ee=Ue/ve.length,Ne=Se/ve.length;return{upperPercent:X,lowerPercent:ie,alphaPercent:Ee,numericPercent:Ne}}function a(ve){const{upperPercent:ke,lowerPercent:Pe}=ve;return Pe===0&&ke>.6}function t(ve){const{upperPercent:ke,lowerPercent:Pe,alphaPercent:Ue,numericPercent:Se}=ve;return Pe>.2&&ke<.8&&Ue>.6&&Se<.2}function r(ve){let ke=0,Pe=0,Ue=0,Se=0;for(let qe=0;qe<ve.length;qe++)Ue=ve.charCodeAt(qe),T(Ue)&&ke++,i(Ue)&&Pe++,w(Ue)&&Se++;return(ke===0||Pe===0)&&Se===0?ve.length<=30:ke<=5}function s(ve,ke){if(!ke||(ke=ke.trim(),ke.length===0)||!r(ve)||ke.length>60)return null;const Pe=u(ke);if(!t(Pe)){if(!a(Pe))return null;ke=ke.toLowerCase()}let Ue=null,Se=0;for(ve=ve.toLowerCase();Se<ke.length&&(Ue=d(ve,ke,0,Se))===null;)Se=b(ke,Se+1);return Ue}e.matchesCamelCase=s;function o(ve,ke,Pe=!1){if(!ke||ke.length===0)return null;let Ue=null,Se=0;for(ve=ve.toLowerCase(),ke=ke.toLowerCase();Se<ke.length&&(Ue=n(ve,ke,0,Se,Pe))===null;)Se=c(ke,Se+1);return Ue}e.matchesWords=o;function n(ve,ke,Pe,Ue,Se){if(Pe===ve.length)return[];if(Ue===ke.length)return null;if(m(ve.charCodeAt(Pe),ke.charCodeAt(Ue))){let qe=null,X=Ue+1;if(qe=n(ve,ke,Pe+1,Ue+1,Se),!Se)for(;!qe&&(X=c(ke,X))<ke.length;)qe=n(ve,ke,Pe+1,X,Se),X++;return qe===null?null:g({start:Ue,end:Ue+1},qe)}else return null}function c(ve,ke){for(let Pe=ke;Pe<ve.length;Pe++)if(l(ve.charCodeAt(Pe))||Pe>0&&l(ve.charCodeAt(Pe-1)))return Pe;return ve.length}const p=R(e.matchesPrefix,s,C),E=R(e.matchesPrefix,s,P),h=new _.LRUCache(1e4);function v(ve,ke,Pe=!1){if(typeof ve!="string"||typeof ke!="string")return null;let Ue=h.get(ve);Ue||(Ue=new RegExp(D.convertSimple2RegExpPattern(ve),"i"),h.set(ve,Ue));const Se=Ue.exec(ke);return Se?[{start:Se.index,end:Se.index+Se[0].length}]:Pe?E(ve,ke):p(ve,ke)}e.matchesFuzzy=v;function A(ve,ke){const Pe=H(ve,ve.toLowerCase(),0,ke,ke.toLowerCase(),0,!0);return Pe?x(Pe):null}e.matchesFuzzy2=A;function F(ve,ke,Pe,Ue,Se,qe){const X=Math.min(13,ve.length);for(;Pe<X;Pe++){const ie=H(ve,ke,Pe,Ue,Se,qe,!1);if(ie)return ie}return[0,qe]}e.anyScore=F;function x(ve){if(typeof ve=="undefined")return[];const ke=[],Pe=ve[1];for(let Ue=ve.length-1;Ue>1;Ue--){const Se=ve[Ue]+Pe,qe=ke[ke.length-1];qe&&qe.end===Se?qe.end=Se+1:ke.push({start:Se,end:Se+1})}return ke}e.createMatches=x;const j=128;function G(){const ve=[],ke=[];for(let Pe=0;Pe<=j;Pe++)ke[Pe]=0;for(let Pe=0;Pe<=j;Pe++)ve.push(ke.slice(0));return ve}function B(ve){const ke=[];for(let Pe=0;Pe<=ve;Pe++)ke[Pe]=0;return ke}const J=B(2*j),O=B(2*j),N=G(),U=G(),L=G(),M=!1;function V(ve,ke,Pe,Ue,Se){function qe(ie,Ee,Ne=" "){for(;ie.length<Ee;)ie=Ne+ie;return ie}let X=` |   |${Ue.split("").map(ie=>qe(ie,3)).join("|")}
`;for(let ie=0;ie<=Pe;ie++)ie===0?X+=" |":X+=`${ke[ie-1]}|`,X+=ve[ie].slice(0,Se+1).map(Ee=>qe(Ee.toString(),3)).join("|")+`
`;return X}function K(ve,ke,Pe,Ue){ve=ve.substr(ke),Pe=Pe.substr(Ue),console.log(V(U,ve,ve.length,Pe,Pe.length)),console.log(V(L,ve,ve.length,Pe,Pe.length)),console.log(V(N,ve,ve.length,Pe,Pe.length))}function se(ve,ke){if(ke<0||ke>=ve.length)return!1;const Pe=ve.codePointAt(ke);switch(Pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!D.isEmojiImprecise(Pe)}}function ce(ve,ke){if(ke<0||ke>=ve.length)return!1;switch(ve.charCodeAt(ke)){case 32:case 9:return!0;default:return!1}}function we(ve,ke,Pe){return ke[ve]!==Pe[ve]}function Te(ve,ke,Pe,Ue,Se,qe,X=!1){for(;ke<Pe&&Se<qe;)ve[ke]===Ue[Se]&&(X&&(J[ke]=Se),ke+=1),Se+=1;return ke===Pe}e.isPatternInWord=Te;var Ie;(function(ve){ve[ve.Diag=1]="Diag",ve[ve.Left=2]="Left",ve[ve.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Me;(function(ve){ve.Default=[-100,0];function ke(Pe){return!Pe||Pe.length===2&&Pe[0]===-100&&Pe[1]===0}ve.isDefault=ke})(Me=e.FuzzyScore||(e.FuzzyScore={}));function H(ve,ke,Pe,Ue,Se,qe,X){const ie=ve.length>j?j:ve.length,Ee=Ue.length>j?j:Ue.length;if(!(Pe>=ie||qe>=Ee||ie-Pe>Ee-qe)&&!!Te(ke,Pe,ie,Se,qe,Ee,!0)){Q(ie,Ee,Pe,qe,ke,Se);let Ne=1,He=1,Be=Pe,Ye=qe;const q=[!1];for(Ne=1,Be=Pe;Be<ie;Ne++,Be++){const ue=J[Be],fe=O[Be],ye=Be+1<ie?O[Be+1]:Ee;for(He=ue-qe+1,Ye=ue;Ye<ye;He++,Ye++){let je=Number.MIN_SAFE_INTEGER,We=!1;Ye<=fe&&(je=ne(ve,ke,Be,Pe,Ue,Se,Ye,Ee,qe,N[Ne-1][He-1]===0,q));let ze=0;je!==Number.MAX_SAFE_INTEGER&&(We=!0,ze=je+U[Ne-1][He-1]);const Xe=Ye>ue,nt=Xe?U[Ne][He-1]+(N[Ne][He-1]>0?-5:0):0,et=Ye>ue+1&&N[Ne][He-1]>0,Je=et?U[Ne][He-2]+(N[Ne][He-2]>0?-5:0):0;if(et&&(!Xe||Je>=nt)&&(!We||Je>=ze))U[Ne][He]=Je,L[Ne][He]=3,N[Ne][He]=0;else if(Xe&&(!We||nt>=ze))U[Ne][He]=nt,L[Ne][He]=2,N[Ne][He]=0;else if(We)U[Ne][He]=ze,L[Ne][He]=1,N[Ne][He]=N[Ne-1][He-1]+1;else throw new Error("not possible")}}if(M&&K(ve,Pe,Ue,qe),!(!q[0]&&!X)){Ne--,He--;const ae=[U[Ne][He],qe];let he=0,Y=0;for(;Ne>=1;){let ue=He;do{const fe=L[Ne][ue];if(fe===3)ue=ue-2;else if(fe===2)ue=ue-1;else break}while(ue>=1);he>1&&ke[Pe+Ne-1]===Se[qe+He-1]&&!we(ue+qe-1,Ue,Se)&&he+1>N[Ne][ue]&&(ue=He),ue===He?he++:he=1,Y||(Y=ue),Ne--,He=ue-1,ae.push(He)}Ee===ie&&(ae[0]+=2);const re=Y-ie;return ae[0]-=re,ae}}}e.fuzzyScore=H;function Q(ve,ke,Pe,Ue,Se,qe){let X=ve-1,ie=ke-1;for(;X>=Pe&&ie>=Ue;)Se[X]===qe[ie]&&(O[X]=ie,X--),ie--}function ne(ve,ke,Pe,Ue,Se,qe,X,ie,Ee,Ne,He){if(ke[Pe]!==qe[X])return Number.MIN_SAFE_INTEGER;let Be=1,Ye=!1;return X===Pe-Ue?Be=ve[Pe]===Se[X]?7:5:we(X,Se,qe)&&(X===0||!we(X-1,Se,qe))?(Be=ve[Pe]===Se[X]?7:5,Ye=!0):se(qe,X)&&(X===0||!se(qe,X-1))?Be=5:(se(qe,X-1)||ce(qe,X-1))&&(Be=5,Ye=!0),Be>1&&Pe===Ue&&(He[0]=!0),Ye||(Ye=we(X,Se,qe)||se(qe,X-1)||ce(qe,X-1)),Pe===Ue?X>Ee&&(Be-=Ye?3:5):Ne?Be+=Ye?2:0:Be+=Ye?0:1,X+1===ie&&(Be-=Ye?3:5),Be}function oe(ve,ke,Pe,Ue,Se,qe,X){return Ce(ve,ke,Pe,Ue,Se,qe,!0,X)}e.fuzzyScoreGracefulAggressive=oe;function ge(ve,ke,Pe,Ue,Se,qe,X){return Ce(ve,ke,Pe,Ue,Se,qe,!1,X)}e.fuzzyScoreGraceful=ge;function Ce(ve,ke,Pe,Ue,Se,qe,X,ie){let Ee=H(ve,ke,Pe,Ue,Se,qe,ie);if(Ee&&!X)return Ee;if(ve.length>=3){const Ne=Math.min(7,ve.length-1);for(let He=Pe+1;He<Ne;He++){const Be=Oe(ve,He);if(Be){const Ye=H(Be,Be.toLowerCase(),Pe,Ue,Se,qe,ie);Ye&&(Ye[0]-=3,(!Ee||Ye[0]>Ee[0])&&(Ee=Ye))}}}return Ee}function Oe(ve,ke){if(!(ke+1>=ve.length)){const Pe=ve[ke],Ue=ve[ke+1];if(Pe!==Ue)return ve.slice(0,ke)+Ue+Pe+ve.slice(ke+2)}}}),define(me[133],pe([0,1,47,93,9]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const I=new RegExp(`\\$\\(${_.CSSIcon.iconNameExpression}(?:${_.CSSIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(`(\\\\)?${I.source}`,"g");function P(m){return m.replace(C,(S,g)=>g?S:`\\${S}`)}e.escapeIcons=P;const y=new RegExp(`\\\\${I.source}`,"g");function i(m){return m.replace(y,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=i;const T=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function k(m){return m.indexOf(e.iconStartMarker)===-1?m:m.replace(T,(S,g,b,d)=>b?S:g||d||"")}e.stripIcons=k;function w(m){const S=m.indexOf(e.iconStartMarker);return S===-1?{text:m}:f(m,S)}e.parseLabelWithIcons=w;function f(m,S){const g=[];let b="";function d(c){if(c){b+=c;for(const p of c)g.push(t)}}let u=-1,a="",t=0,r,s,o=S;const n=m.length;for(d(m.substr(0,S));o<n;)r=m[o],s=m[o+1],r===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(u=o,d(a),a=e.iconStartMarker,o++):r===")"&&u!==-1?(t+=o-u+1,u=-1,a=""):u!==-1?/^[a-z0-9\-]$/i.test(r)?a+=r:(d(a),u=-1,a=""):d(r),o++;return d(a),{text:b,iconOffsets:g}}function l(m,S,g=!1){const{text:b,iconOffsets:d}=S;if(!d||d.length===0)return(0,D.matchesFuzzy)(m,b,g);const u=(0,R.ltrim)(b," "),a=b.length-u.length,t=(0,D.matchesFuzzy)(m,u,g);if(t)for(const r of t){const s=d[r.start+a]+a;r.start+=s,r.end+=s}return t}e.matchesFuzzyIconAware=l}),define(me[94],pe([0,1,14,133,18]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(m="",S=!1){var g,b;if(this.value=m,typeof this.value!="string")throw(0,R.illegalArgument)("value");typeof S=="boolean"?(this.isTrusted=S,this.supportThemeIcons=!1):(this.isTrusted=(g=S.isTrusted)!==null&&g!==void 0?g:void 0,this.supportThemeIcons=(b=S.supportThemeIcons)!==null&&b!==void 0?b:!1)}appendText(m,S=0){return this.value+=k(this.supportThemeIcons?(0,D.escapeIcons)(m):m).replace(/([ \t]+)/g,(g,b)=>"&nbsp;".repeat(b.length)).replace(/^>/gm,"\\>").replace(/\n/g,S===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,S){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=S,this.value+="\n```\n",this}}e.MarkdownString=C;function P(l){return y(l)?!l.value:Array.isArray(l)?l.every(P):!0}e.isEmptyMarkdownString=P;function y(l){return l instanceof C?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function i(l,m){return!l&&!m?!0:!l||!m?!1:Array.isArray(l)&&Array.isArray(m)?(0,_.equals)(l,m,T):y(l)&&y(m)?T(l,m):!1}e.markedStringsEquals=i;function T(l,m){return l===m?!0:!l||!m?!1:l.value===m.value&&l.isTrusted===m.isTrusted&&l.supportThemeIcons===m.supportThemeIcons}function k(l){return l.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function w(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=w;function f(l){const m=[],S=l.split("|").map(b=>b.trim());l=S[0];const g=S[1];if(g){const b=/height=(\d+)/.exec(g),d=/width=(\d+)/.exec(g),u=b?b[1]:"",a=d?d[1]:"",t=isFinite(parseInt(a)),r=isFinite(parseInt(u));t&&m.push(`width="${a}"`),r&&m.push(`height="${u}"`)}return{href:l,dimensions:m}}e.parseHrefAndDimensions=f}),define(me[58],pe([0,1,26,9,2]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function I(i){return JSON.stringify(i,P)}e.stringify=I;function C(i){let T=JSON.parse(i);return T=y(T),T}e.parse=C;function P(i,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,D.regExpFlags)(T)}:T}function y(i,T=0){if(!i||T>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return R.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof _.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let k=0;k<i.length;++k)i[k]=y(i[k],T+1);else for(const k in i)Object.hasOwnProperty.call(i,k)&&(i[k]=y(i[k],T+1))}return i}e.revive=y}),define(me[11],pe([0,1,2,10]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.vscodeWebviewResource="vscode-webview-resource",P.extension="extension",P.vscodeFileResource="vscode-file"})(R=e.Schemas||(e.Schemas={}));class I{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,i,T){this._hosts[y]=i,this._ports[y]=T}setConnectionToken(y,i){this._connectionTokens[y]=i}rewrite(y){if(this._delegate)return this._delegate(y);const i=y.authority;let T=this._hosts[i];T&&T.indexOf(":")!==-1&&(T=`[${T}]`);const k=this._ports[i],w=this._connectionTokens[i];let f=`path=${encodeURIComponent(y.path)}`;return typeof w=="string"&&(f+=`&tkn=${encodeURIComponent(w)}`),_.URI.from({scheme:D.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${T}:${k}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new I;class C{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,i,T){const k=this.toUri(y,i);return k.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(k):D.isNative&&(T||D.isPreferringBrowserCodeLoad)&&k.scheme===R.file?k.with({scheme:R.vscodeFileResource,authority:k.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(y,i){const T=this.toUri(y,i);return T.scheme===R.vscodeFileResource?T.with({scheme:R.file,authority:T.authority!==this.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(y,i){return _.URI.isUri(y)?y:_.URI.parse(i.toUrl(y))}}e.FileAccess=new C}),define(me[76],pe([0,1,22]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const D=new _.LRUCache(1e4);function R(i){return y(i,"NFC",D)}e.normalizeNFC=R;const I=new _.LRUCache(1e4);function C(i){return y(i,"NFD",I)}e.normalizeNFD=C;const P=/[^\u0000-\u0080]/;function y(i,T,k){if(!e.canNormalize||!i)return i;const w=k.get(i);if(w)return w;let f;return P.test(i)?f=i.normalize(T):f=i,k.set(i,f),f}e.removeAccents=function(){if(e.canNormalize){const i=/[\u0300-\u036f]/g;return function(T){return C(T).replace(i,"")}}else return function(i){return i}}()}),define(me[23],pe([0,1,30,7,2,9,11,10]),function(Z,e,_,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(f){return(0,R.uriToFsPath)(f,!0)}e.originalFSPath=y;class i{constructor(l){this._ignorePathCasing=l}compare(l,m,S=!1){return l===m?0:(0,I.compare)(this.getComparisonKey(l,S),this.getComparisonKey(m,S))}isEqual(l,m,S=!1){return l===m?!0:!l||!m?!1:this.getComparisonKey(l,S)===this.getComparisonKey(m,S)}getComparisonKey(l,m=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,m,S=!1){if(l.scheme===m.scheme){if(l.scheme===C.Schemas.file)return _.isEqualOrParent(y(l),y(m),this._ignorePathCasing(l))&&l.query===m.query&&(S||l.fragment===m.fragment);if((0,e.isEqualAuthority)(l.authority,m.authority))return _.isEqualOrParent(l.path,m.path,this._ignorePathCasing(l),"/")&&l.query===m.query&&(S||l.fragment===m.fragment)}return!1}joinPath(l,...m){return R.URI.joinPath(l,...m)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return D.posix.basename(l.path)}extname(l){return D.posix.extname(l.path)}dirname(l){if(l.path.length===0)return l;let m;return l.scheme===C.Schemas.file?m=R.URI.file(D.dirname(y(l))).path:(m=D.posix.dirname(l.path),l.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),m="/")),l.with({path:m})}normalizePath(l){if(!l.path.length)return l;let m;return l.scheme===C.Schemas.file?m=R.URI.file(D.normalize(y(l))).path:m=D.posix.normalize(l.path),l.with({path:m})}relativePath(l,m){if(!(l.scheme!==m.scheme||!(0,e.isEqualAuthority)(l.authority,m.authority))){if(l.scheme===C.Schemas.file){const b=D.relative(y(l),y(m));return P.isWindows?_.toSlashes(b):b}let S=l.path||"/",g=m.path||"/";if(this._ignorePathCasing(l)){let b=0;for(const d=Math.min(S.length,g.length);b<d&&!(S.charCodeAt(b)!==g.charCodeAt(b)&&S.charAt(b).toLowerCase()!==g.charAt(b).toLowerCase());b++);S=g.substr(0,b)+S.substr(b)}return D.posix.relative(S,g)}}resolvePath(l,m){if(l.scheme===C.Schemas.file){const S=R.URI.file(D.resolve(y(l),m));return l.with({authority:S.authority,path:S.path})}return m.indexOf("/")===-1&&(m=_.toSlashes(m),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m)),l.with({path:D.posix.resolve(l.path,m)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,m){return l===m||(0,I.equalsIgnoreCase)(l,m)}hasTrailingPathSeparator(l,m=D.sep){if(l.scheme===C.Schemas.file){const S=y(l);return S.length>_.getRoot(S).length&&S[S.length-1]===m}else{const S=l.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,m=D.sep){return(0,e.hasTrailingPathSeparator)(l,m)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,m=D.sep){let S=!1;if(l.scheme===C.Schemas.file){const g=y(l);S=g!==void 0&&g.length===_.getRoot(g).length&&g[g.length-1]===m}else{m="/";const g=l.path;S=g.length===1&&g.charCodeAt(g.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(l,m)?l.with({path:l.path+"/"}):l}}e.ExtUri=i,e.extUri=new i(()=>!1),e.extUriBiasedIgnorePathCase=new i(f=>f.scheme===C.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new i(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(f,l){const m=[];for(let S=0;S<f.length;S++){const g=l(f[S]);f.some((b,d)=>d===S?!1:(0,e.isEqualOrParent)(g,l(b)))||m.push(f[S])}return m}e.distinctParents=T;var k;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function l(m){const S=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(d=>{const[u,a]=d.split(":");u&&a&&S.set(u,a)});const b=m.path.substring(0,m.path.indexOf(";"));return b&&S.set(f.META_DATA_MIME,b),S}f.parseMetaData=l})(k=e.DataUri||(e.DataUri={}));function w(f,l,m){if(l){let S=f.path;return S&&S[0]!==D.posix.sep&&(S=D.posix.sep+S),f.with({scheme:m,authority:l,path:S})}return f.with({scheme:m})}e.toLocalResource=w}),define(me[19],pe([0,1,21,18,3,6,57,23]),function(Z,e,_,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(U){return!!U&&typeof U.then=="function"}e.isThenable=y;function i(U){const L=new _.CancellationTokenSource,M=U(L.token),V=new Promise((K,se)=>{L.token.onCancellationRequested(()=>{se((0,D.canceled)())}),Promise.resolve(M).then(ce=>{L.dispose(),K(ce)},ce=>{L.dispose(),se(ce)})});return new class{cancel(){L.cancel()}then(K,se){return V.then(K,se)}catch(K){return this.then(void 0,K)}finally(K){return V.finally(K)}}}e.createCancelablePromise=i;function T(U,L,M){return Promise.race([U,new Promise(V=>L.onCancellationRequested(()=>V(M)))])}e.raceCancellation=T;async function k(U){let L=-1;const M=U.map((K,se)=>K.then(ce=>(L=se,ce))),V=await Promise.race(M);return U.forEach((K,se)=>{se!==L&&K.cancel()}),V}e.raceCancellablePromises=k;function w(U,L,M){let V;const K=setTimeout(()=>{V==null||V(void 0),M==null||M()},L);return Promise.race([U.finally(()=>clearTimeout(K)),new Promise(se=>V=se)])}e.raceTimeout=w;function f(U){return new Promise((L,M)=>{const V=U();y(V)?V.then(L,M):L(V)})}e.asPromise=f;class l{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(M,M).then(V)})}return new Promise((M,V)=>{this.queuedPromise.then(M,V)})}return this.activePromise=L(),new Promise((M,V)=>{this.activePromise.then(K=>{this.activePromise=null,M(K)},K=>{this.activePromise=null,V(K)})})}}e.Throttler=l;class m{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=m;class S{constructor(){this.promiseMap=new Map}queue(L,M){var V;const se=((V=this.promiseMap.get(L))!==null&&V!==void 0?V:Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(L)===se&&this.promiseMap.delete(L)});return this.promiseMap.set(L,se),se}}e.SequencerByKey=S;class g{constructor(L){this.defaultDelay=L,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,M=this.defaultDelay){return this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,K)=>{this.doResolve=V,this.doReject=K}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},M),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,D.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=g;class b{constructor(L){this.delayer=new g(L),this.throttler=new l}trigger(L,M){return this.delayer.trigger(()=>this.throttler.queue(L),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class d{constructor(){this._isOpen=!1,this._promise=new Promise((L,M)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=d;class u extends d{constructor(L){super();this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function a(U,L){return L?new Promise((M,V)=>{const K=setTimeout(M,U);L.onCancellationRequested(()=>{clearTimeout(K),V((0,D.canceled)())})}):i(M=>a(U,M))}e.timeout=a;function t(U,L=0){const M=setTimeout(U,L);return(0,I.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=t;function r(U){return U.then(void 0,L=>{})}e.ignoreErrors=r;function s(U){const L=[];let M=0;const V=U.length;function K(){return M<V?U[M++]():null}function se(ce){ce!=null&&L.push(ce);const we=K();return we?we.then(se):Promise.resolve(L)}return Promise.resolve(null).then(se)}e.sequence=s;function o(U,L=V=>!!V,M=null){let V=0;const K=U.length,se=()=>{if(V>=K)return Promise.resolve(M);const ce=U[V++];return Promise.resolve(ce()).then(Te=>L(Te)?Promise.resolve(Te):se())};return se()}e.first=o;function n(U,L=V=>!!V,M=null){if(U.length===0)return Promise.resolve(M);let V=U.length;const K=()=>{var se,ce;V=-1;for(const we of U)(ce=(se=we).cancel)===null||ce===void 0||ce.call(se)};return new Promise((se,ce)=>{for(const we of U)we.then(Te=>{--V>=0&&L(Te)?(K(),se(Te)):V===0&&se(M)}).catch(Te=>{--V>=0&&(K(),ce(Te))})})}e.firstParallel=n;class c{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(L){return this._size++,new Promise((M,V)=>{this.outstandingPromises.push({factory:L,c:M,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const M=L.factory();M.then(L.c,L.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=c;class p extends c{constructor(){super(1)}}e.Queue=p;class E{constructor(){this.queues=new Map}queueFor(L,M=P.extUri){const V=M.getComparisonKey(L);let K=this.queues.get(V);return K||(K=new p,R.Event.once(K.onFinished)(()=>{K==null||K.dispose(),this.queues.delete(V)}),this.queues.set(V,K)),K}dispose(){this.queues.forEach(L=>L.dispose()),this.queues.clear()}}e.ResourceQueue=E;class h{constructor(L,M){this._token=-1,typeof L=="function"&&typeof M=="number"&&this.setIfNotSet(L,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},M)}setIfNotSet(L,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},M))}}e.TimeoutTimer=h;class v{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,M){this.cancel(),this._token=setInterval(()=>{L()},M)}}e.IntervalTimer=v;class A{constructor(L,M){this.timeoutToken=-1,this.runner=L,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=A;class F extends A{constructor(L,M){super(L,M);this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner&&this.runner(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const U=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=L=>{const M=setTimeout(()=>L(U));let V=!1;return{dispose(){V||(V=!0,clearTimeout(M))}}}}else e.runWhenIdle=(U,L)=>{const M=requestIdleCallback(U,typeof L=="number"?{timeout:L}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(M))}}}}();class x{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=x;async function j(U,L,M){let V;for(let K=0;K<M;K++)try{return await U()}catch(se){V=se,await a(L)}throw V}e.retry=j;class G{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var L;(L=this._pending)===null||L===void 0||L.cancel()}setPending(L,M,V){return this._pending={taskId:L,cancel:()=>V==null?void 0:V(),promise:M},M.then(()=>this.donePending(L),()=>this.donePending(L)),M}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let M,V;const K=new Promise((se,ce)=>{M=se,V=ce});this._next={run:L,promise:K,promiseResolve:M,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=G;class B{constructor(L){this.interval=L,this.lastIncrementTime=0,this.value=0}increment(){const L=Date.now();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class J{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,M)=>{this.completeCallback=L,this.errorCallback=M})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(M=>{this.completeCallback(L),this.resolved=!0,M()})}error(L){return new Promise(M=>{this.errorCallback(L),this.rejected=!0,M()})}cancel(){new Promise(L=>{this.errorCallback((0,D.canceled)()),this.rejected=!0,L()})}}e.DeferredPromise=J;class O extends R.Emitter{async fireAsync(L,M,V){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const K of this._listeners)this._asyncDeliveryQueue.push([K,L]);for(;this._asyncDeliveryQueue.size>0&&!M.isCancellationRequested;){const[K,se]=this._asyncDeliveryQueue.shift(),ce=[],we=Object.assign(Object.assign({},se),{waitUntil:Te=>{if(Object.isFrozen(ce))throw new Error("waitUntil can NOT be called asynchronous");V&&(Te=V(Te,typeof K=="function"?K:K[0])),ce.push(Te)}});try{typeof K=="function"?K.call(void 0,we):K[0].call(K[1],we)}catch(Te){(0,D.onUnexpectedError)(Te);continue}Object.freeze(ce),await N.settled(ce).catch(Te=>(0,D.onUnexpectedError)(Te))}}}}e.AsyncEmitter=O;var N;(function(U){async function L(se){return typeof Promise.allSettled=="function"?M(se):V(se)}U.allSettled=L;async function M(se){return Promise.allSettled(se)}async function V(se){return Promise.all(se.map(ce=>ce.then(we=>({status:"fulfilled",value:we}),we=>({status:"rejected",reason:we}))))}async function K(se){let ce;const we=await Promise.all(se.map(Te=>Te.then(Ie=>Ie,Ie=>{ce||(ce=Ie)})));if(typeof ce!="undefined")throw ce;return we}U.settled=K})(N=e.Promises||(e.Promises={}))}),define(me[95],pe([0,1,7,19]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const R=new D.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),I=new D.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new D.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(u,a,t=!1){const r=u||"",s=a||"",o=R.value.collator.compare(r,s);return R.value.collatorIsNumeric&&o===0&&r!==s?r<s?-1:1:o}e.compareFileNames=P;function y(u,a){const t=I.value.collator;return u=u||"",a=a||"",m(t,u,a)}e.compareFileNamesDefault=y;function i(u,a,t=!1){t||(u=u&&u.toLowerCase(),a=a&&a.toLowerCase());const[r,s]=f(u),[o,n]=f(a);return r!==o?r<o?-1:1:s===n?0:s<n?-1:1}e.noIntlCompareFileNames=i;function T(u,a){const[t,r]=f(u),[s,o]=f(a);let n=R.value.collator.compare(r,o);if(n===0){if(R.value.collatorIsNumeric&&r!==o)return r<o?-1:1;if(n=R.value.collator.compare(t,s),R.value.collatorIsNumeric&&n===0&&t!==s)return t<s?-1:1}return n}e.compareFileExtensions=T;function k(u,a){u=u||"",a=a||"";const t=l(u),r=l(a),s=I.value.collator,o=C.value.collator;let n;return n=m(o,t,r),n!==0?n:m(s,u,a)}e.compareFileExtensionsDefault=k;const w=/^(.*?)(\.([^.]*))?$/;function f(u,a=!1){const t=u?w.exec(u):[];let r=[t&&t[1]||"",t&&t[3]||""];return a&&(!r[0]&&r[1]||r[0]&&r[0].charAt(0)===".")&&(r=[r[0]+"."+r[1],""]),r}function l(u){const a=u?w.exec(u):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function m(u,a,t){let r=u.compare(a,t);return r!==0?r:a.length!==t.length?a.length<t.length?-1:1:0}function S(u,a,t=!1){return t||(u=u&&u.toLowerCase(),a=a&&a.toLowerCase()),u===a?0:u<a?-1:1}function g(u,a,t=!1){const r=u.split(_.sep),s=a.split(_.sep),o=r.length-1,n=s.length-1;let c,p;for(let E=0;;E++){if(c=o===E,p=n===E,c&&p)return P(r[E],s[E],t);if(c)return-1;if(p)return 1;const h=S(r[E],s[E],t);if(h!==0)return h}}e.comparePaths=g;function b(u,a,t){const r=u.toLowerCase(),s=a.toLowerCase(),o=d(u,a,t);if(o)return o;const n=r.endsWith(t),c=s.endsWith(t);if(n!==c)return n?-1:1;const p=P(r,s);return p!==0?p:r.localeCompare(s)}e.compareAnything=b;function d(u,a,t){const r=u.toLowerCase(),s=a.toLowerCase(),o=r.startsWith(t),n=s.startsWith(t);if(o!==n)return o?-1:1;if(o&&n){if(r.length<s.length)return-1;if(r.length>s.length)return 1}return 0}e.compareByPrefix=d}),define(me[96],pe([0,1,95,93,7,10,9]),function(Z,e,_,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const P=0,y=[P,[]];function i(B,J,O,N){if(!B||!J)return y;const U=B.length,L=J.length;if(U<L)return y;const M=B.toLowerCase();return!N&&!M.includes(O)?y:T(J,O,L,B,M,U)}e.scoreFuzzy=i;function T(B,J,O,N,U,L){const M=[],V=[];for(let we=0;we<O;we++){const Te=we*L,Ie=Te-L,Me=we>0,H=B[we],Q=J[we];for(let ne=0;ne<L;ne++){const oe=ne>0,ge=Te+ne,Ce=ge-1,Oe=Ie+ne-1,ve=oe?M[Ce]:0,ke=Me&&oe?M[Oe]:0,Pe=Me&&oe?V[Oe]:0;let Ue;!ke&&Me?Ue=0:Ue=k(H,Q,N,U,ne,Pe),Ue&&ke+Ue>=ve?(V[ge]=Pe+1,M[ge]=ke+Ue):(V[ge]=P,M[ge]=ve)}}const K=[];let se=O-1,ce=L-1;for(;se>=0&&ce>=0;){const we=se*L+ce;V[we]===P||(K.push(ce),se--),ce--}return[M[O*L-1],K.reverse()]}function k(B,J,O,N,U,L){let M=0;if(!w(J,N[U]))return M;if(M+=1,L>0&&(M+=L*5),B===O[U]&&(M+=1),U===0)M+=8;else{const V=f(O.charCodeAt(U-1));V?M+=V:(0,D.isUpper)(O.charCodeAt(U))&&(M+=2)}return M}function w(B,J){return B===J?!0:B==="/"||B==="\\"?J==="/"||J==="\\":!1}function f(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const l=[void 0,[]];function m(B,J,O=0,N=0){const U=J;return U.values&&U.values.length>1?S(B,U.values,O,N):g(B,J,O,N)}e.scoreFuzzy2=m;function S(B,J,O,N){let U=0;const L=[];for(const M of J){const[V,K]=g(B,M,O,N);if(typeof V!="number")return l;U+=V,L.push(...K)}return[U,c(L)]}function g(B,J,O,N){const U=(0,D.fuzzyScore)(J.original,J.originalLowercase,O,B,B.toLowerCase(),N,!0);return U?[U[0],(0,D.createMatches)(U)]:l}const b=Object.freeze({score:0}),d=1<<18,u=1<<17,a=1<<16;function t(B,J,O,N,U){if(!B||!J.normalized)return b;const L=N.getItemLabel(B);if(!L)return b;const M=N.getItemDescription(B);let V;M?V=`${L}${M}${J.normalized}${Array.isArray(J.values)?J.values.length:""}${O}`:V=`${L}${J.normalized}${Array.isArray(J.values)?J.values.length:""}${O}`;const K=U[V];if(K)return K;const se=r(L,M,N.getItemPath(B),J,O);return U[V]=se,se}e.scoreItemFuzzy=t;function r(B,J,O,N,U){const L=!O||!N.containsPathSeparator;return O&&(I.isLinux?N.pathNormalized===O:(0,C.equalsIgnoreCase)(N.pathNormalized,O))?{score:d,labelMatch:[{start:0,end:B.length}],descriptionMatch:J?[{start:0,end:J.length}]:void 0}:N.values&&N.values.length>1?s(B,J,O,N.values,L,U):o(B,J,O,N,L,U)}function s(B,J,O,N,U,L){let M=0;const V=[],K=[];for(const se of N){const{score:ce,labelMatch:we,descriptionMatch:Te}=o(B,J,O,se,U,L);if(ce===P)return b;M+=ce,we&&V.push(...we),Te&&K.push(...Te)}return{score:M,labelMatch:c(V),descriptionMatch:c(K)}}function o(B,J,O,N,U,L){if(U||!J){const[M,V]=i(B,N.normalized,N.normalizedLowercase,L);if(M){const K=(0,D.matchesPrefix)(N.normalized,B);let se;return K?(se=u,se+=Math.round(N.normalized.length/B.length*100)):se=a,{score:se+M,labelMatch:K||n(V)}}}if(J){let M=J;O&&(M=`${J}${R.sep}`);const V=M.length,K=`${M}${B}`,[se,ce]=i(K,N.normalized,N.normalizedLowercase,L);if(se){const we=n(ce),Te=[],Ie=[];return we.forEach(Me=>{Me.start<V&&Me.end>V?(Te.push({start:0,end:Me.end-V}),Ie.push({start:Me.start,end:V})):Me.start>=V?Te.push({start:Me.start-V,end:Me.end-V}):Ie.push(Me)}),{score:se,labelMatch:Te,descriptionMatch:Ie}}}return b}function n(B){const J=[];if(!B)return J;let O;for(const N of B)O&&O.end===N?O.end+=1:(O={start:N,end:N+1},J.push(O));return J}function c(B){const J=B.sort((U,L)=>U.start-L.start),O=[];let N;for(const U of J)!N||!p(N,U)?(N=U,O.push(U)):(N.start=Math.min(N.start,U.start),N.end=Math.max(N.end,U.end));return O}function p(B,J){return!(B.end<J.start||J.end<B.start)}function E(B,J,O,N,U,L){const M=t(B,O,N,U,L),V=t(J,O,N,U,L),K=M.score,se=V.score;if((K===d||se===d)&&K!==se)return K===d?-1:1;if(K>a||se>a){if(K!==se)return K>se?-1:1;if(K<u&&se<u){const Q=v(M.labelMatch,V.labelMatch);if(Q!==0)return Q}const Me=U.getItemLabel(B)||"",H=U.getItemLabel(J)||"";if(Me.length!==H.length)return Me.length-H.length}if(K!==se)return K>se?-1:1;const ce=Array.isArray(M.labelMatch)&&M.labelMatch.length>0,we=Array.isArray(V.labelMatch)&&V.labelMatch.length>0;if(ce&&!we)return-1;if(we&&!ce)return 1;const Te=h(B,M,U),Ie=h(J,V,U);return Te&&Ie&&Te!==Ie?Ie>Te?-1:1:A(B,J,O,U)}e.compareItemsByFuzzyScore=E;function h(B,J,O){let N=-1,U=-1;if(J.descriptionMatch&&J.descriptionMatch.length?N=J.descriptionMatch[0].start:J.labelMatch&&J.labelMatch.length&&(N=J.labelMatch[0].start),J.labelMatch&&J.labelMatch.length){if(U=J.labelMatch[J.labelMatch.length-1].end,J.descriptionMatch&&J.descriptionMatch.length){const L=O.getItemDescription(B);L&&(U+=L.length)}}else J.descriptionMatch&&J.descriptionMatch.length&&(U=J.descriptionMatch[J.descriptionMatch.length-1].end);return U-N}function v(B,J){if(!B&&!J||(!B||!B.length)&&(!J||!J.length))return 0;if(!J||!J.length)return-1;if(!B||!B.length)return 1;const O=B[0].start,U=B[B.length-1].end-O,L=J[0].start,V=J[J.length-1].end-L;return U===V?0:V<U?1:-1}function A(B,J,O,N){const U=N.getItemLabel(B)||"",L=N.getItemLabel(J)||"",M=N.getItemDescription(B),V=N.getItemDescription(J),K=U.length+(M?M.length:0),se=L.length+(V?V.length:0);if(K!==se)return K-se;const ce=N.getItemPath(B),we=N.getItemPath(J);return ce&&we&&ce.length!==we.length?ce.length-we.length:U!==L?(0,_.compareAnything)(U,L,O.normalized):M&&V&&M!==V?(0,_.compareAnything)(M,V,O.normalized):ce&&we&&ce!==we?(0,_.compareAnything)(ce,we,O.normalized):0}const F=" ";function x(B){typeof B!="string"&&(B="");const J=B.toLowerCase(),{pathNormalized:O,normalized:N,normalizedLowercase:U}=j(B),L=O.indexOf(R.sep)>=0;let M;const V=B.split(F);if(V.length>1)for(const K of V){const{pathNormalized:se,normalized:ce,normalizedLowercase:we}=j(K);ce&&(M||(M=[]),M.push({original:K,originalLowercase:K.toLowerCase(),pathNormalized:se,normalized:ce,normalizedLowercase:we}))}return{original:B,originalLowercase:J,pathNormalized:O,normalized:N,normalizedLowercase:U,values:M,containsPathSeparator:L}}e.prepareQuery=x;function j(B){let J;I.isWindows?J=B.replace(/\//g,R.sep):J=B.replace(/\\/g,R.sep);const O=(0,C.stripWildcards)(J).replace(/\s/g,"");return{pathNormalized:J,normalized:O,normalizedLowercase:O.toLowerCase()}}function G(B){return Array.isArray(B)?x(B.map(J=>J.original).join(F)):x(B.original)}e.pieceToQuery=G}),define(me[33],pe([0,1,9,30,7,22,19]),function(Z,e,_,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const y="**",i="/",T="[/\\\\]",k="[^/\\\\]",w=/\//g;function f(M){switch(M){case 0:return"";case 1:return`${k}*?`;default:return`(?:${T}|${k}+${T}|${T}${k}+)*?`}}function l(M,V){if(!M)return[];const K=[];let se=!1,ce=!1,we="";for(const Te of M){switch(Te){case V:if(!se&&!ce){K.push(we),we="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}we+=Te}return we&&K.push(we),K}e.splitGlobAware=l;function m(M){if(!M)return"";let V="";const K=l(M,i);if(K.every(se=>se===y))V=".*";else{let se=!1;K.forEach((ce,we)=>{if(ce===y){se||(V+=f(2),se=!0);return}let Te=!1,Ie="",Me=!1,H="";for(const Q of ce){if(Q!=="}"&&Te){Ie+=Q;continue}if(Me&&(Q!=="]"||!H)){let ne;Q==="-"?ne=Q:(Q==="^"||Q==="!")&&!H?ne="^":Q===i?ne="":ne=_.escapeRegExpCharacters(Q),H+=ne;continue}switch(Q){case"{":Te=!0;continue;case"[":Me=!0;continue;case"}":V+=`(?:${l(Ie,",").map(ge=>m(ge)).join("|")})`,Te=!1,Ie="";break;case"]":V+="["+H+"]",Me=!1,H="";break;case"?":V+=k;continue;case"*":V+=f(1);continue;default:V+=_.escapeRegExpCharacters(Q)}}we<K.length-1&&(K[we+1]!==y||we+2<K.length)&&(V+=T),se=!1})}return V}const S=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.LRUCache(1e4),r=function(){return!1},s=function(){return null};function o(M,V){if(!M)return s;let K;typeof M!="string"?K=M.pattern:K=M,K=K.trim();const se=`${K}_${!!V.trimForExclusions}`;let ce=t.get(se);if(ce)return n(ce,M);let we;if(S.test(K)){const Te=K.substr(4);ce=function(Ie,Me){return typeof Ie=="string"&&Ie.endsWith(Te)?K:null}}else(we=g.exec(c(K,V)))?ce=p(we[1],K):(V.trimForExclusions?d:b).test(K)?ce=E(K,V):(we=u.exec(c(K,V)))?ce=h(we[1].substr(1),K,!0):(we=a.exec(c(K,V)))?ce=h(we[1],K,!1):ce=v(K);return t.set(se,ce),n(ce,M)}function n(M,V){return typeof V=="string"?M:function(K,se){return D.isEqualOrParent(K,V.base)?M(R.relative(V.base,K),se):null}}function c(M,V){return V.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function p(M,V){const K=`/${M}`,se=`\\${M}`,ce=function(Te,Ie){return typeof Te!="string"?null:Ie?Ie===M?V:null:Te===M||Te.endsWith(K)||Te.endsWith(se)?V:null},we=[M];return ce.basenames=we,ce.patterns=[V],ce.allBasenames=we,ce}function E(M,V){const K=L(M.slice(1,-1).split(",").map(Ie=>o(Ie,V)).filter(Ie=>Ie!==s),M),se=K.length;if(!se)return s;if(se===1)return K[0];const ce=function(Ie,Me){for(let H=0,Q=K.length;H<Q;H++)if(K[H](Ie,Me))return M;return null},we=K.find(Ie=>!!Ie.allBasenames);we&&(ce.allBasenames=we.allBasenames);const Te=K.reduce((Ie,Me)=>Me.allPaths?Ie.concat(Me.allPaths):Ie,[]);return Te.length&&(ce.allPaths=Te),ce}function h(M,V,K){const se=R.sep===R.posix.sep,ce=se?M:M.replace(w,R.sep),we=R.sep+ce,Te=R.posix.sep+M,Ie=K?function(Me,H){return typeof Me=="string"&&(Me===ce||Me.endsWith(we)||!se&&(Me===M||Me.endsWith(Te)))?V:null}:function(Me,H){return typeof Me=="string"&&(Me===ce||!se&&Me===M)?V:null};return Ie.allPaths=[(K?"*/":"./")+M],Ie}function v(M){try{const V=new RegExp(`^${m(M)}$`);return function(K){return V.lastIndex=0,typeof K=="string"&&V.test(K)?M:null}}catch(V){return s}}function A(M,V,K){return!M||typeof V!="string"?!1:F(M)(V,void 0,K)}e.match=A;function F(M,V={}){if(!M)return r;if(typeof M=="string"||B(M)){const K=o(M,V);if(K===s)return r;const se=function(ce,we){return!!K(ce,we)};return K.allBasenames&&(se.allBasenames=K.allBasenames),K.allPaths&&(se.allPaths=K.allPaths),se}return N(M,V)}e.parse=F;function x(M){if(!!M){let V;return K=>(V||(V=(M()||Promise.resolve([])).then(se=>se?G(se):{})),V.then(se=>!!se[K]))}}e.hasSiblingPromiseFn=x;function j(M){if(!!M){let V;return K=>{if(!V){const se=M();V=se?G(se):{}}return!!V[K]}}}e.hasSiblingFn=j;function G(M){const V={};for(const K of M)V[K]=!0;return V}function B(M){const V=M;return V&&typeof V.base=="string"&&typeof V.pattern=="string"}e.isRelativePattern=B;function J(M){return M.allBasenames||[]}e.getBasenameTerms=J;function O(M){return M.allPaths||[]}e.getPathTerms=O;function N(M,V){const K=L(Object.getOwnPropertyNames(M).map(Ie=>U(Ie,M[Ie],V)).filter(Ie=>Ie!==s)),se=K.length;if(!se)return s;if(!K.some(Ie=>!!Ie.requiresSiblings)){if(se===1)return K[0];const Ie=function(Q,ne){for(let oe=0,ge=K.length;oe<ge;oe++){const Ce=K[oe](Q,ne);if(Ce)return Ce}return null},Me=K.find(Q=>!!Q.allBasenames);Me&&(Ie.allBasenames=Me.allBasenames);const H=K.reduce((Q,ne)=>ne.allPaths?Q.concat(ne.allPaths):Q,[]);return H.length&&(Ie.allPaths=H),Ie}const ce=function(Ie,Me,H){let Q;for(let ne=0,oe=K.length;ne<oe;ne++){const ge=K[ne];ge.requiresSiblings&&H&&(Me||(Me=R.basename(Ie)),Q||(Q=Me.substr(0,Me.length-R.extname(Ie).length)));const Ce=ge(Ie,Me,Q,H);if(Ce)return Ce}return null},we=K.find(Ie=>!!Ie.allBasenames);we&&(ce.allBasenames=we.allBasenames);const Te=K.reduce((Ie,Me)=>Me.allPaths?Ie.concat(Me.allPaths):Ie,[]);return Te.length&&(ce.allPaths=Te),ce}function U(M,V,K){if(V===!1)return s;const se=o(M,K);if(se===s)return s;if(typeof V=="boolean")return se;if(V){const ce=V.when;if(typeof ce=="string"){const we=(Te,Ie,Me,H)=>{if(!H||!se(Te,Ie))return null;const Q=ce.replace("$(basename)",Me),ne=H(Q);return(0,C.isThenable)(ne)?ne.then(oe=>oe?M:null):ne?M:null};return we.requiresSiblings=!0,we}}return se}function L(M,V){const K=M.filter(Ie=>!!Ie.basenames);if(K.length<2)return M;const se=K.reduce((Ie,Me)=>{const H=Me.basenames;return H?Ie.concat(H):Ie},[]);let ce;if(V){ce=[];for(let Ie=0,Me=se.length;Ie<Me;Ie++)ce.push(V)}else ce=K.reduce((Ie,Me)=>{const H=Me.patterns;return H?Ie.concat(H):Ie},[]);const we=function(Ie,Me){if(typeof Ie!="string")return null;if(!Me){let Q;for(Q=Ie.length;Q>0;Q--){const ne=Ie.charCodeAt(Q-1);if(ne===47||ne===92)break}Me=Ie.substr(Q)}const H=se.indexOf(Me);return H!==-1?ce[H]:null};we.basenames=se,we.patterns=ce,we.allBasenames=se;const Te=M.filter(Ie=>!Ie.basenames);return Te.push(we),Te}}),define(me[77],pe([0,1,2,7,9,11,10,23,30]),function(Z,e,_,D,R,I,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function i(o,n,c){if(typeof o=="string"&&(o=_.URI.file(o)),c){const E=c.getWorkspaceFolder(o);if(E){const h=c.getWorkspace().folders.length>1;let v;if((0,P.isEqual)(E.uri,o)?v="":v=(0,P.relativePath)(E.uri,o),h){const A=E.name?E.name:(0,P.basename)(E.uri);v=v?A+" \u2022 "+v:A}return v}}if(o.scheme!==I.Schemas.file&&o.scheme!==I.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(o.fsPath))return(0,D.normalize)(k(o.fsPath));let p=(0,D.normalize)(o.fsPath);return!C.isWindows&&(n==null?void 0:n.userHome)&&(p=f(p,n.userHome.fsPath)),p}e.getPathLabel=i;function T(o){if(!!o){typeof o=="string"&&(o=_.URI.file(o));const n=(0,P.basename)(o)||(o.scheme===I.Schemas.file?o.fsPath:o.path);return C.isWindows&&(0,y.isRootOrDriveLetter)(n)?k(n):n}}e.getBaseLabel=T;function k(o){return(0,y.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=k;let w=Object.create(null);function f(o,n){if(C.isWindows||!o||!n)return o;let c=w.original===n?w.normalized:void 0;return c||(c=`${(0,R.rtrim)(n,D.posix.sep)}${D.posix.sep}`,w={original:n,normalized:c}),(C.isLinux?o.startsWith(c):(0,R.startsWithIgnoreCase)(o,c))&&(o=`~/${o.substr(c.length)}`),o}e.tildify=f;function l(o,n){return o.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=l;const m="\u2026",S="\\\\",g="~";function b(o,n=D.sep){const c=new Array(o.length);let p=!1;for(let E=0;E<o.length;E++){let h=o[E];if(h===""){c[E]=`.${n}`;continue}if(!h){c[E]=h;continue}p=!0;let v="";h.indexOf(S)===0?(v=h.substr(0,h.indexOf(S)+S.length),h=h.substr(h.indexOf(S)+S.length)):h.indexOf(n)===0?(v=h.substr(0,h.indexOf(n)+n.length),h=h.substr(h.indexOf(n)+n.length)):h.indexOf(g)===0&&(v=h.substr(0,h.indexOf(g)+g.length),h=h.substr(h.indexOf(g)+g.length));const A=h.split(n);for(let F=1;p&&F<=A.length;F++)for(let x=A.length-F;p&&x>=0;x--){p=!1;let j=A.slice(x,x+F).join(n);for(let G=0;!p&&G<o.length;G++)if(G!==E&&o[G]&&o[G].indexOf(j)>-1){const B=x+F===A.length,J=x>0&&o[G].indexOf(n)>-1?n+j:j,O=o[G].endsWith(J);p=!B||O}if(!p){let G="";(A[0].endsWith(":")||v!=="")&&(x===1&&(x=0,F++,j=A[0]+n+j),x>0&&(G=A[0]+n),G=v+G),x>0&&(G=G+m+n),G=G+j,x+F<A.length&&(G=G+n+m),c[E]=G}}p&&(c[E]=h)}return c}e.shorten=b;var d;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function u(o,n=Object.create(null)){const c=[];let p=!1,E="";for(const h of o)if(h==="$"||p&&h==="{")E&&c.push({value:E,type:d.TEXT}),E="",p=!0;else if(h==="}"&&p){const v=n[E];if(typeof v=="string")v.length&&c.push({value:v,type:d.VARIABLE});else if(v){const A=c[c.length-1];(!A||A.type!==d.SEPARATOR)&&c.push({value:v.label,type:d.SEPARATOR})}E="",p=!1}else E+=h;return E&&!p&&c.push({value:E,type:d.TEXT}),c.filter((h,v)=>{if(h.type===d.SEPARATOR){const A=c[v-1],F=c[v+1];return[A,F].every(x=>x&&(x.type===d.VARIABLE||x.type===d.TEXT)&&x.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=u;function a(o,n){return C.isMacintosh||n?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):o.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=a;function t(o,n){return C.isMacintosh||n?o.replace(/\(&&\w\)|&&/g,""):C.isWindows?o.replace(/&&|&/g,c=>c==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(o){const n=o.indexOf("/")!==-1?D.posix:D.win32,c=n.basename(o),p=n.dirname(o);return c.length?{name:c,parentPath:p}:{name:p,parentPath:""}}e.splitName=s}),define(me[97],pe([0,1,2]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(T){return T.toJSON()}class R{constructor(k){this._uriTransformer=k}transformIncoming(k){const w=this._uriTransformer.transformIncoming(k);return w===k?k:D(_.URI.from(w))}transformOutgoing(k){const w=this._uriTransformer.transformOutgoing(k);return w===k?k:D(_.URI.from(w))}transformOutgoingURI(k){const w=this._uriTransformer.transformOutgoing(k);return w===k?k:_.URI.from(w)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function I(T,k,w){if(!T||w>200)return null;if(typeof T=="object"){if(T instanceof _.URI)return k.transformOutgoing(T);for(let f in T)if(Object.hasOwnProperty.call(T,f)){const l=I(T[f],k,w+1);l!==null&&(T[f]=l)}}return null}function C(T,k){const w=I(T,k,0);return w===null?T:w}e.transformOutgoingURIs=C;function P(T,k,w,f){if(!T||f>200)return null;if(typeof T=="object"){if(T.$mid===1)return w?_.URI.revive(k.transformIncoming(T)):k.transformIncoming(T);for(let l in T)if(Object.hasOwnProperty.call(T,l)){const m=P(T[l],k,w,f+1);m!==null&&(T[l]=m)}}return null}function y(T,k){const w=P(T,k,!1,0);return w===null?T:w}e.transformIncomingURIs=y;function i(T,k){const w=P(T,k,!0,0);return w===null?T:w}e.transformAndReviveIncomingURIs=i}),define(me[28],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const _=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(y){return _.test(y)}e.isUUID=D;const R=new Uint8Array(16),I=[];for(let y=0;y<256;y++)I.push(y.toString(16).padStart(2,"0"));let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(y){for(let i=0;i<y.length;i++)y[i]=Math.floor(Math.random()*256);return y};function P(){C(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let y=0,i="";return i+=I[R[y++]],i+=I[R[y++]],i+=I[R[y++]],i+=I[R[y++]],i+="-",i+=I[R[y++]],i+=I[R[y++]],i+="-",i+=I[R[y++]],i+=I[R[y++]],i+="-",i+=I[R[y++]],i+=I[R[y++]],i+="-",i+=I[R[y++]],i+=I[R[y++]],i+=I[R[y++]],i+=I[R[y++]],i+=I[R[y++]],i+=I[R[y++]],i}e.generateUuid=P}),define(me[134],pe([0,1,98]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class D{constructor(I="utf8"){this.stringDecoder=new _.StringDecoder(I),this.remaining=null}write(I){const C=[],P=this.remaining?this.remaining+this.stringDecoder.write(I):this.stringDecoder.write(I);if(P.length<1)return C;let y=0,i,T=y;for(;T<P.length;)if(i=P.charCodeAt(T),i===13||i===10){if(C.push(P.substring(y,T)),T++,T<P.length){const k=i;i=P.charCodeAt(T),(k===13&&i===10||k===10&&i===13)&&T++}y=T}else T++;return this.remaining=y<P.length?P.substr(y):null,C}end(){return this.remaining}}e.LineDecoder=D}),define(me[25],pe([0,1,34,43,7,19,10,30,28,76,23,2]),function(Z,e,_,D,R,I,C,P,y,i,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=e.MAX_HEAP_SIZE=e.MAX_FILE_SIZE=void 0;const w=300*1024*1024,f=16*1024*1024*1024,l=700*1024*1024,m=700*2*1024*1024;e.MAX_FILE_SIZE=process.arch==="ia32"?w:f,e.MAX_HEAP_SIZE=process.arch==="ia32"?l:m;var S;(function(L){L[L.UNLINK=0]="UNLINK",L[L.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function g(L,M=S.UNLINK){if((0,P.isRootOrDriveLetter)(L))throw new Error("rimraf - will refuse to recursively delete root");return M===S.UNLINK?d(L):b(L)}e.rimraf=g;async function b(L){try{const M=(0,R.join)((0,D.tmpdir)(),(0,y.generateUuid)());try{await _.promises.rename(L,M)}catch(V){return d(L)}d(M).catch(V=>{})}catch(M){if(M.code!=="ENOENT")throw M}}async function d(L){return _.promises.rmdir(L,{recursive:!0,maxRetries:3})}function u(L){if((0,P.isRootOrDriveLetter)(L))throw new Error("rimraf - will refuse to recursively delete root");_.rmdirSync(L,{recursive:!0})}e.rimrafSync=u;async function a(L,M){return s(await(M?t(L):_.promises.readdir(L)))}e.readdir=a;async function t(L){try{return await _.promises.readdir(L,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const M=[],V=await a(L);for(const K of V){let se=!1,ce=!1,we=!1;try{const Te=await _.promises.lstat((0,R.join)(L,K));se=Te.isFile(),ce=Te.isDirectory(),we=Te.isSymbolicLink()}catch(Te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Te)}M.push({name:K,isFile:()=>se,isDirectory:()=>ce,isSymbolicLink:()=>we})}return M}function r(L){return s(_.readdirSync(L))}e.readdirSync=r;function s(L){return L.map(M=>typeof M=="string"?C.isMacintosh?(0,i.normalizeNFC)(M):M:(M.name=C.isMacintosh?(0,i.normalizeNFC)(M.name):M.name,M))}async function o(L){const M=await a(L),V=[];for(const K of M)await c.existsDirectory((0,R.join)(L,K))&&V.push(K);return V}e.readDirsInDir=o;function n(L,M=1e3){return new Promise(V=>{let K=!1;const se=setInterval(()=>{K||(K=!0,_.access(L,ce=>{K=!1,ce&&(clearInterval(se),V(void 0))}))},M)})}e.whenDeleted=n;var c;(function(L){async function M(se){let ce;try{if(ce=await _.promises.lstat(se),!ce.isSymbolicLink())return{stat:ce}}catch(we){}try{return{stat:await _.promises.stat(se),symbolicLink:(ce==null?void 0:ce.isSymbolicLink())?{dangling:!1}:void 0}}catch(we){if(we.code==="ENOENT"&&ce)return{stat:ce,symbolicLink:{dangling:!0}};if(C.isWindows&&we.code==="EACCES")try{return{stat:await _.promises.stat(await _.promises.readlink(se)),symbolicLink:{dangling:!1}}}catch(Te){if(Te.code==="ENOENT"&&ce)return{stat:ce,symbolicLink:{dangling:!0}};throw Te}throw we}}L.stat=M;async function V(se){try{const{stat:ce,symbolicLink:we}=await L.stat(se);return ce.isFile()&&(we==null?void 0:we.dangling)!==!0}catch(ce){}return!1}L.existsFile=V;async function K(se){try{const{stat:ce,symbolicLink:we}=await L.stat(se);return ce.isDirectory()&&(we==null?void 0:we.dangling)!==!0}catch(ce){}return!1}L.existsDirectory=K})(c=e.SymlinkSupport||(e.SymlinkSupport={}));const p=new I.ResourceQueue;function E(L,M,V){return p.queueFor(k.URI.file(L),T.extUriBiasedIgnorePathCase).queue(()=>{const K=F(V);return new Promise((se,ce)=>v(L,M,K,we=>we?ce(we):se()))})}e.writeFile=E;let h=!0;function v(L,M,V,K){if(!h)return _.writeFile(L,M,{mode:V.mode,flag:V.flag},K);_.open(L,V.flag,V.mode,(se,ce)=>{if(se)return K(se);_.writeFile(ce,M,we=>{if(we)return _.close(ce,()=>K(we));_.fdatasync(ce,Te=>(Te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Te),h=!1),_.close(ce,Ie=>K(Ie))))})})}function A(L,M,V){const K=F(V);if(!h)return _.writeFileSync(L,M,{mode:K.mode,flag:K.flag});const se=_.openSync(L,K.flag,K.mode);try{_.writeFileSync(se,M);try{_.fdatasyncSync(se)}catch(ce){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",ce),h=!1}}finally{_.closeSync(se)}}e.writeFileSync=A;function F(L){return L?{mode:typeof L.mode=="number"?L.mode:438,flag:typeof L.flag=="string"?L.flag:"w"}:{mode:438,flag:"w"}}async function x(L,M){if(L!==M){async function V(K){try{const se=await _.promises.lstat(K);if(se.isDirectory()||se.isSymbolicLink())return;const ce=await _.promises.open(K,"a");try{await ce.utimes(se.atime,new Date)}finally{await ce.close()}}catch(se){}}try{await _.promises.rename(L,M),await V(M)}catch(K){if(L.toLowerCase()!==M.toLowerCase()&&K.code==="EXDEV"||L.endsWith("."))await j(L,M,{preserveSymlinks:!1}),await g(L,S.MOVE),await V(M);else throw K}}}e.move=x;async function j(L,M,V){return B(L,M,{root:{source:L,target:M},options:V,handledSourcePaths:new Set})}e.copy=j;const G=511;async function B(L,M,V){if(!V.handledSourcePaths.has(L)){V.handledSourcePaths.add(L);const{stat:K,symbolicLink:se}=await c.stat(L);if(se){if(V.options.preserveSymlinks)try{return await N(L,M,V)}catch(ce){console.warn("[node.js fs] copy of symlink failed: ",ce)}if(se.dangling)return}return K.isDirectory()?J(L,M,K.mode&G,V):O(L,M,K.mode&G)}}async function J(L,M,V,K){await _.promises.mkdir(M,{recursive:!0,mode:V});const se=await a(L);for(const ce of se)await B((0,R.join)(L,ce),(0,R.join)(M,ce),K)}async function O(L,M,V){await _.promises.copyFile(L,M),await _.promises.chmod(M,V)}async function N(L,M,V){let K=await _.promises.readlink(L);(0,P.isEqualOrParent)(K,V.root.source,!C.isLinux)&&(K=(0,R.join)(V.root.target,K.substr(V.root.source.length+1))),await _.promises.symlink(K,M)}async function U(L){try{return await _.promises.access(L),!0}catch(M){return!1}}e.exists=U}),define(me[135],pe([0,1,34,9,7,25]),function(Z,e,_,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function C(T){const k=(0,R.dirname)(T);if(T===k)return T;const w=((0,R.basename)(T)||T).toLowerCase();try{const l=(0,I.readdirSync)(k).filter(m=>m.toLowerCase()===w);if(l.length===1){const m=C(k);if(m)return(0,R.join)(m,l[0])}else if(l.length>1){const m=l.indexOf(w);if(m>=0){const S=C(k);if(S)return(0,R.join)(S,l[m])}}}catch(f){}return null}e.realcaseSync=C;async function P(T){try{return await _.promises.realpath(T)}catch(k){const w=i(T);return await _.promises.access(w,_.constants.R_OK),w}}e.realpath=P;function y(T){try{return _.realpathSync(T)}catch(k){const w=i(T);return _.accessSync(w,_.constants.R_OK),w}}e.realpathSync=y;function i(T){return(0,D.rtrim)((0,R.normalize)(T),R.sep)}});var vt=this&&this.__await||function(Z){return this instanceof vt?(this.v=Z,this):new vt(Z)},In=this&&this.__asyncGenerator||function(Z,e,_){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var D=_.apply(Z,e||[]),R,I=[];return R={},C("next"),C("throw"),C("return"),R[Symbol.asyncIterator]=function(){return this},R;function C(w){D[w]&&(R[w]=function(f){return new Promise(function(l,m){I.push([w,f,l,m])>1||P(w,f)})})}function P(w,f){try{y(D[w](f))}catch(l){k(I[0][3],l)}}function y(w){w.value instanceof vt?Promise.resolve(w.value.v).then(i,T):k(I[0][2],w)}function i(w){P("next",w)}function T(w){P("throw",w)}function k(w,f){w(f),I.shift(),I.length&&P(I[0][0],I[0][1])}},sn=this&&this.__asyncValues||function(Z){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=Z[Symbol.asyncIterator],_;return e?e.call(Z):(Z=typeof __values=="function"?__values(Z):Z[Symbol.iterator](),_={},D("next"),D("throw"),D("return"),_[Symbol.asyncIterator]=function(){return this},_);function D(I){_[I]=Z[I]&&function(C){return new Promise(function(P,y){C=Z[I](C),R(P,y,C.done,C.value)})}}function R(I,C,P,y){Promise.resolve(y).then(function(i){I({value:i,done:P})},C)}};define(me[99],pe([0,1,25,43,7,37]),function(Z,e,_,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,P=/^Microsoft.PowerShell_.*/,y=/^Microsoft.PowerShellPreview_.*/;var i;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(i||(i={}));let T;switch(process.arch){case"ia32":case"x32":T=1;break;case"arm":case"arm64":T=2;break;default:T=0;break}let k;process.env.PROCESSOR_ARCHITEW6432?k=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?k=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?k=1:k=0;class w{constructor(t,r,s){this.exePath=t,this.displayName=r,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await _.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:a=!1}={}){return a?T===0?I.env["ProgramFiles(x86)"]||null:k===0&&I.env.ProgramW6432||null:I.env.ProgramFiles||null}async function l({useAlternateBitness:a=!1,findPreview:t=!1}={}){const r=f({useAlternateBitness:a});if(!r)return null;const s=R.join(r,"PowerShell");if(!await _.SymlinkSupport.existsDirectory(s))return null;let o=-1,n=null;for(const E of await _.readdir(s)){let h=-1;if(t){const A=E.indexOf("-");if(A<0)continue;const F=E.substring(0,A);if(!C.test(F)||E.substring(A+1)!=="preview")continue;h=parseInt(F,10)}else{if(!C.test(E))continue;h=parseInt(E,10)}if(!(h<=o)){const v=R.join(s,E,"pwsh.exe");!await _.SymlinkSupport.existsFile(v)||(n=v,o=h)}}if(!n)return null;const c=r.includes("x86")?" (x86)":"",p=t?" Preview":"";return new w(n,`PowerShell${p}${c}`,!0)}async function m({findPreview:a}={}){if(!I.env.LOCALAPPDATA)return null;const t=R.join(I.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await _.SymlinkSupport.existsDirectory(t))return null;const{pwshMsixDirRegex:r,pwshMsixName:s}=a?{pwshMsixDirRegex:y,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:P,pwshMsixName:"PowerShell (Store)"};for(const o of await _.readdir(t))if(r.test(o)){const n=R.join(t,o,"pwsh.exe");return new w(n,s)}return null}function S(){const a=R.join(D.homedir(),".dotnet","tools","pwsh.exe");return new w(a,".NET Core PowerShell Global Tool")}function g(){const a=R.join(I.env.windir,T===1&&k!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(a,"Windows PowerShell",!0)}function b(){return In(this,arguments,function*(){let t=yield vt(l());t&&(yield yield vt(t)),t=yield vt(l({useAlternateBitness:!0})),t&&(yield yield vt(t)),t=yield vt(m()),t&&(yield yield vt(t)),t=S(),t&&(yield yield vt(t)),t=yield vt(l({findPreview:!0})),t&&(yield yield vt(t)),t=yield vt(m({findPreview:!0})),t&&(yield yield vt(t)),t=yield vt(l({useAlternateBitness:!0,findPreview:!0})),t&&(yield yield vt(t)),t=g(),t&&(yield yield vt(t))})}function d(){return In(this,arguments,function*(){var t,r;try{for(var s=sn(b()),o;o=yield vt(s.next()),!o.done;){const n=o.value;(yield vt(n.exists()))&&(yield yield vt(n))}}catch(n){t={error:n}}finally{try{o&&!o.done&&(r=s.return)&&(yield vt(r.call(s)))}finally{if(t)throw t.error}}})}e.enumeratePowerShellInstallations=d;async function u(){var a,t;try{for(var r=sn(d()),s;s=await r.next(),!s.done;)return s.value}catch(o){a={error:o}}finally{try{s&&!s.done&&(t=r.return)&&await t.call(r)}finally{if(a)throw a.error}}return null}e.getFirstAvailablePowerShellInstallation=u}),define(me[100],pe([0,1,3,6,19,21,18,26,14,15,58,9]),function(Z,e,_,D,R,I,C,P,y,i,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var w;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(w=e.RequestType||(e.RequestType={}));function f(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(l=e.ResponseType||(e.ResponseType={}));function m(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(S||(S={}));class g{constructor(L){this.buffer=L,this.pos=0}read(L){const M=this.buffer.slice(this.pos,this.pos+L);return this.pos+=M.byteLength,M}}class b{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(L){this.buffers.push(L)}}var d;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(d||(d={}));function u(U){const L=P.VSBuffer.alloc(4);return L.writeUInt32BE(U,0),L}function a(U){return U.read(4).readUInt32BE(0)}function t(U){const L=P.VSBuffer.alloc(1);return L.writeUInt8(U,0),L}const r={Undefined:t(d.Undefined),String:t(d.String),Buffer:t(d.Buffer),VSBuffer:t(d.VSBuffer),Array:t(d.Array),Object:t(d.Object)},s=typeof Buffer!="undefined";function o(U,L){if(typeof L=="undefined")U.write(r.Undefined);else if(typeof L=="string"){const M=P.VSBuffer.fromString(L);U.write(r.String),U.write(u(M.byteLength)),U.write(M)}else if(s&&Buffer.isBuffer(L)){const M=P.VSBuffer.wrap(L);U.write(r.Buffer),U.write(u(M.byteLength)),U.write(M)}else if(L instanceof P.VSBuffer)U.write(r.VSBuffer),U.write(u(L.byteLength)),U.write(L);else if(Array.isArray(L)){U.write(r.Array),U.write(u(L.length));for(const M of L)o(U,M)}else{const M=P.VSBuffer.fromString(JSON.stringify(L));U.write(r.Object),U.write(u(M.byteLength)),U.write(M)}}function n(U){switch(U.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return U.read(a(U)).toString();case d.Buffer:return U.read(a(U)).buffer;case d.VSBuffer:return U.read(a(U));case d.Array:{const M=a(U),V=[];for(let K=0;K<M;K++)V.push(n(U));return V}case d.Object:return JSON.parse(U.read(a(U)).toString())}}class c{constructor(L,M,V=null,K=1e3){this.protocol=L,this.ctx=M,this.logger=V,this.timeoutDelay=K,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(se=>this.onRawMessage(se)),this.sendResponse({type:200})}registerChannel(L,M){this.channels.set(L,M),setTimeout(()=>this.flushPendingRequests(L),0)}sendResponse(L){switch(L.type){case 200:{const M=this.send([L.type]);this.logger&&this.logger.logOutgoing(M,0,1,m(L.type));return}case 201:case 202:case 204:case 203:{const M=this.send([L.type,L.id],L.data);this.logger&&this.logger.logOutgoing(M,L.id,1,m(L.type),L.data);return}}}send(L,M=void 0){const V=new b;return o(V,L),o(V,M),this.sendBuffer(V.buffer)}sendBuffer(L){try{return this.protocol.send(L),L.byteLength}catch(M){return 0}}onRawMessage(L){const M=new g(L),V=n(M),K=n(M),se=V[0];switch(se){case 100:return this.logger&&this.logger.logIncoming(L.byteLength,V[1],1,`${f(se)}: ${V[2]}.${V[3]}`,K),this.onPromise({type:se,id:V[1],channelName:V[2],name:V[3],arg:K});case 102:return this.logger&&this.logger.logIncoming(L.byteLength,V[1],1,`${f(se)}: ${V[2]}.${V[3]}`,K),this.onEventListen({type:se,id:V[1],channelName:V[2],name:V[3],arg:K});case 101:return this.logger&&this.logger.logIncoming(L.byteLength,V[1],1,`${f(se)}`),this.disposeActiveRequest({type:se,id:V[1]});case 103:return this.logger&&this.logger.logIncoming(L.byteLength,V[1],1,`${f(se)}`),this.disposeActiveRequest({type:se,id:V[1]})}}onPromise(L){const M=this.channels.get(L.channelName);if(!M){this.collectPendingRequest(L);return}const V=new I.CancellationTokenSource;let K;try{K=M.call(this.ctx,L.name,L.arg,V.token)}catch(we){K=Promise.reject(we)}const se=L.id;K.then(we=>{this.sendResponse({id:se,data:we,type:201}),this.activeRequests.delete(L.id)},we=>{we instanceof Error?this.sendResponse({id:se,data:{message:we.message,name:we.name,stack:we.stack?we.stack.split?we.stack.split(`
`):we.stack:void 0},type:202}):this.sendResponse({id:se,data:we,type:203}),this.activeRequests.delete(L.id)});const ce=(0,D.toDisposable)(()=>V.cancel());this.activeRequests.set(L.id,ce)}onEventListen(L){const M=this.channels.get(L.channelName);if(!M){this.collectPendingRequest(L);return}const V=L.id,se=M.listen(this.ctx,L.name,L.arg)(ce=>this.sendResponse({id:V,data:ce,type:204}));this.activeRequests.set(L.id,se)}disposeActiveRequest(L){const M=this.activeRequests.get(L.id);M&&(M.dispose(),this.activeRequests.delete(L.id))}collectPendingRequest(L){let M=this.pendingRequests.get(L.channelName);M||(M=[],this.pendingRequests.set(L.channelName,M));const V=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.sendResponse({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);M.push({request:L,timeoutTimer:V})}flushPendingRequests(L){const M=this.pendingRequests.get(L);if(M){for(const V of M)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.onPromise(V.request);break;case 102:this.onEventListen(V.request);break}this.pendingRequests.delete(L)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(L=>L.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var p;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(L,M=null){this.protocol=L,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=M}getChannel(L){const M=this;return{call(V,K,se){return M.isDisposed?Promise.reject(C.canceled()):M.requestPromise(L,V,K,se)},listen(V,K){return M.isDisposed?Promise.reject(C.canceled()):M.requestEvent(L,V,K)}}}requestPromise(L,M,V,K=I.CancellationToken.None){const se=this.lastRequestId++,we={id:se,type:100,channelName:L,name:M,arg:V};if(K.isCancellationRequested)return Promise.reject(C.canceled());let Te;return new Promise((Me,H)=>{if(K.isCancellationRequested)return H(C.canceled());const Q=()=>{const Ce=Oe=>{switch(Oe.type){case 201:this.handlers.delete(se),Me(Oe.data);break;case 202:this.handlers.delete(se);const ve=new Error(Oe.data.message);ve.stack=Oe.data.stack,ve.name=Oe.data.name,H(ve);break;case 203:this.handlers.delete(se),H(Oe.data);break}};this.handlers.set(se,Ce),this.sendRequest(we)};let ne=null;this.state===S.Idle?Q():(ne=(0,R.createCancelablePromise)(Ce=>this.whenInitialized()),ne.then(()=>{ne=null,Q()}));const oe=()=>{ne?(ne.cancel(),ne=null):this.sendRequest({id:se,type:101}),H(C.canceled())},ge=K.onCancellationRequested(oe);Te=(0,D.combinedDisposable)((0,D.toDisposable)(oe),ge),this.activeRequests.add(Te)}).finally(()=>{this.activeRequests.delete(Te)})}requestEvent(L,M,V){const K=this.lastRequestId++,ce={id:K,type:102,channelName:L,name:M,arg:V};let we=null;const Te=new _.Emitter({onFirstListenerAdd:()=>{we=(0,R.createCancelablePromise)(Me=>this.whenInitialized()),we.then(()=>{we=null,this.activeRequests.add(Te),this.sendRequest(ce)})},onLastListenerRemove:()=>{we?(we.cancel(),we=null):(this.activeRequests.delete(Te),this.sendRequest({id:K,type:103}))}}),Ie=Me=>Te.fire(Me.data);return this.handlers.set(K,Ie),Te.event}sendRequest(L){switch(L.type){case 100:case 102:{const M=this.send([L.type,L.id,L.channelName,L.name],L.arg);this.logger&&this.logger.logOutgoing(M,L.id,0,`${f(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const M=this.send([L.type,L.id]);this.logger&&this.logger.logOutgoing(M,L.id,0,f(L.type));return}}}send(L,M=void 0){const V=new b;return o(V,L),o(V,M),this.sendBuffer(V.buffer)}sendBuffer(L){try{return this.protocol.send(L),L.byteLength}catch(M){return 0}}onBuffer(L){const M=new g(L),V=n(M),K=n(M),se=V[0];switch(se){case 200:return this.logger&&this.logger.logIncoming(L.byteLength,0,0,m(se)),this.onResponse({type:V[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(L.byteLength,V[1],0,m(se),K),this.onResponse({type:V[0],id:V[1],data:K})}}onResponse(L){if(L.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const M=this.handlers.get(L.id);M&&M(L)}whenInitialized(){return this.state===S.Idle?Promise.resolve():_.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(L=>L.dispose()),this.activeRequests.clear()}}e.ChannelClient=E;class h{constructor(L){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,L(({protocol:M,onDidClientDisconnect:V})=>{_.Event.once(M.onMessage)(se=>{const ce=new g(se),we=n(ce),Te=new c(M,we),Ie=new E(M);this.channels.forEach((H,Q)=>Te.registerChannel(Q,H));const Me={channelServer:Te,channelClient:Ie,ctx:we};this._connections.add(Me),this._onDidAddConnection.fire(Me),V(()=>{Te.dispose(),Ie.dispose(),this._connections.delete(Me),this._onDidRemoveConnection.fire(Me)})})})}get connections(){const L=[];return this._connections.forEach(M=>L.push(M)),L}getChannel(L,M){const V=this;return{call(K,se,ce){let we;if((0,i.isFunction)(M)){let Ie=(0,y.getRandomElement)(V.connections.filter(M));we=Ie?Promise.resolve(Ie):_.Event.toPromise(_.Event.filter(V.onDidAddConnection,M))}else we=M.routeCall(V,K,se);const Te=we.then(Ie=>Ie.channelClient.getChannel(L));return A(Te).call(K,se,ce)},listen(K,se){if((0,i.isFunction)(M))return V.getMulticastEvent(L,M,K,se);const ce=M.routeEvent(V,K,se).then(we=>we.channelClient.getChannel(L));return A(ce).listen(K,se)}}}getMulticastEvent(L,M,V,K){const se=this;let ce=new D.DisposableStore;const we=new _.Emitter({onFirstListenerAdd:()=>{ce=new D.DisposableStore;const Te=new _.EventMultiplexer,Ie=new Map,Me=Q=>{const oe=Q.channelClient.getChannel(L).listen(V,K),ge=Te.add(oe);Ie.set(Q,ge)},H=Q=>{const ne=Ie.get(Q);!ne||(ne.dispose(),Ie.delete(Q))};se.connections.filter(M).forEach(Me),_.Event.filter(se.onDidAddConnection,M)(Me,void 0,ce),se.onDidRemoveConnection(H,void 0,ce),Te.event(we.fire,we,ce),ce.add(Te)},onLastListenerRemove:()=>{ce.dispose()}});return we.event}registerChannel(L,M){this.channels.set(L,M),this._connections.forEach(V=>{V.channelServer.registerChannel(L,M)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=h;class v{constructor(L,M,V=null){const K=new b;o(K,M),L.send(K.buffer),this.channelClient=new E(L,V),this.channelServer=new c(L,M,V)}getChannel(L){return this.channelClient.getChannel(L)}registerChannel(L,M){this.channelServer.registerChannel(L,M)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=v;function A(U){return{call(L,M,V){return U.then(K=>K.call(L,M,V))},listen(L,M){const V=new _.Relay;return U.then(K=>V.input=K.listen(L,M)),V.event}}}e.getDelayedChannel=A;function F(U){let L=!1;return{call(M,V,K){return L?U.call(M,V,K):(0,R.timeout)(0).then(()=>L=!0).then(()=>U.call(M,V,K))},listen(M,V){if(L)return U.listen(M,V);const K=new _.Relay;return(0,R.timeout)(0).then(()=>L=!0).then(()=>K.input=U.listen(M,V)),K.event}}}e.getNextTickChannel=F;class x{constructor(L){this.fn=L}routeCall(L){return this.route(L)}routeEvent(L){return this.route(L)}async route(L){for(const M of L.connections)if(await Promise.resolve(this.fn(M.ctx)))return Promise.resolve(M);return await _.Event.toPromise(L.onDidAddConnection),await this.route(L)}}e.StaticRouter=x;var j;(function(U){function L(K,se){const ce=K,we=se&&se.disableMarshalling,Te=new Map;for(const Ie in ce)V(Ie)&&Te.set(Ie,_.Event.buffer(ce[Ie],!0));return new class{listen(Ie,Me){const H=Te.get(Me);if(H)return H;throw new Error(`Event not found: ${Me}`)}call(Ie,Me,H){const Q=ce[Me];if(typeof Q=="function"){if(!we&&Array.isArray(H))for(let ne=0;ne<H.length;ne++)H[ne]=(0,T.revive)(H[ne]);return Q.apply(ce,H)}throw new Error(`Method not found: ${Me}`)}}}U.fromService=L;function M(K,se){const ce=se&&se.disableMarshalling;return new Proxy({},{get(we,Te){var Ie;if(typeof Te=="string")return((Ie=se==null?void 0:se.properties)===null||Ie===void 0?void 0:Ie.has(Te))?se.properties.get(Te):V(Te)?K.listen(Te):async function(...Me){let H;se&&!(0,i.isUndefinedOrNull)(se.context)?H=[se.context,...Me]:H=Me;const Q=await K.call(Te,H);return ce?Q:(0,T.revive)(Q)};throw new Error(`Property not found: ${String(Te)}`)}})}U.toService=M;function V(K){return K[0]==="o"&&K[1]==="n"&&k.isUpperAsciiLetter(K.charCodeAt(2))}})(j=e.ProxyChannel||(e.ProxyChannel={}));const G=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let L=U.toString();if(L!=="[object Object]")return L}return U}function J(U){return Array.isArray(U)?U.map(B):B(U)}function O(U,L,M,V,K,se,ce){ce=J(ce);const we=G[K],Te=we[V%we.length];let Ie=[`%c[${U}]%c[${String(L).padStart(7," ")}]%c[len: ${String(M).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${Te}`];/\($/.test(se)?(Ie=Ie.concat(ce),Ie.push(")")):Ie.push(ce),console.log.apply(console,Ie)}e.logWithColors=O;class N{constructor(L,M){this._outgoingPrefix=L,this._incomingPrefix=M,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(L,M,V,K,se){this._totalOutgoing+=L,O(this._outgoingPrefix,this._totalOutgoing,L,M,V,K,se)}logIncoming(L,M,V,K,se){this._totalIncoming+=L,O(this._incomingPrefix,this._totalIncoming,L,M,V,K,se)}}e.IPCLogger=N}),define(me[101],pe([0,1,3,100,6,26,10,37]),function(Z,e,_,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let y=null;function i(){return y||(y=I.VSBuffer.alloc(0)),y}class T{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,o){if(s===0)return i();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const E=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=s),E}if(this._chunks[0].byteLength>s){const E=this._chunks[0].slice(0,s);return o&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),E}let n=I.VSBuffer.alloc(s),c=0,p=0;for(;s>0;){const E=this._chunks[p];if(E.byteLength>s){const h=E.slice(0,s);n.set(h,c),c+=s,o&&(this._chunks[p]=E.slice(s),this._totalLength-=s),s-=s}else n.set(E,c),c+=E.byteLength,o?(this._chunks.shift(),this._totalLength-=E.byteLength):p++,s-=E.byteLength}return n}}e.ChunkStream=T;var k;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(k||(k={}));var w;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class f{constructor(s,o,n,c){this.type=s,this.id=o,this.ack=n,this.data=c,this.writtenTime=0}get size(){return this.data.byteLength}}class l extends R.Disposable{constructor(s){super();this._onMessage=this._register(new _.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new T,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5);else{const n=this._state.messageType,c=this._state.id,p=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new f(n,c,p,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(!this._isDisposed){s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=I.VSBuffer.alloc(13);o.writeUInt8(s.type,0),o.writeUInt32BE(s.id,1),o.writeUInt32BE(s.ack,5),o.writeUInt32BE(s.data.byteLength,9),this._writeSoon(o,s.data)}}_bufferAdd(s,o){const n=this._totalLength===0;return this._data.push(s,o),this._totalLength+=s.byteLength+o.byteLength,n}_bufferTake(){const s=I.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,o){this._bufferAdd(s,o)&&C.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class S extends R.Disposable{constructor(s){super();this._onMessage=new _.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new l(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new f(1,0,0,s))}}e.Protocol=S;class g extends D.IPCClient{constructor(s,o,n=null){super(s,o,n);this.protocol=s}static fromSocket(s,o){return new g(new S(s),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=g;class b{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new _.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,P.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=b;class d{constructor(s){this.data=s,this.next=null}}class u{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],o=0,n=this._first;for(;n;)s[o++]=n.data,n=n.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const o=new d(s);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class a{constructor(){this.lastRuns=[];const s=Date.now();for(let o=0;o<a._HISTORY_LENGTH;o++)this.lastRuns[o]=s-1e3*o;setInterval(()=>{for(let o=a._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const s=Date.now(),o=(1+a._HISTORY_LENGTH)*1e3;let n=0;for(let c=0;c<a._HISTORY_LENGTH;c++)s-this.lastRuns[c]<=o&&n++;return 1-n/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class t{constructor(s,o=null){this._loadEstimator=a.getInstance(),this._onControlMessage=new b,this.onControlMessage=this._onControlMessage.event,this._onMessage=new b,this.onMessage=this._onMessage.event,this._onDidDispose=new b,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new b,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new b,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new u,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new l(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(n=>this._receiveMessage(n))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),o&&this._socketReader.acceptChunk(o),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,R.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new f(5,0,0,i());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const o=new f(4,0,0,i());this._socketWriter.write(o),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,o){this._isReconnecting=!0,this._socketDisposables=(0,R.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new l(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(n=>this._receiveMessage(n))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let o=0,n=s.length;o<n;o++)this._socketWriter.write(s[o]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new f(6,0,0,i())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const o=this._outgoingUnackMsg.toArray();for(let n=0,c=o.length;n<c;n++)this._socketWriter.write(o[n]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const n=new f(1,o,this._incomingAckId,s);this._outgoingUnackMsg.push(n),this._isReconnecting||(this._socketWriter.write(n),this._recvAckCheck())}sendControl(s){const o=new f(2,0,0,s);this._socketWriter.write(o)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const s=this._outgoingUnackMsg.peek(),o=Date.now()-s.writtenTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-o,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const s=new f(3,0,this._incomingAckId,i());this._socketWriter.write(s)}}}e.PersistentProtocol=t}),define(me[102],pe([0,1,92]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class D{constructor(P){let y=(0,_.toUint8)(P);this._defaultValue=y,this._asciiMap=D._createAsciiMap(y),this._map=new Map}static _createAsciiMap(P){let y=new Uint8Array(256);for(let i=0;i<256;i++)y[i]=P;return y}set(P,y){let i=(0,_.toUint8)(y);P>=0&&P<256?this._asciiMap[P]=i:this._map.set(P,i)}get(P){return P>=0&&P<256?this._asciiMap[P]:this._map.get(P)||this._defaultValue}}e.CharacterClassifier=D;var R;(function(C){C[C.False=0]="False",C[C.True=1]="True"})(R||(R={}));class I{constructor(){this._actual=new D(0)}add(P){this._actual.set(P,1)}has(P){return this._actual.get(P)===1}}e.CharacterSet=I}),define(me[136],pe([0,1,102]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var D;(function(C){C[C.Regular=0]="Regular",C[C.Whitespace=1]="Whitespace",C[C.WordSeparator=2]="WordSeparator"})(D=e.WordCharacterClass||(e.WordCharacterClass={}));class R extends _.CharacterClassifier{constructor(P){super(0);for(let y=0,i=P.length;y<i;y++)this.set(P.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=R;function I(C){let P={};return y=>(P.hasOwnProperty(y)||(P[y]=C(y)),P[y])}e.getMapForWordSeparators=I(C=>new R(C))}),define(me[48],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class _{constructor(R,I){this.lineNumber=R,this.column=I}with(R=this.lineNumber,I=this.column){return R===this.lineNumber&&I===this.column?this:new _(R,I)}delta(R=0,I=0){return this.with(this.lineNumber+R,this.column+I)}equals(R){return _.equals(this,R)}static equals(R,I){return!R&&!I?!0:!!R&&!!I&&R.lineNumber===I.lineNumber&&R.column===I.column}isBefore(R){return _.isBefore(this,R)}static isBefore(R,I){return R.lineNumber<I.lineNumber?!0:I.lineNumber<R.lineNumber?!1:R.column<I.column}isBeforeOrEqual(R){return _.isBeforeOrEqual(this,R)}static isBeforeOrEqual(R,I){return R.lineNumber<I.lineNumber?!0:I.lineNumber<R.lineNumber?!1:R.column<=I.column}static compare(R,I){let C=R.lineNumber|0,P=I.lineNumber|0;if(C===P){let y=R.column|0,i=I.column|0;return y-i}return C-P}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(R){return new _(R.lineNumber,R.column)}static isIPosition(R){return R&&typeof R.lineNumber=="number"&&typeof R.column=="number"}}e.Position=_}),define(me[44],pe([0,1,48]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class D{constructor(I,C,P,y){I>P||I===P&&C>y?(this.startLineNumber=P,this.startColumn=y,this.endLineNumber=I,this.endColumn=C):(this.startLineNumber=I,this.startColumn=C,this.endLineNumber=P,this.endColumn=y)}isEmpty(){return D.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return D.containsPosition(this,I)}static containsPosition(I,C){return!(C.lineNumber<I.startLineNumber||C.lineNumber>I.endLineNumber||C.lineNumber===I.startLineNumber&&C.column<I.startColumn||C.lineNumber===I.endLineNumber&&C.column>I.endColumn)}containsRange(I){return D.containsRange(this,I)}static containsRange(I,C){return!(C.startLineNumber<I.startLineNumber||C.endLineNumber<I.startLineNumber||C.startLineNumber>I.endLineNumber||C.endLineNumber>I.endLineNumber||C.startLineNumber===I.startLineNumber&&C.startColumn<I.startColumn||C.endLineNumber===I.endLineNumber&&C.endColumn>I.endColumn)}strictContainsRange(I){return D.strictContainsRange(this,I)}static strictContainsRange(I,C){return!(C.startLineNumber<I.startLineNumber||C.endLineNumber<I.startLineNumber||C.startLineNumber>I.endLineNumber||C.endLineNumber>I.endLineNumber||C.startLineNumber===I.startLineNumber&&C.startColumn<=I.startColumn||C.endLineNumber===I.endLineNumber&&C.endColumn>=I.endColumn)}plusRange(I){return D.plusRange(this,I)}static plusRange(I,C){let P,y,i,T;return C.startLineNumber<I.startLineNumber?(P=C.startLineNumber,y=C.startColumn):C.startLineNumber===I.startLineNumber?(P=C.startLineNumber,y=Math.min(C.startColumn,I.startColumn)):(P=I.startLineNumber,y=I.startColumn),C.endLineNumber>I.endLineNumber?(i=C.endLineNumber,T=C.endColumn):C.endLineNumber===I.endLineNumber?(i=C.endLineNumber,T=Math.max(C.endColumn,I.endColumn)):(i=I.endLineNumber,T=I.endColumn),new D(P,y,i,T)}intersectRanges(I){return D.intersectRanges(this,I)}static intersectRanges(I,C){let P=I.startLineNumber,y=I.startColumn,i=I.endLineNumber,T=I.endColumn,k=C.startLineNumber,w=C.startColumn,f=C.endLineNumber,l=C.endColumn;return P<k?(P=k,y=w):P===k&&(y=Math.max(y,w)),i>f?(i=f,T=l):i===f&&(T=Math.min(T,l)),P>i||P===i&&y>T?null:new D(P,y,i,T)}equalsRange(I){return D.equalsRange(this,I)}static equalsRange(I,C){return!!I&&!!C&&I.startLineNumber===C.startLineNumber&&I.startColumn===C.startColumn&&I.endLineNumber===C.endLineNumber&&I.endColumn===C.endColumn}getEndPosition(){return D.getEndPosition(this)}static getEndPosition(I){return new _.Position(I.endLineNumber,I.endColumn)}getStartPosition(){return D.getStartPosition(this)}static getStartPosition(I){return new _.Position(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,C){return new D(this.startLineNumber,this.startColumn,I,C)}setStartPosition(I,C){return new D(I,C,this.endLineNumber,this.endColumn)}collapseToStart(){return D.collapseToStart(this)}static collapseToStart(I){return new D(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}static fromPositions(I,C=I){return new D(I.lineNumber,I.column,C.lineNumber,C.column)}static lift(I){return I?new D(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,C){return!(I.endLineNumber<C.startLineNumber||I.endLineNumber===C.startLineNumber&&I.endColumn<C.startColumn||C.endLineNumber<I.startLineNumber||C.endLineNumber===I.startLineNumber&&C.endColumn<I.startColumn)}static areIntersecting(I,C){return!(I.endLineNumber<C.startLineNumber||I.endLineNumber===C.startLineNumber&&I.endColumn<=C.startColumn||C.endLineNumber<I.startLineNumber||C.endLineNumber===I.startLineNumber&&C.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,C){if(I&&C){const i=I.startLineNumber|0,T=C.startLineNumber|0;if(i===T){const k=I.startColumn|0,w=C.startColumn|0;if(k===w){const f=I.endLineNumber|0,l=C.endLineNumber|0;if(f===l){const m=I.endColumn|0,S=C.endColumn|0;return m-S}return f-l}return k-w}return i-T}return(I?1:0)-(C?1:0)}static compareRangesUsingEnds(I,C){return I.endLineNumber===C.endLineNumber?I.endColumn===C.endColumn?I.startLineNumber===C.startLineNumber?I.startColumn-C.startColumn:I.startLineNumber-C.startLineNumber:I.endColumn-C.endColumn:I.endLineNumber-C.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}}e.Range=D}),define(me[137],pe([0,1,48,44]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var R;(function(C){C[C.LTR=0]="LTR",C[C.RTL=1]="RTL"})(R=e.SelectionDirection||(e.SelectionDirection={}));class I extends D.Range{constructor(P,y,i,T){super(P,y,i,T);this.selectionStartLineNumber=P,this.selectionStartColumn=y,this.positionLineNumber=i,this.positionColumn=T}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return I.selectionsEqual(this,P)}static selectionsEqual(P,y){return P.selectionStartLineNumber===y.selectionStartLineNumber&&P.selectionStartColumn===y.selectionStartColumn&&P.positionLineNumber===y.positionLineNumber&&P.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,y){return this.getDirection()===0?new I(this.startLineNumber,this.startColumn,P,y):new I(P,y,this.startLineNumber,this.startColumn)}getPosition(){return new _.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(P,y){return this.getDirection()===0?new I(P,y,this.endLineNumber,this.endColumn):new I(this.endLineNumber,this.endColumn,P,y)}static fromPositions(P,y=P){return new I(P.lineNumber,P.column,y.lineNumber,y.column)}static liftSelection(P){return new I(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,y){if(P&&!y||!P&&y)return!1;if(!P&&!y)return!0;if(P.length!==y.length)return!1;for(let i=0,T=P.length;i<T;i++)if(!this.selectionsEqual(P[i],y[i]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,y,i,T,k){return k===0?new I(P,y,i,T):new I(i,T,P,y)}}e.Selection=I}),define(me[103],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var _;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(_=e.OverviewRulerLane||(e.OverviewRulerLane={}));var D;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(D=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(R=e.EndOfLinePreference||(e.EndOfLinePreference={}));var I;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(I=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var C;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(C=e.EndOfLineSequence||(e.EndOfLineSequence={}));class P{constructor(l){this.tabSize=Math.max(1,l.tabSize|0),this.indentSize=l.tabSize|0,this.insertSpaces=Boolean(l.insertSpaces),this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=Boolean(l.trimAutoWhitespace)}equals(l){return this.tabSize===l.tabSize&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class y{constructor(l,m){this.range=l,this.matches=m}}e.FindMatch=y;var i;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(i=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var T;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(T=e.ModelConstants||(e.ModelConstants={}));class k{constructor(l,m,S,g,b,d){this.identifier=l,this.range=m,this.text=S,this.forceMoveMarkers=g,this.isAutoWhitespaceEdit=b,this._isTracked=d}}e.ValidAnnotatedEditOperation=k;class w{constructor(l,m,S){this.reverseEdits=l,this.changes=m,this.trimAutoWhitespaceLineNumbers=S}}e.ApplyEditsResult=w}),define(me[138],pe([0,1,9,136,48,44,103]),function(Z,e,_,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class y{constructor(d,u,a,t){this.searchString=d,this.isRegex=u,this.matchCase=a,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let d;this.isRegex?d=i(this.searchString):d=this.searchString.indexOf(`
`)>=0;let u=null;try{u=_.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:d,global:!0,unicode:!0})}catch(t){return null}if(!u)return null;let a=!this.isRegex&&!d;return a&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(a=this.matchCase),new T(u,this.wordSeparators?(0,D.getMapForWordSeparators)(this.wordSeparators):null,a?this.searchString:null)}}e.SearchParams=y;function i(b){if(!b||b.length===0)return!1;for(let d=0,u=b.length;d<u;d++)if(b.charCodeAt(d)===92){if(d++,d>=u)break;const t=b.charCodeAt(d);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=i;class T{constructor(d,u,a){this.regex=d,this.wordSeparators=u,this.simpleSearch=a}}e.SearchData=T;function k(b,d,u){if(!u)return new C.FindMatch(b,null);let a=[];for(let t=0,r=d.length;t<r;t++)a[t]=d[t];return new C.FindMatch(b,a)}e.createFindMatch=k;class w{constructor(d){let u=[],a=0;for(let t=0,r=d.length;t<r;t++)d.charCodeAt(t)===10&&(u[a++]=t);this._lineFeedsOffsets=u}findLineFeedCountBeforeOffset(d){const u=this._lineFeedsOffsets;let a=0,t=u.length-1;if(t===-1||d<=u[0])return 0;for(;a<t;){const r=a+((t-a)/2>>0);u[r]>=d?t=r-1:u[r+1]>=d?(a=r,t=r):a=r+1}return a+1}}class f{static findMatches(d,u,a,t,r){const s=u.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(d,a,new g(s.wordSeparators,s.regex),t,r):this._doFindMatchesLineByLine(d,a,s,t,r):[]}static _getMultilineMatchRange(d,u,a,t,r,s){let o,n=0;t?(n=t.findLineFeedCountBeforeOffset(r),o=u+r+n):o=u+r;let c;if(t){let v=t.findLineFeedCountBeforeOffset(r+s.length)-n;c=o+s.length+v}else c=o+s.length;const p=d.getPositionAt(o),E=d.getPositionAt(c);return new I.Range(p.lineNumber,p.column,E.lineNumber,E.column)}static _doFindMatchesMultiline(d,u,a,t,r){const s=d.getOffsetAt(u.getStartPosition()),o=d.getValueInRange(u,1),n=d.getEOL()===`\r
`?new w(o):null,c=[];let p=0,E;for(a.reset(0);E=a.next(o);)if(c[p++]=k(this._getMultilineMatchRange(d,s,o,n,E.index,E[0]),E,t),p>=r)return c;return c}static _doFindMatchesLineByLine(d,u,a,t,r){const s=[];let o=0;if(u.startLineNumber===u.endLineNumber){const c=d.getLineContent(u.startLineNumber).substring(u.startColumn-1,u.endColumn-1);return o=this._findMatchesInLine(a,c,u.startLineNumber,u.startColumn-1,o,s,t,r),s}const n=d.getLineContent(u.startLineNumber).substring(u.startColumn-1);o=this._findMatchesInLine(a,n,u.startLineNumber,u.startColumn-1,o,s,t,r);for(let c=u.startLineNumber+1;c<u.endLineNumber&&o<r;c++)o=this._findMatchesInLine(a,d.getLineContent(c),c,0,o,s,t,r);if(o<r){const c=d.getLineContent(u.endLineNumber).substring(0,u.endColumn-1);o=this._findMatchesInLine(a,c,u.endLineNumber,0,o,s,t,r)}return s}static _findMatchesInLine(d,u,a,t,r,s,o,n){const c=d.wordSeparators;if(!o&&d.simpleSearch){const h=d.simpleSearch,v=h.length,A=u.length;let F=-v;for(;(F=u.indexOf(h,F+v))!==-1;)if((!c||S(c,u,A,F,v))&&(s[r++]=new C.FindMatch(new I.Range(a,F+1+t,a,F+1+v+t),null),r>=n))return r;return r}const p=new g(d.wordSeparators,d.regex);let E;p.reset(0);do if(E=p.next(u),E&&(s[r++]=k(new I.Range(a,E.index+1+t,a,E.index+1+E[0].length+t),E,o),r>=n))return r;while(E);return r}static findNextMatch(d,u,a,t){const r=u.parseSearchRequest();if(!r)return null;const s=new g(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(d,a,s,t):this._doFindNextMatchLineByLine(d,a,s,t)}static _doFindNextMatchMultiline(d,u,a,t){const r=new R.Position(u.lineNumber,1),s=d.getOffsetAt(r),o=d.getLineCount(),n=d.getValueInRange(new I.Range(r.lineNumber,r.column,o,d.getLineMaxColumn(o)),1),c=d.getEOL()===`\r
`?new w(n):null;a.reset(u.column-1);let p=a.next(n);return p?k(this._getMultilineMatchRange(d,s,n,c,p.index,p[0]),p,t):u.lineNumber!==1||u.column!==1?this._doFindNextMatchMultiline(d,new R.Position(1,1),a,t):null}static _doFindNextMatchLineByLine(d,u,a,t){const r=d.getLineCount(),s=u.lineNumber,o=d.getLineContent(s),n=this._findFirstMatchInLine(a,o,s,u.column,t);if(n)return n;for(let c=1;c<=r;c++){const p=(s+c-1)%r,E=d.getLineContent(p+1),h=this._findFirstMatchInLine(a,E,p+1,1,t);if(h)return h}return null}static _findFirstMatchInLine(d,u,a,t,r){d.reset(t-1);const s=d.next(u);return s?k(new I.Range(a,s.index+1,a,s.index+1+s[0].length),s,r):null}static findPreviousMatch(d,u,a,t){const r=u.parseSearchRequest();if(!r)return null;const s=new g(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(d,a,s,t):this._doFindPreviousMatchLineByLine(d,a,s,t)}static _doFindPreviousMatchMultiline(d,u,a,t){const r=this._doFindMatchesMultiline(d,new I.Range(1,1,u.lineNumber,u.column),a,t,10*P);if(r.length>0)return r[r.length-1];const s=d.getLineCount();return u.lineNumber!==s||u.column!==d.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(d,new R.Position(s,d.getLineMaxColumn(s)),a,t):null}static _doFindPreviousMatchLineByLine(d,u,a,t){const r=d.getLineCount(),s=u.lineNumber,o=d.getLineContent(s).substring(0,u.column-1),n=this._findLastMatchInLine(a,o,s,t);if(n)return n;for(let c=1;c<=r;c++){const p=(r+s-c-1)%r,E=d.getLineContent(p+1),h=this._findLastMatchInLine(a,E,p+1,t);if(h)return h}return null}static _findLastMatchInLine(d,u,a,t){let r=null,s;for(d.reset(0);s=d.next(u);)r=k(new I.Range(a,s.index+1,a,s.index+1+s[0].length),s,t);return r}}e.TextModelSearch=f;function l(b,d,u,a,t){if(a===0)return!0;const r=d.charCodeAt(a-1);if(b.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=d.charCodeAt(a);if(b.get(s)!==0)return!0}return!1}function m(b,d,u,a,t){if(a+t===u)return!0;const r=d.charCodeAt(a+t);if(b.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=d.charCodeAt(a+t-1);if(b.get(s)!==0)return!0}return!1}function S(b,d,u,a,t){return l(b,d,u,a,t)&&m(b,d,u,a,t)}e.isValidMatch=S;class g{constructor(d,u){this._wordSeparators=d,this._searchRegex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(d){this._searchRegex.lastIndex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(d){const u=d.length;let a;do{if(this._prevMatchStartIndex+this._prevMatchLength===u||(a=this._searchRegex.exec(d),!a))return null;const t=a.index,r=a[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){_.getNextCodePoint(d,u,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||S(this._wordSeparators,d,u,t,r))return a}while(a);return null}}e.Searcher=g}),define(me[104],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function _(P=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const i of e.USUAL_WORD_SEPARATORS)P.indexOf(i)>=0||(y+="\\"+i);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=_();function D(P){let y=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)y=P;else{let i="g";P.ignoreCase&&(i+="i"),P.multiline&&(i+="m"),P.unicode&&(i+="u"),y=new RegExp(P.source,i)}return y.lastIndex=0,y}e.ensureValidWordDefinition=D;const R={maxLen:1e3,windowSize:15,timeBudget:150};function I(P,y,i,T,k=R){if(i.length>k.maxLen){let S=P-k.maxLen/2;return S<0?S=0:T+=S,i=i.substring(S,P+k.maxLen/2),I(P,y,i,T,k)}const w=Date.now(),f=P-1-T;let l=-1,m=null;for(let S=1;!(Date.now()-w>=k.timeBudget);S++){const g=f-k.windowSize*S;y.lastIndex=Math.max(0,g);const b=C(y,i,f,l);if(!b&&m||(m=b,g<=0))break;l=g}if(m){let S={word:m[0],startColumn:T+1+m.index,endColumn:T+1+m.index+m[0].length};return y.lastIndex=0,S}return null}e.getWordAtText=I;function C(P,y,i,T){let k;for(;k=P.exec(y);){const w=k.index||0;if(w<=i&&P.lastIndex>=i)return k;if(T>0&&w>T)return null}return null}}),define(me[139],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var _;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(_=e.IndentAction||(e.IndentAction={}));class D{constructor(P){if(this.open=P.open,this.close=P.close,this._standardTokenMask=0,Array.isArray(P.notIn))for(let y=0,i=P.notIn.length;y<i;y++)switch(P.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(P){return(this._standardTokenMask&P)==0}}e.StandardAutoClosingPairConditional=D;class R{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of P)I(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),I(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),I(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),I(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&I(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=R;function I(C,P,y){C.has(P)?C.get(P).push(y):C.set(P,[y])}}),define(me[78],pe([0,1,33,7]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function R(I,C,P,y){if(Array.isArray(I)){let i=0;for(const T of I){const k=R(T,C,P,y);if(k===10)return k;k>i&&(i=k)}return i}else{if(typeof I=="string")return y?I==="*"?5:I===P?10:0:0;if(I){const{language:i,pattern:T,scheme:k,hasAccessToAllModels:w}=I;if(!y&&!w)return 0;let f=0;if(k)if(k===C.scheme)f=10;else if(k==="*")f=5;else return 0;if(i)if(i===P)f=10;else if(i==="*")f=Math.max(f,5);else return 0;if(T){let l;if(typeof T=="string"?l=T:l=Object.assign(Object.assign({},T),{base:(0,D.normalize)(T.base)}),l===C.fsPath||(0,_.match)(l,C.fsPath))f=10;else return 0}return f}else return 0}}e.score=R}),define(me[140],pe([0,1,102]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var D;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(D=e.State||(e.State={}));class R{constructor(l,m,S){const g=new Uint8Array(l*m);for(let b=0,d=l*m;b<d;b++)g[b]=S;this._data=g,this.rows=l,this.cols=m}get(l,m){return this._data[l*this.cols+m]}set(l,m,S){this._data[l*this.cols+m]=S}}e.Uint8Matrix=R;class I{constructor(l){let m=0,S=0;for(let b=0,d=l.length;b<d;b++){let[u,a,t]=l[b];a>m&&(m=a),u>S&&(S=u),t>S&&(S=t)}m++,S++;let g=new R(S,m,0);for(let b=0,d=l.length;b<d;b++){let[u,a,t]=l[b];g.set(u,a,t)}this._states=g,this._maxCharCode=m}nextState(l,m){return m<0||m>=this._maxCharCode?0:this._states.get(l,m)}}e.StateMachine=I;let C=null;function P(){return C===null&&(C=new I([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),C}var y;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let i=null;function T(){if(i===null){i=new _.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<f.length;m++)i.set(f.charCodeAt(m),1);const l=".,;";for(let m=0;m<l.length;m++)i.set(l.charCodeAt(m),2)}return i}class k{static _createLink(l,m,S,g,b){let d=b-1;do{const u=m.charCodeAt(d);if(l.get(u)!==2)break;d--}while(d>g);if(g>0){const u=m.charCodeAt(g-1),a=m.charCodeAt(d);(u===40&&a===41||u===91&&a===93||u===123&&a===125)&&d--}return{range:{startLineNumber:S,startColumn:g+1,endLineNumber:S,endColumn:d+2},url:m.substring(g,d+1)}}static computeLinks(l,m=P()){const S=T();let g=[];for(let b=1,d=l.getLineCount();b<=d;b++){const u=l.getLineContent(b),a=u.length;let t=0,r=0,s=0,o=1,n=!1,c=!1,p=!1,E=!1;for(;t<a;){let h=!1;const v=u.charCodeAt(t);if(o===13){let A;switch(v){case 40:n=!0,A=0;break;case 41:A=n?0:1;break;case 91:p=!0,c=!0,A=0;break;case 93:p=!1,A=c?0:1;break;case 123:E=!0,A=0;break;case 125:A=E?0:1;break;case 39:A=s===34||s===96?0:1;break;case 34:A=s===39||s===96?0:1;break;case 96:A=s===39||s===34?0:1;break;case 42:A=s===42?1:0;break;case 124:A=s===124?1:0;break;case 32:A=p?0:1;break;default:A=S.get(v)}A===1&&(g.push(k._createLink(S,u,b,r,t)),h=!0)}else if(o===12){let A;v===91?(c=!0,A=0):A=S.get(v),A===1?h=!0:o=13}else o=m.nextState(o,v),o===0&&(h=!0);h&&(o=1,n=!1,c=!1,E=!1,r=t+1,s=v),t++}o===13&&g.push(k._createLink(S,u,b,r,a))}return g}}e.LinkComputer=k;function w(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:k.computeLinks(f)}e.computeLinks=w}),define(me[141],pe([0,1,3,6]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class R{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(C){this._onDidChange.fire({changedLanguages:C,changedColorMap:!1})}register(C,P){return this._map.set(C,P),this.fire([C]),(0,D.toDisposable)(()=>{this._map.get(C)===P&&(this._map.delete(C),this.fire([C]))})}registerPromise(C,P){let y=null,i=!1;return this._promises.set(C,P.then(T=>{this._promises.delete(C),!(i||!T)&&(y=this.register(C,T))})),(0,D.toDisposable)(()=>{i=!0,y&&y.dispose()})}getPromise(C){const P=this.get(C);if(P)return Promise.resolve(P);const y=this._promises.get(C);return y?y.then(i=>this.get(C)):null}get(C){return this._map.get(C)||null}setColorMap(C){this._colorMap=C,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=R}),define(me[105],pe([0,1,26,10]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var R;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(R||(R={}));function I(k){for(let w=0,f=k.length;w<f;w+=4){const l=k[w+0],m=k[w+1],S=k[w+2],g=k[w+3];k[w+0]=g,k[w+1]=S,k[w+2]=m,k[w+3]=l}}function C(k){const w=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return D.isLittleEndian()||I(w),_.VSBuffer.wrap(w)}function P(k){const w=k.buffer;if(D.isLittleEndian()||I(w),w.byteOffset%4==0)return new Uint32Array(w.buffer,w.byteOffset,w.length/4);{const f=new Uint8Array(w.byteLength);return f.set(w),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function y(k){const w=new Uint32Array(i(k));let f=0;if(w[f++]=k.id,k.type==="full")w[f++]=1,w[f++]=k.data.length,w.set(k.data,f),f+=k.data.length;else{w[f++]=2,w[f++]=k.deltas.length;for(const l of k.deltas)w[f++]=l.start,w[f++]=l.deleteCount,l.data?(w[f++]=l.data.length,w.set(l.data,f),f+=l.data.length):w[f++]=0}return C(w)}e.encodeSemanticTokensDto=y;function i(k){let w=0;if(w+=1+1,k.type==="full")w+=1+k.data.length;else{w+=1,w+=(1+1+1)*k.deltas.length;for(const f of k.deltas)f.data&&(w+=f.data.length)}return w}function T(k){const w=P(k);let f=0;const l=w[f++];if(w[f++]===1){const b=w[f++],d=w.subarray(f,f+b);return f+=b,{id:l,type:"full",data:d}}const S=w[f++];let g=[];for(let b=0;b<S;b++){const d=w[f++],u=w[f++],a=w[f++];let t;a>0&&(t=w.subarray(f,f+a),f+=a),g[b]={start:d,deleteCount:u,data:t}}return{id:l,type:"delta",deltas:g}}e.decodeSemanticTokensDto=T}),define(me[106],pe([0,1,92]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class D{constructor(C,P){this.index=C,this.remainder=P}}e.PrefixSumIndexOfResult=D;class R{constructor(C){this.values=C,this.prefixSum=new Uint32Array(C.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(C,P){C=(0,_.toUint32)(C);const y=this.values,i=this.prefixSum,T=P.length;return T===0?!1:(this.values=new Uint32Array(y.length+T),this.values.set(y.subarray(0,C),0),this.values.set(y.subarray(C),C+T),this.values.set(P,C),C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(i.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(C,P){return C=(0,_.toUint32)(C),P=(0,_.toUint32)(P),this.values[C]===P?!1:(this.values[C]=P,C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),!0)}removeValues(C,P){C=(0,_.toUint32)(C),P=(0,_.toUint32)(P);const y=this.values,i=this.prefixSum;if(C>=y.length)return!1;let T=y.length-C;return P>=T&&(P=T),P===0?!1:(this.values=new Uint32Array(y.length-P),this.values.set(y.subarray(0,C),0),this.values.set(y.subarray(C+P),C),this.prefixSum=new Uint32Array(this.values.length),C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(i.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(C){return C<0?0:(C=(0,_.toUint32)(C),this._getAccumulatedValue(C))}_getAccumulatedValue(C){if(C<=this.prefixSumValidIndex[0])return this.prefixSum[C];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),C>=this.values.length&&(C=this.values.length-1);for(let y=P;y<=C;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],C),this.prefixSum[C]}getIndexOf(C){C=Math.floor(C),this.getTotalValue();let P=0,y=this.values.length-1,i=0,T=0,k=0;for(;P<=y;)if(i=P+(y-P)/2|0,T=this.prefixSum[i],k=T-this.values[i],C<k)y=i-1;else if(C>=T)P=i+1;else break;return new D(i,C-k)}}e.PrefixSumComputer=R}),define(me[142],pe([0,1,9,48,106]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class I{constructor(P,y,i,T){this._uri=P,this._lines=y,this._eol=i,this._versionId=T,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(P){P.eol&&P.eol!==this._eol&&(this._eol=P.eol,this._lineStarts=null);const y=P.changes;for(const i of y)this._acceptDeleteRange(i.range),this._acceptInsertText(new D.Position(i.range.startLineNumber,i.range.startColumn),i.text);this._versionId=P.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const P=this._eol.length,y=this._lines.length,i=new Uint32Array(y);for(let T=0;T<y;T++)i[T]=this._lines[T].length+P;this._lineStarts=new R.PrefixSumComputer(i)}}_setLineText(P,y){this._lines[P]=y,this._lineStarts&&this._lineStarts.changeValue(P,this._lines[P].length+this._eol.length)}_acceptDeleteRange(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.startLineNumber-1].substring(P.endColumn-1));return}this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.endLineNumber-1].substring(P.endColumn-1)),this._lines.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}_acceptInsertText(P,y){if(y.length!==0){let i=(0,_.splitLines)(y);if(i.length===1){this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+i[0]+this._lines[P.lineNumber-1].substring(P.column-1));return}i[i.length-1]+=this._lines[P.lineNumber-1].substring(P.column-1),this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+i[0]);let T=new Uint32Array(i.length-1);for(let k=1;k<i.length;k++)this._lines.splice(P.lineNumber+k-1,0,i[k]),T[k-1]=i[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(P.lineNumber,T)}}}e.MirrorTextModel=I}),define(me[143],pe([16,17]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(me[144],pe([0,1,143]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const D=60,R=D*60,I=R*24,C=I*7,P=I*30,y=I*365;function i(k,w){typeof k!="number"&&(k=k.getTime());const f=Math.round((new Date().getTime()-k)/1e3);if(f<-30)return(0,_.localize)(0,null,i(new Date().getTime()+f*1e3,!1));if(f<30)return(0,_.localize)(1,null);let l;return f<D?(l=f,w?l===1?(0,_.localize)(2,null,l):(0,_.localize)(3,null,l):l===1?(0,_.localize)(4,null,l):(0,_.localize)(5,null,l)):f<R?(l=Math.floor(f/D),w?l===1?(0,_.localize)(6,null,l):(0,_.localize)(7,null,l):l===1?(0,_.localize)(8,null,l):(0,_.localize)(9,null,l)):f<I?(l=Math.floor(f/R),w?l===1?(0,_.localize)(10,null,l):(0,_.localize)(11,null,l):l===1?(0,_.localize)(12,null,l):(0,_.localize)(13,null,l)):f<C?(l=Math.floor(f/I),w?l===1?(0,_.localize)(14,null,l):(0,_.localize)(15,null,l):l===1?(0,_.localize)(16,null,l):(0,_.localize)(17,null,l)):f<P?(l=Math.floor(f/C),w?l===1?(0,_.localize)(18,null,l):(0,_.localize)(19,null,l):l===1?(0,_.localize)(20,null,l):(0,_.localize)(21,null,l)):f<y?(l=Math.floor(f/P),w?l===1?(0,_.localize)(22,null,l):(0,_.localize)(23,null,l):l===1?(0,_.localize)(24,null,l):(0,_.localize)(25,null,l)):(l=Math.floor(f/y),w?l===1?(0,_.localize)(26,null,l):(0,_.localize)(27,null,l):l===1?(0,_.localize)(28,null,l):(0,_.localize)(29,null,l))}e.fromNow=i;function T(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(me[145],pe([16,17]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(me[59],pe([0,1,145,15,14]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function I(i,T){return T&&(i.stack||i.stacktrace)?_.localize(0,null,P(i),C(i.stack)||C(i.stacktrace)):P(i)}function C(i){return Array.isArray(i)?i.join(`
`):i}function P(i){return typeof i.code=="string"&&typeof i.errno=="number"&&typeof i.syscall=="string"?_.localize(1,null,i.message):i.message||_.localize(2,null)}function y(i=null,T=!1){if(!i)return _.localize(3,null);if(Array.isArray(i)){const k=R.coalesce(i),w=y(k[0],T);return k.length>1?_.localize(4,null,w,k.length):w}if(D.isString(i))return i;if(i.detail){const k=i.detail;if(k.error)return I(k.error,T);if(k.exception)return I(k.exception,T)}return i.stack?I(i,T):i.message?i.message:_.localize(5,null)}e.toErrorMessage=y}),define(me[146],pe([16,17]),function(Z,e){return Z.create("vs/base/node/processes",e)}),define(me[79],pe([0,1,7,34,25,38,146,15,24,30,10,134,11]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function f(u){switch(u){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function l(u,a){if(T.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};a&&(t.cwd=a);const r=I.execFile("taskkill",["/T","/F","/PID",u.pid.toString()],t);return new Promise(s=>{r.once("error",o=>{s({success:!1,error:o})}),r.once("exit",(o,n)=>{s(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?f(t.status):1})}else if(T.isLinux||T.isMacintosh)try{const t=w.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Z).fsPath;return new Promise(r=>{I.execFile(t,[u.pid.toString()],{encoding:"utf8",shell:!0},(s,o,n)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else u.kill("SIGKILL");return Promise.resolve({success:!0})}function m(u=process.env){return u.comspec||"cmd.exe"}e.getWindowsShell=m;class S{constructor(a,t,r,s){if(t!==void 0&&r!==void 0&&s!==void 0)this.cmd=a,this.args=t,this.shell=r,this.options=s;else{const o=a;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(process.env).forEach(n=>{o[n]=process.env[n]}),Object.keys(this.options.env).forEach(n=>{o[n]=this.options.env[n]}),this.options.env=o}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const t=a.lastIndexOf(_.sep);return t!==-1&&(a=a.substring(t+1)),S.WellKnowCommands[a]?a:"other"}start(a){return T.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(process.cwd()))?Promise.reject(new Error(C.localize(0,null))):this.useExec().then(t=>{let r,s;const o=new Promise((n,c)=>{r=n,s=c});if(t){let n=this.cmd;this.args&&(n=n+" "+this.args.join(" ")),this.childProcess=I.exec(n,this.options,(c,p,E)=>{this.childProcess=null;const h=c;h&&h.killed?s({killed:this.terminateRequested,stdout:p.toString(),stderr:E.toString()}):this.handleExec(r,a,c,p,E)})}else{let n=null;const c=p=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(p,r,a,s);const E={terminated:this.terminateRequested};P.isNumber(p)&&(E.cmdCode=p),r(E)};if(this.shell&&T.isWindows){const p=y.deepClone(this.options);p.windowsVerbatimArguments=!0,p.detached=!1;let E=!1,h=!1;const v=[];let A=this.ensureQuotes(this.cmd);v.push(A.value),E=A.quoted,this.args&&this.args.forEach(x=>{A=this.ensureQuotes(x),v.push(A.value),h=h&&A.quoted});const F=["/s","/c"];E?h?F.push('"'+v.join(" ")+'"'):v.length>1?F.push('"'+v[0]+'" '+v.slice(1).join(" ")):F.push('"'+v[0]+'"'):F.push(v.join(" ")),n=I.spawn(m(),F,p)}else this.cmd&&(n=I.spawn(this.cmd,this.args,this.options));n&&(this.childProcess=n,this.childProcessPromise=Promise.resolve(n),this.pidResolve&&(this.pidResolve(P.isNumber(n.pid)?n.pid:-1),this.pidResolve=void 0),n.on("error",p=>{this.childProcess=null,s({terminated:this.terminateRequested,error:p})}),n.pid&&(this.childProcess.on("close",c),this.handleSpawn(n,r,a,s,!0)))}return o})}handleClose(a,t,r,s){}ensureQuotes(a){return S.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,l(a,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!T.isWindows)return a(!1);const t=I.spawn(m(),["/s","/c"]);t.on("error",r=>a(!0)),t.on("exit",r=>a(!1))})}}e.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class g extends S{constructor(a,t,r,s){super(a,t,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,t,r,s,o){[s,o].forEach((n,c)=>{const p=new k.LineDecoder;p.write(n).forEach(v=>{t({line:v,source:c===0?0:1})});const h=p.end();h&&t({line:h,source:c===0?0:1})}),a({terminated:this.terminateRequested,error:r})}handleSpawn(a,t,r,s,o){const n=new k.LineDecoder,c=new k.LineDecoder;a.stdout.on("data",p=>{n.write(p).forEach(h=>r({line:h,source:0}))}),a.stderr.on("data",p=>{c.write(p).forEach(h=>r({line:h,source:1}))}),this.stdoutLineDecoder=n,this.stderrLineDecoder=c}handleClose(a,t,r,s){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&r({line:o,source:0});const n=this.stderrLineDecoder?this.stderrLineDecoder.end():null;n&&r({line:n,source:1})}}e.LineProcess=g;function b(u){let a=[],t=!1;const r=function(s){if(t){a.push(s);return}(!u.send(s,n=>{if(n&&console.error(n),t=!1,a.length>0){const c=a.slice(0);a=[],c.forEach(p=>r(p))}})||T.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=b;var d;(function(u){async function a(t,r,s){if(_.isAbsolute(t))return t;if(r===void 0&&(r=process.cwd()),_.dirname(t)!=="."||(s===void 0&&P.isString(process.env.PATH)&&(s=process.env.PATH.split(_.delimiter)),s===void 0||s.length===0))return _.join(r,t);async function n(c){return await R.exists(c)?!(await D.promises.stat(c)).isDirectory():!1}for(let c of s){let p;if(_.isAbsolute(c)?p=_.join(c,t):p=_.join(r,c,t),await n(p))return p;let E=p+".com";if(await n(E)||(E=p+".exe",await n(E)))return E}return _.join(r,t)}u.findExecutable=a})(d=e.win32||(e.win32={}))}),define(me[147],pe([0,1,43,10,99,79]),function(Z,e,_,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function C(f,l=process.env){return f===3?D.isWindows?k():I.getWindowsShell(l):i(f,l)}e.getSystemShell=C;function P(f,l=process.env){return f===3?D.isWindows?w(l):I.getWindowsShell(l):i(f,l)}e.getSystemShellSync=P;let y=null;function i(f,l){if(D.isLinux&&f===1||D.isMacintosh&&f===2)return"/bin/bash";if(!y){let m;if(D.isWindows)m="/bin/bash";else{if(m=l.SHELL,!m)try{m=_.userInfo().shell}catch(S){}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}y=m}return y}let T=null;async function k(){return T||(T=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),T}function w(f){if(T)return T;const l=D.isWindows&&parseFloat(_.release())>=10,m=f.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${f.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return l?S:I.getWindowsShell(f)}}),define(me[148],pe([16,17]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(me[149],pe([0,1,148,10,104]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var I;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(I=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=C;class P{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,Ee){this._values[ie]=Ee}}e.ValidatedEditorOptions=P;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class i{constructor(ie,Ee,Ne,He){this.id=ie,this.name=Ee,this.defaultValue=Ne,this.schema=He}compute(ie,Ee,Ne){return Ne}}class T{constructor(ie,Ee=null){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0,this.deps=Ee}validate(ie){return this.defaultValue}}class k{constructor(ie,Ee,Ne,He){this.id=ie,this.name=Ee,this.defaultValue=Ne,this.schema=He}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,Ee,Ne){return Ne}}function w(X,ie){return typeof X=="undefined"?ie:X==="false"?!1:Boolean(X)}e.boolean=w;class f extends k{constructor(ie,Ee,Ne,He=void 0){typeof He!="undefined"&&(He.type="boolean",He.default=Ne),super(ie,Ee,Ne,He)}validate(ie){return w(ie,this.defaultValue)}}class l extends k{constructor(ie,Ee,Ne,He,Be,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="integer",Ye.default=Ne,Ye.minimum=He,Ye.maximum=Be),super(ie,Ee,Ne,Ye),this.minimum=He,this.maximum=Be}static clampedInt(ie,Ee,Ne,He){if(typeof ie=="undefined")return Ee;let Be=parseInt(ie,10);return isNaN(Be)?Ee:(Be=Math.max(Ne,Be),Be=Math.min(He,Be),Be|0)}validate(ie){return l.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class m extends k{constructor(ie,Ee,Ne,He,Be){typeof Be!="undefined"&&(Be.type="number",Be.default=Ne),super(ie,Ee,Ne,Be),this.validationFn=He}static clamp(ie,Ee,Ne){return ie<Ee?Ee:ie>Ne?Ne:ie}static float(ie,Ee){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return Ee;const Ne=parseFloat(ie);return isNaN(Ne)?Ee:Ne}validate(ie){return this.validationFn(m.float(ie,this.defaultValue))}}class S extends k{static string(ie,Ee){return typeof ie!="string"?Ee:ie}constructor(ie,Ee,Ne,He=void 0){typeof He!="undefined"&&(He.type="string",He.default=Ne),super(ie,Ee,Ne,He)}validate(ie){return S.string(ie,this.defaultValue)}}function g(X,ie,Ee){return typeof X!="string"||Ee.indexOf(X)===-1?ie:X}e.stringSet=g;class b extends k{constructor(ie,Ee,Ne,He,Be=void 0){typeof Be!="undefined"&&(Be.type="string",Be.enum=He,Be.default=Ne),super(ie,Ee,Ne,Be),this._allowedValues=He}validate(ie){return g(ie,this.defaultValue,this._allowedValues)}}class d extends i{constructor(ie,Ee,Ne,He,Be,Ye,q=void 0){typeof q!="undefined"&&(q.type="string",q.enum=Be,q.default=He),super(ie,Ee,Ne,q),this._allowedValues=Be,this._convert=Ye}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function u(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class a extends i{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[_.localize(0,null),_.localize(1,null),_.localize(2,null)],default:"auto",description:_.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,Ee,Ne){return Ne===0?ie.accessibilitySupport:Ne}}class t extends i{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(16,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:_.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:_.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{insertSpace:w(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:w(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var o;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(o=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function n(X){switch(X){case o.Line:return"line";case o.Block:return"block";case o.Underline:return"underline";case o.LineThin:return"line-thin";case o.BlockOutline:return"block-outline";case o.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=n;function c(X){switch(X){case"line":return o.Line;case"block":return o.Block;case"underline":return o.Underline;case"line-thin":return o.LineThin;case"block-outline":return o.BlockOutline;case"underline-thin":return o.UnderlineThin}}class p extends T{constructor(){super(121,[60,29])}compute(ie,Ee,Ne){const He=["monaco-editor"];return Ee.get(29)&&He.push(Ee.get(29)),ie.extraEditorClassName&&He.push(ie.extraEditorClassName),Ee.get(60)==="default"?He.push("mouse-default"):Ee.get(60)==="copy"&&He.push("mouse-copy"),Ee.get(95)&&He.push("showUnused"),Ee.get(119)&&He.push("showDeprecated"),He.join(" ")}}class E extends f{constructor(){super(28,"emptySelectionClipboard",!0,{description:_.localize(6,null)})}compute(ie,Ee,Ne){return Ne&&ie.emptySelectionClipboard}}class h extends i{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(31,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:_.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ie.seedSearchStringFromSelection,description:_.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[_.localize(9,null),_.localize(10,null),_.localize(11,null)],description:_.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:_.localize(13,null),included:D.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:_.localize(14,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:_.localize(15,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{cursorMoveOnType:w(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:w(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":g(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:w(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:w(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:w(Ee.loop,this.defaultValue.loop)}}}class v extends i{constructor(){super(39,"fontLigatures",v.OFF,{anyOf:[{type:"boolean",description:_.localize(16,null)},{type:"string",description:_.localize(17,null)}],description:_.localize(18,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?v.OFF:ie==="true"?v.ON:ie:Boolean(ie)?v.ON:v.OFF}}e.EditorFontLigatures=v,v.OFF='"liga" off, "calt" off',v.ON='"liga" on, "calt" on';class A extends T{constructor(){super(38)}compute(ie,Ee,Ne){return ie.fontInfo}}class F extends k{constructor(){super(40,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:_.localize(19,null)})}validate(ie){let Ee=m.float(ie,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(Ee,6,100)}compute(ie,Ee,Ne){return ie.fontInfo.fontSize}}class x extends i{constructor(){super(41,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.MINIMUM_VALUE,maximum:x.MAXIMUM_VALUE,errorMessage:_.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:_.localize(21,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(l.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,x.MINIMUM_VALUE,x.MAXIMUM_VALUE))}}x.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],x.MINIMUM_VALUE=1,x.MAXIMUM_VALUE=1e3;class j extends i{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[_.localize(22,null),_.localize(23,null),_.localize(24,null)]};super(45,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:_.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:_.localize(26,null)},Ee),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:_.localize(27,null)},Ee),"editor.gotoLocation.multipleDeclarations":Object.assign({description:_.localize(28,null)},Ee),"editor.gotoLocation.multipleImplementations":Object.assign({description:_.localize(29,null)},Ee),"editor.gotoLocation.multipleReferences":Object.assign({description:_.localize(30,null)},Ee),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,description:_.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,description:_.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,description:_.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,description:_.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,description:_.localize(35,null)}})}validate(ie){var Ee,Ne,He,Be,Ye;if(!ie||typeof ie!="object")return this.defaultValue;const q=ie;return{multiple:g(q.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(Ee=q.multipleDefinitions)!==null&&Ee!==void 0?Ee:g(q.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ne=q.multipleTypeDefinitions)!==null&&Ne!==void 0?Ne:g(q.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(He=q.multipleDeclarations)!==null&&He!==void 0?He:g(q.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Be=q.multipleImplementations)!==null&&Be!==void 0?Be:g(q.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ye=q.multipleReferences)!==null&&Ye!==void 0?Ye:g(q.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(q.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(q.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(q.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(q.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(q.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class G extends i{constructor(){const ie={enabled:!0,delay:300,sticky:!0};super(48,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:_.localize(36,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:_.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:_.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:w(Ee.enabled,this.defaultValue.enabled),delay:l.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:w(Ee.sticky,this.defaultValue.sticky)}}}var B;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(B=e.RenderMinimap||(e.RenderMinimap={}));class J extends T{constructor(){super(124,[44,52,33,59,87,54,55,89,111,114,115,116,2])}compute(ie,Ee,Ne){return J.computeLayout(Ee,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const Ee=ie.height/ie.lineHeight,Ne=ie.scrollBeyondLastLine?Ee-1:0,He=(ie.viewLineCount+Ne)/(ie.pixelRatio*ie.height),Be=Math.floor(ie.viewLineCount/He);return{typicalViewportLineCount:Ee,extraLinesBeyondLastLine:Ne,desiredRatio:He,minimapLineCount:Be}}static _computeMinimapLayout(ie,Ee){const Ne=ie.outerWidth,He=ie.outerHeight,Be=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Be*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const Ye=Ee.stableMinimapLayoutInput,q=Ye&&ie.outerHeight===Ye.outerHeight&&ie.lineHeight===Ye.lineHeight&&ie.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&ie.pixelRatio===Ye.pixelRatio&&ie.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&ie.minimap.enabled===Ye.minimap.enabled&&ie.minimap.side===Ye.minimap.side&&ie.minimap.size===Ye.minimap.size&&ie.minimap.showSlider===Ye.minimap.showSlider&&ie.minimap.renderCharacters===Ye.minimap.renderCharacters&&ie.minimap.maxColumn===Ye.minimap.maxColumn&&ie.minimap.scale===Ye.minimap.scale&&ie.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&ie.isViewportWrapping===Ye.isViewportWrapping,ae=ie.lineHeight,he=ie.typicalHalfwidthCharacterWidth,Y=ie.scrollBeyondLastLine,re=ie.minimap.renderCharacters;let ue=Be>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const fe=ie.minimap.maxColumn,ye=ie.minimap.size,je=ie.minimap.side,We=ie.verticalScrollbarWidth,ze=ie.viewLineCount,Xe=ie.remainingWidth,nt=ie.isViewportWrapping,et=re?2:3;let Je=Math.floor(Be*He);const _e=Je/Be;let De=!1,de=!1,ee=et*ue,Ae=ue/Be,Re=1;if(ye==="fill"||ye==="fit"){const{typicalViewportLineCount:ot,extraLinesBeyondLastLine:ut,desiredRatio:kt,minimapLineCount:Dt}=J.computeContainedMinimapLineCount({viewLineCount:ze,scrollBeyondLastLine:Y,height:He,lineHeight:ae,pixelRatio:Be});if(ze/Dt>1)De=!0,de=!0,ue=1,ee=1,Ae=ue/Be;else{let lt=!1,ft=ue+1;if(ye==="fit"){const dt=Math.ceil((ze+ut)*ee);nt&&q&&Xe<=Ee.stableFitRemainingWidth?(lt=!0,ft=Ee.stableFitMaxMinimapScale):(lt=dt>Je,nt&&lt?(Ee.stableMinimapLayoutInput=ie,Ee.stableFitRemainingWidth=Xe):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0))}if(ye==="fill"||lt){De=!0;const dt=ue;ee=Math.min(ae*Be,Math.max(1,Math.floor(1/kt))),ue=Math.min(ft,Math.max(1,Math.floor(ee/et))),ue>dt&&(Re=Math.min(2,ue/dt)),Ae=ue/Be/Re,Je=Math.ceil(Math.max(ot,ze+ut)*ee),nt&&lt&&(Ee.stableFitMaxMinimapScale=ue)}}}const Ze=Math.floor(fe*Ae),Le=Math.min(Ze,Math.max(0,Math.floor((Xe-We-2)*Ae/(he+Ae)))+e.MINIMAP_GUTTER_WIDTH);let it=Math.floor(Be*Le);const st=it/Be;it=Math.floor(it*Re);const Ke=re?1:2,ct=je==="left"?0:Ne-Le-We;return{renderMinimap:Ke,minimapLeft:ct,minimapWidth:Le,minimapHeightIsEditorHeight:De,minimapIsSampling:de,minimapScale:ue,minimapLineHeight:ee,minimapCanvasInnerWidth:it,minimapCanvasInnerHeight:Je,minimapCanvasOuterWidth:st,minimapCanvasOuterHeight:_e}}static computeLayout(ie,Ee){const Ne=Ee.outerWidth|0,He=Ee.outerHeight|0,Be=Ee.lineHeight|0,Ye=Ee.lineNumbersDigitCount|0,q=Ee.typicalHalfwidthCharacterWidth,ae=Ee.maxDigitWidth,he=Ee.pixelRatio,Y=Ee.viewLineCount,re=ie.get(116),ue=re==="inherit"?ie.get(115):re,fe=ue==="inherit"?ie.get(111):ue,ye=ie.get(114),je=ie.get(2),We=Ee.isDominatedByLongLines,ze=ie.get(44),Xe=ie.get(54).renderType!==0,nt=ie.get(55),et=ie.get(89),Je=ie.get(59),_e=ie.get(87),De=_e.verticalScrollbarSize,de=_e.verticalHasArrows,ee=_e.arrowSize,Ae=_e.horizontalScrollbarSize,Re=ie.get(52),Ze=ie.get(33);let Le;if(typeof Re=="string"&&/^\d+(\.\d+)?ch$/.test(Re)){const Pt=parseFloat(Re.substr(0,Re.length-2));Le=l.clampedInt(Pt*q,0,0,1e3)}else Le=l.clampedInt(Re,0,0,1e3);Ze&&(Le+=16);let it=0;if(Xe){const Pt=Math.max(Ye,nt);it=Math.round(Pt*ae)}let st=0;ze&&(st=Be);let Ke=0,ct=Ke+st,ot=ct+it,ut=ot+Le;const kt=Ne-st-it-Le;let Dt=!1,pt=!1,lt=-1;je!==2&&(ue==="inherit"&&We?(Dt=!0,pt=!0):fe==="on"||fe==="bounded"?pt=!0:fe==="wordWrapColumn"&&(lt=ye));const ft=J._computeMinimapLayout({outerWidth:Ne,outerHeight:He,lineHeight:Be,typicalHalfwidthCharacterWidth:q,pixelRatio:he,scrollBeyondLastLine:et,minimap:Je,verticalScrollbarWidth:De,viewLineCount:Y,remainingWidth:kt,isViewportWrapping:pt},Ee.memory||new y);ft.renderMinimap!==0&&ft.minimapLeft===0&&(Ke+=ft.minimapWidth,ct+=ft.minimapWidth,ot+=ft.minimapWidth,ut+=ft.minimapWidth);const dt=kt-ft.minimapWidth,It=Math.max(1,Math.floor((dt-De-2)/q)),St=de?ee:0;return pt&&(lt=Math.max(1,It),fe==="bounded"&&(lt=Math.min(lt,ye))),{width:Ne,height:He,glyphMarginLeft:Ke,glyphMarginWidth:st,lineNumbersLeft:ct,lineNumbersWidth:it,decorationsLeft:ot,decorationsWidth:Le,contentLeft:ut,contentWidth:dt,minimap:ft,viewportColumn:It,isWordWrapMinified:Dt,isViewportWrapping:pt,wrappingColumn:lt,verticalScrollbarWidth:De,horizontalScrollbarHeight:Ae,overviewRuler:{top:St,width:De,height:He-2*St,right:0}}}}e.EditorLayoutInfoComputer=J;class O extends i{constructor(){const ie={enabled:!0};super(51,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:_.localize(39,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:w(ie.enabled,this.defaultValue.enabled)}}}class N extends i{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(120,"inlineHints",ie,{"editor.inlineHints.enabled":{type:"boolean",default:ie.enabled,description:_.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:ie.fontSize,description:_.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:ie.fontFamily,description:_.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:w(Ee.enabled,this.defaultValue.enabled),fontSize:l.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(Ee.fontFamily,this.defaultValue.fontFamily)}}}class U extends l{constructor(){super(53,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:_.localize(43,null)})}compute(ie,Ee,Ne){return ie.fontInfo.lineHeight}}class L extends i{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(59,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:_.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[_.localize(45,null),_.localize(46,null),_.localize(47,null)],default:ie.size,description:_.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:_.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:_.localize(50,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:_.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:_.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:_.localize(53,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:w(Ee.enabled,this.defaultValue.enabled),size:g(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:g(Ee.side,this.defaultValue.side,["right","left"]),showSlider:g(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:w(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(Ee.scale,1,1,3),maxColumn:l.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function M(X){return X==="ctrlCmd"?D.isMacintosh?"metaKey":"ctrlKey":"altKey"}class V extends i{constructor(){super(69,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(55,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{top:l.clampedInt(Ee.top,0,0,1e3),bottom:l.clampedInt(Ee.bottom,0,0,1e3)}}}class K extends i{constructor(){const ie={enabled:!0,cycle:!1};super(70,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:_.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:_.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:w(Ee.enabled,this.defaultValue.enabled),cycle:w(Ee.cycle,this.defaultValue.cycle)}}}class se extends T{constructor(){super(122)}compute(ie,Ee,Ne){return ie.pixelRatio}}class ce extends i{constructor(){const ie={other:!0,comments:!1,strings:!1};super(73,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:_.localize(58,null)},comments:{type:"boolean",default:ie.comments,description:_.localize(59,null)},other:{type:"boolean",default:ie.other,description:_.localize(60,null)}}}],default:ie,description:_.localize(61,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const Ee=ie,Ne={other:w(Ee.other,this.defaultValue.other),comments:w(Ee.comments,this.defaultValue.comments),strings:w(Ee.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var we;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(we=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Te extends i{constructor(){super(54,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[_.localize(62,null),_.localize(63,null),_.localize(64,null),_.localize(65,null)],default:"on",description:_.localize(66,null)})}validate(ie){let Ee=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(Ee=4,Ne=ie):ie==="interval"?Ee=3:ie==="relative"?Ee=2:ie==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:Ne}}}function Ie(X){const ie=X.get(82);return ie==="editable"?X.get(75):ie!=="on"}e.filterValidationDecorations=Ie;class Me extends i{constructor(){const ie=[],Ee={type:"number",description:_.localize(67,null)};super(86,"rulers",ie,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:_.localize(68,null),format:"color-hex"}}}]},default:ie,description:_.localize(69,null)})}validate(ie){if(Array.isArray(ie)){let Ee=[];for(let Ne of ie)if(typeof Ne=="number")Ee.push({column:l.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const He=Ne;Ee.push({column:l.clampedInt(He.column,0,0,1e4),color:He.color})}return Ee.sort((Ne,He)=>Ne.column-He.column),Ee}return this.defaultValue}}function H(X,ie){if(typeof X!="string")return ie;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class Q extends i{constructor(){super(87,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie,Ne=l.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=l.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:H(Ee.vertical,this.defaultValue.vertical),horizontal:H(Ee.horizontal,this.defaultValue.horizontal),useShadows:w(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:w(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:w(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:w(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:w(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:l.clampedInt(Ee.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:He,verticalSliderSize:l.clampedInt(Ee.verticalSliderSize,He,0,1e3),scrollByPage:w(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}class ne extends i{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(101,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[_.localize(70,null),_.localize(71,null)],default:ie.insertMode,description:_.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:_.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:_.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:_.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:_.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:_.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:_.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:_.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:_.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:_.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:_.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:_.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:_.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:_.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:_.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:_.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:_.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:_.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:_.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:_.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:_.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:_.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:_.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:_.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:_.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:_.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:_.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:_.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:_.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:_.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:_.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:_.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:_.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:_.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:_.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:_.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:_.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:_.localize(109,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{insertMode:g(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:w(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:w(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:w(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:w(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:w(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:w(Ee.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:w(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:w(Ee.showMethods,this.defaultValue.showMethods),showFunctions:w(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:w(Ee.showConstructors,this.defaultValue.showConstructors),showFields:w(Ee.showFields,this.defaultValue.showFields),showVariables:w(Ee.showVariables,this.defaultValue.showVariables),showClasses:w(Ee.showClasses,this.defaultValue.showClasses),showStructs:w(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:w(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:w(Ee.showModules,this.defaultValue.showModules),showProperties:w(Ee.showProperties,this.defaultValue.showProperties),showEvents:w(Ee.showEvents,this.defaultValue.showEvents),showOperators:w(Ee.showOperators,this.defaultValue.showOperators),showUnits:w(Ee.showUnits,this.defaultValue.showUnits),showValues:w(Ee.showValues,this.defaultValue.showValues),showConstants:w(Ee.showConstants,this.defaultValue.showConstants),showEnums:w(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:w(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:w(Ee.showKeywords,this.defaultValue.showKeywords),showWords:w(Ee.showWords,this.defaultValue.showWords),showColors:w(Ee.showColors,this.defaultValue.showColors),showFiles:w(Ee.showFiles,this.defaultValue.showFiles),showReferences:w(Ee.showReferences,this.defaultValue.showReferences),showFolders:w(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:w(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:w(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:w(Ee.showUsers,this.defaultValue.showUsers),showIssues:w(Ee.showIssues,this.defaultValue.showIssues)}}}class oe extends i{constructor(){super(97,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:_.localize(110,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:w(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ge extends T{constructor(){super(123,[75])}compute(ie,Ee,Ne){return Ee.get(75)?!0:ie.tabFocusMode}}var Ce;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Ce=e.WrappingIndent||(e.WrappingIndent={}));function Oe(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ve extends T{constructor(){super(125,[124])}compute(ie,Ee,Ne){const He=Ee.get(124);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}const ke="Consolas, 'Courier New', monospace",Pe="Menlo, Monaco, 'Courier New', monospace",Ue="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:D.isMacintosh?Pe:D.isLinux?Ue:ke,fontWeight:"normal",fontSize:D.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Se(X){return e.editorOptionsRegistry[X.id]=X,X}var qe;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingOvertype=6]="autoClosingOvertype",X[X.autoClosingQuotes=7]="autoClosingQuotes",X[X.autoIndent=8]="autoIndent",X[X.automaticLayout=9]="automaticLayout",X[X.autoSurround=10]="autoSurround",X[X.codeLens=11]="codeLens",X[X.codeLensFontFamily=12]="codeLensFontFamily",X[X.codeLensFontSize=13]="codeLensFontSize",X[X.colorDecorators=14]="colorDecorators",X[X.columnSelection=15]="columnSelection",X[X.comments=16]="comments",X[X.contextmenu=17]="contextmenu",X[X.copyWithSyntaxHighlighting=18]="copyWithSyntaxHighlighting",X[X.cursorBlinking=19]="cursorBlinking",X[X.cursorSmoothCaretAnimation=20]="cursorSmoothCaretAnimation",X[X.cursorStyle=21]="cursorStyle",X[X.cursorSurroundingLines=22]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=23]="cursorSurroundingLinesStyle",X[X.cursorWidth=24]="cursorWidth",X[X.disableLayerHinting=25]="disableLayerHinting",X[X.disableMonospaceOptimizations=26]="disableMonospaceOptimizations",X[X.dragAndDrop=27]="dragAndDrop",X[X.emptySelectionClipboard=28]="emptySelectionClipboard",X[X.extraEditorClassName=29]="extraEditorClassName",X[X.fastScrollSensitivity=30]="fastScrollSensitivity",X[X.find=31]="find",X[X.fixedOverflowWidgets=32]="fixedOverflowWidgets",X[X.folding=33]="folding",X[X.foldingStrategy=34]="foldingStrategy",X[X.foldingHighlight=35]="foldingHighlight",X[X.unfoldOnClickAfterEndOfLine=36]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=37]="fontFamily",X[X.fontInfo=38]="fontInfo",X[X.fontLigatures=39]="fontLigatures",X[X.fontSize=40]="fontSize",X[X.fontWeight=41]="fontWeight",X[X.formatOnPaste=42]="formatOnPaste",X[X.formatOnType=43]="formatOnType",X[X.glyphMargin=44]="glyphMargin",X[X.gotoLocation=45]="gotoLocation",X[X.hideCursorInOverviewRuler=46]="hideCursorInOverviewRuler",X[X.highlightActiveIndentGuide=47]="highlightActiveIndentGuide",X[X.hover=48]="hover",X[X.inDiffEditor=49]="inDiffEditor",X[X.letterSpacing=50]="letterSpacing",X[X.lightbulb=51]="lightbulb",X[X.lineDecorationsWidth=52]="lineDecorationsWidth",X[X.lineHeight=53]="lineHeight",X[X.lineNumbers=54]="lineNumbers",X[X.lineNumbersMinChars=55]="lineNumbersMinChars",X[X.linkedEditing=56]="linkedEditing",X[X.links=57]="links",X[X.matchBrackets=58]="matchBrackets",X[X.minimap=59]="minimap",X[X.mouseStyle=60]="mouseStyle",X[X.mouseWheelScrollSensitivity=61]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=62]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=63]="multiCursorMergeOverlapping",X[X.multiCursorModifier=64]="multiCursorModifier",X[X.multiCursorPaste=65]="multiCursorPaste",X[X.occurrencesHighlight=66]="occurrencesHighlight",X[X.overviewRulerBorder=67]="overviewRulerBorder",X[X.overviewRulerLanes=68]="overviewRulerLanes",X[X.padding=69]="padding",X[X.parameterHints=70]="parameterHints",X[X.peekWidgetDefaultFocus=71]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=72]="definitionLinkOpensInPeek",X[X.quickSuggestions=73]="quickSuggestions",X[X.quickSuggestionsDelay=74]="quickSuggestionsDelay",X[X.readOnly=75]="readOnly",X[X.renameOnType=76]="renameOnType",X[X.renderControlCharacters=77]="renderControlCharacters",X[X.renderIndentGuides=78]="renderIndentGuides",X[X.renderFinalNewline=79]="renderFinalNewline",X[X.renderLineHighlight=80]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=81]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=82]="renderValidationDecorations",X[X.renderWhitespace=83]="renderWhitespace",X[X.revealHorizontalRightPadding=84]="revealHorizontalRightPadding",X[X.roundedSelection=85]="roundedSelection",X[X.rulers=86]="rulers",X[X.scrollbar=87]="scrollbar",X[X.scrollBeyondLastColumn=88]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=89]="scrollBeyondLastLine",X[X.scrollPredominantAxis=90]="scrollPredominantAxis",X[X.selectionClipboard=91]="selectionClipboard",X[X.selectionHighlight=92]="selectionHighlight",X[X.selectOnLineNumbers=93]="selectOnLineNumbers",X[X.showFoldingControls=94]="showFoldingControls",X[X.showUnused=95]="showUnused",X[X.snippetSuggestions=96]="snippetSuggestions",X[X.smartSelect=97]="smartSelect",X[X.smoothScrolling=98]="smoothScrolling",X[X.stickyTabStops=99]="stickyTabStops",X[X.stopRenderingLineAfter=100]="stopRenderingLineAfter",X[X.suggest=101]="suggest",X[X.suggestFontSize=102]="suggestFontSize",X[X.suggestLineHeight=103]="suggestLineHeight",X[X.suggestOnTriggerCharacters=104]="suggestOnTriggerCharacters",X[X.suggestSelection=105]="suggestSelection",X[X.tabCompletion=106]="tabCompletion",X[X.tabIndex=107]="tabIndex",X[X.unusualLineTerminators=108]="unusualLineTerminators",X[X.useTabStops=109]="useTabStops",X[X.wordSeparators=110]="wordSeparators",X[X.wordWrap=111]="wordWrap",X[X.wordWrapBreakAfterCharacters=112]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=113]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=114]="wordWrapColumn",X[X.wordWrapOverride1=115]="wordWrapOverride1",X[X.wordWrapOverride2=116]="wordWrapOverride2",X[X.wrappingIndent=117]="wrappingIndent",X[X.wrappingStrategy=118]="wrappingStrategy",X[X.showDeprecated=119]="showDeprecated",X[X.inlineHints=120]="inlineHints",X[X.editorClassName=121]="editorClassName",X[X.pixelRatio=122]="pixelRatio",X[X.tabFocusMode=123]="tabFocusMode",X[X.layoutInfo=124]="layoutInfo",X[X.wrappingInfo=125]="wrappingInfo"})(qe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Se(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:_.localize(111,null)})),acceptSuggestionOnEnter:Se(new b(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",_.localize(112,null),""],markdownDescription:_.localize(113,null)})),accessibilitySupport:Se(new a),accessibilityPageSize:Se(new l(3,"accessibilityPageSize",10,1,1073741824,{description:_.localize(114,null),deprecationMessage:_.localize(115,null)})),ariaLabel:Se(new S(4,"ariaLabel",_.localize(116,null))),autoClosingBrackets:Se(new b(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(117,null),_.localize(118,null),""],description:_.localize(119,null)})),autoClosingOvertype:Se(new b(6,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",_.localize(120,null),""],description:_.localize(121,null)})),autoClosingQuotes:Se(new b(7,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(122,null),_.localize(123,null),""],description:_.localize(124,null)})),autoIndent:Se(new d(8,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[_.localize(125,null),_.localize(126,null),_.localize(127,null),_.localize(128,null),_.localize(129,null)],description:_.localize(130,null)})),automaticLayout:Se(new f(9,"automaticLayout",!1)),autoSurround:Se(new b(10,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[_.localize(131,null),_.localize(132,null),_.localize(133,null),""],description:_.localize(134,null)})),stickyTabStops:Se(new f(99,"stickyTabStops",!1,{description:_.localize(135,null)})),codeLens:Se(new f(11,"codeLens",!0,{description:_.localize(136,null)})),codeLensFontFamily:Se(new S(12,"codeLensFontFamily","",{description:_.localize(137,null)})),codeLensFontSize:Se(new l(13,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:_.localize(138,null)})),colorDecorators:Se(new f(14,"colorDecorators",!0,{description:_.localize(139,null)})),columnSelection:Se(new f(15,"columnSelection",!1,{description:_.localize(140,null)})),comments:Se(new t),contextmenu:Se(new f(17,"contextmenu",!0)),copyWithSyntaxHighlighting:Se(new f(18,"copyWithSyntaxHighlighting",!0,{description:_.localize(141,null)})),cursorBlinking:Se(new d(19,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:_.localize(142,null)})),cursorSmoothCaretAnimation:Se(new f(20,"cursorSmoothCaretAnimation",!1,{description:_.localize(143,null)})),cursorStyle:Se(new d(21,"cursorStyle",o.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],c,{description:_.localize(144,null)})),cursorSurroundingLines:Se(new l(22,"cursorSurroundingLines",0,0,1073741824,{description:_.localize(145,null)})),cursorSurroundingLinesStyle:Se(new b(23,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[_.localize(146,null),_.localize(147,null)],description:_.localize(148,null)})),cursorWidth:Se(new l(24,"cursorWidth",0,0,1073741824,{markdownDescription:_.localize(149,null)})),disableLayerHinting:Se(new f(25,"disableLayerHinting",!1)),disableMonospaceOptimizations:Se(new f(26,"disableMonospaceOptimizations",!1)),dragAndDrop:Se(new f(27,"dragAndDrop",!0,{description:_.localize(150,null)})),emptySelectionClipboard:Se(new E),extraEditorClassName:Se(new S(29,"extraEditorClassName","")),fastScrollSensitivity:Se(new m(30,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:_.localize(151,null)})),find:Se(new h),fixedOverflowWidgets:Se(new f(32,"fixedOverflowWidgets",!1)),folding:Se(new f(33,"folding",!0,{description:_.localize(152,null)})),foldingStrategy:Se(new b(34,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[_.localize(153,null),_.localize(154,null)],description:_.localize(155,null)})),foldingHighlight:Se(new f(35,"foldingHighlight",!0,{description:_.localize(156,null)})),unfoldOnClickAfterEndOfLine:Se(new f(36,"unfoldOnClickAfterEndOfLine",!1,{description:_.localize(157,null)})),fontFamily:Se(new S(37,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:_.localize(158,null)})),fontInfo:Se(new A),fontLigatures2:Se(new v),fontSize:Se(new F),fontWeight:Se(new x),formatOnPaste:Se(new f(42,"formatOnPaste",!1,{description:_.localize(159,null)})),formatOnType:Se(new f(43,"formatOnType",!1,{description:_.localize(160,null)})),glyphMargin:Se(new f(44,"glyphMargin",!0,{description:_.localize(161,null)})),gotoLocation:Se(new j),hideCursorInOverviewRuler:Se(new f(46,"hideCursorInOverviewRuler",!1,{description:_.localize(162,null)})),highlightActiveIndentGuide:Se(new f(47,"highlightActiveIndentGuide",!0,{description:_.localize(163,null)})),hover:Se(new G),inDiffEditor:Se(new f(49,"inDiffEditor",!1)),letterSpacing:Se(new m(50,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>m.clamp(X,-5,20),{description:_.localize(164,null)})),lightbulb:Se(new O),lineDecorationsWidth:Se(new k(52,"lineDecorationsWidth",10)),lineHeight:Se(new U),lineNumbers:Se(new Te),lineNumbersMinChars:Se(new l(55,"lineNumbersMinChars",5,1,300)),linkedEditing:Se(new f(56,"linkedEditing",!1,{description:_.localize(165,null)})),links:Se(new f(57,"links",!0,{description:_.localize(166,null)})),matchBrackets:Se(new b(58,"matchBrackets","always",["always","near","never"],{description:_.localize(167,null)})),minimap:Se(new L),mouseStyle:Se(new b(60,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Se(new m(61,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:_.localize(168,null)})),mouseWheelZoom:Se(new f(62,"mouseWheelZoom",!1,{markdownDescription:_.localize(169,null)})),multiCursorMergeOverlapping:Se(new f(63,"multiCursorMergeOverlapping",!0,{description:_.localize(170,null)})),multiCursorModifier:Se(new d(64,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],M,{markdownEnumDescriptions:[_.localize(171,null),_.localize(172,null)],markdownDescription:_.localize(173,null)})),multiCursorPaste:Se(new b(65,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[_.localize(174,null),_.localize(175,null)],markdownDescription:_.localize(176,null)})),occurrencesHighlight:Se(new f(66,"occurrencesHighlight",!0,{description:_.localize(177,null)})),overviewRulerBorder:Se(new f(67,"overviewRulerBorder",!0,{description:_.localize(178,null)})),overviewRulerLanes:Se(new l(68,"overviewRulerLanes",3,0,3)),padding:Se(new V),parameterHints:Se(new K),peekWidgetDefaultFocus:Se(new b(71,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[_.localize(179,null),_.localize(180,null)],description:_.localize(181,null)})),definitionLinkOpensInPeek:Se(new f(72,"definitionLinkOpensInPeek",!1,{description:_.localize(182,null)})),quickSuggestions:Se(new ce),quickSuggestionsDelay:Se(new l(74,"quickSuggestionsDelay",10,0,1073741824,{description:_.localize(183,null)})),readOnly:Se(new f(75,"readOnly",!1)),renameOnType:Se(new f(76,"renameOnType",!1,{description:_.localize(184,null),markdownDeprecationMessage:_.localize(185,null)})),renderControlCharacters:Se(new f(77,"renderControlCharacters",!1,{description:_.localize(186,null)})),renderIndentGuides:Se(new f(78,"renderIndentGuides",!0,{description:_.localize(187,null)})),renderFinalNewline:Se(new f(79,"renderFinalNewline",!0,{description:_.localize(188,null)})),renderLineHighlight:Se(new b(80,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",_.localize(189,null)],description:_.localize(190,null)})),renderLineHighlightOnlyWhenFocus:Se(new f(81,"renderLineHighlightOnlyWhenFocus",!1,{description:_.localize(191,null)})),renderValidationDecorations:Se(new b(82,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Se(new b(83,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",_.localize(192,null),_.localize(193,null),_.localize(194,null),""],description:_.localize(195,null)})),revealHorizontalRightPadding:Se(new l(84,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Se(new f(85,"roundedSelection",!0,{description:_.localize(196,null)})),rulers:Se(new Me),scrollbar:Se(new Q),scrollBeyondLastColumn:Se(new l(88,"scrollBeyondLastColumn",5,0,1073741824,{description:_.localize(197,null)})),scrollBeyondLastLine:Se(new f(89,"scrollBeyondLastLine",!0,{description:_.localize(198,null)})),scrollPredominantAxis:Se(new f(90,"scrollPredominantAxis",!0,{description:_.localize(199,null)})),selectionClipboard:Se(new f(91,"selectionClipboard",!0,{description:_.localize(200,null),included:D.isLinux})),selectionHighlight:Se(new f(92,"selectionHighlight",!0,{description:_.localize(201,null)})),selectOnLineNumbers:Se(new f(93,"selectOnLineNumbers",!0)),showFoldingControls:Se(new b(94,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[_.localize(202,null),_.localize(203,null)],description:_.localize(204,null)})),showUnused:Se(new f(95,"showUnused",!0,{description:_.localize(205,null)})),showDeprecated:Se(new f(119,"showDeprecated",!0,{description:_.localize(206,null)})),inlineHints:Se(new N),snippetSuggestions:Se(new b(96,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[_.localize(207,null),_.localize(208,null),_.localize(209,null),_.localize(210,null)],description:_.localize(211,null)})),smartSelect:Se(new oe),smoothScrolling:Se(new f(98,"smoothScrolling",!1,{description:_.localize(212,null)})),stopRenderingLineAfter:Se(new l(100,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Se(new ne),suggestFontSize:Se(new l(102,"suggestFontSize",0,0,1e3,{markdownDescription:_.localize(213,null)})),suggestLineHeight:Se(new l(103,"suggestLineHeight",0,0,1e3,{markdownDescription:_.localize(214,null)})),suggestOnTriggerCharacters:Se(new f(104,"suggestOnTriggerCharacters",!0,{description:_.localize(215,null)})),suggestSelection:Se(new b(105,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[_.localize(216,null),_.localize(217,null),_.localize(218,null)],description:_.localize(219,null)})),tabCompletion:Se(new b(106,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[_.localize(220,null),_.localize(221,null),_.localize(222,null)],description:_.localize(223,null)})),tabIndex:Se(new l(107,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Se(new b(108,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[_.localize(224,null),_.localize(225,null),_.localize(226,null)],description:_.localize(227,null)})),useTabStops:Se(new f(109,"useTabStops",!0,{description:_.localize(228,null)})),wordSeparators:Se(new S(110,"wordSeparators",R.USUAL_WORD_SEPARATORS,{description:_.localize(229,null)})),wordWrap:Se(new b(111,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[_.localize(230,null),_.localize(231,null),_.localize(232,null),_.localize(233,null)],description:_.localize(234,null)})),wordWrapBreakAfterCharacters:Se(new S(112,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Se(new S(113,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Se(new l(114,"wordWrapColumn",80,1,1073741824,{markdownDescription:_.localize(235,null)})),wordWrapOverride1:Se(new b(115,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Se(new b(116,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Se(new d(117,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Oe,{enumDescriptions:[_.localize(236,null),_.localize(237,null),_.localize(238,null),_.localize(239,null)],description:_.localize(240,null)})),wrappingStrategy:Se(new b(118,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[_.localize(241,null),_.localize(242,null)],description:_.localize(243,null)})),editorClassName:Se(new p),pixelRatio:Se(new se),tabFocusMode:Se(new ge),layoutInfo:Se(new J),wrappingInfo:Se(new ve)}}),define(me[150],pe([16,17]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[151],pe([16,17]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[152],pe([16,17]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(me[153],pe([16,17]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(me[154],pe([16,17]),function(Z,e){return Z.create("vs/platform/theme/common/iconRegistry",e)}),define(me[155],pe([16,17]),function(Z,e){return Z.create("vs/platform/workspaces/common/workspaces",e)}),define(me[156],pe([16,17]),function(Z,e){return Z.create("vs/workbench/api/common/extHost.api.impl",e)}),define(me[157],pe([16,17]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[158],pe([16,17]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(me[159],pe([16,17]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[160],pe([16,17]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(me[161],pe([16,17]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[162],pe([16,17]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[163],pe([16,17]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[164],pe([16,17]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[165],pe([16,17]),function(Z,e){return Z.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[166],pe([16,17]),function(Z,e){return Z.create("vs/workbench/common/views",e)}),define(me[167],pe([16,17]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[168],pe([16,17]),function(Z,e){return Z.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[169],pe([16,17]),function(Z,e){return Z.create("vs/workbench/contrib/externalTerminal/node/externalTerminalService",e)}),define(me[170],pe([16,17]),function(Z,e){return Z.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[171],pe([16,17]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[172],pe([16,17]),function(Z,e){return Z.create("vs/workbench/contrib/terminal/common/terminal",e)}),define(me[173],pe([16,17]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[174],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var _;(function(C){C[C.ACTIVATE=0]="ACTIVATE",C[C.RESTORE=1]="RESTORE",C[C.PRESERVE=2]="PRESERVE"})(_=e.EditorActivation||(e.EditorActivation={}));var D;(function(C){C[C.PICK=1]="PICK",C[C.DISABLED=2]="DISABLED"})(D=e.EditorOverride||(e.EditorOverride={}));var R;(function(C){C[C.API=0]="API",C[C.USER=1]="USER"})(R=e.EditorOpenContext||(e.EditorOpenContext={}));var I;(function(C){C[C.Center=0]="Center",C[C.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",C[C.NearTop=2]="NearTop",C[C.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(I=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[107],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class _{constructor(I,C=[],P=!1){this.ctor=I,this.staticArguments=C,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=_;const D=(R,...I)=>new _(R,I);e.createSyncDescriptor=D}),define(me[80],pe([0,1,107]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const D=[];function R(C,P,y){P instanceof _.SyncDescriptor||(P=new _.SyncDescriptor(P,[],y)),D.push([C,P])}e.registerSingleton=R;function I(){return D}e.getSingletonServiceDescriptors=I}),define(me[175],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class _{constructor(I){this.incoming=new Map,this.outgoing=new Map,this.data=I}}e.Node=_;class D{constructor(I){this._hashFn=I,this._nodes=new Map}roots(){const I=[];for(let C of this._nodes.values())C.outgoing.size===0&&I.push(C);return I}insertEdge(I,C){const P=this.lookupOrInsertNode(I),y=this.lookupOrInsertNode(C);P.outgoing.set(this._hashFn(C),y),y.incoming.set(this._hashFn(I),P)}removeNode(I){const C=this._hashFn(I);this._nodes.delete(C);for(let P of this._nodes.values())P.outgoing.delete(C),P.incoming.delete(C)}lookupOrInsertNode(I){const C=this._hashFn(I);let P=this._nodes.get(C);return P||(P=new _(I),this._nodes.set(C,P)),P}lookup(I){return this._nodes.get(this._hashFn(I))}isEmpty(){return this._nodes.size===0}toString(){let I=[];for(let[C,P]of this._nodes)I.push(`${C}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return I.join(`
`)}}e.Graph=D}),define(me[4],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var _;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function y(i){return i[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=y})(_=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function D(P,y,i,T){y[_.DI_TARGET]===y?y[_.DI_DEPENDENCIES].push({id:P,index:i,optional:T}):(y[_.DI_DEPENDENCIES]=[{id:P,index:i,optional:T}],y[_.DI_TARGET]=y)}function R(P){if(_.serviceIds.has(P))return _.serviceIds.get(P);const y=function(i,T,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(y,i,k,!1)};return y.toString=()=>P,_.serviceIds.set(P,y),y}e.createDecorator=R;function I(P){return P}e.refineServiceDecorator=I;function C(P){return function(y,i,T){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");D(P,y,T,!0)}}e.optional=C}),define(me[176],pe([0,1,4]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,_.createDecorator)("modelService");function D(R){return!R.isTooLargeForSyncing()&&!R.isForSimpleWidget}e.shouldSynchronizeModel=D}),define(me[177],pe([0,1,3,74,6,22,73,78,176]),function(Z,e,_,D,R,I,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function i(w){return typeof w=="string"?!1:Array.isArray(w)?w.every(i):!!w.exclusive}class T{constructor(){this._clock=0,this._entries=[],this._onDidChange=new _.Emitter}get onDidChange(){return this._onDidChange.event}register(f,l){let m={selector:f,provider:l,_score:-1,_time:this._clock++};return this._entries.push(m),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,R.toDisposable)(()=>{if(m){let S=this._entries.indexOf(m);S>=0&&(this._entries.splice(S,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),m=void 0)}})}has(f){return this.all(f).length>0}all(f){if(!f)return[];this._updateScores(f);const l=[];for(let m of this._entries)m._score>0&&l.push(m.provider);return l}ordered(f){const l=[];return this._orderedForEach(f,m=>l.push(m.provider)),l}orderedGroups(f){const l=[];let m,S;return this._orderedForEach(f,g=>{m&&S===g._score?m.push(g.provider):(S=g._score,m=[g.provider],l.push(m))}),l}_orderedForEach(f,l){if(!!f){this._updateScores(f);for(const m of this._entries)m._score>0&&l(m)}}_updateScores(f){let l={uri:f.uri.toString(),language:f.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===l.language&&this._lastCandidate.uri===l.uri)){this._lastCandidate=l;for(let m of this._entries)if(m._score=(0,P.score)(m.selector,f.uri,f.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(f)),i(m.selector)&&m._score>0){for(let S of this._entries)S._score=0;m._score=1e3;break}this._entries.sort(T._compareByScoreAndTime)}}static _compareByScoreAndTime(f,l){return f._score<l._score?1:f._score>l._score?-1:f._time<l._time?1:f._time>l._time?-1:0}}e.LanguageFeatureRegistry=T;class k{constructor(f,l,m=Number.MAX_SAFE_INTEGER){this._registry=f,this.min=l,this.max=m,this._cache=new I.LRUCache(50,.7)}_key(f){return f.id+(0,D.hash)(this._registry.all(f))}_clamp(f){return f===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(f*1.3)))}get(f){const l=this._key(f),m=this._cache.get(l);return this._clamp(m==null?void 0:m.value)}update(f,l){const m=this._key(f);let S=this._cache.get(m);return S||(S=new C.MovingAverage,this._cache.set(m,S)),S.update(l),this.get(f)}}e.LanguageFeatureRequestDelays=k}),define(me[81],pe([0,1,2,44,177,141,47]),function(Z,e,_,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var P;(function(h){h[h.Null=0]="Null",h[h.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));class y{constructor(v,A){this.language=v,this.id=A}}e.LanguageIdentifier=y;var i;(function(h){h[h.NotSet=-1]="NotSet",h[h.None=0]="None",h[h.Italic=1]="Italic",h[h.Bold=2]="Bold",h[h.Underline=4]="Underline"})(i=e.FontStyle||(e.FontStyle={}));var T;(function(h){h[h.None=0]="None",h[h.DefaultForeground=1]="DefaultForeground",h[h.DefaultBackground=2]="DefaultBackground"})(T=e.ColorId||(e.ColorId={}));var k;(function(h){h[h.Other=0]="Other",h[h.Comment=1]="Comment",h[h.String=2]="String",h[h.RegEx=4]="RegEx"})(k=e.StandardTokenType||(e.StandardTokenType={}));var w;(function(h){h[h.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",h[h.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",h[h.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",h[h.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",h[h.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",h[h.ITALIC_MASK=2048]="ITALIC_MASK",h[h.BOLD_MASK=4096]="BOLD_MASK",h[h.UNDERLINE_MASK=8192]="UNDERLINE_MASK",h[h.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",h[h.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",h[h.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",h[h.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",h[h.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",h[h.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",h[h.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",h[h.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",h[h.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",h[h.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(w=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(v){return(v&255)>>>0}static getTokenType(v){return(v&1792)>>>8}static getFontStyle(v){return(v&14336)>>>11}static getForeground(v){return(v&8372224)>>>14}static getBackground(v){return(v&4286578688)>>>23}static getClassNameFromMetadata(v){let A=this.getForeground(v),F="mtk"+A,x=this.getFontStyle(v);return x&1&&(F+=" mtki"),x&2&&(F+=" mtkb"),x&4&&(F+=" mtku"),F}static getInlineStyleFromMetadata(v,A){const F=this.getForeground(v),x=this.getFontStyle(v);let j=`color: ${A[F]};`;return x&1&&(j+="font-style: italic;"),x&2&&(j+="font-weight: bold;"),x&4&&(j+="text-decoration: underline;"),j}}e.TokenMetadata=f;var l;(function(h){h[h.Method=0]="Method",h[h.Function=1]="Function",h[h.Constructor=2]="Constructor",h[h.Field=3]="Field",h[h.Variable=4]="Variable",h[h.Class=5]="Class",h[h.Struct=6]="Struct",h[h.Interface=7]="Interface",h[h.Module=8]="Module",h[h.Property=9]="Property",h[h.Event=10]="Event",h[h.Operator=11]="Operator",h[h.Unit=12]="Unit",h[h.Value=13]="Value",h[h.Constant=14]="Constant",h[h.Enum=15]="Enum",h[h.EnumMember=16]="EnumMember",h[h.Keyword=17]="Keyword",h[h.Text=18]="Text",h[h.Color=19]="Color",h[h.File=20]="File",h[h.Reference=21]="Reference",h[h.Customcolor=22]="Customcolor",h[h.Folder=23]="Folder",h[h.TypeParameter=24]="TypeParameter",h[h.User=25]="User",h[h.Issue=26]="Issue",h[h.Snippet=27]="Snippet"})(l=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let h=Object.create(null);return h[0]="symbol-method",h[1]="symbol-function",h[2]="symbol-constructor",h[3]="symbol-field",h[4]="symbol-variable",h[5]="symbol-class",h[6]="symbol-struct",h[7]="symbol-interface",h[8]="symbol-module",h[9]="symbol-property",h[10]="symbol-event",h[11]="symbol-operator",h[12]="symbol-unit",h[13]="symbol-value",h[14]="symbol-constant",h[15]="symbol-enum",h[16]="symbol-enum-member",h[17]="symbol-keyword",h[27]="symbol-snippet",h[18]="symbol-text",h[19]="symbol-color",h[20]="symbol-file",h[21]="symbol-reference",h[22]="symbol-customcolor",h[23]="symbol-folder",h[24]="symbol-type-parameter",h[25]="account",h[26]="issues",function(v){const A=h[v];let F=A&&C.iconRegistry.get(A);return F||(console.info("No codicon found for CompletionItemKind "+v),F=C.Codicon.symbolProperty),F.classNames}}(),e.completionKindFromString=function(){let h=Object.create(null);return h.method=0,h.function=1,h.constructor=2,h.field=3,h.variable=4,h.class=5,h.struct=6,h.interface=7,h.module=8,h.property=9,h.event=10,h.operator=11,h.unit=12,h.value=13,h.constant=14,h.enum=15,h["enum-member"]=16,h.enumMember=16,h.keyword=17,h.snippet=27,h.text=18,h.color=19,h.file=20,h.reference=21,h.customcolor=22,h.folder=23,h["type-parameter"]=24,h.typeParameter=24,h.account=25,h.issue=26,function(v,A){let F=h[v];return typeof F=="undefined"&&!A&&(F=9),F}}();var m;(function(h){h[h.Deprecated=1]="Deprecated"})(m=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(h){h[h.KeepWhitespace=1]="KeepWhitespace",h[h.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var g;(function(h){h[h.Invoke=0]="Invoke",h[h.TriggerCharacter=1]="TriggerCharacter",h[h.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(h){h[h.Auto=1]="Auto",h[h.Manual=2]="Manual"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(h){h[h.Invoke=1]="Invoke",h[h.TriggerCharacter=2]="TriggerCharacter",h[h.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var u;(function(h){h[h.Text=0]="Text",h[h.Read=1]="Read",h[h.Write=2]="Write"})(u=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function a(h){return h&&_.URI.isUri(h.uri)&&D.Range.isIRange(h.range)&&(D.Range.isIRange(h.originSelectionRange)||D.Range.isIRange(h.targetSelectionRange))}e.isLocationLink=a;var t;(function(h){h[h.File=0]="File",h[h.Module=1]="Module",h[h.Namespace=2]="Namespace",h[h.Package=3]="Package",h[h.Class=4]="Class",h[h.Method=5]="Method",h[h.Property=6]="Property",h[h.Field=7]="Field",h[h.Constructor=8]="Constructor",h[h.Enum=9]="Enum",h[h.Interface=10]="Interface",h[h.Function=11]="Function",h[h.Variable=12]="Variable",h[h.Constant=13]="Constant",h[h.String=14]="String",h[h.Number=15]="Number",h[h.Boolean=16]="Boolean",h[h.Array=17]="Array",h[h.Object=18]="Object",h[h.Key=19]="Key",h[h.Null=20]="Null",h[h.EnumMember=21]="EnumMember",h[h.Struct=22]="Struct",h[h.Event=23]="Event",h[h.Operator=24]="Operator",h[h.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var r;(function(h){h[h.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var s;(function(h){const v=new Map;v.set("file",0),v.set("module",1),v.set("namespace",2),v.set("package",3),v.set("class",4),v.set("method",5),v.set("property",6),v.set("field",7),v.set("constructor",8),v.set("enum",9),v.set("interface",10),v.set("function",11),v.set("variable",12),v.set("constant",13),v.set("string",14),v.set("number",15),v.set("boolean",16),v.set("array",17),v.set("object",18),v.set("key",19),v.set("null",20),v.set("enum-member",21),v.set("struct",22),v.set("event",23),v.set("operator",24),v.set("type-parameter",25);const A=new Map;A.set(0,"file"),A.set(1,"module"),A.set(2,"namespace"),A.set(3,"package"),A.set(4,"class"),A.set(5,"method"),A.set(6,"property"),A.set(7,"field"),A.set(8,"constructor"),A.set(9,"enum"),A.set(10,"interface"),A.set(11,"function"),A.set(12,"variable"),A.set(13,"constant"),A.set(14,"string"),A.set(15,"number"),A.set(16,"boolean"),A.set(17,"array"),A.set(18,"object"),A.set(19,"key"),A.set(20,"null"),A.set(21,"enum-member"),A.set(22,"struct"),A.set(23,"event"),A.set(24,"operator"),A.set(25,"type-parameter");function F(G){return v.get(G)}h.fromString=F;function x(G){return A.get(G)}h.toString=x;function j(G,B){const J=A.get(G);let O=J&&C.iconRegistry.get("symbol-"+J);return O||(console.info("No codicon found for SymbolKind "+G),O=C.Codicon.symbolProperty),`${B?"inline":"block"} ${O.classNames}`}h.toCssClassName=j})(s=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(v){this.value=v}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var n;(function(h){h[h.Collapsed=0]="Collapsed",h[h.Expanded=1]="Expanded"})(n=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var c;(function(h){h[h.Editing=0]="Editing",h[h.Preview=1]="Preview"})(c=e.CommentMode||(e.CommentMode={}));var p;(function(h){h[h.Other=0]="Other",h[h.Type=1]="Type",h[h.Parameter=2]="Parameter"})(p=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new R.LanguageFeatureRegistry,e.RenameProviderRegistry=new R.LanguageFeatureRegistry,e.CompletionProviderRegistry=new R.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new R.LanguageFeatureRegistry,e.HoverProviderRegistry=new R.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new R.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new R.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new R.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new R.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new R.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new R.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new R.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new R.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new R.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new R.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new R.LanguageFeatureRegistry,e.LinkProviderRegistry=new R.LanguageFeatureRegistry,e.ColorProviderRegistry=new R.LanguageFeatureRegistry,e.SelectionRangeRegistry=new R.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new R.LanguageFeatureRegistry,e.TokenizationRegistry=new I.TokenizationRegistryImpl;var E;(function(h){h[h.None=0]="None",h[h.Option=1]="Option",h[h.Default=2]="Default",h[h.Preferred=3]="Preferred"})(E=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[178],pe([0,1,6,15,4,3,57,72]),function(Z,e,_,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,R.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new I.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(y,i){if(!y)throw new Error("invalid command");if(typeof y=="string"){if(!i)throw new Error("invalid command");return this.registerCommand({id:y,handler:i})}if(y.description){const l=[];for(let S of y.description.args)l.push(S.constraint);const m=y.handler;y.handler=function(S,...g){return(0,D.validateConstraints)(g,l),m(S,...g)}}const{id:T}=y;let k=this._commands.get(T);k||(k=new C.LinkedList,this._commands.set(T,k));let w=k.unshift(y),f=(0,_.toDisposable)(()=>{w();const l=this._commands.get(T);(l==null?void 0:l.isEmpty())&&this._commands.delete(T)});return this._onDidRegisterCommand.fire(T),f}registerCommandAlias(y,i){return e.CommandsRegistry.registerCommand(y,(T,...k)=>T.get(e.ICommandService).executeCommand(i,...k))}getCommand(y){const i=this._commands.get(y);if(!(!i||i.isEmpty()))return P.Iterable.first(i)}getCommands(){const y=new Map;for(const i of this._commands.keys()){const T=this.getCommand(i);T&&y.set(i,T)}return y}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>_.Disposable.None,onDidExecuteCommand:()=>_.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(me[60],pe([0,1,9,4,10]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let I=R.userAgent||"";const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",R.isMacintosh),C.set("isLinux",R.isLinux),C.set("isWindows",R.isWindows),C.set("isWeb",R.isWeb),C.set("isMacNative",R.isMacintosh&&!R.isWeb),C.set("isEdge",I.indexOf("Edg/")>=0),C.set("isFirefox",I.indexOf("Firefox")>=0),C.set("isChrome",I.indexOf("Chrome")>=0),C.set("isSafari",I.indexOf("Safari")>=0),C.set("isIPad",I.indexOf("iPad")>=0);const P=Object.prototype.hasOwnProperty;var y;(function(h){h[h.False=0]="False",h[h.True=1]="True",h[h.Defined=2]="Defined",h[h.Not=3]="Not",h[h.Equals=4]="Equals",h[h.NotEquals=5]="NotEquals",h[h.And=6]="And",h[h.Regex=7]="Regex",h[h.NotRegex=8]="NotRegex",h[h.Or=9]="Or",h[h.In=10]="In",h[h.NotIn=11]="NotIn",h[h.Greater=12]="Greater",h[h.GreaterEquals=13]="GreaterEquals",h[h.Smaller=14]="Smaller",h[h.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class i{static false(){return k.INSTANCE}static true(){return w.INSTANCE}static has(v){return f.create(v)}static equals(v,A){return l.create(v,A)}static notEquals(v,A){return g.create(v,A)}static regex(v,A){return r.create(v,A)}static in(v,A){return m.create(v,A)}static not(v){return b.create(v)}static and(...v){return o.create(v)}static or(...v){return n.create(v)}static greater(v,A){return d.create(v,A)}static less(v,A){return a.create(v,A)}static deserialize(v,A=!1){if(!!v)return this._deserializeOrExpression(v,A)}static _deserializeOrExpression(v,A){let F=v.split("||");return n.create(F.map(x=>this._deserializeAndExpression(x,A)))}static _deserializeAndExpression(v,A){let F=v.split("&&");return o.create(F.map(x=>this._deserializeOne(x,A)))}static _deserializeOne(v,A){if(v=v.trim(),v.indexOf("!=")>=0){let F=v.split("!=");return g.create(F[0].trim(),this._deserializeValue(F[1],A))}if(v.indexOf("==")>=0){let F=v.split("==");return l.create(F[0].trim(),this._deserializeValue(F[1],A))}if(v.indexOf("=~")>=0){let F=v.split("=~");return r.create(F[0].trim(),this._deserializeRegexValue(F[1],A))}if(v.indexOf(" in ")>=0){let F=v.split(" in ");return m.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(v)){const F=v.split(">=");return u.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(v)){const F=v.split(">");return d.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(v)){const F=v.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(v)){const F=v.split("<");return a.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(v)?b.create(v.substr(1).trim()):f.create(v)}static _deserializeValue(v,A){if(v=v.trim(),v==="true")return!0;if(v==="false")return!1;let F=/^'([^']*)'$/.exec(v);return F?F[1].trim():v}static _deserializeRegexValue(v,A){if((0,_.isFalsyOrWhitespace)(v)){if(A)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=v.indexOf("/"),x=v.lastIndexOf("/");if(F===x||F<0){if(A)throw new Error(`bad regexp-value '${v}', missing /-enclosure`);return console.warn(`bad regexp-value '${v}', missing /-enclosure`),null}let j=v.slice(F+1,x),G=v[x+1]==="i"?"i":"";try{return new RegExp(j,G)}catch(B){if(A)throw new Error(`bad regexp-value '${v}', parse error: ${B}`);return console.warn(`bad regexp-value '${v}', parse error: ${B}`),null}}}e.ContextKeyExpr=i;function T(h,v){return h.cmp(v)}class k{constructor(){this.type=0}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}evaluate(v){return!1}serialize(){return"false"}keys(){return[]}map(v){return this}negate(){return w.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class w{constructor(){this.type=1}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}evaluate(v){return!0}serialize(){return"true"}keys(){return[]}map(v){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=w,w.INSTANCE=new w;class f{constructor(v){this.key=v,this.type=2}static create(v){const A=C.get(v);return typeof A=="boolean"?A?w.INSTANCE:k.INSTANCE:new f(v)}cmp(v){return v.type!==this.type?this.type-v.type:p(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}evaluate(v){return!!v.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(v){return v.mapDefined(this.key)}negate(){return b.create(this.key)}}e.ContextKeyDefinedExpr=f;class l{constructor(v,A){this.key=v,this.value=A,this.type=4}static create(v,A){if(typeof A=="boolean")return A?f.create(v):b.create(v);const F=C.get(v);return typeof F=="boolean"?A===(F?"true":"false")?w.INSTANCE:k.INSTANCE:new l(v,A)}cmp(v){return v.type!==this.type?this.type-v.type:E(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return v.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(v){return v.mapEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeyEqualsExpr=l;class m{constructor(v,A){this.key=v,this.valueKey=A,this.type=10}static create(v,A){return new m(v,A)}cmp(v){return v.type!==this.type?this.type-v.type:E(this.key,this.valueKey,v.key,v.valueKey)}equals(v){return v.type===this.type?this.key===v.key&&this.valueKey===v.valueKey:!1}evaluate(v){const A=v.getValue(this.valueKey),F=v.getValue(this.key);return Array.isArray(A)?A.indexOf(F)>=0:typeof F=="string"&&typeof A=="object"&&A!==null?P.call(A,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(v){return v.mapIn(this.key,this.valueKey)}negate(){return S.create(this)}}e.ContextKeyInExpr=m;class S{constructor(v){this._actual=v,this.type=11}static create(v){return new S(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new S(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class g{constructor(v,A){this.key=v,this.value=A,this.type=5}static create(v,A){if(typeof A=="boolean")return A?b.create(v):f.create(v);const F=C.get(v);return typeof F=="boolean"?A===(F?"true":"false")?k.INSTANCE:w.INSTANCE:new g(v,A)}cmp(v){return v.type!==this.type?this.type-v.type:E(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return v.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(v){return v.mapNotEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=g;class b{constructor(v){this.key=v,this.type=3}static create(v){const A=C.get(v);return typeof A=="boolean"?A?k.INSTANCE:w.INSTANCE:new b(v)}cmp(v){return v.type!==this.type?this.type-v.type:p(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}evaluate(v){return!v.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(v){return v.mapNot(this.key)}negate(){return f.create(this.key)}}e.ContextKeyNotExpr=b;class d{constructor(v,A){this.key=v,this.value=A,this.type=12}static create(v,A){return new d(v,A)}cmp(v){return v.type!==this.type?this.type-v.type:E(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=d;class u{constructor(v,A){this.key=v,this.value=A,this.type=13}static create(v,A){return new u(v,A)}cmp(v){return v.type!==this.type?this.type-v.type:E(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreaterEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=u;class a{constructor(v,A){this.key=v,this.value=A,this.type=14}static create(v,A){return new a(v,A)}cmp(v){return v.type!==this.type?this.type-v.type:E(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmaller(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerExpr=a;class t{constructor(v,A){this.key=v,this.value=A,this.type=15}static create(v,A){return new t(v,A)}cmp(v){return v.type!==this.type?this.type-v.type:E(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmallerEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(v,A){this.key=v,this.regexp=A,this.type=7}static create(v,A){return new r(v,A)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.key<v.key)return-1;if(this.key>v.key)return 1;const A=this.regexp?this.regexp.source:"",F=v.regexp?v.regexp.source:"";return A<F?-1:A>F?1:0}equals(v){if(v.type===this.type){const A=this.regexp?this.regexp.source:"",F=v.regexp?v.regexp.source:"";return this.key===v.key&&A===F}return!1}evaluate(v){let A=v.getValue(this.key);return this.regexp?this.regexp.test(A):!1}serialize(){const v=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${v}`}keys(){return[this.key]}map(v){return v.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=r;class s{constructor(v){this._actual=v,this.type=8}static create(v){return new s(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new s(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class o{constructor(v){this.expr=v,this.type=6}static create(v){return o._normalizeArr(v)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let A=0,F=this.expr.length;A<F;A++){const x=T(this.expr[A],v.expr[A]);if(x!==0)return x}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let A=0,F=this.expr.length;A<F;A++)if(!this.expr[A].equals(v.expr[A]))return!1;return!0}return!1}evaluate(v){for(let A=0,F=this.expr.length;A<F;A++)if(!this.expr[A].evaluate(v))return!1;return!0}static _normalizeArr(v){const A=[];let F=!1;for(const x of v)if(!!x){if(x.type===1){F=!0;continue}if(x.type===0)return k.INSTANCE;if(x.type===6){A.push(...x.expr);continue}A.push(x)}if(A.length===0&&F)return w.INSTANCE;if(A.length!==0){if(A.length===1)return A[0];for(A.sort(T);A.length>1;){const x=A[A.length-1];if(x.type!==9)break;A.pop();const j=A.pop(),G=n.create(x.expr.map(B=>o.create([B,j])));G&&(A.push(G),A.sort(T))}return A.length===1?A[0]:new o(A)}}serialize(){return this.expr.map(v=>v.serialize()).join(" && ")}keys(){const v=[];for(let A of this.expr)v.push(...A.keys());return v}map(v){return new o(this.expr.map(A=>A.map(v)))}negate(){let v=[];for(let A of this.expr)v.push(A.negate());return n.create(v)}}e.ContextKeyAndExpr=o;class n{constructor(v){this.expr=v,this.type=9}static create(v){const A=n._normalizeArr(v);if(A.length!==0)return A.length===1?A[0]:new n(A)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let A=0,F=this.expr.length;A<F;A++){const x=T(this.expr[A],v.expr[A]);if(x!==0)return x}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let A=0,F=this.expr.length;A<F;A++)if(!this.expr[A].equals(v.expr[A]))return!1;return!0}return!1}evaluate(v){for(let A=0,F=this.expr.length;A<F;A++)if(this.expr[A].evaluate(v))return!0;return!1}static _normalizeArr(v){let A=[],F=!1;if(v){for(let x=0,j=v.length;x<j;x++){const G=v[x];if(!!G){if(G.type===0){F=!0;continue}if(G.type===1)return[w.INSTANCE];if(G.type===9){A=A.concat(G.expr);continue}A.push(G)}}if(A.length===0&&F)return[k.INSTANCE];A.sort(T)}return A}serialize(){return this.expr.map(v=>v.serialize()).join(" || ")}keys(){const v=[];for(let A of this.expr)v.push(...A.keys());return v}map(v){return new n(this.expr.map(A=>A.map(v)))}negate(){let v=[];for(let F of this.expr)v.push(F.negate());const A=F=>F.type===9?F.expr:[F];for(;v.length>1;){const F=v.shift(),x=v.shift(),j=[];for(const G of A(F))for(const B of A(x))j.push(i.and(G,B));v.unshift(i.or(...j))}return v[0]}}e.ContextKeyOrExpr=n;class c extends f{constructor(v,A,F){super(v);this.key=v,this._defaultValue=A,typeof F=="object"?c._info.push(Object.assign(Object.assign({},F),{key:v})):F!==!0&&c._info.push({key:v,description:F,type:A!=null?typeof A:void 0})}static all(){return c._info.values()}bindTo(v){return v.createKey(this.key,this._defaultValue)}getValue(v){return v.getContextKeyValue(this.key)}toNegated(){return i.not(this.key)}isEqualTo(v){return i.equals(this.key,v)}notEqualsTo(v){return i.notEquals(this.key,v)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(h,v){return h<v?-1:h>v?1:0}function E(h,v,A,F){return h<A?-1:h>A?1:v<F?-1:v>F?1:0}}),define(me[179],pe([0,1,4]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,_.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,_.refineServiceDecorator)(e.IEnvironmentService)}),define(me[180],pe([0,1,151,4,11]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function I(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=I;var C;(function(k){k[k.NoneOrRelevance=0]="NoneOrRelevance",k[k.LastUpdatedDate=1]="LastUpdatedDate",k[k.Title=2]="Title",k[k.PublisherName=3]="PublisherName",k[k.InstallCount=4]="InstallCount",k[k.PublishedDate=5]="PublishedDate",k[k.AverageRating=6]="AverageRating",k[k.WeightedRating=12]="WeightedRating"})(C=e.SortBy||(e.SortBy={}));var P;(function(k){k[k.Default=0]="Default",k[k.Ascending=1]="Ascending",k[k.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var y;(function(k){k.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var i;(function(k){k[k.None=0]="None",k[k.Install=1]="Install",k[k.Update=2]="Update"})(i=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class T extends Error{constructor(w,f){super(w);this.code=f}}e.ExtensionManagementError=T,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=R.FileAccess.asBrowserUri("./media/defaultIcon.png",Z).toString(!0),e.ExtensionsLabel=(0,_.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,_.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(me[29],pe([0,1,9,4]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function R(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class C{constructor(T){this.value=T,this._lower=T.toLowerCase()}static equals(T,k){if(typeof T=="undefined"||T===null)return typeof k=="undefined"||k===null;if(typeof k=="undefined"||k===null)return!1;if(typeof T=="string"||typeof k=="string"){let w=typeof T=="string"?T:T.value,f=typeof k=="string"?k:k.value;return _.equalsIgnoreCase(w,f)}return T._lower===k._lower}static toKey(T){return typeof T=="string"?T.toLowerCase():T._lower}}e.ExtensionIdentifier=C;function P(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function y(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y,e.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[181],pe([0,1,9,29]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(f,l){return f.uuid&&l.uuid?f.uuid===l.uuid:f.id===l.id?!0:(0,_.compareIgnoreCase)(f.id,l.id)===0}e.areSameExtensions=R;class I{constructor(l,m){this.version=m,this.id=l.id,this.uuid=l.uuid}key(){return`${this.id}-${this.version}`}equals(l){return l instanceof I?R(this,l)&&this.version===l.version:!1}}e.ExtensionIdentifierWithVersion=I;function C(f,l){return`${f}.${l}`}e.getExtensionId=C;function P(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function y(f,l){return P(C(f,l))}e.getGalleryExtensionId=y;function i(f,l){const m=[],S=g=>{for(const b of m)if(b.some(d=>R(l(d),l(g))))return b;return null};for(const g of f){const b=S(g);b?b.push(g):m.push([g])}return m}e.groupByExtension=i;function T(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=T;function k(f){return Object.assign({id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0)},f.telemetryData)}e.getGalleryExtensionTelemetryData=k,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function w(f){const l=new Set;for(const m of f)m.malicious&&l.add(m.id.id);return l}e.getMaliciousExtensionsSet=w}),define(me[49],pe([0,1,152,7,2,4,9,15,22]),function(Z,e,_,D,R,I,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");var i;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var T;(function(F){F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash"})(T=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function k(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=k;function w(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=w;function f(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function l(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=l;var m;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",F.FileTooLarge="EntryTooLarge",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class S extends Error{constructor(x,j){super(x);this.code=j}}e.FileSystemProviderError=S;function g(F,x){const j=new S(F.toString(),x);return d(j,x),j}e.createFileSystemProviderError=g;function b(F){return F||g((0,_.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=b;function d(F,x){return F.name=x?`${x} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=d;function u(F){if(!F)return m.Unknown;if(F instanceof S)return F.code;const x=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!x)return m.Unknown;switch(x[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=u;function a(F){if(F instanceof c)return F.fileOperationResult;switch(u(F)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var t;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class r{constructor(x,j,G){this.resource=x,this.operation=j,this.target=G}isOperation(x){return this.operation===x}}e.FileOperationEvent=r;var s;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class o{constructor(x,j){this.ignorePathCasing=j,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=x;for(const G of x)switch(G.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(G.resource,G);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(G.resource,G);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(G.resource,G);break}}contains(x,...j){return this.doContains(x,{includeChildren:!1},...j)}affects(x,...j){return this.doContains(x,{includeChildren:!0},...j)}doContains(x,j,...G){var B,J,O,N,U,L;if(!x)return!1;const M=G.length>0;return!!((!M||G.includes(1))&&(((B=this.added)===null||B===void 0?void 0:B.get(x))||j.includeChildren&&((J=this.added)===null||J===void 0?void 0:J.findSuperstr(x)))||(!M||G.includes(0))&&(((O=this.updated)===null||O===void 0?void 0:O.get(x))||j.includeChildren&&((N=this.updated)===null||N===void 0?void 0:N.findSuperstr(x)))||(!M||G.includes(2))&&(((U=this.deleted)===null||U===void 0?void 0:U.findSubstr(x))||j.includeChildren&&((L=this.deleted)===null||L===void 0?void 0:L.findSuperstr(x))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(x){const j=[],G=x===1?this.added:x===0?this.updated:this.deleted;if(G)for(const[,B]of G)j.push(B);return j}filter(x){return new o(this.changes.filter(j=>x(j)),this.ignorePathCasing)}}e.FileChangesEvent=o;function n(F,x,j){return!F||!x||F===x||x.length>F.length?!1:(x.charAt(x.length-1)!==D.sep&&(x+=D.sep),j?(0,C.startsWithIgnoreCase)(F,x):F.indexOf(x)===0)}e.isParent=n;class c extends Error{constructor(x,j,G){super(x);this.fileOperationResult=j,this.options=G}static isFileOperationError(x){return x instanceof Error&&!(0,P.isUndefinedOrNull)(x.fileOperationResult)}}e.FileOperationError=c;var p;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_READ_ONLY=5]="FILE_READ_ONLY",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",F[F.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(p=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var E;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(E=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function h(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=h;async function v(F,x){if(!x.canHandleResource(R.URI.from({scheme:F.scheme})))return new Promise(j=>{const G=x.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===F.scheme&&B.added&&(G.dispose(),j())})})}e.whenProviderRegistered=v,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class A{static formatSize(x){return(0,P.isNumber)(x)||(x=0),x<A.KB?(0,_.localize)(1,null,x.toFixed(0)):x<A.MB?(0,_.localize)(2,null,(x/A.KB).toFixed(2)):x<A.GB?(0,_.localize)(3,null,(x/A.MB).toFixed(2)):x<A.TB?(0,_.localize)(4,null,(x/A.GB).toFixed(2)):(0,_.localize)(5,null,(x/A.TB).toFixed(2))}}e.ByteSize=A,A.KB=1024,A.MB=A.KB*A.KB,A.GB=A.MB*A.KB,A.TB=A.GB*A.KB}),define(me[82],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class _{constructor(...R){this._entries=new Map;for(let[I,C]of R)this.set(I,C)}set(R,I){const C=this._entries.get(R);return this._entries.set(R,I),C}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=_}),define(me[182],pe([0,1,18,175,107,4,82,19]),function(Z,e,_,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class i extends Error{constructor(l){super("cyclic dependency between services");this.message=l.toString()}}class T{constructor(l=new C.ServiceCollection,m=!1,S){this._activeInstantiations=new Set,this._services=l,this._strict=m,this._parent=S,this._services.set(I.IInstantiationService,this)}createChild(l){return new T(l,this._strict,this)}invokeFunction(l,...m){let S=w.traceInvocation(l),g=!1;try{return l({get:(d,u)=>{if(g)throw(0,_.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(d,S);if(!a&&u!==I.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return a}},...m)}finally{g=!0,S.stop()}}createInstance(l,...m){let S,g;return l instanceof R.SyncDescriptor?(S=w.traceCreation(l.ctor),g=this._createInstance(l.ctor,l.staticArguments.concat(m),S)):(S=w.traceCreation(l),g=this._createInstance(l,m,S)),S.stop(),g}_createInstance(l,m=[],S){let g=I._util.getServiceDependencies(l).sort((u,a)=>u.index-a.index),b=[];for(const u of g){let a=this._getOrCreateServiceInstance(u.id,S);if(!a&&this._strict&&!u.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${u.id}.`);b.push(a)}let d=g.length>0?g[0].index:m.length;if(m.length!==d){console.warn(`[createInstance] First service dependency of ${l.name} at position ${d+1} conflicts with ${m.length} static arguments`);let u=d-m.length;u>0?m=m.concat(new Array(u)):m=m.slice(0,d)}return new l(...[...m,...b])}_setServiceInstance(l,m){if(this._services.get(l)instanceof R.SyncDescriptor)this._services.set(l,m);else if(this._parent)this._parent._setServiceInstance(l,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let m=this._services.get(l);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):m}_getOrCreateServiceInstance(l,m){let S=this._getServiceInstanceOrDescriptor(l);return S instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,S,m.branch(l,!0)):(m.branch(l,!1),S)}_safeCreateAndCacheServiceInstance(l,m,S){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,m,S)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,m,S){const g=new D.Graph(u=>u.id.toString());let b=0;const d=[{id:l,desc:m,_trace:S}];for(;d.length;){const u=d.pop();if(g.lookupOrInsertNode(u),b++>1e3)throw new i(g);for(let a of I._util.getServiceDependencies(u.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${l} depends on ${a.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const r={id:a.id,desc:t,_trace:u._trace.branch(a.id,!0)};g.insertEdge(u,r),d.push(r)}}}for(;;){const u=g.roots();if(u.length===0){if(!g.isEmpty())throw new i(g);break}for(const{data:a}of u){if(this._getServiceInstanceOrDescriptor(a.id)instanceof R.SyncDescriptor){const r=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,r)}g.removeNode(a)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,m,S=[],g,b){if(this._services.get(l)instanceof R.SyncDescriptor)return this._createServiceInstance(m,S,g,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,m,S,g,b);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(l,m=[],S,g){if(S){const b=new P.IdleValue(()=>this._createInstance(l,m,g));return new Proxy(Object.create(null),{get(d,u){if(u in d)return d[u];let a=b.value,t=a[u];return typeof t!="function"||(t=t.bind(a),d[u]=t),t},set(d,u,a){return b.value[u]=a,!0}})}else return this._createInstance(l,m,g)}}e.InstantiationService=T;var k;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(k||(k={}));class w{constructor(l,m){this.type=l,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return y?new w(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):w._None}static traceCreation(l){return y?new w(0,l.name):w._None}branch(l,m){let S=new w(2,l.toString());return this._dep.push([l,m,S]),S}stop(){let l=Date.now()-this._start;w._totals+=l;let m=!1;function S(b,d){let u=[],a=new Array(b+1).join("	");for(const[t,r,s]of d._dep)if(r&&s){m=!0,u.push(`${a}CREATES -> ${t}`);let o=S(b+1,s);o&&u.push(o)}else u.push(`${a}uses -> ${t}`);return u.join(`
`)}let g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${w._totals.toFixed(2)}ms)`];(l>2||m)&&console.log(g.join(`
`))}}w._None=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w._totals=0}),define(me[12],pe([0,1,4,6,10,3,59]),function(Z,e,_,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function P(){return new Date().toISOString()}var y;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class i extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=i;class T extends i{constructor(a){super();this.logAlways=a}checkLogLevel(a){return this.logAlways||this.getLevel()<=a}trace(a,...t){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([a,...t]))}debug(a,...t){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([a,...t]))}info(a,...t){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([a,...t]))}warn(a,...t){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([a,...t]))}error(a,...t){if(this.checkLogLevel(y.Error))if(a instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=a.stack,this.log(y.Error,this.format(r))}else this.log(y.Error,this.format([a,...t]))}critical(a,...t){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([a,...t]))}flush(){}format(a){let t="";for(let r=0;r<a.length;r++){let s=a[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch(o){}t+=(r>0?" ":"")+s}return t}}e.AbstractMessageLogger=T;class k extends i{constructor(a=e.DEFAULT_LOG_LEVEL){super();this.setLevel(a),this.useColors=!R.isWindows}trace(a,...t){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,a,...t):console.log(`[main ${P()}]`,a,...t))}debug(a,...t){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,a,...t):console.log(`[main ${P()}]`,a,...t))}info(a,...t){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,a,...t):console.log(`[main ${P()}]`,a,...t))}warn(a,...t){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,a,...t):console.warn(`[main ${P()}]`,a,...t))}error(a,...t){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,a,...t):console.error(`[main ${P()}]`,a,...t))}critical(a,...t){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,a,...t):console.error(`[main ${P()}]`,a,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class w extends i{constructor(a=e.DEFAULT_LOG_LEVEL){super();this.setLevel(a)}trace(a,...t){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",a,...t)}debug(a,...t){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...t)}info(a,...t){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",a,...t)}warn(a,...t){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",a,...t)}error(a,...t){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",a,...t)}critical(a,...t){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",a,...t)}dispose(){}flush(){}}e.ConsoleLogger=w;class f extends i{constructor(a,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=a,this.setLevel(t)}trace(a,...t){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(a),...t])}debug(a,...t){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(a),...t])}info(a,...t){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(a),...t])}warn(a,...t){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(a),...t])}error(a,...t){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(a),...t])}critical(a,...t){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(a),...t])}extractMessage(a){return typeof a=="string"?a:(0,C.toErrorMessage)(a,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class l extends i{constructor(a){super();this.logServices=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const t of this.logServices)t.setLevel(a);super.setLevel(a)}trace(a,...t){for(const r of this.logServices)r.trace(a,...t)}debug(a,...t){for(const r of this.logServices)r.debug(a,...t)}info(a,...t){for(const r of this.logServices)r.info(a,...t)}warn(a,...t){for(const r of this.logServices)r.warn(a,...t)}error(a,...t){for(const r of this.logServices)r.error(a,...t)}critical(a,...t){for(const r of this.logServices)r.critical(a,...t)}flush(){for(const a of this.logServices)a.flush()}dispose(){for(const a of this.logServices)a.dispose()}}e.MultiplexLogService=l;class m extends D.Disposable{constructor(a){super();this.logger=a,this._register(a)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(a){this.logger.setLevel(a)}getLevel(){return this.logger.getLevel()}trace(a,...t){this.logger.trace(a,...t)}debug(a,...t){this.logger.debug(a,...t)}info(a,...t){this.logger.info(a,...t)}warn(a,...t){this.logger.warn(a,...t)}error(a,...t){this.logger.error(a,...t)}critical(a,...t){this.logger.critical(a,...t)}flush(){this.logger.flush()}}e.LogService=m;class S{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(a){}getLevel(){return y.Info}trace(a,...t){}debug(a,...t){}info(a,...t){}warn(a,...t){}error(a,...t){}critical(a,...t){}dispose(){}flush(){}}e.NullLogService=S;function g(u){if(u.verbose)return y.Trace;if(typeof u.logLevel=="string"){const a=b(u.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=g;function b(u){switch(u){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=b;function d(u){switch(u){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=d}),define(me[108],pe([0,1,12,49]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function R(y,i,T,k){try{const w=await new Promise((f,l)=>{Z(["spdlog"],f,l)});return w.setAsyncMode(8192,500),w.createRotatingLoggerAsync(y,i,T,k)}catch(w){console.error(w)}return null}function I(y,i,T,k){return Z.__$__nodeRequire("spdlog").createRotatingLogger(y,i,T,k)}e.createRotatingLogger=I;function C(y,i,T){switch(i){case _.LogLevel.Trace:y.trace(T);break;case _.LogLevel.Debug:y.debug(T);break;case _.LogLevel.Info:y.info(T);break;case _.LogLevel.Warning:y.warn(T);break;case _.LogLevel.Error:y.error(T);break;case _.LogLevel.Critical:y.critical(T);break;default:throw new Error("Invalid log level")}}class P extends _.AbstractMessageLogger{constructor(i,T,k,w){super();this.name=i,this.filepath=T,this.rotating=k,this.buffer=[],this.setLevel(w),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(f=>{this._logger&&this._logger.setLevel(f)}))}_createSpdLogLogger(){const i=this.rotating?6:1,T=30/i*D.ByteSize.MB;return R(this.name,this.filepath,T,i).then(k=>{if(k){this._logger=k,this._logger.setLevel(this.getLevel());for(const{level:w,message:f}of this.buffer)C(this._logger,w,f);this.buffer=[]}})}log(i,T){this._logger?C(this._logger,i,T):this.getLevel()<=i&&this.buffer.push({level:i,message:T})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(me[109],pe([0,1,4,153,75]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(I=e.MarkerTag||(e.MarkerTag={}));var C;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function i(l,m){return m-l}y.compare=i;const T=Object.create(null);T[y.Error]=(0,D.localize)(0,null),T[y.Warning]=(0,D.localize)(1,null),T[y.Info]=(0,D.localize)(2,null);function k(l){return T[l]||""}y.toString=k;function w(l){switch(l){case R.default.Error:return y.Error;case R.default.Warning:return y.Warning;case R.default.Info:return y.Info;case R.default.Ignore:return y.Hint}}y.fromSeverity=w;function f(l){switch(l){case y.Error:return R.default.Error;case y.Warning:return R.default.Warning;case y.Info:return R.default.Info;case y.Hint:return R.default.Ignore}}y.toSeverity=f}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(y){const i="";function T(w){return k(w,!0)}y.makeKey=T;function k(w,f){let l=[i];return w.source?l.push(w.source.replace("\xA6","\\\xA6")):l.push(i),w.code?typeof w.code=="string"?l.push(w.code.replace("\xA6","\\\xA6")):l.push(w.code.value.replace("\xA6","\\\xA6")):l.push(i),w.severity!==void 0&&w.severity!==null?l.push(C.toString(w.severity)):l.push(i),w.message&&f?l.push(w.message.replace("\xA6","\\\xA6")):l.push(i),w.startLineNumber!==void 0&&w.startLineNumber!==null?l.push(w.startLineNumber.toString()):l.push(i),w.startColumn!==void 0&&w.startColumn!==null?l.push(w.startColumn.toString()):l.push(i),w.endLineNumber!==void 0&&w.endLineNumber!==null?l.push(w.endLineNumber.toString()):l.push(i),w.endColumn!==void 0&&w.endColumn!==null?l.push(w.endColumn.toString()):l.push(i),l.push(i),l.join("\xA6")}y.makeKeyOptionalMessage=k})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(me[183],pe([0,1,75,4,3]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=_.default,e.INotificationService=(0,D.createDecorator)("notificationService");var I;(function(i){i[i.WORKSPACE=0]="WORKSPACE",i[i.GLOBAL=1]="GLOBAL"})(I=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(i){i[i.OFF=0]="OFF",i[i.SILENT=1]="SILENT",i[i.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new y,this.onDidClose=R.Event.None,this.onDidChangeVisibility=R.Event.None}updateSeverity(T){}updateMessage(T){}updateActions(T){}close(){}}e.NoOpNotification=P;class y{infinite(){}done(){}total(T){}worked(T){}}e.NoOpProgress=y}),define(me[184],pe([0,1,10,37,11,23]),function(Z,e,_,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;if(_.isWeb||typeof Z=="undefined"||typeof Z.__$__nodeRequire!="function")C={},Object.keys(C).length===0&&Object.assign(C,{version:"1.55.0-dev",nameShort:_.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:_.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser"]});else{const P=(0,I.dirname)(R.FileAccess.asFileUri("",Z));C=Z.__$__nodeRequire((0,I.joinPath)(P,"product.json").fsPath);const y=Z.__$__nodeRequire((0,I.joinPath)(P,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`}),Object.assign(C,{version:y.version})}e.default=C}),define(me[110],pe([0,1,4,21,6]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,_.createDecorator)("progressService");var I;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(I=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(i){this.callback=i}get value(){return this._value}report(i){this._value=i,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});class P extends R.Disposable{constructor(i){super();this.progressIndicator=i,this.currentOperationId=0,this.currentOperationDisposables=this._register(new R.DisposableStore)}start(i){this.stop();const T=++this.currentOperationId,k=new D.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{T===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},i),this.currentOperationDisposables.add((0,R.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,R.toDisposable)(()=>k.cancel())),this.currentOperationDisposables.add((0,R.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:T,token:k.token,stop:()=>this.doStop(T),isCurrent:()=>this.currentOperationId===T}}stop(){this.doStop(this.currentOperationId)}doStop(i){this.currentOperationId===i&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,_.createDecorator)("editorProgressService")}),define(me[40],pe([0,1,15,53]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(C,P){D.ok(_.isString(C)),D.ok(_.isObject(P)),D.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,P)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}e.Registry=new R}),define(me[111],pe([0,1,40,3]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class I{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,i){this.schemasById[R(y)]=i,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new I;_.Registry.add(e.Extensions.JSONContribution,C)}),define(me[83],pe([0,1,150,3,40,15,111]),function(Z,e,_,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=R.Registry.as(C.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(g,b=!0){this.registerConfigurations([g],b)}registerConfigurations(g,b=!0){const d=[];g.forEach(u=>{d.push(...this.validateAndRegisterProperties(u,b)),this.configurationContributors.push(u),this.registerJSONConfiguration(u)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterConfigurations(g){const b=[],d=u=>{if(u.properties)for(const a in u.properties)b.push(a),delete this.configurationProperties[a],this.removeFromSchema(a,u.properties[a]);u.allOf&&u.allOf.forEach(a=>d(a))};for(const u of g){d(u);const a=this.configurationContributors.indexOf(u);a!==-1&&this.configurationContributors.splice(a,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}registerDefaultConfigurations(g){const b=[],d=[];for(const u of g)for(const a in u)if(b.push(a),e.OVERRIDE_PROPERTY_PATTERN.test(a)){this.defaultValues[a]=Object.assign(Object.assign({},this.defaultValues[a]||{}),u[a]);const t={type:"object",default:this.defaultValues[a],description:_.localize(1,null,a),$ref:e.resourceLanguageSettingsSchemaId};d.push(k(a)),this.configurationProperties[a]=t,this.defaultLanguageConfigurationOverridesNode.properties[a]=t}else{this.defaultValues[a]=u[a];const t=this.configurationProperties[a];t&&(this.updatePropertyDefaultValue(a,t),this.updateSchema(a,t))}this.registerOverrideIdentifiers(d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}deregisterDefaultConfigurations(g){const b=[];for(const d of g)for(const u in d)if(b.push(u),delete this.defaultValues[u],e.OVERRIDE_PROPERTY_PATTERN.test(u))delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u];else{const a=this.configurationProperties[u];a&&(this.updatePropertyDefaultValue(u,a),this.updateSchema(u,a))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}notifyConfigurationSchemaUpdated(...g){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(g){for(const b of g)this.overrideIdentifiers.add(b);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(g,b=!0,d=3){d=I.isUndefinedOrNull(g.scope)?d:g.scope;let u=[],a=g.properties;if(a)for(let r in a){if(b&&l(r)){delete a[r];continue}const s=a[r];if(this.updatePropertyDefaultValue(r,s),e.OVERRIDE_PROPERTY_PATTERN.test(r)?s.scope=void 0:s.scope=I.isUndefinedOrNull(s.scope)?d:s.scope,a[r].hasOwnProperty("included")&&!a[r].included){this.excludedConfigurationProperties[r]=a[r],delete a[r];continue}else this.configurationProperties[r]=a[r];!a[r].deprecationMessage&&a[r].markdownDeprecationMessage&&(a[r].deprecationMessage=a[r].markdownDeprecationMessage),u.push(r)}let t=g.allOf;if(t)for(let r of t)u.push(...this.validateAndRegisterProperties(r,b,d));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(g){const b=d=>{let u=d.properties;if(u)for(const t in u)this.updateSchema(t,u[t]);let a=d.allOf;a&&a.forEach(b)};b(g)}updateSchema(g,b){switch(e.allSettings.properties[g]=b,b.scope){case 1:e.applicationSettings.properties[g]=b;break;case 2:e.machineSettings.properties[g]=b;break;case 6:e.machineOverridableSettings.properties[g]=b;break;case 3:e.windowSettings.properties[g]=b;break;case 4:e.resourceSettings.properties[g]=b;break;case 5:e.resourceSettings.properties[g]=b,this.resourceLanguageSettingsSchema.properties[g]=b;break}}removeFromSchema(g,b){switch(delete e.allSettings.properties[g],b.scope){case 1:delete e.applicationSettings.properties[g];break;case 2:delete e.machineSettings.properties[g];break;case 6:delete e.machineOverridableSettings.properties[g];break;case 3:delete e.windowSettings.properties[g];break;case 4:case 5:delete e.resourceSettings.properties[g];break}}updateOverridePropertyPatternKey(){for(const g of this.overrideIdentifiers.values()){const b=`[${g}]`,d={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(b,d),e.allSettings.properties[b]=d,e.applicationSettings.properties[b]=d,e.machineSettings.properties[b]=d,e.machineOverridableSettings.properties[b]=d,e.windowSettings.properties[b]=d,e.resourceSettings.properties[b]=d}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(g,b){let d=this.defaultValues[g];I.isUndefined(d)&&(d=b.default),I.isUndefined(d)&&(d=w(b.type)),b.default=d}}const T="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(T);function k(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=k;function w(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=w;const f=new i;R.Registry.add(e.Extensions.Configuration,f);function l(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?_.localize(5,null,S):f.getConfigurationProperties()[S]!==void 0?_.localize(6,null,S):null:_.localize(4,null)}e.validateProperty=l;function m(){const S=[],g=f.getConfigurationProperties();for(const b of Object.keys(g))S.push([b,g[b].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=m}),define(me[84],pe([0,1,24,15,2,40,4,83]),function(Z,e,_,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function y(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof R.URI)}e.isConfigurationOverrides=y;var i;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(i=e.ConfigurationTarget||(e.ConfigurationTarget={}));function T(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=T;function k(r,s){const o=s?r?s.keys.filter(A=>r.keys.indexOf(A)===-1):[...s.keys]:[],n=r?s?r.keys.filter(A=>s.keys.indexOf(A)===-1):[...r.keys]:[],c=[];if(s&&r){for(const A of r.keys)if(s.keys.indexOf(A)!==-1){const F=g(r.contents,A),x=g(s.contents,A);_.equals(F,x)||c.push(A)}}const p=[],E=A=>{const F={};for(const x of A)for(const j of x.identifiers)F[a(j)]=x;return F},h=s?E(s.overrides):{},v=r?E(r.overrides):{};if(Object.keys(h).length)for(const A of o){const F=h[A];F&&p.push([(0,P.overrideIdentifierFromKey)(A),F.keys])}if(Object.keys(v).length)for(const A of n){const F=v[A];F&&p.push([(0,P.overrideIdentifierFromKey)(A),F.keys])}if(Object.keys(h).length&&Object.keys(v).length)for(const A of c){const F=v[A],x=h[A];if(F&&x){const j=k({contents:F.contents,keys:F.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});p.push([(0,P.overrideIdentifierFromKey)(A),[...j.added,...j.removed,...j.updated]])}}return{added:o,removed:n,updated:c,overrides:p}}e.compare=k;function w(r,s){const o=[];for(const n of Object.keys(r))if(P.OVERRIDE_PROPERTY_PATTERN.test(n)){const c={};for(const p in r[n])c[p]=r[n][p];o.push({identifiers:[(0,P.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(c),contents:f(c,s)})}return o}e.toOverrides=w;function f(r,s){const o=Object.create(null);for(let n in r)l(o,n,r[n],s);return o}e.toValuesTree=f;function l(r,s,o,n){const c=s.split("."),p=c.pop();let E=r;for(let h=0;h<c.length;h++){let v=c[h],A=E[v];switch(typeof A){case"undefined":A=E[v]=Object.create(null);break;case"object":break;default:n(`Ignoring ${s} as ${c.slice(0,h+1).join(".")} is ${JSON.stringify(A)}`);return}E=A}if(typeof E=="object"&&E!==null)try{E[p]=o}catch(h){n(`Ignoring ${s} as ${c.join(".")} is ${JSON.stringify(E)}`)}else n(`Ignoring ${s} as ${c.join(".")} is ${JSON.stringify(E)}`)}e.addToValueTree=l;function m(r,s){const o=s.split(".");S(r,o)}e.removeFromValueTree=m;function S(r,s){const o=s.shift();if(s.length===0){delete r[o];return}if(Object.keys(r).indexOf(o)!==-1){const n=r[o];typeof n=="object"&&!Array.isArray(n)&&(S(n,s),Object.keys(n).length===0&&delete r[o])}}function g(r,s,o){function n(E,h){let v=E;for(const A of h){if(typeof v!="object"||v===null)return;v=v[A]}return v}const c=s.split("."),p=n(r,c);return typeof p=="undefined"?o:p}e.getConfigurationValue=g;function b(r,s,o){Object.keys(s).forEach(n=>{n!=="__proto__"&&(n in r?D.isObject(r[n])&&D.isObject(s[n])?b(r[n],s[n],o):o&&(r[n]=s[n]):r[n]=s[n])})}e.merge=b;function d(){const r=I.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=d;function u(){const r=Object.create(null),s=I.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let o in s){let n=s[o].default;l(r,o,n,c=>console.error(`Conflict in default settings: ${c}`))}return r}e.getDefaultValues=u;function a(r){return`[${r}]`}e.keyFromOverrideIdentifier=a;function t(r,s,o){const n=r.inspect(s),c=r.inspect(o);return typeof n.userValue!="undefined"||typeof n.workspaceValue!="undefined"||typeof n.workspaceFolderValue!="undefined"?n.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:n.defaultValue}e.getMigratedSettingValue=t}),define(me[185],pe([0,1,56,22,14,15,24,2,83,84,40,6,3]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},r=[],s=[]){this._contents=t,this._keys=r,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const s=this.getContentsForOverrideIdentifer(r);return s?t?(0,i.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const o of R.distinct([...Object.keys(this.contents),...Object.keys(r)])){let n=this.contents[o],c=r[o];c&&(typeof n=="object"&&typeof c=="object"?(n=C.deepClone(n),this.mergeContents(n,c)):n=c),s[o]=n}return new f(s,this.keys,this.overrides)}merge(...t){const r=C.deepClone(this.contents),s=C.deepClone(this.overrides),o=[...this.keys];for(const n of t){this.mergeContents(r,n.contents);for(const c of n.overrides){const[p]=s.filter(E=>R.equals(E.identifiers,c.identifiers));p?this.mergeContents(p.contents,c.contents):s.push(C.deepClone(c))}for(const c of n.keys)o.indexOf(c)===-1&&o.push(c)}return new f(r,o,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const s of Object.keys(r)){if(s in t&&I.isObject(t[s])&&I.isObject(r[s])){this.mergeContents(t[s],r[s]);continue}t[s]=C.deepClone(r[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?C.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,i.addToValueTree)(this.contents,t,r,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let s=0;s<r;s++)t.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=f;class l extends f{constructor(){const t=(0,i.getDefaultValues)(),r=(0,i.getConfigurationKeys)(),s=[];for(const o of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(o)&&s.push({identifiers:[(0,y.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(t[o]),contents:(0,i.toValuesTree)(t[o],n=>console.error(`Conflict in default settings file: ${n}`))});super(t,r,s)}}e.DefaultConfigurationModel=l;class m{constructor(t,r){this._name=t,this._scopes=r,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get errors(){return this._parseErrors}parseContent(t){if(!I.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r)}}parseRaw(t){this._raw=t;const r=this.doParseRaw(t);this._configurationModel=new f(r.contents,r.keys,r.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let r={},s=null,o=[],n=[],c=[];function p(h){Array.isArray(o)?o.push(h):s&&(o[s]=h)}let E={onObjectBegin:()=>{let h={};p(h),n.push(o),o=h,s=null},onObjectProperty:h=>{s=h},onObjectEnd:()=>{o=n.pop()},onArrayBegin:()=>{let h=[];p(h),n.push(o),o=h,s=null},onArrayEnd:()=>{o=n.pop()},onLiteralValue:p,onError:(h,v,A)=>{c.push({error:h,offset:v,length:A})}};if(t)try{_.visit(t,E),r=o[0]||{}}catch(h){console.error(`Error while parsing settings file ${this._name}: ${h}`),this._parseErrors=[h]}return r}doParseRaw(t){if(this._scopes){const n=T.Registry.as(y.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,n,!0,this._scopes)}const r=(0,i.toValuesTree)(t,n=>console.error(`Conflict in settings file ${this._name}: ${n}`)),s=Object.keys(t),o=(0,i.toOverrides)(t,n=>console.error(`Conflict in settings file ${this._name}: ${n}`));return{contents:r,keys:s,overrides:o}}filterByScope(t,r,s,o){const n={};for(let c in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(c)&&s)n[c]=this.filterByScope(t[c],r,!1,o);else{const p=this.getScope(c,r);(p===void 0||o.indexOf(p)!==-1)&&(n[c]=t[c])}return n}getScope(t,r){const s=r[t];return s?typeof s.scope!="undefined"?s.scope:3:void 0}}e.ConfigurationModelParser=m;class S extends k.Disposable{constructor(t,r,s,o){super();this.userSettingsResource=t,this.scopes=r,this.fileService=o,this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(w.Event.filter(this.fileService.onDidFilesChange,n=>n.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new f}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=S;class g{constructor(t,r,s=new f,o=new f,n=new D.ResourceMap,c=new f,p=new D.ResourceMap,E=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=o,this._folderConfigurations=n,this._memoryConfiguration=c,this._memoryConfigurationByResource=p,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(t,r,s){return this.getConsolidateConfigurationModel(r,s).getValue(t)}updateValue(t,r,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new f,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,r===void 0?o.removeValue(t):o.setValue(t,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,s){const o=this.getConsolidateConfigurationModel(r,s),n=this.getFolderConfigurationModelForResource(r.resource,s),c=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,p=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),E=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),h=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),v=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),A=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=n?r.overrideIdentifier?n.freeze().override(r.overrideIdentifier).getValue(t):n.freeze().getValue(t):void 0,x=r.overrideIdentifier?c.override(r.overrideIdentifier).getValue(t):c.getValue(t),j=o.getValue(t),G=R.distinct(R.flatten(o.overrides.map(B=>B.identifiers))).filter(B=>o.getOverrideValue(t,B)!==void 0);return{defaultValue:p,userValue:E,userLocalValue:h,userRemoteValue:v,workspaceValue:A,workspaceFolderValue:F,memoryValue:x,value:j,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:h!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:v!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:A!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:n==null?void 0:n.freeze().getValue(t),override:r.overrideIdentifier?n==null?void 0:n.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:c.getValue(t),override:r.overrideIdentifier?c.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:G.length?G:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const s=r.filter(o=>y.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const n=(0,y.overrideIdentifierFromKey)(o),c=this._defaultConfiguration.getKeysForOverrideIdentifier(n),p=t.getKeysForOverrideIdentifier(n),E=[...p.filter(h=>c.indexOf(h)===-1),...c.filter(h=>p.indexOf(h)===-1),...c.filter(h=>!C.equals(this._defaultConfiguration.override(n).getValue(h),t.override(n).getValue(h)))];return[n,E]});return this.updateDefaultConfiguration(t),{keys:r,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:s,removed:o,overrides:n}=(0,i.compare)(this.localUserConfiguration,t),c=[...r,...s,...o];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:n}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:s,removed:o,overrides:n}=(0,i.compare)(this.remoteUserConfiguration,t);let c=[...r,...s,...o];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:n}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:s,removed:o,overrides:n}=(0,i.compare)(this.workspaceConfiguration,t);let c=[...r,...s,...o];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:n}}compareAndUpdateFolderConfiguration(t,r){const s=this.folderConfigurations.get(t),{added:o,updated:n,removed:c,overrides:p}=(0,i.compare)(s,r);let E=[...o,...n,...c];return(E.length||!s)&&this.updateFolderConfiguration(t,r),{keys:E,overrides:p}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:n,overrides:c}=(0,i.compare)(r,void 0);return{keys:[...s,...o,...n],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const o=r.getFolder(t);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const n=this._memoryConfigurationByResource.get(t);n&&(s=s.merge(n))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(r=s.merge(o),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=s}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const s=r.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:s,overrides:o,keys:n}=this._folderConfigurations.get(r);return t.push([r,{contents:s,overrides:o,keys:n}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),o=this.parseConfigurationModel(t.workspace),n=t.folders.reduce((c,p)=>(c.set(P.URI.revive(p[0]),this.parseConfigurationModel(p[1])),c),new D.ResourceMap);return new g(r,s,new f,o,n,new f,new D.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=g;function b(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,r=new Map;for(const o of a)o.keys.forEach(n=>t.add(n)),o.overrides.forEach(([n,c])=>{const p=(0,D.getOrSet)(r,n,new Set);c.forEach(E=>p.add(E))});const s=[];return r.forEach((o,n)=>s.push([n,[...o.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=b;class d{constructor(t,r,s,o){this.change=t,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=o,this._previousConfiguration=void 0;const n=new Set;t.keys.forEach(p=>n.add(p)),t.overrides.forEach(([,p])=>p.forEach(E=>n.add(E))),this.affectedKeys=[...n.values()];const c=new f;this.affectedKeys.forEach(p=>c.setValue(p,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,n=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!C.equals(o,n)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let s=(0,i.toValuesTree)({[r]:!0},()=>{}),o;for(;typeof s=="object"&&(o=Object.keys(s)[0]);){if(t=t[o],!t)return!1;s=s[o]}return!0}}e.ConfigurationChangeEvent=d;class u extends d{constructor(t,r,s,o){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=s,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=u}),define(me[112],pe([0,1,4]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,_.createDecorator)("remoteAuthorityResolverService");var D;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends Error{constructor(C,P=D.Unknown,y){super(C);this._message=C,this._code=P,this._detail=y,this.isHandled=P===D.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(C){return C instanceof R&&C._code===D.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof R&&C._code===D.NoResolverFound}static isHandled(C){return C instanceof R&&C.isHandled}}e.RemoteAuthorityResolverError=R}),define(me[113],pe([0,1,11]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function D(I){return I.scheme===_.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=D;function R(I){if(!!I){const C=I.indexOf("+");return C<0?I:I.substr(0,C)}}e.getRemoteName=R}),define(me[186],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class _{vsda(){return new Promise((R,I)=>Z(["vsda"],R,I))}async sign(R){try{const I=await this.vsda(),C=new I.signer;if(C)return C.sign(R)}catch(I){}return R}}e.SignService=_}),define(me[187],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class _{constructor(R){this._callback=R,this._terminalBufferMap=new Map}dispose(){for(const R of this._terminalBufferMap.values())R.dispose()}startBuffering(R,I,C=5){let P;return P=I(y=>{const i=typeof y=="string"?y:y.data;let T=this._terminalBufferMap.get(R);if(T){T.data.push(i);return}const k=setTimeout(()=>this._flushBuffer(R),C);T={data:[i],timeoutId:k,dispose:()=>{clearTimeout(k),this._flushBuffer(R),P.dispose()}},this._terminalBufferMap.set(R,T)}),P}stopBuffering(R){const I=this._terminalBufferMap.get(R);I&&I.dispose()}_flushBuffer(R){const I=this._terminalBufferMap.get(R);I&&(this._terminalBufferMap.delete(R),this._callback(R,I.data.join("")))}}e.TerminalDataBufferer=_}),define(me[188],pe([0,1,43,7,25,15,24,10]),function(Z,e,_,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function y(){const T=/(\d+)\.(\d+)\.(\d+)/g.exec(_.release());let k=0;return T&&T.length===4&&(k=parseInt(T[3])),k}e.getWindowsBuildNumber=y;async function i(T,k,w,f=process.env){if(D.isAbsolute(T))return await(0,R.exists)(T)?T:void 0;if(k===void 0&&(k=process.cwd()),D.dirname(T)!=="."){const g=D.join(k,T);return await(0,R.exists)(g)?g:void 0}const m=(0,C.getCaseInsensitive)(f,"PATH");if(w===void 0&&(0,I.isString)(m)&&(w=m.split(D.delimiter)),w===void 0||w.length===0){const g=D.join(k,T);return await(0,R.exists)(g)?g:void 0}for(let g of w){let b;if(D.isAbsolute(g)?b=D.join(g,T):b=D.join(k,g,T),await(0,R.exists)(b))return b;if(P.isWindows){let d=b+".com";if(await(0,R.exists)(d)||(d=b+".exe",await(0,R.exists)(d)))return d}}const S=D.join(k,T);return await(0,R.exists)(S)?S:void 0}e.findExecutable=i}),define(me[189],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var _;(function(D){D.DARK="dark",D.LIGHT="light",D.HIGH_CONTRAST="hc"})(_=e.ColorScheme||(e.ColorScheme={}))}),define(me[190],pe([0,1,4,6,40,3,189,47]),function(Z,e,_,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,_.createDecorator)("themeService");var y;(function(S){function g(b){return b&&typeof b=="object"&&typeof b.id=="string"}S.isThemeColor=g})(y=e.ThemeColor||(e.ThemeColor={}));function i(S){return{id:S}}e.themeColorFromId=i;var T;(function(S){function g(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||y.isThemeColor(t.color))}S.isThemeIcon=g;const b=new RegExp(`^\\$\\((${P.CSSIcon.iconNameExpression}(?:${P.CSSIcon.iconModifierExpression})?)\\)$`);function d(t){const r=b.exec(t);if(!!r){let[,s]=r;return{id:s}}}S.fromString=d;function u(t,r){let s=t.id;const o=s.lastIndexOf("~");return o!==-1&&(s=s.substring(0,o)),r&&(s=`${s}~${r}`),{id:s}}S.modify=u;function a(t,r){var s,o;return t.id===r.id&&((s=t.color)===null||s===void 0?void 0:s.id)===((o=r.color)===null||o===void 0?void 0:o.id)}S.isEqual=a,S.asClassNameArray=P.CSSIcon.asClassNameArray,S.asClassName=P.CSSIcon.asClassName,S.asCSSSelector=P.CSSIcon.asCSSSelector})(T=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=P.Codicon.file,e.FolderThemeIcon=P.Codicon.folder;function k(S){switch(S){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class w{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new I.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,D.toDisposable)(()=>{const b=this.themingParticipants.indexOf(g);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new w;R.Registry.add(e.Extensions.ThemingContribution,f);function l(S){return f.onColorThemeChange(S)}e.registerThemingParticipant=l;class m extends D.Disposable{constructor(g){super();this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,b){let d=this.theme.getColor(g);return d&&b&&(d=b(d,this.theme)),d?d.toString():null}}e.Themable=m}),define(me[191],pe([0,1,40,190,3,154,111,19,47]),function(Z,e,_,D,R,I,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class i{constructor(){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,I.localize)(0,null)},fontCharacter:{type:"string",description:(0,I.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(g,b,d,u){const a=this.iconsById[g];if(a){if(d&&!a.description){a.description=d,this.iconSchema.properties[g].markdownDescription=`${d} $(${g})`;const s=this.iconReferenceSchema.enum.indexOf(g);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=d),this._onDidChange.fire()}return a}let t={id:g,description:d,defaults:b,deprecationMessage:u};this.iconsById[g]=t;let r={$ref:"#/definitions/icons"};return u&&(r.deprecationMessage=u),d&&(r.markdownDescription=`${d}: $(${g})`),this.iconSchema.properties[g]=r,this.iconReferenceSchema.enum.push(g),this.iconReferenceSchema.enumDescriptions.push(d||""),this._onDidChange.fire(),{id:g}}deregisterIcon(g){delete this.iconsById[g],delete this.iconSchema.properties[g];const b=this.iconReferenceSchema.enum.indexOf(g);b!==-1&&(this.iconReferenceSchema.enum.splice(b,1),this.iconReferenceSchema.enumDescriptions.splice(b,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(g=>this.iconsById[g])}getIcon(g){return this.iconsById[g]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(g,b){const d=this.iconFontsById[g];if(d)return d;let u={id:g,definition:b};return this.iconFontsById[g]=u,this._onDidChange.fire(),u}deregisterIconFont(g){delete this.iconFontsById[g]}getIconFonts(){return Object.keys(this.iconFontsById).map(g=>this.iconFontsById[g])}getIconFont(g){return this.iconFontsById[g]}toString(){const g=(a,t)=>a.id.localeCompare(t.id),b=a=>{for(;D.ThemeIcon.isThemeIcon(a.defaults);)a=this.iconsById[a.defaults.id];return`codicon codicon-${a?a.id:""}`};let d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.iconsById).map(a=>this.iconsById[a]);for(const a of u.filter(t=>!!t.description).sort(g))d.push(`|<i class="${b(a)}"></i>|${a.id}|${D.ThemeIcon.isThemeIcon(a.defaults)?a.defaults.id:a.id}|${a.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const a of u.filter(t=>!D.ThemeIcon.isThemeIcon(t.defaults)).sort(g))d.push(`|<i class="${b(a)}"></i>|${a.id}|`);return d.join(`
`)}}const T=new i;_.Registry.add(e.Extensions.IconContribution,T);function k(S,g,b,d){return T.registerIcon(S,g,b,d)}e.registerIcon=k;function w(){return T}e.getIconRegistry=w;function f(){for(const S of y.iconRegistry.all)T.registerIcon(S.id,S.definition,S.description);y.iconRegistry.onDidRegister(S=>T.registerIcon(S.id,S.definition,S.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let l=_.Registry.as(C.Extensions.JSONContribution);l.registerSchema(e.iconsSchemaId,T.getIconSchema());const m=new P.RunOnceScheduler(()=>l.notifySchemaChanged(e.iconsSchemaId),200);T.onDidChange(()=>{m.isScheduled()||m.schedule()}),e.widgetClose=k("widget-close",y.Codicon.close,(0,I.localize)(2,null)),e.gotoPreviousLocation=k("goto-previous-location",y.Codicon.arrowUp,(0,I.localize)(3,null)),e.gotoNextLocation=k("goto-next-location",y.Codicon.arrowDown,(0,I.localize)(4,null)),e.syncing=D.ThemeIcon.modify(y.Codicon.sync,"spin")}),define(me[61],pe([0,1,2,23,4,22]),function(Z,e,_,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");var C;(function(w){w[w.EMPTY=1]="EMPTY",w[w.FOLDER=2]="FOLDER",w[w.WORKSPACE=3]="WORKSPACE"})(C=e.WorkbenchState||(e.WorkbenchState={}));function P(w){const f=w;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=P;function y(w){const f=w;return!!(f&&typeof f=="object"&&_.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=y;class i{constructor(f,l,m,S){this._id=f,this._configuration=m,this._ignorePathCasing=S,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=l}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=i;class T{constructor(f,l){this.raw=l,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,D.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=T;function k(w){return new T({uri:w,index:0,name:(0,D.basenameOrAuthority)(w)},{uri:w.toString()})}e.toWorkspaceFolder=k}),define(me[114],pe([0,1,4,155,61,2,10,7,23,130,56,11,77,30,113]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(j){return(typeof j=="string"?(0,P.extname)(j):(0,y.extname)(j))===m}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=(0,_.createDecorator)("workspacesService");function g(j){return j.hasOwnProperty("workspace")}e.isRecentWorkspace=g;function b(j){return j.hasOwnProperty("folderUri")}e.isRecentFolder=b;function d(j){return j.hasOwnProperty("fileUri")}e.isRecentFile=d;function u(j){const G=j;return typeof(G==null?void 0:G.id)=="string"&&I.URI.isUri(G.uri)}e.isSingleFolderWorkspaceIdentifier=u;function a(j){if(j.configuration)return{id:j.id,configPath:j.configuration};if(j.folders.length===1)return{id:j.id,uri:j.folders[0].uri}}e.toWorkspaceIdentifier=a;function t(j){const G=j;return typeof(G==null?void 0:G.id)=="string"&&I.URI.isUri(G.configPath)}e.isWorkspaceIdentifier=t;function r(j){const G=j;if(G==null?void 0:G.uri)return{id:G.id,uri:I.URI.revive(G.uri)};const B=j;if(B==null?void 0:B.configPath)return{id:B.id,configPath:I.URI.revive(B.configPath)};if(j==null?void 0:j.id)return{id:j.id}}e.reviveIdentifier=r;function s(j,G){return y.extUriBiasedIgnorePathCase.isEqualOrParent(j,G.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function o(j){return n(j)||c(j)}e.isStoredWorkspaceFolder=o;function n(j){const G=j;return typeof(G==null?void 0:G.path)=="string"&&(!G.name||typeof G.name=="string")}e.isRawFileWorkspaceFolder=n;function c(j){const G=j;return typeof(G==null?void 0:G.uri)=="string"&&(!G.name||typeof G.name=="string")}e.isRawUriWorkspaceFolder=c;function p(j,G,B,J,O=!C.isWindows,N){if(j.scheme!==J.scheme)return{name:B,uri:j.toString(!0)};let U=G?void 0:N.relativePath(J,j);if(U!==void 0)U.length===0?U=".":C.isWindows&&j.scheme===k.Schemas.file&&!O&&(U=U.replace(/\//g,"\\"));else if(j.scheme===k.Schemas.file)U=j.fsPath,C.isWindows&&(U=(0,w.normalizeDriveLetter)(U),O&&(U=(0,f.toSlashes)(U)));else{if(!N.isEqualAuthority(j.authority,J.authority))return{name:B,uri:j.toString(!0)};U=j.path}return{name:B,path:U}}e.getStoredWorkspaceFolder=p;function E(j,G,B){let J=[],O=new Set;const N=B.dirname(G);for(let U of j){let L=null;if(n(U))U.path&&(L=B.resolvePath(N,U.path));else if(c(U))try{L=I.URI.parse(U.uri),L.path[0]!=="/"&&(L=L.with({path:"/"+L.path}))}catch(M){console.warn(M)}if(L){let M=B.getComparisonKey(L);if(!O.has(M)){O.add(M);const V=U.name||B.basenameOrAuthority(L);J.push(new R.WorkspaceFolder({uri:L,name:V,index:J.length},U))}}}return J}e.toWorkspaceFolders=E;function h(j,G,B,J,O){let N=v(G,j);const U=O.dirname(G),L=O.dirname(J),M=[],V=A(N.folders);for(const we of N.folders){const Te=n(we)?O.resolvePath(U,we.path):I.URI.parse(we.uri);let Ie;B?Ie=!1:Ie=!n(we)||(0,P.isAbsolute)(we.path),M.push(p(Te,Ie,we.name,L,V,O))}const K={insertSpaces:!1,tabSize:4,eol:C.isLinux||C.isMacintosh?`
`:`\r
`},se=i.setProperty(j,["folders"],M,K);let ce=i.applyEdits(j,se);return N.remoteAuthority===(0,l.getRemoteAuthority)(J)&&(ce=i.applyEdits(ce,i.removeProperty(ce,["remoteAuthority"],K))),ce}e.rewriteWorkspaceFileForNewLocation=h;function v(j,G){let B=T.parse(G);if(B&&Array.isArray(B.folders))B.folders=B.folders.filter(J=>o(J));else throw new Error(`${j} looks like an invalid workspace file.`);return B}function A(j){return C.isWindows?j.some(G=>n(G)&&G.path.indexOf("/")>=0):!0}e.useSlashForPath=A;function F(j,G){const B={workspaces:[],files:[]};if(j){const J=function(N,U){for(let L=0;L<N.length;L++)try{U(N[L],L)}catch(M){G.warn(`Error restoring recent entry ${JSON.stringify(N[L])}: ${M.toString()}. Skip entry.`)}},O=j;Array.isArray(O.workspaces3)&&J(O.workspaces3,(N,U)=>{const L=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[U]||void 0;typeof N=="object"&&typeof N.id=="string"&&typeof N.configURIPath=="string"?B.workspaces.push({label:L,workspace:{id:N.id,configPath:I.URI.parse(N.configURIPath)}}):typeof N=="string"&&B.workspaces.push({label:L,folderUri:I.URI.parse(N)})}),Array.isArray(O.files2)&&J(O.files2,(N,U)=>{const L=Array.isArray(O.fileLabels)&&O.fileLabels[U]||void 0;typeof N=="string"&&B.files.push({label:L,fileUri:I.URI.parse(N)})})}return B}e.restoreRecentlyOpened=F;function x(j){const G={workspaces3:[],files2:[]};let B=!1;const J=[];for(const N of j.workspaces)b(N)?G.workspaces3.push(N.folderUri.toString()):G.workspaces3.push({id:N.workspace.id,configURIPath:N.workspace.configPath.toString()}),J.push(N.label||null),B=B||!!N.label;B&&(G.workspaceLabels=J),B=!1;const O=[];for(const N of j.files)G.files2.push(N.fileUri.toString()),O.push(N.label||null),B=B||!!N.label;return B&&(G.fileLabels=O),G}e.toStoreData=x}),define(me[115],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class _{constructor(R){this.id=R,this._data=new Map,this._idPool=1}add(R){const I=this._idPool++;return this._data.set(I,R),this.logDebugInfo(),I}get(R,I){return this._data.has(R)?this._data.get(R)[I]:void 0}delete(R){this._data.delete(R),this.logDebugInfo()}logDebugInfo(){!_.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=_,_.enableDebugLogging=!1}),define(me[192],pe([0,1,2,3]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class R{constructor(){this._onDidChangeTabs=new D.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(C){this._tabs=C.map(P=>({name:P.name,group:P.group,resource:_.URI.revive(P.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=R}),define(me[62],pe([0,1,11,4]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this._systemSchemes=new Set(Object.keys(_.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(C,P){P===null?this._providerInfo.delete(C):this._providerInfo.set(C,P)}isFreeScheme(C){return!this._providerInfo.has(C)&&!this._systemSchemes.has(C)}getCapabilities(C){return this._providerInfo.get(C)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],pe([0,1,4]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,_.createDecorator)("IExtHostInitDataService")}),define(me[193],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class _{constructor(I,C,P){this._id=I,this._shared=C,this._storage=P,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)})}get whenReady(){return this._init}get(I,C){let P=this._value[I];return typeof P=="undefined"&&(P=C),P}update(I,C){return this._value[I]=C,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=_;class D extends _{constructor(I,C){super(I.identifier.value,!0,C);this._extension=I}setKeysForSync(I){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},I)}}e.ExtensionGlobalMemento=D}),define(me[13],pe([0,1,4]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,_.createDecorator)("IExtHostRpcService");class D{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.ExtHostRpcService=D});var tt=this&&this.__classPrivateFieldSet||function(Z,e,_){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,_),_},$e=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(me[194],pe([0,1,29,3]),function(Z,e,_,D){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class I{constructor(P,y){R.set(this,void 0),this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this._id=_.ExtensionIdentifier.toKey(P.identifier),tt(this,R,y),$e(this,R).onDidChangePassword(i=>{i.extensionId===this._id&&this._onDidChange.fire({key:i.key})})}get(P){return $e(this,R).get(this._id,P)}store(P,y){return $e(this,R).store(this._id,P,y)}delete(P){return $e(this,R).delete(this._id,P)}}e.ExtensionSecrets=I,R=new WeakMap}),define(me[116],pe([0,1,4,3]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class R{constructor(){this._onDidChangeTelemetryEnabled=new D.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(C){this._enabled=C}$onDidChangeTelemetryEnabled(C){this._enabled=C,this._onDidChangeTelemetryEnabled.fire(C)}}e.ExtHostTelemetry=R,e.IExtHostTelemetry=(0,_.createDecorator)("IExtHostTelemetry")});var Ve=this&&this.__decorate||function(Z,e,_,D){var R=arguments.length,I=R<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,_):D,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(Z,e,_,D);else for(var P=Z.length-1;P>=0;P--)(C=Z[P])&&(I=(R<3?C(I):R>3?C(e,_,I):C(e,_))||I);return R>3&&I&&Object.defineProperty(e,_,I),I},xe=this&&this.__param||function(Z,e){return function(_,D){e(_,D,Z)}};define(me[50],pe([0,1,4,3,13]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var I;(function(P){function y(T){return{remoteAddress:T.remoteAddress,localAddress:T.localAddress,public:!!T.public}}P.fromApiTunnel=y;function i(T){return{remoteAddress:{host:T.tunnelRemoteHost,port:T.tunnelRemotePort},localAddress:T.localAddress,public:T.public}}P.fromServiceTunnel=i})(I=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,_.createDecorator)("IExtHostTunnelService");let C=class{constructor(y){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,i){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}async $forwardPort(y,i){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};C=Ve([xe(0,R.IExtHostRpcService)],C),e.ExtHostTunnelService=C}),define(me[63],pe([0,1,4]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,_.createDecorator)("IURITransformerService");class D{constructor(I){I?(this.transformIncoming=I.transformIncoming.bind(I),this.transformOutgoing=I.transformOutgoing.bind(I),this.transformOutgoingURI=I.transformOutgoingURI.bind(I),this.transformOutgoingScheme=I.transformOutgoingScheme.bind(I)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=D}),define(me[85],pe([0,1,2]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function D(I,C,P){const y=I.webviewResourceRoot.replace("{{resource}}",P.scheme+R(P)).replace("{{uuid}}",C);return _.URI.parse(y)}e.asWebviewUri=D;function R(I){return I.toString().replace(/^\S+?:/,"")}}),define(me[195],pe([0,1,3,6,85,28]),function(Z,e,_,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(y,i,T){this._proxy=y,this._editors=i,this._initData=T,this._handlePool=0,this._disposables=new D.DisposableStore,this._insets=new Map,this._disposables.add(i.onDidChangeVisibleTextEditors(()=>{const k=i.getVisibleTextEditors();for(const w of this._insets.values())k.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,i,T,k,w){let f;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===y){f=u;break}if(!f)throw new Error("not a visible editor");const l=this,m=this._handlePool++,S=new _.Emitter,g=new _.Emitter,b=new class{constructor(){this._uuid=(0,I.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,R.asWebviewUri)(l._initData,this._uuid,u)}get cspSource(){return l._initData.webviewCspSource}set options(u){this._options=u,l._proxy.$setOptions(m,u)}get options(){return this._options}set html(u){this._html=u,l._proxy.$setHtml(m,u)}get html(){return this._html}get onDidReceiveMessage(){return S.event}postMessage(u){return l._proxy.$postMessage(m,u)}},d=new class{constructor(){this.editor=y,this.line=i,this.height=T,this.webview=b,this.onDidDispose=g.event}dispose(){l._insets.has(m)&&(l._insets.delete(m),l._proxy.$disposeEditorInset(m),g.fire(),g.dispose(),S.dispose())}};return this._proxy.$createEditorInset(m,f.id,f.value.document.uri,i+1,T,k||{},w.identifier,w.extensionLocation),this._insets.set(m,{editor:y,inset:d,onDidReceiveMessage:S}),d}$onDidDispose(y){const i=this._insets.get(y);i&&i.inset.dispose()}$onDidReceiveMessage(y,i){const T=this._insets.get(y);T&&T.onDidReceiveMessage.fire(i)}}e.ExtHostEditorInsets=C}),define(me[196],pe([0,1,3,60,166,4,6,22,40,14,54,24,47,191]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",w.Codicon.window,(0,R.localize)(0,null));var l;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(l=e.Extensions||(e.Extensions={}));var m;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel"})(m=e.ViewContainerLocation||(e.ViewContainerLocation={}));function S(n){switch(n){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=S;function g(n){return`viewContainer.${n}.enabled`}e.getEnabledViewContainerContextKey=g;class b extends C.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new _.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new _.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,i.flatten)([...this.viewContainers.values()])}registerViewContainer(c,p,E){var h;const v=this.get(c.id);if(v)return v;const A=c;return A.openCommandActionDescriptor=(E==null?void 0:E.donotRegisterOpenCommand)?void 0:(h=A.openCommandActionDescriptor)!==null&&h!==void 0?h:{id:A.id},(0,P.getOrSet)(this.viewContainers,p,[]).push(A),(E==null?void 0:E.isDefault)&&this.defaultViewContainers.push(A),this._onDidRegister.fire({viewContainer:A,viewContainerLocation:p}),A}deregisterViewContainer(c){for(const p of this.viewContainers.keys()){const E=this.viewContainers.get(p),h=E==null?void 0:E.indexOf(c);if(h!==-1){E==null||E.splice(h,1),E.length===0&&this.viewContainers.delete(p),this._onDidDeregister.fire({viewContainer:c,viewContainerLocation:p});return}}}get(c){return this.all.filter(p=>p.id===c)[0]}getViewContainers(c){return[...this.viewContainers.get(c)||[]]}getViewContainerLocation(c){return[...this.viewContainers.keys()].filter(p=>this.getViewContainers(p).filter(E=>(E==null?void 0:E.id)===c.id).length>0)[0]}getDefaultViewContainer(c){return this.defaultViewContainers.find(p=>this.getViewContainerLocation(p)===c)}}y.Registry.add(l.ViewContainersRegistry,new b);var d;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(d=e.ViewContentGroups||(e.ViewContentGroups={}));function u(n,c){var p,E,h,v;const A=(p=n.group)!==null&&p!==void 0?p:d.More,F=(E=c.group)!==null&&E!==void 0?E:d.More;return A!==F?A.localeCompare(F):((h=n.order)!==null&&h!==void 0?h:5)-((v=c.order)!==null&&v!==void 0?v:5)}class a extends C.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new _.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new _.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new _.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new _.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new T.SetMap}registerViews(c,p){this.registerViews2([{views:c,viewContainer:p}])}registerViews2(c){c.forEach(({views:p,viewContainer:E})=>this.addViews(p,E)),this._onViewsRegistered.fire(c)}deregisterViews(c,p){const E=this.removeViews(c,p);E.length&&this._onViewsDeregistered.fire({views:E,viewContainer:p})}moveViews(c,p){for(const E of this._views.keys())if(E!==p){const h=this.removeViews(c,E);h.length&&(this.addViews(h,p),this._onDidChangeContainer.fire({views:h,from:E,to:p}))}}getViews(c){return this._views.get(c)||[]}getView(c){for(const p of this._viewContainers){const E=(this._views.get(p)||[]).filter(h=>h.id===c)[0];if(E)return E}return null}getViewContainer(c){for(const p of this._viewContainers)if((this._views.get(p)||[]).filter(h=>h.id===c)[0])return p;return null}registerViewWelcomeContent(c,p){return this._viewWelcomeContents.add(c,p),this._onDidChangeViewWelcomeContent.fire(c),(0,C.toDisposable)(()=>{this._viewWelcomeContents.delete(c,p),this._onDidChangeViewWelcomeContent.fire(c)})}registerViewWelcomeContent2(c,p){const E=new Map;for(const[h,v]of p)this._viewWelcomeContents.add(c,v),E.set(h,(0,C.toDisposable)(()=>{this._viewWelcomeContents.delete(c,v),this._onDidChangeViewWelcomeContent.fire(c)}));return this._onDidChangeViewWelcomeContent.fire(c),E}getViewWelcomeContent(c){const p=[];return this._viewWelcomeContents.forEach(c,E=>p.push(E)),p.sort(u)}addViews(c,p){let E=this._views.get(p);E||(E=[],this._views.set(p,E),this._viewContainers.push(p));for(const h of c){if(this.getView(h.id)!==null)throw new Error((0,R.localize)(1,null,h.id));E.push(h)}}removeViews(c,p){const E=this._views.get(p);if(!E)return[];const h=[],v=[];for(const A of E)c.includes(A)?h.push(A):v.push(A);return h.length&&(v.length?this._views.set(p,v):(this._views.delete(p),this._viewContainers.splice(this._viewContainers.indexOf(p),1))),h}}y.Registry.add(l.ViewsRegistry,new a),e.IViewsService=(0,I.createDecorator)("viewsService"),e.FocusedViewContext=new D.RawContextKey("focusedView","",(0,R.localize)(2,null));function t(n){return`view.${n}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,I.createDecorator)("viewDescriptorService");var r;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(r=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class o{constructor(c,p){this.resolved=!1,this._hasResolve=!1,(0,k.mixin)(this,c),this._hasResolve=!!p,this.resolve=async E=>{var h,v;if(p&&!this.resolved){const A=await p(E);A&&(this.tooltip=(h=this.tooltip)!==null&&h!==void 0?h:A.tooltip,this.command=(v=this.command)!==null&&v!==void 0?v:A.command)}E.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=o}),define(me[197],pe([0,1,2,178,114,12,179,196]),function(Z,e,_,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function y(m){return(S,...g)=>m(S.get(D.ICommandService),...g)}class i{static execute(S,g){const b={forceReuseWindow:g&&g.reuseWindow,remoteAuthority:g&&g.remoteAuthority};return S.executeCommand("_files.newWindow",b)}}e.NewWindowAPICommand=i,i.ID="vscode.newWindow",D.CommandsRegistry.registerCommand({id:i.ID,handler:y(i.execute),description:{description:"Opens an new window",args:[]}}),D.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(m,S){return m.get(R.IWorkspacesService).removeRecentlyOpened([S])});class T{static execute(S,g){return typeof g=="string"?g=g.match(/^[^:/?#]+:\/\//)?_.URI.parse(g):_.URI.file(g):g=_.URI.revive(g),S.executeCommand("_workbench.removeFromRecentlyOpened",g)}}e.RemoveFromRecentlyOpenedAPICommand=T,T.ID="vscode.removeFromRecentlyOpened",D.CommandsRegistry.registerCommand(T.ID,y(T.execute));class k{static execute(S,g){const b=typeof g=="string"?{extensionId:g}:g;return S.executeCommand("workbench.action.openIssueReporter",b)}}e.OpenIssueReporter=k,k.ID="vscode.openIssueReporter",D.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(m,S){const g=m.get(R.IWorkspacesService);let b;const d=S.uri,u=S.label;return S.type==="workspace"?b={workspace:await g.getWorkspaceIdentifier(d),label:u}:S.type==="folder"?b={folderUri:d,label:u}:b={fileUri:d,label:u},g.addRecentlyOpened([b])}),D.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(m){return m.get(R.IWorkspacesService).getRecentlyOpened()}),D.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(m,S){const g=m.get(I.ILogService),b=m.get(C.IEnvironmentService);b.isExtensionDevelopment&&!!b.extensionTestsLocationURI&&g.setLevel(S)}),D.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(m){return m.get(I.ILogService).getLevel()}),D.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(m,S){const g=m.get(P.IViewDescriptorService),b=g.getViewContainerById(S.destinationId);if(!!b){for(const d of S.viewIds){const u=g.getViewDescriptorById(d);(u==null?void 0:u.canMoveView)&&g.moveViewsToContainer([u],b,P.ViewVisibilityState.Default)}await m.get(P.IViewsService).openViewContainer(b.id,!0)}});class w{static execute(S,g){return!Array.isArray(g==null?void 0:g.viewIds)||typeof(g==null?void 0:g.destinationId)!="string"?Promise.reject("Invalid arguments"):S.executeCommand("_workbench.action.moveViews",g)}}e.MoveViewsAPICommand=w,w.ID="vscode.moveViews",D.CommandsRegistry.registerCommand({id:w.ID,handler:y(w.execute),description:{description:"Move Views",args:[]}});class f{static execute(S,g){return S.executeCommand("_workbench.open",g)}}f.ID="vscode.open",D.CommandsRegistry.registerCommand(f.ID,y(f.execute));class l{static execute(S,g,b,d,u){return S.executeCommand("_workbench.diff",[g,b,d])}}l.ID="vscode.diff",D.CommandsRegistry.registerCommand(l.ID,y(l.execute))}),define(me[117],pe([0,1,3,19,167]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class I{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new _.Emitter,this._onExit=new _.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,y,i,T){const k={command:P};if(y&&Object.keys(y).length>0&&(k.arguments=y),this.internalSend("request",k),typeof T=="number"){const w=setTimeout(()=>{clearTimeout(w);const f=this.pendingRequests.get(k.seq);if(f){this.pendingRequests.delete(k.seq);const l={type:"response",seq:0,request_seq:k.seq,success:!1,command:P,message:(0,R.localize)(0,null,T,P)};f(l)}},T)}return i&&this.pendingRequests.set(k.seq,i),k.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,y){return P.type!=="event"||y.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,D.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":const y=P,i=this.pendingRequests.get(y.request_seq);i&&(this.pendingRequests.delete(y.request_seq),i(y));break}}}internalSend(P,y){y.type=P,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((y,i)=>P.set(i,y)),await(0,D.timeout)(500),P.forEach((y,i)=>{y({type:"response",seq:0,request_seq:i,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(i)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=I}),define(me[198],pe([0,1,9,2,7,24,11]),function(Z,e,_,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function y(r,s,o){return r.replace(P,function(n,c){return s&&c.length>0&&c[0]!=="_"?n:o&&o.hasOwnProperty(c)?o[c]:n})}e.formatPII=y;function i(r){const s={};for(const o of Object.keys(r))o.startsWith("!")||(s[o]=r[o]);return s}e.filterExceptionsFromTelemetry=i;function T(r){return r.configuration.request==="attach"&&!k(r)}e.isSessionAttach=T;function k(r){let s=r.configuration.type;if(!!s)return s==="vslsShare"&&(s=r.configuration.adapterProxy.configuration.type),(0,_.equalsIgnoreCase)(s,"extensionhost")||(0,_.equalsIgnoreCase)(s,"pwa-extensionhost")?r:r.parentSession?k(r.parentSession):void 0}e.getExtensionHostDebugSession=k;function w(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=w;function f(r,s,o){let n,c=0,p=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,E=null;for(;E=p.exec(r);){let h=E.index+1,v=h+E[0].length;if(h<=s&&v>=o){n=E[0],c=h;break}}if(n){let h=/\w+/g,v=null;for(;(v=h.exec(n))&&!(v.index+1+c+v[0].length>=o););v&&(n=n.substring(0,h.lastIndex))}return n?{start:c,end:c+n.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function m(r){return!!(r&&r.match(l))}e.isUri=m;function S(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(m(r.path))return D.URI.parse(r.path);if((0,R.isAbsolute)(r.path))return D.URI.file(r.path)}return r.path}function g(r){if(typeof r.path=="object"){const s=D.URI.revive(r.path);if(s)return s.scheme===C.Schemas.file?s.fsPath:s.toString()}return r.path}function b(r,s){const o=s?S:g,n=(0,I.deepClone)(r);return u(n,(c,p)=>{c&&p&&(p.path=o(p))}),n}e.convertToDAPaths=b;function d(r,s){const o=s?S:g,n=(0,I.deepClone)(r);return u(n,(c,p)=>{!c&&p&&(p.path=o(p))}),n}e.convertToVSCPaths=d;function u(r,s){switch(r.type){case"event":const o=r;switch(o.event){case"output":s(!1,o.body.source);break;case"loadedSource":s(!1,o.body.source);break;case"breakpoint":s(!1,o.body.breakpoint.source);break;default:break}break;case"request":const n=r;switch(n.command){case"setBreakpoints":s(!0,n.arguments.source);break;case"breakpointLocations":s(!0,n.arguments.source);break;case"source":s(!0,n.arguments.source);break;case"gotoTargets":s(!0,n.arguments.source);break;case"launchVSCode":n.arguments.args.forEach(p=>s(!1,p));break;default:break}break;case"response":const c=r;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(p=>s(!1,p.source));break;case"loadedSources":c.body.sources.forEach(p=>s(!1,p));break;case"scopes":c.body.scopes.forEach(p=>s(!1,p.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(p=>s(!1,p.source));break;case"setBreakpoints":c.body.breakpoints.forEach(p=>s(!1,p.source));break;default:break}break}}function a(r){return r.filter(s=>{var o;return!((o=s.presentation)===null||o===void 0?void 0:o.hidden)}).sort((s,o)=>s.presentation?o.presentation?s.presentation.group?o.presentation.group?s.presentation.group!==o.presentation.group?s.presentation.group.localeCompare(o.presentation.group):t(s.presentation.order,o.presentation.order):-1:o.presentation.group?1:t(s.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.getVisibleAndSorted=a;function t(r,s){return typeof r!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:r-s}}),define(me[199],pe([0,1,25,38,168,118,7,9,24,10,180,117]),function(Z,e,_,D,R,I,C,P,y,i,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class w extends k.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,d){this.outputStream=d,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",u=>this.handleData(u))}sendMessage(b){if(this.outputStream){const d=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(d,"utf8")}${w.TWO_CRLF}${d}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const d=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,d.length>0)try{this.acceptMessage(JSON.parse(d))}catch(u){this._onError.fire(new Error((u.message||u)+`
`+d))}continue}}else{const d=this.rawData.indexOf(w.TWO_CRLF);if(d!==-1){const a=this.rawData.toString("utf8",0,d).split(w.HEADER_LINESEPARATOR);for(const t of a){const r=t.split(w.HEADER_FIELDSEPARATOR);r[0]==="Content-Length"&&(this.contentLength=Number(r[1]))}this.rawData=this.rawData.slice(d+w.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=w,w.TWO_CRLF=`\r
\r
`,w.HEADER_LINESEPARATOR=/\r?\n/,w.HEADER_FIELDSEPARATOR=/: */;class f extends w{startSession(){return new Promise((b,d)=>{let u=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),u=!0}),this.socket.on("close",()=>{u?this._onError.fire(new Error("connection closed")):d(new Error("connection closed"))}),this.socket.on("error",a=>{u?this._onError.fire(a):d(a)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=f;class l extends f{constructor(b){super();this.adapterServer=b}createConnection(b){return I.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=l;class m extends f{constructor(b){super();this.adapterServer=b}createConnection(b){return I.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=m;class S extends w{constructor(b,d,u){super();this.adapterExecutable=b,this.debugType=d,this.outputService=u}async startSession(){const b=this.adapterExecutable.command,d=this.adapterExecutable.args,u=this.adapterExecutable.options||{};try{if(b)if(C.isAbsolute(b)){if(!await(0,_.exists)(b))throw new Error(R.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(R.localize(1,null,this.debugType));let a=process.env;if(u.env&&Object.keys(u.env).length>0&&(a=y.mixin(y.deepClone(process.env),u.env)),b==="node")if(Array.isArray(d)&&d.length>0){const r=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:a,execArgv:r?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};u.cwd&&(s.cwd=u.cwd);const o=D.fork(d[0],d.slice(1),s);if(!o.pid)throw new Error(R.localize(2,null,d[0]));this.serverProcess=o}else throw new Error(R.localize(3,null));else{const r={env:a};u.cwd&&(r.cwd=u.cwd),this.serverProcess=D.spawn(b,d,r)}this.serverProcess.on("error",r=>{this._onError.fire(r)}),this.serverProcess.on("exit",(r,s)=>{this._onExit.fire(r)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",r=>{this._onError.fire(r)}),this.serverProcess.stdin.on("error",r=>{this._onError.fire(r)});const t=this.outputService;if(t){const r=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const o=t.getChannel(T.ExtensionsChannelId);o&&o.append(r(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(a){this._onError.fire(a)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),i.isWindows?new Promise((b,d)=>{const u=D.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(a,t,r){if(a)return d(a)});u.on("exit",b),u.on("error",d)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,d){if(!!b){const u=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?u.runtime=C.join(d,b.runtime):u.runtime=b.runtime),b.runtimeArgs&&(u.runtimeArgs=b.runtimeArgs),b.program&&(C.isAbsolute(b.program)?u.program=b.program:u.program=C.join(d,b.program)),b.args&&(u.args=b.args);const a=b;return a.win&&(u.win=S.extract(a.win,d)),a.winx86&&(u.winx86=S.extract(a.winx86,d)),a.windows&&(u.windows=S.extract(a.windows,d)),a.osx&&(u.osx=S.extract(a.osx,d)),a.linux&&(u.linux=S.extract(a.linux,d)),u}}static platformAdapterExecutable(b,d){let u=Object.create(null);d=d.toLowerCase();for(const n of b)if(n.contributes){const c=n.contributes.debuggers;c&&c.length>0&&c.filter(p=>typeof p.type=="string"&&P.equalsIgnoreCase(p.type,d)).forEach(p=>{const E=S.extract(p,n.extensionLocation.fsPath);u=y.mixin(u,E,n.isBuiltin)})}let a;i.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?a=u.winx86||u.win||u.windows:i.isWindows?a=u.win||u.windows:i.isMacintosh?a=u.osx:i.isLinux&&(a=u.linux),a=a||u;let t=a.program||u.program;const r=a.args||u.args;let s=a.runtime||u.runtime;const o=a.runtimeArgs||u.runtimeArgs;if(s)return{type:"executable",command:s,args:(o||[]).concat(typeof t=="string"?[t]:[]).concat(r||[])};if(t)return{type:"executable",command:t,args:r||[]}}}e.ExecutableDebugAdapter=S}),define(me[200],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=void 0,e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(me[201],pe([0,1,38,7,79,169,25,10,84,4,200,11]),function(Z,e,_,D,R,I,C,P,y,i,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const w=I.localize(0,null);let f=class Mt{constructor(d){this._configurationService=d}openTerminal(d){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(_,u,R.getWindowsShell(),d)}}runInTerminal(d,u,a,t,r){const s=r.windowsExec||Mt.getDefaultTerminalWindows();return new Promise((o,n)=>{const c=`"${u} - ${w}"`,p=`""${a.join('" "')}" & pause"`,E=["/c","start",c,"/wait",s,"/c",p],h=Object.assign({},process.env,t);Object.keys(h).filter(F=>h[F]===null).forEach(F=>delete h[F]);const v={cwd:u,env:h,windowsVerbatimArguments:!0};_.spawn(Mt.CMD,E,v).on("error",F=>{n(S(F))}),o(void 0)})}spawnTerminal(d,u,a,t){const s=u.terminal.external.windowsExec||Mt.getDefaultTerminalWindows();t&&t[1]===":"&&(t=t[0].toUpperCase()+t.substr(1));const o=D.basename(s).toLowerCase();if(o==="cmder"||o==="cmder.exe")return d.spawn(s,t?[t]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return s.indexOf(" ")>=0&&n.push('""'),n.push(s),(o==="wt"||o==="wt.exe")&&n.push("-d ."),new Promise((c,p)=>{const E=t?{cwd:t}:void 0,h=d.spawn(a,n,E);h.on("error",p),h.on("exit",()=>c())})}static getDefaultTerminalWindows(){if(!Mt._DEFAULT_TERMINAL_WINDOWS){const d=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");Mt._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${d?"Sysnative":"System32"}\\cmd.exe`}return Mt._DEFAULT_TERMINAL_WINDOWS}};f.CMD="cmd.exe",f=Ve([xe(0,(0,i.optional)(y.IConfigurationService))],f),e.WindowsExternalTerminalService=f;let l=class Tn{constructor(d){this._configurationService=d}openTerminal(d){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(_,u,d)}}runInTerminal(d,u,a,t,r){const s=r.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((o,n)=>{if(s===T.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const c=s===T.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",E=[k.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,Z).fsPath,"-t",d||w,"-w",u];for(let A of a)E.push("-a"),E.push(A);if(t)for(let A in t){const F=t[A];F===null?(E.push("-u"),E.push(A)):(E.push("-e"),E.push(`${A}=${F}`))}let h="";const v=_.spawn(Tn.OSASCRIPT,E);v.on("error",A=>{n(S(A))}),v.stderr.on("data",A=>{h+=A.toString()}),v.on("exit",A=>{if(A===0)o(void 0);else if(h){const F=h.split(`
`,1);n(new Error(F[0]))}else n(new Error(I.localize(1,null,c,A)))})}else n(new Error(I.localize(2,null,s)))})}spawnTerminal(d,u,a){const r=u.terminal.external.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((s,o)=>{const n=["-a",r];a&&n.push(a);const c=d.spawn("/usr/bin/open",n);c.on("error",o),c.on("exit",()=>s())})}};l.OSASCRIPT="/usr/bin/osascript",l=Ve([xe(0,(0,i.optional)(y.IConfigurationService))],l),e.MacExternalTerminalService=l;let m=class Nt{constructor(d){this._configurationService=d}openTerminal(d){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(_,u,d)}}runInTerminal(d,u,a,t,r){const s=r.linuxExec?Promise.resolve(r.linuxExec):Nt.getDefaultTerminalLinuxReady();return new Promise((o,n)=>{let c=[];s.then(p=>{p.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const E=`${g(a)}; echo; read -p "${Nt.WAIT_MESSAGE}" -n1;`;c.push(`''${E}''`);const h=Object.assign({},process.env,t);Object.keys(h).filter(x=>h[x]===null).forEach(x=>delete h[x]);const v={cwd:u,env:h};let A="";const F=_.spawn(p,c,v);F.on("error",x=>{n(S(x))}),F.stderr.on("data",x=>{A+=x.toString()}),F.on("exit",x=>{if(x===0)o(void 0);else if(A){const j=A.split(`
`,1);n(new Error(j[0]))}else n(new Error(I.localize(4,null,p,x)))})})})}spawnTerminal(d,u,a){const t=u.terminal.external,r=t.linuxExec?Promise.resolve(t.linuxExec):Nt.getDefaultTerminalLinuxReady();return new Promise((s,o)=>{r.then(n=>{const c=a?{cwd:a}:void 0,p=d.spawn(n,[],c);p.on("error",o),p.on("exit",()=>s())})})}static async getDefaultTerminalLinuxReady(){return Nt._DEFAULT_TERMINAL_LINUX_READY||(Nt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async d=>{P.isLinux?await C.exists("/etc/debian_version")?d("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?d("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?d("konsole"):process.env.COLORTERM?d(process.env.COLORTERM):process.env.TERM?d(process.env.TERM):d("xterm"):d("xterm")})),Nt._DEFAULT_TERMINAL_LINUX_READY}};m.WAIT_MESSAGE=I.localize(3,null),m=Ve([xe(0,(0,i.optional)(y.IConfigurationService))],m),e.LinuxExternalTerminalService=m;function S(b){return"errno"in b&&b.errno==="ENOENT"&&"path"in b&&typeof b.path=="string"?new Error(I.localize(5,null,b.path)):b}function g(b){let d="";for(let u of b)u.indexOf(" ")>=0?d+='"'+u+'"':d+=u,d+=" ";return d}}),define(me[202],pe([0,1,38,10,201,30]),function(Z,e,_,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;let C;function P(w,f){if(!C)if(D.isWindows)C=new R.WindowsExternalTerminalService(void 0);else if(D.isMacintosh)C=new R.MacExternalTerminalService(void 0);else if(D.isLinux)C=new R.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const l=f.getConfiguration("terminal");return C.runInTerminal(w.title,w.cwd,w.args,w.env||{},l.external||{})}e.runInExternalTerminal=P;function y(w,f){return new Promise((l,m)=>{let S="";const g=_.spawn(w,f);g.pid&&g.stdout.on("data",b=>{S+=b.toString()}),g.on("error",b=>{m(b)}),g.on("close",b=>{l(S)})})}function i(w){return w?D.isWindows?y("wmic",["process","get","ParentProcessId"]).then(f=>f.split(`\r
`).some(m=>parseInt(m)===w),f=>!0):y("/usr/bin/pgrep",["-lP",String(w)]).then(f=>{const l=f.trim();return!(l.length===0||l.indexOf(" tmux")>=0)},f=>!0):Promise.resolve(!0)}e.hasChildProcesses=i;var T;(function(w){w[w.cmd=0]="cmd",w[w.powershell=1]="powershell",w[w.bash=2]="bash"})(T||(T={}));function k(w,f,l,m){w=w.trim().toLowerCase();let S;w.indexOf("powershell")>=0||w.indexOf("pwsh")>=0?S=1:w.indexOf("cmd.exe")>=0?S=0:w.indexOf("bash")>=0?S=2:D.isWindows?S=0:S=2;let g,b=" ";switch(S){case 1:if(g=u=>(u=u.replace(/\'/g,"''"),u.length>0&&u.charAt(u.length-1)==="\\"?`'${u}\\'`:`'${u}'`),l){const u=(0,I.getDriveLetter)(l);u&&(b+=`${u}:; `),b+=`cd ${g(l)}; `}if(m)for(let u in m){const a=m[u];a===null?b+=`Remove-Item env:${u}; `:b+=`\${env:${u}}='${a}'; `}if(f.length>0){const u=g(f.shift());b+=u[0]==="'"?`& ${u} `:`${u} `;for(let a of f)b+=`${g(a)} `}break;case 0:if(g=u=>(u=u.replace(/\"/g,'""'),u.indexOf(" ")>=0||u.indexOf('"')>=0||u.length===0?`"${u}"`:u),l){const u=(0,I.getDriveLetter)(l);u&&(b+=`${u}: && `),b+=`cd ${g(l)} && `}if(m){b+='cmd /C "';for(let u in m){let a=m[u];a===null?b+=`set "${u}=" && `:(a=a.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),b+=`set "${u}=${a}" && `)}}for(let u of f)b+=`${g(u)} `;m&&(b+='"');break;case 2:g=u=>(u=u.replace(/(["'\\\$])/g,"\\$1"),u.indexOf(" ")>=0||u.indexOf(";")>=0||u.length===0?`"${u}"`:u);const d=u=>/[^\w@%\/+=,.:^-]/.test(u)?`'${u.replace(/'/g,"'\\''")}'`:u;if(l&&(b+=`cd ${g(l)} ; `),m){b+="/usr/bin/env";for(let u in m){const a=m[u];a===null?b+=` -u ${d(u)}`:b+=` ${d(`${u}=${a}`)}`}b+=" "}for(let u of f)b+=`${g(u)} `;break}return b}e.prepareCommand=k}),define(me[51],pe([0,1,33,11,7,10,60]),function(Z,e,_,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookCellRunState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var P;(function(E){E[E.Markdown=1]="Markdown",E[E.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(E){E[E.Running=1]="Running",E[E.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={editable:!0,runnable:!0,cellEditable:!0,cellRunnable:!0,cellHasExecutionOrder:!0,custom:{},runState:y.Idle,trusted:!0};var i;(function(E){E[E.Running=1]="Running",E[E.Idle=2]="Idle",E[E.Success=3]="Success",E[E.Error=4]="Error"})(i=e.NotebookCellRunState||(e.NotebookCellRunState={}));var T;(function(E){E[E.ModelChange=1]="ModelChange",E[E.Move=2]="Move",E[E.CellClearOutput=3]="CellClearOutput",E[E.CellsClearOutput=4]="CellsClearOutput",E[E.ChangeLanguage=5]="ChangeLanguage",E[E.Initialize=6]="Initialize",E[E.ChangeCellMetadata=7]="ChangeCellMetadata",E[E.Output=8]="Output",E[E.OutputItem=9]="OutputItem",E[E.ChangeCellContent=10]="ChangeCellContent",E[E.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",E[E.Unknown=12]="Unknown"})(T=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var k;(function(E){E[E.Handle=0]="Handle",E[E.Index=1]="Index"})(k=e.SelectionStateType||(e.SelectionStateType={}));var w;(function(E){E[E.Replace=1]="Replace",E[E.Output=2]="Output",E[E.Metadata=3]="Metadata",E[E.CellLanguage=4]="CellLanguage",E[E.DocumentMetadata=5]="DocumentMetadata",E[E.OutputsSplice=6]="OutputsSplice",E[E.Move=7]="Move",E[E.Unknown=8]="Unknown",E[E.CellContent=9]="CellContent",E[E.OutputItems=10]="OutputItems"})(w=e.CellEditType||(e.CellEditType={}));function f(E){const h=l.parse(E);return h?h.notebook.toString():E.toString()}e.getCellUndoRedoComparisonKey=f;var l;(function(E){E.scheme=D.Schemas.vscodeNotebookCell;const h=/^ch(\d{7,})/;function v(j,G){return j.with({scheme:E.scheme,fragment:`ch${G.toString().padStart(7,"0")}${j.scheme!==D.Schemas.file?j.scheme:""}`})}E.generate=v;function A(j){if(j.scheme===E.scheme){const G=h.exec(j.fragment);if(!!G)return{handle:Number(G[1]),notebook:j.with({scheme:j.fragment.substr(G[0].length)||D.Schemas.file,fragment:null})}}}E.parse=A;function F(j,G){return j.with({scheme:D.Schemas.vscodeNotebookCellMetadata,fragment:`ch${G.toString().padStart(7,"0")}${j.scheme!==D.Schemas.file?j.scheme:""}`})}E.generateCellMetadataUri=F;function x(j){if(j.scheme===D.Schemas.vscodeNotebookCellMetadata){const G=h.exec(j.fragment);if(!!G)return{handle:Number(G[1]),notebook:j.with({scheme:j.fragment.substr(G[0].length)||D.Schemas.file,fragment:null})}}}E.parseCellMetadataUri=x})(l=e.CellUri||(e.CellUri={}));const m=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}]]);function S(E){var h,v;return(v=(h=m.get(E))===null||h===void 0?void 0:h.alwaysSecure)!==null&&v!==void 0?v:!1}e.mimeTypeIsAlwaysSecure=S;function g(E){var h,v;return(v=(h=m.get(E))===null||h===void 0?void 0:h.supportedByCore)!==null&&v!==void 0?v:!1}e.mimeTypeSupportedByCore=g;function b(E,h){return I.isWindows&&(E=E.replace(/\//g,"\\"),h=h.replace(/\//g,"\\")),_.match(E,h)}function d(E,h,v){let A=0;for(let F=0;F<h.length;F++){if(b(h[F],E))return A;A++}for(let F=0;F<v.length;F++){if(b(v[F],E))return A;A++}return A}function u(E,h,v){return E.sort((A,F)=>d(A,h,v)-d(F,h,v))}e.sortMimeTypes=u;function a(E,h,v,A=(F,x)=>F===x){const F=[];function x(B,J,O){if(!(J===0&&O.length===0)){const N=F[F.length-1];N&&N.start+N.deleteCount===B?(N.deleteCount+=J,N.toInsert.push(...O)):F.push({start:B,deleteCount:J,toInsert:O})}}let j=0,G=0;for(;;){if(j===E.length){x(j,0,h.slice(G));break}if(G===h.length){x(j,E.length-j,[]);break}const B=E[j],J=h[G];if(A(B,J)){j+=1,G+=1;continue}v(J)?(x(j,1,[]),j+=1):(x(j,0,[J]),G+=1)}return F}e.diff=a,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=new C.RawContextKey("notebookEditorCursorAtEditorBeginEnd",!1);var t;(function(E){E.default="default",E.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(E){const h=E;return!!((typeof h.include=="string"||_.isRelativePattern(h.include))&&(typeof h.exclude=="string"||_.isRelativePattern(h.exclude)))}e.isDocumentExcludePattern=r;function s(E,h,v){if(Array.isArray(E.viewType)&&E.viewType.indexOf(h)>=0||E.viewType===h)return!0;if(E.filenamePattern){let A=r(E.filenamePattern)?E.filenamePattern.include:E.filenamePattern,F=r(E.filenamePattern)?E.filenamePattern.exclude:void 0;if(_.match(A,(0,R.basename)(v.fsPath).toLowerCase()))return!(F&&_.match(F,(0,R.basename)(v.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s;class o{constructor(h){this.textModel=h}getElements(){const h=new Int32Array(this.textModel.cells.length);for(let v=0;v<this.textModel.cells.length;v++)h[v]=this.textModel.cells[v].getHashValue();return h}}e.CellSequence=o,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview";var n;(function(E){E[E.LEFT=0]="LEFT",E[E.RIGHT=1]="RIGHT"})(n=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function c(E){const h=E.shift();return h===void 0?[]:E.reduce(function(v,A){return A<=v[0][1]?v[0][1]=A+1:v.unshift([A,A+1]),v},[[h,h+1]]).reverse().map(v=>({start:v[0],end:v[1]}))}e.cellIndexesToRanges=c;function p(E){return E.reduce((v,A)=>{for(let F=A.start;F<A.end;F++)v.push(F);return v},[])}e.cellRangesToIndexes=p});var tt=this&&this.__classPrivateFieldSet||function(Z,e,_){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,_),_},$e=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(me[8],pe([0,1,14,18,94,22,15,2,28,49,112,51]),function(Z,e,_,D,R,I,C,P,y,i,T,k){"use strict";var w,f,l,m,S,g,b,d,u,a,t,r,s,o,n,c;Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestState=e.TestItem=e.TestMessageSeverity=e.TestResult=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookRunState=e.NotebookCellRunState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function p(z){function W(){return Reflect.construct(z,arguments,this.constructor)}return Object.defineProperty(W,"name",Object.getOwnPropertyDescriptor(z,"name")),Object.setPrototypeOf(W,z),Object.setPrototypeOf(W.prototype,z.prototype),W}let E=l=class{constructor(W){w.set(this,void 0),tt(this,w,W)}static from(...W){let le=W;return new l(function(){if(le){for(const $ of le)$&&typeof $.dispose=="function"&&$.dispose();le=void 0}})}dispose(){typeof $e(this,w)=="function"&&($e(this,w).call(this),tt(this,w,void 0))}};w=new WeakMap,E=l=Ve([p],E),e.Disposable=E;let h=m=class{constructor(W,le){if(W<0)throw(0,D.illegalArgument)("line must be non-negative");if(le<0)throw(0,D.illegalArgument)("character must be non-negative");this._line=W,this._character=le}static Min(...W){if(W.length===0)throw new TypeError;let le=W[0];for(let $=1;$<W.length;$++){const te=W[$];te.isBefore(le)&&(le=te)}return le}static Max(...W){if(W.length===0)throw new TypeError;let le=W[0];for(let $=1;$<W.length;$++){const te=W[$];te.isAfter(le)&&(le=te)}return le}static isPosition(W){if(!W)return!1;if(W instanceof m)return!0;let{line:le,character:$}=W;return typeof le=="number"&&typeof $=="number"}get line(){return this._line}get character(){return this._character}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,le=0){if(W===null||le===null)throw(0,D.illegalArgument)();let $;return typeof W=="undefined"?$=0:typeof W=="number"?$=W:($=typeof W.lineDelta=="number"?W.lineDelta:0,le=typeof W.characterDelta=="number"?W.characterDelta:0),$===0&&le===0?this:new m(this.line+$,this.character+le)}with(W,le=this.character){if(W===null||le===null)throw(0,D.illegalArgument)();let $;return typeof W=="undefined"?$=this.line:typeof W=="number"?$=W:($=typeof W.line=="number"?W.line:this.line,le=typeof W.character=="number"?W.character:this.character),$===this.line&&le===this.character?this:new m($,le)}toJSON(){return{line:this.line,character:this.character}}};h=m=Ve([p],h),e.Position=h;let v=S=class{constructor(W,le,$,te){let be,Ge;if(typeof W=="number"&&typeof le=="number"&&typeof $=="number"&&typeof te=="number"?(be=new h(W,le),Ge=new h($,te)):W instanceof h&&le instanceof h&&(be=W,Ge=le),!be||!Ge)throw new Error("Invalid arguments");be.isBefore(Ge)?(this._start=be,this._end=Ge):(this._start=Ge,this._end=be)}static isRange(W){return W instanceof S?!0:W?h.isPosition(W.start)&&h.isPosition(W.end):!1}get start(){return this._start}get end(){return this._end}contains(W){return W instanceof S?this.contains(W._start)&&this.contains(W._end):W instanceof h?!(W.isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const le=h.Max(W.start,this._start),$=h.Min(W.end,this._end);if(!le.isAfter($))return new S(le,$)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const le=h.Min(W.start,this._start),$=h.Max(W.end,this.end);return new S(le,$)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,le=this.end){if(W===null||le===null)throw(0,D.illegalArgument)();let $;return W?h.isPosition(W)?$=W:($=W.start||this.start,le=W.end||this.end):$=this.start,$.isEqual(this._start)&&le.isEqual(this.end)?this:new S($,le)}toJSON(){return[this.start,this.end]}};v=S=Ve([p],v),e.Range=v;let A=g=class extends v{constructor(W,le,$,te){let be,Ge;if(typeof W=="number"&&typeof le=="number"&&typeof $=="number"&&typeof te=="number"?(be=new h(W,le),Ge=new h($,te)):W instanceof h&&le instanceof h&&(be=W,Ge=le),!be||!Ge)throw new Error("Invalid arguments");super(be,Ge);this._anchor=be,this._active=Ge}static isSelection(W){return W instanceof g?!0:W?v.isRange(W)&&h.isPosition(W.anchor)&&h.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};A=g=Ve([p],A),e.Selection=A;class F{constructor(W,le,$){if(typeof W!="string"||W.length===0)throw(0,D.illegalArgument)("host");if(typeof le!="number"||le===0||Math.round(le)!==le)throw(0,D.illegalArgument)("port");if(typeof $!="undefined"&&(typeof $!="string"||$.length===0||!/^[0-9A-Za-z\-]+$/.test($)))throw(0,D.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(le),this.connectionToken=$}}e.ResolvedAuthority=F;class x extends Error{constructor(W,le=T.RemoteAuthorityResolverErrorCode.Unknown,$){super(W);this._message=W,this._code=le,this._detail=$,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,x.prototype)}static NotAvailable(W,le){return new x(W,T.RemoteAuthorityResolverErrorCode.NotAvailable,le)}static TemporarilyNotAvailable(W){return new x(W,T.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=x;var j;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(j=e.EndOfLine||(e.EndOfLine={}));var G;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(G=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let B=b=class{constructor(W,le){this._range=W,this._newText=le}static isTextEdit(W){return W instanceof b?!0:W?v.isRange(W)&&typeof W.newText=="string":!1}static replace(W,le){return new b(W,le)}static insert(W,le){return b.replace(new v(W,W),le)}static delete(W){return b.replace(W,"")}static setEndOfLine(W){const le=new b(new v(new h(0,0),new h(0,0)),"");return le.newEol=W,le}get range(){return this._range}set range(W){if(W&&!v.isRange(W))throw(0,D.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,D.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,D.illegalArgument)("newEol");this._newEol=W}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};B=b=Ve([p],B),e.TextEdit=B;var J;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellOutput=4]="CellOutput",z[z.CellReplace=5]="CellReplace",z[z.CellOutputItem=6]="CellOutputItem"})(J=e.FileEditType||(e.FileEditType={}));let O=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,le,$,te){this._edits.push({_type:1,from:W,to:le,options:$,metadata:te})}createFile(W,le,$){this._edits.push({_type:1,from:void 0,to:W,options:le,metadata:$})}deleteFile(W,le,$){this._edits.push({_type:1,from:W,to:void 0,options:le,metadata:$})}replaceNotebookMetadata(W,le,$){this._edits.push({_type:3,metadata:$,uri:W,edit:{editType:5,metadata:Object.assign(Object.assign({},k.notebookDocumentMetadataDefaults),le)},notebookMetadata:le})}replaceNotebookCells(W,le,$,te,be){(le!==$||te.length>0)&&this._edits.push({_type:5,uri:W,index:le,count:$-le,cells:te,metadata:be})}replaceNotebookCellOutput(W,le,$,te){this._editNotebookCellOutput(W,le,!1,$,te)}appendNotebookCellOutput(W,le,$,te){this._editNotebookCellOutput(W,le,!0,$,te)}replaceNotebookCellOutputItems(W,le,$,te,be){this._editNotebookCellOutputItems(W,le,$,!1,te,be)}appendNotebookCellOutputItems(W,le,$,te,be){this._editNotebookCellOutputItems(W,le,$,!0,te,be)}_editNotebookCellOutputItems(W,le,$,te,be,Ge){this._edits.push({_type:6,metadata:Ge,uri:W,index:le,outputId:$,append:te,newOutputItems:be})}_editNotebookCellOutput(W,le,$,te,be){this._edits.push({_type:4,metadata:be,uri:W,index:le,append:$,newOutputs:te,newMetadata:void 0})}replaceNotebookCellMetadata(W,le,$,te){this._edits.push({_type:3,metadata:te,uri:W,edit:{editType:3,index:le,metadata:$}})}replace(W,le,$,te){this._edits.push({_type:2,uri:W,edit:new B(le,$),metadata:te})}insert(W,le,$,te){this.replace(W,new v(le,le),$,te)}delete(W,le,$){this.replace(W,le,"",$)}has(W){return this._edits.some(le=>le._type===2&&le.uri.toString()===W.toString())}set(W,le){if(le)for(const $ of le)$&&this._edits.push({_type:2,uri:W,edit:$});else{for(let $=0;$<this._edits.length;$++){const te=this._edits[$];te._type===2&&te.uri.toString()===W.toString()&&(this._edits[$]=void 0)}(0,_.coalesceInPlace)(this._edits)}}get(W){const le=[];for(let $ of this._edits)$._type===2&&$.uri.toString()===W.toString()&&le.push($.edit);return le}entries(){const W=new I.ResourceMap;for(let le of this._edits)if(le._type===2){let $=W.get(le.uri);$||($=[le.uri,[]],W.set(le.uri,$)),$[1].push(le.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};O=Ve([p],O),e.WorkspaceEdit=O;let N=d=class{constructor(W){this._tabstop=1,this.value=W||""}static isSnippetString(W){return W instanceof d?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}appendText(W){return this.value+=d._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,le=this._tabstop++){if(typeof W=="function"){const $=new d;$._tabstop=this._tabstop,W($),this._tabstop=$._tabstop,W=$.value}else W=d._escape(W);return this.value+="${",this.value+=le,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,le=this._tabstop++){const $=W.map(te=>te.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=le,this.value+="|",this.value+=$,this.value+="|}",this}appendVariable(W,le){if(typeof le=="function"){const $=new d;$._tabstop=this._tabstop,le($),this._tabstop=$._tabstop,le=$.value}else typeof le=="string"&&(le=le.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,le&&(this.value+=":",this.value+=le),this.value+="}",this}};N=d=Ve([p],N),e.SnippetString=N;var U;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(U=e.DiagnosticTag||(e.DiagnosticTag={}));var L;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(L=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let M=u=class{constructor(W,le){if(this.uri=W,le)if(le instanceof v)this.range=le;else if(le instanceof h)this.range=new v(le,le);else throw new Error("Illegal argument")}static isLocation(W){return W instanceof u?!0:W?v.isRange(W.range)&&P.URI.isUri(W.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};M=u=Ve([p],M),e.Location=M;let V=class{constructor(W,le){this.location=W,this.message=le}static is(W){return W?typeof W.message=="string"&&W.location&&v.isRange(W.location.range)&&P.URI.isUri(W.location.uri):!1}static isEqual(W,le){return W===le?!0:!W||!le?!1:W.message===le.message&&W.location.range.isEqual(le.location.range)&&W.location.uri.toString()===le.location.uri.toString()}};V=Ve([p],V),e.DiagnosticRelatedInformation=V;let K=class{constructor(W,le,$=L.Error){if(!v.isRange(W))throw new TypeError("range must be set");if(!le)throw new TypeError("message must be set");this.range=W,this.message=le,this.severity=$}toJSON(){return{severity:L[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,le){return W===le?!0:!W||!le?!1:W.message===le.message&&W.severity===le.severity&&W.code===le.code&&W.severity===le.severity&&W.source===le.source&&W.range.isEqual(le.range)&&(0,_.equals)(W.tags,le.tags)&&(0,_.equals)(W.relatedInformation,le.relatedInformation,V.isEqual)}};K=Ve([p],K),e.Diagnostic=K;let se=class{constructor(W,le){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:(0,R.isMarkdownString)(W)?this.contents=[W]:this.contents=[W],this.range=le}};se=Ve([p],se),e.Hover=se;var ce;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(ce=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let we=class{constructor(W,le=ce.Text){this.range=W,this.kind=le}toJSON(){return{range:this.range,kind:ce[this.kind]}}};we=Ve([p],we),e.DocumentHighlight=we;var Te;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(Te=e.SymbolKind||(e.SymbolKind={}));var Ie;(function(z){z[z.Deprecated=1]="Deprecated"})(Ie=e.SymbolTag||(e.SymbolTag={}));let Me=a=class{constructor(W,le,$,te,be){this.name=W,this.kind=le,this.containerName=be,typeof $=="string"&&(this.containerName=$),te instanceof M?this.location=te:$ instanceof v&&(this.location=new M(te,$)),a.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Te[this.kind],location:this.location,containerName:this.containerName}}};Me=a=Ve([p],Me),e.SymbolInformation=Me;let H=t=class{constructor(W,le,$,te,be){this.name=W,this.detail=le,this.kind=$,this.range=te,this.selectionRange=be,this.children=[],t.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children&&W.children.forEach(t.validate)}};H=t=Ve([p],H),e.DocumentSymbol=H;var Q;(function(z){z[z.Automatic=1]="Automatic",z[z.Manual=2]="Manual"})(Q=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ne=class{constructor(W,le){this.title=W,this.kind=le}};ne=Ve([p],ne),e.CodeAction=ne;let oe=r=class{constructor(W){this.value=W}append(W){return new r(this.value?this.value+r.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+r.sep)}};oe.sep=".",oe=r=Ve([p],oe),e.CodeActionKind=oe,oe.Empty=new oe(""),oe.QuickFix=oe.Empty.append("quickfix"),oe.Refactor=oe.Empty.append("refactor"),oe.RefactorExtract=oe.Refactor.append("extract"),oe.RefactorInline=oe.Refactor.append("inline"),oe.RefactorRewrite=oe.Refactor.append("rewrite"),oe.Source=oe.Empty.append("source"),oe.SourceOrganizeImports=oe.Source.append("organizeImports"),oe.SourceFixAll=oe.Source.append("fixAll");let ge=class{constructor(W,le){if(this.range=W,this.parent=le,le&&!le.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ge=Ve([p],ge),e.SelectionRange=ge;class Ce{constructor(W,le,$,te,be,Ge){this.kind=W,this.name=le,this.detail=$,this.uri=te,this.range=be,this.selectionRange=Ge}}e.CallHierarchyItem=Ce;class Oe{constructor(W,le){this.fromRanges=le,this.from=W}}e.CallHierarchyIncomingCall=Oe;class ve{constructor(W,le){this.fromRanges=le,this.to=W}}e.CallHierarchyOutgoingCall=ve;let ke=class{constructor(W,le){this.range=W,this.command=le}get isResolved(){return!!this.command}};ke=Ve([p],ke),e.CodeLens=ke;let Pe=s=class{constructor(W,le=!1){f.set(this,void 0),tt(this,f,new R.MarkdownString(W,{supportThemeIcons:le}))}static isMarkdownString(W){return W instanceof s?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}get value(){return $e(this,f).value}set value(W){$e(this,f).value=W}get isTrusted(){return $e(this,f).isTrusted}set isTrusted(W){$e(this,f).isTrusted=W}get supportThemeIcons(){return $e(this,f).supportThemeIcons}appendText(W){return $e(this,f).appendText(W),this}appendMarkdown(W){return $e(this,f).appendMarkdown(W),this}appendCodeblock(W,le){return $e(this,f).appendCodeblock(le!=null?le:"",W),this}};f=new WeakMap,Pe=s=Ve([p],Pe),e.MarkdownString=Pe;let Ue=class{constructor(W,le){this.label=W,this.documentation=le}};Ue=Ve([p],Ue),e.ParameterInformation=Ue;let Se=class{constructor(W,le){this.label=W,this.documentation=le,this.parameters=[]}};Se=Ve([p],Se),e.SignatureInformation=Se;let qe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};qe=Ve([p],qe),e.SignatureHelp=qe;var X;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(X=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ie;(function(z){z[z.Other=0]="Other",z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(ie=e.InlineHintKind||(e.InlineHintKind={}));let Ee=class{constructor(W,le,$){this.text=W,this.range=le,this.kind=$}};Ee=Ve([p],Ee),e.InlineHint=Ee;var Ne;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ne=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var He;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(He=e.CompletionItemKind||(e.CompletionItemKind={}));var Be;(function(z){z[z.Deprecated=1]="Deprecated"})(Be=e.CompletionItemTag||(e.CompletionItemTag={}));let Ye=class{constructor(W,le){this.label=W,this.kind=le}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&He[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ye=Ve([p],Ye),e.CompletionItem=Ye;let q=class{constructor(W=[],le=!1){this.items=W,this.isIncomplete=le}};q=Ve([p],q),e.CompletionList=q;var ae;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(ae=e.ViewColumn||(e.ViewColumn={}));var he;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(he=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Y;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(Y=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var re;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(re=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ue;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(ue=e.TextEditorRevealType||(e.TextEditorRevealType={}));var fe;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(fe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ye;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(ye=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function W(le){switch(le){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=W}(fe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let je=class{constructor(W,le){if(le&&!P.URI.isUri(le))throw(0,D.illegalArgument)("target");if(!v.isRange(W)||W.isEmpty)throw(0,D.illegalArgument)("range");this.range=W,this.target=le}};je=Ve([p],je),e.DocumentLink=je;let We=class{constructor(W,le,$,te){this.red=W,this.green=le,this.blue=$,this.alpha=te}};We=Ve([p],We),e.Color=We;let ze=class{constructor(W,le){if(le&&!(le instanceof We))throw(0,D.illegalArgument)("color");if(!v.isRange(W)||W.isEmpty)throw(0,D.illegalArgument)("range");this.range=W,this.color=le}};ze=Ve([p],ze),e.ColorInformation=ze;let Xe=class{constructor(W){if(!W||typeof W!="string")throw(0,D.illegalArgument)("label");this.label=W}};Xe=Ve([p],Xe),e.ColorPresentation=Xe;var nt;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(nt=e.ColorFormat||(e.ColorFormat={}));var et;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(et=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Je;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(Je=e.TaskRevealKind||(e.TaskRevealKind={}));var _e;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(_e=e.TaskPanelKind||(e.TaskPanelKind={}));let De=o=class{constructor(W,le){if(typeof W!="string"||typeof le!="string")throw(0,D.illegalArgument)("name");this._id=W}static from(W){switch(W){case"clean":return o.Clean;case"build":return o.Build;case"rebuild":return o.Rebuild;case"test":return o.Test;default:return}}get id(){return this._id}};De.Clean=new o("clean","Clean"),De.Build=new o("build","Build"),De.Rebuild=new o("rebuild","Rebuild"),De.Test=new o("test","Test"),De=o=Ve([p],De),e.TaskGroup=De;function de(z){let W="";for(let le=0;le<z.length;le++)W+=z[le].replace(/,/g,",,")+",";return W}let ee=class{constructor(W,le,$){if(typeof W!="string")throw(0,D.illegalArgument)("process");this._args=[],this._process=W,le!==void 0&&(Array.isArray(le)?(this._args=le,this._options=$):this._options=le)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,D.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(let le of this._args)W.push(le);return de(W)}};ee=Ve([p],ee),e.ProcessExecution=ee;let Ae=class{constructor(W,le,$){if(this._args=[],Array.isArray(le)){if(!W)throw(0,D.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,D.illegalArgument)("command");this._command=W,this._args=le,this._options=$}else{if(typeof W!="string")throw(0,D.illegalArgument)("commandLine");this._commandLine=W,this._options=le}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,D.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,D.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let le of this._args)W.push(typeof le=="string"?le:le.value);return de(W)}};Ae=Ve([p],Ae),e.ShellExecution=Ae;var Re;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(Re=e.ShellQuoting||(e.ShellQuoting={}));var Ze;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(Ze=e.TaskScope||(e.TaskScope={}));class Le{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,y.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=Le;let it=n=class{constructor(W,le,$,te,be,Ge){this.__deprecated=!1,this._definition=this.definition=W;let Qe;typeof le=="string"?(this._name=this.name=le,this._source=this.source=$,this.execution=te,Qe=be,this.__deprecated=!0):le===Ze.Global||le===Ze.Workspace?(this.target=le,this._name=this.name=$,this._source=this.source=te,this.execution=be,Qe=Ge):(this.target=le,this._name=this.name=$,this._source=this.source=te,this.execution=be,Qe=Ge),typeof Qe=="string"?(this._problemMatchers=[Qe],this._hasDefinedMatchers=!0):Array.isArray(Qe)?(this._problemMatchers=Qe,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ee?this._definition={type:n.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ae?this._definition={type:n.ShellType,id:this._execution.computeId()}:this._execution instanceof Le?this._definition={type:n.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:n.EmptyType,id:(0,y.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,D.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,D.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const le=this._definition.type;(n.EmptyType===le||n.ProcessType===le||n.ShellType===le||n.ExtensionCallbackType===le)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,D.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};it.ExtensionCallbackType="customExecution",it.ProcessType="process",it.ShellType="shell",it.EmptyType="$empty",it=n=Ve([p],it),e.Task=it;var st;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(st=e.ProgressLocation||(e.ProgressLocation={}));let Ke=class{constructor(W,le=ct.None){this.collapsibleState=le,P.URI.isUri(W)?this.resourceUri=W:this.label=W}};Ke=Ve([p],Ke),e.TreeItem=Ke;var ct;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(ct=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ot=class{constructor(W,le){this.id=W,this.color=le}};ot=Ve([p],ot),e.ThemeIcon=ot,ot.File=new ot("file"),ot.Folder=new ot("folder");let ut=class{constructor(W){this.id=W}};ut=Ve([p],ut),e.ThemeColor=ut;var kt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(kt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Dt=class{constructor(W,le){if(typeof W!="string"&&(!W||!P.URI.isUri(W)&&!P.URI.isUri(W.uri)))throw(0,D.illegalArgument)("base");if(typeof le!="string")throw(0,D.illegalArgument)("pattern");typeof W=="string"?(this.baseFolder=P.URI.file(W),this.base=W):P.URI.isUri(W)?(this.baseFolder=W,this.base=W.fsPath):(this.baseFolder=W.uri,this.base=W.uri.fsPath),this.pattern=le}};Dt=Ve([p],Dt),e.RelativePattern=Dt;let pt=class{constructor(W,le,$,te){this.enabled=typeof W=="boolean"?W:!0,typeof le=="string"&&(this.condition=le),typeof $=="string"&&(this.hitCondition=$),typeof te=="string"&&(this.logMessage=te)}get id(){return this._id||(this._id=(0,y.generateUuid)()),this._id}};pt=Ve([p],pt),e.Breakpoint=pt;let lt=class extends pt{constructor(W,le,$,te,be){super(le,$,te,be);if(W===null)throw(0,D.illegalArgument)("location");this.location=W}};lt=Ve([p],lt),e.SourceBreakpoint=lt;let ft=class extends pt{constructor(W,le,$,te,be){super(le,$,te,be);this.functionName=W}};ft=Ve([p],ft),e.FunctionBreakpoint=ft;let dt=class extends pt{constructor(W,le,$,te,be,Ge,Qe){super(te,be,Ge,Qe);if(!le)throw(0,D.illegalArgument)("dataId");this.label=W,this.dataId=le,this.canPersist=$}};dt=Ve([p],dt),e.DataBreakpoint=dt;let It=class{constructor(W,le,$){this.command=W,this.args=le||[],this.options=$}};It=Ve([p],It),e.DebugAdapterExecutable=It;let St=class{constructor(W,le){this.port=W,this.host=le}};St=Ve([p],St),e.DebugAdapterServer=St;let Pt=class{constructor(W){this.path=W}};Pt=Ve([p],Pt),e.DebugAdapterNamedPipeServer=Pt;let xt=class{constructor(W){this.implementation=W}};xt=Ve([p],xt),e.DebugAdapterInlineImplementation=xt;let Wt=class{constructor(W,le){this.range=W,this.expression=le}};Wt=Ve([p],Wt),e.EvaluatableExpression=Wt;let Et=class{constructor(W,le){this.range=W,this.text=le}};Et=Ve([p],Et),e.InlineValueText=Et;let jt=class{constructor(W,le,$=!0){this.range=W,this.variableName=le,this.caseSensitiveLookup=$}};jt=Ve([p],jt),e.InlineValueVariableLookup=jt;let qt=class{constructor(W,le){this.range=W,this.expression=le}};qt=Ve([p],qt),e.InlineValueEvaluatableExpression=qt;let gt=class{constructor(W,le){this.frameId=W,this.stoppedLocation=le}};gt=Ve([p],gt),e.InlineValueContext=gt;var yt;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(yt=e.FileChangeType||(e.FileChangeType={}));let Bt=c=class extends Error{constructor(W,le=i.FileSystemProviderErrorCode.Unknown,$){var te;super(P.URI.isUri(W)?W.toString(!0):W);this.code=(te=$==null?void 0:$.name)!==null&&te!==void 0?te:"Unknown",(0,i.markAsFileSystemProviderError)(this,le),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,c.prototype),typeof Error.captureStackTrace=="function"&&typeof $=="function"&&Error.captureStackTrace(this,$)}static FileExists(W){return new c(W,i.FileSystemProviderErrorCode.FileExists,c.FileExists)}static FileNotFound(W){return new c(W,i.FileSystemProviderErrorCode.FileNotFound,c.FileNotFound)}static FileNotADirectory(W){return new c(W,i.FileSystemProviderErrorCode.FileNotADirectory,c.FileNotADirectory)}static FileIsADirectory(W){return new c(W,i.FileSystemProviderErrorCode.FileIsADirectory,c.FileIsADirectory)}static NoPermissions(W){return new c(W,i.FileSystemProviderErrorCode.NoPermissions,c.NoPermissions)}static Unavailable(W){return new c(W,i.FileSystemProviderErrorCode.Unavailable,c.Unavailable)}};Bt=c=Ve([p],Bt),e.FileSystemError=Bt;let Gt=class{constructor(W,le,$){this.start=W,this.end=le,this.kind=$}};Gt=Ve([p],Gt),e.FoldingRange=Gt;var $t;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})($t=e.FoldingRangeKind||(e.FoldingRangeKind={}));var at;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(at=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var gn;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(gn=e.CommentMode||(e.CommentMode={}));class Tt{constructor(W,le=[]){this.tokenTypes=W,this.tokenModifiers=le}}e.SemanticTokensLegend=Tt;function Ft(z){return typeof z=="undefined"||(0,C.isStringArray)(z)}class Ht{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let le=0,$=W.tokenTypes.length;le<$;le++)this._tokenTypeStrToInt.set(W.tokenTypes[le],le);for(let le=0,$=W.tokenModifiers.length;le<$;le++)this._tokenModifierStrToInt.set(W.tokenModifiers[le],le)}}push(W,le,$,te,be){if(typeof W=="number"&&typeof le=="number"&&typeof $=="number"&&typeof te=="number"&&(typeof be=="number"||typeof be=="undefined"))return typeof be=="undefined"&&(be=0),this._pushEncoded(W,le,$,te,be);if(v.isRange(W)&&typeof le=="string"&&Ft($))return this._push(W,le,$);throw(0,D.illegalArgument)()}_push(W,le,$){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(le))throw new Error("`tokenType` is not in the provided legend");const te=W.start.line,be=W.start.character,Ge=W.end.character-W.start.character,Qe=this._tokenTypeStrToInt.get(le);let rt=0;if($)for(const mt of $){if(!this._tokenModifierStrToInt.has(mt))throw new Error("`tokenModifier` is not in the provided legend");const wt=this._tokenModifierStrToInt.get(mt);rt|=1<<wt>>>0}this._pushEncoded(te,be,Ge,Qe,rt)}_pushEncoded(W,le,$,te,be){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&le<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const rt=this._data.length/5|0;let mt=0,wt=0;for(let _t=0;_t<rt;_t++){let bt=this._data[5*_t],Ct=this._data[5*_t+1];bt===0?(bt=mt,Ct+=wt):bt+=mt,this._data[5*_t]=bt,this._data[5*_t+1]=Ct,mt=bt,wt=Ct}}let Ge=W,Qe=le;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Ge-=this._prevLine,Ge===0&&(Qe-=this._prevChar)),this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=Qe,this._data[this._dataLen++]=$,this._data[this._dataLen++]=te,this._data[this._dataLen++]=be,this._prevLine=W,this._prevChar=le}static _sortAndDeltaEncode(W){let le=[];const $=W.length/5|0;for(let Qe=0;Qe<$;Qe++)le[Qe]=Qe;le.sort((Qe,rt)=>{const mt=W[5*Qe],wt=W[5*rt];if(mt===wt){const _t=W[5*Qe+1],bt=W[5*rt+1];return _t-bt}return mt-wt});const te=new Uint32Array(W.length);let be=0,Ge=0;for(let Qe=0;Qe<$;Qe++){const rt=5*le[Qe],mt=W[rt+0],wt=W[rt+1],_t=W[rt+2],bt=W[rt+3],Ct=W[rt+4],Pn=mt-be,Fn=Pn===0?wt-Ge:wt,rn=5*Qe;te[rn+0]=Pn,te[rn+1]=Fn,te[rn+2]=_t,te[rn+3]=bt,te[rn+4]=Ct,be=mt,Ge=wt}return te}build(W){return this._dataIsSortedAndDeltaEncoded?new Kt(new Uint32Array(this._data),W):new Kt(Ht._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=Ht;class Kt{constructor(W,le){this.resultId=le,this.data=W}}e.SemanticTokens=Kt;class on{constructor(W,le,$){this.start=W,this.deleteCount=le,this.data=$}}e.SemanticTokensEdit=on;class pn{constructor(W,le){this.resultId=le,this.edits=W}}e.SemanticTokensEdits=pn;var an;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(an=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Lt;(function(z){z[z.Initial=1]="Initial",z[z.Dynamic=2]="Dynamic"})(Lt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let zt=class{constructor(){}};zt.Back={iconPath:new ot("arrow-left")},zt=Ve([p],zt),e.QuickInputButtons=zt;var Xt;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(Xt=e.ExtensionKind||(e.ExtensionKind={}));class Yt{constructor(W,le,$){this.badge=W,this.tooltip=le,this.color=$}static validate(W){if(W.badge&&W.badge.length!==1&&W.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Yt;let Qt=class{constructor(W){this.kind=W}};Qt=Ve([p],Qt),e.ColorTheme=Qt;var vn;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast"})(vn=e.ColorThemeKind||(e.ColorThemeKind={}));class At{constructor(W,le){if(W<0)throw(0,D.illegalArgument)("start must be positive");if(le<W)throw(0,D.illegalArgument)("end cannot be smaller than start");this._start=W,this._end=le}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}}e.NotebookCellRange=At;class Jt{constructor(W,le,$,te,be,Ge,Qe,rt,mt,wt,_t,bt){this.editable=W,this.breakpointMargin=le,this.runnable=$,this.hasExecutionOrder=te,this.executionOrder=be,this.runState=Ge,this.runStartTime=Qe,this.statusMessage=rt,this.lastRunDuration=mt,this.inputCollapsed=wt,this.outputCollapsed=_t,this.custom=bt}with(W){let{editable:le,breakpointMargin:$,runnable:te,hasExecutionOrder:be,executionOrder:Ge,runState:Qe,runStartTime:rt,statusMessage:mt,lastRunDuration:wt,inputCollapsed:_t,outputCollapsed:bt,custom:Ct}=W;return le===void 0?le=this.editable:le===null&&(le=void 0),$===void 0?$=this.breakpointMargin:$===null&&($=void 0),te===void 0?te=this.runnable:te===null&&(te=void 0),be===void 0?be=this.hasExecutionOrder:be===null&&(be=void 0),Ge===void 0?Ge=this.executionOrder:Ge===null&&(Ge=void 0),Qe===void 0?Qe=this.runState:Qe===null&&(Qe=void 0),rt===void 0?rt=this.runStartTime:rt===null&&(rt=void 0),mt===void 0?mt=this.statusMessage:mt===null&&(mt=void 0),wt===void 0?wt=this.lastRunDuration:wt===null&&(wt=void 0),_t===void 0?_t=this.inputCollapsed:_t===null&&(_t=void 0),bt===void 0?bt=this.outputCollapsed:bt===null&&(bt=void 0),Ct===void 0?Ct=this.custom:Ct===null&&(Ct=void 0),le===this.editable&&$===this.breakpointMargin&&te===this.runnable&&be===this.hasExecutionOrder&&Ge===this.executionOrder&&Qe===this.runState&&rt===this.runStartTime&&mt===this.statusMessage&&wt===this.lastRunDuration&&_t===this.inputCollapsed&&bt===this.outputCollapsed&&Ct===this.custom?this:new Jt(le,$,te,be,Ge,Qe,rt,mt,wt,_t,bt,Ct)}}e.NotebookCellMetadata=Jt;class Zt{constructor(W=!0,le=!0,$=!0,te=!0,be=!0,Ge={},Qe=Fe.Idle,rt=!0){this.editable=W,this.runnable=le,this.cellEditable=$,this.cellRunnable=te,this.cellHasExecutionOrder=be,this.custom=Ge,this.runState=Qe,this.trusted=rt}with(W){let{editable:le,runnable:$,cellEditable:te,cellRunnable:be,cellHasExecutionOrder:Ge,custom:Qe,runState:rt,trusted:mt}=W;return le===void 0?le=this.editable:le===null&&(le=void 0),$===void 0?$=this.runnable:$===null&&($=void 0),te===void 0?te=this.cellEditable:te===null&&(te=void 0),be===void 0?be=this.cellRunnable:be===null&&(be=void 0),Ge===void 0?Ge=this.cellHasExecutionOrder:Ge===null&&(Ge=void 0),Qe===void 0?Qe=this.custom:Qe===null&&(Qe=void 0),rt===void 0?rt=this.runState:rt===null&&(rt=void 0),mt===void 0?mt=this.trusted:mt===null&&(mt=void 0),le===this.editable&&$===this.runnable&&te===this.cellEditable&&be===this.cellRunnable&&Ge===this.cellHasExecutionOrder&&Qe===this.custom&&rt===this.runState&&mt===this.trusted?this:new Zt(le,$,te,be,Ge,Qe,rt,mt)}}e.NotebookDocumentMetadata=Zt;class wn{constructor(W,le,$,te,be){this.kind=W,this.source=le,this.language=$,this.outputs=te!=null?te:[],this.metadata=be}}e.NotebookCellData=wn;class _n{constructor(W,le){this.cells=W,this.metadata=le}}e.NotebookData=_n;class Ot{constructor(W,le,$){this.mime=W,this.value=le,this.metadata=$}static isNotebookCellOutputItem(W){return W instanceof Ot}}e.NotebookCellOutputItem=Ot;class ln{constructor(W,le,$){this.outputs=W,typeof le=="string"?(this.id=le,this.metadata=$):(this.id=(0,y.generateUuid)(),this.metadata=le!=null?le:$)}}e.NotebookCellOutput=ln;var cn;(function(z){z[z.Markdown=1]="Markdown",z[z.Code=2]="Code"})(cn=e.NotebookCellKind||(e.NotebookCellKind={}));var en;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle",z[z.Success=3]="Success",z[z.Error=4]="Error"})(en=e.NotebookCellRunState||(e.NotebookCellRunState={}));var Fe;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(Fe=e.NotebookRunState||(e.NotebookRunState={}));var tn;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(tn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var nn;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(nn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));let ht=class{constructor(W,le){this.label=W,this.timestamp=le}};ht=Ve([p],ht),e.TimelineItem=ht;var bn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(bn=e.ExtensionMode||(e.ExtensionMode={}));var En;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(En=e.ExtensionRuntime||(e.ExtensionRuntime={}));var un;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=4]="RegEx"})(un=e.StandardTokenType||(e.StandardTokenType={}));class dn{constructor(W,le){this.ranges=W,this.wordPattern=le}}e.LinkedEditingRanges=dn;var Sn;(function(z){z[z.Unset=0]="Unset",z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(Sn=e.TestResult||(e.TestResult={}));var hn;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information",z[z.Hint=3]="Hint"})(hn=e.TestMessageSeverity||(e.TestMessageSeverity={}));class yn{constructor(W,le){this.label=le,this.runnable=!0,this.debuggable=!1,this.children=[],Object.defineProperty(this,"id",{value:W,enumerable:!0,writable:!1})}}e.TestItem=yn;class Dn{constructor(W){this.state=W,this.messages=[]}}e.TestState=Dn;class Vt{constructor(W){this.message=W,this.severity=hn.Error}static diff(W,le,$){const te=new Vt(W);return te.expectedOutput=le,te.actualOutput=$,te}}e.TestMessage=Vt;var Cn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(Cn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var kn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unknown=2]="Unknown"})(kn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}))}),define(me[119],pe([0,1,53,11,9,142,104,8,14]),function(Z,e,_,D,R,I,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const i=new Map;function T(l,m){m?i.set(l,m):i.delete(l)}e.setWordDefinitionFor=T;function k(l){return i.get(l)}e.getWordDefinitionFor=k;class w extends I.MirrorTextModel{constructor(m,S,g,b,d,u,a,t){super(S,g,b,d);this._proxy=m,this._languageId=u,this._isDirty=a,this._notebook=t,this._isDisposed=!1}dispose(){(0,_.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(m){return(0,y.equals)(this._lines,m)}get document(){if(!this._document){const m=this;this._document={get uri(){return m._uri},get fileName(){return m._uri.fsPath},get isUntitled(){return m._uri.scheme===D.Schemas.untitled},get languageId(){return m._languageId},get version(){return m._versionId},get isClosed(){return m._isDisposed},get isDirty(){return m._isDirty},get notebook(){return m._notebook},save(){return m._save()},getText(S){return S?m._getTextInRange(S):m.getText()},get eol(){return m._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return m._lines.length},lineAt(S){return m._lineAt(S)},offsetAt(S){return m._offsetAt(S)},positionAt(S){return m._positionAt(S)},validateRange(S){return m._validateRange(S)},validatePosition(S){return m._validatePosition(S)},getWordRangeAtPosition(S,g){return m._getWordRangeAtPosition(S,g)}}}return Object.freeze(this._document)}_acceptLanguageId(m){(0,_.ok)(!this._isDisposed),this._languageId=m}_acceptIsDirty(m){(0,_.ok)(!this._isDisposed),this._isDirty=m}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(m){const S=this._validateRange(m);if(S.isEmpty)return"";if(S.isSingleLine)return this._lines[S.start.line].substring(S.start.character,S.end.character);const g=this._eol,b=S.start.line,d=S.end.line,u=[];u.push(this._lines[b].substring(S.start.character));for(let a=b+1;a<d;a++)u.push(this._lines[a]);return u.push(this._lines[d].substring(0,S.end.character)),u.join(g)}_lineAt(m){let S;if(m instanceof P.Position?S=m.line:typeof m=="number"&&(S=m),typeof S!="number"||S<0||S>=this._lines.length||Math.floor(S)!==S)throw new Error("Illegal value for `line`");return new f(S,this._lines[S],S===this._lines.length-1)}_offsetAt(m){return m=this._validatePosition(m),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(m.line-1)+m.character}_positionAt(m){m=Math.floor(m),m=Math.max(0,m),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(m),g=this._lines[S.index].length;return new P.Position(S.index,Math.min(S.remainder,g))}_validateRange(m){if(!(m instanceof P.Range))throw new Error("Invalid argument");const S=this._validatePosition(m.start),g=this._validatePosition(m.end);return S===m.start&&g===m.end?m:new P.Range(S.line,S.character,g.line,g.character)}_validatePosition(m){if(!(m instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return m.with(0,0);let{line:S,character:g}=m,b=!1;if(S<0)S=0,g=0,b=!0;else if(S>=this._lines.length)S=this._lines.length-1,g=this._lines[S].length,b=!0;else{const d=this._lines[S].length;g<0?(g=0,b=!0):g>d&&(g=d,b=!0)}return b?new P.Position(S,g):m}_getWordRangeAtPosition(m,S){const g=this._validatePosition(m);if(!S)S=k(this._languageId);else if((0,R.regExpLeadsToEndlessLoop)(S))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${S.source}' because it matches the empty string.`);const b=(0,C.getWordAtText)(g.character+1,(0,C.ensureValidWordDefinition)(S),this._lines[g.line],0);if(b)return new P.Range(g.line,b.startColumn-1,g.line,b.endColumn-1)}}e.ExtHostDocumentData=w;class f{constructor(m,S,g){this._line=m,this._text=S,this._isLastLine=g}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(me[203],pe([0,1,8,3,106,6,78,22,2,28]),function(Z,e,_,D,R,I,C,P,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class T{constructor(w,f,l,m){this._notebook=l,this._selector=m,this._disposables=new I.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,i.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(g=>{const b=this._cellUris.get(g.document.uri);b!==void 0&&(this._cellLengths.changeValue(b,this._cells[b].document.getText().length+1),this._cellLines.changeValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const S=g=>{g===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(w.onDidChangeCellLanguage(g=>S(g.document))),this._disposables.add(w.onDidChangeNotebookCells(g=>S(g.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const w=[],f=[];for(const l of this._notebook.cells)l.cellKind===_.NotebookCellKind.Code&&(!this._selector||(0,C.score)(this._selector,l.uri,l.language,!0))&&(this._cellUris.set(l.uri,this._cells.length),this._cells.push(l),w.push(l.document.getText().length+1),f.push(l.document.lineCount));this._cellLengths=new R.PrefixSumComputer(new Uint32Array(w)),this._cellLines=new R.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(w){var f,l;if(!w){let d="";for(const u of this._cells)d+=u.document.getText()+`
`;return d=d.slice(0,-1),d}if(w.isEmpty)return"";const m=this.locationAt(w.start),S=this.locationAt(w.end),g=this._cells[(f=this._cellUris.get(m.uri))!==null&&f!==void 0?f:-1],b=this._cells[(l=this._cellUris.get(S.uri))!==null&&l!==void 0?l:-1];if(!g||!b)return"";if(g===b)return g.document.getText(new _.Range(m.range.start,S.range.end));{const d=g.document.getText(new _.Range(m.range.start,new _.Position(g.document.lineCount,0))),u=b.document.getText(new _.Range(new _.Position(0,0),S.range.end));return d+`
`+u}}offsetAt(w){const f=this._cellLines.getIndexOf(w.line),l=this._cellLengths.getAccumulatedValue(f.index-1),m=this._cells[f.index].document.offsetAt(w.with(f.remainder));return l+m}positionAt(w){if(typeof w=="number"){const l=this._cellLengths.getIndexOf(w),m=this._cellLines.getAccumulatedValue(l.index-1);return this._cells[l.index].document.positionAt(l.remainder).translate(m)}const f=this._cellUris.get(w.uri);if(f!==void 0){const l=this._cellLines.getAccumulatedValue(f-1);return new _.Position(l+w.range.start.line,w.range.start.character)}return new _.Position(0,0)}locationAt(w){_.Range.isRange(w)||(w=new _.Range(w,w));const f=this._cellLines.getIndexOf(w.start.line);let l=f;w.isEmpty||(l=this._cellLines.getIndexOf(w.end.line));const m=new _.Position(f.remainder,w.start.character),S=new _.Position(l.remainder,w.end.character),g=new _.Range(m,S),b=this._cells[f.index];return new _.Location(b.uri,b.document.validateRange(g))}contains(w){return this._cellUris.has(w)}validateRange(w){const f=this.validatePosition(w.start),l=this.validatePosition(w.end);return w.with(f,l)}validatePosition(w){const f=this._cellLines.getIndexOf(w.line),l=new _.Position(f.remainder,w.character),m=this._cells[f.index].document.validatePosition(l),S=this._cellLines.getAccumulatedValue(f.index-1);return new _.Position(S+m.line,m.character)}}e.ExtHostNotebookConcatDocument=T}),define(me[204],pe([0,1,8,13,3]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let I=class{constructor(P){this._actual=new _.ColorTheme(_.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new R.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let y=P==="light"?_.ColorThemeKind.Light:P==="dark"?_.ColorThemeKind.Dark:_.ColorThemeKind.HighContrast;this._actual=new _.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};I=Ve([xe(0,D.IExtHostRpcService)],I),e.ExtHostTheming=I}),define(me[205],pe([0,1,171,4,60]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new R.RawContextKey("customExecutionSupported",!0,_.localize(0,null)),e.ShellExecutionSupportedContext=new R.RawContextKey("shellExecutionSupported",!1,_.localize(1,null)),e.ProcessExecutionSupportedContext=new R.RawContextKey("processExecutionSupported",!1,_.localize(2,null)),e.ITaskService=(0,D.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[206],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function _(R){return[...R.entries()]}e.serializeEnvironmentVariableCollection=_;function D(R){return new Map(R)}e.deserializeEnvironmentVariableCollection=D}),define(me[207],pe([0,1,172,60]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.terminalContributionsDescriptor=e.DEFAULT_COMMANDS_TO_SKIP_SHELL=e.TERMINAL_COMMAND_ID=e.TitleEventSource=e.LinuxDistro=e.ProcessState=e.DEFAULT_LOCAL_ECHO_EXCLUDE=e.SUGGESTIONS_FONT_WEIGHT=e.DEFAULT_BOLD_FONT_WEIGHT=e.DEFAULT_FONT_WEIGHT=e.MAXIMUM_FONT_WEIGHT=e.MINIMUM_FONT_WEIGHT=e.DEFAULT_LINE_HEIGHT=e.MINIMUM_LETTER_SPACING=e.DEFAULT_LETTER_SPACING=e.TERMINAL_ACTION_CATEGORY=e.TERMINAL_CONFIG_SECTION=e.TerminalCursorStyle=e.SUGGESTED_RENDERER_TYPE=e.TERMINAL_CREATION_COMMANDS=e.NEVER_MEASURE_RENDER_TIME_STORAGE_KEY=e.IS_WORKSPACE_SHELL_ALLOWED_STORAGE_KEY=e.KEYBINDING_CONTEXT_TERMINAL_PROCESS_SUPPORTED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_NOT_VISIBLE=e.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE=e.KEYBINDING_CONTEXT_TERMINAL_TEXT_NOT_SELECTED=e.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED=e.KEYBINDING_CONTEXT_TERMINAL_A11Y_TREE_FOCUS=e.KEYBINDING_CONTEXT_TERMINAL_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_ALT_BUFFER_ACTIVE=e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE=e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY=e.KEYBINDING_CONTEXT_TERMINAL_FOCUS=e.KEYBINDING_CONTEXT_TERMINAL_IS_OPEN=e.TERMINAL_VIEW_ID=void 0,e.TERMINAL_VIEW_ID="terminal",e.KEYBINDING_CONTEXT_TERMINAL_IS_OPEN=new D.RawContextKey("terminalIsOpen",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_FOCUS=new D.RawContextKey("terminalFocus",!1,_.localize(0,null)),e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY="terminalShellType",e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE=new D.RawContextKey(e.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY,void 0,{type:"string",description:_.localize(1,null)}),e.KEYBINDING_CONTEXT_TERMINAL_ALT_BUFFER_ACTIVE=new D.RawContextKey("terminalAltBufferActive",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FOCUS.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_A11Y_TREE_FOCUS=new D.RawContextKey("terminalA11yTreeFocus",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED=new D.RawContextKey("terminalTextSelected",!1,_.localize(2,null)),e.KEYBINDING_CONTEXT_TERMINAL_TEXT_NOT_SELECTED=e.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE=new D.RawContextKey("terminalFindVisible",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_FIND_NOT_VISIBLE=e.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED=new D.RawContextKey("terminalFindInputFocused",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_FIND_FOCUSED=new D.RawContextKey("terminalFindFocused",!1,!0),e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_NOT_FOCUSED=e.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED.toNegated(),e.KEYBINDING_CONTEXT_TERMINAL_PROCESS_SUPPORTED=new D.RawContextKey("terminalProcessSupported",!1,_.localize(3,null)),e.IS_WORKSPACE_SHELL_ALLOWED_STORAGE_KEY="terminal.integrated.isWorkspaceShellAllowed",e.NEVER_MEASURE_RENDER_TIME_STORAGE_KEY="terminal.integrated.neverMeasureRenderTime",e.TERMINAL_CREATION_COMMANDS=["workbench.action.terminal.toggleTerminal","workbench.action.terminal.new","workbench.action.togglePanel","workbench.action.terminal.focus"],e.SUGGESTED_RENDERER_TYPE="terminal.integrated.suggestedRendererType",e.TerminalCursorStyle={BLOCK:"block",LINE:"line",UNDERLINE:"underline"},e.TERMINAL_CONFIG_SECTION="terminal.integrated",e.TERMINAL_ACTION_CATEGORY=_.localize(4,null),e.DEFAULT_LETTER_SPACING=0,e.MINIMUM_LETTER_SPACING=-5,e.DEFAULT_LINE_HEIGHT=1,e.MINIMUM_FONT_WEIGHT=1,e.MAXIMUM_FONT_WEIGHT=1e3,e.DEFAULT_FONT_WEIGHT="normal",e.DEFAULT_BOLD_FONT_WEIGHT="bold",e.SUGGESTIONS_FONT_WEIGHT=["normal","bold","100","200","300","400","500","600","700","800","900"],e.DEFAULT_LOCAL_ECHO_EXCLUDE=["vim","vi","nano","tmux"];var R;(function(y){y[y.UNINITIALIZED=0]="UNINITIALIZED",y[y.LAUNCHING=1]="LAUNCHING",y[y.RUNNING=2]="RUNNING",y[y.KILLED_DURING_LAUNCH=3]="KILLED_DURING_LAUNCH",y[y.KILLED_BY_USER=4]="KILLED_BY_USER",y[y.KILLED_BY_PROCESS=5]="KILLED_BY_PROCESS"})(R=e.ProcessState||(e.ProcessState={}));var I;(function(y){y[y.Fedora=0]="Fedora",y[y.Ubuntu=1]="Ubuntu",y[y.Unknown=2]="Unknown"})(I=e.LinuxDistro||(e.LinuxDistro={}));var C;(function(y){y[y.Api=0]="Api",y[y.Process=1]="Process",y[y.Sequence=2]="Sequence"})(C=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(y){y.FIND_NEXT="workbench.action.terminal.findNext",y.FIND_PREVIOUS="workbench.action.terminal.findPrevious",y.TOGGLE="workbench.action.terminal.toggleTerminal",y.KILL="workbench.action.terminal.kill",y.QUICK_KILL="workbench.action.terminal.quickKill",y.CONFIGURE_TERMINAL_SETTINGS="workbench.action.terminal.openSettings",y.COPY_SELECTION="workbench.action.terminal.copySelection",y.SELECT_ALL="workbench.action.terminal.selectAll",y.DELETE_WORD_LEFT="workbench.action.terminal.deleteWordLeft",y.DELETE_WORD_RIGHT="workbench.action.terminal.deleteWordRight",y.DELETE_TO_LINE_START="workbench.action.terminal.deleteToLineStart",y.MOVE_TO_LINE_START="workbench.action.terminal.moveToLineStart",y.MOVE_TO_LINE_END="workbench.action.terminal.moveToLineEnd",y.NEW="workbench.action.terminal.new",y.NEW_WITH_CWD="workbench.action.terminal.newWithCwd",y.NEW_LOCAL="workbench.action.terminal.newLocal",y.NEW_IN_ACTIVE_WORKSPACE="workbench.action.terminal.newInActiveWorkspace",y.SPLIT="workbench.action.terminal.split",y.SPLIT_IN_ACTIVE_WORKSPACE="workbench.action.terminal.splitInActiveWorkspace",y.RELAUNCH="workbench.action.terminal.relaunch",y.FOCUS_PREVIOUS_PANE="workbench.action.terminal.focusPreviousPane",y.FOCUS_NEXT_PANE="workbench.action.terminal.focusNextPane",y.RESIZE_PANE_LEFT="workbench.action.terminal.resizePaneLeft",y.RESIZE_PANE_RIGHT="workbench.action.terminal.resizePaneRight",y.RESIZE_PANE_UP="workbench.action.terminal.resizePaneUp",y.RESIZE_PANE_DOWN="workbench.action.terminal.resizePaneDown",y.FOCUS="workbench.action.terminal.focus",y.FOCUS_NEXT="workbench.action.terminal.focusNext",y.FOCUS_PREVIOUS="workbench.action.terminal.focusPrevious",y.PASTE="workbench.action.terminal.paste",y.SELECT_DEFAULT_SHELL="workbench.action.terminal.selectDefaultShell",y.RUN_SELECTED_TEXT="workbench.action.terminal.runSelectedText",y.RUN_ACTIVE_FILE="workbench.action.terminal.runActiveFile",y.SWITCH_TERMINAL="workbench.action.terminal.switchTerminal",y.SCROLL_DOWN_LINE="workbench.action.terminal.scrollDown",y.SCROLL_DOWN_PAGE="workbench.action.terminal.scrollDownPage",y.SCROLL_TO_BOTTOM="workbench.action.terminal.scrollToBottom",y.SCROLL_UP_LINE="workbench.action.terminal.scrollUp",y.SCROLL_UP_PAGE="workbench.action.terminal.scrollUpPage",y.SCROLL_TO_TOP="workbench.action.terminal.scrollToTop",y.CLEAR="workbench.action.terminal.clear",y.CLEAR_SELECTION="workbench.action.terminal.clearSelection",y.MANAGE_WORKSPACE_SHELL_PERMISSIONS="workbench.action.terminal.manageWorkspaceShellPermissions",y.RENAME="workbench.action.terminal.rename",y.RENAME_WITH_ARG="workbench.action.terminal.renameWithArg",y.FIND_FOCUS="workbench.action.terminal.focusFind",y.FIND_HIDE="workbench.action.terminal.hideFind",y.QUICK_OPEN_TERM="workbench.action.quickOpenTerm",y.SCROLL_TO_PREVIOUS_COMMAND="workbench.action.terminal.scrollToPreviousCommand",y.SCROLL_TO_NEXT_COMMAND="workbench.action.terminal.scrollToNextCommand",y.SELECT_TO_PREVIOUS_COMMAND="workbench.action.terminal.selectToPreviousCommand",y.SELECT_TO_NEXT_COMMAND="workbench.action.terminal.selectToNextCommand",y.SELECT_TO_PREVIOUS_LINE="workbench.action.terminal.selectToPreviousLine",y.SELECT_TO_NEXT_LINE="workbench.action.terminal.selectToNextLine",y.TOGGLE_ESCAPE_SEQUENCE_LOGGING="toggleEscapeSequenceLogging",y.SEND_SEQUENCE="workbench.action.terminal.sendSequence",y.TOGGLE_FIND_REGEX="workbench.action.terminal.toggleFindRegex",y.TOGGLE_FIND_WHOLE_WORD="workbench.action.terminal.toggleFindWholeWord",y.TOGGLE_FIND_CASE_SENSITIVE="workbench.action.terminal.toggleFindCaseSensitive",y.NAVIGATION_MODE_EXIT="workbench.action.terminal.navigationModeExit",y.NAVIGATION_MODE_FOCUS_NEXT="workbench.action.terminal.navigationModeFocusNext",y.NAVIGATION_MODE_FOCUS_PREVIOUS="workbench.action.terminal.navigationModeFocusPrevious",y.SHOW_ENVIRONMENT_INFORMATION="workbench.action.terminal.showEnvironmentInformation",y.SEARCH_WORKSPACE="workbench.action.terminal.searchWorkspace",y.ATTACH_TO_REMOTE_TERMINAL="workbench.action.terminal.attachToSession"})(P=e.TERMINAL_COMMAND_ID||(e.TERMINAL_COMMAND_ID={})),e.DEFAULT_COMMANDS_TO_SKIP_SHELL=["workbench.action.terminal.clearSelection","workbench.action.terminal.clear","workbench.action.terminal.copySelection","workbench.action.terminal.deleteToLineStart","workbench.action.terminal.deleteWordLeft","workbench.action.terminal.deleteWordRight","workbench.action.terminal.focusFind","workbench.action.terminal.hideFind","workbench.action.terminal.findNext","workbench.action.terminal.findPrevious","workbench.action.terminal.toggleFindRegex","workbench.action.terminal.toggleFindWholeWord","workbench.action.terminal.toggleFindCaseSensitive","workbench.action.terminal.focusNextPane","workbench.action.terminal.focusNext","workbench.action.terminal.focusPreviousPane","workbench.action.terminal.focusPrevious","workbench.action.terminal.focus","workbench.action.terminal.kill","workbench.action.terminal.moveToLineEnd","workbench.action.terminal.moveToLineStart","workbench.action.terminal.newInActiveWorkspace","workbench.action.terminal.new","workbench.action.terminal.paste","workbench.action.terminal.resizePaneDown","workbench.action.terminal.resizePaneLeft","workbench.action.terminal.resizePaneRight","workbench.action.terminal.resizePaneUp","workbench.action.terminal.runActiveFile","workbench.action.terminal.runSelectedText","workbench.action.terminal.scrollDown","workbench.action.terminal.scrollDownPage","workbench.action.terminal.scrollToBottom","workbench.action.terminal.scrollToNextCommand","workbench.action.terminal.scrollToPreviousCommand","workbench.action.terminal.scrollToTop","workbench.action.terminal.scrollUp","workbench.action.terminal.scrollUpPage","workbench.action.terminal.sendSequence","workbench.action.terminal.selectAll","workbench.action.terminal.selectToNextCommand","workbench.action.terminal.selectToNextLine","workbench.action.terminal.selectToPreviousCommand","workbench.action.terminal.selectToPreviousLine","workbench.action.terminal.splitInActiveWorkspace","workbench.action.terminal.split","workbench.action.terminal.toggleTerminal","workbench.action.terminal.navigationModeExit","workbench.action.terminal.navigationModeFocusNext","workbench.action.terminal.navigationModeFocusPrevious","editor.action.toggleTabFocusMode","workbench.action.quickOpen","workbench.action.quickOpenPreviousEditor","workbench.action.showCommands","workbench.action.tasks.build","workbench.action.tasks.restartTask","workbench.action.tasks.runTask","workbench.action.tasks.reRunTask","workbench.action.tasks.showLog","workbench.action.tasks.showTasks","workbench.action.tasks.terminate","workbench.action.tasks.test","workbench.action.toggleFullScreen","workbench.action.terminal.focusAtIndex1","workbench.action.terminal.focusAtIndex2","workbench.action.terminal.focusAtIndex3","workbench.action.terminal.focusAtIndex4","workbench.action.terminal.focusAtIndex5","workbench.action.terminal.focusAtIndex6","workbench.action.terminal.focusAtIndex7","workbench.action.terminal.focusAtIndex8","workbench.action.terminal.focusAtIndex9","workbench.action.focusSecondEditorGroup","workbench.action.focusThirdEditorGroup","workbench.action.focusFourthEditorGroup","workbench.action.focusFifthEditorGroup","workbench.action.focusSixthEditorGroup","workbench.action.focusSeventhEditorGroup","workbench.action.focusEighthEditorGroup","workbench.action.focusNextPart","workbench.action.focusPreviousPart","workbench.action.nextPanelView","workbench.action.previousPanelView","workbench.action.nextSideBarView","workbench.action.previousSideBarView","workbench.action.debug.start","workbench.action.debug.stop","workbench.action.debug.run","workbench.action.debug.restart","workbench.action.debug.continue","workbench.action.debug.pause","workbench.action.debug.stepInto","workbench.action.debug.stepOut","workbench.action.debug.stepOver","workbench.action.nextEditor","workbench.action.previousEditor","workbench.action.nextEditorInGroup","workbench.action.previousEditorInGroup","workbench.action.openNextRecentlyUsedEditor","workbench.action.openPreviousRecentlyUsedEditor","workbench.action.openNextRecentlyUsedEditorInGroup","workbench.action.openPreviousRecentlyUsedEditorInGroup","workbench.action.quickOpenPreviousRecentlyUsedEditor","workbench.action.quickOpenLeastRecentlyUsedEditor","workbench.action.quickOpenPreviousRecentlyUsedEditorInGroup","workbench.action.quickOpenLeastRecentlyUsedEditorInGroup","workbench.action.focusActiveEditorGroup","workbench.action.focusFirstEditorGroup","workbench.action.focusLastEditorGroup","workbench.action.firstEditorInGroup","workbench.action.lastEditorInGroup","workbench.action.navigateUp","workbench.action.navigateDown","workbench.action.navigateRight","workbench.action.navigateLeft","workbench.action.togglePanel","workbench.action.quickOpenView","workbench.action.toggleMaximizedPanel"],e.terminalContributionsDescriptor={extensionPoint:"terminal",defaultExtensionKind:"workspace",jsonSchema:{description:_.localize(5,null),type:"object",properties:{types:{type:"array",description:_.localize(6,null),items:{type:"object",required:["command","title"],properties:{command:{description:_.localize(7,null),type:"string"},title:{description:_.localize(8,null),type:"string"}}}}}}}}),define(me[208],pe([0,1,7,10,132]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.escapeNonWindowsPath=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function I(a,t){if(!!t)if(D.isWindows)for(const r in t){let s=r;for(const n in a)if(r.toLowerCase()===n.toLowerCase()){s=n;break}const o=t[r];C(a,s,o)}else Object.keys(t).forEach(r=>{const s=t[r];C(a,r,s)})}e.mergeEnvironments=I;function C(a,t,r){typeof r=="string"?a[t]=r:delete a[t]}function P(a,t,r,s){a.TERM_PROGRAM="vscode",t&&(a.TERM_PROGRAM_VERSION=t),T(a,s)&&(a.LANG=k(r)),a.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=P;function y(a,t){if(!!t)for(const r of Object.keys(t)){const s=t[r];s&&(a[r]=s)}}function i(a,t){return Object.keys(t).forEach(r=>{const s=t[r];if(typeof s=="string")try{t[r]=a(s)}catch(o){t[r]=s}}),t}function T(a,t){if(t==="on")return!0;if(t==="auto"){const r=a.LANG;return!r||r.search(/\.UTF\-8$/)===-1&&r.search(/\.utf8$/)===-1&&r.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=T;function k(a){const t=a?a.split("-"):[],r=t.length;if(r===0)return"en_US.UTF-8";if(r===1){const s={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in s&&t.push(s[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.getLangEnvVariable=k;function w(a,t,r,s,o,n){if(a.cwd){const p=typeof a.cwd=="object"?a.cwd.fsPath:a.cwd,E=f(p,r);return l(E||p)}let c;return!a.ignoreConfigurationCwd&&o&&(r&&(o=f(o,r,n)),o&&(_.isAbsolute(o)?c=o:s&&(c=_.join(s.fsPath,o)))),c||(c=s?s.fsPath:t||""),l(c)}e.getCwd=w;function f(a,t,r){if(t)try{return t(a)}catch(s){r==null||r.error("Could not resolve terminal cwd",s);return}return a}function l(a){return D.platform===3&&a&&a[1]===":"?a[0].toUpperCase()+a.substr(1):a}function m(a){let t=a;t.indexOf("\\")!==0&&(t=t.replace(/\\/g,"\\\\"));const r=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return t=t.replace(r,""),`'${t}'`}e.escapeNonWindowsPath=m;function S(a,t){if(!!t)return r=>t.resolve(a,r)}e.createVariableResolver=S;function g(a,t,r,s,o,n,c,p,E=D.platform){let h=null;p&&(h=d(a,t,"automationShell",E)),h||(h=d(a,t,"shell",E));let v=h||r;if(E===3&&!s&&o){const A=_.join(o,"Sysnative").replace(/\//g,"\\").toLowerCase();v&&v.toLowerCase().indexOf(A)===0&&(v=_.join(o,"System32",v.substr(A.length+1)))}if(v&&E===3&&(v=v.replace(/\//g,"\\")),n)try{v=n(v)}catch(A){c.error("Could not resolve shell",A)}return v}e.getDefaultShell=g;function b(a,t,r,s,o,n=D.platform){if(r&&d(a,t,"automationShell",n))return[];const c=n===3?"windows":n===1?"osx":"linux",p=a(`terminal.integrated.shellArgs.${c}`);let E=(t?p.value:p.userValue)||p.defaultValue;if(!E)return[];if(typeof E=="string"&&n===3)return s?s(E):E;if(s){const h=[];for(const v of E)try{h.push(s(v))}catch(A){o.error(`Could not resolve terminal.integrated.shellArgs.${c}`,A),h.push(v)}E=h}return E}e.getDefaultShellArgs=b;function d(a,t,r,s=D.platform){const n=a(`terminal.integrated.${r}.${s===3?"windows":s===1?"osx":"linux"}`);return(t?n.value:n.userValue)||n.defaultValue}function u(a,t,r,s,o,n,c){let p={};if(a.strictEnv)y(p,a.env);else{y(p,c);const E=Object.assign({},s?t.value:t.userValue);r&&(E&&i(r,E),a.env&&i(r,a.env)),(0,R.sanitizeProcessEnvironment)(p,"VSCODE_IPC_HOOK_CLI"),I(p,E),I(p,a.env),P(p,o,D.locale,n)}return p}e.createTerminalEnvironment=u});var sn=this&&this.__asyncValues||function(Z){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=Z[Symbol.asyncIterator],_;return e?e.call(Z):(Z=typeof __values=="function"?__values(Z):Z[Symbol.iterator](),_={},D("next"),D("throw"),D("return"),_[Symbol.asyncIterator]=function(){return this},_);function D(I){_[I]=Z[I]&&function(C){return new Promise(function(P,y){C=Z[I](C),R(P,y,C.done,C.value)})}}function R(I,C,P,y){Promise.resolve(y).then(function(i){I({value:i,done:P})},C)}};define(me[209],pe([0,1,34,10,25,14,7,99,188,207]),function(Z,e,_,D,R,I,C,P,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableShells=e.linuxDistro=void 0;let T=i.LinuxDistro.Unknown;if(D.isLinux){const m="/etc/os-release";R.SymlinkSupport.existsFile(m).then(async S=>{if(!!S){const b=(await _.promises.readFile(m)).toString();/NAME="?Fedora"?/.test(b)?T=i.LinuxDistro.Fedora:/NAME="?Ubuntu"?/.test(b)&&(T=i.LinuxDistro.Ubuntu)}})}e.linuxDistro=T;function k(){return D.isWindows?w():f()}e.detectAvailableShells=k;async function w(){var m,S;const g=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${process.env.windir}\\${g?"Sysnative":"System32"}`;let d=!1;(0,y.getWindowsBuildNumber)()>=16299&&(d=!0);const u={"Command Prompt":[`${b}\\cmd.exe`],"WSL Bash":[`${b}\\${d?"wsl.exe":"bash.exe"}`],"Git Bash":[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`]};try{for(var a=sn((0,P.enumeratePowerShellInstallations)()),t;t=await a.next(),!t.done;){const o=t.value;u[o.displayName]=[o.exePath]}}catch(o){m={error:o}}finally{try{t&&!t.done&&(S=a.return)&&await S.call(a)}finally{if(m)throw m.error}}const r=[];Object.keys(u).forEach(o=>r.push(l(o,u[o])));const s=await Promise.all(r);return(0,I.coalesce)(s)}async function f(){return(await _.promises.readFile("/etc/shells","utf8")).split(`
`).filter(g=>g.trim().indexOf("#")!==0&&g.trim().length>0).map(g=>({label:(0,C.basename)(g),path:g}))}async function l(m,S){if(S.length===0)return Promise.resolve(void 0);const g=S.shift();if(g==="")return l(m,S);try{const b=await _.promises.stat((0,C.normalize)(g));if(b.isFile()||b.isSymbolicLink())return{label:m,path:g}}catch(b){try{const d=await _.promises.lstat((0,C.normalize)(g));if(d.isFile()||d.isSymbolicLink())return{label:m,path:g}}catch(d){}}return l(m,S)}}),define(me[210],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=void 0;var _;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.Remove=2]="Remove",C[C.DeltaDiscoverComplete=3]="DeltaDiscoverComplete",C[C.DeltaRootsComplete=4]="DeltaRootsComplete"})(_=e.TestDiffOpType||(e.TestDiffOpType={}));const D=(C,P)=>`${C}:${P.toString()}`;e.getTestSubscriptionKey=D;class R{add(P){}update(P){}remove(P,y){}complete(){}}e.IncrementalChangeCollector=R;class I{constructor(){this.items=new Map,this.roots=new Set}apply(P){const y=this.createChangeCollector();for(const i of P)switch(i[0]){case 0:{const T=i[1];if(T.parent){if(this.items.has(T.parent)){const k=this.items.get(T.parent);k.children.add(T.item.extId);const w=this.createItem(T,k);this.items.set(T.item.extId,w),y.add(w)}}else{this.roots.add(T.item.extId);const k=this.createItem(T);this.items.set(T.item.extId,k),y.add(k)}break}case 1:{const T=i[1],k=this.items.get(T.item.extId);k&&(Object.assign(k.item,T.item),y.update(k));break}case 2:{const T=this.items.get(i[1]);if(!T)break;T.parent?this.items.get(T.parent).children.delete(T.item.extId):this.roots.delete(T.item.extId);const k=[[i[1]]];for(;k.length;)for(const w of k.pop()){const f=this.items.get(w);f&&(k.push(f.children),this.items.delete(w),y.remove(f,f!==T))}break}case 3:this.updateBusyProviders(i[1]);break;case 4:this.updatePendingRoots(i[1]);break}y.complete()}updateBusyProviders(P){}updatePendingRoots(P){}createChangeCollector(){return new R}}e.AbstractIncrementalTestCollection=I}),define(me[211],pe([0,1,7,37,15,24,10,77,173]),function(Z,e,_,D,R,I,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class i{constructor(k,w,f){if(this._contributedVariables=new Map,this._context=k,this._labelService=w,f)if(C.isWindows){const l=Object.create(null);this._envVariables=l,Object.keys(f).forEach(m=>{l[m.toLowerCase()]=f[m]})}else this._envVariables=f}resolve(k,w){return this.recursiveResolve(k?k.uri:void 0,w)}resolveAnyBase(k,w,f,l){const m=I.deepClone(w);return C.isWindows&&m.windows?Object.keys(m.windows).forEach(S=>m[S]=m.windows[S]):C.isMacintosh&&m.osx?Object.keys(m.osx).forEach(S=>m[S]=m.osx[S]):C.isLinux&&m.linux&&Object.keys(m.linux).forEach(S=>m[S]=m.linux[S]),delete m.windows,delete m.osx,delete m.linux,this.recursiveResolve(k?k.uri:void 0,m,f,l)}resolveAny(k,w,f){return this.resolveAnyBase(k,w,f)}resolveAnyMap(k,w,f){const l=new Map;return{newConfig:this.resolveAnyBase(k,w,f,l),resolvedVariables:l}}resolveWithInteractionReplace(k,w,f,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,w,f,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,w){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,w)}recursiveResolve(k,w,f,l){if(R.isString(w))return this.resolveString(k,w,f,l);if(R.isArray(w))return w.map(m=>this.recursiveResolve(k,m,f,l));if(R.isObject(w)){let m=Object.create(null);return Object.keys(w).forEach(S=>{const g=this.resolveString(k,S,f,l);m[g]=this.recursiveResolve(k,w[S],f,l)}),m}return w}resolveString(k,w,f,l){return w.replace(i.VARIABLE_REGEXP,(S,g)=>{if(g.includes(i.VARIABLE_LHS))return S;let b=this.evaluateSingleVariable(S,g,k,f);return l&&l.set(g,b),b})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}evaluateSingleVariable(k,w,f,l){let m;const S=w.split(":");S.length>1&&(w=S[0],m=S[1]);const g=()=>{const u=this._context.getFilePath();if(u)return u;throw new Error((0,y.localize)(0,null,k))},b=()=>{const u=g();if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return a}throw new Error((0,y.localize)(1,null,k,_.basename(u)))},d=()=>{if(m){const u=this._context.getFolderUri(m);if(u)return u;throw new Error((0,y.localize)(2,null,k,m))}if(f)return f;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,k)):new Error((0,y.localize)(4,null,k))};switch(w){case"env":if(m){if(this._envVariables){const u=this._envVariables[C.isWindows?m.toLowerCase():m];if(R.isString(u))return u}return""}throw new Error((0,y.localize)(5,null,k));case"config":if(m){const u=this._context.getConfigurationValue(f,m);if(R.isUndefinedOrNull(u))throw new Error((0,y.localize)(6,null,k,m));if(R.isObject(u))throw new Error((0,y.localize)(7,null,k,m));return u}throw new Error((0,y.localize)(8,null,k));case"command":return this.resolveFromMap(k,m,l,"command");case"input":return this.resolveFromMap(k,m,l,"input");default:switch(w){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(d()));case"cwd":return f||m?(0,P.normalizeDriveLetter)(this.fsPath(d())):D.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return _.basename(this.fsPath(d()));case"lineNumber":const u=this._context.getLineNumber();if(u)return u;throw new Error((0,y.localize)(9,null,k));case"selectedText":const a=this._context.getSelectedText();if(a)return a;throw new Error((0,y.localize)(10,null,k));case"file":return g();case"fileWorkspaceFolder":return b();case"relativeFile":return f||m?_.relative(this.fsPath(d()),g()):g();case"relativeFileDirname":const t=_.dirname(g());if(f||m){const n=_.relative(this.fsPath(d()),t);return n.length===0?".":n}return t;case"fileDirname":return _.dirname(g());case"fileExtname":return _.extname(g());case"fileBasename":return _.basename(g());case"fileBasenameNoExtension":const r=_.basename(g());return r.slice(0,r.length-_.extname(r).length);case"fileDirnameBasename":return _.basename(_.dirname(g()));case"execPath":const s=this._context.getExecPath();return s||k;case"execInstallFolder":const o=this._context.getAppRoot();return o||k;case"pathSeparator":return _.sep;default:try{const n=m?`${w}:${m}`:w;return this.resolveFromMap(k,n,l,void 0)}catch(n){return k}}}}resolveFromMap(k,w,f,l){if(w&&f){const m=l===void 0?f[w]:f[l+":"+w];if(typeof m=="string")return m;throw new Error((0,y.localize)(11,null,k))}return k}}e.AbstractVariableResolverService=i,i.VARIABLE_LHS="${",i.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[212],pe([0,1,4]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,_.createDecorator)("editorGroupsService");var D;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var R;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var C;(function(w){w[w.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var P;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(P=e.MergeGroupMode||(e.MergeGroupMode={}));var y;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(y=e.GroupsOrder||(e.GroupsOrder={}));var i;(function(w){w[w.GROUP_ACTIVE=0]="GROUP_ACTIVE",w[w.GROUP_INDEX=1]="GROUP_INDEX",w[w.EDITOR_OPEN=2]="EDITOR_OPEN",w[w.EDITOR_CLOSE=3]="EDITOR_CLOSE",w[w.EDITOR_MOVE=4]="EDITOR_MOVE",w[w.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",w[w.EDITOR_LABEL=6]="EDITOR_LABEL",w[w.EDITOR_PIN=7]="EDITOR_PIN",w[w.EDITOR_STICKY=8]="EDITOR_STICKY",w[w.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(i=e.GroupChangeKind||(e.GroupChangeKind={}));var T;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function k(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=k}),define(me[213],pe([0,1,4]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,_.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(me[20],pe([0,1,81,8,174,2,44,94,109,213,15,284,58,24,14,51]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.TestState=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var S;(function(_e){function De(ee){const{selectionStartLineNumber:Ae,selectionStartColumn:Re,positionLineNumber:Ze,positionColumn:Le}=ee,it=new D.Position(Ae-1,Re-1),st=new D.Position(Ze-1,Le-1);return new D.Selection(it,st)}_e.to=De;function de(ee){const{anchor:Ae,active:Re}=ee;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Re.line+1,positionColumn:Re.character+1}}_e.from=de})(S=e.Selection||(e.Selection={}));var g;(function(_e){function De(ee){if(!!ee){const{start:Ae,end:Re}=ee;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Re.line+1,endColumn:Re.character+1}}}_e.from=De;function de(ee){if(!!ee){const{startLineNumber:Ae,startColumn:Re,endLineNumber:Ze,endColumn:Le}=ee;return new D.Range(Ae-1,Re-1,Ze-1,Le-1)}}_e.to=de})(g=e.Range||(e.Range={}));var b;(function(_e){function De(de){switch(de){case 1:return D.StandardTokenType.Comment;case 0:return D.StandardTokenType.Other;case 4:return D.StandardTokenType.RegEx;case 2:return D.StandardTokenType.String}}_e.to=De})(b=e.TokenType||(e.TokenType={}));var d;(function(_e){function De(ee){return new D.Position(ee.lineNumber-1,ee.column-1)}_e.to=De;function de(ee){return{lineNumber:ee.line+1,column:ee.character+1}}_e.from=de})(d=e.Position||(e.Position={}));var u;(function(_e){function De(ee){switch(ee){case D.DiagnosticTag.Unnecessary:return 1;case D.DiagnosticTag.Deprecated:return 2}}_e.from=De;function de(ee){switch(ee){case 1:return D.DiagnosticTag.Unnecessary;case 2:return D.DiagnosticTag.Deprecated;default:return}}_e.to=de})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var a;(function(_e){function De(ee){let Ae;return ee.code&&((0,T.isString)(ee.code)||(0,T.isNumber)(ee.code)?Ae=String(ee.code):Ae={value:String(ee.code.value),target:ee.code.target}),Object.assign(Object.assign({},g.from(ee.range)),{message:ee.message,source:ee.source,code:Ae,severity:r.from(ee.severity),relatedInformation:ee.relatedInformation&&ee.relatedInformation.map(t.from),tags:Array.isArray(ee.tags)?(0,l.coalesce)(ee.tags.map(u.from)):void 0})}_e.from=De;function de(ee){var Ae;const Re=new D.Diagnostic(g.to(ee),ee.message,r.to(ee.severity));return Re.source=ee.source,Re.code=(0,T.isString)(ee.code)?ee.code:(Ae=ee.code)===null||Ae===void 0?void 0:Ae.value,Re.relatedInformation=ee.relatedInformation&&ee.relatedInformation.map(t.to),Re.tags=ee.tags&&(0,l.coalesce)(ee.tags.map(u.to)),Re}_e.to=de})(a=e.Diagnostic||(e.Diagnostic={}));var t;(function(_e){function De(ee){return Object.assign(Object.assign({},g.from(ee.location.range)),{message:ee.message,resource:ee.location.uri})}_e.from=De;function de(ee){return new D.DiagnosticRelatedInformation(new D.Location(ee.resource,g.to(ee)),ee.message)}_e.to=de})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var r;(function(_e){function De(ee){switch(ee){case D.DiagnosticSeverity.Error:return y.MarkerSeverity.Error;case D.DiagnosticSeverity.Warning:return y.MarkerSeverity.Warning;case D.DiagnosticSeverity.Information:return y.MarkerSeverity.Info;case D.DiagnosticSeverity.Hint:return y.MarkerSeverity.Hint}return y.MarkerSeverity.Error}_e.from=De;function de(ee){switch(ee){case y.MarkerSeverity.Info:return D.DiagnosticSeverity.Information;case y.MarkerSeverity.Warning:return D.DiagnosticSeverity.Warning;case y.MarkerSeverity.Error:return D.DiagnosticSeverity.Error;case y.MarkerSeverity.Hint:return D.DiagnosticSeverity.Hint;default:return D.DiagnosticSeverity.Error}}_e.to=de})(r=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(_e){function De(ee){return typeof ee=="number"&&ee>=D.ViewColumn.One?ee-1:ee===D.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}_e.from=De;function de(ee){if(typeof ee=="number"&&ee>=0)return ee+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=de})(s=e.ViewColumn||(e.ViewColumn={}));function o(_e){return typeof _e.range!="undefined"}function n(_e){return _e.length===0?!0:!!o(_e[0])}e.isDecorationOptionsArr=n;var c;(function(_e){function De(Le){return Le.map(_e.from)}_e.fromMany=De;function de(Le){return Le&&typeof Le=="object"&&typeof Le.language=="string"&&typeof Le.value=="string"}function ee(Le){let it;if(de(Le)){const{language:ot,value:ut}=Le;it={value:"```"+ot+`
`+ut+"\n```\n"}}else D.MarkdownString.isMarkdownString(Le)?it={value:Le.value,isTrusted:Le.isTrusted,supportThemeIcons:Le.supportThemeIcons}:typeof Le=="string"?it={value:Le}:it={value:""};const st=Object.create(null);it.uris=st;const Ke=ot=>{try{let ut=I.URI.parse(ot,!0);ut=ut.with({query:Ae(ut.query,st)}),st[ot]=ut}catch(ut){}return""},ct=new k.Renderer;return ct.link=Ke,ct.image=ot=>Ke(P.parseHrefAndDimensions(ot).href),k(it.value,{renderer:ct}),it}_e.from=ee;function Ae(Le,it){if(!Le)return Le;let st;try{st=(0,w.parse)(Le)}catch(ct){}if(!st)return Le;let Ke=!1;return st=(0,f.cloneAndChange)(st,ct=>{if(I.URI.isUri(ct)){const ot=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[ot]=ct,Ke=!0,ot}else return}),Ke?JSON.stringify(st):Le}function Re(Le){const it=new D.MarkdownString(Le.value,Le.supportThemeIcons);return it.isTrusted=Le.isTrusted,it}_e.to=Re;function Ze(Le){if(!!Le)return typeof Le=="string"?Le:_e.from(Le)}_e.fromStrict=Ze})(c=e.MarkdownString||(e.MarkdownString={}));function p(_e){return n(_e)?_e.map(De=>({range:g.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?c.fromMany(De.hoverMessage):De.hoverMessage?c.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):_e.map(De=>({range:g.from(De)}))}e.fromRangeOrRangeWithMessage=p;function E(_e){return typeof _e=="undefined"?_e:typeof _e=="string"?I.URI.file(_e):_e}e.pathOrURIToURI=E;var h;(function(_e){function De(de){return typeof de=="undefined"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?E(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}_e.from=De})(h=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var v;(function(_e){function De(de){return typeof de=="undefined"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?E(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?h.from(de.before):void 0,after:de.after?h.from(de.after):void 0}}_e.from=De})(v=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var A;(function(_e){function De(de){if(typeof de=="undefined")return de;switch(de){case D.DecorationRangeBehavior.OpenOpen:return 0;case D.DecorationRangeBehavior.ClosedClosed:return 1;case D.DecorationRangeBehavior.OpenClosed:return 2;case D.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=De})(A=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var F;(function(_e){function De(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?A.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?v.from(de.light):void 0,dark:de.dark?v.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?E(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?h.from(de.before):void 0,after:de.after?h.from(de.after):void 0}}_e.from=De})(F=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var x;(function(_e){function De(ee){return{text:ee.newText,eol:ee.newEol&&ie.from(ee.newEol),range:g.from(ee.range)}}_e.from=De;function de(ee){const Ae=new D.TextEdit(g.to(ee.range),ee.text);return Ae.newEol=typeof ee.eol=="undefined"?void 0:ie.to(ee.eol),Ae}_e.to=de})(x=e.TextEdit||(e.TextEdit={}));var j;(function(_e){function De(ee,Ae,Re){var Ze,Le,it;const st={edits:[]};if(ee instanceof D.WorkspaceEdit)for(let Ke of ee._allEntries())if(Ke._type===1)st.edits.push({_type:1,oldUri:Ke.from,newUri:Ke.to,options:Ke.options,metadata:Ke.metadata});else if(Ke._type===2){const ct=Ae==null?void 0:Ae.getDocument(Ke.uri);st.edits.push({_type:2,resource:Ke.uri,edit:x.from(Ke.edit),modelVersionId:ct==null?void 0:ct.version,metadata:Ke.metadata})}else Ke._type===3?st.edits.push({_type:3,metadata:Ke.metadata,resource:Ke.uri,edit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:(Ze=Re==null?void 0:Re.lookupNotebookDocument(Ke.uri))===null||Ze===void 0?void 0:Ze.notebookDocument.version}):Ke._type===4?(Ke.newOutputs&&st.edits.push({_type:3,metadata:Ke.metadata,resource:Ke.uri,edit:{editType:2,index:Ke.index,append:Ke.append,outputs:Ke.newOutputs.map(ye.from)}}),Ke.newMetadata&&st.edits.push({_type:3,metadata:Ke.metadata,resource:Ke.uri,edit:{editType:3,index:Ke.index,metadata:Ke.newMetadata}})):Ke._type===5?st.edits.push({_type:3,metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:(Le=Re==null?void 0:Re.lookupNotebookDocument(Ke.uri))===null||Le===void 0?void 0:Le.notebookDocument.version,edit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(ue.from)}}):Ke._type===6&&st.edits.push({_type:3,metadata:Ke.metadata,resource:Ke.uri,edit:{editType:10,index:Ke.index,outputId:Ke.outputId,items:((it=Ke.newOutputItems)===null||it===void 0?void 0:it.map(fe.from))||[],append:Ke.append}});return st}_e.from=De;function de(ee){const Ae=new D.WorkspaceEdit;for(const Re of ee.edits)Re.edit?Ae.replace(I.URI.revive(Re.resource),g.to(Re.edit.range),Re.edit.text):Ae.renameFile(I.URI.revive(Re.oldUri),I.URI.revive(Re.newUri),Re.options);return Ae}_e.to=de})(j=e.WorkspaceEdit||(e.WorkspaceEdit={}));var G;(function(_e){const De=Object.create(null);De[D.SymbolKind.File]=0,De[D.SymbolKind.Module]=1,De[D.SymbolKind.Namespace]=2,De[D.SymbolKind.Package]=3,De[D.SymbolKind.Class]=4,De[D.SymbolKind.Method]=5,De[D.SymbolKind.Property]=6,De[D.SymbolKind.Field]=7,De[D.SymbolKind.Constructor]=8,De[D.SymbolKind.Enum]=9,De[D.SymbolKind.Interface]=10,De[D.SymbolKind.Function]=11,De[D.SymbolKind.Variable]=12,De[D.SymbolKind.Constant]=13,De[D.SymbolKind.String]=14,De[D.SymbolKind.Number]=15,De[D.SymbolKind.Boolean]=16,De[D.SymbolKind.Array]=17,De[D.SymbolKind.Object]=18,De[D.SymbolKind.Key]=19,De[D.SymbolKind.Null]=20,De[D.SymbolKind.EnumMember]=21,De[D.SymbolKind.Struct]=22,De[D.SymbolKind.Event]=23,De[D.SymbolKind.Operator]=24,De[D.SymbolKind.TypeParameter]=25;function de(Ae){return typeof De[Ae]=="number"?De[Ae]:6}_e.from=de;function ee(Ae){for(const Re in De)if(De[Re]===Ae)return Number(Re);return D.SymbolKind.Property}_e.to=ee})(G=e.SymbolKind||(e.SymbolKind={}));var B;(function(_e){function De(ee){switch(ee){case D.SymbolTag.Deprecated:return 1}}_e.from=De;function de(ee){switch(ee){case 1:return D.SymbolTag.Deprecated}}_e.to=de})(B=e.SymbolTag||(e.SymbolTag={}));var J;(function(_e){function De(ee){return{name:ee.name,kind:G.from(ee.kind),tags:ee.tags&&ee.tags.map(B.from),containerName:ee.containerName,location:M.from(ee.location)}}_e.from=De;function de(ee){const Ae=new D.SymbolInformation(ee.name,G.to(ee.kind),ee.containerName,M.to(ee.location));return Ae.tags=ee.tags&&ee.tags.map(B.to),Ae}_e.to=de})(J=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var O;(function(_e){function De(ee){var Ae,Re;const Ze={name:ee.name||"!!MISSING: name!!",detail:ee.detail,range:g.from(ee.range),selectionRange:g.from(ee.selectionRange),kind:G.from(ee.kind),tags:(Re=(Ae=ee.tags)===null||Ae===void 0?void 0:Ae.map(B.from))!==null&&Re!==void 0?Re:[]};return ee.children&&(Ze.children=ee.children.map(De)),Ze}_e.from=De;function de(ee){const Ae=new D.DocumentSymbol(ee.name,ee.detail,G.to(ee.kind),g.to(ee.range),g.to(ee.selectionRange));return(0,l.isNonEmptyArray)(ee.tags)&&(Ae.tags=ee.tags.map(B.to)),ee.children&&(Ae.children=ee.children.map(de)),Ae}_e.to=de})(O=e.DocumentSymbol||(e.DocumentSymbol={}));var N;(function(_e){function De(de){const ee=new D.CallHierarchyItem(G.to(de.kind),de.name,de.detail||"",I.URI.revive(de.uri),g.to(de.range),g.to(de.selectionRange));return ee._sessionId=de._sessionId,ee._itemId=de._itemId,ee}_e.to=De})(N=e.CallHierarchyItem||(e.CallHierarchyItem={}));var U;(function(_e){function De(de){return new D.CallHierarchyIncomingCall(N.to(de.from),de.fromRanges.map(ee=>g.to(ee)))}_e.to=De})(U=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var L;(function(_e){function De(de){return new D.CallHierarchyOutgoingCall(N.to(de.to),de.fromRanges.map(ee=>g.to(ee)))}_e.to=De})(L=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var M;(function(_e){function De(ee){return{range:ee.range&&g.from(ee.range),uri:ee.uri}}_e.from=De;function de(ee){return new D.Location(I.URI.revive(ee.uri),g.to(ee.range))}_e.to=de})(M=e.location||(e.location={}));var V;(function(_e){function De(ee){const Ae=ee,Re=ee;return{originSelectionRange:Ae.originSelectionRange?g.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Re.uri,range:g.from(Ae.targetRange?Ae.targetRange:Re.range),targetSelectionRange:Ae.targetSelectionRange?g.from(Ae.targetSelectionRange):void 0}}_e.from=De;function de(ee){return{targetUri:I.URI.revive(ee.uri),targetRange:g.to(ee.range),targetSelectionRange:ee.targetSelectionRange?g.to(ee.targetSelectionRange):void 0,originSelectionRange:ee.originSelectionRange?g.to(ee.originSelectionRange):void 0}}_e.to=de})(V=e.DefinitionLink||(e.DefinitionLink={}));var K;(function(_e){function De(ee){return{range:g.from(ee.range),contents:c.fromMany(ee.contents)}}_e.from=De;function de(ee){return new D.Hover(ee.contents.map(c.to),g.to(ee.range))}_e.to=de})(K=e.Hover||(e.Hover={}));var se;(function(_e){function De(ee){return{range:g.from(ee.range),expression:ee.expression}}_e.from=De;function de(ee){return new D.EvaluatableExpression(g.to(ee.range),ee.expression)}_e.to=de})(se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ce;(function(_e){function De(ee){if(ee instanceof D.InlineValueText)return{type:"text",range:g.from(ee.range),text:ee.text};if(ee instanceof D.InlineValueVariableLookup)return{type:"variable",range:g.from(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};if(ee instanceof D.InlineValueEvaluatableExpression)return{type:"expression",range:g.from(ee.range),expression:ee.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=De;function de(ee){switch(ee.type){case"text":return{range:g.to(ee.range),text:ee.text};case"variable":return{range:g.to(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};case"expression":return{range:g.to(ee.range),expression:ee.expression}}}_e.to=de})(ce=e.InlineValue||(e.InlineValue={}));var we;(function(_e){function De(ee){return{frameId:ee.frameId,stoppedLocation:g.from(ee.stoppedLocation)}}_e.from=De;function de(ee){return new D.InlineValueContext(ee.frameId,g.to(ee.stoppedLocation))}_e.to=de})(we=e.InlineValueContext||(e.InlineValueContext={}));var Te;(function(_e){function De(ee){return{range:g.from(ee.range),kind:ee.kind}}_e.from=De;function de(ee){return new D.DocumentHighlight(g.to(ee.range),ee.kind)}_e.to=de})(Te=e.DocumentHighlight||(e.DocumentHighlight={}));var Ie;(function(_e){function De(de){switch(de){case 1:return D.CompletionTriggerKind.TriggerCharacter;case 2:return D.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return D.CompletionTriggerKind.Invoke}}_e.to=De})(Ie=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Me;(function(_e){function De(de){return{triggerKind:Ie.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}_e.to=De})(Me=e.CompletionContext||(e.CompletionContext={}));var H;(function(_e){function De(ee){switch(ee){case D.CompletionItemTag.Deprecated:return 1}}_e.from=De;function de(ee){switch(ee){case 1:return D.CompletionItemTag.Deprecated}}_e.to=de})(H=e.CompletionItemTag||(e.CompletionItemTag={}));var Q;(function(_e){const De=new Map([[D.CompletionItemKind.Method,0],[D.CompletionItemKind.Function,1],[D.CompletionItemKind.Constructor,2],[D.CompletionItemKind.Field,3],[D.CompletionItemKind.Variable,4],[D.CompletionItemKind.Class,5],[D.CompletionItemKind.Interface,7],[D.CompletionItemKind.Struct,6],[D.CompletionItemKind.Module,8],[D.CompletionItemKind.Property,9],[D.CompletionItemKind.Unit,12],[D.CompletionItemKind.Value,13],[D.CompletionItemKind.Constant,14],[D.CompletionItemKind.Enum,15],[D.CompletionItemKind.EnumMember,16],[D.CompletionItemKind.Keyword,17],[D.CompletionItemKind.Snippet,27],[D.CompletionItemKind.Text,18],[D.CompletionItemKind.Color,19],[D.CompletionItemKind.File,20],[D.CompletionItemKind.Reference,21],[D.CompletionItemKind.Folder,23],[D.CompletionItemKind.Event,10],[D.CompletionItemKind.Operator,11],[D.CompletionItemKind.TypeParameter,24],[D.CompletionItemKind.Issue,26],[D.CompletionItemKind.User,25]]);function de(Re){var Ze;return(Ze=De.get(Re))!==null&&Ze!==void 0?Ze:9}_e.from=de;const ee=new Map([[0,D.CompletionItemKind.Method],[1,D.CompletionItemKind.Function],[2,D.CompletionItemKind.Constructor],[3,D.CompletionItemKind.Field],[4,D.CompletionItemKind.Variable],[5,D.CompletionItemKind.Class],[7,D.CompletionItemKind.Interface],[6,D.CompletionItemKind.Struct],[8,D.CompletionItemKind.Module],[9,D.CompletionItemKind.Property],[12,D.CompletionItemKind.Unit],[13,D.CompletionItemKind.Value],[14,D.CompletionItemKind.Constant],[15,D.CompletionItemKind.Enum],[16,D.CompletionItemKind.EnumMember],[17,D.CompletionItemKind.Keyword],[27,D.CompletionItemKind.Snippet],[18,D.CompletionItemKind.Text],[19,D.CompletionItemKind.Color],[20,D.CompletionItemKind.File],[21,D.CompletionItemKind.Reference],[23,D.CompletionItemKind.Folder],[10,D.CompletionItemKind.Event],[11,D.CompletionItemKind.Operator],[24,D.CompletionItemKind.TypeParameter],[25,D.CompletionItemKind.User],[26,D.CompletionItemKind.Issue]]);function Ae(Re){var Ze;return(Ze=ee.get(Re))!==null&&Ze!==void 0?Ze:D.CompletionItemKind.Property}_e.to=Ae})(Q=e.CompletionItemKind||(e.CompletionItemKind={}));var ne;(function(_e){function De(de,ee){var Ae;const Re=new D.CompletionItem(typeof de.label=="string"?de.label:de.label.name);return typeof de.label!="string"&&(Re.label2=de.label),Re.insertText=de.insertText,Re.kind=Q.to(de.kind),Re.tags=(Ae=de.tags)===null||Ae===void 0?void 0:Ae.map(H.to),Re.detail=de.detail,Re.documentation=P.isMarkdownString(de.documentation)?c.to(de.documentation):de.documentation,Re.sortText=de.sortText,Re.filterText=de.filterText,Re.preselect=de.preselect,Re.commitCharacters=de.commitCharacters,C.Range.isIRange(de.range)?Re.range=g.to(de.range):typeof de.range=="object"&&(Re.range={inserting:g.to(de.range.insert),replacing:g.to(de.range.replace)}),Re.keepWhitespace=typeof de.insertTextRules=="undefined"?!1:Boolean(de.insertTextRules&1),typeof de.insertTextRules!="undefined"&&de.insertTextRules&4?Re.insertText=new D.SnippetString(de.insertText):(Re.insertText=de.insertText,Re.textEdit=Re.range instanceof D.Range?new D.TextEdit(Re.range,Re.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Re.additionalTextEdits=de.additionalTextEdits.map(Ze=>x.to(Ze))),Re.command=ee&&de.command?ee.fromInternal(de.command):void 0,Re}_e.to=De})(ne=e.CompletionItem||(e.CompletionItem={}));var oe;(function(_e){function De(ee){return{label:ee.label,documentation:ee.documentation?c.fromStrict(ee.documentation):void 0}}_e.from=De;function de(ee){return{label:ee.label,documentation:P.isMarkdownString(ee.documentation)?c.to(ee.documentation):ee.documentation}}_e.to=de})(oe=e.ParameterInformation||(e.ParameterInformation={}));var ge;(function(_e){function De(ee){return{label:ee.label,documentation:ee.documentation?c.fromStrict(ee.documentation):void 0,parameters:Array.isArray(ee.parameters)?ee.parameters.map(oe.from):[],activeParameter:ee.activeParameter}}_e.from=De;function de(ee){return{label:ee.label,documentation:P.isMarkdownString(ee.documentation)?c.to(ee.documentation):ee.documentation,parameters:Array.isArray(ee.parameters)?ee.parameters.map(oe.to):[],activeParameter:ee.activeParameter}}_e.to=de})(ge=e.SignatureInformation||(e.SignatureInformation={}));var Ce;(function(_e){function De(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(ge.from):[]}}_e.from=De;function de(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(ge.to):[]}}_e.to=de})(Ce=e.SignatureHelp||(e.SignatureHelp={}));var Oe;(function(_e){function De(ee){var Ae;return{text:ee.text,range:g.from(ee.range),kind:ve.from((Ae=ee.kind)!==null&&Ae!==void 0?Ae:D.InlineHintKind.Other),description:ee.description&&c.fromStrict(ee.description),whitespaceBefore:ee.whitespaceBefore,whitespaceAfter:ee.whitespaceAfter}}_e.from=De;function de(ee){const Ae=new D.InlineHint(ee.text,g.to(ee.range),ve.to(ee.kind));return Ae.whitespaceAfter=ee.whitespaceAfter,Ae.whitespaceBefore=ee.whitespaceBefore,Ae.description=P.isMarkdownString(ee.description)?c.to(ee.description):ee.description,Ae}_e.to=de})(Oe=e.InlineHint||(e.InlineHint={}));var ve;(function(_e){function De(ee){return ee}_e.from=De;function de(ee){return ee}_e.to=de})(ve=e.InlineHintKind||(e.InlineHintKind={}));var ke;(function(_e){function De(ee){return{range:g.from(ee.range),url:ee.target,tooltip:ee.tooltip}}_e.from=De;function de(ee){let Ae;if(ee.url)try{Ae=typeof ee.url=="string"?I.URI.parse(ee.url,!0):I.URI.revive(ee.url)}catch(Re){}return new D.DocumentLink(g.to(ee.range),Ae)}_e.to=de})(ke=e.DocumentLink||(e.DocumentLink={}));var Pe;(function(_e){function De(ee){const Ae=new D.ColorPresentation(ee.label);return ee.textEdit&&(Ae.textEdit=x.to(ee.textEdit)),ee.additionalTextEdits&&(Ae.additionalTextEdits=ee.additionalTextEdits.map(Re=>x.to(Re))),Ae}_e.to=De;function de(ee){return{label:ee.label,textEdit:ee.textEdit?x.from(ee.textEdit):void 0,additionalTextEdits:ee.additionalTextEdits?ee.additionalTextEdits.map(Ae=>x.from(Ae)):void 0}}_e.from=de})(Pe=e.ColorPresentation||(e.ColorPresentation={}));var Ue;(function(_e){function De(ee){return new D.Color(ee[0],ee[1],ee[2],ee[3])}_e.to=De;function de(ee){return[ee.red,ee.green,ee.blue,ee.alpha]}_e.from=de})(Ue=e.Color||(e.Color={}));var Se;(function(_e){function De(ee){return{range:g.from(ee.range)}}_e.from=De;function de(ee){return new D.SelectionRange(g.to(ee.range))}_e.to=de})(Se=e.SelectionRange||(e.SelectionRange={}));var qe;(function(_e){function De(de){switch(de){case 2:return D.TextDocumentSaveReason.AfterDelay;case 1:return D.TextDocumentSaveReason.Manual;case 3:case 4:return D.TextDocumentSaveReason.FocusOut}}_e.to=De})(qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var X;(function(_e){function De(ee){switch(ee){case D.TextEditorLineNumbersStyle.Off:return 0;case D.TextEditorLineNumbersStyle.Relative:return 2;case D.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=De;function de(ee){switch(ee){case 0:return D.TextEditorLineNumbersStyle.Off;case 2:return D.TextEditorLineNumbersStyle.Relative;case 1:default:return D.TextEditorLineNumbersStyle.On}}_e.to=de})(X=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ie;(function(_e){function De(ee){if(ee===D.EndOfLine.CRLF)return 1;if(ee===D.EndOfLine.LF)return 0}_e.from=De;function de(ee){if(ee===1)return D.EndOfLine.CRLF;if(ee===0)return D.EndOfLine.LF}_e.to=de})(ie=e.EndOfLine||(e.EndOfLine={}));var Ee;(function(_e){function De(de){if(typeof de=="object")return de.viewId;switch(de){case D.ProgressLocation.SourceControl:return 3;case D.ProgressLocation.Window:return 10;case D.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=De})(Ee=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(_e){function De(de){const ee={start:de.start+1,end:de.end+1};return de.kind&&(ee.kind=He.from(de.kind)),ee}_e.from=De})(Ne=e.FoldingRange||(e.FoldingRange={}));var He;(function(_e){function De(de){if(de)switch(de){case D.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case D.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case D.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}_e.from=De})(He=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Be;(function(_e){function De(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?g.from(de.selection):void 0,override:typeof de.override=="boolean"?R.EditorOverride.DISABLED:void 0}}_e.from=De})(Be=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ye;(function(_e){function De(ee){return ee instanceof D.RelativePattern||typeof ee=="string"?ee:de(ee)?new D.RelativePattern(ee.base,ee.pattern):ee}_e.from=De;function de(ee){const Ae=ee;return Ae&&typeof Ae.base=="string"&&typeof Ae.pattern=="string"}})(Ye=e.GlobPattern||(e.GlobPattern={}));var q;(function(_e){function De(de){if(de){if(Array.isArray(de))return de.map(De);if(typeof de=="string")return de;{const ee=de;return{language:ee.language,scheme:ee.scheme,pattern:typeof ee.pattern=="undefined"?void 0:Ye.from(ee.pattern),exclusive:ee.exclusive}}}else return}_e.from=De})(q=e.LanguageSelector||(e.LanguageSelector={}));var ae;(function(_e){function De(ee){return{start:ee.start,end:ee.end}}_e.from=De;function de(ee){return new D.NotebookCellRange(ee.start,ee.end)}_e.to=de})(ae=e.NotebookCellRange||(e.NotebookCellRange={}));var he;(function(_e){function De(de){return new D.NotebookCellMetadata(de.editable,de.breakpointMargin,de.runnable,de.hasExecutionOrder,de.executionOrder,de.runState,de.runStartTime,de.statusMessage,de.lastRunDuration,de.inputCollapsed,de.outputCollapsed,de.custom)}_e.to=De})(he=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var Y;(function(_e){function De(ee){return ee}_e.from=De;function de(ee){return new D.NotebookDocumentMetadata(ee.editable,ee.runnable,ee.cellEditable,ee.cellRunnable,ee.cellHasExecutionOrder,ee.custom,ee.runState,ee.trusted)}_e.to=de})(Y=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var re;(function(_e){function De(ee){switch(ee){case D.NotebookCellKind.Markdown:return m.CellKind.Markdown;case D.NotebookCellKind.Code:default:return m.CellKind.Code}}_e.from=De;function de(ee){switch(ee){case m.CellKind.Markdown:return D.NotebookCellKind.Markdown;case m.CellKind.Code:default:return D.NotebookCellKind.Code}}_e.to=de})(re=e.NotebookCellKind||(e.NotebookCellKind={}));var ue;(function(_e){function De(de){return{cellKind:re.from(de.kind),language:de.language,source:de.source,metadata:de.metadata,outputs:de.outputs?de.outputs.map(ye.from):[]}}_e.from=De})(ue=e.NotebookCellData||(e.NotebookCellData={}));var fe;(function(_e){function De(ee){return{mime:ee.mime,value:ee.value,metadata:ee.metadata}}_e.from=De;function de(ee){return new D.NotebookCellOutputItem(ee.mime,ee.value,ee.metadata)}_e.to=de})(fe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ye;(function(_e){function De(ee){return{outputId:ee.id,outputs:ee.outputs.map(fe.from),metadata:ee.metadata}}_e.from=De;function de(ee){const Ae=ee.outputs.map(fe.to);return new D.NotebookCellOutput(Ae,ee.outputId,ee.metadata)}_e.to=de})(ye=e.NotebookCellOutput||(e.NotebookCellOutput={}));var je;(function(_e){function De(Re){if(Re!=null){if(Re instanceof D.RelativePattern||typeof Re=="string")return Re;if(Ae(Re))return new D.RelativePattern(Re.base,Re.pattern);if(ee(Re))return{include:Ye.from(Re.include)||void 0,exclude:Ye.from(Re.exclude)||void 0}}}_e.from=De;function de(Re){return typeof Re=="string"?Re:Ae(Re)?{base:Re.base,pattern:Re.pattern}:{include:Re.include,exclude:Re.exclude}}_e.to=de;function ee(Re){const Ze=Re,Le=Ye.from(Ze.include);if(!(Le&&Le instanceof D.RelativePattern||typeof Le=="string"))return!1;const it=Ye.from(Ze.exclude);return!!(it&&it instanceof D.RelativePattern||typeof it=="string")}function Ae(Re){const Ze=Re;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(je=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var We;(function(_e){function De(de){return{backgroundColor:de.backgroundColor,borderColor:de.borderColor,top:de.top?h.from(de.top):void 0}}_e.from=De})(We=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ze;(function(_e){function De(ee){return{state:ee.state,duration:ee.duration,messages:ee.messages.map(Xe.from)}}_e.from=De;function de(ee){const Ae=new D.TestState(ee.state);return Ae.duration=ee.duration,Ae.messages=ee.messages.map(Xe.to),Ae}_e.to=de})(ze=e.TestState||(e.TestState={}));var Xe;(function(_e){function De(ee){return{message:c.fromStrict(ee.message)||"",severity:ee.severity,expectedOutput:ee.expectedOutput,actualOutput:ee.actualOutput,location:ee.location?M.from(ee.location):void 0}}_e.from=De;function de(ee){const Ae=new D.TestMessage(typeof ee.message=="string"?ee.message:c.to(ee.message));return Ae.severity=ee.severity,Ae.actualOutput=ee.actualOutput,Ae.expectedOutput=ee.expectedOutput,Ae}_e.to=de})(Xe=e.TestMessage||(e.TestMessage={}));var nt;(function(_e){function De(Ae){var Re,Ze;return{extId:Ae.id,label:Ae.label,location:Ae.location?M.from(Ae.location):void 0,debuggable:(Re=Ae.debuggable)!==null&&Re!==void 0?Re:!1,description:Ae.description,runnable:(Ze=Ae.runnable)!==null&&Ze!==void 0?Ze:!0}}_e.from=De;function de(Ae){return{id:Ae.extId,label:Ae.label,location:Ae.location&&M.to({range:Ae.location.range,uri:I.URI.revive(Ae.location.uri)}),debuggable:Ae.debuggable,description:Ae.description,runnable:Ae.runnable}}_e.toPlainShallow=de;function ee(Ae){const Re=new D.TestItem(Ae.extId,Ae.label);return Ae.location&&(Re.location=M.to({range:Ae.location.range,uri:I.URI.revive(Ae.location.uri)})),Re.debuggable=Ae.debuggable,Re.description=Ae.description,Re.runnable=Ae.runnable,Re}_e.toShallow=ee})(nt=e.TestItem||(e.TestItem={}));var et;(function(_e){function De(Ae,Re){var Ze,Le,it;const st={completedAt:Re.completedAt,id:Ae,items:[]},Ke=[[null,Re.results]];for(;Ke.length;){const[ct,ot]=Ke.pop();for(const ut of ot){const kt={children:(Le=(Ze=ut.children)===null||Ze===void 0?void 0:Ze.map(Dt=>Dt.id))!==null&&Le!==void 0?Le:[],computedState:ut.result.state,item:nt.from(ut),state:ze.from(ut.result),retired:void 0,parent:(it=ct==null?void 0:ct.item.extId)!==null&&it!==void 0?it:null,providerId:"",direct:!ct};st.items.push(kt),ut.children&&Ke.push([kt,ut.children])}}return st}_e.from=De;const de=(Ae,Re)=>Object.assign(Object.assign({},nt.toPlainShallow(Ae.item)),{result:ze.to(Ae.state),children:Ae.children.map(Ze=>Re.get(Ze)).filter(T.isDefined).map(Ze=>de(Ze,Re))});function ee(Ae){const Re=[],Ze=new Map;for(const Le of Ae.items)Ze.set(Le.item.extId,Le),Le.direct&&Re.push(Le);return{completedAt:Ae.completedAt,results:Re.map(Le=>de(Le,Ze))}}_e.to=ee})(et=e.TestResults||(e.TestResults={}));var Je;(function(_e){function De(de){switch(de){case 1:return D.CodeActionTriggerKind.Automatic;case 2:return D.CodeActionTriggerKind.Manual}}_e.to=De})(Je=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(me[214],pe([0,1,2,18,8,20,57]),function(Z,e,_,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(i,T,k,w={timeout:1500,errors:3}){this._logService=i,this._documents=T,this._mainThreadBulkEdits=k,this._thresholds=w,this._callbacks=new C.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(i){return(T,k,w)=>{const l={dispose:this._callbacks.push([T,k,i])};return Array.isArray(w)&&w.push(l),l}}async $participateInSave(i,T){const k=_.URI.revive(i);let w=!1;const f=setTimeout(()=>w=!0,this._thresholds.timeout),l=[];try{for(let m of[...this._callbacks]){if(w)break;const S=this._documents.getDocument(k),g=await this._deliverEventAsyncAndBlameBadListeners(m,{document:S,reason:I.TextDocumentSaveReason.to(T)});l.push(g)}}finally{clearTimeout(f)}return l}_deliverEventAsyncAndBlameBadListeners([i,T,k],w){const f=this._badListeners.get(i);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,i,T,w).then(()=>!0,l=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const m=this._badListeners.get(i);this._badListeners.set(i,m?m+1:1),typeof m=="number"&&m>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(i,T,k,w){const f=[],l=Date.now(),{document:m,reason:S}=w,{version:g}=m,b=Object.freeze({document:m,reason:S,waitUntil(d){if(Object.isFrozen(f))throw(0,D.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(d))}});try{T.apply(k,[b])}catch(d){return Promise.reject(d)}return Object.freeze(f),new Promise((d,u)=>{const a=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${i.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(a),d(t)}).catch(t=>{clearTimeout(a),u(t)})}).then(d=>{const u={edits:[]};for(const a of d)if(Array.isArray(a)&&a.every(t=>t instanceof R.TextEdit))for(const{newText:t,newEol:r,range:s}of a)u.edits.push({_type:2,resource:m.uri,edit:{range:s&&I.Range.from(s),text:t,eol:r&&I.EndOfLine.from(r)}});if(u.edits.length!==0)return g===m.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(me[215],pe([0,1,3,19,33,2,20,8]),function(Z,e,_,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(k,w,f,l,m){this._onDidCreate=new _.Emitter,this._onDidChange=new _.Emitter,this._onDidDelete=new _.Emitter,this._config=0,f&&(this._config+=1),l&&(this._config+=2),m&&(this._config+=4);const S=(0,R.parse)(w),g=k(b=>{if(!f)for(let d of b.created){const u=I.URI.revive(d);S(u.fsPath)&&this._onDidCreate.fire(u)}if(!l)for(let d of b.changed){const u=I.URI.revive(d);S(u.fsPath)&&this._onDidChange.fire(u)}if(!m)for(let d of b.deleted){const u=I.URI.revive(d);S(u.fsPath)&&this._onDidDelete.fire(u)}});this._disposable=P.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,g)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class i{constructor(k,w,f){this._logService=w,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new _.Emitter,this._onDidRenameFile=new _.Emitter,this._onDidCreateFile=new _.Emitter,this._onDidDeleteFile=new _.Emitter,this._onWillRenameFile=new D.AsyncEmitter,this._onWillCreateFile=new D.AsyncEmitter,this._onWillDeleteFile=new D.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(k,w,f,l){return new y(this._onFileSystemEvent.event,k,w,f,l)}$onFileEvent(k){this._onFileSystemEvent.fire(k)}$onDidRunFileOperation(k,w){switch(k){case 2:this._onDidRenameFile.fire(Object.freeze({files:w.map(f=>({oldUri:I.URI.revive(f.source),newUri:I.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:w.map(f=>I.URI.revive(f.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:w.map(f=>I.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(k){return this._createWillExecuteEvent(k,this._onWillRenameFile)}getOnWillCreateFileEvent(k){return this._createWillExecuteEvent(k,this._onWillCreateFile)}getOnWillDeleteFileEvent(k){return this._createWillExecuteEvent(k,this._onWillDeleteFile)}_createWillExecuteEvent(k,w){return(f,l,m)=>{const S=function(b){f.call(l,b)};return S.extension=k,w.event(S,void 0,m)}}async $onWillRunFileOperation(k,w,f,l){switch(k){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:w.map(m=>({oldUri:I.URI.revive(m.source),newUri:I.URI.revive(m.target)}))},f,l);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:w.map(m=>I.URI.revive(m.target))},f,l);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:w.map(m=>I.URI.revive(m.target))},f,l)}}async _fireWillEvent(k,w,f,l){const m=new Set,S=[];if(await k.fireAsync(w,l,async(b,d)=>{var u;const a=Date.now(),t=await Promise.resolve(b);t instanceof P.WorkspaceEdit&&(S.push(t),m.add((u=d.extension.displayName)!==null&&u!==void 0?u:d.extension.identifier.value)),Date.now()-a>f&&this._logService.warn("SLOW file-participant",d.extension.identifier)}),!l.isCancellationRequested&&S.length!==0){const g={edits:[]};for(let b of S){let{edits:d}=C.WorkspaceEdit.from(b,this._extHostDocumentsAndEditors);g.edits=g.edits.concat(d)}return{edit:g,extensionNames:Array.from(m)}}}}e.ExtHostFileSystemEventService=i}),define(me[216],pe([0,1,3,6,11,2,20,51]),function(Z,e,_,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(w,f,l,m){this.start=w,this.deletedCount=f,this.deletedItems=l,this.items=m}static asApiEvent(w){return Object.freeze({start:w.start,deletedCount:w.deletedCount,deletedItems:w.deletedItems,items:w.items.map(f=>f.cell)})}}class i{constructor(w,f,l){var m;this._notebook=w,this._extHostDocument=f,this._cellData=l,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this.handle=l.handle,this.uri=I.URI.revive(l.uri),this.cellKind=l.cellKind,this._outputs=l.outputs.map(C.NotebookCellOutput.to),this._metadata=C.NotebookCellMetadata.to((m=l.metadata)!==null&&m!==void 0?m:{})}static asModelAddData(w,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:w}}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get cell(){if(!this._cell){const w=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return w._notebook.getCellIndex(w)},notebook:w._notebook.notebookDocument,uri:w.uri,cellKind:C.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get language(){return f.document.languageId},get outputs(){return w._outputs.slice(0)},set outputs(l){throw new Error("Use WorkspaceEdit to update cell outputs.")},get metadata(){return w._metadata},set metadata(l){throw new Error("Use WorkspaceEdit to update cell metadata.")}})}return this._cell}setOutputs(w){this._outputs=w.map(C.NotebookCellOutput.to)}setOutputItems(w,f,l){const m=l.map(C.NotebookCellOutputItem.to),S=this._outputs.find(g=>g.id===w);S&&(f||(S.outputs.length=0),S.outputs.push(...m))}setMetadata(w){this._metadata=C.NotebookCellMetadata.to(w)}}e.ExtHostCell=i;class T extends D.Disposable{constructor(w,f,l,m,S,g,b){super();this._proxy=w,this._documentsAndEditors=f,this._emitter=l,this._viewType=m,this._contentOptions=S,this._metadata=g,this.uri=b,this.handle=T._handlePool++,this._cells=[],this._cellDisposableMapping=new Map,this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0,super.dispose(),(0,D.dispose)(this._cellDisposableMapping.values())}get notebookDocument(){if(!this._notebook){const w=this;this._notebook=Object.freeze({get uri(){return w.uri},get version(){return w._versionId},get fileName(){return w.uri.fsPath},get viewType(){return w._viewType},get isDirty(){return w._isDirty},get isUntitled(){return w.uri.scheme===R.Schemas.untitled},get cells(){return w._cells.map(f=>f.cell)},get metadata(){return w._metadata},set metadata(f){throw new Error("Use WorkspaceEdit to update metadata.")},get contentOptions(){return w._contentOptions},save(){return w._save()}})}return this._notebook}updateBackup(w){var f;(f=this._backup)===null||f===void 0||f.delete(),this._backup=w}disposeBackup(){var w;(w=this._backup)===null||w===void 0||w.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(w){const f=Object.assign(Object.assign({},P.notebookDocumentMetadataDefaults),w.metadata);this._metadata=this._metadata.with(f),this._emitter.emitDocumentMetadataChange({document:this.notebookDocument})}acceptModelChanged(w,f){this._versionId=w.versionId,this._isDirty=f,w.rawEvents.forEach(l=>{l.kind===P.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(l.changes,!0),l.kind===P.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(l.changes,!1):l.kind===P.NotebookCellsChangeType.Move?this._moveCell(l.index,l.newIdx):l.kind===P.NotebookCellsChangeType.Output?this._setCellOutputs(l.index,l.outputs):l.kind===P.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(l.index,l.outputId,l.append,l.outputItems):l.kind===P.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(l.index,l.language):l.kind===P.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(l.index,l.metadata)})}async _save(){return this._disposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(w,f){if(!this._disposed){const l=[],m=[],S=[];w.reverse().forEach(g=>{var b;const u=g[2].map(r=>{const s=new i(this,this._documentsAndEditors,r);if(f||m.push(i.asModelAddData(this.notebookDocument,r)),!this._cellDisposableMapping.has(s.handle)){const o=new D.DisposableStore;o.add(s),this._cellDisposableMapping.set(s.handle,o)}return s});for(let r=g[0];r<g[0]+g[1];r++)(b=this._cellDisposableMapping.get(this._cells[r].handle))===null||b===void 0||b.dispose(),this._cellDisposableMapping.delete(this._cells[r].handle);const a=new y(g[0],g[1],[],u),t=this._cells.splice(g[0],g[1],...u);for(let r of t)S.push(r.uri),a.deletedItems.push(r.cell);l.push(a)}),this._documentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:m,removedDocuments:S}),f||this._emitter.emitModelChange({document:this.notebookDocument,changes:l.map(y.asApiEvent)})}}_moveCell(w,f){const l=this._cells.splice(w,1);this._cells.splice(f,0,...l);const m=[{start:w,deletedCount:1,deletedItems:l.map(S=>S.cell),items:[]},{start:f,deletedCount:0,deletedItems:[],items:l.map(S=>S.cell)}];this._emitter.emitModelChange({document:this.notebookDocument,changes:m})}_setCellOutputs(w,f){const l=this._cells[w];l.setOutputs(f),this._emitter.emitCellOutputsChange({document:this.notebookDocument,cells:[l.cell]})}_setCellOutputItems(w,f,l,m){const S=this._cells[w];S.setOutputItems(f,l,m),this._emitter.emitCellOutputsChange({document:this.notebookDocument,cells:[S.cell]})}_changeCellLanguage(w,f){const l=this._cells[w],m={document:this.notebookDocument,cell:l.cell,language:f};this._emitter.emitCellLanguageChange(m)}_changeCellMetadata(w,f){const l=this._cells[w];l.setMetadata(f||{});const m={document:this.notebookDocument,cell:l.cell};this._emitter.emitCellMetadataChange(m)}getCellFromIndex(w){return this._cells[w]}getCell(w){return this._cells.find(f=>f.handle===w)}getCellIndex(w){return this._cells.indexOf(w)}}e.ExtHostNotebookDocument=T,T._handlePool=0}),define(me[217],pe([0,1,3,8,20,51]),function(Z,e,_,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(i){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=i}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(i){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:Object.assign(Object.assign({},I.notebookDocumentMetadataDefaults),i)})}replaceCellMetadata(i,T){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:i,metadata:T})}replaceCellOutput(i,T){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:i,outputs:T.map(k=>R.NotebookCellOutput.from(k))})}replaceCells(i,T,k){this._throwIfFinalized(),!(i===T&&k.length===0)&&this._collectedEdits.push({editType:1,index:i,count:T-i,cells:k.map(R.NotebookCellData.from)})}}class P{constructor(i,T,k,w,f,l,m){this.id=i,this._viewType=T,this._proxy=k,this.notebookData=w,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this._selections=l,this._visibleRanges=f,this._viewColumn=m}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get editor(){if(!this._editor){const i=this;this._editor={get document(){return i.notebookData.notebookDocument},get selection(){var T;const k=i._selections[0];return k&&((T=i.notebookData.getCellFromIndex(k.start))===null||T===void 0?void 0:T.cell)},get selections(){return i._selections},get visibleRanges(){return i._visibleRanges},revealRange(T,k){i._proxy.$tryRevealRange(i.id,R.NotebookCellRange.from(T),k!=null?k:D.NotebookEditorRevealType.Default)},get viewColumn(){return i._viewColumn},get onDidDispose(){return i.onDidDispose},edit(T){const k=new C(this.document.version);return T(k),i._applyEdit(k.finalize())},get kernel(){return i._kernel},setDecorations(T,k){return i.setDecorations(T,k)}}}return this._editor}_acceptKernel(i){this._kernel=i}get visible(){return this._visible}_acceptVisibility(i){this._visible=i}_acceptVisibleRanges(i){this._visibleRanges=i}_acceptSelections(i){this._selections=i}_applyEdit(i){if(i.cellEdits.length===0)return Promise.resolve(!0);const T=[];let k=-1;for(let w=0;w<i.cellEdits.length;w++){if(k<0){T.push(i.cellEdits[w]),k++;continue}const l=T[k];if(l.editType===1&&i.cellEdits[w].editType===1){const m=i.cellEdits[w];if(m.editType!==5&&l.index===m.index){l.cells.push(...i.cellEdits[w].cells),l.count+=i.cellEdits[w].count;continue}}T.push(i.cellEdits[w]),k++}return this._proxy.$tryApplyEdits(this._viewType,this.notebookData.uri,i.documentVersionId,T)}setDecorations(i,T){if(!(T.isEmpty&&!this._hasDecorationsForKey.has(i.key)))return T.isEmpty?this._hasDecorationsForKey.delete(i.key):this._hasDecorationsForKey.add(i.key),this._proxy.$trySetDecorations(this.id,R.NotebookCellRange.from(T),i.key)}}e.ExtHostNotebookEditor=P}),define(me[218],pe([0,1,20,110,160,21,55]),function(Z,e,_,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class P{constructor(k){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=k}withProgress(k,w,f){const l=this._handles++,{title:m,location:S,cancellable:g}=w,b=(0,R.localize)(0,null,k.displayName||k.name);return this._proxy.$startProgress(l,{location:_.ProgressLocation.from(S),title:m,source:b,cancellable:g},k),this._withProgress(l,f,!!g)}_withProgress(k,w,f){let l;f&&(l=new I.CancellationTokenSource,this._mapHandleToCancellationSource.set(k,l));const m=g=>{this._proxy.$progressEnd(g),this._mapHandleToCancellationSource.delete(g),l&&l.dispose()};let S;try{S=w(new i(this._proxy,k),f&&l?l.token:I.CancellationToken.None)}catch(g){throw m(k),g}return S.then(g=>m(k),g=>m(k)),S}$acceptProgressCanceled(k){const w=this._mapHandleToCancellationSource.get(k);w&&(w.cancel(),this._mapHandleToCancellationSource.delete(k))}}e.ExtHostProgress=P;function y(T,k){return T.message=k.message,typeof k.increment=="number"&&(typeof T.increment=="number"?T.increment+=k.increment:T.increment=k.increment),T}class i extends D.Progress{constructor(k,w){super(f=>this.throttledReport(f));this._proxy=k,this._handle=w}throttledReport(k){this._proxy.$progressReport(this._handle,k)}}Ve([(0,C.throttle)(100,(T,k)=>y(T,k),()=>Object.create(null))],i.prototype,"throttledReport",null)}),define(me[120],pe([0,1,53,18,71,20,8]),function(Z,e,_,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(w,f){const l=P._Keys.nextId();w.$registerTextEditorDecorationType(l,I.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:l,dispose(){w.$removeTextEditorDecorationType(l)}})}}e.TextEditorDecorationType=P,P._Keys=new R.IdGenerator("TextEditorDecorationType");class y{constructor(w,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=w,this._documentVersionId=w.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(w,f){this._throwIfFinalized();let l=null;if(w instanceof C.Position)l=new C.Range(w,w);else if(w instanceof C.Range)l=w;else throw new Error("Unrecognized location");this._pushEdit(l,f,!1)}insert(w,f){this._throwIfFinalized(),this._pushEdit(new C.Range(w,w),f,!0)}delete(w){this._throwIfFinalized();let f=null;if(w instanceof C.Range)f=w;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(w,f,l){const m=this._document.validateRange(w);this._collectedEdits.push({range:m,text:f,forceMoveMarkers:l})}setEndOfLine(w){if(this._throwIfFinalized(),w!==C.EndOfLine.LF&&w!==C.EndOfLine.CRLF)throw(0,D.illegalArgument)("endOfLine");this._setEndOfLine=w}}e.TextEditorEdit=y;class i{constructor(w,f,l,m){this._proxy=w,this._id=f,this._accept(l),this._logService=m;const S=this;this.value={get tabSize(){return S._tabSize},set tabSize(g){S._setTabSize(g)},get insertSpaces(){return S._insertSpaces},set insertSpaces(g){S._setInsertSpaces(g)},get cursorStyle(){return S._cursorStyle},set cursorStyle(g){S._setCursorStyle(g)},get lineNumbers(){return S._lineNumbers},set lineNumbers(g){S._setLineNumbers(g)}}}_accept(w){this._tabSize=w.tabSize,this._insertSpaces=w.insertSpaces,this._cursorStyle=w.cursorStyle,this._lineNumbers=I.TextEditorLineNumbersStyle.to(w.lineNumbers)}_validateTabSize(w){if(w==="auto")return"auto";if(typeof w=="number"){const f=Math.floor(w);return f>0?f:null}if(typeof w=="string"){const f=parseInt(w,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(w){const f=this._validateTabSize(w);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(w){return w==="auto"?"auto":w==="false"?!1:Boolean(w)}_setInsertSpaces(w){const f=this._validateInsertSpaces(w);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(w){this._cursorStyle!==w&&(this._cursorStyle=w,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:w})))}_setLineNumbers(w){this._lineNumbers!==w&&(this._lineNumbers=w,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:I.TextEditorLineNumbersStyle.from(w)})))}assign(w){const f={};let l=!1;if(typeof w.tabSize!="undefined"){const m=this._validateTabSize(w.tabSize);m==="auto"?(l=!0,f.tabSize=m):typeof m=="number"&&this._tabSize!==m&&(this._tabSize=m,l=!0,f.tabSize=m)}if(typeof w.insertSpaces!="undefined"){const m=this._validateInsertSpaces(w.insertSpaces);m==="auto"?(l=!0,f.insertSpaces=m):this._insertSpaces!==m&&(this._insertSpaces=m,l=!0,f.insertSpaces=m)}typeof w.cursorStyle!="undefined"&&this._cursorStyle!==w.cursorStyle&&(this._cursorStyle=w.cursorStyle,l=!0,f.cursorStyle=w.cursorStyle),typeof w.lineNumbers!="undefined"&&this._lineNumbers!==w.lineNumbers&&(this._lineNumbers=w.lineNumbers,l=!0,f.lineNumbers=I.TextEditorLineNumbersStyle.from(w.lineNumbers)),l&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(w){w.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=i;class T{constructor(w,f,l,m,S,g,b,d){this.id=w,this._proxy=f,this._logService=l,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=S,this._options=new i(this._proxy,this.id,g,l),this._visibleRanges=b,this._viewColumn=d;const u=this;this.value=Object.freeze({get document(){return m.getValue()},set document(a){throw(0,D.readonly)("document")},get selection(){return u._selections&&u._selections[0]},set selection(a){if(!(a instanceof C.Selection))throw(0,D.illegalArgument)("selection");u._selections=[a],u._trySetSelection()},get selections(){return u._selections},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof C.Selection)))throw(0,D.illegalArgument)("selections");u._selections=a,u._trySetSelection()},get visibleRanges(){return u._visibleRanges},set visibleRanges(a){throw(0,D.readonly)("visibleRanges")},get options(){return u._options.value},set options(a){u._disposed||u._options.assign(a)},get viewColumn(){return u._viewColumn},set viewColumn(a){throw(0,D.readonly)("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new y(m.getValue(),t);return a(r),u._applyEdit(r)},insertSnippet(a,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=u._selections.map(o=>I.Range.from(o));else if(t instanceof C.Position){const{lineNumber:o,column:n}=I.Position.from(t);s=[{startLineNumber:o,startColumn:n,endLineNumber:o,endColumn:n}]}else if(t instanceof C.Range)s=[I.Range.from(t)];else{s=[];for(const o of t)if(o instanceof C.Range)s.push(I.Range.from(o));else{const{lineNumber:n,column:c}=I.Position.from(o);s.push({startLineNumber:n,startColumn:c,endLineNumber:n,endColumn:c})}}return f.$tryInsertSnippet(w,a.value,s,r)},setDecorations(a,t){const r=t.length===0;r&&!u._hasDecorationsForKey.has(a.key)||(r?u._hasDecorationsForKey.delete(a.key):u._hasDecorationsForKey.add(a.key),u._runOnProxy(()=>{if(I.isDecorationOptionsArr(t))return f.$trySetDecorations(w,a.key,I.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let o=0,n=t.length;o<n;o++){const c=t[o];s[4*o]=c.start.line+1,s[4*o+1]=c.start.character+1,s[4*o+2]=c.end.line+1,s[4*o+3]=c.end.character+1}return f.$trySetDecorationsFast(w,a.key,s)}}))},revealRange(a,t){u._runOnProxy(()=>f.$tryRevealRange(w,I.Range.from(a),t||C.TextEditorRevealType.Default))},show(a){f.$tryShowEditor(w,I.ViewColumn.from(a))},hide(){f.$tryHideEditor(w)}})}dispose(){(0,_.ok)(!this._disposed),this._disposed=!0}_acceptOptions(w){(0,_.ok)(!this._disposed),this._options._accept(w)}_acceptVisibleRanges(w){(0,_.ok)(!this._disposed),this._visibleRanges=w}_acceptViewColumn(w){(0,_.ok)(!this._disposed),this._viewColumn=w}_acceptSelections(w){(0,_.ok)(!this._disposed),this._selections=w}async _trySetSelection(){const w=this._selections.map(I.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,w)),this.value}_applyEdit(w){const f=w.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const l=f.edits.map(S=>S.range);l.sort((S,g)=>S.end.line===g.end.line?S.end.character===g.end.character?S.start.line===g.start.line?S.start.character-g.start.character:S.start.line-g.start.line:S.end.character-g.end.character:S.end.line-g.end.line);for(let S=0,g=l.length-1;S<g;S++){const b=l[S].end;if(l[S+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const m=f.edits.map(S=>({range:I.Range.from(S.range),text:S.text,forceMoveMarkers:S.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,m,{setEndOfLine:typeof f.setEndOfLine=="number"?I.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(w){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):w().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=T}),define(me[219],pe([0,1,163,23,2,3,6,19,8,15,14,20,21]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(S,g){if((0,i.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let b;return Array.isArray(S.highlights)&&(b=S.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),b=b.length?b:void 0),{label:S.label,highlights:b}}}class l{constructor(g,b,d){this._proxy=g,this.commands=b,this.logService=d,this.treeViews=new Map;function u(a){return a&&a.$treeViewId&&a.$treeItemHandle}b.registerArgumentProcessor({processArgument:a=>u(a)?this.convertArgument(a):Array.isArray(a)&&a.length>0?a.map(t=>u(t)?this.convertArgument(t):t):a})}registerTreeDataProvider(g,b,d){const u=this.createTreeView(g,{treeDataProvider:b},d);return{dispose:()=>u.dispose()}}createTreeView(g,b,d){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=this._proxy.$registerTreeViewDataProvider(g,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany}),a=this.createExtHostTreeView(g,b,d);return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get message(){return a.message},set message(t){a.message=t},get title(){return a.title},set title(t){a.title=t},get description(){return a.description},set description(t){a.description=t},reveal:(t,r)=>a.reveal(t,r),dispose:async()=>{await u,this.treeViews.delete(g),a.dispose()}}}$getChildren(g,b){const d=this.treeViews.get(g);return d?d.getChildren(b):Promise.reject(new Error((0,_.localize)(0,null,g)))}async $hasResolve(g){const b=this.treeViews.get(g);if(!b)throw new Error((0,_.localize)(1,null,g));return b.hasResolve}$resolve(g,b,d){const u=this.treeViews.get(g);if(!u)throw new Error((0,_.localize)(2,null,g));return u.resolveTreeItem(b,d)}$setExpanded(g,b,d){const u=this.treeViews.get(g);if(!u)throw new Error((0,_.localize)(3,null,g));u.setExpanded(b,d)}$setSelection(g,b){const d=this.treeViews.get(g);if(!d)throw new Error((0,_.localize)(4,null,g));d.setSelection(b)}$setVisible(g,b){const d=this.treeViews.get(g);if(!d)throw new Error((0,_.localize)(5,null,g));d.setVisible(b)}createExtHostTreeView(g,b,d){const u=new m(g,b,this._proxy,this.commands.converter,this.logService,d);return this.treeViews.set(g,u),u}convertArgument(g){const b=this.treeViews.get(g.$treeViewId);return b?b.getExtensionElement(g.$treeItemHandle):null}}e.ExtHostTreeViews=l;class m extends C.Disposable{constructor(g,b,d,u,a,t){super();if(this.viewId=g,this.proxy=d,this.commands=u,this.logService=a,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new I.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new I.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new I.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new I.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new I.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new w.CancellationTokenSource,t.contributes&&t.contributes.views)for(const o in t.contributes.views)for(const n of t.contributes.views[o])n.id===g&&(this._title=n.name);this.dataProvider=b.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let r,s;this._register(I.Event.debounce(this._onDidChangeData.event,(o,n)=>(o||(o={message:!1,elements:[]}),n.element!==!1&&(r||(r=new Promise(c=>s=c),this.refreshPromise=this.refreshPromise.then(()=>r)),o.elements.push(n.element)),n.message&&(o.message=!0),o),200,!0)(({message:o,elements:n})=>{n.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const c=s;return r=null,this.refresh(n).then(()=>c())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(g=>this.getExtensionElement(g)).filter(g=>!(0,i.isUndefinedOrNull)(g))}getChildren(g){const b=g?this.getExtensionElement(g):void 0;if(g&&!b)return this.logService.error(`No tree item with id '${g}' found.`),Promise.resolve([]);const d=this.getChildrenNodes(g);return(d?Promise.resolve(d):this.fetchChildrenNodes(b)).then(u=>u.map(a=>a.item))}getExtensionElement(g){return this.elements.get(g)}reveal(g,b){b=b||{select:!0,focus:!1};const d=(0,i.isUndefinedOrNull)(b.select)?!0:b.select,u=(0,i.isUndefinedOrNull)(b.focus)?!1:b.focus,a=(0,i.isUndefinedOrNull)(b.expand)?!1:b.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):g?this.refreshPromise.then(()=>this.resolveUnknownParentChain(g)).then(t=>this.resolveTreeNode(g,t[t.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:t.map(s=>s.item)},{select:d,focus:u,expand:a})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:d,focus:u,expand:a})}get message(){return this._message}set message(g){this._message=g,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(g){this._title=g,this.proxy.$setTitle(this.viewId,g,this._description)}get description(){return this._description}set description(g){this._description=g,this.proxy.$setTitle(this.viewId,this._title,g)}setExpanded(g,b){const d=this.getExtensionElement(g);d&&(b?this._onDidExpandElement.fire(Object.freeze({element:d})):this._onDidCollapseElement.fire(Object.freeze({element:d})))}setSelection(g){(0,T.equals)(this._selectedHandles,g)||(this._selectedHandles=g,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(g){g!==this._visible&&(this._visible=g,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(g,b){var d;if(!!this.dataProvider.resolveTreeItem){const u=this.elements.get(g);if(u){const a=this.nodes.get(u);if(a){const t=(d=await this.dataProvider.resolveTreeItem(a.extensionItem,u,b))!==null&&d!==void 0?d:a.extensionItem;return a.item.tooltip=this.getTooltip(t.tooltip),a.item.command=this.getCommand(a.disposableStore,t.command),a.item}}}}resolveUnknownParentChain(g){return this.resolveParent(g).then(b=>b?this.resolveUnknownParentChain(b).then(d=>this.resolveTreeNode(b,d[d.length-1]).then(u=>(d.push(u),d))):Promise.resolve([]))}resolveParent(g){const b=this.nodes.get(g);return b?Promise.resolve(b.parent?this.elements.get(b.parent.item.handle):void 0):(0,P.asPromise)(()=>this.dataProvider.getParent(g))}resolveTreeNode(g,b){const d=this.nodes.get(g);return d?Promise.resolve(d):(0,P.asPromise)(()=>this.dataProvider.getTreeItem(g)).then(u=>this.createHandle(g,u,b,!0)).then(u=>this.getChildren(b?b.item.handle:void 0).then(()=>{const a=this.getExtensionElement(u);if(a){const t=this.nodes.get(a);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(g){if(g){let b;if(typeof g=="string"){const d=this.getExtensionElement(g);b=d?this.nodes.get(d):void 0}else b=g;return b&&b.children||null}return this.roots}async fetchChildrenNodes(g){this.clearChildren(g);const b=new w.CancellationTokenSource(this._refreshCancellationSource.token);try{const d=g?this.nodes.get(g):void 0,u=await this.dataProvider.getChildren(g);if(b.token.isCancellationRequested)return[];const a=await Promise.all((0,T.coalesce)(u||[]).map(async t=>{const r=await this.dataProvider.getTreeItem(t);return r&&!b.token.isCancellationRequested?this.createAndRegisterTreeNode(t,r,d):null}));return b.token.isCancellationRequested?[]:(0,T.coalesce)(a)}finally{b.dispose()}}refresh(g){if(g.some(d=>!d))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new w.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const d=this.getHandlesToRefresh(g);if(d.length)return this.refreshHandles(d)}return Promise.resolve(void 0)}getHandlesToRefresh(g){const b=new Set;for(const u of g){const a=this.nodes.get(u);if(a&&!b.has(a.item.handle)){let t=a;for(;t&&t.parent&&!b.has(t.parent.item.handle);){const r=this.elements.get(t.parent.item.handle);t=r?this.nodes.get(r):void 0}t&&!t.parent&&b.add(a.item.handle)}}const d=[];return b.forEach(u=>{const a=this.elements.get(u);if(a){const t=this.nodes.get(a);t&&(!t.parent||!b.has(t.parent.item.handle))&&d.push(u)}}),d}refreshHandles(g){const b={};return Promise.all(g.map(d=>this.refreshNode(d).then(u=>{u&&(b[d]=u.item)}))).then(()=>Object.keys(b).length?this.proxy.$refresh(this.viewId,b):void 0)}refreshNode(g){const b=this.getExtensionElement(g);if(b){const d=this.nodes.get(b);if(d)return this.clearChildren(b),(0,P.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(u=>{if(u){const a=this.createTreeNode(b,u,d.parent);return this.updateNodeCache(b,a,d,d.parent),d.dispose(),a}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(g,b,d){const u=this.createTreeNode(g,b,d);if(b.id&&this.elements.has(u.item.handle))throw new Error((0,_.localize)(6,null,b.id));return this.addNodeToCache(g,u),this.addNodeToParentCache(u,d),u}getTooltip(g){return y.MarkdownString.isMarkdownString(g)?k.MarkdownString.from(g):g}getCommand(g,b){return b?this.commands.toInternal(b,g):void 0}createTreeNode(g,b,d){const u=new C.DisposableStore,a=this.createHandle(g,b,d),t=this.getLightIconPath(b);return{item:{handle:a,parentHandle:d?d.item.handle:void 0,label:f(b.label,this.extension),description:b.description,resourceUri:b.resourceUri,tooltip:this.getTooltip(b.tooltip),command:this.getCommand(u,b.command),contextValue:b.contextValue,icon:t,iconDark:this.getDarkIconPath(b)||t,themeIcon:this.getThemeIcon(b),collapsibleState:(0,i.isUndefinedOrNull)(b.collapsibleState)?y.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation},extensionItem:b,parent:d,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(g){return g.iconPath instanceof y.ThemeIcon?g.iconPath:void 0}createHandle(g,{id:b,label:d,resourceUri:u},a,t){if(b)return`${m.ID_HANDLE_PREFIX}/${b}`;const r=f(d,this.extension),s=a?a.item.handle:m.LABEL_HANDLE_PREFIX;let o=r?r.label:u?(0,D.basename)(u):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const n=this.nodes.has(g)?this.nodes.get(g).item.handle:void 0,c=this.getChildrenNodes(a)||[];let p,E=0;do{if(p=`${s}/${E}:${o}`,t||!this.elements.has(p)||n===p)break;E++}while(E<=c.length);return p}getLightIconPath(g){if(g.iconPath&&!(g.iconPath instanceof y.ThemeIcon))return typeof g.iconPath=="string"||R.URI.isUri(g.iconPath)?this.getIconPath(g.iconPath):this.getIconPath(g.iconPath.light)}getDarkIconPath(g){if(g.iconPath&&!(g.iconPath instanceof y.ThemeIcon)&&g.iconPath.dark)return this.getIconPath(g.iconPath.dark)}getIconPath(g){return R.URI.isUri(g)?g:R.URI.file(g)}addNodeToCache(g,b){this.elements.set(b.item.handle,g),this.nodes.set(g,b)}updateNodeCache(g,b,d,u){this.elements.delete(b.item.handle),this.nodes.delete(g),b.item.handle!==d.item.handle&&this.elements.delete(d.item.handle),this.addNodeToCache(g,b);const a=this.getChildrenNodes(u)||[],t=a.filter(r=>r.item.handle===d.item.handle)[0];t&&a.splice(a.indexOf(t),1,b)}addNodeToParentCache(g,b){b?(b.children||(b.children=[]),b.children.push(g)):(this.roots||(this.roots=[]),this.roots.push(g))}clearChildren(g){if(g){const b=this.nodes.get(g);if(b){if(b.children)for(const d of b.children){const u=this.elements.get(d.item.handle);u&&this.clear(u)}b.children=void 0}}else this.clearAll()}clear(g){const b=this.nodes.get(g);if(b){if(b.children)for(const d of b.children){const u=this.elements.get(d.item.handle);u&&this.clear(u)}this.nodes.delete(g),this.elements.delete(b.item.handle),b.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(g=>g.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}m.LABEL_HANDLE_PREFIX="0",m.ID_HANDLE_PREFIX="1"}),define(me[220],pe([0,1,14,19,55,20]),function(Z,e,_,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class C{constructor(){this.testIdsToInternal=new Set}getTestById(l){return(0,_.mapFind)(this.testIdsToInternal,m=>{const S=m.get(l);return S&&[m,S]})}createForHierarchy(l=()=>{}){return new i(this.createIdMap(),l)}createIdMap(){const l=new y;return this.testIdsToInternal.add(l),{object:l,dispose:()=>this.testIdsToInternal.delete(l)}}}e.OwnedTestCollection=C;var P;(function(f){f[f.Disconnected=0]="Disconnected",f[f.IsChild=1]="IsChild",f[f.IsParent=2]="IsParent",f[f.IsSame=3]="IsSame"})(P=e.TestPosition||(e.TestPosition={}));class y{constructor(){this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(l){if(this.map.has(l.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${l.item.extId}`);this.map.set(l.item.extId,l),l.parent||this._roots.add(l)}has(l){return this.map.has(l)}delete(l){const m=this.map.get(l);return m?(this.map.delete(l),this._roots.delete(m),!0):!1}get(l){return this.map.get(l)}comparePositions(l,m){const S=typeof l=="string"?this.map.get(l):l,g=typeof m=="string"?this.map.get(m):m;if(!S||!g)return 0;if(S===g)return 3;for(let b=this.map.get(g.parent);b;b=this.map.get(b.parent))if(b===S)return 1;for(let b=this.map.get(S.parent);b;b=this.map.get(b.parent))if(b===g)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=y;class i{constructor(l,m){this.testIdToInternal=l,this.publishDiff=m,this.testItemToInternal=new Map,this.diff=[],this.disposed=!1,this.debounceSendDiff=new D.RunOnceScheduler(()=>this.throttleSendDiff(),2)}addRoot(l,m){this.addItem(l,m,null),this.debounceSendDiff.schedule()}getTestByReference(l){return this.testItemToInternal.get(l)}onItemChange(l,m){const S=this.testItemToInternal.get(l);if(!S){this.disposed||console.warn("Received a TestProvider.onDidChangeTest for a test that wasn't seen before as a child.");return}this.addItem(l,m,S.parent),this.debounceSendDiff.schedule()}collectDiff(){const l=this.diff;return this.diff=[],l}pushDiff(l){this.diff.push(l),this.debounceSendDiff.schedule()}dispose(){this.testIdToInternal.dispose(),this.diff=[],this.disposed=!0}addItem(l,m,S){let g=this.testItemToInternal.get(l);if(g)g.previousEquals(l)||(g.item=I.TestItem.from(l),g.previousEquals=w(l),this.diff.push([1,{parent:S,providerId:m,item:g.item}]));else{if(this.testIdToInternal.object.has(l.id))throw new Error(`Attempted to insert a duplicate test item ID ${l.id}`);g={actual:l,parent:S,item:I.TestItem.from(l),providerId:m,previousChildren:new Set,previousEquals:w(l)},this.testIdToInternal.object.add(g),this.testItemToInternal.set(l,g),this.diff.push([0,{parent:S,providerId:m,item:g.item}])}if(l.children){const b=g.previousChildren,d=new Set;for(const u of l.children){const a=this.testIdToInternal.object.get(u.id);a&&a.actual!==u&&this.removeItembyId(u.id);const t=this.addItem(u,m,g.item.extId);b.delete(t.item.extId),d.add(t.item.extId)}for(const u of b)this.removeItembyId(u);g.previousChildren=d}return g}removeItembyId(l){this.diff.push([2,l]);const m=[this.testIdToInternal.object.get(l)];for(;m.length;){const S=m.pop();if(!!S){this.testIdToInternal.object.delete(S.item.extId),this.testItemToInternal.delete(S.actual);for(const g of S.previousChildren)m.push(this.testIdToInternal.object.get(g))}}}throttleSendDiff(){this.flushDiff()}flushDiff(){const l=this.collectDiff();l.length&&this.publishDiff(l)}}Ve([(0,R.throttle)(200)],i.prototype,"throttleSendDiff",null),e.SingleUseTestCollection=i;const k=Object.keys({id:null,label:null,location:null,debuggable:null,description:null,runnable:null}),w=f=>{const l=[];for(const m of k)l.push(f[m]);return m=>{for(let S=0;S<k.length;S++)if(l[S]!==m[k[S]])return!1;return!0}}}),define(me[221],pe([0,1,29,3,7]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class I{constructor(T){this.removedDueToLooping=T}}e.DeltaExtensionsResult=I;class C{constructor(T){this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=T,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const T of this._extensionDescriptions){if(this._extensionsMap.has(_.ExtensionIdentifier.toKey(T.identifier))){console.error("Extension `"+T.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(_.ExtensionIdentifier.toKey(T.identifier),T),this._extensionsArr.push(T),Array.isArray(T.activationEvents))for(let k of T.activationEvents)k==="onUri"&&(k=`onUri:${_.ExtensionIdentifier.toKey(T.identifier)}`),this._activationMap.has(k)||this._activationMap.set(k,[]),this._activationMap.get(k).push(T)}}keepOnly(T){const k=new Set;T.forEach(w=>k.add(_.ExtensionIdentifier.toKey(w))),this._extensionDescriptions=this._extensionDescriptions.filter(w=>k.has(_.ExtensionIdentifier.toKey(w.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(T,k){T.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(T));const w=C._findLoopingExtensions(this._extensionDescriptions);if(k=k.concat(w.map(f=>f.identifier)),k.length>0){const f=new Set;k.forEach(l=>f.add(_.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>!f.has(_.ExtensionIdentifier.toKey(l.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new I(w)}static _findLoopingExtensions(T){const k=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(S){this._nodesSet.has(S)||(this._nodesSet.add(S),this._nodesArr.push(S))}addArc(S,g){this.addNode(S),this.addNode(g),this._arcs.has(S)?this._arcs.get(S).push(g):this._arcs.set(S,[g])}getArcs(S){return this._arcs.has(S)?this._arcs.get(S):[]}hasOnlyGoodArcs(S,g){const b=k.getArcs(S);for(let d=0;d<b.length;d++)if(!g.has(b[d]))return!1;return!0}getNodes(){return this._nodesArr}};let w=new Map;for(let S of T){const g=_.ExtensionIdentifier.toKey(S.identifier);if(w.set(g,S),S.extensionDependencies)for(let b of S.extensionDependencies){const d=_.ExtensionIdentifier.toKey(b);k.addArc(g,d)}}let f=new Set;k.getNodes().filter(S=>k.getArcs(S).length===0).forEach(S=>f.add(S));let l=k.getNodes().filter(S=>!f.has(S)),m;do{m=!1;for(let S=0;S<l.length;S++){const g=l[S];k.hasOnlyGoodArcs(g,f)&&(l.splice(S,1),S--,f.add(g),m=!0)}}while(m);return l.map(S=>w.get(S))}containsActivationEvent(T){return this._activationMap.has(T)}containsExtension(T){return this._extensionsMap.has(_.ExtensionIdentifier.toKey(T))}getExtensionDescriptionsForActivationEvent(T){const k=this._activationMap.get(T);return k?k.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(T){const k=this._extensionsMap.get(_.ExtensionIdentifier.toKey(T));return k||void 0}}e.ExtensionDescriptionRegistry=C;var P;(function(i){i[i.Builtin=0]="Builtin",i[i.User=1]="User",i[i.Dev=2]="Dev"})(P||(P={}));function y(i,T){const k=i.isBuiltin?0:i.isUnderDevelopment?2:1,w=T.isBuiltin?0:T.isUnderDevelopment?2:1;if(k!==w)return k-w;const f=R.posix.basename(i.extensionLocation.path),l=R.posix.basename(T.extensionLocation.path);return f<l?-1:f>l?1:0}}),define(me[222],pe([0,1,26]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var D;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(D=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function I(P){const y=_.VSBuffer.alloc(1);switch(P){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=I;function C(P,y){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=C}),define(me[41],pe([0,1,3,2,4,29,181]),function(Z,e,_,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwRequiresWorkspaceTrustError=e.checkRequiresWorkspaceTrust=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new I.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:D.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,R.createDecorator)("extensionService");class P{constructor(u){this.dependency=u}}e.MissingDependencyError=P;var y;(function(d){d[d.LocalProcess=0]="LocalProcess",d[d.LocalWebWorker=1]="LocalWebWorker",d[d.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class i{constructor(u,a,t,r){this.codeLoadingTime=u,this.activateCallTime=a,this.activateResolvedTime=t,this.activationReason=r}}e.ActivationTimes=i;class T{constructor(u,a){this.description=u,this.value=a}}e.ExtensionPointContribution=T,e.ExtensionHostLogFileName="exthost";var k;(function(d){d[d.Normal=0]="Normal",d[d.Immediate=1]="Immediate"})(k=e.ActivationKind||(e.ActivationKind={}));function w(d){d.enableProposedApi||f(d)}e.checkProposedApiEnabled=w;function f(d){throw new Error(`[${d.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${d.identifier.value}`)}e.throwProposedApiError=f;function l(d){d.requiresWorkspaceTrust||m(d)}e.checkRequiresWorkspaceTrust=l;function m(d){throw new Error(`[${d.identifier.value}]: This API is only available when the "requiresWorkspaceTrust" is set to "onStart" or "onDemand" in the extension's package.json.`)}e.throwRequiresWorkspaceTrustError=m;function S(d){return{type:d.isBuiltin?0:1,isBuiltin:d.isBuiltin||d.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(d.publisher,d.name),uuid:d.uuid},manifest:d,location:d.extensionLocation}}e.toExtension=S;function g(d){return Object.assign(Object.assign({identifier:new I.ExtensionIdentifier(d.identifier.id),isBuiltin:d.type===0,isUserBuiltin:d.type===1&&d.isBuiltin,isUnderDevelopment:!1,extensionLocation:d.location},d.manifest),{uuid:d.identifier.uuid})}e.toExtensionDescription=g;class b{constructor(){this.onDidRegisterExtensions=_.Event.None,this.onDidChangeExtensionsStatus=_.Event.None,this.onDidChangeExtensions=_.Event.None,this.onWillActivateByEvent=_.Event.None,this.onDidChangeResponsiveChange=_.Event.None}activateByEvent(u){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u){return Promise.resolve(0)}restartExtensionHost(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(u,a){}_activateById(u,a){return Promise.resolve()}_onWillActivateExtension(u){}_onDidActivateExtension(u,a,t,r,s){}_onExtensionRuntimeError(u,a){}_onExtensionHostExit(u){}}e.NullExtensionService=b}),define(me[223],pe([0,1,158,29,41,12]),function(Z,e,_,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const C=Promise.resolve(void 0);class P{constructor(m,S,g,b){this.startup=m,this.codeLoadingTime=S,this.activateCallTime=g,this.activateResolvedTime=b}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class y{constructor(m){this._startup=m,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(m,S){return m===-1||S===-1?-1:S-m}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class i{constructor(m,S,g,b,d,u){this.activationFailed=m,this.activationFailedError=S,this.activationTimes=g,this.module=b,this.exports=d,this.subscriptions=u}}e.ActivatedExtension=i;class T extends i{constructor(m){super(!1,null,m,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class k extends i{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=k;class w extends i{constructor(m){super(!0,m,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=w;let f=class{constructor(m,S,g,b,d){this._logService=d,this._registry=m,this._resolvedExtensionsSet=new Set,S.forEach(u=>this._resolvedExtensionsSet.add(D.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,g.forEach(u=>this._hostExtensionsMap.set(D.ExtensionIdentifier.toKey(u),u)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(m){const S=D.ExtensionIdentifier.toKey(m);return this._activatedExtensions.has(S)}getActivatedExtension(m){const S=D.ExtensionIdentifier.toKey(m),g=this._activatedExtensions.get(S);if(!g)throw new Error("Extension `"+m.value+"` is not known or not activated");return g}activateByEvent(m,S){if(this._alreadyActivatedEvents[m])return C;const g=this._registry.getExtensionDescriptionsForActivationEvent(m);return this._activateExtensions(g.map(b=>({id:b.identifier,reason:{startup:S,extensionId:b.identifier,activationEvent:m}}))).then(()=>{this._alreadyActivatedEvents[m]=!0})}activateById(m,S){const g=this._registry.getExtensionDescription(m);if(!g)throw new Error("Extension `"+m+"` is not known");return this._activateExtensions([{id:g.identifier,reason:S}])}_handleActivateRequest(m,S,g){if(this._hostExtensionsMap.has(D.ExtensionIdentifier.toKey(m.id))){S[D.ExtensionIdentifier.toKey(m.id)]=m;return}const b=this._registry.getExtensionDescription(m.id);if(!b){this._host.onExtensionActivationError(m.id,new R.MissingDependencyError(m.id.value));const a=new Error(`Unknown dependency '${m.id.value}'`);this._activatedExtensions.set(D.ExtensionIdentifier.toKey(m.id),new w(a));return}const d=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let u=!0;for(let a=0,t=d.length;a<t;a++){const r=d[a];if(!this._resolvedExtensionsSet.has(D.ExtensionIdentifier.toKey(r))){const s=this._activatedExtensions.get(D.ExtensionIdentifier.toKey(r));if(!(s&&!s.activationFailed)){if(s&&s.activationFailed){this._host.onExtensionActivationError(b.identifier,_.localize(0,null,b.displayName||b.identifier.value,r));const c=new Error(`Dependency ${r} failed to activate`);c.detail=s.activationFailedError,this._activatedExtensions.set(D.ExtensionIdentifier.toKey(b.identifier),new w(c));return}if(this._hostExtensionsMap.has(D.ExtensionIdentifier.toKey(r))){u=!1,S[D.ExtensionIdentifier.toKey(r)]={id:this._hostExtensionsMap.get(D.ExtensionIdentifier.toKey(r)),reason:m.reason};continue}const o=this._registry.getExtensionDescription(r);if(o){u=!1,S[D.ExtensionIdentifier.toKey(r)]={id:o.identifier,reason:m.reason};continue}this._host.onExtensionActivationError(b.identifier,new R.MissingDependencyError(r));const n=new Error(`Unknown dependency '${r}'`);this._activatedExtensions.set(D.ExtensionIdentifier.toKey(b.identifier),new w(n));return}}}u?S[D.ExtensionIdentifier.toKey(b.identifier)]=m:g.push(m)}_activateExtensions(m){if(m.length===0||(m=m.filter(d=>!this._activatedExtensions.has(D.ExtensionIdentifier.toKey(d.id))),m.length===0))return Promise.resolve(void 0);const S=Object.create(null),g=[];for(let d=0,u=m.length;d<u;d++)this._handleActivateRequest(m[d],S,g);for(let d=0,u=g.length;d<u;d++){const a=D.ExtensionIdentifier.toKey(g[d].id);S[a]&&delete S[a]}const b=Object.keys(S).map(d=>S[d]);return g.length===0?Promise.all(b.map(d=>this._activateExtension(d.id,d.reason))).then(d=>{}):this._activateExtensions(b).then(d=>this._activateExtensions(g))}_activateExtension(m,S){const g=D.ExtensionIdentifier.toKey(m);if(this._activatedExtensions.has(g))return Promise.resolve(void 0);const b=this._activatingExtensions.get(g);if(b)return b;const d=this._host.actualActivateExtension(m,S).then(void 0,u=>(this._host.onExtensionActivationError(m,_.localize(1,null,m.value,u.message)),this._logService.error(`Activating extension ${m.value} failed due to an error:`),this._logService.error(u),new w(u))).then(u=>{this._activatedExtensions.set(g,u),this._activatingExtensions.delete(g)});return this._activatingExtensions.set(g,d),d}};f=Ve([xe(4,I.ILogService)],f),e.ExtensionsActivator=f}),define(me[224],pe([0,1,12,41,27,11,108]),function(Z,e,_,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends _.LogService{constructor(i){if(i.logFile.scheme!==I.Schemas.file)throw new Error("Only file-logging supported");super(new C.SpdLogLogger(D.ExtensionHostLogFileName,i.logFile.fsPath,!0,i.logLevel))}$setLevel(i){this.setLevel(i)}};P=Ve([xe(0,R.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(me[225],pe([0,1,18]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class D{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((I,C)=>{this._actualOk=I,this._actualErr=C,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(I){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=I,this._actual&&this._actualOk(I))}resolveErr(I){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=I,this._actual?this._actualErr(I):(0,_.onUnexpectedError)(I))}then(I,C){return this._ensureActual().then(I,C)}catch(I){return this._ensureActual().then(void 0,I)}finally(I){return this._ensureActual().finally(I)}}e.LazyPromise=D}),define(me[121],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class _{constructor(y,i){this.isMain=y,this.sid=i,this.nid=++_.count}}e.ProxyIdentifier=_,_.count=0;const D=[];function R(P){const y=new _(!0,P);return D[y.nid]=y,y}e.createMainContextProxyIdentifier=R;function I(P){const y=new _(!1,P);return D[y.nid]=y,y}e.createExtHostContextProxyIdentifier=I;function C(P){return D[P].sid}e.getStringIdentifierForProxy=C}),define(me[5],pe([0,1,2,121,58]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var I;(function(d){d[d.Desktop=1]="Desktop",d[d.Web=2]="Web"})(I=e.UIKind||(e.UIKind={}));var C;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(C=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(d){d[d.Markdown=1]="Markdown",d[d.Code=2]="Code"})(y=e.CellKind||(e.CellKind={}));var i;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(i=e.CellOutputKind||(e.CellOutputKind={}));var T;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(T=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var k;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(k=e.CandidatePortSource||(e.CandidatePortSource={}));var w;(function(d){d.name="$ident";function u(t,r){return Object.defineProperty(t,d.name,{value:r,enumerable:!0}),t}d.mixin=u;function a(t){return t[d.name]}d.of=a})(w=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(u){return u._id=f._n++,u}}e.IdObject=f,f._n=0;var l;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.command="m",d.kindModifier="n",d.label2="o"})(l=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var m;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(m=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var S;(function(d){d[d.File=1]="File",d[d.Text=2]="Text",d[d.Cell=3]="Cell"})(S=e.WorkspaceEditType||(e.WorkspaceEditType={}));function g(d){if(d&&d.edits)for(const u of d.edits)typeof u.resource=="object"?u.resource=_.URI.revive(u.resource):(u.newUri=_.URI.revive(u.newUri),u.oldUri=_.URI.revive(u.oldUri)),u.metadata&&u.metadata.iconPath&&(u.metadata=(0,R.revive)(u.metadata));return d}e.reviveWorkspaceEditDto=g;var b;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,D.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,D.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,D.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,D.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,D.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,D.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,D.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,D.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,D.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,D.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,D.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,D.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,D.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,D.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,D.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,D.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,D.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,D.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,D.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,D.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,D.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,D.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,D.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,D.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,D.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,D.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,D.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,D.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,D.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadTheming:(0,D.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,D.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,D.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,D.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,D.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,D.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,D.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,D.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,D.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,D.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,D.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,D.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,D.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,D.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,D.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,D.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,D.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,D.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,D.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,D.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,D.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,D.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,D.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,D.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostTheming:(0,D.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,D.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,D.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,D.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,D.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,D.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[86],pe([0,1,5,3,4]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class I{constructor(P){this._onDidChangePassword=new D.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(_.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,y){return this._proxy.$getPassword(P,y)}store(P,y,i){return this._proxy.$setPassword(P,y,i)}delete(P,y){return this._proxy.$deletePassword(P,y)}}e.ExtHostSecretState=I,e.IExtHostSecretState=(0,R.createDecorator)("IExtHostSecretState")}),define(me[64],pe([0,1,4,12,5,13]),function(Z,e,_,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,_.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(y,i){this._extHostLogService=i,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(R.MainContext.MainThreadTelemetry)}report(y,i,T){const k=this.getUsageKey(y,i);this._reportedUsages.has(k)||(this._reportedUsages.add(k),i.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${T}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:i.identifier.value,apiId:y}))}getUsageKey(y,i){return`${y}-${i.identifier.value}`}};C=Ve([xe(0,I.IExtHostRpcService),xe(1,D.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(P,y,i){}})}),define(me[226],pe([0,1,3,5,8,29]),function(Z,e,_,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new _.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new _.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(D.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(y,i,T,k={}){const w=I.ExtensionIdentifier.toKey(y.identifier),f=this._inFlightRequests.get(w)||[],l=T.sort().join(" ");let m=f.find(S=>S.scopes===l);if(m)return m.result;{const S=this._getSession(y,w,i,T,k);m={scopes:l,result:S},f.push(m),this._inFlightRequests.set(w,f);try{await S}finally{const g=f.findIndex(b=>b.scopes===l);g>-1&&(f.splice(g),this._inFlightRequests.set(w,f))}return S}}async _getSession(y,i,T,k,w={}){await this._proxy.$ensureProvider(T);const f=y.displayName||y.name;return this._proxy.$getSession(T,k,i,f,w)}async removeSession(y,i){const T=this._authenticationProviders.get(y);return T?T.provider.removeSession(i):this._proxy.$removeSession(y,i)}registerAuthenticationProvider(y,i,T,k){var w;if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:i,provider:T,options:k!=null?k:{supportsMultipleAccounts:!1}}),this._providers.find(l=>l.id===y)||this._providers.push({id:y,label:i});const f=T.onDidChangeSessions(l=>{var m,S,g;this._proxy.$sendDidChangeSessions(y,{added:(m=l.added)!==null&&m!==void 0?m:[],changed:(S=l.changed)!==null&&S!==void 0?S:[],removed:(g=l.changed)!==null&&g!==void 0?g:[]})});return this._proxy.$registerAuthenticationProvider(y,i,(w=k==null?void 0:k.supportsMultipleAccounts)!==null&&w!==void 0?w:!1),new R.Disposable(()=>{f.dispose(),this._authenticationProviders.delete(y);const l=this._providers.findIndex(m=>m.id===y);l>-1&&this._providers.splice(l),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,i){const T=this._authenticationProviders.get(y);if(T)return Promise.resolve(T.provider.createSession(i));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,i){const T=this._authenticationProviders.get(y);if(T)return Promise.resolve(T.provider.removeSession(i));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,i){const T=this._authenticationProviders.get(y);if(T)return Promise.resolve(T.provider.getSessions(i));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,i){return this._onDidChangeSessions.fire({provider:{id:y,label:i}}),Promise.resolve()}$onDidChangeAuthenticationProviders(y,i){return y.forEach(T=>{this._providers.some(k=>k.id===T.id)||this._providers.push(T)}),i.forEach(T=>{const k=this._providers.findIndex(w=>w.id===T.id);k>-1&&this._providers.splice(k)}),this._onDidChangeAuthenticationProviders.fire({added:y,removed:i}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(me[227],pe([0,1,5,13,20]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let I=class{constructor(P,y){this._extHostDocumentsAndEditors=y,this._proxy=P.getProxy(_.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const y=R.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};I=Ve([xe(0,D.IExtHostRpcService)],I),e.ExtHostBulkEdits=I}),define(me[228],pe([0,1,5]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class D{constructor(I){const C=I.getProxy(_.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(P){return C.$writeText(P)}})}}e.ExtHostClipboard=D}),define(me[52],pe([0,1,15,8,20,24,5,14,12,58,44,48,2,6,4,13]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let S=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(C.MainContext.MainThreadCommands),this._logService=r,this.converter=new g(this,s=>{const o=this._apiCommands.get(s);return(o==null?void 0:o.result)===d.Void?o:void 0},r),this._argumentProcessors=[{processArgument(s){return(0,i.revive)(s)}},{processArgument(s){return(0,I.cloneAndChange)(s,function(o){if(T.Range.isIRange(o))return R.Range.to(o);if(k.Position.isIPosition(o))return R.Position.to(o);if(T.Range.isIRange(o.range)&&w.URI.isUri(o.uri))return R.location.to(o);if(!Array.isArray(o))return o})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...s)=>{const o=t.args.map((c,p)=>{if(!c.validate(s[p]))throw new Error(`Invalid argument '${c.name}' when running '${t.id}', received: ${s[p]}`);return c.convert(s[p])}),n=await this.executeCommand(t.internalId,...o);return t.result.convert(n,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new D.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,s,o,n){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:s,thisArg:o,description:n}),t&&this._proxy.$registerCommand(r),new D.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,s){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const o=(0,I.cloneAndChange)(r,function(n){if(n instanceof D.Position)return R.Position.from(n);if(n instanceof D.Range)return R.Range.from(n);if(n instanceof D.Location)return R.location.from(n);if(!Array.isArray(n))return n});try{const n=await this._proxy.$executeCommand(t,o,s);return(0,i.revive)(n)}catch(n){if(n instanceof Error&&n.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw n}}}async _executeContributedCommand(t,r){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:o,thisArg:n,description:c}=s;if(c)for(let p=0;p<c.args.length;p++)try{(0,_.validateConstraint)(r[p],c.args[p].constraint)}catch(E){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${c.args[p].name}' - ${c.args[p].description}`)}try{return await o.apply(n,r)}catch(p){if(t===this.converter.delegatingCommandId){const E=this.converter.getActualCommand(...r);E&&(t=E.command)}throw this._logService.error(p,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(s=>this._argumentProcessors.reduce((o,n)=>n.processArgument(o),s)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(s=>s[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,s]of this._commands){let{description:o}=s;o&&(t[r]=o)}return Promise.resolve(t)}};S=Ve([xe(0,m.IExtHostRpcService),xe(1,y.ILogService)],S),e.ExtHostCommands=S,e.IExtHostCommands=(0,l.createDecorator)("IExtHostCommands");class g{constructor(t,r,s){this._commands=t,this._lookupApiCommand=r,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!!t){const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const o=this._lookupApiCommand(t.command);if(o)s.id=o.internalId,s.arguments=o.args.map((n,c)=>n.convert(t.arguments&&t.arguments[c]));else if((0,P.isNonEmptyArray)(t.arguments)){const n=++this._cachIdPool;this._cache.set(n,t),r.add((0,f.toDisposable)(()=>{this._cache.delete(n),this._logService.trace("CommandsConverter#DISPOSE",n)})),s.$ident=n,s.id=this.delegatingCommandId,s.arguments=[n],this._logService.trace("CommandsConverter#CREATE",t.command,n)}return s}}fromInternal(t){const r=C.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=g;class b{constructor(t,r,s,o){this.name=t,this.description=r,this.validate=s,this.convert=o}optional(){return new b(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new b(t!=null?t:this.name,r!=null?r:this.description,this.validate,this.convert)}}e.ApiCommandArgument=b,b.Uri=new b("uri","Uri of a text document",a=>w.URI.isUri(a),a=>a),b.Position=new b("position","A position in a text document",a=>D.Position.isPosition(a),R.Position.from),b.Range=new b("range","A range in a text document",a=>D.Range.isRange(a),R.Range.from),b.Selection=new b("selection","A selection in a text document",a=>D.Selection.isSelection(a),R.Selection.from),b.Number=new b("number","",a=>typeof a=="number",a=>a),b.String=new b("string","",a=>typeof a=="string",a=>a),b.CallHierarchyItem=new b("item","A call hierarchy item",a=>a instanceof D.CallHierarchyItem,R.CallHierarchyItem.to);class d{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=d,d.Void=new d("no result",a=>a);class u{constructor(t,r,s,o,n){this.id=t,this.internalId=r,this.description=s,this.args=o,this.result=n}}e.ApiCommand=u}),define(me[229],pe([0,1,6,20,8,81,52,197,14,105]),function(Z,e,_,D,R,I,C,P,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const T=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",w(D.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(l,m)=>{if(!(0,y.isFalsyOrEmpty)(l)){class S extends R.SymbolInformation{static to(b){const d=new S(b.name,D.SymbolKind.to(b.kind),b.containerName||"",new R.Location(m[0],D.Range.to(b.range)));return d.detail=b.detail,d.range=d.location.range,d.selectionRange=D.Range.to(b.selectionRange),d.children=b.children?b.children.map(S.to):[],d}}return l.map(S.to)}})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(D.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(D.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new C.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(D.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",w(D.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",w(D.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(m=>R.Position.isPosition(m)),l=>l.map(D.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(m=>{let S;for(const g of m.reverse())S=new R.SelectionRange(D.Range.to(g),S);return S}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>{const m=[];if(Array.isArray(l))for(let S of l)m.push(...S[1].map(D.WorkspaceSymbol.to));return m})),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(D.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(D.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(D.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return D.WorkspaceEdit.to(l)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(D.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!!l){const m=(0,i.decodeSemanticTokensDto)(l);if(m.type==="full")return new R.SemanticTokens(m.data,void 0)}})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!!l){const m=(0,i.decodeSemanticTokensDto)(l);if(m.type==="full")return new R.SemanticTokens(m.data,void 0)}})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,m,S)=>{if(!l)return new R.CompletionList([]);const g=l.suggestions.map(b=>D.CompletionItem.to(b,S));return new R.CompletionList(g,l.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return D.SignatureHelp.to(l)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,m,S)=>w(g=>new R.CodeLens(D.Range.to(g.range),g.command&&S.fromInternal(g.command)))(l))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>R.Range.isRange(l),l=>R.Selection.isSelection(l)?D.Selection.from(l):D.Range.from(l)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,m,S)=>w(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return S.fromInternal(g.command)}else{const b=new R.CodeAction(g.title,g.kind?new R.CodeActionKind(g.kind):void 0);return g.edit&&(b.edit=D.WorkspaceEdit.to(g.edit)),g.command&&(b.command=S.fromInternal(g.command)),b.isPreferred=g.isPreferred,b}})(l))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(m=>new R.ColorInformation(D.Range.to(m.range),D.Color.to(m.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",l=>l instanceof R.Color,D.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:D.Range.from(l.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(D.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineHint objects",l=>l.map(D.InlineHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",w(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientMetadata:l.options.transientMetadata},filenamePattern:l.filenamePattern.map(m=>D.NotebookExclusiveDocumentPattern.to(m))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(D.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[D.ViewColumn.from(l.viewColumn),D.TextEditorOpenOptions.from(l)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[D.ViewColumn.from(l.viewColumn),D.TextEditorOpenOptions.from(l)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[D.ViewColumn.from(l.viewColumn),D.TextEditorOpenOptions.from(l)]).optional()],C.ApiCommandResult.Void)];class k{constructor(m){this._disposables=new _.DisposableStore,this._commands=m}static register(m){return T.forEach(m.registerApiCommand,m),new k(m).registerCommands()}registerCommands(){const m=S=>(...g)=>S(this._commands,...g);this._register(P.RemoveFromRecentlyOpenedAPICommand.ID,m(P.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:S=>typeof S=="string"}]}),this._register(P.OpenIssueReporter.ID,m(P.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:S=>typeof S=="string"||typeof S=="object"&&typeof S.extensionId=="string"}]})}_register(m,S,g){const b=this._commands.registerCommand(!1,m,S,this,g);this._disposables.add(b)}}e.ExtHostApiCommands=k;function w(l){return m=>{if(Array.isArray(m))return m.map(l)}}function f(l){if(!!Array.isArray(l)){const m=[];for(const S of l)I.isLocationLink(S)?m.push(D.DefinitionLink.to(S)):m.push(D.location.to(S));return m}}}),define(me[230],pe([0,1,19,55,3,6,2,81,29,20,8,5]),function(Z,e,_,D,R,I,C,P,y,i,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class w{constructor(u,a,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=u.getProxy(k.MainContext.MainThreadComments),a.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const s=this._commentControllers.get(r.handle);return s||r}else if(r&&r.$mid===7){const s=this._commentControllers.get(r.commentControlHandle);if(!s)return r;const o=s.getCommentThread(r.commentThreadHandle);return o||r}else if(r&&r.$mid===8){const s=this._commentControllers.get(r.thread.commentControlHandle);if(!s)return r;const o=s.getCommentThread(r.thread.commentThreadHandle);return o?{thread:o,text:r.text}:r}else if(r&&r.$mid===9){const s=this._commentControllers.get(r.thread.commentControlHandle);if(!s)return r;const o=s.getCommentThread(r.thread.commentThreadHandle);if(!o)return r;let n=r.commentUniqueId,c=o.getCommentByUniqueId(n);return c||r}else if(r&&r.$mid===10){const s=this._commentControllers.get(r.thread.commentControlHandle);if(!s)return r;const o=s.getCommentThread(r.thread.commentThreadHandle);if(!o)return r;let n=r.text,c=r.commentUniqueId,p=o.getCommentByUniqueId(c);return p?(p.body=n,p):r}return r}})}createCommentController(u,a,t){const r=w.handlePool++,s=new l(u,r,this._proxy,a,t);this._commentControllers.set(s.handle,s);const o=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(u.identifier))||[];return o.push(s),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(u.identifier),o),s}$createCommentThreadTemplate(u,a,t){const r=this._commentControllers.get(u);!r||r.$createCommentThreadTemplate(a,t)}async $updateCommentThreadTemplate(u,a,t){const r=this._commentControllers.get(u);!r||r.$updateCommentThreadTemplate(a,t)}$deleteCommentThread(u,a){const t=this._commentControllers.get(u);t&&t.$deleteCommentThread(a)}$provideCommentingRanges(u,a,t){const r=this._commentControllers.get(u);if(!r||!r.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(C.URI.revive(a));return(0,_.asPromise)(()=>r.commentingRangeProvider.provideCommentingRanges(s,t)).then(o=>o?o.map(n=>i.Range.from(n)):void 0)}$toggleReaction(u,a,t,r,s){const o=this._commentControllers.get(u);return!o||!o.reactionHandler?Promise.resolve(void 0):(0,_.asPromise)(()=>{const n=o.getCommentThread(a);if(n){const c=n.getCommentByUniqueId(r.uniqueIdInThread);if(o!==void 0&&c&&o.reactionHandler)return o.reactionHandler(c,g(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=w,w.handlePool=0;class f{constructor(u,a,t,r,s,o,n){this._proxy=u,this._commentController=a,this._id=t,this._uri=r,this._range=s,this._comments=o,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new R.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new I.MutableDisposable,this._acceptInputDisposables.value=new I.DisposableStore,this._id===void 0&&(this._id=`${a.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,i.Range.from(this._range),n),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=o}set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){u.isEqual(this._range)||(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new I.DisposableStore);const u=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),a={};u("range")&&(a.range=i.Range.from(this._range)),u("label")&&(a.label=this.label),u("contextValue")&&(a.contextValue=this.contextValue),u("comments")&&(a.comments=this._comments.map(t=>m(this,this._commentController,t,this._commentsMap))),u("collapsibleState")&&(a.collapseState=b(this._collapseState)),u("canReply")&&(a.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,a)}}getCommentByUniqueId(u){for(let a of this._commentsMap){let t=a[0],r=a[1];if(u===r)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}f._handlePool=0,Ve([(0,D.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=f;class l{constructor(u,a,t,r,s){this._extension=u,this._handle=a,this._proxy=t,this._id=r,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,r,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(u,a,t,r){if(typeof u=="string"){const s=new f(this._proxy,this,u,a,t,r,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new f(this._proxy,this,void 0,u,a,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(u,a){const t=new f(this._proxy,this,void 0,C.URI.revive(u),i.Range.to(a),[],this._extension.identifier);return t.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(u,a){let t=this._threads.get(u);t&&(t.range=i.Range.to(a))}$deleteCommentThread(u){let a=this._threads.get(u);a&&a.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function m(d,u,a,t){let r=t.get(a);r||(r=++d.commentHandle,t.set(a,r));const s=a.author&&a.author.iconPath?a.author.iconPath.toString():void 0;return{mode:a.mode,contextValue:a.contextValue,uniqueIdInThread:r,body:i.MarkdownString.from(a.body),userName:a.author.name,userIconPath:s,label:a.label,commentReactions:a.reactions?a.reactions.map(o=>S(o)):void 0}}function S(d){return{label:d.label,iconPath:d.iconPath?i.pathOrURIToURI(d.iconPath):void 0,count:d.count,hasReacted:d.authorHasReacted}}function g(d){return{label:d.label||"",count:d.count||0,iconPath:d.iconPath?C.URI.revive(d.iconPath):"",authorHasReacted:d.hasReacted||!1}}function b(d){if(d!==void 0)switch(d){case T.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}}),define(me[122],pe([0,1,2,5,8,4,13,12,14,9,7]),function(Z,e,_,D,R,I,C,P,y,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class fn{constructor(f,l){this._logService=l,this._provider=new Map,this._proxy=f.getProxy(D.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,l){const m=fn._handlePool++;this._provider.set(m,{provider:f,extensionId:l}),this._proxy.$registerDecorationProvider(m,l.value);const S=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(g=>{if(!g){this._proxy.$onDidChange(m,null);return}let b=(0,y.asArray)(g);if(b.length<=fn._maxEventSize){this._proxy.$onDidChange(m,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",l.value,b.length);const d=b.map(t=>({uri:t,rank:(0,i.count)(t.path,"/")})),u=(0,y.groupBy)(d,(t,r)=>t.rank-r.rank||(0,i.compare)(t.uri.path,r.uri.path));let a=[];e:for(let t of u){let r;for(let s of t){let o=(0,T.dirname)(s.uri.path);if(r!==o&&(r=o,a.push(s.uri)>=fn._maxEventSize))break e}}this._proxy.$onDidChange(m,a)});return new R.Disposable(()=>{S==null||S.dispose(),this._proxy.$unregisterDecorationProvider(m),this._provider.delete(m)})}async $provideDecorations(f,l,m){if(!this._provider.has(f))return Object.create(null);const S=Object.create(null),{provider:g,extensionId:b}=this._provider.get(f);return await Promise.all(l.map(async d=>{try{const{uri:u,id:a}=d,t=await Promise.resolve(g.provideFileDecoration(_.URI.revive(u),m));if(!t)return;try{R.FileDecoration.validate(t),S[a]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${b.value}': ${r}`)}}catch(u){this._logService.error(u)}})),S}};k._handlePool=0,k._maxEventSize=250,k=Ve([xe(0,C.IExtHostRpcService),xe(1,P.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,I.createDecorator)("IExtHostDecorations")}),define(me[231],pe([0,1,157,109,2,5,8,20,3,12,22]),function(Z,e,_,D,R,I,C,P,y,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class k{constructor(l,m,S,g,b){this._name=l,this._owner=m,this._maxDiagnosticsPerFile=S,this._proxy=g,this._onDidChangeDiagnostics=b,this._isDisposed=!1,this._data=new T.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(l,m){if(!l){this.clear();return}this._checkDisposed();let S=[];if(R.URI.isUri(l)){if(!m){this.delete(l);return}this._data.set(l,m.slice()),S=[l]}else if(Array.isArray(l)){S=[];let b;l=[...l].sort(k._compareIndexedTuplesByUri);for(const d of l){const[u,a]=d;if((!b||u.toString()!==b.toString())&&(b&&this._data.get(b).length===0&&this._data.delete(b),b=u,S.push(u),this._data.set(u,[])),a){const t=this._data.get(u);t&&t.push(...a)}else{const t=this._data.get(u);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(S),!!this._proxy){const g=[];for(let b of S){let d=[];const u=this._data.get(b);if(u)if(u.length>this._maxDiagnosticsPerFile){d=[];const a=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of u)if(r.severity===a[t]&&d.push(P.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;d.push({severity:D.MarkerSeverity.Info,message:(0,_.localize)(0,null,u.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=u.map(a=>P.Diagnostic.from(a));g.push([b,d])}this._proxy.$changeMany(this._owner,g)}}delete(l){this._checkDisposed(),this._onDidChangeDiagnostics.fire([l]),this._data.delete(l),this._proxy&&this._proxy.$changeMany(this._owner,[[l,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(l,m){this._checkDisposed();for(let S of this._data.keys())l.apply(m,[S,this.get(S),this])}get(l){this._checkDisposed();const m=this._data.get(l);return Array.isArray(m)?Object.freeze(m.slice(0)):[]}has(l){return this._checkDisposed(),Array.isArray(this._data.get(l))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(l,m){return l[0].toString()<m[0].toString()?-1:l[0].toString()>m[0].toString()?1:0}}e.DiagnosticCollection=k;let w=class Ut{constructor(l,m){this._logService=m,this._collections=new Map,this._onDidChangeDiagnostics=new y.Emitter,this.onDidChangeDiagnostics=y.Event.map(y.Event.debounce(this._onDidChangeDiagnostics.event,Ut._debouncer,50),Ut._mapper),this._proxy=l.getProxy(I.MainContext.MainThreadDiagnostics)}static _debouncer(l,m){return l?l.concat(m):m}static _mapper(l){const m=[],S=new Set;for(const g of l)typeof g=="string"?S.has(g)||(S.add(g),m.push(R.URI.parse(g))):S.has(g.toString())||(S.add(g.toString()),m.push(g));return Object.freeze(m),{uris:m}}createDiagnosticCollection(l,m){const{_collections:S,_proxy:g,_onDidChangeDiagnostics:b,_logService:d}=this,u=new class{$changeMany(r,s){g.$changeMany(r,s),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",l.value,r,s.length===0?"CLEARING":s)}$clear(r){g.$clear(r),d.trace("[DiagnosticCollection] remove all (extension, owner)",l.value,r)}dispose(){g.dispose()}};let a;if(!m)m="_generated_diagnostic_collection_name_#"+Ut._idPool++,a=m;else if(!S.has(m))a=m;else{this._logService.warn(`DiagnosticCollection with name '${m}' does already exist.`);do a=m+Ut._idPool++;while(S.has(a))}return new class extends k{constructor(){super(m,a,Ut._maxDiagnosticsPerFile,u,b);S.set(a,this)}dispose(){super.dispose(),S.delete(a)}}}getDiagnostics(l){if(l)return this._getDiagnostics(l);{const m=new Map,S=[];for(const g of this._collections.values())g.forEach((b,d)=>{let u=m.get(b.toString());typeof u=="undefined"&&(u=S.length,m.set(b.toString(),u),S.push([b,[]])),S[u][1]=S[u][1].concat(...d)});return S}}_getDiagnostics(l){let m=[];for(let S of this._collections.values())S.has(l)&&(m=m.concat(S.get(l)));return m}$acceptMarkersChange(l){if(!this._mirrorCollection){const m="_generated_mirror",S=new k(m,m,Ut._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(m,S),this._mirrorCollection=S}for(const[m,S]of l)this._mirrorCollection.set(R.URI.revive(m),S.map(P.Diagnostic.to))}};w._idPool=0,w._maxDiagnosticsPerFile=1e3,w=Ve([xe(1,i.ILogService)],w),e.ExtHostDiagnostics=w}),define(me[232],pe([0,1,2,5]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class R{constructor(C){this._proxy=C.getProxy(D.MainContext.MainThreadDialogs)}showOpenDialog(C){return this._proxy.$showOpenDialog(C).then(P=>P?P.map(y=>_.URI.revive(y)):void 0)}showSaveDialog(C){return this._proxy.$showSaveDialog(C).then(P=>P?_.URI.revive(P):void 0)}}e.ExtHostDialogs=R}),define(me[233],pe([0,1,18,2,8,5,11,21,9]),function(Z,e,_,D,R,I,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class i{constructor(k,w,f){this._documentsAndEditors=w,this._logService=f,this._documentContentProviders=new Map,this._proxy=k.getProxy(I.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,w){if(Object.keys(C.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const f=i._handlePool++;this._documentContentProviders.set(f,w),this._proxy.$registerTextContentProvider(f,k);let l;return typeof w.onDidChange=="function"&&(l=w.onDidChange(m=>{if(m.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(m)&&this.$provideTextDocumentContent(f,m).then(S=>{if(!(!S&&typeof S!="string")){const g=this._documentsAndEditors.getDocument(m);if(!!g){const b=(0,y.splitLines)(S);if(!g.equalLines(b))return this._proxy.$onVirtualDocumentChange(m,S)}}},_.onUnexpectedError)})),new R.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),l&&(l.dispose(),l=void 0)})}$provideTextDocumentContent(k,w){const f=this._documentContentProviders.get(k);return f?Promise.resolve(f.provideTextDocumentContent(D.URI.revive(w),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${w.scheme}`))}}e.ExtHostDocumentContentProvider=i,i._handlePool=0}),define(me[234],pe([0,1,3,6,2,5,119,20,15,24]),function(Z,e,_,D,R,I,C,P,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(w,f){this._onDidAddDocument=new _.Emitter,this._onDidRemoveDocument=new _.Emitter,this._onDidChangeDocument=new _.Emitter,this._onDidSaveDocument=new _.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new D.DisposableStore,this._documentLoader=new Map,this._proxy=w.getProxy(I.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(l=>{for(const m of l)this._onDidRemoveDocument.fire(m.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(l=>{for(const m of l)this._onDidAddDocument.fire(m.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(w){if(!!w){const f=this._documentsAndEditors.getDocument(w);if(f)return f}}getDocument(w){const f=this.getDocumentData(w);if(!(f==null?void 0:f.document))throw new Error(`Unable to retrieve document from URI '${w}'`);return f.document}ensureDocumentData(w){const f=this._documentsAndEditors.getDocument(w);if(f)return Promise.resolve(f);let l=this._documentLoader.get(w.toString());return l||(l=this._proxy.$tryOpenDocument(w).then(m=>{this._documentLoader.delete(w.toString());const S=R.URI.revive(m);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(S))},m=>(this._documentLoader.delete(w.toString()),Promise.reject(m))),this._documentLoader.set(w.toString(),l)),l}createDocumentData(w){return this._proxy.$tryCreateDocument(w).then(f=>R.URI.revive(f))}$acceptModelModeChanged(w,f,l){const m=R.URI.revive(w),S=this._documentsAndEditors.getDocument(m);if(!S)throw new Error("unknown document");this._onDidRemoveDocument.fire(S.document),S._acceptLanguageId(l),this._onDidAddDocument.fire(S.document)}$acceptModelSaved(w){const f=R.URI.revive(w),l=this._documentsAndEditors.getDocument(f);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this._onDidSaveDocument.fire(l.document)}$acceptDirtyStateChanged(w,f){const l=R.URI.revive(w),m=this._documentsAndEditors.getDocument(l);if(!m)throw new Error("unknown document");m._acceptIsDirty(f),this._onDidChangeDocument.fire({document:m.document,contentChanges:[]})}$acceptModelChanged(w,f,l){const m=R.URI.revive(w),S=this._documentsAndEditors.getDocument(m);if(!S)throw new Error("unknown document");S._acceptIsDirty(l),S.onEvents(f),this._onDidChangeDocument.fire((0,i.deepFreeze)({document:S.document,contentChanges:f.changes.map(g=>({range:P.Range.to(g.range),rangeOffset:g.rangeOffset,rangeLength:g.rangeLength,text:g.text}))}))}setWordDefinitionFor(w,f){(0,C.setWordDefinitionFor)(w,f)}}e.ExtHostDocuments=T}),define(me[39],pe([0,1,53,3,6,2,4,5,119,13,120,20,12,22,11,72,131]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class g{constructor(u){this.value=u,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(u,a){this._extHostRpc=u,this._logService=a,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new D.Emitter,this._onDidRemoveDocuments=new D.Emitter,this._onDidChangeVisibleTextEditors=new D.Emitter,this._onDidChangeActiveTextEditor=new D.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const a=[],t=[],r=[];if(u.removedDocuments)for(const s of u.removedDocuments){const o=I.URI.revive(s),n=this._documents.get(o);(n==null?void 0:n.unref())&&(this._documents.delete(o),a.push(n.value))}if(u.addedDocuments)for(const s of u.addedDocuments){const o=I.URI.revive(s.uri);let n=this._documents.get(o);if(n&&o.scheme!==l.Schemas.vscodeNotebookCell)throw new Error(`document '${o} already exists!'`);n||(n=new g(new y.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),o,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(o,n),t.push(n.value)),n.ref()}if(u.removedEditors)for(const s of u.removedEditors){const o=this._editors.get(s);this._editors.delete(s),o&&r.push(o)}if(u.addedEditors)for(const s of u.addedEditors){const o=I.URI.revive(s.documentUri);_.ok(this._documents.has(o),`document '${o}' does not exist`),_.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const n=this._documents.get(o).value,c=new T.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new S.Lazy(()=>n.document),s.selections.map(k.Selection.to),s.options,s.visibleRanges.map(p=>k.Range.to(p)),typeof s.editorPosition=="number"?k.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,c)}u.newActiveEditor!==void 0&&(_.ok(u.newActiveEditor===null||this._editors.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this._activeEditorId=u.newActiveEditor),(0,R.dispose)(a),(0,R.dispose)(r),u.removedDocuments&&this._onDidRemoveDocuments.fire(a),u.addedDocuments&&this._onDidAddDocuments.fire(t),(u.removedEditors||u.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),u.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(u){var a;return(a=this._documents.get(u))===null||a===void 0?void 0:a.value}allDocuments(){return m.Iterable.map(this._documents.values(),u=>u.value)}getEditor(u){return this._editors.get(u)}activeEditor(u){if(!!this._activeEditorId){const a=this._editors.get(this._activeEditorId);return u?a:a==null?void 0:a.value}}allEditors(){return[...this._editors.values()]}};b=Ve([xe(0,i.IExtHostRpcService),xe(1,w.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[235],pe([0,1,2,5,6,8,20,140,9,26]),function(Z,e,_,D,R,I,C,P,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class T{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const l=this._schemes.indexOf(f);l>=0&&(this._schemes.splice(l,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),l=[];let m,S,g=14,b=14;for(const d of f){let u=m?(0,y.commonPrefixLength)(m,d):0;for(u===0?S=1:S=b;u<d.length;u++)u+1===d.length?(g=b,b=9):b+=1,l.push([S,d.toUpperCase().charCodeAt(u),b]),l.push([S,d.toLowerCase().charCodeAt(u),b]),S=b;m=d,b=g}l.push([9,58,10]),l.push([10,47,12]),this._stateMachine=new P.StateMachine(l)}}provideDocumentLinks(f){this._initStateMachine();const l=[],m=P.LinkComputer.computeLinks({getLineContent(S){return f.lineAt(S-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const S of m){const g=C.DocumentLink.to(S);g.target&&l.push(g)}return l}}class k{constructor(f,l){this._extHostLanguageFeatures=l,this._linkProvider=new T,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(D.MainContext.MainThreadFileSystem)}dispose(){var f;(f=this._linkProviderRegistration)===null||f===void 0||f.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,l,m,S={}){if(this._registeredSchemes.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const g=this._handlePool++;this._linkProvider.add(l),this._registeredSchemes.add(l),this._fsProvider.set(g,m);let b=2;S.isCaseSensitive&&(b+=1024),S.isReadonly&&(b+=2048),typeof m.copy=="function"&&(b+=8),typeof m.open=="function"&&typeof m.close=="function"&&typeof m.read=="function"&&typeof m.write=="function"&&(b+=4),this._proxy.$registerFileSystemProvider(g,l,b).catch(u=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${l}`),console.error(u)});const d=m.onDidChangeFile(u=>{const a=[];for(const t of u){let{uri:r,type:s}=t;if(r.scheme===l){let o;switch(s){case I.FileChangeType.Changed:o=0;break;case I.FileChangeType.Created:o=1;break;case I.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:r,type:o})}}this._proxy.$onFileSystemChange(g,a)});return(0,R.toDisposable)(()=>{d.dispose(),this._linkProvider.delete(l),this._registeredSchemes.delete(l),this._fsProvider.delete(g),this._proxy.$unregisterProvider(g)})}static _asIStat(f){const{type:l,ctime:m,mtime:S,size:g}=f;return{type:l,ctime:m,mtime:S,size:g}}$stat(f,l){return Promise.resolve(this._getFsProvider(f).stat(_.URI.revive(l))).then(k._asIStat)}$readdir(f,l){return Promise.resolve(this._getFsProvider(f).readDirectory(_.URI.revive(l)))}$readFile(f,l){return Promise.resolve(this._getFsProvider(f).readFile(_.URI.revive(l))).then(m=>i.VSBuffer.wrap(m))}$writeFile(f,l,m,S){return Promise.resolve(this._getFsProvider(f).writeFile(_.URI.revive(l),m.buffer,S))}$delete(f,l,m){return Promise.resolve(this._getFsProvider(f).delete(_.URI.revive(l),m))}$rename(f,l,m,S){return Promise.resolve(this._getFsProvider(f).rename(_.URI.revive(l),_.URI.revive(m),S))}$copy(f,l,m,S){const g=this._getFsProvider(f);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(_.URI.revive(l),_.URI.revive(m),S))}$mkdir(f,l){return Promise.resolve(this._getFsProvider(f).createDirectory(_.URI.revive(l)))}$watch(f,l,m,S){const g=this._getFsProvider(f).watch(_.URI.revive(m),S);this._watches.set(l,g)}$unwatch(f,l){const m=this._watches.get(l);m&&(m.dispose(),this._watches.delete(l))}$open(f,l,m){const S=this._getFsProvider(f);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(_.URI.revive(l),m))}$close(f,l){const m=this._getFsProvider(f);if(!m.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(m.close(l))}$read(f,l,m,S){const g=this._getFsProvider(f);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const b=i.VSBuffer.alloc(S);return Promise.resolve(g.read(l,m,b.buffer,0,S)).then(d=>b.slice(0,d))}$write(f,l,m,S){const g=this._getFsProvider(f);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(l,m,S.buffer,0,S.byteLength))}_getFsProvider(f){const l=this._fsProvider.get(f);if(!l){const m=new Error;throw m.name="ENOPRO",m.message="no provider",m}return l}}e.ExtHostFileSystem=k}),define(me[87],pe([0,1,5,49,8,26,4,13,62]),function(Z,e,_,D,R,I,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let i=class Rt{constructor(k,w){const f=k.getProxy(_.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(l){return f.$stat(l).catch(Rt._handleError)},readDirectory(l){return f.$readdir(l).catch(Rt._handleError)},createDirectory(l){return f.$mkdir(l).catch(Rt._handleError)},async readFile(l){return f.$readFile(l).then(m=>m.buffer).catch(Rt._handleError)},writeFile(l,m){return f.$writeFile(l,I.VSBuffer.wrap(m)).catch(Rt._handleError)},delete(l,m){return f.$delete(l,Object.assign({recursive:!1,useTrash:!1},m)).catch(Rt._handleError)},rename(l,m,S){return f.$rename(l,m,Object.assign({overwrite:!1},S)).catch(Rt._handleError)},copy(l,m,S){return f.$copy(l,m,Object.assign({overwrite:!1},S)).catch(Rt._handleError)},isWritableFileSystem(l){const m=w.getCapabilities(l);if(typeof m=="number")return!(m&2048)}})}static _handleError(k){if(!(k instanceof Error))throw new R.FileSystemError(String(k));if(k.name==="ENOPRO")throw R.FileSystemError.Unavailable(k.message);switch(k.name){case D.FileSystemProviderErrorCode.FileExists:throw R.FileSystemError.FileExists(k.message);case D.FileSystemProviderErrorCode.FileNotFound:throw R.FileSystemError.FileNotFound(k.message);case D.FileSystemProviderErrorCode.FileNotADirectory:throw R.FileSystemError.FileNotADirectory(k.message);case D.FileSystemProviderErrorCode.FileIsADirectory:throw R.FileSystemError.FileIsADirectory(k.message);case D.FileSystemProviderErrorCode.NoPermissions:throw R.FileSystemError.NoPermissions(k.message);case D.FileSystemProviderErrorCode.Unavailable:throw R.FileSystemError.Unavailable(k.message);default:throw new R.FileSystemError(k.message,k.name)}}};i=Ve([xe(0,P.IExtHostRpcService),xe(1,y.IExtHostFileSystemInfo)],i),e.ExtHostConsumerFileSystem=i,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(me[236],pe([0,1,6,5]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class R{constructor(C){this._handlePool=0,this._proxy=C.getProxy(D.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,C),(0,_.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=R}),define(me[237],pe([0,1,2,24,20,8,19,5,9,44,14,15,137,6,105,71,115,46,18]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l,m,S,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class d{constructor(H,Q){this._documents=H,this._provider=Q}provideDocumentSymbols(H,Q){const ne=this._documents.getDocument(H);return(0,C.asPromise)(()=>this._provider.provideDocumentSymbols(ne,Q)).then(oe=>{if(!(0,T.isFalsyOrEmpty)(oe))return oe[0]instanceof I.DocumentSymbol?oe.map(R.DocumentSymbol.from):d._asDocumentSymbolTree(oe)})}static _asDocumentSymbolTree(H){var Q;H=H.slice(0).sort((ge,Ce)=>{let Oe=ge.location.range.start.compareTo(Ce.location.range.start);return Oe===0&&(Oe=Ce.location.range.end.compareTo(ge.location.range.end)),Oe});const ne=[],oe=[];for(const ge of H){const Ce={name:ge.name||"!!MISSING: name!!",kind:R.SymbolKind.from(ge.kind),tags:((Q=ge.tags)===null||Q===void 0?void 0:Q.map(R.SymbolTag.from))||[],detail:"",containerName:ge.containerName,range:R.Range.from(ge.location.range),selectionRange:R.Range.from(ge.location.range),children:[]};for(;;){if(oe.length===0){oe.push(Ce),ne.push(Ce);break}const Oe=oe[oe.length-1];if(i.Range.containsRange(Oe.range,Ce.range)&&!i.Range.equalsRange(Oe.range,Ce.range)){Oe.children&&Oe.children.push(Ce),oe.push(Ce);break}oe.pop()}}return ne}}class u{constructor(H,Q,ne){this._documents=H,this._commands=Q,this._provider=ne,this._cache=new S.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(H,Q){const ne=this._documents.getDocument(H),oe=await this._provider.provideCodeLenses(ne,Q);if(!(!oe||Q.isCancellationRequested)){const ge=this._cache.add(oe),Ce=new f.DisposableStore;this._disposables.set(ge,Ce);const Oe={cacheId:ge,lenses:[]};for(let ve=0;ve<oe.length;ve++)Oe.lenses.push({cacheId:[ge,ve],range:R.Range.from(oe[ve].range),command:this._commands.toInternal(oe[ve].command,Ce)});return Oe}}async resolveCodeLens(H,Q){var ne;const oe=H.cacheId&&this._cache.get(...H.cacheId);if(!!oe){let ge;if(typeof this._provider.resolveCodeLens!="function"||oe.isResolved?ge=oe:ge=await this._provider.resolveCodeLens(oe,Q),ge||(ge=oe),!Q.isCancellationRequested){const Ce=H.cacheId&&this._disposables.get(H.cacheId[0]);if(!!Ce)return H.command=this._commands.toInternal((ne=ge.command)!==null&&ne!==void 0?ne:u._badCmd,Ce),H}}}releaseCodeLenses(H){var Q;(Q=this._disposables.get(H))===null||Q===void 0||Q.dispose(),this._disposables.delete(H),this._cache.delete(H)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function a(Me){return Array.isArray(Me)?Me.map(R.DefinitionLink.from):Me?[R.DefinitionLink.from(Me)]:[]}class t{constructor(H,Q){this._documents=H,this._provider=Q}provideDefinition(H,Q,ne){const oe=this._documents.getDocument(H),ge=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.provideDefinition(oe,ge,ne)).then(a)}}class r{constructor(H,Q){this._documents=H,this._provider=Q}provideDeclaration(H,Q,ne){const oe=this._documents.getDocument(H),ge=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.provideDeclaration(oe,ge,ne)).then(a)}}class s{constructor(H,Q){this._documents=H,this._provider=Q}provideImplementation(H,Q,ne){const oe=this._documents.getDocument(H),ge=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.provideImplementation(oe,ge,ne)).then(a)}}class o{constructor(H,Q){this._documents=H,this._provider=Q}provideTypeDefinition(H,Q,ne){const oe=this._documents.getDocument(H),ge=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.provideTypeDefinition(oe,ge,ne)).then(a)}}class n{constructor(H,Q){this._documents=H,this._provider=Q}provideHover(H,Q,ne){const oe=this._documents.getDocument(H),ge=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.provideHover(oe,ge,ne)).then(Ce=>{if(!(!Ce||(0,T.isFalsyOrEmpty)(Ce.contents)))return Ce.range||(Ce.range=oe.getWordRangeAtPosition(ge)),Ce.range||(Ce.range=new I.Range(ge,ge)),R.Hover.from(Ce)})}}class c{constructor(H,Q){this._documents=H,this._provider=Q}provideEvaluatableExpression(H,Q,ne){const oe=this._documents.getDocument(H),ge=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.provideEvaluatableExpression(oe,ge,ne)).then(Ce=>{if(Ce)return R.EvaluatableExpression.from(Ce)})}}class p{constructor(H,Q){this._documents=H,this._provider=Q}provideInlineValues(H,Q,ne,oe){const ge=this._documents.getDocument(H);return(0,C.asPromise)(()=>this._provider.provideInlineValues(ge,R.Range.to(Q),R.InlineValueContext.to(ne),oe)).then(Ce=>{if(Array.isArray(Ce))return Ce.map(Oe=>R.InlineValue.from(Oe))})}}class E{constructor(H,Q){this._documents=H,this._provider=Q}provideDocumentHighlights(H,Q,ne){const oe=this._documents.getDocument(H),ge=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.provideDocumentHighlights(oe,ge,ne)).then(Ce=>{if(Array.isArray(Ce))return Ce.map(R.DocumentHighlight.from)})}}class h{constructor(H,Q){this._documents=H,this._provider=Q}provideLinkedEditingRanges(H,Q,ne){const oe=this._documents.getDocument(H),ge=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.provideLinkedEditingRanges(oe,ge,ne)).then(Ce=>{if(Ce&&Array.isArray(Ce.ranges))return{ranges:(0,T.coalesce)(Ce.ranges.map(R.Range.from)),wordPattern:Ce.wordPattern}})}}class v{constructor(H,Q){this._documents=H,this._provider=Q}provideReferences(H,Q,ne,oe){const ge=this._documents.getDocument(H),Ce=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.provideReferences(ge,Ce,ne,oe)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(R.location.from)})}}class A{constructor(H,Q,ne,oe,ge,Ce,Oe){this._documents=H,this._commands=Q,this._diagnostics=ne,this._provider=oe,this._logService=ge,this._extension=Ce,this._apiDeprecation=Oe,this._cache=new S.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(H,Q,ne,oe){const ge=this._documents.getDocument(H),Ce=w.Selection.isISelection(Q)?R.Selection.to(Q):R.Range.to(Q),Oe=[];for(const ke of this._diagnostics.getDiagnostics(H))if(Ce.intersection(ke.range)&&Oe.push(ke)>A._maxCodeActionsPerFile)break;const ve={diagnostics:Oe,only:ne.only?new I.CodeActionKind(ne.only):void 0,triggerKind:R.CodeActionTriggerKind.to(ne.trigger)};return(0,C.asPromise)(()=>this._provider.provideCodeActions(ge,Ce,ve,oe)).then(ke=>{var Pe;if(!(!(0,T.isNonEmptyArray)(ke)||oe.isCancellationRequested)){const Ue=this._cache.add(ke),Se=new f.DisposableStore;this._disposables.set(Ue,Se);const qe=[];for(let X=0;X<ke.length;X++){const ie=ke[X];!ie||(A._isCommand(ie)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:ie.title,command:this._commands.toInternal(ie,Se)})):(ve.only&&(ie.kind?ve.only.contains(ie.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action is of kind '${ie.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[Ue,X],title:ie.title,command:ie.command&&this._commands.toInternal(ie.command,Se),diagnostics:ie.diagnostics&&ie.diagnostics.map(R.Diagnostic.from),edit:ie.edit&&R.WorkspaceEdit.from(ie.edit),kind:ie.kind&&ie.kind.value,isPreferred:ie.isPreferred,disabled:(Pe=ie.disabled)===null||Pe===void 0?void 0:Pe.reason})))}return{cacheId:Ue,actions:qe}}})}async resolveCodeAction(H,Q){var ne;const[oe,ge]=H,Ce=this._cache.get(oe,ge);if(!(!Ce||A._isCommand(Ce))&&!!this._provider.resolveCodeAction){const Oe=(ne=await this._provider.resolveCodeAction(Ce,Q))!==null&&ne!==void 0?ne:Ce;return(Oe==null?void 0:Oe.edit)?R.WorkspaceEdit.from(Oe.edit):void 0}}releaseCodeActions(H){var Q;(Q=this._disposables.get(H))===null||Q===void 0||Q.dispose(),this._disposables.delete(H),this._cache.delete(H)}static _isCommand(H){return typeof H.command=="string"&&typeof H.title=="string"}}A._maxCodeActionsPerFile=1e3;class F{constructor(H,Q){this._documents=H,this._provider=Q}provideDocumentFormattingEdits(H,Q,ne){const oe=this._documents.getDocument(H);return(0,C.asPromise)(()=>this._provider.provideDocumentFormattingEdits(oe,Q,ne)).then(ge=>{if(Array.isArray(ge))return ge.map(R.TextEdit.from)})}}class x{constructor(H,Q){this._documents=H,this._provider=Q}provideDocumentRangeFormattingEdits(H,Q,ne,oe){const ge=this._documents.getDocument(H),Ce=R.Range.to(Q);return(0,C.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(ge,Ce,ne,oe)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(R.TextEdit.from)})}}class j{constructor(H,Q){this._documents=H,this._provider=Q,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(H,Q,ne,oe,ge){const Ce=this._documents.getDocument(H),Oe=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(Ce,Oe,ne,oe,ge)).then(ve=>{if(Array.isArray(ve))return ve.map(R.TextEdit.from)})}}class G{constructor(H,Q){this._provider=H,this._logService=Q,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(H,Q){const ne=P.IdObject.mixin({symbols:[]});return(0,C.asPromise)(()=>this._provider.provideWorkspaceSymbols(H,Q)).then(oe=>{if((0,T.isNonEmptyArray)(oe)){for(const ge of oe)if(!!ge){if(!ge.name){this._logService.warn("INVALID SymbolInformation, lacks name",ge);continue}const Ce=P.IdObject.mixin(R.WorkspaceSymbol.from(ge));this._symbolCache.set(Ce._id,ge),ne.symbols.push(Ce)}}}).then(()=>(ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne))}async resolveWorkspaceSymbol(H,Q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return H;const ne=this._symbolCache.get(H._id);if(ne){const oe=await(0,C.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ne,Q));return oe&&(0,D.mixin)(H,R.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(H){const Q=this._resultCache.get(H);if(Q){for(let[ne,oe]=Q;ne<=oe;ne++)this._symbolCache.delete(ne);this._resultCache.delete(H)}}}class B{constructor(H,Q,ne){this._documents=H,this._provider=Q,this._logService=ne}static supportsResolving(H){return typeof H.prepareRename=="function"}provideRenameEdits(H,Q,ne,oe){const ge=this._documents.getDocument(H),Ce=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.provideRenameEdits(ge,Ce,ne,oe)).then(Oe=>{if(!!Oe)return R.WorkspaceEdit.from(Oe)},Oe=>{const ve=B._asMessage(Oe);return ve?{rejectReason:ve,edits:void 0}:Promise.reject(Oe)})}resolveRenameLocation(H,Q,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument(H),ge=R.Position.to(Q);return(0,C.asPromise)(()=>this._provider.prepareRename(oe,ge,ne)).then(Ce=>{let Oe,ve;if(I.Range.isRange(Ce)?(Oe=Ce,ve=oe.getText(Ce)):(0,k.isObject)(Ce)&&(Oe=Ce.range,ve=Ce.placeholder),!!Oe){if(Oe.start.line>ge.line||Oe.end.line<ge.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:R.Range.from(Oe),text:ve}}},Ce=>{const Oe=B._asMessage(Ce);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(Ce)})}static _asMessage(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class J{constructor(H,Q){this.resultId=H,this.tokens=Q}}class O{constructor(H,Q){this._documents=H,this._provider=Q,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(H,Q,ne){const oe=this._documents.getDocument(H),ge=Q!==0?this._previousResults.get(Q):null;return(0,C.asPromise)(()=>ge&&typeof ge.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(oe,ge.resultId,ne):this._provider.provideDocumentSemanticTokens(oe,ne)).then(Ce=>(ge&&this._previousResults.delete(Q),Ce?(Ce=O._fixProvidedSemanticTokens(Ce),this._send(O._convertToEdits(ge,Ce),Ce)):null))}async releaseDocumentSemanticColoring(H){this._previousResults.delete(H)}static _fixProvidedSemanticTokens(H){return O._isSemanticTokens(H)?O._isCorrectSemanticTokens(H)?H:new I.SemanticTokens(new Uint32Array(H.data),H.resultId):O._isSemanticTokensEdits(H)?O._isCorrectSemanticTokensEdits(H)?H:new I.SemanticTokensEdits(H.edits.map(Q=>new I.SemanticTokensEdit(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),H.resultId):H}static _isSemanticTokens(H){return H&&!!H.data}static _isCorrectSemanticTokens(H){return H.data instanceof Uint32Array}static _isSemanticTokensEdits(H){return H&&Array.isArray(H.edits)}static _isCorrectSemanticTokensEdits(H){for(const Q of H.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(H,Q){if(!O._isSemanticTokens(Q)||!H||!H.tokens)return Q;const ne=H.tokens,oe=ne.length,ge=Q.data,Ce=ge.length;let Oe=0;const ve=Math.min(oe,Ce);for(;Oe<ve&&ne[Oe]===ge[Oe];)Oe++;if(Oe===oe&&Oe===Ce)return new I.SemanticTokensEdits([],Q.resultId);let ke=0;const Pe=ve-Oe;for(;ke<Pe&&ne[oe-ke-1]===ge[Ce-ke-1];)ke++;return new I.SemanticTokensEdits([{start:Oe,deleteCount:oe-Oe-ke,data:ge.subarray(Oe,Ce-ke)}],Q.resultId)}_send(H,Q){if(O._isSemanticTokens(H)){const ne=this._nextResultId++;return this._previousResults.set(ne,new J(H.resultId,H.data)),(0,l.encodeSemanticTokensDto)({id:ne,type:"full",data:H.data})}if(O._isSemanticTokensEdits(H)){const ne=this._nextResultId++;return O._isSemanticTokens(Q)?this._previousResults.set(ne,new J(Q.resultId,Q.data)):this._previousResults.set(ne,new J(H.resultId)),(0,l.encodeSemanticTokensDto)({id:ne,type:"delta",deltas:(H.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}e.DocumentSemanticTokensAdapter=O;class N{constructor(H,Q){this._documents=H,this._provider=Q}provideDocumentRangeSemanticTokens(H,Q,ne){const oe=this._documents.getDocument(H);return(0,C.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(oe,R.Range.to(Q),ne)).then(ge=>ge?this._send(ge):null)}_send(H){return(0,l.encodeSemanticTokensDto)({id:0,type:"full",data:H.data})}}e.DocumentRangeSemanticTokensAdapter=N;class U{constructor(H,Q,ne,oe,ge){this._documents=H,this._commands=Q,this._provider=ne,this._apiDeprecation=oe,this._extension=ge,this._cache=new S.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(H){return typeof H.resolveCompletionItem=="function"}async provideCompletionItems(H,Q,ne,oe){const ge=this._documents.getDocument(H),Ce=R.Position.to(Q),Oe=ge.getWordRangeAtPosition(Ce)||new I.Range(Ce,Ce),ve=Oe.with({end:Ce}),ke=new g.StopWatch(!0),Pe=await(0,C.asPromise)(()=>this._provider.provideCompletionItems(ge,Ce,oe,R.CompletionContext.to(ne)));if(!!Pe&&!oe.isCancellationRequested){const Ue=Array.isArray(Pe)?new I.CompletionList(Pe):Pe,Se=U.supportsResolving(this._provider)?this._cache.add(Ue.items):this._cache.add([]),qe=new f.DisposableStore;this._disposables.set(Se,qe);const X=[],ie={x:Se,b:X,a:{replace:R.Range.from(Oe),insert:R.Range.from(ve)},c:Ue.isIncomplete||void 0,d:ke.elapsed()};for(let Ee=0;Ee<Ue.items.length;Ee++){const Ne=Ue.items[Ee],He=this._convertCompletionItem(Ne,[Se,Ee],ve,Oe);X.push(He)}return ie}}async resolveCompletionItem(H,Q){if(typeof this._provider.resolveCompletionItem=="function"){const ne=this._cache.get(...H);if(!!ne){const oe=await(0,C.asPromise)(()=>this._provider.resolveCompletionItem(ne,Q));if(!!oe)return this._convertCompletionItem(oe,H)}}}releaseCompletionItems(H){var Q;(Q=this._disposables.get(H))===null||Q===void 0||Q.dispose(),this._disposables.delete(H),this._cache.delete(H)}_convertCompletionItem(H,Q,ne,oe){var ge;const Ce=this._disposables.get(Q[0]);if(!Ce)throw Error("DisposableStore is missing...");const Oe={x:Q,a:(ge=H.label)!==null&&ge!==void 0?ge:"",o:H.label2,b:H.kind!==void 0?R.CompletionItemKind.from(H.kind):void 0,n:H.tags&&H.tags.map(R.CompletionItemTag.from),c:H.detail,d:typeof H.documentation=="undefined"?void 0:R.MarkdownString.fromStrict(H.documentation),e:H.sortText!==H.label?H.sortText:void 0,f:H.filterText!==H.label?H.filterText:void 0,g:H.preselect||void 0,i:H.keepWhitespace?1:0,k:H.commitCharacters,l:H.additionalTextEdits&&H.additionalTextEdits.map(R.TextEdit.from),m:this._commands.toInternal(H.command,Ce)};H.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=H.textEdit.newText):typeof H.insertText=="string"?Oe.h=H.insertText:H.insertText instanceof I.SnippetString&&(Oe.h=H.insertText.value,Oe.i|=4);let ve;return H.textEdit?ve=H.textEdit.range:H.range&&(ve=H.range),I.Range.isRange(ve)?Oe.j=R.Range.from(ve):ve&&(!(ne==null?void 0:ne.isEqual(ve.inserting))||!(oe==null?void 0:oe.isEqual(ve.replacing)))&&(Oe.j={insert:R.Range.from(ve.inserting),replace:R.Range.from(ve.replacing)}),Oe}}class L{constructor(H,Q){this._documents=H,this._provider=Q,this._cache=new S.Cache("SignatureHelp")}provideSignatureHelp(H,Q,ne,oe){const ge=this._documents.getDocument(H),Ce=R.Position.to(Q),Oe=this.reviveContext(ne);return(0,C.asPromise)(()=>this._provider.provideSignatureHelp(ge,Ce,oe,Oe)).then(ve=>{if(ve){const ke=this._cache.add([ve]);return Object.assign(Object.assign({},R.SignatureHelp.from(ve)),{id:ke})}})}reviveContext(H){let Q;if(H.activeSignatureHelp){const ne=R.SignatureHelp.to(H.activeSignatureHelp),oe=this._cache.get(H.activeSignatureHelp.id,0);oe?(Q=oe,Q.activeSignature=ne.activeSignature,Q.activeParameter=ne.activeParameter):Q=ne}return Object.assign(Object.assign({},H),{activeSignatureHelp:Q})}releaseSignatureHelp(H){this._cache.delete(H)}}class M{constructor(H,Q){this._documents=H,this._provider=Q}provideInlineHints(H,Q,ne){const oe=this._documents.getDocument(H);return(0,C.asPromise)(()=>this._provider.provideInlineHints(oe,R.Range.to(Q),ne)).then(ge=>ge?{hints:ge.map(R.InlineHint.from)}:void 0)}}class V{constructor(H,Q){this._documents=H,this._provider=Q,this._cache=new S.Cache("DocumentLink")}provideLinks(H,Q){const ne=this._documents.getDocument(H);return(0,C.asPromise)(()=>this._provider.provideDocumentLinks(ne,Q)).then(oe=>{if(!(!Array.isArray(oe)||oe.length===0)&&!Q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.map(R.DocumentLink.from)};{const ge=this._cache.add(oe),Ce={links:[],id:ge};for(let Oe=0;Oe<oe.length;Oe++){const ve=R.DocumentLink.from(oe[Oe]);ve.cacheId=[ge,Oe],Ce.links.push(ve)}return Ce}}})}resolveLink(H,Q){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ne=this._cache.get(...H);return ne?(0,C.asPromise)(()=>this._provider.resolveDocumentLink(ne,Q)).then(oe=>oe&&R.DocumentLink.from(oe)||void 0):Promise.resolve(void 0)}releaseLinks(H){this._cache.delete(H)}}class K{constructor(H,Q){this._documents=H,this._provider=Q}provideColors(H,Q){const ne=this._documents.getDocument(H);return(0,C.asPromise)(()=>this._provider.provideDocumentColors(ne,Q)).then(oe=>Array.isArray(oe)?oe.map(Ce=>({color:R.Color.from(Ce.color),range:R.Range.from(Ce.range)})):[])}provideColorPresentations(H,Q,ne){const oe=this._documents.getDocument(H),ge=R.Range.to(Q.range),Ce=R.Color.to(Q.color);return(0,C.asPromise)(()=>this._provider.provideColorPresentations(Ce,{document:oe,range:ge},ne)).then(Oe=>{if(!!Array.isArray(Oe))return Oe.map(R.ColorPresentation.from)})}}class se{constructor(H,Q){this._documents=H,this._provider=Q}provideFoldingRanges(H,Q,ne){const oe=this._documents.getDocument(H);return(0,C.asPromise)(()=>this._provider.provideFoldingRanges(oe,Q,ne)).then(ge=>{if(!!Array.isArray(ge))return ge.map(R.FoldingRange.from)})}}class ce{constructor(H,Q,ne){this._documents=H,this._provider=Q,this._logService=ne}provideSelectionRanges(H,Q,ne){const oe=this._documents.getDocument(H),ge=Q.map(R.Position.to);return(0,C.asPromise)(()=>this._provider.provideSelectionRanges(oe,ge,ne)).then(Ce=>{if(!(0,T.isNonEmptyArray)(Ce))return[];if(Ce.length!==ge.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let ve=0;ve<ge.length;ve++){const ke=[];Oe.push(ke);let Pe=ge[ve],Ue=Ce[ve];for(;;){if(!Ue.range.contains(Pe))throw new Error("INVALID selection range, must contain the previous range");if(ke.push(R.SelectionRange.from(Ue)),!Ue.parent)break;Pe=Ue.range,Ue=Ue.parent}}return Oe})}}class we{constructor(H,Q){this._documents=H,this._provider=Q,this._idPool=new m.IdGenerator(""),this._cache=new Map}async prepareSession(H,Q,ne){const oe=this._documents.getDocument(H),ge=R.Position.to(Q),Ce=await this._provider.prepareCallHierarchy(oe,ge,ne);if(!!Ce){const Oe=this._idPool.nextId();return this._cache.set(Oe,new Map),Array.isArray(Ce)?Ce.map(ve=>this._cacheAndConvertItem(Oe,ve)):[this._cacheAndConvertItem(Oe,Ce)]}}async provideCallsTo(H,Q,ne){const oe=this._itemFromCache(H,Q);if(!oe)throw new Error("missing call hierarchy item");const ge=await this._provider.provideCallHierarchyIncomingCalls(oe,ne);if(!!ge)return ge.map(Ce=>({from:this._cacheAndConvertItem(H,Ce.from),fromRanges:Ce.fromRanges.map(Oe=>R.Range.from(Oe))}))}async provideCallsFrom(H,Q,ne){const oe=this._itemFromCache(H,Q);if(!oe)throw new Error("missing call hierarchy item");const ge=await this._provider.provideCallHierarchyOutgoingCalls(oe,ne);if(!!ge)return ge.map(Ce=>({to:this._cacheAndConvertItem(H,Ce.to),fromRanges:Ce.fromRanges.map(Oe=>R.Range.from(Oe))}))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,Q){var ne;const oe=this._cache.get(H),ge={_sessionId:H,_itemId:oe.size.toString(36),name:Q.name,detail:Q.detail,kind:R.SymbolKind.from(Q.kind),uri:Q.uri,range:R.Range.from(Q.range),selectionRange:R.Range.from(Q.selectionRange),tags:(ne=Q.tags)===null||ne===void 0?void 0:ne.map(R.SymbolTag.from)};return oe.set(ge._itemId,Q),ge}_itemFromCache(H,Q){const ne=this._cache.get(H);return ne==null?void 0:ne.get(Q)}}class Te{constructor(H,Q){this.adapter=H,this.extension=Q}}class Ie{constructor(H,Q,ne,oe,ge,Ce,Oe){this._adapter=new Map,this._uriTransformer=Q,this._proxy=H.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=oe,this._diagnostics=ge,this._logService=Ce,this._apiDeprecation=Oe}_transformDocumentSelector(H){return(0,T.coalesce)((0,T.asArray)(H).map(Q=>this._doTransformDocumentSelector(Q)))}_doTransformDocumentSelector(H){if(typeof H=="string")return{$serialized:!0,language:H};if(H)return{$serialized:!0,language:H.language,scheme:this._transformScheme(H.scheme),pattern:typeof H.pattern=="undefined"?void 0:R.GlobPattern.from(H.pattern),exclusive:H.exclusive}}_transformScheme(H){return this._uriTransformer&&typeof H=="string"?this._uriTransformer.transformOutgoingScheme(H):H}_createDisposable(H){return new I.Disposable(()=>{this._adapter.delete(H),this._proxy.$unregister(H)})}_nextHandle(){return Ie._handlePool++}_withAdapter(H,Q,ne,oe,ge=!1){const Ce=this._adapter.get(H);if(!Ce)return Promise.resolve(oe);if(Ce.adapter instanceof Q){let Oe;Ce.extension&&(Oe=Date.now(),this._logService.trace(`[${Ce.extension.identifier.value}] INVOKE provider '${Q.name}'`));const ve=ne(Ce.adapter,Ce.extension),ke=Ce.extension;return ke&&Promise.resolve(ve).then(()=>this._logService.trace(`[${ke.identifier.value}] provider DONE after ${Date.now()-Oe}ms`),Pe=>{ge&&Pe instanceof b.CancellationError||(this._logService.error(`[${ke.identifier.value}] provider FAILED`),this._logService.error(Pe))}),ve}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(H,Q){const ne=this._nextHandle();return this._adapter.set(ne,new Te(H,Q)),ne}static _extLabel(H){return H.displayName||H.name}registerDocumentSymbolProvider(H,Q,ne,oe){const ge=this._addNewAdapter(new d(this._documents,ne),H),Ce=oe&&oe.label||Ie._extLabel(H);return this._proxy.$registerDocumentSymbolProvider(ge,this._transformDocumentSelector(Q),Ce),this._createDisposable(ge)}$provideDocumentSymbols(H,Q,ne){return this._withAdapter(H,d,oe=>oe.provideDocumentSymbols(_.URI.revive(Q),ne),void 0)}registerCodeLensProvider(H,Q,ne){const oe=this._nextHandle(),ge=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Te(new u(this._documents,this._commands.converter,ne),H)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(Q),ge);let Ce=this._createDisposable(oe);if(ge!==void 0){const Oe=ne.onDidChangeCodeLenses(ve=>this._proxy.$emitCodeLensEvent(ge));Ce=I.Disposable.from(Ce,Oe)}return Ce}$provideCodeLenses(H,Q,ne){return this._withAdapter(H,u,oe=>oe.provideCodeLenses(_.URI.revive(Q),ne),void 0)}$resolveCodeLens(H,Q,ne){return this._withAdapter(H,u,oe=>oe.resolveCodeLens(Q,ne),void 0)}$releaseCodeLenses(H,Q){this._withAdapter(H,u,ne=>Promise.resolve(ne.releaseCodeLenses(Q)),void 0)}registerDefinitionProvider(H,Q,ne){const oe=this._addNewAdapter(new t(this._documents,ne),H);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(Q)),this._createDisposable(oe)}$provideDefinition(H,Q,ne,oe){return this._withAdapter(H,t,ge=>ge.provideDefinition(_.URI.revive(Q),ne,oe),[])}registerDeclarationProvider(H,Q,ne){const oe=this._addNewAdapter(new r(this._documents,ne),H);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(Q)),this._createDisposable(oe)}$provideDeclaration(H,Q,ne,oe){return this._withAdapter(H,r,ge=>ge.provideDeclaration(_.URI.revive(Q),ne,oe),[])}registerImplementationProvider(H,Q,ne){const oe=this._addNewAdapter(new s(this._documents,ne),H);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(Q)),this._createDisposable(oe)}$provideImplementation(H,Q,ne,oe){return this._withAdapter(H,s,ge=>ge.provideImplementation(_.URI.revive(Q),ne,oe),[])}registerTypeDefinitionProvider(H,Q,ne){const oe=this._addNewAdapter(new o(this._documents,ne),H);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(Q)),this._createDisposable(oe)}$provideTypeDefinition(H,Q,ne,oe){return this._withAdapter(H,o,ge=>ge.provideTypeDefinition(_.URI.revive(Q),ne,oe),[])}registerHoverProvider(H,Q,ne,oe){const ge=this._addNewAdapter(new n(this._documents,ne),H);return this._proxy.$registerHoverProvider(ge,this._transformDocumentSelector(Q)),this._createDisposable(ge)}$provideHover(H,Q,ne,oe){return this._withAdapter(H,n,ge=>ge.provideHover(_.URI.revive(Q),ne,oe),void 0)}registerEvaluatableExpressionProvider(H,Q,ne,oe){const ge=this._addNewAdapter(new c(this._documents,ne),H);return this._proxy.$registerEvaluatableExpressionProvider(ge,this._transformDocumentSelector(Q)),this._createDisposable(ge)}$provideEvaluatableExpression(H,Q,ne,oe){return this._withAdapter(H,c,ge=>ge.provideEvaluatableExpression(_.URI.revive(Q),ne,oe),void 0)}registerInlineValuesProvider(H,Q,ne,oe){const ge=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Ce=this._addNewAdapter(new p(this._documents,ne),H);this._proxy.$registerInlineValuesProvider(Ce,this._transformDocumentSelector(Q),ge);let Oe=this._createDisposable(Ce);if(ge!==void 0){const ve=ne.onDidChangeInlineValues(ke=>this._proxy.$emitInlineValuesEvent(ge));Oe=I.Disposable.from(Oe,ve)}return Oe}$provideInlineValues(H,Q,ne,oe,ge){return this._withAdapter(H,p,Ce=>Ce.provideInlineValues(_.URI.revive(Q),ne,oe,ge),void 0)}registerDocumentHighlightProvider(H,Q,ne){const oe=this._addNewAdapter(new E(this._documents,ne),H);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(Q)),this._createDisposable(oe)}$provideDocumentHighlights(H,Q,ne,oe){return this._withAdapter(H,E,ge=>ge.provideDocumentHighlights(_.URI.revive(Q),ne,oe),void 0)}registerLinkedEditingRangeProvider(H,Q,ne){const oe=this._addNewAdapter(new h(this._documents,ne),H);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(Q)),this._createDisposable(oe)}$provideLinkedEditingRanges(H,Q,ne,oe){return this._withAdapter(H,h,async ge=>{const Ce=await ge.provideLinkedEditingRanges(_.URI.revive(Q),ne,oe);if(Ce)return{ranges:Ce.ranges,wordPattern:Ce.wordPattern?Ie._serializeRegExp(Ce.wordPattern):void 0}},void 0)}registerReferenceProvider(H,Q,ne){const oe=this._addNewAdapter(new v(this._documents,ne),H);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(Q)),this._createDisposable(oe)}$provideReferences(H,Q,ne,oe,ge){return this._withAdapter(H,v,Ce=>Ce.provideReferences(_.URI.revive(Q),ne,oe,ge),void 0)}registerCodeActionProvider(H,Q,ne,oe){var ge,Ce;const Oe=new f.DisposableStore,ve=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,H,this._apiDeprecation),H);return this._proxy.$registerQuickFixSupport(ve,this._transformDocumentSelector(Q),{providedKinds:(ge=oe==null?void 0:oe.providedCodeActionKinds)===null||ge===void 0?void 0:ge.map(ke=>ke.value),documentation:(Ce=oe==null?void 0:oe.documentation)===null||Ce===void 0?void 0:Ce.map(ke=>({kind:ke.kind.value,command:this._commands.converter.toInternal(ke.command,Oe)}))},Ie._extLabel(H),Boolean(ne.resolveCodeAction)),Oe.add(this._createDisposable(ve)),Oe}$provideCodeActions(H,Q,ne,oe,ge){return this._withAdapter(H,A,Ce=>Ce.provideCodeActions(_.URI.revive(Q),ne,oe,ge),void 0)}$resolveCodeAction(H,Q,ne){return this._withAdapter(H,A,oe=>oe.resolveCodeAction(Q,ne),void 0)}$releaseCodeActions(H,Q){this._withAdapter(H,A,ne=>Promise.resolve(ne.releaseCodeActions(Q)),void 0)}registerDocumentFormattingEditProvider(H,Q,ne){const oe=this._addNewAdapter(new F(this._documents,ne),H);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(Q),H.identifier,H.displayName||H.name),this._createDisposable(oe)}$provideDocumentFormattingEdits(H,Q,ne,oe){return this._withAdapter(H,F,ge=>ge.provideDocumentFormattingEdits(_.URI.revive(Q),ne,oe),void 0)}registerDocumentRangeFormattingEditProvider(H,Q,ne){const oe=this._addNewAdapter(new x(this._documents,ne),H);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(Q),H.identifier,H.displayName||H.name),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits(H,Q,ne,oe,ge){return this._withAdapter(H,x,Ce=>Ce.provideDocumentRangeFormattingEdits(_.URI.revive(Q),ne,oe,ge),void 0)}registerOnTypeFormattingEditProvider(H,Q,ne,oe){const ge=this._addNewAdapter(new j(this._documents,ne),H);return this._proxy.$registerOnTypeFormattingSupport(ge,this._transformDocumentSelector(Q),oe,H.identifier),this._createDisposable(ge)}$provideOnTypeFormattingEdits(H,Q,ne,oe,ge,Ce){return this._withAdapter(H,j,Oe=>Oe.provideOnTypeFormattingEdits(_.URI.revive(Q),ne,oe,ge,Ce),void 0)}registerWorkspaceSymbolProvider(H,Q){const ne=this._addNewAdapter(new G(Q,this._logService),H);return this._proxy.$registerNavigateTypeSupport(ne),this._createDisposable(ne)}$provideWorkspaceSymbols(H,Q,ne){return this._withAdapter(H,G,oe=>oe.provideWorkspaceSymbols(Q,ne),{symbols:[]})}$resolveWorkspaceSymbol(H,Q,ne){return this._withAdapter(H,G,oe=>oe.resolveWorkspaceSymbol(Q,ne),void 0)}$releaseWorkspaceSymbols(H,Q){this._withAdapter(H,G,ne=>ne.releaseWorkspaceSymbols(Q),void 0)}registerRenameProvider(H,Q,ne){const oe=this._addNewAdapter(new B(this._documents,ne,this._logService),H);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(Q),B.supportsResolving(ne)),this._createDisposable(oe)}$provideRenameEdits(H,Q,ne,oe,ge){return this._withAdapter(H,B,Ce=>Ce.provideRenameEdits(_.URI.revive(Q),ne,oe,ge),void 0)}$resolveRenameLocation(H,Q,ne,oe){return this._withAdapter(H,B,ge=>ge.resolveRenameLocation(_.URI.revive(Q),ne,oe),void 0)}registerDocumentSemanticTokensProvider(H,Q,ne,oe){const ge=this._nextHandle(),Ce=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(ge,new Te(new O(this._documents,ne),H)),this._proxy.$registerDocumentSemanticTokensProvider(ge,this._transformDocumentSelector(Q),oe,Ce);let Oe=this._createDisposable(ge);if(Ce){const ve=ne.onDidChangeSemanticTokens(ke=>this._proxy.$emitDocumentSemanticTokensEvent(Ce));Oe=I.Disposable.from(Oe,ve)}return Oe}$provideDocumentSemanticTokens(H,Q,ne,oe){return this._withAdapter(H,O,ge=>ge.provideDocumentSemanticTokens(_.URI.revive(Q),ne,oe),null,!0)}$releaseDocumentSemanticTokens(H,Q){this._withAdapter(H,O,ne=>ne.releaseDocumentSemanticColoring(Q),void 0)}registerDocumentRangeSemanticTokensProvider(H,Q,ne,oe){const ge=this._addNewAdapter(new N(this._documents,ne),H);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ge,this._transformDocumentSelector(Q),oe),this._createDisposable(ge)}$provideDocumentRangeSemanticTokens(H,Q,ne,oe){return this._withAdapter(H,N,ge=>ge.provideDocumentRangeSemanticTokens(_.URI.revive(Q),ne,oe),null,!0)}registerCompletionItemProvider(H,Q,ne,oe){const ge=this._addNewAdapter(new U(this._documents,this._commands.converter,ne,this._apiDeprecation,H),H);return this._proxy.$registerSuggestSupport(ge,this._transformDocumentSelector(Q),oe,U.supportsResolving(ne),`${H.identifier.value}(${oe.join("")})`),this._createDisposable(ge)}$provideCompletionItems(H,Q,ne,oe,ge){return this._withAdapter(H,U,Ce=>Ce.provideCompletionItems(_.URI.revive(Q),ne,oe,ge),void 0)}$resolveCompletionItem(H,Q,ne){return this._withAdapter(H,U,oe=>oe.resolveCompletionItem(Q,ne),void 0)}$releaseCompletionItems(H,Q){this._withAdapter(H,U,ne=>ne.releaseCompletionItems(Q),void 0)}registerSignatureHelpProvider(H,Q,ne,oe){const ge=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,Ce=this._addNewAdapter(new L(this._documents,ne),H);return this._proxy.$registerSignatureHelpProvider(Ce,this._transformDocumentSelector(Q),ge),this._createDisposable(Ce)}$provideSignatureHelp(H,Q,ne,oe,ge){return this._withAdapter(H,L,Ce=>Ce.provideSignatureHelp(_.URI.revive(Q),ne,oe,ge),void 0)}$releaseSignatureHelp(H,Q){this._withAdapter(H,L,ne=>ne.releaseSignatureHelp(Q),void 0)}registerInlineHintsProvider(H,Q,ne){const oe=typeof ne.onDidChangeInlineHints=="function"?this._nextHandle():void 0,ge=this._addNewAdapter(new M(this._documents,ne),H);this._proxy.$registerInlineHintsProvider(ge,this._transformDocumentSelector(Q),oe);let Ce=this._createDisposable(ge);if(oe!==void 0){const Oe=ne.onDidChangeInlineHints(ve=>this._proxy.$emitInlineHintsEvent(oe));Ce=I.Disposable.from(Ce,Oe)}return Ce}$provideInlineHints(H,Q,ne,oe){return this._withAdapter(H,M,ge=>ge.provideInlineHints(_.URI.revive(Q),ne,oe),void 0)}registerDocumentLinkProvider(H,Q,ne){const oe=this._addNewAdapter(new V(this._documents,ne),H);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(Q),typeof ne.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks(H,Q,ne){return this._withAdapter(H,V,oe=>oe.provideLinks(_.URI.revive(Q),ne),void 0)}$resolveDocumentLink(H,Q,ne){return this._withAdapter(H,V,oe=>oe.resolveLink(Q,ne),void 0)}$releaseDocumentLinks(H,Q){this._withAdapter(H,V,ne=>ne.releaseLinks(Q),void 0)}registerColorProvider(H,Q,ne){const oe=this._addNewAdapter(new K(this._documents,ne),H);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(Q)),this._createDisposable(oe)}$provideDocumentColors(H,Q,ne){return this._withAdapter(H,K,oe=>oe.provideColors(_.URI.revive(Q),ne),[])}$provideColorPresentations(H,Q,ne,oe){return this._withAdapter(H,K,ge=>ge.provideColorPresentations(_.URI.revive(Q),ne,oe),void 0)}registerFoldingRangeProvider(H,Q,ne){const oe=this._nextHandle(),ge=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Te(new se(this._documents,ne),H)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(Q),ge);let Ce=this._createDisposable(oe);if(ge!==void 0){const Oe=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ge));Ce=I.Disposable.from(Ce,Oe)}return Ce}$provideFoldingRanges(H,Q,ne,oe){return this._withAdapter(H,se,ge=>ge.provideFoldingRanges(_.URI.revive(Q),ne,oe),void 0)}registerSelectionRangeProvider(H,Q,ne){const oe=this._addNewAdapter(new ce(this._documents,ne,this._logService),H);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(Q)),this._createDisposable(oe)}$provideSelectionRanges(H,Q,ne,oe){return this._withAdapter(H,ce,ge=>ge.provideSelectionRanges(_.URI.revive(Q),ne,oe),[])}registerCallHierarchyProvider(H,Q,ne){const oe=this._addNewAdapter(new we(this._documents,ne),H);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(Q)),this._createDisposable(oe)}$prepareCallHierarchy(H,Q,ne,oe){return this._withAdapter(H,we,ge=>Promise.resolve(ge.prepareSession(_.URI.revive(Q),ne,oe)),void 0)}$provideCallHierarchyIncomingCalls(H,Q,ne,oe){return this._withAdapter(H,we,ge=>ge.provideCallsTo(Q,ne,oe),void 0)}$provideCallHierarchyOutgoingCalls(H,Q,ne,oe){return this._withAdapter(H,we,ge=>ge.provideCallsFrom(Q,ne,oe),void 0)}$releaseCallHierarchy(H,Q){this._withAdapter(H,we,ne=>Promise.resolve(ne.releaseSession(Q)),void 0)}static _serializeRegExp(H){return{pattern:H.source,flags:(0,y.regExpFlags)(H)}}static _serializeIndentationRule(H){return{decreaseIndentPattern:Ie._serializeRegExp(H.decreaseIndentPattern),increaseIndentPattern:Ie._serializeRegExp(H.increaseIndentPattern),indentNextLinePattern:H.indentNextLinePattern?Ie._serializeRegExp(H.indentNextLinePattern):void 0,unIndentedLinePattern:H.unIndentedLinePattern?Ie._serializeRegExp(H.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(H){return{beforeText:Ie._serializeRegExp(H.beforeText),afterText:H.afterText?Ie._serializeRegExp(H.afterText):void 0,previousLineText:H.previousLineText?Ie._serializeRegExp(H.previousLineText):void 0,action:H.action}}static _serializeOnEnterRules(H){return H.map(Ie._serializeOnEnterRule)}setLanguageConfiguration(H,Q,ne){let{wordPattern:oe}=ne;if(oe&&(0,y.regExpLeadsToEndlessLoop)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(Q,oe):this._documents.setWordDefinitionFor(Q,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",H,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",H,"Do not use.");const ge=this._nextHandle(),Ce={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?Ie._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?Ie._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?Ie._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ge,Q,Ce),this._createDisposable(ge)}$setWordDefinitions(H){for(const Q of H)this._documents.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.ExtHostLanguageFeatures=Ie,Ie._handlePool=0}),define(me[238],pe([0,1,5,20,8]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class I{constructor(P,y){this._proxy=P.getProxy(_.MainContext.MainThreadLanguages),this._documents=y}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(P,y){await this._proxy.$changeLanguage(P,y);const i=this._documents.getDocumentData(P);if(!i)throw new Error(`document '${P.toString}' NOT found`);return i.document}async tokenAtPosition(P,y){var i;const T=P.version,k=D.Position.from(y),w=await this._proxy.$tokensAtPosition(P.uri,k),f={type:R.StandardTokenType.Other,range:(i=P.getWordRangeAtPosition(y))!==null&&i!==void 0?i:new R.Range(y.line,y.character,y.line,y.character)};if(!w)return f;const l={range:D.Range.to(w.range),type:D.TokenType.to(w.type)};return!l.range.contains(y)||T!==P.version?f:l}}e.ExtHostLanguages=I}),define(me[239],pe([0,1,5,12,41]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function I(P){return P&&P.title}let C=class{constructor(y,i){this._logService=i,this._proxy=y.getProxy(_.MainContext.MainThreadMessageService)}showMessage(y,i,T,k,w){const f={extension:y};let l;typeof k=="string"||I(k)?l=[k,...w]:(f.modal=k&&k.modal,f.useCustom=k&&k.useCustom,l=w),f.useCustom&&(0,R.checkProposedApiEnabled)(y);const m=[];for(let S=0;S<l.length;S++){const g=l[S];if(typeof g=="string")m.push({title:g,handle:S,isCloseAffordance:!1});else if(typeof g=="object"){let{title:b,isCloseAffordance:d}=g;m.push({title:b,isCloseAffordance:!!d,handle:S})}else this._logService.warn("Invalid message item:",g)}return this._proxy.$showMessage(i,T,f,m).then(S=>{if(typeof S=="number")return l[S]})}};C=Ve([xe(1,D.ILogService)],C),e.ExtHostMessageService=C}),define(me[240],pe([0,1,21,3,6,2,28,5,20,8,85,51,22,216,217,71,15,74]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l,m,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookCellStatusBarItemInternal=e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class b extends R.Disposable{constructor(n,c,p,E,h){super();this._editorId=n,this.uri=c,this._proxy=p,this._webviewInitData=E,this.document=h,this._onDidReceiveDocumentMessage=new D.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:v=>this._proxy.$postMessage(this._editorId,void 0,v),asWebviewUri:v=>this._asWebviewUri(v)}}onDidReceiveMessage(n,c){var p;this._onDidReceiveDocumentMessage.fire(c),n!==void 0&&((p=this._rendererIdToEmitters.get(n))===null||p===void 0||p.fire(c))}getRendererComm(n){const c=new D.Emitter;return this._rendererIdToEmitters.set(n,c),{editorId:this._editorId,onDidReceiveMessage:c.event,postMessage:p=>this._proxy.$postMessage(this._editorId,n,p),asWebviewUri:p=>this._asWebviewUri(p)}}_asWebviewUri(n){return(0,T.asWebviewUri)(this._webviewInitData,this._editorId,n)}}class d extends R.Disposable{constructor(n,c,p,E){super();this._proxy=n,this._handle=c,this._extension=p,this._provider=E,this._kernelToFriendlyId=new w.ResourceMap,this._friendlyIdToKernel=new w.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(h=>{const v=h==null?void 0:h.uri;this._proxy.$onNotebookKernelChange(this._handle,v)}))}async provideKernels(n,c){const p=await this._provider.provideKernels(n.notebookDocument,c)||[],E=new Map;let h=0;const v=new Set,A=this._kernelToFriendlyId.get(n.uri),F=p.map(j=>{let G=A==null?void 0:A.get(j);return G===void 0&&(j.id&&v.has(j.id)?G=`${this._extension.identifier.value}_${j.id}_${h++}`:G=`${this._extension.identifier.value}_${j.id||C.generateUuid()}`),E.set(j,G),{id:j.id,friendlyId:G,label:j.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:j.description,detail:j.detail,isPreferred:j.isPreferred,preloads:j.preloads,supportedLanguages:j.supportedLanguages}});this._kernelToFriendlyId.set(n.uri,E);const x=new Map;return E.forEach((j,G)=>{x.set(j,G)}),this._friendlyIdToKernel.set(n.uri,x),F}getKernelByFriendlyId(n,c){var p;return(p=this._friendlyIdToKernel.get(n))===null||p===void 0?void 0:p.get(c)}async resolveNotebook(n,c,p,E){var h;const v=(h=this._friendlyIdToKernel.get(c.uri))===null||h===void 0?void 0:h.get(n);if(v&&this._provider.resolveKernel)return this._provider.resolveKernel(v,c.notebookDocument,p,E)}async executeNotebook(n,c,p){var E;const h=(E=this._friendlyIdToKernel.get(c.uri))===null||E===void 0?void 0:E.get(n);if(!!h)return u(p?v=>h.executeCell(c.notebookDocument,p.cell,v):v=>h.executeAllCells(c.notebookDocument,v))}async cancelNotebook(n,c,p){var E;const h=(E=this._friendlyIdToKernel.get(c.uri))===null||E===void 0?void 0:E.get(n);if(!!h)return p?h.cancelCellExecution(c.notebookDocument,p.cell):h.cancelAllCellsExecution(c.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=d;async function u(o){const n=new _.CancellationTokenSource;try{await o(n.token)}finally{n.dispose()}}class a{constructor(n,c){const p=a._Keys.nextId();n.$registerNotebookEditorDecorationType(p,y.NotebookDecorationRenderOptions.from(c)),this.value={key:p,dispose(){n.$removeNotebookEditorDecorationType(p)}}}}e.NotebookEditorDecorationType=a,a._Keys=new m.IdGenerator("NotebookEditorDecorationType");class t{constructor(n,c,p,E,h,v){this._documentsAndEditors=p,this._webviewInitData=E,this.logService=h,this._extensionStoragePaths=v,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._documents=new w.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new D.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new D.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new D.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new D.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new D.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellLanguage=new D.Emitter,this.onDidChangeCellLanguage=this._onDidChangeCellLanguage.event,this._onDidChangeCellMetadata=new D.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new D.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new D.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new D.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new D.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new D.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new D.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._backupIdPool=0,this._proxy=n.getProxy(P.MainContext.MainThreadNotebook),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:A=>{var F;if(A&&A.$mid===12){const x=(F=A.notebookEditor)===null||F===void 0?void 0:F.notebookUri,j=A.cell.handle,G=this._documents.get(x),B=G==null?void 0:G.getCell(j);if(B)return B.cell}return A}})}get activeNotebookEditor(){var n;return(n=this._activeNotebookEditor)===null||n===void 0?void 0:n.editor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(n=>n.editor)}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(n){return this._documents.get(n)}_getNotebookDocument(n){const c=this._documents.get(n);if(!c)throw new Error(`NO notebook document for '${n}'`);return c}_getProviderData(n){const c=this._notebookContentProviders.get(n);if(!c)throw new Error(`NO provider for '${n}'`);return c}registerNotebookContentProvider(n,c,p,E){var h,v,A;if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);this._notebookContentProviders.set(c,{extension:n,provider:p});let F;p.onDidChangeNotebookContentOptions&&(F=p.onDidChangeNotebookContentOptions(()=>{this._proxy.$updateNotebookProviderOptions(c,p.options)}));const x=(h=E==null?void 0:E.viewOptions)===null||h===void 0?void 0:h.filenamePattern.map(j=>y.NotebookExclusiveDocumentPattern.from(j)).filter(j=>j!==void 0);return((v=E==null?void 0:E.viewOptions)===null||v===void 0?void 0:v.filenamePattern)&&!x&&console.warn(`Notebook content provider view options file name pattern is invalid ${(A=E==null?void 0:E.viewOptions)===null||A===void 0?void 0:A.filenamePattern}`),this._proxy.$registerNotebookProvider({id:n.identifier,location:n.extensionLocation,description:n.description},c,{transientOutputs:(E==null?void 0:E.transientOutputs)||!1,transientMetadata:(E==null?void 0:E.transientMetadata)||{},viewOptions:(E==null?void 0:E.viewOptions)&&x?{displayName:E.viewOptions.displayName,filenamePattern:x,exclusive:E.viewOptions.exclusive||!1}:void 0}),new i.Disposable(()=>{F==null||F.dispose(),this._notebookContentProviders.delete(c),this._proxy.$unregisterNotebookProvider(c)})}registerNotebookKernelProvider(n,c,p){const E=t._notebookKernelProviderHandlePool++,h=new d(this._proxy,E,n,p);return this._notebookKernelProviders.set(E,h),this._proxy.$registerNotebookKernelProvider({id:n.identifier,location:n.extensionLocation,description:n.description},E,{viewType:c.viewType,filenamePattern:c.filenamePattern?y.NotebookExclusiveDocumentPattern.from(c.filenamePattern):void 0}),new i.Disposable(()=>{h.dispose(),this._notebookKernelProviders.delete(E),this._proxy.$unregisterNotebookKernelProvider(E)})}createNotebookEditorDecorationType(n){return new a(this._proxy,n).value}async openNotebookDocument(n,c){const p=this._documents.get(I.URI.revive(n));if(p)return p.notebookDocument;await this._proxy.$tryOpenDocument(n,c);const E=this._documents.get(I.URI.revive(n));return(0,S.assertIsDefined)(E==null?void 0:E.notebookDocument)}_withAdapter(n,c,p){const E=this._documents.get(I.URI.revive(c));if(!E)return[];const h=this._notebookKernelProviders.get(n);return h?p(h,E):[]}async showNotebookDocument(n,c){var p;I.URI.isUri(n)&&(n=await this.openNotebookDocument(n));let E;typeof c=="object"?E={position:y.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selection:c.selection&&y.NotebookCellRange.from(c.selection),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:E={preserveFocus:!1};const h=await this._proxy.$tryShowNotebookDocument(n.uri,n.viewType,E),v=h&&((p=this._editors.get(h))===null||p===void 0?void 0:p.editor);if(v)return v.editor;throw h?new Error(`Could NOT open editor for "${n.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.toString()}".`)}async $provideNotebookKernels(n,c,p){return this._withAdapter(n,c,(E,h)=>E.provideKernels(h,p))}async $resolveNotebookKernel(n,c,p,E,h){await this._withAdapter(n,p,async(v,A)=>{const F=this._webviewComm.get(c);F&&await v.resolveNotebook(E,A,F.contentProviderComm,h)})}async $resolveNotebookEditor(n,c,p){const E=this._notebookContentProviders.get(n),h=I.URI.revive(c),v=this._documents.get(h);if(!(!v||!E)){let A=this._webviewComm.get(p);A||(A=new b(p,h,this._proxy,this._webviewInitData,v),this._webviewComm.set(p,A)),!!E.provider.resolveNotebook&&await E.provider.resolveNotebook(v.notebookDocument,A.contentProviderComm)}}async $executeNotebookKernelFromProvider(n,c,p,E){await this._withAdapter(n,c,async(h,v)=>{const A=E!==void 0?v.getCell(E):void 0;return h.executeNotebook(p,v,A)})}async $cancelNotebookKernelFromProvider(n,c,p,E){await this._withAdapter(n,c,async(h,v)=>{const A=E!==void 0?v.getCell(E):void 0;return h.cancelNotebook(p,v,A)})}async $openNotebook(n,c,p){const{provider:E}=this._getProviderData(n),h=await E.openNotebook(I.URI.revive(c),{backupId:p});return{metadata:Object.assign(Object.assign({},k.notebookDocumentMetadataDefaults),h.metadata),cells:h.cells.map(y.NotebookCellData.from)}}async $saveNotebook(n,c,p){const E=this._getNotebookDocument(I.URI.revive(c)),{provider:h}=this._getProviderData(n);return await h.saveNotebook(E.notebookDocument,p),!0}async $saveNotebookAs(n,c,p,E){const h=this._getNotebookDocument(I.URI.revive(c)),{provider:v}=this._getProviderData(n);return await v.saveNotebookAs(I.URI.revive(p),h.notebookDocument,E),!0}async $backupNotebook(n,c,p){var E;const h=this._getNotebookDocument(I.URI.revive(c)),v=this._getProviderData(n),A=(E=this._extensionStoragePaths.workspaceValue(v.extension))!==null&&E!==void 0?E:this._extensionStoragePaths.globalValue(v.extension),F=String((0,g.hash)([h.uri.toString(),this._backupIdPool++])),x=I.URI.joinPath(A,F),j=await v.provider.backupNotebook(h.notebookDocument,{destination:x},p);return h.updateBackup(j),j.id}$acceptNotebookActiveKernelChange(n){n.providerHandle!==void 0&&this._withAdapter(n.providerHandle,n.uri,async(c,p)=>{const E=n.kernelFriendlyId?c.getKernelByFriendlyId(I.URI.revive(n.uri),n.kernelFriendlyId):void 0;this._editors.forEach(h=>{h.editor.notebookData===p&&h.editor._acceptKernel(E)}),this._onDidChangeActiveNotebookKernel.fire({document:p.notebookDocument,kernel:E})})}$onDidReceiveMessage(n,c,p){var E;(E=this._webviewComm.get(n))===null||E===void 0||E.onDidReceiveMessage(c,p)}$acceptModelChanged(n,c,p){this._getNotebookDocument(I.URI.revive(n)).acceptModelChanged(c,p)}$acceptDirtyStateChanged(n,c){const p=this._getNotebookDocument(I.URI.revive(n));p.acceptModelChanged({rawEvents:[],versionId:p.notebookDocument.version},c)}$acceptModelSaved(n){const c=this._getNotebookDocument(I.URI.revive(n));this._onDidSaveNotebookDocument.fire(c.notebookDocument)}$acceptEditorPropertiesChanged(n,c){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",n,c);const p=this._editors.get(n);if(!p)throw new Error(`unknown text editor: ${n}`);c.visibleRanges&&p.editor._acceptVisibleRanges(c.visibleRanges.ranges.map(y.NotebookCellRange.to)),c.selections&&p.editor._acceptSelections(c.selections.selections.map(y.NotebookCellRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:p.editor.editor,visibleRanges:p.editor.editor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:p.editor.editor,selections:p.editor.editor.selections}))}$acceptDocumentPropertiesChanged(n,c){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",n.path,c),this._getNotebookDocument(I.URI.revive(n)).acceptDocumentPropertiesChanged(c)}_createExtHostEditor(n,c,p){var E;const h=n.uri;let v=this._webviewComm.get(c);v||(v=new b(c,h,this._proxy,this._webviewInitData,n),this._webviewComm.set(c,v));const A=new l.ExtHostNotebookEditor(c,n.notebookDocument.viewType,this._proxy,n,p.visibleRanges.map(y.NotebookCellRange.to),p.selections.map(y.NotebookCellRange.to),typeof p.viewColumn=="number"?y.ViewColumn.to(p.viewColumn):void 0);(E=this._editors.get(c))===null||E===void 0||E.editor.dispose(),this._editors.set(c,{editor:A})}$acceptDocumentAndEditorsDelta(n){var c,p,E,h;let v=!1;if(n.removedDocuments)for(const F of n.removedDocuments){const x=I.URI.revive(F),j=this._documents.get(x);j&&(j.dispose(),this._documents.delete(x),this._documentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:j.notebookDocument.cells.map(G=>G.uri)}),this._onDidCloseNotebookDocument.fire(j.notebookDocument));for(const G of this._editors.values())G.editor.notebookData.uri.toString()===x.toString()&&(G.editor.dispose(),this._editors.delete(G.editor.id),v=!0)}if(n.addedDocuments){const F=[];for(const x of n.addedDocuments){const j=I.URI.revive(x.uri),G=x.viewType;if(this._documents.has(j))throw new Error(`adding EXISTING notebook ${j}`);const B=this,J=new f.ExtHostNotebookDocument(this._proxy,this._documentsAndEditors,{emitModelChange(O){B._onDidChangeNotebookCells.fire(O)},emitCellOutputsChange(O){B._onDidChangeCellOutputs.fire(O)},emitCellLanguageChange(O){B._onDidChangeCellLanguage.fire(O)},emitCellMetadataChange(O){B._onDidChangeCellMetadata.fire(O)},emitDocumentMetadataChange(O){B._onDidChangeNotebookDocumentMetadata.fire(O)}},G,x.contentOptions,x.metadata?y.NotebookDocumentMetadata.to(x.metadata):new i.NotebookDocumentMetadata,j);J.acceptModelChanged({versionId:x.versionId,rawEvents:[{kind:k.NotebookCellsChangeType.Initialize,changes:[[0,0,x.cells]]}]},!1),F.push(...x.cells.map(O=>f.ExtHostCell.asModelAddData(J.notebookDocument,O))),(c=this._documents.get(j))===null||c===void 0||c.dispose(),this._documents.set(j,J),this._documentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:F}),this._onDidOpenNotebookDocument.fire(J.notebookDocument)}}if(n.addedEditors)for(const F of n.addedEditors){if(this._editors.has(F.id))return;const x=I.URI.revive(F.documentUri),j=this._documents.get(x);j&&(this._createExtHostEditor(j,F.id,F),v=!0)}const A=[];if(n.removedEditors)for(const F of n.removedEditors){const x=this._editors.get(F);x&&(v=!0,this._editors.delete(F),((p=this._activeNotebookEditor)===null||p===void 0?void 0:p.id)===x.editor.id&&(this._activeNotebookEditor=void 0),A.push(x))}if(v&&A.forEach(F=>{F.editor.dispose()}),n.visibleEditors){this._visibleNotebookEditors=n.visibleEditors.map(x=>this._editors.get(x).editor).filter(x=>!!x);const F=new Set;this._visibleNotebookEditors.forEach(x=>F.add(x.id));for(const x of this._editors.values()){const j=F.has(x.editor.id);x.editor._acceptVisibility(j)}this._visibleNotebookEditors=[...this._editors.values()].map(x=>x.editor).filter(x=>x.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}n.newActiveEditor===null?this._activeNotebookEditor=void 0:n.newActiveEditor&&(this._activeNotebookEditor=(E=this._editors.get(n.newActiveEditor))===null||E===void 0?void 0:E.editor),this._onDidChangeActiveNotebookEditor.fire((h=this._activeNotebookEditor)===null||h===void 0?void 0:h.editor)}createNotebookCellStatusBarItemInternal(n,c,p){const E=new r(this._proxy,this._commandsConverter,n,c,p),h=k.CellUri.parse(n.uri);if(h){const v=this._documents.get(h.notebook);if(v){const A=v.getCell(h.handle);A&&D.Event.once(A.onDidDispose)(()=>E.dispose())}}return E}}e.ExtHostNotebookController=t,t._notebookKernelProviderHandlePool=0;class r extends R.Disposable{constructor(n,c,p,E,h){super();this._proxy=n,this._commands=c,this._cell=p,this._priority=h,this._id=r.NEXT_ID++,this._isDisposed=!1,this._text="",this._visible=!1,this._internalCommandRegistration=this._register(new R.DisposableStore),this._alignment=E!=null?E:i.NotebookCellStatusBarAlignment.Left}get apiItem(){return this._apiItem||(this._apiItem=s(this)),this._apiItem}get cell(){return this._cell}get alignment(){return this._alignment}set alignment(n){this._alignment=n,this.update()}get priority(){return this._priority}set priority(n){this._priority=n,this.update()}get text(){return this._text}set text(n){this._text=n,this.update()}get tooltip(){return this._tooltip}set tooltip(n){this._tooltip=n,this.update()}get command(){var n;return(n=this._command)===null||n===void 0?void 0:n.fromApi}set command(n){var c;((c=this._command)===null||c===void 0?void 0:c.fromApi)!==n&&(this._internalCommandRegistration.clear(),typeof n=="string"?this._command={fromApi:n,internal:this._commands.toInternal({title:"",command:n},this._internalCommandRegistration)}:n?this._command={fromApi:n,internal:this._commands.toInternal(n,this._internalCommandRegistration)}:this._command=void 0,this.update())}get accessibilityInformation(){return this._accessibilityInformation}set accessibilityInformation(n){this._accessibilityInformation=n,this.update()}show(){this._visible=!0,this.update()}hide(){this._visible=!1,this.update()}dispose(){this.hide(),this._isDisposed=!0,this._internalCommandRegistration.dispose()}update(){var n;if(!this._isDisposed){const c={alignment:this.alignment===i.NotebookCellStatusBarAlignment.Left?0:1,cellResource:this.cell.uri,command:(n=this._command)===null||n===void 0?void 0:n.internal,text:this.text,tooltip:this.tooltip,accessibilityInformation:this.accessibilityInformation,priority:this.priority,visible:this._visible};this._proxy.$setStatusBarEntry(this._id,c)}}}e.NotebookCellStatusBarItemInternal=r,r.NEXT_ID=0;function s(o){return Object.freeze({cell:o.cell,get alignment(){return o.alignment},set alignment(n){o.alignment=n},get priority(){return o.priority},set priority(n){o.priority=n},get text(){return o.text},set text(n){o.text=n},get tooltip(){return o.tooltip},set tooltip(n){o.tooltip=n},get command(){return o.command},set command(n){o.command=n},get accessibilityInformation(){return o.accessibilityInformation},set accessibilityInformation(n){o.accessibilityInformation=n},show(){o.show()},hide(){o.hide()},dispose(){o.dispose()}})}}),define(me[65],pe([0,1,5,3,6,26,4,13]),function(Z,e,_,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends R.Disposable{constructor(l,m,S,g){super();this._onDidAppend=this._register(new D.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=l,this._proxy=g,this._id=g.$register(this.name,m,S),this._disposed=!1,this._offset=0}get name(){return this._name}append(l){this.validate(),this._offset+=l?I.VSBuffer.fromString(l).byteLength:0}update(){this._id.then(l=>this._proxy.$update(l))}appendLine(l){this.validate(),this.append(l+`
`)}clear(){this.validate();const l=this._offset;this._id.then(m=>this._proxy.$clear(m,l))}show(l,m){this.validate(),this._id.then(S=>this._proxy.$reveal(S,!!(typeof l=="boolean"?l:m)))}hide(){this.validate(),this._id.then(l=>this._proxy.$close(l))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(l=>this._proxy.$dispose(l)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class i extends y{constructor(l,m){super(l,!1,void 0,m)}append(l){super.append(l),this._id.then(m=>this._proxy.$append(m,l)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=i;class T extends y{constructor(l,m,S){super(l,!0,m,S)}append(l){throw new Error("Not supported")}}class k{constructor(l,m){this.name=l,this._channel=m}append(l){this._channel.then(m=>m.append(l))}appendLine(l){this._channel.then(m=>m.appendLine(l))}clear(){this._channel.then(l=>l.clear())}show(l,m){this._channel.then(S=>S.show(l,m))}hide(){this._channel.then(l=>l.hide())}dispose(){this._channel.then(l=>l.dispose())}}e.LazyOutputChannel=k;let w=class{constructor(l){this._proxy=l.getProxy(_.MainContext.MainThreadOutputService)}$setVisibleChannel(l){}createOutputChannel(l){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");return new i(l,this._proxy)}createOutputChannelFromLogFile(l,m){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");if(!m)throw new Error("illegal argument `file`. must not be falsy");return new T(l,m,this._proxy)}};w=Ve([xe(0,P.IExtHostRpcService)],w),e.ExtHostOutputService=w,e.IExtHostOutputService=(0,C.createDecorator)("IExtHostOutputService")}),define(me[241],pe([0,1,19,21,3,6,5,2,8,18,14]),function(Z,e,_,D,R,I,C,P,y,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function k(w,f,l){const m=w.getProxy(C.MainContext.MainThreadQuickOpen);class S{constructor(s,o){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=o}showQuickPick(s,o,n,c=D.CancellationToken.None){this._onDidSelectItem=void 0;const p=Promise.resolve(s),E=++this._instances,h=m.$show(E,{placeHolder:n&&n.placeHolder,matchOnDescription:n&&n.matchOnDescription,matchOnDetail:n&&n.matchOnDetail,ignoreFocusLost:n&&n.ignoreFocusOut,canPickMany:n&&n.canPickMany},c),v={},A=h.then(()=>v);return Promise.race([A,p]).then(F=>{if(F!==v)return p.then(x=>{const j=[];for(let G=0;G<x.length;G++){const B=x[G];let J,O,N,U,L;typeof B=="string"?J=B:(J=B.label,O=B.description,N=B.detail,U=B.picked,L=B.alwaysShow),j.push({label:J,description:O,handle:G,detail:N,picked:U,alwaysShow:L})}return n&&typeof n.onDidSelectItem=="function"&&(this._onDidSelectItem=G=>{n.onDidSelectItem(x[G])}),m.$setItems(E,j),h.then(G=>{if(typeof G=="number")return x[G];if(Array.isArray(G))return G.map(B=>x[B])})})}).then(void 0,F=>{if(!(0,i.isPromiseCanceledError)(F))return m.$setError(E,F),Promise.reject(F)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,o=D.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,m.$input(s,typeof this._validateInput=="function",o).then(void 0,n=>{if(!(0,i.isPromiseCanceledError)(n))return Promise.reject(n)})}$validateInput(s){return this._validateInput?(0,_.asPromise)(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,o=D.CancellationToken.None){const n=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!!n){const c=await this._workspace.getWorkspaceFolders2();if(!!c)return c.find(p=>p.uri.toString()===n.uri.toString())}}createQuickPick(s,o){const n=new a(s,o,()=>this._sessions.delete(n._id));return this._sessions.set(n._id,n),n}createInputBox(s){const o=new t(s,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}$onDidChangeValue(s,o){const n=this._sessions.get(s);n&&n._fireDidChangeValue(o)}$onDidAccept(s){const o=this._sessions.get(s);o&&o._fireDidAccept()}$onDidChangeActive(s,o){const n=this._sessions.get(s);n instanceof a&&n._fireDidChangeActive(o)}$onDidChangeSelection(s,o){const n=this._sessions.get(s);n instanceof a&&n._fireDidChangeSelection(o)}$onDidTriggerButton(s,o){const n=this._sessions.get(s);n&&n._fireDidTriggerButton(o)}$onDidHide(s){const o=this._sessions.get(s);o&&o._fireDidHide()}}class g{constructor(s,o){this._extensionId=s,this._onDidDispose=o,this._id=a._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new R.Emitter,this._onDidChangeValueEmitter=new R.Emitter,this._onDidTriggerButtonEmitter=new R.Emitter,this._onDidHideEmitter=new R.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((o,n)=>{const c=o===y.QuickInputButtons.Back?-1:n;this._handlesToButtons.set(c,o)}),this.update({buttons:s.map((o,n)=>({iconPath:b(o.iconPath),tooltip:o.tooltip,handle:o===y.QuickInputButtons.Back?-1:n}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const o=this._handlesToButtons.get(s);o&&this._onDidTriggerButtonEmitter.fire(o)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,I.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),m.$dispose(this._id))}update(s){if(!this._disposed){for(const o of Object.keys(s)){const n=s[o];this._pendingUpdate[o]=n===void 0?null:n}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){m.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}g._nextId=1;function b(r){if(r instanceof y.ThemeIcon)return{id:r.id};const s=u(r),o=d(r);return{dark:typeof s=="string"?P.URI.file(s):s,light:typeof o=="string"?P.URI.file(o):o}}function d(r){return typeof r=="object"&&"light"in r?r.light:r}function u(r){return typeof r=="object"&&"dark"in r?r.dark:r}class a extends g{constructor(s,o,n){super(s,n);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new R.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new R.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((o,n)=>{this._handlesToItems.set(n,o),this._itemsToHandles.set(o,n)}),this.update({items:s.map((o,n)=>({label:o.label,description:o.description,handle:n,detail:o.detail,picked:o.picked,alwaysShow:o.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(o=>this._itemsToHandles.has(o)),this.update({activeItems:this._activeItems.map(o=>this._itemsToHandles.get(o))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(o=>this._itemsToHandles.has(o)),this.update({selectedItems:this._selectedItems.map(o=>this._itemsToHandles.get(o))})}_fireDidChangeActive(s){const o=(0,T.coalesce)(s.map(n=>this._handlesToItems.get(n)));this._activeItems=o,this._onDidChangeActiveEmitter.fire(o)}_fireDidChangeSelection(s){const o=(0,T.coalesce)(s.map(n=>this._handlesToItems.get(n)));this._selectedItems=o,this._onDidChangeSelectionEmitter.fire(o)}}class t extends g{constructor(s,o){super(s,o);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s})}}return new S(f,l)}e.createExtHostQuickOpen=k}),define(me[242],pe([0,1,2,3,55,6,19,5,14,95,12,29,41]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(o){if(o)return typeof o.iconPath=="string"?_.URI.file(o.iconPath):o.iconPath}function l(o,n){if(!o.iconPath&&!n.iconPath)return 0;if(o.iconPath){if(!n.iconPath)return 1}else return-1;const c=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath,p=typeof n.iconPath=="string"?n.iconPath:n.iconPath.fsPath;return(0,i.comparePaths)(c,p)}function m(o,n){let c=0;if(o.strikeThrough!==n.strikeThrough)return o.strikeThrough?1:-1;if(o.faded!==n.faded)return o.faded?1:-1;if(o.tooltip!==n.tooltip)return(o.tooltip||"").localeCompare(n.tooltip||"");if(c=l(o,n),c!==0)return c;if(o.light&&n.light)c=l(o.light,n.light);else{if(o.light)return 1;if(n.light)return-1}if(c!==0)return c;if(o.dark&&n.dark)c=l(o.dark,n.dark);else{if(o.dark)return 1;if(n.dark)return-1}return c}function S(o,n){if(o.command!==n.command)return o.command<n.command?-1:1;if(o.title!==n.title)return o.title<n.title?-1:1;if(o.tooltip!==n.tooltip){if(o.tooltip!==void 0&&n.tooltip!==void 0)return o.tooltip<n.tooltip?-1:1;if(o.tooltip!==void 0)return 1;if(n.tooltip!==void 0)return-1}if(o.arguments===n.arguments)return 0;if(o.arguments)if(n.arguments){if(o.arguments.length!==n.arguments.length)return o.arguments.length-n.arguments.length}else return 1;else return-1;for(let c=0;c<o.arguments.length;c++){const p=o.arguments[c],E=n.arguments[c];if(p!==E)return p<E?-1:1}return 0}function g(o,n){let c=(0,i.comparePaths)(o.resourceUri.fsPath,n.resourceUri.fsPath,!0);if(c!==0)return c;if(o.command&&n.command)c=S(o.command,n.command);else{if(o.command)return 1;if(n.command)return-1}if(c!==0)return c;if(o.decorations&&n.decorations)c=m(o.decorations,n.decorations);else{if(o.decorations)return 1;if(n.decorations)return-1}return c}function b(o,n){for(let c=0;c<o.length;c++)if(o[c]!==n[c])return!1;return!0}function d(o,n){return o.command===n.command&&o.title===n.title&&o.tooltip===n.tooltip&&(o.arguments&&n.arguments?b(o.arguments,n.arguments):o.arguments===n.arguments)}function u(o,n){return(0,y.equals)(o,n,d)}class a{constructor(n,c,p){this._extension=n,this._proxy=c,this._sourceControlHandle=p,this._value="",this._onDidChange=new D.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(n){this._proxy.$setInputBoxValue(this._sourceControlHandle,n),this.updateValue(n)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(n){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,n),this._placeholder=n}get validateInput(){return(0,w.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(n){if((0,w.checkProposedApiEnabled)(this._extension),n&&typeof n!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=n,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!n)}get visible(){return this._visible}set visible(n){n=!!n,this._visible!==n&&(this._visible=n,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,n))}$onInputBoxValueChange(n){this.updateValue(n)}updateValue(n){this._value=n,this._onDidChange.fire(n)}}e.ExtHostSCMInputBox=a;class t{constructor(n,c,p,E,h){this._proxy=n,this._commands=c,this._sourceControlHandle=p,this._id=E,this._label=h,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new D.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new D.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(n){this._label=n,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,n)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(n){this._hideWhenEmpty=n,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(n){this._resourceStates=[...n],this._onDidUpdateResourceStates.fire()}getResourceState(n){return this._resourceStatesMap.get(n)}$executeResourceCommand(n,c){const p=this._resourceStatesCommandsMap.get(n);return p?(0,C.asPromise)(()=>this._commands.executeCommand(p.command,...p.arguments||[],c)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var n;const c=[...this._resourceStates].sort(g),E=(0,y.sortedDiff)(this._resourceSnapshot,c,g).map(A=>{const F=A.toInsert.map(x=>{const j=this._resourceHandlePool++;this._resourceStatesMap.set(j,x);const G=x.resourceUri,B=f(x.decorations),J=x.decorations&&f(x.decorations.light)||B,O=x.decorations&&f(x.decorations.dark)||B,N=[];let U;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"){const ce=new I.DisposableStore;U=this._commands.converter.toInternal(x.command,ce),this._resourceStatesDisposablesMap.set(j,ce)}else this._resourceStatesCommandsMap.set(j,x.command);J&&N.push(J),O&&O.toString()!==(J==null?void 0:J.toString())&&N.push(O);const L=x.decorations&&x.decorations.tooltip||"",M=x.decorations&&!!x.decorations.strikeThrough,V=x.decorations&&!!x.decorations.faded,K=x.contextValue||"";return{rawResource:[j,G,N,L,M,V,K,U],handle:j}});return{start:A.start,deleteCount:A.deleteCount,toInsert:F}}),h=E.map(({start:A,deleteCount:F,toInsert:x})=>[A,F,x.map(j=>j.rawResource)]),v=E.reverse();for(const{start:A,deleteCount:F,toInsert:x}of v){const j=x.map(B=>B.handle),G=this._handlesSnapshot.splice(A,F,...j);for(const B of G)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),(n=this._resourceStatesDisposablesMap.get(B))===null||n===void 0||n.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=c,h}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class r{constructor(n,c,p,E,h,v){this._proxy=c,this._commands=p,this._id=E,this._label=h,this._rootUri=v,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new I.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new I.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new D.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new a(n,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,E,h,v)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(n){this._count!==n&&(this._count=n,this._proxy.$updateSourceControl(this.handle,{count:n}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(n){this._quickDiffProvider=n,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!n})}get commitTemplate(){return this._commitTemplate}set commitTemplate(n){n!==this._commitTemplate&&(this._commitTemplate=n,this._proxy.$updateSourceControl(this.handle,{commitTemplate:n}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(n){this._acceptInputDisposables.value=new I.DisposableStore,this._acceptInputCommand=n;const c=this._commands.converter.toInternal(n,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:c})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(n){if(!(this._statusBarCommands&&n&&u(this._statusBarCommands,n))){this._statusBarDisposables.value=new I.DisposableStore,this._statusBarCommands=n;const c=(n||[]).map(p=>this._commands.converter.toInternal(p,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:c})}}get selected(){return this._selected}createResourceGroup(n,c){const p=new t(this._proxy,this._commands,this.handle,n,c),E=D.Event.once(p.onDidDispose)(()=>this.createdResourceGroups.delete(p));return this.createdResourceGroups.set(p,E),this.eventuallyAddResourceGroups(),p}eventuallyAddResourceGroups(){const n=[],c=[];for(const[p,E]of this.createdResourceGroups){E.dispose();const h=p.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(p),this.eventuallyUpdateResourceStates()});D.Event.once(p.onDidDispose)(()=>{this.updatedResourceGroups.delete(p),h.dispose(),this._groups.delete(p.handle),this._proxy.$unregisterGroup(this.handle,p.handle)}),n.push([p.handle,p.id,p.label,p.features]);const v=p._takeResourceStateSnapshot();v.length>0&&c.push([p.handle,v]),this._groups.set(p.handle,p)}this._proxy.$registerGroups(this.handle,n,c),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const n=[];this.updatedResourceGroups.forEach(c=>{const p=c._takeResourceStateSnapshot();p.length!==0&&n.push([c.handle,p])}),n.length>0&&this._proxy.$spliceResourceStates(this.handle,n),this.updatedResourceGroups.clear()}getResourceGroup(n){return this._groups.get(n)}setSelectionState(n){this._selected=n,this._onDidChangeSelection.fire(n)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(n=>n.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,Ve([(0,R.debounce)(100)],r.prototype,"eventuallyAddResourceGroups",null),Ve([(0,R.debounce)(100)],r.prototype,"eventuallyUpdateResourceStates",null);let s=class An{constructor(n,c,p){this._commands=c,this.logService=p,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new D.Emitter,this._proxy=n.getProxy(P.MainContext.MainThreadSCM),this._telemetry=n.getProxy(P.MainContext.MainThreadTelemetry),c.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===3){const h=this._sourceControls.get(E.sourceControlHandle);if(!h)return E;const v=h.getResourceGroup(E.groupHandle);return v?v.getResourceState(E.handle):E}else if(E&&E.$mid===4){const h=this._sourceControls.get(E.sourceControlHandle);return h?h.getResourceGroup(E.groupHandle):E}else if(E&&E.$mid===5){const h=this._sourceControls.get(E.handle);return h||E}return E}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(n,c,p,E){this.logService.trace("ExtHostSCM#createSourceControl",n.identifier.value,c,p,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:n.identifier.value});const h=An._handlePool++,v=new r(n,this._proxy,this._commands,c,p,E);this._sourceControls.set(h,v);const A=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(n.identifier))||[];return A.push(v),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(n.identifier),A),v}getLastInputBox(n){this.logService.trace("ExtHostSCM#getLastInputBox",n.identifier.value);const c=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(n.identifier)),p=c&&c[c.length-1];return p&&p.inputBox}$provideOriginalResource(n,c,p){const E=_.URI.revive(c);this.logService.trace("ExtHostSCM#$provideOriginalResource",n,E.toString());const h=this._sourceControls.get(n);return!h||!h.quickDiffProvider||!h.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>h.quickDiffProvider.provideOriginalResource(E,p)).then(v=>v||null)}$onInputBoxValueChange(n,c){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",n);const p=this._sourceControls.get(n);return p&&p.inputBox.$onInputBoxValueChange(c),Promise.resolve(void 0)}$executeResourceCommand(n,c,p,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",n,c,p);const h=this._sourceControls.get(n);if(!h)return Promise.resolve(void 0);const v=h.getResourceGroup(c);return v?v.$executeResourceCommand(p,E):Promise.resolve(void 0)}$validateInput(n,c,p){this.logService.trace("ExtHostSCM#$validateInput",n);const E=this._sourceControls.get(n);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>E.inputBox.validateInput(c,p)).then(h=>h?Promise.resolve([h.message,h.type]):Promise.resolve(void 0))}$setSelectedSourceControl(n){var c,p;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",n),n!==void 0&&((c=this._sourceControls.get(n))===null||c===void 0||c.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((p=this._sourceControls.get(this._selectedSourceControlHandle))===null||p===void 0||p.setSelectionState(!1)),this._selectedSourceControlHandle=n,Promise.resolve(void 0)}};s._handlePool=0,s=Ve([xe(2,T.ILogService)],s),e.ExtHostSCM=s});var tt=this&&this.__classPrivateFieldSet||function(Z,e,_){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,_),_},$e=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(me[243],pe([0,1,8,5,161,6]),function(Z,e,_,D,R,I){"use strict";var C,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{constructor(w,f,l,m,S=_.StatusBarAlignment.Left,g,b){C.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new I.DisposableStore,tt(this,C,w),tt(this,P,f),this._id=y.ID_GEN++,this._statusId=l,this._statusName=m,this._alignment=S,this._priority=g,this._accessibilityInformation=b}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var w;return(w=this._command)===null||w===void 0?void 0:w.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(w){this._text=w,this.update()}set tooltip(w){this._tooltip=w,this.update()}set color(w){this._color=w,this.update()}set backgroundColor(w){w&&!y.ALLOWED_BACKGROUND_COLORS.has(w.id)&&(w=void 0),this._backgroundColor=w,this.update()}set command(w){var f;((f=this._command)===null||f===void 0?void 0:f.fromApi)!==w&&(this._internalCommandRegistration.clear(),typeof w=="string"?this._command={fromApi:w,internal:$e(this,P).toInternal({title:"",command:w},this._internalCommandRegistration)}:w?this._command={fromApi:w,internal:$e(this,P).toInternal(w,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(w){this._accessibilityInformation=w,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,$e(this,C).$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var w;this._timeoutHandle=void 0;let f=this._color;this._backgroundColor&&(f=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),$e(this,C).$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(w=this._command)===null||w===void 0?void 0:w.internal,f,this._backgroundColor,this._alignment===_.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y,C=new WeakMap,P=new WeakMap,y.ID_GEN=0,y.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new _.ThemeColor("statusBarItem.errorForeground")]]);class i{constructor(w){this._messages=[],this._item=w.createStatusBarEntry("status.extensionMessage",(0,R.localize)(0,null),_.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(w){const f={message:w};return this._messages.unshift(f),this._update(),new _.Disposable(()=>{const l=this._messages.indexOf(f);l>=0&&(this._messages.splice(l,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class T{constructor(w,f){this._proxy=w.getProxy(D.MainContext.MainThreadStatusBar),this._commands=f,this._statusMessage=new i(this)}createStatusBarEntry(w,f,l,m,S){return new y(this._proxy,this._commands,w,f,l,m,S)}setStatusBarMessage(w,f){const l=this._statusMessage.setMessage(w);let m;return typeof f=="number"?m=setTimeout(()=>l.dispose(),f):typeof f!="undefined"&&f.then(()=>l.dispose(),()=>l.dispose()),new _.Disposable(()=>{l.dispose(),clearTimeout(m)})}}e.ExtHostStatusBar=T}),define(me[88],pe([0,1,5,3,4]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class I{constructor(P){this._onDidChangeStorage=new D.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(_.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,y){this._proxy.$registerExtensionStorageKeysToSync(P,y)}getValue(P,y,i){return this._proxy.$getValue(P,y).then(T=>T||i)}setValue(P,y,i){return this._proxy.$setValue(P,y,i)}$acceptValue(P,y,i){this._onDidChangeStorage.fire({shared:P,key:y,value:i})}}e.ExtHostStorage=I,e.IExtHostStorage=(0,R.createDecorator)("IExtHostStorage")}),define(me[89],pe([0,1,4,27,12,87,2]),function(Z,e,_,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,_.createDecorator)("IExtensionStoragePaths");let P=class{constructor(i,T,k){var w;this._logService=T,this._extHostFileSystem=k,this._workspace=(w=i.workspace)!==null&&w!==void 0?w:void 0,this._environment=i.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(f=>this._value=f)}async _getOrCreateWorkspaceStoragePath(){var i;if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,k=C.URI.joinPath(this._environment.workspaceStorageHome,T);try{return await this._extHostFileSystem.value.stat(k),this._logService.trace("[ExtHostStorage] storage dir already exists",k),k}catch(w){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",k),await this._extHostFileSystem.value.createDirectory(k),await this._extHostFileSystem.value.writeFile(C.URI.joinPath(k,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(i=C.URI.revive(this._workspace.configuration))===null||i===void 0?void 0:i.toString(),name:this._workspace.name},void 0,2))),k}catch(w){this._logService.error("[ExtHostStorage]",w);return}}workspaceValue(i){if(this._value)return C.URI.joinPath(this._value,i.identifier.value)}globalValue(i){return C.URI.joinPath(this._environment.globalStorageHome,i.identifier.value.toLowerCase())}};P=Ve([xe(0,D.IExtHostInitDataService),xe(1,R.ILogService),xe(2,I.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(me[35],pe([0,1,3,5,4,2,13,6,8,162,18,206,21,28,187]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,R.createDecorator)("IExtHostTerminalService");class m{constructor(t,r,s,o){this._proxy=t,this._id=r,this._creationOptions=s,this._name=o,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(c=>this._pidPromiseComplete=c);const n=this;this.value={get name(){return n._name||""},get processId(){return n._pidPromise},get creationOptions(){return n._creationOptions},get exitStatus(){return n._exitStatus},sendText(c,p=!0){n._checkDisposed(),n._proxy.$sendText(n._id,c,p)},show(c){n._checkDisposed(),n._proxy.$show(n._id,c)},hide(){n._checkDisposed(),n._proxy.$hide(n._id)},dispose(){n._disposed||(n._disposed=!0,n._proxy.$dispose(n._id))},get dimensions(){if(!(n._cols===void 0||n._rows===void 0))return{columns:n._cols,rows:n._rows}}}}async create(t,r,s,o,n,c,p,E,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:r,cwd:s,env:o,waitOnExit:n,strictEnv:c,hideFromUser:p,isFeatureTerminal:E,isExtensionOwnedTerminal:h})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,r){return t===this._cols&&r===this._rows||t===0||r===0?!1:(this._cols=t,this._rows=r,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(r=>{r!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=m;class S{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new _.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new _.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new _.Emitter,this._onProcessTitleChanged=new _.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new _.Emitter,this._onProcessShellTypeChanged=new _.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,r){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:r})}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(r=>this._onProcessData.fire(r)),this._pty.onDidClose&&this._pty.onDidClose((r=void 0)=>{this._onProcessExit.fire(r===void 0?void 0:r)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r&&{cols:r.columns,rows:r.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=S;let g=1,b=class extends P.Disposable{constructor(t,r){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new _.Emitter,this._onDidOpenTerminal=new _.Emitter,this._onDidChangeActiveTerminal=new _.Emitter,this._onDidChangeTerminalDimensions=new _.Emitter,this._proxy=r.getProxy(D.MainContext.MainThreadTerminalService),this._bufferer=new l.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new _.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[s,o]of this._terminalProcesses)o.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const r=new m(this._proxy,(0,f.generateUuid)(),t,t.name),s=new S(t.pty);return r.createExtensionTerminal().then(o=>{const n=this._setupExtHostProcessListeners(o,s);this._terminalProcessDisposables[o]=n}),this._terminals.push(r),r.value}attachPtyToTerminal(t,r){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const o=new S(r),n=this._setupExtHostProcessListeners(t,o);this._terminalProcessDisposables[t]=n}async $acceptActiveTerminalChanged(t){const r=this._activeTerminal;if(t===null){this._activeTerminal=void 0,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const s=this._getTerminalById(t);s&&(this._activeTerminal=s,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,r){const s=this._getTerminalById(t);s&&this._onDidWriteTerminalData.fire({terminal:s.value,data:r})}async $acceptTerminalDimensions(t,r,s){const o=this._getTerminalById(t);o&&o.setDimensions(r,s)&&this._onDidChangeTerminalDimensions.fire({terminal:o.value,dimensions:o.value.dimensions})}async $acceptTerminalMaximumDimensions(t,r,s){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.resize(r,s)}async $acceptTerminalTitleChange(t,r){const s=this._getTerminalById(t);s&&(s.name=r)}async $acceptTerminalClosed(t,r){const s=this._getTerminalObjectIndexById(this._terminals,t);if(s!==null){const o=this._terminals.splice(s,1)[0];o.setExitCode(r),this._onDidCloseTerminal.fire(o.value)}}$acceptTerminalOpened(t,r,s,o){if(r){const p=this._getTerminalObjectIndexById(this._terminals,r);if(p!==null){this._terminals[p]._id=t,this._onDidOpenTerminal.fire(this.terminals[p]),this._terminals[p].isOpen=!0;return}}const n={name:o.name,shellPath:o.executable,shellArgs:o.args,cwd:typeof o.cwd=="string"?o.cwd:I.URI.revive(o.cwd),env:o.env,hideFromUser:o.hideFromUser},c=new m(this._proxy,t,n,s);this._terminals.push(c),this._onDidOpenTerminal.fire(c.value),c.isOpen=!0}async $acceptTerminalProcessId(t,r){const s=this._getTerminalById(t);s&&s._setProcessId(r)}async $startExtensionTerminal(t,r){const s=this._getTerminalById(t);if(!s)return{message:(0,i.localize)(0,null,t)};s.isOpen||await new Promise(n=>{const c=this.onDidOpenTerminal(async p=>{p===s.value&&(c.dispose(),n())})});const o=this._terminalProcesses.get(t);o?o.startSendingEvents(r):this._extensionTerminalAwaitingStart[t]={initialDimensions:r}}_setupExtHostProcessListeners(t,r){const s=new P.DisposableStore;s.add(r.onProcessReady(n=>this._proxy.$sendProcessReady(t,n.pid,n.cwd))),s.add(r.onProcessTitleChanged(n=>this._proxy.$sendProcessTitle(t,n))),this._bufferer.startBuffering(t,r.onProcessData),s.add(r.onProcessExit(n=>this._onProcessExit(t,n))),r.onProcessOverrideDimensions&&s.add(r.onProcessOverrideDimensions(n=>this._proxy.$sendOverrideDimensions(t,n))),this._terminalProcesses.set(t,r);const o=this._extensionTerminalAwaitingStart[t];return o&&r instanceof S&&(r.startSendingEvents(o.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),s}$acceptProcessAckDataEvent(t,r){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.acknowledgeDataEvent(r)}$acceptProcessInput(t,r){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.input(r)}$acceptProcessResize(t,r,s){var o;try{(o=this._terminalProcesses.get(t))===null||o===void 0||o.resize(r,s)}catch(n){if(n.code!=="EPIPE"&&n.code!=="ERR_IPC_CHANNEL_CLOSED")throw n}}$acceptProcessShutdown(t,r){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.shutdown(r)}$acceptProcessRequestInitialCwd(t){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.getInitialCwd().then(s=>this._proxy.$sendProcessInitialCwd(t,s))}$acceptProcessRequestCwd(t){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.getCwd().then(s=>this._proxy.$sendProcessCwd(t,s))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,r){const s=this._getTerminalById(t);if(!s)return[];this._terminalLinkCache.delete(t);const o=this._terminalLinkCancellationSource.get(t);o&&o.dispose(!0);const n=new w.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,n);const c=[],p={terminal:s.value,line:r},E=[];for(const A of this._linkProviders)E.push(new Promise(async F=>{n.token.onCancellationRequested(()=>F({provider:A,links:[]}));const x=await A.provideTerminalLinks(p,n.token)||[];n.token.isCancellationRequested||F({provider:A,links:x})}));const h=await Promise.all(E);if(n.token.isCancellationRequested)return[];const v=new Map;for(const A of h)A&&A.links.length>0&&c.push(...A.links.map(F=>{const x={id:g++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return v.set(x.id,{provider:A.provider,link:F}),x}));return this._terminalLinkCache.set(t,v),c}$activateLink(t,r){var s;const o=(s=this._terminalLinkCache.get(t))===null||s===void 0?void 0:s.get(r);!o||o.provider.handleTerminalLink(o.link)}_onProcessExit(t,r){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const s=this._terminalProcessDisposables[t];s&&(s.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,r)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,r){const s=this._getTerminalObjectIndexById(t,r);return s!==null?t[s]:null}_getTerminalObjectIndexById(t,r){let s=null;return t.some((o,n)=>o._id===r?(s=n,!0):!1),s}getEnvironmentVariableCollection(t){let r=this._environmentVariableCollections.get(t.identifier.value);return r||(r=new d,this._setEnvironmentVariableCollection(t.identifier.value,r)),r}_syncEnvironmentVariableCollection(t,r){const s=(0,k.serializeEnvironmentVariableCollection)(r.map);this._proxy.$setEnvironmentVariableCollection(t,r.persistent,s.length===0?void 0:s)}$initEnvironmentVariableCollections(t){t.forEach(r=>{const s=r[0],o=new d(r[1]);this._setEnvironmentVariableCollection(s,o)})}_setEnvironmentVariableCollection(t,r){this._environmentVariableCollections.set(t,r),r.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,r)})}};b=Ve([xe(1,C.IExtHostRpcService)],b),e.BaseExtHostTerminalService=b;class d{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new _.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,r){this._setIfDiffers(t,{value:r,type:y.EnvironmentVariableMutatorType.Replace})}append(t,r){this._setIfDiffers(t,{value:r,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,r){this._setIfDiffers(t,{value:r,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,r){const s=this.map.get(t);(!s||s.value!==r.value||s.type!==r.type)&&(this.map.set(t,r),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,r){this.map.forEach((s,o)=>t.call(r,o,s,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=d;let u=class extends b{constructor(t){super(!1,t)}createTerminal(t,r,s){throw new T.NotSupportedError}createTerminalFromOptions(t){throw new T.NotSupportedError}getDefaultShell(t,r){return""}getDefaultShellArgs(t,r){throw new T.NotSupportedError}$getAvailableShells(){throw new T.NotSupportedError}async $getDefaultShellAndArgs(t){throw new T.NotSupportedError}$acceptWorkspacePermissionsChanged(t){}};u=Ve([xe(0,C.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u}),define(me[244],pe([0,1,3,14,5,120,20,8]),function(Z,e,_,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(T,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new _.Emitter,this._onDidChangeTextEditorOptions=new _.Emitter,this._onDidChangeTextEditorVisibleRanges=new _.Emitter,this._onDidChangeTextEditorViewColumn=new _.Emitter,this._onDidChangeActiveTextEditor=new _.Emitter,this._onDidChangeVisibleTextEditors=new _.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=T.getProxy(R.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(w=>this._onDidChangeVisibleTextEditors.fire(w)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(w=>this._onDidChangeActiveTextEditor.fire(w))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(T){const k=this._extHostDocumentsAndEditors.allEditors();return T?k:k.map(w=>w.value)}async showTextDocument(T,k,w){let f;typeof k=="number"?f={position:C.ViewColumn.from(k),preserveFocus:w}:typeof k=="object"?f={position:C.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?C.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:f={preserveFocus:!1};const l=await this._proxy.$tryShowTextDocument(T.uri,f),m=l&&this._extHostDocumentsAndEditors.getEditor(l);if(m)return m.value;throw l?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T){return new I.TextEditorDecorationType(this._proxy,T).value}$acceptEditorPropertiesChanged(T,k){const w=this._extHostDocumentsAndEditors.getEditor(T);if(!w)throw new Error("unknown text editor");if(k.options&&w._acceptOptions(k.options),k.selections){const f=k.selections.selections.map(C.Selection.to);w._acceptSelections(f)}if(k.visibleRanges){const f=D.coalesce(k.visibleRanges.map(C.Range.to));w._acceptVisibleRanges(f)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:w.value,options:Object.assign(Object.assign({},k.options),{lineNumbers:C.TextEditorLineNumbersStyle.to(k.options.lineNumbers)})}),k.selections){const f=P.TextEditorSelectionChangeKind.fromValue(k.selections.source),l=k.selections.selections.map(C.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:w.value,selections:l,kind:f})}if(k.visibleRanges){const f=D.coalesce(k.visibleRanges.map(C.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:w.value,visibleRanges:f})}}$acceptEditorPositionData(T){for(const k in T){const w=this._extHostDocumentsAndEditors.getEditor(k);if(!w)throw new Error("Unknown text editor");const f=C.ViewColumn.to(T[k]);w.value.viewColumn!==f&&(w._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:w.value,viewColumn:f}))}}getDiffInformation(T){return Promise.resolve(this._proxy.$getDiffInformation(T))}}e.ExtHostEditors=y});var mn=this&&this.__rest||function(Z,e){var _={};for(var D in Z)Object.prototype.hasOwnProperty.call(Z,D)&&e.indexOf(D)<0&&(_[D]=Z[D]);if(Z!=null&&typeof Object.getOwnPropertySymbols=="function")for(var R=0,D=Object.getOwnPropertySymbols(Z);R<D.length;R++)e.indexOf(D[R])<0&&Object.prototype.propertyIsEnumerable.call(Z,D[R])&&(_[D[R]]=Z[D[R]]);return _};define(me[245],pe([0,1,2,4,5,6,8]),function(Z,e,_,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,D.createDecorator)("IExtHostTimeline");class P{constructor(T,k){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=T.getProxy(R.MainContext.MainThreadTimeline),k.registerArgumentProcessor({processArgument:w=>{var f,l;if(w&&w.$mid===11){const m=w.uri===void 0?void 0:_.URI.revive(w.uri);return(l=(f=this._itemsBySourceAndUriMap.get(w.source))===null||f===void 0?void 0:f.get(y(m)))===null||l===void 0?void 0:l.get(w.handle)}return w}})}async $getTimeline(T,k,w,f,l){const m=this._providers.get(T);return m==null?void 0:m.provideTimeline(_.URI.revive(k),w,f,l)}registerTimelineProvider(T,k,w,f){const l=new I.DisposableStore,m=this.convertTimelineItem(k.id,f,l).bind(this);let S;k.onDidChange&&(S=k.onDidChange(b=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},b),{id:k.id})),this));const g=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},k),{scheme:T,onDidChange:void 0,async provideTimeline(b,d,u,a){var t;(a==null?void 0:a.resetCache)&&(l.clear(),(t=g.get(k.id))===null||t===void 0||t.clear());const r=await k.provideTimeline(b,d,u);if(r!=null){const s=m(b,a);return Object.assign(Object.assign({},r),{source:k.id,items:r.items.map(s)})}},dispose(){var b;for(const d of g.values())(b=d.get(k.id))===null||b===void 0||b.clear();S==null||S.dispose(),l.dispose()}}))}convertTimelineItem(T,k,w){return(f,l)=>{let m;if(l==null?void 0:l.cacheResults){let S=this._itemsBySourceAndUriMap.get(T);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(T,S));const g=y(f);m=S.get(g),m===void 0&&(m=new Map,S.set(g,m))}return S=>{var g,b;const{iconPath:d}=S,u=mn(S,["iconPath"]),a=`${T}|${(g=S.id)!==null&&g!==void 0?g:S.timestamp}`;m==null||m.set(a,S);let t,r,s;return S.iconPath&&(d instanceof C.ThemeIcon?s={id:d.id}:_.URI.isUri(d)?(t=d,r=d):{light:t,dark:r}=d),Object.assign(Object.assign({},u),{id:(b=u.id)!==null&&b!==void 0?b:void 0,handle:a,source:T,command:S.command?k.toInternal(S.command,w):void 0,icon:t,iconDark:r,themeIcon:s,accessibilityInformation:S.accessibilityInformation})}}}registerTimelineProviderCore(T){if(this._providers.get(T.id))throw new Error(`Timeline Provider ${T.id} already exists.`);return this._proxy.$registerTimelineProvider({id:T.id,label:T.label,scheme:T.scheme}),this._providers.set(T.id,T),(0,I.toDisposable)(()=>{var w;for(const f of this._itemsBySourceAndUriMap.values())(w=f.get(T.id))===null||w===void 0||w.clear();this._providers.delete(T.id),this._proxy.$unregisterTimelineProvider(T.id),T.dispose()})}}e.ExtHostTimeline=P;function y(i){return i==null?void 0:i.toString()}}),define(me[246],pe([0,1,6,11,2,5]),function(Z,e,_,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(y){this._openers=new Map,this._proxy=y.getProxy(I.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,i,T,k){if(this._openers.has(i))throw new Error(`Opener with id '${i}' already registered`);const w=k.schemes.find(f=>!C.supportedSchemes.has(f));if(w)throw new Error(`Scheme '${w}' is not supported. Only http and https are currently supported.`);return this._openers.set(i,T),this._proxy.$registerUriOpener(i,k.schemes,y,k.label),(0,_.toDisposable)(()=>{this._openers.delete(i),this._proxy.$unregisterUriOpener(i)})}async $canOpenUri(y,i,T){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener with id: ${y}`);const w=R.URI.revive(i);return k.canOpenExternalUri(w,T)}async $openUri(y,i,T){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener id: '${y}'`);return k.openExternalUri(R.URI.revive(i.resolvedUri),{sourceUri:R.URI.revive(i.sourceUri)},T)}}e.ExtHostUriOpeners=C,C.supportedSchemes=new Set([D.Schemas.http,D.Schemas.https])}),define(me[247],pe([0,1,5,2,6,18,29]),function(Z,e,_,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(i){this.handles=new Set,this.handlers=new Map,this._proxy=i.getProxy(_.MainContext.MainThreadUrls)}registerUriHandler(i,T){if(this.handles.has(C.ExtensionIdentifier.toKey(i)))throw new Error(`Protocol handler already registered for extension ${i}`);const k=P.HandlePool++;return this.handles.add(C.ExtensionIdentifier.toKey(i)),this.handlers.set(k,T),this._proxy.$registerUriHandler(k,i),(0,R.toDisposable)(()=>{this.handles.delete(C.ExtensionIdentifier.toKey(i)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(i,T){const k=this.handlers.get(i);if(!k)return Promise.resolve(void 0);try{k.handleUri(D.URI.revive(T))}catch(w){(0,I.onUnexpectedError)(w)}return Promise.resolve(void 0)}async createAppUri(i){return D.URI.revive(await this._proxy.$createAppUri(i))}}e.ExtHostUrls=P,P.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(Z,e,_){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,_),_},$e=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(me[66],pe([0,1,3,2,85,5]),function(Z,e,_,D,R,I){"use strict";var C,P,y,i,T,k,w,f,l,m,S;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.ExtHostWebview=void 0;class g{constructor(s,o,n,c,p,E,h){C.set(this,void 0),P.set(this,void 0),y.set(this,void 0),i.set(this,void 0),T.set(this,void 0),k.set(this,void 0),w.set(this,""),f.set(this,void 0),l.set(this,!1),m.set(this,!1),this._onMessageEmitter=new _.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,S.set(this,new _.Emitter),this._onDidDispose=$e(this,S).event,tt(this,C,s),tt(this,P,o),tt(this,f,n),tt(this,i,c),tt(this,T,p),tt(this,k,E),tt(this,y,h)}dispose(){tt(this,l,!0),$e(this,S).fire(),$e(this,S).dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return tt(this,m,!0),(0,R.asWebviewUri)($e(this,i),$e(this,C),s)}get cspSource(){return $e(this,i).webviewCspSource.replace("{{uuid}}",$e(this,C))}get html(){return this.assertNotDisposed(),$e(this,w)}set html(s){this.assertNotDisposed(),$e(this,w)!==s&&(tt(this,w,s),!$e(this,m)&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(tt(this,m,!0),$e(this,y).report("Webview vscode-resource: uris",$e(this,k),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),$e(this,P).$setHtml($e(this,C),s))}get options(){return this.assertNotDisposed(),$e(this,f)}set options(s){this.assertNotDisposed(),$e(this,P).$setOptions($e(this,C),u($e(this,k),$e(this,T),s)),tt(this,f,s)}async postMessage(s){return $e(this,l)?!1:$e(this,P).$postMessage($e(this,C),s)}assertNotDisposed(){if($e(this,l))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,C=new WeakMap,P=new WeakMap,y=new WeakMap,i=new WeakMap,T=new WeakMap,k=new WeakMap,w=new WeakMap,f=new WeakMap,l=new WeakMap,m=new WeakMap,S=new WeakMap;class b{constructor(s,o,n,c,p){this.initData=o,this.workspace=n,this._logService=c,this._deprecationService=p,this._webviews=new Map,this._webviewProxy=s.getProxy(I.MainContext.MainThreadWebviews)}$onMessage(s,o){const n=this.getWebview(s);n&&n._onMessageEmitter.fire(o)}$onMissingCsp(s,o){this._logService.warn(`${o} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,o,n){const c=new g(s,this._webviewProxy,a(o),this.initData,this.workspace,n,this._deprecationService);return this._webviews.set(s,c),c._onDidDispose(()=>{this._webviews.delete(s)}),c}deleteWebview(s){this._webviews.delete(s)}getWebview(s){return this._webviews.get(s)}}e.ExtHostWebviews=b;function d(r){return{id:r.identifier,location:r.extensionLocation}}e.toExtensionData=d;function u(r,s,o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots||t(r,s)}}e.serializeWebviewOptions=u;function a(r){var s;return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,portMapping:r.portMapping,localResourceRoots:(s=r.localResourceRoots)===null||s===void 0?void 0:s.map(o=>D.URI.from(o))}}e.reviveOptions=a;function t(r,s){return[...((s==null?void 0:s.getWorkspaceFolders())||[]).map(o=>o.uri),r.extensionLocation]}}),define(me[248],pe([0,1,21,74,6,11,23,2,20,66,115,5,8]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new T.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=u(this.document.uri)+this._backupCounter++;return(0,C.joinPath)(this._storagePath,t)}updateBackup(t){var r;(r=this._backup)===null||r===void 0||r.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class l{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,s){const o=this.key(t,r.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const n=new f(r,s);return this._documents.set(o,n),n}delete(t,r){const s=this.key(t,r.uri);this._documents.delete(s)}key(t,r){return`${t}@@@${r}`}}var m;(function(a){a[a.Text=0]="Text",a[a.Custom=1]="Custom"})(m||(m={}));class S{constructor(){this._providers=new Map}addTextProvider(t,r,s){return this.add(0,t,r,s)}addCustomProvider(t,r,s){return this.add(1,t,r,s)}get(t){return this._providers.get(t)}add(t,r,s,o){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:s,provider:o}),new w.Disposable(()=>this._providers.delete(r))}}class g{constructor(t,r,s,o,n){this._extHostDocuments=r,this._extensionStoragePaths=s,this._extHostWebview=o,this._extHostWebviewPanels=n,this._editorProviders=new S,this._documents=new l,this._proxy=t.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,s,o){const n=new R.DisposableStore;return b(s)?(n.add(this._editorProviders.addTextProvider(r,t,s)),this._proxy.$registerTextEditorProvider((0,i.toExtensionData)(t),r,o.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor})):(n.add(this._editorProviders.addCustomProvider(r,t,s)),this.supportEditing(s)&&n.add(s.onDidChangeCustomDocument(c=>{const p=this.getCustomDocumentEntry(r,c.document.uri);if(d(c)){const E=p.addEdit(c);this._proxy.$onDidEdit(c.document.uri,r,E,c.label)}else this._proxy.$onContentChange(c.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,i.toExtensionData)(t),r,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument)),w.Disposable.from(n,new w.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,s,o){var n;const c=this._editorProviders.get(r);if(!c)throw new Error(`No provider found for '${r}'`);if(c.type!==1)throw new Error(`Invalid provide type for '${r}'`);const p=P.URI.revive(t),E=await c.provider.openCustomDocument(p,{backupId:s},o);let h;return this.supportEditing(c.provider)&&this._extensionStoragePaths&&(h=(n=this._extensionStoragePaths.workspaceValue(c.extension))!==null&&n!==void 0?n:this._extensionStoragePaths.globalValue(c.extension)),this._documents.add(r,E,h),{editable:this.supportEditing(c.provider)}}async $disposeCustomDocument(t,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${r}'`);const o=P.URI.revive(t),{document:n}=this.getCustomDocumentEntry(r,o);this._documents.delete(r,n),n.dispose()}async $resolveWebviewEditor(t,r,s,o,n,c){const p=this._editorProviders.get(s);if(!p)throw new Error(`No provider found for '${s}'`);const E=y.ViewColumn.to(n),h=this._extHostWebview.createNewWebview(r,o.webviewOptions,p.extension),v=this._extHostWebviewPanels.createNewWebviewPanel(r,s,o.title,E,o.panelOptions,h),A=P.URI.revive(t);switch(p.type){case 1:{const{document:F}=this.getCustomDocumentEntry(s,A);return p.provider.resolveCustomEditor(F,v,c)}case 0:{const F=this._extHostDocuments.getDocument(A);return p.provider.resolveCustomTextEditor(F,v,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,s){this.getCustomDocumentEntry(r,t).disposeEdits(s)}async $onMoveCustomEditor(t,r,s){const o=this._editorProviders.get(s);if(!o)throw new Error(`No provider found for '${s}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const n=this._extHostWebviewPanels.getWebviewPanel(t);if(!n)throw new Error("No webview found");const c=P.URI.revive(r),p=this._extHostDocuments.getDocument(c);await o.provider.moveCustomTextEditor(p,n,_.CancellationToken.None)}async $undo(t,r,s,o){return this.getCustomDocumentEntry(r,t).undo(s,o)}async $redo(t,r,s,o){return this.getCustomDocumentEntry(r,t).redo(s,o)}async $revert(t,r,s){const o=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(o.document,s),o.disposeBackup()}async $onSave(t,r,s){const o=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(o.document,s),o.disposeBackup()}async $onSaveAs(t,r,s,o){const n=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(n.document,P.URI.revive(s),o)}async $backup(t,r,s){const o=this.getCustomDocumentEntry(r,t),c=await this.getCustomEditorProvider(r).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},s);return o.updateBackup(c),c.id}getCustomDocumentEntry(t,r){const s=this._documents.get(t,P.URI.revive(r));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const r=this._editorProviders.get(t),s=r==null?void 0:r.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=g;function b(a){return typeof a.resolveCustomTextEditor=="function"}function d(a){return typeof a.undo=="function"&&typeof a.redo=="function"}function u(a){const t=a.scheme===I.Schemas.file||a.scheme===I.Schemas.untitled?a.fsPath:a.toString();return(0,D.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(Z,e,_){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,_),_},$e=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(me[249],pe([0,1,3,6,2,28,20,66,5,8]),function(Z,e,_,D,R,I,C,P,y,i){"use strict";var T,k,w,f,l,m,S,g,b,d,u,a,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends D.Disposable{constructor(c,p,E,h,v,A,F){super();T.set(this,void 0),k.set(this,void 0),w.set(this,void 0),f.set(this,void 0),l.set(this,void 0),m.set(this,void 0),S.set(this,void 0),g.set(this,void 0),b.set(this,!0),d.set(this,!0),u.set(this,!1),a.set(this,this._register(new _.Emitter)),this.onDidDispose=$e(this,a).event,t.set(this,this._register(new _.Emitter)),this.onDidChangeViewState=$e(this,t).event,tt(this,T,c),tt(this,k,p),tt(this,w,E),tt(this,l,A),tt(this,g,v),tt(this,m,h),tt(this,f,F)}dispose(){$e(this,u)||(tt(this,u,!0),$e(this,a).fire(),$e(this,k).$disposeWebview($e(this,T)),$e(this,f).dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),$e(this,f)}get viewType(){return this.assertNotDisposed(),$e(this,w)}get title(){return this.assertNotDisposed(),$e(this,m)}set title(c){this.assertNotDisposed(),$e(this,m)!==c&&(tt(this,m,c),$e(this,k).$setTitle($e(this,T),c))}get iconPath(){return this.assertNotDisposed(),$e(this,S)}set iconPath(c){this.assertNotDisposed(),$e(this,S)!==c&&(tt(this,S,c),$e(this,k).$setIconPath($e(this,T),R.URI.isUri(c)?{light:c,dark:c}:c))}get options(){return $e(this,l)}get viewColumn(){if(this.assertNotDisposed(),!(typeof $e(this,g)=="number"&&$e(this,g)<0))return $e(this,g)}get active(){return this.assertNotDisposed(),$e(this,d)}get visible(){return this.assertNotDisposed(),$e(this,b)}_updateViewState(c){$e(this,u)||(this.active!==c.active||this.visible!==c.visible||this.viewColumn!==c.viewColumn)&&(tt(this,d,c.active),tt(this,b,c.visible),tt(this,g,c.viewColumn),$e(this,t).fire({webviewPanel:this}))}reveal(c,p){this.assertNotDisposed(),$e(this,k).$reveal($e(this,T),{viewColumn:c?C.ViewColumn.from(c):void 0,preserveFocus:!!p})}assertNotDisposed(){if($e(this,u))throw new Error("Webview is disposed")}}T=new WeakMap,k=new WeakMap,w=new WeakMap,f=new WeakMap,l=new WeakMap,m=new WeakMap,S=new WeakMap,g=new WeakMap,b=new WeakMap,d=new WeakMap,u=new WeakMap,a=new WeakMap,t=new WeakMap;class s{constructor(c,p,E){this.webviews=p,this.workspace=E,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=c.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,I.generateUuid)()}createWebviewPanel(c,p,E,h,v={}){const A=typeof h=="object"?h.viewColumn:h,F={viewColumn:C.ViewColumn.from(A),preserveFocus:typeof h=="object"&&!!h.preserveFocus},x=s.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(c),x,p,{title:E,panelOptions:o(v),webviewOptions:(0,P.serializeWebviewOptions)(c,this.workspace,v)},F);const j=this.webviews.createNewWebview(x,v,c);return this.createNewWebviewPanel(x,p,E,A,v,j)}$onDidChangeWebviewPanelViewStates(c){const p=Object.keys(c);p.sort((E,h)=>{const v=c[E],A=c[h];return v.active?1:A.active?-1:+v.visible-+A.visible});for(const E of p){const h=this.getWebviewPanel(E);if(!!h){const v=c[E];h._updateViewState({active:v.active,visible:v.visible,viewColumn:C.ViewColumn.to(v.position)})}}}async $onDidDisposeWebviewPanel(c){const p=this.getWebviewPanel(c);p==null||p.dispose(),this._webviewPanels.delete(c),this.webviews.deleteWebview(c)}registerWebviewPanelSerializer(c,p,E){if(this._serializers.has(p))throw new Error(`Serializer for '${p}' already registered`);return this._serializers.set(p,{serializer:E,extension:c}),this._proxy.$registerSerializer(p),new i.Disposable(()=>{this._serializers.delete(p),this._proxy.$unregisterSerializer(p)})}async $deserializeWebviewPanel(c,p,E,h){const v=this._serializers.get(p);if(!v)throw new Error(`No serializer found for '${p}'`);const{serializer:A,extension:F}=v,x=this.webviews.createNewWebview(c,E.webviewOptions,F),j=this.createNewWebviewPanel(c,p,E.title,h,E.panelOptions,x);await A.deserializeWebviewPanel(j,E.state)}createNewWebviewPanel(c,p,E,h,v,A){const F=new r(c,this._proxy,p,E,h,v,A);return this._webviewPanels.set(c,F),F}getWebviewPanel(c){return this._webviewPanels.get(c)}}e.ExtHostWebviewPanels=s;function o(n){return{enableFindWidget:n.enableFindWidget,retainContextWhenHidden:n.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(Z,e,_){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,_),_},$e=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(me[250],pe([0,1,3,6,66,5,8]),function(Z,e,_,D,R,I,C){"use strict";var P,y,i,T,k,w,f,l,m,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class g extends D.Disposable{constructor(u,a,t,r,s,o){super();P.set(this,void 0),y.set(this,void 0),i.set(this,void 0),T.set(this,void 0),k.set(this,!1),w.set(this,void 0),f.set(this,void 0),l.set(this,void 0),m.set(this,this._register(new _.Emitter)),this.onDidChangeVisibility=$e(this,m).event,S.set(this,this._register(new _.Emitter)),this.onDidDispose=$e(this,S).event,tt(this,i,t),tt(this,f,r),tt(this,P,u),tt(this,y,a),tt(this,T,s),tt(this,w,o)}dispose(){$e(this,k)||(tt(this,k,!0),$e(this,S).fire(),$e(this,T).dispose(),super.dispose())}get title(){return this.assertNotDisposed(),$e(this,f)}set title(u){this.assertNotDisposed(),$e(this,f)!==u&&(tt(this,f,u),$e(this,y).$setWebviewViewTitle($e(this,P),u))}get description(){return this.assertNotDisposed(),$e(this,l)}set description(u){this.assertNotDisposed(),$e(this,l)!==u&&(tt(this,l,u),$e(this,y).$setWebviewViewDescription($e(this,P),u))}get visible(){return $e(this,w)}get webview(){return $e(this,T)}get viewType(){return $e(this,i)}_setVisible(u){u===$e(this,w)||$e(this,k)||(tt(this,w,u),$e(this,m).fire())}show(u){this.assertNotDisposed(),$e(this,y).$show($e(this,P),!!u)}assertNotDisposed(){if($e(this,k))throw new Error("Webview is disposed")}}P=new WeakMap,y=new WeakMap,i=new WeakMap,T=new WeakMap,k=new WeakMap,w=new WeakMap,f=new WeakMap,l=new WeakMap,m=new WeakMap,S=new WeakMap;class b{constructor(u,a){this._extHostWebview=a,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=u.getProxy(I.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(u,a,t,r){if(this._viewProviders.has(a))throw new Error(`View provider for '${a}' already registered`);return this._viewProviders.set(a,{provider:t,extension:u}),this._proxy.$registerWebviewViewProvider((0,R.toExtensionData)(u),a,r),new C.Disposable(()=>{this._viewProviders.delete(a),this._proxy.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(u,a,t,r,s){const o=this._viewProviders.get(a);if(!o)throw new Error(`No view provider found for '${a}'`);const{provider:n,extension:c}=o,p=this._extHostWebview.createNewWebview(u,{},c),E=new g(u,this._proxy,a,t,p,!0);this._webviewViews.set(u,E),await n.resolveWebviewView(E,{state:r},s)}async $onDidChangeWebviewViewVisibility(u,a){this.getWebviewView(u)._setVisible(a)}async $disposeWebviewView(u){const a=this.getWebviewView(u);this._webviewViews.delete(u),a.dispose(),this._extHostWebview.deleteWebview(u)}getWebviewView(u){const a=this._webviewViews.get(u);if(!a)throw new Error("No webview found");return a}}e.ExtHostWebviewViews=b}),define(me[123],pe([0,1,3,5,2,11,9,4,13]),function(Z,e,_,D,R,I,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let i=class Rn{constructor(k){this._onDidChangeWindowState=new _.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Rn.InitialState,this._proxy=k.getProxy(D.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(w=>this.$onDidChangeWindowFocus(w))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:k}),this._onDidChangeWindowState.fire(this._state))}openUri(k,w){let f;if(typeof k=="string"){f=k;try{k=R.URI.parse(k)}catch(l){return Promise.reject(`Invalid uri - '${k}'`)}}return(0,C.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===I.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,f,w)}async asExternalUri(k,w){if((0,C.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([I.Schemas.http,I.Schemas.https]).has(k.scheme))return Promise.reject(`Invalid scheme '${k.scheme}'`);const f=await this._proxy.$asExternalUri(k,w);return R.URI.from(f)}};i.InitialState={focused:!0},i=Ve([xe(0,y.IExtHostRpcService)],i),e.ExtHostWindow=i,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(me[251],pe([0,1,7,43,28,52,6,5,2,13]),function(Z,e,_,D,R,I,C,P,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let T=class extends C.Disposable{constructor(w,f){super();const l=w.getProxy(P.MainContext.MainThreadDownloadService);f.registerCommand(!1,"_workbench.downloadResource",async m=>{const S=y.URI.file((0,_.join)((0,D.tmpdir)(),(0,R.generateUuid)()));return await l.$download(m,S),S})}};T=Ve([xe(0,i.IExtHostRpcService),xe(1,I.IExtHostCommands)],T),e.ExtHostDownloadService=T}),define(me[252],pe([0,1,2,7,144,25,34,65,27,13,6,12,108,49]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=e.ExtHostOutputChannelBackedByFile=void 0;class l{constructor(b,d){this.file=d,this.appender=(0,w.createRotatingLogger)(b,d,30*f.ByteSize.MB,1),this.appender.clearFormatters()}append(b){this.appender.critical(b)}flush(){this.appender.flush()}}class m extends P.AbstractExtHostOutputChannel{constructor(b,d,u){super(b,!1,_.URI.file(d.file),u);this._appender=d}append(b){super.append(b),this._appender.append(b),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(b,d){this._appender.flush(),super.show(b,d)}clear(){this._appender.flush(),super.clear()}}e.ExtHostOutputChannelBackedByFile=m;let S=class extends P.ExtHostOutputService{constructor(b,d,u){super(b);this.logService=d,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new T.MutableDisposable,this._logsLocation=u.logsLocation}$setVisibleChannel(b){if(b){const d=this._channels.get(b);d&&(this._visibleChannelDisposable.value=d.onDidAppend(()=>d.update()))}}createOutputChannel(b){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const d=this._doCreateOutChannel(b);return d.then(u=>u._id.then(a=>this._channels.set(a,u))),new P.LazyOutputChannel(b,d)}async _doCreateOutChannel(b){try{const d=(0,D.join)(this._logsLocation.fsPath,`output_logging_${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await I.SymlinkSupport.existsDirectory(d)||await C.promises.mkdir(d,{recursive:!0});const a=`${this._namePool++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=_.URI.file((0,D.join)(d,`${a}.log`)),r=new l(a,t.fsPath);return new m(b,r,this._proxy)}catch(d){return this.logService.error(d),new P.ExtHostPushOutputChannel(b,this._proxy)}}};S=Ve([xe(0,i.IExtHostRpcService),xe(1,k.ILogService),xe(2,y.IExtHostInitDataService)],S),e.ExtHostOutputService2=S}),define(me[253],pe([0,1,5,13,6,27,2,38,23,34,25,10,50,3,73,12]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.findPorts=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class S{constructor(o,n,c){this.remoteAddress=o,this.localAddress=n,this._dispose=c,this._onDispose=new f.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function g(s){const o=s.trim().split(`
`),n=[];return o.forEach(c=>{const p=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(c);p&&p.length>=3&&n.push({pid:parseInt(p[1],10),socket:parseInt(p[2],10)})}),n}e.getSockets=g;function b(...s){const o=[].concat(...s.map(u));return[...new Map(o.filter(n=>n.st==="0A").map(n=>{const c=n.local_address.split(":");return{socket:parseInt(n.inode,10),ip:d(c[0]),port:parseInt(c[1],16)}}).map(n=>[n.ip+":"+n.port,n])).values()]}e.loadListeningPorts=b;function d(s){let o="";if(s.length===8)for(let n=s.length-2;n>=0;n-=2)o+=parseInt(s.substr(n,2),16),n!==0&&(o+=".");else for(let n=s.length-4;n>=0;n-=4)o+=parseInt(s.substr(n,4),16).toString(16),n!==0&&(o+=":");return o}e.parseIpAddress=d;function u(s){const o=s.trim().split(`
`),n=o.shift().trim().split(/\s+/).filter(p=>p!=="rx_queue"&&p!=="tm->when");return o.map(p=>p.trim().split(/\s+/).reduce((E,h,v)=>(E[n[v]||v]=h,E),{}))}e.loadConnectionTable=u;function a(s){return!!s.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||s.indexOf("out/vs/server/main.js")!==-1||s.indexOf("_productName=VSCode")!==-1}async function t(s,o,n,c){const p=b(s,o),h=g(n).reduce((F,x)=>(F[x.socket]=x,F),{}),v=c.reduce((F,x)=>(F[x.pid]=x,F),{}),A=[];return p.filter(F=>h[F.socket]).forEach(({socket:F,ip:x,port:j})=>{const G=v[h[F].pid].cmd;a(G)||A.push({host:x,port:j,detail:v[h[F].pid].cmd,pid:h[F].pid})}),A}e.findPorts=t;let r=class extends R.Disposable{constructor(o,n,c){super();this.logService=c,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new f.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._proxy=o.getProxy(_.MainContext.MainThreadTunnelService),k.isLinux&&n.remote.isRemote&&n.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(o,n){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier} called openTunnel API for ${n.remoteAddress.port}.`);const c=await this._proxy.$openTunnel(n,o.displayName);if(c){const p=new S(c.remoteAddress,c.localAddress,()=>this._proxy.$closeTunnel(c.remoteAddress));return this._register(p),p}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(o){return Math.max(o*20,2e3)}async $registerCandidateFinder(o){if(!(o&&this._candidateFindingEnabled)){this._candidateFindingEnabled=o;let n=new l.MovingAverage,c;for(;this._candidateFindingEnabled;){const p=new Date().getTime(),E=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${E.map(v=>v.port).join(", ")}`);const h=new Date().getTime()-p;n.update(h),(!c||JSON.stringify(c)!==JSON.stringify(E))&&(c=E,await this._proxy.$onFoundNewCandidates(c)),await new Promise(v=>setTimeout(()=>v(),this.calculateDelay(n.value)))}}}async setTunnelExtensionFunctions(o){var n;return o?(o.candidatePortSource!==void 0&&await this._proxy.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this._showCandidatePort=o.showCandidatePort,await this._proxy.$setCandidateFilter()),o.tunnelFactory&&(this._forwardPortProvider=o.tunnelFactory,await this._proxy.$setTunnelProvider((n=o.tunnelFeatures)!==null&&n!==void 0?n:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,R.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(o,n){if(this._extensionTunnels.has(o.host)){const c=this._extensionTunnels.get(o.host);c.has(o.port)&&(n&&c.get(o.port).disposeListener.dispose(),await c.get(o.port).tunnel.dispose(),c.delete(o.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(o,n){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const c=this._forwardPortProvider(o,n);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),c!==void 0){const p=await c;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(o.remoteAddress.host)||this._extensionTunnels.set(o.remoteAddress.host,new Map);const E=this._register(p.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(p.remoteAddress))));return this._extensionTunnels.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:p,disposeListener:E}),w.TunnelDto.fromApiTunnel(p)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(c){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(o){const n=await Promise.all(o.map(p=>this._showCandidatePort(p.host,p.port,p.detail))),c=o.filter((p,E)=>n[E]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(p=>p.port).join(", ")} to ${c.map(p=>p.port).join(", ")}`),c}async findCandidatePorts(){let o="",n="";try{o=await i.promises.readFile("/proc/net/tcp","utf8"),n=await i.promises.readFile("/proc/net/tcp6","utf8")}catch(h){}const c=await new Promise(h=>{(0,P.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(v,A,F)=>{h(A)})}),p=await T.readdir("/proc"),E=[];for(let h of p)try{const v=Number(h),A=y.joinPath(C.URI.file("/proc"),h);if((await i.promises.stat(A.fsPath)).isDirectory()&&!isNaN(v)){const x=await i.promises.readlink(y.joinPath(A,"cwd").fsPath),j=await i.promises.readFile(y.joinPath(A,"cmdline").fsPath,"utf8");E.push({pid:v,cwd:x,cmd:j})}}catch(v){}return t(o,n,c,E)}};r=Ve([xe(0,D.IExtHostRpcService),xe(1,I.IExtHostInitDataService),xe(2,m.ILogService)],r),e.ExtHostTunnelService=r}),define(me[254],pe([0,1,19,21,18,3,6,97,225,121,26]),function(Z,e,_,D,R,I,C,P,y,i,T){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function w(o,n){try{return JSON.stringify(o,n)}catch(c){return"null"}}function f(o,n){return JSON.stringify(o,n)}function l(o){return o?(n,c)=>c&&c.$mid===1?o.transformOutgoing(c):c:null}var m;(function(o){o[o.LocalSide=0]="LocalSide",o[o.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(o){o[o.Responsive=0]="Responsive",o[o.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const g=()=>{},b=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class u extends C.Disposable{constructor(n,c=null,p=null){super();this[k]=!0,this._onDidChangeResponsiveState=this._register(new I.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=n,this._logger=c,this._uriTransformer=p,this._uriReplacer=l(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let E=0,h=i.ProxyIdentifier.count;E<h;E++)this._locals[E]=null,this._proxies[E]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new _.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(E=>this._receiveOneMessage(E))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(n=>{this._pendingRPCReplies[n].resolveErr(R.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(n){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(n){this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(n){this._responsiveState!==n&&(this._responsiveState=n,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(n){return this._uriTransformer?(0,P.transformIncomingURIs)(n,this._uriTransformer):n}getProxy(n){const{nid:c,sid:p}=n;return this._proxies[c]||(this._proxies[c]=this._createProxy(c,p)),this._proxies[c]}_createProxy(n,c){let p={get:(E,h)=>(typeof h=="string"&&!E[h]&&h.charCodeAt(0)===36&&(E[h]=(...v)=>this._remoteCall(n,h,v)),h===d?c:E[h])};return new Proxy(Object.create(null),p)}set(n,c){return this._locals[n.nid]=c,c}assertRegistered(n){for(let c=0,p=n.length;c<p;c++){const E=n[c];if(!this._locals[E.nid])throw new Error(`Missing actor ${E.sid} (isMain: ${E.isMain})`)}}_receiveOneMessage(n){if(!this._isDisposed){const c=n.byteLength,p=a.read(n,0),E=p.readUInt8(),h=p.readUInt32();switch(E){case 1:case 2:{let{rpcId:v,method:A,args:F}=t.deserializeRequestJSONArgs(p);this._uriTransformer&&(F=(0,P.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(c,h,v,A,F,E===2);break}case 3:case 4:{let{rpcId:v,method:A,args:F}=t.deserializeRequestMixedArgs(p);this._uriTransformer&&(F=(0,P.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(c,h,v,A,F,E===4);break}case 5:{this._logger&&this._logger.logIncoming(c,h,0,"ack"),this._onDidReceiveAcknowledge(h);break}case 6:{this._receiveCancel(c,h);break}case 7:{this._receiveReply(c,h,void 0);break}case 9:{let v=t.deserializeReplyOKJSON(p);this._uriTransformer&&(v=(0,P.transformIncomingURIs)(v,this._uriTransformer)),this._receiveReply(c,h,v);break}case 8:{let v=t.deserializeReplyOKVSBuffer(p);this._receiveReply(c,h,v);break}case 10:{let v=t.deserializeReplyErrError(p);this._uriTransformer&&(v=(0,P.transformIncomingURIs)(v,this._uriTransformer)),this._receiveReplyErr(c,h,v);break}case 11:{this._receiveReplyErr(c,h,void 0);break}default:console.error("received unexpected message"),console.error(n)}}}_receiveRequest(n,c,p,E,h,v){this._logger&&this._logger.logIncoming(n,c,1,`receiveRequest ${(0,i.getStringIdentifierForProxy)(p)}.${E}(`,h);const A=String(c);let F,x;if(v){const G=new D.CancellationTokenSource;h.push(G.token),F=this._invokeHandler(p,E,h),x=()=>G.cancel()}else F=this._invokeHandler(p,E,h),x=g;this._cancelInvokedHandlers[A]=x;const j=t.serializeAcknowledged(c);this._logger&&this._logger.logOutgoing(j.byteLength,c,1,"ack"),this._protocol.send(j),F.then(G=>{delete this._cancelInvokedHandlers[A];const B=t.serializeReplyOK(c,G,this._uriReplacer);this._logger&&this._logger.logOutgoing(B.byteLength,c,1,"reply:",G),this._protocol.send(B)},G=>{delete this._cancelInvokedHandlers[A];const B=t.serializeReplyErr(c,G);this._logger&&this._logger.logOutgoing(B.byteLength,c,1,"replyErr:",G),this._protocol.send(B)})}_receiveCancel(n,c){this._logger&&this._logger.logIncoming(n,c,1,"receiveCancel");const p=String(c);this._cancelInvokedHandlers[p]&&this._cancelInvokedHandlers[p]()}_receiveReply(n,c,p){this._logger&&this._logger.logIncoming(n,c,0,"receiveReply:",p);const E=String(c);if(!!this._pendingRPCReplies.hasOwnProperty(E)){const h=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E],h.resolveOk(p)}}_receiveReplyErr(n,c,p){this._logger&&this._logger.logIncoming(n,c,0,"receiveReplyErr:",p);const E=String(c);if(!!this._pendingRPCReplies.hasOwnProperty(E)){const h=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E];let v;p&&(p.$isError?(v=new Error,v.name=p.name,v.message=p.message,v.stack=p.stack):v=p),h.resolveErr(v)}}_invokeHandler(n,c,p){try{return Promise.resolve(this._doInvokeHandler(n,c,p))}catch(E){return Promise.reject(E)}}_doInvokeHandler(n,c,p){const E=this._locals[n];if(!E)throw new Error("Unknown actor "+(0,i.getStringIdentifierForProxy)(n));let h=E[c];if(typeof h!="function")throw new Error("Unknown method "+c+" on actor "+(0,i.getStringIdentifierForProxy)(n));return h.apply(E,p)}_remoteCall(n,c,p){if(this._isDisposed)return Promise.reject(R.canceled());let E=null;if(p.length>0&&D.CancellationToken.isCancellationToken(p[p.length-1])&&(E=p.pop()),E&&E.isCancellationRequested)return Promise.reject(R.canceled());const h=t.serializeRequestArguments(p,this._uriReplacer),v=++this._lastMessageId,A=String(v),F=new y.LazyPromise;E&&E.onCancellationRequested(()=>{const j=t.serializeCancel(v);this._logger&&this._logger.logOutgoing(j.byteLength,v,0,"cancel"),this._protocol.send(t.serializeCancel(v))}),this._pendingRPCReplies[A]=F,this._onWillSendRequest(v);const x=t.serializeRequest(v,n,c,h,!!E);return this._logger&&this._logger.logOutgoing(x.byteLength,v,0,`request: ${(0,i.getStringIdentifierForProxy)(n)}.${c}(`,p),this._protocol.send(x),F}}e.RPCProtocol=u,k=b,u.UNRESPONSIVE_TIME=3*1e3;class a{constructor(n,c){this._buff=n,this._offset=c}static alloc(n,c,p){let E=new a(T.VSBuffer.alloc(p+1+4),0);return E.writeUInt8(n),E.writeUInt32(c),E}static read(n,c){return new a(n,c)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(n){this._buff.writeUInt8(n,this._offset),this._offset+=1}readUInt8(){const n=this._buff.readUInt8(this._offset);return this._offset+=1,n}writeUInt32(n){this._buff.writeUInt32BE(n,this._offset),this._offset+=4}readUInt32(){const n=this._buff.readUInt32BE(this._offset);return this._offset+=4,n}static sizeShortString(n){return 1+n.byteLength}writeShortString(n){this._buff.writeUInt8(n.byteLength,this._offset),this._offset+=1,this._buff.set(n,this._offset),this._offset+=n.byteLength}readShortString(){const n=this._buff.readUInt8(this._offset);this._offset+=1;const p=this._buff.slice(this._offset,this._offset+n).toString();return this._offset+=n,p}static sizeLongString(n){return 4+n.byteLength}writeLongString(n){this._buff.writeUInt32BE(n.byteLength,this._offset),this._offset+=4,this._buff.set(n,this._offset),this._offset+=n.byteLength}readLongString(){const n=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+n).toString();return this._offset+=n,p}writeBuffer(n){this._buff.writeUInt32BE(n.byteLength,this._offset),this._offset+=4,this._buff.set(n,this._offset),this._offset+=n.byteLength}static sizeVSBuffer(n){return 4+n.byteLength}writeVSBuffer(n){this._buff.writeUInt32BE(n.byteLength,this._offset),this._offset+=4,this._buff.set(n,this._offset),this._offset+=n.byteLength}readVSBuffer(){const n=this._buff.readUInt32BE(this._offset);this._offset+=4;const c=this._buff.slice(this._offset,this._offset+n);return this._offset+=n,c}static sizeMixedArray(n,c){let p=0;p+=1;for(let E=0,h=n.length;E<h;E++){const v=n[E],A=c[E];switch(p+=1,A){case 1:p+=this.sizeLongString(v);break;case 2:p+=this.sizeVSBuffer(v);break;case 3:break}}return p}writeMixedArray(n,c){this._buff.writeUInt8(n.length,this._offset),this._offset+=1;for(let p=0,E=n.length;p<E;p++){const h=n[p];switch(c[p]){case 1:this.writeUInt8(1),this.writeLongString(h);break;case 2:this.writeUInt8(2),this.writeVSBuffer(h);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const n=this._buff.readUInt8(this._offset);this._offset+=1;let c=new Array(n);for(let p=0;p<n;p++)switch(this.readUInt8()){case 1:c[p]=this.readLongString();break;case 2:c[p]=this.readVSBuffer();break;case 3:c[p]=void 0;break}return c}}class t{static _arrayContainsBufferOrUndefined(n){for(let c=0,p=n.length;c<p;c++)if(n[c]instanceof T.VSBuffer||typeof n[c]=="undefined")return!0;return!1}static serializeRequestArguments(n,c){if(this._arrayContainsBufferOrUndefined(n)){let p=[],E=[];for(let h=0,v=n.length;h<v;h++){const A=n[h];A instanceof T.VSBuffer?(p[h]=A,E[h]=2):typeof A=="undefined"?(p[h]=T.VSBuffer.alloc(0),E[h]=3):(p[h]=T.VSBuffer.fromString(f(A,c)),E[h]=1)}return{type:"mixed",args:p,argsType:E}}return{type:"simple",args:f(n,c)}}static serializeRequest(n,c,p,E,h){return E.type==="mixed"?this._requestMixedArgs(n,c,p,E.args,E.argsType,h):this._requestJSONArgs(n,c,p,E.args,h)}static _requestJSONArgs(n,c,p,E,h){const v=T.VSBuffer.fromString(p),A=T.VSBuffer.fromString(E);let F=0;F+=a.sizeUInt8(),F+=a.sizeShortString(v),F+=a.sizeLongString(A);let x=a.alloc(h?2:1,n,F);return x.writeUInt8(c),x.writeShortString(v),x.writeLongString(A),x.buffer}static deserializeRequestJSONArgs(n){const c=n.readUInt8(),p=n.readShortString(),E=n.readLongString();return{rpcId:c,method:p,args:JSON.parse(E)}}static _requestMixedArgs(n,c,p,E,h,v){const A=T.VSBuffer.fromString(p);let F=0;F+=a.sizeUInt8(),F+=a.sizeShortString(A),F+=a.sizeMixedArray(E,h);let x=a.alloc(v?4:3,n,F);return x.writeUInt8(c),x.writeShortString(A),x.writeMixedArray(E,h),x.buffer}static deserializeRequestMixedArgs(n){const c=n.readUInt8(),p=n.readShortString(),E=n.readMixedArray(),h=new Array(E.length);for(let v=0,A=E.length;v<A;v++){const F=E[v];typeof F=="string"?h[v]=JSON.parse(F):h[v]=F}return{rpcId:c,method:p,args:h}}static serializeAcknowledged(n){return a.alloc(5,n,0).buffer}static serializeCancel(n){return a.alloc(6,n,0).buffer}static serializeReplyOK(n,c,p){return typeof c=="undefined"?this._serializeReplyOKEmpty(n):c instanceof T.VSBuffer?this._serializeReplyOKVSBuffer(n,c):this._serializeReplyOKJSON(n,w(c,p))}static _serializeReplyOKEmpty(n){return a.alloc(7,n,0).buffer}static _serializeReplyOKVSBuffer(n,c){let p=0;p+=a.sizeVSBuffer(c);let E=a.alloc(8,n,p);return E.writeVSBuffer(c),E.buffer}static deserializeReplyOKVSBuffer(n){return n.readVSBuffer()}static _serializeReplyOKJSON(n,c){const p=T.VSBuffer.fromString(c);let E=0;E+=a.sizeLongString(p);let h=a.alloc(9,n,E);return h.writeLongString(p),h.buffer}static deserializeReplyOKJSON(n){const c=n.readLongString();return JSON.parse(c)}static serializeReplyErr(n,c){return c?this._serializeReplyErrEror(n,c):this._serializeReplyErrEmpty(n)}static _serializeReplyErrEror(n,c){const p=T.VSBuffer.fromString(w(R.transformErrorForSerialization(c),null));let E=0;E+=a.sizeLongString(p);let h=a.alloc(10,n,E);return h.writeLongString(p),h.buffer}static deserializeReplyErrError(n){const c=n.readLongString();return JSON.parse(c)}static _serializeReplyErrEmpty(n){return a.alloc(11,n,0).buffer}}var r;(function(o){o[o.RequestJSONArgs=1]="RequestJSONArgs",o[o.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",o[o.RequestMixedArgs=3]="RequestMixedArgs",o[o.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",o[o.Acknowledged=5]="Acknowledged",o[o.Cancel=6]="Cancel",o[o.ReplyOKEmpty=7]="ReplyOKEmpty",o[o.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",o[o.ReplyOKJSON=9]="ReplyOKJSON",o[o.ReplyErrError=10]="ReplyErrError",o[o.ReplyErrEmpty=11]="ReplyErrEmpty"})(r||(r={}));var s;(function(o){o[o.String=1]="String",o[o.VSBuffer=2]="VSBuffer",o[o.Undefined=3]="Undefined"})(s||(s={}))}),define(me[255],pe([0,1,4]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,_.createDecorator)("remoteAgentService")}),define(me[256],pe([0,1,11,7,10,2,4,255]),function(Z,e,_,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,C.createDecorator)("pathService");let y=class{constructor(T,k){this.localUserHome=T,this.remoteAgentService=k,this.resolveOS=(async()=>{const w=await this.remoteAgentService.getEnvironment();return(w==null?void 0:w.os)||R.OS})(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(w==null?void 0:w.userHome)||T})()}async userHome(T){return(T==null?void 0:T.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(T=>T===1?D.win32:D.posix)}async fileURI(T){let k="";if(await this.resolveOS===1&&(T=T.replace(/\\/g,"/")),T[0]==="/"&&T[1]==="/"){const f=T.indexOf("/",2);f===-1?(k=T.substring(2),T="/"):(k=T.substring(2,f),T=T.substring(f)||"/")}return I.URI.from({scheme:_.Schemas.file,authority:k,path:T,query:"",fragment:""})}};y=Ve([xe(1,P.IRemoteAgentService)],y),e.AbstractPathService=y}),define(me[31],pe([0,1,14,33,24,30,9,4,7,18]),function(Z,e,_,D,R,I,C,P,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const T="\u27EA ",k=" characters skipped \u27EB",w=(T.length+k.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var f;(function(O){O[O.file=0]="file",O[O.text=1]="text"})(f=e.SearchProviderType||(e.SearchProviderType={}));var l;(function(O){O[O.File=1]="File",O[O.Text=2]="Text"})(l=e.QueryType||(e.QueryType={}));function m(O){return!!O.preview}e.resultIsMatch=m;function S(O){return!!O.resource}e.isFileMatch=S;function g(O){return!!O.message}e.isProgressMessage=g;var b;(function(O){O[O.Normal=0]="Normal",O[O.NewSearchStarted=1]="NewSearchStarted"})(b=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class d{constructor(N){this.resource=N,this.results=[]}}e.FileMatch=d;class u{constructor(N,U,L){this.ranges=U;const M=Array.isArray(U)?U:[U];if(L&&L.matchLines===1&&a(M)){N=(0,C.getNLines)(N,L.matchLines);let V="",K=0,se=0;const ce=Math.floor(L.charsPerLine/5),we=[];for(const Te of M){const Ie=Math.max(Te.startColumn-ce,0),Me=Te.startColumn+L.charsPerLine;if(Ie>se+ce+w){const H=T+(Ie-se)+k;V+=H+N.slice(Ie,Me),K+=Ie-(se+H.length)}else V+=N.slice(se,Me);we.push(new r(0,Te.startColumn-K,Te.endColumn-K)),se=Me}this.preview={text:V,matches:Array.isArray(this.ranges)?we:we[0]}}else{const V=Array.isArray(U)?U[0].startLineNumber:U.startLineNumber;this.preview={text:N,matches:(0,_.mapArrayOrNot)(U,K=>new t(K.startLineNumber-V,K.startColumn,K.endLineNumber-V,K.endColumn))}}}}e.TextSearchMatch=u;function a(O){const N=O[0].startLineNumber;for(const U of O)if(U.startLineNumber!==N||U.endLineNumber!==N)return!1;return!0}class t{constructor(N,U,L,M){this.startLineNumber=N,this.startColumn=U,this.endLineNumber=L,this.endColumn=M}}e.SearchRange=t;class r extends t{constructor(N,U,L){super(N,U,N,L)}}e.OneLineRange=r;var s;(function(O){O.Default="default",O.FileNames="fileNames",O.Type="type",O.Modified="modified",O.CountDescending="countDescending",O.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function o(O,N=!0){const U=O&&O.files&&O.files.exclude,L=N&&O&&O.search&&O.search.exclude;if(!(!U&&!L)){if(!U||!L)return U||L;let M=Object.create(null);return M=R.mixin(M,R.deepClone(U)),M=R.mixin(M,R.deepClone(L),!0),M}}e.getExcludes=o;function n(O,N){return O.excludePattern&&D.match(O.excludePattern,N)?!1:O.includePattern||O.usingSearchPaths?O.includePattern&&D.match(O.includePattern,N)?!0:O.usingSearchPaths?!!O.folderQueries&&O.folderQueries.some(U=>{const L=U.folder.fsPath;if(I.isEqualOrParent(N,L)){const M=y.relative(L,N);return!U.includePattern||!!D.match(U.includePattern,M)}else return!1}):!1:!0}e.pathIncludedInQuery=n;var c;(function(O){O[O.unknownEncoding=1]="unknownEncoding",O[O.regexParseError=2]="regexParseError",O[O.globParseError=3]="globParseError",O[O.invalidLiteral=4]="invalidLiteral",O[O.rgProcessError=5]="rgProcessError",O[O.other=6]="other",O[O.canceled=7]="canceled"})(c=e.SearchErrorCode||(e.SearchErrorCode={}));class p extends Error{constructor(N,U){super(N);this.code=U}}e.SearchError=p;function E(O){const N=O.message;if((0,i.isPromiseCanceledError)(O))return new p(N,c.canceled);try{const U=JSON.parse(N);return new p(U.message,U.code)}catch(U){return new p(N,c.other)}}e.deserializeSearchError=E;function h(O){const N={message:O.message,code:O.code};return new Error(JSON.stringify(N))}e.serializeSearchError=h;function v(O){return O.type==="error"?!0:O.type==="success"}e.isSerializedSearchComplete=v;function A(O){return O.type==="success"}e.isSerializedSearchSuccess=A;function F(O){return!!O.path}e.isSerializedFileMatch=F;function x(O,N){const U=O.searchPath?O.searchPath:O.relativePath;return(0,C.fuzzyContains)(U,N)}e.isFilePatternMatch=x;class j{constructor(N){this.path=N,this.results=[]}addMatch(N){this.results.push(N)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=j;function G(O,N){const U=Object.assign(Object.assign({},O||{}),N||{});return Object.keys(U).filter(L=>{const M=U[L];return typeof M=="boolean"&&M})}e.resolvePatternsForProvider=G;class B{constructor(N,U){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},N.excludePattern||{}),U.excludePattern||{}),this._parsedExcludeExpression=D.parse(this._excludeExpression);let L=N.includePattern;U.includePattern&&(L?L=Object.assign(Object.assign({},L),U.includePattern):L=U.includePattern),L&&(this._parsedIncludeExpression=D.parse(L))}includedInQuerySync(N,U,L){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(N,U,L)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(N,U,L))}includedInQuery(N,U,L){return Promise.resolve(this._parsedExcludeExpression(N,U,L)).then(V=>!!V).then(V=>V?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(N,U,L)).then(K=>!!K):Promise.resolve(!0)).then(V=>V)}hasSiblingExcludeClauses(){return J(this._excludeExpression)}}e.QueryGlobTester=B;function J(O){for(const N in O)if(typeof O[N]!="boolean")return!0;return!1}}),define(me[32],pe([0,1,14,19,21,3,22,11,73,23,9,15,2,164,4,12,183,61,62,27,13,8,31,5]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l,m,S,g,b,d,u,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(A,F,x){return new i.ExtUri(j=>p(j,x)).isEqual(A,F)}function o(A,F,x){return s(A.uri,F.uri,x)?0:(0,T.compare)(A.uri.toString(),F.uri.toString())}function n(A,F,x){return A.index!==F.index?A.index<F.index?-1:1:s(A.uri,F.uri,x)?(0,T.compare)(A.name,F.name):(0,T.compare)(A.uri.toString(),F.uri.toString())}function c(A,F,x,j){const G=A.slice(0).sort((J,O)=>x(J,O,j)),B=F.slice(0).sort((J,O)=>x(J,O,j));return(0,_.delta)(G,B,(J,O)=>x(J,O,j))}function p(A,F){const x=F.getCapabilities(A.scheme);return!(x&&x&1024)}class E extends g.Workspace{constructor(F,x,j,G,B,J){super(F,j.map(O=>new g.WorkspaceFolder(O)),G,J);this._name=x,this._isUntitled=B,this._workspaceFolders=[],this._structure=C.TernarySearchTree.forUris(J),j.forEach(O=>{this._workspaceFolders.push(O),this._structure.set(O.uri,O)})}static toExtHostWorkspace(F,x,j,G){if(!F)return{workspace:null,added:[],removed:[]};const{id:B,name:J,folders:O,configuration:N,isUntitled:U}=F,L=[],M=x;x?O.forEach((ce,we)=>{const Te=w.URI.revive(ce.uri),Ie=E._findFolder(j||x,Te,G);Ie?(Ie.name=ce.name,Ie.index=ce.index,L.push(Ie)):L.push({uri:Te,name:ce.name,index:we})}):L.push(...O.map(({uri:ce,name:we,index:Te})=>({uri:w.URI.revive(ce),name:we,index:Te}))),L.sort((ce,we)=>ce.index<we.index?-1:1);const V=new E(B,J,L,N?w.URI.revive(N):null,!!U,ce=>p(ce,G)),{added:K,removed:se}=c(M?M.workspaceFolders:[],V.workspaceFolders,o,G);return{workspace:V,added:K,removed:se}}static _findFolder(F,x,j){for(let G=0;G<F.folders.length;G++){const B=F.workspaceFolders[G];if(s(B.uri,x,j))return B}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,x){return x&&this._structure.get(F)&&(F=(0,i.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let h=class{constructor(F,x,j,G){this._onDidChangeWorkspace=new I.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidChangeWorkspaceTrustState=new I.Emitter,this.onDidChangeWorkspaceTrustState=this._onDidChangeWorkspaceTrustState.event,this._activeSearchCallbacks=[],this._workspaceTrustState=a.WorkspaceTrustState.Unknown,this._logService=G,this._extHostFileSystemInfo=j,this._requestIdProvider=new y.Counter,this._barrier=new D.Barrier,this._proxy=F.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(r.MainContext.MainThreadMessageService);const B=x.workspace;this._confirmedWorkspace=B?new E(B.id,B.name,[],B.configuration?w.URI.revive(B.configuration):null,!!B.isUntitled,J=>p(J,j)):void 0}$initializeWorkspace(F,x){this._workspaceTrustState=x,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?w.URI.from({scheme:P.Schemas.untitled,path:(0,i.basename)((0,i.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,x,j,...G){const B=[];if(Array.isArray(G)&&G.forEach(L=>{w.URI.isUri(L.uri)&&!B.some(M=>s(M.uri,L.uri,this._extHostFileSystemInfo))&&B.push({uri:L.uri,name:L.name||(0,i.basenameOrAuthority)(L.uri)})}),this._unconfirmedWorkspace||[x,j].some(L=>typeof L!="number"||L<0)||j===0&&B.length===0)return!1;const J=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(x+j>J.length)return!1;const O=J.slice(0);O.splice(x,j,...B.map(L=>({uri:L.uri,name:L.name||(0,i.basenameOrAuthority)(L.uri),index:void 0})));for(let L=0;L<O.length;L++){const M=O[L];if(O.some((V,K)=>K!==L&&s(M.uri,V.uri,this._extHostFileSystemInfo)))return!1}O.forEach((L,M)=>L.index=M);const{added:N,removed:U}=c(J,O,n,this._extHostFileSystemInfo);if(N.length===0&&U.length===0)return!1;if(this._proxy){const L=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(L,x,j,B).then(void 0,M=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(S.Severity.Error,(0,f.localize)(0,null,L,M.toString()),{extension:F},[])})}return this.trySetWorkspaceFolders(O),!0}getWorkspaceFolder(F,x){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,x)}async getWorkspaceFolder2(F,x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,x)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!!this._actualWorkspace){const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}}getRelativePath(F,x){let j,G="";if(typeof F=="string"?(j=w.URI.file(F),G=F):typeof F!="undefined"&&(j=F,G=F.fsPath),!j)return G;const B=this.getWorkspaceFolder(j,!0);if(!B)return G;typeof x=="undefined"&&this._actualWorkspace&&(x=this._actualWorkspace.folders.length>1);let J=(0,i.relativePath)(B.uri,j);return x&&B.name&&(J=`${B.name}/${J}`),J}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=E.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:x,added:j,removed:G}=E.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=x||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:j,removed:G}))}findFiles(F,x,j,G,B=R.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${G.value}, entryPoint: findFiles`);let J;if(x===null?J=!1:x&&(typeof x=="string"?J=x:J=x.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:O,folder:N}=v(F);return this._proxy.$startFileSearch((0,k.withUndefinedAsNull)(O),(0,k.withUndefinedAsNull)(N),(0,k.withUndefinedAsNull)(J),(0,k.withUndefinedAsNull)(j),B).then(U=>Array.isArray(U)?U.map(L=>w.URI.revive(L)):[])}async findTextInFiles(F,x,j,G,B=R.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${G.value}, entryPoint: findTextInFiles`);const J=this._requestIdProvider.getNext(),O=typeof x.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:x.previewOptions,{includePattern:N,folder:U}=v(x.include),L=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,M={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!0,fileEncoding:x.encoding,maxResults:x.maxResults,previewOptions:O,afterContext:x.afterContext,beforeContext:x.beforeContext,includePattern:N,excludePattern:L},V=!1;if(this._activeSearchCallbacks[J]=K=>{if(!V){const se=w.URI.revive(K.resource);K.results.forEach(ce=>{(0,t.resultIsMatch)(ce)?j({uri:se,preview:{text:ce.preview.text,matches:(0,_.mapArrayOrNot)(ce.preview.matches,we=>new a.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:(0,_.mapArrayOrNot)(ce.ranges,we=>new a.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):j({uri:se,text:ce.text,lineNumber:ce.lineNumber})})}},B.isCancellationRequested)return{};try{const K=await this._proxy.$startTextSearch(F,(0,k.withUndefinedAsNull)(U),M,J,B);return delete this._activeSearchCallbacks[J],K||{}}catch(K){throw delete this._activeSearchCallbacks[J],K}}$handleTextSearchResult(F,x){this._activeSearchCallbacks[x]&&this._activeSearchCallbacks[x](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trustState(){return this._workspaceTrustState}requireWorkspaceTrust(F){return this._proxy.$requireWorkspaceTrust(F)}$onDidChangeWorkspaceTrustState(F){this._workspaceTrustState=F.currentTrustState,this._onDidChangeWorkspaceTrustState.fire(Object.freeze(F))}};h=Ve([xe(0,u.IExtHostRpcService),xe(1,d.IExtHostInitDataService),xe(2,b.IExtHostFileSystemInfo),xe(3,m.ILogService)],h),e.ExtHostWorkspace=h,e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function v(A){let F,x;return A&&(typeof A=="string"?F=A:(F=A.pattern,x=A.baseFolder||w.URI.file(A.base))),{includePattern:F,folder:x}}}),define(me[36],pe([0,1,24,3,32,5,8,185,83,15,19,4,13,12,2]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function m(r,s){if(s){const o=s.split(".");let n=r;for(let c=0;n&&c<o.length;c++)n=n[o[c]];return n}}function S(r){return r instanceof l.URI}function g(r){return r&&r.uri instanceof l.URI&&r.languageId&&typeof r.languageId=="string"}function b(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function d(r){return r&&r.uri instanceof l.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function u(r){if(S(r))return{resource:r};if(g(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(b(r))return{overrideIdentifier:r.languageId};if(d(r))return{resource:r.uri};if(r===null)return{resource:null}}let a=class{constructor(s,o,n){this._proxy=s.getProxy(I.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=n,this._barrier=new T.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,o){this.getConfigProvider().then(n=>n.$acceptConfigurationChanged(s,o))}};a=Ve([xe(0,w.IExtHostRpcService),xe(1,R.IExtHostWorkspace),xe(2,f.ILogService)],a),e.ExtHostConfiguration=a;class t{constructor(s,o,n,c){this._onDidChangeConfiguration=new D.Emitter,this._proxy=s,this._logService=c,this._extHostWorkspace=o,this._configuration=P.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,o){const n={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,n))}getConfiguration(s,o,n){const c=u(o)||{},p=this._toReadonlyValue(s?m(this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,c,n==null?void 0:n.identifier);function E(v){if(v==null)return null;if(typeof v=="boolean")return v?1:4;switch(v){case C.ConfigurationTarget.Global:return 1;case C.ConfigurationTarget.Workspace:return 4;case C.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(v){return typeof m(p,v)!="undefined"},get:(v,A)=>{this._validateConfigurationAccess(s?`${s}.${v}`:v,c,n==null?void 0:n.identifier);let F=m(p,v);if(typeof F=="undefined")F=A;else{let x;const j=(G,B)=>{let J;const O=()=>{x=x||(0,_.deepClone)(p),J=J||m(x,B)};return(0,i.isObject)(G)?new Proxy(G,{get:(N,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return O(),()=>J;if(x)return J=J||m(x,B),J[U];const L=N[U];return typeof U=="string"?j(L,`${B}.${U}`):L},set:(N,U,L)=>(O(),J&&(J[U]=L),!0),deleteProperty:(N,U)=>(O(),J&&delete J[U],!0),defineProperty:(N,U,L)=>(O(),J&&Object.defineProperty(J,U,L),!0)}):G};F=j(F,v)}return F},update:(v,A,F,x)=>{v=s?`${s}.${v}`:v;const j=E(F);return A!==void 0?this._proxy.$updateConfigurationOption(j,v,A,c,x):this._proxy.$removeConfigurationOption(j,v,c,x)},inspect:v=>{var A,F,x,j,G,B,J,O;v=s?`${s}.${v}`:v;const N=(0,_.deepClone)(this._configuration.inspect(v,c,this._extHostWorkspace.workspace));if(N)return{key:v,defaultValue:(A=N.default)===null||A===void 0?void 0:A.value,globalValue:(F=N.user)===null||F===void 0?void 0:F.value,workspaceValue:(x=N.workspace)===null||x===void 0?void 0:x.value,workspaceFolderValue:(j=N.workspaceFolder)===null||j===void 0?void 0:j.value,defaultLanguageValue:(G=N.default)===null||G===void 0?void 0:G.override,globalLanguageValue:(B=N.user)===null||B===void 0?void 0:B.override,workspaceLanguageValue:(J=N.workspace)===null||J===void 0?void 0:J.override,workspaceFolderLanguageValue:(O=N.workspaceFolder)===null||O===void 0?void 0:O.override,languageIds:N.overrideIdentifiers}}};return typeof p=="object"&&(0,_.mixin)(h,p,!1),Object.freeze(h)}_toReadonlyValue(s){const o=n=>(0,i.isObject)(n)?new Proxy(n,{get:(c,p)=>o(c[p]),set:(c,p,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(c,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(c,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):n;return o(s)}_validateConfigurationAccess(s,o,n){const c=y.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),p=n?`[${n.value}] `:"";if(c===4){typeof(o==null?void 0:o.resource)=="undefined"&&this._logService.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){(o==null?void 0:o.resource)&&this._logService.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,o){const n=new P.ConfigurationChangeEvent(s,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(c,p)=>n.affectsConfiguration(c,u(p))})}_toMap(s){return s.reduce((o,n)=>(o.set(n[0],n[1]),o),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(Z,e,_){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,_),_},$e=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(me[67],pe([0,1,2,19,3,5,8,32,39,36,21,35,13,27,4,11,10,12,64,205,18]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l,m,S,g,b,d,u){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(G){function B(O){if(O!=null)return O}G.from=B;function J(O){if(O!=null)return O}G.to=J})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var r;(function(G){function B(O){if(O!=null)return O}G.from=B;function J(O){if(O!=null)return O}G.to=J})(r=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(G){function B(O){if(O!=null)return O}G.from=B;function J(O){if(O!=null)return O}G.to=J})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var o;(function(G){function B(N){if(N){const U=N;return U&&!!U.process}else return!1}G.is=B;function J(N){if(N!=null){const U={process:N.process,args:N.args};return N.options&&(U.options=s.from(N.options)),U}}G.from=J;function O(N){if(N!=null)return new C.ProcessExecution(N.process,N.args,N.options)}G.to=O})(o=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var n;(function(G){function B(O){if(O!=null)return O}G.from=B;function J(O){if(O!=null)return O}G.to=J})(n=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var c;(function(G){function B(N){if(N){const U=N;return U&&(!!U.commandLine||!!U.command)}else return!1}G.is=B;function J(N){if(N!=null){const U={};return N.commandLine!==void 0?U.commandLine=N.commandLine:(U.command=N.command,U.args=N.args),N.options&&(U.options=n.from(N.options)),U}}G.from=J;function O(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new C.ShellExecution(N.commandLine,N.options):new C.ShellExecution(N.command,N.args?N.args:[],N.options)}G.to=O})(c=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var p;(function(G){function B(N){if(N){let U=N;return U&&U.customExecution==="customExecution"}else return!1}G.is=B;function J(N){return{customExecution:"customExecution"}}G.from=J;function O(N,U){return U.get(N)}G.to=O})(p=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var E;(function(G){function B(J,O){let N;return J.scope!==void 0&&typeof J.scope!="number"?N=J.scope.uri:J.scope!==void 0&&typeof J.scope=="number"&&(J.scope===C.TaskScope.Workspace&&O&&O.workspaceFile?N=O.workspaceFile:N=d.USER_TASKS_GROUP_KEY),{id:J._id,workspaceFolder:N}}G.from=B})(E=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(G){function B(N,U){if(N==null)return[];const L=[];for(let M of N){const V=J(M,U);V&&L.push(V)}return L}G.fromMany=B;function J(N,U){if(N!=null){let L;N.execution instanceof C.ProcessExecution?L=o.from(N.execution):N.execution instanceof C.ShellExecution?L=c.from(N.execution):N.execution&&N.execution instanceof C.CustomExecution&&(L=p.from(N.execution));const M=t.from(N.definition);let V;if(N.scope?typeof N.scope=="number"?V=N.scope:V=N.scope.uri:V=C.TaskScope.Workspace,!(!M||!V)){const K=N.group?N.group.id:void 0;return{_id:N._id,definition:M,name:N.name,source:{extensionId:U.identifier.value,label:N.source,scope:V},execution:L,isBackground:N.isBackground,group:K,presentationOptions:r.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}}}G.from=J;async function O(N,U,L){if(N!=null){let M;o.is(N.execution)?M=o.to(N.execution):c.is(N.execution)?M=c.to(N.execution):p.is(N.execution)&&(M=p.to(N._id,L));const V=t.to(N.definition);let K;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?K=N.source.scope:K=await U.resolveWorkspaceFolder(_.URI.revive(N.source.scope)):K=C.TaskScope.Workspace),!(!V||!K)){const se=new C.Task(V,K,N.name,N.source.label,M,N.problemMatchers);return N.isBackground!==void 0&&(se.isBackground=N.isBackground),N.group!==void 0&&(se.group=C.TaskGroup.from(N.group)),N.presentationOptions&&(se.presentationOptions=r.to(N.presentationOptions)),N._id&&(se._id=N._id),N.detail&&(se.detail=N.detail),se}}}G.to=O})(h=e.TaskDTO||(e.TaskDTO={}));var v;(function(G){function B(O){return O}G.from=B;function J(O){if(!!O)return Object.assign(Object.create(null),O)}G.to=J})(v=e.TaskFilterDTO||(e.TaskFilterDTO={}));class A{constructor(B,J,O){this._id=J,this._task=O,a.set(this,void 0),tt(this,a,B)}get task(){return this._task}terminate(){$e(this,a).terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}a=new WeakMap;var F;(function(G){function B(J){return{id:J._id,task:void 0}}G.from=B})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let x=class{constructor(B,J,O,N,U,L,M,V){this._onDidExecuteTask=new R.Emitter,this._onDidTerminateTask=new R.Emitter,this._onDidTaskProcessStarted=new R.Emitter,this._onDidTaskProcessEnded=new R.Emitter,this._proxy=B.getProxy(I.MainContext.MainThreadTask),this._workspaceProvider=O,this._editorService=N,this._configurationService=U,this._terminalService=L,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=M,this._deprecationService=V,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(B,J,O){if(!O)return new C.Disposable(()=>{});const N=this.nextHandle();return this._handlers.set(N,{type:J,provider:O,extension:B}),this._proxy.$registerTaskProvider(N,J),new C.Disposable(()=>{this._handlers.delete(N),this._proxy.$unregisterTaskProvider(N)})}registerTaskSystem(B,J){this._proxy.$registerTaskSystem(B,J)}fetchTasks(B){return this._proxy.$fetchTasks(v.from(B)).then(async J=>{const O=[];for(let N of J){const U=await h.to(N,this._workspaceProvider,this._providedCustomExecutions2);U&&O.push(U)}return O})}get taskExecutions(){const B=[];return this._taskExecutions.forEach(J=>B.push(J)),B}terminateTask(B){if(!(B instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(B._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(B,J,O){const N=this._providedCustomExecutions2.get(B.id);if(N){if(this._activeCustomExecutions2.get(B.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(B.id,N),this._terminalService.attachPtyToTerminal(J,await N.callback(O))}this._lastStartedTask=B.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(B)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(B){const J=await this.getTaskExecution(B);this._taskExecutionPromises.delete(B.id),this._taskExecutions.delete(B.id),this.customExecutionComplete(B),this._onDidTerminateTask.fire({execution:J})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(B){const J=await this.getTaskExecution(B.id);this._onDidTaskProcessStarted.fire({execution:J,processId:B.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(B){const J=await this.getTaskExecution(B.id);this._onDidTaskProcessEnded.fire({execution:J,exitCode:B.exitCode})}$provideTasks(B,J){const O=this._handlers.get(B);if(!O)return Promise.reject(new Error("no handler found"));const N=[],U=(0,D.asPromise)(()=>O.provider.provideTasks(T.CancellationToken.None)).then(L=>this.provideTasksInternal(J,N,O,L));return new Promise(L=>{U.then(M=>{Promise.all(N).then(()=>{L(M)})})})}async $resolveTask(B,J){const O=this._handlers.get(B);if(!O)return Promise.reject(new Error("no handler found"));if(J.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${J.definition.type}] cannot be resolved by provider of type [${O.type}].`);const N=await h.to(J,this._workspaceProvider,this._providedCustomExecutions2);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const U=await O.provider.resolveTask(N,T.CancellationToken.None);if(!!U){this.checkDeprecation(U,O);const L=h.from(U,O.extension);if(!L)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(L.execution)&&await this.addCustomExecution(L,U,!0),await this.resolveTaskInternal(L)}}nextHandle(){return this._handleCounter++}async addCustomExecution(B,J,O){const N=await this._proxy.$createTaskId(B);!O&&!this._providedCustomExecutions2.has(N)&&this._notProvidedCustomExecutions.add(N),this._providedCustomExecutions2.set(N,J.execution)}async getTaskExecution(B,J){if(typeof B=="string"){const U=this._taskExecutionPromises.get(B);if(!U)throw new Error("Unexpected: The specified task is missing an execution");return U}let O=this._taskExecutionPromises.get(B.id);if(O)return O;const N=new Promise(async(U,L)=>{const M=J||await h.to(B.task,this._workspaceProvider,this._providedCustomExecutions2);M?U(new A(this,B.id,M)):L("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(B.id,N),N.then(U=>(this._taskExecutions.set(B.id,U),U),U=>Promise.reject(U))}checkDeprecation(B,J){B._deprecated&&this._deprecationService.report("Task.constructor",J.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(B){this._activeCustomExecutions2.get(B.id)&&this._activeCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.has(B.id)&&this._lastStartedTask!==B.id&&(this._providedCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.delete(B.id));let O=this._notProvidedCustomExecutions.values(),N=O.next();for(;!N.done;)!this._activeCustomExecutions2.has(N.value)&&this._lastStartedTask!==N.value&&(this._providedCustomExecutions2.delete(N.value),this._notProvidedCustomExecutions.delete(N.value)),N=O.next()}};x=Ve([xe(0,w.IExtHostRpcService),xe(1,f.IExtHostInitDataService),xe(2,P.IExtHostWorkspace),xe(3,y.IExtHostDocumentsAndEditors),xe(4,i.IExtHostConfiguration),xe(5,k.IExtHostTerminalService),xe(6,g.ILogService),xe(7,b.IExtHostApiDeprecationService)],x),e.ExtHostTaskBase=x;let j=class extends x{constructor(B,J,O,N,U,L,M,V){super(B,J,O,N,U,L,M,V);this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:"",platform:S.PlatformToString(0)})}async executeTask(B,J){if(!J.execution)throw new Error("Tasks to execute must include an execution");const O=h.from(J,B);if(O===void 0)throw new Error("Task is not valid");if(p.is(O.execution))await this.addCustomExecution(O,J,!1);else throw new u.NotSupportedError;const N=await this.getTaskExecution(await this._proxy.$getTaskExecution(O),J);return this._proxy.$executeTask(O).catch(U=>{throw new Error(U)}),N}provideTasksInternal(B,J,O,N){const U=[];if(N)for(let L of N){this.checkDeprecation(L,O),(!L.definition||!B[L.definition.type])&&this._logService.warn(`The task [${L.source}, ${L.name}] uses an undefined task type. The task will be ignored in the future.`);const M=h.from(L,O.extension);M&&p.is(M.execution)?(U.push(M),J.push(this.addCustomExecution(M,L,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:U,extension:O.extension}}async resolveTaskInternal(B){if(p.is(B.execution))return B;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(B,J){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(B,J,O){}};j=Ve([xe(0,w.IExtHostRpcService),xe(1,f.IExtHostInitDataService),xe(2,P.IExtHostWorkspace),xe(3,y.IExtHostDocumentsAndEditors),xe(4,i.IExtHostConfiguration),xe(5,k.IExtHostTerminalService),xe(6,g.ILogService),xe(7,b.IExtHostApiDeprecationService)],j),e.WorkerExtHostTask=j,e.IExtHostTask=(0,l.createDecorator)("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(Z,e,_){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,_),_},$e=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)},mn=this&&this.__rest||function(Z,e){var _={};for(var D in Z)Object.prototype.hasOwnProperty.call(Z,D)&&e.indexOf(D)<0&&(_[D]=Z[D]);if(Z!=null&&typeof Object.getOwnPropertySymbols=="function")for(var R=0,D=Object.getOwnPropertySymbols(Z);R<D.length;R++)e.indexOf(D[R])<0&&Object.prototype.propertyIsEnumerable.call(Z,D[R])&&(_[D[R]]=Z[D[R]]);return _};define(me[257],pe([0,1,14,19,21,3,70,6,24,15,2,28,5,39,13,20,8,32,220,210]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l,m,S,g,b,d){"use strict";var u,a;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.ExtHostTesting=void 0;const t=(v,A)=>`${v}:${A.toString()}`;let r=class{constructor(A,F,x){this.documents=F,this.workspace=x,this.resultsChangedEmitter=new I.Emitter,this.providers=new Map,this.ownedTests=new b.OwnedTestCollection,this.testSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=A.getProxy(w.MainContext.MainThreadTesting),this.workspaceObservers=new E(this.proxy),this.textDocumentObservers=new h(this.proxy,F)}registerTestProvider(A){const F=(0,k.generateUuid)();this.providers.set(F,A),this.proxy.$registerTestProvider(F);const x=[...this.testSubscriptions.keys()];return setTimeout(()=>{var j;for(const G of x)(j=this.testSubscriptions.get(G))===null||j===void 0||j.subscribeFn(F,A)},0),new S.Disposable(()=>{this.providers.delete(F),this.proxy.$unregisterTestProvider(F)})}createTextDocumentTestObserver(A){return this.textDocumentObservers.checkout(A.uri)}createWorkspaceTestObserver(A){return this.workspaceObservers.checkout(A.uri)}async runTests(A,F=R.CancellationToken.None){const x=j=>j.map(this.getInternalTestForReference,this).filter(i.isDefined).map(G=>({providerId:G.providerId,testId:G.item.extId}));await this.proxy.$runTests({exclude:A.exclude?x(A.exclude).map(j=>j.testId):void 0,tests:x(A.tests),debug:A.debug},F)}publishExtensionProvidedResults(A,F){this.proxy.$publishExtensionProvidedResults(m.TestResults.from((0,k.generateUuid)(),A),F)}$publishTestResults(A){this.results=Object.freeze(A.map(F=>(0,y.deepFreeze)(m.TestResults.to(F))).concat(this.results).sort((F,x)=>x.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(A,F){const x=T.URI.revive(F),j=t(A,x);if(!this.testSubscriptions.has(j)){const G=new R.CancellationTokenSource;let B;if(A===1){let U=this.documents.getDocument(x);if(!U){const L=new P.DisposableStore;U=await new Promise(M=>{L.add((0,D.disposableTimeout)(()=>M(void 0),5e3)),L.add(this.documents.onDidAddDocuments(V=>{const K=V.find(se=>se.document.uri.toString()===x.toString());K&&M(K)}))}).finally(()=>L.dispose())}if(U){const L=await this.workspace.getWorkspaceFolder2(x,!1);B=M=>M.provideDocumentTestHierarchy?M.provideDocumentTestHierarchy(U.document,G.token):this.createDefaultDocumentTestHierarchy(M,U.document,L,G.token)}}else{const U=await this.workspace.getWorkspaceFolder2(x,!1);U&&(B=L=>L.provideWorkspaceTestHierarchy(U,G.token))}if(!!B){const J=async(U,L)=>{var M;try{N.pushDiff([3,1]);const V=await B(L);if(!V){N.pushDiff([3,-1]);return}N.addRoot(V.root,U),Promise.resolve(V.discoveredInitialTests).then(()=>N.pushDiff([3,-1])),V.onDidChangeTest(K=>N.onItemChange(K,U)),(M=V.onDidInvalidateTest)===null||M===void 0||M.call(V,K=>{const se=N.getTestByReference(K);se?this.proxy.$retireTest(se.item.extId):console.warn("Received a TestProvider.onDidInvalidateTest for a test that does not currently exist.")})}catch(V){console.error(V)}},O=new P.DisposableStore,N=O.add(this.ownedTests.createForHierarchy(U=>this.proxy.$publishDiff(A,F,U)));O.add((0,P.toDisposable)(()=>G.dispose(!0)));for(const[U,L]of this.providers)J(U,L);N.pushDiff([4,-1]),this.testSubscriptions.set(j,{store:O,collection:N,subscribeFn:J})}}}$unsubscribeFromTests(A,F){var x;const j=T.URI.revive(F),G=t(A,j);(x=this.testSubscriptions.get(G))===null||x===void 0||x.store.dispose(),this.testSubscriptions.delete(G)}$acceptDiff(A,F,x){A===1?this.textDocumentObservers.acceptDiff(T.URI.revive(F),x):this.workspaceObservers.acceptDiff(T.URI.revive(F),x)}async $runTestsForProvider(A,F){const x=this.providers.get(A.providerId);if(!!x){const j=A.ids.map(B=>{var J;return(J=this.ownedTests.getTestById(B))===null||J===void 0?void 0:J[1]}).filter(i.isDefined),G=A.excludeExtIds.map(B=>this.ownedTests.getTestById(B)).filter(i.isDefined).filter(([B,J])=>j.some(O=>B.comparePositions(O,J)===1));if(!!j.length)try{await x.runTests({setState:(B,J)=>{for(const[O,N]of G){const U=O.comparePositions(N,B.id);if(U===1||U===3)return}this.flushCollectionDiffs(),this.proxy.$updateTestStateInRun(A.runId,B.id,m.TestState.from(J))},tests:j.map(B=>s.unwrap(B.actual)),exclude:G.map(([,B])=>s.unwrap(B.actual)),debug:A.debug},F);for(const{collection:B}of this.testSubscriptions.values())B.flushDiff();return}catch(B){throw console.error(B),B}}}$lookupTest(A){const F=this.ownedTests.getTestById(A.testId);if(!F)return Promise.resolve(void 0);const x=F[1],{actual:j,previousChildren:G,previousEquals:B}=x,J=mn(x,["actual","previousChildren","previousEquals"]);return Promise.resolve(J)}flushCollectionDiffs(){for(const{collection:A}of this.testSubscriptions.values())A.flushDiff()}getInternalTestForReference(A){var F,x;return(x=(F=this.workspaceObservers.getMirroredTestDataByReference(A))!==null&&F!==void 0?F:(0,_.mapFind)(this.testSubscriptions.values(),j=>j.collection.getTestByReference(A)))!==null&&x!==void 0?x:this.textDocumentObservers.getMirroredTestDataByReference(A)}async createDefaultDocumentTestHierarchy(A,F,x,j){var G;if(!!x){const B=await A.provideWorkspaceTestHierarchy(x,j);if(!!B){const J=new I.Emitter;(G=B.onDidInvalidateTest)===null||G===void 0||G.call(B,N=>{const U=s.getWrapperForTestItem(N,F);U.hasNodeMatchingFilter&&J.fire(U)});const O=new I.Emitter;return B.onDidChangeTest(N=>{const U=s.getWrapperForTestItem(N,F);if(U.hasNodeMatchingFilter){if(U.reset(),U.hasNodeMatchingFilter){O.fire(U);return}O.fire(U.visibleParent);return}const M=U.visibleParent;U.reset(),!!U.hasNodeMatchingFilter&&(M.reset(),O.fire(M))}),j.onCancellationRequested(()=>{s.removeFilter(F),O.dispose()}),{root:s.getWrapperForTestItem(B.root,F),discoveredInitialTests:B.discoveredInitialTests,onDidInvalidateTest:J.event,onDidChangeTest:O.event}}}}};r=Ve([xe(0,l.IExtHostRpcService),xe(1,f.IExtHostDocumentsAndEditors),xe(2,g.IExtHostWorkspace)],r),e.ExtHostTesting=r;class s{constructor(A,F,x){this.actual=A,this.filterDocument=F,this.parent=x,this.getWrappedChildren()}static removeFilter(A){this.wrapperMap.delete(A)}static getWrapperForTestItem(A,F,x){let j=this.wrapperMap.get(F);if(j==null?void 0:j.has(A))return j.get(A);j||(j=new WeakMap,this.wrapperMap.set(F,j));const G=new s(A,F,x);return j.set(A,G),G}static unwrap(A){return A instanceof s?A.actual:A}get id(){return this.actual.id}get label(){return this.actual.label}get debuggable(){return this.actual.debuggable}get description(){return this.actual.description}get location(){return this.actual.location}get runnable(){return this.actual.runnable}get children(){return this.getWrappedChildren().filter(A=>A.hasNodeMatchingFilter)}get visibleParent(){return this.hasNodeMatchingFilter?this:this.parent.visibleParent}get hasNodeMatchingFilter(){var A;return this.matchesFilter===void 0&&(this.matchesFilter=!this.parent||((A=this.actual.location)===null||A===void 0?void 0:A.uri.toString())===this.filterDocument.uri.toString()||this.getWrappedChildren().some(F=>F.hasNodeMatchingFilter)),this.matchesFilter}reset(){var A;this!==this.visibleParent&&((A=this.parent)===null||A===void 0||A.reset()),this.matchesFilter=void 0}getWrappedChildren(){var A;return((A=this.actual.children)===null||A===void 0?void 0:A.map(F=>s.getWrapperForTestItem(F,this.filterDocument,this)))||[]}}e.TestItemFilteredWrapper=s,s.wrapperMap=new WeakMap;class o extends d.IncrementalChangeCollector{constructor(A,F){super();this.collection=A,this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(A){this.added.add(A)}update(A){Object.assign(A.revived,m.TestItem.toPlainShallow(A.item)),this.added.has(A)||this.updated.add(A)}remove(A){if(this.added.has(A)){this.added.delete(A);return}if(this.updated.delete(A),A.parent&&this.alreadyRemoved.has(A.parent)){this.alreadyRemoved.add(A.item.extId);return}this.removed.add(A)}getChangeEvent(){const{collection:A,added:F,updated:x,removed:j}=this;return{get added(){return[...F].map(A.getPublicTestItem,A)},get updated(){return[...x].map(A.getPublicTestItem,A)},get removed(){return[...j].map(A.getPublicTestItem,A)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class n extends d.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new I.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(A){let F=[];for(const x of A){const j=this.items.get(x);j&&F.push(this.getPublicTestItem(j))}return F}getMirroredTestDataById(A){return this.items.get(A)}getMirroredTestDataByReference(A){return this.items.get(A.id)}createItem(A,F){return Object.assign(Object.assign({},A),{revived:m.TestItem.toPlainShallow(A.item),depth:F?F.depth+1:0,children:new Set})}createChangeCollector(){return new o(this,this.changeEmitter)}getPublicTestItem(A){return A.wrapped||(A.wrapped=new c(A,this)),A.wrapped}}e.MirroredTestCollection=n;class c{constructor(A,F){u.set(this,void 0),a.set(this,void 0),tt(this,u,A),tt(this,a,F)}get id(){return $e(this,u).revived.id}get label(){return $e(this,u).revived.label}get description(){return $e(this,u).revived.description}get location(){return $e(this,u).revived.location}get runnable(){var A;return(A=$e(this,u).revived.runnable)!==null&&A!==void 0?A:!0}get debuggable(){var A;return(A=$e(this,u).revived.debuggable)!==null&&A!==void 0?A:!1}get children(){return $e(this,a).getAllAsTestItem($e(this,u).children)}toJSON(){return{id:this.id,label:this.label,description:this.description,location:this.location,runnable:this.runnable,debuggable:this.debuggable,children:this.children.map(F=>F.toJSON()),providerId:$e(this,u).providerId,testId:this.id}}}u=new WeakMap,a=new WeakMap;class p{constructor(){this.resources=new Map}checkout(A){var F,x;const j=A.toString(),G=(F=this.resources.get(j))!==null&&F!==void 0?F:this.createObserverData(A);return(x=G.pendingDeletion)===null||x===void 0||x.dispose(),G.observers++,{onDidChangeTest:G.tests.onDidChangeTests,onDidDiscoverInitialTests:new I.Emitter().event,get tests(){return G.tests.rootTestItems},dispose:(0,C.once)(()=>{--G.observers||(G.pendingDeletion=this.eventuallyDispose(A))})}}getMirroredTestDataByReference(A){for(const{tests:F}of this.resources.values()){const x=F.getMirroredTestDataByReference(A);if(x)return x}}eventuallyDispose(A){return(0,D.disposableTimeout)(()=>this.unlisten(A),10*1e3)}createObserverData(A){const F=new n,x=this.listen(A,G=>F.apply(G)),j={observers:0,tests:F,listener:x};return this.resources.set(A.toString(),j),j}unlisten(A){var F;const x=A.toString(),j=this.resources.get(x);j&&(j.observers=-1,(F=j.pendingDeletion)===null||F===void 0||F.dispose(),j.listener.dispose(),this.resources.delete(x))}}class E extends p{constructor(A){super();this.proxy=A,this.diffListeners=new Map}acceptDiff(A,F){var x;(x=this.diffListeners.get(A.toString()))===null||x===void 0||x(F)}listen(A,F){this.proxy.$subscribeToDiffs(0,A);const x=A.toString();return this.diffListeners.set(x,F),new S.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,A),this.diffListeners.delete(x)})}}class h extends p{constructor(A,F){super();this.proxy=A,this.documents=F,this.diffListeners=new Map}acceptDiff(A,F){var x;(x=this.diffListeners.get(A.toString()))===null||x===void 0||x(F)}listen(A,F){if(!this.documents.getDocument(A))return new S.Disposable(()=>{});const j=A.toString();return this.diffListeners.set(j,F),this.proxy.$subscribeToDiffs(1,A),new S.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,A),this.diffListeners.delete(j)})}}}),define(me[258],pe([0,1,14,54,33,77,22,11,7,23,9,15,2,138,170,84,61,212,256,31]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l,m,S,g,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(E,h,v,A){this.configurationService=E,this.workspaceContextService=h,this.editorGroupsService=v,this.pathService=A}text(E,h,v={}){E=this.getContentPattern(E,v);const A=this.configurationService.getValue(),F=h&&h.some(j=>!this.configurationService.getValue({resource:j}).search.useRipgrep),x=this.commonQuery(h==null?void 0:h.map(S.toWorkspaceFolder),v);return Object.assign(Object.assign({},x),{type:2,contentPattern:E,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:A.search.usePCRE2||F||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles})}getContentPattern(E,h){const v=this.configurationService.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const A=Object.assign(Object.assign({},E),{wordSeparators:v.editor.wordSeparators});return this.isCaseSensitive(E,h)&&(A.isCaseSensitive=!0),this.isMultiline(E)&&(A.isMultiline=!0),A}file(E,h={}){const v=this.commonQuery(E,h);return Object.assign(Object.assign({},v),{type:1,filePattern:h.filePattern?h.filePattern.trim():h.filePattern,exists:h.exists,sortByScore:h.sortByScore,cacheKey:h.cacheKey})}handleIncludeExclude(E,h){return E?(E=Array.isArray(E)?E.map(o):o(E),h?this.parseSearchPaths(E):{pattern:t(...Array.isArray(E)?E:[E])}):{}}commonQuery(E=[],h={}){const v=this.handleIncludeExclude(h.includePattern,h.expandPatterns),A=this.handleIncludeExclude(h.excludePattern,h.expandPatterns),F=E.length>1,x=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(B=>this.getFolderQueryForSearchPath(B,h,A)):E.map(B=>this.getFolderQueryForRoot(B,h,A,F))).filter(B=>!!B),j={_reason:h._reason,folderQueries:x,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:h.extraFileResources,excludePattern:A.pattern,includePattern:v.pattern,onlyOpenEditors:h.onlyOpenEditors,maxResults:h.maxResults};if(h.onlyOpenEditors){const J=_.coalesce(_.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(U=>U.resource)))).filter(N=>(0,d.pathIncludedInQuery)(j,N.fsPath)),O=this.commonQueryFromFileList(J);return Object.assign(Object.assign({},j),O)}const G=h.extraFileResources&&h.extraFileResources.filter(B=>(0,d.pathIncludedInQuery)(j,B.fsPath));return j.extraFileResources=G&&G.length?G:void 0,j}commonQueryFromFileList(E){const h=[],v=new C.ResourceMap,A={};let F=!1;return E.forEach(x=>{var j,G;if(x.scheme!==P.Schemas.walkThrough)if((0,i.isAbsolutePath)(x)){const J=(G=(j=this.workspaceContextService.getWorkspaceFolder(x))===null||j===void 0?void 0:j.uri)!==null&&G!==void 0?G:x.with({path:y.dirname(x.fsPath)});let O=v.get(J);O||(F=!0,O={folder:J,includePattern:{}},h.push(O),v.set(J,O));const N=y.relative(J.fsPath,x.fsPath);(0,k.assertIsDefined)(O.includePattern)[N.replace(/\\/g,"/")]=!0}else x.fsPath&&(F=!0,A[x.fsPath]=!0)}),{folderQueries:h,includePattern:A,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(E,h){if(h.isSmartCase){if(E.isRegExp){if(T.containsUppercaseCharacter(E.pattern,!0))return!0}else if(T.containsUppercaseCharacter(E.pattern))return!0}return!!E.isCaseSensitive}isMultiline(E){return E.isMultiline||E.isRegExp&&(0,f.isMultilineRegexSource)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const h=O=>y.isAbsolute(O)||/^\.\.?([\/\\]|$)/.test(O),A=(Array.isArray(E)?E:r(E)).map(O=>{const N=this.pathService.resolvedUserHome;return N?(0,I.untildify)(O,N.scheme===P.Schemas.file?N.fsPath:N.path):O}),F=D.groupBy(A,O=>h(O)?"searchPaths":"exprSegments"),x=(F.exprSegments||[]).map(O=>T.rtrim(O,"/")).map(O=>T.rtrim(O,"\\")).map(O=>(O[0]==="."&&(O="*"+O),s(O))),j={},G=this.expandSearchPathPatterns(F.searchPaths||[]);G&&G.length&&(j.searchPaths=G);const B=_.flatten(x),J=t(...B);return J&&(j.pattern=J),j}getExcludesForFolder(E,h){return h.disregardExcludeSettings?void 0:(0,d.getExcludes)(E,!h.disregardSearchExcludeSettings)}expandSearchPathPatterns(E){if(!E||!E.length)return[];const h=_.flatten(E.map(A=>{let{pathPortion:F,globPortion:x}=a(A);x&&(x=n(x));const j=this.expandOneSearchPath(F);return _.flatten(j.map(G=>this.resolveOneSearchPathPattern(G,x)))})),v=new Map;return h.forEach(A=>{const F=A.searchPath.toString(),x=v.get(F);x?A.pattern&&(x.pattern=x.pattern||{},x.pattern[A.pattern]=!0):v.set(F,{searchPath:A.searchPath,pattern:A.pattern?t(A.pattern):void 0})}),Array.from(v.values())}expandOneSearchPath(E){if(y.isAbsolute(E)){const h=this.workspaceContextService.getWorkspace().folders;return h[0]&&h[0].uri.scheme!==P.Schemas.file?[{searchPath:h[0].uri.with({path:E})}]:[{searchPath:w.URI.file(y.normalize(E))}]}if(this.workspaceContextService.getWorkbenchState()===2){const h=this.workspaceContextService.getWorkspace().folders[0].uri;if(E=o(E),E.startsWith("../")||E===".."){const A=y.posix.resolve(h.path,E);return[{searchPath:h.with({path:A})}]}const v=n(E);return[{searchPath:h,pattern:v}]}else{if(E==="./"||E===".\\")return[];{const h=E.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(h){const v=h[1],A=this.workspaceContextService.getWorkspace().folders.filter(F=>F.name===v);if(A.length)return A.map(F=>{const x=h[2];return{searchPath:F.uri,pattern:x&&n(x)}});{const F=l.localize(0,null,v);throw new Error(F)}}}}return[]}resolveOneSearchPathPattern(E,h){const v=E.pattern&&h?`${E.pattern}/${h}`:E.pattern||h,A=[{searchPath:E.searchPath,pattern:v}];return v&&!v.endsWith("**")&&A.push({searchPath:E.searchPath,pattern:v+"/**"}),A}getFolderQueryForSearchPath(E,h,v){const A=this.getFolderQueryForRoot((0,S.toWorkspaceFolder)(E.searchPath),h,v,!1);return A?Object.assign(Object.assign({},A),{includePattern:E.pattern}):null}getFolderQueryForRoot(E,h,v,A){let F;const x=w.URI.isUri(E)?E:E.uri;if(v.searchPaths){const O=v.searchPaths.filter(N=>(0,i.isEqual)(N.searchPath,x))[0];if(O&&!O.pattern)return null;O&&(F=O.pattern)}const j=this.configurationService.getValue({resource:x}),G=this.getExcludesForFolder(j,h),B=Object.assign(Object.assign({},G||{}),F||{}),J=w.URI.isUri(E)?(0,i.basename)(E):E.name;return{folder:x,folderName:A?J:void 0,excludePattern:Object.keys(B).length>0?B:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof h.disregardIgnoreFiles=="boolean"?h.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof h.disregardGlobalIgnoreFiles=="boolean"?h.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof h.ignoreSymlinks=="boolean"?h.ignoreSymlinks:!j.search.followSymlinks}}};u=Ve([xe(0,m.IConfigurationService),xe(1,S.IWorkspaceContextService),xe(2,g.IEditorGroupsService),xe(3,b.IPathService)],u),e.QueryBuilder=u;function a(p){const E=p.match(/[\*\{\}\(\)\[\]\?]/);if(E){const h=E.index,v=p.substr(0,h).match(/[/|\\][^/\\]*$/);if(v){let A=p.substr(0,v.index);return A.match(/[/\\]/)||(A+="/"),{pathPortion:A,globPortion:p.substr((v.index||0)+1)}}}return{pathPortion:p}}function t(...p){return p.length?p.reduce((E,h)=>(E[h]=!0,E),Object.create(null)):void 0}function r(p){return R.splitGlobAware(p,",").map(E=>E.trim()).filter(E=>!!E.length)}function s(p){return[`**/${p}/**`,`**/${p}`].map(h=>h.replace(/\*\*\/\*\*/g,"**"))}function o(p){return p.replace(/\\/g,"/")}function n(p){return o(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(p,E){p=_.distinct(p,A=>A.toString());const h=[],v=E.getWorkspace();return p&&p.forEach(A=>{let F;if(E.getWorkbenchState()===2)F=(0,i.relativePath)(v.folders[0].uri,A),F&&F!=="."&&(F="./"+F);else{const x=E.getWorkspaceFolder(A);if(x){const j=x.name;if(v.folders.filter(B=>B.name===j).length===1){const B=(0,i.relativePath)(x.uri,A);B===""?F=`./${x.name}`:F=`./${x.name}/${B}`}else F=A.fsPath}}F&&h.push(F)}),h}e.resolveResourcesForSearchIncludes=c}),define(me[259],pe([0,1,23,2,21,18,4,258,31,61]),function(Z,e,_,D,R,I,C,P,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const T=7e3;function k(m,S){const g=S.activationEvents;if(!g)return Promise.resolve(void 0);const b=[],d=[];for(const o of g)if(/^workspaceContains:/.test(o)){const n=o.substr("workspaceContains:".length);n.indexOf("*")>=0||n.indexOf("?")>=0||m.forceUsingSearch?d.push(n):b.push(n)}if(b.length===0&&d.length===0)return Promise.resolve(void 0);let u;const a=new Promise((o,n)=>{u=o}),t=o=>u({activationEvent:o}),r=Promise.all(b.map(o=>w(m,o,t))).then(()=>{}),s=f(m,S.identifier,d,t);return Promise.all([r,s]).then(()=>{u(void 0)}),a}e.checkActivateWorkspaceContainsExtension=k;async function w(m,S,g){for(const b of m.folders)if(await m.exists(_.joinPath(D.URI.revive(b),S))){g(`workspaceContains:${S}`);return}}async function f(m,S,g,b){if(g.length===0)return Promise.resolve(void 0);const d=new R.CancellationTokenSource,u=m.checkExists(m.folders,g,d.token),a=setTimeout(async()=>{d.cancel(),b(`workspaceContainsTimeout:${g.join(",")}`)},T);let t=!1;try{t=await u}catch(r){I.isPromiseCanceledError(r)||I.onUnexpectedError(r)}d.dispose(),clearTimeout(a),t&&b(`workspaceContains:${g.join(",")}`)}function l(m,S,g,b){const d=m.get(C.IInstantiationService),u=m.get(y.ISearchService),t=d.createInstance(P.QueryBuilder).file(S.map(r=>(0,i.toWorkspaceFolder)(D.URI.revive(r))),{_reason:"checkExists",includePattern:g,exists:!0});return u.fileSearch(t,b).then(r=>!!r.limitHit,r=>I.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=l}),define(me[42],pe([0,1,159,7,68,23,19,6,22,2,12,5,36,223,88,32,41,221,18,29,11,26,193,8,112,4,27,89,13,82,50,35,3,259,86,194]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l,m,S,g,b,d,u,a,t,r,s,o,n,c,p,E,h,v,A,F,x,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let G=class Ln extends P.Disposable{constructor(O,N,U,L,M,V,K,se,ce,we){super();this._onDidChangeRemoteConnectionData=this._register(new A.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=N,this._extHostContext=U,this._initData=K,this._extHostWorkspace=L,this._extHostConfiguration=M,this._logService=V,this._extHostTunnelService=ce,this._extHostTerminalService=we,this._disposables=new P.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new C.Barrier,this._readyToStartExtensionHost=new C.Barrier,this._readyToRunExtensions=new C.Barrier,this._registry=new g.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new l.ExtHostStorage(this._extHostContext),this._secretState=new x.ExtHostSecretState(this._extHostContext),this._storagePath=se,this._instaService=O.createChild(new E.ServiceCollection([l.IExtHostStorage,this._storage],[x.IExtHostSecretState,this._secretState]));const Te=new Set;this._initData.hostExtensions.forEach(Ie=>Te.add(d.ExtensionIdentifier.toKey(Ie))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ie,Me)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ie,Me)},actualActivateExtension:async(Ie,Me)=>{if(Te.has(d.ExtensionIdentifier.toKey(Ie)))return await this._mainThreadExtensionsProxy.$activateExtension(Ie,Me),new f.HostExtension;const H=this._registry.getExtensionDescription(Ie);return this._activateExtension(H,Me)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),R.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){b.onUnexpectedError(O)}}async deactivateAll(){let O=[];try{O=this._registry.getAllExtensionDescriptions().map(M=>M.identifier).filter(M=>this.isActivated(M)).map(M=>this._deactivate(M))}catch(N){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,N){return this._activator.activateByEvent(O,N)}_activateById(O,N){return this._activator.activateById(O,N)}activateByIdWithErrors(O,N){return this._activateById(O,N).then(()=>{const U=this._activator.getActivatedExtension(O);if(U.activationFailed)return Promise.reject(U.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const O=y.TernarySearchTree.forPaths(),N=this._registry.getAllExtensionDescriptions().map(U=>{if(!!this._getEntryPoint(U))return this._hostUtils.realpath(U.extensionLocation.fsPath).then(L=>O.set(i.URI.file(L).fsPath,U))});this._extensionPathIndex=Promise.all(N).then(()=>O)}return this._extensionPathIndex}_deactivate(O){let N=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return N;const U=this._activator.getActivatedExtension(O);if(!U)return N;try{typeof U.module.deactivate=="function"&&(N=Promise.resolve(U.module.deactivate()).then(void 0,L=>Promise.resolve(void 0)))}catch(L){}try{(0,P.dispose)(U.subscriptions)}catch(L){}return N}async _activateExtension(O,N){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,N).then(U=>{const L=U.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,L.codeLoadingTime,L.activateCallTime,L.activateResolvedTime,N),this._logExtensionActivationTimes(O,N,"success",L),U},U=>{throw this._logExtensionActivationTimes(O,N,"failure"),U})}_logExtensionActivationTimes(O,N,U,L){const M=B(O,N);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},M),L||{}),{outcome:U}))}_doActivateExtension(O,N){const U=B(O,N);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",U);const L=this._getEntryPoint(O);if(!L)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value} ${JSON.stringify(N)}`),this._logService.flush();const M=new f.ExtensionActivationTimesBuilder(N.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,I.joinPath)(O.extensionLocation,L),M),this._loadExtensionContext(O)]).then(V=>(R.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),Ln._callActivate(this._logService,O.identifier,V[0],V[1],M))).then(V=>(R.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),V))}_loadExtensionContext(O){const N=new t.ExtensionGlobalMemento(O,this._storage),U=new t.ExtensionMemento(O.identifier.value,!1,this._storage),L=new j.ExtensionSecrets(O,this._secretState),M=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,V=Date.now()-new Date(this._initData.telemetryInfo.firstSessionDate).getTime();return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([N.whenReady,U.whenReady,this._storagePath.whenReady]).then(()=>{const K=this;return Object.freeze({globalState:N,workspaceState:U,secrets:L,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(se){return D.join(O.extensionLocation.fsPath,se)},get storagePath(){var se;return(se=K._storagePath.workspaceValue(O))===null||se===void 0?void 0:se.fsPath},get globalStoragePath(){return K._storagePath.globalValue(O).fsPath},get logPath(){return D.join(K._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return i.URI.joinPath(K._initData.logsLocation,O.identifier.value)},get storageUri(){return K._storagePath.workspaceValue(O)},get globalStorageUri(){return K._storagePath.globalValue(O)},get extensionMode(){return M},get extensionId(){return(0,S.checkProposedApiEnabled)(O),O.identifier.value},get extensionVersion(){return(0,S.checkProposedApiEnabled)(O),O.version},get extensionRuntime(){return(0,S.checkProposedApiEnabled)(O),K.extensionRuntime},get isNewInstall(){return(0,S.checkProposedApiEnabled)(O),isNaN(V)?!1:V<1e3*60*60*24},get environmentVariableCollection(){return K._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,N,U,L,M){return U=U||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,N,U,L,M).then(V=>new f.ActivatedExtension(!1,null,M.build(),U,V,L.subscriptions))}static _callActivateOptional(O,N,U,L,M){if(typeof U.activate=="function")try{M.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${N.value}`);const V=typeof global=="object"?global:self,K=U.activate.apply(V,[L]);return M.activateCallStop(),M.activateResolveStart(),Promise.resolve(K).then(se=>(M.activateResolveStop(),se))}catch(V){return Promise.reject(V)}else return Promise.resolve(U)}_activateOneStartupFinished(O,N){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:N}).then(void 0,U=>{this._logService.error(U)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(R.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const N of O.activationEvents)N==="onStartupFinished"&&this._activateOneStartupFinished(O,N)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,M=>{this._logService.error(M)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(M=>this._handleWorkspaceContainsEagerExtensions(M.added)));const N=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],U=this._handleWorkspaceContainsEagerExtensions(N),L=Promise.all([O,U]).then(()=>{});return Promise.race([L,(0,C.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),L}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(N=>this._handleWorkspaceContainsEagerExtension(O,N))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,N){if(!this.isActivated(N.identifier)){const U=!this._initData.remote.isRemote&&!!this._initData.remote.authority,L={folders:O.map(V=>V.uri),forceUsingSearch:U,exists:V=>this._hostUtils.exists(V.fsPath),checkExists:(V,K,se)=>this._mainThreadWorkspaceProxy.$checkExists(V,K,se)},M=await(0,F.checkActivateWorkspaceContainsExtension)(L,N);if(!!M)return this._activateById(N.identifier,{startup:!0,extensionId:N.identifier,activationEvent:M.activationEvent}).then(void 0,V=>this._logService.error(V))}}_handleExtensionTests(){return this._doHandleExtensionTests().then(void 0,O=>(console.error(O),Promise.reject(O)))}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:N}=this._initData.environment;if(!(O&&N&&N.scheme===u.Schemas.file))return Promise.resolve(void 0);const U=(0,I.originalFSPath)(N);let L,M;try{L=await this._loadCommonJSModule(null,i.URI.file(U),new f.ExtensionActivationTimesBuilder(!1))}catch(V){M=V}return L&&typeof L.run=="function"?new Promise((V,K)=>{const se=(we,Te)=>{we?K(we.toString()):V(void 0),this._testRunnerExit(we||typeof Te=="number"&&Te>0?1:0)},ce=L.run(U,se);ce&&ce.then&&ce.then(()=>{V(),this._testRunnerExit(0)}).catch(we=>{K(we.toString()),this._testRunnerExit(1)})}):(this._testRunnerExit(1),Promise.reject(new Error(M?M.toString():_.localize(0,null,U))))}_testRunnerExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.flush();const N=this._mainThreadExtensionsProxy.$onExtensionHostExit(O),U=this._extHostContext.drain();Promise.race([Promise.all([N,U]),(0,C.timeout)(5e3)]).then(()=>{this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>this._handleExtensionTests()).then(()=>{this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,N){return this._resolvers[O]=N,(0,P.toDisposable)(()=>{delete this._resolvers[O]})}async $resolveAuthority(O,N){const U=O.indexOf("+");if(U===-1)throw new Error("Not an authority that can be resolved!");const L=O.substr(0,U);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${L}`,!1);const M=this._resolvers[L];if(!M)return{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${L}.`,detail:void 0}};try{R.mark(`code/extHost/willResolveAuthority/${L}`);const V=await M.resolve(O,{resolveAttempt:N});R.mark(`code/extHost/didResolveAuthorityOK/${L}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(M));const K={authority:O,host:V.host,port:V.port,connectionToken:V.connectionToken},se={extensionHostEnv:V.extensionHostEnv};return{type:"ok",value:{authority:K,options:se,tunnelInformation:{environmentTunnels:V.environmentTunnels}}}}catch(V){if(R.mark(`code/extHost/didResolveAuthorityError/${L}`),V instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:V._code,message:V._message,detail:V._detail}};throw V}}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,N){return N===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(U=>this._activateByEvent(O,!1))}async $activate(O,N){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,N),!0):!1}async $deltaExtensions(O,N){O.forEach(L=>L.extensionLocation=i.URI.revive(L.extensionLocation));const U=await this.getExtensionPathIndex();return await Promise.all(N.map(async L=>{const M=this._registry.getExtensionDescription(L);if(!!M){const V=await this._hostUtils.realpath(M.extensionLocation.fsPath);U.delete(i.URI.file(V).fsPath)}})),await Promise.all(O.map(async L=>{const M=await this._hostUtils.realpath(L.extensionLocation.fsPath);U.set(i.URI.file(M).fsPath,L)})),this._registry.deltaExtensions(O,N),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let N=a.VSBuffer.alloc(O),U=Math.random()%256;for(let L=0;L<O;L++)N.writeUInt8(U,L);return N}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};G=Ve([xe(0,o.IInstantiationService),xe(1,e.IHostUtils),xe(2,p.IExtHostRpcService),xe(3,m.IExtHostWorkspace),xe(4,w.IExtHostConfiguration),xe(5,T.ILogService),xe(6,n.IExtHostInitDataService),xe(7,c.IExtensionStoragePaths),xe(8,h.IExtHostTunnelService),xe(9,v.IExtHostTerminalService)],G),e.AbstractExtHostExtensionService=G;function B(J,O){return{id:J.identifier.value,name:J.name,extensionVersion:J.version,publisherDisplayName:J.publisher,activationEvents:J.activationEvents?J.activationEvents.join(","):null,isBuiltin:J.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService")}),define(me[45],pe([0,1,7,2,3,19,5,8,117,32,42,39,211,36,198,13,4,15]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l,m,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let b=class{constructor(n,c,p,E,h){this._workspaceService=c,this._extensionService=p,this._editorsService=E,this._configurationService=h,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new R.Emitter,this._onDidTerminateDebugSession=new R.Emitter,this._onDidChangeActiveDebugSession=new R.Emitter,this._onDidReceiveDebugSessionCustomEvent=new R.Emitter,this._debugServiceProxy=n.getProxy(C.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new R.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new u(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(v=>{v.onDidChange(A=>{this.registerAllDebugTypes(v)}),this.registerAllDebugTypes(v)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(n,c){const p=n;if(typeof p.sourceReference=="number"&&p.sourceReference>0){let E=`debug:${encodeURIComponent(p.path||"")}`,h="?";return c&&(E+=`${h}session=${encodeURIComponent(c.id)}`,h="&"),E+=`${h}ref=${p.sourceReference}`,D.URI.parse(E)}else{if(p.path)return D.URI.file(p.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(n){const c=[];for(const p of n.getAllExtensionDescriptions())if(p.contributes){const E=p.contributes.debuggers;if(E&&E.length>0)for(const h of E)(0,l.isDebuggerMainContribution)(h)&&c.push(h.type)}this._debugServiceProxy.$registerDebugTypes(c)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const n=[];return this._breakpoints.forEach(c=>n.push(c)),n}addBreakpoints(n){this.startBreakpoints();const c=n.filter(h=>{const v=h.id;return this._breakpoints.has(v)?!1:(this._breakpoints.set(v,h),!0)});this.fireBreakpointChanges(c,[],[]);const p=[],E=new Map;for(const h of c)if(h instanceof P.SourceBreakpoint){let v=E.get(h.location.uri.toString());v||(v={type:"sourceMulti",uri:h.location.uri,lines:[]},E.set(h.location.uri.toString(),v),p.push(v)),v.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof P.FunctionBreakpoint&&p.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this._debugServiceProxy.$registerBreakpoints(p)}removeBreakpoints(n){this.startBreakpoints();const c=n.filter(v=>this._breakpoints.delete(v.id));this.fireBreakpointChanges([],c,[]);const p=c.filter(v=>v instanceof P.SourceBreakpoint).map(v=>v.id),E=c.filter(v=>v instanceof P.FunctionBreakpoint).map(v=>v.id),h=c.filter(v=>v instanceof P.DataBreakpoint).map(v=>v.id);return this._debugServiceProxy.$unregisterBreakpoints(p,E,h)}startDebugging(n,c,p){return this._debugServiceProxy.$startDebugging(n?n.uri:void 0,c,{parentSessionID:p.parentSession?p.parentSession.id:void 0,repl:p.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:p.noDebug,compact:p.compact})}stopDebugging(n){return this._debugServiceProxy.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,c,p){if(!c)return new P.Disposable(()=>{});const E=this._configProviderHandleCounter++;return this._configProviders.push({type:n,handle:E,provider:c}),this._debugServiceProxy.$registerDebugConfigurationProvider(n,p,!!c.provideDebugConfigurations,!!c.resolveDebugConfiguration,!!c.resolveDebugConfigurationWithSubstitutedVariables,E),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(h=>h.provider!==c),this._debugServiceProxy.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(n,c,p){if(!p)return new P.Disposable(()=>{});if(!this.definesDebugType(n,c))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${c}' debugger.`);if(this.getAdapterDescriptorFactoryByType(c))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:c,handle:E,factory:p}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(c,E),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(h=>h.factory!==p),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(n,c){if(!c)return new P.Disposable(()=>{});const p=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:n,handle:p,factory:c}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(E=>E.factory!==c)})}async $runInTerminal(n,c){return Promise.resolve(void 0)}async $substituteVariables(n,c){if(!this._variableResolver){const[h,v]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(h||[],this._editorsService,v)}let p;const E=await this.getFolder(n);return E&&(p={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAny(p,c)}createDebugAdapter(n,c){if(n.type==="implementation")return new r(n.implementation)}createSignService(){}async $startDASession(n,c){const p=this,E=await this.getSession(c);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(E.type),E).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const v=this.convertToDto(h),A=this.createDebugAdapter(v,E);if(!A)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const F=A;return this._debugAdapters.set(n,F),this.getDebugAdapterTrackers(E).then(x=>(x&&this._debugAdaptersTrackers.set(n,x),F.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const G=j,B={type:"response",seq:0,command:G.command,request_seq:G.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const J=await this._signService.sign(G.arguments.value);B.body={signature:J},F.sendResponse(B)}else throw new Error("no signer")}catch(J){B.success=!1,B.message=J.message,F.sendResponse(B)}}else x&&x.onDidSendMessage&&x.onDidSendMessage(j),j=(0,l.convertToVSCPaths)(j,!0),p._debugServiceProxy.$acceptDAMessage(n,j)}),F.onError(j=>{x&&x.onError&&x.onError(j),this._debugServiceProxy.$acceptDAError(n,j.name,j.message,j.stack)}),F.onExit(j=>{x&&x.onExit&&x.onExit((0,g.withNullAsUndefined)(j),void 0),this._debugServiceProxy.$acceptDAExit(n,(0,g.withNullAsUndefined)(j),void 0)}),x&&x.onWillStartSession&&x.onWillStartSession(),F.startSession()))})}$sendDAMessage(n,c){c=(0,l.convertToDAPaths)(c,!1);const p=this._debugAdaptersTrackers.get(n);p&&p.onWillReceiveMessage&&p.onWillReceiveMessage(c);const E=this._debugAdapters.get(n);E&&E.sendMessage(c)}$stopDASession(n){const c=this._debugAdaptersTrackers.get(n);this._debugAdaptersTrackers.delete(n),c&&c.onWillStopSession&&c.onWillStopSession();const p=this._debugAdapters.get(n);return this._debugAdapters.delete(n),p?p.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const c=[],p=[],E=[];if(n.added)for(const h of n.added){const v=h.id;if(v&&!this._breakpoints.has(v)){let A;if(h.type==="function")A=new P.FunctionBreakpoint(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")A=new P.DataBreakpoint(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const F=D.URI.revive(h.uri);A=new P.SourceBreakpoint(new P.Location(F,new P.Position(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}A._id=v,this._breakpoints.set(v,A),c.push(A)}}if(n.removed)for(const h of n.removed){const v=this._breakpoints.get(h);v&&(this._breakpoints.delete(h),p.push(v))}if(n.changed){for(const h of n.changed)if(h.id){const v=this._breakpoints.get(h.id);if(v){if(v instanceof P.FunctionBreakpoint&&h.type==="function"){const A=v;A.enabled=h.enabled,A.condition=h.condition,A.hitCondition=h.hitCondition,A.logMessage=h.logMessage,A.functionName=h.functionName}else if(v instanceof P.SourceBreakpoint&&h.type==="source"){const A=v;A.enabled=h.enabled,A.condition=h.condition,A.hitCondition=h.hitCondition,A.logMessage=h.logMessage,A.location=new P.Location(D.URI.revive(h.uri),new P.Position(h.line,h.character))}E.push(v)}}}this.fireBreakpointChanges(c,p,E)}$provideDebugConfigurations(n,c,p){return(0,I.asPromise)(async()=>{const E=this.getConfigProviderByHandle(n);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.getFolder(c);return E.provideDebugConfigurations(h,p)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(n,c,p,E){return(0,I.asPromise)(async()=>{const h=this.getConfigProviderByHandle(n);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const v=await this.getFolder(c);return h.resolveDebugConfiguration(v,p,E)})}$resolveDebugConfigurationWithSubstitutedVariables(n,c,p,E){return(0,I.asPromise)(async()=>{const h=this.getConfigProviderByHandle(n);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const v=await this.getFolder(c);return h.resolveDebugConfigurationWithSubstitutedVariables(v,p,E)})}async $provideDebugAdapter(n,c){const p=this.getAdapterDescriptorFactoryByHandle(n);if(!p)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.getSession(c);return this.getAdapterDescriptor(p,E).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.convertToDto(h)})}async $acceptDebugSessionStarted(n){const c=await this.getSession(n);this._onDidStartDebugSession.fire(c)}async $acceptDebugSessionTerminated(n){const c=await this.getSession(n);c&&(this._onDidTerminateDebugSession.fire(c),this._debugSessions.delete(c.id))}async $acceptDebugSessionActiveChanged(n){this._activeDebugSession=n?await this.getSession(n):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(n,c){const p=await this.getSession(n);p&&p._acceptNameChanged(c)}async $acceptDebugSessionCustomEvent(n,c){const E={session:await this.getSession(n),event:c.event,body:c.body};this._onDidReceiveDebugSessionCustomEvent.fire(E)}convertToDto(n){if(n instanceof P.DebugAdapterExecutable)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof P.DebugAdapterServer)return{type:"server",port:n.port,host:n.host};if(n instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:n.path};if(n instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(n){const c=this._adapterFactories.filter(p=>p.type===n);if(c.length>0)return c[0].factory}getAdapterDescriptorFactoryByHandle(n){const c=this._adapterFactories.filter(p=>p.handle===n);if(c.length>0)return c[0].factory}getConfigProviderByHandle(n){const c=this._configProviders.filter(p=>p.handle===n);if(c.length>0)return c[0].provider}definesDebugType(n,c){if(n.contributes){const p=n.contributes.debuggers;if(p&&p.length>0){for(const E of p)if(E.label&&E.type&&E.type===c)return!0}}return!1}getDebugAdapterTrackers(n){const p=n.configuration.type,E=this._trackerFactories.filter(h=>h.type===p||h.type==="*").map(h=>(0,I.asPromise)(()=>h.factory.createDebugAdapterTracker(n)).then(v=>v,v=>null));return Promise.race([Promise.all(E).then(h=>{const v=h.filter(A=>!!A);if(v.length>0)return new t(v)}),new Promise((h,v)=>{const A=setTimeout(()=>{clearTimeout(A),v(new Error("timeout"))},1e3)})]).catch(h=>{})}async getAdapterDescriptor(n,c){const p=c.configuration.debugServer;if(typeof p=="number")return Promise.resolve(new P.DebugAdapterServer(p));if(n){const h=await this._extensionService.getExtensionRegistry();return(0,I.asPromise)(()=>n.createDebugAdapterDescriptor(c,this.daExecutableFromPackage(c,h))).then(v=>{if(v)return v})}const E=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(c,E))}daExecutableFromPackage(n,c){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(n,c,p){(n.length>0||c.length>0||p.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:n,removed:c,changed:p}))}async getSession(n){if(n)if(typeof n=="string"){const c=this._debugSessions.get(n);if(c)return c}else{let c=this._debugSessions.get(n.id);if(!c){const p=await this.getFolder(n.folderUri);c=new d(this._debugServiceProxy,n.id,n.type,n.name,p,n.configuration),this._debugSessions.set(c.id,c),this._debugServiceProxy.$sessionCached(c.id)}return c}throw new Error("cannot find session")}getFolder(n){if(n){const c=D.URI.revive(n);return this._workspaceService.resolveWorkspaceFolder(c)}return Promise.resolve(void 0)}};b=Ve([xe(0,m.IExtHostRpcService),xe(1,i.IExtHostWorkspace),xe(2,T.IExtHostExtensionService),xe(3,k.IExtHostDocumentsAndEditors),xe(4,f.IExtHostConfiguration)],b),e.ExtHostDebugServiceBase=b;class d{constructor(n,c,p,E,h,v){this._debugServiceProxy=n,this._id=c,this._type=p,this._name=E,this._workspaceFolder=h,this._configuration=v}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(n){this._name=n,this._debugServiceProxy.$setDebugSessionName(this._id,n)}_acceptNameChanged(n){this._name=n}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(n,c){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,n,c)}getDebugProtocolBreakpoint(n){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,n.id)}}e.ExtHostDebugSession=d;class u{constructor(n){this.value=Object.freeze({append(c){n.$appendDebugConsole(c)},appendLine(c){this.append(c+`
`)}})}}e.ExtHostDebugConsole=u;class a extends w.AbstractVariableResolverService{constructor(n,c,p,E,h){super({getFolderUri:v=>{const A=n.filter(F=>F.name===v);if(A&&A.length>0)return A[0].uri},getWorkspaceFolderCount:()=>n.length,getConfigurationValue:(v,A)=>p.getConfiguration(void 0,v).get(A),getAppRoot:()=>E?E.VSCODE_CWD:void 0,getExecPath:()=>E?E.VSCODE_EXEC_PATH:void 0,getFilePath:()=>{if(c){const v=c.activeEditor();if(v)return _.normalize(v.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(c&&h){const v=c.activeEditor();if(v){const A=h.getWorkspaceFolder(v.document.uri);if(A)return _.normalize(A.uri.fsPath)}}},getSelectedText:()=>{if(c){const v=c.activeEditor();if(v&&!v.selection.isEmpty)return v.document.getText(v.selection)}},getLineNumber:()=>{if(c){const v=c.activeEditor();if(v)return String(v.selection.end.line+1)}}},void 0,E)}}e.ExtHostVariableResolverService=a;class t{constructor(n){this.trackers=n}onWillStartSession(){this.trackers.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.trackers.forEach(c=>c.onWillReceiveMessage?c.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.trackers.forEach(c=>c.onDidSendMessage?c.onDidSendMessage(n):void 0)}onWillStopSession(){this.trackers.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.trackers.forEach(c=>c.onError?c.onError(n):void 0)}onExit(n,c){this.trackers.forEach(p=>p.onExit?p.onExit(n,c):void 0)}}class r extends y.AbstractDebugAdapter{constructor(n){super();this.implementation=n,n.onDidSendMessage(c=>{this.acceptMessage(c)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.implementation.handleMessage(n)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let s=class extends b{constructor(n,c,p,E,h){super(n,c,p,E,h)}createVariableResolver(n,c,p){return new a(n,c,p)}};s=Ve([xe(0,m.IExtHostRpcService),xe(1,i.IExtHostWorkspace),xe(2,T.IExtHostExtensionService),xe(3,k.IExtHostDocumentsAndEditors),xe(4,f.IExtHostConfiguration)],s),e.WorkerExtHostDebugService=s}),define(me[260],pe([0,1,68,2,5,36,41,29,13,27,4,42,37,12]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let l=class{constructor(d,u,a,t,r,s,o){this._apiFactory=d,this._extensionRegistry=u,this._instaService=a,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=s,this._logService=o,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),_.mark("code/extHost/willWaitForConfig");const d=await this._extHostConfiguration.getConfigProvider();_.mark("code/extHost/didWaitForConfig");const u=await this._extHostExtensionService.getExtensionPathIndex();this.register(new m(this._apiFactory,u,this._extensionRegistry,d,this._logService)),this.register(this._instaService.createInstance(S)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(g,u,this._initData.environment.appUriScheme))}register(d){if(Array.isArray(d.nodeModuleName))for(let u of d.nodeModuleName)this._factories.set(u,d);else this._factories.set(d.nodeModuleName,d);typeof d.alternativeModuleName=="function"&&this._alternatives.push(u=>d.alternativeModuleName(u))}};l=Ve([xe(2,T.IInstantiationService),xe(3,I.IExtHostConfiguration),xe(4,k.IExtHostExtensionService),xe(5,i.IExtHostInitDataService),xe(6,f.ILogService)],l),e.RequireInterceptor=l;class m{constructor(d,u,a,t,r){this._apiFactory=d,this._extensionPaths=u,this._extensionRegistry=a,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(d,u){const a=this._extensionPaths.findSubstr(u.fsPath);if(a){let t=this._extApiImpl.get(P.ExtensionIdentifier.toKey(a.identifier));return t||(t=this._apiFactory(a,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(a.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,s)=>t+=`	${s} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${u.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(C.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let S=class{constructor(d,u){this.nodeModuleName="keytar";const{environment:a}=u,t=d.getProxy(R.MainContext.MainThreadKeytar);if(a.appRoot){let r=a.appRoot.fsPath;w.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,s)=>t.$getPassword(r,s),setPassword:(r,s,o)=>t.$setPassword(r,s,o),deletePassword:(r,s)=>t.$deletePassword(r,s),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(d,u){return this._impl}alternativeModuleName(d){const u=d.length;if(!(u<=7||!this.alternativeNames)){const a=u-7;if((d.charAt(a)==="/"||d.charAt(a)==="\\")&&d.endsWith("keytar")&&(d=d.replace(/\\/g,"/"),this.alternativeNames.has(d)))return"keytar"}}};S=Ve([xe(0,y.IExtHostRpcService),xe(1,i.IExtHostInitDataService)],S);let g=class{constructor(d,u,a){this._extensionPaths=d,this._appUriScheme=u,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=a.getProxy(R.MainContext.MainThreadTelemetry);const t=a.getProxy(R.MainContext.MainThreadWindow);this._impl=(r,s)=>{const o=D.URI.parse(r);return s?this.callOriginal(r,s):o.scheme==="http"||o.scheme==="https"?t.$openUri(o,r,{allowTunneling:!0}):o.scheme==="mailto"||o.scheme===this._appUriScheme?t.$openUri(o,r,{}):this.callOriginal(r,s)}}load(d,u,a){const t=this._extensionPaths.findSubstr(u.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=a(d),this._impl}callOriginal(d,u){return this.sendNoForwardTelemetry(),this._original(d,u)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};g=Ve([xe(2,y.IExtHostRpcService)],g)}),define(me[261],pe([0,1,165,8,199,32,42,39,36,35,13,45,186,202,19]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let m=class extends k.ExtHostDebugServiceBase{constructor(b,d,u,a,t,r){super(b,d,u,a,t);this._terminalService=r,this._integratedTerminalInstances=new S}createDebugAdapter(b,d){switch(b.type){case"server":return new R.SocketDebugAdapter(b);case"pipeServer":return new R.NamedPipeDebugAdapter(b);case"executable":return new R.ExecutableDebugAdapter(b,d.type)}return super.createDebugAdapter(b,d)}daExecutableFromPackage(b,d){const u=R.ExecutableDebugAdapter.platformAdapterExecutable(d.getAllExtensionDescriptions(),b.type);if(u)return new D.DebugAdapterExecutable(u.command,u.args,u.options)}createSignService(){return new w.SignService}async $runInTerminal(b,d){if(b.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(h=>{this._integratedTerminalInstances.onTerminalClosed(h)}));const u=await this._configurationService.getConfigProvider(),a=this._terminalService.getDefaultShell(!0,u),t=this._terminalService.getDefaultShellArgs(!0,u),r=JSON.stringify({shell:a,shellArgs:t});let s=await this._integratedTerminalInstances.checkout(r),o,n=!1;if(s)o=b.cwd;else{const h={shellPath:a,shellArgs:t,cwd:b.cwd,name:b.title||_.localize(0,null)};n=!0,s=this._terminalService.createTerminalFromOptions(h,!0),this._integratedTerminalInstances.insert(s,r)}s.show(!0);const c=await s.processId;n&&await new Promise(h=>setTimeout(h,1e3));const p=(0,f.prepareCommand)(a,b.args,o,b.env);s.sendText(p,!0);const E=this.onDidTerminateDebugSession(h=>{h.id===d&&(this._integratedTerminalInstances.free(s),E.dispose())});return c}else if(b.kind==="external")return(0,f.runInExternalTerminal)(b,await this._configurationService.getConfigProvider());return super.$runInTerminal(b,d)}createVariableResolver(b,d,u){return new k.ExtHostVariableResolverService(b,d,u,process.env,this._workspaceService)}};m=Ve([xe(0,T.IExtHostRpcService),xe(1,I.IExtHostWorkspace),xe(2,C.IExtHostExtensionService),xe(3,P.IExtHostDocumentsAndEditors),xe(4,y.IExtHostConfiguration),xe(5,i.IExtHostTerminalService)],m),e.ExtHostDebugService=m;class S{constructor(){this._terminalInstances=new Map}async checkout(b){const u=[...this._terminalInstances.entries()].map(([a,t])=>(0,l.createCancelablePromise)(async r=>{if(t.lastUsedAt!==-1&&await(0,f.hasChildProcesses)(await a.processId))return null;const s=Date.now();return t.lastUsedAt+S.minUseDelay>s||r.isCancellationRequested||t.config!==b?null:(t.lastUsedAt=s,a)}));return await(0,l.firstParallel)(u,a=>!!a)}insert(b,d){this._terminalInstances.set(b,{lastUsedAt:Date.now(),config:d})}free(b){const d=this._terminalInstances.get(b);d&&(d.lastUsedAt=-1)}onTerminalClosed(b){this._terminalInstances.delete(b)}}S.minUseDelay=1e3}),define(me[262],pe([0,1,7,2,79,32,45,39,36,35,13,27,67,11,12,64]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let S=class extends w.ExtHostTaskBase{constructor(b,d,u,a,t,r,s,o){super(b,d,u,a,t,r,s,o);this.workspaceService=u,d.remote.isRemote&&d.remote.authority&&this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:d.remote.authority,platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(b,d){const u=d;if(!d.execution&&u._id===void 0)throw new Error("Tasks to execute must include an execution");if(u._id!==void 0){const a=w.TaskHandleDTO.from(u,this.workspaceService),t=await this._proxy.$getTaskExecution(a);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.getTaskExecution(t,d);return this._proxy.$executeTask(a).catch(()=>{}),r}else{const a=w.TaskDTO.from(d,b);if(a===void 0)return Promise.reject(new Error("Task is not valid"));w.CustomExecutionDTO.is(a.execution)&&await this.addCustomExecution(a,d,!1);const t=await this.getTaskExecution(await this._proxy.$getTaskExecution(a),d);return this._proxy.$executeTask(a).catch(()=>{}),t}}provideTasksInternal(b,d,u,a){const t=[];if(a)for(let r of a){this.checkDeprecation(r,u),(!r.definition||!b[r.definition.type])&&this._logService.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const s=w.TaskDTO.from(r,u.extension);s&&(t.push(s),w.CustomExecutionDTO.is(s.execution)&&d.push(this.addCustomExecution(s,r,!0)))}return{tasks:t,extension:u.extension}}async resolveTaskInternal(b){return b}async getVariableResolver(b){if(this._variableResolver===void 0){const d=await this._configurationService.getConfigProvider();this._variableResolver=new C.ExtHostVariableResolverService(b,this._editorService,d,process.env,this.workspaceService)}return this._variableResolver}async $resolveVariables(b,d){const u=D.URI.revive(b),a={process:void 0,variables:Object.create(null)},t=await this._workspaceProvider.resolveWorkspaceFolder(u),r=await this._workspaceProvider.getWorkspaceFolders2();if(!r||!t)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const s=await this.getVariableResolver(r),o={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}};for(let n of d.variables)a.variables[n]=s.resolve(o,n);if(d.process!==void 0){let n;if(d.process.path!==void 0){n=d.process.path.split(_.delimiter);for(let c=0;c<n.length;c++)n[c]=s.resolve(o,n[c])}a.process=await R.win32.findExecutable(s.resolve(o,d.process.name),d.process.cwd!==void 0?s.resolve(o,d.process.cwd):void 0,n)}return a}$getDefaultShellAndArgs(){return this._terminalService.$getDefaultShellAndArgs(!0)}async $jsonTasksSupported(){return!0}async $findExecutable(b,d,u){return R.win32.findExecutable(b,d,u)}};S=Ve([xe(0,T.IExtHostRpcService),xe(1,k.IExtHostInitDataService),xe(2,I.IExtHostWorkspace),xe(3,P.IExtHostDocumentsAndEditors),xe(4,y.IExtHostConfiguration),xe(5,i.IExtHostTerminalService),xe(6,l.ILogService),xe(7,m.IExtHostApiDeprecationService)],S),e.ExtHostTask=S}),define(me[263],pe([0,1,10,15,28,147,12,36,45,39,13,35,32,208,209]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let m=class extends k.BaseExtHostTerminalService{constructor(g,b,d,u,a){super(!0,g);this._extHostConfiguration=b,this._extHostWorkspace=d,this._extHostDocumentsAndEditors=u,this._logService=a,this._isWorkspaceShellAllowed=!1,(0,I.getSystemShell)(_.platform).then(t=>this._defaultShell=t),this._updateLastActiveWorkspace(),this._updateVariableResolver(),this._registerListeners()}createTerminal(g,b,d){const u=new k.ExtHostTerminal(this._proxy,(0,R.generateUuid)(),{name:g,shellPath:b,shellArgs:d},g);return this._terminals.push(u),u.create(b,d),u.value}createTerminalFromOptions(g,b){const d=new k.ExtHostTerminal(this._proxy,(0,R.generateUuid)(),g,g.name);return this._terminals.push(d),d.create((0,D.withNullAsUndefined)(g.shellPath),(0,D.withNullAsUndefined)(g.shellArgs),(0,D.withNullAsUndefined)(g.cwd),(0,D.withNullAsUndefined)(g.env),void 0,(0,D.withNullAsUndefined)(g.strictEnv),(0,D.withNullAsUndefined)(g.hideFromUser),(0,D.withNullAsUndefined)(b),!0),d.value}getDefaultShell(g,b){var d;const u=a=>{const t=b.getConfiguration(a.substr(0,a.lastIndexOf("."))).inspect(a.substr(a.lastIndexOf(".")+1));return this._apiInspectConfigToPlain(t)};return f.getDefaultShell(u,this._isWorkspaceShellAllowed,(d=this._defaultShell)!==null&&d!==void 0?d:(0,I.getSystemShellSync)(_.platform),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,f.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService,g)}getDefaultShellArgs(g,b){const d=u=>{const a=b.getConfiguration(u.substr(0,u.lastIndexOf("."))).inspect(u.substr(u.lastIndexOf(".")+1));return this._apiInspectConfigToPlain(a)};return f.getDefaultShellArgs(d,this._isWorkspaceShellAllowed,g,f.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService)}_apiInspectConfigToPlain(g){return{userValue:g?g.globalValue:void 0,value:g?g.workspaceValue:void 0,defaultValue:g?g.defaultValue:void 0}}_registerListeners(){this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(()=>this._updateLastActiveWorkspace()),this._extHostWorkspace.onDidChangeWorkspace(()=>this._updateVariableResolver())}_updateLastActiveWorkspace(){const g=this._extHostDocumentsAndEditors.activeEditor();g&&(this._lastActiveWorkspace=this._extHostWorkspace.getWorkspaceFolder(g.document.uri))}async _updateVariableResolver(){const g=await this._extHostConfiguration.getConfigProvider(),b=await this._extHostWorkspace.getWorkspaceFolders2();this._variableResolver=new y.ExtHostVariableResolverService(b||[],this._extHostDocumentsAndEditors,g,process.env)}$getAvailableShells(){return(0,l.detectAvailableShells)()}async $getDefaultShellAndArgs(g){const b=await this._extHostConfiguration.getConfigProvider();return{shell:this.getDefaultShell(g,b),args:this.getDefaultShellArgs(g,b)}}$acceptWorkspacePermissionsChanged(g){this._isWorkspaceShellAllowed=g}};m=Ve([xe(0,T.IExtHostRpcService),xe(1,P.IExtHostConfiguration),xe(2,w.IExtHostWorkspace),xe(3,i.IExtHostDocumentsAndEditors),xe(4,C.ILogService)],m),e.ExtHostTerminalService=m}),define(me[264],pe([0,1,19,18,68,6,2,5,254,12,80,82,27,182,13,63,42,35]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l,m,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(u,a,t,r){this._disposables=new I.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const s=new y.RPCProtocol(u,null,r);a=b._transform(a,s);const o=new k.ServiceCollection(...(0,T.getSingletonServiceDescriptors)());o.set(w.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},a)),o.set(l.IExtHostRpcService,new l.ExtHostRpcService(s)),o.set(m.IURITransformerService,new m.URITransformerService(r)),o.set(S.IHostUtils,t);const n=new f.InstantiationService(o,!0),c=n.invokeFunction(v=>v.get(g.IExtHostTerminalService));this._disposables.add(c),this._logService=n.invokeFunction(v=>v.get(i.ILogService)),R.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",a),this._extensionService=n.invokeFunction(v=>v.get(S.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const p=new WeakMap;this._extensionService.getExtensionPathIndex().then(v=>{Error.prepareStackTrace=(A,F)=>{let x="",j,G;for(const B of F)x+=`
	at ${B.toString()}`,G=B.getFileName(),!j&&G&&(j=v.findSubstr(G));return p.set(A,j),`${A.name||"Error"}: ${A.message||""}${x}`}});const E=s.getProxy(P.MainContext.MainThreadExtensionService),h=s.getProxy(P.MainContext.MainThreadErrors);D.setUnexpectedErrorHandler(v=>{const A=D.transformErrorForSerialization(v),F=p.get(v);F?E.$onExtensionRuntimeError(F.identifier,A):h.$onUnexpectedError(A)})}terminate(u){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${u}`),this._logService.flush(),this._disposables.dispose(),D.setUnexpectedErrorHandler(t=>{});const a=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,_.timeout)(4e3),a]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(u,a){u.extensions.forEach(r=>r.extensionLocation=C.URI.revive(a.transformIncomingURIs(r.extensionLocation))),u.environment.appRoot=C.URI.revive(a.transformIncomingURIs(u.environment.appRoot));const t=u.environment.extensionDevelopmentLocationURI;return t&&(u.environment.extensionDevelopmentLocationURI=t.map(r=>C.URI.revive(a.transformIncomingURIs(r)))),u.environment.extensionTestsLocationURI=C.URI.revive(a.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=C.URI.revive(a.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=C.URI.revive(a.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=C.URI.revive(a.transformIncomingURIs(u.logsLocation)),u.logFile=C.URI.revive(a.transformIncomingURIs(u.logFile)),u.workspace=a.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=b}),define(me[265],pe([0,1,7,21,59,33,23,46,31,37]),function(Z,e,_,D,R,I,C,P,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(f,l,m){this.config=f,this.provider=l,this.sessionToken=m,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=f.filePattern,this.includePattern=f.includePattern&&I.parse(f.includePattern),this.maxResults=f.maxResults||void 0,this.exists=f.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=f.excludePattern&&I.parse(f.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(f=>f.cancel()),this.activeCancellationTokens=new Set}search(f){const l=this.config.folderQueries||[];return new Promise((m,S)=>{const g=b=>{this.resultCount++,f(b)};if(this.isCanceled)return m({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(b=>{const d=b.toString(),u=_.basename(d);this.globalExcludePattern&&this.globalExcludePattern(d,u)||this.matchFile(g,{base:b,basename:u})}),Promise.all(l.map(b=>this.searchInFolder(b,g))).then(b=>{m({limitHit:this.isLimitHit,stats:b[0]||void 0})},b=>{S(new Error((0,R.toErrorMessage)(b)))})})}searchInFolder(f,l){const m=new D.CancellationTokenSource;return new Promise((S,g)=>{const b=this.getSearchOptionsForFolder(f),d=this.initDirectoryTree(),u=new y.QueryGlobTester(this.config,f),a=!u.hasSiblingExcludeClauses();let t;new Promise(r=>(0,i.nextTick)(r)).then(()=>(this.activeCancellationTokens.add(m),t=P.StopWatch.create(),this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},b,m.token))).then(r=>{const s=t.elapsed(),o=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(n=>{const c=_.posix.relative(f.folder.path,n.path);if(a){const p=_.basename(n.path);this.matchFile(l,{base:f.folder,relativePath:c,basename:p});return}this.addDirectoryEntries(d,f.folder,c,l)}),this.activeCancellationTokens.delete(m),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(d,u,l),{providerTime:s,postProcessTime:o.elapsed()})}).then(r=>{m.dispose(),S(r)},r=>{m.dispose(),g(r)})})}getSearchOptionsForFolder(f){const l=(0,y.resolvePatternsForProvider)(this.config.includePattern,f.includePattern),m=(0,y.resolvePatternsForProvider)(this.config.excludePattern,f.excludePattern);return{folder:f.folder,excludes:m,includes:l,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}addDirectoryEntries({pathToEntries:f},l,m,S){if(m===this.filePattern){const b=_.basename(this.filePattern);this.matchFile(S,{base:l,relativePath:this.filePattern,basename:b})}function g(b){const d=_.basename(b),u=_.dirname(b);let a=f[u];a||(a=f[u]=[],g(u)),a.push({base:l,relativePath:b,basename:d})}g(m)}matchDirectoryTree({rootEntries:f,pathToEntries:l},m,S){const g=this,b=this.filePattern;function d(u){const a=I.hasSiblingFn(()=>u.map(t=>t.basename));for(let t=0,r=u.length;t<r;t++){const s=u[t],{relativePath:o,basename:n}=s;if(!!m.includedInQuerySync(o,n,b!==n?a:void 0)){const c=l[o];if(c)d(c);else{if(o===b)continue;g.matchFile(S,s)}if(g.isLimitHit)break}}}d(f)}matchFile(f,l){(!this.includePattern||l.relativePath&&this.includePattern(l.relativePath,l.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||f(l))}}class k{constructor(){this.sessions=new Map}fileSearch(f,l,m,S){const g=this.getSessionTokenSource(f.cacheKey),b=new T(f,l,g&&g.token);let d=0;const u=a=>{d+=a.length,m(a.map(t=>this.rawMatchToSearchItem(t)))};return this.doSearch(b,k.BATCH_SIZE,u,S).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:d,detailStats:a.stats}}))}clearCache(f){const l=this.getSessionTokenSource(f);l&&l.cancel()}getSessionTokenSource(f){if(!!f)return this.sessions.has(f)||this.sessions.set(f,new D.CancellationTokenSource),this.sessions.get(f)}rawMatchToSearchItem(f){return f.relativePath?{resource:C.joinPath(f.base,f.relativePath)}:{resource:f.base}}doSearch(f,l,m,S){S.onCancellationRequested(()=>{f.cancel()});const g=d=>{d&&(b.push(d),l>0&&b.length>=l&&(m(b),b=[]))};let b=[];return f.search(g).then(d=>(b.length&&m(b),d),d=>(b.length&&m(b),Promise.reject(d)))}}e.FileSearchManager=k,k.BATCH_SIZE=512}),define(me[124],pe([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=e.Position=void 0;class _{constructor(I,C){this.line=I,this.character=C}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,C){return new _(0,0)}with(I){return new _(0,0)}}e.Position=_;class D{constructor(I,C,P,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new _(I,C),this.end=new _(P,y)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new D(0,0,0,0)}with(I){return new D(0,0,0,0)}}e.Range=D}),define(me[125],pe([0,1,7,14,21,59,23,33,2,31,37,11]),function(Z,e,_,D,R,I,C,P,y,i,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class w{constructor(d,u,a){this.query=d,this.provider=u,this.fileUtils=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(d,u){const a=this.query.folderQueries||[],t=new R.CancellationTokenSource;return u.onCancellationRequested(()=>t.cancel()),new Promise((r,s)=>{this.collector=new l(d);let o=!1;const n=(c,p)=>{if(!o&&!this.isLimitHit){const E=this.resultSize(c);S(c)&&typeof this.query.maxResults=="number"&&this.resultCount+E>this.query.maxResults&&(this.isLimitHit=!0,o=!0,t.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const h=this.resultSize(c);this.resultCount+=h,(h>0||!S(c))&&this.collector.add(c,p)}};Promise.all(a.map((c,p)=>this.searchInFolder(c,E=>n(E,p),t.token))).then(c=>{t.dispose(),this.collector.flush();const p=c.some(E=>!!E&&!!E.limitHit);r({limitHit:this.isLimitHit||p,stats:{type:"textSearchProvider"}})},c=>{t.dispose();const p=(0,I.toErrorMessage)(c);s(new Error(p))})})}resultSize(d){return S(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}trimResultToSize(d,u){const a=Array.isArray(d.ranges)?d.ranges:[d.ranges],t=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:a.slice(0,u),preview:{matches:t.slice(0,u),text:d.preview.text},uri:d.uri}}searchInFolder(d,u,a){const t=new i.QueryGlobTester(this.query,d),r=[],s={report:n=>{if(!!this.validateProviderResult(n)){const c=d.folder.scheme===k.Schemas.file?P.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(n.uri))):void 0,p=C.relativePath(d.folder,n.uri);p&&r.push(t.includedInQuery(p,_.basename(p),c).then(E=>{E&&u(n)}))}}},o=this.getSearchOptionsForFolder(d);return new Promise(n=>(0,T.nextTick)(n)).then(()=>this.provider.provideTextSearchResults(f(this.query.contentPattern),o,s,a)).then(n=>Promise.all(r).then(()=>n))}validateProviderResult(d){if(S(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(d){const u=(0,i.resolvePatternsForProvider)(this.query.includePattern,d.includePattern),a=(0,i.resolvePatternsForProvider)(this.query.excludePattern,d.excludePattern),t={folder:y.URI.from(d.folder),excludes:a,includes:u,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.fileUtils.toCanonicalName(d.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=w;function f(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class l{constructor(d){this._onResult=d,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new g(512,u=>this.sendItems(u))}add(d,u){this._currentFileMatch&&(this._currentFolderIdx!==u||!C.isEqual(this._currentUri,d.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=u,this._currentFileMatch={resource:d.uri,results:[]}),this._currentFileMatch.results.push(m(d))}pushToCollector(){const d=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,d)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(d){this._onResult(d)}}e.TextSearchResultsCollector=l;function m(b){return S(b)?{preview:{matches:(0,D.mapArrayOrNot)(b.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:b.preview.text},ranges:(0,D.mapArrayOrNot)(b.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function S(b){return!!b.preview}e.extensionResultIsMatch=S;class g{constructor(d,u){this.maxBatchSize=d,this.cb=u,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(d,u){!d||this.addItemToBatch(d,u)}addItems(d,u){!d||this.addItemsToBatch(d,u)}addItemToBatch(d,u){this.batch.push(d),this.batchSize+=u,this.onUpdate()}addItemsToBatch(d,u){this.batch=this.batch.concat(d),this.batchSize+=u,this.onUpdate()}onUpdate(){this.totalNumberCompleted<g.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},g.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=g,g.TIMEOUT=4e3,g.START_BATCH_AFTER_COUNT=50}),define(me[69],pe([0,1,6,5,4,265,13,63,12,2,125]),function(Z,e,_,D,R,I,C,P,y,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,R.createDecorator)("IExtHostSearch");let k=class{constructor(m,S,g){this.extHostRpc=m,this._uriTransformer=S,this._logService=g,this._proxy=this.extHostRpc.getProxy(D.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new I.FileSearchManager}_transformScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}registerTextSearchProvider(m,S){if(this._textSearchUsedSchemes.has(m))throw new Error(`a text search provider for the scheme '${m}' is already registered`);this._textSearchUsedSchemes.add(m);const g=this._handlePool++;return this._textSearchProvider.set(g,S),this._proxy.$registerTextSearchProvider(g,this._transformScheme(m)),(0,_.toDisposable)(()=>{this._textSearchUsedSchemes.delete(m),this._textSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}registerFileSearchProvider(m,S){if(this._fileSearchUsedSchemes.has(m))throw new Error(`a file search provider for the scheme '${m}' is already registered`);this._fileSearchUsedSchemes.add(m);const g=this._handlePool++;return this._fileSearchProvider.set(g,S),this._proxy.$registerFileSearchProvider(g,this._transformScheme(m)),(0,_.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(m),this._fileSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}$provideFileSearchResults(m,S,g,b){const d=w(g),u=this._fileSearchProvider.get(m);if(u)return this._fileSearchManager.fileSearch(d,u,a=>{this._proxy.$handleFileMatch(m,S,a.map(t=>t.resource))},b);throw new Error("unknown provider: "+m)}$clearCache(m){return this._fileSearchManager.clearCache(m),Promise.resolve(void 0)}$provideTextSearchResults(m,S,g,b){const d=this._textSearchProvider.get(m);if(!d||!d.provideTextSearchResults)throw new Error(`Unknown provider ${m}`);const u=w(g);return this.createTextSearchManager(u,d).search(t=>this._proxy.$handleTextMatch(m,S,t),b)}createTextSearchManager(m,S){return new T.TextSearchManager(m,S,{readdir:g=>Promise.resolve([]),toCanonicalName:g=>g})}};k=Ve([xe(0,C.IExtHostRpcService),xe(1,P.IURITransformerService),xe(2,y.ILogService)],k),e.ExtHostSearch=k;function w(l){return Object.assign(Object.assign({},l),{folderQueries:l.folderQueries&&l.folderQueries.map(f),extraFileResources:l.extraFileResources&&l.extraFileResources.map(m=>i.URI.revive(m))})}e.reviveQuery=w;function f(l){return Object.assign(Object.assign({},l),{folder:i.URI.revive(l.folder)})}});var tt=this&&this.__classPrivateFieldSet||function(Z,e,_){if(!e.has(Z))throw new TypeError("attempted to set private field on non-instance");return e.set(Z,_),_},$e=this&&this.__classPrivateFieldGet||function(Z,e){if(!e.has(Z))throw new TypeError("attempted to get private field on non-instance");return e.get(Z)};define(me[266],pe([0,1,156,21,18,3,7,75,2,149,103,139,78,49,5,229,228,52,230,36,231,232,233,214,234,39,42,235,215,237,238,239,65,218,241,242,243,88,35,244,219,20,8,247,66,123,32,41,23,54,195,236,113,122,67,45,69,12,63,13,27,240,204,50,64,226,245,203,89,87,250,248,249,227,62,257,246,86,192,116]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l,m,S,g,b,d,u,a,t,r,s,o,n,c,p,E,h,v,A,F,x,j,G,B,J,O,N,U,L,M,V,K,se,ce,we,Te,Ie,Me,H,Q,ne,oe,ge,Ce,Oe,ve,ke,Pe,Ue,Se,qe,X,ie,Ee,Ne,He,Be,Ye,q,ae,he,Y,re,ue,fe,ye){"use strict";var je,We,ze;Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Xe(et){const Je=et.get(ke.IExtHostInitDataService),_e=et.get(he.IExtHostFileSystemInfo),De=et.get(He.IExtHostConsumerFileSystem),de=et.get(n.IExtHostExtensionService),ee=et.get(se.IExtHostWorkspace),Ae=et.get(ye.IExtHostTelemetry),Re=et.get(d.IExtHostConfiguration),Ze=et.get(Oe.IURITransformerService),Le=et.get(ve.IExtHostRpcService),it=et.get(B.IExtHostStorage),st=et.get(Ne.IExtensionStoragePaths),Ke=et.get(Ce.ILogService),ct=et.get(Se.IExtHostTunnelService),ot=et.get(qe.IExtHostApiDeprecationService),ut=et.get(K.IExtHostWindow),kt=et.get(ue.IExtHostSecretState);Le.set(l.ExtHostContext.ExtHostFileSystemInfo,_e),Le.set(l.ExtHostContext.ExtHostLogService,Ke),Le.set(l.ExtHostContext.ExtHostWorkspace,ee),Le.set(l.ExtHostContext.ExtHostConfiguration,Re),Le.set(l.ExtHostContext.ExtHostExtensionService,de),Le.set(l.ExtHostContext.ExtHostStorage,it),Le.set(l.ExtHostContext.ExtHostTunnelService,ct),Le.set(l.ExtHostContext.ExtHostWindow,ut),Le.set(l.ExtHostContext.ExtHostSecretState,kt),Le.set(l.ExtHostContext.ExtHostTelemetry,Ae);const Dt=Le.set(l.ExtHostContext.ExtHostDecorations,et.get(Q.IExtHostDecorations)),pt=Le.set(l.ExtHostContext.ExtHostDocumentsAndEditors,et.get(o.IExtHostDocumentsAndEditors)),lt=Le.set(l.ExtHostContext.ExtHostCommands,et.get(g.IExtHostCommands)),ft=Le.set(l.ExtHostContext.ExtHostTerminalService,et.get(J.IExtHostTerminalService)),dt=Le.set(l.ExtHostContext.ExtHostDebugService,et.get(oe.IExtHostDebugService)),It=Le.set(l.ExtHostContext.ExtHostSearch,et.get(ge.IExtHostSearch)),St=Le.set(l.ExtHostContext.ExtHostTask,et.get(ne.IExtHostTask)),Pt=Le.set(l.ExtHostContext.ExtHostOutputService,et.get(A.IExtHostOutputService)),xt=Le.set(l.ExtHostContext.ExtHostEditorTabs,new fe.ExtHostEditorTabs),Wt=Le.set(l.ExtHostContext.ExtHostUrls,new M.ExtHostUrls(Le)),Et=Le.set(l.ExtHostContext.ExtHostDocuments,new s.ExtHostDocuments(Le,pt)),jt=Le.set(l.ExtHostContext.ExtHostDocumentContentProviders,new t.ExtHostDocumentContentProvider(Le,pt,Ke)),qt=Le.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new r.ExtHostDocumentSaveParticipant(Ke,Et,Le.getProxy(l.MainContext.MainThreadBulkEdits))),gt=Le.set(l.ExtHostContext.ExtHostNotebook,new Pe.ExtHostNotebookController(Le,lt,pt,Je.environment,Ke,st)),yt=Le.set(l.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(Le,pt)),Bt=Le.set(l.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(Le.getProxy(l.MainContext.MainThreadTreeViews),lt,Ke)),Gt=Le.set(l.ExtHostContext.ExtHostEditorInsets,new Ie.ExtHostEditorInsets(Le.getProxy(l.MainContext.MainThreadEditorInsets),yt,Je.environment)),$t=Le.set(l.ExtHostContext.ExtHostDiagnostics,new u.ExtHostDiagnostics(Le,Ke)),at=Le.set(l.ExtHostContext.ExtHostLanguageFeatures,new E.ExtHostLanguageFeatures(Le,Ze,Et,lt,$t,Ke,ot)),gn=Le.set(l.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(Le,at)),Tt=Le.set(l.ExtHostContext.ExtHostFileSystemEventService,new p.ExtHostFileSystemEventService(Le,Ke,pt)),Ft=Le.set(l.ExtHostContext.ExtHostQuickOpen,(0,x.createExtHostQuickOpen)(Le,ee,lt)),Ht=Le.set(l.ExtHostContext.ExtHostSCM,new j.ExtHostSCM(Le,lt,Ke)),Kt=Le.set(l.ExtHostContext.ExtHostComments,new b.ExtHostComments(Le,lt,Et)),on=Le.set(l.ExtHostContext.ExtHostProgress,new F.ExtHostProgress(Le.getProxy(l.MainContext.MainThreadProgress))),pn=Le.set(l.ExtHostContext.ExtHosLabelService,new Me.ExtHostLabelService(Le)),an=Le.set(l.ExtHostContext.ExtHostTheming,new Ue.ExtHostTheming(Le)),Lt=Le.set(l.ExtHostContext.ExtHostAuthentication,new X.ExtHostAuthentication(Le)),zt=Le.set(l.ExtHostContext.ExtHostTimeline,new ie.ExtHostTimeline(Le,lt)),Xt=Le.set(l.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(Le,Je.environment,ee,Ke,ot)),Yt=Le.set(l.ExtHostContext.ExtHostWebviewPanels,new q.ExtHostWebviewPanels(Le,Xt,ee)),Qt=Le.set(l.ExtHostContext.ExtHostCustomEditors,new Ye.ExtHostCustomEditors(Le,Et,st,Xt,Yt)),vn=Le.set(l.ExtHostContext.ExtHostWebviewViews,new Be.ExtHostWebviewViews(Le,Xt)),At=Le.set(l.ExtHostContext.ExtHostTesting,new Y.ExtHostTesting(Le,pt,ee)),Jt=Le.set(l.ExtHostContext.ExtHostUriOpeners,new re.ExtHostUriOpeners(Le)),Zt=(0,Te.values)(l.ExtHostContext);Le.assertRegistered(Zt);const wn=new ae.ExtHostBulkEdits(Le,pt),_n=new S.ExtHostClipboard(Le),Ot=new v.ExtHostMessageService(Le,Ke),ln=new a.ExtHostDialogs(Le),cn=new G.ExtHostStatusBar(Le,lt.converter),en=new h.ExtHostLanguages(Le,Et);return m.ExtHostApiCommands.register(lt),function(Fe,tn,nn){const ht=function(){let $=!Fe.isUnderDevelopment;function te(be){$||(Ke.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),$=!0)}return function be(Ge){if(Array.isArray(Ge))Ge.forEach(be);else if(typeof Ge=="string")te(Ge);else{const Qe=Ge;typeof Qe.scheme=="undefined"&&te(Ge),!Fe.enableProposedApi&&typeof Qe.exclusive=="boolean"&&(0,ce.throwProposedApiError)(Fe)}return Ge}}(),bn={getSession($,te,be){return Lt.getSession(Fe,$,te,be)},get onDidChangeSessions(){return Lt.onDidChangeSessions},registerAuthenticationProvider($,te,be,Ge){return Lt.registerAuthenticationProvider($,te,be,Ge)},get onDidChangeAuthenticationProviders(){return(0,ce.checkProposedApiEnabled)(Fe),Lt.onDidChangeAuthenticationProviders},get providers(){return(0,ce.checkProposedApiEnabled)(Fe),Lt.providers},logout($,te){return(0,ce.checkProposedApiEnabled)(Fe),Lt.removeSession($,te)}},En={registerCommand($,te,be){return lt.registerCommand(!0,$,te,be)},registerTextEditorCommand($,te,be){return lt.registerCommand(!0,$,(...Ge)=>{const Qe=yt.getActiveTextEditor();if(!Qe){Ke.warn("Cannot execute "+$+" because there is no active text editor.");return}return Qe.edit(rt=>{te.apply(be,[Qe,rt,...Ge])}).then(rt=>{rt||Ke.warn("Edits from command "+$+" were not applied.")},rt=>{Ke.warn("An error occurred while running command "+$,rt)})})},registerDiffInformationCommand:($,te,be)=>((0,ce.checkProposedApiEnabled)(Fe),lt.registerCommand(!0,$,async(...Ge)=>{const Qe=pt.activeEditor(!0);if(!Qe){Ke.warn("Cannot execute "+$+" because there is no active text editor.");return}const rt=await yt.getDiffInformation(Qe.id);te.apply(be,[rt,...Ge])})),executeCommand($,...te){return lt.executeCommand($,...te)},getCommands($=!1){return lt.getCommands($)}},un={get machineId(){return Je.telemetryInfo.machineId},get sessionId(){return Je.telemetryInfo.sessionId},get language(){return Je.environment.appLanguage},get appName(){return Je.environment.appName},get appRoot(){var $,te;return(te=($=Je.environment.appRoot)===null||$===void 0?void 0:$.fsPath)!==null&&te!==void 0?te:""},get uriScheme(){return Je.environment.appUriScheme},get clipboard(){return _n.value},get shell(){return ft.getDefaultShell(!1,nn)},get isTelemetryEnabled(){return(0,ce.checkProposedApiEnabled)(Fe),Ae.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return(0,ce.checkProposedApiEnabled)(Fe),Ae.onDidChangeTelemetryEnabled},openExternal($,te){return ut.openUri($,{allowTunneling:!!Je.remote.authority,allowContributedOpeners:te==null?void 0:te.allowContributedOpeners})},asExternalUri($){return $.scheme===Je.environment.appUriScheme?Wt.createAppUri($):ut.asExternalUri($,{allowTunneling:!!Je.remote.authority})},get remoteName(){return(0,H.getRemoteName)(Je.remote.authority)},get uiKind(){return Je.uiKind}};Je.environment.extensionTestsLocationURI||Object.freeze(un);const dn=Je.remote.isRemote?L.ExtensionKind.Workspace:L.ExtensionKind.UI,Sn={registerTestProvider($){return(0,ce.checkProposedApiEnabled)(Fe),At.registerTestProvider($)},createDocumentTestObserver($){return(0,ce.checkProposedApiEnabled)(Fe),At.createTextDocumentTestObserver($)},createWorkspaceTestObserver($){return(0,ce.checkProposedApiEnabled)(Fe),At.createWorkspaceTestObserver($)},runTests($){return(0,ce.checkProposedApiEnabled)(Fe),At.runTests($)},publishTestResult($,te=!0){return(0,ce.checkProposedApiEnabled)(Fe),At.publishExtensionProvidedResults($,te)},get onDidChangeTestResults(){return(0,ce.checkProposedApiEnabled)(Fe),At.onResultsChanged},get testResults(){return(0,ce.checkProposedApiEnabled)(Fe),At.results}},hn={getExtension($){const te=tn.getExtensionDescription($);if(te)return new nt(de,Fe.identifier,te,dn)},get all(){return tn.getAllExtensionDescriptions().map($=>new nt(de,Fe.identifier,$,dn))},get onDidChange(){return tn.onDidChange}},yn={createDiagnosticCollection($){return $t.createDiagnosticCollection(Fe.identifier,$)},get onDidChangeDiagnostics(){return $t.onDidChangeDiagnostics},getDiagnostics:$=>$t.getDiagnostics($),getLanguages(){return en.getLanguages()},setTextDocumentLanguage($,te){return en.changeLanguage($.uri,te)},match($,te){return(0,w.score)(U.LanguageSelector.from($),te.uri,te.languageId,!0)},registerCodeActionsProvider($,te,be){return at.registerCodeActionProvider(Fe,ht($),te,be)},registerCodeLensProvider($,te){return at.registerCodeLensProvider(Fe,ht($),te)},registerDefinitionProvider($,te){return at.registerDefinitionProvider(Fe,ht($),te)},registerDeclarationProvider($,te){return at.registerDeclarationProvider(Fe,ht($),te)},registerImplementationProvider($,te){return at.registerImplementationProvider(Fe,ht($),te)},registerTypeDefinitionProvider($,te){return at.registerTypeDefinitionProvider(Fe,ht($),te)},registerHoverProvider($,te){return at.registerHoverProvider(Fe,ht($),te,Fe.identifier)},registerEvaluatableExpressionProvider($,te){return at.registerEvaluatableExpressionProvider(Fe,ht($),te,Fe.identifier)},registerInlineValuesProvider($,te){return(0,ce.checkProposedApiEnabled)(Fe),at.registerInlineValuesProvider(Fe,ht($),te,Fe.identifier)},registerDocumentHighlightProvider($,te){return at.registerDocumentHighlightProvider(Fe,ht($),te)},registerLinkedEditingRangeProvider($,te){return at.registerLinkedEditingRangeProvider(Fe,ht($),te)},registerReferenceProvider($,te){return at.registerReferenceProvider(Fe,ht($),te)},registerRenameProvider($,te){return at.registerRenameProvider(Fe,ht($),te)},registerDocumentSymbolProvider($,te,be){return at.registerDocumentSymbolProvider(Fe,ht($),te,be)},registerWorkspaceSymbolProvider($){return at.registerWorkspaceSymbolProvider(Fe,$)},registerDocumentFormattingEditProvider($,te){return at.registerDocumentFormattingEditProvider(Fe,ht($),te)},registerDocumentRangeFormattingEditProvider($,te){return at.registerDocumentRangeFormattingEditProvider(Fe,ht($),te)},registerOnTypeFormattingEditProvider($,te,be,...Ge){return at.registerOnTypeFormattingEditProvider(Fe,ht($),te,[be].concat(Ge))},registerDocumentSemanticTokensProvider($,te,be){return at.registerDocumentSemanticTokensProvider(Fe,ht($),te,be)},registerDocumentRangeSemanticTokensProvider($,te,be){return at.registerDocumentRangeSemanticTokensProvider(Fe,ht($),te,be)},registerSignatureHelpProvider($,te,be,...Ge){return typeof be=="object"?at.registerSignatureHelpProvider(Fe,ht($),te,be):at.registerSignatureHelpProvider(Fe,ht($),te,typeof be=="undefined"?[]:[be,...Ge])},registerCompletionItemProvider($,te,...be){return at.registerCompletionItemProvider(Fe,ht($),te,be)},registerDocumentLinkProvider($,te){return at.registerDocumentLinkProvider(Fe,ht($),te)},registerColorProvider($,te){return at.registerColorProvider(Fe,ht($),te)},registerFoldingRangeProvider($,te){return at.registerFoldingRangeProvider(Fe,ht($),te)},registerSelectionRangeProvider($,te){return at.registerSelectionRangeProvider(Fe,$,te)},registerCallHierarchyProvider($,te){return at.registerCallHierarchyProvider(Fe,$,te)},setLanguageConfiguration:($,te)=>at.setLanguageConfiguration(Fe,$,te),getTokenInformationAtPosition($,te){return(0,ce.checkProposedApiEnabled)(Fe),en.tokenAtPosition($,te)},registerInlineHintsProvider($,te){return(0,ce.checkProposedApiEnabled)(Fe),at.registerInlineHintsProvider(Fe,$,te)}},Dn={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument($,te,be){const Ge=await(y.URI.isUri($)?Promise.resolve(Vt.openTextDocument($)):Promise.resolve($));return yt.showTextDocument(Ge,te,be)},createTextEditorDecorationType($){return yt.createTextEditorDecorationType($)},onDidChangeActiveTextEditor($,te,be){return yt.onDidChangeActiveTextEditor($,te,be)},onDidChangeVisibleTextEditors($,te,be){return yt.onDidChangeVisibleTextEditors($,te,be)},onDidChangeTextEditorSelection($,te,be){return yt.onDidChangeTextEditorSelection($,te,be)},onDidChangeTextEditorOptions($,te,be){return yt.onDidChangeTextEditorOptions($,te,be)},onDidChangeTextEditorVisibleRanges($,te,be){return yt.onDidChangeTextEditorVisibleRanges($,te,be)},onDidChangeTextEditorViewColumn($,te,be){return yt.onDidChangeTextEditorViewColumn($,te,be)},onDidCloseTerminal($,te,be){return ft.onDidCloseTerminal($,te,be)},onDidOpenTerminal($,te,be){return ft.onDidOpenTerminal($,te,be)},onDidChangeActiveTerminal($,te,be){return ft.onDidChangeActiveTerminal($,te,be)},onDidChangeTerminalDimensions($,te,be){return(0,ce.checkProposedApiEnabled)(Fe),ft.onDidChangeTerminalDimensions($,te,be)},onDidWriteTerminalData($,te,be){return(0,ce.checkProposedApiEnabled)(Fe),ft.onDidWriteTerminalData($,te,be)},get state(){return ut.state},onDidChangeWindowState($,te,be){return ut.onDidChangeWindowState($,te,be)},showInformationMessage($,...te){return Ot.showMessage(Fe,P.default.Info,$,te[0],te.slice(1))},showWarningMessage($,...te){return Ot.showMessage(Fe,P.default.Warning,$,te[0],te.slice(1))},showErrorMessage($,...te){return Ot.showMessage(Fe,P.default.Error,$,te[0],te.slice(1))},showQuickPick($,te,be){return Ft.showQuickPick($,!!Fe.enableProposedApi,te,be)},showWorkspaceFolderPick($){return Ft.showWorkspaceFolderPick($)},showInputBox($,te){return Ft.showInput($,te)},showOpenDialog($){return ln.showOpenDialog($)},showSaveDialog($){return ln.showSaveDialog($)},createStatusBarItem($,te){let be,Ge,Qe,rt;return $&&typeof $!="number"?(be=$.id,Ge=$.name,Qe=$.alignment,te=$.priority,rt=$.accessibilityInformation):(be=Fe.identifier.value,Ge=_.localize(0,null,Fe.displayName||Fe.name),Qe=$),cn.createStatusBarEntry(be,Ge,Qe,te,rt)},setStatusBarMessage($,te){return cn.setStatusBarMessage($,te)},withScmProgress($){return ot.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),on.withProgress(Fe,{location:L.ProgressLocation.SourceControl},(te,be)=>$({report(Ge){}}))},withProgress($,te){return on.withProgress(Fe,$,te)},createOutputChannel($){return Pt.createOutputChannel($)},createWebviewPanel($,te,be,Ge){return Yt.createWebviewPanel(Fe,$,te,be,Ge)},createWebviewTextEditorInset($,te,be,Ge){return(0,ce.checkProposedApiEnabled)(Fe),Gt.createWebviewEditorInset($,te,be,Ge,Fe)},createTerminal($,te,be){return typeof $=="object"?"pty"in $?ft.createExtensionTerminal($):ft.createTerminalFromOptions($):ft.createTerminal($,te,be)},registerTerminalLinkProvider($){return ft.registerLinkProvider($)},registerTreeDataProvider($,te){return Bt.registerTreeDataProvider($,te,Fe)},createTreeView($,te){return Bt.createTreeView($,te,Fe)},registerWebviewPanelSerializer:($,te)=>Yt.registerWebviewPanelSerializer(Fe,$,te),registerCustomEditorProvider:($,te,be={})=>Qt.registerCustomEditorProvider(Fe,$,te,be),registerFileDecorationProvider($){return Dt.registerFileDecorationProvider($,Fe.identifier)},registerUriHandler($){return Wt.registerUriHandler(Fe.identifier,$)},createQuickPick(){return Ft.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return Ft.createInputBox(Fe.identifier)},get activeColorTheme(){return an.activeColorTheme},onDidChangeActiveColorTheme($,te,be){return an.onDidChangeActiveColorTheme($,te,be)},registerWebviewViewProvider($,te,be){return vn.registerWebviewViewProvider(Fe,$,te,be==null?void 0:be.webviewOptions)},get activeNotebookEditor(){return(0,ce.checkProposedApiEnabled)(Fe),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor($,te,be){return(0,ce.checkProposedApiEnabled)(Fe),gt.onDidChangeActiveNotebookEditor($,te,be)},get visibleNotebookEditors(){return(0,ce.checkProposedApiEnabled)(Fe),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ce.checkProposedApiEnabled)(Fe),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection($,te,be){return(0,ce.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookEditorSelection($,te,be)},onDidChangeNotebookEditorVisibleRanges($,te,be){return(0,ce.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookEditorVisibleRanges($,te,be)},showNotebookDocument($,te){return(0,ce.checkProposedApiEnabled)(Fe),gt.showNotebookDocument($,te)},registerExternalUriOpener($,te,be){return(0,ce.checkProposedApiEnabled)(Fe),Jt.registerExternalUriOpener(Fe.identifier,$,te,be)},get openEditors(){return(0,ce.checkProposedApiEnabled)(Fe),xt.tabs},get onDidChangeOpenEditors(){return(0,ce.checkProposedApiEnabled)(Fe),xt.onDidChangeTabs}},Vt={get rootPath(){return ot.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ee.getPath()},set rootPath($){throw R.readonly()},getWorkspaceFolder($){return ee.getWorkspaceFolder($)},get workspaceFolders(){return ee.getWorkspaceFolders()},get name(){return ee.name},set name($){throw R.readonly()},get workspaceFile(){return ee.workspaceFile},set workspaceFile($){throw R.readonly()},updateWorkspaceFolders:($,te,...be)=>ee.updateWorkspaceFolders(Fe,$,te||0,...be),onDidChangeWorkspaceFolders:function($,te,be){return ee.onDidChangeWorkspace($,te,be)},asRelativePath:($,te)=>ee.getRelativePath($,te),findFiles:($,te,be,Ge)=>ee.findFiles(U.GlobPattern.from($),U.GlobPattern.from(te),be,Fe.identifier,Ge),findTextInFiles:($,te,be,Ge)=>{let Qe,rt;return typeof te=="object"?(Qe=te,rt=be):(Qe={},rt=te,Ge=be),ee.findTextInFiles($,Qe||{},rt,Fe.identifier,Ge)},saveAll:$=>ee.saveAll($),applyEdit($){return wn.applyWorkspaceEdit($)},createFileSystemWatcher:($,te,be,Ge)=>Tt.createFileSystemWatcher(U.GlobPattern.from($),te,be,Ge),get textDocuments(){return Et.getAllDocumentData().map($=>$.document)},set textDocuments($){throw R.readonly()},openTextDocument($){let te;const be=$;if(typeof $=="string")te=Promise.resolve(y.URI.file($));else if(y.URI.isUri($))te=Promise.resolve($);else if(!be||typeof be=="object")te=Et.createDocumentData(be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return te.then(Ge=>Et.ensureDocumentData(Ge).then(Qe=>Qe.document))},onDidOpenTextDocument:($,te,be)=>Et.onDidAddDocument($,te,be),onDidCloseTextDocument:($,te,be)=>Et.onDidRemoveDocument($,te,be),onDidChangeTextDocument:($,te,be)=>Et.onDidChangeDocument($,te,be),onDidSaveTextDocument:($,te,be)=>Et.onDidSaveDocument($,te,be),onWillSaveTextDocument:($,te,be)=>qt.getOnWillSaveTextDocumentEvent(Fe)($,te,be),onDidChangeConfiguration:($,te,be)=>nn.onDidChangeConfiguration($,te,be),getConfiguration($,te){return te=arguments.length===1?void 0:te,nn.getConfiguration($,te,Fe)},registerTextDocumentContentProvider($,te){return jt.registerTextDocumentContentProvider($,te)},registerTaskProvider:($,te)=>(ot.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(Fe,$,te)),registerFileSystemProvider($,te,be){return gn.registerFileSystemProvider(Fe.identifier,$,te,be)},get fs(){return De.value},registerFileSearchProvider:($,te)=>((0,ce.checkProposedApiEnabled)(Fe),It.registerFileSearchProvider($,te)),registerTextSearchProvider:($,te)=>((0,ce.checkProposedApiEnabled)(Fe),It.registerTextSearchProvider($,te)),registerRemoteAuthorityResolver:($,te)=>((0,ce.checkProposedApiEnabled)(Fe),de.registerRemoteAuthorityResolver($,te)),registerResourceLabelFormatter:$=>((0,ce.checkProposedApiEnabled)(Fe),pn.$registerResourceLabelFormatter($)),onDidCreateFiles:($,te,be)=>Tt.onDidCreateFile($,te,be),onDidDeleteFiles:($,te,be)=>Tt.onDidDeleteFile($,te,be),onDidRenameFiles:($,te,be)=>Tt.onDidRenameFile($,te,be),onWillCreateFiles:($,te,be)=>Tt.getOnWillCreateFileEvent(Fe)($,te,be),onWillDeleteFiles:($,te,be)=>Tt.getOnWillDeleteFileEvent(Fe)($,te,be),onWillRenameFiles:($,te,be)=>Tt.getOnWillRenameFileEvent(Fe)($,te,be),openTunnel:$=>((0,ce.checkProposedApiEnabled)(Fe),ct.openTunnel(Fe,$).then(te=>{if(!te)throw new Error("cannot open tunnel");return te})),get tunnels(){return(0,ce.checkProposedApiEnabled)(Fe),ct.getTunnels()},onDidChangeTunnels:($,te,be)=>((0,ce.checkProposedApiEnabled)(Fe),ct.onDidChangeTunnels($,te,be)),registerTimelineProvider:($,te)=>((0,ce.checkProposedApiEnabled)(Fe),zt.registerTimelineProvider($,te,Fe.identifier,lt.converter)),get trustState(){return(0,ce.checkProposedApiEnabled)(Fe),(0,ce.checkRequiresWorkspaceTrust)(Fe),ee.trustState},requireWorkspaceTrust:$=>((0,ce.checkProposedApiEnabled)(Fe),(0,ce.checkRequiresWorkspaceTrust)(Fe),ee.requireWorkspaceTrust($)),onDidChangeWorkspaceTrustState:($,te,be)=>ee.onDidChangeWorkspaceTrustState($,te,be)},Cn={get inputBox(){return ot.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),Ht.getLastInputBox(Fe)},createSourceControl($,te,be){return Ht.createSourceControl(Fe,$,te,be)}},kn={createCommentController($,te){return Kt.createCommentController(Fe,$,te)}},z={get activeDebugSession(){return dt.activeDebugSession},get activeDebugConsole(){return dt.activeDebugConsole},get breakpoints(){return dt.breakpoints},onDidStartDebugSession($,te,be){return dt.onDidStartDebugSession($,te,be)},onDidTerminateDebugSession($,te,be){return dt.onDidTerminateDebugSession($,te,be)},onDidChangeActiveDebugSession($,te,be){return dt.onDidChangeActiveDebugSession($,te,be)},onDidReceiveDebugSessionCustomEvent($,te,be){return dt.onDidReceiveDebugSessionCustomEvent($,te,be)},onDidChangeBreakpoints($,te,be){return dt.onDidChangeBreakpoints($,te,be)},registerDebugConfigurationProvider($,te,be){return dt.registerDebugConfigurationProvider($,te,be||L.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory($,te){return dt.registerDebugAdapterDescriptorFactory(Fe,$,te)},registerDebugAdapterTrackerFactory($,te){return dt.registerDebugAdapterTrackerFactory($,te)},startDebugging($,te,be){return!be||typeof be=="object"&&"configuration"in be?dt.startDebugging($,te,{parentSession:be}):dt.startDebugging($,te,be||{})},stopDebugging($){return dt.stopDebugging($)},addBreakpoints($){return dt.addBreakpoints($)},removeBreakpoints($){return dt.removeBreakpoints($)},asDebugSourceUri($,te){return dt.asDebugSourceUri($,te)}},W={registerTaskProvider:($,te)=>St.registerTaskProvider(Fe,$,te),fetchTasks:$=>St.fetchTasks($),executeTask:$=>St.executeTask(Fe,$),get taskExecutions(){return St.taskExecutions},onDidStartTask:($,te,be)=>St.onDidStartTask($,te,be),onDidEndTask:($,te,be)=>St.onDidEndTask($,te,be),onDidStartTaskProcess:($,te,be)=>St.onDidStartTaskProcess($,te,be),onDidEndTaskProcess:($,te,be)=>St.onDidEndTaskProcess($,te,be)},le={openNotebookDocument:($,te)=>((0,ce.checkProposedApiEnabled)(Fe),gt.openNotebookDocument($,te)),get onDidOpenNotebookDocument(){return(0,ce.checkProposedApiEnabled)(Fe),gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,ce.checkProposedApiEnabled)(Fe),gt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,ce.checkProposedApiEnabled)(Fe),gt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,ce.checkProposedApiEnabled)(Fe),gt.notebookDocuments.map($=>$.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,ce.checkProposedApiEnabled)(Fe),gt.onDidChangeActiveNotebookKernel},registerNotebookContentProvider:($,te,be)=>((0,ce.checkProposedApiEnabled)(Fe),gt.registerNotebookContentProvider(Fe,$,te,be)),registerNotebookKernelProvider:($,te)=>((0,ce.checkProposedApiEnabled)(Fe),gt.registerNotebookKernelProvider(Fe,$,te)),createNotebookEditorDecorationType($){return(0,ce.checkProposedApiEnabled)(Fe),gt.createNotebookEditorDecorationType($)},onDidChangeNotebookDocumentMetadata($,te,be){return(0,ce.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookDocumentMetadata($,te,be)},onDidChangeNotebookCells($,te,be){return(0,ce.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookCells($,te,be)},onDidChangeCellOutputs($,te,be){return(0,ce.checkProposedApiEnabled)(Fe),gt.onDidChangeCellOutputs($,te,be)},onDidChangeCellLanguage($,te,be){return(0,ce.checkProposedApiEnabled)(Fe),gt.onDidChangeCellLanguage($,te,be)},onDidChangeCellMetadata($,te,be){return(0,ce.checkProposedApiEnabled)(Fe),gt.onDidChangeCellMetadata($,te,be)},createConcatTextDocument($,te){return(0,ce.checkProposedApiEnabled)(Fe),new Ee.ExtHostNotebookConcatDocument(gt,Et,$,te)},createCellStatusBarItem($,te,be){return(0,ce.checkProposedApiEnabled)(Fe),gt.createNotebookCellStatusBarItemInternal($,te,be)}};return{version:Je.version,authentication:bn,commands:En,comments:kn,debug:z,env:un,extensions:hn,languages:yn,notebook:le,scm:Cn,tasks:W,test:Sn,window:Dn,workspace:Vt,Breakpoint:L.Breakpoint,CallHierarchyIncomingCall:L.CallHierarchyIncomingCall,CallHierarchyItem:L.CallHierarchyItem,CallHierarchyOutgoingCall:L.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:D.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:L.CodeAction,CodeActionKind:L.CodeActionKind,CodeActionTriggerKind:L.CodeActionTriggerKind,CodeLens:L.CodeLens,Color:L.Color,ColorInformation:L.ColorInformation,ColorPresentation:L.ColorPresentation,ColorThemeKind:L.ColorThemeKind,CommentMode:L.CommentMode,CommentThreadCollapsibleState:L.CommentThreadCollapsibleState,CompletionItem:L.CompletionItem,CompletionItemKind:L.CompletionItemKind,CompletionItemTag:L.CompletionItemTag,CompletionList:L.CompletionList,CompletionTriggerKind:L.CompletionTriggerKind,ConfigurationTarget:L.ConfigurationTarget,CustomExecution:L.CustomExecution,DebugAdapterExecutable:L.DebugAdapterExecutable,DebugAdapterInlineImplementation:L.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:L.DebugAdapterNamedPipeServer,DebugAdapterServer:L.DebugAdapterServer,DebugConfigurationProviderTriggerKind:L.DebugConfigurationProviderTriggerKind,DebugConsoleMode:L.DebugConsoleMode,DecorationRangeBehavior:L.DecorationRangeBehavior,Diagnostic:L.Diagnostic,DiagnosticRelatedInformation:L.DiagnosticRelatedInformation,DiagnosticSeverity:L.DiagnosticSeverity,DiagnosticTag:L.DiagnosticTag,Disposable:L.Disposable,DocumentHighlight:L.DocumentHighlight,DocumentHighlightKind:L.DocumentHighlightKind,DocumentLink:L.DocumentLink,DocumentSymbol:L.DocumentSymbol,EndOfLine:L.EndOfLine,EnvironmentVariableMutatorType:L.EnvironmentVariableMutatorType,EvaluatableExpression:L.EvaluatableExpression,InlineValueText:L.InlineValueText,InlineValueVariableLookup:L.InlineValueVariableLookup,InlineValueEvaluatableExpression:L.InlineValueEvaluatableExpression,EventEmitter:I.Emitter,ExtensionKind:L.ExtensionKind,ExtensionMode:L.ExtensionMode,ExternalUriOpenerPriority:L.ExternalUriOpenerPriority,FileChangeType:L.FileChangeType,FileDecoration:L.FileDecoration,FileSystemError:L.FileSystemError,FileType:f.FileType,FoldingRange:L.FoldingRange,FoldingRangeKind:L.FoldingRangeKind,FunctionBreakpoint:L.FunctionBreakpoint,Hover:L.Hover,IndentAction:k.IndentAction,Location:L.Location,MarkdownString:L.MarkdownString,OverviewRulerLane:T.OverviewRulerLane,ParameterInformation:L.ParameterInformation,Position:L.Position,ProcessExecution:L.ProcessExecution,ProgressLocation:L.ProgressLocation,QuickInputButtons:L.QuickInputButtons,Range:L.Range,RelativePattern:L.RelativePattern,Selection:L.Selection,SelectionRange:L.SelectionRange,SemanticTokens:L.SemanticTokens,SemanticTokensBuilder:L.SemanticTokensBuilder,SemanticTokensEdit:L.SemanticTokensEdit,SemanticTokensEdits:L.SemanticTokensEdits,SemanticTokensLegend:L.SemanticTokensLegend,ShellExecution:L.ShellExecution,ShellQuoting:L.ShellQuoting,SignatureHelp:L.SignatureHelp,SignatureHelpTriggerKind:L.SignatureHelpTriggerKind,SignatureInformation:L.SignatureInformation,SnippetString:L.SnippetString,SourceBreakpoint:L.SourceBreakpoint,StandardTokenType:L.StandardTokenType,StatusBarAlignment:L.StatusBarAlignment,SymbolInformation:L.SymbolInformation,SymbolKind:L.SymbolKind,SymbolTag:L.SymbolTag,Task:L.Task,TaskGroup:L.TaskGroup,TaskPanelKind:L.TaskPanelKind,TaskRevealKind:L.TaskRevealKind,TaskScope:L.TaskScope,TextDocumentSaveReason:L.TextDocumentSaveReason,TextEdit:L.TextEdit,TextEditorCursorStyle:i.TextEditorCursorStyle,TextEditorLineNumbersStyle:L.TextEditorLineNumbersStyle,TextEditorRevealType:L.TextEditorRevealType,TextEditorSelectionChangeKind:L.TextEditorSelectionChangeKind,ThemeColor:L.ThemeColor,ThemeIcon:L.ThemeIcon,TreeItem:L.TreeItem,TreeItemCollapsibleState:L.TreeItemCollapsibleState,UIKind:l.UIKind,Uri:y.URI,ViewColumn:L.ViewColumn,WorkspaceEdit:L.WorkspaceEdit,InlineHint:L.InlineHint,InlineHintKind:L.InlineHintKind,RemoteAuthorityResolverError:L.RemoteAuthorityResolverError,ResolvedAuthority:L.ResolvedAuthority,SourceControlInputBoxValidationType:L.SourceControlInputBoxValidationType,ExtensionRuntime:L.ExtensionRuntime,TimelineItem:L.TimelineItem,NotebookCellRange:L.NotebookCellRange,NotebookCellKind:L.NotebookCellKind,NotebookCellRunState:L.NotebookCellRunState,NotebookDocumentMetadata:L.NotebookDocumentMetadata,NotebookCellMetadata:L.NotebookCellMetadata,NotebookCellData:L.NotebookCellData,NotebookData:L.NotebookData,NotebookRunState:L.NotebookRunState,NotebookCellStatusBarAlignment:L.NotebookCellStatusBarAlignment,NotebookEditorRevealType:L.NotebookEditorRevealType,NotebookCellOutput:L.NotebookCellOutput,NotebookCellOutputItem:L.NotebookCellOutputItem,LinkedEditingRanges:L.LinkedEditingRanges,TestItem:L.TestItem,TestState:L.TestState,TestResult:L.TestResult,TestMessage:L.TestMessage,TestMessageSeverity:L.TestMessageSeverity,WorkspaceTrustState:L.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Xe;class nt{constructor(Je,_e,De,de){je.set(this,void 0),We.set(this,void 0),ze.set(this,void 0),tt(this,je,Je),tt(this,We,_e),tt(this,ze,De.identifier),this.id=De.identifier.value,this.extensionUri=De.extensionLocation,this.extensionPath=C.normalize((0,we.originalFSPath)(De.extensionLocation)),this.packageJSON=De,this.extensionKind=de}get isActive(){return $e(this,je).isActivated($e(this,ze))}get exports(){if(this.packageJSON.api!=="none")return $e(this,je).getExtensionExports($e(this,ze))}activate(){return $e(this,je).activateByIdWithErrors($e(this,ze),{startup:!1,extensionId:$e(this,We),activationEvent:"api"}).then(()=>this.exports)}}je=new WeakMap,We=new WeakMap,ze=new WeakMap}),define(me[267],pe([0,1,80,65,32,122,36,52,39,35,67,45,69,89,88,50,64,123,87,62,86,116]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l,m,S,g,b,d,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(f.IExtensionStoragePaths,f.ExtensionStoragePaths),(0,_.registerSingleton)(S.IExtHostApiDeprecationService,S.ExtHostApiDeprecationService),(0,_.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,_.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration),(0,_.registerSingleton)(b.IExtHostConsumerFileSystem,b.ExtHostConsumerFileSystem),(0,_.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService),(0,_.registerSingleton)(I.IExtHostDecorations,I.ExtHostDecorations),(0,_.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,_.registerSingleton)(d.IExtHostFileSystemInfo,d.ExtHostFileSystemInfo),(0,_.registerSingleton)(D.IExtHostOutputService,D.ExtHostOutputService),(0,_.registerSingleton)(w.IExtHostSearch,w.ExtHostSearch),(0,_.registerSingleton)(l.IExtHostStorage,l.ExtHostStorage),(0,_.registerSingleton)(T.IExtHostTask,T.WorkerExtHostTask),(0,_.registerSingleton)(i.IExtHostTerminalService,i.WorkerExtHostTerminalService),(0,_.registerSingleton)(m.IExtHostTunnelService,m.ExtHostTunnelService),(0,_.registerSingleton)(g.IExtHostWindow,g.ExtHostWindow),(0,_.registerSingleton)(R.IExtHostWorkspace,R.ExtHostWorkspace),(0,_.registerSingleton)(u.IExtHostSecretState,u.ExtHostSecretState),(0,_.registerSingleton)(a.IExtHostTelemetry,a.ExtHostTelemetry)}),define(me[90],pe([0,1,14,12,31,124]),function(Z,e,_,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function C(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=C;function P(k,w,f,l){const m=(0,_.mapArrayOrNot)(f,y),S=new R.TextSearchMatch(w,m,l),g=S.preview.matches;return{ranges:(0,_.mapArrayOrNot)(m,i),uri:k,preview:{text:S.preview.text,matches:(0,_.mapArrayOrNot)(g,i)}}}e.createTextSearchResult=P;function y(k){return new R.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function i(k){return new I.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let T=class{constructor(w,f){this.prefix=w,this.logService=f}appendLine(w){this.logService.debug(`${this.prefix}#search`,w)}};T=Ve([xe(1,D.ILogService)],T),e.OutputChannel=T}),define(me[268],pe([0,1,91,26]),function(Z,e,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function R(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(r=>r===t)}e.isUTFEncoding=R,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const I=512,C=512,P=512*8,y=512*128;class i{constructor(r){this.iconvLiteDecoder=r}static async create(r){let s;if(r!==e.UTF8)s=(await new Promise((n,c)=>{Z(["iconv-lite-umd"],n,c)})).getDecoder(f(r));else{const o=new TextDecoder;s={write(n){return o.decode(n,{stream:!0})},end(){return o.decode()}}}return new i(s)}write(r){return this.iconvLiteDecoder.write(r)}end(){return this.iconvLiteDecoder.end()}}function T(t,r){var s;const o=((s=r.minBytesRequiredForDetection)!==null&&s!==void 0?s:r.guessEncoding)?P:C;return new Promise((n,c)=>{const p=(0,_.newWriteableStream)(F=>F.join("")),E=[];let h=0,v;const A=async()=>{try{const F=await a({buffer:D.VSBuffer.concat(E),bytesRead:h},r.guessEncoding);F.encoding=await r.overwriteEncoding(F.encoding),v=await i.create(F.encoding);const x=v.write(D.VSBuffer.concat(E).buffer);p.write(x),E.length=0,h=0,n({stream:p,detected:F})}catch(F){c(F)}};(0,_.listenStream)(t,{onData:async F=>{v?p.write(v.write(F.buffer)):(E.push(F),h+=F.byteLength,h>=o&&(t.pause(),await A(),setTimeout(()=>t.resume())))},onError:F=>p.error(F),onEnd:async()=>{v||await A(),p.end(v==null?void 0:v.end())}})})}e.toDecodeStream=T;async function k(t,r,s){const n=(await new Promise((E,h)=>{Z(["iconv-lite-umd"],E,h)})).getEncoder(f(r),s);let c=!1,p=!1;return{read(){if(p)return null;const E=t.read();if(typeof E!="string"){if(p=!0,!c&&(s==null?void 0:s.addBOM))switch(r){case e.UTF8:case e.UTF8_with_bom:return D.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return D.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return D.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const h=n.end();return h&&h.length>0?(c=!0,D.VSBuffer.wrap(h)):null}return c=!0,D.VSBuffer.wrap(n.write(E))}}}e.toEncodeReadable=k;async function w(t){return(await new Promise((s,o)=>{Z(["iconv-lite-umd"],s,o)})).encodingExists(f(t))}e.encodingExists=w;function f(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=f;function l(t,r){if(!t||r<e.UTF16be_BOM.length)return null;const s=t.readUInt8(0),o=t.readUInt8(1);if(s===e.UTF16be_BOM[0]&&o===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&o===e.UTF16le_BOM[1])return e.UTF16le;if(r<e.UTF8_BOM.length)return null;const n=t.readUInt8(2);return s===e.UTF8_BOM[0]&&o===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=l;const m=["ascii","utf-16","utf-32"];async function S(t){const r=await new Promise((p,E)=>{Z(["jschardet"],p,E)}),s=t.slice(0,y),o=d(s.buffer),n=r.detect(o);if(!n||!n.encoding)return null;const c=n.encoding.toLowerCase();return 0<=m.indexOf(c)?null:b(n.encoding)}const g={ibm866:"cp866",big5:"cp950"};function b(t){const r=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return g[r]||r}function d(t){let r="";for(let s=0;s<t.length;s++)r+=String.fromCharCode(t[s]);return r}function u(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const r=t.match(/windows(\d+)/);return r?"windows-"+r[1]:t}}e.toCanonicalName=u;function a({buffer:t,bytesRead:r},s){let o=l(t,r),n=!1;if(o!==e.UTF16be&&o!==e.UTF16le&&t){let c=!0,p=!0,E=!1;for(let h=0;h<r&&h<I;h++){const v=h%2==1,A=t.readUInt8(h)===0;if(A&&(E=!0),c&&(v&&!A||!v&&A)&&(c=!1),p&&(v&&A||!v&&!A)&&(p=!1),A&&!c&&!p)break}E&&(c?o=e.UTF16le:p?o=e.UTF16be:n=!0)}return s&&!n&&!o&&t?S(t.slice(0,r)).then(c=>({seemsBinary:!1,encoding:c})):{seemsBinary:n,encoding:o}}e.detectEncodingFromBuffer=a,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[126],pe([0,1,268,25,125]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class I extends R.TextSearchManager{constructor(P,y,i=D){super(P,y,{readdir:T=>i.readdir(T.fsPath),toCanonicalName:T=>(0,_.toCanonicalName)(T)})}}e.NativeTextSearchManager=I}),define(me[269],pe([0,1,270,285,43,34,38,286]),function(Z,e,_,D,R,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.tlsPatches=e.patches=e.setupProxyResolution=e.LogLevel=void 0;var y;(function(c){c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error",c[c.Critical=6]="Critical",c[c.Off=7]="Off"})(y=e.LogLevel||(e.LogLevel={}));const i=5e3;function T(c){const{getHttpProxySetting:p,log:E,getLogLevel:h,proxyResolverTelemetry:v,useHostProxy:A,env:F}=c;let x=f(F.https_proxy||F.HTTPS_PROXY||F.http_proxy||F.HTTP_PROXY),j=l(F.no_proxy||F.NO_PROXY),G=0,B=new Map,J=new Map;function O(oe){return D.format(Object.assign(Object.assign({},oe),{pathname:void 0,search:void 0,hash:void 0}))}function N(oe){let ge=J.get(oe);return ge||(ge=B.get(oe),ge&&(B.delete(oe),U(oe,ge)),ge)}function U(oe,ge){J.set(oe,ge),J.size>=i&&(B=J,J=new Map,G++,E(y.Debug,"ProxyResolver#cacheProxy cacheRolls",G))}let L,M=0,V=0,K=0,se=0,ce=0,we=0,Te=0,Ie=0,Me=[];function H(){L=void 0,v({count:M,duration:V,errorCount:K,cacheCount:se,cacheSize:J.size,cacheRolls:G,envCount:ce,settingsCount:we,localhostCount:Te,envNoProxyCount:Ie,results:Me}),M=V=K=se=ce=we=Te=Ie=0,Me=[]}function Q(oe,ge,Ce,Oe,ve){L||(L=setTimeout(H,10*60*1e3));const ke=h()===y.Trace?`
`+new Error("Error for stack trace").stack:"";g(c,oe.useSystemCertificates,Ce,()=>{ne(A,oe.useProxySettings,ge,Ce,Oe,ke,ve)})}function ne(oe,ge,Ce,Oe,ve,ke,Pe){if(!ge){Pe("DIRECT");return}const Ue=D.parse(ve),Se=Ue.hostname;if(Se==="localhost"||Se==="127.0.0.1"||Se==="::1"||Se==="::ffff:127.0.0.1"){Te++,Pe("DIRECT"),E(y.Debug,"ProxyResolver#resolveProxy localhost",ve,"DIRECT",ke);return}if(typeof Se=="string"&&j(Se,String(Ue.port||Oe.agent.defaultPort))){Ie++,Pe("DIRECT"),E(y.Debug,"ProxyResolver#resolveProxy envNoProxy",ve,"DIRECT",ke);return}let qe=f(p());if(qe){we++,Pe(qe),E(y.Debug,"ProxyResolver#resolveProxy settings",ve,qe,ke);return}if(x){ce++,Pe(x),E(y.Debug,"ProxyResolver#resolveProxy env",ve,x,ke);return}const X=O(Ue),ie=N(X);if(ie){se++,k(Me,ie,Ue.protocol==="https:"?"HTTPS":"HTTP",Ce),Pe(ie),E(y.Debug,"ProxyResolver#resolveProxy cached",ve,ie,ke);return}if(!oe){Pe("DIRECT"),E(y.Debug,"ProxyResolver#resolveProxy unconfigured",ve,"DIRECT",ke);return}const Ee=Date.now();c.resolveProxy(ve).then(Ne=>{Ne&&(U(X,Ne),k(Me,Ne,Ue.protocol==="https:"?"HTTPS":"HTTP",Ce)),Pe(Ne),E(y.Debug,"ProxyResolver#resolveProxy",ve,Ne,ke)}).then(()=>{M++,V=Date.now()-Ee+V},Ne=>{K++,Pe(),E(y.Error,"ProxyResolver#resolveProxy",n(Ne),ke)})}return Q}e.setupProxyResolution=T;function k(c,p,E,h){const v=p?String(p).trim().split(/\s+/,1)[0]:"EMPTY";h.on("response",A=>{const F=`HTTP_${A.statusCode}`,x=w(c,v,E,F);x.count++}),h.on("error",A=>{const F=A&&typeof A.code=="string"&&A.code||"UNKNOWN_ERROR",x=w(c,v,E,F);x.count++})}function w(c,p,E,h){for(const A of c)if(A.proxy===p&&A.connection===E&&A.code===h)return A;const v={proxy:p,connection:E,code:h,count:0};return c.push(v),v}function f(c){if(!!c){const p=(c||"").trim(),E=p.indexOf("://");if(E!==-1){const h=p.substr(0,E).toLowerCase(),v=p.substr(E+3);if(h==="http")return"PROXY "+v;if(h==="https")return"HTTPS "+v;if(h==="socks")return"SOCKS "+v}}}function l(c){const p=(c||"").trim().toLowerCase();if(p==="*")return()=>!0;const E=p.split(",").map(h=>h.trim().split(":",2)).map(([h,v])=>({name:h,port:v})).filter(h=>!!h.name).map(({name:h,port:v})=>({domain:h[0]==="."?h:`.${h}`,port:v}));return E.length?(h,v)=>E.some(({domain:A,port:F})=>`.${h.toLowerCase()}`.endsWith(A)&&(!F||v===F)):()=>!1}function m(c,p,E,h,v){return{get:A(c.get),request:A(c.request)};function A(F){function x(j,G,B){if(typeof j!="string"&&!(j&&j.searchParams)&&(B=G,G=j,j=null),typeof G=="function"&&(B=G,G=null),G=G||{},G.socketPath)return F.apply(null,arguments);const J=G.agent;if(J===!0)throw new Error("Unexpected agent option: true");const O=J instanceof P.ProxyAgent,N=v&&(G._vscodeProxySupport||G._vscodeSystemProxy)||E.config,U=!O&&(N==="override"||N==="on"&&J===void 0),L=!O&&h.config&&c===_&&!G.ca;if(U||L){if(j){const M=typeof j=="string"?new D.URL(j):j,V={protocol:M.protocol,hostname:M.hostname.lastIndexOf("[",0)===0?M.hostname.slice(1,-1):M.hostname,port:M.port,path:`${M.pathname}${M.search}`};(M.username||M.password)&&(G.auth=`${M.username}:${M.password}`),G=Object.assign(Object.assign({},V),G)}else G=Object.assign({},G);return G.agent=new P.ProxyAgent({resolveProxy:p.bind(void 0,{useProxySettings:U,useSystemCertificates:L}),defaultPort:c===_?443:80,originalAgent:J}),F(G,B)}return F.apply(null,arguments)}return x}}e.patches=m;function S(c){return{createSecureContext:p(c.createSecureContext)};function p(E){return function(h){const v=E.apply(null,arguments),A=h._vscodeAdditionalCaCerts;if(A)for(const F of A)v.context.addCACert(F);return v}}}e.tlsPatches=S;function g(c,p,E,h){p?d(c).then(v=>{v&&(v.append?E._vscodeAdditionalCaCerts=v.certs:E.ca=v.certs),h()}).catch(v=>{c.log(y.Error,"ProxyResolver#useSystemCertificates",n(v))}):h()}let b;async function d({log:c}){return b||(b=u().then(p=>(c(y.Debug,"ProxyResolver#getCaCertificates count",p&&p.certs.length),p&&p.certs.length?p:void 0)).catch(p=>{c(y.Error,"ProxyResolver#getCaCertificates error",n(p))})),b}async function u(){if(process.platform==="win32")return a();if(process.platform==="darwin")return t();if(process.platform==="linux")return s()}async function a(){const c=await new Promise((v,A)=>{Z(["vscode-windows-ca-certs"],v,A)});let p=[];const E=new c.Crypt32;try{let v;for(;v=E.next();)p.push(v)}finally{E.done()}const h=new Set(p.map(o));return{certs:Array.from(h),append:!0}}async function t(){const c=await new Promise((E,h)=>{const v=C.spawn("/usr/bin/security",["find-certificate","-a","-p"]),A=[];v.stdout.setEncoding("utf8"),v.stdout.on("data",F=>A.push(F)),v.on("error",h),v.on("exit",F=>F?h(F):E(A.join("")))}),p=new Set(c.split(/(?=-----BEGIN CERTIFICATE-----)/g).filter(E=>!!E.length));return{certs:Array.from(p),append:!0}}const r=["/etc/ssl/certs/ca-certificates.crt","/etc/ssl/certs/ca-bundle.crt"];async function s(){for(const c of r)try{const p=await I.promises.readFile(c,{encoding:"utf8"}),E=new Set(p.split(/(?=-----BEGIN CERTIFICATE-----)/g).filter(h=>!!h.length));return{certs:Array.from(E),append:!1}}catch(p){if(p.code!=="ENOENT")throw p}}function o(c){const p=["-----BEGIN CERTIFICATE-----"],E=c.toString("base64");for(let h=0;h<E.length;h+=64)p.push(E.substr(h,64));return p.push("-----END CERTIFICATE-----",""),p.join(R.EOL)}function n(c){return c&&(c.stack||c.message)||String(c)}}),define(me[271],pe([0,1,272,270,287,2,269]),function(Z,e,_,D,R,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(k,w,f,l,m,S){const g=S.environment.useHostProxy,b=typeof g=="boolean"?g:!S.remote.isRemote,d=(0,C.setupProxyResolution)({resolveProxy:a=>k.resolveProxy(a),getHttpProxySetting:()=>w.getConfiguration("http").get("proxy"),log:(a,t,...r)=>{switch(a){case C.LogLevel.Trace:l.trace(t,...r);break;case C.LogLevel.Debug:l.debug(t,...r);break;case C.LogLevel.Info:l.info(t,...r);break;case C.LogLevel.Warning:l.warn(t,...r);break;case C.LogLevel.Error:l.error(t,...r);break;case C.LogLevel.Critical:l.critical(t,...r);break;case C.LogLevel.Off:break;default:s(a,t,r);break}function s(o,n,...c){l.error("Unknown log level",o),l.error(n,...c)}},getLogLevel:()=>l.getLevel(),proxyResolverTelemetry:a=>{m.$publicLog2("resolveProxy",a)},useHostProxy:b,env:process.env}),u=y(w,d);return T(f,u)}e.connectProxyResolver=P;function y(k,w){const f={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(m=>{f.config=k.getConfiguration("http").get("proxySupport")||"off"});const l={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(m=>{l.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},_,(0,C.patches)(_,w,{config:"off"},l,!0)),on:Object.assign({},_,(0,C.patches)(_,w,{config:"on"},l,!0)),override:Object.assign({},_,(0,C.patches)(_,w,{config:"override"},l,!0)),onRequest:Object.assign({},_,(0,C.patches)(_,w,f,l,!0)),default:Object.assign(_,(0,C.patches)(_,w,f,l,!1))},https:{off:Object.assign({},D,(0,C.patches)(D,w,{config:"off"},l,!0)),on:Object.assign({},D,(0,C.patches)(D,w,{config:"on"},l,!0)),override:Object.assign({},D,(0,C.patches)(D,w,{config:"override"},l,!0)),onRequest:Object.assign({},D,(0,C.patches)(D,w,f,l,!0)),default:Object.assign(D,(0,C.patches)(D,w,f,l,!1))},tls:Object.assign(R,(0,C.tlsPatches)(R))}}const i=new Map;function T(k,w){return k.getExtensionPathIndex().then(f=>{const l=Z.__$__nodeRequire("module"),m=l._load;l._load=function(g,b,d){if(g==="tls")return w.tls;if(g!=="http"&&g!=="https")return m.apply(this,arguments);const u=w[g],a=f.findSubstr(I.URI.file(b.filename).fsPath);let t=i.get(a);if(t||i.set(a,t={}),!t[g]){let r=u.default;a&&a.enableProposedApi&&(r=u[a.proxySupport]||u.onRequest),t[g]=Object.assign({},r)}return t[g]}})}}),define(me[273],pe([0,1,38,7,76,30,10,9,90,274]),function(Z,e,_,D,R,I,C,P,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const T=i.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(d,u,a,t){const r=w(d,u,a,t),s=u.folder.fsPath;return{cmd:_.spawn(T,r.args,{cwd:s}),rgDiskPath:T,siblingClauses:r.siblingClauses,rgArgs:r,cwd:s}}e.spawnRipgrepCmd=k;function w(d,u,a,t){const r=["--files","--hidden","--case-sensitive"];l([u],a,!1).forEach(o=>{const n=(0,y.anchorGlob)(o);if(r.push("-g",n),C.isMacintosh){const c=(0,R.normalizeNFD)(n);c!==n&&r.push("-g",c)}});const s=f([u],t,void 0,!1);return s.globArgs.forEach(o=>{const n=`!${(0,y.anchorGlob)(o)}`;if(r.push("-g",n),C.isMacintosh){const c=(0,R.normalizeNFD)(n);c!==n&&r.push("-g",c)}}),u.disregardIgnoreFiles!==!1?r.push("--no-ignore"):r.push("--no-ignore-parent"),u.ignoreSymlinks||r.push("--follow"),d.exists&&r.push("--quiet"),r.push("--no-config"),u.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:s.siblingClauses}}function f(d,u,a,t=!0){const r=[];let s={};return d.forEach(o=>{const n=Object.assign({},o.excludePattern||{},u||{}),c=m(n,t?o.folder.fsPath:void 0,a);r.push(...c.globArgs),c.siblingClauses&&(s=Object.assign(s,c.siblingClauses))}),{globArgs:r,siblingClauses:s}}e.foldersToRgExcludeGlobs=f;function l(d,u,a=!0){const t=[];return d.forEach(r=>{const s=Object.assign({},u||{},r.includePattern||{}),o=m(s,a?r.folder.fsPath:void 0);t.push(...o.globArgs)}),t}e.foldersToIncludeGlobs=l;function m(d,u,a){const t=[],r={};return Object.keys(d).forEach(s=>{if(!(a&&a.has(s))&&!!s){const o=d[s];s=g(u?S(u,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof o=="boolean"&&o?(s.startsWith("\\\\")&&(s+="**"),t.push(b(s))):o&&o.when&&(r[s]=o)}}),{globArgs:t,siblingClauses:r}}function S(d,u){return D.isAbsolute(u)?u:D.join(d,u)}e.getAbsoluteGlob=S;function g(d){return d=P.rtrim(d,"\\"),P.rtrim(d,"/")}function b(d){return I.getRoot(d).toLowerCase()==="c:/"?d.replace(/^c:[/\\]/i,"/"):d}e.fixDriveC=b}),define(me[275],pe([0,1,38,34,7,98,14,59,33,76,30,10,46,9,15,25,31,273,96]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l,m,S,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const d=new Set;process.on("exit",()=>{d.forEach(s=>s())});class u{constructor(o){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=o,this.filePattern=o.filePattern||"",this.includePattern=o.includePattern&&y.parse(o.includePattern),this.maxResults=o.maxResults||null,this.exists=!!o.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,b.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=o.excludePattern&&y.parse(o.excludePattern),this.folderExcludePatterns=new Map,o.folderQueries.forEach(n=>{const c=Object.assign({},n.excludePattern||{},this.config.excludePattern||{}),p=n.folder.fsPath;o.folderQueries.map(E=>E.folder.fsPath).filter(E=>E!==p).forEach(E=>{(0,T.isEqualOrParent)(E,p)&&(c[R.relative(p,E)]=!0)}),this.folderExcludePatterns.set(p,new t(c,p))})}cancel(){this.isCanceled=!0}walk(o,n,c,p,E){if(this.fileWalkSW=w.StopWatch.create(!1),this.isCanceled)return E(null,this.isLimitHit);n.forEach(h=>{const v=R.basename(h.fsPath);this.globalExcludePattern&&this.globalExcludePattern(h.fsPath,v)||this.matchFile(c,{relativePath:h.fsPath,searchPath:void 0})}),this.cmdSW=w.StopWatch.create(!1),this.parallel(o,(h,v)=>{this.call(this.cmdTraversal,this,h,c,p,A=>{if(A){const F=(0,P.toErrorMessage)(A);console.error(F),this.errors.push(F),v(A,void 0)}else v(null,void 0)})},(h,v)=>{this.fileWalkSW.stop();const A=h?C.coalesce(h)[0]:null;E(A,this.isLimitHit)})}parallel(o,n,c){const p=new Array(o.length),E=new Array(o.length);let h=!1,v=0;if(o.length===0)return c(null,[]);o.forEach((A,F)=>{n(A,(x,j)=>{if(x?(h=!0,p[F]=null,E[F]=x):(p[F]=j,E[F]=null),++v===o.length)return c(h?E:null,p)})})}call(o,n,...c){try{o.apply(n,c)}catch(p){c[c.length-1](p)}}cmdTraversal(o,n,c,p){const E=o.folder.fsPath,h=k.isMacintosh;let v;const A=()=>v&&v.kill();d.add(A);let F=N=>{d.delete(A),F=()=>{},p(N)},x="";const j=this.initDirectoryTree();let G;const B=(0,g.spawnRipgrepCmd)(this.config,o,this.config.includePattern,this.folderExcludePatterns.get(o.folder.fsPath).expression);v=B.cmd,G=!Object.keys(B.siblingClauses).length;const J=B.rgArgs.args.map(N=>N.match(/^-/)?N:`'${N}'`).join(" ");let O=`${B.rgDiskPath} ${J}
 - cwd: ${B.cwd}`;B.rgArgs.siblingClauses&&(O+=`
 - Sibling clauses: ${JSON.stringify(B.rgArgs.siblingClauses)}`),c({message:O}),this.cmdResultCount=0,this.collectStdout(v,"utf8",c,(N,U,L)=>{if(N){F(N);return}if(this.isLimitHit){F();return}const V=(x+(h?i.normalizeNFC(U||""):U)).split(`
`);if(L){const K=V.length;V[K-1]=V[K-1].trim(),V[K-1]||V.pop()}else x=V.pop()||"";if(V.length&&V[0].indexOf(`
`)!==-1){F(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=V.length,G){for(const K of V)if(this.matchFile(n,{base:E,relativePath:K,searchPath:this.getSearchPath(o,K)}),this.isLimitHit){A();break}(L||this.isLimitHit)&&F();return}this.addDirectoryEntries(o,j,E,V,n),L&&(this.matchDirectoryTree(j,E,n),F())})}spawnFindCmd(o){const n=this.folderExcludePatterns.get(o.folder.fsPath),c=n.getBasenameTerms(),p=n.getPathTerms(),E=["-L","."];if(c.length||p.length){E.push("-not","(","(");for(const h of c)E.push("-name",h),E.push("-o");for(const h of p)E.push("-path",h),E.push("-o");E.pop(),E.push(")","-prune",")")}return E.push("-type","f"),_.spawn("find",E,{cwd:o.folder.fsPath})}readStdout(o,n,c){let p="";this.collectStdout(o,n,()=>{},(E,h,v)=>{if(E){c(E);return}p+=h,v&&c(null,p)})}collectStdout(o,n,c,p){let E=(A,F,x)=>{(A||x)&&(E=()=>{},this.cmdSW&&this.cmdSW.stop()),p(A,F,x)},h=!1;o.stdout?(this.forwardData(o.stdout,n,E),o.stdout.once("data",()=>h=!0)):c({message:"stdout is null"});let v;o.stderr?v=this.collectData(o.stderr):c({message:"stderr is null"}),o.on("error",A=>{E(A)}),o.on("close",A=>{let F;!h&&(F=this.decodeData(v,n))&&r(F)?E(new Error(`command failed with error code ${A}: ${this.decodeData(v,n)}`)):(this.exists&&A===0&&(this.isLimitHit=!0),E(null,"",!0))})}forwardData(o,n,c){const p=new I.StringDecoder(n);return o.on("data",E=>{c(null,p.write(E))}),p}collectData(o){const n=[];return o.on("data",c=>{n.push(c)}),n}decodeData(o,n){const c=new I.StringDecoder(n);return o.map(p=>c.write(p)).join("")}initDirectoryTree(){const o={rootEntries:[],pathToEntries:Object.create(null)};return o.pathToEntries["."]=o.rootEntries,o}addDirectoryEntries(o,{pathToEntries:n},c,p,E){p.indexOf(this.filePattern)!==-1&&this.matchFile(E,{base:c,relativePath:this.filePattern,searchPath:this.getSearchPath(o,this.filePattern)});const h=v=>{const A=R.basename(v),F=R.dirname(v);let x=n[F];x||(x=n[F]=[],h(F)),x.push({base:c,relativePath:v,basename:A,searchPath:this.getSearchPath(o,v)})};p.forEach(h)}matchDirectoryTree({rootEntries:o,pathToEntries:n},c,p){const E=this,h=this.folderExcludePatterns.get(c),v=this.filePattern;function A(F){E.directoriesWalked++;const x=y.hasSiblingFn(()=>F.map(j=>j.basename));for(let j=0,G=F.length;j<G;j++){const B=F[j],{relativePath:J,basename:O}=B;if(!h.test(J,O,v!==O?x:void 0)){const N=n[J];if(N)A(N);else{if(E.filesWalked++,J===v)continue;E.matchFile(p,B)}if(E.isLimitHit)break}}}A(o)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(o,n,c,p,E){const h=o.folder,v=y.hasSiblingFn(()=>c);this.parallel(c,(A,F)=>{if(this.isCanceled||this.isLimitHit)return F(null);const x=n?[n,A].join(R.sep):A;if(this.folderExcludePatterns.get(o.folder.fsPath).test(x,A,this.config.filePattern!==A?v:void 0))return F(null);const j=[h.fsPath,x].join(R.sep);D.lstat(j,(G,B)=>{if(G||this.isCanceled||this.isLimitHit)return F(null);this.statLinkIfNeeded(j,B,(J,O)=>J||this.isCanceled||this.isLimitHit?F(null):O.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(j,B,(N,U)=>N||this.isCanceled||this.isLimitHit||(U=U||"",this.walkedPaths[U])?F(null):(this.walkedPaths[U]=!0,(0,m.readdir)(j).then(L=>{if(this.isCanceled||this.isLimitHit)return F(null);this.doWalk(o,x,L,p,M=>F(M||null))},L=>{F(null)})))):(this.filesWalked++,x===this.filePattern||this.maxFilesize&&l.isNumber(O.size)&&O.size>this.maxFilesize||this.matchFile(p,{base:h.fsPath,relativePath:x,searchPath:this.getSearchPath(o,x)}),F(null,void 0)))})},A=>{const F=A&&C.coalesce(A);return E(F&&F.length>0?F[0]:void 0)})}matchFile(o,n){this.isFileMatch(n)&&(!this.includePattern||this.includePattern(n.relativePath,R.basename(n.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||o(n))}isFileMatch(o){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,S.isFilePatternMatch)(o,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(o,n,c){return n.isSymbolicLink()?D.stat(o,c):c(null,n)}realPathIfNeeded(o,n,c){return n.isSymbolicLink()?D.realpath(o,(p,E)=>p?c(p):c(null,E)):c(null,o)}getSearchPath(o,n){return o.folderName?R.join(o.folderName,n):n}}e.FileWalker=u;class a{constructor(o){this.folderQueries=o.folderQueries,this.extraFiles=o.extraFileResources||[],this.walker=new u(o)}search(o,n,c){this.walker.walk(this.folderQueries,this.extraFiles,o,n,(p,E)=>{c(p,{limitHit:E,stats:this.walker.getStats()})})}cancel(){this.walker.cancel()}}e.Engine=a;class t{constructor(o,n){this.expression=o,this.root=n,this.init(o)}init(o){let n,c;Object.keys(o).filter(p=>o[p]).forEach(p=>{R.isAbsolute(p)?(n=n||y.getEmptyExpression(),n[p]=o[p]):(c=c||y.getEmptyExpression(),c[p]=o[p])}),this.absoluteParsedExpr=n&&y.parse(n,{trimForExclusions:!0}),this.relativeParsedExpr=c&&y.parse(c,{trimForExclusions:!0})}test(o,n,c){return this.relativeParsedExpr&&this.relativeParsedExpr(o,n,c)||this.absoluteParsedExpr&&this.absoluteParsedExpr(R.join(this.root,o),n,c)}getBasenameTerms(){const o=[];return this.absoluteParsedExpr&&o.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&o.push(...y.getBasenameTerms(this.relativeParsedExpr)),o}getPathTerms(){const o=[];return this.absoluteParsedExpr&&o.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&o.push(...y.getPathTerms(this.relativeParsedExpr)),o}}function r(s){const o=s.trim().split(`
`),n=o[0].trim();if(n.startsWith("Error parsing regex"))return n;if(n.startsWith("regex parse error"))return f.uppercaseFirstLetter(o[o.length-1].trim());if(n.startsWith("error parsing glob")||n.startsWith("unsupported encoding"))return n.charAt(0).toUpperCase()+n.substr(1);if(n==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(n.startsWith("Literal "))return n}e.rgErrorMsgForDisplay=r}),define(me[127],pe([0,1,38,288,98,14,54,33,7,9,2,31,124,289,274,90]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const S=l.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class g{constructor(h){this.outputChannel=h}provideTextSearchResults(h,v,A,F){return this.outputChannel.appendLine(`provideTextSearchResults ${h.pattern}, ${JSON.stringify(Object.assign(Object.assign({},v),{folder:v.folder.toString()}))}`),new Promise((x,j)=>{F.onCancellationRequested(()=>M());const G=r(h,v),B=v.folder.fsPath,J=G.map(we=>we.match(/^-/)?we:`'${we}'`).join(" ");this.outputChannel.appendLine(`${S} ${J}
 - cwd: ${B}`);let O=_.spawn(S,G,{cwd:B});O.on("error",we=>{console.error(we),this.outputChannel.appendLine("Error: "+(we&&we.message)),j((0,k.serializeSearchError)(new k.SearchError(we&&we.message,k.SearchErrorCode.rgProcessError)))});let N=!1;const U=new u(v.maxResults,B,v.previewOptions);U.on("result",we=>{N=!0,K="",A.report(we)});let L=!1;const M=()=>{L=!0,O&&O.kill(),U&&U.cancel()};let V=!1;U.on("hitLimit",()=>{V=!0,M()});let K="";O.stdout.on("data",we=>{U.handleData(we),N||(K+=we)});let se=!1;O.stdout.once("data",()=>se=!0);let ce="";O.stderr.on("data",we=>{const Te=we.toString();this.outputChannel.appendLine(Te),ce+=Te}),O.on("close",()=>{if(this.outputChannel.appendLine(se?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(N?"Got result from parser":"No result from parser"),K&&this.outputChannel.appendLine(`Got data without result: ${K}`),this.outputChannel.appendLine(""),L)x({limitHit:V});else{U.flush(),O=null;let we;ce&&!se&&(we=b(ce))?j((0,k.serializeSearchError)(new k.SearchError(we.message,we.code))):x({limitHit:V})}})})}}e.RipgrepTextSearchEngine=g;function b(E){const h=E.split(`
`),v=h[0].trim();if(h.some(F=>F.startsWith("regex parse error")))return new k.SearchError(d(h),k.SearchErrorCode.regexParseError);const A=v.match(/grep config error: unknown encoding: (.*)/);if(A)return new k.SearchError(`Unknown encoding: ${A[1]}`,k.SearchErrorCode.unknownEncoding);if(v.startsWith("error parsing glob"))return new k.SearchError(v.charAt(0).toUpperCase()+v.substr(1),k.SearchErrorCode.globParseError);if(v.startsWith("the literal"))return new k.SearchError(v.charAt(0).toUpperCase()+v.substr(1),k.SearchErrorCode.invalidLiteral);if(v.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(v,k.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function d(E){const h=["Regex parse error"],v=E.filter(A=>A.startsWith("PCRE2:"));if(v.length>=1){const A=v[0].replace("PCRE2:","");if(A.indexOf(":")!==-1&&A.split(":").length>=2){const F=A.split(":")[1];h.push(":"+F)}}return h.join("")}e.buildRegexParseError=d;class u extends D.EventEmitter{constructor(h,v,A){super();this.maxResults=h,this.rootFolder=v,this.previewOptions=A,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new R.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(h,v){return super.on(h,v),this}handleData(h){if(!this.isDone){const v=typeof h=="string"?h:this.stringDecoder.write(h);this.handleDecodedData(v)}}handleDecodedData(h){let v=h.indexOf(`
`);const A=this.remainder+h;if(v>=0)v+=this.remainder.length;else{this.remainder=A;return}let F=0;for(;v>=0;)this.handleLine(A.substring(F,v).trim()),F=v+1,v=A.indexOf(`
`,F);this.remainder=A.substring(F)}handleLine(h){if(!(this.isDone||!h)){let v;try{v=JSON.parse(h)}catch(A){throw new Error(`malformed line from rg: ${h}`)}if(v.type==="match"){const A=a(v.data.path),F=T.URI.file(y.join(this.rootFolder,A)),x=this.createTextSearchMatch(v.data,F);this.onResult(x),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(v.type==="context"){const A=a(v.data.path),F=T.URI.file(y.join(this.rootFolder,A));this.createTextSearchContext(v.data,F).forEach(j=>this.onResult(j))}}}createTextSearchMatch(h,v){const A=h.line_number-1;let F=!1,x=a(h.lines);A===0&&(0,i.startsWithUTF8BOM)(x)&&(F=!0,x=(0,i.stripUTF8BOM)(x));const j=Buffer.from(x);let G=0,B=0,J=A;h.submatches.length===0&&h.submatches.push(x.length?{start:0,end:1,match:{text:x[0]}}:{start:0,end:0,match:{text:""}});const O=(0,I.coalesce)(h.submatches.map((N,U)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let L=a(N.match);A===0&&U===0&&F&&(L=(0,i.stripUTF8BOM)(L),N.start=N.start<=3?0:N.start-3,N.end=N.end<=3?0:N.end-3);const M=j.slice(G,N.start).toString().length,V=B+M,K=t(L),se=J,ce=K.numLines+se,we=K.numLines>0?K.lastLineLength:K.lastLineLength+V;return G=N.end,B=we,J=ce,new w.Range(se,V,ce,we)}));return(0,m.createTextSearchResult)(v,x,O,this.previewOptions)}createTextSearchContext(h,v){const A=a(h.lines),F=h.line_number;return A.replace(/\r?\n$/,"").split(`
`).map((x,j)=>({text:x,uri:v,lineNumber:F+j}))}onResult(h){this.emit("result",h)}}e.RipgrepParser=u;function a(E){return E.bytes?Buffer.from(E.bytes,"base64").toString():E.text}function t(E){const h=/\n/g;let v=0,A=-1,F;for(;F=h.exec(E);)v++,A=F.index;const x=A>=0?E.length-A-1:E.length;return{numLines:v,lastLineLength:x}}function r(E,h){const v=["--hidden"];v.push(E.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:A,otherIncludes:F}=(0,C.groupBy)(h.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const j=new Set;F.forEach(G=>{j.add(G)}),v.push("-g","!*"),j.forEach(G=>{s(G).map(m.anchorGlob).forEach(B=>{v.push("-g",B)})})}A&&A.length&&A.forEach(j=>{v.push("-g",j)}),h.excludes.map(m.anchorGlob).forEach(j=>v.push("-g",`!${j}`)),h.maxFileSize&&v.push("--max-filesize",h.maxFileSize+""),h.useIgnoreFiles?v.push("--no-ignore-parent"):v.push("--no-ignore"),h.followSymlinks&&v.push("--follow"),h.encoding&&h.encoding!=="utf8"&&v.push("--encoding",h.encoding),E.pattern==="--"&&(E.isRegExp=!0,E.pattern="\\-\\-"),E.isMultiline&&!E.isRegExp&&(E.pattern=(0,i.escapeRegExpCharacters)(E.pattern),E.isRegExp=!0),h.usePCRE2&&v.push("--pcre2"),v.push("--crlf"),E.isRegExp&&(E.pattern=o(E.pattern),v.push("--auto-hybrid-regex"));let x;if(E.isWordMatch){const G=(0,i.createRegExp)(E.pattern,!!E.isRegExp,{wholeWord:E.isWordMatch}).source.replace(/\\\//g,"/");v.push("--regexp",G)}else if(E.isRegExp){let j=c(E.pattern);j=p(j),v.push("--regexp",j)}else x=E.pattern,v.push("--fixed-strings");return v.push("--no-config"),h.useGlobalIgnoreFiles||v.push("--no-ignore-global"),v.push("--json"),E.isMultiline&&v.push("--multiline"),h.beforeContext&&v.push("--before-context",h.beforeContext+""),h.afterContext&&v.push("--after-context",h.afterContext+""),v.push("--"),x&&v.push(x),v.push("."),v}function s(E){const h=(0,P.splitGlobAware)(E,"/");return h.map((v,A)=>h.slice(0,A+1).join("/"))}e.spreadGlobComponents=s;function o(E){const h=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;E.match(h);)E=E.replace(h,"$1\\x{$2}");const v=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;E.match(v);)E=E.replace(v,"$1\\x{$2}");return E}e.unicodeEscapesToPCRE2=o;const n=E=>E.type==="Assertion"&&E.kind==="lookbehind";function c(E){let h;try{h=new f.RegExpParser().parsePattern(E)}catch(G){return E}let v="",A=0;const F=(G,B,J)=>{v+=E.slice(A,G)+J,A=B},x=[];return new f.RegExpVisitor({onCharacterEnter(G){if(G.raw==="\\n"){const B=x[0];if(!B)F(G.start,G.end,"\\r?\\n");else if(!x.some(n))if(B.type==="CharacterClass"){const J=E.slice(B.start+1,G.start)+E.slice(G.end,B.end-1);F(B.start,B.end,J===""?"\\r?\\n":`(?:[${J}]|\\r?\\n)`)}else B.type==="Quantifier"&&F(G.start,G.end,"(?:\\r?\\n)")}},onQuantifierEnter(G){x.unshift(G)},onQuantifierLeave(){x.shift()},onCharacterClassRangeEnter(G){x.unshift(G)},onCharacterClassRangeLeave(){x.shift()},onCharacterClassEnter(G){x.unshift(G)},onCharacterClassLeave(){x.shift()},onAssertionEnter(G){n(G)&&x.push(G)},onAssertionLeave(G){x[0]===G&&x.shift()}}).visit(h),v+=E.slice(A),v}e.fixRegexNewline=c;function p(E){return E.replace(/\n/g,"\\r?\\n")}e.fixNewline=p}),define(me[276],pe([0,1,21,127,110,11]),function(Z,e,_,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class C{constructor(i){this.outputChannel=i,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(i,T,k,w){const f=new D.RipgrepTextSearchEngine(this.outputChannel);if(T.folder.scheme===I.Schemas.userData){const l=Object.assign(Object.assign({},T),{folder:T.folder.with({scheme:I.Schemas.file})}),m=new R.Progress(S=>k.report(Object.assign(Object.assign({},S),{uri:S.uri.with({scheme:T.folder.scheme})})));return this.withToken(w,S=>f.provideTextSearchResults(i,l,m,S))}else return this.withToken(w,l=>f.provideTextSearchResults(i,T,k,l))}async withToken(i,T){const k=P(i);this.inProgress.add(k);const w=await T(k.token);return this.inProgress.delete(k),w}dispose(){this.inProgress.forEach(i=>i.cancel())}}e.RipgrepSearchProvider=C;function P(y){const i=new _.CancellationTokenSource;return y.onCancellationRequested(()=>i.cancel()),i}}),define(me[277],pe([0,1,25,127,126]),function(Z,e,_,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class I{constructor(y){this.query=y}search(y,i,T){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(f){T({message:f})}},w=new R.NativeTextSearchManager(this.query,new D.RipgrepTextSearchEngine(k),_);return new Promise((f,l)=>w.search(m=>{i(m.map(C))},y).then(m=>f({limitHit:m.limitHit,type:"success"}),l))}}e.TextSearchEngineAdapter=I;function C(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((y,i)=>{if(i.ranges){const T=i;return y+(Array.isArray(T.ranges)?T.ranges.length:1)}else return y+1},0)}}}),define(me[278],pe([0,1,34,290,14,19,18,3,96,7,46,2,25,31,275,277]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,D.gracefulify(_);class S{constructor(){this.caches=Object.create(null)}fileSearch(t){let r;const s=d(t),o=new P.Emitter({onFirstListenerDidAdd:()=>{r=(0,I.createCancelablePromise)(n=>this.doFileSearchWithEngine(l.Engine,s,c=>o.fire(c),n)),r.then(n=>o.fire(n),n=>o.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return o.event}textSearch(t){let r;const s=d(t),o=new P.Emitter({onFirstListenerDidAdd:()=>{r=(0,I.createCancelablePromise)(n=>this.ripgrepTextSearch(s,c=>o.fire(c),n)),r.then(n=>o.fire(n),n=>o.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return o.event}ripgrepTextSearch(t,r,s){return t.maxFileSize=w.MAX_FILE_SIZE,new m.TextSearchEngineAdapter(t).search(s,r,r)}doFileSearch(t,r,s){return this.doFileSearchWithEngine(l.Engine,t,r,s)}doFileSearchWithEngine(t,r,s,o,n=S.BATCH_SIZE){let c=0;const p=h=>{Array.isArray(h)?(c+=h.length,s(h.map(v=>this.rawMatchToSearchItem(v)))):h.relativePath?(c++,s(this.rawMatchToSearchItem(h))):s(h)};if(r.sortByScore){let h=this.trySortedSearchFromCache(r,p,o);if(!h){const v=r.maxResults?Object.assign({},r,{maxResults:null}):r,A=new t(v);h=this.doSortedSearch(A,r,s,p,o)}return new Promise((v,A)=>{h.then(([F,x])=>{const j=x.map(G=>this.rawMatchToSearchItem(G));this.sendProgress(j,s,n),v(F)},A)})}const E=new t(r);return this.doSearch(E,p,n,o).then(h=>({limitHit:h.limitHit,type:"success",stats:{detailStats:h.stats,type:"searchProcess",fromCache:!1,resultCount:c,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,i.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,r,s,o,n){const c=new P.Emitter;let p=(0,I.createCancelablePromise)(h=>{let v=[];const A=F=>{Array.isArray(F)?v=F:(o(F),c.fire(F))};return this.doSearch(t,A,-1,h).then(F=>[F,v])}),E;if(r.cacheKey){E=this.getOrCreateCache(r.cacheKey);const h={promise:p,event:c.event,resolved:!1};E.resultsToSearchCache[r.filePattern||""]=h,p.then(()=>{h.resolved=!0},v=>{delete E.resultsToSearchCache[r.filePattern||""]}),p=this.preventCancellation(p)}return p.then(([h,v])=>{const A=E?E.scorerCache:Object.create(null),F=(typeof r.maxResults!="number"||r.maxResults>0)&&T.StopWatch.create(!1);return this.sortResults(r,v,A,n).then(x=>{const j=F?F.elapsed():-1;return[{type:"success",stats:{detailStats:h.stats,sortingTime:j,fromCache:!1,type:"searchProcess",workspaceFolderCount:r.folderQueries.length,resultCount:x.length},limitHit:h.limitHit||typeof r.maxResults=="number"&&v.length>r.maxResults},x]})})}getOrCreateCache(t){const r=this.caches[t];return r||(this.caches[t]=new g)}trySortedSearchFromCache(t,r,s){const o=t.cacheKey&&this.caches[t.cacheKey];if(!!o){const n=this.getResultsFromCache(o,t.filePattern||"",r,s);if(n)return n.then(([c,p,E])=>{const h=T.StopWatch.create(!1);return this.sortResults(t,p,o.scorerCache,s).then(v=>{const A=h.elapsed(),F={fromCache:!0,detailStats:E,type:"searchProcess",resultCount:p.length,sortingTime:A};return[{type:"success",limitHit:c.limitHit||typeof t.maxResults=="number"&&p.length>t.maxResults,stats:F},v]})})}}sortResults(t,r,s,o){const n=(0,y.prepareQuery)(t.filePattern||""),c=(E,h)=>(0,y.compareItemsByFuzzyScore)(E,h,n,!0,b,s),p=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return R.topAsync(r,c,p,1e4,o)}sendProgress(t,r,s){if(s&&s>0)for(let o=0;o<t.length;o+=s)r(t.slice(o,o+s));else r(t)}getResultsFromCache(t,r,s,o){const n=T.StopWatch.create(!1),c=r.indexOf(i.sep)>=0;let p;for(const A in t.resultsToSearchCache)if(r.startsWith(A)){if(c&&A.indexOf(i.sep)<0&&A!=="")continue;const F=t.resultsToSearchCache[A];p={promise:this.preventCancellation(F.promise),event:F.event,resolved:F.resolved};break}if(!p)return null;const E=n.elapsed(),h=T.StopWatch.create(!1),v=p.event(s);return o&&o.onCancellationRequested(()=>{v.dispose()}),p.promise.then(([A,F])=>{if(o&&o.isCancellationRequested)throw(0,C.canceled)();const x=[],j=(0,y.prepareQuery)(r).normalizedLowercase;for(const G of F)!(0,f.isFilePatternMatch)(G,j)||x.push(G);return[A,x,{cacheWasResolved:p.resolved,cacheLookupTime:E,cacheFilterTime:h.elapsed(),cacheEntryCount:F.length}]})}doSearch(t,r,s,o){return new Promise((n,c)=>{let p=[];o&&o.onCancellationRequested(()=>t.cancel()),t.search(E=>{E&&(s?(p.push(E),s>0&&p.length>=s&&(r(p),p=[])):r(E))},E=>{r(E)},(E,h)=>{p.length&&r(p),E?c(E):n(h)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(r,s){return t.then(r,s)}catch(r){return this.then(void 0,r)}finally(r){return t.finally(r)}}}}e.SearchService=S,S.BATCH_SIZE=512;class g{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(a){return(0,i.basename)(a.relativePath)}getItemDescription(a){return(0,i.dirname)(a.relativePath)}getItemPath(a){return a.relativePath}};function d(a){return Object.assign(Object.assign({},a),{folderQueries:a.folderQueries&&a.folderQueries.map(u),extraFileResources:a.extraFileResources&&a.extraFileResources.map(t=>k.URI.revive(t))})}function u(a){return Object.assign(Object.assign({},a),{folder:k.URI.revive(a.folder)})}}),define(me[279],pe([0,1,6,2,25,12,31,278,276,90,13,63,27,69,11,126]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let S=class extends f.ExtHostSearch{constructor(b,d,u,a){super(b,u,a);this._pfs=R,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new i.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(l.Schemas.userData,new y.RipgrepSearchProvider(t)),d.remote.isRemote&&d.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const b=new i.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(l.Schemas.file,new y.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(l.Schemas.file,new P.SearchService)}registerInternalFileSearchProvider(b,d){const u=this._handlePool++;return this._internalFileSearchProvider=d,this._internalFileSearchHandle=u,this._proxy.$registerFileSearchProvider(u,this._transformScheme(b)),(0,_.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(u)})}$provideFileSearchResults(b,d,u,a){const t=(0,f.reviveQuery)(u);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,d,t,a):super.$provideFileSearchResults(b,d,u,a)}doInternalFileSearch(b,d,u,a){const t=r=>{if((0,C.isSerializedFileMatch)(r)&&(r=[r]),Array.isArray(r)){this._proxy.$handleFileMatch(b,d,r.map(s=>D.URI.file(s.path)));return}r.message&&this._logService.debug("ExtHostSearch",r.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(u,t,a)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,d){return new m.NativeTextSearchManager(b,d)}};S=Ve([xe(0,T.IExtHostRpcService),xe(1,w.IExtHostInitDataService),xe(2,k.IURITransformerService),xe(3,I.ILogService)],S),e.NativeExtHostSearch=S}),define(me[128],pe([0,1,291,118,292,3,100,7,43,28,6,26,101,18,10]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(p){this.socket=p}dispose(){this.socket.destroy()}onData(p){const E=h=>p(k.VSBuffer.wrap(h));return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(p){return this.socket.on("close",p),{dispose:()=>this.socket.off("close",p)}}onEnd(p){return this.socket.on("end",p),{dispose:()=>this.socket.off("end",p)}}write(p){if(!this.socket.destroyed)try{this.socket.write(p.buffer)}catch(E){if(E.code==="EPIPE")return;(0,f.onUnexpectedError)(E)}}end(){this.socket.end()}drain(){return new Promise((p,E)=>{if(this.socket.bufferSize===0){p();return}const h=()=>{this.socket.off("close",h),this.socket.off("end",h),this.socket.off("error",h),this.socket.off("timeout",h),this.socket.off("drain",h),p()};this.socket.on("close",h),this.socket.on("end",h),this.socket.on("error",h),this.socket.on("timeout",h),this.socket.on("drain",h)})}}e.NodeSocket=m;var S;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var g;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(g||(g={}));class b extends T.Disposable{constructor(p,E,h,v){super();this._onDidZlibFlush=this._register(new I.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=p,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=E,this._recordInflateBytes=v,E?(this._zlibInflate=R.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",A=>{console.error(A),(0,f.onUnexpectedError)(A),this._onClose.fire()}),this._zlibInflate.on("data",A=>{this._pendingInflateData.push(A)}),h&&(this._zlibInflate.write(h.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=R.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{console.error(A),(0,f.onUnexpectedError)(A),this._onClose.fire()}),this._zlibDeflate.on("data",A=>{this._pendingDeflateData.push(A)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new w.ChunkStream,this._register(this.socket.onData(A=>this._acceptChunk(A))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):k.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this._onData.event(p)}onClose(p){return this._onClose.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){this._totalOutgoingDataBytes+=p.byteLength,this._zlibDeflate?(this._zlibDeflate.write(p.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let E=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,E=E.slice(0,E.length-4),this._isEnded||this._write(k.VSBuffer.wrap(E),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(p,!1)}_write(p,E){let h=2;p.byteLength<126?h+=0:p.byteLength<2**16?h+=2:h+=8;const v=k.VSBuffer.alloc(h);if(E?v.writeUInt8(194,0):v.writeUInt8(130,0),p.byteLength<126)v.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){v.writeUInt8(126,1);let A=1;v.writeUInt8(p.byteLength>>>8&255,++A),v.writeUInt8(p.byteLength>>>0&255,++A)}else{v.writeUInt8(127,1);let A=1;v.writeUInt8(0,++A),v.writeUInt8(0,++A),v.writeUInt8(0,++A),v.writeUInt8(0,++A),v.writeUInt8(p.byteLength>>>24&255,++A),v.writeUInt8(p.byteLength>>>16&255,++A),v.writeUInt8(p.byteLength>>>8&255,++A),v.writeUInt8(p.byteLength>>>0&255,++A)}this._totalOutgoingWireBytes+=v.byteLength+p.byteLength,this.socket.write(k.VSBuffer.concat([v,p]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(p){if(p.byteLength!==0){for(this._totalIncomingWireBytes+=p.byteLength,this._incomingData.acceptChunk(p);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const E=this._incomingData.peek(this._state.readLen),v=(E.readUInt8(0)&128)>>>7,A=E.readUInt8(1),F=(A&128)>>>7,x=A&127;this._state.state=2,this._state.readLen=2+(F?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=v,this._state.mask=0}else if(this._state.state===2){const E=this._incomingData.read(this._state.readLen),h=E.readUInt8(1),v=(h&128)>>>7;let A=h&127,F=1;A===126?A=E.readUInt8(++F)*2**8+E.readUInt8(++F):A===127&&(A=E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*2**24+E.readUInt8(++F)*2**16+E.readUInt8(++F)*2**8+E.readUInt8(++F));let x=0;v&&(x=E.readUInt8(++F)*2**24+E.readUInt8(++F)*2**16+E.readUInt8(++F)*2**8+E.readUInt8(++F)),this._state.state=3,this._state.readLen=A,this._state.mask=x}else if(this._state.state===3){const E=this._incomingData.read(this._state.readLen);d(E,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(E.buffer)),this._zlibInflate.write(E.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const h=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=h.length,this._onData.fire(k.VSBuffer.wrap(h))})):(this._totalIncomingDataBytes+=E.byteLength,this._onData.fire(E))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await I.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=b;function d(c,p){if(p!==0){let E=c.byteLength>>>2;for(let j=0;j<E;j++){const G=c.readUInt32BE(j*4);c.writeUInt32BE(G^p,j*4)}let h=E*4,v=c.byteLength-h;const A=p>>>24&255,F=p>>>16&255,x=p>>>8&255;v>=1&&c.writeUInt8(c.readUInt8(h)^A,h),v>=2&&c.writeUInt8(c.readUInt8(h+1)^F,h+1),v>=3&&c.writeUInt8(c.readUInt8(h+2)^x,h+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const u={[2]:107,[1]:103};function a(){const c=(0,i.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let p;return e.XDG_RUNTIME_DIR?p=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):p=(0,P.join)((0,y.tmpdir)(),`vscode-ipc-${c}.sock`),r(p),p}e.createRandomIPCHandle=a;function t(c,p,E){const h=(0,_.createHash)("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${h}-${E}-${p}-sock`;let v;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?v=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${h.substr(0,8)}-${E}-${p}.sock`):v=(0,P.join)(c,`${E}-${p}.sock`),r(v),v}e.createStaticIPCHandle=t;function r(c){const p=u[l.platform];typeof p=="number"&&c.length>=p&&console.warn(`WARNING: IPC handle "${c}" is longer than ${p} chars, try a shorter --user-data-dir`)}class s extends C.IPCServer{constructor(p){super(s.toClientConnectionEvent(p));this.server=p}static toClientConnectionEvent(p){const E=I.Event.fromNodeEventEmitter(p,"connection");return I.Event.map(E,h=>({protocol:new w.Protocol(new m(h)),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(h,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function o(c){return new Promise((p,E)=>{const h=(0,D.createServer)();h.on("error",E),h.listen(c,()=>{h.removeListener("error",E),p(new s(h))})})}e.serve=o;function n(c,p){return new Promise((E,h)=>{const v=(0,D.createConnection)(c,()=>{v.removeListener("error",h),E(w.Client.fromSocket(new m(v),p))});v.once("error",h)})}e.connect=n}),define(me[280],pe([0,1,128,272,34,52,2,114,12]),function(Z,e,_,D,R,I,C,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class i{constructor(w,f,l){this._commands=w,this.logService=f,this._ipcHandlePath=l,this._server=D.createServer((m,S)=>this.onRequest(m,S)),this.setup().catch(m=>(f.error(m),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",w=>this.logService.error(w))}catch(w){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(w,f){const l=[];w.setEncoding("utf8"),w.on("data",m=>l.push(m)),w.on("end",()=>{const m=JSON.parse(l.join(""));switch(m.type){case"open":this.open(m,f);break;case"openExternal":this.openExternal(m,f);break;case"status":this.getStatus(m,f);break;case"command":this.runCommand(m,f).catch(this.logService.error);break;case"extensionManagement":this.manageExtensions(m,f).catch(this.logService.error);break;default:f.writeHead(404),f.write(`Unknown message type: ${m.type}`,S=>{S&&this.logService.error(S)}),f.end();break}})}open(w,f){let{fileURIs:l,folderURIs:m,forceNewWindow:S,diffMode:g,addMode:b,forceReuseWindow:d,gotoLineMode:u,waitMarkerFilePath:a}=w;const t=[];if(Array.isArray(m))for(const r of m)try{t.push({folderUri:C.URI.parse(r)})}catch(s){}if(Array.isArray(l))for(const r of l)try{(0,P.hasWorkspaceFileExtension)(r)?t.push({workspaceUri:C.URI.parse(r)}):t.push({fileUri:C.URI.parse(r)})}catch(s){}if(t.length){const r=a?C.URI.file(a):void 0,o={forceNewWindow:S,diffMode:g,addMode:b,gotoLineMode:u,forceReuseWindow:d,preferNewWindow:!d&&!r&&!b,waitMarkerFileURI:r};this._commands.executeCommand("_files.windowOpen",t,o)}f.writeHead(200),f.end()}async openExternal(w,f){for(const l of w.uris){const m=C.URI.parse(l),S=m.scheme==="file"?m:l;await this._commands.executeCommand("_remoteCLI.openExternal",S)}f.writeHead(200),f.end()}async manageExtensions(w,f){console.log("server: manageExtensions");try{const l=g=>g==null?void 0:g.map(b=>/\.vsix$/i.test(b)?C.URI.parse(b):b),m={list:w.list,install:l(w.install),uninstall:l(w.uninstall),force:w.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",m,{allowTunneling:!0});f.writeHead(200),f.write(S)}catch(l){f.writeHead(500),f.write(String(l))}f.end()}async getStatus(w,f){try{const l=await this._commands.executeCommand("_issues.getSystemStatus");f.writeHead(200),f.write(l),f.end()}catch(l){f.writeHead(500),f.write(String(l),m=>{m&&this.logService.error(m)}),f.end()}}async runCommand(w,f){try{const{command:l,args:m}=w,S=await this._commands.executeCommand(l,...m);f.writeHead(200),f.write(JSON.stringify(S),g=>{g&&this.logService.error(g)}),f.end()}catch(l){f.writeHead(500),f.write(String(l),m=>{m&&this.logService.error(m)}),f.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&R.existsSync(this._ipcHandlePath)&&R.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=i;let T=class extends i{constructor(w,f){super(w,f,(0,_.createRandomIPCHandle)())}};T=Ve([xe(0,I.IExtHostCommands),xe(1,y.ILogService)],T),e.CLIServer=T}),define(me[281],pe([0,1,68,266,260,5,271,42,251,2,11,8,280]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class f extends R.RequireInterceptor{_installInterceptor(){const S=this,g=Z.__$__nodeRequire("module"),b=g._load;g._load=function(u,a,t){for(let r of S._alternatives){let s=r(u);if(s){u=s;break}}return S._factories.has(u)?S._factories.get(u).load(u,i.URI.file(a.filename),r=>b.apply(this,[r,a,t])):b.apply(this,arguments)}}}class l extends P.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=k.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const S=this._instaService.invokeFunction(D.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(y.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const a=this._instaService.createInstance(w.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}await this._instaService.createInstance(f,S,this._registry).install(),_.mark("code/extHost/didInitAPI");const b=await this._extHostConfiguration.getConfigProvider();await(0,C.connectProxyResolver)(this._extHostWorkspace,b,this,this._logService,this._mainThreadTelemetryProxy,this._initData),_.mark("code/extHost/didInitProxyResolver");const d=process.send,u=this._extHostContext.getProxy(I.MainContext.MainThreadConsole);process.send=(...a)=>a.length===0||!a[0]||a[0].type!=="__$console"?d.apply(process,a):(u.$logExtensionHostMessage(a[0]),!1)}_getEntryPoint(S){return S.main}_loadCommonJSModule(S,g,b){if(g.scheme!==T.Schemas.file)throw new Error(`Cannot load URI: '${g}', must be of file-scheme`);let d=null;b.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${g.toString(!0)}`),this._logService.flush();try{S&&_.mark(`code/extHost/willLoadExtensionCode/${S.value}`),d=Z.__$__nodeRequire(g.fsPath)}catch(u){return Promise.reject(u)}finally{S&&_.mark(`code/extHost/didLoadExtensionCode/${S.value}`),b.codeLoadingStop()}return Promise.resolve(d)}async $setRemoteEnvironment(S){if(!!this._initData.remote.isRemote)for(const g in S){const b=S[g];b===null?delete process.env[g]:process.env[g]=b}}}e.ExtHostExtensionService=l}),define(me[282],pe([0,1,80,252,263,262,261,279,281,224,253,45,42,65,69,67,35,50,12]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l,m,S,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(w.IExtHostExtensionService,y.ExtHostExtensionService),(0,_.registerSingleton)(b.ILogService,i.ExtHostLogService),(0,_.registerSingleton)(k.IExtHostDebugService,C.ExtHostDebugService),(0,_.registerSingleton)(f.IExtHostOutputService,D.ExtHostOutputService2),(0,_.registerSingleton)(l.IExtHostSearch,P.NativeExtHostSearch),(0,_.registerSingleton)(m.IExtHostTask,I.ExtHostTask),(0,_.registerSingleton)(S.IExtHostTerminalService,R.ExtHostTerminalService),(0,_.registerSingleton)(g.IExtHostTunnelService,T.ExtHostTunnelService)}),define(me[283],pe([0,1,118,293,68,18,101,128,184,222,264,26,97,25,135,19,267,282]),function(Z,e,_,D,R,I,C,P,y,i,T,k,w,f,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let o=0;o<process.execArgv.length;o++)process.execArgv[o]==="--inspect-port=0"&&(process.execArgv.splice(o,1),o--)}();const S=D(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const s=Z.__$__nodeRequire("module"),o=s._load;s._load=function(n){if(n==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return o.apply(this,arguments)}})();const g=process.exit.bind(process);function b(s){process.exit=function(o){if(s)g(o);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const o=new Error("An extension called process.crash() and this was prevented.");console.warn(o.stack)}}let d=function(s){g()};function u(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((s,o)=>{let n=null,c=setTimeout(()=>{o(new Error("VSCODE_EXTHOST_IPC_SOCKET timeout"))},6e4);const p=108e5,E=3e5,h=new m.RunOnceScheduler(()=>d("renderer disconnected for too long (1)"),p),v=new m.RunOnceScheduler(()=>d("renderer disconnected for too long (2)"),E);process.on("message",(F,x)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){const j=k.VSBuffer.wrap(Buffer.from(F.initialDataChunk,"base64"));let G;if(F.skipWebSocketFrames)G=new P.NodeSocket(x);else{const B=k.VSBuffer.wrap(Buffer.from(F.inflateBytes,"base64"));G=new P.WebSocketNodeSocket(new P.NodeSocket(x),F.permessageDeflate,B,!1)}n?(h.cancel(),v.cancel(),n.beginAcceptReconnection(G,j),n.endAcceptReconnection()):(clearTimeout(c),n=new C.PersistentProtocol(G,j),n.onDidDispose(()=>d("renderer disconnected")),s(n),n.onSocketClose(()=>{h.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(v.isScheduled())return;h.isScheduled()&&v.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(A)});{const s=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((o,n)=>{const c=_.createConnection(s,()=>{c.removeListener("error",n),o(new C.PersistentProtocol(new P.NodeSocket(c)))});c.once("error",n)})}}async function a(){const s=await u();return new class{constructor(){this._onMessage=new C.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,s.onMessage(o=>{(0,i.isMessageOfType)(o,2)?(this._terminating=!0,d("received terminate message from renderer")):this._onMessage.fire(o)})}send(o){this._terminating||s.send(o)}drain(){return s.drain()}}}function t(s){return new Promise(o=>{const n=s.onMessage(c=>{n.dispose();const p=JSON.parse(c.toString()),E=p.commit,h=y.default.commit;E&&h&&E!==h&&g(55);const v=[];process.on("unhandledRejection",(x,j)=>{v.push(j),setTimeout(()=>{const G=v.indexOf(j);G>=0&&j.catch(B=>{v.splice(G,1),console.warn(`rejected promise not handled within 1 second: ${B}`),B&&B.stack&&console.warn(`stack trace: ${B.stack}`),(0,I.onUnexpectedError)(x)})},1e3)}),process.on("rejectionHandled",x=>{const j=v.indexOf(x);j>=0&&v.splice(j,1)}),process.on("uncaughtException",function(x){(0,I.onUnexpectedError)(x)});let A=0;setInterval(function(){try{process.kill(p.parentPid,0),A=0}catch(x){x&&x.code==="EPERM"?(A++,A>=3&&d(`parent process ${p.parentPid} does not exist anymore (3 x EPERM): ${x.message} (code: ${x.code}) (errno: ${x.errno})`)):d(`parent process ${p.parentPid} does not exist anymore: ${x.message} (code: ${x.code}) (errno: ${x.errno})`)}},1e3);let F;try{F=Z.__$__nodeRequire("native-watchdog"),F.start(p.parentPid)}catch(x){(0,I.onUnexpectedError)(x)}s.send((0,i.createMessageOfType)(0)),o({protocol:s,initData:p})});s.send((0,i.createMessageOfType)(1))})}async function r(){R.mark("code/extHost/willConnectToRenderer");const s=await a();R.mark("code/extHost/didConnectToRenderer");const o=await t(s);R.mark("code/extHost/didWaitForInitData");const{initData:n}=o;b(!!n.environment.extensionTestsLocationURI),n.environment.useHostProxy=S.useHostProxy!==void 0?S.useHostProxy!=="false":void 0;const c=new class{exit(v){g(v)}exists(v){return(0,f.exists)(v)}realpath(v){return(0,l.realpath)(v)}};let p=null;if(n.remote.authority&&S.uriTransformerPath)try{const v=Z.__$__nodeRequire(S.uriTransformerPath)(n.remote.authority);p=new w.URITransformer(v)}catch(h){console.error(h)}const E=new T.ExtensionHostMain(o.protocol,n,c,p);d=h=>E.terminate(h)}e.startExtensionHostProcess=r}),define(me[294],pe([0,1,283]),function(Z,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.startExtensionHostProcess)().catch(D=>console.log(D))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5d80c30e5b6ce8b2f5336ed55ad043490b0b818f/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
