/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/base/common/network","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/platform/log/common/log","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/linkedList","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(re){for(var e=[],_=0,S=re.length;_<S;_++)e[_]=we[re[_]];return e};define(we[44],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function _(S,T){if(!S)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}e.ok=_}),define(we[51],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const _=Object.prototype.hasOwnProperty;function S(A){const I=[];for(let p in A)_.call(A,p)&&I.push(A[p]);return I}e.values=S;function T(A,I){for(let p in A)if(_.call(A,p)&&I({key:p,value:A[p]},function(){delete A[p]})===!1)return}e.forEach=T;function P(A,I){const p=Object.create(null);for(const f of A){const s=I(f);let h=p[s];h||(h=p[s]=[]),h.push(f)}return p}e.groupBy=P;function E(A){const I=Object.create(null);return A&&A.forEach((p,f)=>{I[f]=p}),I}e.fromMap=E;function C(A,I){const p=[],f=[];for(let s of A)I.has(s)||p.push(s);for(let s of I)A.has(s)||f.push(s);return{removed:p,added:f}}e.diffSets=C;function D(A,I){const p=[],f=[];for(let[s,h]of A)I.has(s)||p.push(h);for(let[s,h]of I)A.has(s)||f.push(h);return{removed:p,added:f}}e.diffMaps=D;class n{constructor(){this.map=new Map}add(I,p){let f=this.map.get(I);f||(f=new Set,this.map.set(I,f)),f.add(p)}delete(I,p){const f=this.map.get(I);!f||(f.delete(p),f.size===0&&this.map.delete(I))}forEach(I,p){const f=this.map.get(I);!f||f.forEach(p)}}e.SetMap=n}),define(we[45],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function _(D){return(n,A,I)=>{let p=null,f=null;if(typeof I.value=="function"?(p="value",f=I.value):typeof I.get=="function"&&(p="get",f=I.get),!f)throw new Error("not supported");I[p]=D(f,A)}}e.createDecorator=_;let S=0;function T(){const D=`$memoize${S++}`;let n;const A=function(p,f,s){let h=null,v=null;if(typeof s.value=="function"?(h="value",v=s.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof s.get=="function"&&(h="get",v=s.get),!v)throw new Error("not supported");const g=`${D}:${f}`;s[h]=function(...b){return n=this,this.hasOwnProperty(g)||Object.defineProperty(this,g,{configurable:!0,enumerable:!1,writable:!0,value:v.apply(this,b)}),this[g]}};return A.clear=()=>{typeof n!="undefined"&&Object.getOwnPropertyNames(n).forEach(I=>{I.indexOf(D)===0&&delete n[I]})},A}e.createMemoizer=T;function P(D,n,A){return T()(D,n,A)}e.memoize=P;function E(D,n,A){return _((I,p)=>{const f=`$debounce$${p}`,s=`$debounce$result$${p}`;return function(...h){this[s]||(this[s]=A?A():void 0),clearTimeout(this[f]),n&&(this[s]=n(this[s],...h),h=[this[s]]),this[f]=setTimeout(()=>{I.apply(this,h),this[s]=A?A():void 0},D)}})}e.debounce=E;function C(D,n,A){return _((I,p)=>{const f=`$throttle$timer$${p}`,s=`$throttle$result$${p}`,h=`$throttle$lastRun$${p}`,v=`$throttle$pending$${p}`;return function(...g){if(this[s]||(this[s]=A?A():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),n&&(this[s]=n(this[s],...g)),!this[v]){const b=this[h]+D;b<=Date.now()?(this[h]=Date.now(),I.apply(this,[this[s]]),this[s]=A?A():void 0):(this[v]=!0,this[f]=setTimeout(()=>{this[v]=!1,this[h]=Date.now(),I.apply(this,[this[s]]),this[s]=A?A():void 0},b-Date.now()))}}})}e.throttle=C}),define(we[11],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class _{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=_,e.errorHandler=new _;function S(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=S;function T(a){D(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=T;function P(a){D(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=P;function E(a){if(a instanceof Error){let{name:t,message:r}=a;const o=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:o}}return a}e.transformErrorForSerialization=E;const C="Canceled";function D(a){return a instanceof Error&&a.name===C&&a.message===C}e.isPromiseCanceledError=D;class n extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=n;function A(){const a=new Error(C);return a.name=a.message,a}e.canceled=A;function I(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=I;function p(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=p;function f(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function s(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=s;function h(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=h;class v extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=v;class g extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=g;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function c(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=c;function u(a,t=Object.create(null)){const r=new Error(a);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=u}),define(we[14],Ee([0,1,11]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function S(L,N=0){return L[L.length-(1+N)]}e.tail=S;function T(L){if(L.length===0)throw new Error("Invalid tail call");return[L.slice(0,L.length-1),L[L.length-1]]}e.tail2=T;function P(L,N,H=(O,K)=>O===K){if(L===N)return!0;if(!L||!N||L.length!==N.length)return!1;for(let O=0,K=L.length;O<K;O++)if(!H(L[O],N[O]))return!1;return!0}e.equals=P;function E(L,N,H){let O=0,K=L.length-1;for(;O<=K;){const le=(O+K)/2|0,ue=H(L[le],N);if(ue<0)O=le+1;else if(ue>0)K=le-1;else return le}return-(O+1)}e.binarySearch=E;function C(L,N){let H=0,O=L.length;if(O===0)return 0;for(;H<O;){const K=Math.floor((H+O)/2);N(L[K])?O=K:H=K+1}return H}e.findFirstInSorted=C;function D(L,N,H){if(L=L|0,L>=N.length)throw new TypeError("invalid index");let O=N[Math.floor(N.length*Math.random())],K=[],le=[],ue=[];for(let pe of N){const ve=H(pe,O);ve<0?K.push(pe):ve>0?le.push(pe):ue.push(pe)}return L<K.length?D(L,K,H):L<K.length+ue.length?ue[0]:D(L-(K.length+ue.length),le,H)}e.quickSelect=D;function n(L,N){const H=[];let O;for(const K of L.slice(0).sort(N))!O||N(O[0],K)!==0?(O=[K],H.push(O)):O.push(K);return H}e.groupBy=n;function A(L,N,H){const O=[];function K(pe,ve,Re){if(!(ve===0&&Re.length===0)){const He=O[O.length-1];He&&He.start+He.deleteCount===pe?(He.deleteCount+=ve,He.toInsert.push(...Re)):O.push({start:pe,deleteCount:ve,toInsert:Re})}}let le=0,ue=0;for(;;){if(le===L.length){K(le,0,N.slice(ue));break}if(ue===N.length){K(le,L.length-le,[]);break}const pe=L[le],ve=N[ue],Re=H(pe,ve);Re===0?(le+=1,ue+=1):Re<0?(K(le,1,[]),le+=1):Re>0&&(K(le,0,[ve]),ue+=1)}return O}e.sortedDiff=A;function I(L,N,H){const O=A(L,N,H),K=[],le=[];for(const ue of O)K.push(...L.slice(ue.start,ue.start+ue.deleteCount)),le.push(...ue.toInsert);return{removed:K,added:le}}e.delta=I;function p(L,N,H){if(H===0)return[];const O=L.slice(0,H).sort(N);return s(L,N,O,H,L.length),O}e.top=p;function f(L,N,H,O,K){return H===0?Promise.resolve([]):new Promise((le,ue)=>{(async()=>{const pe=L.length,ve=L.slice(0,H).sort(N);for(let Re=H,He=Math.min(H+O,pe);Re<pe;Re=He,He=Math.min(He+O,pe)){if(Re>H&&await new Promise(Fe=>setTimeout(Fe)),K&&K.isCancellationRequested)throw(0,_.canceled)();s(L,N,ve,Re,He)}return ve})().then(le,ue)})}e.topAsync=f;function s(L,N,H,O,K){for(const le=H.length;O<K;O++){const ue=L[O];if(N(ue,H[le-1])<0){H.pop();const pe=C(H,ve=>N(ue,ve)<0);H.splice(pe,0,ue)}}}function h(L){return L.filter(N=>!!N)}e.coalesce=h;function v(L){let N=0;for(let H=0;H<L.length;H++)L[H]&&(L[N]=L[H],N+=1);L.length=N}e.coalesceInPlace=v;function g(L,N,H){L.splice(H,0,L.splice(N,1)[0])}e.move=g;function b(L){return!Array.isArray(L)||L.length===0}e.isFalsyOrEmpty=b;function c(L){return Array.isArray(L)&&L.length>0}e.isNonEmptyArray=c;function u(L,N){if(!N)return L.filter((O,K)=>L.indexOf(O)===K);const H=Object.create(null);return L.filter(O=>{const K=N(O);return H[K]?!1:(H[K]=!0,!0)})}e.distinct=u;function a(L){const N=new Set;return L.filter(H=>N.has(H)?!1:(N.add(H),!0))}e.distinctES6=a;function t(L){const N=Object.create(null);return H=>{const O=L(H);return N[O]?!1:(N[O]=!0,!0)}}e.uniqueFilter=t;function r(L,N){for(let H=L.length-1;H>=0;H--){const O=L[H];if(N(O))return H}return-1}e.lastIndex=r;function o(L,N){return L.length>0?L[0]:N}e.firstOrDefault=o;function l(L,N,H=(O,K)=>O===K){let O=0;for(let K=0,le=Math.min(L.length,N.length);K<le&&H(L[K],N[K]);K++)O++;return O}e.commonPrefixLength=l;function i(L){return[].concat(...L)}e.flatten=i;function d(L,N){let H=typeof N=="number"?L:0;typeof N=="number"?H=L:(H=0,N=L);const O=[];if(H<=N)for(let K=H;K<N;K++)O.push(K);else for(let K=H;K>N;K--)O.push(K);return O}e.range=d;function y(L,N,H){return L.reduce((O,K)=>(O[N(K)]=H?H(K):K,O),Object.create(null))}e.index=y;function k(L,N){return L.push(N),()=>m(L,N)}e.insert=k;function m(L,N){const H=L.indexOf(N);if(H>-1)return L.splice(H,1),N}e.remove=m;function w(L,N,H){const O=L.slice(0,N),K=L.slice(N);return O.concat(H,K)}e.arrayInsert=w;function R(L,N){let H;if(typeof N=="number"){let O=N;H=()=>{const K=Math.sin(O++)*179426549;return K-Math.floor(K)}}else H=Math.random;for(let O=L.length-1;O>0;O-=1){const K=Math.floor(H()*(O+1)),le=L[O];L[O]=L[K],L[K]=le}}e.shuffle=R;function F(L,N){const H=L.indexOf(N);H>-1&&(L.splice(H,1),L.unshift(N))}e.pushToStart=F;function B(L,N){const H=L.indexOf(N);H>-1&&(L.splice(H,1),L.push(N))}e.pushToEnd=B;function Q(L,N){return Array.isArray(L)?L.map(N):N(L)}e.mapArrayOrNot=Q;function J(L){return Array.isArray(L)?L:[L]}e.asArray=J;function z(L){return L[Math.floor(Math.random()*L.length)]}e.getRandomElement=z;function ae(L,N){for(const H of L){const O=N(H);if(O!==void 0)return O}}e.mapFind=ae}),define(we[52],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function _(S){const T=this;let P=!1,E;return function(){return P||(P=!0,E=S.apply(T,arguments)),E}}e.once=_}),define(we[53],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class _{constructor(T){this._prefix=T,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=_,e.defaultGenerator=new _("id#")}),define(we[54],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var _;(function(S){function T(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}S.is=T;const P=Object.freeze([]);function E(){return P}S.empty=E;function*C(a){yield a}S.single=C;function D(a){return a||P}S.from=D;function n(a){return!a||a[Symbol.iterator]().next().done===!0}S.isEmpty=n;function A(a){return a[Symbol.iterator]().next().value}S.first=A;function I(a,t){for(const r of a)if(t(r))return!0;return!1}S.some=I;function p(a,t){for(const r of a)if(t(r))return r}S.find=p;function*f(a,t){for(const r of a)t(r)&&(yield r)}S.filter=f;function*s(a,t){for(const r of a)yield t(r)}S.map=s;function*h(...a){for(const t of a)for(const r of t)yield r}S.concat=h;function*v(a){for(const t of a)for(const r of t)yield r}S.concatNested=v;function g(a,t,r){let o=r;for(const l of a)o=t(o,l);return o}S.reduce=g;function*b(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}S.slice=b;function c(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const o=a[Symbol.iterator]();for(let l=0;l<t;l++){const i=o.next();if(i.done)return[r,S.empty()];r.push(i.value)}return[r,{[Symbol.iterator](){return o}}]}S.consume=c;function u(a,t,r=(o,l)=>o===l){const o=a[Symbol.iterator](),l=t[Symbol.iterator]();for(;;){const i=o.next(),d=l.next();if(i.done!==d.done)return!1;if(i.done)return!0;if(!r(i.value,d.value))return!1}}S.equals=u})(_=e.Iterable||(e.Iterable={}))}),define(we[46],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var _;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(_=e.ScanError||(e.ScanError={}));var S;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(S=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function E(t,r=!1){let o=0,l=t.length,i="",d=0,y=16,k=0;function m(z){let ae=0,L=0;for(;ae<z;){const N=t.charCodeAt(o);if(N>=48&&N<=57)L=L*16+N-48;else if(N>=65&&N<=70)L=L*16+N-65+10;else if(N>=97&&N<=102)L=L*16+N-97+10;else break;o++,ae++}return ae<z&&(L=-1),L}function w(z){o=z,i="",d=0,y=16,k=0}function R(){const z=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&n(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&n(t.charCodeAt(o)))for(o++;o<t.length&&n(t.charCodeAt(o));)o++;else return k=3,t.substring(z,o);let ae=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&n(t.charCodeAt(o))){for(o++;o<t.length&&n(t.charCodeAt(o));)o++;ae=o}else k=3;return t.substring(z,ae)}function F(){let z="",ae=o;for(;;){if(o>=l){z+=t.substring(ae,o),k=2;break}const L=t.charCodeAt(o);if(L===34){z+=t.substring(ae,o),o++;break}if(L===92){if(z+=t.substring(ae,o),o++,o>=l){k=2;break}switch(t.charCodeAt(o++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:const H=m(4);H>=0?z+=String.fromCharCode(H):k=4;break;default:k=5}ae=o;continue}if(L>=0&&L<=31)if(D(L)){z+=t.substring(ae,o),k=2;break}else k=6;o++}return z}function B(){if(i="",k=0,d=o,o>=l)return d=l,y=17;let z=t.charCodeAt(o);if(C(z)){do o++,i+=String.fromCharCode(z),z=t.charCodeAt(o);while(C(z));return y=15}if(D(z))return o++,i+=String.fromCharCode(z),z===13&&t.charCodeAt(o)===10&&(o++,i+=`
`),y=14;switch(z){case 123:return o++,y=1;case 125:return o++,y=2;case 91:return o++,y=3;case 93:return o++,y=4;case 58:return o++,y=6;case 44:return o++,y=5;case 34:return o++,i=F(),y=10;case 47:const ae=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<l&&!D(t.charCodeAt(o));)o++;return i=t.substring(ae,o),y=12}if(t.charCodeAt(o+1)===42){o+=2;const L=l-1;let N=!1;for(;o<L;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,N=!0;break}o++}return N||(o++,k=1),i=t.substring(ae,o),y=13}return i+=String.fromCharCode(z),o++,y=16;case 45:if(i+=String.fromCharCode(z),o++,o===l||!n(t.charCodeAt(o)))return y=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=R(),y=11;default:for(;o<l&&Q(z);)o++,z=t.charCodeAt(o);if(d!==o){switch(i=t.substring(d,o),i){case"true":return y=8;case"false":return y=9;case"null":return y=7}return y=16}return i+=String.fromCharCode(z),o++,y=16}}function Q(z){if(C(z)||D(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function J(){let z;do z=B();while(z>=12&&z<=15);return z}return{setPosition:w,getPosition:()=>o,scan:r?J:B,getToken:()=>y,getTokenValue:()=>i,getTokenOffset:()=>d,getTokenLength:()=>o-d,getTokenError:()=>k}}e.createScanner=E;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function n(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function I(t,r){const o=[],l=new Object;let i;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let y=!1;function k(m,w,R,F){d.value=m,d.offset=w,d.length=R,d.type=F,d.colonOffset=void 0,i=d}try{c(t,{onObjectBegin:(m,w)=>{if(r<=m)throw l;i=void 0,y=r>m,o.push("")},onObjectProperty:(m,w,R)=>{if(r<w||(k(m,w,R,"property"),o[o.length-1]=m,r<=w+R))throw l},onObjectEnd:(m,w)=>{if(r<=m)throw l;i=void 0,o.pop()},onArrayBegin:(m,w)=>{if(r<=m)throw l;i=void 0,o.push(0)},onArrayEnd:(m,w)=>{if(r<=m)throw l;i=void 0,o.pop()},onLiteralValue:(m,w,R)=>{if(r<w||(k(m,w,R,a(m)),r<=w+R))throw l},onSeparator:(m,w,R)=>{if(r<=w)throw l;if(m===":"&&i&&i.type==="property")i.colonOffset=w,y=!1,i=void 0;else if(m===","){const F=o[o.length-1];typeof F=="number"?o[o.length-1]=F+1:(y=!0,o[o.length-1]=""),i=void 0}}})}catch(m){if(m!==l)throw m}return{path:o,previousNode:i,isAtPropertyKey:y,matches:m=>{let w=0;for(let R=0;w<m.length&&R<o.length;R++)if(m[w]===o[R]||m[w]==="*")w++;else if(m[w]!=="**")return!1;return w===m.length}}}e.getLocation=I;function p(t,r=[],o=P.DEFAULT){let l=null,i=[];const d=[];function y(m){Array.isArray(i)?i.push(m):l!==null&&(i[l]=m)}return c(t,{onObjectBegin:()=>{const m={};y(m),d.push(i),i=m,l=null},onObjectProperty:m=>{l=m},onObjectEnd:()=>{i=d.pop()},onArrayBegin:()=>{const m=[];y(m),d.push(i),i=m,l=null},onArrayEnd:()=>{i=d.pop()},onLiteralValue:y,onError:(m,w,R)=>{r.push({error:m,offset:w,length:R})}},o),i[0]}e.parse=p;function f(t,r=[],o=P.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(m){l.type==="property"&&(l.length=m-l.offset,l=l.parent)}function d(m){return l.children.push(m),m}c(t,{onObjectBegin:m=>{l=d({type:"object",offset:m,length:-1,parent:l,children:[]})},onObjectProperty:(m,w,R)=>{l=d({type:"property",offset:w,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:m,offset:w,length:R,parent:l})},onObjectEnd:(m,w)=>{l.length=m+w-l.offset,l=l.parent,i(m+w)},onArrayBegin:(m,w)=>{l=d({type:"array",offset:m,length:-1,parent:l,children:[]})},onArrayEnd:(m,w)=>{l.length=m+w-l.offset,l=l.parent,i(m+w)},onLiteralValue:(m,w,R)=>{d({type:a(m),offset:w,length:R,parent:l,value:m}),i(w+R)},onSeparator:(m,w,R)=>{l.type==="property"&&(m===":"?l.colonOffset=w:m===","&&i(w))},onError:(m,w,R)=>{r.push({error:m,offset:w,length:R})}},o);const k=l.children[0];return k&&delete k.parent,k}e.parseTree=f;function s(t,r){if(!!t){let o=t;for(let l of r)if(typeof l=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let i=!1;for(const d of o.children)if(Array.isArray(d.children)&&d.children[0].value===l){o=d.children[1],i=!0;break}if(!i)return}else{const i=l;if(o.type!=="array"||i<0||!Array.isArray(o.children)||i>=o.children.length)return;o=o.children[i]}return o}}e.findNodeAtLocation=s;function h(t){if(!t.parent||!t.parent.children)return[];const r=h(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;r.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&r.push(o)}return r}e.getNodePath=h;function v(t){switch(t.type){case"array":return t.children.map(v);case"object":const r=Object.create(null);for(let o of t.children){const l=o.children[1];l&&(r[o.children[0].value]=v(l))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=v;function g(t,r,o=!1){return r>=t.offset&&r<t.offset+t.length||o&&r===t.offset+t.length}e.contains=g;function b(t,r,o=!1){if(g(t,r,o)){const l=t.children;if(Array.isArray(l))for(let i=0;i<l.length&&l[i].offset<=r;i++){const d=b(l[i],r,o);if(d)return d}return t}}e.findNodeAtOffset=b;function c(t,r,o=P.DEFAULT){const l=E(t,!1);function i(ve){return ve?()=>ve(l.getTokenOffset(),l.getTokenLength()):()=>!0}function d(ve){return ve?Re=>ve(Re,l.getTokenOffset(),l.getTokenLength()):()=>!0}const y=i(r.onObjectBegin),k=d(r.onObjectProperty),m=i(r.onObjectEnd),w=i(r.onArrayBegin),R=i(r.onArrayEnd),F=d(r.onLiteralValue),B=d(r.onSeparator),Q=i(r.onComment),J=d(r.onError),z=o&&o.disallowComments,ae=o&&o.allowTrailingComma;function L(){for(;;){const ve=l.scan();switch(l.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:z||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(ve){case 12:case 13:z?N(10):Q();break;case 16:N(1);break;case 15:case 14:break;default:return ve}}}function N(ve,Re=[],He=[]){if(J(ve),Re.length+He.length>0){let Fe=l.getToken();for(;Fe!==17;){if(Re.indexOf(Fe)!==-1){L();break}else if(He.indexOf(Fe)!==-1)break;Fe=L()}}}function H(ve){const Re=l.getTokenValue();return ve?F(Re):k(Re),L(),!0}function O(){switch(l.getToken()){case 11:let ve=0;try{ve=JSON.parse(l.getTokenValue()),typeof ve!="number"&&(N(2),ve=0)}catch(Re){N(2)}F(ve);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return L(),!0}function K(){return l.getToken()!==10?(N(3,[],[2,5]),!1):(H(!1),l.getToken()===6?(B(":"),L(),pe()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function le(){y(),L();let ve=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(ve||N(4,[],[]),B(","),L(),l.getToken()===2&&ae)break}else ve&&N(6,[],[]);K()||N(4,[],[2,5]),ve=!0}return m(),l.getToken()!==2?N(7,[2],[]):L(),!0}function ue(){w(),L();let ve=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(ve||N(4,[],[]),B(","),L(),l.getToken()===4&&ae)break}else ve&&N(6,[],[]);pe()||N(4,[],[4,5]),ve=!0}return R(),l.getToken()!==4?N(8,[4],[]):L(),!0}function pe(){switch(l.getToken()){case 3:return ue();case 1:return le();case 10:return H(!0);default:return O()}}return L(),l.getToken()===17?o.allowEmptyContent?!0:(N(4,[],[]),!1):pe()?(l.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=c;function u(t,r){let o=E(t),l=[],i,d=0,y;do switch(y=o.getPosition(),i=o.scan(),i){case 12:case 13:case 17:d!==y&&l.push(t.substring(d,y)),r!==void 0&&l.push(o.getTokenValue().replace(/[^\r\n]/g,r)),d=o.getPosition();break}while(i!==17);return l.join("")}e.stripComments=u;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(we[103],Ee([0,1,46]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function S(D,n,A){let I,p,f,s,h;if(n){for(s=n.offset,h=s+n.length,f=s;f>0&&!C(D,f-1);)f--;let d=h;for(;d<D.length&&!C(D,d);)d++;p=D.substring(f,d),I=P(p,A)}else p=D,I=0,f=0,s=0,h=D.length;const v=E(A,D);let g=!1,b=0,c;A.insertSpaces?c=T(" ",A.tabSize||4):c="	";const u=(0,_.createScanner)(p,!1);let a=!1;function t(){return v+T(c,I+b)}function r(){let d=u.scan();for(g=!1;d===15||d===14;)g=g||d===14,d=u.scan();return a=d===16||u.getTokenError()!==0,d}const o=[];function l(d,y,k){!a&&y<h&&k>s&&D.substring(y,k)!==d&&o.push({offset:y,length:k-y,content:d})}let i=r();if(i!==17){const d=u.getTokenOffset()+f,y=T(c,I);l(y,f,d)}for(;i!==17;){let d=u.getTokenOffset()+u.getTokenLength()+f,y=r(),k="";for(;!g&&(y===12||y===13);){const w=u.getTokenOffset()+f;l(" ",d,w),d=u.getTokenOffset()+u.getTokenLength()+f,k=y===12?t():"",y=r()}if(y===2)i!==1&&(b--,k=t());else if(y===4)i!==3&&(b--,k=t());else{switch(i){case 3:case 1:b++,k=t();break;case 5:case 12:k=t();break;case 13:g?k=t():k=" ";break;case 6:k=" ";break;case 10:if(y===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?k=" ":y!==5&&y!==17&&(a=!0);break;case 16:a=!0;break}g&&(y===12||y===13)&&(k=t())}const m=u.getTokenOffset()+f;l(k,d,m),i=y}return o}e.format=S;function T(D,n){let A="";for(let I=0;I<n;I++)A+=D;return A}function P(D,n){let A=0,I=0;const p=n.tabSize||4;for(;A<D.length;){const f=D.charAt(A);if(f===" ")I++;else if(f==="	")I+=p;else break;A++}return Math.floor(I/p)}function E(D,n){for(let A=0;A<n.length;A++){const I=n.charAt(A);if(I==="\r")return A+1<n.length&&n.charAt(A+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=E;function C(D,n){return`\r
`.indexOf(D.charAt(n))!==-1}e.isEOL=C}),define(we[104],Ee([0,1,46,103]),function(re,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(n,A,I){return P(n,A,void 0,I)}e.removeProperty=T;function P(n,A,I,p,f){const s=A.slice(),h=[],v=(0,_.parseTree)(n,h);let g,b;for(;s.length>0&&(b=s.pop(),g=(0,_.findNodeAtLocation)(v,s),g===void 0&&I!==void 0);)typeof b=="string"?I={[b]:I}:I=[I];if(g)if(g.type==="object"&&typeof b=="string"&&Array.isArray(g.children)){const c=(0,_.findNodeAtLocation)(g,[b]);if(c!==void 0)if(I===void 0){if(!c.parent)throw new Error("Malformed AST");const u=g.children.indexOf(c.parent);let a,t=c.parent.offset+c.parent.length;if(u>0){const r=g.children[u-1];a=r.offset+r.length}else a=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return E(n,{offset:a,length:t-a,content:""},p)}else return E(n,{offset:c.offset,length:c.length,content:JSON.stringify(I)},p);else{if(I===void 0)return[];const u=`${JSON.stringify(b)}: ${JSON.stringify(I)}`,a=f?f(g.children.map(r=>r.children[0].value)):g.children.length;let t;if(a>0){const r=g.children[a-1];t={offset:r.offset+r.length,length:0,content:","+u}}else g.children.length===0?t={offset:g.offset+1,length:0,content:u}:t={offset:g.offset+1,length:0,content:u+","};return E(n,t,p)}}else if(g.type==="array"&&typeof b=="number"&&Array.isArray(g.children))if(I!==void 0){const c=`${JSON.stringify(I)}`;let u;if(g.children.length===0||b===0)u={offset:g.offset+1,length:0,content:g.children.length===0?c:c+","};else{const a=b===-1||b>g.children.length?g.children.length:b,t=g.children[a-1];u={offset:t.offset+t.length,length:0,content:","+c}}return E(n,u,p)}else{const c=b,u=g.children[c];let a;if(g.children.length===1)a={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===c){const t=g.children[c-1],r=t.offset+t.length,o=g.offset+g.length;a={offset:r,length:o-2-r,content:""}}else a={offset:u.offset,length:g.children[c+1].offset-u.offset,content:""};return E(n,a,p)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${g.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return E(n,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(I)},p)}}e.setProperty=P;function E(n,A,I){let p=C(n,A),f=A.offset,s=A.offset+A.content.length;if(A.length===0||A.content.length===0){for(;f>0&&!(0,S.isEOL)(p,f-1);)f--;for(;s<p.length&&!(0,S.isEOL)(p,s);)s++}const h=(0,S.format)(p,{offset:f,length:s-f},I);for(let g=h.length-1;g>=0;g--){const b=h[g];p=C(p,b),f=Math.min(f,b.offset),s=Math.max(s,b.offset+b.length),s+=b.content.length-b.length}const v=n.length-(p.length-s)-f;return[{offset:f,length:v,content:p.substring(f,s)}]}e.withFormatting=E;function C(n,A){return n.substring(0,A.offset)+A.content+n.substring(A.offset+A.length)}e.applyEdit=C;function D(n,A){let I=A.slice(0).sort((f,s)=>{const h=f.offset-s.offset;return h===0?f.length-s.length:h}),p=n.length;for(let f=I.length-1;f>=0;f--){let s=I[f];if(s.offset+s.length<=p)n=C(n,s);else throw new Error("Overlapping edit");p=s.offset}return n}e.applyEdits=D}),define(we[105],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class _{constructor(T){this.executor=T,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(T){return new _(()=>T(this.getValue()))}}e.Lazy=_}),define(we[6],Ee([0,1,52,54]),function(re,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const T=!1;let P=null;function E(c){P=c}if(e.setDisposableTracker=E,T){const c="__is_disposable_tracked__";P=new class{trackDisposable(u){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[c]||console.log(a)},3e3)}markTracked(u){if(u&&u!==h.None)try{u[c]=!0}catch(a){}}}}function C(c){!P||P.markTracked(c)}function D(c){return P&&P.trackDisposable(c),c}e.trackDisposable=D;class n extends Error{constructor(u){super(`Encountered errors while disposing of store. Errors: [${u.join(", ")}]`);this.errors=u}}e.MultiDisposeError=n;function A(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=A;function I(c){if(S.Iterable.is(c)){let u=[];for(const a of c)if(a){C(a);try{a.dispose()}catch(t){u.push(t)}}if(u.length===1)throw u[0];if(u.length>1)throw new n(u);return Array.isArray(c)?[]:c}else if(c)return C(c),c.dispose(),c}e.dispose=I;function p(...c){return c.forEach(C),f(()=>I(c))}e.combinedDisposable=p;function f(c){const u=D({dispose:()=>{C(u),c()}});return u}e.toDisposable=f;class s{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return C(u),this._isDisposed?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=s,s.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this._store=new s,D(this)}dispose(){C(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=h,h.None=Object.freeze({dispose(){}});class v{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){var a;this._isDisposed||u===this._value||((a=this._value)===null||a===void 0||a.dispose(),u&&C(u),this._value=u)}clear(){this.value=void 0}dispose(){var u;this._isDisposed=!0,C(this),(u=this._value)===null||u===void 0||u.dispose(),this._value=void 0}}e.MutableDisposable=v;class g{constructor(){this.references=new Map}acquire(u,...a){let t=this.references.get(u);t||(t={counter:0,object:this.createReferencedObject(u,...a)},this.references.set(u,t));const{object:r}=t,o=(0,_.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(u,t.object),this.references.delete(u))});return t.counter++,{object:r,dispose:o}}}e.ReferenceCollection=g;class b{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=b}),define(we[47],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class _{constructor(P){this.element=P,this.next=_.Undefined,this.prev=_.Undefined}}_.Undefined=new _(void 0);class S{constructor(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===_.Undefined}clear(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,E){const C=new _(P);if(this._first===_.Undefined)this._first=C,this._last=C;else if(E){const n=this._last;this._last=C,C.prev=n,n.next=C}else{const n=this._first;this._first=C,C.next=n,n.prev=C}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(C))}}shift(){if(this._first!==_.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==_.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==_.Undefined&&P.next!==_.Undefined){const E=P.prev;E.next=P.next,P.next.prev=E}else P.prev===_.Undefined&&P.next===_.Undefined?(this._first=_.Undefined,this._last=_.Undefined):P.next===_.Undefined?(this._last=this._last.prev,this._last.next=_.Undefined):P.prev===_.Undefined&&(this._first=this._first.next,this._first.prev=_.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==_.Undefined;)yield P.element,P=P.next}}e.LinkedList=S}),function(re,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(re=typeof globalThis!="undefined"?globalThis:re||self,re.marked=e())}(this,function(){"use strict";function re(x,ee){for(var ce=0;ce<ee.length;ce++){var j=ee[ce];j.enumerable=j.enumerable||!1,j.configurable=!0,"value"in j&&(j.writable=!0),Object.defineProperty(x,j.key,j)}}function e(x,ee,ce){return ee&&re(x.prototype,ee),ce&&re(x,ce),x}function _(x,ee){if(!!x){if(typeof x=="string")return S(x,ee);var ce=Object.prototype.toString.call(x).slice(8,-1);if(ce==="Object"&&x.constructor&&(ce=x.constructor.name),ce==="Map"||ce==="Set")return Array.from(x);if(ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ce))return S(x,ee)}}function S(x,ee){(ee==null||ee>x.length)&&(ee=x.length);for(var ce=0,j=new Array(ee);ce<ee;ce++)j[ce]=x[ce];return j}function T(x,ee){var ce;if(typeof Symbol=="undefined"||x[Symbol.iterator]==null){if(Array.isArray(x)||(ce=_(x))||ee&&x&&typeof x.length=="number"){ce&&(x=ce);var j=0;return function(){return j>=x.length?{done:!0}:{done:!1,value:x[j++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return ce=x[Symbol.iterator](),ce.next.bind(ce)}function P(x){var ee={exports:{}};return x(ee,ee.exports),ee.exports}var E=P(function(x){function ee(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function ce(j){x.exports.defaults=j}x.exports={defaults:ee(),getDefaults:ee,changeDefaults:ce}}),C=/[&<>"']/,D=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,A=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(ee){return I[ee]};function f(x,ee){if(ee){if(C.test(x))return x.replace(D,p)}else if(n.test(x))return x.replace(A,p);return x}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(x){return x.replace(s,function(ee,ce){return ce=ce.toLowerCase(),ce==="colon"?":":ce.charAt(0)==="#"?ce.charAt(1)==="x"?String.fromCharCode(parseInt(ce.substring(2),16)):String.fromCharCode(+ce.substring(1)):""})}var v=/(^|[^\[])\^/g;function g(x,ee){x=x.source||x,ee=ee||"";var ce={replace:function(X,se){return se=se.source||se,se=se.replace(v,"$1"),x=x.replace(X,se),ce},getRegex:function(){return new RegExp(x,ee)}};return ce}var b=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(x,ee,ce){if(x){var j;try{j=decodeURIComponent(h(ce)).replace(b,"").toLowerCase()}catch(X){return null}if(j.indexOf("javascript:")===0||j.indexOf("vbscript:")===0||j.indexOf("data:")===0)return null}ee&&!c.test(ce)&&(ce=l(ee,ce));try{ce=encodeURI(ce).replace(/%25/g,"%")}catch(X){return null}return ce}var a={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(x,ee){a[" "+x]||(t.test(x)?a[" "+x]=x+"/":a[" "+x]=k(x,"/",!0)),x=a[" "+x];var ce=x.indexOf(":")===-1;return ee.substring(0,2)==="//"?ce?ee:x.replace(r,"$1")+ee:ee.charAt(0)==="/"?ce?ee:x.replace(o,"$1")+ee:x+ee}var i={exec:function(){}};function d(x){for(var ee=1,ce,j;ee<arguments.length;ee++){ce=arguments[ee];for(j in ce)Object.prototype.hasOwnProperty.call(ce,j)&&(x[j]=ce[j])}return x}function y(x,ee){var ce=x.replace(/\|/g,function(se,de,Se){for(var xe=!1,Oe=de;--Oe>=0&&Se[Oe]==="\\";)xe=!xe;return xe?"|":" |"}),j=ce.split(/ \|/),X=0;if(j.length>ee)j.splice(ee);else for(;j.length<ee;)j.push("");for(;X<j.length;X++)j[X]=j[X].trim().replace(/\\\|/g,"|");return j}function k(x,ee,ce){var j=x.length;if(j===0)return"";for(var X=0;X<j;){var se=x.charAt(j-X-1);if(se===ee&&!ce)X++;else if(se!==ee&&ce)X++;else break}return x.substr(0,j-X)}function m(x,ee){if(x.indexOf(ee[1])===-1)return-1;for(var ce=x.length,j=0,X=0;X<ce;X++)if(x[X]==="\\")X++;else if(x[X]===ee[0])j++;else if(x[X]===ee[1]&&(j--,j<0))return X;return-1}function w(x){x&&x.sanitize&&!x.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(x,ee){if(ee<1)return"";for(var ce="";ee>1;)ee&1&&(ce+=x),ee>>=1,x+=x;return ce+x}var F={escape:f,unescape:h,edit:g,cleanUrl:u,resolveUrl:l,noopTest:i,merge:d,splitCells:y,rtrim:k,findClosingBracket:m,checkSanitizeDeprecation:w,repeatString:R},B=E.defaults,Q=F.rtrim,J=F.splitCells,z=F.escape,ae=F.findClosingBracket;function L(x,ee,ce){var j=ee.href,X=ee.title?z(ee.title):null,se=x[1].replace(/\\([\[\]])/g,"$1");return x[0].charAt(0)!=="!"?{type:"link",raw:ce,href:j,title:X,text:se}:{type:"image",raw:ce,href:j,title:X,text:z(se)}}function N(x,ee){var ce=x.match(/^(\s+)(?:```)/);if(ce===null)return ee;var j=ce[1];return ee.split(`
`).map(function(X){var se=X.match(/^\s+/);if(se===null)return X;var de=se[0];return de.length>=j.length?X.slice(j.length):X}).join(`
`)}var H=function(){function x(ce){this.options=ce||B}var ee=x.prototype;return ee.space=function(j){var X=this.rules.block.newline.exec(j);if(X)return X[0].length>1?{type:"space",raw:X[0]}:{raw:`
`}},ee.code=function(j){var X=this.rules.block.code.exec(j);if(X){var se=X[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:X[0],codeBlockStyle:"indented",text:this.options.pedantic?se:Q(se,`
`)}}},ee.fences=function(j){var X=this.rules.block.fences.exec(j);if(X){var se=X[0],de=N(se,X[3]||"");return{type:"code",raw:se,lang:X[2]?X[2].trim():X[2],text:de}}},ee.heading=function(j){var X=this.rules.block.heading.exec(j);if(X){var se=X[2].trim();if(/#$/.test(se)){var de=Q(se,"#");(this.options.pedantic||!de||/ $/.test(de))&&(se=de.trim())}return{type:"heading",raw:X[0],depth:X[1].length,text:se}}},ee.nptable=function(j){var X=this.rules.block.nptable.exec(j);if(X){var se={type:"table",header:J(X[1].replace(/^ *| *\| *$/g,"")),align:X[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:X[3]?X[3].replace(/\n$/,"").split(`
`):[],raw:X[0]};if(se.header.length===se.align.length){var de=se.align.length,Se;for(Se=0;Se<de;Se++)/^ *-+: *$/.test(se.align[Se])?se.align[Se]="right":/^ *:-+: *$/.test(se.align[Se])?se.align[Se]="center":/^ *:-+ *$/.test(se.align[Se])?se.align[Se]="left":se.align[Se]=null;for(de=se.cells.length,Se=0;Se<de;Se++)se.cells[Se]=J(se.cells[Se],se.header.length);return se}}},ee.hr=function(j){var X=this.rules.block.hr.exec(j);if(X)return{type:"hr",raw:X[0]}},ee.blockquote=function(j){var X=this.rules.block.blockquote.exec(j);if(X){var se=X[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:X[0],text:se}}},ee.list=function(j){var X=this.rules.block.list.exec(j);if(X){var se=X[0],de=X[2],Se=de.length>1,xe={type:"list",raw:se,ordered:Se,start:Se?+de.slice(0,-1):"",loose:!1,items:[]},Oe=X[0].match(this.rules.block.item),Be=!1,Qe,nt,et,Xe,fe,ye,oe,q,Ie=Oe.length;et=this.rules.block.listItemStart.exec(Oe[0]);for(var Pe=0;Pe<Ie;Pe++){if(Qe=Oe[Pe],se=Qe,Pe!==Ie-1){if(Xe=this.rules.block.listItemStart.exec(Oe[Pe+1]),this.options.pedantic?Xe[1].length>et[1].length:Xe[1].length>et[0].length||Xe[1].length>3){Oe.splice(Pe,2,Oe[Pe]+`
`+Oe[Pe+1]),Pe--,Ie--;continue}else(!this.options.pedantic||this.options.smartLists?Xe[2][Xe[2].length-1]!==de[de.length-1]:Se===(Xe[2].length===1))&&(fe=Oe.slice(Pe+1).join(`
`),xe.raw=xe.raw.substring(0,xe.raw.length-fe.length),Pe=Ie-1);et=Xe}nt=Qe.length,Qe=Qe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Qe.indexOf(`
 `)&&(nt-=Qe.length,Qe=this.options.pedantic?Qe.replace(/^ {1,4}/gm,""):Qe.replace(new RegExp("^ {1,"+nt+"}","gm"),"")),ye=Be||/\n\n(?!\s*$)/.test(Qe),Pe!==Ie-1&&(Be=Qe.charAt(Qe.length-1)===`
`,ye||(ye=Be)),ye&&(xe.loose=!0),this.options.gfm&&(oe=/^\[[ xX]\] /.test(Qe),q=void 0,oe&&(q=Qe[1]!==" ",Qe=Qe.replace(/^\[[ xX]\] +/,""))),xe.items.push({type:"list_item",raw:se,task:oe,checked:q,loose:ye,text:Qe})}return xe}},ee.html=function(j){var X=this.rules.block.html.exec(j);if(X)return{type:this.options.sanitize?"paragraph":"html",raw:X[0],pre:!this.options.sanitizer&&(X[1]==="pre"||X[1]==="script"||X[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(X[0]):z(X[0]):X[0]}},ee.def=function(j){var X=this.rules.block.def.exec(j);if(X){X[3]&&(X[3]=X[3].substring(1,X[3].length-1));var se=X[1].toLowerCase().replace(/\s+/g," ");return{tag:se,raw:X[0],href:X[2],title:X[3]}}},ee.table=function(j){var X=this.rules.block.table.exec(j);if(X){var se={type:"table",header:J(X[1].replace(/^ *| *\| *$/g,"")),align:X[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:X[3]?X[3].replace(/\n$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=X[0];var de=se.align.length,Se;for(Se=0;Se<de;Se++)/^ *-+: *$/.test(se.align[Se])?se.align[Se]="right":/^ *:-+: *$/.test(se.align[Se])?se.align[Se]="center":/^ *:-+ *$/.test(se.align[Se])?se.align[Se]="left":se.align[Se]=null;for(de=se.cells.length,Se=0;Se<de;Se++)se.cells[Se]=J(se.cells[Se].replace(/^ *\| *| *\| *$/g,""),se.header.length);return se}}},ee.lheading=function(j){var X=this.rules.block.lheading.exec(j);if(X)return{type:"heading",raw:X[0],depth:X[2].charAt(0)==="="?1:2,text:X[1]}},ee.paragraph=function(j){var X=this.rules.block.paragraph.exec(j);if(X)return{type:"paragraph",raw:X[0],text:X[1].charAt(X[1].length-1)===`
`?X[1].slice(0,-1):X[1]}},ee.text=function(j){var X=this.rules.block.text.exec(j);if(X)return{type:"text",raw:X[0],text:X[0]}},ee.escape=function(j){var X=this.rules.inline.escape.exec(j);if(X)return{type:"escape",raw:X[0],text:z(X[1])}},ee.tag=function(j,X,se){var de=this.rules.inline.tag.exec(j);if(de)return!X&&/^<a /i.test(de[0])?X=!0:X&&/^<\/a>/i.test(de[0])&&(X=!1),!se&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?se=!0:se&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(se=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:X,inRawBlock:se,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):z(de[0]):de[0]}},ee.link=function(j){var X=this.rules.inline.link.exec(j);if(X){var se=X[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var de=Q(se.slice(0,-1),"\\");if((se.length-de.length)%2==0)return}else{var Se=ae(X[2],"()");if(Se>-1){var xe=X[0].indexOf("!")===0?5:4,Oe=xe+X[1].length+Se;X[2]=X[2].substring(0,Se),X[0]=X[0].substring(0,Oe).trim(),X[3]=""}}var Be=X[2],Qe="";if(this.options.pedantic){var nt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Be);nt&&(Be=nt[1],Qe=nt[3])}else Qe=X[3]?X[3].slice(1,-1):"";return Be=Be.trim(),/^</.test(Be)&&(this.options.pedantic&&!/>$/.test(se)?Be=Be.slice(1):Be=Be.slice(1,-1)),L(X,{href:Be&&Be.replace(this.rules.inline._escapes,"$1"),title:Qe&&Qe.replace(this.rules.inline._escapes,"$1")},X[0])}},ee.reflink=function(j,X){var se;if((se=this.rules.inline.reflink.exec(j))||(se=this.rules.inline.nolink.exec(j))){var de=(se[2]||se[1]).replace(/\s+/g," ");if(de=X[de.toLowerCase()],!de||!de.href){var Se=se[0].charAt(0);return{type:"text",raw:Se,text:Se}}return L(se,de,se[0])}},ee.emStrong=function(j,X,se){se===void 0&&(se="");var de=this.rules.inline.emStrong.lDelim.exec(j);if(!!de&&!(de[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Se=de[1]||de[2]||"";if(!Se||Se&&(se===""||this.rules.inline.punctuation.exec(se))){var xe=de[0].length-1,Oe,Be,Qe=xe,nt=0,et=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(et.lastIndex=0,X=X.slice(-1*j.length+xe);(de=et.exec(X))!=null;)if(Oe=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!Oe){if(Be=Oe.length,de[3]||de[4]){Qe+=Be;continue}else if((de[5]||de[6])&&xe%3&&!((xe+Be)%3)){nt+=Be;continue}if(Qe-=Be,!(Qe>0)){if(Qe+nt-Be<=0&&!X.slice(et.lastIndex).match(et)&&(Be=Math.min(Be,Be+Qe+nt)),Math.min(xe,Be)%2)return{type:"em",raw:j.slice(0,xe+de.index+Be+1),text:j.slice(1,xe+de.index+Be)};if(Math.min(xe,Be)%2==0)return{type:"strong",raw:j.slice(0,xe+de.index+Be+1),text:j.slice(2,xe+de.index+Be-1)}}}}}},ee.codespan=function(j){var X=this.rules.inline.code.exec(j);if(X){var se=X[2].replace(/\n/g," "),de=/[^ ]/.test(se),Se=/^ /.test(se)&&/ $/.test(se);return de&&Se&&(se=se.substring(1,se.length-1)),se=z(se,!0),{type:"codespan",raw:X[0],text:se}}},ee.br=function(j){var X=this.rules.inline.br.exec(j);if(X)return{type:"br",raw:X[0]}},ee.del=function(j){var X=this.rules.inline.del.exec(j);if(X)return{type:"del",raw:X[0],text:X[2]}},ee.autolink=function(j,X){var se=this.rules.inline.autolink.exec(j);if(se){var de,Se;return se[2]==="@"?(de=z(this.options.mangle?X(se[1]):se[1]),Se="mailto:"+de):(de=z(se[1]),Se=de),{type:"link",raw:se[0],text:de,href:Se,tokens:[{type:"text",raw:de,text:de}]}}},ee.url=function(j,X){var se;if(se=this.rules.inline.url.exec(j)){var de,Se;if(se[2]==="@")de=z(this.options.mangle?X(se[0]):se[0]),Se="mailto:"+de;else{var xe;do xe=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(xe!==se[0]);de=z(se[0]),se[1]==="www."?Se="http://"+de:Se=de}return{type:"link",raw:se[0],text:de,href:Se,tokens:[{type:"text",raw:de,text:de}]}}},ee.inlineText=function(j,X,se){var de=this.rules.inline.text.exec(j);if(de){var Se;return X?Se=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):z(de[0]):de[0]:Se=z(this.options.smartypants?se(de[0]):de[0]),{type:"text",raw:de[0],text:Se}}},x}(),O=F.noopTest,K=F.edit,le=F.merge,ue={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:O,table:O,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};ue._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,ue._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ue.def=K(ue.def).replace("label",ue._label).replace("title",ue._title).getRegex(),ue.bullet=/(?:[*+-]|\d{1,9}[.)])/,ue.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,ue.item=K(ue.item,"gm").replace(/bull/g,ue.bullet).getRegex(),ue.listItemStart=K(/^( *)(bull)/).replace("bull",ue.bullet).getRegex(),ue.list=K(ue.list).replace(/bull/g,ue.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ue.def.source+")").getRegex(),ue._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ue._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ue.html=K(ue.html,"i").replace("comment",ue._comment).replace("tag",ue._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ue.paragraph=K(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",ue._tag).getRegex(),ue.blockquote=K(ue.blockquote).replace("paragraph",ue.paragraph).getRegex(),ue.normal=le({},ue),ue.gfm=le({},ue.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ue.gfm.nptable=K(ue.gfm.nptable).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",ue._tag).getRegex(),ue.gfm.table=K(ue.gfm.table).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",ue._tag).getRegex(),ue.pedantic=le({},ue.normal,{html:K(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ue._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:O,paragraph:K(ue.normal._paragraph).replace("hr",ue.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ue.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var pe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:O,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:O,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};pe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",pe.punctuation=K(pe.punctuation).replace(/punctuation/g,pe._punctuation).getRegex(),pe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,pe.escapedEmSt=/\\\*|\\_/g,pe._comment=K(ue._comment).replace("(?:-->|$)","-->").getRegex(),pe.emStrong.lDelim=K(pe.emStrong.lDelim).replace(/punct/g,pe._punctuation).getRegex(),pe.emStrong.rDelimAst=K(pe.emStrong.rDelimAst,"g").replace(/punct/g,pe._punctuation).getRegex(),pe.emStrong.rDelimUnd=K(pe.emStrong.rDelimUnd,"g").replace(/punct/g,pe._punctuation).getRegex(),pe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,pe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,pe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,pe.autolink=K(pe.autolink).replace("scheme",pe._scheme).replace("email",pe._email).getRegex(),pe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,pe.tag=K(pe.tag).replace("comment",pe._comment).replace("attribute",pe._attribute).getRegex(),pe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,pe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,pe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,pe.link=K(pe.link).replace("label",pe._label).replace("href",pe._href).replace("title",pe._title).getRegex(),pe.reflink=K(pe.reflink).replace("label",pe._label).getRegex(),pe.reflinkSearch=K(pe.reflinkSearch,"g").replace("reflink",pe.reflink).replace("nolink",pe.nolink).getRegex(),pe.normal=le({},pe),pe.pedantic=le({},pe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:K(/^!?\[(label)\]\((.*?)\)/).replace("label",pe._label).getRegex(),reflink:K(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",pe._label).getRegex()}),pe.gfm=le({},pe.normal,{escape:K(pe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),pe.gfm.url=K(pe.gfm.url,"i").replace("email",pe.gfm._extended_email).getRegex(),pe.breaks=le({},pe.gfm,{br:K(pe.br).replace("{2,}","*").getRegex(),text:K(pe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ve={block:ue,inline:pe},Re=E.defaults,He=ve.block,Fe=ve.inline,ze=F.repeatString;function $(x){return x.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(x){var ee="",ce,j,X=x.length;for(ce=0;ce<X;ce++)j=x.charCodeAt(ce),Math.random()>.5&&(j="x"+j.toString(16)),ee+="&#"+j+";";return ee}var te=function(){function x(ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=ce||Re,this.options.tokenizer=this.options.tokenizer||new H,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var j={block:He.normal,inline:Fe.normal};this.options.pedantic?(j.block=He.pedantic,j.inline=Fe.pedantic):this.options.gfm&&(j.block=He.gfm,this.options.breaks?j.inline=Fe.breaks:j.inline=Fe.gfm),this.tokenizer.rules=j}x.lex=function(j,X){var se=new x(X);return se.lex(j)},x.lexInline=function(j,X){var se=new x(X);return se.inlineTokens(j)};var ee=x.prototype;return ee.lex=function(j){return j=j.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(j,this.tokens,!0),this.inline(this.tokens),this.tokens},ee.blockTokens=function(j,X,se){X===void 0&&(X=[]),se===void 0&&(se=!0),this.options.pedantic&&(j=j.replace(/^ +$/gm,""));for(var de,Se,xe,Oe;j;){if(de=this.tokenizer.space(j)){j=j.substring(de.raw.length),de.type&&X.push(de);continue}if(de=this.tokenizer.code(j)){j=j.substring(de.raw.length),Oe=X[X.length-1],Oe&&Oe.type==="paragraph"?(Oe.raw+=`
`+de.raw,Oe.text+=`
`+de.text):X.push(de);continue}if(de=this.tokenizer.fences(j)){j=j.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.heading(j)){j=j.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.nptable(j)){j=j.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.hr(j)){j=j.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.blockquote(j)){j=j.substring(de.raw.length),de.tokens=this.blockTokens(de.text,[],se),X.push(de);continue}if(de=this.tokenizer.list(j)){for(j=j.substring(de.raw.length),xe=de.items.length,Se=0;Se<xe;Se++)de.items[Se].tokens=this.blockTokens(de.items[Se].text,[],!1);X.push(de);continue}if(de=this.tokenizer.html(j)){j=j.substring(de.raw.length),X.push(de);continue}if(se&&(de=this.tokenizer.def(j))){j=j.substring(de.raw.length),this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(j)){j=j.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.lheading(j)){j=j.substring(de.raw.length),X.push(de);continue}if(se&&(de=this.tokenizer.paragraph(j))){j=j.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.text(j)){j=j.substring(de.raw.length),Oe=X[X.length-1],Oe&&Oe.type==="text"?(Oe.raw+=`
`+de.raw,Oe.text+=`
`+de.text):X.push(de);continue}if(j){var Be="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(Be);break}else throw new Error(Be)}}return X},ee.inline=function(j){var X,se,de,Se,xe,Oe,Be=j.length;for(X=0;X<Be;X++)switch(Oe=j[X],Oe.type){case"paragraph":case"text":case"heading":{Oe.tokens=[],this.inlineTokens(Oe.text,Oe.tokens);break}case"table":{for(Oe.tokens={header:[],cells:[]},Se=Oe.header.length,se=0;se<Se;se++)Oe.tokens.header[se]=[],this.inlineTokens(Oe.header[se],Oe.tokens.header[se]);for(Se=Oe.cells.length,se=0;se<Se;se++)for(xe=Oe.cells[se],Oe.tokens.cells[se]=[],de=0;de<xe.length;de++)Oe.tokens.cells[se][de]=[],this.inlineTokens(xe[de],Oe.tokens.cells[se][de]);break}case"blockquote":{this.inline(Oe.tokens);break}case"list":{for(Se=Oe.items.length,se=0;se<Se;se++)this.inline(Oe.items[se].tokens);break}}return j},ee.inlineTokens=function(j,X,se,de){X===void 0&&(X=[]),se===void 0&&(se=!1),de===void 0&&(de=!1);var Se,xe,Oe=j,Be,Qe,nt;if(this.tokens.links){var et=Object.keys(this.tokens.links);if(et.length>0)for(;(Be=this.tokenizer.rules.inline.reflinkSearch.exec(Oe))!=null;)et.includes(Be[0].slice(Be[0].lastIndexOf("[")+1,-1))&&(Oe=Oe.slice(0,Be.index)+"["+ze("a",Be[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Be=this.tokenizer.rules.inline.blockSkip.exec(Oe))!=null;)Oe=Oe.slice(0,Be.index)+"["+ze("a",Be[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Be=this.tokenizer.rules.inline.escapedEmSt.exec(Oe))!=null;)Oe=Oe.slice(0,Be.index)+"++"+Oe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;j;){if(Qe||(nt=""),Qe=!1,Se=this.tokenizer.escape(j)){j=j.substring(Se.raw.length),X.push(Se);continue}if(Se=this.tokenizer.tag(j,se,de)){j=j.substring(Se.raw.length),se=Se.inLink,de=Se.inRawBlock;var Xe=X[X.length-1];Xe&&Se.type==="text"&&Xe.type==="text"?(Xe.raw+=Se.raw,Xe.text+=Se.text):X.push(Se);continue}if(Se=this.tokenizer.link(j)){j=j.substring(Se.raw.length),Se.type==="link"&&(Se.tokens=this.inlineTokens(Se.text,[],!0,de)),X.push(Se);continue}if(Se=this.tokenizer.reflink(j,this.tokens.links)){j=j.substring(Se.raw.length);var fe=X[X.length-1];Se.type==="link"?(Se.tokens=this.inlineTokens(Se.text,[],!0,de),X.push(Se)):fe&&Se.type==="text"&&fe.type==="text"?(fe.raw+=Se.raw,fe.text+=Se.text):X.push(Se);continue}if(Se=this.tokenizer.emStrong(j,Oe,nt)){j=j.substring(Se.raw.length),Se.tokens=this.inlineTokens(Se.text,[],se,de),X.push(Se);continue}if(Se=this.tokenizer.codespan(j)){j=j.substring(Se.raw.length),X.push(Se);continue}if(Se=this.tokenizer.br(j)){j=j.substring(Se.raw.length),X.push(Se);continue}if(Se=this.tokenizer.del(j)){j=j.substring(Se.raw.length),Se.tokens=this.inlineTokens(Se.text,[],se,de),X.push(Se);continue}if(Se=this.tokenizer.autolink(j,G)){j=j.substring(Se.raw.length),X.push(Se);continue}if(!se&&(Se=this.tokenizer.url(j,G))){j=j.substring(Se.raw.length),X.push(Se);continue}if(Se=this.tokenizer.inlineText(j,de,$)){j=j.substring(Se.raw.length),Se.raw.slice(-1)!=="_"&&(nt=Se.raw.slice(-1)),Qe=!0,xe=X[X.length-1],xe&&xe.type==="text"?(xe.raw+=Se.raw,xe.text+=Se.text):X.push(Se);continue}if(j){var ye="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(ye);break}else throw new Error(ye)}}return X},e(x,null,[{key:"rules",get:function(){return{block:He,inline:Fe}}}]),x}(),ie=E.defaults,he=F.cleanUrl,De=F.escape,Le=function(){function x(ce){this.options=ce||ie}var ee=x.prototype;return ee.code=function(j,X,se){var de=(X||"").match(/\S*/)[0];if(this.options.highlight){var Se=this.options.highlight(j,de);Se!=null&&Se!==j&&(se=!0,j=Se)}return j=j.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+De(de,!0)+'">'+(se?j:De(j,!0))+`</code></pre>
`:"<pre><code>"+(se?j:De(j,!0))+`</code></pre>
`},ee.blockquote=function(j){return`<blockquote>
`+j+`</blockquote>
`},ee.html=function(j){return j},ee.heading=function(j,X,se,de){return this.options.headerIds?"<h"+X+' id="'+this.options.headerPrefix+de.slug(se)+'">'+j+"</h"+X+`>
`:"<h"+X+">"+j+"</h"+X+`>
`},ee.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ee.list=function(j,X,se){var de=X?"ol":"ul",Se=X&&se!==1?' start="'+se+'"':"";return"<"+de+Se+`>
`+j+"</"+de+`>
`},ee.listitem=function(j){return"<li>"+j+`</li>
`},ee.checkbox=function(j){return"<input "+(j?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ee.paragraph=function(j){return"<p>"+j+`</p>
`},ee.table=function(j,X){return X&&(X="<tbody>"+X+"</tbody>"),`<table>
<thead>
`+j+`</thead>
`+X+`</table>
`},ee.tablerow=function(j){return`<tr>
`+j+`</tr>
`},ee.tablecell=function(j,X){var se=X.header?"th":"td",de=X.align?"<"+se+' align="'+X.align+'">':"<"+se+">";return de+j+"</"+se+`>
`},ee.strong=function(j){return"<strong>"+j+"</strong>"},ee.em=function(j){return"<em>"+j+"</em>"},ee.codespan=function(j){return"<code>"+j+"</code>"},ee.br=function(){return this.options.xhtml?"<br/>":"<br>"},ee.del=function(j){return"<del>"+j+"</del>"},ee.link=function(j,X,se){if(j=he(this.options.sanitize,this.options.baseUrl,j),j===null)return se;var de='<a href="'+De(j)+'"';return X&&(de+=' title="'+X+'"'),de+=">"+se+"</a>",de},ee.image=function(j,X,se){if(j=he(this.options.sanitize,this.options.baseUrl,j),j===null)return se;var de='<img src="'+j+'" alt="'+se+'"';return X&&(de+=' title="'+X+'"'),de+=this.options.xhtml?"/>":">",de},ee.text=function(j){return j},x}(),me=function(){function x(){}var ee=x.prototype;return ee.strong=function(j){return j},ee.em=function(j){return j},ee.codespan=function(j){return j},ee.del=function(j){return j},ee.html=function(j){return j},ee.text=function(j){return j},ee.link=function(j,X,se){return""+se},ee.image=function(j,X,se){return""+se},ee.br=function(){return""},x}(),Ce=function(){function x(){this.seen={}}var ee=x.prototype;return ee.serialize=function(j){return j.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ee.getNextSafeSlug=function(j,X){var se=j,de=0;if(this.seen.hasOwnProperty(se)){de=this.seen[j];do de++,se=j+"-"+de;while(this.seen.hasOwnProperty(se))}return X||(this.seen[j]=de,this.seen[se]=0),se},ee.slug=function(j,X){X===void 0&&(X={});var se=this.serialize(j);return this.getNextSafeSlug(se,X.dryrun)},x}(),ke=E.defaults,Ue=F.unescape,be=function(){function x(ce){this.options=ce||ke,this.options.renderer=this.options.renderer||new Le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new me,this.slugger=new Ce}x.parse=function(j,X){var se=new x(X);return se.parse(j)},x.parseInline=function(j,X){var se=new x(X);return se.parseInline(j)};var ee=x.prototype;return ee.parse=function(j,X){X===void 0&&(X=!0);var se="",de,Se,xe,Oe,Be,Qe,nt,et,Xe,fe,ye,oe,q,Ie,Pe,Ze,Ae,it,st=j.length;for(de=0;de<st;de++)switch(fe=j[de],fe.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(fe.tokens),fe.depth,Ue(this.parseInline(fe.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(fe.text,fe.lang,fe.escaped);continue}case"table":{for(et="",nt="",Oe=fe.header.length,Se=0;Se<Oe;Se++)nt+=this.renderer.tablecell(this.parseInline(fe.tokens.header[Se]),{header:!0,align:fe.align[Se]});for(et+=this.renderer.tablerow(nt),Xe="",Oe=fe.cells.length,Se=0;Se<Oe;Se++){for(Qe=fe.tokens.cells[Se],nt="",Be=Qe.length,xe=0;xe<Be;xe++)nt+=this.renderer.tablecell(this.parseInline(Qe[xe]),{header:!1,align:fe.align[xe]});Xe+=this.renderer.tablerow(nt)}se+=this.renderer.table(et,Xe);continue}case"blockquote":{Xe=this.parse(fe.tokens),se+=this.renderer.blockquote(Xe);continue}case"list":{for(ye=fe.ordered,oe=fe.start,q=fe.loose,Oe=fe.items.length,Xe="",Se=0;Se<Oe;Se++)Pe=fe.items[Se],Ze=Pe.checked,Ae=Pe.task,Ie="",Pe.task&&(it=this.renderer.checkbox(Ze),q?Pe.tokens.length>0&&Pe.tokens[0].type==="text"?(Pe.tokens[0].text=it+" "+Pe.tokens[0].text,Pe.tokens[0].tokens&&Pe.tokens[0].tokens.length>0&&Pe.tokens[0].tokens[0].type==="text"&&(Pe.tokens[0].tokens[0].text=it+" "+Pe.tokens[0].tokens[0].text)):Pe.tokens.unshift({type:"text",text:it}):Ie+=it),Ie+=this.parse(Pe.tokens,q),Xe+=this.renderer.listitem(Ie,Ae,Ze);se+=this.renderer.list(Xe,ye,oe);continue}case"html":{se+=this.renderer.html(fe.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(fe.tokens));continue}case"text":{for(Xe=fe.tokens?this.parseInline(fe.tokens):fe.text;de+1<st&&j[de+1].type==="text";)fe=j[++de],Xe+=`
`+(fe.tokens?this.parseInline(fe.tokens):fe.text);se+=X?this.renderer.paragraph(Xe):Xe;continue}default:{var Ge='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(Ge);return}else throw new Error(Ge)}}return se},ee.parseInline=function(j,X){X=X||this.renderer;var se="",de,Se,xe=j.length;for(de=0;de<xe;de++)switch(Se=j[de],Se.type){case"escape":{se+=X.text(Se.text);break}case"html":{se+=X.html(Se.text);break}case"link":{se+=X.link(Se.href,Se.title,this.parseInline(Se.tokens,X));break}case"image":{se+=X.image(Se.href,Se.title,Se.text);break}case"strong":{se+=X.strong(this.parseInline(Se.tokens,X));break}case"em":{se+=X.em(this.parseInline(Se.tokens,X));break}case"codespan":{se+=X.codespan(Se.text);break}case"br":{se+=X.br();break}case"del":{se+=X.del(this.parseInline(Se.tokens,X));break}case"text":{se+=X.text(Se.text);break}default:{var Oe='Token with "'+Se.type+'" type was not found.';if(this.options.silent){console.error(Oe);return}else throw new Error(Oe)}}return se},x}(),je=F.merge,V=F.checkSanitizeDeprecation,Z=F.escape,_e=E.getDefaults,Me=E.changeDefaults,$e=E.defaults;function Ne(x,ee,ce){if(typeof x=="undefined"||x===null)throw new Error("marked(): input parameter is undefined or null");if(typeof x!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(x)+", string expected");if(typeof ee=="function"&&(ce=ee,ee=null),ee=je({},Ne.defaults,ee||{}),V(ee),ce){var j=ee.highlight,X;try{X=te.lex(x,ee)}catch(xe){return ce(xe)}var se=function(Oe){var Be;if(!Oe)try{Be=be.parse(X,ee)}catch(Qe){Oe=Qe}return ee.highlight=j,Oe?ce(Oe):ce(null,Be)};if(!j||j.length<3||(delete ee.highlight,!X.length))return se();var de=0;Ne.walkTokens(X,function(xe){xe.type==="code"&&(de++,setTimeout(function(){j(xe.text,xe.lang,function(Oe,Be){if(Oe)return se(Oe);Be!=null&&Be!==xe.text&&(xe.text=Be,xe.escaped=!0),de--,de===0&&se()})},0))}),de===0&&se();return}try{var Se=te.lex(x,ee);return ee.walkTokens&&Ne.walkTokens(Se,ee.walkTokens),be.parse(Se,ee)}catch(xe){if(xe.message+=`
Please report this to https://github.com/markedjs/marked.`,ee.silent)return"<p>An error occurred:</p><pre>"+Z(xe.message+"",!0)+"</pre>";throw xe}}Ne.options=Ne.setOptions=function(x){return je(Ne.defaults,x),Me(Ne.defaults),Ne},Ne.getDefaults=_e,Ne.defaults=$e,Ne.use=function(x){var ee=je({},x);if(x.renderer&&function(){var j=Ne.defaults.renderer||new Le,X=function(Se){var xe=j[Se];j[Se]=function(){for(var Oe=arguments.length,Be=new Array(Oe),Qe=0;Qe<Oe;Qe++)Be[Qe]=arguments[Qe];var nt=x.renderer[Se].apply(j,Be);return nt===!1&&(nt=xe.apply(j,Be)),nt}};for(var se in x.renderer)X(se);ee.renderer=j}(),x.tokenizer&&function(){var j=Ne.defaults.tokenizer||new H,X=function(Se){var xe=j[Se];j[Se]=function(){for(var Oe=arguments.length,Be=new Array(Oe),Qe=0;Qe<Oe;Qe++)Be[Qe]=arguments[Qe];var nt=x.tokenizer[Se].apply(j,Be);return nt===!1&&(nt=xe.apply(j,Be)),nt}};for(var se in x.tokenizer)X(se);ee.tokenizer=j}(),x.walkTokens){var ce=Ne.defaults.walkTokens;ee.walkTokens=function(j){x.walkTokens(j),ce&&ce(j)}}Ne.setOptions(ee)},Ne.walkTokens=function(x,ee){for(var ce=T(x),j;!(j=ce()).done;){var X=j.value;switch(ee(X),X.type){case"table":{for(var se=T(X.tokens.header),de;!(de=se()).done;){var Se=de.value;Ne.walkTokens(Se,ee)}for(var xe=T(X.tokens.cells),Oe;!(Oe=xe()).done;)for(var Be=Oe.value,Qe=T(Be),nt;!(nt=Qe()).done;){var et=nt.value;Ne.walkTokens(et,ee)}break}case"list":{Ne.walkTokens(X.items,ee);break}default:X.tokens&&Ne.walkTokens(X.tokens,ee)}}},Ne.parseInline=function(x,ee){if(typeof x=="undefined"||x===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof x!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(x)+", string expected");ee=je({},Ne.defaults,ee||{}),V(ee);try{var ce=te.lexInline(x,ee);return ee.walkTokens&&Ne.walkTokens(ce,ee.walkTokens),be.parseInline(ce,ee)}catch(j){if(j.message+=`
Please report this to https://github.com/markedjs/marked.`,ee.silent)return"<p>An error occurred:</p><pre>"+Z(j.message+"",!0)+"</pre>";throw j}},Ne.Parser=be,Ne.parser=be.parse,Ne.Renderer=Le,Ne.TextRenderer=me,Ne.Lexer=te,Ne.lexer=te.lex,Ne.Tokenizer=H,Ne.Slugger=Ce,Ne.parse=Ne;var Je=Ne;return Je}),define(we[78],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function _(E,C,D){return Math.min(Math.max(E,C),D)}e.clamp=_;function S(E,C){return(C+E%C)%C}e.rot=S;class T{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=T;class P{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=P});"use strict";(function(){function re(T){const P=[];typeof T=="number"&&P.push("code/timeOrigin",T);function E(D){P.push(D,Date.now())}function C(){const D=[];for(let n=0;n<P.length;n+=2)D.push({name:P[n],startTime:P[n+1]});return D}return{mark:E,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const E of performance.getEntriesByType("mark"))P.push({name:E.name,startTime:Math.round(T+E.startTime)});return P}};if(typeof process=="object"){const T=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function _(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var S;typeof global=="object"?S=global:typeof self=="object"?S=self:S={},typeof define=="function"?define("vs/base/common/performance",[],function(){return _(S)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=_(S):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),S.perf=_(S))})(),define(we[21],Ee([0,1]),function(re,e){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.globals=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=void 0;const S="en";let T=!1,P=!1,E=!1,C=!1,D=!1,n=!1,A=!1,I,p=S,f,s;const h=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof process!="undefined"?v=process:typeof h.vscode!="undefined"&&(v=h.vscode.process);const g=typeof((_=v==null?void 0:v.versions)===null||_===void 0?void 0:_.electron)=="string"&&v.type==="renderer";if(e.isElectronSandboxed=g&&(v==null?void 0:v.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=v==null?void 0:v.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!g)s=navigator.userAgent,T=s.indexOf("Windows")>=0,P=s.indexOf("Macintosh")>=0,A=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,E=s.indexOf("Linux")>=0,n=!0,I=navigator.language,p=I;else if(typeof v=="object"){T=v.platform==="win32",P=v.platform==="darwin",E=v.platform==="linux",C=E&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,I=S,p=S;const i=v.env.VSCODE_NLS_CONFIG;if(i)try{const d=JSON.parse(i),y=d.availableLanguages["*"];I=d.locale,p=y||S,f=d._translationsConfigFile}catch(d){}D=!0}else console.error("Unable to resolve platform.");var b;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function c(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let u=0;P?u=1:T?u=3:E&&(u=2),e.isWindows=T,e.isMacintosh=P,e.isLinux=E,e.isLinuxSnap=C,e.isNative=D,e.isWeb=n,e.isIOS=A,e.platform=u,e.userAgent=s,e.language=p;var a;(function(i){function d(){return e.language}i.value=d;function y(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=y;function k(){return e.language==="en"}i.isDefault=k})(a=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=f,e.globals=h,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let y=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeSetImmediateId)for(let w=0,R=y.length;w<R;w++){const F=y[w];if(F.id===m.data.vscodeSetImmediateId){y.splice(w,1),F.callback();return}}});let k=0;return m=>{const w=++k;y.push({id:w,callback:m}),e.globals.postMessage({vscodeSetImmediateId:w},"*")}}if(v&&typeof v.nextTick=="function")return v.nextTick.bind(v);const d=Promise.resolve();return y=>d.then(y)}();var t;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||A?2:T?1:3;let r=!0,o=!1;function l(){if(!o){o=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,r=new Uint16Array(i.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=l}),define(we[36],Ee([0,1,21]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let S;typeof process!="undefined"?S=process:typeof _.globals.vscode!="undefined"?S={get platform(){return _.globals.vscode.process.platform},get env(){return _.globals.vscode.process.env},nextTick(T){return(0,_.setImmediate)(T)},cwd(){return _.globals.vscode.process.env.VSCODE_CWD||_.globals.vscode.process.execPath.substr(0,_.globals.vscode.process.execPath.lastIndexOf(_.globals.vscode.process.platform==="win32"?"\\":"/"))}}:S={get platform(){return _.isWindows?"win32":_.isMacintosh?"darwin":"linux"},nextTick(T){return(0,_.setImmediate)(T)},get env(){return Object.create(null)},cwd(){return"/"}},e.cwd=S.cwd,e.env=S.env,e.platform=S.platform,e.nextTick=S.nextTick}),define(we[10],Ee([0,1,36]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const S=65,T=97,P=90,E=122,C=46,D=47,n=92,A=58,I=63;class p extends Error{constructor(u,a,t){let r;typeof a=="string"&&a.indexOf("not ")===0?(r="must not be",a=a.replace(/^not /,"")):r="must be";const o=u.indexOf(".")!==-1?"property":"argument";let l=`The "${u}" ${o} ${r} of type ${a}`;l+=`. Received type ${typeof t}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function f(c,u){if(typeof c!="string")throw new p(u,"string",c)}function s(c){return c===D||c===n}function h(c){return c===D}function v(c){return c>=S&&c<=P||c>=T&&c<=E}function g(c,u,a,t){let r="",o=0,l=-1,i=0,d=0;for(let y=0;y<=c.length;++y){if(y<c.length)d=c.charCodeAt(y);else{if(t(d))break;d=D}if(t(d)){if(!(l===y-1||i===1))if(i===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==C||r.charCodeAt(r.length-2)!==C){if(r.length>2){const k=r.lastIndexOf(a);k===-1?(r="",o=0):(r=r.slice(0,k),o=r.length-1-r.lastIndexOf(a)),l=y,i=0;continue}else if(r.length!==0){r="",o=0,l=y,i=0;continue}}u&&(r+=r.length>0?`${a}..`:"..",o=2)}else r.length>0?r+=`${a}${c.slice(l+1,y)}`:r=c.slice(l+1,y),o=y-l-1;l=y,i=0}else d===C&&i!==-1?++i:i=-1}return r}function b(c,u){if(u===null||typeof u!="object")throw new p("pathObject","Object",u);const a=u.dir||u.root,t=u.base||`${u.name||""}${u.ext||""}`;return a?a===u.root?`${a}${t}`:`${a}${c}${t}`:t}e.win32={resolve(...c){let u="",a="",t=!1;for(let r=c.length-1;r>=-1;r--){let o;if(r>=0){if(o=c[r],f(o,"path"),o.length===0)continue}else u.length===0?o=_.cwd():(o=_.env[`=${u}`]||_.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==u.toLowerCase()&&o.charCodeAt(2)===n)&&(o=`${u}\\`));const l=o.length;let i=0,d="",y=!1;const k=o.charCodeAt(0);if(l===1)s(k)&&(i=1,y=!0);else if(s(k))if(y=!0,s(o.charCodeAt(1))){let m=2,w=m;for(;m<l&&!s(o.charCodeAt(m));)m++;if(m<l&&m!==w){const R=o.slice(w,m);for(w=m;m<l&&s(o.charCodeAt(m));)m++;if(m<l&&m!==w){for(w=m;m<l&&!s(o.charCodeAt(m));)m++;(m===l||m!==w)&&(d=`\\\\${R}\\${o.slice(w,m)}`,i=m)}}}else i=1;else v(k)&&o.charCodeAt(1)===A&&(d=o.slice(0,2),i=2,l>2&&s(o.charCodeAt(2))&&(y=!0,i=3));if(d.length>0)if(u.length>0){if(d.toLowerCase()!==u.toLowerCase())continue}else u=d;if(t){if(u.length>0)break}else if(a=`${o.slice(i)}\\${a}`,t=y,y&&u.length>0)break}return a=g(a,!t,"\\",s),t?`${u}\\${a}`:`${u}${a}`||"."},normalize(c){f(c,"path");const u=c.length;if(u===0)return".";let a=0,t,r=!1;const o=c.charCodeAt(0);if(u===1)return h(o)?"\\":c;if(s(o))if(r=!0,s(c.charCodeAt(1))){let i=2,d=i;for(;i<u&&!s(c.charCodeAt(i));)i++;if(i<u&&i!==d){const y=c.slice(d,i);for(d=i;i<u&&s(c.charCodeAt(i));)i++;if(i<u&&i!==d){for(d=i;i<u&&!s(c.charCodeAt(i));)i++;if(i===u)return`\\\\${y}\\${c.slice(d)}\\`;i!==d&&(t=`\\\\${y}\\${c.slice(d,i)}`,a=i)}}}else a=1;else v(o)&&c.charCodeAt(1)===A&&(t=c.slice(0,2),a=2,u>2&&s(c.charCodeAt(2))&&(r=!0,a=3));let l=a<u?g(c.slice(a),!r,"\\",s):"";return l.length===0&&!r&&(l="."),l.length>0&&s(c.charCodeAt(u-1))&&(l+="\\"),t===void 0?r?`\\${l}`:l:r?`${t}\\${l}`:`${t}${l}`},isAbsolute(c){f(c,"path");const u=c.length;if(u===0)return!1;const a=c.charCodeAt(0);return s(a)||u>2&&v(a)&&c.charCodeAt(1)===A&&s(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let u,a;for(let o=0;o<c.length;++o){const l=c[o];f(l,"path"),l.length>0&&(u===void 0?u=a=l:u+=`\\${l}`)}if(u===void 0)return".";let t=!0,r=0;if(typeof a=="string"&&s(a.charCodeAt(0))){++r;const o=a.length;o>1&&s(a.charCodeAt(1))&&(++r,o>2&&(s(a.charCodeAt(2))?++r:t=!1))}if(t){for(;r<u.length&&s(u.charCodeAt(r));)r++;r>=2&&(u=`\\${u.slice(r)}`)}return e.win32.normalize(u)},relative(c,u){if(f(c,"from"),f(u,"to"),c===u)return"";const a=e.win32.resolve(c),t=e.win32.resolve(u);if(a===t||(c=a.toLowerCase(),u=t.toLowerCase(),c===u))return"";let r=0;for(;r<c.length&&c.charCodeAt(r)===n;)r++;let o=c.length;for(;o-1>r&&c.charCodeAt(o-1)===n;)o--;const l=o-r;let i=0;for(;i<u.length&&u.charCodeAt(i)===n;)i++;let d=u.length;for(;d-1>i&&u.charCodeAt(d-1)===n;)d--;const y=d-i,k=l<y?l:y;let m=-1,w=0;for(;w<k;w++){const F=c.charCodeAt(r+w);if(F!==u.charCodeAt(i+w))break;F===n&&(m=w)}if(w!==k){if(m===-1)return t}else{if(y>k){if(u.charCodeAt(i+w)===n)return t.slice(i+w+1);if(w===2)return t.slice(i+w)}l>k&&(c.charCodeAt(r+w)===n?m=w:w===2&&(m=3)),m===-1&&(m=0)}let R="";for(w=r+m+1;w<=o;++w)(w===o||c.charCodeAt(w)===n)&&(R+=R.length===0?"..":"\\..");return i+=m,R.length>0?`${R}${t.slice(i,d)}`:(t.charCodeAt(i)===n&&++i,t.slice(i,d))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const u=e.win32.resolve(c);if(u.length<=2)return c;if(u.charCodeAt(0)===n){if(u.charCodeAt(1)===n){const a=u.charCodeAt(2);if(a!==I&&a!==C)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(v(u.charCodeAt(0))&&u.charCodeAt(1)===A&&u.charCodeAt(2)===n)return`\\\\?\\${u}`;return c},dirname(c){f(c,"path");const u=c.length;if(u===0)return".";let a=-1,t=0;const r=c.charCodeAt(0);if(u===1)return s(r)?c:".";if(s(r)){if(a=t=1,s(c.charCodeAt(1))){let i=2,d=i;for(;i<u&&!s(c.charCodeAt(i));)i++;if(i<u&&i!==d){for(d=i;i<u&&s(c.charCodeAt(i));)i++;if(i<u&&i!==d){for(d=i;i<u&&!s(c.charCodeAt(i));)i++;if(i===u)return c;i!==d&&(a=t=i+1)}}}}else v(r)&&c.charCodeAt(1)===A&&(a=u>2&&s(c.charCodeAt(2))?3:2,t=a);let o=-1,l=!0;for(let i=u-1;i>=t;--i)if(s(c.charCodeAt(i))){if(!l){o=i;break}}else l=!1;if(o===-1){if(a===-1)return".";o=a}return c.slice(0,o)},basename(c,u){u!==void 0&&f(u,"ext"),f(c,"path");let a=0,t=-1,r=!0,o;if(c.length>=2&&v(c.charCodeAt(0))&&c.charCodeAt(1)===A&&(a=2),u!==void 0&&u.length>0&&u.length<=c.length){if(u===c)return"";let l=u.length-1,i=-1;for(o=c.length-1;o>=a;--o){const d=c.charCodeAt(o);if(s(d)){if(!r){a=o+1;break}}else i===-1&&(r=!1,i=o+1),l>=0&&(d===u.charCodeAt(l)?--l==-1&&(t=o):(l=-1,t=i))}return a===t?t=i:t===-1&&(t=c.length),c.slice(a,t)}for(o=c.length-1;o>=a;--o)if(s(c.charCodeAt(o))){if(!r){a=o+1;break}}else t===-1&&(r=!1,t=o+1);return t===-1?"":c.slice(a,t)},extname(c){f(c,"path");let u=0,a=-1,t=0,r=-1,o=!0,l=0;c.length>=2&&c.charCodeAt(1)===A&&v(c.charCodeAt(0))&&(u=t=2);for(let i=c.length-1;i>=u;--i){const d=c.charCodeAt(i);if(s(d)){if(!o){t=i+1;break}continue}r===-1&&(o=!1,r=i+1),d===C?a===-1?a=i:l!==1&&(l=1):a!==-1&&(l=-1)}return a===-1||r===-1||l===0||l===1&&a===r-1&&a===t+1?"":c.slice(a,r)},format:b.bind(null,"\\"),parse(c){f(c,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return u;const a=c.length;let t=0,r=c.charCodeAt(0);if(a===1)return s(r)?(u.root=u.dir=c,u):(u.base=u.name=c,u);if(s(r)){if(t=1,s(c.charCodeAt(1))){let m=2,w=m;for(;m<a&&!s(c.charCodeAt(m));)m++;if(m<a&&m!==w){for(w=m;m<a&&s(c.charCodeAt(m));)m++;if(m<a&&m!==w){for(w=m;m<a&&!s(c.charCodeAt(m));)m++;m===a?t=m:m!==w&&(t=m+1)}}}}else if(v(r)&&c.charCodeAt(1)===A){if(a<=2)return u.root=u.dir=c,u;if(t=2,s(c.charCodeAt(2))){if(a===3)return u.root=u.dir=c,u;t=3}}t>0&&(u.root=c.slice(0,t));let o=-1,l=t,i=-1,d=!0,y=c.length-1,k=0;for(;y>=t;--y){if(r=c.charCodeAt(y),s(r)){if(!d){l=y+1;break}continue}i===-1&&(d=!1,i=y+1),r===C?o===-1?o=y:k!==1&&(k=1):o!==-1&&(k=-1)}return i!==-1&&(o===-1||k===0||k===1&&o===i-1&&o===l+1?u.base=u.name=c.slice(l,i):(u.name=c.slice(l,o),u.base=c.slice(l,i),u.ext=c.slice(o,i))),l>0&&l!==t?u.dir=c.slice(0,l-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let u="",a=!1;for(let t=c.length-1;t>=-1&&!a;t--){const r=t>=0?c[t]:_.cwd();f(r,"path"),r.length!==0&&(u=`${r}/${u}`,a=r.charCodeAt(0)===D)}return u=g(u,!a,"/",h),a?`/${u}`:u.length>0?u:"."},normalize(c){if(f(c,"path"),c.length===0)return".";const u=c.charCodeAt(0)===D,a=c.charCodeAt(c.length-1)===D;return c=g(c,!u,"/",h),c.length===0?u?"/":a?"./":".":(a&&(c+="/"),u?`/${c}`:c)},isAbsolute(c){return f(c,"path"),c.length>0&&c.charCodeAt(0)===D},join(...c){if(c.length===0)return".";let u;for(let a=0;a<c.length;++a){const t=c[a];f(t,"path"),t.length>0&&(u===void 0?u=t:u+=`/${t}`)}return u===void 0?".":e.posix.normalize(u)},relative(c,u){if(f(c,"from"),f(u,"to"),c===u||(c=e.posix.resolve(c),u=e.posix.resolve(u),c===u))return"";const a=1,t=c.length,r=t-a,o=1,l=u.length-o,i=r<l?r:l;let d=-1,y=0;for(;y<i;y++){const m=c.charCodeAt(a+y);if(m!==u.charCodeAt(o+y))break;m===D&&(d=y)}if(y===i)if(l>i){if(u.charCodeAt(o+y)===D)return u.slice(o+y+1);if(y===0)return u.slice(o+y)}else r>i&&(c.charCodeAt(a+y)===D?d=y:y===0&&(d=0));let k="";for(y=a+d+1;y<=t;++y)(y===t||c.charCodeAt(y)===D)&&(k+=k.length===0?"..":"/..");return`${k}${u.slice(o+d)}`},toNamespacedPath(c){return c},dirname(c){if(f(c,"path"),c.length===0)return".";const u=c.charCodeAt(0)===D;let a=-1,t=!0;for(let r=c.length-1;r>=1;--r)if(c.charCodeAt(r)===D){if(!t){a=r;break}}else t=!1;return a===-1?u?"/":".":u&&a===1?"//":c.slice(0,a)},basename(c,u){u!==void 0&&f(u,"ext"),f(c,"path");let a=0,t=-1,r=!0,o;if(u!==void 0&&u.length>0&&u.length<=c.length){if(u===c)return"";let l=u.length-1,i=-1;for(o=c.length-1;o>=0;--o){const d=c.charCodeAt(o);if(d===D){if(!r){a=o+1;break}}else i===-1&&(r=!1,i=o+1),l>=0&&(d===u.charCodeAt(l)?--l==-1&&(t=o):(l=-1,t=i))}return a===t?t=i:t===-1&&(t=c.length),c.slice(a,t)}for(o=c.length-1;o>=0;--o)if(c.charCodeAt(o)===D){if(!r){a=o+1;break}}else t===-1&&(r=!1,t=o+1);return t===-1?"":c.slice(a,t)},extname(c){f(c,"path");let u=-1,a=0,t=-1,r=!0,o=0;for(let l=c.length-1;l>=0;--l){const i=c.charCodeAt(l);if(i===D){if(!r){a=l+1;break}continue}t===-1&&(r=!1,t=l+1),i===C?u===-1?u=l:o!==1&&(o=1):u!==-1&&(o=-1)}return u===-1||t===-1||o===0||o===1&&u===t-1&&u===a+1?"":c.slice(u,t)},format:b.bind(null,"/"),parse(c){f(c,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return u;const a=c.charCodeAt(0)===D;let t;a?(u.root="/",t=1):t=0;let r=-1,o=0,l=-1,i=!0,d=c.length-1,y=0;for(;d>=t;--d){const k=c.charCodeAt(d);if(k===D){if(!i){o=d+1;break}continue}l===-1&&(i=!1,l=d+1),k===C?r===-1?r=d:y!==1&&(y=1):r!==-1&&(y=-1)}if(l!==-1){const k=o===0&&a?1:o;r===-1||y===0||y===1&&r===l-1&&r===o+1?u.base=u.name=c.slice(k,l):(u.name=c.slice(k,r),u.base=c.slice(k,l),u.ext=c.slice(r,l))}return o>0?u.dir=c.slice(0,o-1):a&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=_.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=_.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=_.platform==="win32"?e.win32.join:e.posix.join,e.resolve=_.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=_.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=_.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=_.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=_.platform==="win32"?e.win32.extname:e.posix.extname,e.format=_.platform==="win32"?e.win32.format:e.posix.format,e.parse=_.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=_.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=_.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=_.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(we[55],Ee([0,1,21]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const S=_.globals.performance&&typeof _.globals.performance.now=="function";class T{constructor(E){this._highResolution=S&&E,this._startTime=this._now(),this._stopTime=-1}static create(E=!0){return new T(E)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?_.globals.performance.now():Date.now()}}e.StopWatch=T}),define(we[3],Ee([0,1,11,52,6,47,55]),function(re,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(g){g.None=()=>T.Disposable.None;function b(J){return(z,ae=null,L)=>{let N=!1,H;return H=J(O=>{if(!N)return H?H.dispose():N=!0,z.call(ae,O)},null,L),N&&H.dispose(),H}}g.once=b;function c(J,z){return l((ae,L=null,N)=>J(H=>ae.call(L,z(H)),null,N))}g.map=c;function u(J,z){return l((ae,L=null,N)=>J(H=>{z(H),ae.call(L,H)},null,N))}g.forEach=u;function a(J,z){return l((ae,L=null,N)=>J(H=>z(H)&&ae.call(L,H),null,N))}g.filter=a;function t(J){return J}g.signal=t;function r(...J){return(z,ae=null,L)=>(0,T.combinedDisposable)(...J.map(N=>N(H=>z.call(ae,H),null,L)))}g.any=r;function o(J,z,ae){let L=ae;return c(J,N=>(L=z(L,N),L))}g.reduce=o;function l(J){let z;const ae=new p({onFirstListenerAdd(){z=J(ae.fire,ae)},onLastListenerRemove(){z.dispose()}});return ae.event}g.snapshot=l;function i(J,z,ae=100,L=!1,N){let H,O,K,le=0;const ue=new p({leakWarningThreshold:N,onFirstListenerAdd(){H=J(pe=>{le++,O=z(O,pe),L&&!K&&(ue.fire(O),O=void 0),clearTimeout(K),K=setTimeout(()=>{const ve=O;O=void 0,K=void 0,(!L||le>1)&&ue.fire(ve),le=0},ae)})},onLastListenerRemove(){H.dispose()}});return ue.event}g.debounce=i;function d(J){const z=new Date().getTime();return c(b(J),ae=>new Date().getTime()-z)}g.stopwatch=d;function y(J){let z=!0,ae;return a(J,L=>{const N=z||L!==ae;return z=!1,ae=L,N})}g.latch=y;function k(J,z=!1,ae=[]){let L=ae.slice(),N=J(K=>{L?L.push(K):O.fire(K)});const H=()=>{L&&L.forEach(K=>O.fire(K)),L=null},O=new p({onFirstListenerAdd(){N||(N=J(K=>O.fire(K)))},onFirstListenerDidAdd(){L&&(z?setTimeout(H):H())},onLastListenerRemove(){N&&N.dispose(),N=null}});return O.event}g.buffer=k;class m{constructor(z){this.event=z}map(z){return new m(c(this.event,z))}forEach(z){return new m(u(this.event,z))}filter(z){return new m(a(this.event,z))}reduce(z,ae){return new m(o(this.event,z,ae))}latch(){return new m(y(this.event))}debounce(z,ae=100,L=!1,N){return new m(i(this.event,z,ae,L,N))}on(z,ae,L){return this.event(z,ae,L)}once(z,ae,L){return b(this.event)(z,ae,L)}}function w(J){return new m(J)}g.chain=w;function R(J,z,ae=L=>L){const L=(...K)=>O.fire(ae(...K)),N=()=>J.on(z,L),H=()=>J.removeListener(z,L),O=new p({onFirstListenerAdd:N,onLastListenerRemove:H});return O.event}g.fromNodeEventEmitter=R;function F(J,z,ae=L=>L){const L=(...K)=>O.fire(ae(...K)),N=()=>J.addEventListener(z,L),H=()=>J.removeEventListener(z,L),O=new p({onFirstListenerAdd:N,onLastListenerRemove:H});return O.event}g.fromDOMEventEmitter=F;function B(J){const z=new p;let ae=!1;return J.then(void 0,()=>null).then(()=>{ae?z.fire(void 0):setTimeout(()=>z.fire(void 0),0)}),ae=!0,z.event}g.fromPromise=B;function Q(J){return new Promise(z=>b(J)(z))}g.toPromise=Q})(C=e.Event||(e.Event={}));class D{constructor(b){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${b}_${D._idPool++}`}start(b){this._stopWatch=new E.StopWatch(!0),this._listenerCount=b}stop(){if(this._stopWatch){const b=this._stopWatch.elapsed();this._elapsedOverall+=b,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${b.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let n=-1;function A(g){const b=n;return n=g,{dispose(){n=b}}}e.setGlobalLeakWarningThreshold=A;class I{constructor(b,c=Math.random().toString(18).slice(2,5)){this.customThreshold=b,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(b){let c=n;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),!(c<=0||b<c)){this._stacks||(this._stacks=new Map);const u=new Error().stack.split(`
`).slice(3).join(`
`),a=this._stacks.get(u)||0;if(this._stacks.set(u,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let t,r=0;for(const[o,l]of this._stacks)(!t||r<l)&&(t=o,r=l);console.warn(`[${this.name}] potential listener LEAK detected, having ${b} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(u)||0;this._stacks.set(u,t-1)}}}}class p{constructor(b){var c;this._disposed=!1,this._options=b,this._leakageMon=n>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((c=this._options)===null||c===void 0?void 0:c._profName)?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(b,c,u)=>{var a;this._listeners||(this._listeners=new P.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(c?[b,c]:b);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,b,c);const o=(a=this._leakageMon)===null||a===void 0?void 0:a.check(this._listeners.size);let l;return l={dispose:()=>{o&&o(),l.dispose=p._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},u instanceof T.DisposableStore?u.add(l):Array.isArray(u)&&u.push(l),l}),this._event}fire(b){var c,u;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new P.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,b]);for((c=this._perfMon)===null||c===void 0||c.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,t]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,t):a[0].call(a[1],t)}catch(r){(0,_.onUnexpectedError)(r)}}(u=this._perfMon)===null||u===void 0||u.stop()}}dispose(){var b,c,u;(b=this._listeners)===null||b===void 0||b.clear(),(c=this._deliveryQueue)===null||c===void 0||c.clear(),(u=this._leakageMon)===null||u===void 0||u.dispose(),this._disposed=!0}}e.Emitter=p,p._noop=function(){};class f extends p{constructor(b){super(b);this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=b==null?void 0:b.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const b=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(b))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(b){this._listeners&&(this._isPaused!==0?this._eventQueue.push(b):super.fire(b))}}e.PauseableEmitter=f;class s{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new p({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(b){const c={event:b,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const u=()=>{this.hasListeners&&this.unhook(c);const a=this.events.indexOf(c);this.events.splice(a,1)};return(0,T.toDisposable)((0,S.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(b=>this.hook(b))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(b=>this.unhook(b))}hook(b){b.listener=b.event(c=>this.emitter.fire(c))}unhook(b){b.listener&&b.listener.dispose(),b.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=s;class h{constructor(){this.buffers=[]}wrapEvent(b){return(c,u,a)=>b(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>c.call(u,t)):c.call(u,t)},void 0,a)}bufferEvents(b){const c=[];this.buffers.push(c);const u=b();return this.buffers.pop(),c.forEach(a=>a()),u}}e.EventBufferer=h;class v{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=T.Disposable.None,this.emitter=new p({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(b){this.inputEvent=b,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=b(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=v}),define(we[20],Ee([0,1,3]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const S=Object.freeze(function(C,D){const n=setTimeout(C.bind(D),0);return{dispose(){clearTimeout(n)}}});var T;(function(C){function D(n){return n===C.None||n===C.Cancelled||n instanceof P?!0:!n||typeof n!="object"?!1:typeof n.isCancellationRequested=="boolean"&&typeof n.onCancellationRequested=="function"}C.isCancellationToken=D,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:S})})(T=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?S:(this._emitter||(this._emitter=new _.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=T.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=E}),define(we[37],Ee([0,1,3]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class S{constructor(){this._icons=new Map,this._onDidRegister=new _.Emitter}add(A){const I=this._icons.get(A.id);I?A.description?I.description=A.description:console.error(`Duplicate registration of codicon ${A.id}`):(this._icons.set(A.id,A),this._onDidRegister.fire(A))}get(A){return this._icons.get(A)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const T=new S;e.iconRegistry=T;function P(n,A){return new E(n,A)}e.registerCodicon=P;class E{constructor(A,I,p){this.id=A,this.definition=I,this.description=p,T.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=E;function C(n,A){const I=["codicon","codicon-"+n];return A&&I.push("codicon-modifier-"+A),I}e.getClassNamesArray=C;var D;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const A=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function I(s){if(s instanceof E)return["codicon","codicon-"+s.id];const h=A.exec(s.id);if(!h)return I(E.error);let[,v,g]=h;const b=["codicon","codicon-"+v];return g&&b.push("codicon-modifier-"+g.substr(1)),b}n.asClassNameArray=I;function p(s){return I(s).join(" ")}n.asClassName=p;function f(s){return"."+I(s).join(".")}n.asCSSSelector=f})(D=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personAdd=new n("person-add",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(E=e.Codicon||(e.Codicon={}))}),define(we[106],Ee([0,1,11,6]),function(re,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function T(v){const g=v;return g&&[g.on,g.pause,g.resume,g.destroy].every(b=>typeof b=="function")}e.isReadableStream=T;function P(v){const g=v;return g&&T(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean"}e.isReadableBufferedStream=P;function E(v,g){return new C(v,g)}e.newWriteableStream=E;class C{constructor(g,b){this.reducer=g,this.options=b,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(g){var b;if(!this.state.destroyed){if(this.state.flowing)this.emitData(g);else if(this.buffer.data.push(g),typeof((b=this.options)===null||b===void 0?void 0:b.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(g){this.state.destroyed||(this.state.flowing?this.emitError(g):this.buffer.error.push(g))}end(g){this.state.destroyed||(typeof g!="undefined"&&this.write(g),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(g){this.listeners.data.slice(0).forEach(b=>b(g))}emitError(g){this.listeners.error.length===0?(0,_.onUnexpectedError)(g):this.listeners.error.slice(0).forEach(b=>b(g))}emitEnd(){this.listeners.end.slice(0).forEach(g=>g())}on(g,b){if(!this.state.destroyed)switch(g){case"data":this.listeners.data.push(b),this.resume();break;case"end":this.listeners.end.push(b),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(b),this.state.flowing&&this.flowErrors();break}}removeListener(g,b){if(!this.state.destroyed){let c;switch(g){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const u=c.indexOf(b);u>=0&&c.splice(u,1)}}}flowData(){if(this.buffer.data.length>0){const g=this.reducer(this.buffer.data);this.emitData(g),this.buffer.data.length=0;const b=[...this.pendingWritePromises];this.pendingWritePromises.length=0,b.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const g of this.buffer.error)this.emitError(g);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(v,g){const b=[];let c;for(;(c=v.read())!==null;)b.push(c);return g(b)}e.consumeReadable=D;function n(v,g,b){const c=[];let u;for(;(u=v.read())!==null&&c.length<b;)c.push(u);return u===null&&c.length>0?g(c):{read:()=>{if(c.length>0)return c.shift();if(typeof u!="undefined"){const a=u;return u=void 0,a}return v.read()}}}e.peekReadable=n;function A(v,g){return new Promise((b,c)=>{const u=[];I(v,{onData:a=>{g&&u.push(a)},onError:a=>{g?c(a):b(void 0)},onEnd:()=>{b(g?g(u):void 0)}})})}e.consumeStream=A;function I(v,g){v.on("error",b=>g.onError(b)),v.on("end",()=>g.onEnd()),v.on("data",b=>g.onData(b))}e.listenStream=I;function p(v,g){return new Promise((b,c)=>{const u=new S.DisposableStore,a=[],t=l=>{if(a.push(l),a.length>g)return u.dispose(),v.pause(),b({stream:v,buffer:a,ended:!1})},r=l=>c(l),o=()=>b({stream:v,buffer:a,ended:!0});u.add((0,S.toDisposable)(()=>v.removeListener("error",r))),v.on("error",r),u.add((0,S.toDisposable)(()=>v.removeListener("end",o))),v.on("end",o),u.add((0,S.toDisposable)(()=>v.removeListener("data",t))),v.on("data",t)})}e.peekStream=p;function f(v,g){const b=E(g);return b.end(v),b}e.toStream=f;function s(v){let g=!1;return{read:()=>g?null:(g=!0,v)}}e.toReadable=s;function h(v,g,b){const c=E(b);return I(v,{onData:u=>c.write(g.data(u)),onError:u=>c.error(g.error?g.error(u):u),onEnd:()=>c.end()}),c}e.transform=h}),define(we[8],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function _(x){return!x||typeof x!="string"?!0:x.trim().length===0}e.isFalsyOrWhitespace=_;const S=/{(\d+)}/g;function T(x,...ee){return ee.length===0?x:x.replace(S,function(ce,j){const X=parseInt(j,10);return isNaN(X)||X<0||X>=ee.length?ce:ee[X]})}e.format=T;function P(x){return x.replace(/[<>&]/g,function(ee){switch(ee){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ee}})}e.escape=P;function E(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function C(x,ee){let ce=0;const j=ee.charCodeAt(0);for(let X=x.length-1;X>=0;X--)x.charCodeAt(X)===j&&ce++;return ce}e.count=C;function D(x,ee,ce="\u2026"){return x.length<=ee?x:`${x.substr(0,ee)}${ce}`}e.truncate=D;function n(x,ee=" "){const ce=A(x,ee);return I(ce,ee)}e.trim=n;function A(x,ee){if(!x||!ee)return x;const ce=ee.length;if(ce===0||x.length===0)return x;let j=0;for(;x.indexOf(ee,j)===j;)j=j+ce;return x.substring(j)}e.ltrim=A;function I(x,ee){if(!x||!ee)return x;const ce=ee.length,j=x.length;if(ce===0||j===0)return x;let X=j,se=-1;for(;se=x.lastIndexOf(ee,X-1),!(se===-1||se+ce!==X);){if(se===0)return"";X=se}return x.substring(0,X)}e.rtrim=I;function p(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function f(x){return x.replace(/\*/g,"")}e.stripWildcards=f;function s(x,ee,ce={}){if(!x)throw new Error("Cannot create regex from empty string");ee||(x=E(x)),ce.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let j="";return ce.global&&(j+="g"),ce.matchCase||(j+="i"),ce.multiline&&(j+="m"),ce.unicode&&(j+="u"),new RegExp(x,j)}e.createRegExp=s;function h(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function v(x){return!!x.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=v;function g(x){return(x.global?"g":"")+(x.ignoreCase?"i":"")+(x.multiline?"m":"")+(x.unicode?"u":"")}e.regExpFlags=g;function b(x){return x.split(/\r\n|\r|\n/)}e.splitLines=b;function c(x){for(let ee=0,ce=x.length;ee<ce;ee++){const j=x.charCodeAt(ee);if(j!==32&&j!==9)return ee}return-1}e.firstNonWhitespaceIndex=c;function u(x,ee=0,ce=x.length){for(let j=ee;j<ce;j++){const X=x.charCodeAt(j);if(X!==32&&X!==9)return x.substring(ee,j)}return x.substring(ee,ce)}e.getLeadingWhitespace=u;function a(x,ee=x.length-1){for(let ce=ee;ce>=0;ce--){const j=x.charCodeAt(ce);if(j!==32&&j!==9)return ce}return-1}e.lastNonWhitespaceIndex=a;function t(x,ee){return x<ee?-1:x>ee?1:0}e.compare=t;function r(x,ee,ce=0,j=x.length,X=0,se=ee.length){for(;ce<j&&X<se;ce++,X++){let xe=x.charCodeAt(ce),Oe=ee.charCodeAt(X);if(xe<Oe)return-1;if(xe>Oe)return 1}const de=j-ce,Se=se-X;return de<Se?-1:de>Se?1:0}e.compareSubstring=r;function o(x,ee){return l(x,ee,0,x.length,0,ee.length)}e.compareIgnoreCase=o;function l(x,ee,ce=0,j=x.length,X=0,se=ee.length){for(;ce<j&&X<se;ce++,X++){let xe=x.charCodeAt(ce),Oe=ee.charCodeAt(X);if(xe!==Oe){const Be=xe-Oe;if(!(Be===32&&d(Oe))&&!(Be===-32&&d(xe)))return i(xe)&&i(Oe)?Be:r(x.toLowerCase(),ee.toLowerCase(),ce,j,X,se)}}const de=j-ce,Se=se-X;return de<Se?-1:de>Se?1:0}e.compareSubstringIgnoreCase=l;function i(x){return x>=97&&x<=122}e.isLowerAsciiLetter=i;function d(x){return x>=65&&x<=90}e.isUpperAsciiLetter=d;function y(x){return i(x)||d(x)}function k(x,ee){return x.length===ee.length&&m(x,ee)}e.equalsIgnoreCase=k;function m(x,ee,ce=x.length){for(let j=0;j<ce;j++){const X=x.charCodeAt(j),se=ee.charCodeAt(j);if(X!==se){if(y(X)&&y(se)){const de=Math.abs(X-se);if(de!==0&&de!==32)return!1}else if(String.fromCharCode(X).toLowerCase()!==String.fromCharCode(se).toLowerCase())return!1}}return!0}function w(x,ee){const ce=ee.length;return ee.length>x.length?!1:m(x,ee,ce)}e.startsWithIgnoreCase=w;function R(x,ee){let ce,j=Math.min(x.length,ee.length);for(ce=0;ce<j;ce++)if(x.charCodeAt(ce)!==ee.charCodeAt(ce))return ce;return j}e.commonPrefixLength=R;function F(x,ee){let ce,j=Math.min(x.length,ee.length);const X=x.length-1,se=ee.length-1;for(ce=0;ce<j;ce++)if(x.charCodeAt(X-ce)!==ee.charCodeAt(se-ce))return ce;return j}e.commonSuffixLength=F;function B(x){return 55296<=x&&x<=56319}e.isHighSurrogate=B;function Q(x){return 56320<=x&&x<=57343}e.isLowSurrogate=Q;function J(x,ee){return(x-55296<<10)+(ee-56320)+65536}e.computeCodePoint=J;function z(x,ee,ce){const j=x.charCodeAt(ce);if(B(j)&&ce+1<ee){const X=x.charCodeAt(ce+1);if(Q(X))return J(j,X)}return j}e.getNextCodePoint=z;function ae(x,ee){const ce=x.charCodeAt(ee-1);if(Q(ce)&&ee>1){const j=x.charCodeAt(ee-2);if(B(j))return J(j,ce)}return ce}function L(x,ee){const ce=Ne.getInstance(),j=ee,X=x.length,se=z(x,X,ee);ee+=se>=65536?2:1;let de=ce.getGraphemeBreakType(se);for(;ee<X;){const Se=z(x,X,ee),xe=ce.getGraphemeBreakType(Se);if(Me(de,xe))break;ee+=Se>=65536?2:1,de=xe}return ee-j}e.nextCharLength=L;function N(x,ee){const ce=Ne.getInstance(),j=ee,X=ae(x,ee);ee-=X>=65536?2:1;let se=ce.getGraphemeBreakType(X);for(;ee>0;){const de=ae(x,ee),Se=ce.getGraphemeBreakType(de);if(Me(Se,se))break;ee-=de>=65536?2:1,se=Se}return j-ee}e.prevCharLength=N;function H(x,ee){const ce=Ne.getInstance(),j=x.length,X=ee,se=z(x,j,ee),de=ce.getGraphemeBreakType(se);ee+=se>=65536?2:1;let Se=de;for(;ee<j;){const Oe=z(x,j,ee),Be=ce.getGraphemeBreakType(Oe);if(Me(Se,Be))break;ee+=Oe>=65536?2:1,Se=Be}const xe=ee;for(ee=X,Se=de;ee>0;){const Oe=ae(x,ee),Be=ce.getGraphemeBreakType(Oe);if(Me(Be,Se))break;ee-=Oe>=65536?2:1,Se=Be}return[ee,xe]}function O(x,ee){return ee>0&&Q(x.charCodeAt(ee))?H(x,ee-1):H(x,ee)}e.getCharContainingOffset=O;function K(x){const ee=x.length;let ce=0,j=0;for(;j<ee;){const de=z(x,ee,j);j+=de>=65536?2:1,de<128?ce+=1:de<2048?ce+=2:de<65536?ce+=3:ce+=4}const X=new Uint8Array(ce);j=0;let se=0;for(;j<ee;){const de=z(x,ee,j);j+=de>=65536?2:1,de<128?X[se++]=de:de<2048?(X[se++]=192|(de&1984)>>>6,X[se++]=128|(de&63)>>>0):de<65536?(X[se++]=224|(de&61440)>>>12,X[se++]=128|(de&4032)>>>6,X[se++]=128|(de&63)>>>0):(X[se++]=240|(de&1835008)>>>18,X[se++]=128|(de&258048)>>>12,X[se++]=128|(de&4032)>>>6,X[se++]=128|(de&63)>>>0)}return X}e.encodeUTF8=K;function le(x){const ee=x.byteLength,ce=[];let j=0;for(;j<ee;){const X=x[j];let se;if(X>=240&&j+3<ee?se=(x[j++]&7)<<18>>>0|(x[j++]&63)<<12>>>0|(x[j++]&63)<<6>>>0|(x[j++]&63)<<0>>>0:X>=224&&j+2<ee?se=(x[j++]&15)<<12>>>0|(x[j++]&63)<<6>>>0|(x[j++]&63)<<0>>>0:X>=192&&j+1<ee?se=(x[j++]&31)<<6>>>0|(x[j++]&63)<<0>>>0:se=x[j++],se>=0&&se<=55295||se>=57344&&se<=65535)ce.push(String.fromCharCode(se));else if(se>=65536&&se<=1114111){const de=se-65536,Se=55296+((de&1047552)>>>10),xe=56320+((de&1023)>>>0);ce.push(String.fromCharCode(Se)),ce.push(String.fromCharCode(xe))}else ce.push(String.fromCharCode(65533))}return ce.join("")}e.decodeUTF8=le;const ue=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function pe(x){return ue.test(x)}e.containsRTL=pe;const ve=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Re(x){return ve.test(x)}e.containsEmoji=Re;const He=/^[\t\n\r\x20-\x7E]*$/;function Fe(x){return He.test(x)}e.isBasicASCII=Fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ze(x){return e.UNUSUAL_LINE_TERMINATORS.test(x)}e.containsUnusualLineTerminators=ze;function $(x){for(let ee=0,ce=x.length;ee<ce;ee++)if(G(x.charCodeAt(ee)))return!0;return!1}e.containsFullWidthCharacter=$;function G(x){return x=+x,x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}e.isFullWidthCharacter=G;function te(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129003||x>=129280&&x<=129535||x>=129648&&x<=129750}e.isEmojiImprecise=te;function ie(x,ee){if(x.length<ee)return x;const ce=/\b/g;let j=0;for(;ce.test(x)&&!(x.length-ce.lastIndex<ee);)j=ce.lastIndex,ce.lastIndex+=1;return x.substring(j).replace(/^\s/,"")}e.lcut=ie;const he=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Le=/\x1b\[0?m/g;function me(x){return x&&(x=x.replace(he,""),x=x.replace(De,""),x=x.replace(Le,"")),x}e.removeAnsiEscapeCodes=me,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function ke(x){return Ce(x)?x.substr(1):x}e.stripUTF8BOM=ke;function Ue(x,ee){if(!x||!ee||x.length<ee.length)return!1;const ce=ee.length,j=x.toLowerCase();let X=0,se=-1;for(;X<ce;){const de=j.indexOf(ee[X],se+1);if(de<0)return!1;se=de,X++}return!0}e.fuzzyContains=Ue;function be(x,ee=!1){return x?(ee&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}e.containsUppercaseCharacter=be;function je(x){return x.charAt(0).toUpperCase()+x.slice(1)}e.uppercaseFirstLetter=je;function V(x,ee=1){if(ee===0)return"";let ce=-1;do ce=x.indexOf(`
`,ce+1),ee--;while(ee>0&&ce>=0);return ce===-1?x:(x[ce-1]==="\r"&&ce--,x.substr(0,ce))}e.getNLines=V;function Z(x){const ee=90-65+1;return x=x%(2*ee),x<ee?String.fromCharCode(97+x):String.fromCharCode(65+x-ee)}e.singleLetterHash=Z;function _e(x){return Ne.getInstance().getGraphemeBreakType(x)}e.getGraphemeBreakType=_e;function Me(x,ee){return x===0?ee!==5&&ee!==7:x===2&&ee===3?!1:x===4||x===2||x===3||ee===4||ee===2||ee===3?!0:!(x===8&&(ee===8||ee===9||ee===11||ee===12)||(x===11||x===9)&&(ee===9||ee===10)||(x===12||x===10)&&ee===10||ee===5||ee===13||ee===7||x===1||x===13&&ee===14||x===6&&ee===6)}e.breakBetweenGraphemeBreakType=Me;var $e;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})($e=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ne{constructor(){this._data=Je()}static getInstance(){return Ne._INSTANCE||(Ne._INSTANCE=new Ne),Ne._INSTANCE}getGraphemeBreakType(ee){if(ee<32)return ee===10?3:ee===13?2:4;if(ee<127)return 0;const ce=this._data,j=ce.length/3;let X=1;for(;X<=j;)if(ee<ce[3*X])X=2*X;else if(ee>ce[3*X+1])X=2*X+1;else return ce[3*X+2];return 0}}Ne._INSTANCE=null;function Je(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(we[26],Ee([0,1,8,106]),function(re,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer!="undefined",P=typeof TextEncoder!="undefined",E=typeof TextDecoder!="undefined";let C,D;class n{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return T?new n(Buffer.allocUnsafe(i)):new n(new Uint8Array(i))}static wrap(i){return T&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new n(i)}static fromString(i,d){return!((d==null?void 0:d.dontUseNodeBuffer)||!1)&&T?new n(Buffer.from(i)):P?(C||(C=new TextEncoder),new n(C.encode(i))):new n(_.encodeUTF8(i))}static concat(i,d){if(typeof d=="undefined"){d=0;for(let m=0,w=i.length;m<w;m++)d+=i[m].byteLength}const y=n.alloc(d);let k=0;for(let m=0,w=i.length;m<w;m++){const R=i[m];y.set(R,k),k+=R.byteLength}return y}toString(){return T?this.buffer.toString():E?(D||(D=new TextDecoder),D.decode(this.buffer)):_.decodeUTF8(this.buffer)}slice(i,d){return new n(this.buffer.subarray(i,d))}set(i,d){i instanceof n?this.buffer.set(i.buffer,d):this.buffer.set(i,d)}readUInt32BE(i){return p(this.buffer,i)}writeUInt32BE(i,d){f(this.buffer,i,d)}readUInt32LE(i){return s(this.buffer,i)}writeUInt32LE(i,d){h(this.buffer,i,d)}readUInt8(i){return v(this.buffer,i)}writeUInt8(i,d){g(this.buffer,i,d)}}e.VSBuffer=n;function A(l,i){return l[i+0]<<0>>>0|l[i+1]<<8>>>0}e.readUInt16LE=A;function I(l,i,d){l[d+0]=i&255,i=i>>>8,l[d+1]=i&255}e.writeUInt16LE=I;function p(l,i){return l[i]*2**24+l[i+1]*2**16+l[i+2]*2**8+l[i+3]}e.readUInt32BE=p;function f(l,i,d){l[d+3]=i,i=i>>>8,l[d+2]=i,i=i>>>8,l[d+1]=i,i=i>>>8,l[d]=i}e.writeUInt32BE=f;function s(l,i){return l[i+0]<<0>>>0|l[i+1]<<8>>>0|l[i+2]<<16>>>0|l[i+3]<<24>>>0}e.readUInt32LE=s;function h(l,i,d){l[d+0]=i&255,i=i>>>8,l[d+1]=i&255,i=i>>>8,l[d+2]=i&255,i=i>>>8,l[d+3]=i&255}e.writeUInt32LE=h;function v(l,i){return l[i]}e.readUInt8=v;function g(l,i,d){l[d]=i}e.writeUInt8=g;function b(l){return S.consumeReadable(l,i=>n.concat(i))}e.readableToBuffer=b;function c(l){return S.toReadable(l)}e.bufferToReadable=c;function u(l){return S.consumeStream(l,i=>n.concat(i))}e.streamToBuffer=u;async function a(l){return l.ended?n.concat(l.buffer):n.concat([...l.buffer,await u(l.stream)])}e.bufferedStreamToBuffer=a;function t(l){return S.toStream(l,i=>n.concat(i))}e.bufferToStream=t;function r(l){return S.transform(l,{data:i=>typeof i=="string"?n.fromString(i):n.wrap(i)},i=>n.concat(i))}e.streamToBufferReadableStream=r;function o(l){return S.newWriteableStream(i=>n.concat(i),l)}e.newWriteableBufferStream=o}),define(we[56],Ee([0,1,8]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function S(g){return T(g,0)}e.hash=S;function T(g,b){switch(typeof g){case"object":return g===null?P(349,b):Array.isArray(g)?D(g,b):n(g,b);case"string":return C(g,b);case"boolean":return E(g,b);case"number":return P(g,b);case"undefined":return P(937,b);default:return P(617,b)}}e.doHash=T;function P(g,b){return(b<<5)-b+g|0}function E(g,b){return P(g?433:863,b)}function C(g,b){b=P(149417,b);for(let c=0,u=g.length;c<u;c++)b=P(g.charCodeAt(c),b);return b}e.stringHash=C;function D(g,b){return b=P(104579,b),g.reduce((c,u)=>T(u,c),b)}function n(g,b){return b=P(181387,b),Object.keys(g).sort().reduce((c,u)=>(c=C(u,c),T(g[u],c)),b)}class A{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=T(b,this._value),this._value}}e.Hasher=A;var I;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function p(g,b,c=32){const u=c-b,a=~((1<<u)-1);return(g<<b|(a&g)>>>u)>>>0}function f(g,b=0,c=g.byteLength,u=0){for(let a=0;a<c;a++)g[b+a]=u}function s(g,b,c="0"){for(;g.length<b;)g=c+g;return g}function h(g,b=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(c=>c.toString(16).padStart(2,"0")).join(""):s((g>>>0).toString(16),b/4)}e.toHexString=h;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const c=b.length;if(c!==0){const u=this._buff;let a=this._buffLen,t=this._leftoverHighSurrogate,r,o;for(t!==0?(r=t,o=-1,t=0):(r=b.charCodeAt(0),o=0);;){let l=r;if(_.isHighSurrogate(r))if(o+1<c){const i=b.charCodeAt(o+1);_.isLowSurrogate(i)?(o++,l=_.computeCodePoint(r,i)):l=65533}else{t=r;break}else _.isLowSurrogate(r)&&(l=65533);if(a=this._push(u,a,l),o++,o<c)r=b.charCodeAt(o);else break}this._buffLen=a,this._leftoverHighSurrogate=t}}_push(b,c,u){return u<128?b[c++]=u:u<2048?(b[c++]=192|(u&1984)>>>6,b[c++]=128|(u&63)>>>0):u<65536?(b[c++]=224|(u&61440)>>>12,b[c++]=128|(u&4032)>>>6,b[c++]=128|(u&63)>>>0):(b[c++]=240|(u&1835008)>>>18,b[c++]=128|(u&258048)>>>12,b[c++]=128|(u&4032)>>>6,b[c++]=128|(u&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=v._bigBlock32,c=this._buffDV;for(let y=0;y<64;y+=4)b.setUint32(y,c.getUint32(y,!1),!1);for(let y=64;y<320;y+=4)b.setUint32(y,p(b.getUint32(y-12,!1)^b.getUint32(y-32,!1)^b.getUint32(y-56,!1)^b.getUint32(y-64,!1),1),!1);let u=this._h0,a=this._h1,t=this._h2,r=this._h3,o=this._h4,l,i,d;for(let y=0;y<80;y++)y<20?(l=a&t|~a&r,i=1518500249):y<40?(l=a^t^r,i=1859775393):y<60?(l=a&t|a&r|t&r,i=2400959708):(l=a^t^r,i=3395469782),d=p(u,5)+l+o+i+b.getUint32(y*4,!1)&4294967295,o=r,r=t,t=p(a,30),a=u,u=d;this._h0=this._h0+u&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))}),define(we[57],Ee([0,1,8]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var S;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(S||(S={})),function(T){const P="error",E="warning",C="warn",D="info";function n(A){return A?_.equalsIgnoreCase(P,A)?T.Error:_.equalsIgnoreCase(E,A)||_.equalsIgnoreCase(C,A)?T.Warning:_.equalsIgnoreCase(D,A)?T.Info:T.Ignore:T.Ignore}T.fromValue=n}(S||(S={})),e.default=S}),define(we[12],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function _(i){return Array.isArray(i)}e.isArray=_;function S(i){return typeof i=="string"}e.isString=S;function T(i){return Array.isArray(i)&&i.every(d=>S(d))}e.isStringArray=T;function P(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}e.isObject=P;function E(i){return typeof i=="number"&&!isNaN(i)}e.isNumber=E;function C(i){return i===!0||i===!1}e.isBoolean=C;function D(i){return typeof i=="undefined"}e.isUndefined=D;function n(i){return!A(i)}e.isDefined=n;function A(i){return D(i)||i===null}e.isUndefinedOrNull=A;function I(i,d){if(!i)throw new Error(d?`Unexpected type, expected '${d}'`:"Unexpected type")}e.assertType=I;function p(i){if(A(i))throw new Error("Assertion Failed: argument is undefined or null");return i}e.assertIsDefined=p;function f(...i){const d=[];for(let y=0;y<i.length;y++){const k=i[y];if(A(k))throw new Error(`Assertion Failed: argument at index ${y} is undefined or null`);d.push(k)}return d}e.assertAllDefined=f;const s=Object.prototype.hasOwnProperty;function h(i){if(!P(i))return!1;for(let d in i)if(s.call(i,d))return!1;return!0}e.isEmptyObject=h;function v(i){return typeof i=="function"}e.isFunction=v;function g(...i){return i.length>0&&i.every(v)}e.areFunctions=g;function b(i,d){const y=Math.min(i.length,d.length);for(let k=0;k<y;k++)c(i[k],d[k])}e.validateConstraints=b;function c(i,d){if(S(d)){if(typeof i!==d)throw new Error(`argument does not match constraint: typeof ${d}`)}else if(v(d)){try{if(i instanceof d)return}catch(y){}if(!A(i)&&i.constructor===d||d.length===1&&d.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function u(i){let d=[],y=Object.getPrototypeOf(i);for(;Object.prototype!==y;)d=d.concat(Object.getOwnPropertyNames(y)),y=Object.getPrototypeOf(y);return d}e.getAllPropertyNames=u;function a(i){const d=[];for(const y of u(i))typeof i[y]=="function"&&d.push(y);return d}e.getAllMethodNames=a;function t(i,d){const y=m=>function(){const w=Array.prototype.slice.call(arguments,0);return d(m,w)};let k={};for(const m of i)k[m]=y(m);return k}e.createProxyObject=t;function r(i){return i===null?void 0:i}e.withNullAsUndefined=r;function o(i){return typeof i=="undefined"?null:i}e.withUndefinedAsNull=o;function l(i){return class{constructor(){return new Proxy({},{get(d,y){if(d[y])return d[y];throw new Error(`Not Implemented: ${i}->${String(y)}`)}})}}}e.NotImplementedProxy=l}),define(we[38],Ee([0,1,21,8,10,12]),function(re,e,_,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function E(r){return r===47||r===92}e.isPathSeparator=E;function C(r){return r.replace(/[\\/]/g,T.posix.sep)}e.toSlashes=C;function D(r,o=T.posix.sep){if(!r)return"";const l=r.length,i=r.charCodeAt(0);if(E(i)){if(E(r.charCodeAt(1))&&!E(r.charCodeAt(2))){let y=3;const k=y;for(;y<l&&!E(r.charCodeAt(y));y++);if(k!==y&&!E(r.charCodeAt(y+1))){for(y+=1;y<l;y++)if(E(r.charCodeAt(y)))return r.slice(0,y+1).replace(/[\\/]/g,o)}}return o}else if(v(i)&&r.charCodeAt(1)===58)return E(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let d=r.indexOf("://");if(d!==-1){for(d+=3;d<l;d++)if(E(r.charCodeAt(d)))return r.slice(0,d+1)}return""}e.getRoot=D;function n(r){if(!_.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let l=2;const i=l;for(;l<r.length&&(o=r.charCodeAt(l),o!==92);l++);return!(i===l||(o=r.charCodeAt(l+1),isNaN(o)||o===92))}e.isUNC=n;const A=/[\\/:\*\?"<>\|]/g,I=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,o=_.isWindows){const l=o?A:I;return!(!r||r.length===0||/^\s+$/.test(r)||(l.lastIndex=0,l.test(r))||o&&p.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=f;function s(r,o,l){const i=r===o;return!l||i?i:!r||!o?!1:(0,S.equalsIgnoreCase)(r,o)}e.isEqual=s;function h(r,o,l,i=T.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(l){if(!(0,S.startsWithIgnoreCase)(r,o))return!1;if(o.length===r.length)return!0;let y=o.length;return o.charAt(o.length-1)===i&&y--,r.charAt(y)===i}return o.charAt(o.length-1)!==i&&(o+=i),r.indexOf(o)===0}e.isEqualOrParent=h;function v(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=v;function g(r,o){return _.isWindows&&r.endsWith(":")&&(r+=T.sep),(0,T.isAbsolute)(r)||(r=(0,T.join)(o,r)),r=(0,T.normalize)(r),_.isWindows?(r=(0,S.rtrim)(r,T.sep),r.endsWith(":")&&(r+=T.sep)):(r=(0,S.rtrim)(r,T.sep),r||(r=T.sep)),r}e.sanitizeFilePath=g;function b(r){const o=(0,T.normalize)(r);return _.isWindows?r.length>3?!1:c(o)&&(r.length===2||o.charCodeAt(2)===92):o===T.posix.sep}e.isRootOrDriveLetter=b;function c(r){return _.isWindows?v(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function u(r){return c(r)?r[0]:void 0}e.getDriveLetter=u;function a(r,o,l){return o.length>r.length?-1:r===o?0:(l&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=a;function t(r){const o=r.split(":");let l,i,d;if(o.forEach(y=>{const k=Number(y);(0,P.isNumber)(k)?i===void 0?i=k:d===void 0&&(d=k):l=l?[l,y].join(":"):y}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:i!==void 0?i:void 0,column:d!==void 0?d:i!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(we[24],Ee([0,1,12]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function S(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const h=Array.isArray(s)?[]:{};return Object.keys(s).forEach(v=>{s[v]&&typeof s[v]=="object"?h[v]=S(s[v]):h[v]=s[v]}),h}e.deepClone=S;function T(s){if(!s||typeof s!="object")return s;const h=[s];for(;h.length>0;){const v=h.shift();Object.freeze(v);for(const g in v)if(P.call(v,g)){const b=v[g];typeof b=="object"&&!Object.isFrozen(b)&&h.push(b)}}return s}e.deepFreeze=T;const P=Object.prototype.hasOwnProperty;function E(s,h){return C(s,h,new Set)}e.cloneAndChange=E;function C(s,h,v){if((0,_.isUndefinedOrNull)(s))return s;const g=h(s);if(typeof g!="undefined")return g;if((0,_.isArray)(s)){const b=[];for(const c of s)b.push(C(c,h,v));return b}if((0,_.isObject)(s)){if(v.has(s))throw new Error("Cannot clone recursive data-structure");v.add(s);const b={};for(let c in s)P.call(s,c)&&(b[c]=C(s[c],h,v));return v.delete(s),b}return s}function D(s,h,v=!0){return(0,_.isObject)(s)?((0,_.isObject)(h)&&Object.keys(h).forEach(g=>{g in s?v&&((0,_.isObject)(s[g])&&(0,_.isObject)(h[g])?D(s[g],h[g],v):s[g]=h[g]):s[g]=h[g]}),s):h}e.mixin=D;function n(s,h){if(s===h)return!0;if(s==null||h===null||h===void 0||typeof s!=typeof h||typeof s!="object"||Array.isArray(s)!==Array.isArray(h))return!1;let v,g;if(Array.isArray(s)){if(s.length!==h.length)return!1;for(v=0;v<s.length;v++)if(!n(s[v],h[v]))return!1}else{const b=[];for(g in s)b.push(g);b.sort();const c=[];for(g in h)c.push(g);if(c.sort(),!n(b,c))return!1;for(v=0;v<b.length;v++)if(!n(s[b[v]],h[b[v]]))return!1}return!0}e.equals=n;function A(s){const h=new Set;return JSON.stringify(s,(v,g)=>{if((0,_.isObject)(g)||Array.isArray(g)){if(h.has(g))return"[Circular]";h.add(g)}return g})}e.safeStringify=A;function I(s,h,v){const g=h(s);return typeof g=="undefined"?v:g}e.getOrDefault=I;function p(s,h){const v=Object.create(null);return!s||!h||Object.keys(h).forEach(b=>{const c=s[b],u=h[b];n(c,u)||(v[b]=u)}),v}e.distinct=p;function f(s,h){const v=h.toLowerCase(),g=Object.keys(s).find(b=>b.toLowerCase()===v);return g?s[g]:s[h]}e.getCaseInsensitive=f}),define(we[79],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var _;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(_=e.Constants||(e.Constants={}));function S(P){return P<0?0:P>255?255:P|0}e.toUint8=S;function T(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=T}),define(we[2],Ee([0,1,21,10]),function(re,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,P=/^\//,E=/^\/\//;function C(o,l){if(!o.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!T.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!P.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(o,l){return!o&&!l?"file":o}function n(o,l){switch(o){case"https":case"http":case"file":l?l[0]!==I&&(l=I+l):l=I;break}return l}const A="",I="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(l,i,d,y,k,m=!1){typeof l=="object"?(this.scheme=l.scheme||A,this.authority=l.authority||A,this.path=l.path||A,this.query=l.query||A,this.fragment=l.fragment||A):(this.scheme=D(l,m),this.authority=i||A,this.path=n(this.scheme,d||A),this.query=y||A,this.fragment=k||A,C(this,m))}static isUri(l){return l instanceof f?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}get fsPath(){return c(this,!1)}with(l){if(!l)return this;let{scheme:i,authority:d,path:y,query:k,fragment:m}=l;return i===void 0?i=this.scheme:i===null&&(i=A),d===void 0?d=this.authority:d===null&&(d=A),y===void 0?y=this.path:y===null&&(y=A),k===void 0?k=this.query:k===null&&(k=A),m===void 0?m=this.fragment:m===null&&(m=A),i===this.scheme&&d===this.authority&&y===this.path&&k===this.query&&m===this.fragment?this:new h(i,d,y,k,m)}static parse(l,i=!1){const d=p.exec(l);return d?new h(d[2]||A,r(d[4]||A),r(d[5]||A),r(d[7]||A),r(d[9]||A),i):new h(A,A,A,A,A)}static file(l){let i=A;if(_.isWindows&&(l=l.replace(/\\/g,I)),l[0]===I&&l[1]===I){const d=l.indexOf(I,2);d===-1?(i=l.substring(2),l=I):(i=l.substring(2,d),l=l.substring(d)||I)}return new h("file",i,l,A,A)}static from(l){return new h(l.scheme,l.authority,l.path,l.query,l.fragment)}static joinPath(l,...i){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return _.isWindows&&l.scheme==="file"?d=f.file(S.win32.join(c(l,!0),...i)).path:d=S.posix.join(l.path,...i),l.with({path:d})}toString(l=!1){return u(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof f)return l;{const i=new h(l);return i._formatted=l.external,i._fsPath=l._sep===s?l.fsPath:null,i}}else return l}}e.URI=f;const s=_.isWindows?1:void 0;class h extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(l=!1){return l?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=s),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(o,l){let i,d=-1;for(let y=0;y<o.length;y++){const k=o.charCodeAt(y);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||l&&k===47)d!==-1&&(i+=encodeURIComponent(o.substring(d,y)),d=-1),i!==void 0&&(i+=o.charAt(y));else{i===void 0&&(i=o.substr(0,y));const m=v[k];m!==void 0?(d!==-1&&(i+=encodeURIComponent(o.substring(d,y)),d=-1),i+=m):d===-1&&(d=y)}}return d!==-1&&(i+=encodeURIComponent(o.substring(d))),i!==void 0?i:o}function b(o){let l;for(let i=0;i<o.length;i++){const d=o.charCodeAt(i);d===35||d===63?(l===void 0&&(l=o.substr(0,i)),l+=v[d]):l!==void 0&&(l+=o[i])}return l!==void 0?l:o}function c(o,l){let i;return o.authority&&o.path.length>1&&o.scheme==="file"?i=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?l?i=o.path.substr(1):i=o.path[1].toLowerCase()+o.path.substr(2):i=o.path,_.isWindows&&(i=i.replace(/\//g,"\\")),i}e.uriToFsPath=c;function u(o,l){const i=l?b:g;let d="",{scheme:y,authority:k,path:m,query:w,fragment:R}=o;if(y&&(d+=y,d+=":"),(k||y==="file")&&(d+=I,d+=I),k){let F=k.indexOf("@");if(F!==-1){const B=k.substr(0,F);k=k.substr(F+1),F=B.indexOf(":"),F===-1?d+=i(B,!1):(d+=i(B.substr(0,F),!1),d+=":",d+=i(B.substr(F+1),!1)),d+="@"}k=k.toLowerCase(),F=k.indexOf(":"),F===-1?d+=i(k,!1):(d+=i(k.substr(0,F),!1),d+=k.substr(F))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const F=m.charCodeAt(1);F>=65&&F<=90&&(m=`/${String.fromCharCode(F+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const F=m.charCodeAt(0);F>=65&&F<=90&&(m=`${String.fromCharCode(F+32)}:${m.substr(2)}`)}d+=i(m,!0)}return w&&(d+="?",d+=i(w,!1)),R&&(d+="#",d+=l?R:g(R,!1)),d}function a(o){try{return decodeURIComponent(o)}catch(l){return o.length>3?o.substr(0,3)+a(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(o){return o.match(t)?o.replace(t,l=>a(l)):o}}),define(we[22],Ee([0,1,2,8]),function(re,e,_,S){"use strict";var T,P;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function E(u,a,t){let r=u.get(a);return r===void 0&&(r=t,u.set(a,r)),r}e.getOrSet=E;function C(u){const a=[];return u.forEach((t,r)=>{a.push(`${r} => ${t}`)}),`Map(${u.size}) {${a.join(", ")}}`}e.mapToString=C;function D(u){const a=[];return u.forEach(t=>{a.push(t)}),`Set(${u.size}) {${a.join(", ")}}`}e.setToString=D;class n{constructor(){this._value="",this._pos=0}reset(a){return this._value=a,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(a){const t=a.charCodeAt(0),r=this._value.charCodeAt(this._pos);return t-r}value(){return this._value[this._pos]}}e.StringIterator=n;class A{constructor(a=!0){this._caseSensitive=a}reset(a){return this._value=a,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(a)this._from++;else break;else a=!1;return this}cmp(a){return this._caseSensitive?(0,S.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,S.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class I{constructor(a=!0,t=!0){this._splitOnBackslash=a,this._caseSensitive=t}reset(a){return this._value=a.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(a)this._from++;else break;else a=!1}return this}cmp(a){return this._caseSensitive?(0,S.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,S.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=I;var p;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(p||(p={}));class f{constructor(a){this._ignorePathCasing=a,this._states=[],this._stateIdx=0}reset(a){return this._value=a,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new I(!1,!this._ignorePathCasing(a)),this._pathIterator.reset(a.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(a){if(this._states[this._stateIdx]===1)return(0,S.compareIgnoreCase)(a,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,S.compareIgnoreCase)(a,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(a);if(this._states[this._stateIdx]===4)return(0,S.compare)(a,this._value.query);if(this._states[this._stateIdx]===5)return(0,S.compare)(a,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class s{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class h{constructor(a){this._iter=a}static forUris(a=()=>!1){return new h(new f(a))}static forPaths(){return new h(new I)}static forStrings(){return new h(new n)}static forConfigKeys(){return new h(new A)}clear(){this._root=void 0}set(a,t){const r=this._iter.reset(a);let o;for(this._root||(this._root=new s,this._root.segment=r.value()),o=this._root;;){const i=r.cmp(o.segment);if(i>0)o.left||(o.left=new s,o.left.segment=r.value()),o=o.left;else if(i<0)o.right||(o.right=new s,o.right.segment=r.value()),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new s,o.mid.segment=r.value()),o=o.mid;else break}const l=o.value;return o.value=t,o.key=a,l}get(a){var t;return(t=this._getNode(a))===null||t===void 0?void 0:t.value}_getNode(a){const t=this._iter.reset(a);let r=this._root;for(;r;){const o=t.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else break}return r}has(a){const t=this._getNode(a);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(a){return this._delete(a,!1)}deleteSuperstr(a){return this._delete(a,!0)}_delete(a,t){const r=this._iter.reset(a),o=[];let l=this._root;for(;l;){const i=r.cmp(l.segment);if(i>0)o.push([1,l]),l=l.left;else if(i<0)o.push([-1,l]),l=l.right;else if(r.hasNext())r.next(),o.push([0,l]),l=l.mid;else{for(t?(l.left=void 0,l.mid=void 0,l.right=void 0):l.value=void 0;o.length>0&&l.isEmpty();){let[d,y]=o.pop();switch(d){case 1:y.left=void 0;break;case 0:y.mid=void 0;break;case-1:y.right=void 0;break}l=y}break}}}findSubstr(a){const t=this._iter.reset(a);let r=this._root,o;for(;r;){const l=t.cmp(r.segment);if(l>0)r=r.left;else if(l<0)r=r.right;else if(t.hasNext())t.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(a){const t=this._iter.reset(a);let r=this._root;for(;r;){const o=t.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(a){for(const[t,r]of this)a(r,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(a){a&&(yield*this._entries(a.left),a.value&&(yield[a.key,a.value]),yield*this._entries(a.mid),yield*this._entries(a.right))}}e.TernarySearchTree=h;class v{constructor(a,t){this[T]="ResourceMap",a instanceof v?(this.map=new Map(a.map),this.toKey=t!=null?t:v.defaultToKey):(this.map=new Map,this.toKey=a!=null?a:v.defaultToKey)}set(a,t){return this.map.set(this.toKey(a),t),this}get(a){return this.map.get(this.toKey(a))}has(a){return this.map.has(this.toKey(a))}get size(){return this.map.size}clear(){this.map.clear()}delete(a){return this.map.delete(this.toKey(a))}forEach(a,t){typeof t!="undefined"&&(a=a.bind(t));for(let[r,o]of this.map)a(o,_.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let a of this.map.keys())yield _.URI.parse(a)}*entries(){for(let a of this.map.entries())yield[_.URI.parse(a[0]),a[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let a of this.map)yield[_.URI.parse(a[0]),a[1]]}}e.ResourceMap=v,v.defaultToKey=u=>u.toString();var g;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(g=e.Touch||(e.Touch={}));class b{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var a;return(a=this._head)===null||a===void 0?void 0:a.value}get last(){var a;return(a=this._tail)===null||a===void 0?void 0:a.value}has(a){return this._map.has(a)}get(a,t=0){const r=this._map.get(a);if(!!r)return t!==0&&this.touch(r,t),r.value}set(a,t,r=0){let o=this._map.get(a);if(o)o.value=t,r!==0&&this.touch(o,r);else{switch(o={key:a,value:t,next:void 0,previous:void 0},r){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(a,o),this._size++}return this}delete(a){return!!this.remove(a)}remove(a){const t=this._map.get(a);if(!!t)return this._map.delete(a),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const a=this._head;return this._map.delete(a.key),this.removeItem(a),this._size--,a.value}}forEach(a,t){const r=this._state;let o=this._head;for(;o;){if(t?a.bind(t)(o.value,o.key,this):a(o.value,o.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const a=this,t=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(a._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const l={value:r.key,done:!1};return r=r.next,l}else return{value:void 0,done:!0}}};return o}values(){const a=this,t=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(a._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const l={value:r.value,done:!1};return r=r.next,l}else return{value:void 0,done:!0}}};return o}entries(){const a=this,t=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(a._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const l={value:[r.key,r.value],done:!1};return r=r.next,l}else return{value:void 0,done:!0}}};return o}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(a){if(!(a>=this.size)){if(a===0){this.clear();return}let t=this._head,r=this.size;for(;t&&r>a;)this._map.delete(t.key),t=t.next,r--;this._head=t,this._size=r,t&&(t.previous=void 0),this._state++}}addItemFirst(a){if(!this._head&&!this._tail)this._tail=a;else if(this._head)a.next=this._head,this._head.previous=a;else throw new Error("Invalid list");this._head=a,this._state++}addItemLast(a){if(!this._head&&!this._tail)this._head=a;else if(this._tail)a.previous=this._tail,this._tail.next=a;else throw new Error("Invalid list");this._tail=a,this._state++}removeItem(a){if(a===this._head&&a===this._tail)this._head=void 0,this._tail=void 0;else if(a===this._head){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this._head=a.next}else if(a===this._tail){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this._tail=a.previous}else{const t=a.next,r=a.previous;if(!t||!r)throw new Error("Invalid list");t.previous=r,r.next=t}a.next=void 0,a.previous=void 0,this._state++}touch(a,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(a===this._head)return;const r=a.next,o=a.previous;a===this._tail?(o.next=void 0,this._tail=o):(r.previous=o,o.next=r),a.previous=void 0,a.next=this._head,this._head.previous=a,this._head=a,this._state++}else if(t===2){if(a===this._tail)return;const r=a.next,o=a.previous;a===this._head?(r.previous=void 0,this._head=r):(r.previous=o,o.next=r),a.next=void 0,a.previous=this._tail,this._tail.next=a,this._tail=a,this._state++}}}toJSON(){const a=[];return this.forEach((t,r)=>{a.push([r,t])}),a}fromJSON(a){this.clear();for(const[t,r]of a)this.set(t,r)}}e.LinkedMap=b;class c extends b{constructor(a,t=1){super();this._limit=a,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(a){this._limit=a,this.checkTrim()}get ratio(){return this._ratio}set ratio(a){this._ratio=Math.min(Math.max(0,a),1),this.checkTrim()}get(a,t=2){return super.get(a,t)}peek(a){return super.get(a,0)}set(a,t){return super.set(a,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c}),define(we[107],Ee([0,1,22,8]),function(re,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function T(...me){return function(Ce,ke){for(let Ue=0,be=me.length;Ue<be;Ue++){const je=me[Ue](Ce,ke);if(je)return je}return null}}e.or=T,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(me,Ce,ke){if(!ke||ke.length<Ce.length)return null;let Ue;return me?Ue=S.startsWithIgnoreCase(ke,Ce):Ue=ke.indexOf(Ce)===0,Ue?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function E(me,Ce){const ke=Ce.toLowerCase().indexOf(me.toLowerCase());return ke===-1?null:[{start:ke,end:ke+me.length}]}e.matchesContiguousSubString=E;function C(me,Ce){return D(me.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=C;function D(me,Ce,ke,Ue){if(ke===me.length)return[];if(Ue===Ce.length)return null;if(me[ke]===Ce[Ue]){let be=null;return(be=D(me,Ce,ke+1,Ue+1))?g({start:Ue,end:Ue+1},be):null}return D(me,Ce,ke,Ue+1)}function n(me){return 97<=me&&me<=122}function A(me){return 65<=me&&me<=90}e.isUpper=A;function I(me){return 48<=me&&me<=57}function p(me){return me===32||me===9||me===10||me===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(me=>f.add(me.charCodeAt(0)));function s(me){return p(me)||f.has(me)}function h(me,Ce){return me===Ce||s(me)&&s(Ce)}function v(me){return n(me)||A(me)||I(me)}function g(me,Ce){return Ce.length===0?Ce=[me]:me.end===Ce[0].start?Ce[0].start=me.start:Ce.unshift(me),Ce}function b(me,Ce){for(let ke=Ce;ke<me.length;ke++){const Ue=me.charCodeAt(ke);if(A(Ue)||I(Ue)||ke>0&&!v(me.charCodeAt(ke-1)))return ke}return me.length}function c(me,Ce,ke,Ue){if(ke===me.length)return[];if(Ue===Ce.length)return null;if(me[ke]!==Ce[Ue].toLowerCase())return null;{let be=null,je=Ue+1;for(be=c(me,Ce,ke+1,Ue+1);!be&&(je=b(Ce,je))<Ce.length;)be=c(me,Ce,ke+1,je),je++;return be===null?null:g({start:Ue,end:Ue+1},be)}}function u(me){let Ce=0,ke=0,Ue=0,be=0,je=0;for(let $e=0;$e<me.length;$e++)je=me.charCodeAt($e),A(je)&&Ce++,n(je)&&ke++,v(je)&&Ue++,I(je)&&be++;const V=Ce/me.length,Z=ke/me.length,_e=Ue/me.length,Me=be/me.length;return{upperPercent:V,lowerPercent:Z,alphaPercent:_e,numericPercent:Me}}function a(me){const{upperPercent:Ce,lowerPercent:ke}=me;return ke===0&&Ce>.6}function t(me){const{upperPercent:Ce,lowerPercent:ke,alphaPercent:Ue,numericPercent:be}=me;return ke>.2&&Ce<.8&&Ue>.6&&be<.2}function r(me){let Ce=0,ke=0,Ue=0,be=0;for(let je=0;je<me.length;je++)Ue=me.charCodeAt(je),A(Ue)&&Ce++,n(Ue)&&ke++,p(Ue)&&be++;return(Ce===0||ke===0)&&be===0?me.length<=30:Ce<=5}function o(me,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!r(me)||Ce.length>60)return null;const ke=u(Ce);if(!t(ke)){if(!a(ke))return null;Ce=Ce.toLowerCase()}let Ue=null,be=0;for(me=me.toLowerCase();be<Ce.length&&(Ue=c(me,Ce,0,be))===null;)be=b(Ce,be+1);return Ue}e.matchesCamelCase=o;function l(me,Ce,ke=!1){if(!Ce||Ce.length===0)return null;let Ue=null,be=0;for(me=me.toLowerCase(),Ce=Ce.toLowerCase();be<Ce.length&&(Ue=i(me,Ce,0,be,ke))===null;)be=d(Ce,be+1);return Ue}e.matchesWords=l;function i(me,Ce,ke,Ue,be){if(ke===me.length)return[];if(Ue===Ce.length)return null;if(h(me.charCodeAt(ke),Ce.charCodeAt(Ue))){let je=null,V=Ue+1;if(je=i(me,Ce,ke+1,Ue+1,be),!be)for(;!je&&(V=d(Ce,V))<Ce.length;)je=i(me,Ce,ke+1,V,be),V++;return je===null?null:g({start:Ue,end:Ue+1},je)}else return null}function d(me,Ce){for(let ke=Ce;ke<me.length;ke++)if(s(me.charCodeAt(ke))||ke>0&&s(me.charCodeAt(ke-1)))return ke;return me.length}const y=T(e.matchesPrefix,o,E),k=T(e.matchesPrefix,o,C),m=new _.LRUCache(1e4);function w(me,Ce,ke=!1){if(typeof me!="string"||typeof Ce!="string")return null;let Ue=m.get(me);Ue||(Ue=new RegExp(S.convertSimple2RegExpPattern(me),"i"),m.set(me,Ue));const be=Ue.exec(Ce);return be?[{start:be.index,end:be.index+be[0].length}]:ke?k(me,Ce):y(me,Ce)}e.matchesFuzzy=w;function R(me,Ce){const ke=$(me,me.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return ke?B(ke):null}e.matchesFuzzy2=R;function F(me,Ce,ke,Ue,be,je){const V=Math.min(13,me.length);for(;ke<V;ke++){const Z=$(me,Ce,ke,Ue,be,je,!1);if(Z)return Z}return[0,je]}e.anyScore=F;function B(me){if(typeof me=="undefined")return[];const Ce=[],ke=me[1];for(let Ue=me.length-1;Ue>1;Ue--){const be=me[Ue]+ke,je=Ce[Ce.length-1];je&&je.end===be?je.end=be+1:Ce.push({start:be,end:be+1})}return Ce}e.createMatches=B;const Q=128;function J(){const me=[],Ce=[];for(let ke=0;ke<=Q;ke++)Ce[ke]=0;for(let ke=0;ke<=Q;ke++)me.push(Ce.slice(0));return me}function z(me){const Ce=[];for(let ke=0;ke<=me;ke++)Ce[ke]=0;return Ce}const ae=z(2*Q),L=z(2*Q),N=J(),H=J(),O=J(),K=!1;function le(me,Ce,ke,Ue,be){function je(Z,_e,Me=" "){for(;Z.length<_e;)Z=Me+Z;return Z}let V=` |   |${Ue.split("").map(Z=>je(Z,3)).join("|")}
`;for(let Z=0;Z<=ke;Z++)Z===0?V+=" |":V+=`${Ce[Z-1]}|`,V+=me[Z].slice(0,be+1).map(_e=>je(_e.toString(),3)).join("|")+`
`;return V}function ue(me,Ce,ke,Ue){me=me.substr(Ce),ke=ke.substr(Ue),console.log(le(H,me,me.length,ke,ke.length)),console.log(le(O,me,me.length,ke,ke.length)),console.log(le(N,me,me.length,ke,ke.length))}function pe(me,Ce){if(Ce<0||Ce>=me.length)return!1;const ke=me.codePointAt(Ce);switch(ke){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!S.isEmojiImprecise(ke)}}function ve(me,Ce){if(Ce<0||Ce>=me.length)return!1;switch(me.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function Re(me,Ce,ke){return Ce[me]!==ke[me]}function He(me,Ce,ke,Ue,be,je,V=!1){for(;Ce<ke&&be<je;)me[Ce]===Ue[be]&&(V&&(ae[Ce]=be),Ce+=1),be+=1;return Ce===ke}e.isPatternInWord=He;var Fe;(function(me){me[me.Diag=1]="Diag",me[me.Left=2]="Left",me[me.LeftLeft=3]="LeftLeft"})(Fe||(Fe={}));var ze;(function(me){me.Default=[-100,0];function Ce(ke){return!ke||ke.length===2&&ke[0]===-100&&ke[1]===0}me.isDefault=Ce})(ze=e.FuzzyScore||(e.FuzzyScore={}));function $(me,Ce,ke,Ue,be,je,V){const Z=me.length>Q?Q:me.length,_e=Ue.length>Q?Q:Ue.length;if(!(ke>=Z||je>=_e||Z-ke>_e-je)&&!!He(Ce,ke,Z,be,je,_e,!0)){G(Z,_e,ke,je,Ce,be);let Me=1,$e=1,Ne=ke,Je=je;const x=[!1];for(Me=1,Ne=ke;Ne<Z;Me++,Ne++){const se=ae[Ne],de=L[Ne],Se=Ne+1<Z?L[Ne+1]:_e;for($e=se-je+1,Je=se;Je<Se;$e++,Je++){let xe=Number.MIN_SAFE_INTEGER,Oe=!1;Je<=de&&(xe=te(me,Ce,Ne,ke,Ue,be,Je,_e,je,N[Me-1][$e-1]===0,x));let Be=0;xe!==Number.MAX_SAFE_INTEGER&&(Oe=!0,Be=xe+H[Me-1][$e-1]);const Qe=Je>se,nt=Qe?H[Me][$e-1]+(N[Me][$e-1]>0?-5:0):0,et=Je>se+1&&N[Me][$e-1]>0,Xe=et?H[Me][$e-2]+(N[Me][$e-2]>0?-5:0):0;if(et&&(!Qe||Xe>=nt)&&(!Oe||Xe>=Be))H[Me][$e]=Xe,O[Me][$e]=3,N[Me][$e]=0;else if(Qe&&(!Oe||nt>=Be))H[Me][$e]=nt,O[Me][$e]=2,N[Me][$e]=0;else if(Oe)H[Me][$e]=Be,O[Me][$e]=1,N[Me][$e]=N[Me-1][$e-1]+1;else throw new Error("not possible")}}if(K&&ue(me,ke,Ue,je),!(!x[0]&&!V)){Me--,$e--;const ee=[H[Me][$e],je];let ce=0,j=0;for(;Me>=1;){let se=$e;do{const de=O[Me][se];if(de===3)se=se-2;else if(de===2)se=se-1;else break}while(se>=1);ce>1&&Ce[ke+Me-1]===be[je+$e-1]&&!Re(se+je-1,Ue,be)&&ce+1>N[Me][se]&&(se=$e),se===$e?ce++:ce=1,j||(j=se),Me--,$e=se-1,ee.push($e)}_e===Z&&(ee[0]+=2);const X=j-Z;return ee[0]-=X,ee}}}e.fuzzyScore=$;function G(me,Ce,ke,Ue,be,je){let V=me-1,Z=Ce-1;for(;V>=ke&&Z>=Ue;)be[V]===je[Z]&&(L[V]=Z,V--),Z--}function te(me,Ce,ke,Ue,be,je,V,Z,_e,Me,$e){if(Ce[ke]!==je[V])return Number.MIN_SAFE_INTEGER;let Ne=1,Je=!1;return V===ke-Ue?Ne=me[ke]===be[V]?7:5:Re(V,be,je)&&(V===0||!Re(V-1,be,je))?(Ne=me[ke]===be[V]?7:5,Je=!0):pe(je,V)&&(V===0||!pe(je,V-1))?Ne=5:(pe(je,V-1)||ve(je,V-1))&&(Ne=5,Je=!0),Ne>1&&ke===Ue&&($e[0]=!0),Je||(Je=Re(V,be,je)||pe(je,V-1)||ve(je,V-1)),ke===Ue?V>_e&&(Ne-=Je?3:5):Me?Ne+=Je?2:0:Ne+=Je?0:1,V+1===Z&&(Ne-=Je?3:5),Ne}function ie(me,Ce,ke,Ue,be,je,V){return De(me,Ce,ke,Ue,be,je,!0,V)}e.fuzzyScoreGracefulAggressive=ie;function he(me,Ce,ke,Ue,be,je,V){return De(me,Ce,ke,Ue,be,je,!1,V)}e.fuzzyScoreGraceful=he;function De(me,Ce,ke,Ue,be,je,V,Z){let _e=$(me,Ce,ke,Ue,be,je,Z);if(_e&&!V)return _e;if(me.length>=3){const Me=Math.min(7,me.length-1);for(let $e=ke+1;$e<Me;$e++){const Ne=Le(me,$e);if(Ne){const Je=$(Ne,Ne.toLowerCase(),ke,Ue,be,je,Z);Je&&(Je[0]-=3,(!_e||Je[0]>_e[0])&&(_e=Je))}}}return _e}function Le(me,Ce){if(!(Ce+1>=me.length)){const ke=me[Ce],Ue=me[Ce+1];if(ke!==Ue)return me.slice(0,Ce)+Ue+ke+me.slice(Ce+2)}}}),define(we[108],Ee([0,1,37,107,8]),function(re,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${_.CSSIcon.iconNameExpression}(?:${_.CSSIcon.iconModifierExpression})?\\)`,"g"),E=new RegExp(`(\\\\)?${P.source}`,"g");function C(h){return h.replace(E,(v,g)=>g?v:`\\${v}`)}e.escapeIcons=C;const D=new RegExp(`\\\\${P.source}`,"g");function n(h){return h.replace(D,v=>`\\${v}`)}e.markdownEscapeEscapedIcons=n;const A=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function I(h){return h.indexOf(e.iconStartMarker)===-1?h:h.replace(A,(v,g,b,c)=>b?v:g||c||"")}e.stripIcons=I;function p(h){const v=h.indexOf(e.iconStartMarker);return v===-1?{text:h}:f(h,v)}e.parseLabelWithIcons=p;function f(h,v){const g=[];let b="";function c(d){if(d){b+=d;for(const y of d)g.push(t)}}let u=-1,a="",t=0,r,o,l=v;const i=h.length;for(c(h.substr(0,v));l<i;)r=h[l],o=h[l+1],r===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(u=l,c(a),a=e.iconStartMarker,l++):r===")"&&u!==-1?(t+=l-u+1,u=-1,a=""):u!==-1?/^[a-z0-9\-]$/i.test(r)?a+=r:(c(a),u=-1,a=""):c(r),l++;return c(a),{text:b,iconOffsets:g}}function s(h,v,g=!1){const{text:b,iconOffsets:c}=v;if(!c||c.length===0)return(0,S.matchesFuzzy)(h,b,g);const u=(0,T.ltrim)(b," "),a=b.length-u.length,t=(0,S.matchesFuzzy)(h,u,g);if(t)for(const r of t){const o=c[r.start+a]+a;r.start+=o,r.end+=o}return t}e.matchesFuzzyIconAware=s}),define(we[80],Ee([0,1,14,108,11]),function(re,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(h="",v=!1){var g,b;if(this.value=h,typeof this.value!="string")throw(0,T.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1):(this.isTrusted=(g=v.isTrusted)!==null&&g!==void 0?g:void 0,this.supportThemeIcons=(b=v.supportThemeIcons)!==null&&b!==void 0?b:!1)}appendText(h,v=0){return this.value+=I(this.supportThemeIcons?(0,S.escapeIcons)(h):h).replace(/([ \t]+)/g,(g,b)=>"&nbsp;".repeat(b.length)).replace(/^>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,v){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}}e.MarkdownString=E;function C(s){return D(s)?!s.value:Array.isArray(s)?s.every(C):!0}e.isEmptyMarkdownString=C;function D(s){return s instanceof E?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function n(s,h){return!s&&!h?!0:!s||!h?!1:Array.isArray(s)&&Array.isArray(h)?(0,_.equals)(s,h,A):D(s)&&D(h)?A(s,h):!1}e.markedStringsEquals=n;function A(s,h){return s===h?!0:!s||!h?!1:s.value===h.value&&s.isTrusted===h.isTrusted&&s.supportThemeIcons===h.supportThemeIcons}function I(s){return s.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=I;function p(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=p;function f(s){const h=[],v=s.split("|").map(b=>b.trim());s=v[0];const g=v[1];if(g){const b=/height=(\d+)/.exec(g),c=/width=(\d+)/.exec(g),u=b?b[1]:"",a=c?c[1]:"",t=isFinite(parseInt(a)),r=isFinite(parseInt(u));t&&h.push(`width="${a}"`),r&&h.push(`height="${u}"`)}return{href:s,dimensions:h}}e.parseHrefAndDimensions=f}),define(we[58],Ee([0,1,26,8,2]),function(re,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(n){return JSON.stringify(n,C)}e.stringify=P;function E(n){let A=JSON.parse(n);return A=D(A),A}e.parse=E;function C(n,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,S.regExpFlags)(A)}:A}function D(n,A=0){if(!n||A>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return T.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof _.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let I=0;I<n.length;++I)n[I]=D(n[I],A+1);else for(const I in n)Object.hasOwnProperty.call(n,I)&&(n[I]=D(n[I],A+1))}return n}e.revive=D}),define(we[16],Ee([0,1,2,21]),function(re,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var T;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.vscodeWebviewResource="vscode-webview-resource",C.extension="extension",C.vscodeFileResource="vscode-file"})(T=e.Schemas||(e.Schemas={}));class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,n,A){this._hosts[D]=n,this._ports[D]=A}setConnectionToken(D,n){this._connectionTokens[D]=n}rewrite(D){if(this._delegate)return this._delegate(D);const n=D.authority;let A=this._hosts[n];A&&A.indexOf(":")!==-1&&(A=`[${A}]`);const I=this._ports[n],p=this._connectionTokens[n];let f=`path=${encodeURIComponent(D.path)}`;return typeof p=="string"&&(f+=`&tkn=${encodeURIComponent(p)}`),_.URI.from({scheme:S.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${A}:${I}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new P;class E{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,n,A){const I=this.toUri(D,n);return I.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(I):S.isNative&&(A||S.isPreferringBrowserCodeLoad)&&I.scheme===T.file?I.with({scheme:T.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(D,n){const A=this.toUri(D,n);return A.scheme===T.vscodeFileResource?A.with({scheme:T.file,authority:A.authority!==this.FALLBACK_AUTHORITY?A.authority:null,query:null,fragment:null}):A}toUri(D,n){return _.URI.isUri(D)?D:_.URI.parse(n.toUrl(D))}}e.FileAccess=new E}),define(we[23],Ee([0,1,38,10,2,8,16,21]),function(re,e,_,S,T,P,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(f){return(0,T.uriToFsPath)(f,!0)}e.originalFSPath=D;class n{constructor(s){this._ignorePathCasing=s}compare(s,h,v=!1){return s===h?0:(0,P.compare)(this.getComparisonKey(s,v),this.getComparisonKey(h,v))}isEqual(s,h,v=!1){return s===h?!0:!s||!h?!1:this.getComparisonKey(s,v)===this.getComparisonKey(h,v)}getComparisonKey(s,h=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,h,v=!1){if(s.scheme===h.scheme){if(s.scheme===E.Schemas.file)return _.isEqualOrParent(D(s),D(h),this._ignorePathCasing(s))&&s.query===h.query&&(v||s.fragment===h.fragment);if((0,e.isEqualAuthority)(s.authority,h.authority))return _.isEqualOrParent(s.path,h.path,this._ignorePathCasing(s),"/")&&s.query===h.query&&(v||s.fragment===h.fragment)}return!1}joinPath(s,...h){return T.URI.joinPath(s,...h)}basenameOrAuthority(s){return(0,e.basename)(s)||s.authority}basename(s){return S.posix.basename(s.path)}extname(s){return S.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let h;return s.scheme===E.Schemas.file?h=T.URI.file(S.dirname(D(s))).path:(h=S.posix.dirname(s.path),s.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${s.toString})) resulted in a relative path`),h="/")),s.with({path:h})}normalizePath(s){if(!s.path.length)return s;let h;return s.scheme===E.Schemas.file?h=T.URI.file(S.normalize(D(s))).path:h=S.posix.normalize(s.path),s.with({path:h})}relativePath(s,h){if(!(s.scheme!==h.scheme||!(0,e.isEqualAuthority)(s.authority,h.authority))){if(s.scheme===E.Schemas.file){const b=S.relative(D(s),D(h));return C.isWindows?_.toSlashes(b):b}let v=s.path||"/",g=h.path||"/";if(this._ignorePathCasing(s)){let b=0;for(const c=Math.min(v.length,g.length);b<c&&!(v.charCodeAt(b)!==g.charCodeAt(b)&&v.charAt(b).toLowerCase()!==g.charAt(b).toLowerCase());b++);v=g.substr(0,b)+v.substr(b)}return S.posix.relative(v,g)}}resolvePath(s,h){if(s.scheme===E.Schemas.file){const v=T.URI.file(S.resolve(D(s),h));return s.with({authority:v.authority,path:v.path})}return h.indexOf("/")===-1&&(h=_.toSlashes(h),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h)),s.with({path:S.posix.resolve(s.path,h)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,h){return s===h||(0,P.equalsIgnoreCase)(s,h)}hasTrailingPathSeparator(s,h=S.sep){if(s.scheme===E.Schemas.file){const v=D(s);return v.length>_.getRoot(v).length&&v[v.length-1]===h}else{const v=s.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,h=S.sep){return(0,e.hasTrailingPathSeparator)(s,h)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,h=S.sep){let v=!1;if(s.scheme===E.Schemas.file){const g=D(s);v=g!==void 0&&g.length===_.getRoot(g).length&&g[g.length-1]===h}else{h="/";const g=s.path;v=g.length===1&&g.charCodeAt(g.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(s,h)?s.with({path:s.path+"/"}):s}}e.ExtUri=n,e.extUri=new n(()=>!1),e.extUriBiasedIgnorePathCase=new n(f=>f.scheme===E.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new n(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function A(f,s){const h=[];for(let v=0;v<f.length;v++){const g=s(f[v]);f.some((b,c)=>c===v?!1:(0,e.isEqualOrParent)(g,s(b)))||h.push(f[v])}return h}e.distinctParents=A;var I;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function s(h){const v=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(c=>{const[u,a]=c.split(":");u&&a&&v.set(u,a)});const b=h.path.substring(0,h.path.indexOf(";"));return b&&v.set(f.META_DATA_MIME,b),v}f.parseMetaData=s})(I=e.DataUri||(e.DataUri={}));function p(f,s,h){if(s){let v=f.path;return v&&v[0]!==S.posix.sep&&(v=S.posix.sep+v),f.with({scheme:h,authority:s,path:v})}return f.with({scheme:h})}e.toLocalResource=p}),define(we[15],Ee([0,1,20,11,3,6,47,23]),function(re,e,_,S,T,P,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(H){return!!H&&typeof H.then=="function"}e.isThenable=D;function n(H){const O=new _.CancellationTokenSource,K=H(O.token),le=new Promise((ue,pe)=>{O.token.onCancellationRequested(()=>{pe((0,S.canceled)())}),Promise.resolve(K).then(ve=>{O.dispose(),ue(ve)},ve=>{O.dispose(),pe(ve)})});return new class{cancel(){O.cancel()}then(ue,pe){return le.then(ue,pe)}catch(ue){return this.then(void 0,ue)}finally(ue){return le.finally(ue)}}}e.createCancelablePromise=n;function A(H,O,K){return Promise.race([H,new Promise(le=>O.onCancellationRequested(()=>le(K)))])}e.raceCancellation=A;async function I(H){let O=-1;const K=H.map((ue,pe)=>ue.then(ve=>(O=pe,ve))),le=await Promise.race(K);return H.forEach((ue,pe)=>{pe!==O&&ue.cancel()}),le}e.raceCancellablePromises=I;function p(H,O,K){let le;const ue=setTimeout(()=>{le==null||le(void 0),K==null||K()},O);return Promise.race([H.finally(()=>clearTimeout(ue)),new Promise(pe=>le=pe)])}e.raceTimeout=p;function f(H){return new Promise((O,K)=>{const le=H();D(le)?le.then(O,K):O(le)})}e.asPromise=f;class s{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(O){if(this.activePromise){if(this.queuedPromiseFactory=O,!this.queuedPromise){const K=()=>{this.queuedPromise=null;const le=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,le};this.queuedPromise=new Promise(le=>{this.activePromise.then(K,K).then(le)})}return new Promise((K,le)=>{this.queuedPromise.then(K,le)})}return this.activePromise=O(),new Promise((K,le)=>{this.activePromise.then(ue=>{this.activePromise=null,K(ue)},ue=>{this.activePromise=null,le(ue)})})}}e.Throttler=s;class h{constructor(){this.current=Promise.resolve(null)}queue(O){return this.current=this.current.then(()=>O(),()=>O())}}e.Sequencer=h;class v{constructor(){this.promiseMap=new Map}queue(O,K){var le;const pe=((le=this.promiseMap.get(O))!==null&&le!==void 0?le:Promise.resolve()).catch(()=>{}).then(K).finally(()=>{this.promiseMap.get(O)===pe&&this.promiseMap.delete(O)});return this.promiseMap.set(O,pe),pe}}e.SequencerByKey=v;class g{constructor(O){this.defaultDelay=O,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(O,K=this.defaultDelay){return this.task=O,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((le,ue)=>{this.doResolve=le,this.doReject=ue}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const le=this.task;return this.task=null,le()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},K),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,S.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=g;class b{constructor(O){this.delayer=new g(O),this.throttler=new s}trigger(O,K){return this.delayer.trigger(()=>this.throttler.queue(O),K)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class c{constructor(){this._isOpen=!1,this._promise=new Promise((O,K)=>{this._completePromise=O})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class u extends c{constructor(O){super();this._timeout=setTimeout(()=>this.open(),O)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function a(H,O){return O?new Promise((K,le)=>{const ue=setTimeout(K,H);O.onCancellationRequested(()=>{clearTimeout(ue),le((0,S.canceled)())})}):n(K=>a(H,K))}e.timeout=a;function t(H,O=0){const K=setTimeout(H,O);return(0,P.toDisposable)(()=>clearTimeout(K))}e.disposableTimeout=t;function r(H){return H.then(void 0,O=>{})}e.ignoreErrors=r;function o(H){const O=[];let K=0;const le=H.length;function ue(){return K<le?H[K++]():null}function pe(ve){ve!=null&&O.push(ve);const Re=ue();return Re?Re.then(pe):Promise.resolve(O)}return Promise.resolve(null).then(pe)}e.sequence=o;function l(H,O=le=>!!le,K=null){let le=0;const ue=H.length,pe=()=>{if(le>=ue)return Promise.resolve(K);const ve=H[le++];return Promise.resolve(ve()).then(He=>O(He)?Promise.resolve(He):pe())};return pe()}e.first=l;function i(H,O=le=>!!le,K=null){if(H.length===0)return Promise.resolve(K);let le=H.length;const ue=()=>{var pe,ve;le=-1;for(const Re of H)(ve=(pe=Re).cancel)===null||ve===void 0||ve.call(pe)};return new Promise((pe,ve)=>{for(const Re of H)Re.then(He=>{--le>=0&&O(He)?(ue(),pe(He)):le===0&&pe(K)}).catch(He=>{--le>=0&&(ue(),ve(He))})})}e.firstParallel=i;class d{constructor(O){this._size=0,this.maxDegreeOfParalellism=O,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new T.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(O){return this._size++,new Promise((K,le)=>{this.outstandingPromises.push({factory:O,c:K,e:le}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const O=this.outstandingPromises.shift();this.runningPromises++;const K=O.factory();K.then(O.c,O.e),K.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=d;class y extends d{constructor(){super(1)}}e.Queue=y;class k{constructor(){this.queues=new Map}queueFor(O,K=C.extUri){const le=K.getComparisonKey(O);let ue=this.queues.get(le);return ue||(ue=new y,T.Event.once(ue.onFinished)(()=>{ue==null||ue.dispose(),this.queues.delete(le)}),this.queues.set(le,ue)),ue}dispose(){this.queues.forEach(O=>O.dispose()),this.queues.clear()}}e.ResourceQueue=k;class m{constructor(O,K){this._token=-1,typeof O=="function"&&typeof K=="number"&&this.setIfNotSet(O,K)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(O,K){this.cancel(),this._token=setTimeout(()=>{this._token=-1,O()},K)}setIfNotSet(O,K){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,O()},K))}}e.TimeoutTimer=m;class w{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(O,K){this.cancel(),this._token=setInterval(()=>{O()},K)}}e.IntervalTimer=w;class R{constructor(O,K){this.timeoutToken=-1,this.runner=O,this.timeout=K,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(O=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,O)}get delay(){return this.timeout}set delay(O){this.timeout=O}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class F extends R{constructor(O,K){super(O,K);this.units=[]}work(O){this.units.push(O),this.isScheduled()||this.schedule()}doRun(){const O=this.units;this.units=[],this.runner&&this.runner(O)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const H=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=O=>{const K=setTimeout(()=>O(H));let le=!1;return{dispose(){le||(le=!0,clearTimeout(K))}}}}else e.runWhenIdle=(H,O)=>{const K=requestIdleCallback(H,typeof O=="number"?{timeout:O}:void 0);let le=!1;return{dispose(){le||(le=!0,cancelIdleCallback(K))}}}}();class B{constructor(O){this._didRun=!1,this._executor=()=>{try{this._value=O()}catch(K){this._error=K}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=B;async function Q(H,O,K){let le;for(let ue=0;ue<K;ue++)try{return await H()}catch(pe){le=pe,await a(O)}throw le}e.retry=Q;class J{hasPending(O){return this._pending?typeof O=="number"?this._pending.taskId===O:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var O;(O=this._pending)===null||O===void 0||O.cancel()}setPending(O,K,le){return this._pending={taskId:O,cancel:()=>le==null?void 0:le(),promise:K},K.then(()=>this.donePending(O),()=>this.donePending(O)),K}donePending(O){this._pending&&O===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const O=this._next;this._next=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}setNext(O){if(this._next)this._next.run=O;else{let K,le;const ue=new Promise((pe,ve)=>{K=pe,le=ve});this._next={run:O,promise:ue,promiseResolve:K,promiseReject:le}}return this._next.promise}}e.TaskSequentializer=J;class z{constructor(O){this.interval=O,this.lastIncrementTime=0,this.value=0}increment(){const O=Date.now();return O-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=O,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class ae{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((O,K)=>{this.completeCallback=O,this.errorCallback=K})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(O){return new Promise(K=>{this.completeCallback(O),this.resolved=!0,K()})}error(O){return new Promise(K=>{this.errorCallback(O),this.rejected=!0,K()})}cancel(){new Promise(O=>{this.errorCallback((0,S.canceled)()),this.rejected=!0,O()})}}e.DeferredPromise=ae;class L extends T.Emitter{async fireAsync(O,K,le){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new E.LinkedList);for(const ue of this._listeners)this._asyncDeliveryQueue.push([ue,O]);for(;this._asyncDeliveryQueue.size>0&&!K.isCancellationRequested;){const[ue,pe]=this._asyncDeliveryQueue.shift(),ve=[],Re=Object.assign(Object.assign({},pe),{waitUntil:He=>{if(Object.isFrozen(ve))throw new Error("waitUntil can NOT be called asynchronous");le&&(He=le(He,typeof ue=="function"?ue:ue[0])),ve.push(He)}});try{typeof ue=="function"?ue.call(void 0,Re):ue[0].call(ue[1],Re)}catch(He){(0,S.onUnexpectedError)(He);continue}Object.freeze(ve),await N.settled(ve).catch(He=>(0,S.onUnexpectedError)(He))}}}}e.AsyncEmitter=L;var N;(function(H){async function O(pe){return typeof Promise.allSettled=="function"?K(pe):le(pe)}H.allSettled=O;async function K(pe){return Promise.allSettled(pe)}async function le(pe){return Promise.all(pe.map(ve=>ve.then(Re=>({status:"fulfilled",value:Re}),Re=>({status:"rejected",reason:Re}))))}async function ue(pe){let ve;const Re=await Promise.all(pe.map(He=>He.then(Fe=>Fe,Fe=>{ve||(ve=Fe)})));if(typeof ve!="undefined")throw ve;return Re}H.settled=ue})(N=e.Promises||(e.Promises={}))}),define(we[109],Ee([0,1,10,15]),function(re,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const T=new S.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),P=new S.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),E=new S.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(u,a,t=!1){const r=u||"",o=a||"",l=T.value.collator.compare(r,o);return T.value.collatorIsNumeric&&l===0&&r!==o?r<o?-1:1:l}e.compareFileNames=C;function D(u,a){const t=P.value.collator;return u=u||"",a=a||"",h(t,u,a)}e.compareFileNamesDefault=D;function n(u,a,t=!1){t||(u=u&&u.toLowerCase(),a=a&&a.toLowerCase());const[r,o]=f(u),[l,i]=f(a);return r!==l?r<l?-1:1:o===i?0:o<i?-1:1}e.noIntlCompareFileNames=n;function A(u,a){const[t,r]=f(u),[o,l]=f(a);let i=T.value.collator.compare(r,l);if(i===0){if(T.value.collatorIsNumeric&&r!==l)return r<l?-1:1;if(i=T.value.collator.compare(t,o),T.value.collatorIsNumeric&&i===0&&t!==o)return t<o?-1:1}return i}e.compareFileExtensions=A;function I(u,a){u=u||"",a=a||"";const t=s(u),r=s(a),o=P.value.collator,l=E.value.collator;let i;return i=h(l,t,r),i!==0?i:h(o,u,a)}e.compareFileExtensionsDefault=I;const p=/^(.*?)(\.([^.]*))?$/;function f(u,a=!1){const t=u?p.exec(u):[];let r=[t&&t[1]||"",t&&t[3]||""];return a&&(!r[0]&&r[1]||r[0]&&r[0].charAt(0)===".")&&(r=[r[0]+"."+r[1],""]),r}function s(u){const a=u?p.exec(u):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function h(u,a,t){let r=u.compare(a,t);return r!==0?r:a.length!==t.length?a.length<t.length?-1:1:0}function v(u,a,t=!1){return t||(u=u&&u.toLowerCase(),a=a&&a.toLowerCase()),u===a?0:u<a?-1:1}function g(u,a,t=!1){const r=u.split(_.sep),o=a.split(_.sep),l=r.length-1,i=o.length-1;let d,y;for(let k=0;;k++){if(d=l===k,y=i===k,d&&y)return C(r[k],o[k],t);if(d)return-1;if(y)return 1;const m=v(r[k],o[k],t);if(m!==0)return m}}e.comparePaths=g;function b(u,a,t){const r=u.toLowerCase(),o=a.toLowerCase(),l=c(u,a,t);if(l)return l;const i=r.endsWith(t),d=o.endsWith(t);if(i!==d)return i?-1:1;const y=C(r,o);return y!==0?y:r.localeCompare(o)}e.compareAnything=b;function c(u,a,t){const r=u.toLowerCase(),o=a.toLowerCase(),l=r.startsWith(t),i=o.startsWith(t);if(l!==i)return l?-1:1;if(l&&i){if(r.length<o.length)return-1;if(r.length>o.length)return 1}return 0}e.compareByPrefix=c}),define(we[28],Ee([0,1,8,38,10,22,15]),function(re,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const D="**",n="/",A="[/\\\\]",I="[^/\\\\]",p=/\//g;function f(K){switch(K){case 0:return"";case 1:return`${I}*?`;default:return`(?:${A}|${I}+${A}|${A}${I}+)*?`}}function s(K,le){if(!K)return[];const ue=[];let pe=!1,ve=!1,Re="";for(const He of K){switch(He){case le:if(!pe&&!ve){ue.push(Re),Re="";continue}break;case"{":pe=!0;break;case"}":pe=!1;break;case"[":ve=!0;break;case"]":ve=!1;break}Re+=He}return Re&&ue.push(Re),ue}e.splitGlobAware=s;function h(K){if(!K)return"";let le="";const ue=s(K,n);if(ue.every(pe=>pe===D))le=".*";else{let pe=!1;ue.forEach((ve,Re)=>{if(ve===D){pe||(le+=f(2),pe=!0);return}let He=!1,Fe="",ze=!1,$="";for(const G of ve){if(G!=="}"&&He){Fe+=G;continue}if(ze&&(G!=="]"||!$)){let te;G==="-"?te=G:(G==="^"||G==="!")&&!$?te="^":G===n?te="":te=_.escapeRegExpCharacters(G),$+=te;continue}switch(G){case"{":He=!0;continue;case"[":ze=!0;continue;case"}":le+=`(?:${s(Fe,",").map(he=>h(he)).join("|")})`,He=!1,Fe="";break;case"]":le+="["+$+"]",ze=!1,$="";break;case"?":le+=I;continue;case"*":le+=f(1);continue;default:le+=_.escapeRegExpCharacters(G)}}Re<ue.length-1&&(ue[Re+1]!==D||Re+2<ue.length)&&(le+=A),pe=!1})}return le}const v=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.LRUCache(1e4),r=function(){return!1},o=function(){return null};function l(K,le){if(!K)return o;let ue;typeof K!="string"?ue=K.pattern:ue=K,ue=ue.trim();const pe=`${ue}_${!!le.trimForExclusions}`;let ve=t.get(pe);if(ve)return i(ve,K);let Re;if(v.test(ue)){const He=ue.substr(4);ve=function(Fe,ze){return typeof Fe=="string"&&Fe.endsWith(He)?ue:null}}else(Re=g.exec(d(ue,le)))?ve=y(Re[1],ue):(le.trimForExclusions?c:b).test(ue)?ve=k(ue,le):(Re=u.exec(d(ue,le)))?ve=m(Re[1].substr(1),ue,!0):(Re=a.exec(d(ue,le)))?ve=m(Re[1],ue,!1):ve=w(ue);return t.set(pe,ve),i(ve,K)}function i(K,le){return typeof le=="string"?K:function(ue,pe){return S.isEqualOrParent(ue,le.base)?K(T.relative(le.base,ue),pe):null}}function d(K,le){return le.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function y(K,le){const ue=`/${K}`,pe=`\\${K}`,ve=function(He,Fe){return typeof He!="string"?null:Fe?Fe===K?le:null:He===K||He.endsWith(ue)||He.endsWith(pe)?le:null},Re=[K];return ve.basenames=Re,ve.patterns=[le],ve.allBasenames=Re,ve}function k(K,le){const ue=O(K.slice(1,-1).split(",").map(Fe=>l(Fe,le)).filter(Fe=>Fe!==o),K),pe=ue.length;if(!pe)return o;if(pe===1)return ue[0];const ve=function(Fe,ze){for(let $=0,G=ue.length;$<G;$++)if(ue[$](Fe,ze))return K;return null},Re=ue.find(Fe=>!!Fe.allBasenames);Re&&(ve.allBasenames=Re.allBasenames);const He=ue.reduce((Fe,ze)=>ze.allPaths?Fe.concat(ze.allPaths):Fe,[]);return He.length&&(ve.allPaths=He),ve}function m(K,le,ue){const pe=T.sep===T.posix.sep,ve=pe?K:K.replace(p,T.sep),Re=T.sep+ve,He=T.posix.sep+K,Fe=ue?function(ze,$){return typeof ze=="string"&&(ze===ve||ze.endsWith(Re)||!pe&&(ze===K||ze.endsWith(He)))?le:null}:function(ze,$){return typeof ze=="string"&&(ze===ve||!pe&&ze===K)?le:null};return Fe.allPaths=[(ue?"*/":"./")+K],Fe}function w(K){try{const le=new RegExp(`^${h(K)}$`);return function(ue){return le.lastIndex=0,typeof ue=="string"&&le.test(ue)?K:null}}catch(le){return o}}function R(K,le,ue){return!K||typeof le!="string"?!1:F(K)(le,void 0,ue)}e.match=R;function F(K,le={}){if(!K)return r;if(typeof K=="string"||z(K)){const ue=l(K,le);if(ue===o)return r;const pe=function(ve,Re){return!!ue(ve,Re)};return ue.allBasenames&&(pe.allBasenames=ue.allBasenames),ue.allPaths&&(pe.allPaths=ue.allPaths),pe}return N(K,le)}e.parse=F;function B(K){if(!!K){let le;return ue=>(le||(le=(K()||Promise.resolve([])).then(pe=>pe?J(pe):{})),le.then(pe=>!!pe[ue]))}}e.hasSiblingPromiseFn=B;function Q(K){if(!!K){let le;return ue=>{if(!le){const pe=K();le=pe?J(pe):{}}return!!le[ue]}}}e.hasSiblingFn=Q;function J(K){const le={};for(const ue of K)le[ue]=!0;return le}function z(K){const le=K;return le&&typeof le.base=="string"&&typeof le.pattern=="string"}e.isRelativePattern=z;function ae(K){return K.allBasenames||[]}e.getBasenameTerms=ae;function L(K){return K.allPaths||[]}e.getPathTerms=L;function N(K,le){const ue=O(Object.getOwnPropertyNames(K).map(Fe=>H(Fe,K[Fe],le)).filter(Fe=>Fe!==o)),pe=ue.length;if(!pe)return o;if(!ue.some(Fe=>!!Fe.requiresSiblings)){if(pe===1)return ue[0];const Fe=function(G,te){for(let ie=0,he=ue.length;ie<he;ie++){const De=ue[ie](G,te);if(De)return De}return null},ze=ue.find(G=>!!G.allBasenames);ze&&(Fe.allBasenames=ze.allBasenames);const $=ue.reduce((G,te)=>te.allPaths?G.concat(te.allPaths):G,[]);return $.length&&(Fe.allPaths=$),Fe}const ve=function(Fe,ze,$){let G;for(let te=0,ie=ue.length;te<ie;te++){const he=ue[te];he.requiresSiblings&&$&&(ze||(ze=T.basename(Fe)),G||(G=ze.substr(0,ze.length-T.extname(Fe).length)));const De=he(Fe,ze,G,$);if(De)return De}return null},Re=ue.find(Fe=>!!Fe.allBasenames);Re&&(ve.allBasenames=Re.allBasenames);const He=ue.reduce((Fe,ze)=>ze.allPaths?Fe.concat(ze.allPaths):Fe,[]);return He.length&&(ve.allPaths=He),ve}function H(K,le,ue){if(le===!1)return o;const pe=l(K,ue);if(pe===o)return o;if(typeof le=="boolean")return pe;if(le){const ve=le.when;if(typeof ve=="string"){const Re=(He,Fe,ze,$)=>{if(!$||!pe(He,Fe))return null;const G=ve.replace("$(basename)",ze),te=$(G);return(0,E.isThenable)(te)?te.then(ie=>ie?K:null):te?K:null};return Re.requiresSiblings=!0,Re}}return pe}function O(K,le){const ue=K.filter(Fe=>!!Fe.basenames);if(ue.length<2)return K;const pe=ue.reduce((Fe,ze)=>{const $=ze.basenames;return $?Fe.concat($):Fe},[]);let ve;if(le){ve=[];for(let Fe=0,ze=pe.length;Fe<ze;Fe++)ve.push(le)}else ve=ue.reduce((Fe,ze)=>{const $=ze.patterns;return $?Fe.concat($):Fe},[]);const Re=function(Fe,ze){if(typeof Fe!="string")return null;if(!ze){let G;for(G=Fe.length;G>0;G--){const te=Fe.charCodeAt(G-1);if(te===47||te===92)break}ze=Fe.substr(G)}const $=pe.indexOf(ze);return $!==-1?ve[$]:null};Re.basenames=pe,Re.patterns=ve,Re.allBasenames=pe;const He=K.filter(Fe=>!Fe.basenames);return He.push(Re),He}}),define(we[59],Ee([0,1,2,10,8,16,21,23,38]),function(re,e,_,S,T,P,E,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function n(l,i,d){if(typeof l=="string"&&(l=_.URI.file(l)),d){const k=d.getWorkspaceFolder(l);if(k){const m=d.getWorkspace().folders.length>1;let w;if((0,C.isEqual)(k.uri,l)?w="":w=(0,C.relativePath)(k.uri,l),m){const R=k.name?k.name:(0,C.basename)(k.uri);w=w?R+" \u2022 "+w:R}return w}}if(l.scheme!==P.Schemas.file&&l.scheme!==P.Schemas.untitled)return l.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(l.fsPath))return(0,S.normalize)(I(l.fsPath));let y=(0,S.normalize)(l.fsPath);return!E.isWindows&&(i==null?void 0:i.userHome)&&(y=f(y,i.userHome.fsPath)),y}e.getPathLabel=n;function A(l){if(!!l){typeof l=="string"&&(l=_.URI.file(l));const i=(0,C.basename)(l)||(l.scheme===P.Schemas.file?l.fsPath:l.path);return E.isWindows&&(0,D.isRootOrDriveLetter)(i)?I(i):i}}e.getBaseLabel=A;function I(l){return(0,D.hasDriveLetter)(l)?l.charAt(0).toUpperCase()+l.slice(1):l}e.normalizeDriveLetter=I;let p=Object.create(null);function f(l,i){if(E.isWindows||!l||!i)return l;let d=p.original===i?p.normalized:void 0;return d||(d=`${(0,T.rtrim)(i,S.posix.sep)}${S.posix.sep}`,p={original:i,normalized:d}),(E.isLinux?l.startsWith(d):(0,T.startsWithIgnoreCase)(l,d))&&(l=`~/${l.substr(d.length)}`),l}e.tildify=f;function s(l,i){return l.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=s;const h="\u2026",v="\\\\",g="~";function b(l,i=S.sep){const d=new Array(l.length);let y=!1;for(let k=0;k<l.length;k++){let m=l[k];if(m===""){d[k]=`.${i}`;continue}if(!m){d[k]=m;continue}y=!0;let w="";m.indexOf(v)===0?(w=m.substr(0,m.indexOf(v)+v.length),m=m.substr(m.indexOf(v)+v.length)):m.indexOf(i)===0?(w=m.substr(0,m.indexOf(i)+i.length),m=m.substr(m.indexOf(i)+i.length)):m.indexOf(g)===0&&(w=m.substr(0,m.indexOf(g)+g.length),m=m.substr(m.indexOf(g)+g.length));const R=m.split(i);for(let F=1;y&&F<=R.length;F++)for(let B=R.length-F;y&&B>=0;B--){y=!1;let Q=R.slice(B,B+F).join(i);for(let J=0;!y&&J<l.length;J++)if(J!==k&&l[J]&&l[J].indexOf(Q)>-1){const z=B+F===R.length,ae=B>0&&l[J].indexOf(i)>-1?i+Q:Q,L=l[J].endsWith(ae);y=!z||L}if(!y){let J="";(R[0].endsWith(":")||w!=="")&&(B===1&&(B=0,F++,Q=R[0]+i+Q),B>0&&(J=R[0]+i),J=w+J),B>0&&(J=J+h+i),J=J+Q,B+F<R.length&&(J=J+i+h),d[k]=J}}y&&(d[k]=m)}return d}e.shorten=b;var c;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function u(l,i=Object.create(null)){const d=[];let y=!1,k="";for(const m of l)if(m==="$"||y&&m==="{")k&&d.push({value:k,type:c.TEXT}),k="",y=!0;else if(m==="}"&&y){const w=i[k];if(typeof w=="string")w.length&&d.push({value:w,type:c.VARIABLE});else if(w){const R=d[d.length-1];(!R||R.type!==c.SEPARATOR)&&d.push({value:w.label,type:c.SEPARATOR})}k="",y=!1}else k+=m;return k&&!y&&d.push({value:k,type:c.TEXT}),d.filter((m,w)=>{if(m.type===c.SEPARATOR){const R=d[w-1],F=d[w+1];return[R,F].every(B=>B&&(B.type===c.VARIABLE||B.type===c.TEXT)&&B.value.length>0)}return!0}).map(m=>m.value).join("")}e.template=u;function a(l,i){return E.isMacintosh||i?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,E.isMacintosh?"&":"&&"):l.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=a;function t(l,i){return E.isMacintosh||i?l.replace(/\(&&\w\)|&&/g,""):E.isWindows?l.replace(/&&|&/g,d=>d==="&"?"&&":"&"):l.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(l){return l.replace(/&/g,"&&")}e.unmnemonicLabel=r;function o(l){const i=l.indexOf("/")!==-1?S.posix:S.win32,d=i.basename(l),y=i.dirname(l);return d.length?{name:d,parentPath:y}:{name:y,parentPath:""}}e.splitName=o}),define(we[110],Ee([0,1,2]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function S(A){return A.toJSON()}class T{constructor(I){this._uriTransformer=I}transformIncoming(I){const p=this._uriTransformer.transformIncoming(I);return p===I?I:S(_.URI.from(p))}transformOutgoing(I){const p=this._uriTransformer.transformOutgoing(I);return p===I?I:S(_.URI.from(p))}transformOutgoingURI(I){const p=this._uriTransformer.transformOutgoing(I);return p===I?I:_.URI.from(p)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(A){return A}transformOutgoing(A){return A}transformOutgoingURI(A){return A}transformOutgoingScheme(A){return A}};function P(A,I,p){if(!A||p>200)return null;if(typeof A=="object"){if(A instanceof _.URI)return I.transformOutgoing(A);for(let f in A)if(Object.hasOwnProperty.call(A,f)){const s=P(A[f],I,p+1);s!==null&&(A[f]=s)}}return null}function E(A,I){const p=P(A,I,0);return p===null?A:p}e.transformOutgoingURIs=E;function C(A,I,p,f){if(!A||f>200)return null;if(typeof A=="object"){if(A.$mid===1)return p?_.URI.revive(I.transformIncoming(A)):I.transformIncoming(A);for(let s in A)if(Object.hasOwnProperty.call(A,s)){const h=C(A[s],I,p,f+1);h!==null&&(A[s]=h)}}return null}function D(A,I){const p=C(A,I,!1,0);return p===null?A:p}e.transformIncomingURIs=D;function n(A,I){const p=C(A,I,!0,0);return p===null?A:p}e.transformAndReviveIncomingURIs=n}),define(we[29],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const _=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function S(D){return _.test(D)}e.isUUID=S;const T=new Uint8Array(16),P=[];for(let D=0;D<256;D++)P.push(D.toString(16).padStart(2,"0"));let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(D){for(let n=0;n<D.length;n++)D[n]=Math.floor(Math.random()*256);return D};function C(){E(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let D=0,n="";return n+=P[T[D++]],n+=P[T[D++]],n+=P[T[D++]],n+=P[T[D++]],n+="-",n+=P[T[D++]],n+=P[T[D++]],n+="-",n+=P[T[D++]],n+=P[T[D++]],n+="-",n+=P[T[D++]],n+=P[T[D++]],n+="-",n+=P[T[D++]],n+=P[T[D++]],n+=P[T[D++]],n+=P[T[D++]],n+=P[T[D++]],n+=P[T[D++]],n}e.generateUuid=C}),define(we[81],Ee([0,1,79]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class S{constructor(C){let D=(0,_.toUint8)(C);this._defaultValue=D,this._asciiMap=S._createAsciiMap(D),this._map=new Map}static _createAsciiMap(C){let D=new Uint8Array(256);for(let n=0;n<256;n++)D[n]=C;return D}set(C,D){let n=(0,_.toUint8)(D);C>=0&&C<256?this._asciiMap[C]=n:this._map.set(C,n)}get(C){return C>=0&&C<256?this._asciiMap[C]:this._map.get(C)||this._defaultValue}}e.CharacterClassifier=S;var T;(function(E){E[E.False=0]="False",E[E.True=1]="True"})(T||(T={}));class P{constructor(){this._actual=new S(0)}add(C){this._actual.set(C,1)}has(C){return this._actual.get(C)===1}}e.CharacterSet=P}),define(we[111],Ee([0,1,81]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var S;(function(E){E[E.Regular=0]="Regular",E[E.Whitespace=1]="Whitespace",E[E.WordSeparator=2]="WordSeparator"})(S=e.WordCharacterClass||(e.WordCharacterClass={}));class T extends _.CharacterClassifier{constructor(C){super(0);for(let D=0,n=C.length;D<n;D++)this.set(C.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=T;function P(E){let C={};return D=>(C.hasOwnProperty(D)||(C[D]=E(D)),C[D])}e.getMapForWordSeparators=P(E=>new T(E))}),define(we[39],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class _{constructor(T,P){this.lineNumber=T,this.column=P}with(T=this.lineNumber,P=this.column){return T===this.lineNumber&&P===this.column?this:new _(T,P)}delta(T=0,P=0){return this.with(this.lineNumber+T,this.column+P)}equals(T){return _.equals(this,T)}static equals(T,P){return!T&&!P?!0:!!T&&!!P&&T.lineNumber===P.lineNumber&&T.column===P.column}isBefore(T){return _.isBefore(this,T)}static isBefore(T,P){return T.lineNumber<P.lineNumber?!0:P.lineNumber<T.lineNumber?!1:T.column<P.column}isBeforeOrEqual(T){return _.isBeforeOrEqual(this,T)}static isBeforeOrEqual(T,P){return T.lineNumber<P.lineNumber?!0:P.lineNumber<T.lineNumber?!1:T.column<=P.column}static compare(T,P){let E=T.lineNumber|0,C=P.lineNumber|0;if(E===C){let D=T.column|0,n=P.column|0;return D-n}return E-C}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(T){return new _(T.lineNumber,T.column)}static isIPosition(T){return T&&typeof T.lineNumber=="number"&&typeof T.column=="number"}}e.Position=_}),define(we[32],Ee([0,1,39]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class S{constructor(P,E,C,D){P>C||P===C&&E>D?(this.startLineNumber=C,this.startColumn=D,this.endLineNumber=P,this.endColumn=E):(this.startLineNumber=P,this.startColumn=E,this.endLineNumber=C,this.endColumn=D)}isEmpty(){return S.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return S.containsPosition(this,P)}static containsPosition(P,E){return!(E.lineNumber<P.startLineNumber||E.lineNumber>P.endLineNumber||E.lineNumber===P.startLineNumber&&E.column<P.startColumn||E.lineNumber===P.endLineNumber&&E.column>P.endColumn)}containsRange(P){return S.containsRange(this,P)}static containsRange(P,E){return!(E.startLineNumber<P.startLineNumber||E.endLineNumber<P.startLineNumber||E.startLineNumber>P.endLineNumber||E.endLineNumber>P.endLineNumber||E.startLineNumber===P.startLineNumber&&E.startColumn<P.startColumn||E.endLineNumber===P.endLineNumber&&E.endColumn>P.endColumn)}strictContainsRange(P){return S.strictContainsRange(this,P)}static strictContainsRange(P,E){return!(E.startLineNumber<P.startLineNumber||E.endLineNumber<P.startLineNumber||E.startLineNumber>P.endLineNumber||E.endLineNumber>P.endLineNumber||E.startLineNumber===P.startLineNumber&&E.startColumn<=P.startColumn||E.endLineNumber===P.endLineNumber&&E.endColumn>=P.endColumn)}plusRange(P){return S.plusRange(this,P)}static plusRange(P,E){let C,D,n,A;return E.startLineNumber<P.startLineNumber?(C=E.startLineNumber,D=E.startColumn):E.startLineNumber===P.startLineNumber?(C=E.startLineNumber,D=Math.min(E.startColumn,P.startColumn)):(C=P.startLineNumber,D=P.startColumn),E.endLineNumber>P.endLineNumber?(n=E.endLineNumber,A=E.endColumn):E.endLineNumber===P.endLineNumber?(n=E.endLineNumber,A=Math.max(E.endColumn,P.endColumn)):(n=P.endLineNumber,A=P.endColumn),new S(C,D,n,A)}intersectRanges(P){return S.intersectRanges(this,P)}static intersectRanges(P,E){let C=P.startLineNumber,D=P.startColumn,n=P.endLineNumber,A=P.endColumn,I=E.startLineNumber,p=E.startColumn,f=E.endLineNumber,s=E.endColumn;return C<I?(C=I,D=p):C===I&&(D=Math.max(D,p)),n>f?(n=f,A=s):n===f&&(A=Math.min(A,s)),C>n||C===n&&D>A?null:new S(C,D,n,A)}equalsRange(P){return S.equalsRange(this,P)}static equalsRange(P,E){return!!P&&!!E&&P.startLineNumber===E.startLineNumber&&P.startColumn===E.startColumn&&P.endLineNumber===E.endLineNumber&&P.endColumn===E.endColumn}getEndPosition(){return S.getEndPosition(this)}static getEndPosition(P){return new _.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return S.getStartPosition(this)}static getStartPosition(P){return new _.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,E){return new S(this.startLineNumber,this.startColumn,P,E)}setStartPosition(P,E){return new S(P,E,this.endLineNumber,this.endColumn)}collapseToStart(){return S.collapseToStart(this)}static collapseToStart(P){return new S(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,E=P){return new S(P.lineNumber,P.column,E.lineNumber,E.column)}static lift(P){return P?new S(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,E){return!(P.endLineNumber<E.startLineNumber||P.endLineNumber===E.startLineNumber&&P.endColumn<E.startColumn||E.endLineNumber<P.startLineNumber||E.endLineNumber===P.startLineNumber&&E.endColumn<P.startColumn)}static areIntersecting(P,E){return!(P.endLineNumber<E.startLineNumber||P.endLineNumber===E.startLineNumber&&P.endColumn<=E.startColumn||E.endLineNumber<P.startLineNumber||E.endLineNumber===P.startLineNumber&&E.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,E){if(P&&E){const n=P.startLineNumber|0,A=E.startLineNumber|0;if(n===A){const I=P.startColumn|0,p=E.startColumn|0;if(I===p){const f=P.endLineNumber|0,s=E.endLineNumber|0;if(f===s){const h=P.endColumn|0,v=E.endColumn|0;return h-v}return f-s}return I-p}return n-A}return(P?1:0)-(E?1:0)}static compareRangesUsingEnds(P,E){return P.endLineNumber===E.endLineNumber?P.endColumn===E.endColumn?P.startLineNumber===E.startLineNumber?P.startColumn-E.startColumn:P.startLineNumber-E.startLineNumber:P.endColumn-E.endColumn:P.endLineNumber-E.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}}e.Range=S}),define(we[112],Ee([0,1,39,32]),function(re,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var T;(function(E){E[E.LTR=0]="LTR",E[E.RTL=1]="RTL"})(T=e.SelectionDirection||(e.SelectionDirection={}));class P extends S.Range{constructor(C,D,n,A){super(C,D,n,A);this.selectionStartLineNumber=C,this.selectionStartColumn=D,this.positionLineNumber=n,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return P.selectionsEqual(this,C)}static selectionsEqual(C,D){return C.selectionStartLineNumber===D.selectionStartLineNumber&&C.selectionStartColumn===D.selectionStartColumn&&C.positionLineNumber===D.positionLineNumber&&C.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(C,D){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,C,D):new P(C,D,this.startLineNumber,this.startColumn)}getPosition(){return new _.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(C,D){return this.getDirection()===0?new P(C,D,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,C,D)}static fromPositions(C,D=C){return new P(C.lineNumber,C.column,D.lineNumber,D.column)}static liftSelection(C){return new P(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,D){if(C&&!D||!C&&D)return!1;if(!C&&!D)return!0;if(C.length!==D.length)return!1;for(let n=0,A=C.length;n<A;n++)if(!this.selectionsEqual(C[n],D[n]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,D,n,A,I){return I===0?new P(C,D,n,A):new P(n,A,C,D)}}e.Selection=P}),define(we[82],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var _;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(_=e.OverviewRulerLane||(e.OverviewRulerLane={}));var S;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(S=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var E;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(E=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(s){this.tabSize=Math.max(1,s.tabSize|0),this.indentSize=s.tabSize|0,this.insertSpaces=Boolean(s.insertSpaces),this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=Boolean(s.trimAutoWhitespace)}equals(s){return this.tabSize===s.tabSize&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class D{constructor(s,h){this.range=s,this.matches=h}}e.FindMatch=D;var n;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var A;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(A=e.ModelConstants||(e.ModelConstants={}));class I{constructor(s,h,v,g,b,c){this.identifier=s,this.range=h,this.text=v,this.forceMoveMarkers=g,this.isAutoWhitespaceEdit=b,this._isTracked=c}}e.ValidAnnotatedEditOperation=I;class p{constructor(s,h,v){this.reverseEdits=s,this.changes=h,this.trimAutoWhitespaceLineNumbers=v}}e.ApplyEditsResult=p}),define(we[113],Ee([0,1,8,111,39,32,82]),function(re,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class D{constructor(c,u,a,t){this.searchString=c,this.isRegex=u,this.matchCase=a,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let c;this.isRegex?c=n(this.searchString):c=this.searchString.indexOf(`
`)>=0;let u=null;try{u=_.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:c,global:!0,unicode:!0})}catch(t){return null}if(!u)return null;let a=!this.isRegex&&!c;return a&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(a=this.matchCase),new A(u,this.wordSeparators?(0,S.getMapForWordSeparators)(this.wordSeparators):null,a?this.searchString:null)}}e.SearchParams=D;function n(b){if(!b||b.length===0)return!1;for(let c=0,u=b.length;c<u;c++)if(b.charCodeAt(c)===92){if(c++,c>=u)break;const t=b.charCodeAt(c);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=n;class A{constructor(c,u,a){this.regex=c,this.wordSeparators=u,this.simpleSearch=a}}e.SearchData=A;function I(b,c,u){if(!u)return new E.FindMatch(b,null);let a=[];for(let t=0,r=c.length;t<r;t++)a[t]=c[t];return new E.FindMatch(b,a)}e.createFindMatch=I;class p{constructor(c){let u=[],a=0;for(let t=0,r=c.length;t<r;t++)c.charCodeAt(t)===10&&(u[a++]=t);this._lineFeedsOffsets=u}findLineFeedCountBeforeOffset(c){const u=this._lineFeedsOffsets;let a=0,t=u.length-1;if(t===-1||c<=u[0])return 0;for(;a<t;){const r=a+((t-a)/2>>0);u[r]>=c?t=r-1:u[r+1]>=c?(a=r,t=r):a=r+1}return a+1}}class f{static findMatches(c,u,a,t,r){const o=u.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(c,a,new g(o.wordSeparators,o.regex),t,r):this._doFindMatchesLineByLine(c,a,o,t,r):[]}static _getMultilineMatchRange(c,u,a,t,r,o){let l,i=0;t?(i=t.findLineFeedCountBeforeOffset(r),l=u+r+i):l=u+r;let d;if(t){let w=t.findLineFeedCountBeforeOffset(r+o.length)-i;d=l+o.length+w}else d=l+o.length;const y=c.getPositionAt(l),k=c.getPositionAt(d);return new P.Range(y.lineNumber,y.column,k.lineNumber,k.column)}static _doFindMatchesMultiline(c,u,a,t,r){const o=c.getOffsetAt(u.getStartPosition()),l=c.getValueInRange(u,1),i=c.getEOL()===`\r
`?new p(l):null,d=[];let y=0,k;for(a.reset(0);k=a.next(l);)if(d[y++]=I(this._getMultilineMatchRange(c,o,l,i,k.index,k[0]),k,t),y>=r)return d;return d}static _doFindMatchesLineByLine(c,u,a,t,r){const o=[];let l=0;if(u.startLineNumber===u.endLineNumber){const d=c.getLineContent(u.startLineNumber).substring(u.startColumn-1,u.endColumn-1);return l=this._findMatchesInLine(a,d,u.startLineNumber,u.startColumn-1,l,o,t,r),o}const i=c.getLineContent(u.startLineNumber).substring(u.startColumn-1);l=this._findMatchesInLine(a,i,u.startLineNumber,u.startColumn-1,l,o,t,r);for(let d=u.startLineNumber+1;d<u.endLineNumber&&l<r;d++)l=this._findMatchesInLine(a,c.getLineContent(d),d,0,l,o,t,r);if(l<r){const d=c.getLineContent(u.endLineNumber).substring(0,u.endColumn-1);l=this._findMatchesInLine(a,d,u.endLineNumber,0,l,o,t,r)}return o}static _findMatchesInLine(c,u,a,t,r,o,l,i){const d=c.wordSeparators;if(!l&&c.simpleSearch){const m=c.simpleSearch,w=m.length,R=u.length;let F=-w;for(;(F=u.indexOf(m,F+w))!==-1;)if((!d||v(d,u,R,F,w))&&(o[r++]=new E.FindMatch(new P.Range(a,F+1+t,a,F+1+w+t),null),r>=i))return r;return r}const y=new g(c.wordSeparators,c.regex);let k;y.reset(0);do if(k=y.next(u),k&&(o[r++]=I(new P.Range(a,k.index+1+t,a,k.index+1+k[0].length+t),k,l),r>=i))return r;while(k);return r}static findNextMatch(c,u,a,t){const r=u.parseSearchRequest();if(!r)return null;const o=new g(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(c,a,o,t):this._doFindNextMatchLineByLine(c,a,o,t)}static _doFindNextMatchMultiline(c,u,a,t){const r=new T.Position(u.lineNumber,1),o=c.getOffsetAt(r),l=c.getLineCount(),i=c.getValueInRange(new P.Range(r.lineNumber,r.column,l,c.getLineMaxColumn(l)),1),d=c.getEOL()===`\r
`?new p(i):null;a.reset(u.column-1);let y=a.next(i);return y?I(this._getMultilineMatchRange(c,o,i,d,y.index,y[0]),y,t):u.lineNumber!==1||u.column!==1?this._doFindNextMatchMultiline(c,new T.Position(1,1),a,t):null}static _doFindNextMatchLineByLine(c,u,a,t){const r=c.getLineCount(),o=u.lineNumber,l=c.getLineContent(o),i=this._findFirstMatchInLine(a,l,o,u.column,t);if(i)return i;for(let d=1;d<=r;d++){const y=(o+d-1)%r,k=c.getLineContent(y+1),m=this._findFirstMatchInLine(a,k,y+1,1,t);if(m)return m}return null}static _findFirstMatchInLine(c,u,a,t,r){c.reset(t-1);const o=c.next(u);return o?I(new P.Range(a,o.index+1,a,o.index+1+o[0].length),o,r):null}static findPreviousMatch(c,u,a,t){const r=u.parseSearchRequest();if(!r)return null;const o=new g(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(c,a,o,t):this._doFindPreviousMatchLineByLine(c,a,o,t)}static _doFindPreviousMatchMultiline(c,u,a,t){const r=this._doFindMatchesMultiline(c,new P.Range(1,1,u.lineNumber,u.column),a,t,10*C);if(r.length>0)return r[r.length-1];const o=c.getLineCount();return u.lineNumber!==o||u.column!==c.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(c,new T.Position(o,c.getLineMaxColumn(o)),a,t):null}static _doFindPreviousMatchLineByLine(c,u,a,t){const r=c.getLineCount(),o=u.lineNumber,l=c.getLineContent(o).substring(0,u.column-1),i=this._findLastMatchInLine(a,l,o,t);if(i)return i;for(let d=1;d<=r;d++){const y=(r+o-d-1)%r,k=c.getLineContent(y+1),m=this._findLastMatchInLine(a,k,y+1,t);if(m)return m}return null}static _findLastMatchInLine(c,u,a,t){let r=null,o;for(c.reset(0);o=c.next(u);)r=I(new P.Range(a,o.index+1,a,o.index+1+o[0].length),o,t);return r}}e.TextModelSearch=f;function s(b,c,u,a,t){if(a===0)return!0;const r=c.charCodeAt(a-1);if(b.get(r)!==0||r===13||r===10)return!0;if(t>0){const o=c.charCodeAt(a);if(b.get(o)!==0)return!0}return!1}function h(b,c,u,a,t){if(a+t===u)return!0;const r=c.charCodeAt(a+t);if(b.get(r)!==0||r===13||r===10)return!0;if(t>0){const o=c.charCodeAt(a+t-1);if(b.get(o)!==0)return!0}return!1}function v(b,c,u,a,t){return s(b,c,u,a,t)&&h(b,c,u,a,t)}e.isValidMatch=v;class g{constructor(c,u){this._wordSeparators=c,this._searchRegex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(c){this._searchRegex.lastIndex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(c){const u=c.length;let a;do{if(this._prevMatchStartIndex+this._prevMatchLength===u||(a=this._searchRegex.exec(c),!a))return null;const t=a.index,r=a[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){_.getNextCodePoint(c,u,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||v(this._wordSeparators,c,u,t,r))return a}while(a);return null}}e.Searcher=g}),define(we[83],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function _(C=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const n of e.USUAL_WORD_SEPARATORS)C.indexOf(n)>=0||(D+="\\"+n);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=_();function S(C){let D=e.DEFAULT_WORD_REGEXP;if(C&&C instanceof RegExp)if(C.global)D=C;else{let n="g";C.ignoreCase&&(n+="i"),C.multiline&&(n+="m"),C.unicode&&(n+="u"),D=new RegExp(C.source,n)}return D.lastIndex=0,D}e.ensureValidWordDefinition=S;const T={maxLen:1e3,windowSize:15,timeBudget:150};function P(C,D,n,A,I=T){if(n.length>I.maxLen){let v=C-I.maxLen/2;return v<0?v=0:A+=v,n=n.substring(v,C+I.maxLen/2),P(C,D,n,A,I)}const p=Date.now(),f=C-1-A;let s=-1,h=null;for(let v=1;!(Date.now()-p>=I.timeBudget);v++){const g=f-I.windowSize*v;D.lastIndex=Math.max(0,g);const b=E(D,n,f,s);if(!b&&h||(h=b,g<=0))break;s=g}if(h){let v={word:h[0],startColumn:A+1+h.index,endColumn:A+1+h.index+h[0].length};return D.lastIndex=0,v}return null}e.getWordAtText=P;function E(C,D,n,A){let I;for(;I=C.exec(D);){const p=I.index||0;if(p<=n&&C.lastIndex>=n)return I;if(A>0&&p>A)return null}return null}}),define(we[114],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var _;(function(E){E[E.None=0]="None",E[E.Indent=1]="Indent",E[E.IndentOutdent=2]="IndentOutdent",E[E.Outdent=3]="Outdent"})(_=e.IndentAction||(e.IndentAction={}));class S{constructor(C){if(this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let D=0,n=C.notIn.length;D<n;D++)switch(C.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=S;class T{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of C)P(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),P(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),P(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),P(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&P(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=T;function P(E,C,D){E.has(C)?E.get(C).push(D):E.set(C,[D])}}),define(we[60],Ee([0,1,28,10]),function(re,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function T(P,E,C,D){if(Array.isArray(P)){let n=0;for(const A of P){const I=T(A,E,C,D);if(I===10)return I;I>n&&(n=I)}return n}else{if(typeof P=="string")return D?P==="*"?5:P===C?10:0:0;if(P){const{language:n,pattern:A,scheme:I,hasAccessToAllModels:p}=P;if(!D&&!p)return 0;let f=0;if(I)if(I===E.scheme)f=10;else if(I==="*")f=5;else return 0;if(n)if(n===C)f=10;else if(n==="*")f=Math.max(f,5);else return 0;if(A){let s;if(typeof A=="string"?s=A:s=Object.assign(Object.assign({},A),{base:(0,S.normalize)(A.base)}),s===E.fsPath||(0,_.match)(s,E.fsPath))f=10;else return 0}return f}else return 0}}e.score=T}),define(we[115],Ee([0,1,81]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var S;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(S=e.State||(e.State={}));class T{constructor(s,h,v){const g=new Uint8Array(s*h);for(let b=0,c=s*h;b<c;b++)g[b]=v;this._data=g,this.rows=s,this.cols=h}get(s,h){return this._data[s*this.cols+h]}set(s,h,v){this._data[s*this.cols+h]=v}}e.Uint8Matrix=T;class P{constructor(s){let h=0,v=0;for(let b=0,c=s.length;b<c;b++){let[u,a,t]=s[b];a>h&&(h=a),u>v&&(v=u),t>v&&(v=t)}h++,v++;let g=new T(v,h,0);for(let b=0,c=s.length;b<c;b++){let[u,a,t]=s[b];g.set(u,a,t)}this._states=g,this._maxCharCode=h}nextState(s,h){return h<0||h>=this._maxCharCode?0:this._states.get(s,h)}}e.StateMachine=P;let E=null;function C(){return E===null&&(E=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),E}var D;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let n=null;function A(){if(n===null){n=new _.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<f.length;h++)n.set(f.charCodeAt(h),1);const s=".,;";for(let h=0;h<s.length;h++)n.set(s.charCodeAt(h),2)}return n}class I{static _createLink(s,h,v,g,b){let c=b-1;do{const u=h.charCodeAt(c);if(s.get(u)!==2)break;c--}while(c>g);if(g>0){const u=h.charCodeAt(g-1),a=h.charCodeAt(c);(u===40&&a===41||u===91&&a===93||u===123&&a===125)&&c--}return{range:{startLineNumber:v,startColumn:g+1,endLineNumber:v,endColumn:c+2},url:h.substring(g,c+1)}}static computeLinks(s,h=C()){const v=A();let g=[];for(let b=1,c=s.getLineCount();b<=c;b++){const u=s.getLineContent(b),a=u.length;let t=0,r=0,o=0,l=1,i=!1,d=!1,y=!1,k=!1;for(;t<a;){let m=!1;const w=u.charCodeAt(t);if(l===13){let R;switch(w){case 40:i=!0,R=0;break;case 41:R=i?0:1;break;case 91:y=!0,d=!0,R=0;break;case 93:y=!1,R=d?0:1;break;case 123:k=!0,R=0;break;case 125:R=k?0:1;break;case 39:R=o===34||o===96?0:1;break;case 34:R=o===39||o===96?0:1;break;case 96:R=o===39||o===34?0:1;break;case 42:R=o===42?1:0;break;case 124:R=o===124?1:0;break;case 32:R=y?0:1;break;default:R=v.get(w)}R===1&&(g.push(I._createLink(v,u,b,r,t)),m=!0)}else if(l===12){let R;w===91?(d=!0,R=0):R=v.get(w),R===1?m=!0:l=13}else l=h.nextState(l,w),l===0&&(m=!0);m&&(l=1,i=!1,d=!1,k=!1,r=t+1,o=w),t++}l===13&&g.push(I._createLink(v,u,b,r,a))}return g}}e.LinkComputer=I;function p(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:I.computeLinks(f)}e.computeLinks=p}),define(we[116],Ee([0,1,3,6]),function(re,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class T{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(E){this._onDidChange.fire({changedLanguages:E,changedColorMap:!1})}register(E,C){return this._map.set(E,C),this.fire([E]),(0,S.toDisposable)(()=>{this._map.get(E)===C&&(this._map.delete(E),this.fire([E]))})}registerPromise(E,C){let D=null,n=!1;return this._promises.set(E,C.then(A=>{this._promises.delete(E),!(n||!A)&&(D=this.register(E,A))})),(0,S.toDisposable)(()=>{n=!0,D&&D.dispose()})}getPromise(E){const C=this.get(E);if(C)return Promise.resolve(C);const D=this._promises.get(E);return D?D.then(n=>this.get(E)):null}get(E){return this._map.get(E)||null}setColorMap(E){this._colorMap=E,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=T}),define(we[84],Ee([0,1,26,21]),function(re,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var T;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(T||(T={}));function P(I){for(let p=0,f=I.length;p<f;p+=4){const s=I[p+0],h=I[p+1],v=I[p+2],g=I[p+3];I[p+0]=g,I[p+1]=v,I[p+2]=h,I[p+3]=s}}function E(I){const p=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return S.isLittleEndian()||P(p),_.VSBuffer.wrap(p)}function C(I){const p=I.buffer;if(S.isLittleEndian()||P(p),p.byteOffset%4==0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const f=new Uint8Array(p.byteLength);return f.set(p),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function D(I){const p=new Uint32Array(n(I));let f=0;if(p[f++]=I.id,I.type==="full")p[f++]=1,p[f++]=I.data.length,p.set(I.data,f),f+=I.data.length;else{p[f++]=2,p[f++]=I.deltas.length;for(const s of I.deltas)p[f++]=s.start,p[f++]=s.deleteCount,s.data?(p[f++]=s.data.length,p.set(s.data,f),f+=s.data.length):p[f++]=0}return E(p)}e.encodeSemanticTokensDto=D;function n(I){let p=0;if(p+=1+1,I.type==="full")p+=1+I.data.length;else{p+=1,p+=(1+1+1)*I.deltas.length;for(const f of I.deltas)f.data&&(p+=f.data.length)}return p}function A(I){const p=C(I);let f=0;const s=p[f++];if(p[f++]===1){const b=p[f++],c=p.subarray(f,f+b);return f+=b,{id:s,type:"full",data:c}}const v=p[f++];let g=[];for(let b=0;b<v;b++){const c=p[f++],u=p[f++],a=p[f++];let t;a>0&&(t=p.subarray(f,f+a),f+=a),g[b]={start:c,deleteCount:u,data:t}}return{id:s,type:"delta",deltas:g}}e.decodeSemanticTokensDto=A}),define(we[85],Ee([0,1,79]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class S{constructor(E,C){this.index=E,this.remainder=C}}e.PrefixSumIndexOfResult=S;class T{constructor(E){this.values=E,this.prefixSum=new Uint32Array(E.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(E,C){E=(0,_.toUint32)(E);const D=this.values,n=this.prefixSum,A=C.length;return A===0?!1:(this.values=new Uint32Array(D.length+A),this.values.set(D.subarray(0,E),0),this.values.set(D.subarray(E),E+A),this.values.set(C,E),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(E,C){return E=(0,_.toUint32)(E),C=(0,_.toUint32)(C),this.values[E]===C?!1:(this.values[E]=C,E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),!0)}removeValues(E,C){E=(0,_.toUint32)(E),C=(0,_.toUint32)(C);const D=this.values,n=this.prefixSum;if(E>=D.length)return!1;let A=D.length-E;return C>=A&&(C=A),C===0?!1:(this.values=new Uint32Array(D.length-C),this.values.set(D.subarray(0,E),0),this.values.set(D.subarray(E+C),E),this.prefixSum=new Uint32Array(this.values.length),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(E){return E<0?0:(E=(0,_.toUint32)(E),this._getAccumulatedValue(E))}_getAccumulatedValue(E){if(E<=this.prefixSumValidIndex[0])return this.prefixSum[E];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),E>=this.values.length&&(E=this.values.length-1);for(let D=C;D<=E;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],E),this.prefixSum[E]}getIndexOf(E){E=Math.floor(E),this.getTotalValue();let C=0,D=this.values.length-1,n=0,A=0,I=0;for(;C<=D;)if(n=C+(D-C)/2|0,A=this.prefixSum[n],I=A-this.values[n],E<I)D=n-1;else if(E>=A)C=n+1;else break;return new S(n,E-I)}}e.PrefixSumComputer=T}),define(we[117],Ee([0,1,8,39,85]),function(re,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(C,D,n,A){this._uri=C,this._lines=D,this._eol=n,this._versionId=A,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const D=C.changes;for(const n of D)this._acceptDeleteRange(n.range),this._acceptInsertText(new S.Position(n.range.startLineNumber,n.range.startColumn),n.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,D=this._lines.length,n=new Uint32Array(D);for(let A=0;A<D;A++)n[A]=this._lines[A].length+C;this._lineStarts=new T.PrefixSumComputer(n)}}_setLineText(C,D){this._lines[C]=D,this._lineStarts&&this._lineStarts.changeValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,D){if(D.length!==0){let n=(0,_.splitLines)(D);if(n.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+n[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}n[n.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+n[0]);let A=new Uint32Array(n.length-1);for(let I=1;I<n.length;I++)this._lines.splice(C.lineNumber+I-1,0,n[I]),A[I-1]=n[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,A)}}}e.MirrorTextModel=P}),define(we[118],Ee([17,18]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(we[61],Ee([0,1,118,12,14]),function(re,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function P(n,A){return A&&(n.stack||n.stacktrace)?_.localize(0,null,C(n),E(n.stack)||E(n.stacktrace)):C(n)}function E(n){return Array.isArray(n)?n.join(`
`):n}function C(n){return typeof n.code=="string"&&typeof n.errno=="number"&&typeof n.syscall=="string"?_.localize(1,null,n.message):n.message||_.localize(2,null)}function D(n=null,A=!1){if(!n)return _.localize(3,null);if(Array.isArray(n)){const I=T.coalesce(n),p=D(I[0],A);return I.length>1?_.localize(4,null,p,I.length):p}if(S.isString(n))return n;if(n.detail){const I=n.detail;if(I.error)return P(I.error,A);if(I.exception)return P(I.exception,A)}return n.stack?P(n,A):n.message?n.message:_.localize(5,null)}e.toErrorMessage=D}),define(we[119],Ee([17,18]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(we[120],Ee([0,1,119,21,83]),function(re,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var P;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(P=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(Z){this._values=Z}hasChanged(Z){return this._values[Z]}}e.ConfigurationChangedEvent=E;class C{constructor(){this._values=[]}_read(Z){return this._values[Z]}get(Z){return this._values[Z]}_write(Z,_e){this._values[Z]=_e}}e.ValidatedEditorOptions=C;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class n{constructor(Z,_e,Me,$e){this.id=Z,this.name=_e,this.defaultValue=Me,this.schema=$e}compute(Z,_e,Me){return Me}}class A{constructor(Z,_e=null){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0,this.deps=_e}validate(Z){return this.defaultValue}}class I{constructor(Z,_e,Me,$e){this.id=Z,this.name=_e,this.defaultValue=Me,this.schema=$e}validate(Z){return typeof Z=="undefined"?this.defaultValue:Z}compute(Z,_e,Me){return Me}}function p(V,Z){return typeof V=="undefined"?Z:V==="false"?!1:Boolean(V)}e.boolean=p;class f extends I{constructor(Z,_e,Me,$e=void 0){typeof $e!="undefined"&&($e.type="boolean",$e.default=Me),super(Z,_e,Me,$e)}validate(Z){return p(Z,this.defaultValue)}}class s extends I{constructor(Z,_e,Me,$e,Ne,Je=void 0){typeof Je!="undefined"&&(Je.type="integer",Je.default=Me,Je.minimum=$e,Je.maximum=Ne),super(Z,_e,Me,Je),this.minimum=$e,this.maximum=Ne}static clampedInt(Z,_e,Me,$e){if(typeof Z=="undefined")return _e;let Ne=parseInt(Z,10);return isNaN(Ne)?_e:(Ne=Math.max(Me,Ne),Ne=Math.min($e,Ne),Ne|0)}validate(Z){return s.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}class h extends I{constructor(Z,_e,Me,$e,Ne){typeof Ne!="undefined"&&(Ne.type="number",Ne.default=Me),super(Z,_e,Me,Ne),this.validationFn=$e}static clamp(Z,_e,Me){return Z<_e?_e:Z>Me?Me:Z}static float(Z,_e){if(typeof Z=="number")return Z;if(typeof Z=="undefined")return _e;const Me=parseFloat(Z);return isNaN(Me)?_e:Me}validate(Z){return this.validationFn(h.float(Z,this.defaultValue))}}class v extends I{static string(Z,_e){return typeof Z!="string"?_e:Z}constructor(Z,_e,Me,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.default=Me),super(Z,_e,Me,$e)}validate(Z){return v.string(Z,this.defaultValue)}}function g(V,Z,_e){return typeof V!="string"||_e.indexOf(V)===-1?Z:V}e.stringSet=g;class b extends I{constructor(Z,_e,Me,$e,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="string",Ne.enum=$e,Ne.default=Me),super(Z,_e,Me,Ne),this._allowedValues=$e}validate(Z){return g(Z,this.defaultValue,this._allowedValues)}}class c extends n{constructor(Z,_e,Me,$e,Ne,Je,x=void 0){typeof x!="undefined"&&(x.type="string",x.enum=Ne,x.default=$e),super(Z,_e,Me,x),this._allowedValues=Ne,this._convert=Je}validate(Z){return typeof Z!="string"?this.defaultValue:this._allowedValues.indexOf(Z)===-1?this.defaultValue:this._convert(Z)}}function u(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class a extends n{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[_.localize(0,null),_.localize(1,null),_.localize(2,null)],default:"auto",description:_.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,_e,Me){return Me===0?Z.accessibilitySupport:Me}}class t extends n{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(16,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:_.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:_.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const _e=Z;return{insertSpace:p(_e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:p(_e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function o(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var l;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(l=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function i(V){switch(V){case l.Line:return"line";case l.Block:return"block";case l.Underline:return"underline";case l.LineThin:return"line-thin";case l.BlockOutline:return"block-outline";case l.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=i;function d(V){switch(V){case"line":return l.Line;case"block":return l.Block;case"underline":return l.Underline;case"line-thin":return l.LineThin;case"block-outline":return l.BlockOutline;case"underline-thin":return l.UnderlineThin}}class y extends A{constructor(){super(121,[60,29])}compute(Z,_e,Me){const $e=["monaco-editor"];return _e.get(29)&&$e.push(_e.get(29)),Z.extraEditorClassName&&$e.push(Z.extraEditorClassName),_e.get(60)==="default"?$e.push("mouse-default"):_e.get(60)==="copy"&&$e.push("mouse-copy"),_e.get(95)&&$e.push("showUnused"),_e.get(119)&&$e.push("showDeprecated"),$e.join(" ")}}class k extends f{constructor(){super(28,"emptySelectionClipboard",!0,{description:_.localize(6,null)})}compute(Z,_e,Me){return Me&&Z.emptySelectionClipboard}}class m extends n{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(31,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:_.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:Z.seedSearchStringFromSelection,description:_.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[_.localize(9,null),_.localize(10,null),_.localize(11,null)],description:_.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:_.localize(13,null),included:S.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:_.localize(14,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:_.localize(15,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const _e=Z;return{cursorMoveOnType:p(_e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:p(_e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":g(_e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:p(_e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:p(_e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:p(_e.loop,this.defaultValue.loop)}}}class w extends n{constructor(){super(39,"fontLigatures",w.OFF,{anyOf:[{type:"boolean",description:_.localize(16,null)},{type:"string",description:_.localize(17,null)}],description:_.localize(18,null),default:!1})}validate(Z){return typeof Z=="undefined"?this.defaultValue:typeof Z=="string"?Z==="false"?w.OFF:Z==="true"?w.ON:Z:Boolean(Z)?w.ON:w.OFF}}e.EditorFontLigatures=w,w.OFF='"liga" off, "calt" off',w.ON='"liga" on, "calt" on';class R extends A{constructor(){super(38)}compute(Z,_e,Me){return Z.fontInfo}}class F extends I{constructor(){super(40,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:_.localize(19,null)})}validate(Z){let _e=h.float(Z,this.defaultValue);return _e===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(_e,6,100)}compute(Z,_e,Me){return Z.fontInfo.fontSize}}class B extends n{constructor(){super(41,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.MINIMUM_VALUE,maximum:B.MAXIMUM_VALUE,errorMessage:_.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:_.localize(21,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(s.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,B.MINIMUM_VALUE,B.MAXIMUM_VALUE))}}B.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],B.MINIMUM_VALUE=1,B.MAXIMUM_VALUE=1e3;class Q extends n{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},_e={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[_.localize(22,null),_.localize(23,null),_.localize(24,null)]};super(45,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:_.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:_.localize(26,null)},_e),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:_.localize(27,null)},_e),"editor.gotoLocation.multipleDeclarations":Object.assign({description:_.localize(28,null)},_e),"editor.gotoLocation.multipleImplementations":Object.assign({description:_.localize(29,null)},_e),"editor.gotoLocation.multipleReferences":Object.assign({description:_.localize(30,null)},_e),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,description:_.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,description:_.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,description:_.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,description:_.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,description:_.localize(35,null)}})}validate(Z){var _e,Me,$e,Ne,Je;if(!Z||typeof Z!="object")return this.defaultValue;const x=Z;return{multiple:g(x.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(_e=x.multipleDefinitions)!==null&&_e!==void 0?_e:g(x.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Me=x.multipleTypeDefinitions)!==null&&Me!==void 0?Me:g(x.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:($e=x.multipleDeclarations)!==null&&$e!==void 0?$e:g(x.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Ne=x.multipleImplementations)!==null&&Ne!==void 0?Ne:g(x.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Je=x.multipleReferences)!==null&&Je!==void 0?Je:g(x.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:v.string(x.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:v.string(x.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:v.string(x.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:v.string(x.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:v.string(x.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class J extends n{constructor(){const Z={enabled:!0,delay:300,sticky:!0};super(48,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:_.localize(36,null)},"editor.hover.delay":{type:"number",default:Z.delay,description:_.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:_.localize(38,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const _e=Z;return{enabled:p(_e.enabled,this.defaultValue.enabled),delay:s.clampedInt(_e.delay,this.defaultValue.delay,0,1e4),sticky:p(_e.sticky,this.defaultValue.sticky)}}}var z;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})(z=e.RenderMinimap||(e.RenderMinimap={}));class ae extends A{constructor(){super(124,[44,52,33,59,87,54,55,89,111,114,115,116,2])}compute(Z,_e,Me){return ae.computeLayout(_e,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio})}static computeContainedMinimapLineCount(Z){const _e=Z.height/Z.lineHeight,Me=Z.scrollBeyondLastLine?_e-1:0,$e=(Z.viewLineCount+Me)/(Z.pixelRatio*Z.height),Ne=Math.floor(Z.viewLineCount/$e);return{typicalViewportLineCount:_e,extraLinesBeyondLastLine:Me,desiredRatio:$e,minimapLineCount:Ne}}static _computeMinimapLayout(Z,_e){const Me=Z.outerWidth,$e=Z.outerHeight,Ne=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ne*$e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:$e};const Je=_e.stableMinimapLayoutInput,x=Je&&Z.outerHeight===Je.outerHeight&&Z.lineHeight===Je.lineHeight&&Z.typicalHalfwidthCharacterWidth===Je.typicalHalfwidthCharacterWidth&&Z.pixelRatio===Je.pixelRatio&&Z.scrollBeyondLastLine===Je.scrollBeyondLastLine&&Z.minimap.enabled===Je.minimap.enabled&&Z.minimap.side===Je.minimap.side&&Z.minimap.size===Je.minimap.size&&Z.minimap.showSlider===Je.minimap.showSlider&&Z.minimap.renderCharacters===Je.minimap.renderCharacters&&Z.minimap.maxColumn===Je.minimap.maxColumn&&Z.minimap.scale===Je.minimap.scale&&Z.verticalScrollbarWidth===Je.verticalScrollbarWidth&&Z.isViewportWrapping===Je.isViewportWrapping,ee=Z.lineHeight,ce=Z.typicalHalfwidthCharacterWidth,j=Z.scrollBeyondLastLine,X=Z.minimap.renderCharacters;let se=Ne>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const de=Z.minimap.maxColumn,Se=Z.minimap.size,xe=Z.minimap.side,Oe=Z.verticalScrollbarWidth,Be=Z.viewLineCount,Qe=Z.remainingWidth,nt=Z.isViewportWrapping,et=X?2:3;let Xe=Math.floor(Ne*$e);const fe=Xe/Ne;let ye=!1,oe=!1,q=et*se,Ie=se/Ne,Pe=1;if(Se==="fill"||Se==="fit"){const{typicalViewportLineCount:ot,extraLinesBeyondLastLine:ct,desiredRatio:Ct,minimapLineCount:yt}=ae.computeContainedMinimapLineCount({viewLineCount:Be,scrollBeyondLastLine:j,height:$e,lineHeight:ee,pixelRatio:Ne});if(Be/yt>1)ye=!0,oe=!0,se=1,q=1,Ie=se/Ne;else{let lt=!1,ft=se+1;if(Se==="fit"){const dt=Math.ceil((Be+ct)*q);nt&&x&&Qe<=_e.stableFitRemainingWidth?(lt=!0,ft=_e.stableFitMaxMinimapScale):(lt=dt>Xe,nt&&lt?(_e.stableMinimapLayoutInput=Z,_e.stableFitRemainingWidth=Qe):(_e.stableMinimapLayoutInput=null,_e.stableFitRemainingWidth=0))}if(Se==="fill"||lt){ye=!0;const dt=se;q=Math.min(ee*Ne,Math.max(1,Math.floor(1/Ct))),se=Math.min(ft,Math.max(1,Math.floor(q/et))),se>dt&&(Pe=Math.min(2,se/dt)),Ie=se/Ne/Pe,Xe=Math.ceil(Math.max(ot,Be+ct)*q),nt&&lt&&(_e.stableFitMaxMinimapScale=se)}}}const Ze=Math.floor(de*Ie),Ae=Math.min(Ze,Math.max(0,Math.floor((Qe-Oe-2)*Ie/(ce+Ie)))+e.MINIMAP_GUTTER_WIDTH);let it=Math.floor(Ne*Ae);const st=it/Ne;it=Math.floor(it*Pe);const Ge=X?1:2,ut=xe==="left"?0:Me-Ae-Oe;return{renderMinimap:Ge,minimapLeft:ut,minimapWidth:Ae,minimapHeightIsEditorHeight:ye,minimapIsSampling:oe,minimapScale:se,minimapLineHeight:q,minimapCanvasInnerWidth:it,minimapCanvasInnerHeight:Xe,minimapCanvasOuterWidth:st,minimapCanvasOuterHeight:fe}}static computeLayout(Z,_e){const Me=_e.outerWidth|0,$e=_e.outerHeight|0,Ne=_e.lineHeight|0,Je=_e.lineNumbersDigitCount|0,x=_e.typicalHalfwidthCharacterWidth,ee=_e.maxDigitWidth,ce=_e.pixelRatio,j=_e.viewLineCount,X=Z.get(116),se=X==="inherit"?Z.get(115):X,de=se==="inherit"?Z.get(111):se,Se=Z.get(114),xe=Z.get(2),Oe=_e.isDominatedByLongLines,Be=Z.get(44),Qe=Z.get(54).renderType!==0,nt=Z.get(55),et=Z.get(89),Xe=Z.get(59),fe=Z.get(87),ye=fe.verticalScrollbarSize,oe=fe.verticalHasArrows,q=fe.arrowSize,Ie=fe.horizontalScrollbarSize,Pe=Z.get(52),Ze=Z.get(33);let Ae;if(typeof Pe=="string"&&/^\d+(\.\d+)?ch$/.test(Pe)){const It=parseFloat(Pe.substr(0,Pe.length-2));Ae=s.clampedInt(It*x,0,0,1e3)}else Ae=s.clampedInt(Pe,0,0,1e3);Ze&&(Ae+=16);let it=0;if(Qe){const It=Math.max(Je,nt);it=Math.round(It*ee)}let st=0;Be&&(st=Ne);let Ge=0,ut=Ge+st,ot=ut+it,ct=ot+Ae;const Ct=Me-st-it-Ae;let yt=!1,pt=!1,lt=-1;xe!==2&&(se==="inherit"&&Oe?(yt=!0,pt=!0):de==="on"||de==="bounded"?pt=!0:de==="wordWrapColumn"&&(lt=Se));const ft=ae._computeMinimapLayout({outerWidth:Me,outerHeight:$e,lineHeight:Ne,typicalHalfwidthCharacterWidth:x,pixelRatio:ce,scrollBeyondLastLine:et,minimap:Xe,verticalScrollbarWidth:ye,viewLineCount:j,remainingWidth:Ct,isViewportWrapping:pt},_e.memory||new D);ft.renderMinimap!==0&&ft.minimapLeft===0&&(Ge+=ft.minimapWidth,ut+=ft.minimapWidth,ot+=ft.minimapWidth,ct+=ft.minimapWidth);const dt=Ct-ft.minimapWidth,kt=Math.max(1,Math.floor((dt-ye-2)/x)),Et=oe?q:0;return pt&&(lt=Math.max(1,kt),de==="bounded"&&(lt=Math.min(lt,Se))),{width:Me,height:$e,glyphMarginLeft:Ge,glyphMarginWidth:st,lineNumbersLeft:ut,lineNumbersWidth:it,decorationsLeft:ot,decorationsWidth:Ae,contentLeft:ct,contentWidth:dt,minimap:ft,viewportColumn:kt,isWordWrapMinified:yt,isViewportWrapping:pt,wrappingColumn:lt,verticalScrollbarWidth:ye,horizontalScrollbarHeight:Ie,overviewRuler:{top:Et,width:ye,height:$e-2*Et,right:0}}}}e.EditorLayoutInfoComputer=ae;class L extends n{constructor(){const Z={enabled:!0};super(51,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:_.localize(39,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:p(Z.enabled,this.defaultValue.enabled)}}}class N extends n{constructor(){const Z={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(120,"inlineHints",Z,{"editor.inlineHints.enabled":{type:"boolean",default:Z.enabled,description:_.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:Z.fontSize,description:_.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:Z.fontFamily,description:_.localize(42,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const _e=Z;return{enabled:p(_e.enabled,this.defaultValue.enabled),fontSize:s.clampedInt(_e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:v.string(_e.fontFamily,this.defaultValue.fontFamily)}}}class H extends s{constructor(){super(53,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:_.localize(43,null)})}compute(Z,_e,Me){return Z.fontInfo.lineHeight}}class O extends n{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(59,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:_.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[_.localize(45,null),_.localize(46,null),_.localize(47,null)],default:Z.size,description:_.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:_.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:_.localize(50,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:_.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:_.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:_.localize(53,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const _e=Z;return{enabled:p(_e.enabled,this.defaultValue.enabled),size:g(_e.size,this.defaultValue.size,["proportional","fill","fit"]),side:g(_e.side,this.defaultValue.side,["right","left"]),showSlider:g(_e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:p(_e.renderCharacters,this.defaultValue.renderCharacters),scale:s.clampedInt(_e.scale,1,1,3),maxColumn:s.clampedInt(_e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function K(V){return V==="ctrlCmd"?S.isMacintosh?"metaKey":"ctrlKey":"altKey"}class le extends n{constructor(){super(69,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(55,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const _e=Z;return{top:s.clampedInt(_e.top,0,0,1e3),bottom:s.clampedInt(_e.bottom,0,0,1e3)}}}class ue extends n{constructor(){const Z={enabled:!0,cycle:!1};super(70,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:_.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:_.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const _e=Z;return{enabled:p(_e.enabled,this.defaultValue.enabled),cycle:p(_e.cycle,this.defaultValue.cycle)}}}class pe extends A{constructor(){super(122)}compute(Z,_e,Me){return Z.pixelRatio}}class ve extends n{constructor(){const Z={other:!0,comments:!1,strings:!1};super(73,"quickSuggestions",Z,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Z.strings,description:_.localize(58,null)},comments:{type:"boolean",default:Z.comments,description:_.localize(59,null)},other:{type:"boolean",default:Z.other,description:_.localize(60,null)}}}],default:Z,description:_.localize(61,null)});this.defaultValue=Z}validate(Z){if(typeof Z=="boolean")return Z;if(Z&&typeof Z=="object"){const _e=Z,Me={other:p(_e.other,this.defaultValue.other),comments:p(_e.comments,this.defaultValue.comments),strings:p(_e.strings,this.defaultValue.strings)};return Me.other&&Me.comments&&Me.strings?!0:!Me.other&&!Me.comments&&!Me.strings?!1:Me}return this.defaultValue}}var Re;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(Re=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class He extends n{constructor(){super(54,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[_.localize(62,null),_.localize(63,null),_.localize(64,null),_.localize(65,null)],default:"on",description:_.localize(66,null)})}validate(Z){let _e=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof Z!="undefined"&&(typeof Z=="function"?(_e=4,Me=Z):Z==="interval"?_e=3:Z==="relative"?_e=2:Z==="on"?_e=1:_e=0),{renderType:_e,renderFn:Me}}}function Fe(V){const Z=V.get(82);return Z==="editable"?V.get(75):Z!=="on"}e.filterValidationDecorations=Fe;class ze extends n{constructor(){const Z=[],_e={type:"number",description:_.localize(67,null)};super(86,"rulers",Z,{type:"array",items:{anyOf:[_e,{type:["object"],properties:{column:_e,color:{type:"string",description:_.localize(68,null),format:"color-hex"}}}]},default:Z,description:_.localize(69,null)})}validate(Z){if(Array.isArray(Z)){let _e=[];for(let Me of Z)if(typeof Me=="number")_e.push({column:s.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const $e=Me;_e.push({column:s.clampedInt($e.column,0,0,1e4),color:$e.color})}return _e.sort((Me,$e)=>Me.column-$e.column),_e}return this.defaultValue}}function $(V,Z){if(typeof V!="string")return Z;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class G extends n{constructor(){super(87,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const _e=Z,Me=s.clampedInt(_e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),$e=s.clampedInt(_e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:s.clampedInt(_e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:$(_e.vertical,this.defaultValue.vertical),horizontal:$(_e.horizontal,this.defaultValue.horizontal),useShadows:p(_e.useShadows,this.defaultValue.useShadows),verticalHasArrows:p(_e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:p(_e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:p(_e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:p(_e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:s.clampedInt(_e.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:$e,verticalSliderSize:s.clampedInt(_e.verticalSliderSize,$e,0,1e3),scrollByPage:p(_e.scrollByPage,this.defaultValue.scrollByPage)}}}class te extends n{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(101,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[_.localize(70,null),_.localize(71,null)],default:Z.insertMode,description:_.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:_.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:_.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:_.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:_.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:_.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:_.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:_.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:_.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:_.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:_.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:_.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:_.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:_.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:_.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:_.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:_.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:_.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:_.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:_.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:_.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:_.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:_.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:_.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:_.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:_.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:_.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:_.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:_.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:_.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:_.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:_.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:_.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:_.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:_.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:_.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:_.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:_.localize(109,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const _e=Z;return{insertMode:g(_e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:p(_e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:p(_e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:p(_e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:p(_e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:p(_e.showIcons,this.defaultValue.showIcons),showStatusBar:p(_e.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:p(_e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:p(_e.showMethods,this.defaultValue.showMethods),showFunctions:p(_e.showFunctions,this.defaultValue.showFunctions),showConstructors:p(_e.showConstructors,this.defaultValue.showConstructors),showFields:p(_e.showFields,this.defaultValue.showFields),showVariables:p(_e.showVariables,this.defaultValue.showVariables),showClasses:p(_e.showClasses,this.defaultValue.showClasses),showStructs:p(_e.showStructs,this.defaultValue.showStructs),showInterfaces:p(_e.showInterfaces,this.defaultValue.showInterfaces),showModules:p(_e.showModules,this.defaultValue.showModules),showProperties:p(_e.showProperties,this.defaultValue.showProperties),showEvents:p(_e.showEvents,this.defaultValue.showEvents),showOperators:p(_e.showOperators,this.defaultValue.showOperators),showUnits:p(_e.showUnits,this.defaultValue.showUnits),showValues:p(_e.showValues,this.defaultValue.showValues),showConstants:p(_e.showConstants,this.defaultValue.showConstants),showEnums:p(_e.showEnums,this.defaultValue.showEnums),showEnumMembers:p(_e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:p(_e.showKeywords,this.defaultValue.showKeywords),showWords:p(_e.showWords,this.defaultValue.showWords),showColors:p(_e.showColors,this.defaultValue.showColors),showFiles:p(_e.showFiles,this.defaultValue.showFiles),showReferences:p(_e.showReferences,this.defaultValue.showReferences),showFolders:p(_e.showFolders,this.defaultValue.showFolders),showTypeParameters:p(_e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:p(_e.showSnippets,this.defaultValue.showSnippets),showUsers:p(_e.showUsers,this.defaultValue.showUsers),showIssues:p(_e.showIssues,this.defaultValue.showIssues)}}}class ie extends n{constructor(){super(97,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:_.localize(110,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:p(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class he extends A{constructor(){super(123,[75])}compute(Z,_e,Me){return _e.get(75)?!0:Z.tabFocusMode}}var De;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(De=e.WrappingIndent||(e.WrappingIndent={}));function Le(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class me extends A{constructor(){super(125,[124])}compute(Z,_e,Me){const $e=_e.get(124);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:$e.isWordWrapMinified,isViewportWrapping:$e.isViewportWrapping,wrappingColumn:$e.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",ke="Menlo, Monaco, 'Courier New', monospace",Ue="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:S.isMacintosh?ke:S.isLinux?Ue:Ce,fontWeight:"normal",fontSize:S.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function be(V){return e.editorOptionsRegistry[V.id]=V,V}var je;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingOvertype=6]="autoClosingOvertype",V[V.autoClosingQuotes=7]="autoClosingQuotes",V[V.autoIndent=8]="autoIndent",V[V.automaticLayout=9]="automaticLayout",V[V.autoSurround=10]="autoSurround",V[V.codeLens=11]="codeLens",V[V.codeLensFontFamily=12]="codeLensFontFamily",V[V.codeLensFontSize=13]="codeLensFontSize",V[V.colorDecorators=14]="colorDecorators",V[V.columnSelection=15]="columnSelection",V[V.comments=16]="comments",V[V.contextmenu=17]="contextmenu",V[V.copyWithSyntaxHighlighting=18]="copyWithSyntaxHighlighting",V[V.cursorBlinking=19]="cursorBlinking",V[V.cursorSmoothCaretAnimation=20]="cursorSmoothCaretAnimation",V[V.cursorStyle=21]="cursorStyle",V[V.cursorSurroundingLines=22]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=23]="cursorSurroundingLinesStyle",V[V.cursorWidth=24]="cursorWidth",V[V.disableLayerHinting=25]="disableLayerHinting",V[V.disableMonospaceOptimizations=26]="disableMonospaceOptimizations",V[V.dragAndDrop=27]="dragAndDrop",V[V.emptySelectionClipboard=28]="emptySelectionClipboard",V[V.extraEditorClassName=29]="extraEditorClassName",V[V.fastScrollSensitivity=30]="fastScrollSensitivity",V[V.find=31]="find",V[V.fixedOverflowWidgets=32]="fixedOverflowWidgets",V[V.folding=33]="folding",V[V.foldingStrategy=34]="foldingStrategy",V[V.foldingHighlight=35]="foldingHighlight",V[V.unfoldOnClickAfterEndOfLine=36]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=37]="fontFamily",V[V.fontInfo=38]="fontInfo",V[V.fontLigatures=39]="fontLigatures",V[V.fontSize=40]="fontSize",V[V.fontWeight=41]="fontWeight",V[V.formatOnPaste=42]="formatOnPaste",V[V.formatOnType=43]="formatOnType",V[V.glyphMargin=44]="glyphMargin",V[V.gotoLocation=45]="gotoLocation",V[V.hideCursorInOverviewRuler=46]="hideCursorInOverviewRuler",V[V.highlightActiveIndentGuide=47]="highlightActiveIndentGuide",V[V.hover=48]="hover",V[V.inDiffEditor=49]="inDiffEditor",V[V.letterSpacing=50]="letterSpacing",V[V.lightbulb=51]="lightbulb",V[V.lineDecorationsWidth=52]="lineDecorationsWidth",V[V.lineHeight=53]="lineHeight",V[V.lineNumbers=54]="lineNumbers",V[V.lineNumbersMinChars=55]="lineNumbersMinChars",V[V.linkedEditing=56]="linkedEditing",V[V.links=57]="links",V[V.matchBrackets=58]="matchBrackets",V[V.minimap=59]="minimap",V[V.mouseStyle=60]="mouseStyle",V[V.mouseWheelScrollSensitivity=61]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=62]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=63]="multiCursorMergeOverlapping",V[V.multiCursorModifier=64]="multiCursorModifier",V[V.multiCursorPaste=65]="multiCursorPaste",V[V.occurrencesHighlight=66]="occurrencesHighlight",V[V.overviewRulerBorder=67]="overviewRulerBorder",V[V.overviewRulerLanes=68]="overviewRulerLanes",V[V.padding=69]="padding",V[V.parameterHints=70]="parameterHints",V[V.peekWidgetDefaultFocus=71]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=72]="definitionLinkOpensInPeek",V[V.quickSuggestions=73]="quickSuggestions",V[V.quickSuggestionsDelay=74]="quickSuggestionsDelay",V[V.readOnly=75]="readOnly",V[V.renameOnType=76]="renameOnType",V[V.renderControlCharacters=77]="renderControlCharacters",V[V.renderIndentGuides=78]="renderIndentGuides",V[V.renderFinalNewline=79]="renderFinalNewline",V[V.renderLineHighlight=80]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=81]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=82]="renderValidationDecorations",V[V.renderWhitespace=83]="renderWhitespace",V[V.revealHorizontalRightPadding=84]="revealHorizontalRightPadding",V[V.roundedSelection=85]="roundedSelection",V[V.rulers=86]="rulers",V[V.scrollbar=87]="scrollbar",V[V.scrollBeyondLastColumn=88]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=89]="scrollBeyondLastLine",V[V.scrollPredominantAxis=90]="scrollPredominantAxis",V[V.selectionClipboard=91]="selectionClipboard",V[V.selectionHighlight=92]="selectionHighlight",V[V.selectOnLineNumbers=93]="selectOnLineNumbers",V[V.showFoldingControls=94]="showFoldingControls",V[V.showUnused=95]="showUnused",V[V.snippetSuggestions=96]="snippetSuggestions",V[V.smartSelect=97]="smartSelect",V[V.smoothScrolling=98]="smoothScrolling",V[V.stickyTabStops=99]="stickyTabStops",V[V.stopRenderingLineAfter=100]="stopRenderingLineAfter",V[V.suggest=101]="suggest",V[V.suggestFontSize=102]="suggestFontSize",V[V.suggestLineHeight=103]="suggestLineHeight",V[V.suggestOnTriggerCharacters=104]="suggestOnTriggerCharacters",V[V.suggestSelection=105]="suggestSelection",V[V.tabCompletion=106]="tabCompletion",V[V.tabIndex=107]="tabIndex",V[V.unusualLineTerminators=108]="unusualLineTerminators",V[V.useTabStops=109]="useTabStops",V[V.wordSeparators=110]="wordSeparators",V[V.wordWrap=111]="wordWrap",V[V.wordWrapBreakAfterCharacters=112]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=113]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=114]="wordWrapColumn",V[V.wordWrapOverride1=115]="wordWrapOverride1",V[V.wordWrapOverride2=116]="wordWrapOverride2",V[V.wrappingIndent=117]="wrappingIndent",V[V.wrappingStrategy=118]="wrappingStrategy",V[V.showDeprecated=119]="showDeprecated",V[V.inlineHints=120]="inlineHints",V[V.editorClassName=121]="editorClassName",V[V.pixelRatio=122]="pixelRatio",V[V.tabFocusMode=123]="tabFocusMode",V[V.layoutInfo=124]="layoutInfo",V[V.wrappingInfo=125]="wrappingInfo"})(je=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:be(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:_.localize(111,null)})),acceptSuggestionOnEnter:be(new b(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",_.localize(112,null),""],markdownDescription:_.localize(113,null)})),accessibilitySupport:be(new a),accessibilityPageSize:be(new s(3,"accessibilityPageSize",10,1,1073741824,{description:_.localize(114,null),deprecationMessage:_.localize(115,null)})),ariaLabel:be(new v(4,"ariaLabel",_.localize(116,null))),autoClosingBrackets:be(new b(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(117,null),_.localize(118,null),""],description:_.localize(119,null)})),autoClosingOvertype:be(new b(6,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",_.localize(120,null),""],description:_.localize(121,null)})),autoClosingQuotes:be(new b(7,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(122,null),_.localize(123,null),""],description:_.localize(124,null)})),autoIndent:be(new c(8,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[_.localize(125,null),_.localize(126,null),_.localize(127,null),_.localize(128,null),_.localize(129,null)],description:_.localize(130,null)})),automaticLayout:be(new f(9,"automaticLayout",!1)),autoSurround:be(new b(10,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[_.localize(131,null),_.localize(132,null),_.localize(133,null),""],description:_.localize(134,null)})),stickyTabStops:be(new f(99,"stickyTabStops",!1,{description:_.localize(135,null)})),codeLens:be(new f(11,"codeLens",!0,{description:_.localize(136,null)})),codeLensFontFamily:be(new v(12,"codeLensFontFamily","",{description:_.localize(137,null)})),codeLensFontSize:be(new s(13,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:_.localize(138,null)})),colorDecorators:be(new f(14,"colorDecorators",!0,{description:_.localize(139,null)})),columnSelection:be(new f(15,"columnSelection",!1,{description:_.localize(140,null)})),comments:be(new t),contextmenu:be(new f(17,"contextmenu",!0)),copyWithSyntaxHighlighting:be(new f(18,"copyWithSyntaxHighlighting",!0,{description:_.localize(141,null)})),cursorBlinking:be(new c(19,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:_.localize(142,null)})),cursorSmoothCaretAnimation:be(new f(20,"cursorSmoothCaretAnimation",!1,{description:_.localize(143,null)})),cursorStyle:be(new c(21,"cursorStyle",l.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],d,{description:_.localize(144,null)})),cursorSurroundingLines:be(new s(22,"cursorSurroundingLines",0,0,1073741824,{description:_.localize(145,null)})),cursorSurroundingLinesStyle:be(new b(23,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[_.localize(146,null),_.localize(147,null)],description:_.localize(148,null)})),cursorWidth:be(new s(24,"cursorWidth",0,0,1073741824,{markdownDescription:_.localize(149,null)})),disableLayerHinting:be(new f(25,"disableLayerHinting",!1)),disableMonospaceOptimizations:be(new f(26,"disableMonospaceOptimizations",!1)),dragAndDrop:be(new f(27,"dragAndDrop",!0,{description:_.localize(150,null)})),emptySelectionClipboard:be(new k),extraEditorClassName:be(new v(29,"extraEditorClassName","")),fastScrollSensitivity:be(new h(30,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:_.localize(151,null)})),find:be(new m),fixedOverflowWidgets:be(new f(32,"fixedOverflowWidgets",!1)),folding:be(new f(33,"folding",!0,{description:_.localize(152,null)})),foldingStrategy:be(new b(34,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[_.localize(153,null),_.localize(154,null)],description:_.localize(155,null)})),foldingHighlight:be(new f(35,"foldingHighlight",!0,{description:_.localize(156,null)})),unfoldOnClickAfterEndOfLine:be(new f(36,"unfoldOnClickAfterEndOfLine",!1,{description:_.localize(157,null)})),fontFamily:be(new v(37,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:_.localize(158,null)})),fontInfo:be(new R),fontLigatures2:be(new w),fontSize:be(new F),fontWeight:be(new B),formatOnPaste:be(new f(42,"formatOnPaste",!1,{description:_.localize(159,null)})),formatOnType:be(new f(43,"formatOnType",!1,{description:_.localize(160,null)})),glyphMargin:be(new f(44,"glyphMargin",!0,{description:_.localize(161,null)})),gotoLocation:be(new Q),hideCursorInOverviewRuler:be(new f(46,"hideCursorInOverviewRuler",!1,{description:_.localize(162,null)})),highlightActiveIndentGuide:be(new f(47,"highlightActiveIndentGuide",!0,{description:_.localize(163,null)})),hover:be(new J),inDiffEditor:be(new f(49,"inDiffEditor",!1)),letterSpacing:be(new h(50,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>h.clamp(V,-5,20),{description:_.localize(164,null)})),lightbulb:be(new L),lineDecorationsWidth:be(new I(52,"lineDecorationsWidth",10)),lineHeight:be(new H),lineNumbers:be(new He),lineNumbersMinChars:be(new s(55,"lineNumbersMinChars",5,1,300)),linkedEditing:be(new f(56,"linkedEditing",!1,{description:_.localize(165,null)})),links:be(new f(57,"links",!0,{description:_.localize(166,null)})),matchBrackets:be(new b(58,"matchBrackets","always",["always","near","never"],{description:_.localize(167,null)})),minimap:be(new O),mouseStyle:be(new b(60,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:be(new h(61,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:_.localize(168,null)})),mouseWheelZoom:be(new f(62,"mouseWheelZoom",!1,{markdownDescription:_.localize(169,null)})),multiCursorMergeOverlapping:be(new f(63,"multiCursorMergeOverlapping",!0,{description:_.localize(170,null)})),multiCursorModifier:be(new c(64,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],K,{markdownEnumDescriptions:[_.localize(171,null),_.localize(172,null)],markdownDescription:_.localize(173,null)})),multiCursorPaste:be(new b(65,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[_.localize(174,null),_.localize(175,null)],markdownDescription:_.localize(176,null)})),occurrencesHighlight:be(new f(66,"occurrencesHighlight",!0,{description:_.localize(177,null)})),overviewRulerBorder:be(new f(67,"overviewRulerBorder",!0,{description:_.localize(178,null)})),overviewRulerLanes:be(new s(68,"overviewRulerLanes",3,0,3)),padding:be(new le),parameterHints:be(new ue),peekWidgetDefaultFocus:be(new b(71,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[_.localize(179,null),_.localize(180,null)],description:_.localize(181,null)})),definitionLinkOpensInPeek:be(new f(72,"definitionLinkOpensInPeek",!1,{description:_.localize(182,null)})),quickSuggestions:be(new ve),quickSuggestionsDelay:be(new s(74,"quickSuggestionsDelay",10,0,1073741824,{description:_.localize(183,null)})),readOnly:be(new f(75,"readOnly",!1)),renameOnType:be(new f(76,"renameOnType",!1,{description:_.localize(184,null),markdownDeprecationMessage:_.localize(185,null)})),renderControlCharacters:be(new f(77,"renderControlCharacters",!1,{description:_.localize(186,null)})),renderIndentGuides:be(new f(78,"renderIndentGuides",!0,{description:_.localize(187,null)})),renderFinalNewline:be(new f(79,"renderFinalNewline",!0,{description:_.localize(188,null)})),renderLineHighlight:be(new b(80,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",_.localize(189,null)],description:_.localize(190,null)})),renderLineHighlightOnlyWhenFocus:be(new f(81,"renderLineHighlightOnlyWhenFocus",!1,{description:_.localize(191,null)})),renderValidationDecorations:be(new b(82,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:be(new b(83,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",_.localize(192,null),_.localize(193,null),_.localize(194,null),""],description:_.localize(195,null)})),revealHorizontalRightPadding:be(new s(84,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:be(new f(85,"roundedSelection",!0,{description:_.localize(196,null)})),rulers:be(new ze),scrollbar:be(new G),scrollBeyondLastColumn:be(new s(88,"scrollBeyondLastColumn",5,0,1073741824,{description:_.localize(197,null)})),scrollBeyondLastLine:be(new f(89,"scrollBeyondLastLine",!0,{description:_.localize(198,null)})),scrollPredominantAxis:be(new f(90,"scrollPredominantAxis",!0,{description:_.localize(199,null)})),selectionClipboard:be(new f(91,"selectionClipboard",!0,{description:_.localize(200,null),included:S.isLinux})),selectionHighlight:be(new f(92,"selectionHighlight",!0,{description:_.localize(201,null)})),selectOnLineNumbers:be(new f(93,"selectOnLineNumbers",!0)),showFoldingControls:be(new b(94,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[_.localize(202,null),_.localize(203,null)],description:_.localize(204,null)})),showUnused:be(new f(95,"showUnused",!0,{description:_.localize(205,null)})),showDeprecated:be(new f(119,"showDeprecated",!0,{description:_.localize(206,null)})),inlineHints:be(new N),snippetSuggestions:be(new b(96,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[_.localize(207,null),_.localize(208,null),_.localize(209,null),_.localize(210,null)],description:_.localize(211,null)})),smartSelect:be(new ie),smoothScrolling:be(new f(98,"smoothScrolling",!1,{description:_.localize(212,null)})),stopRenderingLineAfter:be(new s(100,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:be(new te),suggestFontSize:be(new s(102,"suggestFontSize",0,0,1e3,{markdownDescription:_.localize(213,null)})),suggestLineHeight:be(new s(103,"suggestLineHeight",0,0,1e3,{markdownDescription:_.localize(214,null)})),suggestOnTriggerCharacters:be(new f(104,"suggestOnTriggerCharacters",!0,{description:_.localize(215,null)})),suggestSelection:be(new b(105,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[_.localize(216,null),_.localize(217,null),_.localize(218,null)],description:_.localize(219,null)})),tabCompletion:be(new b(106,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[_.localize(220,null),_.localize(221,null),_.localize(222,null)],description:_.localize(223,null)})),tabIndex:be(new s(107,"tabIndex",0,-1,1073741824)),unusualLineTerminators:be(new b(108,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[_.localize(224,null),_.localize(225,null),_.localize(226,null)],description:_.localize(227,null)})),useTabStops:be(new f(109,"useTabStops",!0,{description:_.localize(228,null)})),wordSeparators:be(new v(110,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:_.localize(229,null)})),wordWrap:be(new b(111,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[_.localize(230,null),_.localize(231,null),_.localize(232,null),_.localize(233,null)],description:_.localize(234,null)})),wordWrapBreakAfterCharacters:be(new v(112,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:be(new v(113,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:be(new s(114,"wordWrapColumn",80,1,1073741824,{markdownDescription:_.localize(235,null)})),wordWrapOverride1:be(new b(115,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:be(new b(116,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:be(new c(117,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Le,{enumDescriptions:[_.localize(236,null),_.localize(237,null),_.localize(238,null),_.localize(239,null)],description:_.localize(240,null)})),wrappingStrategy:be(new b(118,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[_.localize(241,null),_.localize(242,null)],description:_.localize(243,null)})),editorClassName:be(new y),pixelRatio:be(new pe),tabFocusMode:be(new he),layoutInfo:be(new ae),wrappingInfo:be(new me)}}),define(we[121],Ee([17,18]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[122],Ee([17,18]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(we[123],Ee([17,18]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(we[124],Ee([17,18]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(we[125],Ee([17,18]),function(re,e){return re.create("vs/platform/workspaces/common/workspaces",e)}),define(we[126],Ee([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHost.api.impl",e)}),define(we[127],Ee([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[128],Ee([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(we[129],Ee([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[130],Ee([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(we[131],Ee([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[132],Ee([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[133],Ee([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[134],Ee([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[135],Ee([17,18]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(we[136],Ee([17,18]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[137],Ee([17,18]),function(re,e){return re.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[138],Ee([17,18]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[139],Ee([17,18]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[140],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var _;(function(E){E[E.ACTIVATE=0]="ACTIVATE",E[E.RESTORE=1]="RESTORE",E[E.PRESERVE=2]="PRESERVE"})(_=e.EditorActivation||(e.EditorActivation={}));var S;(function(E){E[E.PICK=1]="PICK",E[E.DISABLED=2]="DISABLED"})(S=e.EditorOverride||(e.EditorOverride={}));var T;(function(E){E[E.API=0]="API",E[E.USER=1]="USER"})(T=e.EditorOpenContext||(e.EditorOpenContext={}));var P;(function(E){E[E.Center=0]="Center",E[E.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",E[E.NearTop=2]="NearTop",E[E.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[86],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class _{constructor(P,E=[],C=!1){this.ctor=P,this.staticArguments=E,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=_;const S=(T,...P)=>new _(T,P);e.createSyncDescriptor=S}),define(we[62],Ee([0,1,86]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const S=[];function T(E,C,D){C instanceof _.SyncDescriptor||(C=new _.SyncDescriptor(C,[],D)),S.push([E,C])}e.registerSingleton=T;function P(){return S}e.getSingletonServiceDescriptors=P}),define(we[141],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class _{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=_;class S{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let E of this._nodes.values())E.outgoing.size===0&&P.push(E);return P}insertEdge(P,E){const C=this.lookupOrInsertNode(P),D=this.lookupOrInsertNode(E);C.outgoing.set(this._hashFn(E),D),D.incoming.set(this._hashFn(P),C)}removeNode(P){const E=this._hashFn(P);this._nodes.delete(E);for(let C of this._nodes.values())C.outgoing.delete(E),C.incoming.delete(E)}lookupOrInsertNode(P){const E=this._hashFn(P);let C=this._nodes.get(E);return C||(C=new _(P),this._nodes.set(E,C)),C}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[E,C]of this._nodes)P.push(`${E}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return P.join(`
`)}}e.Graph=S}),define(we[4],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var _;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function D(n){return n[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=D})(_=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function S(C,D,n,A){D[_.DI_TARGET]===D?D[_.DI_DEPENDENCIES].push({id:C,index:n,optional:A}):(D[_.DI_DEPENDENCIES]=[{id:C,index:n,optional:A}],D[_.DI_TARGET]=D)}function T(C){if(_.serviceIds.has(C))return _.serviceIds.get(C);const D=function(n,A,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");S(D,n,I,!1)};return D.toString=()=>C,_.serviceIds.set(C,D),D}e.createDecorator=T;function P(C){return C}e.refineServiceDecorator=P;function E(C){return function(D,n,A){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");S(C,D,A,!0)}}e.optional=E}),define(we[142],Ee([0,1,4]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,_.createDecorator)("modelService");function S(T){return!T.isTooLargeForSyncing()&&!T.isForSimpleWidget}e.shouldSynchronizeModel=S}),define(we[143],Ee([0,1,3,56,6,22,78,60,142]),function(re,e,_,S,T,P,E,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function n(p){return typeof p=="string"?!1:Array.isArray(p)?p.every(n):!!p.exclusive}class A{constructor(){this._clock=0,this._entries=[],this._onDidChange=new _.Emitter}get onDidChange(){return this._onDidChange.event}register(f,s){let h={selector:f,provider:s,_score:-1,_time:this._clock++};return this._entries.push(h),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,T.toDisposable)(()=>{if(h){let v=this._entries.indexOf(h);v>=0&&(this._entries.splice(v,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),h=void 0)}})}has(f){return this.all(f).length>0}all(f){if(!f)return[];this._updateScores(f);const s=[];for(let h of this._entries)h._score>0&&s.push(h.provider);return s}ordered(f){const s=[];return this._orderedForEach(f,h=>s.push(h.provider)),s}orderedGroups(f){const s=[];let h,v;return this._orderedForEach(f,g=>{h&&v===g._score?h.push(g.provider):(v=g._score,h=[g.provider],s.push(h))}),s}_orderedForEach(f,s){if(!!f){this._updateScores(f);for(const h of this._entries)h._score>0&&s(h)}}_updateScores(f){let s={uri:f.uri.toString(),language:f.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===s.language&&this._lastCandidate.uri===s.uri)){this._lastCandidate=s;for(let h of this._entries)if(h._score=(0,C.score)(h.selector,f.uri,f.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(f)),n(h.selector)&&h._score>0){for(let v of this._entries)v._score=0;h._score=1e3;break}this._entries.sort(A._compareByScoreAndTime)}}static _compareByScoreAndTime(f,s){return f._score<s._score?1:f._score>s._score?-1:f._time<s._time?1:f._time>s._time?-1:0}}e.LanguageFeatureRegistry=A;class I{constructor(f,s,h=Number.MAX_SAFE_INTEGER){this._registry=f,this.min=s,this.max=h,this._cache=new P.LRUCache(50,.7)}_key(f){return f.id+(0,S.hash)(this._registry.all(f))}_clamp(f){return f===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(f*1.3)))}get(f){const s=this._key(f),h=this._cache.get(s);return this._clamp(h==null?void 0:h.value)}update(f,s){const h=this._key(f);let v=this._cache.get(h);return v||(v=new E.MovingAverage,this._cache.set(h,v)),v.update(s),this.get(f)}}e.LanguageFeatureRequestDelays=I}),define(we[63],Ee([0,1,2,32,143,116,37]),function(re,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(m){m[m.Null=0]="Null",m[m.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class D{constructor(w,R){this.language=w,this.id=R}}e.LanguageIdentifier=D;var n;(function(m){m[m.NotSet=-1]="NotSet",m[m.None=0]="None",m[m.Italic=1]="Italic",m[m.Bold=2]="Bold",m[m.Underline=4]="Underline"})(n=e.FontStyle||(e.FontStyle={}));var A;(function(m){m[m.None=0]="None",m[m.DefaultForeground=1]="DefaultForeground",m[m.DefaultBackground=2]="DefaultBackground"})(A=e.ColorId||(e.ColorId={}));var I;(function(m){m[m.Other=0]="Other",m[m.Comment=1]="Comment",m[m.String=2]="String",m[m.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var p;(function(m){m[m.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",m[m.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",m[m.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",m[m.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",m[m.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",m[m.ITALIC_MASK=2048]="ITALIC_MASK",m[m.BOLD_MASK=4096]="BOLD_MASK",m[m.UNDERLINE_MASK=8192]="UNDERLINE_MASK",m[m.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",m[m.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",m[m.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",m[m.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",m[m.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",m[m.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",m[m.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",m[m.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",m[m.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",m[m.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(p=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(w){return(w&255)>>>0}static getTokenType(w){return(w&1792)>>>8}static getFontStyle(w){return(w&14336)>>>11}static getForeground(w){return(w&8372224)>>>14}static getBackground(w){return(w&4286578688)>>>23}static getClassNameFromMetadata(w){let R=this.getForeground(w),F="mtk"+R,B=this.getFontStyle(w);return B&1&&(F+=" mtki"),B&2&&(F+=" mtkb"),B&4&&(F+=" mtku"),F}static getInlineStyleFromMetadata(w,R){const F=this.getForeground(w),B=this.getFontStyle(w);let Q=`color: ${R[F]};`;return B&1&&(Q+="font-style: italic;"),B&2&&(Q+="font-weight: bold;"),B&4&&(Q+="text-decoration: underline;"),Q}}e.TokenMetadata=f;var s;(function(m){m[m.Method=0]="Method",m[m.Function=1]="Function",m[m.Constructor=2]="Constructor",m[m.Field=3]="Field",m[m.Variable=4]="Variable",m[m.Class=5]="Class",m[m.Struct=6]="Struct",m[m.Interface=7]="Interface",m[m.Module=8]="Module",m[m.Property=9]="Property",m[m.Event=10]="Event",m[m.Operator=11]="Operator",m[m.Unit=12]="Unit",m[m.Value=13]="Value",m[m.Constant=14]="Constant",m[m.Enum=15]="Enum",m[m.EnumMember=16]="EnumMember",m[m.Keyword=17]="Keyword",m[m.Text=18]="Text",m[m.Color=19]="Color",m[m.File=20]="File",m[m.Reference=21]="Reference",m[m.Customcolor=22]="Customcolor",m[m.Folder=23]="Folder",m[m.TypeParameter=24]="TypeParameter",m[m.User=25]="User",m[m.Issue=26]="Issue",m[m.Snippet=27]="Snippet"})(s=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let m=Object.create(null);return m[0]="symbol-method",m[1]="symbol-function",m[2]="symbol-constructor",m[3]="symbol-field",m[4]="symbol-variable",m[5]="symbol-class",m[6]="symbol-struct",m[7]="symbol-interface",m[8]="symbol-module",m[9]="symbol-property",m[10]="symbol-event",m[11]="symbol-operator",m[12]="symbol-unit",m[13]="symbol-value",m[14]="symbol-constant",m[15]="symbol-enum",m[16]="symbol-enum-member",m[17]="symbol-keyword",m[27]="symbol-snippet",m[18]="symbol-text",m[19]="symbol-color",m[20]="symbol-file",m[21]="symbol-reference",m[22]="symbol-customcolor",m[23]="symbol-folder",m[24]="symbol-type-parameter",m[25]="account",m[26]="issues",function(w){const R=m[w];let F=R&&E.iconRegistry.get(R);return F||(console.info("No codicon found for CompletionItemKind "+w),F=E.Codicon.symbolProperty),F.classNames}}(),e.completionKindFromString=function(){let m=Object.create(null);return m.method=0,m.function=1,m.constructor=2,m.field=3,m.variable=4,m.class=5,m.struct=6,m.interface=7,m.module=8,m.property=9,m.event=10,m.operator=11,m.unit=12,m.value=13,m.constant=14,m.enum=15,m["enum-member"]=16,m.enumMember=16,m.keyword=17,m.snippet=27,m.text=18,m.color=19,m.file=20,m.reference=21,m.customcolor=22,m.folder=23,m["type-parameter"]=24,m.typeParameter=24,m.account=25,m.issue=26,function(w,R){let F=m[w];return typeof F=="undefined"&&!R&&(F=9),F}}();var h;(function(m){m[m.Deprecated=1]="Deprecated"})(h=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(m){m[m.KeepWhitespace=1]="KeepWhitespace",m[m.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var g;(function(m){m[m.Invoke=0]="Invoke",m[m.TriggerCharacter=1]="TriggerCharacter",m[m.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(m){m[m.Auto=1]="Auto",m[m.Manual=2]="Manual"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var c;(function(m){m[m.Invoke=1]="Invoke",m[m.TriggerCharacter=2]="TriggerCharacter",m[m.ContentChange=3]="ContentChange"})(c=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var u;(function(m){m[m.Text=0]="Text",m[m.Read=1]="Read",m[m.Write=2]="Write"})(u=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function a(m){return m&&_.URI.isUri(m.uri)&&S.Range.isIRange(m.range)&&(S.Range.isIRange(m.originSelectionRange)||S.Range.isIRange(m.targetSelectionRange))}e.isLocationLink=a;var t;(function(m){m[m.File=0]="File",m[m.Module=1]="Module",m[m.Namespace=2]="Namespace",m[m.Package=3]="Package",m[m.Class=4]="Class",m[m.Method=5]="Method",m[m.Property=6]="Property",m[m.Field=7]="Field",m[m.Constructor=8]="Constructor",m[m.Enum=9]="Enum",m[m.Interface=10]="Interface",m[m.Function=11]="Function",m[m.Variable=12]="Variable",m[m.Constant=13]="Constant",m[m.String=14]="String",m[m.Number=15]="Number",m[m.Boolean=16]="Boolean",m[m.Array=17]="Array",m[m.Object=18]="Object",m[m.Key=19]="Key",m[m.Null=20]="Null",m[m.EnumMember=21]="EnumMember",m[m.Struct=22]="Struct",m[m.Event=23]="Event",m[m.Operator=24]="Operator",m[m.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var r;(function(m){m[m.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var o;(function(m){const w=new Map;w.set("file",0),w.set("module",1),w.set("namespace",2),w.set("package",3),w.set("class",4),w.set("method",5),w.set("property",6),w.set("field",7),w.set("constructor",8),w.set("enum",9),w.set("interface",10),w.set("function",11),w.set("variable",12),w.set("constant",13),w.set("string",14),w.set("number",15),w.set("boolean",16),w.set("array",17),w.set("object",18),w.set("key",19),w.set("null",20),w.set("enum-member",21),w.set("struct",22),w.set("event",23),w.set("operator",24),w.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function F(J){return w.get(J)}m.fromString=F;function B(J){return R.get(J)}m.toString=B;function Q(J,z){const ae=R.get(J);let L=ae&&E.iconRegistry.get("symbol-"+ae);return L||(console.info("No codicon found for SymbolKind "+J),L=E.Codicon.symbolProperty),`${z?"inline":"block"} ${L.classNames}`}m.toCssClassName=Q})(o=e.SymbolKinds||(e.SymbolKinds={}));class l{constructor(w){this.value=w}}e.FoldingRangeKind=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var i;(function(m){m[m.Collapsed=0]="Collapsed",m[m.Expanded=1]="Expanded"})(i=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(m){m[m.Editing=0]="Editing",m[m.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var y;(function(m){m[m.Other=0]="Other",m[m.Type=1]="Type",m[m.Parameter=2]="Parameter"})(y=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new T.LanguageFeatureRegistry,e.RenameProviderRegistry=new T.LanguageFeatureRegistry,e.CompletionProviderRegistry=new T.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new T.LanguageFeatureRegistry,e.HoverProviderRegistry=new T.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new T.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new T.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new T.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new T.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new T.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new T.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.LinkProviderRegistry=new T.LanguageFeatureRegistry,e.ColorProviderRegistry=new T.LanguageFeatureRegistry,e.SelectionRangeRegistry=new T.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.TokenizationRegistry=new P.TokenizationRegistryImpl;var k;(function(m){m[m.None=0]="None",m[m.Option=1]="Option",m[m.Default=2]="Default",m[m.Preferred=3]="Preferred"})(k=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[144],Ee([0,1,6,12,4,3,47,54]),function(re,e,_,S,T,P,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,T.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new P.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(D,n){if(!D)throw new Error("invalid command");if(typeof D=="string"){if(!n)throw new Error("invalid command");return this.registerCommand({id:D,handler:n})}if(D.description){const s=[];for(let v of D.description.args)s.push(v.constraint);const h=D.handler;D.handler=function(v,...g){return(0,S.validateConstraints)(g,s),h(v,...g)}}const{id:A}=D;let I=this._commands.get(A);I||(I=new E.LinkedList,this._commands.set(A,I));let p=I.unshift(D),f=(0,_.toDisposable)(()=>{p();const s=this._commands.get(A);(s==null?void 0:s.isEmpty())&&this._commands.delete(A)});return this._onDidRegisterCommand.fire(A),f}registerCommandAlias(D,n){return e.CommandsRegistry.registerCommand(D,(A,...I)=>A.get(e.ICommandService).executeCommand(n,...I))}getCommand(D){const n=this._commands.get(D);if(!(!n||n.isEmpty()))return C.Iterable.first(n)}getCommands(){const D=new Map;for(const n of this._commands.keys()){const A=this.getCommand(n);A&&D.set(n,A)}return D}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>_.Disposable.None,onDidExecuteCommand:()=>_.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(we[64],Ee([0,1,8,4,21]),function(re,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let P=T.userAgent||"";const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",T.isMacintosh),E.set("isLinux",T.isLinux),E.set("isWindows",T.isWindows),E.set("isWeb",T.isWeb),E.set("isMacNative",T.isMacintosh&&!T.isWeb),E.set("isEdge",P.indexOf("Edg/")>=0),E.set("isFirefox",P.indexOf("Firefox")>=0),E.set("isChrome",P.indexOf("Chrome")>=0),E.set("isSafari",P.indexOf("Safari")>=0),E.set("isIPad",P.indexOf("iPad")>=0);const C=Object.prototype.hasOwnProperty;var D;(function(m){m[m.False=0]="False",m[m.True=1]="True",m[m.Defined=2]="Defined",m[m.Not=3]="Not",m[m.Equals=4]="Equals",m[m.NotEquals=5]="NotEquals",m[m.And=6]="And",m[m.Regex=7]="Regex",m[m.NotRegex=8]="NotRegex",m[m.Or=9]="Or",m[m.In=10]="In",m[m.NotIn=11]="NotIn",m[m.Greater=12]="Greater",m[m.GreaterEquals=13]="GreaterEquals",m[m.Smaller=14]="Smaller",m[m.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class n{static false(){return I.INSTANCE}static true(){return p.INSTANCE}static has(w){return f.create(w)}static equals(w,R){return s.create(w,R)}static notEquals(w,R){return g.create(w,R)}static regex(w,R){return r.create(w,R)}static in(w,R){return h.create(w,R)}static not(w){return b.create(w)}static and(...w){return l.create(w)}static or(...w){return i.create(w)}static greater(w,R){return c.create(w,R)}static less(w,R){return a.create(w,R)}static deserialize(w,R=!1){if(!!w)return this._deserializeOrExpression(w,R)}static _deserializeOrExpression(w,R){let F=w.split("||");return i.create(F.map(B=>this._deserializeAndExpression(B,R)))}static _deserializeAndExpression(w,R){let F=w.split("&&");return l.create(F.map(B=>this._deserializeOne(B,R)))}static _deserializeOne(w,R){if(w=w.trim(),w.indexOf("!=")>=0){let F=w.split("!=");return g.create(F[0].trim(),this._deserializeValue(F[1],R))}if(w.indexOf("==")>=0){let F=w.split("==");return s.create(F[0].trim(),this._deserializeValue(F[1],R))}if(w.indexOf("=~")>=0){let F=w.split("=~");return r.create(F[0].trim(),this._deserializeRegexValue(F[1],R))}if(w.indexOf(" in ")>=0){let F=w.split(" in ");return h.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(w)){const F=w.split(">=");return u.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(w)){const F=w.split(">");return c.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(w)){const F=w.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(w)){const F=w.split("<");return a.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(w)?b.create(w.substr(1).trim()):f.create(w)}static _deserializeValue(w,R){if(w=w.trim(),w==="true")return!0;if(w==="false")return!1;let F=/^'([^']*)'$/.exec(w);return F?F[1].trim():w}static _deserializeRegexValue(w,R){if((0,_.isFalsyOrWhitespace)(w)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=w.indexOf("/"),B=w.lastIndexOf("/");if(F===B||F<0){if(R)throw new Error(`bad regexp-value '${w}', missing /-enclosure`);return console.warn(`bad regexp-value '${w}', missing /-enclosure`),null}let Q=w.slice(F+1,B),J=w[B+1]==="i"?"i":"";try{return new RegExp(Q,J)}catch(z){if(R)throw new Error(`bad regexp-value '${w}', parse error: ${z}`);return console.warn(`bad regexp-value '${w}', parse error: ${z}`),null}}}e.ContextKeyExpr=n;function A(m,w){return m.cmp(w)}class I{constructor(){this.type=0}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!1}serialize(){return"false"}keys(){return[]}map(w){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class p{constructor(){this.type=1}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!0}serialize(){return"true"}keys(){return[]}map(w){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class f{constructor(w){this.key=w,this.type=2}static create(w){const R=E.get(w);return typeof R=="boolean"?R?p.INSTANCE:I.INSTANCE:new f(w)}cmp(w){return w.type!==this.type?this.type-w.type:y(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!!w.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(w){return w.mapDefined(this.key)}negate(){return b.create(this.key)}}e.ContextKeyDefinedExpr=f;class s{constructor(w,R){this.key=w,this.value=R,this.type=4}static create(w,R){if(typeof R=="boolean")return R?f.create(w):b.create(w);const F=E.get(w);return typeof F=="boolean"?R===(F?"true":"false")?p.INSTANCE:I.INSTANCE:new s(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:k(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(w){return w.mapEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeyEqualsExpr=s;class h{constructor(w,R){this.key=w,this.valueKey=R,this.type=10}static create(w,R){return new h(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:k(this.key,this.valueKey,w.key,w.valueKey)}equals(w){return w.type===this.type?this.key===w.key&&this.valueKey===w.valueKey:!1}evaluate(w){const R=w.getValue(this.valueKey),F=w.getValue(this.key);return Array.isArray(R)?R.indexOf(F)>=0:typeof F=="string"&&typeof R=="object"&&R!==null?C.call(R,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(w){return w.mapIn(this.key,this.valueKey)}negate(){return v.create(this)}}e.ContextKeyInExpr=h;class v{constructor(w){this._actual=w,this.type=11}static create(w){return new v(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new v(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class g{constructor(w,R){this.key=w,this.value=R,this.type=5}static create(w,R){if(typeof R=="boolean")return R?b.create(w):f.create(w);const F=E.get(w);return typeof F=="boolean"?R===(F?"true":"false")?I.INSTANCE:p.INSTANCE:new g(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:k(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(w){return w.mapNotEquals(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=g;class b{constructor(w){this.key=w,this.type=3}static create(w){const R=E.get(w);return typeof R=="boolean"?R?I.INSTANCE:p.INSTANCE:new b(w)}cmp(w){return w.type!==this.type?this.type-w.type:y(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!w.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(w){return w.mapNot(this.key)}negate(){return f.create(this.key)}}e.ContextKeyNotExpr=b;class c{constructor(w,R){this.key=w,this.value=R,this.type=12}static create(w,R){return new c(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:k(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=c;class u{constructor(w,R){this.key=w,this.value=R,this.type=13}static create(w,R){return new u(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:k(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreaterEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=u;class a{constructor(w,R){this.key=w,this.value=R,this.type=14}static create(w,R){return new a(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:k(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmaller(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerExpr=a;class t{constructor(w,R){this.key=w,this.value=R,this.type=15}static create(w,R){return new t(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:k(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmallerEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(w,R){this.key=w,this.regexp=R,this.type=7}static create(w,R){return new r(w,R)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.key<w.key)return-1;if(this.key>w.key)return 1;const R=this.regexp?this.regexp.source:"",F=w.regexp?w.regexp.source:"";return R<F?-1:R>F?1:0}equals(w){if(w.type===this.type){const R=this.regexp?this.regexp.source:"",F=w.regexp?w.regexp.source:"";return this.key===w.key&&R===F}return!1}evaluate(w){let R=w.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const w=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${w}`}keys(){return[this.key]}map(w){return w.mapRegex(this.key,this.regexp)}negate(){return o.create(this)}}e.ContextKeyRegexExpr=r;class o{constructor(w){this._actual=w,this.type=8}static create(w){return new o(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new o(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;class l{constructor(w){this.expr=w,this.type=6}static create(w){return l._normalizeArr(w)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let R=0,F=this.expr.length;R<F;R++){const B=A(this.expr[R],w.expr[R]);if(B!==0)return B}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].equals(w.expr[R]))return!1;return!0}return!1}evaluate(w){for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].evaluate(w))return!1;return!0}static _normalizeArr(w){const R=[];let F=!1;for(const B of w)if(!!B){if(B.type===1){F=!0;continue}if(B.type===0)return I.INSTANCE;if(B.type===6){R.push(...B.expr);continue}R.push(B)}if(R.length===0&&F)return p.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(A);R.length>1;){const B=R[R.length-1];if(B.type!==9)break;R.pop();const Q=R.pop(),J=i.create(B.expr.map(z=>l.create([z,Q])));J&&(R.push(J),R.sort(A))}return R.length===1?R[0]:new l(R)}}serialize(){return this.expr.map(w=>w.serialize()).join(" && ")}keys(){const w=[];for(let R of this.expr)w.push(...R.keys());return w}map(w){return new l(this.expr.map(R=>R.map(w)))}negate(){let w=[];for(let R of this.expr)w.push(R.negate());return i.create(w)}}e.ContextKeyAndExpr=l;class i{constructor(w){this.expr=w,this.type=9}static create(w){const R=i._normalizeArr(w);if(R.length!==0)return R.length===1?R[0]:new i(R)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let R=0,F=this.expr.length;R<F;R++){const B=A(this.expr[R],w.expr[R]);if(B!==0)return B}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].equals(w.expr[R]))return!1;return!0}return!1}evaluate(w){for(let R=0,F=this.expr.length;R<F;R++)if(this.expr[R].evaluate(w))return!0;return!1}static _normalizeArr(w){let R=[],F=!1;if(w){for(let B=0,Q=w.length;B<Q;B++){const J=w[B];if(!!J){if(J.type===0){F=!0;continue}if(J.type===1)return[p.INSTANCE];if(J.type===9){R=R.concat(J.expr);continue}R.push(J)}}if(R.length===0&&F)return[I.INSTANCE];R.sort(A)}return R}serialize(){return this.expr.map(w=>w.serialize()).join(" || ")}keys(){const w=[];for(let R of this.expr)w.push(...R.keys());return w}map(w){return new i(this.expr.map(R=>R.map(w)))}negate(){let w=[];for(let F of this.expr)w.push(F.negate());const R=F=>F.type===9?F.expr:[F];for(;w.length>1;){const F=w.shift(),B=w.shift(),Q=[];for(const J of R(F))for(const z of R(B))Q.push(n.and(J,z));w.unshift(n.or(...Q))}return w[0]}}e.ContextKeyOrExpr=i;class d extends f{constructor(w,R,F){super(w);this.key=w,this._defaultValue=R,typeof F=="object"?d._info.push(Object.assign(Object.assign({},F),{key:w})):F!==!0&&d._info.push({key:w,description:F,type:R!=null?typeof R:void 0})}static all(){return d._info.values()}bindTo(w){return w.createKey(this.key,this._defaultValue)}getValue(w){return w.getContextKeyValue(this.key)}toNegated(){return n.not(this.key)}isEqualTo(w){return n.equals(this.key,w)}notEqualsTo(w){return n.notEquals(this.key,w)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,S.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function y(m,w){return m<w?-1:m>w?1:0}function k(m,w,R,F){return m<R?-1:m>R?1:w<F?-1:w>F?1:0}}),define(we[145],Ee([0,1,4]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,_.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,_.refineServiceDecorator)(e.IEnvironmentService)}),define(we[25],Ee([0,1,8,4]),function(re,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function T(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class E{constructor(A){this.value=A,this._lower=A.toLowerCase()}static equals(A,I){if(typeof A=="undefined"||A===null)return typeof I=="undefined"||I===null;if(typeof I=="undefined"||I===null)return!1;if(typeof A=="string"||typeof I=="string"){let p=typeof A=="string"?A:A.value,f=typeof I=="string"?I:I.value;return _.equalsIgnoreCase(p,f)}return A._lower===I._lower}static toKey(A){return typeof A=="string"?A.toLowerCase():A._lower}}e.ExtensionIdentifier=E;function C(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function D(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=D,e.IBuiltinExtensionsScannerService=(0,S.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[146],Ee([0,1,8,25]),function(re,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function T(f,s){return f.uuid&&s.uuid?f.uuid===s.uuid:f.id===s.id?!0:(0,_.compareIgnoreCase)(f.id,s.id)===0}e.areSameExtensions=T;class P{constructor(s,h){this.version=h,this.id=s.id,this.uuid=s.uuid}key(){return`${this.id}-${this.version}`}equals(s){return s instanceof P?T(this,s)&&this.version===s.version:!1}}e.ExtensionIdentifierWithVersion=P;function E(f,s){return`${f}.${s}`}e.getExtensionId=E;function C(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function D(f,s){return C(E(f,s))}e.getGalleryExtensionId=D;function n(f,s){const h=[],v=g=>{for(const b of h)if(b.some(c=>T(s(c),s(g))))return b;return null};for(const g of f){const b=v(g);b?b.push(g):h.push([g])}return h}e.groupByExtension=n;function A(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=A;function I(f){return Object.assign({id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0)},f.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new S.ExtensionIdentifier("pprice.better-merge");function p(f){const s=new Set;for(const h of f)h.malicious&&s.add(h.id.id);return s}e.getMaliciousExtensionsSet=p}),define(we[65],Ee([0,1,122,10,2,4,8,12,22]),function(re,e,_,S,T,P,E,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");var n;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var A;(function(F){F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash"})(A=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function I(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=I;function p(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=p;function f(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function s(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=s;var h;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",F.FileTooLarge="EntryTooLarge",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(h=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(B,Q){super(B);this.code=Q}}e.FileSystemProviderError=v;function g(F,B){const Q=new v(F.toString(),B);return c(Q,B),Q}e.createFileSystemProviderError=g;function b(F){return F||g((0,_.localize)(0,null),h.Unknown)}e.ensureFileSystemProviderError=b;function c(F,B){return F.name=B?`${B} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=c;function u(F){if(!F)return h.Unknown;if(F instanceof v)return F.code;const B=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!B)return h.Unknown;switch(B[1]){case h.FileExists:return h.FileExists;case h.FileIsADirectory:return h.FileIsADirectory;case h.FileNotADirectory:return h.FileNotADirectory;case h.FileNotFound:return h.FileNotFound;case h.FileExceedsMemoryLimit:return h.FileExceedsMemoryLimit;case h.FileTooLarge:return h.FileTooLarge;case h.NoPermissions:return h.NoPermissions;case h.Unavailable:return h.Unavailable}return h.Unknown}e.toFileSystemProviderErrorCode=u;function a(F){if(F instanceof d)return F.fileOperationResult;switch(u(F)){case h.FileNotFound:return 1;case h.FileIsADirectory:return 0;case h.FileNotADirectory:return 10;case h.NoPermissions:return 6;case h.FileExists:return 4;case h.FileExceedsMemoryLimit:return 9;case h.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var t;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class r{constructor(B,Q,J){this.resource=B,this.operation=Q,this.target=J}isOperation(B){return this.operation===B}}e.FileOperationEvent=r;var o;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class l{constructor(B,Q){this.ignorePathCasing=Q,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=B;for(const J of B)switch(J.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(J.resource,J);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(J.resource,J);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(J.resource,J);break}}contains(B,...Q){return this.doContains(B,{includeChildren:!1},...Q)}affects(B,...Q){return this.doContains(B,{includeChildren:!0},...Q)}doContains(B,Q,...J){var z,ae,L,N,H,O;if(!B)return!1;const K=J.length>0;return!!((!K||J.includes(1))&&(((z=this.added)===null||z===void 0?void 0:z.get(B))||Q.includeChildren&&((ae=this.added)===null||ae===void 0?void 0:ae.findSuperstr(B)))||(!K||J.includes(0))&&(((L=this.updated)===null||L===void 0?void 0:L.get(B))||Q.includeChildren&&((N=this.updated)===null||N===void 0?void 0:N.findSuperstr(B)))||(!K||J.includes(2))&&(((H=this.deleted)===null||H===void 0?void 0:H.findSubstr(B))||Q.includeChildren&&((O=this.deleted)===null||O===void 0?void 0:O.findSuperstr(B))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(B){const Q=[],J=B===1?this.added:B===0?this.updated:this.deleted;if(J)for(const[,z]of J)Q.push(z);return Q}filter(B){return new l(this.changes.filter(Q=>B(Q)),this.ignorePathCasing)}}e.FileChangesEvent=l;function i(F,B,Q){return!F||!B||F===B||B.length>F.length?!1:(B.charAt(B.length-1)!==S.sep&&(B+=S.sep),Q?(0,E.startsWithIgnoreCase)(F,B):F.indexOf(B)===0)}e.isParent=i;class d extends Error{constructor(B,Q,J){super(B);this.fileOperationResult=Q,this.options=J}static isFileOperationError(B){return B instanceof Error&&!(0,C.isUndefinedOrNull)(B.fileOperationResult)}}e.FileOperationError=d;var y;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_READ_ONLY=5]="FILE_READ_ONLY",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",F[F.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(y=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var k;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(k=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function m(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=m;async function w(F,B){if(!B.canHandleResource(T.URI.from({scheme:F.scheme})))return new Promise(Q=>{const J=B.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===F.scheme&&z.added&&(J.dispose(),Q())})})}e.whenProviderRegistered=w,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class R{static formatSize(B){return(0,C.isNumber)(B)||(B=0),B<R.KB?(0,_.localize)(1,null,B.toFixed(0)):B<R.MB?(0,_.localize)(2,null,(B/R.KB).toFixed(2)):B<R.GB?(0,_.localize)(3,null,(B/R.MB).toFixed(2)):B<R.TB?(0,_.localize)(4,null,(B/R.GB).toFixed(2)):(0,_.localize)(5,null,(B/R.TB).toFixed(2))}}e.ByteSize=R,R.KB=1024,R.MB=R.KB*R.KB,R.GB=R.MB*R.KB,R.TB=R.GB*R.KB}),define(we[66],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class _{constructor(...T){this._entries=new Map;for(let[P,E]of T)this.set(P,E)}set(T,P){const E=this._entries.get(T);return this._entries.set(T,P),E}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=_}),define(we[147],Ee([0,1,11,141,86,4,66,15]),function(re,e,_,S,T,P,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class n extends Error{constructor(s){super("cyclic dependency between services");this.message=s.toString()}}class A{constructor(s=new E.ServiceCollection,h=!1,v){this._activeInstantiations=new Set,this._services=s,this._strict=h,this._parent=v,this._services.set(P.IInstantiationService,this)}createChild(s){return new A(s,this._strict,this)}invokeFunction(s,...h){let v=p.traceInvocation(s),g=!1;try{return s({get:(c,u)=>{if(g)throw(0,_.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(c,v);if(!a&&u!==P.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return a}},...h)}finally{g=!0,v.stop()}}createInstance(s,...h){let v,g;return s instanceof T.SyncDescriptor?(v=p.traceCreation(s.ctor),g=this._createInstance(s.ctor,s.staticArguments.concat(h),v)):(v=p.traceCreation(s),g=this._createInstance(s,h,v)),v.stop(),g}_createInstance(s,h=[],v){let g=P._util.getServiceDependencies(s).sort((u,a)=>u.index-a.index),b=[];for(const u of g){let a=this._getOrCreateServiceInstance(u.id,v);if(!a&&this._strict&&!u.optional)throw new Error(`[createInstance] ${s.name} depends on UNKNOWN service ${u.id}.`);b.push(a)}let c=g.length>0?g[0].index:h.length;if(h.length!==c){console.warn(`[createInstance] First service dependency of ${s.name} at position ${c+1} conflicts with ${h.length} static arguments`);let u=c-h.length;u>0?h=h.concat(new Array(u)):h=h.slice(0,c)}return new s(...[...h,...b])}_setServiceInstance(s,h){if(this._services.get(s)instanceof T.SyncDescriptor)this._services.set(s,h);else if(this._parent)this._parent._setServiceInstance(s,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){let h=this._services.get(s);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):h}_getOrCreateServiceInstance(s,h){let v=this._getServiceInstanceOrDescriptor(s);return v instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,v,h.branch(s,!0)):(h.branch(s,!1),v)}_safeCreateAndCacheServiceInstance(s,h,v){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,h,v)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,h,v){const g=new S.Graph(u=>u.id.toString());let b=0;const c=[{id:s,desc:h,_trace:v}];for(;c.length;){const u=c.pop();if(g.lookupOrInsertNode(u),b++>1e3)throw new n(g);for(let a of P._util.getServiceDependencies(u.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${s} depends on ${a.id} which is NOT registered.`),t instanceof T.SyncDescriptor){const r={id:a.id,desc:t,_trace:u._trace.branch(a.id,!0)};g.insertEdge(u,r),c.push(r)}}}for(;;){const u=g.roots();if(u.length===0){if(!g.isEmpty())throw new n(g);break}for(const{data:a}of u){if(this._getServiceInstanceOrDescriptor(a.id)instanceof T.SyncDescriptor){const r=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,r)}g.removeNode(a)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,h,v=[],g,b){if(this._services.get(s)instanceof T.SyncDescriptor)return this._createServiceInstance(h,v,g,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,h,v,g,b);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(s,h=[],v,g){if(v){const b=new C.IdleValue(()=>this._createInstance(s,h,g));return new Proxy(Object.create(null),{get(c,u){if(u in c)return c[u];let a=b.value,t=a[u];return typeof t!="function"||(t=t.bind(a),c[u]=t),t},set(c,u,a){return b.value[u]=a,!0}})}else return this._createInstance(s,h,g)}}e.InstantiationService=A;var I;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(I||(I={}));class p{constructor(s,h){this.type=s,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(s){return D?new p(1,s.name||s.toString().substring(0,42).replace(/\n/g,"")):p._None}static traceCreation(s){return D?new p(0,s.name):p._None}branch(s,h){let v=new p(2,s.toString());return this._dep.push([s,h,v]),v}stop(){let s=Date.now()-this._start;p._totals+=s;let h=!1;function v(b,c){let u=[],a=new Array(b+1).join("	");for(const[t,r,o]of c._dep)if(r&&o){h=!0,u.push(`${a}CREATES -> ${t}`);let l=v(b+1,o);l&&u.push(l)}else u.push(`${a}uses -> ${t}`);return u.join(`
`)}let g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(s>2||h)&&console.log(g.join(`
`))}}p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(we[19],Ee([0,1,4,6,21,3,61]),function(re,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function C(){return new Date().toISOString()}var D;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class n extends S.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=n;class A extends n{constructor(a){super();this.logAlways=a}checkLogLevel(a){return this.logAlways||this.getLevel()<=a}trace(a,...t){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([a,...t]))}debug(a,...t){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([a,...t]))}info(a,...t){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([a,...t]))}warn(a,...t){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([a,...t]))}error(a,...t){if(this.checkLogLevel(D.Error))if(a instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=a.stack,this.log(D.Error,this.format(r))}else this.log(D.Error,this.format([a,...t]))}critical(a,...t){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([a,...t]))}flush(){}format(a){let t="";for(let r=0;r<a.length;r++){let o=a[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch(l){}t+=(r>0?" ":"")+o}return t}}e.AbstractMessageLogger=A;class I extends n{constructor(a=e.DEFAULT_LOG_LEVEL){super();this.setLevel(a),this.useColors=!T.isWindows}trace(a,...t){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,a,...t):console.log(`[main ${C()}]`,a,...t))}debug(a,...t){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,a,...t):console.log(`[main ${C()}]`,a,...t))}info(a,...t){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,a,...t):console.log(`[main ${C()}]`,a,...t))}warn(a,...t){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,a,...t):console.warn(`[main ${C()}]`,a,...t))}error(a,...t){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,a,...t):console.error(`[main ${C()}]`,a,...t))}critical(a,...t){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,a,...t):console.error(`[main ${C()}]`,a,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class p extends n{constructor(a=e.DEFAULT_LOG_LEVEL){super();this.setLevel(a)}trace(a,...t){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",a,...t)}debug(a,...t){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...t)}info(a,...t){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",a,...t)}warn(a,...t){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",a,...t)}error(a,...t){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",a,...t)}critical(a,...t){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",a,...t)}dispose(){}flush(){}}e.ConsoleLogger=p;class f extends n{constructor(a,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=a,this.setLevel(t)}trace(a,...t){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(a),...t])}debug(a,...t){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(a),...t])}info(a,...t){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(a),...t])}warn(a,...t){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(a),...t])}error(a,...t){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(a),...t])}critical(a,...t){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(a),...t])}extractMessage(a){return typeof a=="string"?a:(0,E.toErrorMessage)(a,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class s extends n{constructor(a){super();this.logServices=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const t of this.logServices)t.setLevel(a);super.setLevel(a)}trace(a,...t){for(const r of this.logServices)r.trace(a,...t)}debug(a,...t){for(const r of this.logServices)r.debug(a,...t)}info(a,...t){for(const r of this.logServices)r.info(a,...t)}warn(a,...t){for(const r of this.logServices)r.warn(a,...t)}error(a,...t){for(const r of this.logServices)r.error(a,...t)}critical(a,...t){for(const r of this.logServices)r.critical(a,...t)}flush(){for(const a of this.logServices)a.flush()}dispose(){for(const a of this.logServices)a.dispose()}}e.MultiplexLogService=s;class h extends S.Disposable{constructor(a){super();this.logger=a,this._register(a)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(a){this.logger.setLevel(a)}getLevel(){return this.logger.getLevel()}trace(a,...t){this.logger.trace(a,...t)}debug(a,...t){this.logger.debug(a,...t)}info(a,...t){this.logger.info(a,...t)}warn(a,...t){this.logger.warn(a,...t)}error(a,...t){this.logger.error(a,...t)}critical(a,...t){this.logger.critical(a,...t)}flush(){this.logger.flush()}}e.LogService=h;class v{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(a){}getLevel(){return D.Info}trace(a,...t){}debug(a,...t){}info(a,...t){}warn(a,...t){}error(a,...t){}critical(a,...t){}dispose(){}flush(){}}e.NullLogService=v;function g(u){if(u.verbose)return D.Trace;if(typeof u.logLevel=="string"){const a=b(u.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=g;function b(u){switch(u){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=b;function c(u){switch(u){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=c}),define(we[87],Ee([0,1,4,123,57]),function(re,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var E;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(E=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function n(s,h){return h-s}D.compare=n;const A=Object.create(null);A[D.Error]=(0,S.localize)(0,null),A[D.Warning]=(0,S.localize)(1,null),A[D.Info]=(0,S.localize)(2,null);function I(s){return A[s]||""}D.toString=I;function p(s){switch(s){case T.default.Error:return D.Error;case T.default.Warning:return D.Warning;case T.default.Info:return D.Info;case T.default.Ignore:return D.Hint}}D.fromSeverity=p;function f(s){switch(s){case D.Error:return T.default.Error;case D.Warning:return T.default.Warning;case D.Info:return T.default.Info;case D.Hint:return T.default.Ignore}}D.toSeverity=f}(E=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(D){const n="";function A(p){return I(p,!0)}D.makeKey=A;function I(p,f){let s=[n];return p.source?s.push(p.source.replace("\xA6","\\\xA6")):s.push(n),p.code?typeof p.code=="string"?s.push(p.code.replace("\xA6","\\\xA6")):s.push(p.code.value.replace("\xA6","\\\xA6")):s.push(n),p.severity!==void 0&&p.severity!==null?s.push(E.toString(p.severity)):s.push(n),p.message&&f?s.push(p.message.replace("\xA6","\\\xA6")):s.push(n),p.startLineNumber!==void 0&&p.startLineNumber!==null?s.push(p.startLineNumber.toString()):s.push(n),p.startColumn!==void 0&&p.startColumn!==null?s.push(p.startColumn.toString()):s.push(n),p.endLineNumber!==void 0&&p.endLineNumber!==null?s.push(p.endLineNumber.toString()):s.push(n),p.endColumn!==void 0&&p.endColumn!==null?s.push(p.endColumn.toString()):s.push(n),s.push(n),s.join("\xA6")}D.makeKeyOptionalMessage=I})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(we[148],Ee([0,1,57,4,3]),function(re,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=_.default,e.INotificationService=(0,S.createDecorator)("notificationService");var P;(function(n){n[n.WORKSPACE=0]="WORKSPACE",n[n.GLOBAL=1]="GLOBAL"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var E;(function(n){n[n.OFF=0]="OFF",n[n.SILENT=1]="SILENT",n[n.ERROR=2]="ERROR"})(E=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new D,this.onDidClose=T.Event.None,this.onDidChangeVisibility=T.Event.None}updateSeverity(A){}updateMessage(A){}updateActions(A){}close(){}}e.NoOpNotification=C;class D{infinite(){}done(){}total(A){}worked(A){}}e.NoOpProgress=D}),define(we[149],Ee([0,1,4,20,6]),function(re,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,_.createDecorator)("progressService");var P;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(P=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class E{constructor(n){this.callback=n}get value(){return this._value}report(n){this._value=n,this.callback(this._value)}}e.Progress=E,E.None=Object.freeze({report(){}});class C extends T.Disposable{constructor(n){super();this.progressIndicator=n,this.currentOperationId=0,this.currentOperationDisposables=this._register(new T.DisposableStore)}start(n){this.stop();const A=++this.currentOperationId,I=new S.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{A===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},n),this.currentOperationDisposables.add((0,T.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,T.toDisposable)(()=>I.cancel())),this.currentOperationDisposables.add((0,T.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:A,token:I.token,stop:()=>this.doStop(A),isCurrent:()=>this.currentOperationId===A}}stop(){this.doStop(this.currentOperationId)}doStop(n){this.currentOperationId===n&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,_.createDecorator)("editorProgressService")}),define(we[30],Ee([0,1,12,44]),function(re,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(E,C){S.ok(_.isString(E)),S.ok(_.isObject(C)),S.ok(!this.data.has(E),"There is already an extension with this id"),this.data.set(E,C)}knows(E){return this.data.has(E)}as(E){return this.data.get(E)||null}}e.Registry=new T}),define(we[88],Ee([0,1,30,3]),function(re,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class P{constructor(){this._onDidChangeSchema=new S.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,n){this.schemasById[T(D)]=n,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const E=new P;_.Registry.add(e.Extensions.JSONContribution,E)}),define(we[67],Ee([0,1,121,3,30,12,88]),function(re,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const D=T.Registry.as(E.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new S.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new S.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(g,b=!0){this.registerConfigurations([g],b)}registerConfigurations(g,b=!0){const c=[];g.forEach(u=>{c.push(...this.validateAndRegisterProperties(u,b)),this.configurationContributors.push(u),this.registerJSONConfiguration(u)}),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(g){const b=[],c=u=>{if(u.properties)for(const a in u.properties)b.push(a),delete this.configurationProperties[a],this.removeFromSchema(a,u.properties[a]);u.allOf&&u.allOf.forEach(a=>c(a))};for(const u of g){c(u);const a=this.configurationContributors.indexOf(u);a!==-1&&this.configurationContributors.splice(a,1)}D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}registerDefaultConfigurations(g){const b=[],c=[];for(const u of g)for(const a in u)if(b.push(a),e.OVERRIDE_PROPERTY_PATTERN.test(a)){this.defaultValues[a]=Object.assign(Object.assign({},this.defaultValues[a]||{}),u[a]);const t={type:"object",default:this.defaultValues[a],description:_.localize(1,null,a),$ref:e.resourceLanguageSettingsSchemaId};c.push(I(a)),this.configurationProperties[a]=t,this.defaultLanguageConfigurationOverridesNode.properties[a]=t}else{this.defaultValues[a]=u[a];const t=this.configurationProperties[a];t&&(this.updatePropertyDefaultValue(a,t),this.updateSchema(a,t))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}deregisterDefaultConfigurations(g){const b=[];for(const c of g)for(const u in c)if(b.push(u),delete this.defaultValues[u],e.OVERRIDE_PROPERTY_PATTERN.test(u))delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u];else{const a=this.configurationProperties[u];a&&(this.updatePropertyDefaultValue(u,a),this.updateSchema(u,a))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}notifyConfigurationSchemaUpdated(...g){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(g){for(const b of g)this.overrideIdentifiers.add(b);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(g,b=!0,c=3){c=P.isUndefinedOrNull(g.scope)?c:g.scope;let u=[],a=g.properties;if(a)for(let r in a){if(b&&s(r)){delete a[r];continue}const o=a[r];if(this.updatePropertyDefaultValue(r,o),e.OVERRIDE_PROPERTY_PATTERN.test(r)?o.scope=void 0:o.scope=P.isUndefinedOrNull(o.scope)?c:o.scope,a[r].hasOwnProperty("included")&&!a[r].included){this.excludedConfigurationProperties[r]=a[r],delete a[r];continue}else this.configurationProperties[r]=a[r];!a[r].deprecationMessage&&a[r].markdownDeprecationMessage&&(a[r].deprecationMessage=a[r].markdownDeprecationMessage),u.push(r)}let t=g.allOf;if(t)for(let r of t)u.push(...this.validateAndRegisterProperties(r,b,c));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(g){const b=c=>{let u=c.properties;if(u)for(const t in u)this.updateSchema(t,u[t]);let a=c.allOf;a&&a.forEach(b)};b(g)}updateSchema(g,b){switch(e.allSettings.properties[g]=b,b.scope){case 1:e.applicationSettings.properties[g]=b;break;case 2:e.machineSettings.properties[g]=b;break;case 6:e.machineOverridableSettings.properties[g]=b;break;case 3:e.windowSettings.properties[g]=b;break;case 4:e.resourceSettings.properties[g]=b;break;case 5:e.resourceSettings.properties[g]=b,this.resourceLanguageSettingsSchema.properties[g]=b;break}}removeFromSchema(g,b){switch(delete e.allSettings.properties[g],b.scope){case 1:delete e.applicationSettings.properties[g];break;case 2:delete e.machineSettings.properties[g];break;case 6:delete e.machineOverridableSettings.properties[g];break;case 3:delete e.windowSettings.properties[g];break;case 4:case 5:delete e.resourceSettings.properties[g];break}}updateOverridePropertyPatternKey(){for(const g of this.overrideIdentifiers.values()){const b=`[${g}]`,c={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(b,c),e.allSettings.properties[b]=c,e.applicationSettings.properties[b]=c,e.machineSettings.properties[b]=c,e.machineOverridableSettings.properties[b]=c,e.windowSettings.properties[b]=c,e.resourceSettings.properties[b]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(g,b){let c=this.defaultValues[g];P.isUndefined(c)&&(c=b.default),P.isUndefined(c)&&(c=p(b.type)),b.default=c}}const A="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(A);function I(v){return v.substring(1,v.length-1)}e.overrideIdentifierFromKey=I;function p(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const f=new n;T.Registry.add(e.Extensions.Configuration,f);function s(v){return v.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(v)?_.localize(5,null,v):f.getConfigurationProperties()[v]!==void 0?_.localize(6,null,v):null:_.localize(4,null)}e.validateProperty=s;function h(){const v=[],g=f.getConfigurationProperties();for(const b of Object.keys(g))v.push([b,g[b].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=h}),define(we[89],Ee([0,1,24,12,2,30,4,67]),function(re,e,_,S,T,P,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,E.createDecorator)("configurationService");function D(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof T.URI)}e.isConfigurationOverrides=D;var n;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(n=e.ConfigurationTarget||(e.ConfigurationTarget={}));function A(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=A;function I(r,o){const l=o?r?o.keys.filter(R=>r.keys.indexOf(R)===-1):[...o.keys]:[],i=r?o?r.keys.filter(R=>o.keys.indexOf(R)===-1):[...r.keys]:[],d=[];if(o&&r){for(const R of r.keys)if(o.keys.indexOf(R)!==-1){const F=g(r.contents,R),B=g(o.contents,R);_.equals(F,B)||d.push(R)}}const y=[],k=R=>{const F={};for(const B of R)for(const Q of B.identifiers)F[a(Q)]=B;return F},m=o?k(o.overrides):{},w=r?k(r.overrides):{};if(Object.keys(m).length)for(const R of l){const F=m[R];F&&y.push([(0,C.overrideIdentifierFromKey)(R),F.keys])}if(Object.keys(w).length)for(const R of i){const F=w[R];F&&y.push([(0,C.overrideIdentifierFromKey)(R),F.keys])}if(Object.keys(m).length&&Object.keys(w).length)for(const R of d){const F=w[R],B=m[R];if(F&&B){const Q=I({contents:F.contents,keys:F.keys,overrides:[]},{contents:B.contents,keys:B.keys,overrides:[]});y.push([(0,C.overrideIdentifierFromKey)(R),[...Q.added,...Q.removed,...Q.updated]])}}return{added:l,removed:i,updated:d,overrides:y}}e.compare=I;function p(r,o){const l=[];for(const i of Object.keys(r))if(C.OVERRIDE_PROPERTY_PATTERN.test(i)){const d={};for(const y in r[i])d[y]=r[i][y];l.push({identifiers:[(0,C.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(d),contents:f(d,o)})}return l}e.toOverrides=p;function f(r,o){const l=Object.create(null);for(let i in r)s(l,i,r[i],o);return l}e.toValuesTree=f;function s(r,o,l,i){const d=o.split("."),y=d.pop();let k=r;for(let m=0;m<d.length;m++){let w=d[m],R=k[w];switch(typeof R){case"undefined":R=k[w]=Object.create(null);break;case"object":break;default:i(`Ignoring ${o} as ${d.slice(0,m+1).join(".")} is ${JSON.stringify(R)}`);return}k=R}if(typeof k=="object"&&k!==null)try{k[y]=l}catch(m){i(`Ignoring ${o} as ${d.join(".")} is ${JSON.stringify(k)}`)}else i(`Ignoring ${o} as ${d.join(".")} is ${JSON.stringify(k)}`)}e.addToValueTree=s;function h(r,o){const l=o.split(".");v(r,l)}e.removeFromValueTree=h;function v(r,o){const l=o.shift();if(o.length===0){delete r[l];return}if(Object.keys(r).indexOf(l)!==-1){const i=r[l];typeof i=="object"&&!Array.isArray(i)&&(v(i,o),Object.keys(i).length===0&&delete r[l])}}function g(r,o,l){function i(k,m){let w=k;for(const R of m){if(typeof w!="object"||w===null)return;w=w[R]}return w}const d=o.split("."),y=i(r,d);return typeof y=="undefined"?l:y}e.getConfigurationValue=g;function b(r,o,l){Object.keys(o).forEach(i=>{i!=="__proto__"&&(i in r?S.isObject(r[i])&&S.isObject(o[i])?b(r[i],o[i],l):l&&(r[i]=o[i]):r[i]=o[i])})}e.merge=b;function c(){const r=P.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=c;function u(){const r=Object.create(null),o=P.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let l in o){let i=o[l].default;s(r,l,i,d=>console.error(`Conflict in default settings: ${d}`))}return r}e.getDefaultValues=u;function a(r){return`[${r}]`}e.keyFromOverrideIdentifier=a;function t(r,o,l){const i=r.inspect(o),d=r.inspect(l);return typeof i.userValue!="undefined"||typeof i.workspaceValue!="undefined"||typeof i.workspaceFolderValue!="undefined"?i.value:typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:i.defaultValue}e.getMigratedSettingValue=t}),define(we[150],Ee([0,1,46,22,14,12,24,2,67,89,30,6,3]),function(re,e,_,S,T,P,E,C,D,n,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},r=[],o=[]){this._contents=t,this._keys=r,this._overrides=o,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const o=this.getContentsForOverrideIdentifer(r);return o?t?(0,n.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let o={};for(const l of T.distinct([...Object.keys(this.contents),...Object.keys(r)])){let i=this.contents[l],d=r[l];d&&(typeof i=="object"&&typeof d=="object"?(i=E.deepClone(i),this.mergeContents(i,d)):i=d),o[l]=i}return new f(o,this.keys,this.overrides)}merge(...t){const r=E.deepClone(this.contents),o=E.deepClone(this.overrides),l=[...this.keys];for(const i of t){this.mergeContents(r,i.contents);for(const d of i.overrides){const[y]=o.filter(k=>T.equals(k.identifiers,d.identifiers));y?this.mergeContents(y.contents,d.contents):o.push(E.deepClone(d))}for(const d of i.keys)l.indexOf(d)===-1&&l.push(d)}return new f(r,l,o)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const o of Object.keys(r)){if(o in t&&P.isObject(t[o])&&P.isObject(r[o])){this.mergeContents(t[o],r[o]);continue}t[o]=E.deepClone(r[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?E.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,n.addToValueTree)(this.contents,t,r,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let o=0;o<r;o++)t.indexOf(this.keys[o])===0&&(r=o);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=f;class s extends f{constructor(){const t=(0,n.getDefaultValues)(),r=(0,n.getConfigurationKeys)(),o=[];for(const l of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(l)&&o.push({identifiers:[(0,D.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(t[l]),contents:(0,n.toValuesTree)(t[l],i=>console.error(`Conflict in default settings file: ${i}`))});super(t,r,o)}}e.DefaultConfigurationModel=s;class h{constructor(t,r){this._name=t,this._scopes=r,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get errors(){return this._parseErrors}parseContent(t){if(!P.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r)}}parseRaw(t){this._raw=t;const r=this.doParseRaw(t);this._configurationModel=new f(r.contents,r.keys,r.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let r={},o=null,l=[],i=[],d=[];function y(m){Array.isArray(l)?l.push(m):o&&(l[o]=m)}let k={onObjectBegin:()=>{let m={};y(m),i.push(l),l=m,o=null},onObjectProperty:m=>{o=m},onObjectEnd:()=>{l=i.pop()},onArrayBegin:()=>{let m=[];y(m),i.push(l),l=m,o=null},onArrayEnd:()=>{l=i.pop()},onLiteralValue:y,onError:(m,w,R)=>{d.push({error:m,offset:w,length:R})}};if(t)try{_.visit(t,k),r=l[0]||{}}catch(m){console.error(`Error while parsing settings file ${this._name}: ${m}`),this._parseErrors=[m]}return r}doParseRaw(t){if(this._scopes){const i=A.Registry.as(D.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,i,!0,this._scopes)}const r=(0,n.toValuesTree)(t,i=>console.error(`Conflict in settings file ${this._name}: ${i}`)),o=Object.keys(t),l=(0,n.toOverrides)(t,i=>console.error(`Conflict in settings file ${this._name}: ${i}`));return{contents:r,keys:o,overrides:l}}filterByScope(t,r,o,l){const i={};for(let d in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(d)&&o)i[d]=this.filterByScope(t[d],r,!1,l);else{const y=this.getScope(d,r);(y===void 0||l.indexOf(y)!==-1)&&(i[d]=t[d])}return i}getScope(t,r){const o=r[t];return o?typeof o.scope!="undefined"?o.scope:3:void 0}}e.ConfigurationModelParser=h;class v extends I.Disposable{constructor(t,r,o,l){super();this.userSettingsResource=t,this.scopes=r,this.fileService=l,this._onDidChange=this._register(new p.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(p.Event.filter(this.fileService.onDidFilesChange,i=>i.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new f}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=v;class g{constructor(t,r,o=new f,l=new f,i=new S.ResourceMap,d=new f,y=new S.ResourceMap,k=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=o,this._workspaceConfiguration=l,this._folderConfigurations=i,this._memoryConfiguration=d,this._memoryConfigurationByResource=y,this._freeze=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new S.ResourceMap,this._userConfiguration=null}getValue(t,r,o){return this.getConsolidateConfigurationModel(r,o).getValue(t)}updateValue(t,r,o={}){let l;o.resource?(l=this._memoryConfigurationByResource.get(o.resource),l||(l=new f,this._memoryConfigurationByResource.set(o.resource,l))):l=this._memoryConfiguration,r===void 0?l.removeValue(t):l.setValue(t,r),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,o){const l=this.getConsolidateConfigurationModel(r,o),i=this.getFolderConfigurationModelForResource(r.resource,o),d=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,y=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),k=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),m=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),w=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=o?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=i?r.overrideIdentifier?i.freeze().override(r.overrideIdentifier).getValue(t):i.freeze().getValue(t):void 0,B=r.overrideIdentifier?d.override(r.overrideIdentifier).getValue(t):d.getValue(t),Q=l.getValue(t),J=T.distinct(T.flatten(l.overrides.map(z=>z.identifiers))).filter(z=>l.getOverrideValue(t,z)!==void 0);return{defaultValue:y,userValue:k,userLocalValue:m,userRemoteValue:w,workspaceValue:R,workspaceFolderValue:F,memoryValue:B,value:Q,default:y!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:k!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:m!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:w!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:i==null?void 0:i.freeze().getValue(t),override:r.overrideIdentifier?i==null?void 0:i.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:B!==void 0?{value:d.getValue(t),override:r.overrideIdentifier?d.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:J.length?J:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const o=r.filter(l=>D.OVERRIDE_PROPERTY_PATTERN.test(l)).map(l=>{const i=(0,D.overrideIdentifierFromKey)(l),d=this._defaultConfiguration.getKeysForOverrideIdentifier(i),y=t.getKeysForOverrideIdentifier(i),k=[...y.filter(m=>d.indexOf(m)===-1),...d.filter(m=>y.indexOf(m)===-1),...d.filter(m=>!E.equals(this._defaultConfiguration.override(i).getValue(m),t.override(i).getValue(m)))];return[i,k]});return this.updateDefaultConfiguration(t),{keys:r,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:o,removed:l,overrides:i}=(0,n.compare)(this.localUserConfiguration,t),d=[...r,...o,...l];return d.length&&this.updateLocalUserConfiguration(t),{keys:d,overrides:i}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:o,removed:l,overrides:i}=(0,n.compare)(this.remoteUserConfiguration,t);let d=[...r,...o,...l];return d.length&&this.updateRemoteUserConfiguration(t),{keys:d,overrides:i}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:o,removed:l,overrides:i}=(0,n.compare)(this.workspaceConfiguration,t);let d=[...r,...o,...l];return d.length&&this.updateWorkspaceConfiguration(t),{keys:d,overrides:i}}compareAndUpdateFolderConfiguration(t,r){const o=this.folderConfigurations.get(t),{added:l,updated:i,removed:d,overrides:y}=(0,n.compare)(o,r);let k=[...l,...i,...d];return(k.length||!o)&&this.updateFolderConfiguration(t,r),{keys:k,overrides:y}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:l,removed:i,overrides:d}=(0,n.compare)(r,void 0);return{keys:[...o,...l,...i],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let o=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},r){let o=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const l=r.getFolder(t);l&&(o=this.getFolderConsolidatedConfiguration(l.uri)||o);const i=this._memoryConfigurationByResource.get(t);i&&(o=o.merge(i))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const o=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(t);l?(r=o.merge(l),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=o}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const o=r.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:o,overrides:l,keys:i}=this._folderConfigurations.get(r);return t.push([r,{contents:o,overrides:l,keys:i}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(l=>r.add(l))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),l=this.parseConfigurationModel(t.workspace),i=t.folders.reduce((d,y)=>(d.set(C.URI.revive(y[0]),this.parseConfigurationModel(y[1])),d),new S.ResourceMap);return new g(r,o,new f,l,i,new f,new S.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=g;function b(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,r=new Map;for(const l of a)l.keys.forEach(i=>t.add(i)),l.overrides.forEach(([i,d])=>{const y=(0,S.getOrSet)(r,i,new Set);d.forEach(k=>y.add(k))});const o=[];return r.forEach((l,i)=>o.push([i,[...l.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=b;class c{constructor(t,r,o,l){this.change=t,this.previous=r,this.currentConfiguraiton=o,this.currentWorkspace=l,this._previousConfiguration=void 0;const i=new Set;t.keys.forEach(y=>i.add(y)),t.overrides.forEach(([,y])=>y.forEach(k=>i.add(k))),this.affectedKeys=[...i.values()];const d=new f;this.affectedKeys.forEach(y=>d.setValue(y,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var o;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const l=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(o=this.previous)===null||o===void 0?void 0:o.workspace):void 0,i=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!E.equals(l,i)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let o=(0,n.toValuesTree)({[r]:!0},()=>{}),l;for(;typeof o=="object"&&(l=Object.keys(o)[0]);){if(t=t[l],!t)return!1;o=o[l]}return!0}}e.ConfigurationChangeEvent=c;class u extends c{constructor(t,r,o,l){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=o,this.sourceConfig=l}}e.AllKeysConfigurationChangeEvent=u}),define(we[90],Ee([0,1,4]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,_.createDecorator)("remoteAuthorityResolverService");var S;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(S=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(E,C=S.Unknown,D){super(E);this._message=E,this._code=C,this._detail=D,this.isHandled=C===S.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(E){return E instanceof T&&E._code===S.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof T&&E._code===S.NoResolverFound}static isHandled(E){return E instanceof T&&E.isHandled}}e.RemoteAuthorityResolverError=T}),define(we[91],Ee([0,1,16]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function S(P){return P.scheme===_.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=S;function T(P){if(!!P){const E=P.indexOf("+");return E<0?P:P.substr(0,E)}}e.getRemoteName=T}),define(we[151],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class _{constructor(T){this._callback=T,this._terminalBufferMap=new Map}dispose(){for(const T of this._terminalBufferMap.values())T.dispose()}startBuffering(T,P,E=5){let C;return C=P(D=>{const n=typeof D=="string"?D:D.data;let A=this._terminalBufferMap.get(T);if(A){A.data.push(n);return}const I=setTimeout(()=>this._flushBuffer(T),E);A={data:[n],timeoutId:I,dispose:()=>{clearTimeout(I),this._flushBuffer(T),C.dispose()}},this._terminalBufferMap.set(T,A)}),C}stopBuffering(T){const P=this._terminalBufferMap.get(T);P&&P.dispose()}_flushBuffer(T){const P=this._terminalBufferMap.get(T);P&&(this._terminalBufferMap.delete(T),this._callback(T,P.data.join("")))}}e.TerminalDataBufferer=_}),define(we[152],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var _;(function(S){S.DARK="dark",S.LIGHT="light",S.HIGH_CONTRAST="hc"})(_=e.ColorScheme||(e.ColorScheme={}))}),define(we[153],Ee([0,1,4,6,30,3,152,37]),function(re,e,_,S,T,P,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,_.createDecorator)("themeService");var D;(function(v){function g(b){return b&&typeof b=="object"&&typeof b.id=="string"}v.isThemeColor=g})(D=e.ThemeColor||(e.ThemeColor={}));function n(v){return{id:v}}e.themeColorFromId=n;var A;(function(v){function g(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||D.isThemeColor(t.color))}v.isThemeIcon=g;const b=new RegExp(`^\\$\\((${C.CSSIcon.iconNameExpression}(?:${C.CSSIcon.iconModifierExpression})?)\\)$`);function c(t){const r=b.exec(t);if(!!r){let[,o]=r;return{id:o}}}v.fromString=c;function u(t,r){let o=t.id;const l=o.lastIndexOf("~");return l!==-1&&(o=o.substring(0,l)),r&&(o=`${o}~${r}`),{id:o}}v.modify=u;function a(t,r){var o,l;return t.id===r.id&&((o=t.color)===null||o===void 0?void 0:o.id)===((l=r.color)===null||l===void 0?void 0:l.id)}v.isEqual=a,v.asClassNameArray=C.CSSIcon.asClassNameArray,v.asClassName=C.CSSIcon.asClassName,v.asCSSSelector=C.CSSIcon.asCSSSelector})(A=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=C.Codicon.file,e.FolderThemeIcon=C.Codicon.folder;function I(v){switch(v){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class p{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new P.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,S.toDisposable)(()=>{const b=this.themingParticipants.indexOf(g);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new p;T.Registry.add(e.Extensions.ThemingContribution,f);function s(v){return f.onColorThemeChange(v)}e.registerThemingParticipant=s;class h extends S.Disposable{constructor(g){super();this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,b){let c=this.theme.getColor(g);return c&&b&&(c=b(c,this.theme)),c?c.toString():null}}e.Themable=h}),define(we[154],Ee([0,1,30,153,3,124,88,15,37]),function(re,e,_,S,T,P,E,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class n{constructor(){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,P.localize)(0,null)},fontCharacter:{type:"string",description:(0,P.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${D.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(g,b,c,u){const a=this.iconsById[g];if(a){if(c&&!a.description){a.description=c,this.iconSchema.properties[g].markdownDescription=`${c} $(${g})`;const o=this.iconReferenceSchema.enum.indexOf(g);o!==-1&&(this.iconReferenceSchema.enumDescriptions[o]=c),this._onDidChange.fire()}return a}let t={id:g,description:c,defaults:b,deprecationMessage:u};this.iconsById[g]=t;let r={$ref:"#/definitions/icons"};return u&&(r.deprecationMessage=u),c&&(r.markdownDescription=`${c}: $(${g})`),this.iconSchema.properties[g]=r,this.iconReferenceSchema.enum.push(g),this.iconReferenceSchema.enumDescriptions.push(c||""),this._onDidChange.fire(),{id:g}}deregisterIcon(g){delete this.iconsById[g],delete this.iconSchema.properties[g];const b=this.iconReferenceSchema.enum.indexOf(g);b!==-1&&(this.iconReferenceSchema.enum.splice(b,1),this.iconReferenceSchema.enumDescriptions.splice(b,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(g=>this.iconsById[g])}getIcon(g){return this.iconsById[g]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(g,b){const c=this.iconFontsById[g];if(c)return c;let u={id:g,definition:b};return this.iconFontsById[g]=u,this._onDidChange.fire(),u}deregisterIconFont(g){delete this.iconFontsById[g]}getIconFonts(){return Object.keys(this.iconFontsById).map(g=>this.iconFontsById[g])}getIconFont(g){return this.iconFontsById[g]}toString(){const g=(a,t)=>a.id.localeCompare(t.id),b=a=>{for(;S.ThemeIcon.isThemeIcon(a.defaults);)a=this.iconsById[a.defaults.id];return`codicon codicon-${a?a.id:""}`};let c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.iconsById).map(a=>this.iconsById[a]);for(const a of u.filter(t=>!!t.description).sort(g))c.push(`|<i class="${b(a)}"></i>|${a.id}|${S.ThemeIcon.isThemeIcon(a.defaults)?a.defaults.id:a.id}|${a.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const a of u.filter(t=>!S.ThemeIcon.isThemeIcon(t.defaults)).sort(g))c.push(`|<i class="${b(a)}"></i>|${a.id}|`);return c.join(`
`)}}const A=new n;_.Registry.add(e.Extensions.IconContribution,A);function I(v,g,b,c){return A.registerIcon(v,g,b,c)}e.registerIcon=I;function p(){return A}e.getIconRegistry=p;function f(){for(const v of D.iconRegistry.all)A.registerIcon(v.id,v.definition,v.description);D.iconRegistry.onDidRegister(v=>A.registerIcon(v.id,v.definition,v.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let s=_.Registry.as(E.Extensions.JSONContribution);s.registerSchema(e.iconsSchemaId,A.getIconSchema());const h=new C.RunOnceScheduler(()=>s.notifySchemaChanged(e.iconsSchemaId),200);A.onDidChange(()=>{h.isScheduled()||h.schedule()}),e.widgetClose=I("widget-close",D.Codicon.close,(0,P.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",D.Codicon.arrowUp,(0,P.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",D.Codicon.arrowDown,(0,P.localize)(4,null)),e.syncing=S.ThemeIcon.modify(D.Codicon.sync,"spin")}),define(we[48],Ee([0,1,2,23,4,22]),function(re,e,_,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var E;(function(p){p[p.EMPTY=1]="EMPTY",p[p.FOLDER=2]="FOLDER",p[p.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function C(p){const f=p;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=C;function D(p){const f=p;return!!(f&&typeof f=="object"&&_.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=D;class n{constructor(f,s,h,v){this._id=f,this._configuration=h,this._ignorePathCasing=v,this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=n;class A{constructor(f,s){this.raw=s,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,S.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=A;function I(p){return new A({uri:p,index:0,name:(0,S.basenameOrAuthority)(p)},{uri:p.toString()})}e.toWorkspaceFolder=I}),define(we[155],Ee([0,1,4,125,48,2,21,10,23,104,46,16,59,38,91]),function(re,e,_,S,T,P,E,C,D,n,A,I,p,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const h=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,S.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(Q){return(typeof Q=="string"?(0,C.extname)(Q):(0,D.extname)(Q))===h}e.hasWorkspaceFileExtension=v,e.IWorkspacesService=(0,_.createDecorator)("workspacesService");function g(Q){return Q.hasOwnProperty("workspace")}e.isRecentWorkspace=g;function b(Q){return Q.hasOwnProperty("folderUri")}e.isRecentFolder=b;function c(Q){return Q.hasOwnProperty("fileUri")}e.isRecentFile=c;function u(Q){const J=Q;return typeof(J==null?void 0:J.id)=="string"&&P.URI.isUri(J.uri)}e.isSingleFolderWorkspaceIdentifier=u;function a(Q){if(Q.configuration)return{id:Q.id,configPath:Q.configuration};if(Q.folders.length===1)return{id:Q.id,uri:Q.folders[0].uri}}e.toWorkspaceIdentifier=a;function t(Q){const J=Q;return typeof(J==null?void 0:J.id)=="string"&&P.URI.isUri(J.configPath)}e.isWorkspaceIdentifier=t;function r(Q){const J=Q;if(J==null?void 0:J.uri)return{id:J.id,uri:P.URI.revive(J.uri)};const z=Q;if(z==null?void 0:z.configPath)return{id:z.id,configPath:P.URI.revive(z.configPath)};if(Q==null?void 0:Q.id)return{id:Q.id}}e.reviveIdentifier=r;function o(Q,J){return D.extUriBiasedIgnorePathCase.isEqualOrParent(Q,J.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function l(Q){return i(Q)||d(Q)}e.isStoredWorkspaceFolder=l;function i(Q){const J=Q;return typeof(J==null?void 0:J.path)=="string"&&(!J.name||typeof J.name=="string")}e.isRawFileWorkspaceFolder=i;function d(Q){const J=Q;return typeof(J==null?void 0:J.uri)=="string"&&(!J.name||typeof J.name=="string")}e.isRawUriWorkspaceFolder=d;function y(Q,J,z,ae,L=!E.isWindows,N){if(Q.scheme!==ae.scheme)return{name:z,uri:Q.toString(!0)};let H=J?void 0:N.relativePath(ae,Q);if(H!==void 0)H.length===0?H=".":E.isWindows&&Q.scheme===I.Schemas.file&&!L&&(H=H.replace(/\//g,"\\"));else if(Q.scheme===I.Schemas.file)H=Q.fsPath,E.isWindows&&(H=(0,p.normalizeDriveLetter)(H),L&&(H=(0,f.toSlashes)(H)));else{if(!N.isEqualAuthority(Q.authority,ae.authority))return{name:z,uri:Q.toString(!0)};H=Q.path}return{name:z,path:H}}e.getStoredWorkspaceFolder=y;function k(Q,J,z){let ae=[],L=new Set;const N=z.dirname(J);for(let H of Q){let O=null;if(i(H))H.path&&(O=z.resolvePath(N,H.path));else if(d(H))try{O=P.URI.parse(H.uri),O.path[0]!=="/"&&(O=O.with({path:"/"+O.path}))}catch(K){console.warn(K)}if(O){let K=z.getComparisonKey(O);if(!L.has(K)){L.add(K);const le=H.name||z.basenameOrAuthority(O);ae.push(new T.WorkspaceFolder({uri:O,name:le,index:ae.length},H))}}}return ae}e.toWorkspaceFolders=k;function m(Q,J,z,ae,L){let N=w(J,Q);const H=L.dirname(J),O=L.dirname(ae),K=[],le=R(N.folders);for(const Re of N.folders){const He=i(Re)?L.resolvePath(H,Re.path):P.URI.parse(Re.uri);let Fe;z?Fe=!1:Fe=!i(Re)||(0,C.isAbsolute)(Re.path),K.push(y(He,Fe,Re.name,O,le,L))}const ue={insertSpaces:!1,tabSize:4,eol:E.isLinux||E.isMacintosh?`
`:`\r
`},pe=n.setProperty(Q,["folders"],K,ue);let ve=n.applyEdits(Q,pe);return N.remoteAuthority===(0,s.getRemoteAuthority)(ae)&&(ve=n.applyEdits(ve,n.removeProperty(ve,["remoteAuthority"],ue))),ve}e.rewriteWorkspaceFileForNewLocation=m;function w(Q,J){let z=A.parse(J);if(z&&Array.isArray(z.folders))z.folders=z.folders.filter(ae=>l(ae));else throw new Error(`${Q} looks like an invalid workspace file.`);return z}function R(Q){return E.isWindows?Q.some(J=>i(J)&&J.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function F(Q,J){const z={workspaces:[],files:[]};if(Q){const ae=function(N,H){for(let O=0;O<N.length;O++)try{H(N[O],O)}catch(K){J.warn(`Error restoring recent entry ${JSON.stringify(N[O])}: ${K.toString()}. Skip entry.`)}},L=Q;Array.isArray(L.workspaces3)&&ae(L.workspaces3,(N,H)=>{const O=Array.isArray(L.workspaceLabels)&&L.workspaceLabels[H]||void 0;typeof N=="object"&&typeof N.id=="string"&&typeof N.configURIPath=="string"?z.workspaces.push({label:O,workspace:{id:N.id,configPath:P.URI.parse(N.configURIPath)}}):typeof N=="string"&&z.workspaces.push({label:O,folderUri:P.URI.parse(N)})}),Array.isArray(L.files2)&&ae(L.files2,(N,H)=>{const O=Array.isArray(L.fileLabels)&&L.fileLabels[H]||void 0;typeof N=="string"&&z.files.push({label:O,fileUri:P.URI.parse(N)})})}return z}e.restoreRecentlyOpened=F;function B(Q){const J={workspaces3:[],files2:[]};let z=!1;const ae=[];for(const N of Q.workspaces)b(N)?J.workspaces3.push(N.folderUri.toString()):J.workspaces3.push({id:N.workspace.id,configURIPath:N.workspace.configPath.toString()}),ae.push(N.label||null),z=z||!!N.label;z&&(J.workspaceLabels=ae),z=!1;const L=[];for(const N of Q.files)J.files2.push(N.fileUri.toString()),L.push(N.label||null),z=z||!!N.label;return z&&(J.fileLabels=L),J}e.toStoreData=B}),define(we[92],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class _{constructor(T){this.id=T,this._data=new Map,this._idPool=1}add(T){const P=this._idPool++;return this._data.set(P,T),this.logDebugInfo(),P}get(T,P){return this._data.has(T)?this._data.get(T)[P]:void 0}delete(T){this._data.delete(T),this.logDebugInfo()}logDebugInfo(){!_.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=_,_.enableDebugLogging=!1}),define(we[156],Ee([0,1,2,3]),function(re,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class T{constructor(){this._onDidChangeTabs=new S.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(E){this._tabs=E.map(C=>({name:C.name,group:C.group,resource:_.URI.revive(C.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(we[49],Ee([0,1,16,4]),function(re,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(_.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(E,C){C===null?this._providerInfo.delete(E):this._providerInfo.set(E,C)}isFreeScheme(E){return!this._providerInfo.has(E)&&!this._systemSchemes.has(E)}getCapabilities(E){return this._providerInfo.get(E)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,S.createDecorator)("IExtHostFileSystemInfo")}),define(we[27],Ee([0,1,4]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,_.createDecorator)("IExtHostInitDataService")}),define(we[157],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class _{constructor(P,E,C){this._id=P,this._shared=E,this._storage=C,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(D=>(this._value=D,this)),this._storageListener=this._storage.onDidChangeStorage(D=>{D.shared===this._shared&&D.key===this._id&&(this._value=D.value)})}get whenReady(){return this._init}get(P,E){let C=this._value[P];return typeof C=="undefined"&&(C=E),C}update(P,E){return this._value[P]=E,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=_;class S extends _{constructor(P,E){super(P.identifier.value,!0,E);this._extension=P}setKeysForSync(P){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},P)}}e.ExtensionGlobalMemento=S}),define(we[13],Ee([0,1,4]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,_.createDecorator)("IExtHostRpcService");class S{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=S});var tt=this&&this.__classPrivateFieldSet||function(re,e,_){if(!e.has(re))throw new TypeError("attempted to set private field on non-instance");return e.set(re,_),_},We=this&&this.__classPrivateFieldGet||function(re,e){if(!e.has(re))throw new TypeError("attempted to get private field on non-instance");return e.get(re)};define(we[158],Ee([0,1,25,3]),function(re,e,_,S){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(C,D){T.set(this,void 0),this._onDidChange=new S.Emitter,this.onDidChange=this._onDidChange.event,this._id=_.ExtensionIdentifier.toKey(C.identifier),tt(this,T,D),We(this,T).onDidChangePassword(n=>{n.extensionId===this._id&&this._onDidChange.fire({key:n.key})})}get(C){return We(this,T).get(this._id,C)}store(C,D){return We(this,T).store(this._id,C,D)}delete(C){return We(this,T).delete(this._id,C)}}e.ExtensionSecrets=P,T=new WeakMap}),define(we[93],Ee([0,1,4,3]),function(re,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class T{constructor(){this._onDidChangeTelemetryEnabled=new S.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(E){this._enabled=E}$onDidChangeTelemetryEnabled(E){this._enabled=E,this._onDidChangeTelemetryEnabled.fire(E)}}e.ExtHostTelemetry=T,e.IExtHostTelemetry=(0,_.createDecorator)("IExtHostTelemetry")});var Ve=this&&this.__decorate||function(re,e,_,S){var T=arguments.length,P=T<3?e:S===null?S=Object.getOwnPropertyDescriptor(e,_):S,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(re,e,_,S);else for(var C=re.length-1;C>=0;C--)(E=re[C])&&(P=(T<3?E(P):T>3?E(e,_,P):E(e,_))||P);return T>3&&P&&Object.defineProperty(e,_,P),P},qe=this&&this.__param||function(re,e){return function(_,S){e(_,S,re)}};define(we[68],Ee([0,1,4,3,13]),function(re,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var P;(function(C){function D(A){return{remoteAddress:A.remoteAddress,localAddress:A.localAddress,public:!!A.public}}C.fromApiTunnel=D;function n(A){return{remoteAddress:{host:A.tunnelRemoteHost,port:A.tunnelRemotePort},localAddress:A.localAddress,public:A.public}}C.fromServiceTunnel=n})(P=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,_.createDecorator)("IExtHostTunnelService");let E=class{constructor(D){this.onDidChangeTunnels=new S.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,n){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}async $forwardPort(D,n){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};E=Ve([qe(0,T.IExtHostRpcService)],E),e.ExtHostTunnelService=E}),define(we[69],Ee([0,1,4]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,_.createDecorator)("IURITransformerService");class S{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=E=>E,this.transformOutgoing=E=>E,this.transformOutgoingURI=E=>E,this.transformOutgoingScheme=E=>E)}}e.URITransformerService=S}),define(we[70],Ee([0,1,2]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function S(P,E,C){const D=P.webviewResourceRoot.replace("{{resource}}",C.scheme+T(C)).replace("{{uuid}}",E);return _.URI.parse(D)}e.asWebviewUri=S;function T(P){return P.toString().replace(/^\S+?:/,"")}}),define(we[159],Ee([0,1,3,6,70,29]),function(re,e,_,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class E{constructor(D,n,A){this._proxy=D,this._editors=n,this._initData=A,this._handlePool=0,this._disposables=new S.DisposableStore,this._insets=new Map,this._disposables.add(n.onDidChangeVisibleTextEditors(()=>{const I=n.getVisibleTextEditors();for(const p of this._insets.values())I.indexOf(p.editor)<0&&p.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,n,A,I,p){let f;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===D){f=u;break}if(!f)throw new Error("not a visible editor");const s=this,h=this._handlePool++,v=new _.Emitter,g=new _.Emitter,b=new class{constructor(){this._uuid=(0,P.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,T.asWebviewUri)(s._initData,this._uuid,u)}get cspSource(){return s._initData.webviewCspSource}set options(u){this._options=u,s._proxy.$setOptions(h,u)}get options(){return this._options}set html(u){this._html=u,s._proxy.$setHtml(h,u)}get html(){return this._html}get onDidReceiveMessage(){return v.event}postMessage(u){return s._proxy.$postMessage(h,u)}},c=new class{constructor(){this.editor=D,this.line=n,this.height=A,this.webview=b,this.onDidDispose=g.event}dispose(){s._insets.has(h)&&(s._insets.delete(h),s._proxy.$disposeEditorInset(h),g.fire(),g.dispose(),v.dispose())}};return this._proxy.$createEditorInset(h,f.id,f.value.document.uri,n+1,A,I||{},p.identifier,p.extensionLocation),this._insets.set(h,{editor:D,inset:c,onDidReceiveMessage:v}),c}$onDidDispose(D){const n=this._insets.get(D);n&&n.inset.dispose()}$onDidReceiveMessage(D,n){const A=this._insets.get(D);A&&A.onDidReceiveMessage.fire(n)}}e.ExtHostEditorInsets=E}),define(we[160],Ee([0,1,3,64,135,4,6,22,30,14,51,24,37,154]),function(re,e,_,S,T,P,E,C,D,n,A,I,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",p.Codicon.window,(0,T.localize)(0,null));var s;(function(i){i.ViewContainersRegistry="workbench.registry.view.containers",i.ViewsRegistry="workbench.registry.view"})(s=e.Extensions||(e.Extensions={}));var h;(function(i){i[i.Sidebar=0]="Sidebar",i[i.Panel=1]="Panel"})(h=e.ViewContainerLocation||(e.ViewContainerLocation={}));function v(i){switch(i){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=v;function g(i){return`viewContainer.${i}.enabled`}e.getEnabledViewContainerContextKey=g;class b extends E.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new _.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new _.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,n.flatten)([...this.viewContainers.values()])}registerViewContainer(d,y,k){var m;const w=this.get(d.id);if(w)return w;const R=d;return R.openCommandActionDescriptor=(k==null?void 0:k.donotRegisterOpenCommand)?void 0:(m=R.openCommandActionDescriptor)!==null&&m!==void 0?m:{id:R.id},(0,C.getOrSet)(this.viewContainers,y,[]).push(R),(k==null?void 0:k.isDefault)&&this.defaultViewContainers.push(R),this._onDidRegister.fire({viewContainer:R,viewContainerLocation:y}),R}deregisterViewContainer(d){for(const y of this.viewContainers.keys()){const k=this.viewContainers.get(y),m=k==null?void 0:k.indexOf(d);if(m!==-1){k==null||k.splice(m,1),k.length===0&&this.viewContainers.delete(y),this._onDidDeregister.fire({viewContainer:d,viewContainerLocation:y});return}}}get(d){return this.all.filter(y=>y.id===d)[0]}getViewContainers(d){return[...this.viewContainers.get(d)||[]]}getViewContainerLocation(d){return[...this.viewContainers.keys()].filter(y=>this.getViewContainers(y).filter(k=>(k==null?void 0:k.id)===d.id).length>0)[0]}getDefaultViewContainer(d){return this.defaultViewContainers.find(y=>this.getViewContainerLocation(y)===d)}}D.Registry.add(s.ViewContainersRegistry,new b);var c;(function(i){i.Open="2_open",i.Debug="4_debug",i.SCM="5_scm",i.More="9_more"})(c=e.ViewContentGroups||(e.ViewContentGroups={}));function u(i,d){var y,k,m,w;const R=(y=i.group)!==null&&y!==void 0?y:c.More,F=(k=d.group)!==null&&k!==void 0?k:c.More;return R!==F?R.localeCompare(F):((m=i.order)!==null&&m!==void 0?m:5)-((w=d.order)!==null&&w!==void 0?w:5)}class a extends E.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new _.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new _.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new _.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new _.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new A.SetMap}registerViews(d,y){this.registerViews2([{views:d,viewContainer:y}])}registerViews2(d){d.forEach(({views:y,viewContainer:k})=>this.addViews(y,k)),this._onViewsRegistered.fire(d)}deregisterViews(d,y){const k=this.removeViews(d,y);k.length&&this._onViewsDeregistered.fire({views:k,viewContainer:y})}moveViews(d,y){for(const k of this._views.keys())if(k!==y){const m=this.removeViews(d,k);m.length&&(this.addViews(m,y),this._onDidChangeContainer.fire({views:m,from:k,to:y}))}}getViews(d){return this._views.get(d)||[]}getView(d){for(const y of this._viewContainers){const k=(this._views.get(y)||[]).filter(m=>m.id===d)[0];if(k)return k}return null}getViewContainer(d){for(const y of this._viewContainers)if((this._views.get(y)||[]).filter(m=>m.id===d)[0])return y;return null}registerViewWelcomeContent(d,y){return this._viewWelcomeContents.add(d,y),this._onDidChangeViewWelcomeContent.fire(d),(0,E.toDisposable)(()=>{this._viewWelcomeContents.delete(d,y),this._onDidChangeViewWelcomeContent.fire(d)})}registerViewWelcomeContent2(d,y){const k=new Map;for(const[m,w]of y)this._viewWelcomeContents.add(d,w),k.set(m,(0,E.toDisposable)(()=>{this._viewWelcomeContents.delete(d,w),this._onDidChangeViewWelcomeContent.fire(d)}));return this._onDidChangeViewWelcomeContent.fire(d),k}getViewWelcomeContent(d){const y=[];return this._viewWelcomeContents.forEach(d,k=>y.push(k)),y.sort(u)}addViews(d,y){let k=this._views.get(y);k||(k=[],this._views.set(y,k),this._viewContainers.push(y));for(const m of d){if(this.getView(m.id)!==null)throw new Error((0,T.localize)(1,null,m.id));k.push(m)}}removeViews(d,y){const k=this._views.get(y);if(!k)return[];const m=[],w=[];for(const R of k)d.includes(R)?m.push(R):w.push(R);return m.length&&(w.length?this._views.set(y,w):(this._views.delete(y),this._viewContainers.splice(this._viewContainers.indexOf(y),1))),m}}D.Registry.add(s.ViewsRegistry,new a),e.IViewsService=(0,P.createDecorator)("viewsService"),e.FocusedViewContext=new S.RawContextKey("focusedView","",(0,T.localize)(2,null));function t(i){return`view.${i}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,P.createDecorator)("viewDescriptorService");var r;(function(i){i[i.Default=0]="Default",i[i.Expand=1]="Expand"})(r=e.ViewVisibilityState||(e.ViewVisibilityState={}));var o;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(o=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class l{constructor(d,y){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,d),this._hasResolve=!!y,this.resolve=async k=>{var m,w;if(y&&!this.resolved){const R=await y(k);R&&(this.tooltip=(m=this.tooltip)!==null&&m!==void 0?m:R.tooltip,this.command=(w=this.command)!==null&&w!==void 0?w:R.command)}k.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=l}),define(we[161],Ee([0,1,2,144,155,19,145,160]),function(re,e,_,S,T,P,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function D(h){return(v,...g)=>h(v.get(S.ICommandService),...g)}class n{static execute(v,g){const b={forceReuseWindow:g&&g.reuseWindow,remoteAuthority:g&&g.remoteAuthority};return v.executeCommand("_files.newWindow",b)}}e.NewWindowAPICommand=n,n.ID="vscode.newWindow",S.CommandsRegistry.registerCommand({id:n.ID,handler:D(n.execute),description:{description:"Opens an new window",args:[]}}),S.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(h,v){return h.get(T.IWorkspacesService).removeRecentlyOpened([v])});class A{static execute(v,g){return typeof g=="string"?g=g.match(/^[^:/?#]+:\/\//)?_.URI.parse(g):_.URI.file(g):g=_.URI.revive(g),v.executeCommand("_workbench.removeFromRecentlyOpened",g)}}e.RemoveFromRecentlyOpenedAPICommand=A,A.ID="vscode.removeFromRecentlyOpened",S.CommandsRegistry.registerCommand(A.ID,D(A.execute));class I{static execute(v,g){const b=typeof g=="string"?{extensionId:g}:g;return v.executeCommand("workbench.action.openIssueReporter",b)}}e.OpenIssueReporter=I,I.ID="vscode.openIssueReporter",S.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(h,v){const g=h.get(T.IWorkspacesService);let b;const c=v.uri,u=v.label;return v.type==="workspace"?b={workspace:await g.getWorkspaceIdentifier(c),label:u}:v.type==="folder"?b={folderUri:c,label:u}:b={fileUri:c,label:u},g.addRecentlyOpened([b])}),S.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(h){return h.get(T.IWorkspacesService).getRecentlyOpened()}),S.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(h,v){const g=h.get(P.ILogService),b=h.get(E.IEnvironmentService);b.isExtensionDevelopment&&!!b.extensionTestsLocationURI&&g.setLevel(v)}),S.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(h){return h.get(P.ILogService).getLevel()}),S.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(h,v){const g=h.get(C.IViewDescriptorService),b=g.getViewContainerById(v.destinationId);if(!!b){for(const c of v.viewIds){const u=g.getViewDescriptorById(c);(u==null?void 0:u.canMoveView)&&g.moveViewsToContainer([u],b,C.ViewVisibilityState.Default)}await h.get(C.IViewsService).openViewContainer(b.id,!0)}});class p{static execute(v,g){return!Array.isArray(g==null?void 0:g.viewIds)||typeof(g==null?void 0:g.destinationId)!="string"?Promise.reject("Invalid arguments"):v.executeCommand("_workbench.action.moveViews",g)}}e.MoveViewsAPICommand=p,p.ID="vscode.moveViews",S.CommandsRegistry.registerCommand({id:p.ID,handler:D(p.execute),description:{description:"Move Views",args:[]}});class f{static execute(v,g){return v.executeCommand("_workbench.open",g)}}f.ID="vscode.open",S.CommandsRegistry.registerCommand(f.ID,D(f.execute));class s{static execute(v,g,b,c,u){return v.executeCommand("_workbench.diff",[g,b,c])}}s.ID="vscode.diff",S.CommandsRegistry.registerCommand(s.ID,D(s.execute))}),define(we[162],Ee([0,1,3,15,136]),function(re,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new _.Emitter,this._onExit=new _.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,D,n,A){const I={command:C};if(D&&Object.keys(D).length>0&&(I.arguments=D),this.internalSend("request",I),typeof A=="number"){const p=setTimeout(()=>{clearTimeout(p);const f=this.pendingRequests.get(I.seq);if(f){this.pendingRequests.delete(I.seq);const s={type:"response",seq:0,request_seq:I.seq,success:!1,command:C,message:(0,T.localize)(0,null,A,C)};f(s)}},A)}return n&&this.pendingRequests.set(I.seq,n),I.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,D){return C.type!=="event"||D.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,S.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const D=C,n=this.pendingRequests.get(D.request_seq);n&&(this.pendingRequests.delete(D.request_seq),n(D));break}}}internalSend(C,D){D.type=C,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((D,n)=>C.set(n,D)),await(0,S.timeout)(500),C.forEach((D,n)=>{D({type:"response",seq:0,request_seq:n,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(n)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(we[163],Ee([0,1,8,2,10,24,16]),function(re,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function D(r,o,l){return r.replace(C,function(i,d){return o&&d.length>0&&d[0]!=="_"?i:l&&l.hasOwnProperty(d)?l[d]:i})}e.formatPII=D;function n(r){const o={};for(const l of Object.keys(r))l.startsWith("!")||(o[l]=r[l]);return o}e.filterExceptionsFromTelemetry=n;function A(r){return r.configuration.request==="attach"&&!I(r)}e.isSessionAttach=A;function I(r){let o=r.configuration.type;if(!!o)return o==="vslsShare"&&(o=r.configuration.adapterProxy.configuration.type),(0,_.equalsIgnoreCase)(o,"extensionhost")||(0,_.equalsIgnoreCase)(o,"pwa-extensionhost")?r:r.parentSession?I(r.parentSession):void 0}e.getExtensionHostDebugSession=I;function p(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=p;function f(r,o,l){let i,d=0,y=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,k=null;for(;k=y.exec(r);){let m=k.index+1,w=m+k[0].length;if(m<=o&&w>=l){i=k[0],d=m;break}}if(i){let m=/\w+/g,w=null;for(;(w=m.exec(i))&&!(w.index+1+d+w[0].length>=l););w&&(i=i.substring(0,m.lastIndex))}return i?{start:d,end:d+i.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(r){return!!(r&&r.match(s))}e.isUri=h;function v(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(h(r.path))return S.URI.parse(r.path);if((0,T.isAbsolute)(r.path))return S.URI.file(r.path)}return r.path}function g(r){if(typeof r.path=="object"){const o=S.URI.revive(r.path);if(o)return o.scheme===E.Schemas.file?o.fsPath:o.toString()}return r.path}function b(r,o){const l=o?v:g,i=(0,P.deepClone)(r);return u(i,(d,y)=>{d&&y&&(y.path=l(y))}),i}e.convertToDAPaths=b;function c(r,o){const l=o?v:g,i=(0,P.deepClone)(r);return u(i,(d,y)=>{!d&&y&&(y.path=l(y))}),i}e.convertToVSCPaths=c;function u(r,o){switch(r.type){case"event":const l=r;switch(l.event){case"output":o(!1,l.body.source);break;case"loadedSource":o(!1,l.body.source);break;case"breakpoint":o(!1,l.body.breakpoint.source);break;default:break}break;case"request":const i=r;switch(i.command){case"setBreakpoints":o(!0,i.arguments.source);break;case"breakpointLocations":o(!0,i.arguments.source);break;case"source":o(!0,i.arguments.source);break;case"gotoTargets":o(!0,i.arguments.source);break;case"launchVSCode":i.arguments.args.forEach(y=>o(!1,y));break;default:break}break;case"response":const d=r;if(d.success&&d.body)switch(d.command){case"stackTrace":d.body.stackFrames.forEach(y=>o(!1,y.source));break;case"loadedSources":d.body.sources.forEach(y=>o(!1,y));break;case"scopes":d.body.scopes.forEach(y=>o(!1,y.source));break;case"setFunctionBreakpoints":d.body.breakpoints.forEach(y=>o(!1,y.source));break;case"setBreakpoints":d.body.breakpoints.forEach(y=>o(!1,y.source));break;default:break}break}}function a(r){return r.filter(o=>{var l;return!((l=o.presentation)===null||l===void 0?void 0:l.hidden)}).sort((o,l)=>o.presentation?l.presentation?o.presentation.group?l.presentation.group?o.presentation.group!==l.presentation.group?o.presentation.group.localeCompare(l.presentation.group):t(o.presentation.order,l.presentation.order):-1:l.presentation.group?1:t(o.presentation.order,l.presentation.order):-1:l.presentation?1:0)}e.getVisibleAndSorted=a;function t(r,o){return typeof r!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:r-o}}),define(we[40],Ee([0,1,28,16,10,21,64]),function(re,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookCellRunState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var C;(function(k){k[k.Markdown=1]="Markdown",k[k.Code=2]="Code"})(C=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(k){k[k.Running=1]="Running",k[k.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={editable:!0,runnable:!0,cellEditable:!0,cellRunnable:!0,cellHasExecutionOrder:!0,custom:{},runState:D.Idle,trusted:!0};var n;(function(k){k[k.Running=1]="Running",k[k.Idle=2]="Idle",k[k.Success=3]="Success",k[k.Error=4]="Error"})(n=e.NotebookCellRunState||(e.NotebookCellRunState={}));var A;(function(k){k[k.ModelChange=1]="ModelChange",k[k.Move=2]="Move",k[k.CellClearOutput=3]="CellClearOutput",k[k.CellsClearOutput=4]="CellsClearOutput",k[k.ChangeLanguage=5]="ChangeLanguage",k[k.Initialize=6]="Initialize",k[k.ChangeCellMetadata=7]="ChangeCellMetadata",k[k.Output=8]="Output",k[k.OutputItem=9]="OutputItem",k[k.ChangeCellContent=10]="ChangeCellContent",k[k.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",k[k.Unknown=12]="Unknown"})(A=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var I;(function(k){k[k.Handle=0]="Handle",k[k.Index=1]="Index"})(I=e.SelectionStateType||(e.SelectionStateType={}));var p;(function(k){k[k.Replace=1]="Replace",k[k.Output=2]="Output",k[k.Metadata=3]="Metadata",k[k.CellLanguage=4]="CellLanguage",k[k.DocumentMetadata=5]="DocumentMetadata",k[k.OutputsSplice=6]="OutputsSplice",k[k.Move=7]="Move",k[k.Unknown=8]="Unknown",k[k.CellContent=9]="CellContent",k[k.OutputItems=10]="OutputItems"})(p=e.CellEditType||(e.CellEditType={}));function f(k){const m=s.parse(k);return m?m.notebook.toString():k.toString()}e.getCellUndoRedoComparisonKey=f;var s;(function(k){k.scheme=S.Schemas.vscodeNotebookCell;const m=/^ch(\d{7,})/;function w(Q,J){return Q.with({scheme:k.scheme,fragment:`ch${J.toString().padStart(7,"0")}${Q.scheme!==S.Schemas.file?Q.scheme:""}`})}k.generate=w;function R(Q){if(Q.scheme===k.scheme){const J=m.exec(Q.fragment);if(!!J)return{handle:Number(J[1]),notebook:Q.with({scheme:Q.fragment.substr(J[0].length)||S.Schemas.file,fragment:null})}}}k.parse=R;function F(Q,J){return Q.with({scheme:S.Schemas.vscodeNotebookCellMetadata,fragment:`ch${J.toString().padStart(7,"0")}${Q.scheme!==S.Schemas.file?Q.scheme:""}`})}k.generateCellMetadataUri=F;function B(Q){if(Q.scheme===S.Schemas.vscodeNotebookCellMetadata){const J=m.exec(Q.fragment);if(!!J)return{handle:Number(J[1]),notebook:Q.with({scheme:Q.fragment.substr(J[0].length)||S.Schemas.file,fragment:null})}}}k.parseCellMetadataUri=B})(s=e.CellUri||(e.CellUri={}));const h=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}]]);function v(k){var m,w;return(w=(m=h.get(k))===null||m===void 0?void 0:m.alwaysSecure)!==null&&w!==void 0?w:!1}e.mimeTypeIsAlwaysSecure=v;function g(k){var m,w;return(w=(m=h.get(k))===null||m===void 0?void 0:m.supportedByCore)!==null&&w!==void 0?w:!1}e.mimeTypeSupportedByCore=g;function b(k,m){return P.isWindows&&(k=k.replace(/\//g,"\\"),m=m.replace(/\//g,"\\")),_.match(k,m)}function c(k,m,w){let R=0;for(let F=0;F<m.length;F++){if(b(m[F],k))return R;R++}for(let F=0;F<w.length;F++){if(b(w[F],k))return R;R++}return R}function u(k,m,w){return k.sort((R,F)=>c(R,m,w)-c(F,m,w))}e.sortMimeTypes=u;function a(k,m,w,R=(F,B)=>F===B){const F=[];function B(z,ae,L){if(!(ae===0&&L.length===0)){const N=F[F.length-1];N&&N.start+N.deleteCount===z?(N.deleteCount+=ae,N.toInsert.push(...L)):F.push({start:z,deleteCount:ae,toInsert:L})}}let Q=0,J=0;for(;;){if(Q===k.length){B(Q,0,m.slice(J));break}if(J===m.length){B(Q,k.length-Q,[]);break}const z=k[Q],ae=m[J];if(R(z,ae)){Q+=1,J+=1;continue}w(ae)?(B(Q,1,[]),Q+=1):(B(Q,0,[ae]),J+=1)}return F}e.diff=a,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new E.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=new E.RawContextKey("notebookEditorCursorAtEditorBeginEnd",!1);var t;(function(k){k.default="default",k.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(k){const m=k;return!!((typeof m.include=="string"||_.isRelativePattern(m.include))&&(typeof m.exclude=="string"||_.isRelativePattern(m.exclude)))}e.isDocumentExcludePattern=r;function o(k,m,w){if(Array.isArray(k.viewType)&&k.viewType.indexOf(m)>=0||k.viewType===m)return!0;if(k.filenamePattern){let R=r(k.filenamePattern)?k.filenamePattern.include:k.filenamePattern,F=r(k.filenamePattern)?k.filenamePattern.exclude:void 0;if(_.match(R,(0,T.basename)(w.fsPath).toLowerCase()))return!(F&&_.match(F,(0,T.basename)(w.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class l{constructor(m){this.textModel=m}getElements(){const m=new Int32Array(this.textModel.cells.length);for(let w=0;w<this.textModel.cells.length;w++)m[w]=this.textModel.cells[w].getHashValue();return m}}e.CellSequence=l,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview";var i;(function(k){k[k.LEFT=0]="LEFT",k[k.RIGHT=1]="RIGHT"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function d(k){const m=k.shift();return m===void 0?[]:k.reduce(function(w,R){return R<=w[0][1]?w[0][1]=R+1:w.unshift([R,R+1]),w},[[m,m+1]]).reverse().map(w=>({start:w[0],end:w[1]}))}e.cellIndexesToRanges=d;function y(k){return k.reduce((w,R)=>{for(let F=R.start;F<R.end;F++)w.push(F);return w},[])}e.cellRangesToIndexes=y});var tt=this&&this.__classPrivateFieldSet||function(re,e,_){if(!e.has(re))throw new TypeError("attempted to set private field on non-instance");return e.set(re,_),_},We=this&&this.__classPrivateFieldGet||function(re,e){if(!e.has(re))throw new TypeError("attempted to get private field on non-instance");return e.get(re)};define(we[7],Ee([0,1,14,11,80,22,12,2,29,65,90,40]),function(re,e,_,S,T,P,E,C,D,n,A,I){"use strict";var p,f,s,h,v,g,b,c,u,a,t,r,o,l,i,d;Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestState=e.TestItem=e.TestMessageSeverity=e.TestResult=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookRunState=e.NotebookCellRunState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function y(W){function M(){return Reflect.construct(W,arguments,this.constructor)}return Object.defineProperty(M,"name",Object.getOwnPropertyDescriptor(W,"name")),Object.setPrototypeOf(M,W),Object.setPrototypeOf(M.prototype,W.prototype),M}let k=s=class{constructor(M){p.set(this,void 0),tt(this,p,M)}static from(...M){let ne=M;return new s(function(){if(ne){for(const U of ne)U&&typeof U.dispose=="function"&&U.dispose();ne=void 0}})}dispose(){typeof We(this,p)=="function"&&(We(this,p).call(this),tt(this,p,void 0))}};p=new WeakMap,k=s=Ve([y],k),e.Disposable=k;let m=h=class{constructor(M,ne){if(M<0)throw(0,S.illegalArgument)("line must be non-negative");if(ne<0)throw(0,S.illegalArgument)("character must be non-negative");this._line=M,this._character=ne}static Min(...M){if(M.length===0)throw new TypeError;let ne=M[0];for(let U=1;U<M.length;U++){const Y=M[U];Y.isBefore(ne)&&(ne=Y)}return ne}static Max(...M){if(M.length===0)throw new TypeError;let ne=M[0];for(let U=1;U<M.length;U++){const Y=M[U];Y.isAfter(ne)&&(ne=Y)}return ne}static isPosition(M){if(!M)return!1;if(M instanceof h)return!0;let{line:ne,character:U}=M;return typeof ne=="number"&&typeof U=="number"}get line(){return this._line}get character(){return this._character}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,ne=0){if(M===null||ne===null)throw(0,S.illegalArgument)();let U;return typeof M=="undefined"?U=0:typeof M=="number"?U=M:(U=typeof M.lineDelta=="number"?M.lineDelta:0,ne=typeof M.characterDelta=="number"?M.characterDelta:0),U===0&&ne===0?this:new h(this.line+U,this.character+ne)}with(M,ne=this.character){if(M===null||ne===null)throw(0,S.illegalArgument)();let U;return typeof M=="undefined"?U=this.line:typeof M=="number"?U=M:(U=typeof M.line=="number"?M.line:this.line,ne=typeof M.character=="number"?M.character:this.character),U===this.line&&ne===this.character?this:new h(U,ne)}toJSON(){return{line:this.line,character:this.character}}};m=h=Ve([y],m),e.Position=m;let w=v=class{constructor(M,ne,U,Y){let ge,Ke;if(typeof M=="number"&&typeof ne=="number"&&typeof U=="number"&&typeof Y=="number"?(ge=new m(M,ne),Ke=new m(U,Y)):M instanceof m&&ne instanceof m&&(ge=M,Ke=ne),!ge||!Ke)throw new Error("Invalid arguments");ge.isBefore(Ke)?(this._start=ge,this._end=Ke):(this._start=Ke,this._end=ge)}static isRange(M){return M instanceof v?!0:M?m.isPosition(M.start)&&m.isPosition(M.end):!1}get start(){return this._start}get end(){return this._end}contains(M){return M instanceof v?this.contains(M._start)&&this.contains(M._end):M instanceof m?!(M.isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const ne=m.Max(M.start,this._start),U=m.Min(M.end,this._end);if(!ne.isAfter(U))return new v(ne,U)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const ne=m.Min(M.start,this._start),U=m.Max(M.end,this.end);return new v(ne,U)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,ne=this.end){if(M===null||ne===null)throw(0,S.illegalArgument)();let U;return M?m.isPosition(M)?U=M:(U=M.start||this.start,ne=M.end||this.end):U=this.start,U.isEqual(this._start)&&ne.isEqual(this.end)?this:new v(U,ne)}toJSON(){return[this.start,this.end]}};w=v=Ve([y],w),e.Range=w;let R=g=class extends w{constructor(M,ne,U,Y){let ge,Ke;if(typeof M=="number"&&typeof ne=="number"&&typeof U=="number"&&typeof Y=="number"?(ge=new m(M,ne),Ke=new m(U,Y)):M instanceof m&&ne instanceof m&&(ge=M,Ke=ne),!ge||!Ke)throw new Error("Invalid arguments");super(ge,Ke);this._anchor=ge,this._active=Ke}static isSelection(M){return M instanceof g?!0:M?w.isRange(M)&&m.isPosition(M.anchor)&&m.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};R=g=Ve([y],R),e.Selection=R;class F{constructor(M,ne,U){if(typeof M!="string"||M.length===0)throw(0,S.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,S.illegalArgument)("port");if(typeof U!="undefined"&&(typeof U!="string"||U.length===0||!/^[0-9A-Za-z\-]+$/.test(U)))throw(0,S.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(ne),this.connectionToken=U}}e.ResolvedAuthority=F;class B extends Error{constructor(M,ne=A.RemoteAuthorityResolverErrorCode.Unknown,U){super(M);this._message=M,this._code=ne,this._detail=U,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,B.prototype)}static NotAvailable(M,ne){return new B(M,A.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(M){return new B(M,A.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=B;var Q;(function(W){W[W.LF=1]="LF",W[W.CRLF=2]="CRLF"})(Q=e.EndOfLine||(e.EndOfLine={}));var J;(function(W){W[W.Replace=1]="Replace",W[W.Append=2]="Append",W[W.Prepend=3]="Prepend"})(J=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let z=b=class{constructor(M,ne){this._range=M,this._newText=ne}static isTextEdit(M){return M instanceof b?!0:M?w.isRange(M)&&typeof M.newText=="string":!1}static replace(M,ne){return new b(M,ne)}static insert(M,ne){return b.replace(new w(M,M),ne)}static delete(M){return b.replace(M,"")}static setEndOfLine(M){const ne=new b(new w(new m(0,0),new m(0,0)),"");return ne.newEol=M,ne}get range(){return this._range}set range(M){if(M&&!w.isRange(M))throw(0,S.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,S.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,S.illegalArgument)("newEol");this._newEol=M}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};z=b=Ve([y],z),e.TextEdit=z;var ae;(function(W){W[W.File=1]="File",W[W.Text=2]="Text",W[W.Cell=3]="Cell",W[W.CellOutput=4]="CellOutput",W[W.CellReplace=5]="CellReplace",W[W.CellOutputItem=6]="CellOutputItem"})(ae=e.FileEditType||(e.FileEditType={}));let L=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,ne,U,Y){this._edits.push({_type:1,from:M,to:ne,options:U,metadata:Y})}createFile(M,ne,U){this._edits.push({_type:1,from:void 0,to:M,options:ne,metadata:U})}deleteFile(M,ne,U){this._edits.push({_type:1,from:M,to:void 0,options:ne,metadata:U})}replaceNotebookMetadata(M,ne,U){this._edits.push({_type:3,metadata:U,uri:M,edit:{editType:5,metadata:Object.assign(Object.assign({},I.notebookDocumentMetadataDefaults),ne)},notebookMetadata:ne})}replaceNotebookCells(M,ne,U,Y,ge){(ne!==U||Y.length>0)&&this._edits.push({_type:5,uri:M,index:ne,count:U-ne,cells:Y,metadata:ge})}replaceNotebookCellOutput(M,ne,U,Y){this._editNotebookCellOutput(M,ne,!1,U,Y)}appendNotebookCellOutput(M,ne,U,Y){this._editNotebookCellOutput(M,ne,!0,U,Y)}replaceNotebookCellOutputItems(M,ne,U,Y,ge){this._editNotebookCellOutputItems(M,ne,U,!1,Y,ge)}appendNotebookCellOutputItems(M,ne,U,Y,ge){this._editNotebookCellOutputItems(M,ne,U,!0,Y,ge)}_editNotebookCellOutputItems(M,ne,U,Y,ge,Ke){this._edits.push({_type:6,metadata:Ke,uri:M,index:ne,outputId:U,append:Y,newOutputItems:ge})}_editNotebookCellOutput(M,ne,U,Y,ge){this._edits.push({_type:4,metadata:ge,uri:M,index:ne,append:U,newOutputs:Y,newMetadata:void 0})}replaceNotebookCellMetadata(M,ne,U,Y){this._edits.push({_type:3,metadata:Y,uri:M,edit:{editType:3,index:ne,metadata:U}})}replace(M,ne,U,Y){this._edits.push({_type:2,uri:M,edit:new z(ne,U),metadata:Y})}insert(M,ne,U,Y){this.replace(M,new w(ne,ne),U,Y)}delete(M,ne,U){this.replace(M,ne,"",U)}has(M){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===M.toString())}set(M,ne){if(ne)for(const U of ne)U&&this._edits.push({_type:2,uri:M,edit:U});else{for(let U=0;U<this._edits.length;U++){const Y=this._edits[U];Y._type===2&&Y.uri.toString()===M.toString()&&(this._edits[U]=void 0)}(0,_.coalesceInPlace)(this._edits)}}get(M){const ne=[];for(let U of this._edits)U._type===2&&U.uri.toString()===M.toString()&&ne.push(U.edit);return ne}entries(){const M=new P.ResourceMap;for(let ne of this._edits)if(ne._type===2){let U=M.get(ne.uri);U||(U=[ne.uri,[]],M.set(ne.uri,U)),U[1].push(ne.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};L=Ve([y],L),e.WorkspaceEdit=L;let N=c=class{constructor(M){this._tabstop=1,this.value=M||""}static isSnippetString(M){return M instanceof c?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}appendText(M){return this.value+=c._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,ne=this._tabstop++){if(typeof M=="function"){const U=new c;U._tabstop=this._tabstop,M(U),this._tabstop=U._tabstop,M=U.value}else M=c._escape(M);return this.value+="${",this.value+=ne,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,ne=this._tabstop++){const U=M.map(Y=>Y.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=U,this.value+="|}",this}appendVariable(M,ne){if(typeof ne=="function"){const U=new c;U._tabstop=this._tabstop,ne(U),this._tabstop=U._tabstop,ne=U.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};N=c=Ve([y],N),e.SnippetString=N;var H;(function(W){W[W.Unnecessary=1]="Unnecessary",W[W.Deprecated=2]="Deprecated"})(H=e.DiagnosticTag||(e.DiagnosticTag={}));var O;(function(W){W[W.Hint=3]="Hint",W[W.Information=2]="Information",W[W.Warning=1]="Warning",W[W.Error=0]="Error"})(O=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let K=u=class{constructor(M,ne){if(this.uri=M,ne)if(ne instanceof w)this.range=ne;else if(ne instanceof m)this.range=new w(ne,ne);else throw new Error("Illegal argument")}static isLocation(M){return M instanceof u?!0:M?w.isRange(M.range)&&C.URI.isUri(M.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};K=u=Ve([y],K),e.Location=K;let le=class{constructor(M,ne){this.location=M,this.message=ne}static is(M){return M?typeof M.message=="string"&&M.location&&w.isRange(M.location.range)&&C.URI.isUri(M.location.uri):!1}static isEqual(M,ne){return M===ne?!0:!M||!ne?!1:M.message===ne.message&&M.location.range.isEqual(ne.location.range)&&M.location.uri.toString()===ne.location.uri.toString()}};le=Ve([y],le),e.DiagnosticRelatedInformation=le;let ue=class{constructor(M,ne,U=O.Error){if(!w.isRange(M))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=M,this.message=ne,this.severity=U}toJSON(){return{severity:O[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,ne){return M===ne?!0:!M||!ne?!1:M.message===ne.message&&M.severity===ne.severity&&M.code===ne.code&&M.severity===ne.severity&&M.source===ne.source&&M.range.isEqual(ne.range)&&(0,_.equals)(M.tags,ne.tags)&&(0,_.equals)(M.relatedInformation,ne.relatedInformation,le.isEqual)}};ue=Ve([y],ue),e.Diagnostic=ue;let pe=class{constructor(M,ne){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:(0,T.isMarkdownString)(M)?this.contents=[M]:this.contents=[M],this.range=ne}};pe=Ve([y],pe),e.Hover=pe;var ve;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(ve=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Re=class{constructor(M,ne=ve.Text){this.range=M,this.kind=ne}toJSON(){return{range:this.range,kind:ve[this.kind]}}};Re=Ve([y],Re),e.DocumentHighlight=Re;var He;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(He=e.SymbolKind||(e.SymbolKind={}));var Fe;(function(W){W[W.Deprecated=1]="Deprecated"})(Fe=e.SymbolTag||(e.SymbolTag={}));let ze=a=class{constructor(M,ne,U,Y,ge){this.name=M,this.kind=ne,this.containerName=ge,typeof U=="string"&&(this.containerName=U),Y instanceof K?this.location=Y:U instanceof w&&(this.location=new K(Y,U)),a.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:He[this.kind],location:this.location,containerName:this.containerName}}};ze=a=Ve([y],ze),e.SymbolInformation=ze;let $=t=class{constructor(M,ne,U,Y,ge){this.name=M,this.detail=ne,this.kind=U,this.range=Y,this.selectionRange=ge,this.children=[],t.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children&&M.children.forEach(t.validate)}};$=t=Ve([y],$),e.DocumentSymbol=$;var G;(function(W){W[W.Automatic=1]="Automatic",W[W.Manual=2]="Manual"})(G=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let te=class{constructor(M,ne){this.title=M,this.kind=ne}};te=Ve([y],te),e.CodeAction=te;let ie=r=class{constructor(M){this.value=M}append(M){return new r(this.value?this.value+r.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+r.sep)}};ie.sep=".",ie=r=Ve([y],ie),e.CodeActionKind=ie,ie.Empty=new ie(""),ie.QuickFix=ie.Empty.append("quickfix"),ie.Refactor=ie.Empty.append("refactor"),ie.RefactorExtract=ie.Refactor.append("extract"),ie.RefactorInline=ie.Refactor.append("inline"),ie.RefactorRewrite=ie.Refactor.append("rewrite"),ie.Source=ie.Empty.append("source"),ie.SourceOrganizeImports=ie.Source.append("organizeImports"),ie.SourceFixAll=ie.Source.append("fixAll");let he=class{constructor(M,ne){if(this.range=M,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};he=Ve([y],he),e.SelectionRange=he;class De{constructor(M,ne,U,Y,ge,Ke){this.kind=M,this.name=ne,this.detail=U,this.uri=Y,this.range=ge,this.selectionRange=Ke}}e.CallHierarchyItem=De;class Le{constructor(M,ne){this.fromRanges=ne,this.from=M}}e.CallHierarchyIncomingCall=Le;class me{constructor(M,ne){this.fromRanges=ne,this.to=M}}e.CallHierarchyOutgoingCall=me;let Ce=class{constructor(M,ne){this.range=M,this.command=ne}get isResolved(){return!!this.command}};Ce=Ve([y],Ce),e.CodeLens=Ce;let ke=o=class{constructor(M,ne=!1){f.set(this,void 0),tt(this,f,new T.MarkdownString(M,{supportThemeIcons:ne}))}static isMarkdownString(M){return M instanceof o?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}get value(){return We(this,f).value}set value(M){We(this,f).value=M}get isTrusted(){return We(this,f).isTrusted}set isTrusted(M){We(this,f).isTrusted=M}get supportThemeIcons(){return We(this,f).supportThemeIcons}appendText(M){return We(this,f).appendText(M),this}appendMarkdown(M){return We(this,f).appendMarkdown(M),this}appendCodeblock(M,ne){return We(this,f).appendCodeblock(ne!=null?ne:"",M),this}};f=new WeakMap,ke=o=Ve([y],ke),e.MarkdownString=ke;let Ue=class{constructor(M,ne){this.label=M,this.documentation=ne}};Ue=Ve([y],Ue),e.ParameterInformation=Ue;let be=class{constructor(M,ne){this.label=M,this.documentation=ne,this.parameters=[]}};be=Ve([y],be),e.SignatureInformation=be;let je=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};je=Ve([y],je),e.SignatureHelp=je;var V;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(V=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Z;(function(W){W[W.Other=0]="Other",W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(Z=e.InlineHintKind||(e.InlineHintKind={}));let _e=class{constructor(M,ne,U){this.text=M,this.range=ne,this.kind=U}};_e=Ve([y],_e),e.InlineHint=_e;var Me;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Me=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $e;(function(W){W[W.Text=0]="Text",W[W.Method=1]="Method",W[W.Function=2]="Function",W[W.Constructor=3]="Constructor",W[W.Field=4]="Field",W[W.Variable=5]="Variable",W[W.Class=6]="Class",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Unit=10]="Unit",W[W.Value=11]="Value",W[W.Enum=12]="Enum",W[W.Keyword=13]="Keyword",W[W.Snippet=14]="Snippet",W[W.Color=15]="Color",W[W.File=16]="File",W[W.Reference=17]="Reference",W[W.Folder=18]="Folder",W[W.EnumMember=19]="EnumMember",W[W.Constant=20]="Constant",W[W.Struct=21]="Struct",W[W.Event=22]="Event",W[W.Operator=23]="Operator",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue"})($e=e.CompletionItemKind||(e.CompletionItemKind={}));var Ne;(function(W){W[W.Deprecated=1]="Deprecated"})(Ne=e.CompletionItemTag||(e.CompletionItemTag={}));let Je=class{constructor(M,ne){this.label=M,this.kind=ne}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&$e[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Je=Ve([y],Je),e.CompletionItem=Je;let x=class{constructor(M=[],ne=!1){this.items=M,this.isIncomplete=ne}};x=Ve([y],x),e.CompletionList=x;var ee;(function(W){W[W.Active=-1]="Active",W[W.Beside=-2]="Beside",W[W.One=1]="One",W[W.Two=2]="Two",W[W.Three=3]="Three",W[W.Four=4]="Four",W[W.Five=5]="Five",W[W.Six=6]="Six",W[W.Seven=7]="Seven",W[W.Eight=8]="Eight",W[W.Nine=9]="Nine"})(ee=e.ViewColumn||(e.ViewColumn={}));var ce;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(ce=e.StatusBarAlignment||(e.StatusBarAlignment={}));var j;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative"})(j=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var X;(function(W){W[W.Manual=1]="Manual",W[W.AfterDelay=2]="AfterDelay",W[W.FocusOut=3]="FocusOut"})(X=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var se;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(se=e.TextEditorRevealType||(e.TextEditorRevealType={}));var de;(function(W){W[W.Keyboard=1]="Keyboard",W[W.Mouse=2]="Mouse",W[W.Command=3]="Command"})(de=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Se;(function(W){W[W.OpenOpen=0]="OpenOpen",W[W.ClosedClosed=1]="ClosedClosed",W[W.OpenClosed=2]="OpenClosed",W[W.ClosedOpen=3]="ClosedOpen"})(Se=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(W){function M(ne){switch(ne){case"keyboard":return W.Keyboard;case"mouse":return W.Mouse;case"api":return W.Command}}W.fromValue=M}(de=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let xe=class{constructor(M,ne){if(ne&&!C.URI.isUri(ne))throw(0,S.illegalArgument)("target");if(!w.isRange(M)||M.isEmpty)throw(0,S.illegalArgument)("range");this.range=M,this.target=ne}};xe=Ve([y],xe),e.DocumentLink=xe;let Oe=class{constructor(M,ne,U,Y){this.red=M,this.green=ne,this.blue=U,this.alpha=Y}};Oe=Ve([y],Oe),e.Color=Oe;let Be=class{constructor(M,ne){if(ne&&!(ne instanceof Oe))throw(0,S.illegalArgument)("color");if(!w.isRange(M)||M.isEmpty)throw(0,S.illegalArgument)("range");this.range=M,this.color=ne}};Be=Ve([y],Be),e.ColorInformation=Be;let Qe=class{constructor(M){if(!M||typeof M!="string")throw(0,S.illegalArgument)("label");this.label=M}};Qe=Ve([y],Qe),e.ColorPresentation=Qe;var nt;(function(W){W[W.RGB=0]="RGB",W[W.HEX=1]="HEX",W[W.HSL=2]="HSL"})(nt=e.ColorFormat||(e.ColorFormat={}));var et;(function(W){W[W.Error=0]="Error",W[W.Warning=1]="Warning",W[W.Information=2]="Information"})(et=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Xe;(function(W){W[W.Always=1]="Always",W[W.Silent=2]="Silent",W[W.Never=3]="Never"})(Xe=e.TaskRevealKind||(e.TaskRevealKind={}));var fe;(function(W){W[W.Shared=1]="Shared",W[W.Dedicated=2]="Dedicated",W[W.New=3]="New"})(fe=e.TaskPanelKind||(e.TaskPanelKind={}));let ye=l=class{constructor(M,ne){if(typeof M!="string"||typeof ne!="string")throw(0,S.illegalArgument)("name");this._id=M}static from(M){switch(M){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}get id(){return this._id}};ye.Clean=new l("clean","Clean"),ye.Build=new l("build","Build"),ye.Rebuild=new l("rebuild","Rebuild"),ye.Test=new l("test","Test"),ye=l=Ve([y],ye),e.TaskGroup=ye;function oe(W){let M="";for(let ne=0;ne<W.length;ne++)M+=W[ne].replace(/,/g,",,")+",";return M}let q=class{constructor(M,ne,U){if(typeof M!="string")throw(0,S.illegalArgument)("process");this._args=[],this._process=M,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=U):this._options=ne)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,S.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(let ne of this._args)M.push(ne);return oe(M)}};q=Ve([y],q),e.ProcessExecution=q;let Ie=class{constructor(M,ne,U){if(this._args=[],Array.isArray(ne)){if(!M)throw(0,S.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,S.illegalArgument)("command");this._command=M,this._args=ne,this._options=U}else{if(typeof M!="string")throw(0,S.illegalArgument)("commandLine");this._commandLine=M,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,S.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,S.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ne of this._args)M.push(typeof ne=="string"?ne:ne.value);return oe(M)}};Ie=Ve([y],Ie),e.ShellExecution=Ie;var Pe;(function(W){W[W.Escape=1]="Escape",W[W.Strong=2]="Strong",W[W.Weak=3]="Weak"})(Pe=e.ShellQuoting||(e.ShellQuoting={}));var Ze;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace"})(Ze=e.TaskScope||(e.TaskScope={}));class Ae{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,D.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=Ae;let it=i=class{constructor(M,ne,U,Y,ge,Ke){this.__deprecated=!1,this._definition=this.definition=M;let Ye;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=U,this.execution=Y,Ye=ge,this.__deprecated=!0):ne===Ze.Global||ne===Ze.Workspace?(this.target=ne,this._name=this.name=U,this._source=this.source=Y,this.execution=ge,Ye=Ke):(this.target=ne,this._name=this.name=U,this._source=this.source=Y,this.execution=ge,Ye=Ke),typeof Ye=="string"?(this._problemMatchers=[Ye],this._hasDefinedMatchers=!0):Array.isArray(Ye)?(this._problemMatchers=Ye,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof q?this._definition={type:i.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ie?this._definition={type:i.ShellType,id:this._execution.computeId()}:this._execution instanceof Ae?this._definition={type:i.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:i.EmptyType,id:(0,D.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,S.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,S.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const ne=this._definition.type;(i.EmptyType===ne||i.ProcessType===ne||i.ShellType===ne||i.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,S.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};it.ExtensionCallbackType="customExecution",it.ProcessType="process",it.ShellType="shell",it.EmptyType="$empty",it=i=Ve([y],it),e.Task=it;var st;(function(W){W[W.SourceControl=1]="SourceControl",W[W.Window=10]="Window",W[W.Notification=15]="Notification"})(st=e.ProgressLocation||(e.ProgressLocation={}));let Ge=class{constructor(M,ne=ut.None){this.collapsibleState=ne,C.URI.isUri(M)?this.resourceUri=M:this.label=M}};Ge=Ve([y],Ge),e.TreeItem=Ge;var ut;(function(W){W[W.None=0]="None",W[W.Collapsed=1]="Collapsed",W[W.Expanded=2]="Expanded"})(ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ot=class{constructor(M,ne){this.id=M,this.color=ne}};ot=Ve([y],ot),e.ThemeIcon=ot,ot.File=new ot("file"),ot.Folder=new ot("folder");let ct=class{constructor(M){this.id=M}};ct=Ve([y],ct),e.ThemeColor=ct;var Ct;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace",W[W.WorkspaceFolder=3]="WorkspaceFolder"})(Ct=e.ConfigurationTarget||(e.ConfigurationTarget={}));let yt=class{constructor(M,ne){if(typeof M!="string"&&(!M||!C.URI.isUri(M)&&!C.URI.isUri(M.uri)))throw(0,S.illegalArgument)("base");if(typeof ne!="string")throw(0,S.illegalArgument)("pattern");typeof M=="string"?(this.baseFolder=C.URI.file(M),this.base=M):C.URI.isUri(M)?(this.baseFolder=M,this.base=M.fsPath):(this.baseFolder=M.uri,this.base=M.uri.fsPath),this.pattern=ne}};yt=Ve([y],yt),e.RelativePattern=yt;let pt=class{constructor(M,ne,U,Y){this.enabled=typeof M=="boolean"?M:!0,typeof ne=="string"&&(this.condition=ne),typeof U=="string"&&(this.hitCondition=U),typeof Y=="string"&&(this.logMessage=Y)}get id(){return this._id||(this._id=(0,D.generateUuid)()),this._id}};pt=Ve([y],pt),e.Breakpoint=pt;let lt=class extends pt{constructor(M,ne,U,Y,ge){super(ne,U,Y,ge);if(M===null)throw(0,S.illegalArgument)("location");this.location=M}};lt=Ve([y],lt),e.SourceBreakpoint=lt;let ft=class extends pt{constructor(M,ne,U,Y,ge){super(ne,U,Y,ge);this.functionName=M}};ft=Ve([y],ft),e.FunctionBreakpoint=ft;let dt=class extends pt{constructor(M,ne,U,Y,ge,Ke,Ye){super(Y,ge,Ke,Ye);if(!ne)throw(0,S.illegalArgument)("dataId");this.label=M,this.dataId=ne,this.canPersist=U}};dt=Ve([y],dt),e.DataBreakpoint=dt;let kt=class{constructor(M,ne,U){this.command=M,this.args=ne||[],this.options=U}};kt=Ve([y],kt),e.DebugAdapterExecutable=kt;let Et=class{constructor(M,ne){this.port=M,this.host=ne}};Et=Ve([y],Et),e.DebugAdapterServer=Et;let It=class{constructor(M){this.path=M}};It=Ve([y],It),e.DebugAdapterNamedPipeServer=It;let Ot=class{constructor(M){this.implementation=M}};Ot=Ve([y],Ot),e.DebugAdapterInlineImplementation=Ot;let Nt=class{constructor(M,ne){this.range=M,this.expression=ne}};Nt=Ve([y],Nt),e.EvaluatableExpression=Nt;let wt=class{constructor(M,ne){this.range=M,this.text=ne}};wt=Ve([y],wt),e.InlineValueText=wt;let Ht=class{constructor(M,ne,U=!0){this.range=M,this.variableName=ne,this.caseSensitiveLookup=U}};Ht=Ve([y],Ht),e.InlineValueVariableLookup=Ht;let zt=class{constructor(M,ne){this.range=M,this.expression=ne}};zt=Ve([y],zt),e.InlineValueEvaluatableExpression=zt;let gt=class{constructor(M,ne){this.frameId=M,this.stoppedLocation=ne}};gt=Ve([y],gt),e.InlineValueContext=gt;var St;(function(W){W[W.Changed=1]="Changed",W[W.Created=2]="Created",W[W.Deleted=3]="Deleted"})(St=e.FileChangeType||(e.FileChangeType={}));let Ut=d=class extends Error{constructor(M,ne=n.FileSystemProviderErrorCode.Unknown,U){var Y;super(C.URI.isUri(M)?M.toString(!0):M);this.code=(Y=U==null?void 0:U.name)!==null&&Y!==void 0?Y:"Unknown",(0,n.markAsFileSystemProviderError)(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,d.prototype),typeof Error.captureStackTrace=="function"&&typeof U=="function"&&Error.captureStackTrace(this,U)}static FileExists(M){return new d(M,n.FileSystemProviderErrorCode.FileExists,d.FileExists)}static FileNotFound(M){return new d(M,n.FileSystemProviderErrorCode.FileNotFound,d.FileNotFound)}static FileNotADirectory(M){return new d(M,n.FileSystemProviderErrorCode.FileNotADirectory,d.FileNotADirectory)}static FileIsADirectory(M){return new d(M,n.FileSystemProviderErrorCode.FileIsADirectory,d.FileIsADirectory)}static NoPermissions(M){return new d(M,n.FileSystemProviderErrorCode.NoPermissions,d.NoPermissions)}static Unavailable(M){return new d(M,n.FileSystemProviderErrorCode.Unavailable,d.Unavailable)}};Ut=d=Ve([y],Ut),e.FileSystemError=Ut;let Vt=class{constructor(M,ne,U){this.start=M,this.end=ne,this.kind=U}};Vt=Ve([y],Vt),e.FoldingRange=Vt;var Wt;(function(W){W[W.Comment=1]="Comment",W[W.Imports=2]="Imports",W[W.Region=3]="Region"})(Wt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var at;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(at=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var dn;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(dn=e.CommentMode||(e.CommentMode={}));class Pt{constructor(M,ne=[]){this.tokenTypes=M,this.tokenModifiers=ne}}e.SemanticTokensLegend=Pt;function Ft(W){return typeof W=="undefined"||(0,E.isStringArray)(W)}class $t{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let ne=0,U=M.tokenTypes.length;ne<U;ne++)this._tokenTypeStrToInt.set(M.tokenTypes[ne],ne);for(let ne=0,U=M.tokenModifiers.length;ne<U;ne++)this._tokenModifierStrToInt.set(M.tokenModifiers[ne],ne)}}push(M,ne,U,Y,ge){if(typeof M=="number"&&typeof ne=="number"&&typeof U=="number"&&typeof Y=="number"&&(typeof ge=="number"||typeof ge=="undefined"))return typeof ge=="undefined"&&(ge=0),this._pushEncoded(M,ne,U,Y,ge);if(w.isRange(M)&&typeof ne=="string"&&Ft(U))return this._push(M,ne,U);throw(0,S.illegalArgument)()}_push(M,ne,U){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const Y=M.start.line,ge=M.start.character,Ke=M.end.character-M.start.character,Ye=this._tokenTypeStrToInt.get(ne);let rt=0;if(U)for(const mt of U){if(!this._tokenModifierStrToInt.has(mt))throw new Error("`tokenModifier` is not in the provided legend");const vt=this._tokenModifierStrToInt.get(mt);rt|=1<<vt>>>0}this._pushEncoded(Y,ge,Ke,Ye,rt)}_pushEncoded(M,ne,U,Y,ge){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const rt=this._data.length/5|0;let mt=0,vt=0;for(let _t=0;_t<rt;_t++){let bt=this._data[5*_t],Dt=this._data[5*_t+1];bt===0?(bt=mt,Dt+=vt):bt+=mt,this._data[5*_t]=bt,this._data[5*_t+1]=Dt,mt=bt,vt=Dt}}let Ke=M,Ye=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Ke-=this._prevLine,Ke===0&&(Ye-=this._prevChar)),this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=U,this._data[this._dataLen++]=Y,this._data[this._dataLen++]=ge,this._prevLine=M,this._prevChar=ne}static _sortAndDeltaEncode(M){let ne=[];const U=M.length/5|0;for(let Ye=0;Ye<U;Ye++)ne[Ye]=Ye;ne.sort((Ye,rt)=>{const mt=M[5*Ye],vt=M[5*rt];if(mt===vt){const _t=M[5*Ye+1],bt=M[5*rt+1];return _t-bt}return mt-vt});const Y=new Uint32Array(M.length);let ge=0,Ke=0;for(let Ye=0;Ye<U;Ye++){const rt=5*ne[Ye],mt=M[rt+0],vt=M[rt+1],_t=M[rt+2],bt=M[rt+3],Dt=M[rt+4],yn=mt-ge,In=yn===0?vt-Ke:vt,en=5*Ye;Y[en+0]=yn,Y[en+1]=In,Y[en+2]=_t,Y[en+3]=bt,Y[en+4]=Dt,ge=mt,Ke=vt}return Y}build(M){return this._dataIsSortedAndDeltaEncoded?new jt(new Uint32Array(this._data),M):new jt($t._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=$t;class jt{constructor(M,ne){this.resultId=ne,this.data=M}}e.SemanticTokens=jt;class tn{constructor(M,ne,U){this.start=M,this.deleteCount=ne,this.data=U}}e.SemanticTokensEdit=tn;class hn{constructor(M,ne){this.resultId=ne,this.edits=M}}e.SemanticTokensEdits=hn;var nn;(function(W){W[W.Separate=0]="Separate",W[W.MergeWithParent=1]="MergeWithParent"})(nn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Rt;(function(W){W[W.Initial=1]="Initial",W[W.Dynamic=2]="Dynamic"})(Rt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Bt=class{constructor(){}};Bt.Back={iconPath:new ot("arrow-left")},Bt=Ve([y],Bt),e.QuickInputButtons=Bt;var qt;(function(W){W[W.UI=1]="UI",W[W.Workspace=2]="Workspace"})(qt=e.ExtensionKind||(e.ExtensionKind={}));class Kt{constructor(M,ne,U){this.badge=M,this.tooltip=ne,this.color=U}static validate(M){if(M.badge&&M.badge.length!==1&&M.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Kt;let Gt=class{constructor(M){this.kind=M}};Gt=Ve([y],Gt),e.ColorTheme=Gt;var fn;(function(W){W[W.Light=1]="Light",W[W.Dark=2]="Dark",W[W.HighContrast=3]="HighContrast"})(fn=e.ColorThemeKind||(e.ColorThemeKind={}));class At{constructor(M,ne){if(M<0)throw(0,S.illegalArgument)("start must be positive");if(ne<M)throw(0,S.illegalArgument)("end cannot be smaller than start");this._start=M,this._end=ne}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}}e.NotebookCellRange=At;class Qt{constructor(M,ne,U,Y,ge,Ke,Ye,rt,mt,vt,_t,bt){this.editable=M,this.breakpointMargin=ne,this.runnable=U,this.hasExecutionOrder=Y,this.executionOrder=ge,this.runState=Ke,this.runStartTime=Ye,this.statusMessage=rt,this.lastRunDuration=mt,this.inputCollapsed=vt,this.outputCollapsed=_t,this.custom=bt}with(M){let{editable:ne,breakpointMargin:U,runnable:Y,hasExecutionOrder:ge,executionOrder:Ke,runState:Ye,runStartTime:rt,statusMessage:mt,lastRunDuration:vt,inputCollapsed:_t,outputCollapsed:bt,custom:Dt}=M;return ne===void 0?ne=this.editable:ne===null&&(ne=void 0),U===void 0?U=this.breakpointMargin:U===null&&(U=void 0),Y===void 0?Y=this.runnable:Y===null&&(Y=void 0),ge===void 0?ge=this.hasExecutionOrder:ge===null&&(ge=void 0),Ke===void 0?Ke=this.executionOrder:Ke===null&&(Ke=void 0),Ye===void 0?Ye=this.runState:Ye===null&&(Ye=void 0),rt===void 0?rt=this.runStartTime:rt===null&&(rt=void 0),mt===void 0?mt=this.statusMessage:mt===null&&(mt=void 0),vt===void 0?vt=this.lastRunDuration:vt===null&&(vt=void 0),_t===void 0?_t=this.inputCollapsed:_t===null&&(_t=void 0),bt===void 0?bt=this.outputCollapsed:bt===null&&(bt=void 0),Dt===void 0?Dt=this.custom:Dt===null&&(Dt=void 0),ne===this.editable&&U===this.breakpointMargin&&Y===this.runnable&&ge===this.hasExecutionOrder&&Ke===this.executionOrder&&Ye===this.runState&&rt===this.runStartTime&&mt===this.statusMessage&&vt===this.lastRunDuration&&_t===this.inputCollapsed&&bt===this.outputCollapsed&&Dt===this.custom?this:new Qt(ne,U,Y,ge,Ke,Ye,rt,mt,vt,_t,bt,Dt)}}e.NotebookCellMetadata=Qt;class Jt{constructor(M=!0,ne=!0,U=!0,Y=!0,ge=!0,Ke={},Ye=Te.Idle,rt=!0){this.editable=M,this.runnable=ne,this.cellEditable=U,this.cellRunnable=Y,this.cellHasExecutionOrder=ge,this.custom=Ke,this.runState=Ye,this.trusted=rt}with(M){let{editable:ne,runnable:U,cellEditable:Y,cellRunnable:ge,cellHasExecutionOrder:Ke,custom:Ye,runState:rt,trusted:mt}=M;return ne===void 0?ne=this.editable:ne===null&&(ne=void 0),U===void 0?U=this.runnable:U===null&&(U=void 0),Y===void 0?Y=this.cellEditable:Y===null&&(Y=void 0),ge===void 0?ge=this.cellRunnable:ge===null&&(ge=void 0),Ke===void 0?Ke=this.cellHasExecutionOrder:Ke===null&&(Ke=void 0),Ye===void 0?Ye=this.custom:Ye===null&&(Ye=void 0),rt===void 0?rt=this.runState:rt===null&&(rt=void 0),mt===void 0?mt=this.trusted:mt===null&&(mt=void 0),ne===this.editable&&U===this.runnable&&Y===this.cellEditable&&ge===this.cellRunnable&&Ke===this.cellHasExecutionOrder&&Ye===this.custom&&rt===this.runState&&mt===this.trusted?this:new Jt(ne,U,Y,ge,Ke,Ye,rt,mt)}}e.NotebookDocumentMetadata=Jt;class mn{constructor(M,ne,U,Y,ge){this.kind=M,this.source=ne,this.language=U,this.outputs=Y!=null?Y:[],this.metadata=ge}}e.NotebookCellData=mn;class gn{constructor(M,ne){this.cells=M,this.metadata=ne}}e.NotebookData=gn;class Lt{constructor(M,ne,U){this.mime=M,this.value=ne,this.metadata=U}static isNotebookCellOutputItem(M){return M instanceof Lt}}e.NotebookCellOutputItem=Lt;class rn{constructor(M,ne,U){this.outputs=M,typeof ne=="string"?(this.id=ne,this.metadata=U):(this.id=(0,D.generateUuid)(),this.metadata=ne!=null?ne:U)}}e.NotebookCellOutput=rn;var sn;(function(W){W[W.Markdown=1]="Markdown",W[W.Code=2]="Code"})(sn=e.NotebookCellKind||(e.NotebookCellKind={}));var Yt;(function(W){W[W.Running=1]="Running",W[W.Idle=2]="Idle",W[W.Success=3]="Success",W[W.Error=4]="Error"})(Yt=e.NotebookCellRunState||(e.NotebookCellRunState={}));var Te;(function(W){W[W.Running=1]="Running",W[W.Idle=2]="Idle"})(Te=e.NotebookRunState||(e.NotebookRunState={}));var Xt;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(Xt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Zt;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(Zt=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));let ht=class{constructor(M,ne){this.label=M,this.timestamp=ne}};ht=Ve([y],ht),e.TimelineItem=ht;var pn;(function(W){W[W.Production=1]="Production",W[W.Development=2]="Development",W[W.Test=3]="Test"})(pn=e.ExtensionMode||(e.ExtensionMode={}));var vn;(function(W){W[W.Node=1]="Node",W[W.Webworker=2]="Webworker"})(vn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var on;(function(W){W[W.Other=0]="Other",W[W.Comment=1]="Comment",W[W.String=2]="String",W[W.RegEx=4]="RegEx"})(on=e.StandardTokenType||(e.StandardTokenType={}));class an{constructor(M,ne){this.ranges=M,this.wordPattern=ne}}e.LinkedEditingRanges=an;var _n;(function(W){W[W.Unset=0]="Unset",W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(_n=e.TestResult||(e.TestResult={}));var ln;(function(W){W[W.Error=0]="Error",W[W.Warning=1]="Warning",W[W.Information=2]="Information",W[W.Hint=3]="Hint"})(ln=e.TestMessageSeverity||(e.TestMessageSeverity={}));class bn{constructor(M,ne){this.label=ne,this.runnable=!0,this.debuggable=!1,this.children=[],Object.defineProperty(this,"id",{value:M,enumerable:!0,writable:!1})}}e.TestItem=bn;class wn{constructor(M){this.state=M,this.messages=[]}}e.TestState=wn;class xt{constructor(M){this.message=M,this.severity=ln.Error}static diff(M,ne,U){const Y=new xt(M);return Y.expectedOutput=ne,Y.actualOutput=U,Y}}e.TestMessage=xt;var En;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(En=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Sn;(function(W){W[W.Untrusted=0]="Untrusted",W[W.Trusted=1]="Trusted",W[W.Unknown=2]="Unknown"})(Sn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}))}),define(we[94],Ee([0,1,44,16,8,117,83,7,14]),function(re,e,_,S,T,P,E,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const n=new Map;function A(s,h){h?n.set(s,h):n.delete(s)}e.setWordDefinitionFor=A;function I(s){return n.get(s)}e.getWordDefinitionFor=I;class p extends P.MirrorTextModel{constructor(h,v,g,b,c,u,a,t){super(v,g,b,c);this._proxy=h,this._languageId=u,this._isDirty=a,this._notebook=t,this._isDisposed=!1}dispose(){(0,_.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return(0,D.equals)(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===S.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},get notebook(){return h._notebook},save(){return h._save()},getText(v){return v?h._getTextInRange(v):h.getText()},get eol(){return h._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(v){return h._lineAt(v)},offsetAt(v){return h._offsetAt(v)},positionAt(v){return h._positionAt(v)},validateRange(v){return h._validateRange(v)},validatePosition(v){return h._validatePosition(v)},getWordRangeAtPosition(v,g){return h._getWordRangeAtPosition(v,g)}}}return Object.freeze(this._document)}_acceptLanguageId(h){(0,_.ok)(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){(0,_.ok)(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const v=this._validateRange(h);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const g=this._eol,b=v.start.line,c=v.end.line,u=[];u.push(this._lines[b].substring(v.start.character));for(let a=b+1;a<c;a++)u.push(this._lines[a]);return u.push(this._lines[c].substring(0,v.end.character)),u.join(g)}_lineAt(h){let v;if(h instanceof C.Position?v=h.line:typeof h=="number"&&(v=h),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new f(v,this._lines[v],v===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(h),g=this._lines[v.index].length;return new C.Position(v.index,Math.min(v.remainder,g))}_validateRange(h){if(!(h instanceof C.Range))throw new Error("Invalid argument");const v=this._validatePosition(h.start),g=this._validatePosition(h.end);return v===h.start&&g===h.end?h:new C.Range(v.line,v.character,g.line,g.character)}_validatePosition(h){if(!(h instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:v,character:g}=h,b=!1;if(v<0)v=0,g=0,b=!0;else if(v>=this._lines.length)v=this._lines.length-1,g=this._lines[v].length,b=!0;else{const c=this._lines[v].length;g<0?(g=0,b=!0):g>c&&(g=c,b=!0)}return b?new C.Position(v,g):h}_getWordRangeAtPosition(h,v){const g=this._validatePosition(h);if(!v)v=I(this._languageId);else if((0,T.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const b=(0,E.getWordAtText)(g.character+1,(0,E.ensureValidWordDefinition)(v),this._lines[g.line],0);if(b)return new C.Range(g.line,b.startColumn-1,g.line,b.endColumn-1)}}e.ExtHostDocumentData=p;class f{constructor(h,v,g){this._line=h,this._text=v,this._isLastLine=g}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(we[164],Ee([0,1,7,3,85,6,60,22,2,29]),function(re,e,_,S,T,P,E,C,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class A{constructor(p,f,s,h){this._notebook=s,this._selector=h,this._disposables=new P.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new S.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,n.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(g=>{const b=this._cellUris.get(g.document.uri);b!==void 0&&(this._cellLengths.changeValue(b,this._cells[b].document.getText().length+1),this._cellLines.changeValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const v=g=>{g===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(p.onDidChangeCellLanguage(g=>v(g.document))),this._disposables.add(p.onDidChangeNotebookCells(g=>v(g.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const p=[],f=[];for(const s of this._notebook.cells)s.cellKind===_.NotebookCellKind.Code&&(!this._selector||(0,E.score)(this._selector,s.uri,s.language,!0))&&(this._cellUris.set(s.uri,this._cells.length),this._cells.push(s),p.push(s.document.getText().length+1),f.push(s.document.lineCount));this._cellLengths=new T.PrefixSumComputer(new Uint32Array(p)),this._cellLines=new T.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(p){var f,s;if(!p){let c="";for(const u of this._cells)c+=u.document.getText()+`
`;return c=c.slice(0,-1),c}if(p.isEmpty)return"";const h=this.locationAt(p.start),v=this.locationAt(p.end),g=this._cells[(f=this._cellUris.get(h.uri))!==null&&f!==void 0?f:-1],b=this._cells[(s=this._cellUris.get(v.uri))!==null&&s!==void 0?s:-1];if(!g||!b)return"";if(g===b)return g.document.getText(new _.Range(h.range.start,v.range.end));{const c=g.document.getText(new _.Range(h.range.start,new _.Position(g.document.lineCount,0))),u=b.document.getText(new _.Range(new _.Position(0,0),v.range.end));return c+`
`+u}}offsetAt(p){const f=this._cellLines.getIndexOf(p.line),s=this._cellLengths.getAccumulatedValue(f.index-1),h=this._cells[f.index].document.offsetAt(p.with(f.remainder));return s+h}positionAt(p){if(typeof p=="number"){const s=this._cellLengths.getIndexOf(p),h=this._cellLines.getAccumulatedValue(s.index-1);return this._cells[s.index].document.positionAt(s.remainder).translate(h)}const f=this._cellUris.get(p.uri);if(f!==void 0){const s=this._cellLines.getAccumulatedValue(f-1);return new _.Position(s+p.range.start.line,p.range.start.character)}return new _.Position(0,0)}locationAt(p){_.Range.isRange(p)||(p=new _.Range(p,p));const f=this._cellLines.getIndexOf(p.start.line);let s=f;p.isEmpty||(s=this._cellLines.getIndexOf(p.end.line));const h=new _.Position(f.remainder,p.start.character),v=new _.Position(s.remainder,p.end.character),g=new _.Range(h,v),b=this._cells[f.index];return new _.Location(b.uri,b.document.validateRange(g))}contains(p){return this._cellUris.has(p)}validateRange(p){const f=this.validatePosition(p.start),s=this.validatePosition(p.end);return p.with(f,s)}validatePosition(p){const f=this._cellLines.getIndexOf(p.line),s=new _.Position(f.remainder,p.character),h=this._cells[f.index].document.validatePosition(s),v=this._cellLines.getAccumulatedValue(f.index-1);return new _.Position(v+h.line,h.character)}}e.ExtHostNotebookConcatDocument=A}),define(we[165],Ee([0,1,7,13,3]),function(re,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(C){this._actual=new _.ColorTheme(_.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new T.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let D=C==="light"?_.ColorThemeKind.Light:C==="dark"?_.ColorThemeKind.Dark:_.ColorThemeKind.HighContrast;this._actual=new _.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=Ve([qe(0,S.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(we[166],Ee([0,1,138,4,64]),function(re,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new T.RawContextKey("customExecutionSupported",!0,_.localize(0,null)),e.ShellExecutionSupportedContext=new T.RawContextKey("shellExecutionSupported",!1,_.localize(1,null)),e.ProcessExecutionSupportedContext=new T.RawContextKey("processExecutionSupported",!1,_.localize(2,null)),e.ITaskService=(0,S.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[167],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function _(T){return[...T.entries()]}e.serializeEnvironmentVariableCollection=_;function S(T){return new Map(T)}e.deserializeEnvironmentVariableCollection=S}),define(we[168],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=void 0;var _;(function(E){E[E.Add=0]="Add",E[E.Update=1]="Update",E[E.Remove=2]="Remove",E[E.DeltaDiscoverComplete=3]="DeltaDiscoverComplete",E[E.DeltaRootsComplete=4]="DeltaRootsComplete"})(_=e.TestDiffOpType||(e.TestDiffOpType={}));const S=(E,C)=>`${E}:${C.toString()}`;e.getTestSubscriptionKey=S;class T{add(C){}update(C){}remove(C,D){}complete(){}}e.IncrementalChangeCollector=T;class P{constructor(){this.items=new Map,this.roots=new Set}apply(C){const D=this.createChangeCollector();for(const n of C)switch(n[0]){case 0:{const A=n[1];if(A.parent){if(this.items.has(A.parent)){const I=this.items.get(A.parent);I.children.add(A.item.extId);const p=this.createItem(A,I);this.items.set(A.item.extId,p),D.add(p)}}else{this.roots.add(A.item.extId);const I=this.createItem(A);this.items.set(A.item.extId,I),D.add(I)}break}case 1:{const A=n[1],I=this.items.get(A.item.extId);I&&(Object.assign(I.item,A.item),D.update(I));break}case 2:{const A=this.items.get(n[1]);if(!A)break;A.parent?this.items.get(A.parent).children.delete(A.item.extId):this.roots.delete(A.item.extId);const I=[[n[1]]];for(;I.length;)for(const p of I.pop()){const f=this.items.get(p);f&&(I.push(f.children),this.items.delete(p),D.remove(f,f!==A))}break}case 3:this.updateBusyProviders(n[1]);break;case 4:this.updatePendingRoots(n[1]);break}D.complete()}updateBusyProviders(C){}updatePendingRoots(C){}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=P}),define(we[169],Ee([0,1,10,36,12,24,21,59,139]),function(re,e,_,S,T,P,E,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class n{constructor(I,p,f){if(this._contributedVariables=new Map,this._context=I,this._labelService=p,f)if(E.isWindows){const s=Object.create(null);this._envVariables=s,Object.keys(f).forEach(h=>{s[h.toLowerCase()]=f[h]})}else this._envVariables=f}resolve(I,p){return this.recursiveResolve(I?I.uri:void 0,p)}resolveAnyBase(I,p,f,s){const h=P.deepClone(p);return E.isWindows&&h.windows?Object.keys(h.windows).forEach(v=>h[v]=h.windows[v]):E.isMacintosh&&h.osx?Object.keys(h.osx).forEach(v=>h[v]=h.osx[v]):E.isLinux&&h.linux&&Object.keys(h.linux).forEach(v=>h[v]=h.linux[v]),delete h.windows,delete h.osx,delete h.linux,this.recursiveResolve(I?I.uri:void 0,h,f,s)}resolveAny(I,p,f){return this.resolveAnyBase(I,p,f)}resolveAnyMap(I,p,f){const s=new Map;return{newConfig:this.resolveAnyBase(I,p,f,s),resolvedVariables:s}}resolveWithInteractionReplace(I,p,f,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,p,f,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,p){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,p)}recursiveResolve(I,p,f,s){if(T.isString(p))return this.resolveString(I,p,f,s);if(T.isArray(p))return p.map(h=>this.recursiveResolve(I,h,f,s));if(T.isObject(p)){let h=Object.create(null);return Object.keys(p).forEach(v=>{const g=this.resolveString(I,v,f,s);h[g]=this.recursiveResolve(I,p[v],f,s)}),h}return p}resolveString(I,p,f,s){return p.replace(n.VARIABLE_REGEXP,(v,g)=>{if(g.includes(n.VARIABLE_LHS))return v;let b=this.evaluateSingleVariable(v,g,I,f);return s&&s.set(g,b),b})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,p,f,s){let h;const v=p.split(":");v.length>1&&(p=v[0],h=v[1]);const g=()=>{const u=this._context.getFilePath();if(u)return u;throw new Error((0,D.localize)(0,null,I))},b=()=>{const u=g();if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return a}throw new Error((0,D.localize)(1,null,I,_.basename(u)))},c=()=>{if(h){const u=this._context.getFolderUri(h);if(u)return u;throw new Error((0,D.localize)(2,null,I,h))}if(f)return f;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,I)):new Error((0,D.localize)(4,null,I))};switch(p){case"env":if(h){if(this._envVariables){const u=this._envVariables[E.isWindows?h.toLowerCase():h];if(T.isString(u))return u}return""}throw new Error((0,D.localize)(5,null,I));case"config":if(h){const u=this._context.getConfigurationValue(f,h);if(T.isUndefinedOrNull(u))throw new Error((0,D.localize)(6,null,I,h));if(T.isObject(u))throw new Error((0,D.localize)(7,null,I,h));return u}throw new Error((0,D.localize)(8,null,I));case"command":return this.resolveFromMap(I,h,s,"command");case"input":return this.resolveFromMap(I,h,s,"input");default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return f||h?(0,C.normalizeDriveLetter)(this.fsPath(c())):S.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return _.basename(this.fsPath(c()));case"lineNumber":const u=this._context.getLineNumber();if(u)return u;throw new Error((0,D.localize)(9,null,I));case"selectedText":const a=this._context.getSelectedText();if(a)return a;throw new Error((0,D.localize)(10,null,I));case"file":return g();case"fileWorkspaceFolder":return b();case"relativeFile":return f||h?_.relative(this.fsPath(c()),g()):g();case"relativeFileDirname":const t=_.dirname(g());if(f||h){const i=_.relative(this.fsPath(c()),t);return i.length===0?".":i}return t;case"fileDirname":return _.dirname(g());case"fileExtname":return _.extname(g());case"fileBasename":return _.basename(g());case"fileBasenameNoExtension":const r=_.basename(g());return r.slice(0,r.length-_.extname(r).length);case"fileDirnameBasename":return _.basename(_.dirname(g()));case"execPath":const o=this._context.getExecPath();return o||I;case"execInstallFolder":const l=this._context.getAppRoot();return l||I;case"pathSeparator":return _.sep;default:try{const i=h?`${p}:${h}`:p;return this.resolveFromMap(I,i,s,void 0)}catch(i){return I}}}}resolveFromMap(I,p,f,s){if(p&&f){const h=s===void 0?f[p]:f[s+":"+p];if(typeof h=="string")return h;throw new Error((0,D.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=n,n.VARIABLE_LHS="${",n.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[170],Ee([0,1,4]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,_.createDecorator)("editorGroupsService");var S;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(S=e.GroupDirection||(e.GroupDirection={}));var T;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var P;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(P=e.GroupLocation||(e.GroupLocation={}));var E;(function(p){p[p.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(E=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));var D;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var n;(function(p){p[p.GROUP_ACTIVE=0]="GROUP_ACTIVE",p[p.GROUP_INDEX=1]="GROUP_INDEX",p[p.EDITOR_OPEN=2]="EDITOR_OPEN",p[p.EDITOR_CLOSE=3]="EDITOR_CLOSE",p[p.EDITOR_MOVE=4]="EDITOR_MOVE",p[p.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",p[p.EDITOR_LABEL=6]="EDITOR_LABEL",p[p.EDITOR_PIN=7]="EDITOR_PIN",p[p.EDITOR_STICKY=8]="EDITOR_STICKY",p[p.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(n=e.GroupChangeKind||(e.GroupChangeKind={}));var A;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(A=e.OpenEditorContext||(e.OpenEditorContext={}));function I(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(we[171],Ee([0,1,4]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,_.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(we[9],Ee([0,1,63,7,140,2,32,80,87,171,12,224,58,24,14,40]),function(re,e,_,S,T,P,E,C,D,n,A,I,p,f,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.TestState=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var v;(function(fe){function ye(q){const{selectionStartLineNumber:Ie,selectionStartColumn:Pe,positionLineNumber:Ze,positionColumn:Ae}=q,it=new S.Position(Ie-1,Pe-1),st=new S.Position(Ze-1,Ae-1);return new S.Selection(it,st)}fe.to=ye;function oe(q){const{anchor:Ie,active:Pe}=q;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:Pe.line+1,positionColumn:Pe.character+1}}fe.from=oe})(v=e.Selection||(e.Selection={}));var g;(function(fe){function ye(q){if(!!q){const{start:Ie,end:Pe}=q;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:Pe.line+1,endColumn:Pe.character+1}}}fe.from=ye;function oe(q){if(!!q){const{startLineNumber:Ie,startColumn:Pe,endLineNumber:Ze,endColumn:Ae}=q;return new S.Range(Ie-1,Pe-1,Ze-1,Ae-1)}}fe.to=oe})(g=e.Range||(e.Range={}));var b;(function(fe){function ye(oe){switch(oe){case 1:return S.StandardTokenType.Comment;case 0:return S.StandardTokenType.Other;case 4:return S.StandardTokenType.RegEx;case 2:return S.StandardTokenType.String}}fe.to=ye})(b=e.TokenType||(e.TokenType={}));var c;(function(fe){function ye(q){return new S.Position(q.lineNumber-1,q.column-1)}fe.to=ye;function oe(q){return{lineNumber:q.line+1,column:q.character+1}}fe.from=oe})(c=e.Position||(e.Position={}));var u;(function(fe){function ye(q){switch(q){case S.DiagnosticTag.Unnecessary:return 1;case S.DiagnosticTag.Deprecated:return 2}}fe.from=ye;function oe(q){switch(q){case 1:return S.DiagnosticTag.Unnecessary;case 2:return S.DiagnosticTag.Deprecated;default:return}}fe.to=oe})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var a;(function(fe){function ye(q){let Ie;return q.code&&((0,A.isString)(q.code)||(0,A.isNumber)(q.code)?Ie=String(q.code):Ie={value:String(q.code.value),target:q.code.target}),Object.assign(Object.assign({},g.from(q.range)),{message:q.message,source:q.source,code:Ie,severity:r.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(t.from),tags:Array.isArray(q.tags)?(0,s.coalesce)(q.tags.map(u.from)):void 0})}fe.from=ye;function oe(q){var Ie;const Pe=new S.Diagnostic(g.to(q),q.message,r.to(q.severity));return Pe.source=q.source,Pe.code=(0,A.isString)(q.code)?q.code:(Ie=q.code)===null||Ie===void 0?void 0:Ie.value,Pe.relatedInformation=q.relatedInformation&&q.relatedInformation.map(t.to),Pe.tags=q.tags&&(0,s.coalesce)(q.tags.map(u.to)),Pe}fe.to=oe})(a=e.Diagnostic||(e.Diagnostic={}));var t;(function(fe){function ye(q){return Object.assign(Object.assign({},g.from(q.location.range)),{message:q.message,resource:q.location.uri})}fe.from=ye;function oe(q){return new S.DiagnosticRelatedInformation(new S.Location(q.resource,g.to(q)),q.message)}fe.to=oe})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var r;(function(fe){function ye(q){switch(q){case S.DiagnosticSeverity.Error:return D.MarkerSeverity.Error;case S.DiagnosticSeverity.Warning:return D.MarkerSeverity.Warning;case S.DiagnosticSeverity.Information:return D.MarkerSeverity.Info;case S.DiagnosticSeverity.Hint:return D.MarkerSeverity.Hint}return D.MarkerSeverity.Error}fe.from=ye;function oe(q){switch(q){case D.MarkerSeverity.Info:return S.DiagnosticSeverity.Information;case D.MarkerSeverity.Warning:return S.DiagnosticSeverity.Warning;case D.MarkerSeverity.Error:return S.DiagnosticSeverity.Error;case D.MarkerSeverity.Hint:return S.DiagnosticSeverity.Hint;default:return S.DiagnosticSeverity.Error}}fe.to=oe})(r=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var o;(function(fe){function ye(q){return typeof q=="number"&&q>=S.ViewColumn.One?q-1:q===S.ViewColumn.Beside?n.SIDE_GROUP:n.ACTIVE_GROUP}fe.from=ye;function oe(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}fe.to=oe})(o=e.ViewColumn||(e.ViewColumn={}));function l(fe){return typeof fe.range!="undefined"}function i(fe){return fe.length===0?!0:!!l(fe[0])}e.isDecorationOptionsArr=i;var d;(function(fe){function ye(Ae){return Ae.map(fe.from)}fe.fromMany=ye;function oe(Ae){return Ae&&typeof Ae=="object"&&typeof Ae.language=="string"&&typeof Ae.value=="string"}function q(Ae){let it;if(oe(Ae)){const{language:ot,value:ct}=Ae;it={value:"```"+ot+`
`+ct+"\n```\n"}}else S.MarkdownString.isMarkdownString(Ae)?it={value:Ae.value,isTrusted:Ae.isTrusted,supportThemeIcons:Ae.supportThemeIcons}:typeof Ae=="string"?it={value:Ae}:it={value:""};const st=Object.create(null);it.uris=st;const Ge=ot=>{try{let ct=P.URI.parse(ot,!0);ct=ct.with({query:Ie(ct.query,st)}),st[ot]=ct}catch(ct){}return""},ut=new I.Renderer;return ut.link=Ge,ut.image=ot=>Ge(C.parseHrefAndDimensions(ot).href),I(it.value,{renderer:ut}),it}fe.from=q;function Ie(Ae,it){if(!Ae)return Ae;let st;try{st=(0,p.parse)(Ae)}catch(ut){}if(!st)return Ae;let Ge=!1;return st=(0,f.cloneAndChange)(st,ut=>{if(P.URI.isUri(ut)){const ot=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[ot]=ut,Ge=!0,ot}else return}),Ge?JSON.stringify(st):Ae}function Pe(Ae){const it=new S.MarkdownString(Ae.value,Ae.supportThemeIcons);return it.isTrusted=Ae.isTrusted,it}fe.to=Pe;function Ze(Ae){if(!!Ae)return typeof Ae=="string"?Ae:fe.from(Ae)}fe.fromStrict=Ze})(d=e.MarkdownString||(e.MarkdownString={}));function y(fe){return i(fe)?fe.map(ye=>({range:g.from(ye.range),hoverMessage:Array.isArray(ye.hoverMessage)?d.fromMany(ye.hoverMessage):ye.hoverMessage?d.from(ye.hoverMessage):void 0,renderOptions:ye.renderOptions})):fe.map(ye=>({range:g.from(ye)}))}e.fromRangeOrRangeWithMessage=y;function k(fe){return typeof fe=="undefined"?fe:typeof fe=="string"?P.URI.file(fe):fe}e.pathOrURIToURI=k;var m;(function(fe){function ye(oe){return typeof oe=="undefined"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?k(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}fe.from=ye})(m=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var w;(function(fe){function ye(oe){return typeof oe=="undefined"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?k(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?m.from(oe.before):void 0,after:oe.after?m.from(oe.after):void 0}}fe.from=ye})(w=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(fe){function ye(oe){if(typeof oe=="undefined")return oe;switch(oe){case S.DecorationRangeBehavior.OpenOpen:return 0;case S.DecorationRangeBehavior.ClosedClosed:return 1;case S.DecorationRangeBehavior.OpenClosed:return 2;case S.DecorationRangeBehavior.ClosedOpen:return 3}}fe.from=ye})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var F;(function(fe){function ye(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?R.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?w.from(oe.light):void 0,dark:oe.dark?w.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?k(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?m.from(oe.before):void 0,after:oe.after?m.from(oe.after):void 0}}fe.from=ye})(F=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var B;(function(fe){function ye(q){return{text:q.newText,eol:q.newEol&&Z.from(q.newEol),range:g.from(q.range)}}fe.from=ye;function oe(q){const Ie=new S.TextEdit(g.to(q.range),q.text);return Ie.newEol=typeof q.eol=="undefined"?void 0:Z.to(q.eol),Ie}fe.to=oe})(B=e.TextEdit||(e.TextEdit={}));var Q;(function(fe){function ye(q,Ie,Pe){var Ze,Ae,it;const st={edits:[]};if(q instanceof S.WorkspaceEdit)for(let Ge of q._allEntries())if(Ge._type===1)st.edits.push({_type:1,oldUri:Ge.from,newUri:Ge.to,options:Ge.options,metadata:Ge.metadata});else if(Ge._type===2){const ut=Ie==null?void 0:Ie.getDocument(Ge.uri);st.edits.push({_type:2,resource:Ge.uri,edit:B.from(Ge.edit),modelVersionId:ut==null?void 0:ut.version,metadata:Ge.metadata})}else Ge._type===3?st.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:(Ze=Pe==null?void 0:Pe.lookupNotebookDocument(Ge.uri))===null||Ze===void 0?void 0:Ze.notebookDocument.version}):Ge._type===4?(Ge.newOutputs&&st.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:{editType:2,index:Ge.index,append:Ge.append,outputs:Ge.newOutputs.map(Se.from)}}),Ge.newMetadata&&st.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:{editType:3,index:Ge.index,metadata:Ge.newMetadata}})):Ge._type===5?st.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:(Ae=Pe==null?void 0:Pe.lookupNotebookDocument(Ge.uri))===null||Ae===void 0?void 0:Ae.notebookDocument.version,edit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(se.from)}}):Ge._type===6&&st.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:{editType:10,index:Ge.index,outputId:Ge.outputId,items:((it=Ge.newOutputItems)===null||it===void 0?void 0:it.map(de.from))||[],append:Ge.append}});return st}fe.from=ye;function oe(q){const Ie=new S.WorkspaceEdit;for(const Pe of q.edits)Pe.edit?Ie.replace(P.URI.revive(Pe.resource),g.to(Pe.edit.range),Pe.edit.text):Ie.renameFile(P.URI.revive(Pe.oldUri),P.URI.revive(Pe.newUri),Pe.options);return Ie}fe.to=oe})(Q=e.WorkspaceEdit||(e.WorkspaceEdit={}));var J;(function(fe){const ye=Object.create(null);ye[S.SymbolKind.File]=0,ye[S.SymbolKind.Module]=1,ye[S.SymbolKind.Namespace]=2,ye[S.SymbolKind.Package]=3,ye[S.SymbolKind.Class]=4,ye[S.SymbolKind.Method]=5,ye[S.SymbolKind.Property]=6,ye[S.SymbolKind.Field]=7,ye[S.SymbolKind.Constructor]=8,ye[S.SymbolKind.Enum]=9,ye[S.SymbolKind.Interface]=10,ye[S.SymbolKind.Function]=11,ye[S.SymbolKind.Variable]=12,ye[S.SymbolKind.Constant]=13,ye[S.SymbolKind.String]=14,ye[S.SymbolKind.Number]=15,ye[S.SymbolKind.Boolean]=16,ye[S.SymbolKind.Array]=17,ye[S.SymbolKind.Object]=18,ye[S.SymbolKind.Key]=19,ye[S.SymbolKind.Null]=20,ye[S.SymbolKind.EnumMember]=21,ye[S.SymbolKind.Struct]=22,ye[S.SymbolKind.Event]=23,ye[S.SymbolKind.Operator]=24,ye[S.SymbolKind.TypeParameter]=25;function oe(Ie){return typeof ye[Ie]=="number"?ye[Ie]:6}fe.from=oe;function q(Ie){for(const Pe in ye)if(ye[Pe]===Ie)return Number(Pe);return S.SymbolKind.Property}fe.to=q})(J=e.SymbolKind||(e.SymbolKind={}));var z;(function(fe){function ye(q){switch(q){case S.SymbolTag.Deprecated:return 1}}fe.from=ye;function oe(q){switch(q){case 1:return S.SymbolTag.Deprecated}}fe.to=oe})(z=e.SymbolTag||(e.SymbolTag={}));var ae;(function(fe){function ye(q){return{name:q.name,kind:J.from(q.kind),tags:q.tags&&q.tags.map(z.from),containerName:q.containerName,location:K.from(q.location)}}fe.from=ye;function oe(q){const Ie=new S.SymbolInformation(q.name,J.to(q.kind),q.containerName,K.to(q.location));return Ie.tags=q.tags&&q.tags.map(z.to),Ie}fe.to=oe})(ae=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var L;(function(fe){function ye(q){var Ie,Pe;const Ze={name:q.name||"!!MISSING: name!!",detail:q.detail,range:g.from(q.range),selectionRange:g.from(q.selectionRange),kind:J.from(q.kind),tags:(Pe=(Ie=q.tags)===null||Ie===void 0?void 0:Ie.map(z.from))!==null&&Pe!==void 0?Pe:[]};return q.children&&(Ze.children=q.children.map(ye)),Ze}fe.from=ye;function oe(q){const Ie=new S.DocumentSymbol(q.name,q.detail,J.to(q.kind),g.to(q.range),g.to(q.selectionRange));return(0,s.isNonEmptyArray)(q.tags)&&(Ie.tags=q.tags.map(z.to)),q.children&&(Ie.children=q.children.map(oe)),Ie}fe.to=oe})(L=e.DocumentSymbol||(e.DocumentSymbol={}));var N;(function(fe){function ye(oe){const q=new S.CallHierarchyItem(J.to(oe.kind),oe.name,oe.detail||"",P.URI.revive(oe.uri),g.to(oe.range),g.to(oe.selectionRange));return q._sessionId=oe._sessionId,q._itemId=oe._itemId,q}fe.to=ye})(N=e.CallHierarchyItem||(e.CallHierarchyItem={}));var H;(function(fe){function ye(oe){return new S.CallHierarchyIncomingCall(N.to(oe.from),oe.fromRanges.map(q=>g.to(q)))}fe.to=ye})(H=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var O;(function(fe){function ye(oe){return new S.CallHierarchyOutgoingCall(N.to(oe.to),oe.fromRanges.map(q=>g.to(q)))}fe.to=ye})(O=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var K;(function(fe){function ye(q){return{range:q.range&&g.from(q.range),uri:q.uri}}fe.from=ye;function oe(q){return new S.Location(P.URI.revive(q.uri),g.to(q.range))}fe.to=oe})(K=e.location||(e.location={}));var le;(function(fe){function ye(q){const Ie=q,Pe=q;return{originSelectionRange:Ie.originSelectionRange?g.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:Pe.uri,range:g.from(Ie.targetRange?Ie.targetRange:Pe.range),targetSelectionRange:Ie.targetSelectionRange?g.from(Ie.targetSelectionRange):void 0}}fe.from=ye;function oe(q){return{targetUri:P.URI.revive(q.uri),targetRange:g.to(q.range),targetSelectionRange:q.targetSelectionRange?g.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?g.to(q.originSelectionRange):void 0}}fe.to=oe})(le=e.DefinitionLink||(e.DefinitionLink={}));var ue;(function(fe){function ye(q){return{range:g.from(q.range),contents:d.fromMany(q.contents)}}fe.from=ye;function oe(q){return new S.Hover(q.contents.map(d.to),g.to(q.range))}fe.to=oe})(ue=e.Hover||(e.Hover={}));var pe;(function(fe){function ye(q){return{range:g.from(q.range),expression:q.expression}}fe.from=ye;function oe(q){return new S.EvaluatableExpression(g.to(q.range),q.expression)}fe.to=oe})(pe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ve;(function(fe){function ye(q){if(q instanceof S.InlineValueText)return{type:"text",range:g.from(q.range),text:q.text};if(q instanceof S.InlineValueVariableLookup)return{type:"variable",range:g.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof S.InlineValueEvaluatableExpression)return{type:"expression",range:g.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}fe.from=ye;function oe(q){switch(q.type){case"text":return{range:g.to(q.range),text:q.text};case"variable":return{range:g.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:g.to(q.range),expression:q.expression}}}fe.to=oe})(ve=e.InlineValue||(e.InlineValue={}));var Re;(function(fe){function ye(q){return{frameId:q.frameId,stoppedLocation:g.from(q.stoppedLocation)}}fe.from=ye;function oe(q){return new S.InlineValueContext(q.frameId,g.to(q.stoppedLocation))}fe.to=oe})(Re=e.InlineValueContext||(e.InlineValueContext={}));var He;(function(fe){function ye(q){return{range:g.from(q.range),kind:q.kind}}fe.from=ye;function oe(q){return new S.DocumentHighlight(g.to(q.range),q.kind)}fe.to=oe})(He=e.DocumentHighlight||(e.DocumentHighlight={}));var Fe;(function(fe){function ye(oe){switch(oe){case 1:return S.CompletionTriggerKind.TriggerCharacter;case 2:return S.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return S.CompletionTriggerKind.Invoke}}fe.to=ye})(Fe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ze;(function(fe){function ye(oe){return{triggerKind:Fe.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}fe.to=ye})(ze=e.CompletionContext||(e.CompletionContext={}));var $;(function(fe){function ye(q){switch(q){case S.CompletionItemTag.Deprecated:return 1}}fe.from=ye;function oe(q){switch(q){case 1:return S.CompletionItemTag.Deprecated}}fe.to=oe})($=e.CompletionItemTag||(e.CompletionItemTag={}));var G;(function(fe){const ye=new Map([[S.CompletionItemKind.Method,0],[S.CompletionItemKind.Function,1],[S.CompletionItemKind.Constructor,2],[S.CompletionItemKind.Field,3],[S.CompletionItemKind.Variable,4],[S.CompletionItemKind.Class,5],[S.CompletionItemKind.Interface,7],[S.CompletionItemKind.Struct,6],[S.CompletionItemKind.Module,8],[S.CompletionItemKind.Property,9],[S.CompletionItemKind.Unit,12],[S.CompletionItemKind.Value,13],[S.CompletionItemKind.Constant,14],[S.CompletionItemKind.Enum,15],[S.CompletionItemKind.EnumMember,16],[S.CompletionItemKind.Keyword,17],[S.CompletionItemKind.Snippet,27],[S.CompletionItemKind.Text,18],[S.CompletionItemKind.Color,19],[S.CompletionItemKind.File,20],[S.CompletionItemKind.Reference,21],[S.CompletionItemKind.Folder,23],[S.CompletionItemKind.Event,10],[S.CompletionItemKind.Operator,11],[S.CompletionItemKind.TypeParameter,24],[S.CompletionItemKind.Issue,26],[S.CompletionItemKind.User,25]]);function oe(Pe){var Ze;return(Ze=ye.get(Pe))!==null&&Ze!==void 0?Ze:9}fe.from=oe;const q=new Map([[0,S.CompletionItemKind.Method],[1,S.CompletionItemKind.Function],[2,S.CompletionItemKind.Constructor],[3,S.CompletionItemKind.Field],[4,S.CompletionItemKind.Variable],[5,S.CompletionItemKind.Class],[7,S.CompletionItemKind.Interface],[6,S.CompletionItemKind.Struct],[8,S.CompletionItemKind.Module],[9,S.CompletionItemKind.Property],[12,S.CompletionItemKind.Unit],[13,S.CompletionItemKind.Value],[14,S.CompletionItemKind.Constant],[15,S.CompletionItemKind.Enum],[16,S.CompletionItemKind.EnumMember],[17,S.CompletionItemKind.Keyword],[27,S.CompletionItemKind.Snippet],[18,S.CompletionItemKind.Text],[19,S.CompletionItemKind.Color],[20,S.CompletionItemKind.File],[21,S.CompletionItemKind.Reference],[23,S.CompletionItemKind.Folder],[10,S.CompletionItemKind.Event],[11,S.CompletionItemKind.Operator],[24,S.CompletionItemKind.TypeParameter],[25,S.CompletionItemKind.User],[26,S.CompletionItemKind.Issue]]);function Ie(Pe){var Ze;return(Ze=q.get(Pe))!==null&&Ze!==void 0?Ze:S.CompletionItemKind.Property}fe.to=Ie})(G=e.CompletionItemKind||(e.CompletionItemKind={}));var te;(function(fe){function ye(oe,q){var Ie;const Pe=new S.CompletionItem(typeof oe.label=="string"?oe.label:oe.label.name);return typeof oe.label!="string"&&(Pe.label2=oe.label),Pe.insertText=oe.insertText,Pe.kind=G.to(oe.kind),Pe.tags=(Ie=oe.tags)===null||Ie===void 0?void 0:Ie.map($.to),Pe.detail=oe.detail,Pe.documentation=C.isMarkdownString(oe.documentation)?d.to(oe.documentation):oe.documentation,Pe.sortText=oe.sortText,Pe.filterText=oe.filterText,Pe.preselect=oe.preselect,Pe.commitCharacters=oe.commitCharacters,E.Range.isIRange(oe.range)?Pe.range=g.to(oe.range):typeof oe.range=="object"&&(Pe.range={inserting:g.to(oe.range.insert),replacing:g.to(oe.range.replace)}),Pe.keepWhitespace=typeof oe.insertTextRules=="undefined"?!1:Boolean(oe.insertTextRules&1),typeof oe.insertTextRules!="undefined"&&oe.insertTextRules&4?Pe.insertText=new S.SnippetString(oe.insertText):(Pe.insertText=oe.insertText,Pe.textEdit=Pe.range instanceof S.Range?new S.TextEdit(Pe.range,Pe.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(Pe.additionalTextEdits=oe.additionalTextEdits.map(Ze=>B.to(Ze))),Pe.command=q&&oe.command?q.fromInternal(oe.command):void 0,Pe}fe.to=ye})(te=e.CompletionItem||(e.CompletionItem={}));var ie;(function(fe){function ye(q){return{label:q.label,documentation:q.documentation?d.fromStrict(q.documentation):void 0}}fe.from=ye;function oe(q){return{label:q.label,documentation:C.isMarkdownString(q.documentation)?d.to(q.documentation):q.documentation}}fe.to=oe})(ie=e.ParameterInformation||(e.ParameterInformation={}));var he;(function(fe){function ye(q){return{label:q.label,documentation:q.documentation?d.fromStrict(q.documentation):void 0,parameters:Array.isArray(q.parameters)?q.parameters.map(ie.from):[],activeParameter:q.activeParameter}}fe.from=ye;function oe(q){return{label:q.label,documentation:C.isMarkdownString(q.documentation)?d.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(ie.to):[],activeParameter:q.activeParameter}}fe.to=oe})(he=e.SignatureInformation||(e.SignatureInformation={}));var De;(function(fe){function ye(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(he.from):[]}}fe.from=ye;function oe(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(he.to):[]}}fe.to=oe})(De=e.SignatureHelp||(e.SignatureHelp={}));var Le;(function(fe){function ye(q){var Ie;return{text:q.text,range:g.from(q.range),kind:me.from((Ie=q.kind)!==null&&Ie!==void 0?Ie:S.InlineHintKind.Other),description:q.description&&d.fromStrict(q.description),whitespaceBefore:q.whitespaceBefore,whitespaceAfter:q.whitespaceAfter}}fe.from=ye;function oe(q){const Ie=new S.InlineHint(q.text,g.to(q.range),me.to(q.kind));return Ie.whitespaceAfter=q.whitespaceAfter,Ie.whitespaceBefore=q.whitespaceBefore,Ie.description=C.isMarkdownString(q.description)?d.to(q.description):q.description,Ie}fe.to=oe})(Le=e.InlineHint||(e.InlineHint={}));var me;(function(fe){function ye(q){return q}fe.from=ye;function oe(q){return q}fe.to=oe})(me=e.InlineHintKind||(e.InlineHintKind={}));var Ce;(function(fe){function ye(q){return{range:g.from(q.range),url:q.target,tooltip:q.tooltip}}fe.from=ye;function oe(q){let Ie;if(q.url)try{Ie=typeof q.url=="string"?P.URI.parse(q.url,!0):P.URI.revive(q.url)}catch(Pe){}return new S.DocumentLink(g.to(q.range),Ie)}fe.to=oe})(Ce=e.DocumentLink||(e.DocumentLink={}));var ke;(function(fe){function ye(q){const Ie=new S.ColorPresentation(q.label);return q.textEdit&&(Ie.textEdit=B.to(q.textEdit)),q.additionalTextEdits&&(Ie.additionalTextEdits=q.additionalTextEdits.map(Pe=>B.to(Pe))),Ie}fe.to=ye;function oe(q){return{label:q.label,textEdit:q.textEdit?B.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Ie=>B.from(Ie)):void 0}}fe.from=oe})(ke=e.ColorPresentation||(e.ColorPresentation={}));var Ue;(function(fe){function ye(q){return new S.Color(q[0],q[1],q[2],q[3])}fe.to=ye;function oe(q){return[q.red,q.green,q.blue,q.alpha]}fe.from=oe})(Ue=e.Color||(e.Color={}));var be;(function(fe){function ye(q){return{range:g.from(q.range)}}fe.from=ye;function oe(q){return new S.SelectionRange(g.to(q.range))}fe.to=oe})(be=e.SelectionRange||(e.SelectionRange={}));var je;(function(fe){function ye(oe){switch(oe){case 2:return S.TextDocumentSaveReason.AfterDelay;case 1:return S.TextDocumentSaveReason.Manual;case 3:case 4:return S.TextDocumentSaveReason.FocusOut}}fe.to=ye})(je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var V;(function(fe){function ye(q){switch(q){case S.TextEditorLineNumbersStyle.Off:return 0;case S.TextEditorLineNumbersStyle.Relative:return 2;case S.TextEditorLineNumbersStyle.On:default:return 1}}fe.from=ye;function oe(q){switch(q){case 0:return S.TextEditorLineNumbersStyle.Off;case 2:return S.TextEditorLineNumbersStyle.Relative;case 1:default:return S.TextEditorLineNumbersStyle.On}}fe.to=oe})(V=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Z;(function(fe){function ye(q){if(q===S.EndOfLine.CRLF)return 1;if(q===S.EndOfLine.LF)return 0}fe.from=ye;function oe(q){if(q===1)return S.EndOfLine.CRLF;if(q===0)return S.EndOfLine.LF}fe.to=oe})(Z=e.EndOfLine||(e.EndOfLine={}));var _e;(function(fe){function ye(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case S.ProgressLocation.SourceControl:return 3;case S.ProgressLocation.Window:return 10;case S.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}fe.from=ye})(_e=e.ProgressLocation||(e.ProgressLocation={}));var Me;(function(fe){function ye(oe){const q={start:oe.start+1,end:oe.end+1};return oe.kind&&(q.kind=$e.from(oe.kind)),q}fe.from=ye})(Me=e.FoldingRange||(e.FoldingRange={}));var $e;(function(fe){function ye(oe){if(oe)switch(oe){case S.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case S.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case S.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}fe.from=ye})($e=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ne;(function(fe){function ye(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?g.from(oe.selection):void 0,override:typeof oe.override=="boolean"?T.EditorOverride.DISABLED:void 0}}fe.from=ye})(Ne=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Je;(function(fe){function ye(q){return q instanceof S.RelativePattern||typeof q=="string"?q:oe(q)?new S.RelativePattern(q.base,q.pattern):q}fe.from=ye;function oe(q){const Ie=q;return Ie&&typeof Ie.base=="string"&&typeof Ie.pattern=="string"}})(Je=e.GlobPattern||(e.GlobPattern={}));var x;(function(fe){function ye(oe){if(oe){if(Array.isArray(oe))return oe.map(ye);if(typeof oe=="string")return oe;{const q=oe;return{language:q.language,scheme:q.scheme,pattern:typeof q.pattern=="undefined"?void 0:Je.from(q.pattern),exclusive:q.exclusive}}}else return}fe.from=ye})(x=e.LanguageSelector||(e.LanguageSelector={}));var ee;(function(fe){function ye(q){return{start:q.start,end:q.end}}fe.from=ye;function oe(q){return new S.NotebookCellRange(q.start,q.end)}fe.to=oe})(ee=e.NotebookCellRange||(e.NotebookCellRange={}));var ce;(function(fe){function ye(oe){return new S.NotebookCellMetadata(oe.editable,oe.breakpointMargin,oe.runnable,oe.hasExecutionOrder,oe.executionOrder,oe.runState,oe.runStartTime,oe.statusMessage,oe.lastRunDuration,oe.inputCollapsed,oe.outputCollapsed,oe.custom)}fe.to=ye})(ce=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var j;(function(fe){function ye(q){return q}fe.from=ye;function oe(q){return new S.NotebookDocumentMetadata(q.editable,q.runnable,q.cellEditable,q.cellRunnable,q.cellHasExecutionOrder,q.custom,q.runState,q.trusted)}fe.to=oe})(j=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var X;(function(fe){function ye(q){switch(q){case S.NotebookCellKind.Markdown:return h.CellKind.Markdown;case S.NotebookCellKind.Code:default:return h.CellKind.Code}}fe.from=ye;function oe(q){switch(q){case h.CellKind.Markdown:return S.NotebookCellKind.Markdown;case h.CellKind.Code:default:return S.NotebookCellKind.Code}}fe.to=oe})(X=e.NotebookCellKind||(e.NotebookCellKind={}));var se;(function(fe){function ye(oe){return{cellKind:X.from(oe.kind),language:oe.language,source:oe.source,metadata:oe.metadata,outputs:oe.outputs?oe.outputs.map(Se.from):[]}}fe.from=ye})(se=e.NotebookCellData||(e.NotebookCellData={}));var de;(function(fe){function ye(q){return{mime:q.mime,value:q.value,metadata:q.metadata}}fe.from=ye;function oe(q){return new S.NotebookCellOutputItem(q.mime,q.value,q.metadata)}fe.to=oe})(de=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Se;(function(fe){function ye(q){return{outputId:q.id,outputs:q.outputs.map(de.from),metadata:q.metadata}}fe.from=ye;function oe(q){const Ie=q.outputs.map(de.to);return new S.NotebookCellOutput(Ie,q.outputId,q.metadata)}fe.to=oe})(Se=e.NotebookCellOutput||(e.NotebookCellOutput={}));var xe;(function(fe){function ye(Pe){if(Pe!=null){if(Pe instanceof S.RelativePattern||typeof Pe=="string")return Pe;if(Ie(Pe))return new S.RelativePattern(Pe.base,Pe.pattern);if(q(Pe))return{include:Je.from(Pe.include)||void 0,exclude:Je.from(Pe.exclude)||void 0}}}fe.from=ye;function oe(Pe){return typeof Pe=="string"?Pe:Ie(Pe)?{base:Pe.base,pattern:Pe.pattern}:{include:Pe.include,exclude:Pe.exclude}}fe.to=oe;function q(Pe){const Ze=Pe,Ae=Je.from(Ze.include);if(!(Ae&&Ae instanceof S.RelativePattern||typeof Ae=="string"))return!1;const it=Je.from(Ze.exclude);return!!(it&&it instanceof S.RelativePattern||typeof it=="string")}function Ie(Pe){const Ze=Pe;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(xe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Oe;(function(fe){function ye(oe){return{backgroundColor:oe.backgroundColor,borderColor:oe.borderColor,top:oe.top?m.from(oe.top):void 0}}fe.from=ye})(Oe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Be;(function(fe){function ye(q){return{state:q.state,duration:q.duration,messages:q.messages.map(Qe.from)}}fe.from=ye;function oe(q){const Ie=new S.TestState(q.state);return Ie.duration=q.duration,Ie.messages=q.messages.map(Qe.to),Ie}fe.to=oe})(Be=e.TestState||(e.TestState={}));var Qe;(function(fe){function ye(q){return{message:d.fromStrict(q.message)||"",severity:q.severity,expectedOutput:q.expectedOutput,actualOutput:q.actualOutput,location:q.location?K.from(q.location):void 0}}fe.from=ye;function oe(q){const Ie=new S.TestMessage(typeof q.message=="string"?q.message:d.to(q.message));return Ie.severity=q.severity,Ie.actualOutput=q.actualOutput,Ie.expectedOutput=q.expectedOutput,Ie}fe.to=oe})(Qe=e.TestMessage||(e.TestMessage={}));var nt;(function(fe){function ye(Ie){var Pe,Ze;return{extId:Ie.id,label:Ie.label,location:Ie.location?K.from(Ie.location):void 0,debuggable:(Pe=Ie.debuggable)!==null&&Pe!==void 0?Pe:!1,description:Ie.description,runnable:(Ze=Ie.runnable)!==null&&Ze!==void 0?Ze:!0}}fe.from=ye;function oe(Ie){return{id:Ie.extId,label:Ie.label,location:Ie.location&&K.to({range:Ie.location.range,uri:P.URI.revive(Ie.location.uri)}),debuggable:Ie.debuggable,description:Ie.description,runnable:Ie.runnable}}fe.toPlainShallow=oe;function q(Ie){const Pe=new S.TestItem(Ie.extId,Ie.label);return Ie.location&&(Pe.location=K.to({range:Ie.location.range,uri:P.URI.revive(Ie.location.uri)})),Pe.debuggable=Ie.debuggable,Pe.description=Ie.description,Pe.runnable=Ie.runnable,Pe}fe.toShallow=q})(nt=e.TestItem||(e.TestItem={}));var et;(function(fe){function ye(Ie,Pe){var Ze,Ae,it;const st={completedAt:Pe.completedAt,id:Ie,items:[]},Ge=[[null,Pe.results]];for(;Ge.length;){const[ut,ot]=Ge.pop();for(const ct of ot){const Ct={children:(Ae=(Ze=ct.children)===null||Ze===void 0?void 0:Ze.map(yt=>yt.id))!==null&&Ae!==void 0?Ae:[],computedState:ct.result.state,item:nt.from(ct),state:Be.from(ct.result),retired:void 0,parent:(it=ut==null?void 0:ut.item.extId)!==null&&it!==void 0?it:null,providerId:"",direct:!ut};st.items.push(Ct),ct.children&&Ge.push([Ct,ct.children])}}return st}fe.from=ye;const oe=(Ie,Pe)=>Object.assign(Object.assign({},nt.toPlainShallow(Ie.item)),{result:Be.to(Ie.state),children:Ie.children.map(Ze=>Pe.get(Ze)).filter(A.isDefined).map(Ze=>oe(Ze,Pe))});function q(Ie){const Pe=[],Ze=new Map;for(const Ae of Ie.items)Ze.set(Ae.item.extId,Ae),Ae.direct&&Pe.push(Ae);return{completedAt:Ie.completedAt,results:Pe.map(Ae=>oe(Ae,Ze))}}fe.to=q})(et=e.TestResults||(e.TestResults={}));var Xe;(function(fe){function ye(oe){switch(oe){case 1:return S.CodeActionTriggerKind.Automatic;case 2:return S.CodeActionTriggerKind.Manual}}fe.to=ye})(Xe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(we[172],Ee([0,1,2,11,7,9,47]),function(re,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(n,A,I,p={timeout:1500,errors:3}){this._logService=n,this._documents=A,this._mainThreadBulkEdits=I,this._thresholds=p,this._callbacks=new E.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(n){return(A,I,p)=>{const s={dispose:this._callbacks.push([A,I,n])};return Array.isArray(p)&&p.push(s),s}}async $participateInSave(n,A){const I=_.URI.revive(n);let p=!1;const f=setTimeout(()=>p=!0,this._thresholds.timeout),s=[];try{for(let h of[...this._callbacks]){if(p)break;const v=this._documents.getDocument(I),g=await this._deliverEventAsyncAndBlameBadListeners(h,{document:v,reason:P.TextDocumentSaveReason.to(A)});s.push(g)}}finally{clearTimeout(f)}return s}_deliverEventAsyncAndBlameBadListeners([n,A,I],p){const f=this._badListeners.get(n);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,n,A,p).then(()=>!0,s=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const h=this._badListeners.get(n);this._badListeners.set(n,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(n,A,I,p){const f=[],s=Date.now(),{document:h,reason:v}=p,{version:g}=h,b=Object.freeze({document:h,reason:v,waitUntil(c){if(Object.isFrozen(f))throw(0,S.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(c))}});try{A.apply(I,[b])}catch(c){return Promise.reject(c)}return Object.freeze(f),new Promise((c,u)=>{const a=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${n.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(a),c(t)}).catch(t=>{clearTimeout(a),u(t)})}).then(c=>{const u={edits:[]};for(const a of c)if(Array.isArray(a)&&a.every(t=>t instanceof T.TextEdit))for(const{newText:t,newEol:r,range:o}of a)u.edits.push({_type:2,resource:h.uri,edit:{range:o&&P.Range.from(o),text:t,eol:r&&P.EndOfLine.from(r)}});if(u.edits.length!==0)return g===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(we[173],Ee([0,1,3,15,28,2,9,7]),function(re,e,_,S,T,P,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(I,p,f,s,h){this._onDidCreate=new _.Emitter,this._onDidChange=new _.Emitter,this._onDidDelete=new _.Emitter,this._config=0,f&&(this._config+=1),s&&(this._config+=2),h&&(this._config+=4);const v=(0,T.parse)(p),g=I(b=>{if(!f)for(let c of b.created){const u=P.URI.revive(c);v(u.fsPath)&&this._onDidCreate.fire(u)}if(!s)for(let c of b.changed){const u=P.URI.revive(c);v(u.fsPath)&&this._onDidChange.fire(u)}if(!h)for(let c of b.deleted){const u=P.URI.revive(c);v(u.fsPath)&&this._onDidDelete.fire(u)}});this._disposable=C.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,g)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class n{constructor(I,p,f){this._logService=p,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new _.Emitter,this._onDidRenameFile=new _.Emitter,this._onDidCreateFile=new _.Emitter,this._onDidDeleteFile=new _.Emitter,this._onWillRenameFile=new S.AsyncEmitter,this._onWillCreateFile=new S.AsyncEmitter,this._onWillDeleteFile=new S.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,p,f,s){return new D(this._onFileSystemEvent.event,I,p,f,s)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,p){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:p.map(f=>({oldUri:P.URI.revive(f.source),newUri:P.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:p.map(f=>P.URI.revive(f.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:p.map(f=>P.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,p){return(f,s,h)=>{const v=function(b){f.call(s,b)};return v.extension=I,p.event(v,void 0,h)}}async $onWillRunFileOperation(I,p,f,s){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:p.map(h=>({oldUri:P.URI.revive(h.source),newUri:P.URI.revive(h.target)}))},f,s);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:p.map(h=>P.URI.revive(h.target))},f,s);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:p.map(h=>P.URI.revive(h.target))},f,s)}}async _fireWillEvent(I,p,f,s){const h=new Set,v=[];if(await I.fireAsync(p,s,async(b,c)=>{var u;const a=Date.now(),t=await Promise.resolve(b);t instanceof C.WorkspaceEdit&&(v.push(t),h.add((u=c.extension.displayName)!==null&&u!==void 0?u:c.extension.identifier.value)),Date.now()-a>f&&this._logService.warn("SLOW file-participant",c.extension.identifier)}),!s.isCancellationRequested&&v.length!==0){const g={edits:[]};for(let b of v){let{edits:c}=E.WorkspaceEdit.from(b,this._extHostDocumentsAndEditors);g.edits=g.edits.concat(c)}return{edit:g,extensionNames:Array.from(h)}}}}e.ExtHostFileSystemEventService=n}),define(we[174],Ee([0,1,3,6,16,2,9,40]),function(re,e,_,S,T,P,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(p,f,s,h){this.start=p,this.deletedCount=f,this.deletedItems=s,this.items=h}static asApiEvent(p){return Object.freeze({start:p.start,deletedCount:p.deletedCount,deletedItems:p.deletedItems,items:p.items.map(f=>f.cell)})}}class n{constructor(p,f,s){var h;this._notebook=p,this._extHostDocument=f,this._cellData=s,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this.handle=s.handle,this.uri=P.URI.revive(s.uri),this.cellKind=s.cellKind,this._outputs=s.outputs.map(E.NotebookCellOutput.to),this._metadata=E.NotebookCellMetadata.to((h=s.metadata)!==null&&h!==void 0?h:{})}static asModelAddData(p,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:p}}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get cell(){if(!this._cell){const p=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return p._notebook.getCellIndex(p)},notebook:p._notebook.notebookDocument,uri:p.uri,cellKind:E.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get language(){return f.document.languageId},get outputs(){return p._outputs.slice(0)},set outputs(s){throw new Error("Use WorkspaceEdit to update cell outputs.")},get metadata(){return p._metadata},set metadata(s){throw new Error("Use WorkspaceEdit to update cell metadata.")}})}return this._cell}setOutputs(p){this._outputs=p.map(E.NotebookCellOutput.to)}setOutputItems(p,f,s){const h=s.map(E.NotebookCellOutputItem.to),v=this._outputs.find(g=>g.id===p);v&&(f||(v.outputs.length=0),v.outputs.push(...h))}setMetadata(p){this._metadata=E.NotebookCellMetadata.to(p)}}e.ExtHostCell=n;class A extends S.Disposable{constructor(p,f,s,h,v,g,b){super();this._proxy=p,this._documentsAndEditors=f,this._emitter=s,this._viewType=h,this._contentOptions=v,this._metadata=g,this.uri=b,this.handle=A._handlePool++,this._cells=[],this._cellDisposableMapping=new Map,this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0,super.dispose(),(0,S.dispose)(this._cellDisposableMapping.values())}get notebookDocument(){if(!this._notebook){const p=this;this._notebook=Object.freeze({get uri(){return p.uri},get version(){return p._versionId},get fileName(){return p.uri.fsPath},get viewType(){return p._viewType},get isDirty(){return p._isDirty},get isUntitled(){return p.uri.scheme===T.Schemas.untitled},get cells(){return p._cells.map(f=>f.cell)},get metadata(){return p._metadata},set metadata(f){throw new Error("Use WorkspaceEdit to update metadata.")},get contentOptions(){return p._contentOptions},save(){return p._save()}})}return this._notebook}updateBackup(p){var f;(f=this._backup)===null||f===void 0||f.delete(),this._backup=p}disposeBackup(){var p;(p=this._backup)===null||p===void 0||p.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(p){const f=Object.assign(Object.assign({},C.notebookDocumentMetadataDefaults),p.metadata);this._metadata=this._metadata.with(f),this._emitter.emitDocumentMetadataChange({document:this.notebookDocument})}acceptModelChanged(p,f){this._versionId=p.versionId,this._isDirty=f,p.rawEvents.forEach(s=>{s.kind===C.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(s.changes,!0),s.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(s.changes,!1):s.kind===C.NotebookCellsChangeType.Move?this._moveCell(s.index,s.newIdx):s.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(s.index,s.outputs):s.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(s.index,s.outputId,s.append,s.outputItems):s.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(s.index,s.language):s.kind===C.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(s.index,s.metadata)})}async _save(){return this._disposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(p,f){if(!this._disposed){const s=[],h=[],v=[];p.reverse().forEach(g=>{var b;const u=g[2].map(r=>{const o=new n(this,this._documentsAndEditors,r);if(f||h.push(n.asModelAddData(this.notebookDocument,r)),!this._cellDisposableMapping.has(o.handle)){const l=new S.DisposableStore;l.add(o),this._cellDisposableMapping.set(o.handle,l)}return o});for(let r=g[0];r<g[0]+g[1];r++)(b=this._cellDisposableMapping.get(this._cells[r].handle))===null||b===void 0||b.dispose(),this._cellDisposableMapping.delete(this._cells[r].handle);const a=new D(g[0],g[1],[],u),t=this._cells.splice(g[0],g[1],...u);for(let r of t)v.push(r.uri),a.deletedItems.push(r.cell);s.push(a)}),this._documentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:v}),f||this._emitter.emitModelChange({document:this.notebookDocument,changes:s.map(D.asApiEvent)})}}_moveCell(p,f){const s=this._cells.splice(p,1);this._cells.splice(f,0,...s);const h=[{start:p,deletedCount:1,deletedItems:s.map(v=>v.cell),items:[]},{start:f,deletedCount:0,deletedItems:[],items:s.map(v=>v.cell)}];this._emitter.emitModelChange({document:this.notebookDocument,changes:h})}_setCellOutputs(p,f){const s=this._cells[p];s.setOutputs(f),this._emitter.emitCellOutputsChange({document:this.notebookDocument,cells:[s.cell]})}_setCellOutputItems(p,f,s,h){const v=this._cells[p];v.setOutputItems(f,s,h),this._emitter.emitCellOutputsChange({document:this.notebookDocument,cells:[v.cell]})}_changeCellLanguage(p,f){const s=this._cells[p],h={document:this.notebookDocument,cell:s.cell,language:f};this._emitter.emitCellLanguageChange(h)}_changeCellMetadata(p,f){const s=this._cells[p];s.setMetadata(f||{});const h={document:this.notebookDocument,cell:s.cell};this._emitter.emitCellMetadataChange(h)}getCellFromIndex(p){return this._cells[p]}getCell(p){return this._cells.find(f=>f.handle===p)}getCellIndex(p){return this._cells.indexOf(p)}}e.ExtHostNotebookDocument=A,A._handlePool=0}),define(we[175],Ee([0,1,3,7,9,40]),function(re,e,_,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class E{constructor(n){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=n}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(n){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:Object.assign(Object.assign({},P.notebookDocumentMetadataDefaults),n)})}replaceCellMetadata(n,A){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:n,metadata:A})}replaceCellOutput(n,A){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:n,outputs:A.map(I=>T.NotebookCellOutput.from(I))})}replaceCells(n,A,I){this._throwIfFinalized(),!(n===A&&I.length===0)&&this._collectedEdits.push({editType:1,index:n,count:A-n,cells:I.map(T.NotebookCellData.from)})}}class C{constructor(n,A,I,p,f,s,h){this.id=n,this._viewType=A,this._proxy=I,this.notebookData=p,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this._selections=s,this._visibleRanges=f,this._viewColumn=h}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get editor(){if(!this._editor){const n=this;this._editor={get document(){return n.notebookData.notebookDocument},get selection(){var A;const I=n._selections[0];return I&&((A=n.notebookData.getCellFromIndex(I.start))===null||A===void 0?void 0:A.cell)},get selections(){return n._selections},get visibleRanges(){return n._visibleRanges},revealRange(A,I){n._proxy.$tryRevealRange(n.id,T.NotebookCellRange.from(A),I!=null?I:S.NotebookEditorRevealType.Default)},get viewColumn(){return n._viewColumn},get onDidDispose(){return n.onDidDispose},edit(A){const I=new E(this.document.version);return A(I),n._applyEdit(I.finalize())},get kernel(){return n._kernel},setDecorations(A,I){return n.setDecorations(A,I)}}}return this._editor}_acceptKernel(n){this._kernel=n}get visible(){return this._visible}_acceptVisibility(n){this._visible=n}_acceptVisibleRanges(n){this._visibleRanges=n}_acceptSelections(n){this._selections=n}_applyEdit(n){if(n.cellEdits.length===0)return Promise.resolve(!0);const A=[];let I=-1;for(let p=0;p<n.cellEdits.length;p++){if(I<0){A.push(n.cellEdits[p]),I++;continue}const s=A[I];if(s.editType===1&&n.cellEdits[p].editType===1){const h=n.cellEdits[p];if(h.editType!==5&&s.index===h.index){s.cells.push(...n.cellEdits[p].cells),s.count+=n.cellEdits[p].count;continue}}A.push(n.cellEdits[p]),I++}return this._proxy.$tryApplyEdits(this._viewType,this.notebookData.uri,n.documentVersionId,A)}setDecorations(n,A){if(!(A.isEmpty&&!this._hasDecorationsForKey.has(n.key)))return A.isEmpty?this._hasDecorationsForKey.delete(n.key):this._hasDecorationsForKey.add(n.key),this._proxy.$trySetDecorations(this.id,T.NotebookCellRange.from(A),n.key)}}e.ExtHostNotebookEditor=C}),define(we[176],Ee([0,1,9,149,130,20,45]),function(re,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,p,f){const s=this._handles++,{title:h,location:v,cancellable:g}=p,b=(0,T.localize)(0,null,I.displayName||I.name);return this._proxy.$startProgress(s,{location:_.ProgressLocation.from(v),title:h,source:b,cancellable:g},I),this._withProgress(s,f,!!g)}_withProgress(I,p,f){let s;f&&(s=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,s));const h=g=>{this._proxy.$progressEnd(g),this._mapHandleToCancellationSource.delete(g),s&&s.dispose()};let v;try{v=p(new n(this._proxy,I),f&&s?s.token:P.CancellationToken.None)}catch(g){throw h(I),g}return v.then(g=>h(I),g=>h(I)),v}$acceptProgressCanceled(I){const p=this._mapHandleToCancellationSource.get(I);p&&(p.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=C;function D(A,I){return A.message=I.message,typeof I.increment=="number"&&(typeof A.increment=="number"?A.increment+=I.increment:A.increment=I.increment),A}class n extends S.Progress{constructor(I,p){super(f=>this.throttledReport(f));this._proxy=I,this._handle=p}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}Ve([(0,E.throttle)(100,(A,I)=>D(A,I),()=>Object.create(null))],n.prototype,"throttledReport",null)}),define(we[95],Ee([0,1,44,11,53,9,7]),function(re,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(p,f){const s=C._Keys.nextId();p.$registerTextEditorDecorationType(s,P.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:s,dispose(){p.$removeTextEditorDecorationType(s)}})}}e.TextEditorDecorationType=C,C._Keys=new T.IdGenerator("TextEditorDecorationType");class D{constructor(p,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=p,this._documentVersionId=p.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(p,f){this._throwIfFinalized();let s=null;if(p instanceof E.Position)s=new E.Range(p,p);else if(p instanceof E.Range)s=p;else throw new Error("Unrecognized location");this._pushEdit(s,f,!1)}insert(p,f){this._throwIfFinalized(),this._pushEdit(new E.Range(p,p),f,!0)}delete(p){this._throwIfFinalized();let f=null;if(p instanceof E.Range)f=p;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(p,f,s){const h=this._document.validateRange(p);this._collectedEdits.push({range:h,text:f,forceMoveMarkers:s})}setEndOfLine(p){if(this._throwIfFinalized(),p!==E.EndOfLine.LF&&p!==E.EndOfLine.CRLF)throw(0,S.illegalArgument)("endOfLine");this._setEndOfLine=p}}e.TextEditorEdit=D;class n{constructor(p,f,s,h){this._proxy=p,this._id=f,this._accept(s),this._logService=h;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(g){v._setTabSize(g)},get insertSpaces(){return v._insertSpaces},set insertSpaces(g){v._setInsertSpaces(g)},get cursorStyle(){return v._cursorStyle},set cursorStyle(g){v._setCursorStyle(g)},get lineNumbers(){return v._lineNumbers},set lineNumbers(g){v._setLineNumbers(g)}}}_accept(p){this._tabSize=p.tabSize,this._insertSpaces=p.insertSpaces,this._cursorStyle=p.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(p.lineNumbers)}_validateTabSize(p){if(p==="auto")return"auto";if(typeof p=="number"){const f=Math.floor(p);return f>0?f:null}if(typeof p=="string"){const f=parseInt(p,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(p){const f=this._validateTabSize(p);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(p){return p==="auto"?"auto":p==="false"?!1:Boolean(p)}_setInsertSpaces(p){const f=this._validateInsertSpaces(p);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(p){this._cursorStyle!==p&&(this._cursorStyle=p,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:p})))}_setLineNumbers(p){this._lineNumbers!==p&&(this._lineNumbers=p,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(p)})))}assign(p){const f={};let s=!1;if(typeof p.tabSize!="undefined"){const h=this._validateTabSize(p.tabSize);h==="auto"?(s=!0,f.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,s=!0,f.tabSize=h)}if(typeof p.insertSpaces!="undefined"){const h=this._validateInsertSpaces(p.insertSpaces);h==="auto"?(s=!0,f.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,s=!0,f.insertSpaces=h)}typeof p.cursorStyle!="undefined"&&this._cursorStyle!==p.cursorStyle&&(this._cursorStyle=p.cursorStyle,s=!0,f.cursorStyle=p.cursorStyle),typeof p.lineNumbers!="undefined"&&this._lineNumbers!==p.lineNumbers&&(this._lineNumbers=p.lineNumbers,s=!0,f.lineNumbers=P.TextEditorLineNumbersStyle.from(p.lineNumbers)),s&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(p){p.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=n;class A{constructor(p,f,s,h,v,g,b,c){this.id=p,this._proxy=f,this._logService=s,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new n(this._proxy,this.id,g,s),this._visibleRanges=b,this._viewColumn=c;const u=this;this.value=Object.freeze({get document(){return h.getValue()},set document(a){throw(0,S.readonly)("document")},get selection(){return u._selections&&u._selections[0]},set selection(a){if(!(a instanceof E.Selection))throw(0,S.illegalArgument)("selection");u._selections=[a],u._trySetSelection()},get selections(){return u._selections},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof E.Selection)))throw(0,S.illegalArgument)("selections");u._selections=a,u._trySetSelection()},get visibleRanges(){return u._visibleRanges},set visibleRanges(a){throw(0,S.readonly)("visibleRanges")},get options(){return u._options.value},set options(a){u._disposed||u._options.assign(a)},get viewColumn(){return u._viewColumn},set viewColumn(a){throw(0,S.readonly)("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new D(h.getValue(),t);return a(r),u._applyEdit(r)},insertSnippet(a,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=u._selections.map(l=>P.Range.from(l));else if(t instanceof E.Position){const{lineNumber:l,column:i}=P.Position.from(t);o=[{startLineNumber:l,startColumn:i,endLineNumber:l,endColumn:i}]}else if(t instanceof E.Range)o=[P.Range.from(t)];else{o=[];for(const l of t)if(l instanceof E.Range)o.push(P.Range.from(l));else{const{lineNumber:i,column:d}=P.Position.from(l);o.push({startLineNumber:i,startColumn:d,endLineNumber:i,endColumn:d})}}return f.$tryInsertSnippet(p,a.value,o,r)},setDecorations(a,t){const r=t.length===0;r&&!u._hasDecorationsForKey.has(a.key)||(r?u._hasDecorationsForKey.delete(a.key):u._hasDecorationsForKey.add(a.key),u._runOnProxy(()=>{if(P.isDecorationOptionsArr(t))return f.$trySetDecorations(p,a.key,P.fromRangeOrRangeWithMessage(t));{const o=new Array(4*t.length);for(let l=0,i=t.length;l<i;l++){const d=t[l];o[4*l]=d.start.line+1,o[4*l+1]=d.start.character+1,o[4*l+2]=d.end.line+1,o[4*l+3]=d.end.character+1}return f.$trySetDecorationsFast(p,a.key,o)}}))},revealRange(a,t){u._runOnProxy(()=>f.$tryRevealRange(p,P.Range.from(a),t||E.TextEditorRevealType.Default))},show(a){f.$tryShowEditor(p,P.ViewColumn.from(a))},hide(){f.$tryHideEditor(p)}})}dispose(){(0,_.ok)(!this._disposed),this._disposed=!0}_acceptOptions(p){(0,_.ok)(!this._disposed),this._options._accept(p)}_acceptVisibleRanges(p){(0,_.ok)(!this._disposed),this._visibleRanges=p}_acceptViewColumn(p){(0,_.ok)(!this._disposed),this._viewColumn=p}_acceptSelections(p){(0,_.ok)(!this._disposed),this._selections=p}async _trySetSelection(){const p=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,p)),this.value}_applyEdit(p){const f=p.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const s=f.edits.map(v=>v.range);s.sort((v,g)=>v.end.line===g.end.line?v.end.character===g.end.character?v.start.line===g.start.line?v.start.character-g.start.character:v.start.line-g.start.line:v.end.character-g.end.character:v.end.line-g.end.line);for(let v=0,g=s.length-1;v<g;v++){const b=s[v].end;if(s[v+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=f.edits.map(v=>({range:P.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,h,{setEndOfLine:typeof f.setEndOfLine=="number"?P.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(p){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=A}),define(we[177],Ee([0,1,133,23,2,3,6,15,7,12,14,9,20]),function(re,e,_,S,T,P,E,C,D,n,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(v,g){if((0,n.isString)(v))return{label:v};if(v&&typeof v=="object"&&typeof v.label=="string"){let b;return Array.isArray(v.highlights)&&(b=v.highlights.filter(c=>c.length===2&&typeof c[0]=="number"&&typeof c[1]=="number"),b=b.length?b:void 0),{label:v.label,highlights:b}}}class s{constructor(g,b,c){this._proxy=g,this.commands=b,this.logService=c,this.treeViews=new Map;function u(a){return a&&a.$treeViewId&&a.$treeItemHandle}b.registerArgumentProcessor({processArgument:a=>u(a)?this.convertArgument(a):Array.isArray(a)&&a.length>0?a.map(t=>u(t)?this.convertArgument(t):t):a})}registerTreeDataProvider(g,b,c){const u=this.createTreeView(g,{treeDataProvider:b},c);return{dispose:()=>u.dispose()}}createTreeView(g,b,c){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=this._proxy.$registerTreeViewDataProvider(g,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany}),a=this.createExtHostTreeView(g,b,c);return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get message(){return a.message},set message(t){a.message=t},get title(){return a.title},set title(t){a.title=t},get description(){return a.description},set description(t){a.description=t},reveal:(t,r)=>a.reveal(t,r),dispose:async()=>{await u,this.treeViews.delete(g),a.dispose()}}}$getChildren(g,b){const c=this.treeViews.get(g);return c?c.getChildren(b):Promise.reject(new Error((0,_.localize)(0,null,g)))}async $hasResolve(g){const b=this.treeViews.get(g);if(!b)throw new Error((0,_.localize)(1,null,g));return b.hasResolve}$resolve(g,b,c){const u=this.treeViews.get(g);if(!u)throw new Error((0,_.localize)(2,null,g));return u.resolveTreeItem(b,c)}$setExpanded(g,b,c){const u=this.treeViews.get(g);if(!u)throw new Error((0,_.localize)(3,null,g));u.setExpanded(b,c)}$setSelection(g,b){const c=this.treeViews.get(g);if(!c)throw new Error((0,_.localize)(4,null,g));c.setSelection(b)}$setVisible(g,b){const c=this.treeViews.get(g);if(!c)throw new Error((0,_.localize)(5,null,g));c.setVisible(b)}createExtHostTreeView(g,b,c){const u=new h(g,b,this._proxy,this.commands.converter,this.logService,c);return this.treeViews.set(g,u),u}convertArgument(g){const b=this.treeViews.get(g.$treeViewId);return b?b.getExtensionElement(g.$treeItemHandle):null}}e.ExtHostTreeViews=s;class h extends E.Disposable{constructor(g,b,c,u,a,t){super();if(this.viewId=g,this.proxy=c,this.commands=u,this.logService=a,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new P.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new P.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new P.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new P.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new p.CancellationTokenSource,t.contributes&&t.contributes.views)for(const l in t.contributes.views)for(const i of t.contributes.views[l])i.id===g&&(this._title=i.name);this.dataProvider=b.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(l=>this._onDidChangeData.fire({message:!1,element:l})));let r,o;this._register(P.Event.debounce(this._onDidChangeData.event,(l,i)=>(l||(l={message:!1,elements:[]}),i.element!==!1&&(r||(r=new Promise(d=>o=d),this.refreshPromise=this.refreshPromise.then(()=>r)),l.elements.push(i.element)),i.message&&(l.message=!0),l),200,!0)(({message:l,elements:i})=>{i.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const d=o;return r=null,this.refresh(i).then(()=>d())})),l&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(g=>this.getExtensionElement(g)).filter(g=>!(0,n.isUndefinedOrNull)(g))}getChildren(g){const b=g?this.getExtensionElement(g):void 0;if(g&&!b)return this.logService.error(`No tree item with id '${g}' found.`),Promise.resolve([]);const c=this.getChildrenNodes(g);return(c?Promise.resolve(c):this.fetchChildrenNodes(b)).then(u=>u.map(a=>a.item))}getExtensionElement(g){return this.elements.get(g)}reveal(g,b){b=b||{select:!0,focus:!1};const c=(0,n.isUndefinedOrNull)(b.select)?!0:b.select,u=(0,n.isUndefinedOrNull)(b.focus)?!1:b.focus,a=(0,n.isUndefinedOrNull)(b.expand)?!1:b.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):g?this.refreshPromise.then(()=>this.resolveUnknownParentChain(g)).then(t=>this.resolveTreeNode(g,t[t.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:t.map(o=>o.item)},{select:c,focus:u,expand:a})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:c,focus:u,expand:a})}get message(){return this._message}set message(g){this._message=g,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(g){this._title=g,this.proxy.$setTitle(this.viewId,g,this._description)}get description(){return this._description}set description(g){this._description=g,this.proxy.$setTitle(this.viewId,this._title,g)}setExpanded(g,b){const c=this.getExtensionElement(g);c&&(b?this._onDidExpandElement.fire(Object.freeze({element:c})):this._onDidCollapseElement.fire(Object.freeze({element:c})))}setSelection(g){(0,A.equals)(this._selectedHandles,g)||(this._selectedHandles=g,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(g){g!==this._visible&&(this._visible=g,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(g,b){var c;if(!!this.dataProvider.resolveTreeItem){const u=this.elements.get(g);if(u){const a=this.nodes.get(u);if(a){const t=(c=await this.dataProvider.resolveTreeItem(a.extensionItem,u,b))!==null&&c!==void 0?c:a.extensionItem;return a.item.tooltip=this.getTooltip(t.tooltip),a.item.command=this.getCommand(a.disposableStore,t.command),a.item}}}}resolveUnknownParentChain(g){return this.resolveParent(g).then(b=>b?this.resolveUnknownParentChain(b).then(c=>this.resolveTreeNode(b,c[c.length-1]).then(u=>(c.push(u),c))):Promise.resolve([]))}resolveParent(g){const b=this.nodes.get(g);return b?Promise.resolve(b.parent?this.elements.get(b.parent.item.handle):void 0):(0,C.asPromise)(()=>this.dataProvider.getParent(g))}resolveTreeNode(g,b){const c=this.nodes.get(g);return c?Promise.resolve(c):(0,C.asPromise)(()=>this.dataProvider.getTreeItem(g)).then(u=>this.createHandle(g,u,b,!0)).then(u=>this.getChildren(b?b.item.handle:void 0).then(()=>{const a=this.getExtensionElement(u);if(a){const t=this.nodes.get(a);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(g){if(g){let b;if(typeof g=="string"){const c=this.getExtensionElement(g);b=c?this.nodes.get(c):void 0}else b=g;return b&&b.children||null}return this.roots}async fetchChildrenNodes(g){this.clearChildren(g);const b=new p.CancellationTokenSource(this._refreshCancellationSource.token);try{const c=g?this.nodes.get(g):void 0,u=await this.dataProvider.getChildren(g);if(b.token.isCancellationRequested)return[];const a=await Promise.all((0,A.coalesce)(u||[]).map(async t=>{const r=await this.dataProvider.getTreeItem(t);return r&&!b.token.isCancellationRequested?this.createAndRegisterTreeNode(t,r,c):null}));return b.token.isCancellationRequested?[]:(0,A.coalesce)(a)}finally{b.dispose()}}refresh(g){if(g.some(c=>!c))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new p.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const c=this.getHandlesToRefresh(g);if(c.length)return this.refreshHandles(c)}return Promise.resolve(void 0)}getHandlesToRefresh(g){const b=new Set;for(const u of g){const a=this.nodes.get(u);if(a&&!b.has(a.item.handle)){let t=a;for(;t&&t.parent&&!b.has(t.parent.item.handle);){const r=this.elements.get(t.parent.item.handle);t=r?this.nodes.get(r):void 0}t&&!t.parent&&b.add(a.item.handle)}}const c=[];return b.forEach(u=>{const a=this.elements.get(u);if(a){const t=this.nodes.get(a);t&&(!t.parent||!b.has(t.parent.item.handle))&&c.push(u)}}),c}refreshHandles(g){const b={};return Promise.all(g.map(c=>this.refreshNode(c).then(u=>{u&&(b[c]=u.item)}))).then(()=>Object.keys(b).length?this.proxy.$refresh(this.viewId,b):void 0)}refreshNode(g){const b=this.getExtensionElement(g);if(b){const c=this.nodes.get(b);if(c)return this.clearChildren(b),(0,C.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(u=>{if(u){const a=this.createTreeNode(b,u,c.parent);return this.updateNodeCache(b,a,c,c.parent),c.dispose(),a}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(g,b,c){const u=this.createTreeNode(g,b,c);if(b.id&&this.elements.has(u.item.handle))throw new Error((0,_.localize)(6,null,b.id));return this.addNodeToCache(g,u),this.addNodeToParentCache(u,c),u}getTooltip(g){return D.MarkdownString.isMarkdownString(g)?I.MarkdownString.from(g):g}getCommand(g,b){return b?this.commands.toInternal(b,g):void 0}createTreeNode(g,b,c){const u=new E.DisposableStore,a=this.createHandle(g,b,c),t=this.getLightIconPath(b);return{item:{handle:a,parentHandle:c?c.item.handle:void 0,label:f(b.label,this.extension),description:b.description,resourceUri:b.resourceUri,tooltip:this.getTooltip(b.tooltip),command:this.getCommand(u,b.command),contextValue:b.contextValue,icon:t,iconDark:this.getDarkIconPath(b)||t,themeIcon:this.getThemeIcon(b),collapsibleState:(0,n.isUndefinedOrNull)(b.collapsibleState)?D.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation},extensionItem:b,parent:c,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(g){return g.iconPath instanceof D.ThemeIcon?g.iconPath:void 0}createHandle(g,{id:b,label:c,resourceUri:u},a,t){if(b)return`${h.ID_HANDLE_PREFIX}/${b}`;const r=f(c,this.extension),o=a?a.item.handle:h.LABEL_HANDLE_PREFIX;let l=r?r.label:u?(0,S.basename)(u):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const i=this.nodes.has(g)?this.nodes.get(g).item.handle:void 0,d=this.getChildrenNodes(a)||[];let y,k=0;do{if(y=`${o}/${k}:${l}`,t||!this.elements.has(y)||i===y)break;k++}while(k<=d.length);return y}getLightIconPath(g){if(g.iconPath&&!(g.iconPath instanceof D.ThemeIcon))return typeof g.iconPath=="string"||T.URI.isUri(g.iconPath)?this.getIconPath(g.iconPath):this.getIconPath(g.iconPath.light)}getDarkIconPath(g){if(g.iconPath&&!(g.iconPath instanceof D.ThemeIcon)&&g.iconPath.dark)return this.getIconPath(g.iconPath.dark)}getIconPath(g){return T.URI.isUri(g)?g:T.URI.file(g)}addNodeToCache(g,b){this.elements.set(b.item.handle,g),this.nodes.set(g,b)}updateNodeCache(g,b,c,u){this.elements.delete(b.item.handle),this.nodes.delete(g),b.item.handle!==c.item.handle&&this.elements.delete(c.item.handle),this.addNodeToCache(g,b);const a=this.getChildrenNodes(u)||[],t=a.filter(r=>r.item.handle===c.item.handle)[0];t&&a.splice(a.indexOf(t),1,b)}addNodeToParentCache(g,b){b?(b.children||(b.children=[]),b.children.push(g)):(this.roots||(this.roots=[]),this.roots.push(g))}clearChildren(g){if(g){const b=this.nodes.get(g);if(b){if(b.children)for(const c of b.children){const u=this.elements.get(c.item.handle);u&&this.clear(u)}b.children=void 0}}else this.clearAll()}clear(g){const b=this.nodes.get(g);if(b){if(b.children)for(const c of b.children){const u=this.elements.get(c.item.handle);u&&this.clear(u)}this.nodes.delete(g),this.elements.delete(b.item.handle),b.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(g=>g.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}h.LABEL_HANDLE_PREFIX="0",h.ID_HANDLE_PREFIX="1"}),define(we[178],Ee([0,1,14,15,45,9]),function(re,e,_,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class E{constructor(){this.testIdsToInternal=new Set}getTestById(s){return(0,_.mapFind)(this.testIdsToInternal,h=>{const v=h.get(s);return v&&[h,v]})}createForHierarchy(s=()=>{}){return new n(this.createIdMap(),s)}createIdMap(){const s=new D;return this.testIdsToInternal.add(s),{object:s,dispose:()=>this.testIdsToInternal.delete(s)}}}e.OwnedTestCollection=E;var C;(function(f){f[f.Disconnected=0]="Disconnected",f[f.IsChild=1]="IsChild",f[f.IsParent=2]="IsParent",f[f.IsSame=3]="IsSame"})(C=e.TestPosition||(e.TestPosition={}));class D{constructor(){this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(s){if(this.map.has(s.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${s.item.extId}`);this.map.set(s.item.extId,s),s.parent||this._roots.add(s)}has(s){return this.map.has(s)}delete(s){const h=this.map.get(s);return h?(this.map.delete(s),this._roots.delete(h),!0):!1}get(s){return this.map.get(s)}comparePositions(s,h){const v=typeof s=="string"?this.map.get(s):s,g=typeof h=="string"?this.map.get(h):h;if(!v||!g)return 0;if(v===g)return 3;for(let b=this.map.get(g.parent);b;b=this.map.get(b.parent))if(b===v)return 1;for(let b=this.map.get(v.parent);b;b=this.map.get(b.parent))if(b===g)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=D;class n{constructor(s,h){this.testIdToInternal=s,this.publishDiff=h,this.testItemToInternal=new Map,this.diff=[],this.disposed=!1,this.debounceSendDiff=new S.RunOnceScheduler(()=>this.throttleSendDiff(),2)}addRoot(s,h){this.addItem(s,h,null),this.debounceSendDiff.schedule()}getTestByReference(s){return this.testItemToInternal.get(s)}onItemChange(s,h){const v=this.testItemToInternal.get(s);if(!v){this.disposed||console.warn("Received a TestProvider.onDidChangeTest for a test that wasn't seen before as a child.");return}this.addItem(s,h,v.parent),this.debounceSendDiff.schedule()}collectDiff(){const s=this.diff;return this.diff=[],s}pushDiff(s){this.diff.push(s),this.debounceSendDiff.schedule()}dispose(){this.testIdToInternal.dispose(),this.diff=[],this.disposed=!0}addItem(s,h,v){let g=this.testItemToInternal.get(s);if(g)g.previousEquals(s)||(g.item=P.TestItem.from(s),g.previousEquals=p(s),this.diff.push([1,{parent:v,providerId:h,item:g.item}]));else{if(this.testIdToInternal.object.has(s.id))throw new Error(`Attempted to insert a duplicate test item ID ${s.id}`);g={actual:s,parent:v,item:P.TestItem.from(s),providerId:h,previousChildren:new Set,previousEquals:p(s)},this.testIdToInternal.object.add(g),this.testItemToInternal.set(s,g),this.diff.push([0,{parent:v,providerId:h,item:g.item}])}if(s.children){const b=g.previousChildren,c=new Set;for(const u of s.children){const a=this.testIdToInternal.object.get(u.id);a&&a.actual!==u&&this.removeItembyId(u.id);const t=this.addItem(u,h,g.item.extId);b.delete(t.item.extId),c.add(t.item.extId)}for(const u of b)this.removeItembyId(u);g.previousChildren=c}return g}removeItembyId(s){this.diff.push([2,s]);const h=[this.testIdToInternal.object.get(s)];for(;h.length;){const v=h.pop();if(!!v){this.testIdToInternal.object.delete(v.item.extId),this.testItemToInternal.delete(v.actual);for(const g of v.previousChildren)h.push(this.testIdToInternal.object.get(g))}}}throttleSendDiff(){this.flushDiff()}flushDiff(){const s=this.collectDiff();s.length&&this.publishDiff(s)}}Ve([(0,T.throttle)(200)],n.prototype,"throttleSendDiff",null),e.SingleUseTestCollection=n;const I=Object.keys({id:null,label:null,location:null,debuggable:null,description:null,runnable:null}),p=f=>{const s=[];for(const h of I)s.push(f[h]);return h=>{for(let v=0;v<I.length;v++)if(s[v]!==h[I[v]])return!1;return!0}}}),define(we[179],Ee([0,1,25,3,10]),function(re,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(A){this.removedDueToLooping=A}}e.DeltaExtensionsResult=P;class E{constructor(A){this._onDidChange=new S.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=A,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const A of this._extensionDescriptions){if(this._extensionsMap.has(_.ExtensionIdentifier.toKey(A.identifier))){console.error("Extension `"+A.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(_.ExtensionIdentifier.toKey(A.identifier),A),this._extensionsArr.push(A),Array.isArray(A.activationEvents))for(let I of A.activationEvents)I==="onUri"&&(I=`onUri:${_.ExtensionIdentifier.toKey(A.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(A)}}keepOnly(A){const I=new Set;A.forEach(p=>I.add(_.ExtensionIdentifier.toKey(p))),this._extensionDescriptions=this._extensionDescriptions.filter(p=>I.has(_.ExtensionIdentifier.toKey(p.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(A,I){A.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(A));const p=E._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(p.map(f=>f.identifier)),I.length>0){const f=new Set;I.forEach(s=>f.add(_.ExtensionIdentifier.toKey(s))),this._extensionDescriptions=this._extensionDescriptions.filter(s=>!f.has(_.ExtensionIdentifier.toKey(s.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new P(p)}static _findLoopingExtensions(A){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,g){this.addNode(v),this.addNode(g),this._arcs.has(v)?this._arcs.get(v).push(g):this._arcs.set(v,[g])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,g){const b=I.getArcs(v);for(let c=0;c<b.length;c++)if(!g.has(b[c]))return!1;return!0}getNodes(){return this._nodesArr}};let p=new Map;for(let v of A){const g=_.ExtensionIdentifier.toKey(v.identifier);if(p.set(g,v),v.extensionDependencies)for(let b of v.extensionDependencies){const c=_.ExtensionIdentifier.toKey(b);I.addArc(g,c)}}let f=new Set;I.getNodes().filter(v=>I.getArcs(v).length===0).forEach(v=>f.add(v));let s=I.getNodes().filter(v=>!f.has(v)),h;do{h=!1;for(let v=0;v<s.length;v++){const g=s[v];I.hasOnlyGoodArcs(g,f)&&(s.splice(v,1),v--,f.add(g),h=!0)}}while(h);return s.map(v=>p.get(v))}containsActivationEvent(A){return this._activationMap.has(A)}containsExtension(A){return this._extensionsMap.has(_.ExtensionIdentifier.toKey(A))}getExtensionDescriptionsForActivationEvent(A){const I=this._activationMap.get(A);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(A){const I=this._extensionsMap.get(_.ExtensionIdentifier.toKey(A));return I||void 0}}e.ExtensionDescriptionRegistry=E;var C;(function(n){n[n.Builtin=0]="Builtin",n[n.User=1]="User",n[n.Dev=2]="Dev"})(C||(C={}));function D(n,A){const I=n.isBuiltin?0:n.isUnderDevelopment?2:1,p=A.isBuiltin?0:A.isUnderDevelopment?2:1;if(I!==p)return I-p;const f=T.posix.basename(n.extensionLocation.path),s=T.posix.basename(A.extensionLocation.path);return f<s?-1:f>s?1:0}}),define(we[180],Ee([0,1,26]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var S;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(S=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var T;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(T=e.MessageType||(e.MessageType={}));function P(C){const D=_.VSBuffer.alloc(1);switch(C){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=P;function E(C,D){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=E}),define(we[33],Ee([0,1,3,2,4,25,146]),function(re,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwRequiresWorkspaceTrustError=e.checkRequiresWorkspaceTrust=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:S.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class C{constructor(u){this.dependency=u}}e.MissingDependencyError=C;var D;(function(c){c[c.LocalProcess=0]="LocalProcess",c[c.LocalWebWorker=1]="LocalWebWorker",c[c.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(u,a,t,r){this.codeLoadingTime=u,this.activateCallTime=a,this.activateResolvedTime=t,this.activationReason=r}}e.ActivationTimes=n;class A{constructor(u,a){this.description=u,this.value=a}}e.ExtensionPointContribution=A,e.ExtensionHostLogFileName="exthost";var I;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function p(c){c.enableProposedApi||f(c)}e.checkProposedApiEnabled=p;function f(c){throw new Error(`[${c.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.throwProposedApiError=f;function s(c){c.requiresWorkspaceTrust||h(c)}e.checkRequiresWorkspaceTrust=s;function h(c){throw new Error(`[${c.identifier.value}]: This API is only available when the "requiresWorkspaceTrust" is set to "onStart" or "onDemand" in the extension's package.json.`)}e.throwRequiresWorkspaceTrustError=h;function v(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,E.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation}}e.toExtension=v;function g(c){return Object.assign(Object.assign({identifier:new P.ExtensionIdentifier(c.identifier.id),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!1,extensionLocation:c.location},c.manifest),{uuid:c.identifier.uuid})}e.toExtensionDescription=g;class b{constructor(){this.onDidRegisterExtensions=_.Event.None,this.onDidChangeExtensionsStatus=_.Event.None,this.onDidChangeExtensions=_.Event.None,this.onWillActivateByEvent=_.Event.None,this.onDidChangeResponsiveChange=_.Event.None}activateByEvent(u){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u){return Promise.resolve(0)}restartExtensionHost(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(u,a){}_activateById(u,a){return Promise.resolve()}_onWillActivateExtension(u){}_onDidActivateExtension(u,a,t,r,o){}_onExtensionRuntimeError(u,a){}_onExtensionHostExit(u){}}e.NullExtensionService=b}),define(we[181],Ee([0,1,128,25,33,19]),function(re,e,_,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const E=Promise.resolve(void 0);class C{constructor(h,v,g,b){this.startup=h,this.codeLoadingTime=v,this.activateCallTime=g,this.activateResolvedTime=b}}e.ExtensionActivationTimes=C,C.NONE=new C(!1,-1,-1,-1);class D{constructor(h){this._startup=h,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(h,v){return h===-1||v===-1?-1:v-h}build(){return new C(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class n{constructor(h,v,g,b,c,u){this.activationFailed=h,this.activationFailedError=v,this.activationTimes=g,this.module=b,this.exports=c,this.subscriptions=u}}e.ActivatedExtension=n;class A extends n{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=A;class I extends n{constructor(){super(!1,null,C.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=I;class p extends n{constructor(h){super(!0,h,C.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=p;let f=class{constructor(h,v,g,b,c){this._logService=c,this._registry=h,this._resolvedExtensionsSet=new Set,v.forEach(u=>this._resolvedExtensionsSet.add(S.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,g.forEach(u=>this._hostExtensionsMap.set(S.ExtensionIdentifier.toKey(u),u)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(h){const v=S.ExtensionIdentifier.toKey(h);return this._activatedExtensions.has(v)}getActivatedExtension(h){const v=S.ExtensionIdentifier.toKey(h),g=this._activatedExtensions.get(v);if(!g)throw new Error("Extension `"+h.value+"` is not known or not activated");return g}activateByEvent(h,v){if(this._alreadyActivatedEvents[h])return E;const g=this._registry.getExtensionDescriptionsForActivationEvent(h);return this._activateExtensions(g.map(b=>({id:b.identifier,reason:{startup:v,extensionId:b.identifier,activationEvent:h}}))).then(()=>{this._alreadyActivatedEvents[h]=!0})}activateById(h,v){const g=this._registry.getExtensionDescription(h);if(!g)throw new Error("Extension `"+h+"` is not known");return this._activateExtensions([{id:g.identifier,reason:v}])}_handleActivateRequest(h,v,g){if(this._hostExtensionsMap.has(S.ExtensionIdentifier.toKey(h.id))){v[S.ExtensionIdentifier.toKey(h.id)]=h;return}const b=this._registry.getExtensionDescription(h.id);if(!b){this._host.onExtensionActivationError(h.id,new T.MissingDependencyError(h.id.value));const a=new Error(`Unknown dependency '${h.id.value}'`);this._activatedExtensions.set(S.ExtensionIdentifier.toKey(h.id),new p(a));return}const c=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let u=!0;for(let a=0,t=c.length;a<t;a++){const r=c[a];if(!this._resolvedExtensionsSet.has(S.ExtensionIdentifier.toKey(r))){const o=this._activatedExtensions.get(S.ExtensionIdentifier.toKey(r));if(!(o&&!o.activationFailed)){if(o&&o.activationFailed){this._host.onExtensionActivationError(b.identifier,_.localize(0,null,b.displayName||b.identifier.value,r));const d=new Error(`Dependency ${r} failed to activate`);d.detail=o.activationFailedError,this._activatedExtensions.set(S.ExtensionIdentifier.toKey(b.identifier),new p(d));return}if(this._hostExtensionsMap.has(S.ExtensionIdentifier.toKey(r))){u=!1,v[S.ExtensionIdentifier.toKey(r)]={id:this._hostExtensionsMap.get(S.ExtensionIdentifier.toKey(r)),reason:h.reason};continue}const l=this._registry.getExtensionDescription(r);if(l){u=!1,v[S.ExtensionIdentifier.toKey(r)]={id:l.identifier,reason:h.reason};continue}this._host.onExtensionActivationError(b.identifier,new T.MissingDependencyError(r));const i=new Error(`Unknown dependency '${r}'`);this._activatedExtensions.set(S.ExtensionIdentifier.toKey(b.identifier),new p(i));return}}}u?v[S.ExtensionIdentifier.toKey(b.identifier)]=h:g.push(h)}_activateExtensions(h){if(h.length===0||(h=h.filter(c=>!this._activatedExtensions.has(S.ExtensionIdentifier.toKey(c.id))),h.length===0))return Promise.resolve(void 0);const v=Object.create(null),g=[];for(let c=0,u=h.length;c<u;c++)this._handleActivateRequest(h[c],v,g);for(let c=0,u=g.length;c<u;c++){const a=S.ExtensionIdentifier.toKey(g[c].id);v[a]&&delete v[a]}const b=Object.keys(v).map(c=>v[c]);return g.length===0?Promise.all(b.map(c=>this._activateExtension(c.id,c.reason))).then(c=>{}):this._activateExtensions(b).then(c=>this._activateExtensions(g))}_activateExtension(h,v){const g=S.ExtensionIdentifier.toKey(h);if(this._activatedExtensions.has(g))return Promise.resolve(void 0);const b=this._activatingExtensions.get(g);if(b)return b;const c=this._host.actualActivateExtension(h,v).then(void 0,u=>(this._host.onExtensionActivationError(h,_.localize(1,null,h.value,u.message)),this._logService.error(`Activating extension ${h.value} failed due to an error:`),this._logService.error(u),new p(u))).then(u=>{this._activatedExtensions.set(g,u),this._activatingExtensions.delete(g)});return this._activatingExtensions.set(g,c),c}};f=Ve([qe(4,P.ILogService)],f),e.ExtensionsActivator=f}),define(we[182],Ee([0,1,11]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class S{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((P,E)=>{this._actualOk=P,this._actualErr=E,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(P){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=P,this._actual&&this._actualOk(P))}resolveErr(P){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=P,this._actual?this._actualErr(P):(0,_.onUnexpectedError)(P))}then(P,E){return this._ensureActual().then(P,E)}catch(P){return this._ensureActual().then(void 0,P)}finally(P){return this._ensureActual().finally(P)}}e.LazyPromise=S}),define(we[96],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class _{constructor(D,n){this.isMain=D,this.sid=n,this.nid=++_.count}}e.ProxyIdentifier=_,_.count=0;const S=[];function T(C){const D=new _(!0,C);return S[D.nid]=D,D}e.createMainContextProxyIdentifier=T;function P(C){const D=new _(!1,C);return S[D.nid]=D,D}e.createExtHostContextProxyIdentifier=P;function E(C){return S[C].sid}e.getStringIdentifierForProxy=E}),define(we[5],Ee([0,1,2,96,58]),function(re,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var P;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(P=e.UIKind||(e.UIKind={}));var E;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(E=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(c){c[c.Markdown=1]="Markdown",c[c.Code=2]="Code"})(D=e.CellKind||(e.CellKind={}));var n;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(n=e.CellOutputKind||(e.CellOutputKind={}));var A;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(A=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var p;(function(c){c.name="$ident";function u(t,r){return Object.defineProperty(t,c.name,{value:r,enumerable:!0}),t}c.mixin=u;function a(t){return t[c.name]}c.of=a})(p=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(u){return u._id=f._n++,u}}e.IdObject=f,f._n=0;var s;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n",c.label2="o"})(s=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var h;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(h=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function g(c){if(c&&c.edits)for(const u of c.edits)typeof u.resource=="object"?u.resource=_.URI.revive(u.resource):(u.newUri=_.URI.revive(u.newUri),u.oldUri=_.URI.revive(u.oldUri)),u.metadata&&u.metadata.iconPath&&(u.metadata=(0,T.revive)(u.metadata));return c}e.reviveWorkspaceEditDto=g;var b;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,S.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,S.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,S.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,S.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,S.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,S.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,S.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,S.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,S.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,S.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,S.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,S.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,S.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,S.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,S.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,S.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,S.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,S.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,S.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,S.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,S.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,S.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,S.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,S.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,S.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,S.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,S.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,S.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,S.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,S.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,S.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadTheming:(0,S.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,S.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,S.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,S.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,S.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,S.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,S.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,S.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,S.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,S.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,S.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,S.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,S.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,S.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,S.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,S.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,S.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,S.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,S.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,S.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,S.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,S.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,S.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,S.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,S.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,S.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostTheming:(0,S.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,S.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,S.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,S.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,S.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,S.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(we[71],Ee([0,1,5,3,4]),function(re,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(C){this._onDidChangePassword=new S.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(_.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,D){return this._proxy.$getPassword(C,D)}store(C,D,n){return this._proxy.$setPassword(C,D,n)}delete(C,D){return this._proxy.$deletePassword(C,D)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,T.createDecorator)("IExtHostSecretState")}),define(we[72],Ee([0,1,4,19,5,13]),function(re,e,_,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,_.createDecorator)("IExtHostApiDeprecationService");let E=class{constructor(D,n){this._extHostLogService=n,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(T.MainContext.MainThreadTelemetry)}report(D,n,A){const I=this.getUsageKey(D,n);this._reportedUsages.has(I)||(this._reportedUsages.add(I),n.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${A}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:n.identifier.value,apiId:D}))}getUsageKey(D,n){return`${D}-${n.identifier.value}`}};E=Ve([qe(0,P.IExtHostRpcService),qe(1,S.ILogService)],E),e.ExtHostApiDeprecationService=E,e.NullApiDeprecationService=Object.freeze(new class{report(C,D,n){}})}),define(we[183],Ee([0,1,3,5,7,25]),function(re,e,_,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class E{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new _.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new _.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(S.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(D,n,A,I={}){const p=P.ExtensionIdentifier.toKey(D.identifier),f=this._inFlightRequests.get(p)||[],s=A.sort().join(" ");let h=f.find(v=>v.scopes===s);if(h)return h.result;{const v=this._getSession(D,p,n,A,I);h={scopes:s,result:v},f.push(h),this._inFlightRequests.set(p,f);try{await v}finally{const g=f.findIndex(b=>b.scopes===s);g>-1&&(f.splice(g),this._inFlightRequests.set(p,f))}return v}}async _getSession(D,n,A,I,p={}){await this._proxy.$ensureProvider(A);const f=D.displayName||D.name;return this._proxy.$getSession(A,I,n,f,p)}async removeSession(D,n){const A=this._authenticationProviders.get(D);return A?A.provider.removeSession(n):this._proxy.$removeSession(D,n)}registerAuthenticationProvider(D,n,A,I){var p;if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:n,provider:A,options:I!=null?I:{supportsMultipleAccounts:!1}}),this._providers.find(s=>s.id===D)||this._providers.push({id:D,label:n});const f=A.onDidChangeSessions(s=>{var h,v,g;this._proxy.$sendDidChangeSessions(D,{added:(h=s.added)!==null&&h!==void 0?h:[],changed:(v=s.changed)!==null&&v!==void 0?v:[],removed:(g=s.changed)!==null&&g!==void 0?g:[]})});return this._proxy.$registerAuthenticationProvider(D,n,(p=I==null?void 0:I.supportsMultipleAccounts)!==null&&p!==void 0?p:!1),new T.Disposable(()=>{f.dispose(),this._authenticationProviders.delete(D);const s=this._providers.findIndex(h=>h.id===D);s>-1&&this._providers.splice(s),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,n){const A=this._authenticationProviders.get(D);if(A)return Promise.resolve(A.provider.createSession(n));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,n){const A=this._authenticationProviders.get(D);if(A)return Promise.resolve(A.provider.removeSession(n));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,n){const A=this._authenticationProviders.get(D);if(A)return Promise.resolve(A.provider.getSessions(n));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,n){return this._onDidChangeSessions.fire({provider:{id:D,label:n}}),Promise.resolve()}$onDidChangeAuthenticationProviders(D,n){return D.forEach(A=>{this._providers.some(I=>I.id===A.id)||this._providers.push(A)}),n.forEach(A=>{const I=this._providers.findIndex(p=>p.id===A.id);I>-1&&this._providers.splice(I)}),this._onDidChangeAuthenticationProviders.fire({added:D,removed:n}),Promise.resolve()}}e.ExtHostAuthentication=E}),define(we[184],Ee([0,1,5,13,9]),function(re,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(C,D){this._extHostDocumentsAndEditors=D,this._proxy=C.getProxy(_.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const D=T.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};P=Ve([qe(0,S.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(we[185],Ee([0,1,5]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class S{constructor(P){const E=P.getProxy(_.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return E.$readText()},writeText(C){return E.$writeText(C)}})}}e.ExtHostClipboard=S}),define(we[73],Ee([0,1,12,7,9,24,5,14,19,58,32,39,2,6,4,13]),function(re,e,_,S,T,P,E,C,D,n,A,I,p,f,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let v=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadCommands),this._logService=r,this.converter=new g(this,o=>{const l=this._apiCommands.get(o);return(l==null?void 0:l.result)===c.Void?l:void 0},r),this._argumentProcessors=[{processArgument(o){return(0,n.revive)(o)}},{processArgument(o){return(0,P.cloneAndChange)(o,function(l){if(A.Range.isIRange(l))return T.Range.to(l);if(I.Position.isIPosition(l))return T.Position.to(l);if(A.Range.isIRange(l.range)&&p.URI.isUri(l.uri))return T.location.to(l);if(!Array.isArray(l))return l})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...o)=>{const l=t.args.map((d,y)=>{if(!d.validate(o[y]))throw new Error(`Invalid argument '${d.name}' when running '${t.id}', received: ${o[y]}`);return d.convert(o[y])}),i=await this.executeCommand(t.internalId,...l);return t.result.convert(i,o,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new S.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,o,l,i){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:o,thisArg:l,description:i}),t&&this._proxy.$registerCommand(r),new S.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,o){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const l=(0,P.cloneAndChange)(r,function(i){if(i instanceof S.Position)return T.Position.from(i);if(i instanceof S.Range)return T.Range.from(i);if(i instanceof S.Location)return T.location.from(i);if(!Array.isArray(i))return i});try{const i=await this._proxy.$executeCommand(t,l,o);return(0,n.revive)(i)}catch(i){if(i instanceof Error&&i.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw i}}}async _executeContributedCommand(t,r){const o=this._commands.get(t);if(!o)throw new Error("Unknown command");let{callback:l,thisArg:i,description:d}=o;if(d)for(let y=0;y<d.args.length;y++)try{(0,_.validateConstraint)(r[y],d.args[y].constraint)}catch(k){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${d.args[y].name}' - ${d.args[y].description}`)}try{return await l.apply(i,r)}catch(y){if(t===this.converter.delegatingCommandId){const k=this.converter.getActualCommand(...r);k&&(t=k.command)}throw this._logService.error(y,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(o=>this._argumentProcessors.reduce((l,i)=>i.processArgument(l),o)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(o=>o[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,o]of this._commands){let{description:l}=o;l&&(t[r]=l)}return Promise.resolve(t)}};v=Ve([qe(0,h.IExtHostRpcService),qe(1,D.ILogService)],v),e.ExtHostCommands=v,e.IExtHostCommands=(0,s.createDecorator)("IExtHostCommands");class g{constructor(t,r,o){this._commands=t,this._lookupApiCommand=r,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!!t){const o={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return o;const l=this._lookupApiCommand(t.command);if(l)o.id=l.internalId,o.arguments=l.args.map((i,d)=>i.convert(t.arguments&&t.arguments[d]));else if((0,C.isNonEmptyArray)(t.arguments)){const i=++this._cachIdPool;this._cache.set(i,t),r.add((0,f.toDisposable)(()=>{this._cache.delete(i),this._logService.trace("CommandsConverter#DISPOSE",i)})),o.$ident=i,o.id=this.delegatingCommandId,o.arguments=[i],this._logService.trace("CommandsConverter#CREATE",t.command,i)}return o}}fromInternal(t){const r=E.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=g;class b{constructor(t,r,o,l){this.name=t,this.description=r,this.validate=o,this.convert=l}optional(){return new b(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new b(t!=null?t:this.name,r!=null?r:this.description,this.validate,this.convert)}}e.ApiCommandArgument=b,b.Uri=new b("uri","Uri of a text document",a=>p.URI.isUri(a),a=>a),b.Position=new b("position","A position in a text document",a=>S.Position.isPosition(a),T.Position.from),b.Range=new b("range","A range in a text document",a=>S.Range.isRange(a),T.Range.from),b.Selection=new b("selection","A selection in a text document",a=>S.Selection.isSelection(a),T.Selection.from),b.Number=new b("number","",a=>typeof a=="number",a=>a),b.String=new b("string","",a=>typeof a=="string",a=>a),b.CallHierarchyItem=new b("item","A call hierarchy item",a=>a instanceof S.CallHierarchyItem,T.CallHierarchyItem.to);class c{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=c,c.Void=new c("no result",a=>a);class u{constructor(t,r,o,l,i){this.id=t,this.internalId=r,this.description=o,this.args=l,this.result=i}}e.ApiCommand=u}),define(we[186],Ee([0,1,6,9,7,63,73,161,14,84]),function(re,e,_,S,T,P,E,C,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const A=[new E.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",p(S.DocumentHighlight.to))),new E.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(s,h)=>{if(!(0,D.isFalsyOrEmpty)(s)){class v extends T.SymbolInformation{static to(b){const c=new v(b.name,S.SymbolKind.to(b.kind),b.containerName||"",new T.Location(h[0],S.Range.to(b.range)));return c.detail=b.detail,c.range=c.location.range,c.selectionRange=S.Range.to(b.selectionRange),c.children=b.children?b.children.map(v.to):[],c}}return s.map(v.to)}})),new E.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(S.TextEdit.to))),new E.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range,new E.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(S.TextEdit.to))),new E.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,new E.ApiCommandArgument("ch","Trigger character",s=>typeof s=="string",s=>s),new E.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(S.TextEdit.to))),new E.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new E.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new E.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new E.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new E.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location-instances.",p(S.location.to))),new E.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Hover-instances.",p(S.Hover.to))),new E.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("position","A position in a text document",s=>Array.isArray(s)&&s.every(h=>T.Position.isPosition(h)),s=>s.map(S.Position.from))],new E.ApiCommandResult("A promise that resolves to an array of ranges.",s=>s.map(h=>{let v;for(const g of h.reverse())v=new T.SelectionRange(S.Range.to(g),v);return v}))),new E.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[E.ApiCommandArgument.String.with("query","Search string")],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",s=>{const h=[];if(Array.isArray(s))for(let v of s)h.push(...v[1].map(S.WorkspaceSymbol.to));return h})),new E.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(S.CallHierarchyItem.to))),new E.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(S.CallHierarchyIncomingCall.to))),new E.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(S.CallHierarchyOutgoingCall.to))),new E.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("newName","The new symbol name")],new E.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",s=>{if(!!s){if(s.rejectReason)throw new Error(s.rejectReason);return S.WorkspaceEdit.to(s)}})),new E.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new E.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(S.DocumentLink.to))),new E.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(!!s)return new T.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!!s){const h=(0,n.decodeSemanticTokensDto)(s);if(h.type==="full")return new T.SemanticTokens(h.data,void 0)}})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(!!s)return new T.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!!s){const h=(0,n.decodeSemanticTokensDto)(s);if(h.type==="full")return new T.SemanticTokens(h.data,void 0)}})),new E.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new E.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(s,h,v)=>{if(!s)return new T.CompletionList([]);const g=s.suggestions.map(b=>S.CompletionItem.to(b,v));return new T.CompletionList(g,s.incomplete)})),new E.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new E.ApiCommandResult("A promise that resolves to SignatureHelp.",s=>{if(s)return S.SignatureHelp.to(s)})),new E.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new E.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(s,h,v)=>p(g=>new T.CodeLens(S.Range.to(g.range),g.command&&v.fromInternal(g.command)))(s))),new E.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>T.Range.isRange(s),s=>T.Selection.isSelection(s)?S.Selection.from(s):S.Range.from(s)),E.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new E.ApiCommandResult("A promise that resolves to an array of Command-instances.",(s,h,v)=>p(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return v.fromInternal(g.command)}else{const b=new T.CodeAction(g.title,g.kind?new T.CodeActionKind(g.kind):void 0);return g.edit&&(b.edit=S.WorkspaceEdit.to(g.edit)),g.command&&(b.command=v.fromInternal(g.command)),b.isPreferred=g.isPreferred,b}})(s))),new E.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(h=>new T.ColorInformation(S.Range.to(h.range),S.Color.to(h.color))):[])),new E.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new E.ApiCommandArgument("color","The color to show and insert",s=>s instanceof T.Color,S.Color.from),new E.ApiCommandArgument("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:S.Range.from(s.range)}))],new E.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(S.ColorPresentation.to):[])),new E.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of InlineHint objects",s=>s.map(S.InlineHint.to))),new E.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new E.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",p(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientMetadata:s.options.transientMetadata},filenamePattern:s.filenamePattern.map(h=>S.NotebookExclusiveDocumentPattern.to(h))})))),new E.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of InlineValue objects",s=>s.map(S.InlineValue.to))),new E.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[s,void 0]:[S.ViewColumn.from(s.viewColumn),S.TextEditorOpenOptions.from(s)])).optional(),E.ApiCommandArgument.String.with("label","").optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[E.ApiCommandArgument.Uri.with("resource","Resource to open"),E.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[s,void 0]:[S.ViewColumn.from(s.viewColumn),S.TextEditorOpenOptions.from(s)])).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[E.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),E.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),E.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[S.ViewColumn.from(s.viewColumn),S.TextEditorOpenOptions.from(s)]).optional()],E.ApiCommandResult.Void)];class I{constructor(h){this._disposables=new _.DisposableStore,this._commands=h}static register(h){return A.forEach(h.registerApiCommand,h),new I(h).registerCommands()}registerCommands(){const h=v=>(...g)=>v(this._commands,...g);this._register(C.RemoveFromRecentlyOpenedAPICommand.ID,h(C.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:v=>typeof v=="string"}]}),this._register(C.OpenIssueReporter.ID,h(C.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:v=>typeof v=="string"||typeof v=="object"&&typeof v.extensionId=="string"}]})}_register(h,v,g){const b=this._commands.registerCommand(!1,h,v,this,g);this._disposables.add(b)}}e.ExtHostApiCommands=I;function p(s){return h=>{if(Array.isArray(h))return h.map(s)}}function f(s){if(!!Array.isArray(s)){const h=[];for(const v of s)P.isLocationLink(v)?h.push(S.DefinitionLink.to(v)):h.push(S.location.to(v));return h}}}),define(we[187],Ee([0,1,15,45,3,6,2,63,25,9,7,5]),function(re,e,_,S,T,P,E,C,D,n,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class p{constructor(u,a,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=u.getProxy(I.MainContext.MainThreadComments),a.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const o=this._commentControllers.get(r.handle);return o||r}else if(r&&r.$mid===7){const o=this._commentControllers.get(r.commentControlHandle);if(!o)return r;const l=o.getCommentThread(r.commentThreadHandle);return l||r}else if(r&&r.$mid===8){const o=this._commentControllers.get(r.thread.commentControlHandle);if(!o)return r;const l=o.getCommentThread(r.thread.commentThreadHandle);return l?{thread:l,text:r.text}:r}else if(r&&r.$mid===9){const o=this._commentControllers.get(r.thread.commentControlHandle);if(!o)return r;const l=o.getCommentThread(r.thread.commentThreadHandle);if(!l)return r;let i=r.commentUniqueId,d=l.getCommentByUniqueId(i);return d||r}else if(r&&r.$mid===10){const o=this._commentControllers.get(r.thread.commentControlHandle);if(!o)return r;const l=o.getCommentThread(r.thread.commentThreadHandle);if(!l)return r;let i=r.text,d=r.commentUniqueId,y=l.getCommentByUniqueId(d);return y?(y.body=i,y):r}return r}})}createCommentController(u,a,t){const r=p.handlePool++,o=new s(u,r,this._proxy,a,t);this._commentControllers.set(o.handle,o);const l=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(u.identifier))||[];return l.push(o),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(u.identifier),l),o}$createCommentThreadTemplate(u,a,t){const r=this._commentControllers.get(u);!r||r.$createCommentThreadTemplate(a,t)}async $updateCommentThreadTemplate(u,a,t){const r=this._commentControllers.get(u);!r||r.$updateCommentThreadTemplate(a,t)}$deleteCommentThread(u,a){const t=this._commentControllers.get(u);t&&t.$deleteCommentThread(a)}$provideCommentingRanges(u,a,t){const r=this._commentControllers.get(u);if(!r||!r.commentingRangeProvider)return Promise.resolve(void 0);const o=this._documents.getDocument(E.URI.revive(a));return(0,_.asPromise)(()=>r.commentingRangeProvider.provideCommentingRanges(o,t)).then(l=>l?l.map(i=>n.Range.from(i)):void 0)}$toggleReaction(u,a,t,r,o){const l=this._commentControllers.get(u);return!l||!l.reactionHandler?Promise.resolve(void 0):(0,_.asPromise)(()=>{const i=l.getCommentThread(a);if(i){const d=i.getCommentByUniqueId(r.uniqueIdInThread);if(l!==void 0&&d&&l.reactionHandler)return l.reactionHandler(d,g(o))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=p,p.handlePool=0;class f{constructor(u,a,t,r,o,l,i){this._proxy=u,this._commentController=a,this._id=t,this._uri=r,this._range=o,this._comments=l,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new T.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${a.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,n.Range.from(this._range),i),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=l}set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){u.isEqual(this._range)||(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const u=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),a={};u("range")&&(a.range=n.Range.from(this._range)),u("label")&&(a.label=this.label),u("contextValue")&&(a.contextValue=this.contextValue),u("comments")&&(a.comments=this._comments.map(t=>h(this,this._commentController,t,this._commentsMap))),u("collapsibleState")&&(a.collapseState=b(this._collapseState)),u("canReply")&&(a.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,a)}}getCommentByUniqueId(u){for(let a of this._commentsMap){let t=a[0],r=a[1];if(u===r)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}f._handlePool=0,Ve([(0,S.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=f;class s{constructor(u,a,t,r,o){this._extension=u,this._handle=a,this._proxy=t,this._id=r,this._label=o,this._threads=new Map,this._proxy.$registerCommentController(this.handle,r,o)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(u,a,t,r){if(typeof u=="string"){const o=new f(this._proxy,this,u,a,t,r,this._extension.identifier);return this._threads.set(o.handle,o),o}else{const o=new f(this._proxy,this,void 0,u,a,t,this._extension.identifier);return this._threads.set(o.handle,o),o}}$createCommentThreadTemplate(u,a){const t=new f(this._proxy,this,void 0,E.URI.revive(u),n.Range.to(a),[],this._extension.identifier);return t.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(u,a){let t=this._threads.get(u);t&&(t.range=n.Range.to(a))}$deleteCommentThread(u){let a=this._threads.get(u);a&&a.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function h(c,u,a,t){let r=t.get(a);r||(r=++c.commentHandle,t.set(a,r));const o=a.author&&a.author.iconPath?a.author.iconPath.toString():void 0;return{mode:a.mode,contextValue:a.contextValue,uniqueIdInThread:r,body:n.MarkdownString.from(a.body),userName:a.author.name,userIconPath:o,label:a.label,commentReactions:a.reactions?a.reactions.map(l=>v(l)):void 0}}function v(c){return{label:c.label,iconPath:c.iconPath?n.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function g(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?E.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function b(c){if(c!==void 0)switch(c){case A.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}}),define(we[97],Ee([0,1,2,5,7,4,13,19,14,8,10]),function(re,e,_,S,T,P,E,C,D,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class un{constructor(f,s){this._logService=s,this._provider=new Map,this._proxy=f.getProxy(S.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,s){const h=un._handlePool++;this._provider.set(h,{provider:f,extensionId:s}),this._proxy.$registerDecorationProvider(h,s.value);const v=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(g=>{if(!g){this._proxy.$onDidChange(h,null);return}let b=(0,D.asArray)(g);if(b.length<=un._maxEventSize){this._proxy.$onDidChange(h,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.value,b.length);const c=b.map(t=>({uri:t,rank:(0,n.count)(t.path,"/")})),u=(0,D.groupBy)(c,(t,r)=>t.rank-r.rank||(0,n.compare)(t.uri.path,r.uri.path));let a=[];e:for(let t of u){let r;for(let o of t){let l=(0,A.dirname)(o.uri.path);if(r!==l&&(r=l,a.push(o.uri)>=un._maxEventSize))break e}}this._proxy.$onDidChange(h,a)});return new T.Disposable(()=>{v==null||v.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(f,s,h){if(!this._provider.has(f))return Object.create(null);const v=Object.create(null),{provider:g,extensionId:b}=this._provider.get(f);return await Promise.all(s.map(async c=>{try{const{uri:u,id:a}=c,t=await Promise.resolve(g.provideFileDecoration(_.URI.revive(u),h));if(!t)return;try{T.FileDecoration.validate(t),v[a]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${b.value}': ${r}`)}}catch(u){this._logService.error(u)}})),v}};I._handlePool=0,I._maxEventSize=250,I=Ve([qe(0,E.IExtHostRpcService),qe(1,C.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")}),define(we[188],Ee([0,1,127,87,2,5,7,9,3,19,22]),function(re,e,_,S,T,P,E,C,D,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(s,h,v,g,b){this._name=s,this._owner=h,this._maxDiagnosticsPerFile=v,this._proxy=g,this._onDidChangeDiagnostics=b,this._isDisposed=!1,this._data=new A.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(s,h){if(!s){this.clear();return}this._checkDisposed();let v=[];if(T.URI.isUri(s)){if(!h){this.delete(s);return}this._data.set(s,h.slice()),v=[s]}else if(Array.isArray(s)){v=[];let b;s=[...s].sort(I._compareIndexedTuplesByUri);for(const c of s){const[u,a]=c;if((!b||u.toString()!==b.toString())&&(b&&this._data.get(b).length===0&&this._data.delete(b),b=u,v.push(u),this._data.set(u,[])),a){const t=this._data.get(u);t&&t.push(...a)}else{const t=this._data.get(u);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(v),!!this._proxy){const g=[];for(let b of v){let c=[];const u=this._data.get(b);if(u)if(u.length>this._maxDiagnosticsPerFile){c=[];const a=[E.DiagnosticSeverity.Error,E.DiagnosticSeverity.Warning,E.DiagnosticSeverity.Information,E.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of u)if(r.severity===a[t]&&c.push(C.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;c.push({severity:S.MarkerSeverity.Info,message:(0,_.localize)(0,null,u.length-this._maxDiagnosticsPerFile),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=u.map(a=>C.Diagnostic.from(a));g.push([b,c])}this._proxy.$changeMany(this._owner,g)}}delete(s){this._checkDisposed(),this._onDidChangeDiagnostics.fire([s]),this._data.delete(s),this._proxy&&this._proxy.$changeMany(this._owner,[[s,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(s,h){this._checkDisposed();for(let v of this._data.keys())s.apply(h,[v,this.get(v),this])}get(s){this._checkDisposed();const h=this._data.get(s);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(s){return this._checkDisposed(),Array.isArray(this._data.get(s))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(s,h){return s[0].toString()<h[0].toString()?-1:s[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=I;let p=class Mt{constructor(s,h){this._logService=h,this._collections=new Map,this._onDidChangeDiagnostics=new D.Emitter,this.onDidChangeDiagnostics=D.Event.map(D.Event.debounce(this._onDidChangeDiagnostics.event,Mt._debouncer,50),Mt._mapper),this._proxy=s.getProxy(P.MainContext.MainThreadDiagnostics)}static _debouncer(s,h){return s?s.concat(h):h}static _mapper(s){const h=[],v=new Set;for(const g of s)typeof g=="string"?v.has(g)||(v.add(g),h.push(T.URI.parse(g))):v.has(g.toString())||(v.add(g.toString()),h.push(g));return Object.freeze(h),{uris:h}}createDiagnosticCollection(s,h){const{_collections:v,_proxy:g,_onDidChangeDiagnostics:b,_logService:c}=this,u=new class{$changeMany(r,o){g.$changeMany(r,o),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,r,o.length===0?"CLEARING":o)}$clear(r){g.$clear(r),c.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,r)}dispose(){g.dispose()}};let a;if(!h)h="_generated_diagnostic_collection_name_#"+Mt._idPool++,a=h;else if(!v.has(h))a=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do a=h+Mt._idPool++;while(v.has(a))}return new class extends I{constructor(){super(h,a,Mt._maxDiagnosticsPerFile,u,b);v.set(a,this)}dispose(){super.dispose(),v.delete(a)}}}getDiagnostics(s){if(s)return this._getDiagnostics(s);{const h=new Map,v=[];for(const g of this._collections.values())g.forEach((b,c)=>{let u=h.get(b.toString());typeof u=="undefined"&&(u=v.length,h.set(b.toString(),u),v.push([b,[]])),v[u][1]=v[u][1].concat(...c)});return v}}_getDiagnostics(s){let h=[];for(let v of this._collections.values())v.has(s)&&(h=h.concat(v.get(s)));return h}$acceptMarkersChange(s){if(!this._mirrorCollection){const h="_generated_mirror",v=new I(h,h,Mt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(h,v),this._mirrorCollection=v}for(const[h,v]of s)this._mirrorCollection.set(T.URI.revive(h),v.map(C.Diagnostic.to))}};p._idPool=0,p._maxDiagnosticsPerFile=1e3,p=Ve([qe(1,n.ILogService)],p),e.ExtHostDiagnostics=p}),define(we[189],Ee([0,1,2,5]),function(re,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class T{constructor(E){this._proxy=E.getProxy(S.MainContext.MainThreadDialogs)}showOpenDialog(E){return this._proxy.$showOpenDialog(E).then(C=>C?C.map(D=>_.URI.revive(D)):void 0)}showSaveDialog(E){return this._proxy.$showSaveDialog(E).then(C=>C?_.URI.revive(C):void 0)}}e.ExtHostDialogs=T}),define(we[190],Ee([0,1,11,2,7,5,16,20,8]),function(re,e,_,S,T,P,E,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class n{constructor(I,p,f){this._documentsAndEditors=p,this._logService=f,this._documentContentProviders=new Map,this._proxy=I.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,p){if(Object.keys(E.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const f=n._handlePool++;this._documentContentProviders.set(f,p),this._proxy.$registerTextContentProvider(f,I);let s;return typeof p.onDidChange=="function"&&(s=p.onDidChange(h=>{if(h.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(f,h).then(v=>{if(!(!v&&typeof v!="string")){const g=this._documentsAndEditors.getDocument(h);if(!!g){const b=(0,D.splitLines)(v);if(!g.equalLines(b))return this._proxy.$onVirtualDocumentChange(h,v)}}},_.onUnexpectedError)})),new T.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),s&&(s.dispose(),s=void 0)})}$provideTextDocumentContent(I,p){const f=this._documentContentProviders.get(I);return f?Promise.resolve(f.provideTextDocumentContent(S.URI.revive(p),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.ExtHostDocumentContentProvider=n,n._handlePool=0}),define(we[191],Ee([0,1,3,6,2,5,94,9,12,24]),function(re,e,_,S,T,P,E,C,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class A{constructor(p,f){this._onDidAddDocument=new _.Emitter,this._onDidRemoveDocument=new _.Emitter,this._onDidChangeDocument=new _.Emitter,this._onDidSaveDocument=new _.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new S.DisposableStore,this._documentLoader=new Map,this._proxy=p.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(s=>{for(const h of s)this._onDidRemoveDocument.fire(h.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(s=>{for(const h of s)this._onDidAddDocument.fire(h.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(p){if(!!p){const f=this._documentsAndEditors.getDocument(p);if(f)return f}}getDocument(p){const f=this.getDocumentData(p);if(!(f==null?void 0:f.document))throw new Error(`Unable to retrieve document from URI '${p}'`);return f.document}ensureDocumentData(p){const f=this._documentsAndEditors.getDocument(p);if(f)return Promise.resolve(f);let s=this._documentLoader.get(p.toString());return s||(s=this._proxy.$tryOpenDocument(p).then(h=>{this._documentLoader.delete(p.toString());const v=T.URI.revive(h);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(v))},h=>(this._documentLoader.delete(p.toString()),Promise.reject(h))),this._documentLoader.set(p.toString(),s)),s}createDocumentData(p){return this._proxy.$tryCreateDocument(p).then(f=>T.URI.revive(f))}$acceptModelModeChanged(p,f,s){const h=T.URI.revive(p),v=this._documentsAndEditors.getDocument(h);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(s),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(p){const f=T.URI.revive(p),s=this._documentsAndEditors.getDocument(f);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this._onDidSaveDocument.fire(s.document)}$acceptDirtyStateChanged(p,f){const s=T.URI.revive(p),h=this._documentsAndEditors.getDocument(s);if(!h)throw new Error("unknown document");h._acceptIsDirty(f),this._onDidChangeDocument.fire({document:h.document,contentChanges:[]})}$acceptModelChanged(p,f,s){const h=T.URI.revive(p),v=this._documentsAndEditors.getDocument(h);if(!v)throw new Error("unknown document");v._acceptIsDirty(s),v.onEvents(f),this._onDidChangeDocument.fire((0,n.deepFreeze)({document:v.document,contentChanges:f.changes.map(g=>({range:C.Range.to(g.range),rangeOffset:g.rangeOffset,rangeLength:g.rangeLength,text:g.text}))}))}setWordDefinitionFor(p,f){(0,E.setWordDefinitionFor)(p,f)}}e.ExtHostDocuments=A}),define(we[41],Ee([0,1,44,3,6,2,4,5,94,13,95,9,19,22,16,54,105]),function(re,e,_,S,T,P,E,C,D,n,A,I,p,f,s,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class g{constructor(u){this.value=u,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(u,a){this._extHostRpc=u,this._logService=a,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new S.Emitter,this._onDidRemoveDocuments=new S.Emitter,this._onDidChangeVisibleTextEditors=new S.Emitter,this._onDidChangeActiveTextEditor=new S.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const a=[],t=[],r=[];if(u.removedDocuments)for(const o of u.removedDocuments){const l=P.URI.revive(o),i=this._documents.get(l);(i==null?void 0:i.unref())&&(this._documents.delete(l),a.push(i.value))}if(u.addedDocuments)for(const o of u.addedDocuments){const l=P.URI.revive(o.uri);let i=this._documents.get(l);if(i&&l.scheme!==s.Schemas.vscodeNotebookCell)throw new Error(`document '${l} already exists!'`);i||(i=new g(new D.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),l,o.lines,o.EOL,o.versionId,o.modeId,o.isDirty,o.notebook)),this._documents.set(l,i),t.push(i.value)),i.ref()}if(u.removedEditors)for(const o of u.removedEditors){const l=this._editors.get(o);this._editors.delete(o),l&&r.push(l)}if(u.addedEditors)for(const o of u.addedEditors){const l=P.URI.revive(o.documentUri);_.ok(this._documents.has(l),`document '${l}' does not exist`),_.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const i=this._documents.get(l).value,d=new A.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>i.document),o.selections.map(I.Selection.to),o.options,o.visibleRanges.map(y=>I.Range.to(y)),typeof o.editorPosition=="number"?I.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,d)}u.newActiveEditor!==void 0&&(_.ok(u.newActiveEditor===null||this._editors.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this._activeEditorId=u.newActiveEditor),(0,T.dispose)(a),(0,T.dispose)(r),u.removedDocuments&&this._onDidRemoveDocuments.fire(a),u.addedDocuments&&this._onDidAddDocuments.fire(t),(u.removedEditors||u.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),u.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(u){var a;return(a=this._documents.get(u))===null||a===void 0?void 0:a.value}allDocuments(){return h.Iterable.map(this._documents.values(),u=>u.value)}getEditor(u){return this._editors.get(u)}activeEditor(u){if(!!this._activeEditorId){const a=this._editors.get(this._activeEditorId);return u?a:a==null?void 0:a.value}}allEditors(){return[...this._editors.values()]}};b=Ve([qe(0,n.IExtHostRpcService),qe(1,p.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,E.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[192],Ee([0,1,2,5,6,7,9,115,8,26]),function(re,e,_,S,T,P,E,C,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class A{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const s=this._schemes.indexOf(f);s>=0&&(this._schemes.splice(s,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),s=[];let h,v,g=14,b=14;for(const c of f){let u=h?(0,D.commonPrefixLength)(h,c):0;for(u===0?v=1:v=b;u<c.length;u++)u+1===c.length?(g=b,b=9):b+=1,s.push([v,c.toUpperCase().charCodeAt(u),b]),s.push([v,c.toLowerCase().charCodeAt(u),b]),v=b;h=c,b=g}s.push([9,58,10]),s.push([10,47,12]),this._stateMachine=new C.StateMachine(s)}}provideDocumentLinks(f){this._initStateMachine();const s=[],h=C.LinkComputer.computeLinks({getLineContent(v){return f.lineAt(v-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const v of h){const g=E.DocumentLink.to(v);g.target&&s.push(g)}return s}}class I{constructor(f,s){this._extHostLanguageFeatures=s,this._linkProvider=new A,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(S.MainContext.MainThreadFileSystem)}dispose(){var f;(f=this._linkProviderRegistration)===null||f===void 0||f.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,s,h,v={}){if(this._registeredSchemes.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const g=this._handlePool++;this._linkProvider.add(s),this._registeredSchemes.add(s),this._fsProvider.set(g,h);let b=2;v.isCaseSensitive&&(b+=1024),v.isReadonly&&(b+=2048),typeof h.copy=="function"&&(b+=8),typeof h.open=="function"&&typeof h.close=="function"&&typeof h.read=="function"&&typeof h.write=="function"&&(b+=4),this._proxy.$registerFileSystemProvider(g,s,b).catch(u=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${s}`),console.error(u)});const c=h.onDidChangeFile(u=>{const a=[];for(const t of u){let{uri:r,type:o}=t;if(r.scheme===s){let l;switch(o){case P.FileChangeType.Changed:l=0;break;case P.FileChangeType.Created:l=1;break;case P.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:r,type:l})}}this._proxy.$onFileSystemChange(g,a)});return(0,T.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(s),this._registeredSchemes.delete(s),this._fsProvider.delete(g),this._proxy.$unregisterProvider(g)})}static _asIStat(f){const{type:s,ctime:h,mtime:v,size:g}=f;return{type:s,ctime:h,mtime:v,size:g}}$stat(f,s){return Promise.resolve(this._getFsProvider(f).stat(_.URI.revive(s))).then(I._asIStat)}$readdir(f,s){return Promise.resolve(this._getFsProvider(f).readDirectory(_.URI.revive(s)))}$readFile(f,s){return Promise.resolve(this._getFsProvider(f).readFile(_.URI.revive(s))).then(h=>n.VSBuffer.wrap(h))}$writeFile(f,s,h,v){return Promise.resolve(this._getFsProvider(f).writeFile(_.URI.revive(s),h.buffer,v))}$delete(f,s,h){return Promise.resolve(this._getFsProvider(f).delete(_.URI.revive(s),h))}$rename(f,s,h,v){return Promise.resolve(this._getFsProvider(f).rename(_.URI.revive(s),_.URI.revive(h),v))}$copy(f,s,h,v){const g=this._getFsProvider(f);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(_.URI.revive(s),_.URI.revive(h),v))}$mkdir(f,s){return Promise.resolve(this._getFsProvider(f).createDirectory(_.URI.revive(s)))}$watch(f,s,h,v){const g=this._getFsProvider(f).watch(_.URI.revive(h),v);this._watches.set(s,g)}$unwatch(f,s){const h=this._watches.get(s);h&&(h.dispose(),this._watches.delete(s))}$open(f,s,h){const v=this._getFsProvider(f);if(!v.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(v.open(_.URI.revive(s),h))}$close(f,s){const h=this._getFsProvider(f);if(!h.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(h.close(s))}$read(f,s,h,v){const g=this._getFsProvider(f);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const b=n.VSBuffer.alloc(v);return Promise.resolve(g.read(s,h,b.buffer,0,v)).then(c=>b.slice(0,c))}$write(f,s,h,v){const g=this._getFsProvider(f);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(s,h,v.buffer,0,v.byteLength))}_getFsProvider(f){const s=this._fsProvider.get(f);if(!s){const h=new Error;throw h.name="ENOPRO",h.message="no provider",h}return s}}e.ExtHostFileSystem=I}),define(we[74],Ee([0,1,5,65,7,26,4,13,49]),function(re,e,_,S,T,P,E,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let n=class Tt{constructor(I,p){const f=I.getProxy(_.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(s){return f.$stat(s).catch(Tt._handleError)},readDirectory(s){return f.$readdir(s).catch(Tt._handleError)},createDirectory(s){return f.$mkdir(s).catch(Tt._handleError)},async readFile(s){return f.$readFile(s).then(h=>h.buffer).catch(Tt._handleError)},writeFile(s,h){return f.$writeFile(s,P.VSBuffer.wrap(h)).catch(Tt._handleError)},delete(s,h){return f.$delete(s,Object.assign({recursive:!1,useTrash:!1},h)).catch(Tt._handleError)},rename(s,h,v){return f.$rename(s,h,Object.assign({overwrite:!1},v)).catch(Tt._handleError)},copy(s,h,v){return f.$copy(s,h,Object.assign({overwrite:!1},v)).catch(Tt._handleError)},isWritableFileSystem(s){const h=p.getCapabilities(s);if(typeof h=="number")return!(h&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new T.FileSystemError(String(I));if(I.name==="ENOPRO")throw T.FileSystemError.Unavailable(I.message);switch(I.name){case S.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(I.message);case S.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(I.message);case S.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(I.message);case S.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(I.message);case S.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(I.message);case S.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(I.message);default:throw new T.FileSystemError(I.message,I.name)}}};n=Ve([qe(0,C.IExtHostRpcService),qe(1,D.IExtHostFileSystemInfo)],n),e.ExtHostConsumerFileSystem=n,e.IExtHostConsumerFileSystem=(0,E.createDecorator)("IExtHostConsumerFileSystem")}),define(we[193],Ee([0,1,6,5]),function(re,e,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class T{constructor(E){this._handlePool=0,this._proxy=E.getProxy(S.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(E){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,E),(0,_.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=T}),define(we[194],Ee([0,1,2,24,9,7,15,5,8,32,14,12,112,6,84,53,92,55,11]),function(re,e,_,S,T,P,E,C,D,n,A,I,p,f,s,h,v,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class c{constructor($,G){this._documents=$,this._provider=G}provideDocumentSymbols($,G){const te=this._documents.getDocument($);return(0,E.asPromise)(()=>this._provider.provideDocumentSymbols(te,G)).then(ie=>{if(!(0,A.isFalsyOrEmpty)(ie))return ie[0]instanceof P.DocumentSymbol?ie.map(T.DocumentSymbol.from):c._asDocumentSymbolTree(ie)})}static _asDocumentSymbolTree($){var G;$=$.slice(0).sort((he,De)=>{let Le=he.location.range.start.compareTo(De.location.range.start);return Le===0&&(Le=De.location.range.end.compareTo(he.location.range.end)),Le});const te=[],ie=[];for(const he of $){const De={name:he.name||"!!MISSING: name!!",kind:T.SymbolKind.from(he.kind),tags:((G=he.tags)===null||G===void 0?void 0:G.map(T.SymbolTag.from))||[],detail:"",containerName:he.containerName,range:T.Range.from(he.location.range),selectionRange:T.Range.from(he.location.range),children:[]};for(;;){if(ie.length===0){ie.push(De),te.push(De);break}const Le=ie[ie.length-1];if(n.Range.containsRange(Le.range,De.range)&&!n.Range.equalsRange(Le.range,De.range)){Le.children&&Le.children.push(De),ie.push(De);break}ie.pop()}}return te}}class u{constructor($,G,te){this._documents=$,this._commands=G,this._provider=te,this._cache=new v.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,G){const te=this._documents.getDocument($),ie=await this._provider.provideCodeLenses(te,G);if(!(!ie||G.isCancellationRequested)){const he=this._cache.add(ie),De=new f.DisposableStore;this._disposables.set(he,De);const Le={cacheId:he,lenses:[]};for(let me=0;me<ie.length;me++)Le.lenses.push({cacheId:[he,me],range:T.Range.from(ie[me].range),command:this._commands.toInternal(ie[me].command,De)});return Le}}async resolveCodeLens($,G){var te;const ie=$.cacheId&&this._cache.get(...$.cacheId);if(!!ie){let he;if(typeof this._provider.resolveCodeLens!="function"||ie.isResolved?he=ie:he=await this._provider.resolveCodeLens(ie,G),he||(he=ie),!G.isCancellationRequested){const De=$.cacheId&&this._disposables.get($.cacheId[0]);if(!!De)return $.command=this._commands.toInternal((te=he.command)!==null&&te!==void 0?te:u._badCmd,De),$}}}releaseCodeLenses($){var G;(G=this._disposables.get($))===null||G===void 0||G.dispose(),this._disposables.delete($),this._cache.delete($)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function a(ze){return Array.isArray(ze)?ze.map(T.DefinitionLink.from):ze?[T.DefinitionLink.from(ze)]:[]}class t{constructor($,G){this._documents=$,this._provider=G}provideDefinition($,G,te){const ie=this._documents.getDocument($),he=T.Position.to(G);return(0,E.asPromise)(()=>this._provider.provideDefinition(ie,he,te)).then(a)}}class r{constructor($,G){this._documents=$,this._provider=G}provideDeclaration($,G,te){const ie=this._documents.getDocument($),he=T.Position.to(G);return(0,E.asPromise)(()=>this._provider.provideDeclaration(ie,he,te)).then(a)}}class o{constructor($,G){this._documents=$,this._provider=G}provideImplementation($,G,te){const ie=this._documents.getDocument($),he=T.Position.to(G);return(0,E.asPromise)(()=>this._provider.provideImplementation(ie,he,te)).then(a)}}class l{constructor($,G){this._documents=$,this._provider=G}provideTypeDefinition($,G,te){const ie=this._documents.getDocument($),he=T.Position.to(G);return(0,E.asPromise)(()=>this._provider.provideTypeDefinition(ie,he,te)).then(a)}}class i{constructor($,G){this._documents=$,this._provider=G}provideHover($,G,te){const ie=this._documents.getDocument($),he=T.Position.to(G);return(0,E.asPromise)(()=>this._provider.provideHover(ie,he,te)).then(De=>{if(!(!De||(0,A.isFalsyOrEmpty)(De.contents)))return De.range||(De.range=ie.getWordRangeAtPosition(he)),De.range||(De.range=new P.Range(he,he)),T.Hover.from(De)})}}class d{constructor($,G){this._documents=$,this._provider=G}provideEvaluatableExpression($,G,te){const ie=this._documents.getDocument($),he=T.Position.to(G);return(0,E.asPromise)(()=>this._provider.provideEvaluatableExpression(ie,he,te)).then(De=>{if(De)return T.EvaluatableExpression.from(De)})}}class y{constructor($,G){this._documents=$,this._provider=G}provideInlineValues($,G,te,ie){const he=this._documents.getDocument($);return(0,E.asPromise)(()=>this._provider.provideInlineValues(he,T.Range.to(G),T.InlineValueContext.to(te),ie)).then(De=>{if(Array.isArray(De))return De.map(Le=>T.InlineValue.from(Le))})}}class k{constructor($,G){this._documents=$,this._provider=G}provideDocumentHighlights($,G,te){const ie=this._documents.getDocument($),he=T.Position.to(G);return(0,E.asPromise)(()=>this._provider.provideDocumentHighlights(ie,he,te)).then(De=>{if(Array.isArray(De))return De.map(T.DocumentHighlight.from)})}}class m{constructor($,G){this._documents=$,this._provider=G}provideLinkedEditingRanges($,G,te){const ie=this._documents.getDocument($),he=T.Position.to(G);return(0,E.asPromise)(()=>this._provider.provideLinkedEditingRanges(ie,he,te)).then(De=>{if(De&&Array.isArray(De.ranges))return{ranges:(0,A.coalesce)(De.ranges.map(T.Range.from)),wordPattern:De.wordPattern}})}}class w{constructor($,G){this._documents=$,this._provider=G}provideReferences($,G,te,ie){const he=this._documents.getDocument($),De=T.Position.to(G);return(0,E.asPromise)(()=>this._provider.provideReferences(he,De,te,ie)).then(Le=>{if(Array.isArray(Le))return Le.map(T.location.from)})}}class R{constructor($,G,te,ie,he,De,Le){this._documents=$,this._commands=G,this._diagnostics=te,this._provider=ie,this._logService=he,this._extension=De,this._apiDeprecation=Le,this._cache=new v.Cache("CodeAction"),this._disposables=new Map}provideCodeActions($,G,te,ie){const he=this._documents.getDocument($),De=p.Selection.isISelection(G)?T.Selection.to(G):T.Range.to(G),Le=[];for(const Ce of this._diagnostics.getDiagnostics($))if(De.intersection(Ce.range)&&Le.push(Ce)>R._maxCodeActionsPerFile)break;const me={diagnostics:Le,only:te.only?new P.CodeActionKind(te.only):void 0,triggerKind:T.CodeActionTriggerKind.to(te.trigger)};return(0,E.asPromise)(()=>this._provider.provideCodeActions(he,De,me,ie)).then(Ce=>{var ke;if(!(!(0,A.isNonEmptyArray)(Ce)||ie.isCancellationRequested)){const Ue=this._cache.add(Ce),be=new f.DisposableStore;this._disposables.set(Ue,be);const je=[];for(let V=0;V<Ce.length;V++){const Z=Ce[V];!Z||(R._isCommand(Z)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),je.push({_isSynthetic:!0,title:Z.title,command:this._commands.toInternal(Z,be)})):(me.only&&(Z.kind?me.only.contains(Z.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${me.only.value} 'requested but returned code action is of kind '${Z.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),je.push({cacheId:[Ue,V],title:Z.title,command:Z.command&&this._commands.toInternal(Z.command,be),diagnostics:Z.diagnostics&&Z.diagnostics.map(T.Diagnostic.from),edit:Z.edit&&T.WorkspaceEdit.from(Z.edit),kind:Z.kind&&Z.kind.value,isPreferred:Z.isPreferred,disabled:(ke=Z.disabled)===null||ke===void 0?void 0:ke.reason})))}return{cacheId:Ue,actions:je}}})}async resolveCodeAction($,G){var te;const[ie,he]=$,De=this._cache.get(ie,he);if(!(!De||R._isCommand(De))&&!!this._provider.resolveCodeAction){const Le=(te=await this._provider.resolveCodeAction(De,G))!==null&&te!==void 0?te:De;return(Le==null?void 0:Le.edit)?T.WorkspaceEdit.from(Le.edit):void 0}}releaseCodeActions($){var G;(G=this._disposables.get($))===null||G===void 0||G.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}R._maxCodeActionsPerFile=1e3;class F{constructor($,G){this._documents=$,this._provider=G}provideDocumentFormattingEdits($,G,te){const ie=this._documents.getDocument($);return(0,E.asPromise)(()=>this._provider.provideDocumentFormattingEdits(ie,G,te)).then(he=>{if(Array.isArray(he))return he.map(T.TextEdit.from)})}}class B{constructor($,G){this._documents=$,this._provider=G}provideDocumentRangeFormattingEdits($,G,te,ie){const he=this._documents.getDocument($),De=T.Range.to(G);return(0,E.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(he,De,te,ie)).then(Le=>{if(Array.isArray(Le))return Le.map(T.TextEdit.from)})}}class Q{constructor($,G){this._documents=$,this._provider=G,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits($,G,te,ie,he){const De=this._documents.getDocument($),Le=T.Position.to(G);return(0,E.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(De,Le,te,ie,he)).then(me=>{if(Array.isArray(me))return me.map(T.TextEdit.from)})}}class J{constructor($,G){this._provider=$,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols($,G){const te=C.IdObject.mixin({symbols:[]});return(0,E.asPromise)(()=>this._provider.provideWorkspaceSymbols($,G)).then(ie=>{if((0,A.isNonEmptyArray)(ie)){for(const he of ie)if(!!he){if(!he.name){this._logService.warn("INVALID SymbolInformation, lacks name",he);continue}const De=C.IdObject.mixin(T.WorkspaceSymbol.from(he));this._symbolCache.set(De._id,he),te.symbols.push(De)}}}).then(()=>(te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te))}async resolveWorkspaceSymbol($,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return $;const te=this._symbolCache.get($._id);if(te){const ie=await(0,E.asPromise)(()=>this._provider.resolveWorkspaceSymbol(te,G));return ie&&(0,S.mixin)($,T.WorkspaceSymbol.from(ie),!0)}}releaseWorkspaceSymbols($){const G=this._resultCache.get($);if(G){for(let[te,ie]=G;te<=ie;te++)this._symbolCache.delete(te);this._resultCache.delete($)}}}class z{constructor($,G,te){this._documents=$,this._provider=G,this._logService=te}static supportsResolving($){return typeof $.prepareRename=="function"}provideRenameEdits($,G,te,ie){const he=this._documents.getDocument($),De=T.Position.to(G);return(0,E.asPromise)(()=>this._provider.provideRenameEdits(he,De,te,ie)).then(Le=>{if(!!Le)return T.WorkspaceEdit.from(Le)},Le=>{const me=z._asMessage(Le);return me?{rejectReason:me,edits:void 0}:Promise.reject(Le)})}resolveRenameLocation($,G,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ie=this._documents.getDocument($),he=T.Position.to(G);return(0,E.asPromise)(()=>this._provider.prepareRename(ie,he,te)).then(De=>{let Le,me;if(P.Range.isRange(De)?(Le=De,me=ie.getText(De)):(0,I.isObject)(De)&&(Le=De.range,me=De.placeholder),!!Le){if(Le.start.line>he.line||Le.end.line<he.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:T.Range.from(Le),text:me}}},De=>{const Le=z._asMessage(De);return Le?{rejectReason:Le,range:void 0,text:void 0}:Promise.reject(De)})}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class ae{constructor($,G){this.resultId=$,this.tokens=G}}class L{constructor($,G){this._documents=$,this._provider=G,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens($,G,te){const ie=this._documents.getDocument($),he=G!==0?this._previousResults.get(G):null;return(0,E.asPromise)(()=>he&&typeof he.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ie,he.resultId,te):this._provider.provideDocumentSemanticTokens(ie,te)).then(De=>(he&&this._previousResults.delete(G),De?(De=L._fixProvidedSemanticTokens(De),this._send(L._convertToEdits(he,De),De)):null))}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return L._isSemanticTokens($)?L._isCorrectSemanticTokens($)?$:new P.SemanticTokens(new Uint32Array($.data),$.resultId):L._isSemanticTokensEdits($)?L._isCorrectSemanticTokensEdits($)?$:new P.SemanticTokensEdits($.edits.map(G=>new P.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const G of $.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,G){if(!L._isSemanticTokens(G)||!$||!$.tokens)return G;const te=$.tokens,ie=te.length,he=G.data,De=he.length;let Le=0;const me=Math.min(ie,De);for(;Le<me&&te[Le]===he[Le];)Le++;if(Le===ie&&Le===De)return new P.SemanticTokensEdits([],G.resultId);let Ce=0;const ke=me-Le;for(;Ce<ke&&te[ie-Ce-1]===he[De-Ce-1];)Ce++;return new P.SemanticTokensEdits([{start:Le,deleteCount:ie-Le-Ce,data:he.subarray(Le,De-Ce)}],G.resultId)}_send($,G){if(L._isSemanticTokens($)){const te=this._nextResultId++;return this._previousResults.set(te,new ae($.resultId,$.data)),(0,s.encodeSemanticTokensDto)({id:te,type:"full",data:$.data})}if(L._isSemanticTokensEdits($)){const te=this._nextResultId++;return L._isSemanticTokens(G)?this._previousResults.set(te,new ae(G.resultId,G.data)):this._previousResults.set(te,new ae($.resultId)),(0,s.encodeSemanticTokensDto)({id:te,type:"delta",deltas:($.edits||[]).map(ie=>({start:ie.start,deleteCount:ie.deleteCount,data:ie.data}))})}return null}}e.DocumentSemanticTokensAdapter=L;class N{constructor($,G){this._documents=$,this._provider=G}provideDocumentRangeSemanticTokens($,G,te){const ie=this._documents.getDocument($);return(0,E.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(ie,T.Range.to(G),te)).then(he=>he?this._send(he):null)}_send($){return(0,s.encodeSemanticTokensDto)({id:0,type:"full",data:$.data})}}e.DocumentRangeSemanticTokensAdapter=N;class H{constructor($,G,te,ie,he){this._documents=$,this._commands=G,this._provider=te,this._apiDeprecation=ie,this._extension=he,this._cache=new v.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving($){return typeof $.resolveCompletionItem=="function"}async provideCompletionItems($,G,te,ie){const he=this._documents.getDocument($),De=T.Position.to(G),Le=he.getWordRangeAtPosition(De)||new P.Range(De,De),me=Le.with({end:De}),Ce=new g.StopWatch(!0),ke=await(0,E.asPromise)(()=>this._provider.provideCompletionItems(he,De,ie,T.CompletionContext.to(te)));if(!!ke&&!ie.isCancellationRequested){const Ue=Array.isArray(ke)?new P.CompletionList(ke):ke,be=H.supportsResolving(this._provider)?this._cache.add(Ue.items):this._cache.add([]),je=new f.DisposableStore;this._disposables.set(be,je);const V=[],Z={x:be,b:V,a:{replace:T.Range.from(Le),insert:T.Range.from(me)},c:Ue.isIncomplete||void 0,d:Ce.elapsed()};for(let _e=0;_e<Ue.items.length;_e++){const Me=Ue.items[_e],$e=this._convertCompletionItem(Me,[be,_e],me,Le);V.push($e)}return Z}}async resolveCompletionItem($,G){if(typeof this._provider.resolveCompletionItem=="function"){const te=this._cache.get(...$);if(!!te){const ie=await(0,E.asPromise)(()=>this._provider.resolveCompletionItem(te,G));if(!!ie)return this._convertCompletionItem(ie,$)}}}releaseCompletionItems($){var G;(G=this._disposables.get($))===null||G===void 0||G.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,G,te,ie){var he;const De=this._disposables.get(G[0]);if(!De)throw Error("DisposableStore is missing...");const Le={x:G,a:(he=$.label)!==null&&he!==void 0?he:"",o:$.label2,b:$.kind!==void 0?T.CompletionItemKind.from($.kind):void 0,n:$.tags&&$.tags.map(T.CompletionItemTag.from),c:$.detail,d:typeof $.documentation=="undefined"?void 0:T.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters,l:$.additionalTextEdits&&$.additionalTextEdits.map(T.TextEdit.from),m:this._commands.toInternal($.command,De)};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Le.h=$.textEdit.newText):typeof $.insertText=="string"?Le.h=$.insertText:$.insertText instanceof P.SnippetString&&(Le.h=$.insertText.value,Le.i|=4);let me;return $.textEdit?me=$.textEdit.range:$.range&&(me=$.range),P.Range.isRange(me)?Le.j=T.Range.from(me):me&&(!(te==null?void 0:te.isEqual(me.inserting))||!(ie==null?void 0:ie.isEqual(me.replacing)))&&(Le.j={insert:T.Range.from(me.inserting),replace:T.Range.from(me.replacing)}),Le}}class O{constructor($,G){this._documents=$,this._provider=G,this._cache=new v.Cache("SignatureHelp")}provideSignatureHelp($,G,te,ie){const he=this._documents.getDocument($),De=T.Position.to(G),Le=this.reviveContext(te);return(0,E.asPromise)(()=>this._provider.provideSignatureHelp(he,De,ie,Le)).then(me=>{if(me){const Ce=this._cache.add([me]);return Object.assign(Object.assign({},T.SignatureHelp.from(me)),{id:Ce})}})}reviveContext($){let G;if($.activeSignatureHelp){const te=T.SignatureHelp.to($.activeSignatureHelp),ie=this._cache.get($.activeSignatureHelp.id,0);ie?(G=ie,G.activeSignature=te.activeSignature,G.activeParameter=te.activeParameter):G=te}return Object.assign(Object.assign({},$),{activeSignatureHelp:G})}releaseSignatureHelp($){this._cache.delete($)}}class K{constructor($,G){this._documents=$,this._provider=G}provideInlineHints($,G,te){const ie=this._documents.getDocument($);return(0,E.asPromise)(()=>this._provider.provideInlineHints(ie,T.Range.to(G),te)).then(he=>he?{hints:he.map(T.InlineHint.from)}:void 0)}}class le{constructor($,G){this._documents=$,this._provider=G,this._cache=new v.Cache("DocumentLink")}provideLinks($,G){const te=this._documents.getDocument($);return(0,E.asPromise)(()=>this._provider.provideDocumentLinks(te,G)).then(ie=>{if(!(!Array.isArray(ie)||ie.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ie.map(T.DocumentLink.from)};{const he=this._cache.add(ie),De={links:[],id:he};for(let Le=0;Le<ie.length;Le++){const me=T.DocumentLink.from(ie[Le]);me.cacheId=[he,Le],De.links.push(me)}return De}}})}resolveLink($,G){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const te=this._cache.get(...$);return te?(0,E.asPromise)(()=>this._provider.resolveDocumentLink(te,G)).then(ie=>ie&&T.DocumentLink.from(ie)||void 0):Promise.resolve(void 0)}releaseLinks($){this._cache.delete($)}}class ue{constructor($,G){this._documents=$,this._provider=G}provideColors($,G){const te=this._documents.getDocument($);return(0,E.asPromise)(()=>this._provider.provideDocumentColors(te,G)).then(ie=>Array.isArray(ie)?ie.map(De=>({color:T.Color.from(De.color),range:T.Range.from(De.range)})):[])}provideColorPresentations($,G,te){const ie=this._documents.getDocument($),he=T.Range.to(G.range),De=T.Color.to(G.color);return(0,E.asPromise)(()=>this._provider.provideColorPresentations(De,{document:ie,range:he},te)).then(Le=>{if(!!Array.isArray(Le))return Le.map(T.ColorPresentation.from)})}}class pe{constructor($,G){this._documents=$,this._provider=G}provideFoldingRanges($,G,te){const ie=this._documents.getDocument($);return(0,E.asPromise)(()=>this._provider.provideFoldingRanges(ie,G,te)).then(he=>{if(!!Array.isArray(he))return he.map(T.FoldingRange.from)})}}class ve{constructor($,G,te){this._documents=$,this._provider=G,this._logService=te}provideSelectionRanges($,G,te){const ie=this._documents.getDocument($),he=G.map(T.Position.to);return(0,E.asPromise)(()=>this._provider.provideSelectionRanges(ie,he,te)).then(De=>{if(!(0,A.isNonEmptyArray)(De))return[];if(De.length!==he.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Le=[];for(let me=0;me<he.length;me++){const Ce=[];Le.push(Ce);let ke=he[me],Ue=De[me];for(;;){if(!Ue.range.contains(ke))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(T.SelectionRange.from(Ue)),!Ue.parent)break;ke=Ue.range,Ue=Ue.parent}}return Le})}}class Re{constructor($,G){this._documents=$,this._provider=G,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession($,G,te){const ie=this._documents.getDocument($),he=T.Position.to(G),De=await this._provider.prepareCallHierarchy(ie,he,te);if(!!De){const Le=this._idPool.nextId();return this._cache.set(Le,new Map),Array.isArray(De)?De.map(me=>this._cacheAndConvertItem(Le,me)):[this._cacheAndConvertItem(Le,De)]}}async provideCallsTo($,G,te){const ie=this._itemFromCache($,G);if(!ie)throw new Error("missing call hierarchy item");const he=await this._provider.provideCallHierarchyIncomingCalls(ie,te);if(!!he)return he.map(De=>({from:this._cacheAndConvertItem($,De.from),fromRanges:De.fromRanges.map(Le=>T.Range.from(Le))}))}async provideCallsFrom($,G,te){const ie=this._itemFromCache($,G);if(!ie)throw new Error("missing call hierarchy item");const he=await this._provider.provideCallHierarchyOutgoingCalls(ie,te);if(!!he)return he.map(De=>({to:this._cacheAndConvertItem($,De.to),fromRanges:De.fromRanges.map(Le=>T.Range.from(Le))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,G){var te;const ie=this._cache.get($),he={_sessionId:$,_itemId:ie.size.toString(36),name:G.name,detail:G.detail,kind:T.SymbolKind.from(G.kind),uri:G.uri,range:T.Range.from(G.range),selectionRange:T.Range.from(G.selectionRange),tags:(te=G.tags)===null||te===void 0?void 0:te.map(T.SymbolTag.from)};return ie.set(he._itemId,G),he}_itemFromCache($,G){const te=this._cache.get($);return te==null?void 0:te.get(G)}}class He{constructor($,G){this.adapter=$,this.extension=G}}class Fe{constructor($,G,te,ie,he,De,Le){this._adapter=new Map,this._uriTransformer=G,this._proxy=$.getProxy(C.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=ie,this._diagnostics=he,this._logService=De,this._apiDeprecation=Le}_transformDocumentSelector($){return(0,A.coalesce)((0,A.asArray)($).map(G=>this._doTransformDocumentSelector(G)))}_doTransformDocumentSelector($){if(typeof $=="string")return{$serialized:!0,language:$};if($)return{$serialized:!0,language:$.language,scheme:this._transformScheme($.scheme),pattern:typeof $.pattern=="undefined"?void 0:T.GlobPattern.from($.pattern),exclusive:$.exclusive}}_transformScheme($){return this._uriTransformer&&typeof $=="string"?this._uriTransformer.transformOutgoingScheme($):$}_createDisposable($){return new P.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return Fe._handlePool++}_withAdapter($,G,te,ie,he=!1){const De=this._adapter.get($);if(!De)return Promise.resolve(ie);if(De.adapter instanceof G){let Le;De.extension&&(Le=Date.now(),this._logService.trace(`[${De.extension.identifier.value}] INVOKE provider '${G.name}'`));const me=te(De.adapter,De.extension),Ce=De.extension;return Ce&&Promise.resolve(me).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-Le}ms`),ke=>{he&&ke instanceof b.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(ke))}),me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter($,G){const te=this._nextHandle();return this._adapter.set(te,new He($,G)),te}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,G,te,ie){const he=this._addNewAdapter(new c(this._documents,te),$),De=ie&&ie.label||Fe._extLabel($);return this._proxy.$registerDocumentSymbolProvider(he,this._transformDocumentSelector(G),De),this._createDisposable(he)}$provideDocumentSymbols($,G,te){return this._withAdapter($,c,ie=>ie.provideDocumentSymbols(_.URI.revive(G),te),void 0)}registerCodeLensProvider($,G,te){const ie=this._nextHandle(),he=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ie,new He(new u(this._documents,this._commands.converter,te),$)),this._proxy.$registerCodeLensSupport(ie,this._transformDocumentSelector(G),he);let De=this._createDisposable(ie);if(he!==void 0){const Le=te.onDidChangeCodeLenses(me=>this._proxy.$emitCodeLensEvent(he));De=P.Disposable.from(De,Le)}return De}$provideCodeLenses($,G,te){return this._withAdapter($,u,ie=>ie.provideCodeLenses(_.URI.revive(G),te),void 0)}$resolveCodeLens($,G,te){return this._withAdapter($,u,ie=>ie.resolveCodeLens(G,te),void 0)}$releaseCodeLenses($,G){this._withAdapter($,u,te=>Promise.resolve(te.releaseCodeLenses(G)),void 0)}registerDefinitionProvider($,G,te){const ie=this._addNewAdapter(new t(this._documents,te),$);return this._proxy.$registerDefinitionSupport(ie,this._transformDocumentSelector(G)),this._createDisposable(ie)}$provideDefinition($,G,te,ie){return this._withAdapter($,t,he=>he.provideDefinition(_.URI.revive(G),te,ie),[])}registerDeclarationProvider($,G,te){const ie=this._addNewAdapter(new r(this._documents,te),$);return this._proxy.$registerDeclarationSupport(ie,this._transformDocumentSelector(G)),this._createDisposable(ie)}$provideDeclaration($,G,te,ie){return this._withAdapter($,r,he=>he.provideDeclaration(_.URI.revive(G),te,ie),[])}registerImplementationProvider($,G,te){const ie=this._addNewAdapter(new o(this._documents,te),$);return this._proxy.$registerImplementationSupport(ie,this._transformDocumentSelector(G)),this._createDisposable(ie)}$provideImplementation($,G,te,ie){return this._withAdapter($,o,he=>he.provideImplementation(_.URI.revive(G),te,ie),[])}registerTypeDefinitionProvider($,G,te){const ie=this._addNewAdapter(new l(this._documents,te),$);return this._proxy.$registerTypeDefinitionSupport(ie,this._transformDocumentSelector(G)),this._createDisposable(ie)}$provideTypeDefinition($,G,te,ie){return this._withAdapter($,l,he=>he.provideTypeDefinition(_.URI.revive(G),te,ie),[])}registerHoverProvider($,G,te,ie){const he=this._addNewAdapter(new i(this._documents,te),$);return this._proxy.$registerHoverProvider(he,this._transformDocumentSelector(G)),this._createDisposable(he)}$provideHover($,G,te,ie){return this._withAdapter($,i,he=>he.provideHover(_.URI.revive(G),te,ie),void 0)}registerEvaluatableExpressionProvider($,G,te,ie){const he=this._addNewAdapter(new d(this._documents,te),$);return this._proxy.$registerEvaluatableExpressionProvider(he,this._transformDocumentSelector(G)),this._createDisposable(he)}$provideEvaluatableExpression($,G,te,ie){return this._withAdapter($,d,he=>he.provideEvaluatableExpression(_.URI.revive(G),te,ie),void 0)}registerInlineValuesProvider($,G,te,ie){const he=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,De=this._addNewAdapter(new y(this._documents,te),$);this._proxy.$registerInlineValuesProvider(De,this._transformDocumentSelector(G),he);let Le=this._createDisposable(De);if(he!==void 0){const me=te.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(he));Le=P.Disposable.from(Le,me)}return Le}$provideInlineValues($,G,te,ie,he){return this._withAdapter($,y,De=>De.provideInlineValues(_.URI.revive(G),te,ie,he),void 0)}registerDocumentHighlightProvider($,G,te){const ie=this._addNewAdapter(new k(this._documents,te),$);return this._proxy.$registerDocumentHighlightProvider(ie,this._transformDocumentSelector(G)),this._createDisposable(ie)}$provideDocumentHighlights($,G,te,ie){return this._withAdapter($,k,he=>he.provideDocumentHighlights(_.URI.revive(G),te,ie),void 0)}registerLinkedEditingRangeProvider($,G,te){const ie=this._addNewAdapter(new m(this._documents,te),$);return this._proxy.$registerLinkedEditingRangeProvider(ie,this._transformDocumentSelector(G)),this._createDisposable(ie)}$provideLinkedEditingRanges($,G,te,ie){return this._withAdapter($,m,async he=>{const De=await he.provideLinkedEditingRanges(_.URI.revive(G),te,ie);if(De)return{ranges:De.ranges,wordPattern:De.wordPattern?Fe._serializeRegExp(De.wordPattern):void 0}},void 0)}registerReferenceProvider($,G,te){const ie=this._addNewAdapter(new w(this._documents,te),$);return this._proxy.$registerReferenceSupport(ie,this._transformDocumentSelector(G)),this._createDisposable(ie)}$provideReferences($,G,te,ie,he){return this._withAdapter($,w,De=>De.provideReferences(_.URI.revive(G),te,ie,he),void 0)}registerCodeActionProvider($,G,te,ie){var he,De;const Le=new f.DisposableStore,me=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,te,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(me,this._transformDocumentSelector(G),{providedKinds:(he=ie==null?void 0:ie.providedCodeActionKinds)===null||he===void 0?void 0:he.map(Ce=>Ce.value),documentation:(De=ie==null?void 0:ie.documentation)===null||De===void 0?void 0:De.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,Le)}))},Fe._extLabel($),Boolean(te.resolveCodeAction)),Le.add(this._createDisposable(me)),Le}$provideCodeActions($,G,te,ie,he){return this._withAdapter($,R,De=>De.provideCodeActions(_.URI.revive(G),te,ie,he),void 0)}$resolveCodeAction($,G,te){return this._withAdapter($,R,ie=>ie.resolveCodeAction(G,te),void 0)}$releaseCodeActions($,G){this._withAdapter($,R,te=>Promise.resolve(te.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider($,G,te){const ie=this._addNewAdapter(new F(this._documents,te),$);return this._proxy.$registerDocumentFormattingSupport(ie,this._transformDocumentSelector(G),$.identifier,$.displayName||$.name),this._createDisposable(ie)}$provideDocumentFormattingEdits($,G,te,ie){return this._withAdapter($,F,he=>he.provideDocumentFormattingEdits(_.URI.revive(G),te,ie),void 0)}registerDocumentRangeFormattingEditProvider($,G,te){const ie=this._addNewAdapter(new B(this._documents,te),$);return this._proxy.$registerRangeFormattingSupport(ie,this._transformDocumentSelector(G),$.identifier,$.displayName||$.name),this._createDisposable(ie)}$provideDocumentRangeFormattingEdits($,G,te,ie,he){return this._withAdapter($,B,De=>De.provideDocumentRangeFormattingEdits(_.URI.revive(G),te,ie,he),void 0)}registerOnTypeFormattingEditProvider($,G,te,ie){const he=this._addNewAdapter(new Q(this._documents,te),$);return this._proxy.$registerOnTypeFormattingSupport(he,this._transformDocumentSelector(G),ie,$.identifier),this._createDisposable(he)}$provideOnTypeFormattingEdits($,G,te,ie,he,De){return this._withAdapter($,Q,Le=>Le.provideOnTypeFormattingEdits(_.URI.revive(G),te,ie,he,De),void 0)}registerWorkspaceSymbolProvider($,G){const te=this._addNewAdapter(new J(G,this._logService),$);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols($,G,te){return this._withAdapter($,J,ie=>ie.provideWorkspaceSymbols(G,te),{symbols:[]})}$resolveWorkspaceSymbol($,G,te){return this._withAdapter($,J,ie=>ie.resolveWorkspaceSymbol(G,te),void 0)}$releaseWorkspaceSymbols($,G){this._withAdapter($,J,te=>te.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider($,G,te){const ie=this._addNewAdapter(new z(this._documents,te,this._logService),$);return this._proxy.$registerRenameSupport(ie,this._transformDocumentSelector(G),z.supportsResolving(te)),this._createDisposable(ie)}$provideRenameEdits($,G,te,ie,he){return this._withAdapter($,z,De=>De.provideRenameEdits(_.URI.revive(G),te,ie,he),void 0)}$resolveRenameLocation($,G,te,ie){return this._withAdapter($,z,he=>he.resolveRenameLocation(_.URI.revive(G),te,ie),void 0)}registerDocumentSemanticTokensProvider($,G,te,ie){const he=this._nextHandle(),De=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(he,new He(new L(this._documents,te),$)),this._proxy.$registerDocumentSemanticTokensProvider(he,this._transformDocumentSelector(G),ie,De);let Le=this._createDisposable(he);if(De){const me=te.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(De));Le=P.Disposable.from(Le,me)}return Le}$provideDocumentSemanticTokens($,G,te,ie){return this._withAdapter($,L,he=>he.provideDocumentSemanticTokens(_.URI.revive(G),te,ie),null,!0)}$releaseDocumentSemanticTokens($,G){this._withAdapter($,L,te=>te.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider($,G,te,ie){const he=this._addNewAdapter(new N(this._documents,te),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(he,this._transformDocumentSelector(G),ie),this._createDisposable(he)}$provideDocumentRangeSemanticTokens($,G,te,ie){return this._withAdapter($,N,he=>he.provideDocumentRangeSemanticTokens(_.URI.revive(G),te,ie),null,!0)}registerCompletionItemProvider($,G,te,ie){const he=this._addNewAdapter(new H(this._documents,this._commands.converter,te,this._apiDeprecation,$),$);return this._proxy.$registerSuggestSupport(he,this._transformDocumentSelector(G),ie,H.supportsResolving(te),`${$.identifier.value}(${ie.join("")})`),this._createDisposable(he)}$provideCompletionItems($,G,te,ie,he){return this._withAdapter($,H,De=>De.provideCompletionItems(_.URI.revive(G),te,ie,he),void 0)}$resolveCompletionItem($,G,te){return this._withAdapter($,H,ie=>ie.resolveCompletionItem(G,te),void 0)}$releaseCompletionItems($,G){this._withAdapter($,H,te=>te.releaseCompletionItems(G),void 0)}registerSignatureHelpProvider($,G,te,ie){const he=Array.isArray(ie)?{triggerCharacters:ie,retriggerCharacters:[]}:ie,De=this._addNewAdapter(new O(this._documents,te),$);return this._proxy.$registerSignatureHelpProvider(De,this._transformDocumentSelector(G),he),this._createDisposable(De)}$provideSignatureHelp($,G,te,ie,he){return this._withAdapter($,O,De=>De.provideSignatureHelp(_.URI.revive(G),te,ie,he),void 0)}$releaseSignatureHelp($,G){this._withAdapter($,O,te=>te.releaseSignatureHelp(G),void 0)}registerInlineHintsProvider($,G,te){const ie=typeof te.onDidChangeInlineHints=="function"?this._nextHandle():void 0,he=this._addNewAdapter(new K(this._documents,te),$);this._proxy.$registerInlineHintsProvider(he,this._transformDocumentSelector(G),ie);let De=this._createDisposable(he);if(ie!==void 0){const Le=te.onDidChangeInlineHints(me=>this._proxy.$emitInlineHintsEvent(ie));De=P.Disposable.from(De,Le)}return De}$provideInlineHints($,G,te,ie){return this._withAdapter($,K,he=>he.provideInlineHints(_.URI.revive(G),te,ie),void 0)}registerDocumentLinkProvider($,G,te){const ie=this._addNewAdapter(new le(this._documents,te),$);return this._proxy.$registerDocumentLinkProvider(ie,this._transformDocumentSelector(G),typeof te.resolveDocumentLink=="function"),this._createDisposable(ie)}$provideDocumentLinks($,G,te){return this._withAdapter($,le,ie=>ie.provideLinks(_.URI.revive(G),te),void 0)}$resolveDocumentLink($,G,te){return this._withAdapter($,le,ie=>ie.resolveLink(G,te),void 0)}$releaseDocumentLinks($,G){this._withAdapter($,le,te=>te.releaseLinks(G),void 0)}registerColorProvider($,G,te){const ie=this._addNewAdapter(new ue(this._documents,te),$);return this._proxy.$registerDocumentColorProvider(ie,this._transformDocumentSelector(G)),this._createDisposable(ie)}$provideDocumentColors($,G,te){return this._withAdapter($,ue,ie=>ie.provideColors(_.URI.revive(G),te),[])}$provideColorPresentations($,G,te,ie){return this._withAdapter($,ue,he=>he.provideColorPresentations(_.URI.revive(G),te,ie),void 0)}registerFoldingRangeProvider($,G,te){const ie=this._nextHandle(),he=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ie,new He(new pe(this._documents,te),$)),this._proxy.$registerFoldingRangeProvider(ie,this._transformDocumentSelector(G),he);let De=this._createDisposable(ie);if(he!==void 0){const Le=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(he));De=P.Disposable.from(De,Le)}return De}$provideFoldingRanges($,G,te,ie){return this._withAdapter($,pe,he=>he.provideFoldingRanges(_.URI.revive(G),te,ie),void 0)}registerSelectionRangeProvider($,G,te){const ie=this._addNewAdapter(new ve(this._documents,te,this._logService),$);return this._proxy.$registerSelectionRangeProvider(ie,this._transformDocumentSelector(G)),this._createDisposable(ie)}$provideSelectionRanges($,G,te,ie){return this._withAdapter($,ve,he=>he.provideSelectionRanges(_.URI.revive(G),te,ie),[])}registerCallHierarchyProvider($,G,te){const ie=this._addNewAdapter(new Re(this._documents,te),$);return this._proxy.$registerCallHierarchyProvider(ie,this._transformDocumentSelector(G)),this._createDisposable(ie)}$prepareCallHierarchy($,G,te,ie){return this._withAdapter($,Re,he=>Promise.resolve(he.prepareSession(_.URI.revive(G),te,ie)),void 0)}$provideCallHierarchyIncomingCalls($,G,te,ie){return this._withAdapter($,Re,he=>he.provideCallsTo(G,te,ie),void 0)}$provideCallHierarchyOutgoingCalls($,G,te,ie){return this._withAdapter($,Re,he=>he.provideCallsFrom(G,te,ie),void 0)}$releaseCallHierarchy($,G){this._withAdapter($,Re,te=>Promise.resolve(te.releaseSession(G)),void 0)}static _serializeRegExp($){return{pattern:$.source,flags:(0,D.regExpFlags)($)}}static _serializeIndentationRule($){return{decreaseIndentPattern:Fe._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:Fe._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?Fe._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?Fe._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:Fe._serializeRegExp($.beforeText),afterText:$.afterText?Fe._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?Fe._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(Fe._serializeOnEnterRule)}setLanguageConfiguration($,G,te){let{wordPattern:ie}=te;if(ie&&(0,D.regExpLeadsToEndlessLoop)(ie))throw new Error(`Invalid language configuration: wordPattern '${ie}' is not allowed to match the empty string.`);ie?this._documents.setWordDefinitionFor(G,ie):this._documents.setWordDefinitionFor(G,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const he=this._nextHandle(),De={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?Fe._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?Fe._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?Fe._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(he,G,De),this._createDisposable(he)}$setWordDefinitions($){for(const G of $)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=Fe,Fe._handlePool=0}),define(we[195],Ee([0,1,5,9,7]),function(re,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class P{constructor(C,D){this._proxy=C.getProxy(_.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(C,D){await this._proxy.$changeLanguage(C,D);const n=this._documents.getDocumentData(C);if(!n)throw new Error(`document '${C.toString}' NOT found`);return n.document}async tokenAtPosition(C,D){var n;const A=C.version,I=S.Position.from(D),p=await this._proxy.$tokensAtPosition(C.uri,I),f={type:T.StandardTokenType.Other,range:(n=C.getWordRangeAtPosition(D))!==null&&n!==void 0?n:new T.Range(D.line,D.character,D.line,D.character)};if(!p)return f;const s={range:S.Range.to(p.range),type:S.TokenType.to(p.type)};return!s.range.contains(D)||A!==C.version?f:s}}e.ExtHostLanguages=P}),define(we[196],Ee([0,1,5,19,33]),function(re,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(C){return C&&C.title}let E=class{constructor(D,n){this._logService=n,this._proxy=D.getProxy(_.MainContext.MainThreadMessageService)}showMessage(D,n,A,I,p){const f={extension:D};let s;typeof I=="string"||P(I)?s=[I,...p]:(f.modal=I&&I.modal,f.useCustom=I&&I.useCustom,s=p),f.useCustom&&(0,T.checkProposedApiEnabled)(D);const h=[];for(let v=0;v<s.length;v++){const g=s[v];if(typeof g=="string")h.push({title:g,handle:v,isCloseAffordance:!1});else if(typeof g=="object"){let{title:b,isCloseAffordance:c}=g;h.push({title:b,isCloseAffordance:!!c,handle:v})}else this._logService.warn("Invalid message item:",g)}return this._proxy.$showMessage(n,A,f,h).then(v=>{if(typeof v=="number")return s[v]})}};E=Ve([qe(1,S.ILogService)],E),e.ExtHostMessageService=E}),define(we[197],Ee([0,1,20,3,6,2,29,5,9,7,70,40,22,174,175,53,12,56]),function(re,e,_,S,T,P,E,C,D,n,A,I,p,f,s,h,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookCellStatusBarItemInternal=e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class b extends T.Disposable{constructor(i,d,y,k,m){super();this._editorId=i,this.uri=d,this._proxy=y,this._webviewInitData=k,this.document=m,this._onDidReceiveDocumentMessage=new S.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:w=>this._proxy.$postMessage(this._editorId,void 0,w),asWebviewUri:w=>this._asWebviewUri(w)}}onDidReceiveMessage(i,d){var y;this._onDidReceiveDocumentMessage.fire(d),i!==void 0&&((y=this._rendererIdToEmitters.get(i))===null||y===void 0||y.fire(d))}getRendererComm(i){const d=new S.Emitter;return this._rendererIdToEmitters.set(i,d),{editorId:this._editorId,onDidReceiveMessage:d.event,postMessage:y=>this._proxy.$postMessage(this._editorId,i,y),asWebviewUri:y=>this._asWebviewUri(y)}}_asWebviewUri(i){return(0,A.asWebviewUri)(this._webviewInitData,this._editorId,i)}}class c extends T.Disposable{constructor(i,d,y,k){super();this._proxy=i,this._handle=d,this._extension=y,this._provider=k,this._kernelToFriendlyId=new p.ResourceMap,this._friendlyIdToKernel=new p.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(m=>{const w=m==null?void 0:m.uri;this._proxy.$onNotebookKernelChange(this._handle,w)}))}async provideKernels(i,d){const y=await this._provider.provideKernels(i.notebookDocument,d)||[],k=new Map;let m=0;const w=new Set,R=this._kernelToFriendlyId.get(i.uri),F=y.map(Q=>{let J=R==null?void 0:R.get(Q);return J===void 0&&(Q.id&&w.has(Q.id)?J=`${this._extension.identifier.value}_${Q.id}_${m++}`:J=`${this._extension.identifier.value}_${Q.id||E.generateUuid()}`),k.set(Q,J),{id:Q.id,friendlyId:J,label:Q.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:Q.description,detail:Q.detail,isPreferred:Q.isPreferred,preloads:Q.preloads,supportedLanguages:Q.supportedLanguages}});this._kernelToFriendlyId.set(i.uri,k);const B=new Map;return k.forEach((Q,J)=>{B.set(Q,J)}),this._friendlyIdToKernel.set(i.uri,B),F}getKernelByFriendlyId(i,d){var y;return(y=this._friendlyIdToKernel.get(i))===null||y===void 0?void 0:y.get(d)}async resolveNotebook(i,d,y,k){var m;const w=(m=this._friendlyIdToKernel.get(d.uri))===null||m===void 0?void 0:m.get(i);if(w&&this._provider.resolveKernel)return this._provider.resolveKernel(w,d.notebookDocument,y,k)}async executeNotebook(i,d,y){var k;const m=(k=this._friendlyIdToKernel.get(d.uri))===null||k===void 0?void 0:k.get(i);if(!!m)return u(y?w=>m.executeCell(d.notebookDocument,y.cell,w):w=>m.executeAllCells(d.notebookDocument,w))}async cancelNotebook(i,d,y){var k;const m=(k=this._friendlyIdToKernel.get(d.uri))===null||k===void 0?void 0:k.get(i);if(!!m)return y?m.cancelCellExecution(d.notebookDocument,y.cell):m.cancelAllCellsExecution(d.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=c;async function u(l){const i=new _.CancellationTokenSource;try{await l(i.token)}finally{i.dispose()}}class a{constructor(i,d){const y=a._Keys.nextId();i.$registerNotebookEditorDecorationType(y,D.NotebookDecorationRenderOptions.from(d)),this.value={key:y,dispose(){i.$removeNotebookEditorDecorationType(y)}}}}e.NotebookEditorDecorationType=a,a._Keys=new h.IdGenerator("NotebookEditorDecorationType");class t{constructor(i,d,y,k,m,w){this._documentsAndEditors=y,this._webviewInitData=k,this.logService=m,this._extensionStoragePaths=w,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._documents=new p.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new S.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new S.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new S.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new S.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new S.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellLanguage=new S.Emitter,this.onDidChangeCellLanguage=this._onDidChangeCellLanguage.event,this._onDidChangeCellMetadata=new S.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new S.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new S.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new S.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new S.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new S.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new S.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._backupIdPool=0,this._proxy=i.getProxy(C.MainContext.MainThreadNotebook),this._commandsConverter=d.converter,d.registerArgumentProcessor({processArgument:R=>{var F;if(R&&R.$mid===12){const B=(F=R.notebookEditor)===null||F===void 0?void 0:F.notebookUri,Q=R.cell.handle,J=this._documents.get(B),z=J==null?void 0:J.getCell(Q);if(z)return z.cell}return R}})}get activeNotebookEditor(){var i;return(i=this._activeNotebookEditor)===null||i===void 0?void 0:i.editor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(i=>i.editor)}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(i){return this._documents.get(i)}_getNotebookDocument(i){const d=this._documents.get(i);if(!d)throw new Error(`NO notebook document for '${i}'`);return d}_getProviderData(i){const d=this._notebookContentProviders.get(i);if(!d)throw new Error(`NO provider for '${i}'`);return d}registerNotebookContentProvider(i,d,y,k){var m,w,R;if(this._notebookContentProviders.has(d))throw new Error(`Notebook provider for '${d}' already registered`);this._notebookContentProviders.set(d,{extension:i,provider:y});let F;y.onDidChangeNotebookContentOptions&&(F=y.onDidChangeNotebookContentOptions(()=>{this._proxy.$updateNotebookProviderOptions(d,y.options)}));const B=(m=k==null?void 0:k.viewOptions)===null||m===void 0?void 0:m.filenamePattern.map(Q=>D.NotebookExclusiveDocumentPattern.from(Q)).filter(Q=>Q!==void 0);return((w=k==null?void 0:k.viewOptions)===null||w===void 0?void 0:w.filenamePattern)&&!B&&console.warn(`Notebook content provider view options file name pattern is invalid ${(R=k==null?void 0:k.viewOptions)===null||R===void 0?void 0:R.filenamePattern}`),this._proxy.$registerNotebookProvider({id:i.identifier,location:i.extensionLocation,description:i.description},d,{transientOutputs:(k==null?void 0:k.transientOutputs)||!1,transientMetadata:(k==null?void 0:k.transientMetadata)||{},viewOptions:(k==null?void 0:k.viewOptions)&&B?{displayName:k.viewOptions.displayName,filenamePattern:B,exclusive:k.viewOptions.exclusive||!1}:void 0}),new n.Disposable(()=>{F==null||F.dispose(),this._notebookContentProviders.delete(d),this._proxy.$unregisterNotebookProvider(d)})}registerNotebookKernelProvider(i,d,y){const k=t._notebookKernelProviderHandlePool++,m=new c(this._proxy,k,i,y);return this._notebookKernelProviders.set(k,m),this._proxy.$registerNotebookKernelProvider({id:i.identifier,location:i.extensionLocation,description:i.description},k,{viewType:d.viewType,filenamePattern:d.filenamePattern?D.NotebookExclusiveDocumentPattern.from(d.filenamePattern):void 0}),new n.Disposable(()=>{m.dispose(),this._notebookKernelProviders.delete(k),this._proxy.$unregisterNotebookKernelProvider(k)})}createNotebookEditorDecorationType(i){return new a(this._proxy,i).value}async openNotebookDocument(i,d){const y=this._documents.get(P.URI.revive(i));if(y)return y.notebookDocument;await this._proxy.$tryOpenDocument(i,d);const k=this._documents.get(P.URI.revive(i));return(0,v.assertIsDefined)(k==null?void 0:k.notebookDocument)}_withAdapter(i,d,y){const k=this._documents.get(P.URI.revive(d));if(!k)return[];const m=this._notebookKernelProviders.get(i);return m?y(m,k):[]}async showNotebookDocument(i,d){var y;P.URI.isUri(i)&&(i=await this.openNotebookDocument(i));let k;typeof d=="object"?k={position:D.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selection:d.selection&&D.NotebookCellRange.from(d.selection),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:k={preserveFocus:!1};const m=await this._proxy.$tryShowNotebookDocument(i.uri,i.viewType,k),w=m&&((y=this._editors.get(m))===null||y===void 0?void 0:y.editor);if(w)return w.editor;throw m?new Error(`Could NOT open editor for "${i.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.toString()}".`)}async $provideNotebookKernels(i,d,y){return this._withAdapter(i,d,(k,m)=>k.provideKernels(m,y))}async $resolveNotebookKernel(i,d,y,k,m){await this._withAdapter(i,y,async(w,R)=>{const F=this._webviewComm.get(d);F&&await w.resolveNotebook(k,R,F.contentProviderComm,m)})}async $resolveNotebookEditor(i,d,y){const k=this._notebookContentProviders.get(i),m=P.URI.revive(d),w=this._documents.get(m);if(!(!w||!k)){let R=this._webviewComm.get(y);R||(R=new b(y,m,this._proxy,this._webviewInitData,w),this._webviewComm.set(y,R)),!!k.provider.resolveNotebook&&await k.provider.resolveNotebook(w.notebookDocument,R.contentProviderComm)}}async $executeNotebookKernelFromProvider(i,d,y,k){await this._withAdapter(i,d,async(m,w)=>{const R=k!==void 0?w.getCell(k):void 0;return m.executeNotebook(y,w,R)})}async $cancelNotebookKernelFromProvider(i,d,y,k){await this._withAdapter(i,d,async(m,w)=>{const R=k!==void 0?w.getCell(k):void 0;return m.cancelNotebook(y,w,R)})}async $openNotebook(i,d,y){const{provider:k}=this._getProviderData(i),m=await k.openNotebook(P.URI.revive(d),{backupId:y});return{metadata:Object.assign(Object.assign({},I.notebookDocumentMetadataDefaults),m.metadata),cells:m.cells.map(D.NotebookCellData.from)}}async $saveNotebook(i,d,y){const k=this._getNotebookDocument(P.URI.revive(d)),{provider:m}=this._getProviderData(i);return await m.saveNotebook(k.notebookDocument,y),!0}async $saveNotebookAs(i,d,y,k){const m=this._getNotebookDocument(P.URI.revive(d)),{provider:w}=this._getProviderData(i);return await w.saveNotebookAs(P.URI.revive(y),m.notebookDocument,k),!0}async $backupNotebook(i,d,y){var k;const m=this._getNotebookDocument(P.URI.revive(d)),w=this._getProviderData(i),R=(k=this._extensionStoragePaths.workspaceValue(w.extension))!==null&&k!==void 0?k:this._extensionStoragePaths.globalValue(w.extension),F=String((0,g.hash)([m.uri.toString(),this._backupIdPool++])),B=P.URI.joinPath(R,F),Q=await w.provider.backupNotebook(m.notebookDocument,{destination:B},y);return m.updateBackup(Q),Q.id}$acceptNotebookActiveKernelChange(i){i.providerHandle!==void 0&&this._withAdapter(i.providerHandle,i.uri,async(d,y)=>{const k=i.kernelFriendlyId?d.getKernelByFriendlyId(P.URI.revive(i.uri),i.kernelFriendlyId):void 0;this._editors.forEach(m=>{m.editor.notebookData===y&&m.editor._acceptKernel(k)}),this._onDidChangeActiveNotebookKernel.fire({document:y.notebookDocument,kernel:k})})}$onDidReceiveMessage(i,d,y){var k;(k=this._webviewComm.get(i))===null||k===void 0||k.onDidReceiveMessage(d,y)}$acceptModelChanged(i,d,y){this._getNotebookDocument(P.URI.revive(i)).acceptModelChanged(d,y)}$acceptDirtyStateChanged(i,d){const y=this._getNotebookDocument(P.URI.revive(i));y.acceptModelChanged({rawEvents:[],versionId:y.notebookDocument.version},d)}$acceptModelSaved(i){const d=this._getNotebookDocument(P.URI.revive(i));this._onDidSaveNotebookDocument.fire(d.notebookDocument)}$acceptEditorPropertiesChanged(i,d){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",i,d);const y=this._editors.get(i);if(!y)throw new Error(`unknown text editor: ${i}`);d.visibleRanges&&y.editor._acceptVisibleRanges(d.visibleRanges.ranges.map(D.NotebookCellRange.to)),d.selections&&y.editor._acceptSelections(d.selections.selections.map(D.NotebookCellRange.to)),d.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:y.editor.editor,visibleRanges:y.editor.editor.visibleRanges}),d.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:y.editor.editor,selections:y.editor.editor.selections}))}$acceptDocumentPropertiesChanged(i,d){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",i.path,d),this._getNotebookDocument(P.URI.revive(i)).acceptDocumentPropertiesChanged(d)}_createExtHostEditor(i,d,y){var k;const m=i.uri;let w=this._webviewComm.get(d);w||(w=new b(d,m,this._proxy,this._webviewInitData,i),this._webviewComm.set(d,w));const R=new s.ExtHostNotebookEditor(d,i.notebookDocument.viewType,this._proxy,i,y.visibleRanges.map(D.NotebookCellRange.to),y.selections.map(D.NotebookCellRange.to),typeof y.viewColumn=="number"?D.ViewColumn.to(y.viewColumn):void 0);(k=this._editors.get(d))===null||k===void 0||k.editor.dispose(),this._editors.set(d,{editor:R})}$acceptDocumentAndEditorsDelta(i){var d,y,k,m;let w=!1;if(i.removedDocuments)for(const F of i.removedDocuments){const B=P.URI.revive(F),Q=this._documents.get(B);Q&&(Q.dispose(),this._documents.delete(B),this._documentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:Q.notebookDocument.cells.map(J=>J.uri)}),this._onDidCloseNotebookDocument.fire(Q.notebookDocument));for(const J of this._editors.values())J.editor.notebookData.uri.toString()===B.toString()&&(J.editor.dispose(),this._editors.delete(J.editor.id),w=!0)}if(i.addedDocuments){const F=[];for(const B of i.addedDocuments){const Q=P.URI.revive(B.uri),J=B.viewType;if(this._documents.has(Q))throw new Error(`adding EXISTING notebook ${Q}`);const z=this,ae=new f.ExtHostNotebookDocument(this._proxy,this._documentsAndEditors,{emitModelChange(L){z._onDidChangeNotebookCells.fire(L)},emitCellOutputsChange(L){z._onDidChangeCellOutputs.fire(L)},emitCellLanguageChange(L){z._onDidChangeCellLanguage.fire(L)},emitCellMetadataChange(L){z._onDidChangeCellMetadata.fire(L)},emitDocumentMetadataChange(L){z._onDidChangeNotebookDocumentMetadata.fire(L)}},J,B.contentOptions,B.metadata?D.NotebookDocumentMetadata.to(B.metadata):new n.NotebookDocumentMetadata,Q);ae.acceptModelChanged({versionId:B.versionId,rawEvents:[{kind:I.NotebookCellsChangeType.Initialize,changes:[[0,0,B.cells]]}]},!1),F.push(...B.cells.map(L=>f.ExtHostCell.asModelAddData(ae.notebookDocument,L))),(d=this._documents.get(Q))===null||d===void 0||d.dispose(),this._documents.set(Q,ae),this._documentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:F}),this._onDidOpenNotebookDocument.fire(ae.notebookDocument)}}if(i.addedEditors)for(const F of i.addedEditors){if(this._editors.has(F.id))return;const B=P.URI.revive(F.documentUri),Q=this._documents.get(B);Q&&(this._createExtHostEditor(Q,F.id,F),w=!0)}const R=[];if(i.removedEditors)for(const F of i.removedEditors){const B=this._editors.get(F);B&&(w=!0,this._editors.delete(F),((y=this._activeNotebookEditor)===null||y===void 0?void 0:y.id)===B.editor.id&&(this._activeNotebookEditor=void 0),R.push(B))}if(w&&R.forEach(F=>{F.editor.dispose()}),i.visibleEditors){this._visibleNotebookEditors=i.visibleEditors.map(B=>this._editors.get(B).editor).filter(B=>!!B);const F=new Set;this._visibleNotebookEditors.forEach(B=>F.add(B.id));for(const B of this._editors.values()){const Q=F.has(B.editor.id);B.editor._acceptVisibility(Q)}this._visibleNotebookEditors=[...this._editors.values()].map(B=>B.editor).filter(B=>B.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}i.newActiveEditor===null?this._activeNotebookEditor=void 0:i.newActiveEditor&&(this._activeNotebookEditor=(k=this._editors.get(i.newActiveEditor))===null||k===void 0?void 0:k.editor),this._onDidChangeActiveNotebookEditor.fire((m=this._activeNotebookEditor)===null||m===void 0?void 0:m.editor)}createNotebookCellStatusBarItemInternal(i,d,y){const k=new r(this._proxy,this._commandsConverter,i,d,y),m=I.CellUri.parse(i.uri);if(m){const w=this._documents.get(m.notebook);if(w){const R=w.getCell(m.handle);R&&S.Event.once(R.onDidDispose)(()=>k.dispose())}}return k}}e.ExtHostNotebookController=t,t._notebookKernelProviderHandlePool=0;class r extends T.Disposable{constructor(i,d,y,k,m){super();this._proxy=i,this._commands=d,this._cell=y,this._priority=m,this._id=r.NEXT_ID++,this._isDisposed=!1,this._text="",this._visible=!1,this._internalCommandRegistration=this._register(new T.DisposableStore),this._alignment=k!=null?k:n.NotebookCellStatusBarAlignment.Left}get apiItem(){return this._apiItem||(this._apiItem=o(this)),this._apiItem}get cell(){return this._cell}get alignment(){return this._alignment}set alignment(i){this._alignment=i,this.update()}get priority(){return this._priority}set priority(i){this._priority=i,this.update()}get text(){return this._text}set text(i){this._text=i,this.update()}get tooltip(){return this._tooltip}set tooltip(i){this._tooltip=i,this.update()}get command(){var i;return(i=this._command)===null||i===void 0?void 0:i.fromApi}set command(i){var d;((d=this._command)===null||d===void 0?void 0:d.fromApi)!==i&&(this._internalCommandRegistration.clear(),typeof i=="string"?this._command={fromApi:i,internal:this._commands.toInternal({title:"",command:i},this._internalCommandRegistration)}:i?this._command={fromApi:i,internal:this._commands.toInternal(i,this._internalCommandRegistration)}:this._command=void 0,this.update())}get accessibilityInformation(){return this._accessibilityInformation}set accessibilityInformation(i){this._accessibilityInformation=i,this.update()}show(){this._visible=!0,this.update()}hide(){this._visible=!1,this.update()}dispose(){this.hide(),this._isDisposed=!0,this._internalCommandRegistration.dispose()}update(){var i;if(!this._isDisposed){const d={alignment:this.alignment===n.NotebookCellStatusBarAlignment.Left?0:1,cellResource:this.cell.uri,command:(i=this._command)===null||i===void 0?void 0:i.internal,text:this.text,tooltip:this.tooltip,accessibilityInformation:this.accessibilityInformation,priority:this.priority,visible:this._visible};this._proxy.$setStatusBarEntry(this._id,d)}}}e.NotebookCellStatusBarItemInternal=r,r.NEXT_ID=0;function o(l){return Object.freeze({cell:l.cell,get alignment(){return l.alignment},set alignment(i){l.alignment=i},get priority(){return l.priority},set priority(i){l.priority=i},get text(){return l.text},set text(i){l.text=i},get tooltip(){return l.tooltip},set tooltip(i){l.tooltip=i},get command(){return l.command},set command(i){l.command=i},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(i){l.accessibilityInformation=i},show(){l.show()},hide(){l.hide()},dispose(){l.dispose()}})}}),define(we[98],Ee([0,1,5,3,6,26,4,13]),function(re,e,_,S,T,P,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends T.Disposable{constructor(s,h,v,g){super();this._onDidAppend=this._register(new S.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=s,this._proxy=g,this._id=g.$register(this.name,h,v),this._disposed=!1,this._offset=0}get name(){return this._name}append(s){this.validate(),this._offset+=s?P.VSBuffer.fromString(s).byteLength:0}update(){this._id.then(s=>this._proxy.$update(s))}appendLine(s){this.validate(),this.append(s+`
`)}clear(){this.validate();const s=this._offset;this._id.then(h=>this._proxy.$clear(h,s))}show(s,h){this.validate(),this._id.then(v=>this._proxy.$reveal(v,!!(typeof s=="boolean"?s:h)))}hide(){this.validate(),this._id.then(s=>this._proxy.$close(s))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(s=>this._proxy.$dispose(s)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class n extends D{constructor(s,h){super(s,!1,void 0,h)}append(s){super.append(s),this._id.then(h=>this._proxy.$append(h,s)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=n;class A extends D{constructor(s,h,v){super(s,!0,h,v)}append(s){throw new Error("Not supported")}}class I{constructor(s,h){this.name=s,this._channel=h}append(s){this._channel.then(h=>h.append(s))}appendLine(s){this._channel.then(h=>h.appendLine(s))}clear(){this._channel.then(s=>s.clear())}show(s,h){this._channel.then(v=>v.show(s,h))}hide(){this._channel.then(s=>s.hide())}dispose(){this._channel.then(s=>s.dispose())}}e.LazyOutputChannel=I;let p=class{constructor(s){this._proxy=s.getProxy(_.MainContext.MainThreadOutputService)}$setVisibleChannel(s){}createOutputChannel(s){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");return new n(s,this._proxy)}createOutputChannelFromLogFile(s,h){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");if(!h)throw new Error("illegal argument `file`. must not be falsy");return new A(s,h,this._proxy)}};p=Ve([qe(0,C.IExtHostRpcService)],p),e.ExtHostOutputService=p,e.IExtHostOutputService=(0,E.createDecorator)("IExtHostOutputService")}),define(we[198],Ee([0,1,15,20,3,6,5,2,7,11,14]),function(re,e,_,S,T,P,E,C,D,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function I(p,f,s){const h=p.getProxy(E.MainContext.MainThreadQuickOpen);class v{constructor(o,l){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=l}showQuickPick(o,l,i,d=S.CancellationToken.None){this._onDidSelectItem=void 0;const y=Promise.resolve(o),k=++this._instances,m=h.$show(k,{placeHolder:i&&i.placeHolder,matchOnDescription:i&&i.matchOnDescription,matchOnDetail:i&&i.matchOnDetail,ignoreFocusLost:i&&i.ignoreFocusOut,canPickMany:i&&i.canPickMany},d),w={},R=m.then(()=>w);return Promise.race([R,y]).then(F=>{if(F!==w)return y.then(B=>{const Q=[];for(let J=0;J<B.length;J++){const z=B[J];let ae,L,N,H,O;typeof z=="string"?ae=z:(ae=z.label,L=z.description,N=z.detail,H=z.picked,O=z.alwaysShow),Q.push({label:ae,description:L,handle:J,detail:N,picked:H,alwaysShow:O})}return i&&typeof i.onDidSelectItem=="function"&&(this._onDidSelectItem=J=>{i.onDidSelectItem(B[J])}),h.$setItems(k,Q),m.then(J=>{if(typeof J=="number")return B[J];if(Array.isArray(J))return J.map(z=>B[z])})})}).then(void 0,F=>{if(!(0,n.isPromiseCanceledError)(F))return h.$setError(k,F),Promise.reject(F)})}$onItemSelected(o){this._onDidSelectItem&&this._onDidSelectItem(o)}showInput(o,l=S.CancellationToken.None){return this._validateInput=o?o.validateInput:void 0,h.$input(o,typeof this._validateInput=="function",l).then(void 0,i=>{if(!(0,n.isPromiseCanceledError)(i))return Promise.reject(i)})}$validateInput(o){return this._validateInput?(0,_.asPromise)(()=>this._validateInput(o)):Promise.resolve(void 0)}async showWorkspaceFolderPick(o,l=S.CancellationToken.None){const i=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!!i){const d=await this._workspace.getWorkspaceFolders2();if(!!d)return d.find(y=>y.uri.toString()===i.uri.toString())}}createQuickPick(o,l){const i=new a(o,l,()=>this._sessions.delete(i._id));return this._sessions.set(i._id,i),i}createInputBox(o){const l=new t(o,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(o,l){const i=this._sessions.get(o);i&&i._fireDidChangeValue(l)}$onDidAccept(o){const l=this._sessions.get(o);l&&l._fireDidAccept()}$onDidChangeActive(o,l){const i=this._sessions.get(o);i instanceof a&&i._fireDidChangeActive(l)}$onDidChangeSelection(o,l){const i=this._sessions.get(o);i instanceof a&&i._fireDidChangeSelection(l)}$onDidTriggerButton(o,l){const i=this._sessions.get(o);i&&i._fireDidTriggerButton(l)}$onDidHide(o){const l=this._sessions.get(o);l&&l._fireDidHide()}}class g{constructor(o,l){this._extensionId=o,this._onDidDispose=l,this._id=a._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new T.Emitter,this._onDidChangeValueEmitter=new T.Emitter,this._onDidTriggerButtonEmitter=new T.Emitter,this._onDidHideEmitter=new T.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((l,i)=>{const d=l===D.QuickInputButtons.Back?-1:i;this._handlesToButtons.set(d,l)}),this.update({buttons:o.map((l,i)=>({iconPath:b(l.iconPath),tooltip:l.tooltip,handle:l===D.QuickInputButtons.Back?-1:i}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const l=this._handlesToButtons.get(o);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,P.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),h.$dispose(this._id))}update(o){if(!this._disposed){for(const l of Object.keys(o)){const i=o[l];this._pendingUpdate[l]=i===void 0?null:i}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){h.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}g._nextId=1;function b(r){if(r instanceof D.ThemeIcon)return{id:r.id};const o=u(r),l=c(r);return{dark:typeof o=="string"?C.URI.file(o):o,light:typeof l=="string"?C.URI.file(l):l}}function c(r){return typeof r=="object"&&"light"in r?r.light:r}function u(r){return typeof r=="object"&&"dark"in r?r.dark:r}class a extends g{constructor(o,l,i){super(o,i);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new T.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new T.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((l,i)=>{this._handlesToItems.set(i,l),this._itemsToHandles.set(l,i)}),this.update({items:o.map((l,i)=>({label:l.label,description:l.description,handle:i,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(o){const l=(0,A.coalesce)(o.map(i=>this._handlesToItems.get(i)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(o){const l=(0,A.coalesce)(o.map(i=>this._handlesToItems.get(i)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}}class t extends g{constructor(o,l){super(o,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,this.update({validationMessage:o})}}return new v(f,s)}e.createExtHostQuickOpen=I}),define(we[199],Ee([0,1,2,3,45,6,15,5,14,109,19,25,33]),function(re,e,_,S,T,P,E,C,D,n,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(l){if(l)return typeof l.iconPath=="string"?_.URI.file(l.iconPath):l.iconPath}function s(l,i){if(!l.iconPath&&!i.iconPath)return 0;if(l.iconPath){if(!i.iconPath)return 1}else return-1;const d=typeof l.iconPath=="string"?l.iconPath:l.iconPath.fsPath,y=typeof i.iconPath=="string"?i.iconPath:i.iconPath.fsPath;return(0,n.comparePaths)(d,y)}function h(l,i){let d=0;if(l.strikeThrough!==i.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==i.faded)return l.faded?1:-1;if(l.tooltip!==i.tooltip)return(l.tooltip||"").localeCompare(i.tooltip||"");if(d=s(l,i),d!==0)return d;if(l.light&&i.light)d=s(l.light,i.light);else{if(l.light)return 1;if(i.light)return-1}if(d!==0)return d;if(l.dark&&i.dark)d=s(l.dark,i.dark);else{if(l.dark)return 1;if(i.dark)return-1}return d}function v(l,i){if(l.command!==i.command)return l.command<i.command?-1:1;if(l.title!==i.title)return l.title<i.title?-1:1;if(l.tooltip!==i.tooltip){if(l.tooltip!==void 0&&i.tooltip!==void 0)return l.tooltip<i.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(i.tooltip!==void 0)return-1}if(l.arguments===i.arguments)return 0;if(l.arguments)if(i.arguments){if(l.arguments.length!==i.arguments.length)return l.arguments.length-i.arguments.length}else return 1;else return-1;for(let d=0;d<l.arguments.length;d++){const y=l.arguments[d],k=i.arguments[d];if(y!==k)return y<k?-1:1}return 0}function g(l,i){let d=(0,n.comparePaths)(l.resourceUri.fsPath,i.resourceUri.fsPath,!0);if(d!==0)return d;if(l.command&&i.command)d=v(l.command,i.command);else{if(l.command)return 1;if(i.command)return-1}if(d!==0)return d;if(l.decorations&&i.decorations)d=h(l.decorations,i.decorations);else{if(l.decorations)return 1;if(i.decorations)return-1}return d}function b(l,i){for(let d=0;d<l.length;d++)if(l[d]!==i[d])return!1;return!0}function c(l,i){return l.command===i.command&&l.title===i.title&&l.tooltip===i.tooltip&&(l.arguments&&i.arguments?b(l.arguments,i.arguments):l.arguments===i.arguments)}function u(l,i){return(0,D.equals)(l,i,c)}class a{constructor(i,d,y){this._extension=i,this._proxy=d,this._sourceControlHandle=y,this._value="",this._onDidChange=new S.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(i){this._proxy.$setInputBoxValue(this._sourceControlHandle,i),this.updateValue(i)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(i){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,i),this._placeholder=i}get validateInput(){return(0,p.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(i){if((0,p.checkProposedApiEnabled)(this._extension),i&&typeof i!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=i,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!i)}get visible(){return this._visible}set visible(i){i=!!i,this._visible!==i&&(this._visible=i,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,i))}$onInputBoxValueChange(i){this.updateValue(i)}updateValue(i){this._value=i,this._onDidChange.fire(i)}}e.ExtHostSCMInputBox=a;class t{constructor(i,d,y,k,m){this._proxy=i,this._commands=d,this._sourceControlHandle=y,this._id=k,this._label=m,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new S.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new S.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(i){this._label=i,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,i)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(i){this._hideWhenEmpty=i,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(i){this._resourceStates=[...i],this._onDidUpdateResourceStates.fire()}getResourceState(i){return this._resourceStatesMap.get(i)}$executeResourceCommand(i,d){const y=this._resourceStatesCommandsMap.get(i);return y?(0,E.asPromise)(()=>this._commands.executeCommand(y.command,...y.arguments||[],d)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var i;const d=[...this._resourceStates].sort(g),k=(0,D.sortedDiff)(this._resourceSnapshot,d,g).map(R=>{const F=R.toInsert.map(B=>{const Q=this._resourceHandlePool++;this._resourceStatesMap.set(Q,B);const J=B.resourceUri,z=f(B.decorations),ae=B.decorations&&f(B.decorations.light)||z,L=B.decorations&&f(B.decorations.dark)||z,N=[];let H;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const ve=new P.DisposableStore;H=this._commands.converter.toInternal(B.command,ve),this._resourceStatesDisposablesMap.set(Q,ve)}else this._resourceStatesCommandsMap.set(Q,B.command);ae&&N.push(ae),L&&L.toString()!==(ae==null?void 0:ae.toString())&&N.push(L);const O=B.decorations&&B.decorations.tooltip||"",K=B.decorations&&!!B.decorations.strikeThrough,le=B.decorations&&!!B.decorations.faded,ue=B.contextValue||"";return{rawResource:[Q,J,N,O,K,le,ue,H],handle:Q}});return{start:R.start,deleteCount:R.deleteCount,toInsert:F}}),m=k.map(({start:R,deleteCount:F,toInsert:B})=>[R,F,B.map(Q=>Q.rawResource)]),w=k.reverse();for(const{start:R,deleteCount:F,toInsert:B}of w){const Q=B.map(z=>z.handle),J=this._handlesSnapshot.splice(R,F,...Q);for(const z of J)this._resourceStatesMap.delete(z),this._resourceStatesCommandsMap.delete(z),(i=this._resourceStatesDisposablesMap.get(z))===null||i===void 0||i.dispose(),this._resourceStatesDisposablesMap.delete(z)}return this._resourceSnapshot=d,m}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class r{constructor(i,d,y,k,m,w){this._proxy=d,this._commands=y,this._id=k,this._label=m,this._rootUri=w,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new S.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new a(i,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,k,m,w)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(i){this._count!==i&&(this._count=i,this._proxy.$updateSourceControl(this.handle,{count:i}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(i){this._quickDiffProvider=i,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!i})}get commitTemplate(){return this._commitTemplate}set commitTemplate(i){i!==this._commitTemplate&&(this._commitTemplate=i,this._proxy.$updateSourceControl(this.handle,{commitTemplate:i}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(i){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=i;const d=this._commands.converter.toInternal(i,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:d})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(i){if(!(this._statusBarCommands&&i&&u(this._statusBarCommands,i))){this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=i;const d=(i||[]).map(y=>this._commands.converter.toInternal(y,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:d})}}get selected(){return this._selected}createResourceGroup(i,d){const y=new t(this._proxy,this._commands,this.handle,i,d),k=S.Event.once(y.onDidDispose)(()=>this.createdResourceGroups.delete(y));return this.createdResourceGroups.set(y,k),this.eventuallyAddResourceGroups(),y}eventuallyAddResourceGroups(){const i=[],d=[];for(const[y,k]of this.createdResourceGroups){k.dispose();const m=y.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(y),this.eventuallyUpdateResourceStates()});S.Event.once(y.onDidDispose)(()=>{this.updatedResourceGroups.delete(y),m.dispose(),this._groups.delete(y.handle),this._proxy.$unregisterGroup(this.handle,y.handle)}),i.push([y.handle,y.id,y.label,y.features]);const w=y._takeResourceStateSnapshot();w.length>0&&d.push([y.handle,w]),this._groups.set(y.handle,y)}this._proxy.$registerGroups(this.handle,i,d),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const i=[];this.updatedResourceGroups.forEach(d=>{const y=d._takeResourceStateSnapshot();y.length!==0&&i.push([d.handle,y])}),i.length>0&&this._proxy.$spliceResourceStates(this.handle,i),this.updatedResourceGroups.clear()}getResourceGroup(i){return this._groups.get(i)}setSelectionState(i){this._selected=i,this._onDidChangeSelection.fire(i)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(i=>i.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,Ve([(0,T.debounce)(100)],r.prototype,"eventuallyAddResourceGroups",null),Ve([(0,T.debounce)(100)],r.prototype,"eventuallyUpdateResourceStates",null);let o=class Dn{constructor(i,d,y){this._commands=d,this.logService=y,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new S.Emitter,this._proxy=i.getProxy(C.MainContext.MainThreadSCM),this._telemetry=i.getProxy(C.MainContext.MainThreadTelemetry),d.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===3){const m=this._sourceControls.get(k.sourceControlHandle);if(!m)return k;const w=m.getResourceGroup(k.groupHandle);return w?w.getResourceState(k.handle):k}else if(k&&k.$mid===4){const m=this._sourceControls.get(k.sourceControlHandle);return m?m.getResourceGroup(k.groupHandle):k}else if(k&&k.$mid===5){const m=this._sourceControls.get(k.handle);return m||k}return k}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(i,d,y,k){this.logService.trace("ExtHostSCM#createSourceControl",i.identifier.value,d,y,k),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:i.identifier.value});const m=Dn._handlePool++,w=new r(i,this._proxy,this._commands,d,y,k);this._sourceControls.set(m,w);const R=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(i.identifier))||[];return R.push(w),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(i.identifier),R),w}getLastInputBox(i){this.logService.trace("ExtHostSCM#getLastInputBox",i.identifier.value);const d=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(i.identifier)),y=d&&d[d.length-1];return y&&y.inputBox}$provideOriginalResource(i,d,y){const k=_.URI.revive(d);this.logService.trace("ExtHostSCM#$provideOriginalResource",i,k.toString());const m=this._sourceControls.get(i);return!m||!m.quickDiffProvider||!m.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,E.asPromise)(()=>m.quickDiffProvider.provideOriginalResource(k,y)).then(w=>w||null)}$onInputBoxValueChange(i,d){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",i);const y=this._sourceControls.get(i);return y&&y.inputBox.$onInputBoxValueChange(d),Promise.resolve(void 0)}$executeResourceCommand(i,d,y,k){this.logService.trace("ExtHostSCM#$executeResourceCommand",i,d,y);const m=this._sourceControls.get(i);if(!m)return Promise.resolve(void 0);const w=m.getResourceGroup(d);return w?w.$executeResourceCommand(y,k):Promise.resolve(void 0)}$validateInput(i,d,y){this.logService.trace("ExtHostSCM#$validateInput",i);const k=this._sourceControls.get(i);return!k||!k.inputBox.validateInput?Promise.resolve(void 0):(0,E.asPromise)(()=>k.inputBox.validateInput(d,y)).then(m=>m?Promise.resolve([m.message,m.type]):Promise.resolve(void 0))}$setSelectedSourceControl(i){var d,y;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",i),i!==void 0&&((d=this._sourceControls.get(i))===null||d===void 0||d.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((y=this._sourceControls.get(this._selectedSourceControlHandle))===null||y===void 0||y.setSelectionState(!1)),this._selectedSourceControlHandle=i,Promise.resolve(void 0)}};o._handlePool=0,o=Ve([qe(2,A.ILogService)],o),e.ExtHostSCM=o});var tt=this&&this.__classPrivateFieldSet||function(re,e,_){if(!e.has(re))throw new TypeError("attempted to set private field on non-instance");return e.set(re,_),_},We=this&&this.__classPrivateFieldGet||function(re,e){if(!e.has(re))throw new TypeError("attempted to get private field on non-instance");return e.get(re)};define(we[200],Ee([0,1,7,5,131,6]),function(re,e,_,S,T,P){"use strict";var E,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(p,f,s,h,v=_.StatusBarAlignment.Left,g,b){E.set(this,void 0),C.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,tt(this,E,p),tt(this,C,f),this._id=D.ID_GEN++,this._statusId=s,this._statusName=h,this._alignment=v,this._priority=g,this._accessibilityInformation=b}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var p;return(p=this._command)===null||p===void 0?void 0:p.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(p){this._text=p,this.update()}set tooltip(p){this._tooltip=p,this.update()}set color(p){this._color=p,this.update()}set backgroundColor(p){p&&!D.ALLOWED_BACKGROUND_COLORS.has(p.id)&&(p=void 0),this._backgroundColor=p,this.update()}set command(p){var f;((f=this._command)===null||f===void 0?void 0:f.fromApi)!==p&&(this._internalCommandRegistration.clear(),typeof p=="string"?this._command={fromApi:p,internal:We(this,C).toInternal({title:"",command:p},this._internalCommandRegistration)}:p?this._command={fromApi:p,internal:We(this,C).toInternal(p,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(p){this._accessibilityInformation=p,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,We(this,E).$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var p;this._timeoutHandle=void 0;let f=this._color;this._backgroundColor&&(f=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),We(this,E).$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(p=this._command)===null||p===void 0?void 0:p.internal,f,this._backgroundColor,this._alignment===_.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,E=new WeakMap,C=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new _.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(p){this._messages=[],this._item=p.createStatusBarEntry("status.extensionMessage",(0,T.localize)(0,null),_.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(p){const f={message:p};return this._messages.unshift(f),this._update(),new _.Disposable(()=>{const s=this._messages.indexOf(f);s>=0&&(this._messages.splice(s,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class A{constructor(p,f){this._proxy=p.getProxy(S.MainContext.MainThreadStatusBar),this._commands=f,this._statusMessage=new n(this)}createStatusBarEntry(p,f,s,h,v){return new D(this._proxy,this._commands,p,f,s,h,v)}setStatusBarMessage(p,f){const s=this._statusMessage.setMessage(p);let h;return typeof f=="number"?h=setTimeout(()=>s.dispose(),f):typeof f!="undefined"&&f.then(()=>s.dispose(),()=>s.dispose()),new _.Disposable(()=>{s.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=A}),define(we[75],Ee([0,1,5,3,4]),function(re,e,_,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(C){this._onDidChangeStorage=new S.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(_.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,D){this._proxy.$registerExtensionStorageKeysToSync(C,D)}getValue(C,D,n){return this._proxy.$getValue(C,D).then(A=>A||n)}setValue(C,D,n){return this._proxy.$setValue(C,D,n)}$acceptValue(C,D,n){this._onDidChangeStorage.fire({shared:C,key:D,value:n})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,T.createDecorator)("IExtHostStorage")}),define(we[76],Ee([0,1,4,27,19,74,2]),function(re,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,_.createDecorator)("IExtensionStoragePaths");let C=class{constructor(n,A,I){var p;this._logService=A,this._extHostFileSystem=I,this._workspace=(p=n.workspace)!==null&&p!==void 0?p:void 0,this._environment=n.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(f=>this._value=f)}async _getOrCreateWorkspaceStoragePath(){var n;if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,I=E.URI.joinPath(this._environment.workspaceStorageHome,A);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch(p){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(E.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(n=E.URI.revive(this._workspace.configuration))===null||n===void 0?void 0:n.toString(),name:this._workspace.name},void 0,2))),I}catch(p){this._logService.error("[ExtHostStorage]",p);return}}workspaceValue(n){if(this._value)return E.URI.joinPath(this._value,n.identifier.value)}globalValue(n){return E.URI.joinPath(this._environment.globalStorageHome,n.identifier.value.toLowerCase())}};C=Ve([qe(0,S.IExtHostInitDataService),qe(1,T.ILogService),qe(2,P.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(we[42],Ee([0,1,3,5,4,2,13,6,7,132,11,167,20,29,151]),function(re,e,_,S,T,P,E,C,D,n,A,I,p,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,T.createDecorator)("IExtHostTerminalService");class h{constructor(t,r,o,l){this._proxy=t,this._id=r,this._creationOptions=o,this._name=l,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(d=>this._pidPromiseComplete=d);const i=this;this.value={get name(){return i._name||""},get processId(){return i._pidPromise},get creationOptions(){return i._creationOptions},get exitStatus(){return i._exitStatus},sendText(d,y=!0){i._checkDisposed(),i._proxy.$sendText(i._id,d,y)},show(d){i._checkDisposed(),i._proxy.$show(i._id,d)},hide(){i._checkDisposed(),i._proxy.$hide(i._id)},dispose(){i._disposed||(i._disposed=!0,i._proxy.$dispose(i._id))},get dimensions(){if(!(i._cols===void 0||i._rows===void 0))return{columns:i._cols,rows:i._rows}}}}async create(t,r,o,l,i,d,y,k,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:r,cwd:o,env:l,waitOnExit:i,strictEnv:d,hideFromUser:y,isFeatureTerminal:k,isExtensionOwnedTerminal:m})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,r){return t===this._cols&&r===this._rows||t===0||r===0?!1:(this._cols=t,this._rows=r,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(r=>{r!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=h;class v{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new _.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new _.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new _.Emitter,this._onProcessTitleChanged=new _.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new _.Emitter,this._onProcessShellTypeChanged=new _.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,r){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:r})}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(r=>this._onProcessData.fire(r)),this._pty.onDidClose&&this._pty.onDidClose((r=void 0)=>{this._onProcessExit.fire(r===void 0?void 0:r)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r&&{cols:r.columns,rows:r.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=v;let g=1,b=class extends C.Disposable{constructor(t,r){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new _.Emitter,this._onDidOpenTerminal=new _.Emitter,this._onDidChangeActiveTerminal=new _.Emitter,this._onDidChangeTerminalDimensions=new _.Emitter,this._proxy=r.getProxy(S.MainContext.MainThreadTerminalService),this._bufferer=new s.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new _.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[o,l]of this._terminalProcesses)l.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const r=new h(this._proxy,(0,f.generateUuid)(),t,t.name),o=new v(t.pty);return r.createExtensionTerminal().then(l=>{const i=this._setupExtHostProcessListeners(l,o);this._terminalProcessDisposables[l]=i}),this._terminals.push(r),r.value}attachPtyToTerminal(t,r){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const l=new v(r),i=this._setupExtHostProcessListeners(t,l);this._terminalProcessDisposables[t]=i}async $acceptActiveTerminalChanged(t){const r=this._activeTerminal;if(t===null){this._activeTerminal=void 0,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const o=this._getTerminalById(t);o&&(this._activeTerminal=o,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,r){const o=this._getTerminalById(t);o&&this._onDidWriteTerminalData.fire({terminal:o.value,data:r})}async $acceptTerminalDimensions(t,r,o){const l=this._getTerminalById(t);l&&l.setDimensions(r,o)&&this._onDidChangeTerminalDimensions.fire({terminal:l.value,dimensions:l.value.dimensions})}async $acceptTerminalMaximumDimensions(t,r,o){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.resize(r,o)}async $acceptTerminalTitleChange(t,r){const o=this._getTerminalById(t);o&&(o.name=r)}async $acceptTerminalClosed(t,r){const o=this._getTerminalObjectIndexById(this._terminals,t);if(o!==null){const l=this._terminals.splice(o,1)[0];l.setExitCode(r),this._onDidCloseTerminal.fire(l.value)}}$acceptTerminalOpened(t,r,o,l){if(r){const y=this._getTerminalObjectIndexById(this._terminals,r);if(y!==null){this._terminals[y]._id=t,this._onDidOpenTerminal.fire(this.terminals[y]),this._terminals[y].isOpen=!0;return}}const i={name:l.name,shellPath:l.executable,shellArgs:l.args,cwd:typeof l.cwd=="string"?l.cwd:P.URI.revive(l.cwd),env:l.env,hideFromUser:l.hideFromUser},d=new h(this._proxy,t,i,o);this._terminals.push(d),this._onDidOpenTerminal.fire(d.value),d.isOpen=!0}async $acceptTerminalProcessId(t,r){const o=this._getTerminalById(t);o&&o._setProcessId(r)}async $startExtensionTerminal(t,r){const o=this._getTerminalById(t);if(!o)return{message:(0,n.localize)(0,null,t)};o.isOpen||await new Promise(i=>{const d=this.onDidOpenTerminal(async y=>{y===o.value&&(d.dispose(),i())})});const l=this._terminalProcesses.get(t);l?l.startSendingEvents(r):this._extensionTerminalAwaitingStart[t]={initialDimensions:r}}_setupExtHostProcessListeners(t,r){const o=new C.DisposableStore;o.add(r.onProcessReady(i=>this._proxy.$sendProcessReady(t,i.pid,i.cwd))),o.add(r.onProcessTitleChanged(i=>this._proxy.$sendProcessTitle(t,i))),this._bufferer.startBuffering(t,r.onProcessData),o.add(r.onProcessExit(i=>this._onProcessExit(t,i))),r.onProcessOverrideDimensions&&o.add(r.onProcessOverrideDimensions(i=>this._proxy.$sendOverrideDimensions(t,i))),this._terminalProcesses.set(t,r);const l=this._extensionTerminalAwaitingStart[t];return l&&r instanceof v&&(r.startSendingEvents(l.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),o}$acceptProcessAckDataEvent(t,r){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.acknowledgeDataEvent(r)}$acceptProcessInput(t,r){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.input(r)}$acceptProcessResize(t,r,o){var l;try{(l=this._terminalProcesses.get(t))===null||l===void 0||l.resize(r,o)}catch(i){if(i.code!=="EPIPE"&&i.code!=="ERR_IPC_CHANNEL_CLOSED")throw i}}$acceptProcessShutdown(t,r){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.shutdown(r)}$acceptProcessRequestInitialCwd(t){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.getInitialCwd().then(o=>this._proxy.$sendProcessInitialCwd(t,o))}$acceptProcessRequestCwd(t){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.getCwd().then(o=>this._proxy.$sendProcessCwd(t,o))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,r){const o=this._getTerminalById(t);if(!o)return[];this._terminalLinkCache.delete(t);const l=this._terminalLinkCancellationSource.get(t);l&&l.dispose(!0);const i=new p.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,i);const d=[],y={terminal:o.value,line:r},k=[];for(const R of this._linkProviders)k.push(new Promise(async F=>{i.token.onCancellationRequested(()=>F({provider:R,links:[]}));const B=await R.provideTerminalLinks(y,i.token)||[];i.token.isCancellationRequested||F({provider:R,links:B})}));const m=await Promise.all(k);if(i.token.isCancellationRequested)return[];const w=new Map;for(const R of m)R&&R.links.length>0&&d.push(...R.links.map(F=>{const B={id:g++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return w.set(B.id,{provider:R.provider,link:F}),B}));return this._terminalLinkCache.set(t,w),d}$activateLink(t,r){var o;const l=(o=this._terminalLinkCache.get(t))===null||o===void 0?void 0:o.get(r);!l||l.provider.handleTerminalLink(l.link)}_onProcessExit(t,r){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const o=this._terminalProcessDisposables[t];o&&(o.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,r)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,r){const o=this._getTerminalObjectIndexById(t,r);return o!==null?t[o]:null}_getTerminalObjectIndexById(t,r){let o=null;return t.some((l,i)=>l._id===r?(o=i,!0):!1),o}getEnvironmentVariableCollection(t){let r=this._environmentVariableCollections.get(t.identifier.value);return r||(r=new c,this._setEnvironmentVariableCollection(t.identifier.value,r)),r}_syncEnvironmentVariableCollection(t,r){const o=(0,I.serializeEnvironmentVariableCollection)(r.map);this._proxy.$setEnvironmentVariableCollection(t,r.persistent,o.length===0?void 0:o)}$initEnvironmentVariableCollections(t){t.forEach(r=>{const o=r[0],l=new c(r[1]);this._setEnvironmentVariableCollection(o,l)})}_setEnvironmentVariableCollection(t,r){this._environmentVariableCollections.set(t,r),r.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,r)})}};b=Ve([qe(1,E.IExtHostRpcService)],b),e.BaseExtHostTerminalService=b;class c{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new _.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,r){this._setIfDiffers(t,{value:r,type:D.EnvironmentVariableMutatorType.Replace})}append(t,r){this._setIfDiffers(t,{value:r,type:D.EnvironmentVariableMutatorType.Append})}prepend(t,r){this._setIfDiffers(t,{value:r,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,r){const o=this.map.get(t);(!o||o.value!==r.value||o.type!==r.type)&&(this.map.set(t,r),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,r){this.map.forEach((o,l)=>t.call(r,l,o,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=c;let u=class extends b{constructor(t){super(!1,t)}createTerminal(t,r,o){throw new A.NotSupportedError}createTerminalFromOptions(t){throw new A.NotSupportedError}getDefaultShell(t,r){return""}getDefaultShellArgs(t,r){throw new A.NotSupportedError}$getAvailableShells(){throw new A.NotSupportedError}async $getDefaultShellAndArgs(t){throw new A.NotSupportedError}$acceptWorkspacePermissionsChanged(t){}};u=Ve([qe(0,E.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u}),define(we[201],Ee([0,1,3,14,5,95,9,7]),function(re,e,_,S,T,P,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(A,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new _.Emitter,this._onDidChangeTextEditorOptions=new _.Emitter,this._onDidChangeTextEditorVisibleRanges=new _.Emitter,this._onDidChangeTextEditorViewColumn=new _.Emitter,this._onDidChangeActiveTextEditor=new _.Emitter,this._onDidChangeVisibleTextEditors=new _.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=A.getProxy(T.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(p=>this._onDidChangeVisibleTextEditors.fire(p)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(p=>this._onDidChangeActiveTextEditor.fire(p))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(A){const I=this._extHostDocumentsAndEditors.allEditors();return A?I:I.map(p=>p.value)}async showTextDocument(A,I,p){let f;typeof I=="number"?f={position:E.ViewColumn.from(I),preserveFocus:p}:typeof I=="object"?f={position:E.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?E.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:f={preserveFocus:!1};const s=await this._proxy.$tryShowTextDocument(A.uri,f),h=s&&this._extHostDocumentsAndEditors.getEditor(s);if(h)return h.value;throw s?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A){return new P.TextEditorDecorationType(this._proxy,A).value}$acceptEditorPropertiesChanged(A,I){const p=this._extHostDocumentsAndEditors.getEditor(A);if(!p)throw new Error("unknown text editor");if(I.options&&p._acceptOptions(I.options),I.selections){const f=I.selections.selections.map(E.Selection.to);p._acceptSelections(f)}if(I.visibleRanges){const f=S.coalesce(I.visibleRanges.map(E.Range.to));p._acceptVisibleRanges(f)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:p.value,options:Object.assign(Object.assign({},I.options),{lineNumbers:E.TextEditorLineNumbersStyle.to(I.options.lineNumbers)})}),I.selections){const f=C.TextEditorSelectionChangeKind.fromValue(I.selections.source),s=I.selections.selections.map(E.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:p.value,selections:s,kind:f})}if(I.visibleRanges){const f=S.coalesce(I.visibleRanges.map(E.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:p.value,visibleRanges:f})}}$acceptEditorPositionData(A){for(const I in A){const p=this._extHostDocumentsAndEditors.getEditor(I);if(!p)throw new Error("Unknown text editor");const f=E.ViewColumn.to(A[I]);p.value.viewColumn!==f&&(p._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:p.value,viewColumn:f}))}}getDiffInformation(A){return Promise.resolve(this._proxy.$getDiffInformation(A))}}e.ExtHostEditors=D});var cn=this&&this.__rest||function(re,e){var _={};for(var S in re)Object.prototype.hasOwnProperty.call(re,S)&&e.indexOf(S)<0&&(_[S]=re[S]);if(re!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,S=Object.getOwnPropertySymbols(re);T<S.length;T++)e.indexOf(S[T])<0&&Object.prototype.propertyIsEnumerable.call(re,S[T])&&(_[S[T]]=re[S[T]]);return _};define(we[202],Ee([0,1,2,4,5,6,7]),function(re,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,S.createDecorator)("IExtHostTimeline");class C{constructor(A,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=A.getProxy(T.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:p=>{var f,s;if(p&&p.$mid===11){const h=p.uri===void 0?void 0:_.URI.revive(p.uri);return(s=(f=this._itemsBySourceAndUriMap.get(p.source))===null||f===void 0?void 0:f.get(D(h)))===null||s===void 0?void 0:s.get(p.handle)}return p}})}async $getTimeline(A,I,p,f,s){const h=this._providers.get(A);return h==null?void 0:h.provideTimeline(_.URI.revive(I),p,f,s)}registerTimelineProvider(A,I,p,f){const s=new P.DisposableStore,h=this.convertTimelineItem(I.id,f,s).bind(this);let v;I.onDidChange&&(v=I.onDidChange(b=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},b),{id:I.id})),this));const g=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},I),{scheme:A,onDidChange:void 0,async provideTimeline(b,c,u,a){var t;(a==null?void 0:a.resetCache)&&(s.clear(),(t=g.get(I.id))===null||t===void 0||t.clear());const r=await I.provideTimeline(b,c,u);if(r!=null){const o=h(b,a);return Object.assign(Object.assign({},r),{source:I.id,items:r.items.map(o)})}},dispose(){var b;for(const c of g.values())(b=c.get(I.id))===null||b===void 0||b.clear();v==null||v.dispose(),s.dispose()}}))}convertTimelineItem(A,I,p){return(f,s)=>{let h;if(s==null?void 0:s.cacheResults){let v=this._itemsBySourceAndUriMap.get(A);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(A,v));const g=D(f);h=v.get(g),h===void 0&&(h=new Map,v.set(g,h))}return v=>{var g,b;const{iconPath:c}=v,u=cn(v,["iconPath"]),a=`${A}|${(g=v.id)!==null&&g!==void 0?g:v.timestamp}`;h==null||h.set(a,v);let t,r,o;return v.iconPath&&(c instanceof E.ThemeIcon?o={id:c.id}:_.URI.isUri(c)?(t=c,r=c):{light:t,dark:r}=c),Object.assign(Object.assign({},u),{id:(b=u.id)!==null&&b!==void 0?b:void 0,handle:a,source:A,command:v.command?I.toInternal(v.command,p):void 0,icon:t,iconDark:r,themeIcon:o,accessibilityInformation:v.accessibilityInformation})}}}registerTimelineProviderCore(A){if(this._providers.get(A.id))throw new Error(`Timeline Provider ${A.id} already exists.`);return this._proxy.$registerTimelineProvider({id:A.id,label:A.label,scheme:A.scheme}),this._providers.set(A.id,A),(0,P.toDisposable)(()=>{var p;for(const f of this._itemsBySourceAndUriMap.values())(p=f.get(A.id))===null||p===void 0||p.clear();this._providers.delete(A.id),this._proxy.$unregisterTimelineProvider(A.id),A.dispose()})}}e.ExtHostTimeline=C;function D(n){return n==null?void 0:n.toString()}}),define(we[203],Ee([0,1,6,16,2,5]),function(re,e,_,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class E{constructor(D){this._openers=new Map,this._proxy=D.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,n,A,I){if(this._openers.has(n))throw new Error(`Opener with id '${n}' already registered`);const p=I.schemes.find(f=>!E.supportedSchemes.has(f));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this._openers.set(n,A),this._proxy.$registerUriOpener(n,I.schemes,D,I.label),(0,_.toDisposable)(()=>{this._openers.delete(n),this._proxy.$unregisterUriOpener(n)})}async $canOpenUri(D,n,A){const I=this._openers.get(D);if(!I)throw new Error(`Unknown opener with id: ${D}`);const p=T.URI.revive(n);return I.canOpenExternalUri(p,A)}async $openUri(D,n,A){const I=this._openers.get(D);if(!I)throw new Error(`Unknown opener id: '${D}'`);return I.openExternalUri(T.URI.revive(n.resolvedUri),{sourceUri:T.URI.revive(n.sourceUri)},A)}}e.ExtHostUriOpeners=E,E.supportedSchemes=new Set([S.Schemas.http,S.Schemas.https])}),define(we[204],Ee([0,1,5,2,6,11,25]),function(re,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(n){this.handles=new Set,this.handlers=new Map,this._proxy=n.getProxy(_.MainContext.MainThreadUrls)}registerUriHandler(n,A){if(this.handles.has(E.ExtensionIdentifier.toKey(n)))throw new Error(`Protocol handler already registered for extension ${n}`);const I=C.HandlePool++;return this.handles.add(E.ExtensionIdentifier.toKey(n)),this.handlers.set(I,A),this._proxy.$registerUriHandler(I,n),(0,T.toDisposable)(()=>{this.handles.delete(E.ExtensionIdentifier.toKey(n)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(n,A){const I=this.handlers.get(n);if(!I)return Promise.resolve(void 0);try{I.handleUri(S.URI.revive(A))}catch(p){(0,P.onUnexpectedError)(p)}return Promise.resolve(void 0)}async createAppUri(n){return S.URI.revive(await this._proxy.$createAppUri(n))}}e.ExtHostUrls=C,C.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(re,e,_){if(!e.has(re))throw new TypeError("attempted to set private field on non-instance");return e.set(re,_),_},We=this&&this.__classPrivateFieldGet||function(re,e){if(!e.has(re))throw new TypeError("attempted to get private field on non-instance");return e.get(re)};define(we[50],Ee([0,1,3,2,70,5]),function(re,e,_,S,T,P){"use strict";var E,C,D,n,A,I,p,f,s,h,v;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.ExtHostWebview=void 0;class g{constructor(o,l,i,d,y,k,m){E.set(this,void 0),C.set(this,void 0),D.set(this,void 0),n.set(this,void 0),A.set(this,void 0),I.set(this,void 0),p.set(this,""),f.set(this,void 0),s.set(this,!1),h.set(this,!1),this._onMessageEmitter=new _.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,v.set(this,new _.Emitter),this._onDidDispose=We(this,v).event,tt(this,E,o),tt(this,C,l),tt(this,f,i),tt(this,n,d),tt(this,A,y),tt(this,I,k),tt(this,D,m)}dispose(){tt(this,s,!0),We(this,v).fire(),We(this,v).dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return tt(this,h,!0),(0,T.asWebviewUri)(We(this,n),We(this,E),o)}get cspSource(){return We(this,n).webviewCspSource.replace("{{uuid}}",We(this,E))}get html(){return this.assertNotDisposed(),We(this,p)}set html(o){this.assertNotDisposed(),We(this,p)!==o&&(tt(this,p,o),!We(this,h)&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(tt(this,h,!0),We(this,D).report("Webview vscode-resource: uris",We(this,I),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),We(this,C).$setHtml(We(this,E),o))}get options(){return this.assertNotDisposed(),We(this,f)}set options(o){this.assertNotDisposed(),We(this,C).$setOptions(We(this,E),u(We(this,I),We(this,A),o)),tt(this,f,o)}async postMessage(o){return We(this,s)?!1:We(this,C).$postMessage(We(this,E),o)}assertNotDisposed(){if(We(this,s))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,E=new WeakMap,C=new WeakMap,D=new WeakMap,n=new WeakMap,A=new WeakMap,I=new WeakMap,p=new WeakMap,f=new WeakMap,s=new WeakMap,h=new WeakMap,v=new WeakMap;class b{constructor(o,l,i,d,y){this.initData=l,this.workspace=i,this._logService=d,this._deprecationService=y,this._webviews=new Map,this._webviewProxy=o.getProxy(P.MainContext.MainThreadWebviews)}$onMessage(o,l){const i=this.getWebview(o);i&&i._onMessageEmitter.fire(l)}$onMissingCsp(o,l){this._logService.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,l,i){const d=new g(o,this._webviewProxy,a(l),this.initData,this.workspace,i,this._deprecationService);return this._webviews.set(o,d),d._onDidDispose(()=>{this._webviews.delete(o)}),d}deleteWebview(o){this._webviews.delete(o)}getWebview(o){return this._webviews.get(o)}}e.ExtHostWebviews=b;function c(r){return{id:r.identifier,location:r.extensionLocation}}e.toExtensionData=c;function u(r,o,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||t(r,o)}}e.serializeWebviewOptions=u;function a(r){var o;return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,portMapping:r.portMapping,localResourceRoots:(o=r.localResourceRoots)===null||o===void 0?void 0:o.map(l=>S.URI.from(l))}}e.reviveOptions=a;function t(r,o){return[...((o==null?void 0:o.getWorkspaceFolders())||[]).map(l=>l.uri),r.extensionLocation]}}),define(we[205],Ee([0,1,20,56,6,16,23,2,9,50,92,5,7]),function(re,e,_,S,T,P,E,C,D,n,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new A.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=u(this.document.uri)+this._backupCounter++;return(0,E.joinPath)(this._storagePath,t)}updateBackup(t){var r;(r=this._backup)===null||r===void 0||r.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class s{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,o){const l=this.key(t,r.uri);if(this._documents.has(l))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const i=new f(r,o);return this._documents.set(l,i),i}delete(t,r){const o=this.key(t,r.uri);this._documents.delete(o)}key(t,r){return`${t}@@@${r}`}}var h;(function(a){a[a.Text=0]="Text",a[a.Custom=1]="Custom"})(h||(h={}));class v{constructor(){this._providers=new Map}addTextProvider(t,r,o){return this.add(0,t,r,o)}addCustomProvider(t,r,o){return this.add(1,t,r,o)}get(t){return this._providers.get(t)}add(t,r,o,l){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:o,provider:l}),new p.Disposable(()=>this._providers.delete(r))}}class g{constructor(t,r,o,l,i){this._extHostDocuments=r,this._extensionStoragePaths=o,this._extHostWebview=l,this._extHostWebviewPanels=i,this._editorProviders=new v,this._documents=new s,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,o,l){const i=new T.DisposableStore;return b(o)?(i.add(this._editorProviders.addTextProvider(r,t,o)),this._proxy.$registerTextEditorProvider((0,n.toExtensionData)(t),r,l.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor})):(i.add(this._editorProviders.addCustomProvider(r,t,o)),this.supportEditing(o)&&i.add(o.onDidChangeCustomDocument(d=>{const y=this.getCustomDocumentEntry(r,d.document.uri);if(c(d)){const k=y.addEdit(d);this._proxy.$onDidEdit(d.document.uri,r,k,d.label)}else this._proxy.$onContentChange(d.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,n.toExtensionData)(t),r,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument)),p.Disposable.from(i,new p.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,o,l){var i;const d=this._editorProviders.get(r);if(!d)throw new Error(`No provider found for '${r}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${r}'`);const y=C.URI.revive(t),k=await d.provider.openCustomDocument(y,{backupId:o},l);let m;return this.supportEditing(d.provider)&&this._extensionStoragePaths&&(m=(i=this._extensionStoragePaths.workspaceValue(d.extension))!==null&&i!==void 0?i:this._extensionStoragePaths.globalValue(d.extension)),this._documents.add(r,k,m),{editable:this.supportEditing(d.provider)}}async $disposeCustomDocument(t,r){const o=this._editorProviders.get(r);if(!o)throw new Error(`No provider found for '${r}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${r}'`);const l=C.URI.revive(t),{document:i}=this.getCustomDocumentEntry(r,l);this._documents.delete(r,i),i.dispose()}async $resolveWebviewEditor(t,r,o,l,i,d){const y=this._editorProviders.get(o);if(!y)throw new Error(`No provider found for '${o}'`);const k=D.ViewColumn.to(i),m=this._extHostWebview.createNewWebview(r,l.webviewOptions,y.extension),w=this._extHostWebviewPanels.createNewWebviewPanel(r,o,l.title,k,l.panelOptions,m),R=C.URI.revive(t);switch(y.type){case 1:{const{document:F}=this.getCustomDocumentEntry(o,R);return y.provider.resolveCustomEditor(F,w,d)}case 0:{const F=this._extHostDocuments.getDocument(R);return y.provider.resolveCustomTextEditor(F,w,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,o){this.getCustomDocumentEntry(r,t).disposeEdits(o)}async $onMoveCustomEditor(t,r,o){const l=this._editorProviders.get(o);if(!l)throw new Error(`No provider found for '${o}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const i=this._extHostWebviewPanels.getWebviewPanel(t);if(!i)throw new Error("No webview found");const d=C.URI.revive(r),y=this._extHostDocuments.getDocument(d);await l.provider.moveCustomTextEditor(y,i,_.CancellationToken.None)}async $undo(t,r,o,l){return this.getCustomDocumentEntry(r,t).undo(o,l)}async $redo(t,r,o,l){return this.getCustomDocumentEntry(r,t).redo(o,l)}async $revert(t,r,o){const l=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(l.document,o),l.disposeBackup()}async $onSave(t,r,o){const l=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(l.document,o),l.disposeBackup()}async $onSaveAs(t,r,o,l){const i=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(i.document,C.URI.revive(o),l)}async $backup(t,r,o){const l=this.getCustomDocumentEntry(r,t),d=await this.getCustomEditorProvider(r).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},o);return l.updateBackup(d),d.id}getCustomDocumentEntry(t,r){const o=this._documents.get(t,C.URI.revive(r));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(t){const r=this._editorProviders.get(t),o=r==null?void 0:r.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=g;function b(a){return typeof a.resolveCustomTextEditor=="function"}function c(a){return typeof a.undo=="function"&&typeof a.redo=="function"}function u(a){const t=a.scheme===P.Schemas.file||a.scheme===P.Schemas.untitled?a.fsPath:a.toString();return(0,S.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(re,e,_){if(!e.has(re))throw new TypeError("attempted to set private field on non-instance");return e.set(re,_),_},We=this&&this.__classPrivateFieldGet||function(re,e){if(!e.has(re))throw new TypeError("attempted to get private field on non-instance");return e.get(re)};define(we[206],Ee([0,1,3,6,2,29,9,50,5,7]),function(re,e,_,S,T,P,E,C,D,n){"use strict";var A,I,p,f,s,h,v,g,b,c,u,a,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends S.Disposable{constructor(d,y,k,m,w,R,F){super();A.set(this,void 0),I.set(this,void 0),p.set(this,void 0),f.set(this,void 0),s.set(this,void 0),h.set(this,void 0),v.set(this,void 0),g.set(this,void 0),b.set(this,!0),c.set(this,!0),u.set(this,!1),a.set(this,this._register(new _.Emitter)),this.onDidDispose=We(this,a).event,t.set(this,this._register(new _.Emitter)),this.onDidChangeViewState=We(this,t).event,tt(this,A,d),tt(this,I,y),tt(this,p,k),tt(this,s,R),tt(this,g,w),tt(this,h,m),tt(this,f,F)}dispose(){We(this,u)||(tt(this,u,!0),We(this,a).fire(),We(this,I).$disposeWebview(We(this,A)),We(this,f).dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),We(this,f)}get viewType(){return this.assertNotDisposed(),We(this,p)}get title(){return this.assertNotDisposed(),We(this,h)}set title(d){this.assertNotDisposed(),We(this,h)!==d&&(tt(this,h,d),We(this,I).$setTitle(We(this,A),d))}get iconPath(){return this.assertNotDisposed(),We(this,v)}set iconPath(d){this.assertNotDisposed(),We(this,v)!==d&&(tt(this,v,d),We(this,I).$setIconPath(We(this,A),T.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return We(this,s)}get viewColumn(){if(this.assertNotDisposed(),!(typeof We(this,g)=="number"&&We(this,g)<0))return We(this,g)}get active(){return this.assertNotDisposed(),We(this,c)}get visible(){return this.assertNotDisposed(),We(this,b)}_updateViewState(d){We(this,u)||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(tt(this,c,d.active),tt(this,b,d.visible),tt(this,g,d.viewColumn),We(this,t).fire({webviewPanel:this}))}reveal(d,y){this.assertNotDisposed(),We(this,I).$reveal(We(this,A),{viewColumn:d?E.ViewColumn.from(d):void 0,preserveFocus:!!y})}assertNotDisposed(){if(We(this,u))throw new Error("Webview is disposed")}}A=new WeakMap,I=new WeakMap,p=new WeakMap,f=new WeakMap,s=new WeakMap,h=new WeakMap,v=new WeakMap,g=new WeakMap,b=new WeakMap,c=new WeakMap,u=new WeakMap,a=new WeakMap,t=new WeakMap;class o{constructor(d,y,k){this.webviews=y,this.workspace=k,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=d.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,P.generateUuid)()}createWebviewPanel(d,y,k,m,w={}){const R=typeof m=="object"?m.viewColumn:m,F={viewColumn:E.ViewColumn.from(R),preserveFocus:typeof m=="object"&&!!m.preserveFocus},B=o.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(d),B,y,{title:k,panelOptions:l(w),webviewOptions:(0,C.serializeWebviewOptions)(d,this.workspace,w)},F);const Q=this.webviews.createNewWebview(B,w,d);return this.createNewWebviewPanel(B,y,k,R,w,Q)}$onDidChangeWebviewPanelViewStates(d){const y=Object.keys(d);y.sort((k,m)=>{const w=d[k],R=d[m];return w.active?1:R.active?-1:+w.visible-+R.visible});for(const k of y){const m=this.getWebviewPanel(k);if(!!m){const w=d[k];m._updateViewState({active:w.active,visible:w.visible,viewColumn:E.ViewColumn.to(w.position)})}}}async $onDidDisposeWebviewPanel(d){const y=this.getWebviewPanel(d);y==null||y.dispose(),this._webviewPanels.delete(d),this.webviews.deleteWebview(d)}registerWebviewPanelSerializer(d,y,k){if(this._serializers.has(y))throw new Error(`Serializer for '${y}' already registered`);return this._serializers.set(y,{serializer:k,extension:d}),this._proxy.$registerSerializer(y),new n.Disposable(()=>{this._serializers.delete(y),this._proxy.$unregisterSerializer(y)})}async $deserializeWebviewPanel(d,y,k,m){const w=this._serializers.get(y);if(!w)throw new Error(`No serializer found for '${y}'`);const{serializer:R,extension:F}=w,B=this.webviews.createNewWebview(d,k.webviewOptions,F),Q=this.createNewWebviewPanel(d,y,k.title,m,k.panelOptions,B);await R.deserializeWebviewPanel(Q,k.state)}createNewWebviewPanel(d,y,k,m,w,R){const F=new r(d,this._proxy,y,k,m,w,R);return this._webviewPanels.set(d,F),F}getWebviewPanel(d){return this._webviewPanels.get(d)}}e.ExtHostWebviewPanels=o;function l(i){return{enableFindWidget:i.enableFindWidget,retainContextWhenHidden:i.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(re,e,_){if(!e.has(re))throw new TypeError("attempted to set private field on non-instance");return e.set(re,_),_},We=this&&this.__classPrivateFieldGet||function(re,e){if(!e.has(re))throw new TypeError("attempted to get private field on non-instance");return e.get(re)};define(we[207],Ee([0,1,3,6,50,5,7]),function(re,e,_,S,T,P,E){"use strict";var C,D,n,A,I,p,f,s,h,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class g extends S.Disposable{constructor(u,a,t,r,o,l){super();C.set(this,void 0),D.set(this,void 0),n.set(this,void 0),A.set(this,void 0),I.set(this,!1),p.set(this,void 0),f.set(this,void 0),s.set(this,void 0),h.set(this,this._register(new _.Emitter)),this.onDidChangeVisibility=We(this,h).event,v.set(this,this._register(new _.Emitter)),this.onDidDispose=We(this,v).event,tt(this,n,t),tt(this,f,r),tt(this,C,u),tt(this,D,a),tt(this,A,o),tt(this,p,l)}dispose(){We(this,I)||(tt(this,I,!0),We(this,v).fire(),We(this,A).dispose(),super.dispose())}get title(){return this.assertNotDisposed(),We(this,f)}set title(u){this.assertNotDisposed(),We(this,f)!==u&&(tt(this,f,u),We(this,D).$setWebviewViewTitle(We(this,C),u))}get description(){return this.assertNotDisposed(),We(this,s)}set description(u){this.assertNotDisposed(),We(this,s)!==u&&(tt(this,s,u),We(this,D).$setWebviewViewDescription(We(this,C),u))}get visible(){return We(this,p)}get webview(){return We(this,A)}get viewType(){return We(this,n)}_setVisible(u){u===We(this,p)||We(this,I)||(tt(this,p,u),We(this,h).fire())}show(u){this.assertNotDisposed(),We(this,D).$show(We(this,C),!!u)}assertNotDisposed(){if(We(this,I))throw new Error("Webview is disposed")}}C=new WeakMap,D=new WeakMap,n=new WeakMap,A=new WeakMap,I=new WeakMap,p=new WeakMap,f=new WeakMap,s=new WeakMap,h=new WeakMap,v=new WeakMap;class b{constructor(u,a){this._extHostWebview=a,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=u.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(u,a,t,r){if(this._viewProviders.has(a))throw new Error(`View provider for '${a}' already registered`);return this._viewProviders.set(a,{provider:t,extension:u}),this._proxy.$registerWebviewViewProvider((0,T.toExtensionData)(u),a,r),new E.Disposable(()=>{this._viewProviders.delete(a),this._proxy.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(u,a,t,r,o){const l=this._viewProviders.get(a);if(!l)throw new Error(`No view provider found for '${a}'`);const{provider:i,extension:d}=l,y=this._extHostWebview.createNewWebview(u,{},d),k=new g(u,this._proxy,a,t,y,!0);this._webviewViews.set(u,k),await i.resolveWebviewView(k,{state:r},o)}async $onDidChangeWebviewViewVisibility(u,a){this.getWebviewView(u)._setVisible(a)}async $disposeWebviewView(u){const a=this.getWebviewView(u);this._webviewViews.delete(u),a.dispose(),this._extHostWebview.deleteWebview(u)}getWebviewView(u){const a=this._webviewViews.get(u);if(!a)throw new Error("No webview found");return a}}e.ExtHostWebviewViews=b}),define(we[99],Ee([0,1,3,5,2,16,8,4,13]),function(re,e,_,S,T,P,E,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let n=class Cn{constructor(I){this._onDidChangeWindowState=new _.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Cn.InitialState,this._proxy=I.getProxy(S.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(p=>this.$onDidChangeWindowFocus(p))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:I}),this._onDidChangeWindowState.fire(this._state))}openUri(I,p){let f;if(typeof I=="string"){f=I;try{I=T.URI.parse(I)}catch(s){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,E.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,f,p)}async asExternalUri(I,p){if((0,E.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([P.Schemas.http,P.Schemas.https]).has(I.scheme))return Promise.reject(`Invalid scheme '${I.scheme}'`);const f=await this._proxy.$asExternalUri(I,p);return T.URI.from(f)}};n.InitialState={focused:!0},n=Ve([qe(0,D.IExtHostRpcService)],n),e.ExtHostWindow=n,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(we[208],Ee([0,1,19,5,27,13]),function(re,e,_,S,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let E=class extends _.AbstractLogger{constructor(D,n){super();this._proxy=D.getProxy(S.MainContext.MainThreadLog),this._logFile=n.logFile.toJSON(),this.setLevel(n.logLevel)}$setLevel(D){this.setLevel(D)}trace(D,...n){this.getLevel()<=_.LogLevel.Trace&&this._proxy.$log(this._logFile,_.LogLevel.Trace,Array.from(arguments))}debug(D,...n){this.getLevel()<=_.LogLevel.Debug&&this._proxy.$log(this._logFile,_.LogLevel.Debug,Array.from(arguments))}info(D,...n){this.getLevel()<=_.LogLevel.Info&&this._proxy.$log(this._logFile,_.LogLevel.Info,Array.from(arguments))}warn(D,...n){this.getLevel()<=_.LogLevel.Warning&&this._proxy.$log(this._logFile,_.LogLevel.Warning,Array.from(arguments))}error(D,...n){this.getLevel()<=_.LogLevel.Error&&this._proxy.$log(this._logFile,_.LogLevel.Error,Array.from(arguments))}critical(D,...n){this.getLevel()<=_.LogLevel.Critical&&this._proxy.$log(this._logFile,_.LogLevel.Critical,Array.from(arguments))}flush(){}};E=Ve([qe(0,P.IExtHostRpcService),qe(1,T.IExtHostInitDataService)],E),e.ExtHostLogService=E}),define(we[209],Ee([0,1,15,20,11,3,6,110,182,96,26]),function(re,e,_,S,T,P,E,C,D,n,A){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function p(l,i){try{return JSON.stringify(l,i)}catch(d){return"null"}}function f(l,i){return JSON.stringify(l,i)}function s(l){return l?(i,d)=>d&&d.$mid===1?l.transformOutgoing(d):d:null}var h;(function(l){l[l.LocalSide=0]="LocalSide",l[l.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(l){l[l.Responsive=0]="Responsive",l[l.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const g=()=>{},b=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class u extends E.Disposable{constructor(i,d=null,y=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new P.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=i,this._logger=d,this._uriTransformer=y,this._uriReplacer=s(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let k=0,m=n.ProxyIdentifier.count;k<m;k++)this._locals[k]=null,this._proxies[k]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new _.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(k=>this._receiveOneMessage(k))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(i=>{this._pendingRPCReplies[i].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(i){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(i){this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(i){this._responsiveState!==i&&(this._responsiveState=i,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(i){return this._uriTransformer?(0,C.transformIncomingURIs)(i,this._uriTransformer):i}getProxy(i){const{nid:d,sid:y}=i;return this._proxies[d]||(this._proxies[d]=this._createProxy(d,y)),this._proxies[d]}_createProxy(i,d){let y={get:(k,m)=>(typeof m=="string"&&!k[m]&&m.charCodeAt(0)===36&&(k[m]=(...w)=>this._remoteCall(i,m,w)),m===c?d:k[m])};return new Proxy(Object.create(null),y)}set(i,d){return this._locals[i.nid]=d,d}assertRegistered(i){for(let d=0,y=i.length;d<y;d++){const k=i[d];if(!this._locals[k.nid])throw new Error(`Missing actor ${k.sid} (isMain: ${k.isMain})`)}}_receiveOneMessage(i){if(!this._isDisposed){const d=i.byteLength,y=a.read(i,0),k=y.readUInt8(),m=y.readUInt32();switch(k){case 1:case 2:{let{rpcId:w,method:R,args:F}=t.deserializeRequestJSONArgs(y);this._uriTransformer&&(F=(0,C.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(d,m,w,R,F,k===2);break}case 3:case 4:{let{rpcId:w,method:R,args:F}=t.deserializeRequestMixedArgs(y);this._uriTransformer&&(F=(0,C.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(d,m,w,R,F,k===4);break}case 5:{this._logger&&this._logger.logIncoming(d,m,0,"ack"),this._onDidReceiveAcknowledge(m);break}case 6:{this._receiveCancel(d,m);break}case 7:{this._receiveReply(d,m,void 0);break}case 9:{let w=t.deserializeReplyOKJSON(y);this._uriTransformer&&(w=(0,C.transformIncomingURIs)(w,this._uriTransformer)),this._receiveReply(d,m,w);break}case 8:{let w=t.deserializeReplyOKVSBuffer(y);this._receiveReply(d,m,w);break}case 10:{let w=t.deserializeReplyErrError(y);this._uriTransformer&&(w=(0,C.transformIncomingURIs)(w,this._uriTransformer)),this._receiveReplyErr(d,m,w);break}case 11:{this._receiveReplyErr(d,m,void 0);break}default:console.error("received unexpected message"),console.error(i)}}}_receiveRequest(i,d,y,k,m,w){this._logger&&this._logger.logIncoming(i,d,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(y)}.${k}(`,m);const R=String(d);let F,B;if(w){const J=new S.CancellationTokenSource;m.push(J.token),F=this._invokeHandler(y,k,m),B=()=>J.cancel()}else F=this._invokeHandler(y,k,m),B=g;this._cancelInvokedHandlers[R]=B;const Q=t.serializeAcknowledged(d);this._logger&&this._logger.logOutgoing(Q.byteLength,d,1,"ack"),this._protocol.send(Q),F.then(J=>{delete this._cancelInvokedHandlers[R];const z=t.serializeReplyOK(d,J,this._uriReplacer);this._logger&&this._logger.logOutgoing(z.byteLength,d,1,"reply:",J),this._protocol.send(z)},J=>{delete this._cancelInvokedHandlers[R];const z=t.serializeReplyErr(d,J);this._logger&&this._logger.logOutgoing(z.byteLength,d,1,"replyErr:",J),this._protocol.send(z)})}_receiveCancel(i,d){this._logger&&this._logger.logIncoming(i,d,1,"receiveCancel");const y=String(d);this._cancelInvokedHandlers[y]&&this._cancelInvokedHandlers[y]()}_receiveReply(i,d,y){this._logger&&this._logger.logIncoming(i,d,0,"receiveReply:",y);const k=String(d);if(!!this._pendingRPCReplies.hasOwnProperty(k)){const m=this._pendingRPCReplies[k];delete this._pendingRPCReplies[k],m.resolveOk(y)}}_receiveReplyErr(i,d,y){this._logger&&this._logger.logIncoming(i,d,0,"receiveReplyErr:",y);const k=String(d);if(!!this._pendingRPCReplies.hasOwnProperty(k)){const m=this._pendingRPCReplies[k];delete this._pendingRPCReplies[k];let w;y&&(y.$isError?(w=new Error,w.name=y.name,w.message=y.message,w.stack=y.stack):w=y),m.resolveErr(w)}}_invokeHandler(i,d,y){try{return Promise.resolve(this._doInvokeHandler(i,d,y))}catch(k){return Promise.reject(k)}}_doInvokeHandler(i,d,y){const k=this._locals[i];if(!k)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(i));let m=k[d];if(typeof m!="function")throw new Error("Unknown method "+d+" on actor "+(0,n.getStringIdentifierForProxy)(i));return m.apply(k,y)}_remoteCall(i,d,y){if(this._isDisposed)return Promise.reject(T.canceled());let k=null;if(y.length>0&&S.CancellationToken.isCancellationToken(y[y.length-1])&&(k=y.pop()),k&&k.isCancellationRequested)return Promise.reject(T.canceled());const m=t.serializeRequestArguments(y,this._uriReplacer),w=++this._lastMessageId,R=String(w),F=new D.LazyPromise;k&&k.onCancellationRequested(()=>{const Q=t.serializeCancel(w);this._logger&&this._logger.logOutgoing(Q.byteLength,w,0,"cancel"),this._protocol.send(t.serializeCancel(w))}),this._pendingRPCReplies[R]=F,this._onWillSendRequest(w);const B=t.serializeRequest(w,i,d,m,!!k);return this._logger&&this._logger.logOutgoing(B.byteLength,w,0,`request: ${(0,n.getStringIdentifierForProxy)(i)}.${d}(`,y),this._protocol.send(B),F}}e.RPCProtocol=u,I=b,u.UNRESPONSIVE_TIME=3*1e3;class a{constructor(i,d){this._buff=i,this._offset=d}static alloc(i,d,y){let k=new a(A.VSBuffer.alloc(y+1+4),0);return k.writeUInt8(i),k.writeUInt32(d),k}static read(i,d){return new a(i,d)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(i){this._buff.writeUInt8(i,this._offset),this._offset+=1}readUInt8(){const i=this._buff.readUInt8(this._offset);return this._offset+=1,i}writeUInt32(i){this._buff.writeUInt32BE(i,this._offset),this._offset+=4}readUInt32(){const i=this._buff.readUInt32BE(this._offset);return this._offset+=4,i}static sizeShortString(i){return 1+i.byteLength}writeShortString(i){this._buff.writeUInt8(i.byteLength,this._offset),this._offset+=1,this._buff.set(i,this._offset),this._offset+=i.byteLength}readShortString(){const i=this._buff.readUInt8(this._offset);this._offset+=1;const y=this._buff.slice(this._offset,this._offset+i).toString();return this._offset+=i,y}static sizeLongString(i){return 4+i.byteLength}writeLongString(i){this._buff.writeUInt32BE(i.byteLength,this._offset),this._offset+=4,this._buff.set(i,this._offset),this._offset+=i.byteLength}readLongString(){const i=this._buff.readUInt32BE(this._offset);this._offset+=4;const y=this._buff.slice(this._offset,this._offset+i).toString();return this._offset+=i,y}writeBuffer(i){this._buff.writeUInt32BE(i.byteLength,this._offset),this._offset+=4,this._buff.set(i,this._offset),this._offset+=i.byteLength}static sizeVSBuffer(i){return 4+i.byteLength}writeVSBuffer(i){this._buff.writeUInt32BE(i.byteLength,this._offset),this._offset+=4,this._buff.set(i,this._offset),this._offset+=i.byteLength}readVSBuffer(){const i=this._buff.readUInt32BE(this._offset);this._offset+=4;const d=this._buff.slice(this._offset,this._offset+i);return this._offset+=i,d}static sizeMixedArray(i,d){let y=0;y+=1;for(let k=0,m=i.length;k<m;k++){const w=i[k],R=d[k];switch(y+=1,R){case 1:y+=this.sizeLongString(w);break;case 2:y+=this.sizeVSBuffer(w);break;case 3:break}}return y}writeMixedArray(i,d){this._buff.writeUInt8(i.length,this._offset),this._offset+=1;for(let y=0,k=i.length;y<k;y++){const m=i[y];switch(d[y]){case 1:this.writeUInt8(1),this.writeLongString(m);break;case 2:this.writeUInt8(2),this.writeVSBuffer(m);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const i=this._buff.readUInt8(this._offset);this._offset+=1;let d=new Array(i);for(let y=0;y<i;y++)switch(this.readUInt8()){case 1:d[y]=this.readLongString();break;case 2:d[y]=this.readVSBuffer();break;case 3:d[y]=void 0;break}return d}}class t{static _arrayContainsBufferOrUndefined(i){for(let d=0,y=i.length;d<y;d++)if(i[d]instanceof A.VSBuffer||typeof i[d]=="undefined")return!0;return!1}static serializeRequestArguments(i,d){if(this._arrayContainsBufferOrUndefined(i)){let y=[],k=[];for(let m=0,w=i.length;m<w;m++){const R=i[m];R instanceof A.VSBuffer?(y[m]=R,k[m]=2):typeof R=="undefined"?(y[m]=A.VSBuffer.alloc(0),k[m]=3):(y[m]=A.VSBuffer.fromString(f(R,d)),k[m]=1)}return{type:"mixed",args:y,argsType:k}}return{type:"simple",args:f(i,d)}}static serializeRequest(i,d,y,k,m){return k.type==="mixed"?this._requestMixedArgs(i,d,y,k.args,k.argsType,m):this._requestJSONArgs(i,d,y,k.args,m)}static _requestJSONArgs(i,d,y,k,m){const w=A.VSBuffer.fromString(y),R=A.VSBuffer.fromString(k);let F=0;F+=a.sizeUInt8(),F+=a.sizeShortString(w),F+=a.sizeLongString(R);let B=a.alloc(m?2:1,i,F);return B.writeUInt8(d),B.writeShortString(w),B.writeLongString(R),B.buffer}static deserializeRequestJSONArgs(i){const d=i.readUInt8(),y=i.readShortString(),k=i.readLongString();return{rpcId:d,method:y,args:JSON.parse(k)}}static _requestMixedArgs(i,d,y,k,m,w){const R=A.VSBuffer.fromString(y);let F=0;F+=a.sizeUInt8(),F+=a.sizeShortString(R),F+=a.sizeMixedArray(k,m);let B=a.alloc(w?4:3,i,F);return B.writeUInt8(d),B.writeShortString(R),B.writeMixedArray(k,m),B.buffer}static deserializeRequestMixedArgs(i){const d=i.readUInt8(),y=i.readShortString(),k=i.readMixedArray(),m=new Array(k.length);for(let w=0,R=k.length;w<R;w++){const F=k[w];typeof F=="string"?m[w]=JSON.parse(F):m[w]=F}return{rpcId:d,method:y,args:m}}static serializeAcknowledged(i){return a.alloc(5,i,0).buffer}static serializeCancel(i){return a.alloc(6,i,0).buffer}static serializeReplyOK(i,d,y){return typeof d=="undefined"?this._serializeReplyOKEmpty(i):d instanceof A.VSBuffer?this._serializeReplyOKVSBuffer(i,d):this._serializeReplyOKJSON(i,p(d,y))}static _serializeReplyOKEmpty(i){return a.alloc(7,i,0).buffer}static _serializeReplyOKVSBuffer(i,d){let y=0;y+=a.sizeVSBuffer(d);let k=a.alloc(8,i,y);return k.writeVSBuffer(d),k.buffer}static deserializeReplyOKVSBuffer(i){return i.readVSBuffer()}static _serializeReplyOKJSON(i,d){const y=A.VSBuffer.fromString(d);let k=0;k+=a.sizeLongString(y);let m=a.alloc(9,i,k);return m.writeLongString(y),m.buffer}static deserializeReplyOKJSON(i){const d=i.readLongString();return JSON.parse(d)}static serializeReplyErr(i,d){return d?this._serializeReplyErrEror(i,d):this._serializeReplyErrEmpty(i)}static _serializeReplyErrEror(i,d){const y=A.VSBuffer.fromString(p(T.transformErrorForSerialization(d),null));let k=0;k+=a.sizeLongString(y);let m=a.alloc(10,i,k);return m.writeLongString(y),m.buffer}static deserializeReplyErrError(i){const d=i.readLongString();return JSON.parse(d)}static _serializeReplyErrEmpty(i){return a.alloc(11,i,0).buffer}}var r;(function(l){l[l.RequestJSONArgs=1]="RequestJSONArgs",l[l.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",l[l.RequestMixedArgs=3]="RequestMixedArgs",l[l.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",l[l.Acknowledged=5]="Acknowledged",l[l.Cancel=6]="Cancel",l[l.ReplyOKEmpty=7]="ReplyOKEmpty",l[l.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",l[l.ReplyOKJSON=9]="ReplyOKJSON",l[l.ReplyErrError=10]="ReplyErrError",l[l.ReplyErrEmpty=11]="ReplyErrEmpty"})(r||(r={}));var o;(function(l){l[l.String=1]="String",l[l.VSBuffer=2]="VSBuffer",l[l.Undefined=3]="Undefined"})(o||(o={}))}),define(we[210],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const _=function(P){const E=C=>{self.removeEventListener("message",E);const D=C.data;Object.defineProperties(self,{postMessage:{value(n,A){D.postMessage(n,A)}},onmessage:{get(){return D.onmessage},set(n){D.onmessage=n}}}),D.addEventListener("message",n=>{self.dispatchEvent(new MessageEvent("message",{data:n.data}))}),D.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(P)};self.addEventListener("message",E)}.toString();class S extends EventTarget{constructor(P,E,C){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${_})('${E}'))`,n=new Blob([D],{type:"application/javascript"}),A=URL.createObjectURL(n),I=new MessageChannel,p=A,f={type:"_newWorker",id:p,port:I.port2,url:A,options:C};P(f,[I.port2]),this.postMessage=I.port1.postMessage.bind(I.port1),this.terminate=()=>{const s={type:"_terminateWorker",id:p};I.port1.postMessage(s),URL.revokeObjectURL(A),I.port1.close(),I.port2.close()},Object.defineProperties(this,{onmessage:{get(){return I.port1.onmessage},set(s){I.port1.onmessage=s}},onmessageerror:{get(){return I.port1.onmessageerror},set(s){I.port1.onmessageerror=s}}}),I.port1.addEventListener("messageerror",s=>{const h=new MessageEvent("messageerror",{data:s.data});this.dispatchEvent(h)}),I.port1.addEventListener("message",s=>{const h=new MessageEvent("message",{data:s.data});this.dispatchEvent(h)}),I.port1.start()}}e.NestedWorker=S}),define(we[211],Ee([0,1,4]),function(re,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,_.createDecorator)("remoteAgentService")}),define(we[212],Ee([0,1,16,10,21,2,4,211]),function(re,e,_,S,T,P,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,E.createDecorator)("pathService");let D=class{constructor(A,I){this.localUserHome=A,this.remoteAgentService=I,this.resolveOS=(async()=>{const p=await this.remoteAgentService.getEnvironment();return(p==null?void 0:p.os)||T.OS})(),this.resolveUserHome=(async()=>{const p=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(p==null?void 0:p.userHome)||A})()}async userHome(A){return(A==null?void 0:A.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(A=>A===1?S.win32:S.posix)}async fileURI(A){let I="";if(await this.resolveOS===1&&(A=A.replace(/\\/g,"/")),A[0]==="/"&&A[1]==="/"){const f=A.indexOf("/",2);f===-1?(I=A.substring(2),A="/"):(I=A.substring(2,f),A=A.substring(f)||"/")}return P.URI.from({scheme:_.Schemas.file,authority:I,path:A,query:"",fragment:""})}};D=Ve([qe(1,C.IRemoteAgentService)],D),e.AbstractPathService=D}),define(we[43],Ee([0,1,14,28,24,38,8,4,10,11]),function(re,e,_,S,T,P,E,C,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const A="\u27EA ",I=" characters skipped \u27EB",p=(A.length+I.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var f;(function(L){L[L.file=0]="file",L[L.text=1]="text"})(f=e.SearchProviderType||(e.SearchProviderType={}));var s;(function(L){L[L.File=1]="File",L[L.Text=2]="Text"})(s=e.QueryType||(e.QueryType={}));function h(L){return!!L.preview}e.resultIsMatch=h;function v(L){return!!L.resource}e.isFileMatch=v;function g(L){return!!L.message}e.isProgressMessage=g;var b;(function(L){L[L.Normal=0]="Normal",L[L.NewSearchStarted=1]="NewSearchStarted"})(b=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class c{constructor(N){this.resource=N,this.results=[]}}e.FileMatch=c;class u{constructor(N,H,O){this.ranges=H;const K=Array.isArray(H)?H:[H];if(O&&O.matchLines===1&&a(K)){N=(0,E.getNLines)(N,O.matchLines);let le="",ue=0,pe=0;const ve=Math.floor(O.charsPerLine/5),Re=[];for(const He of K){const Fe=Math.max(He.startColumn-ve,0),ze=He.startColumn+O.charsPerLine;if(Fe>pe+ve+p){const $=A+(Fe-pe)+I;le+=$+N.slice(Fe,ze),ue+=Fe-(pe+$.length)}else le+=N.slice(pe,ze);Re.push(new r(0,He.startColumn-ue,He.endColumn-ue)),pe=ze}this.preview={text:le,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const le=Array.isArray(H)?H[0].startLineNumber:H.startLineNumber;this.preview={text:N,matches:(0,_.mapArrayOrNot)(H,ue=>new t(ue.startLineNumber-le,ue.startColumn,ue.endLineNumber-le,ue.endColumn))}}}}e.TextSearchMatch=u;function a(L){const N=L[0].startLineNumber;for(const H of L)if(H.startLineNumber!==N||H.endLineNumber!==N)return!1;return!0}class t{constructor(N,H,O,K){this.startLineNumber=N,this.startColumn=H,this.endLineNumber=O,this.endColumn=K}}e.SearchRange=t;class r extends t{constructor(N,H,O){super(N,H,N,O)}}e.OneLineRange=r;var o;(function(L){L.Default="default",L.FileNames="fileNames",L.Type="type",L.Modified="modified",L.CountDescending="countDescending",L.CountAscending="countAscending"})(o=e.SearchSortOrder||(e.SearchSortOrder={}));function l(L,N=!0){const H=L&&L.files&&L.files.exclude,O=N&&L&&L.search&&L.search.exclude;if(!(!H&&!O)){if(!H||!O)return H||O;let K=Object.create(null);return K=T.mixin(K,T.deepClone(H)),K=T.mixin(K,T.deepClone(O),!0),K}}e.getExcludes=l;function i(L,N){return L.excludePattern&&S.match(L.excludePattern,N)?!1:L.includePattern||L.usingSearchPaths?L.includePattern&&S.match(L.includePattern,N)?!0:L.usingSearchPaths?!!L.folderQueries&&L.folderQueries.some(H=>{const O=H.folder.fsPath;if(P.isEqualOrParent(N,O)){const K=D.relative(O,N);return!H.includePattern||!!S.match(H.includePattern,K)}else return!1}):!1:!0}e.pathIncludedInQuery=i;var d;(function(L){L[L.unknownEncoding=1]="unknownEncoding",L[L.regexParseError=2]="regexParseError",L[L.globParseError=3]="globParseError",L[L.invalidLiteral=4]="invalidLiteral",L[L.rgProcessError=5]="rgProcessError",L[L.other=6]="other",L[L.canceled=7]="canceled"})(d=e.SearchErrorCode||(e.SearchErrorCode={}));class y extends Error{constructor(N,H){super(N);this.code=H}}e.SearchError=y;function k(L){const N=L.message;if((0,n.isPromiseCanceledError)(L))return new y(N,d.canceled);try{const H=JSON.parse(N);return new y(H.message,H.code)}catch(H){return new y(N,d.other)}}e.deserializeSearchError=k;function m(L){const N={message:L.message,code:L.code};return new Error(JSON.stringify(N))}e.serializeSearchError=m;function w(L){return L.type==="error"?!0:L.type==="success"}e.isSerializedSearchComplete=w;function R(L){return L.type==="success"}e.isSerializedSearchSuccess=R;function F(L){return!!L.path}e.isSerializedFileMatch=F;function B(L,N){const H=L.searchPath?L.searchPath:L.relativePath;return(0,E.fuzzyContains)(H,N)}e.isFilePatternMatch=B;class Q{constructor(N){this.path=N,this.results=[]}addMatch(N){this.results.push(N)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=Q;function J(L,N){const H=Object.assign(Object.assign({},L||{}),N||{});return Object.keys(H).filter(O=>{const K=H[O];return typeof K=="boolean"&&K})}e.resolvePatternsForProvider=J;class z{constructor(N,H){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},N.excludePattern||{}),H.excludePattern||{}),this._parsedExcludeExpression=S.parse(this._excludeExpression);let O=N.includePattern;H.includePattern&&(O?O=Object.assign(Object.assign({},O),H.includePattern):O=H.includePattern),O&&(this._parsedIncludeExpression=S.parse(O))}includedInQuerySync(N,H,O){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(N,H,O)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(N,H,O))}includedInQuery(N,H,O){return Promise.resolve(this._parsedExcludeExpression(N,H,O)).then(le=>!!le).then(le=>le?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(N,H,O)).then(ue=>!!ue):Promise.resolve(!0)).then(le=>le)}hasSiblingExcludeClauses(){return ae(this._excludeExpression)}}e.QueryGlobTester=z;function ae(L){for(const N in L)if(typeof L[N]!="boolean")return!0;return!1}}),define(we[31],Ee([0,1,14,15,20,3,22,16,78,23,8,12,2,134,4,19,148,48,49,27,13,7,43,5]),function(re,e,_,S,T,P,E,C,D,n,A,I,p,f,s,h,v,g,b,c,u,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(R,F,B){return new n.ExtUri(Q=>y(Q,B)).isEqual(R,F)}function l(R,F,B){return o(R.uri,F.uri,B)?0:(0,A.compare)(R.uri.toString(),F.uri.toString())}function i(R,F,B){return R.index!==F.index?R.index<F.index?-1:1:o(R.uri,F.uri,B)?(0,A.compare)(R.name,F.name):(0,A.compare)(R.uri.toString(),F.uri.toString())}function d(R,F,B,Q){const J=R.slice(0).sort((ae,L)=>B(ae,L,Q)),z=F.slice(0).sort((ae,L)=>B(ae,L,Q));return(0,_.delta)(J,z,(ae,L)=>B(ae,L,Q))}function y(R,F){const B=F.getCapabilities(R.scheme);return!(B&&B&1024)}class k extends g.Workspace{constructor(F,B,Q,J,z,ae){super(F,Q.map(L=>new g.WorkspaceFolder(L)),J,ae);this._name=B,this._isUntitled=z,this._workspaceFolders=[],this._structure=E.TernarySearchTree.forUris(ae),Q.forEach(L=>{this._workspaceFolders.push(L),this._structure.set(L.uri,L)})}static toExtHostWorkspace(F,B,Q,J){if(!F)return{workspace:null,added:[],removed:[]};const{id:z,name:ae,folders:L,configuration:N,isUntitled:H}=F,O=[],K=B;B?L.forEach((ve,Re)=>{const He=p.URI.revive(ve.uri),Fe=k._findFolder(Q||B,He,J);Fe?(Fe.name=ve.name,Fe.index=ve.index,O.push(Fe)):O.push({uri:He,name:ve.name,index:Re})}):O.push(...L.map(({uri:ve,name:Re,index:He})=>({uri:p.URI.revive(ve),name:Re,index:He}))),O.sort((ve,Re)=>ve.index<Re.index?-1:1);const le=new k(z,ae,O,N?p.URI.revive(N):null,!!H,ve=>y(ve,J)),{added:ue,removed:pe}=d(K?K.workspaceFolders:[],le.workspaceFolders,l,J);return{workspace:le,added:ue,removed:pe}}static _findFolder(F,B,Q){for(let J=0;J<F.folders.length;J++){const z=F.workspaceFolders[J];if(o(z.uri,B,Q))return z}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,B){return B&&this._structure.get(F)&&(F=(0,n.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let m=class{constructor(F,B,Q,J){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidChangeWorkspaceTrustState=new P.Emitter,this.onDidChangeWorkspaceTrustState=this._onDidChangeWorkspaceTrustState.event,this._activeSearchCallbacks=[],this._workspaceTrustState=a.WorkspaceTrustState.Unknown,this._logService=J,this._extHostFileSystemInfo=Q,this._requestIdProvider=new D.Counter,this._barrier=new S.Barrier,this._proxy=F.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(r.MainContext.MainThreadMessageService);const z=B.workspace;this._confirmedWorkspace=z?new k(z.id,z.name,[],z.configuration?p.URI.revive(z.configuration):null,!!z.isUntitled,ae=>y(ae,Q)):void 0}$initializeWorkspace(F,B){this._workspaceTrustState=B,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?p.URI.from({scheme:C.Schemas.untitled,path:(0,n.basename)((0,n.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,B,Q,...J){const z=[];if(Array.isArray(J)&&J.forEach(O=>{p.URI.isUri(O.uri)&&!z.some(K=>o(K.uri,O.uri,this._extHostFileSystemInfo))&&z.push({uri:O.uri,name:O.name||(0,n.basenameOrAuthority)(O.uri)})}),this._unconfirmedWorkspace||[B,Q].some(O=>typeof O!="number"||O<0)||Q===0&&z.length===0)return!1;const ae=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+Q>ae.length)return!1;const L=ae.slice(0);L.splice(B,Q,...z.map(O=>({uri:O.uri,name:O.name||(0,n.basenameOrAuthority)(O.uri),index:void 0})));for(let O=0;O<L.length;O++){const K=L[O];if(L.some((le,ue)=>ue!==O&&o(K.uri,le.uri,this._extHostFileSystemInfo)))return!1}L.forEach((O,K)=>O.index=K);const{added:N,removed:H}=d(ae,L,i,this._extHostFileSystemInfo);if(N.length===0&&H.length===0)return!1;if(this._proxy){const O=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(O,B,Q,z).then(void 0,K=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(v.Severity.Error,(0,f.localize)(0,null,O,K.toString()),{extension:F},[])})}return this.trySetWorkspaceFolders(L),!0}getWorkspaceFolder(F,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,B)}async getWorkspaceFolder2(F,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,B)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!!this._actualWorkspace){const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}}getRelativePath(F,B){let Q,J="";if(typeof F=="string"?(Q=p.URI.file(F),J=F):typeof F!="undefined"&&(Q=F,J=F.fsPath),!Q)return J;const z=this.getWorkspaceFolder(Q,!0);if(!z)return J;typeof B=="undefined"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let ae=(0,n.relativePath)(z.uri,Q);return B&&z.name&&(ae=`${z.name}/${ae}`),ae}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=k.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:B,added:Q,removed:J}=k.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:Q,removed:J}))}findFiles(F,B,Q,J,z=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${J.value}, entryPoint: findFiles`);let ae;if(B===null?ae=!1:B&&(typeof B=="string"?ae=B:ae=B.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:L,folder:N}=w(F);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(L),(0,I.withUndefinedAsNull)(N),(0,I.withUndefinedAsNull)(ae),(0,I.withUndefinedAsNull)(Q),z).then(H=>Array.isArray(H)?H.map(O=>p.URI.revive(O)):[])}async findTextInFiles(F,B,Q,J,z=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${J.value}, entryPoint: findTextInFiles`);const ae=this._requestIdProvider.getNext(),L=typeof B.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:N,folder:H}=w(B.include),O=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,K={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:L,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:N,excludePattern:O},le=!1;if(this._activeSearchCallbacks[ae]=ue=>{if(!le){const pe=p.URI.revive(ue.resource);ue.results.forEach(ve=>{(0,t.resultIsMatch)(ve)?Q({uri:pe,preview:{text:ve.preview.text,matches:(0,_.mapArrayOrNot)(ve.preview.matches,Re=>new a.Range(Re.startLineNumber,Re.startColumn,Re.endLineNumber,Re.endColumn))},ranges:(0,_.mapArrayOrNot)(ve.ranges,Re=>new a.Range(Re.startLineNumber,Re.startColumn,Re.endLineNumber,Re.endColumn))}):Q({uri:pe,text:ve.text,lineNumber:ve.lineNumber})})}},z.isCancellationRequested)return{};try{const ue=await this._proxy.$startTextSearch(F,(0,I.withUndefinedAsNull)(H),K,ae,z);return delete this._activeSearchCallbacks[ae],ue||{}}catch(ue){throw delete this._activeSearchCallbacks[ae],ue}}$handleTextSearchResult(F,B){this._activeSearchCallbacks[B]&&this._activeSearchCallbacks[B](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trustState(){return this._workspaceTrustState}requireWorkspaceTrust(F){return this._proxy.$requireWorkspaceTrust(F)}$onDidChangeWorkspaceTrustState(F){this._workspaceTrustState=F.currentTrustState,this._onDidChangeWorkspaceTrustState.fire(Object.freeze(F))}};m=Ve([qe(0,u.IExtHostRpcService),qe(1,c.IExtHostInitDataService),qe(2,b.IExtHostFileSystemInfo),qe(3,h.ILogService)],m),e.ExtHostWorkspace=m,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function w(R){let F,B;return R&&(typeof R=="string"?F=R:(F=R.pattern,B=R.baseFolder||p.URI.file(R.base))),{includePattern:F,folder:B}}}),define(we[34],Ee([0,1,24,3,31,5,7,150,67,12,15,4,13,19,2]),function(re,e,_,S,T,P,E,C,D,n,A,I,p,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(r,o){if(o){const l=o.split(".");let i=r;for(let d=0;i&&d<l.length;d++)i=i[l[d]];return i}}function v(r){return r instanceof s.URI}function g(r){return r&&r.uri instanceof s.URI&&r.languageId&&typeof r.languageId=="string"}function b(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function c(r){return r&&r.uri instanceof s.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function u(r){if(v(r))return{resource:r};if(g(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(b(r))return{overrideIdentifier:r.languageId};if(c(r))return{resource:r.uri};if(r===null)return{resource:null}}let a=class{constructor(o,l,i){this._proxy=o.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=l,this._logService=i,this._barrier=new A.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new t(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,l){this.getConfigProvider().then(i=>i.$acceptConfigurationChanged(o,l))}};a=Ve([qe(0,p.IExtHostRpcService),qe(1,T.IExtHostWorkspace),qe(2,f.ILogService)],a),e.ExtHostConfiguration=a;class t{constructor(o,l,i,d){this._onDidChangeConfiguration=new S.Emitter,this._proxy=o,this._logService=d,this._extHostWorkspace=l,this._configuration=C.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,l){const i={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(l,i))}getConfiguration(o,l,i){const d=u(l)||{},y=this._toReadonlyValue(o?h(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,d,i==null?void 0:i.identifier);function k(w){if(w==null)return null;if(typeof w=="boolean")return w?1:4;switch(w){case E.ConfigurationTarget.Global:return 1;case E.ConfigurationTarget.Workspace:return 4;case E.ConfigurationTarget.WorkspaceFolder:return 5}}const m={has(w){return typeof h(y,w)!="undefined"},get:(w,R)=>{this._validateConfigurationAccess(o?`${o}.${w}`:w,d,i==null?void 0:i.identifier);let F=h(y,w);if(typeof F=="undefined")F=R;else{let B;const Q=(J,z)=>{let ae;const L=()=>{B=B||(0,_.deepClone)(y),ae=ae||h(B,z)};return(0,n.isObject)(J)?new Proxy(J,{get:(N,H)=>{if(typeof H=="string"&&H.toLowerCase()==="tojson")return L(),()=>ae;if(B)return ae=ae||h(B,z),ae[H];const O=N[H];return typeof H=="string"?Q(O,`${z}.${H}`):O},set:(N,H,O)=>(L(),ae&&(ae[H]=O),!0),deleteProperty:(N,H)=>(L(),ae&&delete ae[H],!0),defineProperty:(N,H,O)=>(L(),ae&&Object.defineProperty(ae,H,O),!0)}):J};F=Q(F,w)}return F},update:(w,R,F,B)=>{w=o?`${o}.${w}`:w;const Q=k(F);return R!==void 0?this._proxy.$updateConfigurationOption(Q,w,R,d,B):this._proxy.$removeConfigurationOption(Q,w,d,B)},inspect:w=>{var R,F,B,Q,J,z,ae,L;w=o?`${o}.${w}`:w;const N=(0,_.deepClone)(this._configuration.inspect(w,d,this._extHostWorkspace.workspace));if(N)return{key:w,defaultValue:(R=N.default)===null||R===void 0?void 0:R.value,globalValue:(F=N.user)===null||F===void 0?void 0:F.value,workspaceValue:(B=N.workspace)===null||B===void 0?void 0:B.value,workspaceFolderValue:(Q=N.workspaceFolder)===null||Q===void 0?void 0:Q.value,defaultLanguageValue:(J=N.default)===null||J===void 0?void 0:J.override,globalLanguageValue:(z=N.user)===null||z===void 0?void 0:z.override,workspaceLanguageValue:(ae=N.workspace)===null||ae===void 0?void 0:ae.override,workspaceFolderLanguageValue:(L=N.workspaceFolder)===null||L===void 0?void 0:L.override,languageIds:N.overrideIdentifiers}}};return typeof y=="object"&&(0,_.mixin)(m,y,!1),Object.freeze(m)}_toReadonlyValue(o){const l=i=>(0,n.isObject)(i)?new Proxy(i,{get:(d,y)=>l(d[y]),set:(d,y,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(y)}' of object`)},deleteProperty:(d,y)=>{throw new Error(`TypeError: Cannot delete read only property '${String(y)}' of object`)},defineProperty:(d,y)=>{throw new Error(`TypeError: Cannot define property '${String(y)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):i;return l(o)}_validateConfigurationAccess(o,l,i){const d=D.OVERRIDE_PROPERTY_PATTERN.test(o)?4:this._configurationScopes.get(o),y=i?`[${i.value}] `:"";if(d===4){typeof(l==null?void 0:l.resource)=="undefined"&&this._logService.warn(`${y}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){(l==null?void 0:l.resource)&&this._logService.warn(`${y}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,l){const i=new C.ConfigurationChangeEvent(o,l,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,y)=>i.affectsConfiguration(d,u(y))})}_toMap(o){return o.reduce((l,i)=>(l.set(i[0],i[1]),l),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(re,e,_){if(!e.has(re))throw new TypeError("attempted to set private field on non-instance");return e.set(re,_),_},We=this&&this.__classPrivateFieldGet||function(re,e){if(!e.has(re))throw new TypeError("attempted to get private field on non-instance");return e.get(re)};define(we[100],Ee([0,1,2,15,3,5,7,31,41,34,20,42,13,27,4,16,21,19,72,166,11]),function(re,e,_,S,T,P,E,C,D,n,A,I,p,f,s,h,v,g,b,c,u){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(J){function z(L){if(L!=null)return L}J.from=z;function ae(L){if(L!=null)return L}J.to=ae})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var r;(function(J){function z(L){if(L!=null)return L}J.from=z;function ae(L){if(L!=null)return L}J.to=ae})(r=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(J){function z(L){if(L!=null)return L}J.from=z;function ae(L){if(L!=null)return L}J.to=ae})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var l;(function(J){function z(N){if(N){const H=N;return H&&!!H.process}else return!1}J.is=z;function ae(N){if(N!=null){const H={process:N.process,args:N.args};return N.options&&(H.options=o.from(N.options)),H}}J.from=ae;function L(N){if(N!=null)return new E.ProcessExecution(N.process,N.args,N.options)}J.to=L})(l=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var i;(function(J){function z(L){if(L!=null)return L}J.from=z;function ae(L){if(L!=null)return L}J.to=ae})(i=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var d;(function(J){function z(N){if(N){const H=N;return H&&(!!H.commandLine||!!H.command)}else return!1}J.is=z;function ae(N){if(N!=null){const H={};return N.commandLine!==void 0?H.commandLine=N.commandLine:(H.command=N.command,H.args=N.args),N.options&&(H.options=i.from(N.options)),H}}J.from=ae;function L(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new E.ShellExecution(N.commandLine,N.options):new E.ShellExecution(N.command,N.args?N.args:[],N.options)}J.to=L})(d=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var y;(function(J){function z(N){if(N){let H=N;return H&&H.customExecution==="customExecution"}else return!1}J.is=z;function ae(N){return{customExecution:"customExecution"}}J.from=ae;function L(N,H){return H.get(N)}J.to=L})(y=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var k;(function(J){function z(ae,L){let N;return ae.scope!==void 0&&typeof ae.scope!="number"?N=ae.scope.uri:ae.scope!==void 0&&typeof ae.scope=="number"&&(ae.scope===E.TaskScope.Workspace&&L&&L.workspaceFile?N=L.workspaceFile:N=c.USER_TASKS_GROUP_KEY),{id:ae._id,workspaceFolder:N}}J.from=z})(k=e.TaskHandleDTO||(e.TaskHandleDTO={}));var m;(function(J){function z(N,H){if(N==null)return[];const O=[];for(let K of N){const le=ae(K,H);le&&O.push(le)}return O}J.fromMany=z;function ae(N,H){if(N!=null){let O;N.execution instanceof E.ProcessExecution?O=l.from(N.execution):N.execution instanceof E.ShellExecution?O=d.from(N.execution):N.execution&&N.execution instanceof E.CustomExecution&&(O=y.from(N.execution));const K=t.from(N.definition);let le;if(N.scope?typeof N.scope=="number"?le=N.scope:le=N.scope.uri:le=E.TaskScope.Workspace,!(!K||!le)){const ue=N.group?N.group.id:void 0;return{_id:N._id,definition:K,name:N.name,source:{extensionId:H.identifier.value,label:N.source,scope:le},execution:O,isBackground:N.isBackground,group:ue,presentationOptions:r.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}}}J.from=ae;async function L(N,H,O){if(N!=null){let K;l.is(N.execution)?K=l.to(N.execution):d.is(N.execution)?K=d.to(N.execution):y.is(N.execution)&&(K=y.to(N._id,O));const le=t.to(N.definition);let ue;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?ue=N.source.scope:ue=await H.resolveWorkspaceFolder(_.URI.revive(N.source.scope)):ue=E.TaskScope.Workspace),!(!le||!ue)){const pe=new E.Task(le,ue,N.name,N.source.label,K,N.problemMatchers);return N.isBackground!==void 0&&(pe.isBackground=N.isBackground),N.group!==void 0&&(pe.group=E.TaskGroup.from(N.group)),N.presentationOptions&&(pe.presentationOptions=r.to(N.presentationOptions)),N._id&&(pe._id=N._id),N.detail&&(pe.detail=N.detail),pe}}}J.to=L})(m=e.TaskDTO||(e.TaskDTO={}));var w;(function(J){function z(L){return L}J.from=z;function ae(L){if(!!L)return Object.assign(Object.create(null),L)}J.to=ae})(w=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(z,ae,L){this._id=ae,this._task=L,a.set(this,void 0),tt(this,a,z)}get task(){return this._task}terminate(){We(this,a).terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}a=new WeakMap;var F;(function(J){function z(ae){return{id:ae._id,task:void 0}}J.from=z})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let B=class{constructor(z,ae,L,N,H,O,K,le){this._onDidExecuteTask=new T.Emitter,this._onDidTerminateTask=new T.Emitter,this._onDidTaskProcessStarted=new T.Emitter,this._onDidTaskProcessEnded=new T.Emitter,this._proxy=z.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=L,this._editorService=N,this._configurationService=H,this._terminalService=O,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=K,this._deprecationService=le,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,ae,L){if(!L)return new E.Disposable(()=>{});const N=this.nextHandle();return this._handlers.set(N,{type:ae,provider:L,extension:z}),this._proxy.$registerTaskProvider(N,ae),new E.Disposable(()=>{this._handlers.delete(N),this._proxy.$unregisterTaskProvider(N)})}registerTaskSystem(z,ae){this._proxy.$registerTaskSystem(z,ae)}fetchTasks(z){return this._proxy.$fetchTasks(w.from(z)).then(async ae=>{const L=[];for(let N of ae){const H=await m.to(N,this._workspaceProvider,this._providedCustomExecutions2);H&&L.push(H)}return L})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(ae=>z.push(ae)),z}terminateTask(z){if(!(z instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,ae,L){const N=this._providedCustomExecutions2.get(z.id);if(N){if(this._activeCustomExecutions2.get(z.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(z.id,N),this._terminalService.attachPtyToTerminal(ae,await N.callback(L))}this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const ae=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:ae})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const ae=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:ae,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const ae=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:ae,exitCode:z.exitCode})}$provideTasks(z,ae){const L=this._handlers.get(z);if(!L)return Promise.reject(new Error("no handler found"));const N=[],H=(0,S.asPromise)(()=>L.provider.provideTasks(A.CancellationToken.None)).then(O=>this.provideTasksInternal(ae,N,L,O));return new Promise(O=>{H.then(K=>{Promise.all(N).then(()=>{O(K)})})})}async $resolveTask(z,ae){const L=this._handlers.get(z);if(!L)return Promise.reject(new Error("no handler found"));if(ae.definition.type!==L.type)throw new Error(`Unexpected: Task of type [${ae.definition.type}] cannot be resolved by provider of type [${L.type}].`);const N=await m.to(ae,this._workspaceProvider,this._providedCustomExecutions2);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const H=await L.provider.resolveTask(N,A.CancellationToken.None);if(!!H){this.checkDeprecation(H,L);const O=m.from(H,L.extension);if(!O)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return y.is(O.execution)&&await this.addCustomExecution(O,H,!0),await this.resolveTaskInternal(O)}}nextHandle(){return this._handleCounter++}async addCustomExecution(z,ae,L){const N=await this._proxy.$createTaskId(z);!L&&!this._providedCustomExecutions2.has(N)&&this._notProvidedCustomExecutions.add(N),this._providedCustomExecutions2.set(N,ae.execution)}async getTaskExecution(z,ae){if(typeof z=="string"){const H=this._taskExecutionPromises.get(z);if(!H)throw new Error("Unexpected: The specified task is missing an execution");return H}let L=this._taskExecutionPromises.get(z.id);if(L)return L;const N=new Promise(async(H,O)=>{const K=ae||await m.to(z.task,this._workspaceProvider,this._providedCustomExecutions2);K?H(new R(this,z.id,K)):O("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(z.id,N),N.then(H=>(this._taskExecutions.set(z.id,H),H),H=>Promise.reject(H))}checkDeprecation(z,ae){z._deprecated&&this._deprecationService.report("Task.constructor",ae.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let L=this._notProvidedCustomExecutions.values(),N=L.next();for(;!N.done;)!this._activeCustomExecutions2.has(N.value)&&this._lastStartedTask!==N.value&&(this._providedCustomExecutions2.delete(N.value),this._notProvidedCustomExecutions.delete(N.value)),N=L.next()}};B=Ve([qe(0,p.IExtHostRpcService),qe(1,f.IExtHostInitDataService),qe(2,C.IExtHostWorkspace),qe(3,D.IExtHostDocumentsAndEditors),qe(4,n.IExtHostConfiguration),qe(5,I.IExtHostTerminalService),qe(6,g.ILogService),qe(7,b.IExtHostApiDeprecationService)],B),e.ExtHostTaskBase=B;let Q=class extends B{constructor(z,ae,L,N,H,O,K,le){super(z,ae,L,N,H,O,K,le);this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(z,ae){if(!ae.execution)throw new Error("Tasks to execute must include an execution");const L=m.from(ae,z);if(L===void 0)throw new Error("Task is not valid");if(y.is(L.execution))await this.addCustomExecution(L,ae,!1);else throw new u.NotSupportedError;const N=await this.getTaskExecution(await this._proxy.$getTaskExecution(L),ae);return this._proxy.$executeTask(L).catch(H=>{throw new Error(H)}),N}provideTasksInternal(z,ae,L,N){const H=[];if(N)for(let O of N){this.checkDeprecation(O,L),(!O.definition||!z[O.definition.type])&&this._logService.warn(`The task [${O.source}, ${O.name}] uses an undefined task type. The task will be ignored in the future.`);const K=m.from(O,L.extension);K&&y.is(K.execution)?(H.push(K),ae.push(this.addCustomExecution(K,O,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:H,extension:L.extension}}async resolveTaskInternal(z){if(y.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,ae){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(z,ae,L){}};Q=Ve([qe(0,p.IExtHostRpcService),qe(1,f.IExtHostInitDataService),qe(2,C.IExtHostWorkspace),qe(3,D.IExtHostDocumentsAndEditors),qe(4,n.IExtHostConfiguration),qe(5,I.IExtHostTerminalService),qe(6,g.ILogService),qe(7,b.IExtHostApiDeprecationService)],Q),e.WorkerExtHostTask=Q,e.IExtHostTask=(0,s.createDecorator)("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(re,e,_){if(!e.has(re))throw new TypeError("attempted to set private field on non-instance");return e.set(re,_),_},We=this&&this.__classPrivateFieldGet||function(re,e){if(!e.has(re))throw new TypeError("attempted to get private field on non-instance");return e.get(re)},cn=this&&this.__rest||function(re,e){var _={};for(var S in re)Object.prototype.hasOwnProperty.call(re,S)&&e.indexOf(S)<0&&(_[S]=re[S]);if(re!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,S=Object.getOwnPropertySymbols(re);T<S.length;T++)e.indexOf(S[T])<0&&Object.prototype.propertyIsEnumerable.call(re,S[T])&&(_[S[T]]=re[S[T]]);return _};define(we[213],Ee([0,1,14,15,20,3,52,6,24,12,2,29,5,41,13,9,7,31,178,168]),function(re,e,_,S,T,P,E,C,D,n,A,I,p,f,s,h,v,g,b,c){"use strict";var u,a;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.ExtHostTesting=void 0;const t=(w,R)=>`${w}:${R.toString()}`;let r=class{constructor(R,F,B){this.documents=F,this.workspace=B,this.resultsChangedEmitter=new P.Emitter,this.providers=new Map,this.ownedTests=new b.OwnedTestCollection,this.testSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(p.MainContext.MainThreadTesting),this.workspaceObservers=new k(this.proxy),this.textDocumentObservers=new m(this.proxy,F)}registerTestProvider(R){const F=(0,I.generateUuid)();this.providers.set(F,R),this.proxy.$registerTestProvider(F);const B=[...this.testSubscriptions.keys()];return setTimeout(()=>{var Q;for(const J of B)(Q=this.testSubscriptions.get(J))===null||Q===void 0||Q.subscribeFn(F,R)},0),new v.Disposable(()=>{this.providers.delete(F),this.proxy.$unregisterTestProvider(F)})}createTextDocumentTestObserver(R){return this.textDocumentObservers.checkout(R.uri)}createWorkspaceTestObserver(R){return this.workspaceObservers.checkout(R.uri)}async runTests(R,F=T.CancellationToken.None){const B=Q=>Q.map(this.getInternalTestForReference,this).filter(n.isDefined).map(J=>({providerId:J.providerId,testId:J.item.extId}));await this.proxy.$runTests({exclude:R.exclude?B(R.exclude).map(Q=>Q.testId):void 0,tests:B(R.tests),debug:R.debug},F)}publishExtensionProvidedResults(R,F){this.proxy.$publishExtensionProvidedResults(h.TestResults.from((0,I.generateUuid)(),R),F)}$publishTestResults(R){this.results=Object.freeze(R.map(F=>(0,D.deepFreeze)(h.TestResults.to(F))).concat(this.results).sort((F,B)=>B.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(R,F){const B=A.URI.revive(F),Q=t(R,B);if(!this.testSubscriptions.has(Q)){const J=new T.CancellationTokenSource;let z;if(R===1){let H=this.documents.getDocument(B);if(!H){const O=new C.DisposableStore;H=await new Promise(K=>{O.add((0,S.disposableTimeout)(()=>K(void 0),5e3)),O.add(this.documents.onDidAddDocuments(le=>{const ue=le.find(pe=>pe.document.uri.toString()===B.toString());ue&&K(ue)}))}).finally(()=>O.dispose())}if(H){const O=await this.workspace.getWorkspaceFolder2(B,!1);z=K=>K.provideDocumentTestHierarchy?K.provideDocumentTestHierarchy(H.document,J.token):this.createDefaultDocumentTestHierarchy(K,H.document,O,J.token)}}else{const H=await this.workspace.getWorkspaceFolder2(B,!1);H&&(z=O=>O.provideWorkspaceTestHierarchy(H,J.token))}if(!!z){const ae=async(H,O)=>{var K;try{N.pushDiff([3,1]);const le=await z(O);if(!le){N.pushDiff([3,-1]);return}N.addRoot(le.root,H),Promise.resolve(le.discoveredInitialTests).then(()=>N.pushDiff([3,-1])),le.onDidChangeTest(ue=>N.onItemChange(ue,H)),(K=le.onDidInvalidateTest)===null||K===void 0||K.call(le,ue=>{const pe=N.getTestByReference(ue);pe?this.proxy.$retireTest(pe.item.extId):console.warn("Received a TestProvider.onDidInvalidateTest for a test that does not currently exist.")})}catch(le){console.error(le)}},L=new C.DisposableStore,N=L.add(this.ownedTests.createForHierarchy(H=>this.proxy.$publishDiff(R,F,H)));L.add((0,C.toDisposable)(()=>J.dispose(!0)));for(const[H,O]of this.providers)ae(H,O);N.pushDiff([4,-1]),this.testSubscriptions.set(Q,{store:L,collection:N,subscribeFn:ae})}}}$unsubscribeFromTests(R,F){var B;const Q=A.URI.revive(F),J=t(R,Q);(B=this.testSubscriptions.get(J))===null||B===void 0||B.store.dispose(),this.testSubscriptions.delete(J)}$acceptDiff(R,F,B){R===1?this.textDocumentObservers.acceptDiff(A.URI.revive(F),B):this.workspaceObservers.acceptDiff(A.URI.revive(F),B)}async $runTestsForProvider(R,F){const B=this.providers.get(R.providerId);if(!!B){const Q=R.ids.map(z=>{var ae;return(ae=this.ownedTests.getTestById(z))===null||ae===void 0?void 0:ae[1]}).filter(n.isDefined),J=R.excludeExtIds.map(z=>this.ownedTests.getTestById(z)).filter(n.isDefined).filter(([z,ae])=>Q.some(L=>z.comparePositions(L,ae)===1));if(!!Q.length)try{await B.runTests({setState:(z,ae)=>{for(const[L,N]of J){const H=L.comparePositions(N,z.id);if(H===1||H===3)return}this.flushCollectionDiffs(),this.proxy.$updateTestStateInRun(R.runId,z.id,h.TestState.from(ae))},tests:Q.map(z=>o.unwrap(z.actual)),exclude:J.map(([,z])=>o.unwrap(z.actual)),debug:R.debug},F);for(const{collection:z}of this.testSubscriptions.values())z.flushDiff();return}catch(z){throw console.error(z),z}}}$lookupTest(R){const F=this.ownedTests.getTestById(R.testId);if(!F)return Promise.resolve(void 0);const B=F[1],{actual:Q,previousChildren:J,previousEquals:z}=B,ae=cn(B,["actual","previousChildren","previousEquals"]);return Promise.resolve(ae)}flushCollectionDiffs(){for(const{collection:R}of this.testSubscriptions.values())R.flushDiff()}getInternalTestForReference(R){var F,B;return(B=(F=this.workspaceObservers.getMirroredTestDataByReference(R))!==null&&F!==void 0?F:(0,_.mapFind)(this.testSubscriptions.values(),Q=>Q.collection.getTestByReference(R)))!==null&&B!==void 0?B:this.textDocumentObservers.getMirroredTestDataByReference(R)}async createDefaultDocumentTestHierarchy(R,F,B,Q){var J;if(!!B){const z=await R.provideWorkspaceTestHierarchy(B,Q);if(!!z){const ae=new P.Emitter;(J=z.onDidInvalidateTest)===null||J===void 0||J.call(z,N=>{const H=o.getWrapperForTestItem(N,F);H.hasNodeMatchingFilter&&ae.fire(H)});const L=new P.Emitter;return z.onDidChangeTest(N=>{const H=o.getWrapperForTestItem(N,F);if(H.hasNodeMatchingFilter){if(H.reset(),H.hasNodeMatchingFilter){L.fire(H);return}L.fire(H.visibleParent);return}const K=H.visibleParent;H.reset(),!!H.hasNodeMatchingFilter&&(K.reset(),L.fire(K))}),Q.onCancellationRequested(()=>{o.removeFilter(F),L.dispose()}),{root:o.getWrapperForTestItem(z.root,F),discoveredInitialTests:z.discoveredInitialTests,onDidInvalidateTest:ae.event,onDidChangeTest:L.event}}}}};r=Ve([qe(0,s.IExtHostRpcService),qe(1,f.IExtHostDocumentsAndEditors),qe(2,g.IExtHostWorkspace)],r),e.ExtHostTesting=r;class o{constructor(R,F,B){this.actual=R,this.filterDocument=F,this.parent=B,this.getWrappedChildren()}static removeFilter(R){this.wrapperMap.delete(R)}static getWrapperForTestItem(R,F,B){let Q=this.wrapperMap.get(F);if(Q==null?void 0:Q.has(R))return Q.get(R);Q||(Q=new WeakMap,this.wrapperMap.set(F,Q));const J=new o(R,F,B);return Q.set(R,J),J}static unwrap(R){return R instanceof o?R.actual:R}get id(){return this.actual.id}get label(){return this.actual.label}get debuggable(){return this.actual.debuggable}get description(){return this.actual.description}get location(){return this.actual.location}get runnable(){return this.actual.runnable}get children(){return this.getWrappedChildren().filter(R=>R.hasNodeMatchingFilter)}get visibleParent(){return this.hasNodeMatchingFilter?this:this.parent.visibleParent}get hasNodeMatchingFilter(){var R;return this.matchesFilter===void 0&&(this.matchesFilter=!this.parent||((R=this.actual.location)===null||R===void 0?void 0:R.uri.toString())===this.filterDocument.uri.toString()||this.getWrappedChildren().some(F=>F.hasNodeMatchingFilter)),this.matchesFilter}reset(){var R;this!==this.visibleParent&&((R=this.parent)===null||R===void 0||R.reset()),this.matchesFilter=void 0}getWrappedChildren(){var R;return((R=this.actual.children)===null||R===void 0?void 0:R.map(F=>o.getWrapperForTestItem(F,this.filterDocument,this)))||[]}}e.TestItemFilteredWrapper=o,o.wrapperMap=new WeakMap;class l extends c.IncrementalChangeCollector{constructor(R,F){super();this.collection=R,this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,h.TestItem.toPlainShallow(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{collection:R,added:F,updated:B,removed:Q}=this;return{get added(){return[...F].map(R.getPublicTestItem,R)},get updated(){return[...B].map(R.getPublicTestItem,R)},get removed(){return[...Q].map(R.getPublicTestItem,R)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class i extends c.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(R){let F=[];for(const B of R){const Q=this.items.get(B);Q&&F.push(this.getPublicTestItem(Q))}return F}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,F){return Object.assign(Object.assign({},R),{revived:h.TestItem.toPlainShallow(R.item),depth:F?F.depth+1:0,children:new Set})}createChangeCollector(){return new l(this,this.changeEmitter)}getPublicTestItem(R){return R.wrapped||(R.wrapped=new d(R,this)),R.wrapped}}e.MirroredTestCollection=i;class d{constructor(R,F){u.set(this,void 0),a.set(this,void 0),tt(this,u,R),tt(this,a,F)}get id(){return We(this,u).revived.id}get label(){return We(this,u).revived.label}get description(){return We(this,u).revived.description}get location(){return We(this,u).revived.location}get runnable(){var R;return(R=We(this,u).revived.runnable)!==null&&R!==void 0?R:!0}get debuggable(){var R;return(R=We(this,u).revived.debuggable)!==null&&R!==void 0?R:!1}get children(){return We(this,a).getAllAsTestItem(We(this,u).children)}toJSON(){return{id:this.id,label:this.label,description:this.description,location:this.location,runnable:this.runnable,debuggable:this.debuggable,children:this.children.map(F=>F.toJSON()),providerId:We(this,u).providerId,testId:this.id}}}u=new WeakMap,a=new WeakMap;class y{constructor(){this.resources=new Map}checkout(R){var F,B;const Q=R.toString(),J=(F=this.resources.get(Q))!==null&&F!==void 0?F:this.createObserverData(R);return(B=J.pendingDeletion)===null||B===void 0||B.dispose(),J.observers++,{onDidChangeTest:J.tests.onDidChangeTests,onDidDiscoverInitialTests:new P.Emitter().event,get tests(){return J.tests.rootTestItems},dispose:(0,E.once)(()=>{--J.observers||(J.pendingDeletion=this.eventuallyDispose(R))})}}getMirroredTestDataByReference(R){for(const{tests:F}of this.resources.values()){const B=F.getMirroredTestDataByReference(R);if(B)return B}}eventuallyDispose(R){return(0,S.disposableTimeout)(()=>this.unlisten(R),10*1e3)}createObserverData(R){const F=new i,B=this.listen(R,J=>F.apply(J)),Q={observers:0,tests:F,listener:B};return this.resources.set(R.toString(),Q),Q}unlisten(R){var F;const B=R.toString(),Q=this.resources.get(B);Q&&(Q.observers=-1,(F=Q.pendingDeletion)===null||F===void 0||F.dispose(),Q.listener.dispose(),this.resources.delete(B))}}class k extends y{constructor(R){super();this.proxy=R,this.diffListeners=new Map}acceptDiff(R,F){var B;(B=this.diffListeners.get(R.toString()))===null||B===void 0||B(F)}listen(R,F){this.proxy.$subscribeToDiffs(0,R);const B=R.toString();return this.diffListeners.set(B,F),new v.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,R),this.diffListeners.delete(B)})}}class m extends y{constructor(R,F){super();this.proxy=R,this.documents=F,this.diffListeners=new Map}acceptDiff(R,F){var B;(B=this.diffListeners.get(R.toString()))===null||B===void 0||B(F)}listen(R,F){if(!this.documents.getDocument(R))return new v.Disposable(()=>{});const Q=R.toString();return this.diffListeners.set(Q,F),this.proxy.$subscribeToDiffs(1,R),new v.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,R),this.diffListeners.delete(Q)})}}}),define(we[214],Ee([0,1,14,51,28,59,22,16,10,23,8,12,2,113,137,89,48,170,212,43]),function(re,e,_,S,T,P,E,C,D,n,A,I,p,f,s,h,v,g,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(k,m,w,R){this.configurationService=k,this.workspaceContextService=m,this.editorGroupsService=w,this.pathService=R}text(k,m,w={}){k=this.getContentPattern(k,w);const R=this.configurationService.getValue(),F=m&&m.some(Q=>!this.configurationService.getValue({resource:Q}).search.useRipgrep),B=this.commonQuery(m==null?void 0:m.map(v.toWorkspaceFolder),w);return Object.assign(Object.assign({},B),{type:2,contentPattern:k,previewOptions:w.previewOptions,maxFileSize:w.maxFileSize,usePCRE2:R.search.usePCRE2||F||!1,beforeContext:w.beforeContext,afterContext:w.afterContext,userDisabledExcludesAndIgnoreFiles:w.disregardExcludeSettings&&w.disregardIgnoreFiles})}getContentPattern(k,m){const w=this.configurationService.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},k),{wordSeparators:w.editor.wordSeparators});return this.isCaseSensitive(k,m)&&(R.isCaseSensitive=!0),this.isMultiline(k)&&(R.isMultiline=!0),R}file(k,m={}){const w=this.commonQuery(k,m);return Object.assign(Object.assign({},w),{type:1,filePattern:m.filePattern?m.filePattern.trim():m.filePattern,exists:m.exists,sortByScore:m.sortByScore,cacheKey:m.cacheKey})}handleIncludeExclude(k,m){return k?(k=Array.isArray(k)?k.map(l):l(k),m?this.parseSearchPaths(k):{pattern:t(...Array.isArray(k)?k:[k])}):{}}commonQuery(k=[],m={}){const w=this.handleIncludeExclude(m.includePattern,m.expandPatterns),R=this.handleIncludeExclude(m.excludePattern,m.expandPatterns),F=k.length>1,B=(w.searchPaths&&w.searchPaths.length?w.searchPaths.map(z=>this.getFolderQueryForSearchPath(z,m,R)):k.map(z=>this.getFolderQueryForRoot(z,m,R,F))).filter(z=>!!z),Q={_reason:m._reason,folderQueries:B,usingSearchPaths:!!(w.searchPaths&&w.searchPaths.length),extraFileResources:m.extraFileResources,excludePattern:R.pattern,includePattern:w.pattern,onlyOpenEditors:m.onlyOpenEditors,maxResults:m.maxResults};if(m.onlyOpenEditors){const ae=_.coalesce(_.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(H=>H.resource)))).filter(N=>(0,c.pathIncludedInQuery)(Q,N.fsPath)),L=this.commonQueryFromFileList(ae);return Object.assign(Object.assign({},Q),L)}const J=m.extraFileResources&&m.extraFileResources.filter(z=>(0,c.pathIncludedInQuery)(Q,z.fsPath));return Q.extraFileResources=J&&J.length?J:void 0,Q}commonQueryFromFileList(k){const m=[],w=new E.ResourceMap,R={};let F=!1;return k.forEach(B=>{var Q,J;if(B.scheme!==C.Schemas.walkThrough)if((0,n.isAbsolutePath)(B)){const ae=(J=(Q=this.workspaceContextService.getWorkspaceFolder(B))===null||Q===void 0?void 0:Q.uri)!==null&&J!==void 0?J:B.with({path:D.dirname(B.fsPath)});let L=w.get(ae);L||(F=!0,L={folder:ae,includePattern:{}},m.push(L),w.set(ae,L));const N=D.relative(ae.fsPath,B.fsPath);(0,I.assertIsDefined)(L.includePattern)[N.replace(/\\/g,"/")]=!0}else B.fsPath&&(F=!0,R[B.fsPath]=!0)}),{folderQueries:m,includePattern:R,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(k,m){if(m.isSmartCase){if(k.isRegExp){if(A.containsUppercaseCharacter(k.pattern,!0))return!0}else if(A.containsUppercaseCharacter(k.pattern))return!0}return!!k.isCaseSensitive}isMultiline(k){return k.isMultiline||k.isRegExp&&(0,f.isMultilineRegexSource)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const m=L=>D.isAbsolute(L)||/^\.\.?([\/\\]|$)/.test(L),R=(Array.isArray(k)?k:r(k)).map(L=>{const N=this.pathService.resolvedUserHome;return N?(0,P.untildify)(L,N.scheme===C.Schemas.file?N.fsPath:N.path):L}),F=S.groupBy(R,L=>m(L)?"searchPaths":"exprSegments"),B=(F.exprSegments||[]).map(L=>A.rtrim(L,"/")).map(L=>A.rtrim(L,"\\")).map(L=>(L[0]==="."&&(L="*"+L),o(L))),Q={},J=this.expandSearchPathPatterns(F.searchPaths||[]);J&&J.length&&(Q.searchPaths=J);const z=_.flatten(B),ae=t(...z);return ae&&(Q.pattern=ae),Q}getExcludesForFolder(k,m){return m.disregardExcludeSettings?void 0:(0,c.getExcludes)(k,!m.disregardSearchExcludeSettings)}expandSearchPathPatterns(k){if(!k||!k.length)return[];const m=_.flatten(k.map(R=>{let{pathPortion:F,globPortion:B}=a(R);B&&(B=i(B));const Q=this.expandOneSearchPath(F);return _.flatten(Q.map(J=>this.resolveOneSearchPathPattern(J,B)))})),w=new Map;return m.forEach(R=>{const F=R.searchPath.toString(),B=w.get(F);B?R.pattern&&(B.pattern=B.pattern||{},B.pattern[R.pattern]=!0):w.set(F,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(w.values())}expandOneSearchPath(k){if(D.isAbsolute(k)){const m=this.workspaceContextService.getWorkspace().folders;return m[0]&&m[0].uri.scheme!==C.Schemas.file?[{searchPath:m[0].uri.with({path:k})}]:[{searchPath:p.URI.file(D.normalize(k))}]}if(this.workspaceContextService.getWorkbenchState()===2){const m=this.workspaceContextService.getWorkspace().folders[0].uri;if(k=l(k),k.startsWith("../")||k===".."){const R=D.posix.resolve(m.path,k);return[{searchPath:m.with({path:R})}]}const w=i(k);return[{searchPath:m,pattern:w}]}else{if(k==="./"||k===".\\")return[];{const m=k.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(m){const w=m[1],R=this.workspaceContextService.getWorkspace().folders.filter(F=>F.name===w);if(R.length)return R.map(F=>{const B=m[2];return{searchPath:F.uri,pattern:B&&i(B)}});{const F=s.localize(0,null,w);throw new Error(F)}}}}return[]}resolveOneSearchPathPattern(k,m){const w=k.pattern&&m?`${k.pattern}/${m}`:k.pattern||m,R=[{searchPath:k.searchPath,pattern:w}];return w&&!w.endsWith("**")&&R.push({searchPath:k.searchPath,pattern:w+"/**"}),R}getFolderQueryForSearchPath(k,m,w){const R=this.getFolderQueryForRoot((0,v.toWorkspaceFolder)(k.searchPath),m,w,!1);return R?Object.assign(Object.assign({},R),{includePattern:k.pattern}):null}getFolderQueryForRoot(k,m,w,R){let F;const B=p.URI.isUri(k)?k:k.uri;if(w.searchPaths){const L=w.searchPaths.filter(N=>(0,n.isEqual)(N.searchPath,B))[0];if(L&&!L.pattern)return null;L&&(F=L.pattern)}const Q=this.configurationService.getValue({resource:B}),J=this.getExcludesForFolder(Q,m),z=Object.assign(Object.assign({},J||{}),F||{}),ae=p.URI.isUri(k)?(0,n.basename)(k):k.name;return{folder:B,folderName:R?ae:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:Q.files&&Q.files.encoding,disregardIgnoreFiles:typeof m.disregardIgnoreFiles=="boolean"?m.disregardIgnoreFiles:!Q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof m.disregardGlobalIgnoreFiles=="boolean"?m.disregardGlobalIgnoreFiles:!Q.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof m.ignoreSymlinks=="boolean"?m.ignoreSymlinks:!Q.search.followSymlinks}}};u=Ve([qe(0,h.IConfigurationService),qe(1,v.IWorkspaceContextService),qe(2,g.IEditorGroupsService),qe(3,b.IPathService)],u),e.QueryBuilder=u;function a(y){const k=y.match(/[\*\{\}\(\)\[\]\?]/);if(k){const m=k.index,w=y.substr(0,m).match(/[/|\\][^/\\]*$/);if(w){let R=y.substr(0,w.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:y.substr((w.index||0)+1)}}}return{pathPortion:y}}function t(...y){return y.length?y.reduce((k,m)=>(k[m]=!0,k),Object.create(null)):void 0}function r(y){return T.splitGlobAware(y,",").map(k=>k.trim()).filter(k=>!!k.length)}function o(y){return[`**/${y}/**`,`**/${y}`].map(m=>m.replace(/\*\*\/\*\*/g,"**"))}function l(y){return y.replace(/\\/g,"/")}function i(y){return l(y).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(y,k){y=_.distinct(y,R=>R.toString());const m=[],w=k.getWorkspace();return y&&y.forEach(R=>{let F;if(k.getWorkbenchState()===2)F=(0,n.relativePath)(w.folders[0].uri,R),F&&F!=="."&&(F="./"+F);else{const B=k.getWorkspaceFolder(R);if(B){const Q=B.name;if(w.folders.filter(z=>z.name===Q).length===1){const z=(0,n.relativePath)(B.uri,R);z===""?F=`./${B.name}`:F=`./${B.name}/${z}`}else F=R.fsPath}}F&&m.push(F)}),m}e.resolveResourcesForSearchIncludes=d}),define(we[215],Ee([0,1,23,2,20,11,4,214,43,48]),function(re,e,_,S,T,P,E,C,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const A=7e3;function I(h,v){const g=v.activationEvents;if(!g)return Promise.resolve(void 0);const b=[],c=[];for(const l of g)if(/^workspaceContains:/.test(l)){const i=l.substr("workspaceContains:".length);i.indexOf("*")>=0||i.indexOf("?")>=0||h.forceUsingSearch?c.push(i):b.push(i)}if(b.length===0&&c.length===0)return Promise.resolve(void 0);let u;const a=new Promise((l,i)=>{u=l}),t=l=>u({activationEvent:l}),r=Promise.all(b.map(l=>p(h,l,t))).then(()=>{}),o=f(h,v.identifier,c,t);return Promise.all([r,o]).then(()=>{u(void 0)}),a}e.checkActivateWorkspaceContainsExtension=I;async function p(h,v,g){for(const b of h.folders)if(await h.exists(_.joinPath(S.URI.revive(b),v))){g(`workspaceContains:${v}`);return}}async function f(h,v,g,b){if(g.length===0)return Promise.resolve(void 0);const c=new T.CancellationTokenSource,u=h.checkExists(h.folders,g,c.token),a=setTimeout(async()=>{c.cancel(),b(`workspaceContainsTimeout:${g.join(",")}`)},A);let t=!1;try{t=await u}catch(r){P.isPromiseCanceledError(r)||P.onUnexpectedError(r)}c.dispose(),clearTimeout(a),t&&b(`workspaceContains:${g.join(",")}`)}function s(h,v,g,b){const c=h.get(E.IInstantiationService),u=h.get(D.ISearchService),t=c.createInstance(C.QueryBuilder).file(v.map(r=>(0,n.toWorkspaceFolder)(S.URI.revive(r))),{_reason:"checkExists",includePattern:g,exists:!0});return u.fileSearch(t,b).then(r=>!!r.limitHit,r=>P.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=s}),define(we[35],Ee([0,1,129,10,77,23,15,6,22,2,19,5,34,181,75,31,33,179,11,25,16,26,157,7,90,4,27,76,13,66,68,42,3,215,71,158]),function(re,e,_,S,T,P,E,C,D,n,A,I,p,f,s,h,v,g,b,c,u,a,t,r,o,l,i,d,y,k,m,w,R,F,B,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,l.createDecorator)("IHostUtils");let J=class kn extends C.Disposable{constructor(L,N,H,O,K,le,ue,pe,ve,Re){super();this._onDidChangeRemoteConnectionData=this._register(new R.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=N,this._extHostContext=H,this._initData=ue,this._extHostWorkspace=O,this._extHostConfiguration=K,this._logService=le,this._extHostTunnelService=ve,this._extHostTerminalService=Re,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new E.Barrier,this._readyToStartExtensionHost=new E.Barrier,this._readyToRunExtensions=new E.Barrier,this._registry=new g.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new s.ExtHostStorage(this._extHostContext),this._secretState=new B.ExtHostSecretState(this._extHostContext),this._storagePath=pe,this._instaService=L.createChild(new k.ServiceCollection([s.IExtHostStorage,this._storage],[B.IExtHostSecretState,this._secretState]));const He=new Set;this._initData.hostExtensions.forEach(Fe=>He.add(c.ExtensionIdentifier.toKey(Fe))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Fe,ze)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Fe,ze)},actualActivateExtension:async(Fe,ze)=>{if(He.has(c.ExtensionIdentifier.toKey(Fe)))return await this._mainThreadExtensionsProxy.$activateExtension(Fe,ze),new f.HostExtension;const $=this._registry.getExtensionDescription(Fe);return this._activateExtension($,ze)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),T.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(L){b.onUnexpectedError(L)}}async deactivateAll(){let L=[];try{L=this._registry.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this._deactivate(K))}catch(N){}await Promise.all(L)}isActivated(L){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(L):!1}_activateByEvent(L,N){return this._activator.activateByEvent(L,N)}_activateById(L,N){return this._activator.activateById(L,N)}activateByIdWithErrors(L,N){return this._activateById(L,N).then(()=>{const H=this._activator.getActivatedExtension(L);if(H.activationFailed)return Promise.reject(H.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(L=>this._registry)}getExtensionExports(L){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(L).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const L=D.TernarySearchTree.forPaths(),N=this._registry.getAllExtensionDescriptions().map(H=>{if(!!this._getEntryPoint(H))return this._hostUtils.realpath(H.extensionLocation.fsPath).then(O=>L.set(n.URI.file(O).fsPath,H))});this._extensionPathIndex=Promise.all(N).then(()=>L)}return this._extensionPathIndex}_deactivate(L){let N=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(L))return N;const H=this._activator.getActivatedExtension(L);if(!H)return N;try{typeof H.module.deactivate=="function"&&(N=Promise.resolve(H.module.deactivate()).then(void 0,O=>Promise.resolve(void 0)))}catch(O){}try{(0,C.dispose)(H.subscriptions)}catch(O){}return N}async _activateExtension(L,N){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(L.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(L.identifier),this._doActivateExtension(L,N).then(H=>{const O=H.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(L.identifier,O.codeLoadingTime,O.activateCallTime,O.activateResolvedTime,N),this._logExtensionActivationTimes(L,N,"success",O),H},H=>{throw this._logExtensionActivationTimes(L,N,"failure"),H})}_logExtensionActivationTimes(L,N,H,O){const K=z(L,N);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},K),O||{}),{outcome:H}))}_doActivateExtension(L,N){const H=z(L,N);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",H);const O=this._getEntryPoint(L);if(!O)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${L.identifier.value} ${JSON.stringify(N)}`),this._logService.flush();const K=new f.ExtensionActivationTimesBuilder(N.startup);return Promise.all([this._loadCommonJSModule(L.identifier,(0,P.joinPath)(L.extensionLocation,O),K),this._loadExtensionContext(L)]).then(le=>(T.mark(`code/extHost/willActivateExtension/${L.identifier.value}`),kn._callActivate(this._logService,L.identifier,le[0],le[1],K))).then(le=>(T.mark(`code/extHost/didActivateExtension/${L.identifier.value}`),le))}_loadExtensionContext(L){const N=new t.ExtensionGlobalMemento(L,this._storage),H=new t.ExtensionMemento(L.identifier.value,!1,this._storage),O=new Q.ExtensionSecrets(L,this._secretState),K=L.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,le=Date.now()-new Date(this._initData.telemetryInfo.firstSessionDate).getTime();return this._logService.trace(`ExtensionService#loadExtensionContext ${L.identifier.value}`),Promise.all([N.whenReady,H.whenReady,this._storagePath.whenReady]).then(()=>{const ue=this;return Object.freeze({globalState:N,workspaceState:H,secrets:O,subscriptions:[],get extensionUri(){return L.extensionLocation},get extensionPath(){return L.extensionLocation.fsPath},asAbsolutePath(pe){return S.join(L.extensionLocation.fsPath,pe)},get storagePath(){var pe;return(pe=ue._storagePath.workspaceValue(L))===null||pe===void 0?void 0:pe.fsPath},get globalStoragePath(){return ue._storagePath.globalValue(L).fsPath},get logPath(){return S.join(ue._initData.logsLocation.fsPath,L.identifier.value)},get logUri(){return n.URI.joinPath(ue._initData.logsLocation,L.identifier.value)},get storageUri(){return ue._storagePath.workspaceValue(L)},get globalStorageUri(){return ue._storagePath.globalValue(L)},get extensionMode(){return K},get extensionId(){return(0,v.checkProposedApiEnabled)(L),L.identifier.value},get extensionVersion(){return(0,v.checkProposedApiEnabled)(L),L.version},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(L),ue.extensionRuntime},get isNewInstall(){return(0,v.checkProposedApiEnabled)(L),isNaN(le)?!1:le<1e3*60*60*24},get environmentVariableCollection(){return ue._extHostTerminalService.getEnvironmentVariableCollection(L)}})})}static _callActivate(L,N,H,O,K){return H=H||{activate:void 0,deactivate:void 0},this._callActivateOptional(L,N,H,O,K).then(le=>new f.ActivatedExtension(!1,null,K.build(),H,le,O.subscriptions))}static _callActivateOptional(L,N,H,O,K){if(typeof H.activate=="function")try{K.activateCallStart(),L.trace(`ExtensionService#_callActivateOptional ${N.value}`);const le=typeof global=="object"?global:self,ue=H.activate.apply(le,[O]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(ue).then(pe=>(K.activateResolveStop(),pe))}catch(le){return Promise.reject(le)}else return Promise.resolve(H)}_activateOneStartupFinished(L,N){this._activateById(L.identifier,{startup:!1,extensionId:L.identifier,activationEvent:N}).then(void 0,H=>{this._logService.error(H)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(T.getMarks());for(const L of this._registry.getAllExtensionDescriptions())if(L.activationEvents)for(const N of L.activationEvents)N==="onStartupFinished"&&this._activateOneStartupFinished(L,N)}_handleEagerExtensions(){const L=this._activateByEvent("*",!0).then(void 0,K=>{this._logService.error(K)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(K=>this._handleWorkspaceContainsEagerExtensions(K.added)));const N=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],H=this._handleWorkspaceContainsEagerExtensions(N),O=Promise.all([L,H]).then(()=>{});return Promise.race([O,(0,E.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),O}_handleWorkspaceContainsEagerExtensions(L){return L.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(N=>this._handleWorkspaceContainsEagerExtension(L,N))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(L,N){if(!this.isActivated(N.identifier)){const H=!this._initData.remote.isRemote&&!!this._initData.remote.authority,O={folders:L.map(le=>le.uri),forceUsingSearch:H,exists:le=>this._hostUtils.exists(le.fsPath),checkExists:(le,ue,pe)=>this._mainThreadWorkspaceProxy.$checkExists(le,ue,pe)},K=await(0,F.checkActivateWorkspaceContainsExtension)(O,N);if(!!K)return this._activateById(N.identifier,{startup:!0,extensionId:N.identifier,activationEvent:K.activationEvent}).then(void 0,le=>this._logService.error(le))}}_handleExtensionTests(){return this._doHandleExtensionTests().then(void 0,L=>(console.error(L),Promise.reject(L)))}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:L,extensionTestsLocationURI:N}=this._initData.environment;if(!(L&&N&&N.scheme===u.Schemas.file))return Promise.resolve(void 0);const H=(0,P.originalFSPath)(N);let O,K;try{O=await this._loadCommonJSModule(null,n.URI.file(H),new f.ExtensionActivationTimesBuilder(!1))}catch(le){K=le}return O&&typeof O.run=="function"?new Promise((le,ue)=>{const pe=(Re,He)=>{Re?ue(Re.toString()):le(void 0),this._testRunnerExit(Re||typeof He=="number"&&He>0?1:0)},ve=O.run(H,pe);ve&&ve.then&&ve.then(()=>{le(),this._testRunnerExit(0)}).catch(Re=>{ue(Re.toString()),this._testRunnerExit(1)})}):(this._testRunnerExit(1),Promise.reject(new Error(K?K.toString():_.localize(0,null,H))))}_testRunnerExit(L){this._logService.info(`extension host terminating: test runner requested exit with code ${L}`),this._logService.flush();const N=this._mainThreadExtensionsProxy.$onExtensionHostExit(L),H=this._extHostContext.drain();Promise.race([Promise.all([N,H]),(0,E.timeout)(5e3)]).then(()=>{this._logService.info(`exiting with code ${L}`),this._logService.flush(),this._hostUtils.exit(L)})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>this._handleExtensionTests()).then(()=>{this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(L,N){return this._resolvers[L]=N,(0,C.toDisposable)(()=>{delete this._resolvers[L]})}async $resolveAuthority(L,N){const H=L.indexOf("+");if(H===-1)throw new Error("Not an authority that can be resolved!");const O=L.substr(0,H);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${O}`,!1);const K=this._resolvers[O];if(!K)return{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${O}.`,detail:void 0}};try{T.mark(`code/extHost/willResolveAuthority/${O}`);const le=await K.resolve(L,{resolveAttempt:N});T.mark(`code/extHost/didResolveAuthorityOK/${O}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(K));const ue={authority:L,host:le.host,port:le.port,connectionToken:le.connectionToken},pe={extensionHostEnv:le.extensionHostEnv};return{type:"ok",value:{authority:ue,options:pe,tunnelInformation:{environmentTunnels:le.environmentTunnels}}}}catch(le){if(T.mark(`code/extHost/didResolveAuthorityError/${O}`),le instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:le._code,message:le._message,detail:le._detail}};throw le}}$startExtensionHost(L){return this._registry.keepOnly(L),this._startExtensionHost()}$activateByEvent(L,N){return N===1?this._activateByEvent(L,!1):this._readyToRunExtensions.wait().then(H=>this._activateByEvent(L,!1))}async $activate(L,N){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(L)?(await this._activateById(L,N),!0):!1}async $deltaExtensions(L,N){L.forEach(O=>O.extensionLocation=n.URI.revive(O.extensionLocation));const H=await this.getExtensionPathIndex();return await Promise.all(N.map(async O=>{const K=this._registry.getExtensionDescription(O);if(!!K){const le=await this._hostUtils.realpath(K.extensionLocation.fsPath);H.delete(n.URI.file(le).fsPath)}})),await Promise.all(L.map(async O=>{const K=await this._hostUtils.realpath(O.extensionLocation.fsPath);H.set(n.URI.file(K).fsPath,O)})),this._registry.deltaExtensions(L,N),Promise.resolve(void 0)}async $test_latency(L){return L}async $test_up(L){return L.byteLength}async $test_down(L){let N=a.VSBuffer.alloc(L),H=Math.random()%256;for(let O=0;O<L;O++)N.writeUInt8(H,O);return N}async $updateRemoteConnectionData(L){this._remoteConnectionData=L,this._onDidChangeRemoteConnectionData.fire()}};J=Ve([qe(0,l.IInstantiationService),qe(1,e.IHostUtils),qe(2,y.IExtHostRpcService),qe(3,h.IExtHostWorkspace),qe(4,p.IExtHostConfiguration),qe(5,A.ILogService),qe(6,i.IExtHostInitDataService),qe(7,d.IExtensionStoragePaths),qe(8,m.IExtHostTunnelService),qe(9,w.IExtHostTerminalService)],J),e.AbstractExtHostExtensionService=J;function z(ae,L){return{id:ae.identifier.value,name:ae.name,extensionVersion:ae.version,publisherDisplayName:ae.publisher,activationEvents:ae.activationEvents?ae.activationEvents.join(","):null,isBuiltin:ae.isBuiltin,reason:L.activationEvent,reasonId:L.extensionId.value}}e.IExtHostExtensionService=(0,l.createDecorator)("IExtHostExtensionService")}),define(we[101],Ee([0,1,10,2,3,15,5,7,162,31,35,41,169,34,163,13,4,12]),function(re,e,_,S,T,P,E,C,D,n,A,I,p,f,s,h,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,v.createDecorator)("IExtHostDebugService");let b=class{constructor(i,d,y,k,m){this._workspaceService=d,this._extensionService=y,this._editorsService=k,this._configurationService=m,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new T.Emitter,this._onDidTerminateDebugSession=new T.Emitter,this._onDidChangeActiveDebugSession=new T.Emitter,this._onDidReceiveDebugSessionCustomEvent=new T.Emitter,this._debugServiceProxy=i.getProxy(E.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new T.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new u(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(w=>{w.onDidChange(R=>{this.registerAllDebugTypes(w)}),this.registerAllDebugTypes(w)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(i,d){const y=i;if(typeof y.sourceReference=="number"&&y.sourceReference>0){let k=`debug:${encodeURIComponent(y.path||"")}`,m="?";return d&&(k+=`${m}session=${encodeURIComponent(d.id)}`,m="&"),k+=`${m}ref=${y.sourceReference}`,S.URI.parse(k)}else{if(y.path)return S.URI.file(y.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(i){const d=[];for(const y of i.getAllExtensionDescriptions())if(y.contributes){const k=y.contributes.debuggers;if(k&&k.length>0)for(const m of k)(0,s.isDebuggerMainContribution)(m)&&d.push(m.type)}this._debugServiceProxy.$registerDebugTypes(d)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const i=[];return this._breakpoints.forEach(d=>i.push(d)),i}addBreakpoints(i){this.startBreakpoints();const d=i.filter(m=>{const w=m.id;return this._breakpoints.has(w)?!1:(this._breakpoints.set(w,m),!0)});this.fireBreakpointChanges(d,[],[]);const y=[],k=new Map;for(const m of d)if(m instanceof C.SourceBreakpoint){let w=k.get(m.location.uri.toString());w||(w={type:"sourceMulti",uri:m.location.uri,lines:[]},k.set(m.location.uri.toString(),w),y.push(w)),w.lines.push({id:m.id,enabled:m.enabled,condition:m.condition,hitCondition:m.hitCondition,logMessage:m.logMessage,line:m.location.range.start.line,character:m.location.range.start.character})}else m instanceof C.FunctionBreakpoint&&y.push({type:"function",id:m.id,enabled:m.enabled,hitCondition:m.hitCondition,logMessage:m.logMessage,condition:m.condition,functionName:m.functionName});return this._debugServiceProxy.$registerBreakpoints(y)}removeBreakpoints(i){this.startBreakpoints();const d=i.filter(w=>this._breakpoints.delete(w.id));this.fireBreakpointChanges([],d,[]);const y=d.filter(w=>w instanceof C.SourceBreakpoint).map(w=>w.id),k=d.filter(w=>w instanceof C.FunctionBreakpoint).map(w=>w.id),m=d.filter(w=>w instanceof C.DataBreakpoint).map(w=>w.id);return this._debugServiceProxy.$unregisterBreakpoints(y,k,m)}startDebugging(i,d,y){return this._debugServiceProxy.$startDebugging(i?i.uri:void 0,d,{parentSessionID:y.parentSession?y.parentSession.id:void 0,repl:y.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:y.noDebug,compact:y.compact})}stopDebugging(i){return this._debugServiceProxy.$stopDebugging(i?i.id:void 0)}registerDebugConfigurationProvider(i,d,y){if(!d)return new C.Disposable(()=>{});const k=this._configProviderHandleCounter++;return this._configProviders.push({type:i,handle:k,provider:d}),this._debugServiceProxy.$registerDebugConfigurationProvider(i,y,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,k),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(m=>m.provider!==d),this._debugServiceProxy.$unregisterDebugConfigurationProvider(k)})}registerDebugAdapterDescriptorFactory(i,d,y){if(!y)return new C.Disposable(()=>{});if(!this.definesDebugType(i,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.getAdapterDescriptorFactoryByType(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const k=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:d,handle:k,factory:y}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(d,k),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(m=>m.factory!==y),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(k)})}registerDebugAdapterTrackerFactory(i,d){if(!d)return new C.Disposable(()=>{});const y=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:i,handle:y,factory:d}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(k=>k.factory!==d)})}async $runInTerminal(i,d){return Promise.resolve(void 0)}async $substituteVariables(i,d){if(!this._variableResolver){const[m,w]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(m||[],this._editorsService,w)}let y;const k=await this.getFolder(i);return k&&(y={uri:k.uri,name:k.name,index:k.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAny(y,d)}createDebugAdapter(i,d){if(i.type==="implementation")return new r(i.implementation)}createSignService(){}async $startDASession(i,d){const y=this,k=await this.getSession(d);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(k.type),k).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}' (extension might have failed to activate)`);const w=this.convertToDto(m),R=this.createDebugAdapter(w,k);if(!R)throw new Error(`Couldn't create a debug adapter for type '${k.type}'.`);const F=R;return this._debugAdapters.set(i,F),this.getDebugAdapterTrackers(k).then(B=>(B&&this._debugAdaptersTrackers.set(i,B),F.onMessage(async Q=>{if(Q.type==="request"&&Q.command==="handshake"){const J=Q,z={type:"response",seq:0,command:J.command,request_seq:J.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const ae=await this._signService.sign(J.arguments.value);z.body={signature:ae},F.sendResponse(z)}else throw new Error("no signer")}catch(ae){z.success=!1,z.message=ae.message,F.sendResponse(z)}}else B&&B.onDidSendMessage&&B.onDidSendMessage(Q),Q=(0,s.convertToVSCPaths)(Q,!0),y._debugServiceProxy.$acceptDAMessage(i,Q)}),F.onError(Q=>{B&&B.onError&&B.onError(Q),this._debugServiceProxy.$acceptDAError(i,Q.name,Q.message,Q.stack)}),F.onExit(Q=>{B&&B.onExit&&B.onExit((0,g.withNullAsUndefined)(Q),void 0),this._debugServiceProxy.$acceptDAExit(i,(0,g.withNullAsUndefined)(Q),void 0)}),B&&B.onWillStartSession&&B.onWillStartSession(),F.startSession()))})}$sendDAMessage(i,d){d=(0,s.convertToDAPaths)(d,!1);const y=this._debugAdaptersTrackers.get(i);y&&y.onWillReceiveMessage&&y.onWillReceiveMessage(d);const k=this._debugAdapters.get(i);k&&k.sendMessage(d)}$stopDASession(i){const d=this._debugAdaptersTrackers.get(i);this._debugAdaptersTrackers.delete(i),d&&d.onWillStopSession&&d.onWillStopSession();const y=this._debugAdapters.get(i);return this._debugAdapters.delete(i),y?y.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(i){const d=[],y=[],k=[];if(i.added)for(const m of i.added){const w=m.id;if(w&&!this._breakpoints.has(w)){let R;if(m.type==="function")R=new C.FunctionBreakpoint(m.functionName,m.enabled,m.condition,m.hitCondition,m.logMessage);else if(m.type==="data")R=new C.DataBreakpoint(m.label,m.dataId,m.canPersist,m.enabled,m.hitCondition,m.condition,m.logMessage);else{const F=S.URI.revive(m.uri);R=new C.SourceBreakpoint(new C.Location(F,new C.Position(m.line,m.character)),m.enabled,m.condition,m.hitCondition,m.logMessage)}R._id=w,this._breakpoints.set(w,R),d.push(R)}}if(i.removed)for(const m of i.removed){const w=this._breakpoints.get(m);w&&(this._breakpoints.delete(m),y.push(w))}if(i.changed){for(const m of i.changed)if(m.id){const w=this._breakpoints.get(m.id);if(w){if(w instanceof C.FunctionBreakpoint&&m.type==="function"){const R=w;R.enabled=m.enabled,R.condition=m.condition,R.hitCondition=m.hitCondition,R.logMessage=m.logMessage,R.functionName=m.functionName}else if(w instanceof C.SourceBreakpoint&&m.type==="source"){const R=w;R.enabled=m.enabled,R.condition=m.condition,R.hitCondition=m.hitCondition,R.logMessage=m.logMessage,R.location=new C.Location(S.URI.revive(m.uri),new C.Position(m.line,m.character))}k.push(w)}}}this.fireBreakpointChanges(d,y,k)}$provideDebugConfigurations(i,d,y){return(0,P.asPromise)(async()=>{const k=this.getConfigProviderByHandle(i);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const m=await this.getFolder(d);return k.provideDebugConfigurations(m,y)}).then(k=>{if(!k)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return k})}$resolveDebugConfiguration(i,d,y,k){return(0,P.asPromise)(async()=>{const m=this.getConfigProviderByHandle(i);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const w=await this.getFolder(d);return m.resolveDebugConfiguration(w,y,k)})}$resolveDebugConfigurationWithSubstitutedVariables(i,d,y,k){return(0,P.asPromise)(async()=>{const m=this.getConfigProviderByHandle(i);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const w=await this.getFolder(d);return m.resolveDebugConfigurationWithSubstitutedVariables(w,y,k)})}async $provideDebugAdapter(i,d){const y=this.getAdapterDescriptorFactoryByHandle(i);if(!y)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const k=await this.getSession(d);return this.getAdapterDescriptor(y,k).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}'`);return this.convertToDto(m)})}async $acceptDebugSessionStarted(i){const d=await this.getSession(i);this._onDidStartDebugSession.fire(d)}async $acceptDebugSessionTerminated(i){const d=await this.getSession(i);d&&(this._onDidTerminateDebugSession.fire(d),this._debugSessions.delete(d.id))}async $acceptDebugSessionActiveChanged(i){this._activeDebugSession=i?await this.getSession(i):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(i,d){const y=await this.getSession(i);y&&y._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(i,d){const k={session:await this.getSession(i),event:d.event,body:d.body};this._onDidReceiveDebugSessionCustomEvent.fire(k)}convertToDto(i){if(i instanceof C.DebugAdapterExecutable)return{type:"executable",command:i.command,args:i.args,options:i.options};if(i instanceof C.DebugAdapterServer)return{type:"server",port:i.port,host:i.host};if(i instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:i.path};if(i instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:i.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(i){const d=this._adapterFactories.filter(y=>y.type===i);if(d.length>0)return d[0].factory}getAdapterDescriptorFactoryByHandle(i){const d=this._adapterFactories.filter(y=>y.handle===i);if(d.length>0)return d[0].factory}getConfigProviderByHandle(i){const d=this._configProviders.filter(y=>y.handle===i);if(d.length>0)return d[0].provider}definesDebugType(i,d){if(i.contributes){const y=i.contributes.debuggers;if(y&&y.length>0){for(const k of y)if(k.label&&k.type&&k.type===d)return!0}}return!1}getDebugAdapterTrackers(i){const y=i.configuration.type,k=this._trackerFactories.filter(m=>m.type===y||m.type==="*").map(m=>(0,P.asPromise)(()=>m.factory.createDebugAdapterTracker(i)).then(w=>w,w=>null));return Promise.race([Promise.all(k).then(m=>{const w=m.filter(R=>!!R);if(w.length>0)return new t(w)}),new Promise((m,w)=>{const R=setTimeout(()=>{clearTimeout(R),w(new Error("timeout"))},1e3)})]).catch(m=>{})}async getAdapterDescriptor(i,d){const y=d.configuration.debugServer;if(typeof y=="number")return Promise.resolve(new C.DebugAdapterServer(y));if(i){const m=await this._extensionService.getExtensionRegistry();return(0,P.asPromise)(()=>i.createDebugAdapterDescriptor(d,this.daExecutableFromPackage(d,m))).then(w=>{if(w)return w})}const k=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(d,k))}daExecutableFromPackage(i,d){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(i,d,y){(i.length>0||d.length>0||y.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:i,removed:d,changed:y}))}async getSession(i){if(i)if(typeof i=="string"){const d=this._debugSessions.get(i);if(d)return d}else{let d=this._debugSessions.get(i.id);if(!d){const y=await this.getFolder(i.folderUri);d=new c(this._debugServiceProxy,i.id,i.type,i.name,y,i.configuration),this._debugSessions.set(d.id,d),this._debugServiceProxy.$sessionCached(d.id)}return d}throw new Error("cannot find session")}getFolder(i){if(i){const d=S.URI.revive(i);return this._workspaceService.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};b=Ve([qe(0,h.IExtHostRpcService),qe(1,n.IExtHostWorkspace),qe(2,A.IExtHostExtensionService),qe(3,I.IExtHostDocumentsAndEditors),qe(4,f.IExtHostConfiguration)],b),e.ExtHostDebugServiceBase=b;class c{constructor(i,d,y,k,m,w){this._debugServiceProxy=i,this._id=d,this._type=y,this._name=k,this._workspaceFolder=m,this._configuration=w}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(i){this._name=i,this._debugServiceProxy.$setDebugSessionName(this._id,i)}_acceptNameChanged(i){this._name=i}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(i,d){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,i,d)}getDebugProtocolBreakpoint(i){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,i.id)}}e.ExtHostDebugSession=c;class u{constructor(i){this.value=Object.freeze({append(d){i.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.ExtHostDebugConsole=u;class a extends p.AbstractVariableResolverService{constructor(i,d,y,k,m){super({getFolderUri:w=>{const R=i.filter(F=>F.name===w);if(R&&R.length>0)return R[0].uri},getWorkspaceFolderCount:()=>i.length,getConfigurationValue:(w,R)=>y.getConfiguration(void 0,w).get(R),getAppRoot:()=>k?k.VSCODE_CWD:void 0,getExecPath:()=>k?k.VSCODE_EXEC_PATH:void 0,getFilePath:()=>{if(d){const w=d.activeEditor();if(w)return _.normalize(w.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(d&&m){const w=d.activeEditor();if(w){const R=m.getWorkspaceFolder(w.document.uri);if(R)return _.normalize(R.uri.fsPath)}}},getSelectedText:()=>{if(d){const w=d.activeEditor();if(w&&!w.selection.isEmpty)return w.document.getText(w.selection)}},getLineNumber:()=>{if(d){const w=d.activeEditor();if(w)return String(w.selection.end.line+1)}}},void 0,k)}}e.ExtHostVariableResolverService=a;class t{constructor(i){this.trackers=i}onWillStartSession(){this.trackers.forEach(i=>i.onWillStartSession?i.onWillStartSession():void 0)}onWillReceiveMessage(i){this.trackers.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(i):void 0)}onDidSendMessage(i){this.trackers.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(i):void 0)}onWillStopSession(){this.trackers.forEach(i=>i.onWillStopSession?i.onWillStopSession():void 0)}onError(i){this.trackers.forEach(d=>d.onError?d.onError(i):void 0)}onExit(i,d){this.trackers.forEach(y=>y.onExit?y.onExit(i,d):void 0)}}class r extends D.AbstractDebugAdapter{constructor(i){super();this.implementation=i,i.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(i){this.implementation.handleMessage(i)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends b{constructor(i,d,y,k,m){super(i,d,y,k,m)}createVariableResolver(i,d,y){return new a(i,d,y)}};o=Ve([qe(0,h.IExtHostRpcService),qe(1,n.IExtHostWorkspace),qe(2,A.IExtHostExtensionService),qe(3,I.IExtHostDocumentsAndEditors),qe(4,f.IExtHostConfiguration)],o),e.WorkerExtHostDebugService=o}),define(we[216],Ee([0,1,77,2,5,34,33,25,13,27,4,35,36,19]),function(re,e,_,S,T,P,E,C,D,n,A,I,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(c,u,a,t,r,o,l){this._apiFactory=c,this._extensionRegistry=u,this._instaService=a,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=o,this._logService=l,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),_.mark("code/extHost/willWaitForConfig");const c=await this._extHostConfiguration.getConfigProvider();_.mark("code/extHost/didWaitForConfig");const u=await this._extHostExtensionService.getExtensionPathIndex();this.register(new h(this._apiFactory,u,this._extensionRegistry,c,this._logService)),this.register(this._instaService.createInstance(v)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(g,u,this._initData.environment.appUriScheme))}register(c){if(Array.isArray(c.nodeModuleName))for(let u of c.nodeModuleName)this._factories.set(u,c);else this._factories.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this._alternatives.push(u=>c.alternativeModuleName(u))}};s=Ve([qe(2,A.IInstantiationService),qe(3,P.IExtHostConfiguration),qe(4,I.IExtHostExtensionService),qe(5,n.IExtHostInitDataService),qe(6,f.ILogService)],s),e.RequireInterceptor=s;class h{constructor(c,u,a,t,r){this._apiFactory=c,this._extensionPaths=u,this._extensionRegistry=a,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(c,u){const a=this._extensionPaths.findSubstr(u.fsPath);if(a){let t=this._extApiImpl.get(C.ExtensionIdentifier.toKey(a.identifier));return t||(t=this._apiFactory(a,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(a.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,o)=>t+=`	${o} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${u.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(E.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(c,u){this.nodeModuleName="keytar";const{environment:a}=u,t=c.getProxy(T.MainContext.MainThreadKeytar);if(a.appRoot){let r=a.appRoot.fsPath;p.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,o)=>t.$getPassword(r,o),setPassword:(r,o,l)=>t.$setPassword(r,o,l),deletePassword:(r,o)=>t.$deletePassword(r,o),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(c,u){return this._impl}alternativeModuleName(c){const u=c.length;if(!(u<=7||!this.alternativeNames)){const a=u-7;if((c.charAt(a)==="/"||c.charAt(a)==="\\")&&c.endsWith("keytar")&&(c=c.replace(/\\/g,"/"),this.alternativeNames.has(c)))return"keytar"}}};v=Ve([qe(0,D.IExtHostRpcService),qe(1,n.IExtHostInitDataService)],v);let g=class{constructor(c,u,a){this._extensionPaths=c,this._appUriScheme=u,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=a.getProxy(T.MainContext.MainThreadTelemetry);const t=a.getProxy(T.MainContext.MainThreadWindow);this._impl=(r,o)=>{const l=S.URI.parse(r);return o?this.callOriginal(r,o):l.scheme==="http"||l.scheme==="https"?t.$openUri(l,r,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this._appUriScheme?t.$openUri(l,r,{}):this.callOriginal(r,o)}}load(c,u,a){const t=this._extensionPaths.findSubstr(u.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=a(c),this._impl}callOriginal(c,u){return this.sendNoForwardTelemetry(),this._original(c,u)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};g=Ve([qe(2,D.IExtHostRpcService)],g)}),define(we[217],Ee([0,1,15,11,77,6,2,5,209,19,62,66,27,147,13,69,35,42]),function(re,e,_,S,T,P,E,C,D,n,A,I,p,f,s,h,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(u,a,t,r){this._disposables=new P.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const o=new D.RPCProtocol(u,null,r);a=b._transform(a,o);const l=new I.ServiceCollection(...(0,A.getSingletonServiceDescriptors)());l.set(p.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},a)),l.set(s.IExtHostRpcService,new s.ExtHostRpcService(o)),l.set(h.IURITransformerService,new h.URITransformerService(r)),l.set(v.IHostUtils,t);const i=new f.InstantiationService(l,!0),d=i.invokeFunction(w=>w.get(g.IExtHostTerminalService));this._disposables.add(d),this._logService=i.invokeFunction(w=>w.get(n.ILogService)),T.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",a),this._extensionService=i.invokeFunction(w=>w.get(v.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const y=new WeakMap;this._extensionService.getExtensionPathIndex().then(w=>{Error.prepareStackTrace=(R,F)=>{let B="",Q,J;for(const z of F)B+=`
	at ${z.toString()}`,J=z.getFileName(),!Q&&J&&(Q=w.findSubstr(J));return y.set(R,Q),`${R.name||"Error"}: ${R.message||""}${B}`}});const k=o.getProxy(C.MainContext.MainThreadExtensionService),m=o.getProxy(C.MainContext.MainThreadErrors);S.setUnexpectedErrorHandler(w=>{const R=S.transformErrorForSerialization(w),F=y.get(w);F?k.$onExtensionRuntimeError(F.identifier,R):m.$onUnexpectedError(R)})}terminate(u){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${u}`),this._logService.flush(),this._disposables.dispose(),S.setUnexpectedErrorHandler(t=>{});const a=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,_.timeout)(4e3),a]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(u,a){u.extensions.forEach(r=>r.extensionLocation=E.URI.revive(a.transformIncomingURIs(r.extensionLocation))),u.environment.appRoot=E.URI.revive(a.transformIncomingURIs(u.environment.appRoot));const t=u.environment.extensionDevelopmentLocationURI;return t&&(u.environment.extensionDevelopmentLocationURI=t.map(r=>E.URI.revive(a.transformIncomingURIs(r)))),u.environment.extensionTestsLocationURI=E.URI.revive(a.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=E.URI.revive(a.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=E.URI.revive(a.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=E.URI.revive(a.transformIncomingURIs(u.logsLocation)),u.logFile=E.URI.revive(a.transformIncomingURIs(u.logFile)),u.workspace=a.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=b}),define(we[218],Ee([0,1,10,20,61,28,23,55,43,36]),function(re,e,_,S,T,P,E,C,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(f,s,h){this.config=f,this.provider=s,this.sessionToken=h,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=f.filePattern,this.includePattern=f.includePattern&&P.parse(f.includePattern),this.maxResults=f.maxResults||void 0,this.exists=f.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=f.excludePattern&&P.parse(f.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(f=>f.cancel()),this.activeCancellationTokens=new Set}search(f){const s=this.config.folderQueries||[];return new Promise((h,v)=>{const g=b=>{this.resultCount++,f(b)};if(this.isCanceled)return h({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(b=>{const c=b.toString(),u=_.basename(c);this.globalExcludePattern&&this.globalExcludePattern(c,u)||this.matchFile(g,{base:b,basename:u})}),Promise.all(s.map(b=>this.searchInFolder(b,g))).then(b=>{h({limitHit:this.isLimitHit,stats:b[0]||void 0})},b=>{v(new Error((0,T.toErrorMessage)(b)))})})}searchInFolder(f,s){const h=new S.CancellationTokenSource;return new Promise((v,g)=>{const b=this.getSearchOptionsForFolder(f),c=this.initDirectoryTree(),u=new D.QueryGlobTester(this.config,f),a=!u.hasSiblingExcludeClauses();let t;new Promise(r=>(0,n.nextTick)(r)).then(()=>(this.activeCancellationTokens.add(h),t=C.StopWatch.create(),this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},b,h.token))).then(r=>{const o=t.elapsed(),l=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(i=>{const d=_.posix.relative(f.folder.path,i.path);if(a){const y=_.basename(i.path);this.matchFile(s,{base:f.folder,relativePath:d,basename:y});return}this.addDirectoryEntries(c,f.folder,d,s)}),this.activeCancellationTokens.delete(h),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(c,u,s),{providerTime:o,postProcessTime:l.elapsed()})}).then(r=>{h.dispose(),v(r)},r=>{h.dispose(),g(r)})})}getSearchOptionsForFolder(f){const s=(0,D.resolvePatternsForProvider)(this.config.includePattern,f.includePattern),h=(0,D.resolvePatternsForProvider)(this.config.excludePattern,f.excludePattern);return{folder:f.folder,excludes:h,includes:s,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}addDirectoryEntries({pathToEntries:f},s,h,v){if(h===this.filePattern){const b=_.basename(this.filePattern);this.matchFile(v,{base:s,relativePath:this.filePattern,basename:b})}function g(b){const c=_.basename(b),u=_.dirname(b);let a=f[u];a||(a=f[u]=[],g(u)),a.push({base:s,relativePath:b,basename:c})}g(h)}matchDirectoryTree({rootEntries:f,pathToEntries:s},h,v){const g=this,b=this.filePattern;function c(u){const a=P.hasSiblingFn(()=>u.map(t=>t.basename));for(let t=0,r=u.length;t<r;t++){const o=u[t],{relativePath:l,basename:i}=o;if(!!h.includedInQuerySync(l,i,b!==i?a:void 0)){const d=s[l];if(d)c(d);else{if(l===b)continue;g.matchFile(v,o)}if(g.isLimitHit)break}}}c(f)}matchFile(f,s){(!this.includePattern||s.relativePath&&this.includePattern(s.relativePath,s.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||f(s))}}class I{constructor(){this.sessions=new Map}fileSearch(f,s,h,v){const g=this.getSessionTokenSource(f.cacheKey),b=new A(f,s,g&&g.token);let c=0;const u=a=>{c+=a.length,h(a.map(t=>this.rawMatchToSearchItem(t)))};return this.doSearch(b,I.BATCH_SIZE,u,v).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:a.stats}}))}clearCache(f){const s=this.getSessionTokenSource(f);s&&s.cancel()}getSessionTokenSource(f){if(!!f)return this.sessions.has(f)||this.sessions.set(f,new S.CancellationTokenSource),this.sessions.get(f)}rawMatchToSearchItem(f){return f.relativePath?{resource:E.joinPath(f.base,f.relativePath)}:{resource:f.base}}doSearch(f,s,h,v){v.onCancellationRequested(()=>{f.cancel()});const g=c=>{c&&(b.push(c),s>0&&b.length>=s&&(h(b),b=[]))};let b=[];return f.search(g).then(c=>(b.length&&h(b),c),c=>(b.length&&h(b),Promise.reject(c)))}}e.FileSearchManager=I,I.BATCH_SIZE=512}),define(we[219],Ee([0,1,10,14,20,61,23,28,2,43,36,16]),function(re,e,_,S,T,P,E,C,D,n,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class p{constructor(c,u,a){this.query=c,this.provider=u,this.fileUtils=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,u){const a=this.query.folderQueries||[],t=new T.CancellationTokenSource;return u.onCancellationRequested(()=>t.cancel()),new Promise((r,o)=>{this.collector=new s(c);let l=!1;const i=(d,y)=>{if(!l&&!this.isLimitHit){const k=this.resultSize(d);v(d)&&typeof this.query.maxResults=="number"&&this.resultCount+k>this.query.maxResults&&(this.isLimitHit=!0,l=!0,t.cancel(),d=this.trimResultToSize(d,this.query.maxResults-this.resultCount));const m=this.resultSize(d);this.resultCount+=m,(m>0||!v(d))&&this.collector.add(d,y)}};Promise.all(a.map((d,y)=>this.searchInFolder(d,k=>i(k,y),t.token))).then(d=>{t.dispose(),this.collector.flush();const y=d.some(k=>!!k&&!!k.limitHit);r({limitHit:this.isLimitHit||y,stats:{type:"textSearchProvider"}})},d=>{t.dispose();const y=(0,P.toErrorMessage)(d);o(new Error(y))})})}resultSize(c){return v(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,u){const a=Array.isArray(c.ranges)?c.ranges:[c.ranges],t=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:a.slice(0,u),preview:{matches:t.slice(0,u),text:c.preview.text},uri:c.uri}}searchInFolder(c,u,a){const t=new n.QueryGlobTester(this.query,c),r=[],o={report:i=>{if(!!this.validateProviderResult(i)){const d=c.folder.scheme===I.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(E.dirname(i.uri))):void 0,y=E.relativePath(c.folder,i.uri);y&&r.push(t.includedInQuery(y,_.basename(y),d).then(k=>{k&&u(i)}))}}},l=this.getSearchOptionsForFolder(c);return new Promise(i=>(0,A.nextTick)(i)).then(()=>this.provider.provideTextSearchResults(f(this.query.contentPattern),l,o,a)).then(i=>Promise.all(r).then(()=>i))}validateProviderResult(c){if(v(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const u=(0,n.resolvePatternsForProvider)(this.query.includePattern,c.includePattern),a=(0,n.resolvePatternsForProvider)(this.query.excludePattern,c.excludePattern),t={folder:D.URI.from(c.folder),excludes:a,includes:u,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=p;function f(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class s{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new g(512,u=>this.sendItems(u))}add(c,u){this._currentFileMatch&&(this._currentFolderIdx!==u||!E.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=u,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(h(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=s;function h(b){return v(b)?{preview:{matches:(0,S.mapArrayOrNot)(b.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:b.preview.text},ranges:(0,S.mapArrayOrNot)(b.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function v(b){return!!b.preview}e.extensionResultIsMatch=v;class g{constructor(c,u){this.maxBatchSize=c,this.cb=u,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,u){!c||this.addItemToBatch(c,u)}addItems(c,u){!c||this.addItemsToBatch(c,u)}addItemToBatch(c,u){this.batch.push(c),this.batchSize+=u,this.onUpdate()}addItemsToBatch(c,u){this.batch=this.batch.concat(c),this.batchSize+=u,this.onUpdate()}onUpdate(){this.totalNumberCompleted<g.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},g.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=g,g.TIMEOUT=4e3,g.START_BATCH_AFTER_COUNT=50}),define(we[102],Ee([0,1,6,5,4,218,13,69,19,2,219]),function(re,e,_,S,T,P,E,C,D,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,T.createDecorator)("IExtHostSearch");let I=class{constructor(h,v,g){this.extHostRpc=h,this._uriTransformer=v,this._logService=g,this._proxy=this.extHostRpc.getProxy(S.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,v){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const g=this._handlePool++;return this._textSearchProvider.set(g,v),this._proxy.$registerTextSearchProvider(g,this._transformScheme(h)),(0,_.toDisposable)(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}registerFileSearchProvider(h,v){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const g=this._handlePool++;return this._fileSearchProvider.set(g,v),this._proxy.$registerFileSearchProvider(g,this._transformScheme(h)),(0,_.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}$provideFileSearchResults(h,v,g,b){const c=p(g),u=this._fileSearchProvider.get(h);if(u)return this._fileSearchManager.fileSearch(c,u,a=>{this._proxy.$handleFileMatch(h,v,a.map(t=>t.resource))},b);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,v,g,b){const c=this._textSearchProvider.get(h);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const u=p(g);return this.createTextSearchManager(u,c).search(t=>this._proxy.$handleTextMatch(h,v,t),b)}createTextSearchManager(h,v){return new A.TextSearchManager(h,v,{readdir:g=>Promise.resolve([]),toCanonicalName:g=>g})}};I=Ve([qe(0,E.IExtHostRpcService),qe(1,C.IURITransformerService),qe(2,D.ILogService)],I),e.ExtHostSearch=I;function p(s){return Object.assign(Object.assign({},s),{folderQueries:s.folderQueries&&s.folderQueries.map(f),extraFileResources:s.extraFileResources&&s.extraFileResources.map(h=>n.URI.revive(h))})}e.reviveQuery=p;function f(s){return Object.assign(Object.assign({},s),{folder:n.URI.revive(s.folder)})}});var tt=this&&this.__classPrivateFieldSet||function(re,e,_){if(!e.has(re))throw new TypeError("attempted to set private field on non-instance");return e.set(re,_),_},We=this&&this.__classPrivateFieldGet||function(re,e){if(!e.has(re))throw new TypeError("attempted to get private field on non-instance");return e.get(re)};define(we[220],Ee([0,1,126,20,11,3,10,57,2,120,82,114,60,65,5,186,185,73,187,34,188,189,190,172,191,41,35,192,173,194,195,196,98,176,198,199,200,75,42,201,177,9,7,204,50,99,31,33,23,51,159,193,91,97,100,101,102,19,69,13,27,197,165,68,72,183,202,164,76,74,207,205,206,184,49,213,203,71,156,93]),function(re,e,_,S,T,P,E,C,D,n,A,I,p,f,s,h,v,g,b,c,u,a,t,r,o,l,i,d,y,k,m,w,R,F,B,Q,J,z,ae,L,N,H,O,K,le,ue,pe,ve,Re,He,Fe,ze,$,G,te,ie,he,De,Le,me,Ce,ke,Ue,be,je,V,Z,_e,Me,$e,Ne,Je,x,ee,ce,j,X,se,de,Se){"use strict";var xe,Oe,Be;Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Qe(et){const Xe=et.get(Ce.IExtHostInitDataService),fe=et.get(ce.IExtHostFileSystemInfo),ye=et.get($e.IExtHostConsumerFileSystem),oe=et.get(i.IExtHostExtensionService),q=et.get(pe.IExtHostWorkspace),Ie=et.get(Se.IExtHostTelemetry),Pe=et.get(c.IExtHostConfiguration),Ze=et.get(Le.IURITransformerService),Ae=et.get(me.IExtHostRpcService),it=et.get(z.IExtHostStorage),st=et.get(Me.IExtensionStoragePaths),Ge=et.get(De.ILogService),ut=et.get(be.IExtHostTunnelService),ot=et.get(je.IExtHostApiDeprecationService),ct=et.get(ue.IExtHostWindow),Ct=et.get(se.IExtHostSecretState);Ae.set(s.ExtHostContext.ExtHostFileSystemInfo,fe),Ae.set(s.ExtHostContext.ExtHostLogService,Ge),Ae.set(s.ExtHostContext.ExtHostWorkspace,q),Ae.set(s.ExtHostContext.ExtHostConfiguration,Pe),Ae.set(s.ExtHostContext.ExtHostExtensionService,oe),Ae.set(s.ExtHostContext.ExtHostStorage,it),Ae.set(s.ExtHostContext.ExtHostTunnelService,ut),Ae.set(s.ExtHostContext.ExtHostWindow,ct),Ae.set(s.ExtHostContext.ExtHostSecretState,Ct),Ae.set(s.ExtHostContext.ExtHostTelemetry,Ie);const yt=Ae.set(s.ExtHostContext.ExtHostDecorations,et.get(G.IExtHostDecorations)),pt=Ae.set(s.ExtHostContext.ExtHostDocumentsAndEditors,et.get(l.IExtHostDocumentsAndEditors)),lt=Ae.set(s.ExtHostContext.ExtHostCommands,et.get(g.IExtHostCommands)),ft=Ae.set(s.ExtHostContext.ExtHostTerminalService,et.get(ae.IExtHostTerminalService)),dt=Ae.set(s.ExtHostContext.ExtHostDebugService,et.get(ie.IExtHostDebugService)),kt=Ae.set(s.ExtHostContext.ExtHostSearch,et.get(he.IExtHostSearch)),Et=Ae.set(s.ExtHostContext.ExtHostTask,et.get(te.IExtHostTask)),It=Ae.set(s.ExtHostContext.ExtHostOutputService,et.get(R.IExtHostOutputService)),Ot=Ae.set(s.ExtHostContext.ExtHostEditorTabs,new de.ExtHostEditorTabs),Nt=Ae.set(s.ExtHostContext.ExtHostUrls,new K.ExtHostUrls(Ae)),wt=Ae.set(s.ExtHostContext.ExtHostDocuments,new o.ExtHostDocuments(Ae,pt)),Ht=Ae.set(s.ExtHostContext.ExtHostDocumentContentProviders,new t.ExtHostDocumentContentProvider(Ae,pt,Ge)),zt=Ae.set(s.ExtHostContext.ExtHostDocumentSaveParticipant,new r.ExtHostDocumentSaveParticipant(Ge,wt,Ae.getProxy(s.MainContext.MainThreadBulkEdits))),gt=Ae.set(s.ExtHostContext.ExtHostNotebook,new ke.ExtHostNotebookController(Ae,lt,pt,Xe.environment,Ge,st)),St=Ae.set(s.ExtHostContext.ExtHostEditors,new L.ExtHostEditors(Ae,pt)),Ut=Ae.set(s.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(Ae.getProxy(s.MainContext.MainThreadTreeViews),lt,Ge)),Vt=Ae.set(s.ExtHostContext.ExtHostEditorInsets,new Fe.ExtHostEditorInsets(Ae.getProxy(s.MainContext.MainThreadEditorInsets),St,Xe.environment)),Wt=Ae.set(s.ExtHostContext.ExtHostDiagnostics,new u.ExtHostDiagnostics(Ae,Ge)),at=Ae.set(s.ExtHostContext.ExtHostLanguageFeatures,new k.ExtHostLanguageFeatures(Ae,Ze,wt,lt,Wt,Ge,ot)),dn=Ae.set(s.ExtHostContext.ExtHostFileSystem,new d.ExtHostFileSystem(Ae,at)),Pt=Ae.set(s.ExtHostContext.ExtHostFileSystemEventService,new y.ExtHostFileSystemEventService(Ae,Ge,pt)),Ft=Ae.set(s.ExtHostContext.ExtHostQuickOpen,(0,B.createExtHostQuickOpen)(Ae,q,lt)),$t=Ae.set(s.ExtHostContext.ExtHostSCM,new Q.ExtHostSCM(Ae,lt,Ge)),jt=Ae.set(s.ExtHostContext.ExtHostComments,new b.ExtHostComments(Ae,lt,wt)),tn=Ae.set(s.ExtHostContext.ExtHostProgress,new F.ExtHostProgress(Ae.getProxy(s.MainContext.MainThreadProgress))),hn=Ae.set(s.ExtHostContext.ExtHosLabelService,new ze.ExtHostLabelService(Ae)),nn=Ae.set(s.ExtHostContext.ExtHostTheming,new Ue.ExtHostTheming(Ae)),Rt=Ae.set(s.ExtHostContext.ExtHostAuthentication,new V.ExtHostAuthentication(Ae)),Bt=Ae.set(s.ExtHostContext.ExtHostTimeline,new Z.ExtHostTimeline(Ae,lt)),qt=Ae.set(s.ExtHostContext.ExtHostWebviews,new le.ExtHostWebviews(Ae,Xe.environment,q,Ge,ot)),Kt=Ae.set(s.ExtHostContext.ExtHostWebviewPanels,new x.ExtHostWebviewPanels(Ae,qt,q)),Gt=Ae.set(s.ExtHostContext.ExtHostCustomEditors,new Je.ExtHostCustomEditors(Ae,wt,st,qt,Kt)),fn=Ae.set(s.ExtHostContext.ExtHostWebviewViews,new Ne.ExtHostWebviewViews(Ae,qt)),At=Ae.set(s.ExtHostContext.ExtHostTesting,new j.ExtHostTesting(Ae,pt,q)),Qt=Ae.set(s.ExtHostContext.ExtHostUriOpeners,new X.ExtHostUriOpeners(Ae)),Jt=(0,He.values)(s.ExtHostContext);Ae.assertRegistered(Jt);const mn=new ee.ExtHostBulkEdits(Ae,pt),gn=new v.ExtHostClipboard(Ae),Lt=new w.ExtHostMessageService(Ae,Ge),rn=new a.ExtHostDialogs(Ae),sn=new J.ExtHostStatusBar(Ae,lt.converter),Yt=new m.ExtHostLanguages(Ae,wt);return h.ExtHostApiCommands.register(lt),function(Te,Xt,Zt){const ht=function(){let U=!Te.isUnderDevelopment;function Y(ge){U||(Ge.info(`Extension '${Te.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),U=!0)}return function ge(Ke){if(Array.isArray(Ke))Ke.forEach(ge);else if(typeof Ke=="string")Y(Ke);else{const Ye=Ke;typeof Ye.scheme=="undefined"&&Y(Ke),!Te.enableProposedApi&&typeof Ye.exclusive=="boolean"&&(0,ve.throwProposedApiError)(Te)}return Ke}}(),pn={getSession(U,Y,ge){return Rt.getSession(Te,U,Y,ge)},get onDidChangeSessions(){return Rt.onDidChangeSessions},registerAuthenticationProvider(U,Y,ge,Ke){return Rt.registerAuthenticationProvider(U,Y,ge,Ke)},get onDidChangeAuthenticationProviders(){return(0,ve.checkProposedApiEnabled)(Te),Rt.onDidChangeAuthenticationProviders},get providers(){return(0,ve.checkProposedApiEnabled)(Te),Rt.providers},logout(U,Y){return(0,ve.checkProposedApiEnabled)(Te),Rt.removeSession(U,Y)}},vn={registerCommand(U,Y,ge){return lt.registerCommand(!0,U,Y,ge)},registerTextEditorCommand(U,Y,ge){return lt.registerCommand(!0,U,(...Ke)=>{const Ye=St.getActiveTextEditor();if(!Ye){Ge.warn("Cannot execute "+U+" because there is no active text editor.");return}return Ye.edit(rt=>{Y.apply(ge,[Ye,rt,...Ke])}).then(rt=>{rt||Ge.warn("Edits from command "+U+" were not applied.")},rt=>{Ge.warn("An error occurred while running command "+U,rt)})})},registerDiffInformationCommand:(U,Y,ge)=>((0,ve.checkProposedApiEnabled)(Te),lt.registerCommand(!0,U,async(...Ke)=>{const Ye=pt.activeEditor(!0);if(!Ye){Ge.warn("Cannot execute "+U+" because there is no active text editor.");return}const rt=await St.getDiffInformation(Ye.id);Y.apply(ge,[rt,...Ke])})),executeCommand(U,...Y){return lt.executeCommand(U,...Y)},getCommands(U=!1){return lt.getCommands(U)}},on={get machineId(){return Xe.telemetryInfo.machineId},get sessionId(){return Xe.telemetryInfo.sessionId},get language(){return Xe.environment.appLanguage},get appName(){return Xe.environment.appName},get appRoot(){var U,Y;return(Y=(U=Xe.environment.appRoot)===null||U===void 0?void 0:U.fsPath)!==null&&Y!==void 0?Y:""},get uriScheme(){return Xe.environment.appUriScheme},get clipboard(){return gn.value},get shell(){return ft.getDefaultShell(!1,Zt)},get isTelemetryEnabled(){return(0,ve.checkProposedApiEnabled)(Te),Ie.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return(0,ve.checkProposedApiEnabled)(Te),Ie.onDidChangeTelemetryEnabled},openExternal(U,Y){return ct.openUri(U,{allowTunneling:!!Xe.remote.authority,allowContributedOpeners:Y==null?void 0:Y.allowContributedOpeners})},asExternalUri(U){return U.scheme===Xe.environment.appUriScheme?Nt.createAppUri(U):ct.asExternalUri(U,{allowTunneling:!!Xe.remote.authority})},get remoteName(){return(0,$.getRemoteName)(Xe.remote.authority)},get uiKind(){return Xe.uiKind}};Xe.environment.extensionTestsLocationURI||Object.freeze(on);const an=Xe.remote.isRemote?O.ExtensionKind.Workspace:O.ExtensionKind.UI,_n={registerTestProvider(U){return(0,ve.checkProposedApiEnabled)(Te),At.registerTestProvider(U)},createDocumentTestObserver(U){return(0,ve.checkProposedApiEnabled)(Te),At.createTextDocumentTestObserver(U)},createWorkspaceTestObserver(U){return(0,ve.checkProposedApiEnabled)(Te),At.createWorkspaceTestObserver(U)},runTests(U){return(0,ve.checkProposedApiEnabled)(Te),At.runTests(U)},publishTestResult(U,Y=!0){return(0,ve.checkProposedApiEnabled)(Te),At.publishExtensionProvidedResults(U,Y)},get onDidChangeTestResults(){return(0,ve.checkProposedApiEnabled)(Te),At.onResultsChanged},get testResults(){return(0,ve.checkProposedApiEnabled)(Te),At.results}},ln={getExtension(U){const Y=Xt.getExtensionDescription(U);if(Y)return new nt(oe,Te.identifier,Y,an)},get all(){return Xt.getAllExtensionDescriptions().map(U=>new nt(oe,Te.identifier,U,an))},get onDidChange(){return Xt.onDidChange}},bn={createDiagnosticCollection(U){return Wt.createDiagnosticCollection(Te.identifier,U)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:U=>Wt.getDiagnostics(U),getLanguages(){return Yt.getLanguages()},setTextDocumentLanguage(U,Y){return Yt.changeLanguage(U.uri,Y)},match(U,Y){return(0,p.score)(H.LanguageSelector.from(U),Y.uri,Y.languageId,!0)},registerCodeActionsProvider(U,Y,ge){return at.registerCodeActionProvider(Te,ht(U),Y,ge)},registerCodeLensProvider(U,Y){return at.registerCodeLensProvider(Te,ht(U),Y)},registerDefinitionProvider(U,Y){return at.registerDefinitionProvider(Te,ht(U),Y)},registerDeclarationProvider(U,Y){return at.registerDeclarationProvider(Te,ht(U),Y)},registerImplementationProvider(U,Y){return at.registerImplementationProvider(Te,ht(U),Y)},registerTypeDefinitionProvider(U,Y){return at.registerTypeDefinitionProvider(Te,ht(U),Y)},registerHoverProvider(U,Y){return at.registerHoverProvider(Te,ht(U),Y,Te.identifier)},registerEvaluatableExpressionProvider(U,Y){return at.registerEvaluatableExpressionProvider(Te,ht(U),Y,Te.identifier)},registerInlineValuesProvider(U,Y){return(0,ve.checkProposedApiEnabled)(Te),at.registerInlineValuesProvider(Te,ht(U),Y,Te.identifier)},registerDocumentHighlightProvider(U,Y){return at.registerDocumentHighlightProvider(Te,ht(U),Y)},registerLinkedEditingRangeProvider(U,Y){return at.registerLinkedEditingRangeProvider(Te,ht(U),Y)},registerReferenceProvider(U,Y){return at.registerReferenceProvider(Te,ht(U),Y)},registerRenameProvider(U,Y){return at.registerRenameProvider(Te,ht(U),Y)},registerDocumentSymbolProvider(U,Y,ge){return at.registerDocumentSymbolProvider(Te,ht(U),Y,ge)},registerWorkspaceSymbolProvider(U){return at.registerWorkspaceSymbolProvider(Te,U)},registerDocumentFormattingEditProvider(U,Y){return at.registerDocumentFormattingEditProvider(Te,ht(U),Y)},registerDocumentRangeFormattingEditProvider(U,Y){return at.registerDocumentRangeFormattingEditProvider(Te,ht(U),Y)},registerOnTypeFormattingEditProvider(U,Y,ge,...Ke){return at.registerOnTypeFormattingEditProvider(Te,ht(U),Y,[ge].concat(Ke))},registerDocumentSemanticTokensProvider(U,Y,ge){return at.registerDocumentSemanticTokensProvider(Te,ht(U),Y,ge)},registerDocumentRangeSemanticTokensProvider(U,Y,ge){return at.registerDocumentRangeSemanticTokensProvider(Te,ht(U),Y,ge)},registerSignatureHelpProvider(U,Y,ge,...Ke){return typeof ge=="object"?at.registerSignatureHelpProvider(Te,ht(U),Y,ge):at.registerSignatureHelpProvider(Te,ht(U),Y,typeof ge=="undefined"?[]:[ge,...Ke])},registerCompletionItemProvider(U,Y,...ge){return at.registerCompletionItemProvider(Te,ht(U),Y,ge)},registerDocumentLinkProvider(U,Y){return at.registerDocumentLinkProvider(Te,ht(U),Y)},registerColorProvider(U,Y){return at.registerColorProvider(Te,ht(U),Y)},registerFoldingRangeProvider(U,Y){return at.registerFoldingRangeProvider(Te,ht(U),Y)},registerSelectionRangeProvider(U,Y){return at.registerSelectionRangeProvider(Te,U,Y)},registerCallHierarchyProvider(U,Y){return at.registerCallHierarchyProvider(Te,U,Y)},setLanguageConfiguration:(U,Y)=>at.setLanguageConfiguration(Te,U,Y),getTokenInformationAtPosition(U,Y){return(0,ve.checkProposedApiEnabled)(Te),Yt.tokenAtPosition(U,Y)},registerInlineHintsProvider(U,Y){return(0,ve.checkProposedApiEnabled)(Te),at.registerInlineHintsProvider(Te,U,Y)}},wn={get activeTextEditor(){return St.getActiveTextEditor()},get visibleTextEditors(){return St.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(U,Y,ge){const Ke=await(D.URI.isUri(U)?Promise.resolve(xt.openTextDocument(U)):Promise.resolve(U));return St.showTextDocument(Ke,Y,ge)},createTextEditorDecorationType(U){return St.createTextEditorDecorationType(U)},onDidChangeActiveTextEditor(U,Y,ge){return St.onDidChangeActiveTextEditor(U,Y,ge)},onDidChangeVisibleTextEditors(U,Y,ge){return St.onDidChangeVisibleTextEditors(U,Y,ge)},onDidChangeTextEditorSelection(U,Y,ge){return St.onDidChangeTextEditorSelection(U,Y,ge)},onDidChangeTextEditorOptions(U,Y,ge){return St.onDidChangeTextEditorOptions(U,Y,ge)},onDidChangeTextEditorVisibleRanges(U,Y,ge){return St.onDidChangeTextEditorVisibleRanges(U,Y,ge)},onDidChangeTextEditorViewColumn(U,Y,ge){return St.onDidChangeTextEditorViewColumn(U,Y,ge)},onDidCloseTerminal(U,Y,ge){return ft.onDidCloseTerminal(U,Y,ge)},onDidOpenTerminal(U,Y,ge){return ft.onDidOpenTerminal(U,Y,ge)},onDidChangeActiveTerminal(U,Y,ge){return ft.onDidChangeActiveTerminal(U,Y,ge)},onDidChangeTerminalDimensions(U,Y,ge){return(0,ve.checkProposedApiEnabled)(Te),ft.onDidChangeTerminalDimensions(U,Y,ge)},onDidWriteTerminalData(U,Y,ge){return(0,ve.checkProposedApiEnabled)(Te),ft.onDidWriteTerminalData(U,Y,ge)},get state(){return ct.state},onDidChangeWindowState(U,Y,ge){return ct.onDidChangeWindowState(U,Y,ge)},showInformationMessage(U,...Y){return Lt.showMessage(Te,C.default.Info,U,Y[0],Y.slice(1))},showWarningMessage(U,...Y){return Lt.showMessage(Te,C.default.Warning,U,Y[0],Y.slice(1))},showErrorMessage(U,...Y){return Lt.showMessage(Te,C.default.Error,U,Y[0],Y.slice(1))},showQuickPick(U,Y,ge){return Ft.showQuickPick(U,!!Te.enableProposedApi,Y,ge)},showWorkspaceFolderPick(U){return Ft.showWorkspaceFolderPick(U)},showInputBox(U,Y){return Ft.showInput(U,Y)},showOpenDialog(U){return rn.showOpenDialog(U)},showSaveDialog(U){return rn.showSaveDialog(U)},createStatusBarItem(U,Y){let ge,Ke,Ye,rt;return U&&typeof U!="number"?(ge=U.id,Ke=U.name,Ye=U.alignment,Y=U.priority,rt=U.accessibilityInformation):(ge=Te.identifier.value,Ke=_.localize(0,null,Te.displayName||Te.name),Ye=U),sn.createStatusBarEntry(ge,Ke,Ye,Y,rt)},setStatusBarMessage(U,Y){return sn.setStatusBarMessage(U,Y)},withScmProgress(U){return ot.report("window.withScmProgress",Te,"Use 'withProgress' instead."),tn.withProgress(Te,{location:O.ProgressLocation.SourceControl},(Y,ge)=>U({report(Ke){}}))},withProgress(U,Y){return tn.withProgress(Te,U,Y)},createOutputChannel(U){return It.createOutputChannel(U)},createWebviewPanel(U,Y,ge,Ke){return Kt.createWebviewPanel(Te,U,Y,ge,Ke)},createWebviewTextEditorInset(U,Y,ge,Ke){return(0,ve.checkProposedApiEnabled)(Te),Vt.createWebviewEditorInset(U,Y,ge,Ke,Te)},createTerminal(U,Y,ge){return typeof U=="object"?"pty"in U?ft.createExtensionTerminal(U):ft.createTerminalFromOptions(U):ft.createTerminal(U,Y,ge)},registerTerminalLinkProvider(U){return ft.registerLinkProvider(U)},registerTreeDataProvider(U,Y){return Ut.registerTreeDataProvider(U,Y,Te)},createTreeView(U,Y){return Ut.createTreeView(U,Y,Te)},registerWebviewPanelSerializer:(U,Y)=>Kt.registerWebviewPanelSerializer(Te,U,Y),registerCustomEditorProvider:(U,Y,ge={})=>Gt.registerCustomEditorProvider(Te,U,Y,ge),registerFileDecorationProvider(U){return yt.registerFileDecorationProvider(U,Te.identifier)},registerUriHandler(U){return Nt.registerUriHandler(Te.identifier,U)},createQuickPick(){return Ft.createQuickPick(Te.identifier,!!Te.enableProposedApi)},createInputBox(){return Ft.createInputBox(Te.identifier)},get activeColorTheme(){return nn.activeColorTheme},onDidChangeActiveColorTheme(U,Y,ge){return nn.onDidChangeActiveColorTheme(U,Y,ge)},registerWebviewViewProvider(U,Y,ge){return fn.registerWebviewViewProvider(Te,U,Y,ge==null?void 0:ge.webviewOptions)},get activeNotebookEditor(){return(0,ve.checkProposedApiEnabled)(Te),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(U,Y,ge){return(0,ve.checkProposedApiEnabled)(Te),gt.onDidChangeActiveNotebookEditor(U,Y,ge)},get visibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Te),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Te),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(U,Y,ge){return(0,ve.checkProposedApiEnabled)(Te),gt.onDidChangeNotebookEditorSelection(U,Y,ge)},onDidChangeNotebookEditorVisibleRanges(U,Y,ge){return(0,ve.checkProposedApiEnabled)(Te),gt.onDidChangeNotebookEditorVisibleRanges(U,Y,ge)},showNotebookDocument(U,Y){return(0,ve.checkProposedApiEnabled)(Te),gt.showNotebookDocument(U,Y)},registerExternalUriOpener(U,Y,ge){return(0,ve.checkProposedApiEnabled)(Te),Qt.registerExternalUriOpener(Te.identifier,U,Y,ge)},get openEditors(){return(0,ve.checkProposedApiEnabled)(Te),Ot.tabs},get onDidChangeOpenEditors(){return(0,ve.checkProposedApiEnabled)(Te),Ot.onDidChangeTabs}},xt={get rootPath(){return ot.report("workspace.rootPath",Te,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),q.getPath()},set rootPath(U){throw T.readonly()},getWorkspaceFolder(U){return q.getWorkspaceFolder(U)},get workspaceFolders(){return q.getWorkspaceFolders()},get name(){return q.name},set name(U){throw T.readonly()},get workspaceFile(){return q.workspaceFile},set workspaceFile(U){throw T.readonly()},updateWorkspaceFolders:(U,Y,...ge)=>q.updateWorkspaceFolders(Te,U,Y||0,...ge),onDidChangeWorkspaceFolders:function(U,Y,ge){return q.onDidChangeWorkspace(U,Y,ge)},asRelativePath:(U,Y)=>q.getRelativePath(U,Y),findFiles:(U,Y,ge,Ke)=>q.findFiles(H.GlobPattern.from(U),H.GlobPattern.from(Y),ge,Te.identifier,Ke),findTextInFiles:(U,Y,ge,Ke)=>{let Ye,rt;return typeof Y=="object"?(Ye=Y,rt=ge):(Ye={},rt=Y,Ke=ge),q.findTextInFiles(U,Ye||{},rt,Te.identifier,Ke)},saveAll:U=>q.saveAll(U),applyEdit(U){return mn.applyWorkspaceEdit(U)},createFileSystemWatcher:(U,Y,ge,Ke)=>Pt.createFileSystemWatcher(H.GlobPattern.from(U),Y,ge,Ke),get textDocuments(){return wt.getAllDocumentData().map(U=>U.document)},set textDocuments(U){throw T.readonly()},openTextDocument(U){let Y;const ge=U;if(typeof U=="string")Y=Promise.resolve(D.URI.file(U));else if(D.URI.isUri(U))Y=Promise.resolve(U);else if(!ge||typeof ge=="object")Y=wt.createDocumentData(ge);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Y.then(Ke=>wt.ensureDocumentData(Ke).then(Ye=>Ye.document))},onDidOpenTextDocument:(U,Y,ge)=>wt.onDidAddDocument(U,Y,ge),onDidCloseTextDocument:(U,Y,ge)=>wt.onDidRemoveDocument(U,Y,ge),onDidChangeTextDocument:(U,Y,ge)=>wt.onDidChangeDocument(U,Y,ge),onDidSaveTextDocument:(U,Y,ge)=>wt.onDidSaveDocument(U,Y,ge),onWillSaveTextDocument:(U,Y,ge)=>zt.getOnWillSaveTextDocumentEvent(Te)(U,Y,ge),onDidChangeConfiguration:(U,Y,ge)=>Zt.onDidChangeConfiguration(U,Y,ge),getConfiguration(U,Y){return Y=arguments.length===1?void 0:Y,Zt.getConfiguration(U,Y,Te)},registerTextDocumentContentProvider(U,Y){return Ht.registerTextDocumentContentProvider(U,Y)},registerTaskProvider:(U,Y)=>(ot.report("window.registerTaskProvider",Te,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Te,U,Y)),registerFileSystemProvider(U,Y,ge){return dn.registerFileSystemProvider(Te.identifier,U,Y,ge)},get fs(){return ye.value},registerFileSearchProvider:(U,Y)=>((0,ve.checkProposedApiEnabled)(Te),kt.registerFileSearchProvider(U,Y)),registerTextSearchProvider:(U,Y)=>((0,ve.checkProposedApiEnabled)(Te),kt.registerTextSearchProvider(U,Y)),registerRemoteAuthorityResolver:(U,Y)=>((0,ve.checkProposedApiEnabled)(Te),oe.registerRemoteAuthorityResolver(U,Y)),registerResourceLabelFormatter:U=>((0,ve.checkProposedApiEnabled)(Te),hn.$registerResourceLabelFormatter(U)),onDidCreateFiles:(U,Y,ge)=>Pt.onDidCreateFile(U,Y,ge),onDidDeleteFiles:(U,Y,ge)=>Pt.onDidDeleteFile(U,Y,ge),onDidRenameFiles:(U,Y,ge)=>Pt.onDidRenameFile(U,Y,ge),onWillCreateFiles:(U,Y,ge)=>Pt.getOnWillCreateFileEvent(Te)(U,Y,ge),onWillDeleteFiles:(U,Y,ge)=>Pt.getOnWillDeleteFileEvent(Te)(U,Y,ge),onWillRenameFiles:(U,Y,ge)=>Pt.getOnWillRenameFileEvent(Te)(U,Y,ge),openTunnel:U=>((0,ve.checkProposedApiEnabled)(Te),ut.openTunnel(Te,U).then(Y=>{if(!Y)throw new Error("cannot open tunnel");return Y})),get tunnels(){return(0,ve.checkProposedApiEnabled)(Te),ut.getTunnels()},onDidChangeTunnels:(U,Y,ge)=>((0,ve.checkProposedApiEnabled)(Te),ut.onDidChangeTunnels(U,Y,ge)),registerTimelineProvider:(U,Y)=>((0,ve.checkProposedApiEnabled)(Te),Bt.registerTimelineProvider(U,Y,Te.identifier,lt.converter)),get trustState(){return(0,ve.checkProposedApiEnabled)(Te),(0,ve.checkRequiresWorkspaceTrust)(Te),q.trustState},requireWorkspaceTrust:U=>((0,ve.checkProposedApiEnabled)(Te),(0,ve.checkRequiresWorkspaceTrust)(Te),q.requireWorkspaceTrust(U)),onDidChangeWorkspaceTrustState:(U,Y,ge)=>q.onDidChangeWorkspaceTrustState(U,Y,ge)},En={get inputBox(){return ot.report("scm.inputBox",Te,"Use 'SourceControl.inputBox' instead"),$t.getLastInputBox(Te)},createSourceControl(U,Y,ge){return $t.createSourceControl(Te,U,Y,ge)}},Sn={createCommentController(U,Y){return jt.createCommentController(Te,U,Y)}},W={get activeDebugSession(){return dt.activeDebugSession},get activeDebugConsole(){return dt.activeDebugConsole},get breakpoints(){return dt.breakpoints},onDidStartDebugSession(U,Y,ge){return dt.onDidStartDebugSession(U,Y,ge)},onDidTerminateDebugSession(U,Y,ge){return dt.onDidTerminateDebugSession(U,Y,ge)},onDidChangeActiveDebugSession(U,Y,ge){return dt.onDidChangeActiveDebugSession(U,Y,ge)},onDidReceiveDebugSessionCustomEvent(U,Y,ge){return dt.onDidReceiveDebugSessionCustomEvent(U,Y,ge)},onDidChangeBreakpoints(U,Y,ge){return dt.onDidChangeBreakpoints(U,Y,ge)},registerDebugConfigurationProvider(U,Y,ge){return dt.registerDebugConfigurationProvider(U,Y,ge||O.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(U,Y){return dt.registerDebugAdapterDescriptorFactory(Te,U,Y)},registerDebugAdapterTrackerFactory(U,Y){return dt.registerDebugAdapterTrackerFactory(U,Y)},startDebugging(U,Y,ge){return!ge||typeof ge=="object"&&"configuration"in ge?dt.startDebugging(U,Y,{parentSession:ge}):dt.startDebugging(U,Y,ge||{})},stopDebugging(U){return dt.stopDebugging(U)},addBreakpoints(U){return dt.addBreakpoints(U)},removeBreakpoints(U){return dt.removeBreakpoints(U)},asDebugSourceUri(U,Y){return dt.asDebugSourceUri(U,Y)}},M={registerTaskProvider:(U,Y)=>Et.registerTaskProvider(Te,U,Y),fetchTasks:U=>Et.fetchTasks(U),executeTask:U=>Et.executeTask(Te,U),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(U,Y,ge)=>Et.onDidStartTask(U,Y,ge),onDidEndTask:(U,Y,ge)=>Et.onDidEndTask(U,Y,ge),onDidStartTaskProcess:(U,Y,ge)=>Et.onDidStartTaskProcess(U,Y,ge),onDidEndTaskProcess:(U,Y,ge)=>Et.onDidEndTaskProcess(U,Y,ge)},ne={openNotebookDocument:(U,Y)=>((0,ve.checkProposedApiEnabled)(Te),gt.openNotebookDocument(U,Y)),get onDidOpenNotebookDocument(){return(0,ve.checkProposedApiEnabled)(Te),gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,ve.checkProposedApiEnabled)(Te),gt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,ve.checkProposedApiEnabled)(Te),gt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,ve.checkProposedApiEnabled)(Te),gt.notebookDocuments.map(U=>U.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,ve.checkProposedApiEnabled)(Te),gt.onDidChangeActiveNotebookKernel},registerNotebookContentProvider:(U,Y,ge)=>((0,ve.checkProposedApiEnabled)(Te),gt.registerNotebookContentProvider(Te,U,Y,ge)),registerNotebookKernelProvider:(U,Y)=>((0,ve.checkProposedApiEnabled)(Te),gt.registerNotebookKernelProvider(Te,U,Y)),createNotebookEditorDecorationType(U){return(0,ve.checkProposedApiEnabled)(Te),gt.createNotebookEditorDecorationType(U)},onDidChangeNotebookDocumentMetadata(U,Y,ge){return(0,ve.checkProposedApiEnabled)(Te),gt.onDidChangeNotebookDocumentMetadata(U,Y,ge)},onDidChangeNotebookCells(U,Y,ge){return(0,ve.checkProposedApiEnabled)(Te),gt.onDidChangeNotebookCells(U,Y,ge)},onDidChangeCellOutputs(U,Y,ge){return(0,ve.checkProposedApiEnabled)(Te),gt.onDidChangeCellOutputs(U,Y,ge)},onDidChangeCellLanguage(U,Y,ge){return(0,ve.checkProposedApiEnabled)(Te),gt.onDidChangeCellLanguage(U,Y,ge)},onDidChangeCellMetadata(U,Y,ge){return(0,ve.checkProposedApiEnabled)(Te),gt.onDidChangeCellMetadata(U,Y,ge)},createConcatTextDocument(U,Y){return(0,ve.checkProposedApiEnabled)(Te),new _e.ExtHostNotebookConcatDocument(gt,wt,U,Y)},createCellStatusBarItem(U,Y,ge){return(0,ve.checkProposedApiEnabled)(Te),gt.createNotebookCellStatusBarItemInternal(U,Y,ge)}};return{version:Xe.version,authentication:pn,commands:vn,comments:Sn,debug:W,env:on,extensions:ln,languages:bn,notebook:ne,scm:En,tasks:M,test:_n,window:wn,workspace:xt,Breakpoint:O.Breakpoint,CallHierarchyIncomingCall:O.CallHierarchyIncomingCall,CallHierarchyItem:O.CallHierarchyItem,CallHierarchyOutgoingCall:O.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:S.CancellationTokenSource,CandidatePortSource:s.CandidatePortSource,CodeAction:O.CodeAction,CodeActionKind:O.CodeActionKind,CodeActionTriggerKind:O.CodeActionTriggerKind,CodeLens:O.CodeLens,Color:O.Color,ColorInformation:O.ColorInformation,ColorPresentation:O.ColorPresentation,ColorThemeKind:O.ColorThemeKind,CommentMode:O.CommentMode,CommentThreadCollapsibleState:O.CommentThreadCollapsibleState,CompletionItem:O.CompletionItem,CompletionItemKind:O.CompletionItemKind,CompletionItemTag:O.CompletionItemTag,CompletionList:O.CompletionList,CompletionTriggerKind:O.CompletionTriggerKind,ConfigurationTarget:O.ConfigurationTarget,CustomExecution:O.CustomExecution,DebugAdapterExecutable:O.DebugAdapterExecutable,DebugAdapterInlineImplementation:O.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:O.DebugAdapterNamedPipeServer,DebugAdapterServer:O.DebugAdapterServer,DebugConfigurationProviderTriggerKind:O.DebugConfigurationProviderTriggerKind,DebugConsoleMode:O.DebugConsoleMode,DecorationRangeBehavior:O.DecorationRangeBehavior,Diagnostic:O.Diagnostic,DiagnosticRelatedInformation:O.DiagnosticRelatedInformation,DiagnosticSeverity:O.DiagnosticSeverity,DiagnosticTag:O.DiagnosticTag,Disposable:O.Disposable,DocumentHighlight:O.DocumentHighlight,DocumentHighlightKind:O.DocumentHighlightKind,DocumentLink:O.DocumentLink,DocumentSymbol:O.DocumentSymbol,EndOfLine:O.EndOfLine,EnvironmentVariableMutatorType:O.EnvironmentVariableMutatorType,EvaluatableExpression:O.EvaluatableExpression,InlineValueText:O.InlineValueText,InlineValueVariableLookup:O.InlineValueVariableLookup,InlineValueEvaluatableExpression:O.InlineValueEvaluatableExpression,EventEmitter:P.Emitter,ExtensionKind:O.ExtensionKind,ExtensionMode:O.ExtensionMode,ExternalUriOpenerPriority:O.ExternalUriOpenerPriority,FileChangeType:O.FileChangeType,FileDecoration:O.FileDecoration,FileSystemError:O.FileSystemError,FileType:f.FileType,FoldingRange:O.FoldingRange,FoldingRangeKind:O.FoldingRangeKind,FunctionBreakpoint:O.FunctionBreakpoint,Hover:O.Hover,IndentAction:I.IndentAction,Location:O.Location,MarkdownString:O.MarkdownString,OverviewRulerLane:A.OverviewRulerLane,ParameterInformation:O.ParameterInformation,Position:O.Position,ProcessExecution:O.ProcessExecution,ProgressLocation:O.ProgressLocation,QuickInputButtons:O.QuickInputButtons,Range:O.Range,RelativePattern:O.RelativePattern,Selection:O.Selection,SelectionRange:O.SelectionRange,SemanticTokens:O.SemanticTokens,SemanticTokensBuilder:O.SemanticTokensBuilder,SemanticTokensEdit:O.SemanticTokensEdit,SemanticTokensEdits:O.SemanticTokensEdits,SemanticTokensLegend:O.SemanticTokensLegend,ShellExecution:O.ShellExecution,ShellQuoting:O.ShellQuoting,SignatureHelp:O.SignatureHelp,SignatureHelpTriggerKind:O.SignatureHelpTriggerKind,SignatureInformation:O.SignatureInformation,SnippetString:O.SnippetString,SourceBreakpoint:O.SourceBreakpoint,StandardTokenType:O.StandardTokenType,StatusBarAlignment:O.StatusBarAlignment,SymbolInformation:O.SymbolInformation,SymbolKind:O.SymbolKind,SymbolTag:O.SymbolTag,Task:O.Task,TaskGroup:O.TaskGroup,TaskPanelKind:O.TaskPanelKind,TaskRevealKind:O.TaskRevealKind,TaskScope:O.TaskScope,TextDocumentSaveReason:O.TextDocumentSaveReason,TextEdit:O.TextEdit,TextEditorCursorStyle:n.TextEditorCursorStyle,TextEditorLineNumbersStyle:O.TextEditorLineNumbersStyle,TextEditorRevealType:O.TextEditorRevealType,TextEditorSelectionChangeKind:O.TextEditorSelectionChangeKind,ThemeColor:O.ThemeColor,ThemeIcon:O.ThemeIcon,TreeItem:O.TreeItem,TreeItemCollapsibleState:O.TreeItemCollapsibleState,UIKind:s.UIKind,Uri:D.URI,ViewColumn:O.ViewColumn,WorkspaceEdit:O.WorkspaceEdit,InlineHint:O.InlineHint,InlineHintKind:O.InlineHintKind,RemoteAuthorityResolverError:O.RemoteAuthorityResolverError,ResolvedAuthority:O.ResolvedAuthority,SourceControlInputBoxValidationType:O.SourceControlInputBoxValidationType,ExtensionRuntime:O.ExtensionRuntime,TimelineItem:O.TimelineItem,NotebookCellRange:O.NotebookCellRange,NotebookCellKind:O.NotebookCellKind,NotebookCellRunState:O.NotebookCellRunState,NotebookDocumentMetadata:O.NotebookDocumentMetadata,NotebookCellMetadata:O.NotebookCellMetadata,NotebookCellData:O.NotebookCellData,NotebookData:O.NotebookData,NotebookRunState:O.NotebookRunState,NotebookCellStatusBarAlignment:O.NotebookCellStatusBarAlignment,NotebookEditorRevealType:O.NotebookEditorRevealType,NotebookCellOutput:O.NotebookCellOutput,NotebookCellOutputItem:O.NotebookCellOutputItem,LinkedEditingRanges:O.LinkedEditingRanges,TestItem:O.TestItem,TestState:O.TestState,TestResult:O.TestResult,TestMessage:O.TestMessage,TestMessageSeverity:O.TestMessageSeverity,WorkspaceTrustState:O.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Qe;class nt{constructor(Xe,fe,ye,oe){xe.set(this,void 0),Oe.set(this,void 0),Be.set(this,void 0),tt(this,xe,Xe),tt(this,Oe,fe),tt(this,Be,ye.identifier),this.id=ye.identifier.value,this.extensionUri=ye.extensionLocation,this.extensionPath=E.normalize((0,Re.originalFSPath)(ye.extensionLocation)),this.packageJSON=ye,this.extensionKind=oe}get isActive(){return We(this,xe).isActivated(We(this,Be))}get exports(){if(this.packageJSON.api!=="none")return We(this,xe).getExtensionExports(We(this,Be))}activate(){return We(this,xe).activateByIdWithErrors(We(this,Be),{startup:!1,extensionId:We(this,Oe),activationEvent:"api"}).then(()=>this.exports)}}xe=new WeakMap,Oe=new WeakMap,Be=new WeakMap}),define(we[221],Ee([0,1,62,98,31,97,34,73,41,42,100,101,102,76,75,68,72,99,74,49,71,93]),function(re,e,_,S,T,P,E,C,D,n,A,I,p,f,s,h,v,g,b,c,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(f.IExtensionStoragePaths,f.ExtensionStoragePaths),(0,_.registerSingleton)(v.IExtHostApiDeprecationService,v.ExtHostApiDeprecationService),(0,_.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,_.registerSingleton)(E.IExtHostConfiguration,E.ExtHostConfiguration),(0,_.registerSingleton)(b.IExtHostConsumerFileSystem,b.ExtHostConsumerFileSystem),(0,_.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,_.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations),(0,_.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,_.registerSingleton)(c.IExtHostFileSystemInfo,c.ExtHostFileSystemInfo),(0,_.registerSingleton)(S.IExtHostOutputService,S.ExtHostOutputService),(0,_.registerSingleton)(p.IExtHostSearch,p.ExtHostSearch),(0,_.registerSingleton)(s.IExtHostStorage,s.ExtHostStorage),(0,_.registerSingleton)(A.IExtHostTask,A.WorkerExtHostTask),(0,_.registerSingleton)(n.IExtHostTerminalService,n.WorkerExtHostTerminalService),(0,_.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService),(0,_.registerSingleton)(g.IExtHostWindow,g.ExtHostWindow),(0,_.registerSingleton)(T.IExtHostWorkspace,T.ExtHostWorkspace),(0,_.registerSingleton)(u.IExtHostSecretState,u.ExtHostSecretState),(0,_.registerSingleton)(a.IExtHostTelemetry,a.ExtHostTelemetry)}),define(we[222],Ee([0,1,220,35,216,7,15]),function(re,e,_,S,T,P,E){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var D;(function(p){var f;const s=(f=self.trustedTypes)===null||f===void 0?void 0:f.createPolicy("TrustedFunctionWorkaround",{createScript:(v,...g)=>{g.forEach(a=>{var t;if(!((t=self.trustedTypes)===null||t===void 0?void 0:t.isScript(a)))throw new Error("TrustedScripts only, please")});const b=g.slice(0,-1).join(","),c=g.pop().toString();return`(function anonymous(${b}) {
${c}
})`}});function h(...v){return s?self.eval(s.createScript("",...v)):new Function(...v)}p.create=h})(D||(D={}));class n extends T.RequireInterceptor{_installInterceptor(){}getModule(f,s){for(let h of this._alternatives){let v=h(f);if(v){f=v;break}}if(this._factories.has(f))return this._factories.get(f).load(f,s,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends S.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const f=this._instaService.invokeFunction(_.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(n,f,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(f){return f.browser}async _loadCommonJSModule(f,s,h){var v,g,b,c,u,a,t,r;s=s.with({path:I(s.path,".js")}),f&&performance.mark(`code/extHost/willFetchExtensionCode/${f.value}`);const o=await fetch(s.toString(!0));if(f&&performance.mark(`code/extHost/didFetchExtensionCode/${f.value}`),o.status!==200)throw new Error(o.statusText);const l=await o.text(),i=`${s.toString(!0)}#vscode-extension`,d=`${l}
//# sourceURL=${i}`;let y;try{y=D.create((g=(v=A._ttpExtensionScripts)===null||v===void 0?void 0:v.createScript("module"))!==null&&g!==void 0?g:"module",(c=(b=A._ttpExtensionScripts)===null||b===void 0?void 0:b.createScript("exports"))!==null&&c!==void 0?c:"exports",(a=(u=A._ttpExtensionScripts)===null||u===void 0?void 0:u.createScript("require"))!==null&&a!==void 0?a:"require",(r=(t=A._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript(d))!==null&&r!==void 0?r:d)}catch(R){throw f?console.error(`Loading code for extension ${f.value} failed: ${R.message}`):console.error(`Loading code failed: ${R.message}`),console.error(`${s.toString(!0)}${typeof R.line=="number"?` line ${R.line}`:""}${typeof R.column=="number"?` column ${R.column}`:""}`),console.error(R),R}const k={},m={exports:k},w=R=>{const F=this._fakeModules.getModule(R,s);if(F===void 0)throw new Error(`Cannot load module '${R}'`);return F};try{return h.codeLoadingStart(),f&&performance.mark(`code/extHost/willLoadExtensionCode/${f.value}`),y(m,k,w),m.exports!==k?m.exports:k}finally{f&&performance.mark(`code/extHost/didLoadExtensionCode/${f.value}`),h.codeLoadingStop()}}async $setRemoteEnvironment(f){throw new Error("Not supported")}async _waitForDebuggerAttachment(f=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const s=Date.now()+f;for(;Date.now()<s&&!("__jsDebugIsReady"in globalThis);)await(0,E.timeout)(10)}}}e.ExtHostExtensionService=A,A._ttpExtensionScripts=(C=self.trustedTypes)===null||C===void 0?void 0:C.createPolicy("ExtensionScripts",{createScript:p=>p});function I(p,f){return p.endsWith(f)?p:p+f}}),define(we[223],Ee([0,1,62,19,35,222,208]),function(re,e,_,S,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(T.IExtHostExtensionService,P.ExtHostExtensionService),(0,_.registerSingleton)(S.ILogService,E.ExtHostLogService)}),define(we[225],Ee([0,1,26,3,180,217,210,10,77,221,223]),function(re,e,_,S,T,P,E,C,D){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0});const A=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const I=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const v=(n=self.trustedTypes)===null||n===void 0?void 0:n.createPolicy("extensionHostWorker",{createScriptURL:b=>b}),g=self.Worker;Worker=function(b,c){const u=`importScripts('${b}');`;c=c||{},c.name=c.name||C.basename(b.toString());const a=new Blob([u],{type:"application/javascript"}),t=URL.createObjectURL(a);return new g(v?v.createScriptURL(t):t,c)}}else self.Worker=class extends E.NestedWorker{constructor(v,g){super(I,v,Object.assign({name:C.basename(v.toString())},g))}};const p=new class{exit(v){A()}async exists(v){return!0}async realpath(v){return v}};class f{constructor(){const g=new MessageChannel,b=new S.Emitter;let c=!1;I(g.port2,[g.port2]),g.port1.onmessage=u=>{const{data:a}=u;if(!(a instanceof ArrayBuffer)){console.warn("UNKNOWN data received",a);return}const t=_.VSBuffer.wrap(new Uint8Array(a,0,a.byteLength));if((0,T.isMessageOfType)(t,2)){c=!0,h("received terminate message from renderer");return}b.fire(t)},this.protocol={onMessage:b.event,send:u=>{if(!c){const a=u.buffer.buffer.slice(u.buffer.byteOffset,u.buffer.byteOffset+u.buffer.byteLength);g.port1.postMessage(a,[a])}}}}}function s(v){return new Promise(g=>{const b=v.onMessage(c=>{b.dispose();const u=JSON.parse(c.toString());v.send((0,T.createMessageOfType)(0)),g({protocol:v,initData:u})});v.send((0,T.createMessageOfType)(1))})}let h=v=>A();(function(){const g=new f;D.mark("code/extHost/willConnectToRenderer"),s(g.protocol).then(b=>{D.mark("code/extHost/didWaitForInitData");const c=new P.ExtensionHostMain(b.protocol,b.initData,p,null);h=u=>c.terminate(u)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5d80c30e5b6ce8b2f5336ed55ad043490b0b818f/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
